#![doc = "Peripheral access API for S32K144 microcontrollers (generated using svd2rust v0.7.2)"]
#![deny(missing_docs)]
#![deny(warnings)]
#![allow(dead_code)]
#![feature(const_fn)]
#![feature(optin_builtin_traits)]
#![no_std]

extern crate cortex_m;
extern crate vcell;
use core::ops::Deref;
use cortex_m::peripheral::Peripheral;
# [ doc = r" Interrupts" ]
pub mod interrupt {
    use cortex_m::ctxt::Context;
    use cortex_m::exception;
    use cortex_m::interrupt::Nr;
    # [ doc = "0 - DMA0" ]
    pub struct Dma0 {
        _0: (),
    }
    unsafe impl Context for Dma0 {}
    unsafe impl Nr for Dma0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            0
        }
    }
    impl !Send for Dma0 {}
    # [ doc = "1 - DMA1" ]
    pub struct Dma1 {
        _0: (),
    }
    unsafe impl Context for Dma1 {}
    unsafe impl Nr for Dma1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            1
        }
    }
    impl !Send for Dma1 {}
    # [ doc = "2 - DMA2" ]
    pub struct Dma2 {
        _0: (),
    }
    unsafe impl Context for Dma2 {}
    unsafe impl Nr for Dma2 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            2
        }
    }
    impl !Send for Dma2 {}
    # [ doc = "3 - DMA3" ]
    pub struct Dma3 {
        _0: (),
    }
    unsafe impl Context for Dma3 {}
    unsafe impl Nr for Dma3 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            3
        }
    }
    impl !Send for Dma3 {}
    # [ doc = "4 - DMA4" ]
    pub struct Dma4 {
        _0: (),
    }
    unsafe impl Context for Dma4 {}
    unsafe impl Nr for Dma4 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            4
        }
    }
    impl !Send for Dma4 {}
    # [ doc = "5 - DMA5" ]
    pub struct Dma5 {
        _0: (),
    }
    unsafe impl Context for Dma5 {}
    unsafe impl Nr for Dma5 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            5
        }
    }
    impl !Send for Dma5 {}
    # [ doc = "6 - DMA6" ]
    pub struct Dma6 {
        _0: (),
    }
    unsafe impl Context for Dma6 {}
    unsafe impl Nr for Dma6 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            6
        }
    }
    impl !Send for Dma6 {}
    # [ doc = "7 - DMA7" ]
    pub struct Dma7 {
        _0: (),
    }
    unsafe impl Context for Dma7 {}
    unsafe impl Nr for Dma7 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            7
        }
    }
    impl !Send for Dma7 {}
    # [ doc = "8 - DMA8" ]
    pub struct Dma8 {
        _0: (),
    }
    unsafe impl Context for Dma8 {}
    unsafe impl Nr for Dma8 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            8
        }
    }
    impl !Send for Dma8 {}
    # [ doc = "9 - DMA9" ]
    pub struct Dma9 {
        _0: (),
    }
    unsafe impl Context for Dma9 {}
    unsafe impl Nr for Dma9 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            9
        }
    }
    impl !Send for Dma9 {}
    # [ doc = "10 - DMA10" ]
    pub struct Dma10 {
        _0: (),
    }
    unsafe impl Context for Dma10 {}
    unsafe impl Nr for Dma10 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            10
        }
    }
    impl !Send for Dma10 {}
    # [ doc = "11 - DMA11" ]
    pub struct Dma11 {
        _0: (),
    }
    unsafe impl Context for Dma11 {}
    unsafe impl Nr for Dma11 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            11
        }
    }
    impl !Send for Dma11 {}
    # [ doc = "12 - DMA12" ]
    pub struct Dma12 {
        _0: (),
    }
    unsafe impl Context for Dma12 {}
    unsafe impl Nr for Dma12 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            12
        }
    }
    impl !Send for Dma12 {}
    # [ doc = "13 - DMA13" ]
    pub struct Dma13 {
        _0: (),
    }
    unsafe impl Context for Dma13 {}
    unsafe impl Nr for Dma13 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            13
        }
    }
    impl !Send for Dma13 {}
    # [ doc = "14 - DMA14" ]
    pub struct Dma14 {
        _0: (),
    }
    unsafe impl Context for Dma14 {}
    unsafe impl Nr for Dma14 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            14
        }
    }
    impl !Send for Dma14 {}
    # [ doc = "15 - DMA15" ]
    pub struct Dma15 {
        _0: (),
    }
    unsafe impl Context for Dma15 {}
    unsafe impl Nr for Dma15 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            15
        }
    }
    impl !Send for Dma15 {}
    # [ doc = "16 - DMA_Error" ]
    pub struct DmaError {
        _0: (),
    }
    unsafe impl Context for DmaError {}
    unsafe impl Nr for DmaError {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            16
        }
    }
    impl !Send for DmaError {}
    # [ doc = "17 - MCM" ]
    pub struct Mcm {
        _0: (),
    }
    unsafe impl Context for Mcm {}
    unsafe impl Nr for Mcm {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            17
        }
    }
    impl !Send for Mcm {}
    # [ doc = "18 - FTFC" ]
    pub struct Ftfc {
        _0: (),
    }
    unsafe impl Context for Ftfc {}
    unsafe impl Nr for Ftfc {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            18
        }
    }
    impl !Send for Ftfc {}
    # [ doc = "19 - Read_Collision" ]
    pub struct ReadCollision {
        _0: (),
    }
    unsafe impl Context for ReadCollision {}
    unsafe impl Nr for ReadCollision {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            19
        }
    }
    impl !Send for ReadCollision {}
    # [ doc = "20 - LVD_LVW" ]
    pub struct LvdLvw {
        _0: (),
    }
    unsafe impl Context for LvdLvw {}
    unsafe impl Nr for LvdLvw {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            20
        }
    }
    impl !Send for LvdLvw {}
    # [ doc = "21 - FTFC_Fault" ]
    pub struct FtfcFault {
        _0: (),
    }
    unsafe impl Context for FtfcFault {}
    unsafe impl Nr for FtfcFault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            21
        }
    }
    impl !Send for FtfcFault {}
    # [ doc = "22 - WDOG_EWM" ]
    pub struct WdogEwm {
        _0: (),
    }
    unsafe impl Context for WdogEwm {}
    unsafe impl Nr for WdogEwm {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            22
        }
    }
    impl !Send for WdogEwm {}
    # [ doc = "23 - RCM" ]
    pub struct Rcm {
        _0: (),
    }
    unsafe impl Context for Rcm {}
    unsafe impl Nr for Rcm {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            23
        }
    }
    impl !Send for Rcm {}
    # [ doc = "24 - LPI2C0_Master" ]
    pub struct Lpi2c0Master {
        _0: (),
    }
    unsafe impl Context for Lpi2c0Master {}
    unsafe impl Nr for Lpi2c0Master {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            24
        }
    }
    impl !Send for Lpi2c0Master {}
    # [ doc = "25 - LPI2C0_Slave" ]
    pub struct Lpi2c0Slave {
        _0: (),
    }
    unsafe impl Context for Lpi2c0Slave {}
    unsafe impl Nr for Lpi2c0Slave {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            25
        }
    }
    impl !Send for Lpi2c0Slave {}
    # [ doc = "26 - LPSPI0" ]
    pub struct Lpspi0 {
        _0: (),
    }
    unsafe impl Context for Lpspi0 {}
    unsafe impl Nr for Lpspi0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            26
        }
    }
    impl !Send for Lpspi0 {}
    # [ doc = "27 - LPSPI1" ]
    pub struct Lpspi1 {
        _0: (),
    }
    unsafe impl Context for Lpspi1 {}
    unsafe impl Nr for Lpspi1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            27
        }
    }
    impl !Send for Lpspi1 {}
    # [ doc = "28 - LPSPI2" ]
    pub struct Lpspi2 {
        _0: (),
    }
    unsafe impl Context for Lpspi2 {}
    unsafe impl Nr for Lpspi2 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            28
        }
    }
    impl !Send for Lpspi2 {}
    # [ doc = "31 - LPUART0_RxTx" ]
    pub struct Lpuart0RxTx {
        _0: (),
    }
    unsafe impl Context for Lpuart0RxTx {}
    unsafe impl Nr for Lpuart0RxTx {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            31
        }
    }
    impl !Send for Lpuart0RxTx {}
    # [ doc = "33 - LPUART1_RxTx" ]
    pub struct Lpuart1RxTx {
        _0: (),
    }
    unsafe impl Context for Lpuart1RxTx {}
    unsafe impl Nr for Lpuart1RxTx {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            33
        }
    }
    impl !Send for Lpuart1RxTx {}
    # [ doc = "35 - LPUART2_RxTx" ]
    pub struct Lpuart2RxTx {
        _0: (),
    }
    unsafe impl Context for Lpuart2RxTx {}
    unsafe impl Nr for Lpuart2RxTx {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            35
        }
    }
    impl !Send for Lpuart2RxTx {}
    # [ doc = "39 - ADC0" ]
    pub struct Adc0 {
        _0: (),
    }
    unsafe impl Context for Adc0 {}
    unsafe impl Nr for Adc0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            39
        }
    }
    impl !Send for Adc0 {}
    # [ doc = "40 - ADC1" ]
    pub struct Adc1 {
        _0: (),
    }
    unsafe impl Context for Adc1 {}
    unsafe impl Nr for Adc1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            40
        }
    }
    impl !Send for Adc1 {}
    # [ doc = "41 - CMP0" ]
    pub struct Cmp0 {
        _0: (),
    }
    unsafe impl Context for Cmp0 {}
    unsafe impl Nr for Cmp0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            41
        }
    }
    impl !Send for Cmp0 {}
    # [ doc = "44 - ERM_single_fault" ]
    pub struct ErmSingleFault {
        _0: (),
    }
    unsafe impl Context for ErmSingleFault {}
    unsafe impl Nr for ErmSingleFault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            44
        }
    }
    impl !Send for ErmSingleFault {}
    # [ doc = "45 - ERM_double_fault" ]
    pub struct ErmDoubleFault {
        _0: (),
    }
    unsafe impl Context for ErmDoubleFault {}
    unsafe impl Nr for ErmDoubleFault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            45
        }
    }
    impl !Send for ErmDoubleFault {}
    # [ doc = "46 - RTC" ]
    pub struct Rtc {
        _0: (),
    }
    unsafe impl Context for Rtc {}
    unsafe impl Nr for Rtc {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            46
        }
    }
    impl !Send for Rtc {}
    # [ doc = "47 - RTC_Seconds" ]
    pub struct RtcSeconds {
        _0: (),
    }
    unsafe impl Context for RtcSeconds {}
    unsafe impl Nr for RtcSeconds {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            47
        }
    }
    impl !Send for RtcSeconds {}
    # [ doc = "48 - LPIT0_Ch0" ]
    pub struct Lpit0Ch0 {
        _0: (),
    }
    unsafe impl Context for Lpit0Ch0 {}
    unsafe impl Nr for Lpit0Ch0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            48
        }
    }
    impl !Send for Lpit0Ch0 {}
    # [ doc = "49 - LPIT0_Ch1" ]
    pub struct Lpit0Ch1 {
        _0: (),
    }
    unsafe impl Context for Lpit0Ch1 {}
    unsafe impl Nr for Lpit0Ch1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            49
        }
    }
    impl !Send for Lpit0Ch1 {}
    # [ doc = "50 - LPIT0_Ch2" ]
    pub struct Lpit0Ch2 {
        _0: (),
    }
    unsafe impl Context for Lpit0Ch2 {}
    unsafe impl Nr for Lpit0Ch2 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            50
        }
    }
    impl !Send for Lpit0Ch2 {}
    # [ doc = "51 - LPIT0_Ch3" ]
    pub struct Lpit0Ch3 {
        _0: (),
    }
    unsafe impl Context for Lpit0Ch3 {}
    unsafe impl Nr for Lpit0Ch3 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            51
        }
    }
    impl !Send for Lpit0Ch3 {}
    # [ doc = "52 - PDB0" ]
    pub struct Pdb0 {
        _0: (),
    }
    unsafe impl Context for Pdb0 {}
    unsafe impl Nr for Pdb0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            52
        }
    }
    impl !Send for Pdb0 {}
    # [ doc = "57 - SCG" ]
    pub struct Scg {
        _0: (),
    }
    unsafe impl Context for Scg {}
    unsafe impl Nr for Scg {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            57
        }
    }
    impl !Send for Scg {}
    # [ doc = "58 - LPTMR0" ]
    pub struct Lptmr0 {
        _0: (),
    }
    unsafe impl Context for Lptmr0 {}
    unsafe impl Nr for Lptmr0 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            58
        }
    }
    impl !Send for Lptmr0 {}
    # [ doc = "59 - PORTA" ]
    pub struct Porta {
        _0: (),
    }
    unsafe impl Context for Porta {}
    unsafe impl Nr for Porta {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            59
        }
    }
    impl !Send for Porta {}
    # [ doc = "60 - PORTB" ]
    pub struct Portb {
        _0: (),
    }
    unsafe impl Context for Portb {}
    unsafe impl Nr for Portb {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            60
        }
    }
    impl !Send for Portb {}
    # [ doc = "61 - PORTC" ]
    pub struct Portc {
        _0: (),
    }
    unsafe impl Context for Portc {}
    unsafe impl Nr for Portc {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            61
        }
    }
    impl !Send for Portc {}
    # [ doc = "62 - PORTD" ]
    pub struct Portd {
        _0: (),
    }
    unsafe impl Context for Portd {}
    unsafe impl Nr for Portd {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            62
        }
    }
    impl !Send for Portd {}
    # [ doc = "63 - PORTE" ]
    pub struct Porte {
        _0: (),
    }
    unsafe impl Context for Porte {}
    unsafe impl Nr for Porte {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            63
        }
    }
    impl !Send for Porte {}
    # [ doc = "68 - PDB1" ]
    pub struct Pdb1 {
        _0: (),
    }
    unsafe impl Context for Pdb1 {}
    unsafe impl Nr for Pdb1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            68
        }
    }
    impl !Send for Pdb1 {}
    # [ doc = "69 - FLEXIO" ]
    pub struct Flexio {
        _0: (),
    }
    unsafe impl Context for Flexio {}
    unsafe impl Nr for Flexio {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            69
        }
    }
    impl !Send for Flexio {}
    # [ doc = "78 - CAN0_ORed" ]
    pub struct Can0Ored {
        _0: (),
    }
    unsafe impl Context for Can0Ored {}
    unsafe impl Nr for Can0Ored {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            78
        }
    }
    impl !Send for Can0Ored {}
    # [ doc = "79 - CAN0_Error" ]
    pub struct Can0Error {
        _0: (),
    }
    unsafe impl Context for Can0Error {}
    unsafe impl Nr for Can0Error {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            79
        }
    }
    impl !Send for Can0Error {}
    # [ doc = "80 - CAN0_Wake_Up" ]
    pub struct Can0WakeUp {
        _0: (),
    }
    unsafe impl Context for Can0WakeUp {}
    unsafe impl Nr for Can0WakeUp {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            80
        }
    }
    impl !Send for Can0WakeUp {}
    # [ doc = "81 - CAN0_ORed_0_15_MB" ]
    pub struct Can0Ored015Mb {
        _0: (),
    }
    unsafe impl Context for Can0Ored015Mb {}
    unsafe impl Nr for Can0Ored015Mb {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            81
        }
    }
    impl !Send for Can0Ored015Mb {}
    # [ doc = "82 - CAN0_ORed_16_31_MB" ]
    pub struct Can0Ored1631Mb {
        _0: (),
    }
    unsafe impl Context for Can0Ored1631Mb {}
    unsafe impl Nr for Can0Ored1631Mb {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            82
        }
    }
    impl !Send for Can0Ored1631Mb {}
    # [ doc = "85 - CAN1_ORed" ]
    pub struct Can1Ored {
        _0: (),
    }
    unsafe impl Context for Can1Ored {}
    unsafe impl Nr for Can1Ored {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            85
        }
    }
    impl !Send for Can1Ored {}
    # [ doc = "86 - CAN1_Error" ]
    pub struct Can1Error {
        _0: (),
    }
    unsafe impl Context for Can1Error {}
    unsafe impl Nr for Can1Error {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            86
        }
    }
    impl !Send for Can1Error {}
    # [ doc = "88 - CAN1_ORed_0_15_MB" ]
    pub struct Can1Ored015Mb {
        _0: (),
    }
    unsafe impl Context for Can1Ored015Mb {}
    unsafe impl Nr for Can1Ored015Mb {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            88
        }
    }
    impl !Send for Can1Ored015Mb {}
    # [ doc = "92 - CAN2_ORed" ]
    pub struct Can2Ored {
        _0: (),
    }
    unsafe impl Context for Can2Ored {}
    unsafe impl Nr for Can2Ored {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            92
        }
    }
    impl !Send for Can2Ored {}
    # [ doc = "93 - CAN2_Error" ]
    pub struct Can2Error {
        _0: (),
    }
    unsafe impl Context for Can2Error {}
    unsafe impl Nr for Can2Error {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            93
        }
    }
    impl !Send for Can2Error {}
    # [ doc = "95 - CAN2_ORed_0_15_MB" ]
    pub struct Can2Ored015Mb {
        _0: (),
    }
    unsafe impl Context for Can2Ored015Mb {}
    unsafe impl Nr for Can2Ored015Mb {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            95
        }
    }
    impl !Send for Can2Ored015Mb {}
    # [ doc = "99 - FTM0_Ch0_Ch1" ]
    pub struct Ftm0Ch0Ch1 {
        _0: (),
    }
    unsafe impl Context for Ftm0Ch0Ch1 {}
    unsafe impl Nr for Ftm0Ch0Ch1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            99
        }
    }
    impl !Send for Ftm0Ch0Ch1 {}
    # [ doc = "100 - FTM0_Ch2_Ch3" ]
    pub struct Ftm0Ch2Ch3 {
        _0: (),
    }
    unsafe impl Context for Ftm0Ch2Ch3 {}
    unsafe impl Nr for Ftm0Ch2Ch3 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            100
        }
    }
    impl !Send for Ftm0Ch2Ch3 {}
    # [ doc = "101 - FTM0_Ch4_Ch5" ]
    pub struct Ftm0Ch4Ch5 {
        _0: (),
    }
    unsafe impl Context for Ftm0Ch4Ch5 {}
    unsafe impl Nr for Ftm0Ch4Ch5 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            101
        }
    }
    impl !Send for Ftm0Ch4Ch5 {}
    # [ doc = "102 - FTM0_Ch6_Ch7" ]
    pub struct Ftm0Ch6Ch7 {
        _0: (),
    }
    unsafe impl Context for Ftm0Ch6Ch7 {}
    unsafe impl Nr for Ftm0Ch6Ch7 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            102
        }
    }
    impl !Send for Ftm0Ch6Ch7 {}
    # [ doc = "103 - FTM0_Fault" ]
    pub struct Ftm0Fault {
        _0: (),
    }
    unsafe impl Context for Ftm0Fault {}
    unsafe impl Nr for Ftm0Fault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            103
        }
    }
    impl !Send for Ftm0Fault {}
    # [ doc = "104 - FTM0_Ovf_Reload" ]
    pub struct Ftm0OvfReload {
        _0: (),
    }
    unsafe impl Context for Ftm0OvfReload {}
    unsafe impl Nr for Ftm0OvfReload {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            104
        }
    }
    impl !Send for Ftm0OvfReload {}
    # [ doc = "105 - FTM1_Ch0_Ch1" ]
    pub struct Ftm1Ch0Ch1 {
        _0: (),
    }
    unsafe impl Context for Ftm1Ch0Ch1 {}
    unsafe impl Nr for Ftm1Ch0Ch1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            105
        }
    }
    impl !Send for Ftm1Ch0Ch1 {}
    # [ doc = "106 - FTM1_Ch2_Ch3" ]
    pub struct Ftm1Ch2Ch3 {
        _0: (),
    }
    unsafe impl Context for Ftm1Ch2Ch3 {}
    unsafe impl Nr for Ftm1Ch2Ch3 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            106
        }
    }
    impl !Send for Ftm1Ch2Ch3 {}
    # [ doc = "107 - FTM1_Ch4_Ch5" ]
    pub struct Ftm1Ch4Ch5 {
        _0: (),
    }
    unsafe impl Context for Ftm1Ch4Ch5 {}
    unsafe impl Nr for Ftm1Ch4Ch5 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            107
        }
    }
    impl !Send for Ftm1Ch4Ch5 {}
    # [ doc = "108 - FTM1_Ch6_Ch7" ]
    pub struct Ftm1Ch6Ch7 {
        _0: (),
    }
    unsafe impl Context for Ftm1Ch6Ch7 {}
    unsafe impl Nr for Ftm1Ch6Ch7 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            108
        }
    }
    impl !Send for Ftm1Ch6Ch7 {}
    # [ doc = "109 - FTM1_Fault" ]
    pub struct Ftm1Fault {
        _0: (),
    }
    unsafe impl Context for Ftm1Fault {}
    unsafe impl Nr for Ftm1Fault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            109
        }
    }
    impl !Send for Ftm1Fault {}
    # [ doc = "110 - FTM1_Ovf_Reload" ]
    pub struct Ftm1OvfReload {
        _0: (),
    }
    unsafe impl Context for Ftm1OvfReload {}
    unsafe impl Nr for Ftm1OvfReload {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            110
        }
    }
    impl !Send for Ftm1OvfReload {}
    # [ doc = "111 - FTM2_Ch0_Ch1" ]
    pub struct Ftm2Ch0Ch1 {
        _0: (),
    }
    unsafe impl Context for Ftm2Ch0Ch1 {}
    unsafe impl Nr for Ftm2Ch0Ch1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            111
        }
    }
    impl !Send for Ftm2Ch0Ch1 {}
    # [ doc = "112 - FTM2_Ch2_Ch3" ]
    pub struct Ftm2Ch2Ch3 {
        _0: (),
    }
    unsafe impl Context for Ftm2Ch2Ch3 {}
    unsafe impl Nr for Ftm2Ch2Ch3 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            112
        }
    }
    impl !Send for Ftm2Ch2Ch3 {}
    # [ doc = "113 - FTM2_Ch4_Ch5" ]
    pub struct Ftm2Ch4Ch5 {
        _0: (),
    }
    unsafe impl Context for Ftm2Ch4Ch5 {}
    unsafe impl Nr for Ftm2Ch4Ch5 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            113
        }
    }
    impl !Send for Ftm2Ch4Ch5 {}
    # [ doc = "114 - FTM2_Ch6_Ch7" ]
    pub struct Ftm2Ch6Ch7 {
        _0: (),
    }
    unsafe impl Context for Ftm2Ch6Ch7 {}
    unsafe impl Nr for Ftm2Ch6Ch7 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            114
        }
    }
    impl !Send for Ftm2Ch6Ch7 {}
    # [ doc = "115 - FTM2_Fault" ]
    pub struct Ftm2Fault {
        _0: (),
    }
    unsafe impl Context for Ftm2Fault {}
    unsafe impl Nr for Ftm2Fault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            115
        }
    }
    impl !Send for Ftm2Fault {}
    # [ doc = "116 - FTM2_Ovf_Reload" ]
    pub struct Ftm2OvfReload {
        _0: (),
    }
    unsafe impl Context for Ftm2OvfReload {}
    unsafe impl Nr for Ftm2OvfReload {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            116
        }
    }
    impl !Send for Ftm2OvfReload {}
    # [ doc = "117 - FTM3_Ch0_Ch1" ]
    pub struct Ftm3Ch0Ch1 {
        _0: (),
    }
    unsafe impl Context for Ftm3Ch0Ch1 {}
    unsafe impl Nr for Ftm3Ch0Ch1 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            117
        }
    }
    impl !Send for Ftm3Ch0Ch1 {}
    # [ doc = "118 - FTM3_Ch2_Ch3" ]
    pub struct Ftm3Ch2Ch3 {
        _0: (),
    }
    unsafe impl Context for Ftm3Ch2Ch3 {}
    unsafe impl Nr for Ftm3Ch2Ch3 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            118
        }
    }
    impl !Send for Ftm3Ch2Ch3 {}
    # [ doc = "119 - FTM3_Ch4_Ch5" ]
    pub struct Ftm3Ch4Ch5 {
        _0: (),
    }
    unsafe impl Context for Ftm3Ch4Ch5 {}
    unsafe impl Nr for Ftm3Ch4Ch5 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            119
        }
    }
    impl !Send for Ftm3Ch4Ch5 {}
    # [ doc = "120 - FTM3_Ch6_Ch7" ]
    pub struct Ftm3Ch6Ch7 {
        _0: (),
    }
    unsafe impl Context for Ftm3Ch6Ch7 {}
    unsafe impl Nr for Ftm3Ch6Ch7 {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            120
        }
    }
    impl !Send for Ftm3Ch6Ch7 {}
    # [ doc = "121 - FTM3_Fault" ]
    pub struct Ftm3Fault {
        _0: (),
    }
    unsafe impl Context for Ftm3Fault {}
    unsafe impl Nr for Ftm3Fault {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            121
        }
    }
    impl !Send for Ftm3Fault {}
    # [ doc = "122 - FTM3_Ovf_Reload" ]
    pub struct Ftm3OvfReload {
        _0: (),
    }
    unsafe impl Context for Ftm3OvfReload {}
    unsafe impl Nr for Ftm3OvfReload {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            122
        }
    }
    impl !Send for Ftm3OvfReload {}
    use cortex_m::Reserved;
    # [ doc = r" Interrupt handlers" ]
    # [ allow ( non_snake_case ) ]
    # [ repr ( C ) ]
    pub struct Handlers {
        # [ doc = "0 - DMA0" ]
        pub Dma0: extern "C" fn(Dma0),
        # [ doc = "1 - DMA1" ]
        pub Dma1: extern "C" fn(Dma1),
        # [ doc = "2 - DMA2" ]
        pub Dma2: extern "C" fn(Dma2),
        # [ doc = "3 - DMA3" ]
        pub Dma3: extern "C" fn(Dma3),
        # [ doc = "4 - DMA4" ]
        pub Dma4: extern "C" fn(Dma4),
        # [ doc = "5 - DMA5" ]
        pub Dma5: extern "C" fn(Dma5),
        # [ doc = "6 - DMA6" ]
        pub Dma6: extern "C" fn(Dma6),
        # [ doc = "7 - DMA7" ]
        pub Dma7: extern "C" fn(Dma7),
        # [ doc = "8 - DMA8" ]
        pub Dma8: extern "C" fn(Dma8),
        # [ doc = "9 - DMA9" ]
        pub Dma9: extern "C" fn(Dma9),
        # [ doc = "10 - DMA10" ]
        pub Dma10: extern "C" fn(Dma10),
        # [ doc = "11 - DMA11" ]
        pub Dma11: extern "C" fn(Dma11),
        # [ doc = "12 - DMA12" ]
        pub Dma12: extern "C" fn(Dma12),
        # [ doc = "13 - DMA13" ]
        pub Dma13: extern "C" fn(Dma13),
        # [ doc = "14 - DMA14" ]
        pub Dma14: extern "C" fn(Dma14),
        # [ doc = "15 - DMA15" ]
        pub Dma15: extern "C" fn(Dma15),
        # [ doc = "16 - DMA_Error" ]
        pub DmaError: extern "C" fn(DmaError),
        # [ doc = "17 - MCM" ]
        pub Mcm: extern "C" fn(Mcm),
        # [ doc = "18 - FTFC" ]
        pub Ftfc: extern "C" fn(Ftfc),
        # [ doc = "19 - Read_Collision" ]
        pub ReadCollision: extern "C" fn(ReadCollision),
        # [ doc = "20 - LVD_LVW" ]
        pub LvdLvw: extern "C" fn(LvdLvw),
        # [ doc = "21 - FTFC_Fault" ]
        pub FtfcFault: extern "C" fn(FtfcFault),
        # [ doc = "22 - WDOG_EWM" ]
        pub WdogEwm: extern "C" fn(WdogEwm),
        # [ doc = "23 - RCM" ]
        pub Rcm: extern "C" fn(Rcm),
        # [ doc = "24 - LPI2C0_Master" ]
        pub Lpi2c0Master: extern "C" fn(Lpi2c0Master),
        # [ doc = "25 - LPI2C0_Slave" ]
        pub Lpi2c0Slave: extern "C" fn(Lpi2c0Slave),
        # [ doc = "26 - LPSPI0" ]
        pub Lpspi0: extern "C" fn(Lpspi0),
        # [ doc = "27 - LPSPI1" ]
        pub Lpspi1: extern "C" fn(Lpspi1),
        # [ doc = "28 - LPSPI2" ]
        pub Lpspi2: extern "C" fn(Lpspi2),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved0: [Reserved; 2],
        # [ doc = "31 - LPUART0_RxTx" ]
        pub Lpuart0RxTx: extern "C" fn(Lpuart0RxTx),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved1: [Reserved; 1],
        # [ doc = "33 - LPUART1_RxTx" ]
        pub Lpuart1RxTx: extern "C" fn(Lpuart1RxTx),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved2: [Reserved; 1],
        # [ doc = "35 - LPUART2_RxTx" ]
        pub Lpuart2RxTx: extern "C" fn(Lpuart2RxTx),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved3: [Reserved; 3],
        # [ doc = "39 - ADC0" ]
        pub Adc0: extern "C" fn(Adc0),
        # [ doc = "40 - ADC1" ]
        pub Adc1: extern "C" fn(Adc1),
        # [ doc = "41 - CMP0" ]
        pub Cmp0: extern "C" fn(Cmp0),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved4: [Reserved; 2],
        # [ doc = "44 - ERM_single_fault" ]
        pub ErmSingleFault: extern "C" fn(ErmSingleFault),
        # [ doc = "45 - ERM_double_fault" ]
        pub ErmDoubleFault: extern "C" fn(ErmDoubleFault),
        # [ doc = "46 - RTC" ]
        pub Rtc: extern "C" fn(Rtc),
        # [ doc = "47 - RTC_Seconds" ]
        pub RtcSeconds: extern "C" fn(RtcSeconds),
        # [ doc = "48 - LPIT0_Ch0" ]
        pub Lpit0Ch0: extern "C" fn(Lpit0Ch0),
        # [ doc = "49 - LPIT0_Ch1" ]
        pub Lpit0Ch1: extern "C" fn(Lpit0Ch1),
        # [ doc = "50 - LPIT0_Ch2" ]
        pub Lpit0Ch2: extern "C" fn(Lpit0Ch2),
        # [ doc = "51 - LPIT0_Ch3" ]
        pub Lpit0Ch3: extern "C" fn(Lpit0Ch3),
        # [ doc = "52 - PDB0" ]
        pub Pdb0: extern "C" fn(Pdb0),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved5: [Reserved; 4],
        # [ doc = "57 - SCG" ]
        pub Scg: extern "C" fn(Scg),
        # [ doc = "58 - LPTMR0" ]
        pub Lptmr0: extern "C" fn(Lptmr0),
        # [ doc = "59 - PORTA" ]
        pub Porta: extern "C" fn(Porta),
        # [ doc = "60 - PORTB" ]
        pub Portb: extern "C" fn(Portb),
        # [ doc = "61 - PORTC" ]
        pub Portc: extern "C" fn(Portc),
        # [ doc = "62 - PORTD" ]
        pub Portd: extern "C" fn(Portd),
        # [ doc = "63 - PORTE" ]
        pub Porte: extern "C" fn(Porte),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved6: [Reserved; 4],
        # [ doc = "68 - PDB1" ]
        pub Pdb1: extern "C" fn(Pdb1),
        # [ doc = "69 - FLEXIO" ]
        pub Flexio: extern "C" fn(Flexio),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved7: [Reserved; 8],
        # [ doc = "78 - CAN0_ORed" ]
        pub Can0Ored: extern "C" fn(Can0Ored),
        # [ doc = "79 - CAN0_Error" ]
        pub Can0Error: extern "C" fn(Can0Error),
        # [ doc = "80 - CAN0_Wake_Up" ]
        pub Can0WakeUp: extern "C" fn(Can0WakeUp),
        # [ doc = "81 - CAN0_ORed_0_15_MB" ]
        pub Can0Ored015Mb: extern "C" fn(Can0Ored015Mb),
        # [ doc = "82 - CAN0_ORed_16_31_MB" ]
        pub Can0Ored1631Mb: extern "C" fn(Can0Ored1631Mb),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved8: [Reserved; 2],
        # [ doc = "85 - CAN1_ORed" ]
        pub Can1Ored: extern "C" fn(Can1Ored),
        # [ doc = "86 - CAN1_Error" ]
        pub Can1Error: extern "C" fn(Can1Error),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved9: [Reserved; 1],
        # [ doc = "88 - CAN1_ORed_0_15_MB" ]
        pub Can1Ored015Mb: extern "C" fn(Can1Ored015Mb),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved10: [Reserved; 3],
        # [ doc = "92 - CAN2_ORed" ]
        pub Can2Ored: extern "C" fn(Can2Ored),
        # [ doc = "93 - CAN2_Error" ]
        pub Can2Error: extern "C" fn(Can2Error),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved11: [Reserved; 1],
        # [ doc = "95 - CAN2_ORed_0_15_MB" ]
        pub Can2Ored015Mb: extern "C" fn(Can2Ored015Mb),
        # [ doc = r" Reserved spot in the vector table" ]
        pub _reserved12: [Reserved; 3],
        # [ doc = "99 - FTM0_Ch0_Ch1" ]
        pub Ftm0Ch0Ch1: extern "C" fn(Ftm0Ch0Ch1),
        # [ doc = "100 - FTM0_Ch2_Ch3" ]
        pub Ftm0Ch2Ch3: extern "C" fn(Ftm0Ch2Ch3),
        # [ doc = "101 - FTM0_Ch4_Ch5" ]
        pub Ftm0Ch4Ch5: extern "C" fn(Ftm0Ch4Ch5),
        # [ doc = "102 - FTM0_Ch6_Ch7" ]
        pub Ftm0Ch6Ch7: extern "C" fn(Ftm0Ch6Ch7),
        # [ doc = "103 - FTM0_Fault" ]
        pub Ftm0Fault: extern "C" fn(Ftm0Fault),
        # [ doc = "104 - FTM0_Ovf_Reload" ]
        pub Ftm0OvfReload: extern "C" fn(Ftm0OvfReload),
        # [ doc = "105 - FTM1_Ch0_Ch1" ]
        pub Ftm1Ch0Ch1: extern "C" fn(Ftm1Ch0Ch1),
        # [ doc = "106 - FTM1_Ch2_Ch3" ]
        pub Ftm1Ch2Ch3: extern "C" fn(Ftm1Ch2Ch3),
        # [ doc = "107 - FTM1_Ch4_Ch5" ]
        pub Ftm1Ch4Ch5: extern "C" fn(Ftm1Ch4Ch5),
        # [ doc = "108 - FTM1_Ch6_Ch7" ]
        pub Ftm1Ch6Ch7: extern "C" fn(Ftm1Ch6Ch7),
        # [ doc = "109 - FTM1_Fault" ]
        pub Ftm1Fault: extern "C" fn(Ftm1Fault),
        # [ doc = "110 - FTM1_Ovf_Reload" ]
        pub Ftm1OvfReload: extern "C" fn(Ftm1OvfReload),
        # [ doc = "111 - FTM2_Ch0_Ch1" ]
        pub Ftm2Ch0Ch1: extern "C" fn(Ftm2Ch0Ch1),
        # [ doc = "112 - FTM2_Ch2_Ch3" ]
        pub Ftm2Ch2Ch3: extern "C" fn(Ftm2Ch2Ch3),
        # [ doc = "113 - FTM2_Ch4_Ch5" ]
        pub Ftm2Ch4Ch5: extern "C" fn(Ftm2Ch4Ch5),
        # [ doc = "114 - FTM2_Ch6_Ch7" ]
        pub Ftm2Ch6Ch7: extern "C" fn(Ftm2Ch6Ch7),
        # [ doc = "115 - FTM2_Fault" ]
        pub Ftm2Fault: extern "C" fn(Ftm2Fault),
        # [ doc = "116 - FTM2_Ovf_Reload" ]
        pub Ftm2OvfReload: extern "C" fn(Ftm2OvfReload),
        # [ doc = "117 - FTM3_Ch0_Ch1" ]
        pub Ftm3Ch0Ch1: extern "C" fn(Ftm3Ch0Ch1),
        # [ doc = "118 - FTM3_Ch2_Ch3" ]
        pub Ftm3Ch2Ch3: extern "C" fn(Ftm3Ch2Ch3),
        # [ doc = "119 - FTM3_Ch4_Ch5" ]
        pub Ftm3Ch4Ch5: extern "C" fn(Ftm3Ch4Ch5),
        # [ doc = "120 - FTM3_Ch6_Ch7" ]
        pub Ftm3Ch6Ch7: extern "C" fn(Ftm3Ch6Ch7),
        # [ doc = "121 - FTM3_Fault" ]
        pub Ftm3Fault: extern "C" fn(Ftm3Fault),
        # [ doc = "122 - FTM3_Ovf_Reload" ]
        pub Ftm3OvfReload: extern "C" fn(Ftm3OvfReload),
    }
    # [ doc = r" Default interrupt handlers" ]
    pub const DEFAULT_HANDLERS: Handlers = Handlers {
        Dma0: exception::default_handler,
        Dma1: exception::default_handler,
        Dma2: exception::default_handler,
        Dma3: exception::default_handler,
        Dma4: exception::default_handler,
        Dma5: exception::default_handler,
        Dma6: exception::default_handler,
        Dma7: exception::default_handler,
        Dma8: exception::default_handler,
        Dma9: exception::default_handler,
        Dma10: exception::default_handler,
        Dma11: exception::default_handler,
        Dma12: exception::default_handler,
        Dma13: exception::default_handler,
        Dma14: exception::default_handler,
        Dma15: exception::default_handler,
        DmaError: exception::default_handler,
        Mcm: exception::default_handler,
        Ftfc: exception::default_handler,
        ReadCollision: exception::default_handler,
        LvdLvw: exception::default_handler,
        FtfcFault: exception::default_handler,
        WdogEwm: exception::default_handler,
        Rcm: exception::default_handler,
        Lpi2c0Master: exception::default_handler,
        Lpi2c0Slave: exception::default_handler,
        Lpspi0: exception::default_handler,
        Lpspi1: exception::default_handler,
        Lpspi2: exception::default_handler,
        _reserved0: [Reserved::Vector; 2],
        Lpuart0RxTx: exception::default_handler,
        _reserved1: [Reserved::Vector; 1],
        Lpuart1RxTx: exception::default_handler,
        _reserved2: [Reserved::Vector; 1],
        Lpuart2RxTx: exception::default_handler,
        _reserved3: [Reserved::Vector; 3],
        Adc0: exception::default_handler,
        Adc1: exception::default_handler,
        Cmp0: exception::default_handler,
        _reserved4: [Reserved::Vector; 2],
        ErmSingleFault: exception::default_handler,
        ErmDoubleFault: exception::default_handler,
        Rtc: exception::default_handler,
        RtcSeconds: exception::default_handler,
        Lpit0Ch0: exception::default_handler,
        Lpit0Ch1: exception::default_handler,
        Lpit0Ch2: exception::default_handler,
        Lpit0Ch3: exception::default_handler,
        Pdb0: exception::default_handler,
        _reserved5: [Reserved::Vector; 4],
        Scg: exception::default_handler,
        Lptmr0: exception::default_handler,
        Porta: exception::default_handler,
        Portb: exception::default_handler,
        Portc: exception::default_handler,
        Portd: exception::default_handler,
        Porte: exception::default_handler,
        _reserved6: [Reserved::Vector; 4],
        Pdb1: exception::default_handler,
        Flexio: exception::default_handler,
        _reserved7: [Reserved::Vector; 8],
        Can0Ored: exception::default_handler,
        Can0Error: exception::default_handler,
        Can0WakeUp: exception::default_handler,
        Can0Ored015Mb: exception::default_handler,
        Can0Ored1631Mb: exception::default_handler,
        _reserved8: [Reserved::Vector; 2],
        Can1Ored: exception::default_handler,
        Can1Error: exception::default_handler,
        _reserved9: [Reserved::Vector; 1],
        Can1Ored015Mb: exception::default_handler,
        _reserved10: [Reserved::Vector; 3],
        Can2Ored: exception::default_handler,
        Can2Error: exception::default_handler,
        _reserved11: [Reserved::Vector; 1],
        Can2Ored015Mb: exception::default_handler,
        _reserved12: [Reserved::Vector; 3],
        Ftm0Ch0Ch1: exception::default_handler,
        Ftm0Ch2Ch3: exception::default_handler,
        Ftm0Ch4Ch5: exception::default_handler,
        Ftm0Ch6Ch7: exception::default_handler,
        Ftm0Fault: exception::default_handler,
        Ftm0OvfReload: exception::default_handler,
        Ftm1Ch0Ch1: exception::default_handler,
        Ftm1Ch2Ch3: exception::default_handler,
        Ftm1Ch4Ch5: exception::default_handler,
        Ftm1Ch6Ch7: exception::default_handler,
        Ftm1Fault: exception::default_handler,
        Ftm1OvfReload: exception::default_handler,
        Ftm2Ch0Ch1: exception::default_handler,
        Ftm2Ch2Ch3: exception::default_handler,
        Ftm2Ch4Ch5: exception::default_handler,
        Ftm2Ch6Ch7: exception::default_handler,
        Ftm2Fault: exception::default_handler,
        Ftm2OvfReload: exception::default_handler,
        Ftm3Ch0Ch1: exception::default_handler,
        Ftm3Ch2Ch3: exception::default_handler,
        Ftm3Ch4Ch5: exception::default_handler,
        Ftm3Ch6Ch7: exception::default_handler,
        Ftm3Fault: exception::default_handler,
        Ftm3OvfReload: exception::default_handler,
    };
    # [ doc = r" Enumeration of all the interrupts" ]
    pub enum Interrupt {
        # [ doc = "0 - DMA0" ]
        Dma0,
        # [ doc = "1 - DMA1" ]
        Dma1,
        # [ doc = "2 - DMA2" ]
        Dma2,
        # [ doc = "3 - DMA3" ]
        Dma3,
        # [ doc = "4 - DMA4" ]
        Dma4,
        # [ doc = "5 - DMA5" ]
        Dma5,
        # [ doc = "6 - DMA6" ]
        Dma6,
        # [ doc = "7 - DMA7" ]
        Dma7,
        # [ doc = "8 - DMA8" ]
        Dma8,
        # [ doc = "9 - DMA9" ]
        Dma9,
        # [ doc = "10 - DMA10" ]
        Dma10,
        # [ doc = "11 - DMA11" ]
        Dma11,
        # [ doc = "12 - DMA12" ]
        Dma12,
        # [ doc = "13 - DMA13" ]
        Dma13,
        # [ doc = "14 - DMA14" ]
        Dma14,
        # [ doc = "15 - DMA15" ]
        Dma15,
        # [ doc = "16 - DMA_Error" ]
        DmaError,
        # [ doc = "17 - MCM" ]
        Mcm,
        # [ doc = "18 - FTFC" ]
        Ftfc,
        # [ doc = "19 - Read_Collision" ]
        ReadCollision,
        # [ doc = "20 - LVD_LVW" ]
        LvdLvw,
        # [ doc = "21 - FTFC_Fault" ]
        FtfcFault,
        # [ doc = "22 - WDOG_EWM" ]
        WdogEwm,
        # [ doc = "23 - RCM" ]
        Rcm,
        # [ doc = "24 - LPI2C0_Master" ]
        Lpi2c0Master,
        # [ doc = "25 - LPI2C0_Slave" ]
        Lpi2c0Slave,
        # [ doc = "26 - LPSPI0" ]
        Lpspi0,
        # [ doc = "27 - LPSPI1" ]
        Lpspi1,
        # [ doc = "28 - LPSPI2" ]
        Lpspi2,
        # [ doc = "31 - LPUART0_RxTx" ]
        Lpuart0RxTx,
        # [ doc = "33 - LPUART1_RxTx" ]
        Lpuart1RxTx,
        # [ doc = "35 - LPUART2_RxTx" ]
        Lpuart2RxTx,
        # [ doc = "39 - ADC0" ]
        Adc0,
        # [ doc = "40 - ADC1" ]
        Adc1,
        # [ doc = "41 - CMP0" ]
        Cmp0,
        # [ doc = "44 - ERM_single_fault" ]
        ErmSingleFault,
        # [ doc = "45 - ERM_double_fault" ]
        ErmDoubleFault,
        # [ doc = "46 - RTC" ]
        Rtc,
        # [ doc = "47 - RTC_Seconds" ]
        RtcSeconds,
        # [ doc = "48 - LPIT0_Ch0" ]
        Lpit0Ch0,
        # [ doc = "49 - LPIT0_Ch1" ]
        Lpit0Ch1,
        # [ doc = "50 - LPIT0_Ch2" ]
        Lpit0Ch2,
        # [ doc = "51 - LPIT0_Ch3" ]
        Lpit0Ch3,
        # [ doc = "52 - PDB0" ]
        Pdb0,
        # [ doc = "57 - SCG" ]
        Scg,
        # [ doc = "58 - LPTMR0" ]
        Lptmr0,
        # [ doc = "59 - PORTA" ]
        Porta,
        # [ doc = "60 - PORTB" ]
        Portb,
        # [ doc = "61 - PORTC" ]
        Portc,
        # [ doc = "62 - PORTD" ]
        Portd,
        # [ doc = "63 - PORTE" ]
        Porte,
        # [ doc = "68 - PDB1" ]
        Pdb1,
        # [ doc = "69 - FLEXIO" ]
        Flexio,
        # [ doc = "78 - CAN0_ORed" ]
        Can0Ored,
        # [ doc = "79 - CAN0_Error" ]
        Can0Error,
        # [ doc = "80 - CAN0_Wake_Up" ]
        Can0WakeUp,
        # [ doc = "81 - CAN0_ORed_0_15_MB" ]
        Can0Ored015Mb,
        # [ doc = "82 - CAN0_ORed_16_31_MB" ]
        Can0Ored1631Mb,
        # [ doc = "85 - CAN1_ORed" ]
        Can1Ored,
        # [ doc = "86 - CAN1_Error" ]
        Can1Error,
        # [ doc = "88 - CAN1_ORed_0_15_MB" ]
        Can1Ored015Mb,
        # [ doc = "92 - CAN2_ORed" ]
        Can2Ored,
        # [ doc = "93 - CAN2_Error" ]
        Can2Error,
        # [ doc = "95 - CAN2_ORed_0_15_MB" ]
        Can2Ored015Mb,
        # [ doc = "99 - FTM0_Ch0_Ch1" ]
        Ftm0Ch0Ch1,
        # [ doc = "100 - FTM0_Ch2_Ch3" ]
        Ftm0Ch2Ch3,
        # [ doc = "101 - FTM0_Ch4_Ch5" ]
        Ftm0Ch4Ch5,
        # [ doc = "102 - FTM0_Ch6_Ch7" ]
        Ftm0Ch6Ch7,
        # [ doc = "103 - FTM0_Fault" ]
        Ftm0Fault,
        # [ doc = "104 - FTM0_Ovf_Reload" ]
        Ftm0OvfReload,
        # [ doc = "105 - FTM1_Ch0_Ch1" ]
        Ftm1Ch0Ch1,
        # [ doc = "106 - FTM1_Ch2_Ch3" ]
        Ftm1Ch2Ch3,
        # [ doc = "107 - FTM1_Ch4_Ch5" ]
        Ftm1Ch4Ch5,
        # [ doc = "108 - FTM1_Ch6_Ch7" ]
        Ftm1Ch6Ch7,
        # [ doc = "109 - FTM1_Fault" ]
        Ftm1Fault,
        # [ doc = "110 - FTM1_Ovf_Reload" ]
        Ftm1OvfReload,
        # [ doc = "111 - FTM2_Ch0_Ch1" ]
        Ftm2Ch0Ch1,
        # [ doc = "112 - FTM2_Ch2_Ch3" ]
        Ftm2Ch2Ch3,
        # [ doc = "113 - FTM2_Ch4_Ch5" ]
        Ftm2Ch4Ch5,
        # [ doc = "114 - FTM2_Ch6_Ch7" ]
        Ftm2Ch6Ch7,
        # [ doc = "115 - FTM2_Fault" ]
        Ftm2Fault,
        # [ doc = "116 - FTM2_Ovf_Reload" ]
        Ftm2OvfReload,
        # [ doc = "117 - FTM3_Ch0_Ch1" ]
        Ftm3Ch0Ch1,
        # [ doc = "118 - FTM3_Ch2_Ch3" ]
        Ftm3Ch2Ch3,
        # [ doc = "119 - FTM3_Ch4_Ch5" ]
        Ftm3Ch4Ch5,
        # [ doc = "120 - FTM3_Ch6_Ch7" ]
        Ftm3Ch6Ch7,
        # [ doc = "121 - FTM3_Fault" ]
        Ftm3Fault,
        # [ doc = "122 - FTM3_Ovf_Reload" ]
        Ftm3OvfReload,
    }
    unsafe impl Nr for Interrupt {
        # [ inline ( always ) ]
        fn nr(&self) -> u8 {
            match *self {
                Interrupt::Dma0 => 0,
                Interrupt::Dma1 => 1,
                Interrupt::Dma2 => 2,
                Interrupt::Dma3 => 3,
                Interrupt::Dma4 => 4,
                Interrupt::Dma5 => 5,
                Interrupt::Dma6 => 6,
                Interrupt::Dma7 => 7,
                Interrupt::Dma8 => 8,
                Interrupt::Dma9 => 9,
                Interrupt::Dma10 => 10,
                Interrupt::Dma11 => 11,
                Interrupt::Dma12 => 12,
                Interrupt::Dma13 => 13,
                Interrupt::Dma14 => 14,
                Interrupt::Dma15 => 15,
                Interrupt::DmaError => 16,
                Interrupt::Mcm => 17,
                Interrupt::Ftfc => 18,
                Interrupt::ReadCollision => 19,
                Interrupt::LvdLvw => 20,
                Interrupt::FtfcFault => 21,
                Interrupt::WdogEwm => 22,
                Interrupt::Rcm => 23,
                Interrupt::Lpi2c0Master => 24,
                Interrupt::Lpi2c0Slave => 25,
                Interrupt::Lpspi0 => 26,
                Interrupt::Lpspi1 => 27,
                Interrupt::Lpspi2 => 28,
                Interrupt::Lpuart0RxTx => 31,
                Interrupt::Lpuart1RxTx => 33,
                Interrupt::Lpuart2RxTx => 35,
                Interrupt::Adc0 => 39,
                Interrupt::Adc1 => 40,
                Interrupt::Cmp0 => 41,
                Interrupt::ErmSingleFault => 44,
                Interrupt::ErmDoubleFault => 45,
                Interrupt::Rtc => 46,
                Interrupt::RtcSeconds => 47,
                Interrupt::Lpit0Ch0 => 48,
                Interrupt::Lpit0Ch1 => 49,
                Interrupt::Lpit0Ch2 => 50,
                Interrupt::Lpit0Ch3 => 51,
                Interrupt::Pdb0 => 52,
                Interrupt::Scg => 57,
                Interrupt::Lptmr0 => 58,
                Interrupt::Porta => 59,
                Interrupt::Portb => 60,
                Interrupt::Portc => 61,
                Interrupt::Portd => 62,
                Interrupt::Porte => 63,
                Interrupt::Pdb1 => 68,
                Interrupt::Flexio => 69,
                Interrupt::Can0Ored => 78,
                Interrupt::Can0Error => 79,
                Interrupt::Can0WakeUp => 80,
                Interrupt::Can0Ored015Mb => 81,
                Interrupt::Can0Ored1631Mb => 82,
                Interrupt::Can1Ored => 85,
                Interrupt::Can1Error => 86,
                Interrupt::Can1Ored015Mb => 88,
                Interrupt::Can2Ored => 92,
                Interrupt::Can2Error => 93,
                Interrupt::Can2Ored015Mb => 95,
                Interrupt::Ftm0Ch0Ch1 => 99,
                Interrupt::Ftm0Ch2Ch3 => 100,
                Interrupt::Ftm0Ch4Ch5 => 101,
                Interrupt::Ftm0Ch6Ch7 => 102,
                Interrupt::Ftm0Fault => 103,
                Interrupt::Ftm0OvfReload => 104,
                Interrupt::Ftm1Ch0Ch1 => 105,
                Interrupt::Ftm1Ch2Ch3 => 106,
                Interrupt::Ftm1Ch4Ch5 => 107,
                Interrupt::Ftm1Ch6Ch7 => 108,
                Interrupt::Ftm1Fault => 109,
                Interrupt::Ftm1OvfReload => 110,
                Interrupt::Ftm2Ch0Ch1 => 111,
                Interrupt::Ftm2Ch2Ch3 => 112,
                Interrupt::Ftm2Ch4Ch5 => 113,
                Interrupt::Ftm2Ch6Ch7 => 114,
                Interrupt::Ftm2Fault => 115,
                Interrupt::Ftm2OvfReload => 116,
                Interrupt::Ftm3Ch0Ch1 => 117,
                Interrupt::Ftm3Ch2Ch3 => 118,
                Interrupt::Ftm3Ch4Ch5 => 119,
                Interrupt::Ftm3Ch6Ch7 => 120,
                Interrupt::Ftm3Fault => 121,
                Interrupt::Ftm3OvfReload => 122,
            }
        }
    }
}
pub use cortex_m::peripheral::Cpuid;
pub use cortex_m::peripheral::CPUID;
pub use cortex_m::peripheral::Dcb;
pub use cortex_m::peripheral::DCB;
pub use cortex_m::peripheral::Dwt;
pub use cortex_m::peripheral::DWT;
pub use cortex_m::peripheral::Fpb;
pub use cortex_m::peripheral::FPB;
pub use cortex_m::peripheral::Fpu;
pub use cortex_m::peripheral::FPU;
pub use cortex_m::peripheral::Itm;
pub use cortex_m::peripheral::ITM;
pub use cortex_m::peripheral::Mpu;
pub use cortex_m::peripheral::MPU;
pub use cortex_m::peripheral::Nvic;
pub use cortex_m::peripheral::NVIC;
pub use cortex_m::peripheral::Scb;
pub use cortex_m::peripheral::SCB;
pub use cortex_m::peripheral::Syst;
pub use cortex_m::peripheral::SYST;
pub use cortex_m::peripheral::Tpiu;
pub use cortex_m::peripheral::TPIU;
# [ doc = "CSE_PRAM" ]
pub const CSE_PRAM: Peripheral<CsePram> = unsafe { Peripheral::new(335548416) };
# [ doc = "CSE_PRAM" ]
pub mod cse_pram {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - CSE PRAM 0 Register" ]
        pub embedded_ram0: EmbeddedRam0,
        # [ doc = "0x04 - CSE PRAM 1 Register" ]
        pub embedded_ram1: EmbeddedRam1,
        # [ doc = "0x08 - CSE PRAM 2 Register" ]
        pub embedded_ram2: EmbeddedRam2,
        # [ doc = "0x0c - CSE PRAM 3 Register" ]
        pub embedded_ram3: EmbeddedRam3,
        # [ doc = "0x10 - CSE PRAM 4 Register" ]
        pub embedded_ram4: EmbeddedRam4,
        # [ doc = "0x14 - CSE PRAM 5 Register" ]
        pub embedded_ram5: EmbeddedRam5,
        # [ doc = "0x18 - CSE PRAM 6 Register" ]
        pub embedded_ram6: EmbeddedRam6,
        # [ doc = "0x1c - CSE PRAM 7 Register" ]
        pub embedded_ram7: EmbeddedRam7,
        # [ doc = "0x20 - CSE PRAM 8 Register" ]
        pub embedded_ram8: EmbeddedRam8,
        # [ doc = "0x24 - CSE PRAM 9 Register" ]
        pub embedded_ram9: EmbeddedRam9,
        # [ doc = "0x28 - CSE PRAM 10 Register" ]
        pub embedded_ram10: EmbeddedRam10,
        # [ doc = "0x2c - CSE PRAM 11 Register" ]
        pub embedded_ram11: EmbeddedRam11,
        # [ doc = "0x30 - CSE PRAM 12 Register" ]
        pub embedded_ram12: EmbeddedRam12,
        # [ doc = "0x34 - CSE PRAM 13 Register" ]
        pub embedded_ram13: EmbeddedRam13,
        # [ doc = "0x38 - CSE PRAM 14 Register" ]
        pub embedded_ram14: EmbeddedRam14,
        # [ doc = "0x3c - CSE PRAM 15 Register" ]
        pub embedded_ram15: EmbeddedRam15,
        # [ doc = "0x40 - CSE PRAM 16 Register" ]
        pub embedded_ram16: EmbeddedRam16,
        # [ doc = "0x44 - CSE PRAM 17 Register" ]
        pub embedded_ram17: EmbeddedRam17,
        # [ doc = "0x48 - CSE PRAM 18 Register" ]
        pub embedded_ram18: EmbeddedRam18,
        # [ doc = "0x4c - CSE PRAM 19 Register" ]
        pub embedded_ram19: EmbeddedRam19,
        # [ doc = "0x50 - CSE PRAM 20 Register" ]
        pub embedded_ram20: EmbeddedRam20,
        # [ doc = "0x54 - CSE PRAM 21 Register" ]
        pub embedded_ram21: EmbeddedRam21,
        # [ doc = "0x58 - CSE PRAM 22 Register" ]
        pub embedded_ram22: EmbeddedRam22,
        # [ doc = "0x5c - CSE PRAM 23 Register" ]
        pub embedded_ram23: EmbeddedRam23,
        # [ doc = "0x60 - CSE PRAM 24 Register" ]
        pub embedded_ram24: EmbeddedRam24,
        # [ doc = "0x64 - CSE PRAM 25 Register" ]
        pub embedded_ram25: EmbeddedRam25,
        # [ doc = "0x68 - CSE PRAM 26 Register" ]
        pub embedded_ram26: EmbeddedRam26,
        # [ doc = "0x6c - CSE PRAM 27 Register" ]
        pub embedded_ram27: EmbeddedRam27,
        # [ doc = "0x70 - CSE PRAM 28 Register" ]
        pub embedded_ram28: EmbeddedRam28,
        # [ doc = "0x74 - CSE PRAM 29 Register" ]
        pub embedded_ram29: EmbeddedRam29,
        # [ doc = "0x78 - CSE PRAM 30 Register" ]
        pub embedded_ram30: EmbeddedRam30,
        # [ doc = "0x7c - CSE PRAM 31 Register" ]
        pub embedded_ram31: EmbeddedRam31,
    }
    # [ doc = "CSE PRAM 0 Register" ]
    pub struct EmbeddedRam0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 0 Register" ]
    pub mod embedded_ram0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM0LL register." ]
    pub struct EmbeddedRam0ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM0LL register." ]
    pub mod embedded_ram0ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam0ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM0LU register." ]
    pub struct EmbeddedRam0lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM0LU register." ]
    pub mod embedded_ram0lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam0lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM0HL register." ]
    pub struct EmbeddedRam0hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM0HL register." ]
    pub mod embedded_ram0hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam0hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM0HU register." ]
    pub struct EmbeddedRam0hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM0HU register." ]
    pub mod embedded_ram0hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam0hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 1 Register" ]
    pub struct EmbeddedRam1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 1 Register" ]
    pub mod embedded_ram1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM1LL register." ]
    pub struct EmbeddedRam1ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM1LL register." ]
    pub mod embedded_ram1ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam1ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM1LU register." ]
    pub struct EmbeddedRam1lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM1LU register." ]
    pub mod embedded_ram1lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam1lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM1HL register." ]
    pub struct EmbeddedRam1hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM1HL register." ]
    pub mod embedded_ram1hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam1hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM1HU register." ]
    pub struct EmbeddedRam1hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM1HU register." ]
    pub mod embedded_ram1hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam1hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 2 Register" ]
    pub struct EmbeddedRam2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 2 Register" ]
    pub mod embedded_ram2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM2LL register." ]
    pub struct EmbeddedRam2ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM2LL register." ]
    pub mod embedded_ram2ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam2ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM2LU register." ]
    pub struct EmbeddedRam2lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM2LU register." ]
    pub mod embedded_ram2lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam2lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM2HL register." ]
    pub struct EmbeddedRam2hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM2HL register." ]
    pub mod embedded_ram2hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam2hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM2HU register." ]
    pub struct EmbeddedRam2hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM2HU register." ]
    pub mod embedded_ram2hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam2hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 3 Register" ]
    pub struct EmbeddedRam3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 3 Register" ]
    pub mod embedded_ram3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM3LL register." ]
    pub struct EmbeddedRam3ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM3LL register." ]
    pub mod embedded_ram3ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam3ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM3LU register." ]
    pub struct EmbeddedRam3lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM3LU register." ]
    pub mod embedded_ram3lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam3lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM3HL register." ]
    pub struct EmbeddedRam3hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM3HL register." ]
    pub mod embedded_ram3hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam3hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM3HU register." ]
    pub struct EmbeddedRam3hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM3HU register." ]
    pub mod embedded_ram3hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam3hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 4 Register" ]
    pub struct EmbeddedRam4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 4 Register" ]
    pub mod embedded_ram4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM4LL register." ]
    pub struct EmbeddedRam4ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM4LL register." ]
    pub mod embedded_ram4ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam4ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM4LU register." ]
    pub struct EmbeddedRam4lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM4LU register." ]
    pub mod embedded_ram4lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam4lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM4HL register." ]
    pub struct EmbeddedRam4hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM4HL register." ]
    pub mod embedded_ram4hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam4hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM4HU register." ]
    pub struct EmbeddedRam4hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM4HU register." ]
    pub mod embedded_ram4hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam4hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 5 Register" ]
    pub struct EmbeddedRam5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 5 Register" ]
    pub mod embedded_ram5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM5LL register." ]
    pub struct EmbeddedRam5ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM5LL register." ]
    pub mod embedded_ram5ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam5ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM5LU register." ]
    pub struct EmbeddedRam5lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM5LU register." ]
    pub mod embedded_ram5lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam5lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM5HL register." ]
    pub struct EmbeddedRam5hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM5HL register." ]
    pub mod embedded_ram5hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam5hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM5HU register." ]
    pub struct EmbeddedRam5hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM5HU register." ]
    pub mod embedded_ram5hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam5hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 6 Register" ]
    pub struct EmbeddedRam6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 6 Register" ]
    pub mod embedded_ram6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM6LL register." ]
    pub struct EmbeddedRam6ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM6LL register." ]
    pub mod embedded_ram6ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam6ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM6LU register." ]
    pub struct EmbeddedRam6lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM6LU register." ]
    pub mod embedded_ram6lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam6lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM6HL register." ]
    pub struct EmbeddedRam6hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM6HL register." ]
    pub mod embedded_ram6hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam6hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM6HU register." ]
    pub struct EmbeddedRam6hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM6HU register." ]
    pub mod embedded_ram6hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam6hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 7 Register" ]
    pub struct EmbeddedRam7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 7 Register" ]
    pub mod embedded_ram7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM7LL register." ]
    pub struct EmbeddedRam7ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM7LL register." ]
    pub mod embedded_ram7ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam7ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM7LU register." ]
    pub struct EmbeddedRam7lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM7LU register." ]
    pub mod embedded_ram7lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam7lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM7HL register." ]
    pub struct EmbeddedRam7hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM7HL register." ]
    pub mod embedded_ram7hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam7hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM7HU register." ]
    pub struct EmbeddedRam7hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM7HU register." ]
    pub mod embedded_ram7hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam7hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 8 Register" ]
    pub struct EmbeddedRam8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 8 Register" ]
    pub mod embedded_ram8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM8LL register." ]
    pub struct EmbeddedRam8ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM8LL register." ]
    pub mod embedded_ram8ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam8ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM8LU register." ]
    pub struct EmbeddedRam8lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM8LU register." ]
    pub mod embedded_ram8lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam8lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM8HL register." ]
    pub struct EmbeddedRam8hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM8HL register." ]
    pub mod embedded_ram8hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam8hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM8HU register." ]
    pub struct EmbeddedRam8hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM8HU register." ]
    pub mod embedded_ram8hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam8hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 9 Register" ]
    pub struct EmbeddedRam9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 9 Register" ]
    pub mod embedded_ram9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM9LL register." ]
    pub struct EmbeddedRam9ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM9LL register." ]
    pub mod embedded_ram9ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam9ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM9LU register." ]
    pub struct EmbeddedRam9lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM9LU register." ]
    pub mod embedded_ram9lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam9lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM9HL register." ]
    pub struct EmbeddedRam9hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM9HL register." ]
    pub mod embedded_ram9hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam9hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM9HU register." ]
    pub struct EmbeddedRam9hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM9HU register." ]
    pub mod embedded_ram9hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam9hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 10 Register" ]
    pub struct EmbeddedRam10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 10 Register" ]
    pub mod embedded_ram10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM10LL register." ]
    pub struct EmbeddedRam10ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM10LL register." ]
    pub mod embedded_ram10ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam10ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM10LU register." ]
    pub struct EmbeddedRam10lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM10LU register." ]
    pub mod embedded_ram10lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam10lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM10HL register." ]
    pub struct EmbeddedRam10hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM10HL register." ]
    pub mod embedded_ram10hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam10hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM10HU register." ]
    pub struct EmbeddedRam10hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM10HU register." ]
    pub mod embedded_ram10hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam10hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 11 Register" ]
    pub struct EmbeddedRam11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 11 Register" ]
    pub mod embedded_ram11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM11LL register." ]
    pub struct EmbeddedRam11ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM11LL register." ]
    pub mod embedded_ram11ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam11ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM11LU register." ]
    pub struct EmbeddedRam11lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM11LU register." ]
    pub mod embedded_ram11lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam11lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM11HL register." ]
    pub struct EmbeddedRam11hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM11HL register." ]
    pub mod embedded_ram11hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam11hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM11HU register." ]
    pub struct EmbeddedRam11hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM11HU register." ]
    pub mod embedded_ram11hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam11hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 12 Register" ]
    pub struct EmbeddedRam12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 12 Register" ]
    pub mod embedded_ram12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM12LL register." ]
    pub struct EmbeddedRam12ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM12LL register." ]
    pub mod embedded_ram12ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam12ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM12LU register." ]
    pub struct EmbeddedRam12lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM12LU register." ]
    pub mod embedded_ram12lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam12lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM12HL register." ]
    pub struct EmbeddedRam12hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM12HL register." ]
    pub mod embedded_ram12hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam12hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM12HU register." ]
    pub struct EmbeddedRam12hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM12HU register." ]
    pub mod embedded_ram12hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam12hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 13 Register" ]
    pub struct EmbeddedRam13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 13 Register" ]
    pub mod embedded_ram13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM13LL register." ]
    pub struct EmbeddedRam13ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM13LL register." ]
    pub mod embedded_ram13ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam13ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM13LU register." ]
    pub struct EmbeddedRam13lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM13LU register." ]
    pub mod embedded_ram13lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam13lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM13HL register." ]
    pub struct EmbeddedRam13hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM13HL register." ]
    pub mod embedded_ram13hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam13hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM13HU register." ]
    pub struct EmbeddedRam13hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM13HU register." ]
    pub mod embedded_ram13hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam13hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 14 Register" ]
    pub struct EmbeddedRam14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 14 Register" ]
    pub mod embedded_ram14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM14LL register." ]
    pub struct EmbeddedRam14ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM14LL register." ]
    pub mod embedded_ram14ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam14ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM14LU register." ]
    pub struct EmbeddedRam14lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM14LU register." ]
    pub mod embedded_ram14lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam14lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM14HL register." ]
    pub struct EmbeddedRam14hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM14HL register." ]
    pub mod embedded_ram14hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam14hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM14HU register." ]
    pub struct EmbeddedRam14hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM14HU register." ]
    pub mod embedded_ram14hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam14hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 15 Register" ]
    pub struct EmbeddedRam15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 15 Register" ]
    pub mod embedded_ram15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM15LL register." ]
    pub struct EmbeddedRam15ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM15LL register." ]
    pub mod embedded_ram15ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam15ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM15LU register." ]
    pub struct EmbeddedRam15lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM15LU register." ]
    pub mod embedded_ram15lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam15lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM15HL register." ]
    pub struct EmbeddedRam15hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM15HL register." ]
    pub mod embedded_ram15hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam15hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM15HU register." ]
    pub struct EmbeddedRam15hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM15HU register." ]
    pub mod embedded_ram15hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam15hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 16 Register" ]
    pub struct EmbeddedRam16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 16 Register" ]
    pub mod embedded_ram16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM16LL register." ]
    pub struct EmbeddedRam16ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM16LL register." ]
    pub mod embedded_ram16ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam16ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM16LU register." ]
    pub struct EmbeddedRam16lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM16LU register." ]
    pub mod embedded_ram16lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam16lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM16HL register." ]
    pub struct EmbeddedRam16hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM16HL register." ]
    pub mod embedded_ram16hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam16hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM16HU register." ]
    pub struct EmbeddedRam16hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM16HU register." ]
    pub mod embedded_ram16hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam16hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 17 Register" ]
    pub struct EmbeddedRam17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 17 Register" ]
    pub mod embedded_ram17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM17LL register." ]
    pub struct EmbeddedRam17ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM17LL register." ]
    pub mod embedded_ram17ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam17ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM17LU register." ]
    pub struct EmbeddedRam17lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM17LU register." ]
    pub mod embedded_ram17lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam17lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM17HL register." ]
    pub struct EmbeddedRam17hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM17HL register." ]
    pub mod embedded_ram17hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam17hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM17HU register." ]
    pub struct EmbeddedRam17hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM17HU register." ]
    pub mod embedded_ram17hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam17hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 18 Register" ]
    pub struct EmbeddedRam18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 18 Register" ]
    pub mod embedded_ram18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM18LL register." ]
    pub struct EmbeddedRam18ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM18LL register." ]
    pub mod embedded_ram18ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam18ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM18LU register." ]
    pub struct EmbeddedRam18lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM18LU register." ]
    pub mod embedded_ram18lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam18lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM18HL register." ]
    pub struct EmbeddedRam18hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM18HL register." ]
    pub mod embedded_ram18hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam18hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM18HU register." ]
    pub struct EmbeddedRam18hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM18HU register." ]
    pub mod embedded_ram18hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam18hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 19 Register" ]
    pub struct EmbeddedRam19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 19 Register" ]
    pub mod embedded_ram19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM19LL register." ]
    pub struct EmbeddedRam19ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM19LL register." ]
    pub mod embedded_ram19ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam19ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM19LU register." ]
    pub struct EmbeddedRam19lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM19LU register." ]
    pub mod embedded_ram19lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam19lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM19HL register." ]
    pub struct EmbeddedRam19hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM19HL register." ]
    pub mod embedded_ram19hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam19hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM19HU register." ]
    pub struct EmbeddedRam19hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM19HU register." ]
    pub mod embedded_ram19hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam19hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 20 Register" ]
    pub struct EmbeddedRam20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 20 Register" ]
    pub mod embedded_ram20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM20LL register." ]
    pub struct EmbeddedRam20ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM20LL register." ]
    pub mod embedded_ram20ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam20ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM20LU register." ]
    pub struct EmbeddedRam20lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM20LU register." ]
    pub mod embedded_ram20lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam20lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM20HL register." ]
    pub struct EmbeddedRam20hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM20HL register." ]
    pub mod embedded_ram20hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam20hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM20HU register." ]
    pub struct EmbeddedRam20hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM20HU register." ]
    pub mod embedded_ram20hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam20hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 21 Register" ]
    pub struct EmbeddedRam21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 21 Register" ]
    pub mod embedded_ram21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM21LL register." ]
    pub struct EmbeddedRam21ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM21LL register." ]
    pub mod embedded_ram21ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam21ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM21LU register." ]
    pub struct EmbeddedRam21lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM21LU register." ]
    pub mod embedded_ram21lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam21lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM21HL register." ]
    pub struct EmbeddedRam21hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM21HL register." ]
    pub mod embedded_ram21hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam21hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM21HU register." ]
    pub struct EmbeddedRam21hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM21HU register." ]
    pub mod embedded_ram21hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam21hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 22 Register" ]
    pub struct EmbeddedRam22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 22 Register" ]
    pub mod embedded_ram22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM22LL register." ]
    pub struct EmbeddedRam22ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM22LL register." ]
    pub mod embedded_ram22ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam22ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM22LU register." ]
    pub struct EmbeddedRam22lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM22LU register." ]
    pub mod embedded_ram22lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam22lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM22HL register." ]
    pub struct EmbeddedRam22hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM22HL register." ]
    pub mod embedded_ram22hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam22hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM22HU register." ]
    pub struct EmbeddedRam22hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM22HU register." ]
    pub mod embedded_ram22hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam22hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 23 Register" ]
    pub struct EmbeddedRam23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 23 Register" ]
    pub mod embedded_ram23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM23LL register." ]
    pub struct EmbeddedRam23ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM23LL register." ]
    pub mod embedded_ram23ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam23ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM23LU register." ]
    pub struct EmbeddedRam23lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM23LU register." ]
    pub mod embedded_ram23lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam23lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM23HL register." ]
    pub struct EmbeddedRam23hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM23HL register." ]
    pub mod embedded_ram23hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam23hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM23HU register." ]
    pub struct EmbeddedRam23hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM23HU register." ]
    pub mod embedded_ram23hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam23hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 24 Register" ]
    pub struct EmbeddedRam24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 24 Register" ]
    pub mod embedded_ram24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM24LL register." ]
    pub struct EmbeddedRam24ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM24LL register." ]
    pub mod embedded_ram24ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam24ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM24LU register." ]
    pub struct EmbeddedRam24lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM24LU register." ]
    pub mod embedded_ram24lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam24lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM24HL register." ]
    pub struct EmbeddedRam24hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM24HL register." ]
    pub mod embedded_ram24hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam24hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM24HU register." ]
    pub struct EmbeddedRam24hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM24HU register." ]
    pub mod embedded_ram24hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam24hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 25 Register" ]
    pub struct EmbeddedRam25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 25 Register" ]
    pub mod embedded_ram25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM25LL register." ]
    pub struct EmbeddedRam25ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM25LL register." ]
    pub mod embedded_ram25ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam25ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM25LU register." ]
    pub struct EmbeddedRam25lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM25LU register." ]
    pub mod embedded_ram25lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam25lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM25HL register." ]
    pub struct EmbeddedRam25hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM25HL register." ]
    pub mod embedded_ram25hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam25hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM25HU register." ]
    pub struct EmbeddedRam25hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM25HU register." ]
    pub mod embedded_ram25hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam25hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 26 Register" ]
    pub struct EmbeddedRam26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 26 Register" ]
    pub mod embedded_ram26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM26LL register." ]
    pub struct EmbeddedRam26ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM26LL register." ]
    pub mod embedded_ram26ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam26ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM26LU register." ]
    pub struct EmbeddedRam26lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM26LU register." ]
    pub mod embedded_ram26lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam26lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM26HL register." ]
    pub struct EmbeddedRam26hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM26HL register." ]
    pub mod embedded_ram26hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam26hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM26HU register." ]
    pub struct EmbeddedRam26hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM26HU register." ]
    pub mod embedded_ram26hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam26hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 27 Register" ]
    pub struct EmbeddedRam27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 27 Register" ]
    pub mod embedded_ram27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM27LL register." ]
    pub struct EmbeddedRam27ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM27LL register." ]
    pub mod embedded_ram27ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam27ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM27LU register." ]
    pub struct EmbeddedRam27lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM27LU register." ]
    pub mod embedded_ram27lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam27lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM27HL register." ]
    pub struct EmbeddedRam27hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM27HL register." ]
    pub mod embedded_ram27hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam27hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM27HU register." ]
    pub struct EmbeddedRam27hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM27HU register." ]
    pub mod embedded_ram27hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam27hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 28 Register" ]
    pub struct EmbeddedRam28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 28 Register" ]
    pub mod embedded_ram28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM28LL register." ]
    pub struct EmbeddedRam28ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM28LL register." ]
    pub mod embedded_ram28ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam28ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM28LU register." ]
    pub struct EmbeddedRam28lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM28LU register." ]
    pub mod embedded_ram28lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam28lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM28HL register." ]
    pub struct EmbeddedRam28hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM28HL register." ]
    pub mod embedded_ram28hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam28hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM28HU register." ]
    pub struct EmbeddedRam28hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM28HU register." ]
    pub mod embedded_ram28hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam28hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 29 Register" ]
    pub struct EmbeddedRam29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 29 Register" ]
    pub mod embedded_ram29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM29LL register." ]
    pub struct EmbeddedRam29ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM29LL register." ]
    pub mod embedded_ram29ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam29ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM29LU register." ]
    pub struct EmbeddedRam29lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM29LU register." ]
    pub mod embedded_ram29lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam29lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM29HL register." ]
    pub struct EmbeddedRam29hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM29HL register." ]
    pub mod embedded_ram29hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam29hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM29HU register." ]
    pub struct EmbeddedRam29hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM29HU register." ]
    pub mod embedded_ram29hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam29hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 30 Register" ]
    pub struct EmbeddedRam30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 30 Register" ]
    pub mod embedded_ram30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM30LL register." ]
    pub struct EmbeddedRam30ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM30LL register." ]
    pub mod embedded_ram30ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam30ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM30LU register." ]
    pub struct EmbeddedRam30lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM30LU register." ]
    pub mod embedded_ram30lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam30lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM30HL register." ]
    pub struct EmbeddedRam30hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM30HL register." ]
    pub mod embedded_ram30hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam30hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM30HU register." ]
    pub struct EmbeddedRam30hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM30HU register." ]
    pub mod embedded_ram30hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam30hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM 31 Register" ]
    pub struct EmbeddedRam31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CSE PRAM 31 Register" ]
    pub mod embedded_ram31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte3R {
            bits: u8,
        }
        impl Byte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte2R {
            bits: u8,
        }
        impl Byte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte1R {
            bits: u8,
        }
        impl Byte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Byte0R {
            bits: u8,
        }
        impl Byte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Byte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Byte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&self) -> Byte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&self) -> Byte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&self) -> Byte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&self) -> Byte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Byte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_3(&mut self) -> _Byte3W {
                _Byte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_2(&mut self) -> _Byte2W {
                _Byte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_1(&mut self) -> _Byte1W {
                _Byte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn byte_0(&mut self) -> _Byte0W {
                _Byte0W { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM31LL register." ]
    pub struct EmbeddedRam31ll {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM31LL register." ]
    pub mod embedded_ram31ll {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam31ll {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLlR {
            bits: u8,
        }
        impl RamLlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&self) -> RamLlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit RAM_" ]
            # [ inline ( always ) ]
            pub fn ram_ll(&mut self) -> _RamLlW {
                _RamLlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM31LU register." ]
    pub struct EmbeddedRam31lu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM31LU register." ]
    pub mod embedded_ram31lu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam31lu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamLuR {
            bits: u8,
        }
        impl RamLuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamLuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamLuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&self) -> RamLuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamLuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_LL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_lu(&mut self) -> _RamLuW {
                _RamLuW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM31HL register." ]
    pub struct EmbeddedRam31hl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM31HL register." ]
    pub mod embedded_ram31hl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam31hl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHlR {
            bits: u8,
        }
        impl RamHlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&self) -> RamHlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hl(&mut self) -> _RamHlW {
                _RamHlW { w: self }
            }
        }
    }
    # [ doc = "CSE PRAM31HU register." ]
    pub struct EmbeddedRam31hu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CSE PRAM31HU register." ]
    pub mod embedded_ram31hu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::EmbeddedRam31hu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamHuR {
            bits: u8,
        }
        impl RamHuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RamHuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RamHuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&self) -> RamHuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamHuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - RAM_HU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn ram_hu(&mut self) -> _RamHuW {
                _RamHuW { w: self }
            }
        }
    }
}
# [ doc = "CSE_PRAM" ]
pub struct CsePram {
    register_block: cse_pram::RegisterBlock,
}
impl Deref for CsePram {
    type Target = cse_pram::RegisterBlock;
    fn deref(&self) -> &cse_pram::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "AIPS-Lite Bridge" ]
pub const AIPS: Peripheral<Aips> = unsafe { Peripheral::new(1073741824) };
# [ doc = "AIPS-Lite Bridge" ]
pub mod aips {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Master Privilege Register A" ]
        pub mpra: Mpra,
        _reserved0: [u8; 28usize],
        # [ doc = "0x20 - Peripheral Access Control Register" ]
        pub pacra: Pacra,
        # [ doc = "0x24 - Peripheral Access Control Register" ]
        pub pacrb: Pacrb,
        # [ doc = "0x28 - Peripheral Access Control Register" ]
        pub pacrc: Pacrc,
        # [ doc = "0x2c - Peripheral Access Control Register" ]
        pub pacrd: Pacrd,
        _reserved1: [u8; 16usize],
        # [ doc = "0x40 - Off-Platform Peripheral Access Control Register" ]
        pub opacra: Opacra,
        # [ doc = "0x44 - Off-Platform Peripheral Access Control Register" ]
        pub opacrb: Opacrb,
        # [ doc = "0x48 - Off-Platform Peripheral Access Control Register" ]
        pub opacrc: Opacrc,
        # [ doc = "0x4c - Off-Platform Peripheral Access Control Register" ]
        pub opacrd: Opacrd,
        # [ doc = "0x50 - Off-Platform Peripheral Access Control Register" ]
        pub opacre: Opacre,
        # [ doc = "0x54 - Off-Platform Peripheral Access Control Register" ]
        pub opacrf: Opacrf,
        # [ doc = "0x58 - Off-Platform Peripheral Access Control Register" ]
        pub opacrg: Opacrg,
        # [ doc = "0x5c - Off-Platform Peripheral Access Control Register" ]
        pub opacrh: Opacrh,
        # [ doc = "0x60 - Off-Platform Peripheral Access Control Register" ]
        pub opacri: Opacri,
        # [ doc = "0x64 - Off-Platform Peripheral Access Control Register" ]
        pub opacrj: Opacrj,
        # [ doc = "0x68 - Off-Platform Peripheral Access Control Register" ]
        pub opacrk: Opacrk,
        # [ doc = "0x6c - Off-Platform Peripheral Access Control Register" ]
        pub opacrl: Opacrl,
    }
    # [ doc = "Master Privilege Register A" ]
    pub struct Mpra {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Privilege Register A" ]
    pub mod mpra {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mpra {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MPL2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mpl2R {
            # [ doc = "Accesses from this master are forced to user-mode." ]
            _0,
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            _1,
        }
        impl Mpl2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mpl2R::_0 => 0,
                    Mpl2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mpl2R {
                match bits {
                    0 => Mpl2R::_0,
                    1 => Mpl2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mpl2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mpl2R::_1
            }
        }
        # [ doc = "Possible values of the field `MTW2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mtw2R {
            # [ doc = "This master is not trusted for write accesses." ]
            _0,
            # [ doc = "This master is trusted for write accesses." ]
            _1,
        }
        impl Mtw2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mtw2R::_0 => 0,
                    Mtw2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mtw2R {
                match bits {
                    0 => Mtw2R::_0,
                    1 => Mtw2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mtw2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mtw2R::_1
            }
        }
        # [ doc = "Possible values of the field `MTR2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mtr2R {
            # [ doc = "This master is not trusted for read accesses." ]
            _0,
            # [ doc = "This master is trusted for read accesses." ]
            _1,
        }
        impl Mtr2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mtr2R::_0 => 0,
                    Mtr2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mtr2R {
                match bits {
                    0 => Mtr2R::_0,
                    1 => Mtr2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mtr2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mtr2R::_1
            }
        }
        # [ doc = "Possible values of the field `MPL1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mpl1R {
            # [ doc = "Accesses from this master are forced to user-mode." ]
            _0,
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            _1,
        }
        impl Mpl1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mpl1R::_0 => 0,
                    Mpl1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mpl1R {
                match bits {
                    0 => Mpl1R::_0,
                    1 => Mpl1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mpl1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mpl1R::_1
            }
        }
        # [ doc = "Possible values of the field `MTW1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mtw1R {
            # [ doc = "This master is not trusted for write accesses." ]
            _0,
            # [ doc = "This master is trusted for write accesses." ]
            _1,
        }
        impl Mtw1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mtw1R::_0 => 0,
                    Mtw1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mtw1R {
                match bits {
                    0 => Mtw1R::_0,
                    1 => Mtw1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mtw1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mtw1R::_1
            }
        }
        # [ doc = "Possible values of the field `MTR1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mtr1R {
            # [ doc = "This master is not trusted for read accesses." ]
            _0,
            # [ doc = "This master is trusted for read accesses." ]
            _1,
        }
        impl Mtr1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mtr1R::_0 => 0,
                    Mtr1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mtr1R {
                match bits {
                    0 => Mtr1R::_0,
                    1 => Mtr1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mtr1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mtr1R::_1
            }
        }
        # [ doc = "Possible values of the field `MPL0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mpl0R {
            # [ doc = "Accesses from this master are forced to user-mode." ]
            _0,
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            _1,
        }
        impl Mpl0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mpl0R::_0 => 0,
                    Mpl0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mpl0R {
                match bits {
                    0 => Mpl0R::_0,
                    1 => Mpl0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mpl0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mpl0R::_1
            }
        }
        # [ doc = "Possible values of the field `MTW0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mtw0R {
            # [ doc = "This master is not trusted for write accesses." ]
            _0,
            # [ doc = "This master is trusted for write accesses." ]
            _1,
        }
        impl Mtw0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mtw0R::_0 => 0,
                    Mtw0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mtw0R {
                match bits {
                    0 => Mtw0R::_0,
                    1 => Mtw0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mtw0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mtw0R::_1
            }
        }
        # [ doc = "Possible values of the field `MTR0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mtr0R {
            # [ doc = "This master is not trusted for read accesses." ]
            _0,
            # [ doc = "This master is trusted for read accesses." ]
            _1,
        }
        impl Mtr0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mtr0R::_0 => 0,
                    Mtr0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mtr0R {
                match bits {
                    0 => Mtr0R::_0,
                    1 => Mtr0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Mtr0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Mtr0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `MPL2`" ]
        pub enum Mpl2W {
            # [ doc = "Accesses from this master are forced to user-mode." ]
            _0,
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            _1,
        }
        impl Mpl2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mpl2W::_0 => 0,
                    Mpl2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mpl2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mpl2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mpl2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from this master are forced to user-mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mpl2W::_0)
            }
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mpl2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MTW2`" ]
        pub enum Mtw2W {
            # [ doc = "This master is not trusted for write accesses." ]
            _0,
            # [ doc = "This master is trusted for write accesses." ]
            _1,
        }
        impl Mtw2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mtw2W::_0 => 0,
                    Mtw2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mtw2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mtw2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mtw2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This master is not trusted for write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mtw2W::_0)
            }
            # [ doc = "This master is trusted for write accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mtw2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MTR2`" ]
        pub enum Mtr2W {
            # [ doc = "This master is not trusted for read accesses." ]
            _0,
            # [ doc = "This master is trusted for read accesses." ]
            _1,
        }
        impl Mtr2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mtr2W::_0 => 0,
                    Mtr2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mtr2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mtr2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mtr2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This master is not trusted for read accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mtr2W::_0)
            }
            # [ doc = "This master is trusted for read accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mtr2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MPL1`" ]
        pub enum Mpl1W {
            # [ doc = "Accesses from this master are forced to user-mode." ]
            _0,
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            _1,
        }
        impl Mpl1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mpl1W::_0 => 0,
                    Mpl1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mpl1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mpl1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mpl1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from this master are forced to user-mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mpl1W::_0)
            }
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mpl1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MTW1`" ]
        pub enum Mtw1W {
            # [ doc = "This master is not trusted for write accesses." ]
            _0,
            # [ doc = "This master is trusted for write accesses." ]
            _1,
        }
        impl Mtw1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mtw1W::_0 => 0,
                    Mtw1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mtw1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mtw1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mtw1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This master is not trusted for write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mtw1W::_0)
            }
            # [ doc = "This master is trusted for write accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mtw1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MTR1`" ]
        pub enum Mtr1W {
            # [ doc = "This master is not trusted for read accesses." ]
            _0,
            # [ doc = "This master is trusted for read accesses." ]
            _1,
        }
        impl Mtr1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mtr1W::_0 => 0,
                    Mtr1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mtr1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mtr1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mtr1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This master is not trusted for read accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mtr1W::_0)
            }
            # [ doc = "This master is trusted for read accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mtr1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MPL0`" ]
        pub enum Mpl0W {
            # [ doc = "Accesses from this master are forced to user-mode." ]
            _0,
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            _1,
        }
        impl Mpl0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mpl0W::_0 => 0,
                    Mpl0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mpl0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mpl0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mpl0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from this master are forced to user-mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mpl0W::_0)
            }
            # [ doc = "Accesses from this master are not forced to user-mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mpl0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MTW0`" ]
        pub enum Mtw0W {
            # [ doc = "This master is not trusted for write accesses." ]
            _0,
            # [ doc = "This master is trusted for write accesses." ]
            _1,
        }
        impl Mtw0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mtw0W::_0 => 0,
                    Mtw0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mtw0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mtw0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mtw0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This master is not trusted for write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mtw0W::_0)
            }
            # [ doc = "This master is trusted for write accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mtw0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MTR0`" ]
        pub enum Mtr0W {
            # [ doc = "This master is not trusted for read accesses." ]
            _0,
            # [ doc = "This master is trusted for read accesses." ]
            _1,
        }
        impl Mtr0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mtr0W::_0 => 0,
                    Mtr0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mtr0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mtr0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mtr0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This master is not trusted for read accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Mtr0W::_0)
            }
            # [ doc = "This master is trusted for read accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Mtr0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 20 - Master 2 Privilege Level" ]
            # [ inline ( always ) ]
            pub fn mpl2(&self) -> Mpl2R {
                Mpl2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Master 2 Trusted For Writes" ]
            # [ inline ( always ) ]
            pub fn mtw2(&self) -> Mtw2R {
                Mtw2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Master 2 Trusted For Read" ]
            # [ inline ( always ) ]
            pub fn mtr2(&self) -> Mtr2R {
                Mtr2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Master 1 Privilege Level" ]
            # [ inline ( always ) ]
            pub fn mpl1(&self) -> Mpl1R {
                Mpl1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 25 - Master 1 Trusted for Writes" ]
            # [ inline ( always ) ]
            pub fn mtw1(&self) -> Mtw1R {
                Mtw1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 25;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 26 - Master 1 Trusted for Read" ]
            # [ inline ( always ) ]
            pub fn mtr1(&self) -> Mtr1R {
                Mtr1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 26;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - Master 0 Privilege Level" ]
            # [ inline ( always ) ]
            pub fn mpl0(&self) -> Mpl0R {
                Mpl0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 28;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 29 - Master 0 Trusted For Writes" ]
            # [ inline ( always ) ]
            pub fn mtw0(&self) -> Mtw0R {
                Mtw0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - Master 0 Trusted For Read" ]
            # [ inline ( always ) ]
            pub fn mtr0(&self) -> Mtr0R {
                Mtr0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2003828736 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 20 - Master 2 Privilege Level" ]
            # [ inline ( always ) ]
            pub fn mpl2(&mut self) -> _Mpl2W {
                _Mpl2W { w: self }
            }
            # [ doc = "Bit 21 - Master 2 Trusted For Writes" ]
            # [ inline ( always ) ]
            pub fn mtw2(&mut self) -> _Mtw2W {
                _Mtw2W { w: self }
            }
            # [ doc = "Bit 22 - Master 2 Trusted For Read" ]
            # [ inline ( always ) ]
            pub fn mtr2(&mut self) -> _Mtr2W {
                _Mtr2W { w: self }
            }
            # [ doc = "Bit 24 - Master 1 Privilege Level" ]
            # [ inline ( always ) ]
            pub fn mpl1(&mut self) -> _Mpl1W {
                _Mpl1W { w: self }
            }
            # [ doc = "Bit 25 - Master 1 Trusted for Writes" ]
            # [ inline ( always ) ]
            pub fn mtw1(&mut self) -> _Mtw1W {
                _Mtw1W { w: self }
            }
            # [ doc = "Bit 26 - Master 1 Trusted for Read" ]
            # [ inline ( always ) ]
            pub fn mtr1(&mut self) -> _Mtr1W {
                _Mtr1W { w: self }
            }
            # [ doc = "Bit 28 - Master 0 Privilege Level" ]
            # [ inline ( always ) ]
            pub fn mpl0(&mut self) -> _Mpl0W {
                _Mpl0W { w: self }
            }
            # [ doc = "Bit 29 - Master 0 Trusted For Writes" ]
            # [ inline ( always ) ]
            pub fn mtw0(&mut self) -> _Mtw0W {
                _Mtw0W { w: self }
            }
            # [ doc = "Bit 30 - Master 0 Trusted For Read" ]
            # [ inline ( always ) ]
            pub fn mtr0(&mut self) -> _Mtr0W {
                _Mtr0W { w: self }
            }
        }
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub struct Pacra {
        register: VolatileCell<u32>,
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub mod pacra {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pacra {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1409286144 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub struct Pacrb {
        register: VolatileCell<u32>,
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub mod pacrb {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pacrb {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1140851712 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub struct Pacrc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub mod pacrc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pacrc {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub struct Pacrd {
        register: VolatileCell<u32>,
    }
    # [ doc = "Peripheral Access Control Register" ]
    pub mod pacrd {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pacrd {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1140850688 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacra {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacra {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacra {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp7R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp7R::_0 => 0,
                    Tp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp7R {
                match bits {
                    0 => Tp7R::_0,
                    1 => Tp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp7R::_1
            }
        }
        # [ doc = "Possible values of the field `WP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp7R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp7R::_0 => 0,
                    Wp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp7R {
                match bits {
                    0 => Wp7R::_0,
                    1 => Wp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp7R::_1
            }
        }
        # [ doc = "Possible values of the field `SP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp7R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp7R::_0 => 0,
                    Sp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp7R {
                match bits {
                    0 => Sp7R::_0,
                    1 => Sp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp7R::_1
            }
        }
        # [ doc = "Possible values of the field `TP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp6R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp6R::_0 => 0,
                    Tp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp6R {
                match bits {
                    0 => Tp6R::_0,
                    1 => Tp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp6R::_1
            }
        }
        # [ doc = "Possible values of the field `WP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp6R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp6R::_0 => 0,
                    Wp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp6R {
                match bits {
                    0 => Wp6R::_0,
                    1 => Wp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp6R::_1
            }
        }
        # [ doc = "Possible values of the field `SP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp6R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp6R::_0 => 0,
                    Sp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp6R {
                match bits {
                    0 => Sp6R::_0,
                    1 => Sp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp6R::_1
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Possible values of the field `TP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp4R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp4R::_0 => 0,
                    Tp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp4R {
                match bits {
                    0 => Tp4R::_0,
                    1 => Tp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp4R::_1
            }
        }
        # [ doc = "Possible values of the field `WP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp4R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp4R::_0 => 0,
                    Wp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp4R {
                match bits {
                    0 => Wp4R::_0,
                    1 => Wp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp4R::_1
            }
        }
        # [ doc = "Possible values of the field `SP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp4R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp4R::_0 => 0,
                    Sp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp4R {
                match bits {
                    0 => Sp4R::_0,
                    1 => Sp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp4R::_1
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP7`" ]
        pub enum Tp7W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp7W::_0 => 0,
                    Tp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp7W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP7`" ]
        pub enum Wp7W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp7W::_0 => 0,
                    Wp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp7W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP7`" ]
        pub enum Sp7W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp7W::_0 => 0,
                    Sp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp7W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP6`" ]
        pub enum Tp6W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp6W::_0 => 0,
                    Tp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp6W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP6`" ]
        pub enum Wp6W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp6W::_0 => 0,
                    Wp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp6W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP6`" ]
        pub enum Sp6W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp6W::_0 => 0,
                    Sp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp6W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP4`" ]
        pub enum Tp4W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp4W::_0 => 0,
                    Tp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp4W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP4`" ]
        pub enum Wp4W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp4W::_0 => 0,
                    Wp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp4W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP4`" ]
        pub enum Sp4W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp4W::_0 => 0,
                    Sp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp4W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp7(&self) -> Tp7R {
                Tp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp7(&self) -> Wp7R {
                Wp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp7(&self) -> Sp7R {
                Sp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&self) -> Tp6R {
                Tp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&self) -> Wp6R {
                Wp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&self) -> Sp6R {
                Sp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&self) -> Tp4R {
                Tp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&self) -> Wp4R {
                Wp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&self) -> Sp4R {
                Sp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1140868164 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp7(&mut self) -> _Tp7W {
                _Tp7W { w: self }
            }
            # [ doc = "Bit 1 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp7(&mut self) -> _Wp7W {
                _Wp7W { w: self }
            }
            # [ doc = "Bit 2 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp7(&mut self) -> _Sp7W {
                _Sp7W { w: self }
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&mut self) -> _Tp6W {
                _Tp6W { w: self }
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&mut self) -> _Wp6W {
                _Wp6W { w: self }
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&mut self) -> _Sp6W {
                _Sp6W { w: self }
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&mut self) -> _Tp4W {
                _Tp4W { w: self }
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&mut self) -> _Wp4W {
                _Wp4W { w: self }
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&mut self) -> _Sp4W {
                _Sp4W { w: self }
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrb {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrb {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrb {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp6R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp6R::_0 => 0,
                    Tp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp6R {
                match bits {
                    0 => Tp6R::_0,
                    1 => Tp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp6R::_1
            }
        }
        # [ doc = "Possible values of the field `WP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp6R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp6R::_0 => 0,
                    Wp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp6R {
                match bits {
                    0 => Wp6R::_0,
                    1 => Wp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp6R::_1
            }
        }
        # [ doc = "Possible values of the field `SP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp6R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp6R::_0 => 0,
                    Sp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp6R {
                match bits {
                    0 => Sp6R::_0,
                    1 => Sp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp6R::_1
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Possible values of the field `TP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp4R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp4R::_0 => 0,
                    Tp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp4R {
                match bits {
                    0 => Tp4R::_0,
                    1 => Tp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp4R::_1
            }
        }
        # [ doc = "Possible values of the field `WP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp4R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp4R::_0 => 0,
                    Wp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp4R {
                match bits {
                    0 => Wp4R::_0,
                    1 => Wp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp4R::_1
            }
        }
        # [ doc = "Possible values of the field `SP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp4R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp4R::_0 => 0,
                    Sp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp4R {
                match bits {
                    0 => Sp4R::_0,
                    1 => Sp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp4R::_1
            }
        }
        # [ doc = "Possible values of the field `TP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp3R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp3R::_0 => 0,
                    Tp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp3R {
                match bits {
                    0 => Tp3R::_0,
                    1 => Tp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp3R::_1
            }
        }
        # [ doc = "Possible values of the field `WP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp3R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp3R::_0 => 0,
                    Wp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp3R {
                match bits {
                    0 => Wp3R::_0,
                    1 => Wp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp3R::_1
            }
        }
        # [ doc = "Possible values of the field `SP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp3R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp3R::_0 => 0,
                    Sp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp3R {
                match bits {
                    0 => Sp3R::_0,
                    1 => Sp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp3R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP6`" ]
        pub enum Tp6W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp6W::_0 => 0,
                    Tp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp6W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP6`" ]
        pub enum Wp6W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp6W::_0 => 0,
                    Wp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp6W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP6`" ]
        pub enum Sp6W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp6W::_0 => 0,
                    Sp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp6W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP4`" ]
        pub enum Tp4W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp4W::_0 => 0,
                    Tp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp4W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP4`" ]
        pub enum Wp4W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp4W::_0 => 0,
                    Wp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp4W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP4`" ]
        pub enum Sp4W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp4W::_0 => 0,
                    Sp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp4W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP3`" ]
        pub enum Tp3W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp3W::_0 => 0,
                    Tp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp3W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP3`" ]
        pub enum Wp3W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp3W::_0 => 0,
                    Wp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp3W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP3`" ]
        pub enum Sp3W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp3W::_0 => 0,
                    Sp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp3W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&self) -> Tp6R {
                Tp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&self) -> Wp6R {
                Wp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&self) -> Sp6R {
                Sp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&self) -> Tp4R {
                Tp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&self) -> Wp4R {
                Wp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&self) -> Sp4R {
                Sp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&self) -> Tp3R {
                Tp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&self) -> Wp3R {
                Wp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&self) -> Sp3R {
                Sp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 279616 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&mut self) -> _Tp6W {
                _Tp6W { w: self }
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&mut self) -> _Wp6W {
                _Wp6W { w: self }
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&mut self) -> _Sp6W {
                _Sp6W { w: self }
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&mut self) -> _Tp4W {
                _Tp4W { w: self }
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&mut self) -> _Wp4W {
                _Wp4W { w: self }
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&mut self) -> _Sp4W {
                _Sp4W { w: self }
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&mut self) -> _Tp3W {
                _Tp3W { w: self }
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&mut self) -> _Wp3W {
                _Wp3W { w: self }
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&mut self) -> _Sp3W {
                _Sp3W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp7R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp7R::_0 => 0,
                    Tp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp7R {
                match bits {
                    0 => Tp7R::_0,
                    1 => Tp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp7R::_1
            }
        }
        # [ doc = "Possible values of the field `WP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp7R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp7R::_0 => 0,
                    Wp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp7R {
                match bits {
                    0 => Wp7R::_0,
                    1 => Wp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp7R::_1
            }
        }
        # [ doc = "Possible values of the field `SP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp7R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp7R::_0 => 0,
                    Sp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp7R {
                match bits {
                    0 => Sp7R::_0,
                    1 => Sp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp7R::_1
            }
        }
        # [ doc = "Possible values of the field `TP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp6R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp6R::_0 => 0,
                    Tp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp6R {
                match bits {
                    0 => Tp6R::_0,
                    1 => Tp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp6R::_1
            }
        }
        # [ doc = "Possible values of the field `WP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp6R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp6R::_0 => 0,
                    Wp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp6R {
                match bits {
                    0 => Wp6R::_0,
                    1 => Wp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp6R::_1
            }
        }
        # [ doc = "Possible values of the field `SP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp6R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp6R::_0 => 0,
                    Sp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp6R {
                match bits {
                    0 => Sp6R::_0,
                    1 => Sp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp6R::_1
            }
        }
        # [ doc = "Possible values of the field `TP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp2R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp2R::_0 => 0,
                    Tp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp2R {
                match bits {
                    0 => Tp2R::_0,
                    1 => Tp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp2R::_1
            }
        }
        # [ doc = "Possible values of the field `WP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp2R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp2R::_0 => 0,
                    Wp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp2R {
                match bits {
                    0 => Wp2R::_0,
                    1 => Wp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp2R::_1
            }
        }
        # [ doc = "Possible values of the field `SP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp2R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp2R::_0 => 0,
                    Sp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp2R {
                match bits {
                    0 => Sp2R::_0,
                    1 => Sp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp2R::_1
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP7`" ]
        pub enum Tp7W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp7W::_0 => 0,
                    Tp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp7W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP7`" ]
        pub enum Wp7W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp7W::_0 => 0,
                    Wp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp7W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP7`" ]
        pub enum Sp7W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp7W::_0 => 0,
                    Sp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp7W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP6`" ]
        pub enum Tp6W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp6W::_0 => 0,
                    Tp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp6W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP6`" ]
        pub enum Wp6W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp6W::_0 => 0,
                    Wp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp6W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP6`" ]
        pub enum Sp6W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp6W::_0 => 0,
                    Sp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp6W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP2`" ]
        pub enum Tp2W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp2W::_0 => 0,
                    Tp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp2W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP2`" ]
        pub enum Wp2W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp2W::_0 => 0,
                    Wp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp2W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP2`" ]
        pub enum Sp2W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp2W::_0 => 0,
                    Sp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp2W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp7(&self) -> Tp7R {
                Tp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp7(&self) -> Wp7R {
                Wp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp7(&self) -> Sp7R {
                Sp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&self) -> Tp6R {
                Tp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&self) -> Wp6R {
                Wp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&self) -> Sp6R {
                Sp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&self) -> Tp2R {
                Tp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&self) -> Wp2R {
                Wp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&self) -> Sp2R {
                Sp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 22;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 71303236 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp7(&mut self) -> _Tp7W {
                _Tp7W { w: self }
            }
            # [ doc = "Bit 1 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp7(&mut self) -> _Wp7W {
                _Wp7W { w: self }
            }
            # [ doc = "Bit 2 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp7(&mut self) -> _Sp7W {
                _Sp7W { w: self }
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&mut self) -> _Tp6W {
                _Tp6W { w: self }
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&mut self) -> _Wp6W {
                _Wp6W { w: self }
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&mut self) -> _Sp6W {
                _Sp6W { w: self }
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&mut self) -> _Tp2W {
                _Tp2W { w: self }
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&mut self) -> _Wp2W {
                _Wp2W { w: self }
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&mut self) -> _Sp2W {
                _Sp2W { w: self }
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrd {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrd {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrd {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Possible values of the field `TP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp3R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp3R::_0 => 0,
                    Tp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp3R {
                match bits {
                    0 => Tp3R::_0,
                    1 => Tp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp3R::_1
            }
        }
        # [ doc = "Possible values of the field `WP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp3R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp3R::_0 => 0,
                    Wp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp3R {
                match bits {
                    0 => Wp3R::_0,
                    1 => Wp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp3R::_1
            }
        }
        # [ doc = "Possible values of the field `SP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp3R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp3R::_0 => 0,
                    Sp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp3R {
                match bits {
                    0 => Sp3R::_0,
                    1 => Sp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp3R::_1
            }
        }
        # [ doc = "Possible values of the field `TP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp2R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp2R::_0 => 0,
                    Tp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp2R {
                match bits {
                    0 => Tp2R::_0,
                    1 => Tp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp2R::_1
            }
        }
        # [ doc = "Possible values of the field `WP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp2R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp2R::_0 => 0,
                    Wp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp2R {
                match bits {
                    0 => Wp2R::_0,
                    1 => Wp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp2R::_1
            }
        }
        # [ doc = "Possible values of the field `SP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp2R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp2R::_0 => 0,
                    Sp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp2R {
                match bits {
                    0 => Sp2R::_0,
                    1 => Sp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp2R::_1
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP3`" ]
        pub enum Tp3W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp3W::_0 => 0,
                    Tp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp3W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP3`" ]
        pub enum Wp3W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp3W::_0 => 0,
                    Wp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp3W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP3`" ]
        pub enum Sp3W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp3W::_0 => 0,
                    Sp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp3W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP2`" ]
        pub enum Tp2W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp2W::_0 => 0,
                    Tp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp2W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP2`" ]
        pub enum Wp2W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp2W::_0 => 0,
                    Wp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp2W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP2`" ]
        pub enum Sp2W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp2W::_0 => 0,
                    Sp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp2W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&self) -> Tp3R {
                Tp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&self) -> Wp3R {
                Wp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&self) -> Sp3R {
                Sp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&self) -> Tp2R {
                Tp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&self) -> Wp2R {
                Wp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&self) -> Sp2R {
                Sp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 22;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1145308160 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&mut self) -> _Tp3W {
                _Tp3W { w: self }
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&mut self) -> _Wp3W {
                _Wp3W { w: self }
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&mut self) -> _Sp3W {
                _Sp3W { w: self }
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&mut self) -> _Tp2W {
                _Tp2W { w: self }
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&mut self) -> _Wp2W {
                _Wp2W { w: self }
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&mut self) -> _Sp2W {
                _Sp2W { w: self }
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacre {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacre {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacre {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp6R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp6R::_0 => 0,
                    Tp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp6R {
                match bits {
                    0 => Tp6R::_0,
                    1 => Tp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp6R::_1
            }
        }
        # [ doc = "Possible values of the field `WP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp6R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp6R::_0 => 0,
                    Wp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp6R {
                match bits {
                    0 => Wp6R::_0,
                    1 => Wp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp6R::_1
            }
        }
        # [ doc = "Possible values of the field `SP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp6R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp6R::_0 => 0,
                    Sp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp6R {
                match bits {
                    0 => Sp6R::_0,
                    1 => Sp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp6R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP6`" ]
        pub enum Tp6W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp6W::_0 => 0,
                    Tp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp6W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP6`" ]
        pub enum Wp6W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp6W::_0 => 0,
                    Wp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp6W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP6`" ]
        pub enum Sp6W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp6W::_0 => 0,
                    Sp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp6W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&self) -> Tp6R {
                Tp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&self) -> Wp6R {
                Wp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&self) -> Sp6R {
                Sp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1073741888 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&mut self) -> _Tp6W {
                _Tp6W { w: self }
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&mut self) -> _Wp6W {
                _Wp6W { w: self }
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&mut self) -> _Sp6W {
                _Sp6W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Possible values of the field `TP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp4R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp4R::_0 => 0,
                    Tp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp4R {
                match bits {
                    0 => Tp4R::_0,
                    1 => Tp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp4R::_1
            }
        }
        # [ doc = "Possible values of the field `WP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp4R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp4R::_0 => 0,
                    Wp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp4R {
                match bits {
                    0 => Wp4R::_0,
                    1 => Wp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp4R::_1
            }
        }
        # [ doc = "Possible values of the field `SP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp4R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp4R::_0 => 0,
                    Sp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp4R {
                match bits {
                    0 => Sp4R::_0,
                    1 => Sp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp4R::_1
            }
        }
        # [ doc = "Possible values of the field `TP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp3R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp3R::_0 => 0,
                    Tp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp3R {
                match bits {
                    0 => Tp3R::_0,
                    1 => Tp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp3R::_1
            }
        }
        # [ doc = "Possible values of the field `WP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp3R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp3R::_0 => 0,
                    Wp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp3R {
                match bits {
                    0 => Wp3R::_0,
                    1 => Wp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp3R::_1
            }
        }
        # [ doc = "Possible values of the field `SP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp3R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp3R::_0 => 0,
                    Sp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp3R {
                match bits {
                    0 => Sp3R::_0,
                    1 => Sp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp3R::_1
            }
        }
        # [ doc = "Possible values of the field `TP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp2R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp2R::_0 => 0,
                    Tp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp2R {
                match bits {
                    0 => Tp2R::_0,
                    1 => Tp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp2R::_1
            }
        }
        # [ doc = "Possible values of the field `WP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp2R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp2R::_0 => 0,
                    Wp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp2R {
                match bits {
                    0 => Wp2R::_0,
                    1 => Wp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp2R::_1
            }
        }
        # [ doc = "Possible values of the field `SP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp2R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp2R::_0 => 0,
                    Sp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp2R {
                match bits {
                    0 => Sp2R::_0,
                    1 => Sp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp2R::_1
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Possible values of the field `TP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp0R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp0R::_0 => 0,
                    Tp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp0R {
                match bits {
                    0 => Tp0R::_0,
                    1 => Tp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp0R::_1
            }
        }
        # [ doc = "Possible values of the field `WP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp0R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp0R::_0 => 0,
                    Wp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp0R {
                match bits {
                    0 => Wp0R::_0,
                    1 => Wp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp0R::_1
            }
        }
        # [ doc = "Possible values of the field `SP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp0R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp0R::_0 => 0,
                    Sp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp0R {
                match bits {
                    0 => Sp0R::_0,
                    1 => Sp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP4`" ]
        pub enum Tp4W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp4W::_0 => 0,
                    Tp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp4W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP4`" ]
        pub enum Wp4W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp4W::_0 => 0,
                    Wp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp4W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP4`" ]
        pub enum Sp4W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp4W::_0 => 0,
                    Sp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp4W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP3`" ]
        pub enum Tp3W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp3W::_0 => 0,
                    Tp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp3W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP3`" ]
        pub enum Wp3W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp3W::_0 => 0,
                    Wp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp3W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP3`" ]
        pub enum Sp3W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp3W::_0 => 0,
                    Sp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp3W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP2`" ]
        pub enum Tp2W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp2W::_0 => 0,
                    Tp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp2W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP2`" ]
        pub enum Wp2W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp2W::_0 => 0,
                    Wp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp2W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP2`" ]
        pub enum Sp2W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp2W::_0 => 0,
                    Sp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp2W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP0`" ]
        pub enum Tp0W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp0W::_0 => 0,
                    Tp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp0W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP0`" ]
        pub enum Wp0W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp0W::_0 => 0,
                    Wp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp0W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP0`" ]
        pub enum Sp0W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp0W::_0 => 0,
                    Sp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp0W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&self) -> Tp4R {
                Tp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&self) -> Wp4R {
                Wp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&self) -> Sp4R {
                Sp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&self) -> Tp3R {
                Tp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&self) -> Wp3R {
                Wp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&self) -> Sp3R {
                Sp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&self) -> Tp2R {
                Tp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&self) -> Wp2R {
                Wp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&self) -> Sp2R {
                Sp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 22;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&self) -> Tp0R {
                Tp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&self) -> Wp0R {
                Wp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&self) -> Sp0R {
                Sp0R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1145324544 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&mut self) -> _Tp4W {
                _Tp4W { w: self }
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&mut self) -> _Wp4W {
                _Wp4W { w: self }
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&mut self) -> _Sp4W {
                _Sp4W { w: self }
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&mut self) -> _Tp3W {
                _Tp3W { w: self }
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&mut self) -> _Wp3W {
                _Wp3W { w: self }
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&mut self) -> _Sp3W {
                _Sp3W { w: self }
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&mut self) -> _Tp2W {
                _Tp2W { w: self }
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&mut self) -> _Wp2W {
                _Wp2W { w: self }
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&mut self) -> _Sp2W {
                _Sp2W { w: self }
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
            # [ doc = "Bit 28 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp0(&mut self) -> _Tp0W {
                _Tp0W { w: self }
            }
            # [ doc = "Bit 29 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp0(&mut self) -> _Wp0W {
                _Wp0W { w: self }
            }
            # [ doc = "Bit 30 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp0(&mut self) -> _Sp0W {
                _Sp0W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrg {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp2R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp2R::_0 => 0,
                    Tp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp2R {
                match bits {
                    0 => Tp2R::_0,
                    1 => Tp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp2R::_1
            }
        }
        # [ doc = "Possible values of the field `WP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp2R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp2R::_0 => 0,
                    Wp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp2R {
                match bits {
                    0 => Wp2R::_0,
                    1 => Wp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp2R::_1
            }
        }
        # [ doc = "Possible values of the field `SP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp2R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp2R::_0 => 0,
                    Sp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp2R {
                match bits {
                    0 => Sp2R::_0,
                    1 => Sp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp2R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP2`" ]
        pub enum Tp2W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp2W::_0 => 0,
                    Tp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp2W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP2`" ]
        pub enum Wp2W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp2W::_0 => 0,
                    Wp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp2W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP2`" ]
        pub enum Sp2W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp2W::_0 => 0,
                    Sp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp2W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&self) -> Tp2R {
                Tp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&self) -> Wp2R {
                Wp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&self) -> Sp2R {
                Sp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 22;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4194304 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&mut self) -> _Tp2W {
                _Tp2W { w: self }
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&mut self) -> _Wp2W {
                _Wp2W { w: self }
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&mut self) -> _Sp2W {
                _Sp2W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrh {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrh {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrh {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp2R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp2R::_0 => 0,
                    Tp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp2R {
                match bits {
                    0 => Tp2R::_0,
                    1 => Tp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp2R::_1
            }
        }
        # [ doc = "Possible values of the field `WP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp2R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp2R::_0 => 0,
                    Wp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp2R {
                match bits {
                    0 => Wp2R::_0,
                    1 => Wp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp2R::_1
            }
        }
        # [ doc = "Possible values of the field `SP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp2R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp2R::_0 => 0,
                    Sp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp2R {
                match bits {
                    0 => Sp2R::_0,
                    1 => Sp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp2R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP2`" ]
        pub enum Tp2W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp2W::_0 => 0,
                    Tp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp2W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP2`" ]
        pub enum Wp2W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp2W::_0 => 0,
                    Wp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp2W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP2`" ]
        pub enum Sp2W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp2W::_0 => 0,
                    Sp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp2W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&self) -> Tp2R {
                Tp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&self) -> Wp2R {
                Wp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&self) -> Sp2R {
                Sp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 22;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4194304 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&mut self) -> _Tp2W {
                _Tp2W { w: self }
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&mut self) -> _Wp2W {
                _Wp2W { w: self }
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&mut self) -> _Sp2W {
                _Sp2W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacri {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacri {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacri {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp6R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp6R::_0 => 0,
                    Tp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp6R {
                match bits {
                    0 => Tp6R::_0,
                    1 => Tp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp6R::_1
            }
        }
        # [ doc = "Possible values of the field `WP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp6R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp6R::_0 => 0,
                    Wp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp6R {
                match bits {
                    0 => Wp6R::_0,
                    1 => Wp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp6R::_1
            }
        }
        # [ doc = "Possible values of the field `SP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp6R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp6R::_0 => 0,
                    Sp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp6R {
                match bits {
                    0 => Sp6R::_0,
                    1 => Sp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp6R::_1
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Possible values of the field `TP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp4R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp4R::_0 => 0,
                    Tp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp4R {
                match bits {
                    0 => Tp4R::_0,
                    1 => Tp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp4R::_1
            }
        }
        # [ doc = "Possible values of the field `WP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp4R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp4R::_0 => 0,
                    Wp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp4R {
                match bits {
                    0 => Wp4R::_0,
                    1 => Wp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp4R::_1
            }
        }
        # [ doc = "Possible values of the field `SP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp4R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp4R::_0 => 0,
                    Sp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp4R {
                match bits {
                    0 => Sp4R::_0,
                    1 => Sp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp4R::_1
            }
        }
        # [ doc = "Possible values of the field `TP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp3R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp3R::_0 => 0,
                    Tp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp3R {
                match bits {
                    0 => Tp3R::_0,
                    1 => Tp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp3R::_1
            }
        }
        # [ doc = "Possible values of the field `WP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp3R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp3R::_0 => 0,
                    Wp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp3R {
                match bits {
                    0 => Wp3R::_0,
                    1 => Wp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp3R::_1
            }
        }
        # [ doc = "Possible values of the field `SP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp3R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp3R::_0 => 0,
                    Sp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp3R {
                match bits {
                    0 => Sp3R::_0,
                    1 => Sp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp3R::_1
            }
        }
        # [ doc = "Possible values of the field `TP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp1R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp1R::_0 => 0,
                    Tp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp1R {
                match bits {
                    0 => Tp1R::_0,
                    1 => Tp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp1R::_1
            }
        }
        # [ doc = "Possible values of the field `WP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp1R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp1R::_0 => 0,
                    Wp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp1R {
                match bits {
                    0 => Wp1R::_0,
                    1 => Wp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp1R::_1
            }
        }
        # [ doc = "Possible values of the field `SP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp1R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp1R::_0 => 0,
                    Sp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp1R {
                match bits {
                    0 => Sp1R::_0,
                    1 => Sp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp1R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP6`" ]
        pub enum Tp6W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp6W::_0 => 0,
                    Tp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp6W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP6`" ]
        pub enum Wp6W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp6W::_0 => 0,
                    Wp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp6W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP6`" ]
        pub enum Sp6W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp6W::_0 => 0,
                    Sp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp6W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP4`" ]
        pub enum Tp4W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp4W::_0 => 0,
                    Tp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp4W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP4`" ]
        pub enum Wp4W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp4W::_0 => 0,
                    Wp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp4W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP4`" ]
        pub enum Sp4W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp4W::_0 => 0,
                    Sp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp4W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP3`" ]
        pub enum Tp3W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp3W::_0 => 0,
                    Tp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp3W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP3`" ]
        pub enum Wp3W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp3W::_0 => 0,
                    Wp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp3W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP3`" ]
        pub enum Sp3W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp3W::_0 => 0,
                    Sp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp3W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP1`" ]
        pub enum Tp1W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp1W::_0 => 0,
                    Tp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp1W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP1`" ]
        pub enum Wp1W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp1W::_0 => 0,
                    Wp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp1W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP1`" ]
        pub enum Sp1W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp1W::_0 => 0,
                    Sp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp1W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&self) -> Tp6R {
                Tp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&self) -> Wp6R {
                Wp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&self) -> Sp6R {
                Sp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&self) -> Tp4R {
                Tp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&self) -> Wp4R {
                Wp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&self) -> Sp4R {
                Sp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&self) -> Tp3R {
                Tp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&self) -> Wp3R {
                Wp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&self) -> Sp3R {
                Sp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&self) -> Tp1R {
                Tp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&self) -> Wp1R {
                Wp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&self) -> Sp1R {
                Sp1R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 67388480 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&mut self) -> _Tp6W {
                _Tp6W { w: self }
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&mut self) -> _Wp6W {
                _Wp6W { w: self }
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&mut self) -> _Sp6W {
                _Sp6W { w: self }
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&mut self) -> _Tp4W {
                _Tp4W { w: self }
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&mut self) -> _Wp4W {
                _Wp4W { w: self }
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&mut self) -> _Sp4W {
                _Sp4W { w: self }
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&mut self) -> _Tp3W {
                _Tp3W { w: self }
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&mut self) -> _Wp3W {
                _Wp3W { w: self }
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&mut self) -> _Sp3W {
                _Sp3W { w: self }
            }
            # [ doc = "Bit 24 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp1(&mut self) -> _Tp1W {
                _Tp1W { w: self }
            }
            # [ doc = "Bit 25 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp1(&mut self) -> _Wp1W {
                _Wp1W { w: self }
            }
            # [ doc = "Bit 26 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp1(&mut self) -> _Sp1W {
                _Sp1W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrj {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrj {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrj {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp4R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp4R::_0 => 0,
                    Tp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp4R {
                match bits {
                    0 => Tp4R::_0,
                    1 => Tp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp4R::_1
            }
        }
        # [ doc = "Possible values of the field `WP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp4R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp4R::_0 => 0,
                    Wp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp4R {
                match bits {
                    0 => Wp4R::_0,
                    1 => Wp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp4R::_1
            }
        }
        # [ doc = "Possible values of the field `SP4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp4R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp4R::_0 => 0,
                    Sp4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp4R {
                match bits {
                    0 => Sp4R::_0,
                    1 => Sp4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp4R::_1
            }
        }
        # [ doc = "Possible values of the field `TP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp3R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp3R::_0 => 0,
                    Tp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp3R {
                match bits {
                    0 => Tp3R::_0,
                    1 => Tp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp3R::_1
            }
        }
        # [ doc = "Possible values of the field `WP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp3R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp3R::_0 => 0,
                    Wp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp3R {
                match bits {
                    0 => Wp3R::_0,
                    1 => Wp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp3R::_1
            }
        }
        # [ doc = "Possible values of the field `SP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp3R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp3R::_0 => 0,
                    Sp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp3R {
                match bits {
                    0 => Sp3R::_0,
                    1 => Sp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp3R::_1
            }
        }
        # [ doc = "Possible values of the field `TP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp2R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp2R::_0 => 0,
                    Tp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp2R {
                match bits {
                    0 => Tp2R::_0,
                    1 => Tp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp2R::_1
            }
        }
        # [ doc = "Possible values of the field `WP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp2R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp2R::_0 => 0,
                    Wp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp2R {
                match bits {
                    0 => Wp2R::_0,
                    1 => Wp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp2R::_1
            }
        }
        # [ doc = "Possible values of the field `SP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp2R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp2R::_0 => 0,
                    Sp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp2R {
                match bits {
                    0 => Sp2R::_0,
                    1 => Sp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp2R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP4`" ]
        pub enum Tp4W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp4W::_0 => 0,
                    Tp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp4W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP4`" ]
        pub enum Wp4W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp4W::_0 => 0,
                    Wp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp4W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP4`" ]
        pub enum Sp4W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp4W::_0 => 0,
                    Sp4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp4W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP3`" ]
        pub enum Tp3W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp3W::_0 => 0,
                    Tp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp3W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP3`" ]
        pub enum Wp3W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp3W::_0 => 0,
                    Wp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp3W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP3`" ]
        pub enum Sp3W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp3W::_0 => 0,
                    Sp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp3W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP2`" ]
        pub enum Tp2W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp2W::_0 => 0,
                    Tp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp2W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP2`" ]
        pub enum Wp2W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp2W::_0 => 0,
                    Wp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp2W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP2`" ]
        pub enum Sp2W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp2W::_0 => 0,
                    Sp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp2W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&self) -> Tp4R {
                Tp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&self) -> Wp4R {
                Wp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&self) -> Sp4R {
                Sp4R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&self) -> Tp3R {
                Tp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&self) -> Wp3R {
                Wp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&self) -> Sp3R {
                Sp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&self) -> Tp2R {
                Tp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&self) -> Wp2R {
                Wp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&self) -> Sp2R {
                Sp2R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 22;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4472832 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 12 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp4(&mut self) -> _Tp4W {
                _Tp4W { w: self }
            }
            # [ doc = "Bit 13 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp4(&mut self) -> _Wp4W {
                _Wp4W { w: self }
            }
            # [ doc = "Bit 14 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp4(&mut self) -> _Sp4W {
                _Sp4W { w: self }
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&mut self) -> _Tp3W {
                _Tp3W { w: self }
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&mut self) -> _Wp3W {
                _Wp3W { w: self }
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&mut self) -> _Sp3W {
                _Sp3W { w: self }
            }
            # [ doc = "Bit 20 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp2(&mut self) -> _Tp2W {
                _Tp2W { w: self }
            }
            # [ doc = "Bit 21 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp2(&mut self) -> _Wp2W {
                _Wp2W { w: self }
            }
            # [ doc = "Bit 22 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp2(&mut self) -> _Sp2W {
                _Sp2W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrk {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrk {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrk {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp3R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp3R::_0 => 0,
                    Tp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp3R {
                match bits {
                    0 => Tp3R::_0,
                    1 => Tp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp3R::_1
            }
        }
        # [ doc = "Possible values of the field `WP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp3R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp3R::_0 => 0,
                    Wp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp3R {
                match bits {
                    0 => Wp3R::_0,
                    1 => Wp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp3R::_1
            }
        }
        # [ doc = "Possible values of the field `SP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp3R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp3R::_0 => 0,
                    Sp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp3R {
                match bits {
                    0 => Sp3R::_0,
                    1 => Sp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp3R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP3`" ]
        pub enum Tp3W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp3W::_0 => 0,
                    Tp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp3W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP3`" ]
        pub enum Wp3W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp3W::_0 => 0,
                    Wp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp3W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP3`" ]
        pub enum Sp3W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp3W::_0 => 0,
                    Sp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp3W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&self) -> Tp3R {
                Tp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&self) -> Wp3R {
                Wp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&self) -> Sp3R {
                Sp3R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 262144 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 16 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp3(&mut self) -> _Tp3W {
                _Tp3W { w: self }
            }
            # [ doc = "Bit 17 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp3(&mut self) -> _Wp3W {
                _Wp3W { w: self }
            }
            # [ doc = "Bit 18 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp3(&mut self) -> _Sp3W {
                _Sp3W { w: self }
            }
        }
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub struct Opacrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Off-Platform Peripheral Access Control Register" ]
    pub mod opacrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Opacrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp7R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp7R::_0 => 0,
                    Tp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp7R {
                match bits {
                    0 => Tp7R::_0,
                    1 => Tp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp7R::_1
            }
        }
        # [ doc = "Possible values of the field `WP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp7R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp7R::_0 => 0,
                    Wp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp7R {
                match bits {
                    0 => Wp7R::_0,
                    1 => Wp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp7R::_1
            }
        }
        # [ doc = "Possible values of the field `SP7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp7R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp7R::_0 => 0,
                    Sp7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp7R {
                match bits {
                    0 => Sp7R::_0,
                    1 => Sp7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp7R::_1
            }
        }
        # [ doc = "Possible values of the field `TP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp6R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp6R::_0 => 0,
                    Tp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp6R {
                match bits {
                    0 => Tp6R::_0,
                    1 => Tp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp6R::_1
            }
        }
        # [ doc = "Possible values of the field `WP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp6R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp6R::_0 => 0,
                    Wp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp6R {
                match bits {
                    0 => Wp6R::_0,
                    1 => Wp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp6R::_1
            }
        }
        # [ doc = "Possible values of the field `SP6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp6R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp6R::_0 => 0,
                    Sp6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp6R {
                match bits {
                    0 => Sp6R::_0,
                    1 => Sp6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp6R::_1
            }
        }
        # [ doc = "Possible values of the field `TP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tp5R {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tp5R::_0 => 0,
                    Tp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tp5R {
                match bits {
                    0 => Tp5R::_0,
                    1 => Tp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tp5R::_1
            }
        }
        # [ doc = "Possible values of the field `WP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Wp5R {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Wp5R::_0 => 0,
                    Wp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Wp5R {
                match bits {
                    0 => Wp5R::_0,
                    1 => Wp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Wp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Wp5R::_1
            }
        }
        # [ doc = "Possible values of the field `SP5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sp5R {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sp5R::_0 => 0,
                    Sp5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sp5R {
                match bits {
                    0 => Sp5R::_0,
                    1 => Sp5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sp5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sp5R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TP7`" ]
        pub enum Tp7W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp7W::_0 => 0,
                    Tp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp7W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP7`" ]
        pub enum Wp7W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp7W::_0 => 0,
                    Wp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp7W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP7`" ]
        pub enum Sp7W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp7W::_0 => 0,
                    Sp7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp7W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP6`" ]
        pub enum Tp6W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp6W::_0 => 0,
                    Tp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp6W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP6`" ]
        pub enum Wp6W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp6W::_0 => 0,
                    Wp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp6W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP6`" ]
        pub enum Sp6W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp6W::_0 => 0,
                    Sp6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp6W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TP5`" ]
        pub enum Tp5W {
            # [ doc = "Accesses from an untrusted master are allowed." ]
            _0,
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            _1,
        }
        impl Tp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tp5W::_0 => 0,
                    Tp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accesses from an untrusted master are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tp5W::_0)
            }
            # [ doc = "Accesses from an untrusted master are not allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WP5`" ]
        pub enum Wp5W {
            # [ doc = "This peripheral allows write accesses." ]
            _0,
            # [ doc = "This peripheral is write protected." ]
            _1,
        }
        impl Wp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Wp5W::_0 => 0,
                    Wp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Wp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Wp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Wp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral allows write accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Wp5W::_0)
            }
            # [ doc = "This peripheral is write protected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Wp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SP5`" ]
        pub enum Sp5W {
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            _0,
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            _1,
        }
        impl Sp5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sp5W::_0 => 0,
                    Sp5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sp5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sp5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sp5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This peripheral does not require supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sp5W::_0)
            }
            # [ doc = "This peripheral requires supervisor privilege level for accesses." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sp5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp7(&self) -> Tp7R {
                Tp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp7(&self) -> Wp7R {
                Wp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp7(&self) -> Sp7R {
                Sp7R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&self) -> Tp6R {
                Tp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&self) -> Wp6R {
                Wp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&self) -> Sp6R {
                Sp6R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&self) -> Tp5R {
                Tp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&self) -> Wp5R {
                Wp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&self) -> Sp5R {
                Sp5R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1092 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp7(&mut self) -> _Tp7W {
                _Tp7W { w: self }
            }
            # [ doc = "Bit 1 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp7(&mut self) -> _Wp7W {
                _Wp7W { w: self }
            }
            # [ doc = "Bit 2 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp7(&mut self) -> _Sp7W {
                _Sp7W { w: self }
            }
            # [ doc = "Bit 4 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp6(&mut self) -> _Tp6W {
                _Tp6W { w: self }
            }
            # [ doc = "Bit 5 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp6(&mut self) -> _Wp6W {
                _Wp6W { w: self }
            }
            # [ doc = "Bit 6 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp6(&mut self) -> _Sp6W {
                _Sp6W { w: self }
            }
            # [ doc = "Bit 8 - Trusted Protect" ]
            # [ inline ( always ) ]
            pub fn tp5(&mut self) -> _Tp5W {
                _Tp5W { w: self }
            }
            # [ doc = "Bit 9 - Write Protect" ]
            # [ inline ( always ) ]
            pub fn wp5(&mut self) -> _Wp5W {
                _Wp5W { w: self }
            }
            # [ doc = "Bit 10 - Supervisor Protect" ]
            # [ inline ( always ) ]
            pub fn sp5(&mut self) -> _Sp5W {
                _Sp5W { w: self }
            }
        }
    }
}
# [ doc = "AIPS-Lite Bridge" ]
pub struct Aips {
    register_block: aips::RegisterBlock,
}
impl Deref for Aips {
    type Target = aips::RegisterBlock;
    fn deref(&self) -> &aips::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "MSCM" ]
pub const MSCM: Peripheral<Mscm> = unsafe { Peripheral::new(1073745920) };
# [ doc = "MSCM" ]
pub mod mscm {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Processor X Type Register" ]
        pub cpx_type: CpxType,
        # [ doc = "0x04 - Processor X Number Register" ]
        pub cpx_num: CpxNum,
        # [ doc = "0x08 - Processor X Master Register" ]
        pub cpx_master: CpxMaster,
        # [ doc = "0x0c - Processor X Count Register" ]
        pub cpx_count: CpxCount,
        # [ doc = "0x10 - Processor X Configuration Register 0" ]
        pub cpx_cfg0: CpxCfg0,
        # [ doc = "0x14 - Processor X Configuration Register 1" ]
        pub cpx_cfg1: CpxCfg1,
        # [ doc = "0x18 - Processor X Configuration Register 2" ]
        pub cpx_cfg2: CpxCfg2,
        # [ doc = "0x1c - Processor X Configuration Register 3" ]
        pub cpx_cfg3: CpxCfg3,
        # [ doc = "0x20 - Processor 0 Type Register" ]
        pub cp0type: Cp0type,
        # [ doc = "0x24 - Processor 0 Number Register" ]
        pub cp0num: Cp0num,
        # [ doc = "0x28 - Processor 0 Master Register" ]
        pub cp0master: Cp0master,
        # [ doc = "0x2c - Processor 0 Count Register" ]
        pub cp0count: Cp0count,
        # [ doc = "0x30 - Processor 0 Configuration Register 0" ]
        pub cp0cfg0: Cp0cfg0,
        # [ doc = "0x34 - Processor 0 Configuration Register 1" ]
        pub cp0cfg1: Cp0cfg1,
        # [ doc = "0x38 - Processor 0 Configuration Register 2" ]
        pub cp0cfg2: Cp0cfg2,
        # [ doc = "0x3c - Processor 0 Configuration Register 3" ]
        pub cp0cfg3: Cp0cfg3,
        _reserved0: [u8; 960usize],
        # [ doc = "0x400 - On-Chip Memory Descriptor Register" ]
        pub ocmdr0: Ocmdr0,
        # [ doc = "0x404 - On-Chip Memory Descriptor Register" ]
        pub ocmdr1: Ocmdr1,
        # [ doc = "0x408 - On-Chip Memory Descriptor Register" ]
        pub ocmdr2: Ocmdr2,
        # [ doc = "0x40c - On-Chip Memory Descriptor Register" ]
        pub ocmdr3: Ocmdr3,
    }
    # [ doc = "Processor X Type Register" ]
    pub struct CpxType {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Type Register" ]
    pub mod cpx_type {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxType {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RypzR {
            bits: u8,
        }
        impl RypzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PersonalityR {
            bits: u32,
        }
        impl PersonalityR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Processor x Revision" ]
            # [ inline ( always ) ]
            pub fn rypz(&self) -> RypzR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RypzR { bits }
            }
            # [ doc = "Bits 8:31 - Processor x Personality" ]
            # [ inline ( always ) ]
            pub fn personality(&self) -> PersonalityR {
                let bits = {
                    const MASK: u32 = 16777215;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PersonalityR { bits }
            }
        }
    }
    # [ doc = "Processor X Number Register" ]
    pub struct CpxNum {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Number Register" ]
    pub mod cpx_num {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxNum {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CpnR {
            bits: u8,
        }
        impl CpnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Processor x Number" ]
            # [ inline ( always ) ]
            pub fn cpn(&self) -> CpnR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CpnR { bits }
            }
        }
    }
    # [ doc = "Processor X Master Register" ]
    pub struct CpxMaster {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Master Register" ]
    pub mod cpx_master {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxMaster {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PpmnR {
            bits: u8,
        }
        impl PpmnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Processor x Physical Master Number" ]
            # [ inline ( always ) ]
            pub fn ppmn(&self) -> PpmnR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PpmnR { bits }
            }
        }
    }
    # [ doc = "Processor X Count Register" ]
    pub struct CpxCount {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Count Register" ]
    pub mod cpx_count {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxCount {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PcntR {
            bits: u8,
        }
        impl PcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Processor Count" ]
            # [ inline ( always ) ]
            pub fn pcnt(&self) -> PcntR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PcntR { bits }
            }
        }
    }
    # [ doc = "Processor X Configuration Register 0" ]
    pub struct CpxCfg0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Configuration Register 0" ]
    pub mod cpx_cfg0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxCfg0 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DcwyR {
            bits: u8,
        }
        impl DcwyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DcszR {
            bits: u8,
        }
        impl DcszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IcwyR {
            bits: u8,
        }
        impl IcwyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IcszR {
            bits: u8,
        }
        impl IcszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Level 1 Data Cache Ways" ]
            # [ inline ( always ) ]
            pub fn dcwy(&self) -> DcwyR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DcwyR { bits }
            }
            # [ doc = "Bits 8:15 - Level 1 Data Cache Size" ]
            # [ inline ( always ) ]
            pub fn dcsz(&self) -> DcszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DcszR { bits }
            }
            # [ doc = "Bits 16:23 - Level 1 Instruction Cache Ways" ]
            # [ inline ( always ) ]
            pub fn icwy(&self) -> IcwyR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                IcwyR { bits }
            }
            # [ doc = "Bits 24:31 - Level 1 Instruction Cache Size" ]
            # [ inline ( always ) ]
            pub fn icsz(&self) -> IcszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                IcszR { bits }
            }
        }
    }
    # [ doc = "Processor X Configuration Register 1" ]
    pub struct CpxCfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Configuration Register 1" ]
    pub mod cpx_cfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxCfg1 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct L2wyR {
            bits: u8,
        }
        impl L2wyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct L2szR {
            bits: u8,
        }
        impl L2szR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:23 - Level 2 Instruction Cache Ways" ]
            # [ inline ( always ) ]
            pub fn l2wy(&self) -> L2wyR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                L2wyR { bits }
            }
            # [ doc = "Bits 24:31 - Level 2 Instruction Cache Size" ]
            # [ inline ( always ) ]
            pub fn l2sz(&self) -> L2szR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                L2szR { bits }
            }
        }
    }
    # [ doc = "Processor X Configuration Register 2" ]
    pub struct CpxCfg2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Configuration Register 2" ]
    pub mod cpx_cfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxCfg2 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmuszR {
            bits: u8,
        }
        impl TmuszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmlszR {
            bits: u8,
        }
        impl TmlszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:15 - Tightly-coupled Memory Upper Size" ]
            # [ inline ( always ) ]
            pub fn tmusz(&self) -> TmuszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TmuszR { bits }
            }
            # [ doc = "Bits 24:31 - Tightly-coupled Memory Lower Size" ]
            # [ inline ( always ) ]
            pub fn tmlsz(&self) -> TmlszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TmlszR { bits }
            }
        }
    }
    # [ doc = "Processor X Configuration Register 3" ]
    pub struct CpxCfg3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor X Configuration Register 3" ]
    pub mod cpx_cfg3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::CpxCfg3 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FPU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FpuR {
            # [ doc = "FPU support is not included." ]
            _0,
            # [ doc = "FPU support is included." ]
            _1,
        }
        impl FpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FpuR::_0 => 0,
                    FpuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FpuR {
                match bits {
                    0 => FpuR::_0,
                    1 => FpuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FpuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FpuR::_1
            }
        }
        # [ doc = "Possible values of the field `SIMD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SimdR {
            # [ doc = "SIMD/NEON support is not included." ]
            _0,
            # [ doc = "SIMD/NEON support is included." ]
            _1,
        }
        impl SimdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SimdR::_0 => 0,
                    SimdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SimdR {
                match bits {
                    0 => SimdR::_0,
                    1 => SimdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SimdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SimdR::_1
            }
        }
        # [ doc = "Possible values of the field `JAZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum JazR {
            # [ doc = "Jazelle support is not included." ]
            _0,
            # [ doc = "Jazelle support is included." ]
            _1,
        }
        impl JazR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    JazR::_0 => 0,
                    JazR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> JazR {
                match bits {
                    0 => JazR::_0,
                    1 => JazR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == JazR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == JazR::_1
            }
        }
        # [ doc = "Possible values of the field `MMU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MmuR {
            # [ doc = "MMU support is not included." ]
            _0,
            # [ doc = "MMU support is included." ]
            _1,
        }
        impl MmuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MmuR::_0 => 0,
                    MmuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MmuR {
                match bits {
                    0 => MmuR::_0,
                    1 => MmuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MmuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MmuR::_1
            }
        }
        # [ doc = "Possible values of the field `TZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TzR {
            # [ doc = "Trust Zone support is not included." ]
            _0,
            # [ doc = "Trust Zone support is included." ]
            _1,
        }
        impl TzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TzR::_0 => 0,
                    TzR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TzR {
                match bits {
                    0 => TzR::_0,
                    1 => TzR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TzR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TzR::_1
            }
        }
        # [ doc = "Possible values of the field `CMP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CmpR {
            # [ doc = "Core Memory Protection is not included." ]
            _0,
            # [ doc = "Core Memory Protection is included." ]
            _1,
        }
        impl CmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CmpR::_0 => 0,
                    CmpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CmpR {
                match bits {
                    0 => CmpR::_0,
                    1 => CmpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CmpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CmpR::_1
            }
        }
        # [ doc = "Possible values of the field `BB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BbR {
            # [ doc = "Bit Banding is not supported." ]
            _0,
            # [ doc = "Bit Banding is supported." ]
            _1,
        }
        impl BbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BbR::_0 => 0,
                    BbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BbR {
                match bits {
                    0 => BbR::_0,
                    1 => BbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BbR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SbpR {
            bits: u8,
        }
        impl SbpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Floating Point Unit" ]
            # [ inline ( always ) ]
            pub fn fpu(&self) -> FpuR {
                FpuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - SIMD/NEON instruction support" ]
            # [ inline ( always ) ]
            pub fn simd(&self) -> SimdR {
                SimdR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Jazelle support" ]
            # [ inline ( always ) ]
            pub fn jaz(&self) -> JazR {
                JazR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Memory Management Unit" ]
            # [ inline ( always ) ]
            pub fn mmu(&self) -> MmuR {
                MmuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Trust Zone" ]
            # [ inline ( always ) ]
            pub fn tz(&self) -> TzR {
                TzR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 4;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 5 - Core Memory Protection unit" ]
            # [ inline ( always ) ]
            pub fn cmp(&self) -> CmpR {
                CmpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Bit Banding" ]
            # [ inline ( always ) ]
            pub fn bb(&self) -> BbR {
                BbR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 6;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:9 - System Bus Ports" ]
            # [ inline ( always ) ]
            pub fn sbp(&self) -> SbpR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SbpR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Type Register" ]
    pub struct Cp0type {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Type Register" ]
    pub mod cp0type {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0type {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RypzR {
            bits: u8,
        }
        impl RypzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PersonalityR {
            bits: u32,
        }
        impl PersonalityR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Processor 0 Revision" ]
            # [ inline ( always ) ]
            pub fn rypz(&self) -> RypzR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RypzR { bits }
            }
            # [ doc = "Bits 8:31 - Processor 0 Personality" ]
            # [ inline ( always ) ]
            pub fn personality(&self) -> PersonalityR {
                let bits = {
                    const MASK: u32 = 16777215;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PersonalityR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Number Register" ]
    pub struct Cp0num {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Number Register" ]
    pub mod cp0num {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0num {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CpnR {
            bits: u8,
        }
        impl CpnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Processor 0 Number" ]
            # [ inline ( always ) ]
            pub fn cpn(&self) -> CpnR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CpnR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Master Register" ]
    pub struct Cp0master {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Master Register" ]
    pub mod cp0master {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0master {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PpmnR {
            bits: u8,
        }
        impl PpmnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Processor 0 Physical Master Number" ]
            # [ inline ( always ) ]
            pub fn ppmn(&self) -> PpmnR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PpmnR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Count Register" ]
    pub struct Cp0count {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Count Register" ]
    pub mod cp0count {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0count {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PcntR {
            bits: u8,
        }
        impl PcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Processor Count" ]
            # [ inline ( always ) ]
            pub fn pcnt(&self) -> PcntR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PcntR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Configuration Register 0" ]
    pub struct Cp0cfg0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Configuration Register 0" ]
    pub mod cp0cfg0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0cfg0 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DcwyR {
            bits: u8,
        }
        impl DcwyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DcszR {
            bits: u8,
        }
        impl DcszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IcwyR {
            bits: u8,
        }
        impl IcwyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IcszR {
            bits: u8,
        }
        impl IcszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Level 1 Data Cache Ways" ]
            # [ inline ( always ) ]
            pub fn dcwy(&self) -> DcwyR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DcwyR { bits }
            }
            # [ doc = "Bits 8:15 - Level 1 Data Cache Size" ]
            # [ inline ( always ) ]
            pub fn dcsz(&self) -> DcszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DcszR { bits }
            }
            # [ doc = "Bits 16:23 - Level 1 Instruction Cache Ways" ]
            # [ inline ( always ) ]
            pub fn icwy(&self) -> IcwyR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                IcwyR { bits }
            }
            # [ doc = "Bits 24:31 - Level 1 Instruction Cache Size" ]
            # [ inline ( always ) ]
            pub fn icsz(&self) -> IcszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                IcszR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Configuration Register 1" ]
    pub struct Cp0cfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Configuration Register 1" ]
    pub mod cp0cfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0cfg1 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct L2wyR {
            bits: u8,
        }
        impl L2wyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct L2szR {
            bits: u8,
        }
        impl L2szR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:23 - Level 2 Instruction Cache Ways" ]
            # [ inline ( always ) ]
            pub fn l2wy(&self) -> L2wyR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                L2wyR { bits }
            }
            # [ doc = "Bits 24:31 - Level 2 Instruction Cache Size" ]
            # [ inline ( always ) ]
            pub fn l2sz(&self) -> L2szR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                L2szR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Configuration Register 2" ]
    pub struct Cp0cfg2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Configuration Register 2" ]
    pub mod cp0cfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0cfg2 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmuszR {
            bits: u8,
        }
        impl TmuszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmlszR {
            bits: u8,
        }
        impl TmlszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:15 - Tightly-coupled Memory Upper Size" ]
            # [ inline ( always ) ]
            pub fn tmusz(&self) -> TmuszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TmuszR { bits }
            }
            # [ doc = "Bits 24:31 - Tightly-coupled Memory Lower Size" ]
            # [ inline ( always ) ]
            pub fn tmlsz(&self) -> TmlszR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TmlszR { bits }
            }
        }
    }
    # [ doc = "Processor 0 Configuration Register 3" ]
    pub struct Cp0cfg3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Processor 0 Configuration Register 3" ]
    pub mod cp0cfg3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cp0cfg3 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FPU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FpuR {
            # [ doc = "FPU support is not included." ]
            _0,
            # [ doc = "FPU support is included." ]
            _1,
        }
        impl FpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FpuR::_0 => 0,
                    FpuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FpuR {
                match bits {
                    0 => FpuR::_0,
                    1 => FpuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FpuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FpuR::_1
            }
        }
        # [ doc = "Possible values of the field `SIMD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SimdR {
            # [ doc = "SIMD/NEON support is not included." ]
            _0,
            # [ doc = "SIMD/NEON support is included." ]
            _1,
        }
        impl SimdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SimdR::_0 => 0,
                    SimdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SimdR {
                match bits {
                    0 => SimdR::_0,
                    1 => SimdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SimdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SimdR::_1
            }
        }
        # [ doc = "Possible values of the field `JAZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum JazR {
            # [ doc = "Jazelle support is not included." ]
            _0,
            # [ doc = "Jazelle support is included." ]
            _1,
        }
        impl JazR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    JazR::_0 => 0,
                    JazR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> JazR {
                match bits {
                    0 => JazR::_0,
                    1 => JazR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == JazR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == JazR::_1
            }
        }
        # [ doc = "Possible values of the field `MMU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MmuR {
            # [ doc = "MMU support is not included." ]
            _0,
            # [ doc = "MMU support is included." ]
            _1,
        }
        impl MmuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MmuR::_0 => 0,
                    MmuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MmuR {
                match bits {
                    0 => MmuR::_0,
                    1 => MmuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MmuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MmuR::_1
            }
        }
        # [ doc = "Possible values of the field `TZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TzR {
            # [ doc = "Trust Zone support is not included." ]
            _0,
            # [ doc = "Trust Zone support is included." ]
            _1,
        }
        impl TzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TzR::_0 => 0,
                    TzR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TzR {
                match bits {
                    0 => TzR::_0,
                    1 => TzR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TzR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TzR::_1
            }
        }
        # [ doc = "Possible values of the field `CMP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CmpR {
            # [ doc = "Core Memory Protection is not included." ]
            _0,
            # [ doc = "Core Memory Protection is included." ]
            _1,
        }
        impl CmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CmpR::_0 => 0,
                    CmpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CmpR {
                match bits {
                    0 => CmpR::_0,
                    1 => CmpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CmpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CmpR::_1
            }
        }
        # [ doc = "Possible values of the field `BB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BbR {
            # [ doc = "Bit Banding is not supported." ]
            _0,
            # [ doc = "Bit Banding is supported." ]
            _1,
        }
        impl BbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BbR::_0 => 0,
                    BbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BbR {
                match bits {
                    0 => BbR::_0,
                    1 => BbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BbR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SbpR {
            bits: u8,
        }
        impl SbpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Floating Point Unit" ]
            # [ inline ( always ) ]
            pub fn fpu(&self) -> FpuR {
                FpuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - SIMD/NEON instruction support" ]
            # [ inline ( always ) ]
            pub fn simd(&self) -> SimdR {
                SimdR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Jazelle support" ]
            # [ inline ( always ) ]
            pub fn jaz(&self) -> JazR {
                JazR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Memory Management Unit" ]
            # [ inline ( always ) ]
            pub fn mmu(&self) -> MmuR {
                MmuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Trust Zone" ]
            # [ inline ( always ) ]
            pub fn tz(&self) -> TzR {
                TzR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 4;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 5 - Core Memory Protection unit" ]
            # [ inline ( always ) ]
            pub fn cmp(&self) -> CmpR {
                CmpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Bit Banding" ]
            # [ inline ( always ) ]
            pub fn bb(&self) -> BbR {
                BbR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 6;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:9 - System Bus Ports" ]
            # [ inline ( always ) ]
            pub fn sbp(&self) -> SbpR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SbpR { bits }
            }
        }
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub struct Ocmdr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub mod ocmdr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ocmdr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm0R {
            bits: u8,
        }
        impl Ocm0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm1R {
            bits: u8,
        }
        impl Ocm1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm2R {
            bits: u8,
        }
        impl Ocm2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OcmpuR {
            bits: u8,
        }
        impl OcmpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `OCMT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmtR {
            # [ doc = "OCMEMn is a System RAM." ]
            _000,
            # [ doc = "OCMEMn is a Graphics RAM." ]
            _001,
            # [ doc = "OCMEMn is a ROM." ]
            _011,
            # [ doc = "OCMEMn is a Program Flash." ]
            _100,
            # [ doc = "OCMEMn is a Data Flash." ]
            _101,
            # [ doc = "OCMEMn is an EEE." ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmtR::_000 => 0,
                    OcmtR::_001 => 1,
                    OcmtR::_011 => 3,
                    OcmtR::_100 => 4,
                    OcmtR::_101 => 5,
                    OcmtR::_110 => 6,
                    OcmtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmtR {
                match bits {
                    0 => OcmtR::_000,
                    1 => OcmtR::_001,
                    3 => OcmtR::_011,
                    4 => OcmtR::_100,
                    5 => OcmtR::_101,
                    6 => OcmtR::_110,
                    i => OcmtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == OcmtR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == OcmtR::_001
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmtR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmtR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmtR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == OcmtR::_110
            }
        }
        # [ doc = "Possible values of the field `RO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RoR {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RoR::_0 => 0,
                    RoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RoR {
                match bits {
                    0 => RoR::_0,
                    1 => RoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RoR::_1
            }
        }
        # [ doc = "Possible values of the field `OCMW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmwR {
            # [ doc = "OCMEMn 32-bits wide" ]
            _010,
            # [ doc = "OCMEMn 64-bits wide" ]
            _011,
            # [ doc = "OCMEMn 128-bits wide" ]
            _100,
            # [ doc = "OCMEMn 256-bits wide" ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmwR::_010 => 2,
                    OcmwR::_011 => 3,
                    OcmwR::_100 => 4,
                    OcmwR::_101 => 5,
                    OcmwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmwR {
                match bits {
                    2 => OcmwR::_010,
                    3 => OcmwR::_011,
                    4 => OcmwR::_100,
                    5 => OcmwR::_101,
                    i => OcmwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == OcmwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmwR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmwR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmwR::_101
            }
        }
        # [ doc = "Possible values of the field `OCMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszR {
            # [ doc = "no OCMEMn" ]
            _0000,
            # [ doc = "1KB OCMEMn" ]
            _0001,
            # [ doc = "2KB OCMEMn" ]
            _0010,
            # [ doc = "4KB OCMEMn" ]
            _0011,
            # [ doc = "8KB OCMEMn" ]
            _0100,
            # [ doc = "16KB OCMEMn" ]
            _0101,
            # [ doc = "32KB OCMEMn" ]
            _0110,
            # [ doc = "64KB OCMEMn" ]
            _0111,
            # [ doc = "128KB OCMEMn" ]
            _1000,
            # [ doc = "256KB OCMEMn" ]
            _1001,
            # [ doc = "512KB OCMEMn" ]
            _1010,
            # [ doc = "1MB OCMEMn" ]
            _1011,
            # [ doc = "2MB OCMEMn" ]
            _1100,
            # [ doc = "4MB OCMEMn" ]
            _1101,
            # [ doc = "8MB OCMEMn" ]
            _1110,
            # [ doc = "16MB OCMEMn" ]
            _1111,
        }
        impl OcmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszR::_0000 => 0,
                    OcmszR::_0001 => 1,
                    OcmszR::_0010 => 2,
                    OcmszR::_0011 => 3,
                    OcmszR::_0100 => 4,
                    OcmszR::_0101 => 5,
                    OcmszR::_0110 => 6,
                    OcmszR::_0111 => 7,
                    OcmszR::_1000 => 8,
                    OcmszR::_1001 => 9,
                    OcmszR::_1010 => 10,
                    OcmszR::_1011 => 11,
                    OcmszR::_1100 => 12,
                    OcmszR::_1101 => 13,
                    OcmszR::_1110 => 14,
                    OcmszR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszR {
                match bits {
                    0 => OcmszR::_0000,
                    1 => OcmszR::_0001,
                    2 => OcmszR::_0010,
                    3 => OcmszR::_0011,
                    4 => OcmszR::_0100,
                    5 => OcmszR::_0101,
                    6 => OcmszR::_0110,
                    7 => OcmszR::_0111,
                    8 => OcmszR::_1000,
                    9 => OcmszR::_1001,
                    10 => OcmszR::_1010,
                    11 => OcmszR::_1011,
                    12 => OcmszR::_1100,
                    13 => OcmszR::_1101,
                    14 => OcmszR::_1110,
                    15 => OcmszR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == OcmszR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == OcmszR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == OcmszR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == OcmszR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == OcmszR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == OcmszR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == OcmszR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == OcmszR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == OcmszR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == OcmszR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == OcmszR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == OcmszR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == OcmszR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == OcmszR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == OcmszR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == OcmszR::_1111
            }
        }
        # [ doc = "Possible values of the field `OCMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszhR {
            # [ doc = "OCMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "OCMEMn is not a power-of-2, with a capacity is 0.75 * OCMSZ." ]
            _1,
        }
        impl OcmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszhR::_0 => 0,
                    OcmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszhR {
                match bits {
                    0 => OcmszhR::_0,
                    1 => OcmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OcmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OcmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "OCMEMn is not present." ]
            _0,
            # [ doc = "OCMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RO`" ]
        pub enum RoW {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RoW::_0 => 0,
                    RoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RoW::_0)
            }
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&self) -> Ocm0R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm0R { bits }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&self) -> Ocm1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm1R { bits }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&self) -> Ocm2R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm2R { bits }
            }
            # [ doc = "Bit 12 - OCMPU" ]
            # [ inline ( always ) ]
            pub fn ocmpu(&self) -> OcmpuR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OcmpuR { bits }
            }
            # [ doc = "Bits 13:15 - OCMT" ]
            # [ inline ( always ) ]
            pub fn ocmt(&self) -> OcmtR {
                OcmtR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&self) -> RoR {
                RoR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 17:19 - OCMW" ]
            # [ inline ( always ) ]
            pub fn ocmw(&self) -> OcmwR {
                OcmwR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:27 - OCMSZ" ]
            # [ inline ( always ) ]
            pub fn ocmsz(&self) -> OcmszR {
                OcmszR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - OCMSZH" ]
            # [ inline ( always ) ]
            pub fn ocmszh(&self) -> OcmszhR {
                OcmszhR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 28;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - V" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1073741824 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&mut self) -> _Ocm0W {
                _Ocm0W { w: self }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&mut self) -> _Ocm1W {
                _Ocm1W { w: self }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&mut self) -> _Ocm2W {
                _Ocm2W { w: self }
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&mut self) -> _RoW {
                _RoW { w: self }
            }
        }
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub struct Ocmdr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub mod ocmdr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ocmdr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm0R {
            bits: u8,
        }
        impl Ocm0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm1R {
            bits: u8,
        }
        impl Ocm1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm2R {
            bits: u8,
        }
        impl Ocm2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OcmpuR {
            bits: u8,
        }
        impl OcmpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `OCMT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmtR {
            # [ doc = "OCMEMn is a System RAM." ]
            _000,
            # [ doc = "OCMEMn is a Graphics RAM." ]
            _001,
            # [ doc = "OCMEMn is a ROM." ]
            _011,
            # [ doc = "OCMEMn is a Program Flash." ]
            _100,
            # [ doc = "OCMEMn is a Data Flash." ]
            _101,
            # [ doc = "OCMEMn is an EEE." ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmtR::_000 => 0,
                    OcmtR::_001 => 1,
                    OcmtR::_011 => 3,
                    OcmtR::_100 => 4,
                    OcmtR::_101 => 5,
                    OcmtR::_110 => 6,
                    OcmtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmtR {
                match bits {
                    0 => OcmtR::_000,
                    1 => OcmtR::_001,
                    3 => OcmtR::_011,
                    4 => OcmtR::_100,
                    5 => OcmtR::_101,
                    6 => OcmtR::_110,
                    i => OcmtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == OcmtR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == OcmtR::_001
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmtR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmtR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmtR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == OcmtR::_110
            }
        }
        # [ doc = "Possible values of the field `RO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RoR {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RoR::_0 => 0,
                    RoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RoR {
                match bits {
                    0 => RoR::_0,
                    1 => RoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RoR::_1
            }
        }
        # [ doc = "Possible values of the field `OCMW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmwR {
            # [ doc = "OCMEMn 32-bits wide" ]
            _010,
            # [ doc = "OCMEMn 64-bits wide" ]
            _011,
            # [ doc = "OCMEMn 128-bits wide" ]
            _100,
            # [ doc = "OCMEMn 256-bits wide" ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmwR::_010 => 2,
                    OcmwR::_011 => 3,
                    OcmwR::_100 => 4,
                    OcmwR::_101 => 5,
                    OcmwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmwR {
                match bits {
                    2 => OcmwR::_010,
                    3 => OcmwR::_011,
                    4 => OcmwR::_100,
                    5 => OcmwR::_101,
                    i => OcmwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == OcmwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmwR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmwR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmwR::_101
            }
        }
        # [ doc = "Possible values of the field `OCMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszR {
            # [ doc = "no OCMEMn" ]
            _0000,
            # [ doc = "1KB OCMEMn" ]
            _0001,
            # [ doc = "2KB OCMEMn" ]
            _0010,
            # [ doc = "4KB OCMEMn" ]
            _0011,
            # [ doc = "8KB OCMEMn" ]
            _0100,
            # [ doc = "16KB OCMEMn" ]
            _0101,
            # [ doc = "32KB OCMEMn" ]
            _0110,
            # [ doc = "64KB OCMEMn" ]
            _0111,
            # [ doc = "128KB OCMEMn" ]
            _1000,
            # [ doc = "256KB OCMEMn" ]
            _1001,
            # [ doc = "512KB OCMEMn" ]
            _1010,
            # [ doc = "1MB OCMEMn" ]
            _1011,
            # [ doc = "2MB OCMEMn" ]
            _1100,
            # [ doc = "4MB OCMEMn" ]
            _1101,
            # [ doc = "8MB OCMEMn" ]
            _1110,
            # [ doc = "16MB OCMEMn" ]
            _1111,
        }
        impl OcmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszR::_0000 => 0,
                    OcmszR::_0001 => 1,
                    OcmszR::_0010 => 2,
                    OcmszR::_0011 => 3,
                    OcmszR::_0100 => 4,
                    OcmszR::_0101 => 5,
                    OcmszR::_0110 => 6,
                    OcmszR::_0111 => 7,
                    OcmszR::_1000 => 8,
                    OcmszR::_1001 => 9,
                    OcmszR::_1010 => 10,
                    OcmszR::_1011 => 11,
                    OcmszR::_1100 => 12,
                    OcmszR::_1101 => 13,
                    OcmszR::_1110 => 14,
                    OcmszR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszR {
                match bits {
                    0 => OcmszR::_0000,
                    1 => OcmszR::_0001,
                    2 => OcmszR::_0010,
                    3 => OcmszR::_0011,
                    4 => OcmszR::_0100,
                    5 => OcmszR::_0101,
                    6 => OcmszR::_0110,
                    7 => OcmszR::_0111,
                    8 => OcmszR::_1000,
                    9 => OcmszR::_1001,
                    10 => OcmszR::_1010,
                    11 => OcmszR::_1011,
                    12 => OcmszR::_1100,
                    13 => OcmszR::_1101,
                    14 => OcmszR::_1110,
                    15 => OcmszR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == OcmszR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == OcmszR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == OcmszR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == OcmszR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == OcmszR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == OcmszR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == OcmszR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == OcmszR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == OcmszR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == OcmszR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == OcmszR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == OcmszR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == OcmszR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == OcmszR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == OcmszR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == OcmszR::_1111
            }
        }
        # [ doc = "Possible values of the field `OCMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszhR {
            # [ doc = "OCMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "OCMEMn is not a power-of-2, with a capacity is 0.75 * OCMSZ." ]
            _1,
        }
        impl OcmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszhR::_0 => 0,
                    OcmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszhR {
                match bits {
                    0 => OcmszhR::_0,
                    1 => OcmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OcmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OcmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "OCMEMn is not present." ]
            _0,
            # [ doc = "OCMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RO`" ]
        pub enum RoW {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RoW::_0 => 0,
                    RoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RoW::_0)
            }
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&self) -> Ocm0R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm0R { bits }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&self) -> Ocm1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm1R { bits }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&self) -> Ocm2R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm2R { bits }
            }
            # [ doc = "Bit 12 - OCMPU" ]
            # [ inline ( always ) ]
            pub fn ocmpu(&self) -> OcmpuR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OcmpuR { bits }
            }
            # [ doc = "Bits 13:15 - OCMT" ]
            # [ inline ( always ) ]
            pub fn ocmt(&self) -> OcmtR {
                OcmtR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&self) -> RoR {
                RoR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 17:19 - OCMW" ]
            # [ inline ( always ) ]
            pub fn ocmw(&self) -> OcmwR {
                OcmwR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:27 - OCMSZ" ]
            # [ inline ( always ) ]
            pub fn ocmsz(&self) -> OcmszR {
                OcmszR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - OCMSZH" ]
            # [ inline ( always ) ]
            pub fn ocmszh(&self) -> OcmszhR {
                OcmszhR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 28;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - V" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1073741824 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&mut self) -> _Ocm0W {
                _Ocm0W { w: self }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&mut self) -> _Ocm1W {
                _Ocm1W { w: self }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&mut self) -> _Ocm2W {
                _Ocm2W { w: self }
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&mut self) -> _RoW {
                _RoW { w: self }
            }
        }
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub struct Ocmdr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub mod ocmdr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ocmdr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm0R {
            bits: u8,
        }
        impl Ocm0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm1R {
            bits: u8,
        }
        impl Ocm1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm2R {
            bits: u8,
        }
        impl Ocm2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OcmpuR {
            bits: u8,
        }
        impl OcmpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `OCMT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmtR {
            # [ doc = "OCMEMn is a System RAM." ]
            _000,
            # [ doc = "OCMEMn is a Graphics RAM." ]
            _001,
            # [ doc = "OCMEMn is a ROM." ]
            _011,
            # [ doc = "OCMEMn is a Program Flash." ]
            _100,
            # [ doc = "OCMEMn is a Data Flash." ]
            _101,
            # [ doc = "OCMEMn is an EEE." ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmtR::_000 => 0,
                    OcmtR::_001 => 1,
                    OcmtR::_011 => 3,
                    OcmtR::_100 => 4,
                    OcmtR::_101 => 5,
                    OcmtR::_110 => 6,
                    OcmtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmtR {
                match bits {
                    0 => OcmtR::_000,
                    1 => OcmtR::_001,
                    3 => OcmtR::_011,
                    4 => OcmtR::_100,
                    5 => OcmtR::_101,
                    6 => OcmtR::_110,
                    i => OcmtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == OcmtR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == OcmtR::_001
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmtR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmtR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmtR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == OcmtR::_110
            }
        }
        # [ doc = "Possible values of the field `RO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RoR {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RoR::_0 => 0,
                    RoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RoR {
                match bits {
                    0 => RoR::_0,
                    1 => RoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RoR::_1
            }
        }
        # [ doc = "Possible values of the field `OCMW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmwR {
            # [ doc = "OCMEMn 32-bits wide" ]
            _010,
            # [ doc = "OCMEMn 64-bits wide" ]
            _011,
            # [ doc = "OCMEMn 128-bits wide" ]
            _100,
            # [ doc = "OCMEMn 256-bits wide" ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmwR::_010 => 2,
                    OcmwR::_011 => 3,
                    OcmwR::_100 => 4,
                    OcmwR::_101 => 5,
                    OcmwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmwR {
                match bits {
                    2 => OcmwR::_010,
                    3 => OcmwR::_011,
                    4 => OcmwR::_100,
                    5 => OcmwR::_101,
                    i => OcmwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == OcmwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmwR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmwR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmwR::_101
            }
        }
        # [ doc = "Possible values of the field `OCMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszR {
            # [ doc = "no OCMEMn" ]
            _0000,
            # [ doc = "1KB OCMEMn" ]
            _0001,
            # [ doc = "2KB OCMEMn" ]
            _0010,
            # [ doc = "4KB OCMEMn" ]
            _0011,
            # [ doc = "8KB OCMEMn" ]
            _0100,
            # [ doc = "16KB OCMEMn" ]
            _0101,
            # [ doc = "32KB OCMEMn" ]
            _0110,
            # [ doc = "64KB OCMEMn" ]
            _0111,
            # [ doc = "128KB OCMEMn" ]
            _1000,
            # [ doc = "256KB OCMEMn" ]
            _1001,
            # [ doc = "512KB OCMEMn" ]
            _1010,
            # [ doc = "1MB OCMEMn" ]
            _1011,
            # [ doc = "2MB OCMEMn" ]
            _1100,
            # [ doc = "4MB OCMEMn" ]
            _1101,
            # [ doc = "8MB OCMEMn" ]
            _1110,
            # [ doc = "16MB OCMEMn" ]
            _1111,
        }
        impl OcmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszR::_0000 => 0,
                    OcmszR::_0001 => 1,
                    OcmszR::_0010 => 2,
                    OcmszR::_0011 => 3,
                    OcmszR::_0100 => 4,
                    OcmszR::_0101 => 5,
                    OcmszR::_0110 => 6,
                    OcmszR::_0111 => 7,
                    OcmszR::_1000 => 8,
                    OcmszR::_1001 => 9,
                    OcmszR::_1010 => 10,
                    OcmszR::_1011 => 11,
                    OcmszR::_1100 => 12,
                    OcmszR::_1101 => 13,
                    OcmszR::_1110 => 14,
                    OcmszR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszR {
                match bits {
                    0 => OcmszR::_0000,
                    1 => OcmszR::_0001,
                    2 => OcmszR::_0010,
                    3 => OcmszR::_0011,
                    4 => OcmszR::_0100,
                    5 => OcmszR::_0101,
                    6 => OcmszR::_0110,
                    7 => OcmszR::_0111,
                    8 => OcmszR::_1000,
                    9 => OcmszR::_1001,
                    10 => OcmszR::_1010,
                    11 => OcmszR::_1011,
                    12 => OcmszR::_1100,
                    13 => OcmszR::_1101,
                    14 => OcmszR::_1110,
                    15 => OcmszR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == OcmszR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == OcmszR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == OcmszR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == OcmszR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == OcmszR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == OcmszR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == OcmszR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == OcmszR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == OcmszR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == OcmszR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == OcmszR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == OcmszR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == OcmszR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == OcmszR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == OcmszR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == OcmszR::_1111
            }
        }
        # [ doc = "Possible values of the field `OCMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszhR {
            # [ doc = "OCMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "OCMEMn is not a power-of-2, with a capacity is 0.75 * OCMSZ." ]
            _1,
        }
        impl OcmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszhR::_0 => 0,
                    OcmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszhR {
                match bits {
                    0 => OcmszhR::_0,
                    1 => OcmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OcmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OcmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "OCMEMn is not present." ]
            _0,
            # [ doc = "OCMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RO`" ]
        pub enum RoW {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RoW::_0 => 0,
                    RoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RoW::_0)
            }
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&self) -> Ocm0R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm0R { bits }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&self) -> Ocm1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm1R { bits }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&self) -> Ocm2R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm2R { bits }
            }
            # [ doc = "Bit 12 - OCMPU" ]
            # [ inline ( always ) ]
            pub fn ocmpu(&self) -> OcmpuR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OcmpuR { bits }
            }
            # [ doc = "Bits 13:15 - OCMT" ]
            # [ inline ( always ) ]
            pub fn ocmt(&self) -> OcmtR {
                OcmtR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&self) -> RoR {
                RoR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 17:19 - OCMW" ]
            # [ inline ( always ) ]
            pub fn ocmw(&self) -> OcmwR {
                OcmwR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:27 - OCMSZ" ]
            # [ inline ( always ) ]
            pub fn ocmsz(&self) -> OcmszR {
                OcmszR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - OCMSZH" ]
            # [ inline ( always ) ]
            pub fn ocmszh(&self) -> OcmszhR {
                OcmszhR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 28;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - V" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1073741824 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&mut self) -> _Ocm0W {
                _Ocm0W { w: self }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&mut self) -> _Ocm1W {
                _Ocm1W { w: self }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&mut self) -> _Ocm2W {
                _Ocm2W { w: self }
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&mut self) -> _RoW {
                _RoW { w: self }
            }
        }
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub struct Ocmdr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "On-Chip Memory Descriptor Register" ]
    pub mod ocmdr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ocmdr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm0R {
            bits: u8,
        }
        impl Ocm0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm1R {
            bits: u8,
        }
        impl Ocm1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ocm2R {
            bits: u8,
        }
        impl Ocm2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OcmpuR {
            bits: u8,
        }
        impl OcmpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `OCMT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmtR {
            # [ doc = "OCMEMn is a System RAM." ]
            _000,
            # [ doc = "OCMEMn is a Graphics RAM." ]
            _001,
            # [ doc = "OCMEMn is a ROM." ]
            _011,
            # [ doc = "OCMEMn is a Program Flash." ]
            _100,
            # [ doc = "OCMEMn is a Data Flash." ]
            _101,
            # [ doc = "OCMEMn is an EEE." ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmtR::_000 => 0,
                    OcmtR::_001 => 1,
                    OcmtR::_011 => 3,
                    OcmtR::_100 => 4,
                    OcmtR::_101 => 5,
                    OcmtR::_110 => 6,
                    OcmtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmtR {
                match bits {
                    0 => OcmtR::_000,
                    1 => OcmtR::_001,
                    3 => OcmtR::_011,
                    4 => OcmtR::_100,
                    5 => OcmtR::_101,
                    6 => OcmtR::_110,
                    i => OcmtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == OcmtR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == OcmtR::_001
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmtR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmtR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmtR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == OcmtR::_110
            }
        }
        # [ doc = "Possible values of the field `RO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RoR {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RoR::_0 => 0,
                    RoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RoR {
                match bits {
                    0 => RoR::_0,
                    1 => RoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RoR::_1
            }
        }
        # [ doc = "Possible values of the field `OCMW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmwR {
            # [ doc = "OCMEMn 32-bits wide" ]
            _010,
            # [ doc = "OCMEMn 64-bits wide" ]
            _011,
            # [ doc = "OCMEMn 128-bits wide" ]
            _100,
            # [ doc = "OCMEMn 256-bits wide" ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OcmwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmwR::_010 => 2,
                    OcmwR::_011 => 3,
                    OcmwR::_100 => 4,
                    OcmwR::_101 => 5,
                    OcmwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmwR {
                match bits {
                    2 => OcmwR::_010,
                    3 => OcmwR::_011,
                    4 => OcmwR::_100,
                    5 => OcmwR::_101,
                    i => OcmwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == OcmwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == OcmwR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == OcmwR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == OcmwR::_101
            }
        }
        # [ doc = "Possible values of the field `OCMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszR {
            # [ doc = "no OCMEMn" ]
            _0000,
            # [ doc = "1KB OCMEMn" ]
            _0001,
            # [ doc = "2KB OCMEMn" ]
            _0010,
            # [ doc = "4KB OCMEMn" ]
            _0011,
            # [ doc = "8KB OCMEMn" ]
            _0100,
            # [ doc = "16KB OCMEMn" ]
            _0101,
            # [ doc = "32KB OCMEMn" ]
            _0110,
            # [ doc = "64KB OCMEMn" ]
            _0111,
            # [ doc = "128KB OCMEMn" ]
            _1000,
            # [ doc = "256KB OCMEMn" ]
            _1001,
            # [ doc = "512KB OCMEMn" ]
            _1010,
            # [ doc = "1MB OCMEMn" ]
            _1011,
            # [ doc = "2MB OCMEMn" ]
            _1100,
            # [ doc = "4MB OCMEMn" ]
            _1101,
            # [ doc = "8MB OCMEMn" ]
            _1110,
            # [ doc = "16MB OCMEMn" ]
            _1111,
        }
        impl OcmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszR::_0000 => 0,
                    OcmszR::_0001 => 1,
                    OcmszR::_0010 => 2,
                    OcmszR::_0011 => 3,
                    OcmszR::_0100 => 4,
                    OcmszR::_0101 => 5,
                    OcmszR::_0110 => 6,
                    OcmszR::_0111 => 7,
                    OcmszR::_1000 => 8,
                    OcmszR::_1001 => 9,
                    OcmszR::_1010 => 10,
                    OcmszR::_1011 => 11,
                    OcmszR::_1100 => 12,
                    OcmszR::_1101 => 13,
                    OcmszR::_1110 => 14,
                    OcmszR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszR {
                match bits {
                    0 => OcmszR::_0000,
                    1 => OcmszR::_0001,
                    2 => OcmszR::_0010,
                    3 => OcmszR::_0011,
                    4 => OcmszR::_0100,
                    5 => OcmszR::_0101,
                    6 => OcmszR::_0110,
                    7 => OcmszR::_0111,
                    8 => OcmszR::_1000,
                    9 => OcmszR::_1001,
                    10 => OcmszR::_1010,
                    11 => OcmszR::_1011,
                    12 => OcmszR::_1100,
                    13 => OcmszR::_1101,
                    14 => OcmszR::_1110,
                    15 => OcmszR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == OcmszR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == OcmszR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == OcmszR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == OcmszR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == OcmszR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == OcmszR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == OcmszR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == OcmszR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == OcmszR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == OcmszR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == OcmszR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == OcmszR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == OcmszR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == OcmszR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == OcmszR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == OcmszR::_1111
            }
        }
        # [ doc = "Possible values of the field `OCMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OcmszhR {
            # [ doc = "OCMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "OCMEMn is not a power-of-2, with a capacity is 0.75 * OCMSZ." ]
            _1,
        }
        impl OcmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OcmszhR::_0 => 0,
                    OcmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OcmszhR {
                match bits {
                    0 => OcmszhR::_0,
                    1 => OcmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OcmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OcmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "OCMEMn is not present." ]
            _0,
            # [ doc = "OCMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ocm2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ocm2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RO`" ]
        pub enum RoW {
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            _0,
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            _1,
        }
        impl RoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RoW::_0 => 0,
                    RoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the OCMDRn[11:0] are allowed" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RoW::_0)
            }
            # [ doc = "Writes to the OCMDRn[11:0] are ignored" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&self) -> Ocm0R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm0R { bits }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&self) -> Ocm1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm1R { bits }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&self) -> Ocm2R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ocm2R { bits }
            }
            # [ doc = "Bit 12 - OCMPU" ]
            # [ inline ( always ) ]
            pub fn ocmpu(&self) -> OcmpuR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OcmpuR { bits }
            }
            # [ doc = "Bits 13:15 - OCMT" ]
            # [ inline ( always ) ]
            pub fn ocmt(&self) -> OcmtR {
                OcmtR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&self) -> RoR {
                RoR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 17:19 - OCMW" ]
            # [ inline ( always ) ]
            pub fn ocmw(&self) -> OcmwR {
                OcmwR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:27 - OCMSZ" ]
            # [ inline ( always ) ]
            pub fn ocmsz(&self) -> OcmszR {
                OcmszR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - OCMSZH" ]
            # [ inline ( always ) ]
            pub fn ocmszh(&self) -> OcmszhR {
                OcmszhR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 28;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - V" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1073741824 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - OCMEM Control Field 0" ]
            # [ inline ( always ) ]
            pub fn ocm0(&mut self) -> _Ocm0W {
                _Ocm0W { w: self }
            }
            # [ doc = "Bits 4:7 - OCMEM Control Field 1" ]
            # [ inline ( always ) ]
            pub fn ocm1(&mut self) -> _Ocm1W {
                _Ocm1W { w: self }
            }
            # [ doc = "Bits 8:11 - OCMEM Control Field 2" ]
            # [ inline ( always ) ]
            pub fn ocm2(&mut self) -> _Ocm2W {
                _Ocm2W { w: self }
            }
            # [ doc = "Bit 16 - RO" ]
            # [ inline ( always ) ]
            pub fn ro(&mut self) -> _RoW {
                _RoW { w: self }
            }
        }
    }
}
# [ doc = "MSCM" ]
pub struct Mscm {
    register_block: mscm::RegisterBlock,
}
impl Deref for Mscm {
    type Target = mscm::RegisterBlock;
    fn deref(&self) -> &mscm::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Enhanced Direct Memory Access" ]
pub const DMA: Peripheral<Dma> = unsafe { Peripheral::new(1073774592) };
# [ doc = "Enhanced Direct Memory Access" ]
pub mod dma {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Control Register" ]
        pub cr: Cr,
        # [ doc = "0x04 - Error Status Register" ]
        pub es: Es,
        _reserved0: [u8; 4usize],
        # [ doc = "0x0c - Enable Request Register" ]
        pub erq: Erq,
        _reserved1: [u8; 4usize],
        # [ doc = "0x14 - Enable Error Interrupt Register" ]
        pub eei: Eei,
        # [ doc = "0x18 - Clear Enable Error Interrupt Register" ]
        pub ceei: Ceei,
        # [ doc = "0x19 - Set Enable Error Interrupt Register" ]
        pub seei: Seei,
        # [ doc = "0x1a - Clear Enable Request Register" ]
        pub cerq: Cerq,
        # [ doc = "0x1b - Set Enable Request Register" ]
        pub serq: Serq,
        # [ doc = "0x1c - Clear DONE Status Bit Register" ]
        pub cdne: Cdne,
        # [ doc = "0x1d - Set START Bit Register" ]
        pub ssrt: Ssrt,
        # [ doc = "0x1e - Clear Error Register" ]
        pub cerr: Cerr,
        # [ doc = "0x1f - Clear Interrupt Request Register" ]
        pub cint: Cint,
        _reserved2: [u8; 4usize],
        # [ doc = "0x24 - Interrupt Request Register" ]
        pub int: Int,
        _reserved3: [u8; 4usize],
        # [ doc = "0x2c - Error Register" ]
        pub err: Err,
        _reserved4: [u8; 4usize],
        # [ doc = "0x34 - Hardware Request Status Register" ]
        pub hrs: Hrs,
        _reserved5: [u8; 12usize],
        # [ doc = "0x44 - Enable Asynchronous Request in Stop Register" ]
        pub ears: Ears,
        _reserved6: [u8; 184usize],
        # [ doc = "0x100 - Channel n Priority Register" ]
        pub dchpri3: Dchpri3,
        # [ doc = "0x101 - Channel n Priority Register" ]
        pub dchpri2: Dchpri2,
        # [ doc = "0x102 - Channel n Priority Register" ]
        pub dchpri1: Dchpri1,
        # [ doc = "0x103 - Channel n Priority Register" ]
        pub dchpri0: Dchpri0,
        # [ doc = "0x104 - Channel n Priority Register" ]
        pub dchpri7: Dchpri7,
        # [ doc = "0x105 - Channel n Priority Register" ]
        pub dchpri6: Dchpri6,
        # [ doc = "0x106 - Channel n Priority Register" ]
        pub dchpri5: Dchpri5,
        # [ doc = "0x107 - Channel n Priority Register" ]
        pub dchpri4: Dchpri4,
        # [ doc = "0x108 - Channel n Priority Register" ]
        pub dchpri11: Dchpri11,
        # [ doc = "0x109 - Channel n Priority Register" ]
        pub dchpri10: Dchpri10,
        # [ doc = "0x10a - Channel n Priority Register" ]
        pub dchpri9: Dchpri9,
        # [ doc = "0x10b - Channel n Priority Register" ]
        pub dchpri8: Dchpri8,
        # [ doc = "0x10c - Channel n Priority Register" ]
        pub dchpri15: Dchpri15,
        # [ doc = "0x10d - Channel n Priority Register" ]
        pub dchpri14: Dchpri14,
        # [ doc = "0x10e - Channel n Priority Register" ]
        pub dchpri13: Dchpri13,
        # [ doc = "0x10f - Channel n Priority Register" ]
        pub dchpri12: Dchpri12,
        _reserved7: [u8; 3824usize],
        # [ doc = "0x1000 - TCD Source Address" ]
        pub tcd0_saddr: Tcd0Saddr,
        # [ doc = "0x1004 - TCD Signed Source Address Offset" ]
        pub tcd0_soff: Tcd0Soff,
        # [ doc = "0x1006 - TCD Transfer Attributes" ]
        pub tcd0_attr: Tcd0Attr,
        # [ doc = "0x1008 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd0_nbytes_mlno: Tcd0NbytesMlno,
        # [ doc = "0x100c - TCD Last Source Address Adjustment" ]
        pub tcd0_slast: Tcd0Slast,
        # [ doc = "0x1010 - TCD Destination Address" ]
        pub tcd0_daddr: Tcd0Daddr,
        # [ doc = "0x1014 - TCD Signed Destination Address Offset" ]
        pub tcd0_doff: Tcd0Doff,
        # [ doc = "0x1016 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd0_citer_elinkno: Tcd0CiterElinkno,
        # [ doc = "0x1018 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd0_dlastsga: Tcd0Dlastsga,
        # [ doc = "0x101c - TCD Control and Status" ]
        pub tcd0_csr: Tcd0Csr,
        # [ doc = "0x101e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd0_biter_elinkno: Tcd0BiterElinkno,
        # [ doc = "0x1020 - TCD Source Address" ]
        pub tcd1_saddr: Tcd1Saddr,
        # [ doc = "0x1024 - TCD Signed Source Address Offset" ]
        pub tcd1_soff: Tcd1Soff,
        # [ doc = "0x1026 - TCD Transfer Attributes" ]
        pub tcd1_attr: Tcd1Attr,
        # [ doc = "0x1028 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd1_nbytes_mlno: Tcd1NbytesMlno,
        # [ doc = "0x102c - TCD Last Source Address Adjustment" ]
        pub tcd1_slast: Tcd1Slast,
        # [ doc = "0x1030 - TCD Destination Address" ]
        pub tcd1_daddr: Tcd1Daddr,
        # [ doc = "0x1034 - TCD Signed Destination Address Offset" ]
        pub tcd1_doff: Tcd1Doff,
        # [ doc = "0x1036 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd1_citer_elinkno: Tcd1CiterElinkno,
        # [ doc = "0x1038 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd1_dlastsga: Tcd1Dlastsga,
        # [ doc = "0x103c - TCD Control and Status" ]
        pub tcd1_csr: Tcd1Csr,
        # [ doc = "0x103e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd1_biter_elinkno: Tcd1BiterElinkno,
        # [ doc = "0x1040 - TCD Source Address" ]
        pub tcd2_saddr: Tcd2Saddr,
        # [ doc = "0x1044 - TCD Signed Source Address Offset" ]
        pub tcd2_soff: Tcd2Soff,
        # [ doc = "0x1046 - TCD Transfer Attributes" ]
        pub tcd2_attr: Tcd2Attr,
        # [ doc = "0x1048 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd2_nbytes_mlno: Tcd2NbytesMlno,
        # [ doc = "0x104c - TCD Last Source Address Adjustment" ]
        pub tcd2_slast: Tcd2Slast,
        # [ doc = "0x1050 - TCD Destination Address" ]
        pub tcd2_daddr: Tcd2Daddr,
        # [ doc = "0x1054 - TCD Signed Destination Address Offset" ]
        pub tcd2_doff: Tcd2Doff,
        # [ doc = "0x1056 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd2_citer_elinkno: Tcd2CiterElinkno,
        # [ doc = "0x1058 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd2_dlastsga: Tcd2Dlastsga,
        # [ doc = "0x105c - TCD Control and Status" ]
        pub tcd2_csr: Tcd2Csr,
        # [ doc = "0x105e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd2_biter_elinkno: Tcd2BiterElinkno,
        # [ doc = "0x1060 - TCD Source Address" ]
        pub tcd3_saddr: Tcd3Saddr,
        # [ doc = "0x1064 - TCD Signed Source Address Offset" ]
        pub tcd3_soff: Tcd3Soff,
        # [ doc = "0x1066 - TCD Transfer Attributes" ]
        pub tcd3_attr: Tcd3Attr,
        # [ doc = "0x1068 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd3_nbytes_mlno: Tcd3NbytesMlno,
        # [ doc = "0x106c - TCD Last Source Address Adjustment" ]
        pub tcd3_slast: Tcd3Slast,
        # [ doc = "0x1070 - TCD Destination Address" ]
        pub tcd3_daddr: Tcd3Daddr,
        # [ doc = "0x1074 - TCD Signed Destination Address Offset" ]
        pub tcd3_doff: Tcd3Doff,
        # [ doc = "0x1076 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd3_citer_elinkno: Tcd3CiterElinkno,
        # [ doc = "0x1078 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd3_dlastsga: Tcd3Dlastsga,
        # [ doc = "0x107c - TCD Control and Status" ]
        pub tcd3_csr: Tcd3Csr,
        # [ doc = "0x107e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd3_biter_elinkno: Tcd3BiterElinkno,
        # [ doc = "0x1080 - TCD Source Address" ]
        pub tcd4_saddr: Tcd4Saddr,
        # [ doc = "0x1084 - TCD Signed Source Address Offset" ]
        pub tcd4_soff: Tcd4Soff,
        # [ doc = "0x1086 - TCD Transfer Attributes" ]
        pub tcd4_attr: Tcd4Attr,
        # [ doc = "0x1088 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd4_nbytes_mlno: Tcd4NbytesMlno,
        # [ doc = "0x108c - TCD Last Source Address Adjustment" ]
        pub tcd4_slast: Tcd4Slast,
        # [ doc = "0x1090 - TCD Destination Address" ]
        pub tcd4_daddr: Tcd4Daddr,
        # [ doc = "0x1094 - TCD Signed Destination Address Offset" ]
        pub tcd4_doff: Tcd4Doff,
        # [ doc = "0x1096 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd4_citer_elinkno: Tcd4CiterElinkno,
        # [ doc = "0x1098 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd4_dlastsga: Tcd4Dlastsga,
        # [ doc = "0x109c - TCD Control and Status" ]
        pub tcd4_csr: Tcd4Csr,
        # [ doc = "0x109e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd4_biter_elinkno: Tcd4BiterElinkno,
        # [ doc = "0x10a0 - TCD Source Address" ]
        pub tcd5_saddr: Tcd5Saddr,
        # [ doc = "0x10a4 - TCD Signed Source Address Offset" ]
        pub tcd5_soff: Tcd5Soff,
        # [ doc = "0x10a6 - TCD Transfer Attributes" ]
        pub tcd5_attr: Tcd5Attr,
        # [ doc = "0x10a8 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd5_nbytes_mlno: Tcd5NbytesMlno,
        # [ doc = "0x10ac - TCD Last Source Address Adjustment" ]
        pub tcd5_slast: Tcd5Slast,
        # [ doc = "0x10b0 - TCD Destination Address" ]
        pub tcd5_daddr: Tcd5Daddr,
        # [ doc = "0x10b4 - TCD Signed Destination Address Offset" ]
        pub tcd5_doff: Tcd5Doff,
        # [ doc = "0x10b6 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd5_citer_elinkno: Tcd5CiterElinkno,
        # [ doc = "0x10b8 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd5_dlastsga: Tcd5Dlastsga,
        # [ doc = "0x10bc - TCD Control and Status" ]
        pub tcd5_csr: Tcd5Csr,
        # [ doc = "0x10be - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd5_biter_elinkno: Tcd5BiterElinkno,
        # [ doc = "0x10c0 - TCD Source Address" ]
        pub tcd6_saddr: Tcd6Saddr,
        # [ doc = "0x10c4 - TCD Signed Source Address Offset" ]
        pub tcd6_soff: Tcd6Soff,
        # [ doc = "0x10c6 - TCD Transfer Attributes" ]
        pub tcd6_attr: Tcd6Attr,
        # [ doc = "0x10c8 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd6_nbytes_mlno: Tcd6NbytesMlno,
        # [ doc = "0x10cc - TCD Last Source Address Adjustment" ]
        pub tcd6_slast: Tcd6Slast,
        # [ doc = "0x10d0 - TCD Destination Address" ]
        pub tcd6_daddr: Tcd6Daddr,
        # [ doc = "0x10d4 - TCD Signed Destination Address Offset" ]
        pub tcd6_doff: Tcd6Doff,
        # [ doc = "0x10d6 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd6_citer_elinkno: Tcd6CiterElinkno,
        # [ doc = "0x10d8 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd6_dlastsga: Tcd6Dlastsga,
        # [ doc = "0x10dc - TCD Control and Status" ]
        pub tcd6_csr: Tcd6Csr,
        # [ doc = "0x10de - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd6_biter_elinkno: Tcd6BiterElinkno,
        # [ doc = "0x10e0 - TCD Source Address" ]
        pub tcd7_saddr: Tcd7Saddr,
        # [ doc = "0x10e4 - TCD Signed Source Address Offset" ]
        pub tcd7_soff: Tcd7Soff,
        # [ doc = "0x10e6 - TCD Transfer Attributes" ]
        pub tcd7_attr: Tcd7Attr,
        # [ doc = "0x10e8 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd7_nbytes_mlno: Tcd7NbytesMlno,
        # [ doc = "0x10ec - TCD Last Source Address Adjustment" ]
        pub tcd7_slast: Tcd7Slast,
        # [ doc = "0x10f0 - TCD Destination Address" ]
        pub tcd7_daddr: Tcd7Daddr,
        # [ doc = "0x10f4 - TCD Signed Destination Address Offset" ]
        pub tcd7_doff: Tcd7Doff,
        # [ doc = "0x10f6 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd7_citer_elinkno: Tcd7CiterElinkno,
        # [ doc = "0x10f8 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd7_dlastsga: Tcd7Dlastsga,
        # [ doc = "0x10fc - TCD Control and Status" ]
        pub tcd7_csr: Tcd7Csr,
        # [ doc = "0x10fe - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd7_biter_elinkno: Tcd7BiterElinkno,
        # [ doc = "0x1100 - TCD Source Address" ]
        pub tcd8_saddr: Tcd8Saddr,
        # [ doc = "0x1104 - TCD Signed Source Address Offset" ]
        pub tcd8_soff: Tcd8Soff,
        # [ doc = "0x1106 - TCD Transfer Attributes" ]
        pub tcd8_attr: Tcd8Attr,
        # [ doc = "0x1108 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd8_nbytes_mlno: Tcd8NbytesMlno,
        # [ doc = "0x110c - TCD Last Source Address Adjustment" ]
        pub tcd8_slast: Tcd8Slast,
        # [ doc = "0x1110 - TCD Destination Address" ]
        pub tcd8_daddr: Tcd8Daddr,
        # [ doc = "0x1114 - TCD Signed Destination Address Offset" ]
        pub tcd8_doff: Tcd8Doff,
        # [ doc = "0x1116 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd8_citer_elinkno: Tcd8CiterElinkno,
        # [ doc = "0x1118 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd8_dlastsga: Tcd8Dlastsga,
        # [ doc = "0x111c - TCD Control and Status" ]
        pub tcd8_csr: Tcd8Csr,
        # [ doc = "0x111e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd8_biter_elinkno: Tcd8BiterElinkno,
        # [ doc = "0x1120 - TCD Source Address" ]
        pub tcd9_saddr: Tcd9Saddr,
        # [ doc = "0x1124 - TCD Signed Source Address Offset" ]
        pub tcd9_soff: Tcd9Soff,
        # [ doc = "0x1126 - TCD Transfer Attributes" ]
        pub tcd9_attr: Tcd9Attr,
        # [ doc = "0x1128 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd9_nbytes_mlno: Tcd9NbytesMlno,
        # [ doc = "0x112c - TCD Last Source Address Adjustment" ]
        pub tcd9_slast: Tcd9Slast,
        # [ doc = "0x1130 - TCD Destination Address" ]
        pub tcd9_daddr: Tcd9Daddr,
        # [ doc = "0x1134 - TCD Signed Destination Address Offset" ]
        pub tcd9_doff: Tcd9Doff,
        # [ doc = "0x1136 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd9_citer_elinkno: Tcd9CiterElinkno,
        # [ doc = "0x1138 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd9_dlastsga: Tcd9Dlastsga,
        # [ doc = "0x113c - TCD Control and Status" ]
        pub tcd9_csr: Tcd9Csr,
        # [ doc = "0x113e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd9_biter_elinkno: Tcd9BiterElinkno,
        # [ doc = "0x1140 - TCD Source Address" ]
        pub tcd10_saddr: Tcd10Saddr,
        # [ doc = "0x1144 - TCD Signed Source Address Offset" ]
        pub tcd10_soff: Tcd10Soff,
        # [ doc = "0x1146 - TCD Transfer Attributes" ]
        pub tcd10_attr: Tcd10Attr,
        # [ doc = "0x1148 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd10_nbytes_mlno: Tcd10NbytesMlno,
        # [ doc = "0x114c - TCD Last Source Address Adjustment" ]
        pub tcd10_slast: Tcd10Slast,
        # [ doc = "0x1150 - TCD Destination Address" ]
        pub tcd10_daddr: Tcd10Daddr,
        # [ doc = "0x1154 - TCD Signed Destination Address Offset" ]
        pub tcd10_doff: Tcd10Doff,
        # [ doc = "0x1156 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd10_citer_elinkno: Tcd10CiterElinkno,
        # [ doc = "0x1158 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd10_dlastsga: Tcd10Dlastsga,
        # [ doc = "0x115c - TCD Control and Status" ]
        pub tcd10_csr: Tcd10Csr,
        # [ doc = "0x115e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd10_biter_elinkno: Tcd10BiterElinkno,
        # [ doc = "0x1160 - TCD Source Address" ]
        pub tcd11_saddr: Tcd11Saddr,
        # [ doc = "0x1164 - TCD Signed Source Address Offset" ]
        pub tcd11_soff: Tcd11Soff,
        # [ doc = "0x1166 - TCD Transfer Attributes" ]
        pub tcd11_attr: Tcd11Attr,
        # [ doc = "0x1168 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd11_nbytes_mlno: Tcd11NbytesMlno,
        # [ doc = "0x116c - TCD Last Source Address Adjustment" ]
        pub tcd11_slast: Tcd11Slast,
        # [ doc = "0x1170 - TCD Destination Address" ]
        pub tcd11_daddr: Tcd11Daddr,
        # [ doc = "0x1174 - TCD Signed Destination Address Offset" ]
        pub tcd11_doff: Tcd11Doff,
        # [ doc = "0x1176 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd11_citer_elinkno: Tcd11CiterElinkno,
        # [ doc = "0x1178 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd11_dlastsga: Tcd11Dlastsga,
        # [ doc = "0x117c - TCD Control and Status" ]
        pub tcd11_csr: Tcd11Csr,
        # [ doc = "0x117e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd11_biter_elinkno: Tcd11BiterElinkno,
        # [ doc = "0x1180 - TCD Source Address" ]
        pub tcd12_saddr: Tcd12Saddr,
        # [ doc = "0x1184 - TCD Signed Source Address Offset" ]
        pub tcd12_soff: Tcd12Soff,
        # [ doc = "0x1186 - TCD Transfer Attributes" ]
        pub tcd12_attr: Tcd12Attr,
        # [ doc = "0x1188 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd12_nbytes_mlno: Tcd12NbytesMlno,
        # [ doc = "0x118c - TCD Last Source Address Adjustment" ]
        pub tcd12_slast: Tcd12Slast,
        # [ doc = "0x1190 - TCD Destination Address" ]
        pub tcd12_daddr: Tcd12Daddr,
        # [ doc = "0x1194 - TCD Signed Destination Address Offset" ]
        pub tcd12_doff: Tcd12Doff,
        # [ doc = "0x1196 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd12_citer_elinkno: Tcd12CiterElinkno,
        # [ doc = "0x1198 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd12_dlastsga: Tcd12Dlastsga,
        # [ doc = "0x119c - TCD Control and Status" ]
        pub tcd12_csr: Tcd12Csr,
        # [ doc = "0x119e - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd12_biter_elinkno: Tcd12BiterElinkno,
        # [ doc = "0x11a0 - TCD Source Address" ]
        pub tcd13_saddr: Tcd13Saddr,
        # [ doc = "0x11a4 - TCD Signed Source Address Offset" ]
        pub tcd13_soff: Tcd13Soff,
        # [ doc = "0x11a6 - TCD Transfer Attributes" ]
        pub tcd13_attr: Tcd13Attr,
        # [ doc = "0x11a8 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd13_nbytes_mlno: Tcd13NbytesMlno,
        # [ doc = "0x11ac - TCD Last Source Address Adjustment" ]
        pub tcd13_slast: Tcd13Slast,
        # [ doc = "0x11b0 - TCD Destination Address" ]
        pub tcd13_daddr: Tcd13Daddr,
        # [ doc = "0x11b4 - TCD Signed Destination Address Offset" ]
        pub tcd13_doff: Tcd13Doff,
        # [ doc = "0x11b6 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd13_citer_elinkno: Tcd13CiterElinkno,
        # [ doc = "0x11b8 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd13_dlastsga: Tcd13Dlastsga,
        # [ doc = "0x11bc - TCD Control and Status" ]
        pub tcd13_csr: Tcd13Csr,
        # [ doc = "0x11be - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd13_biter_elinkno: Tcd13BiterElinkno,
        # [ doc = "0x11c0 - TCD Source Address" ]
        pub tcd14_saddr: Tcd14Saddr,
        # [ doc = "0x11c4 - TCD Signed Source Address Offset" ]
        pub tcd14_soff: Tcd14Soff,
        # [ doc = "0x11c6 - TCD Transfer Attributes" ]
        pub tcd14_attr: Tcd14Attr,
        # [ doc = "0x11c8 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd14_nbytes_mlno: Tcd14NbytesMlno,
        # [ doc = "0x11cc - TCD Last Source Address Adjustment" ]
        pub tcd14_slast: Tcd14Slast,
        # [ doc = "0x11d0 - TCD Destination Address" ]
        pub tcd14_daddr: Tcd14Daddr,
        # [ doc = "0x11d4 - TCD Signed Destination Address Offset" ]
        pub tcd14_doff: Tcd14Doff,
        # [ doc = "0x11d6 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd14_citer_elinkno: Tcd14CiterElinkno,
        # [ doc = "0x11d8 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd14_dlastsga: Tcd14Dlastsga,
        # [ doc = "0x11dc - TCD Control and Status" ]
        pub tcd14_csr: Tcd14Csr,
        # [ doc = "0x11de - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd14_biter_elinkno: Tcd14BiterElinkno,
        # [ doc = "0x11e0 - TCD Source Address" ]
        pub tcd15_saddr: Tcd15Saddr,
        # [ doc = "0x11e4 - TCD Signed Source Address Offset" ]
        pub tcd15_soff: Tcd15Soff,
        # [ doc = "0x11e6 - TCD Transfer Attributes" ]
        pub tcd15_attr: Tcd15Attr,
        # [ doc = "0x11e8 - TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
        pub tcd15_nbytes_mlno: Tcd15NbytesMlno,
        # [ doc = "0x11ec - TCD Last Source Address Adjustment" ]
        pub tcd15_slast: Tcd15Slast,
        # [ doc = "0x11f0 - TCD Destination Address" ]
        pub tcd15_daddr: Tcd15Daddr,
        # [ doc = "0x11f4 - TCD Signed Destination Address Offset" ]
        pub tcd15_doff: Tcd15Doff,
        # [ doc = "0x11f6 - TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd15_citer_elinkno: Tcd15CiterElinkno,
        # [ doc = "0x11f8 - TCD Last Destination Address Adjustment/Scatter Gather Address" ]
        pub tcd15_dlastsga: Tcd15Dlastsga,
        # [ doc = "0x11fc - TCD Control and Status" ]
        pub tcd15_csr: Tcd15Csr,
        # [ doc = "0x11fe - TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
        pub tcd15_biter_elinkno: Tcd15BiterElinkno,
    }
    # [ doc = "Control Register" ]
    pub struct Cr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control Register" ]
    pub mod cr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EdbgR {
            bits: u8,
        }
        impl EdbgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ErcaR {
            bits: u8,
        }
        impl ErcaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `HOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HoeR {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Any error causes the HALT bit to set. Subsequently, all service requests are ignored until the HALT bit is cleared." ]
            _1,
        }
        impl HoeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HoeR::_0 => 0,
                    HoeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HoeR {
                match bits {
                    0 => HoeR::_0,
                    1 => HoeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HoeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HoeR::_1
            }
        }
        # [ doc = "Possible values of the field `HALT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HaltR {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Stall the start of any new channels. Executing channels are allowed to complete. Channel execution resumes when this bit is cleared." ]
            _1,
        }
        impl HaltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HaltR::_0 => 0,
                    HaltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HaltR {
                match bits {
                    0 => HaltR::_0,
                    1 => HaltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HaltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HaltR::_1
            }
        }
        # [ doc = "Possible values of the field `CLM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClmR {
            # [ doc = "A minor loop channel link made to itself goes through channel arbitration before being activated again." ]
            _0,
            # [ doc = "A minor loop channel link made to itself does not go through channel arbitration before being activated again. Upon minor loop completion, the channel activates again if that channel has a minor loop channel link enabled and the link channel is itself. This effectively applies the minor loop offsets and restarts the next minor loop." ]
            _1,
        }
        impl ClmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClmR::_0 => 0,
                    ClmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClmR {
                match bits {
                    0 => ClmR::_0,
                    1 => ClmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ClmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ClmR::_1
            }
        }
        # [ doc = "Possible values of the field `EMLM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EmlmR {
            # [ doc = "Disabled. TCDn.word2 is defined as a 32-bit NBYTES field." ]
            _0,
            # [ doc = "Enabled. TCDn.word2 is redefined to include individual enable fields, an offset field, and the NBYTES field. The individual enable fields allow the minor loop offset to be applied to the source address, the destination address, or both. The NBYTES field is reduced when either offset is enabled." ]
            _1,
        }
        impl EmlmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EmlmR::_0 => 0,
                    EmlmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EmlmR {
                match bits {
                    0 => EmlmR::_0,
                    1 => EmlmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EmlmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EmlmR::_1
            }
        }
        # [ doc = "Possible values of the field `ECX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcxR {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Cancel the remaining data transfer in the same fashion as the CX bit. Stop the executing channel and force the minor loop to finish. The cancel takes effect after the last write of the current read/write sequence. The ECX bit clears itself after the cancel is honored. In addition to cancelling the transfer, ECX treats the cancel as an error condition, thus updating the Error Status register (DMAx_ES) and generating an optional error interrupt." ]
            _1,
        }
        impl EcxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcxR::_0 => 0,
                    EcxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcxR {
                match bits {
                    0 => EcxR::_0,
                    1 => EcxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcxR::_1
            }
        }
        # [ doc = "Possible values of the field `CX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CxR {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Cancel the remaining data transfer. Stop the executing channel and force the minor loop to finish. The cancel takes effect after the last write of the current read/write sequence. The CX bit clears itself after the cancel has been honored. This cancel retires the channel normally as if the minor loop was completed." ]
            _1,
        }
        impl CxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CxR::_0 => 0,
                    CxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CxR {
                match bits {
                    0 => CxR::_0,
                    1 => CxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CxR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EdbgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EdbgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErcaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErcaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HOE`" ]
        pub enum HoeW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Any error causes the HALT bit to set. Subsequently, all service requests are ignored until the HALT bit is cleared." ]
            _1,
        }
        impl HoeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HoeW::_0 => 0,
                    HoeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HoeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HoeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HoeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HoeW::_0)
            }
            # [ doc = "Any error causes the HALT bit to set. Subsequently, all service requests are ignored until the HALT bit is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HoeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HALT`" ]
        pub enum HaltW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Stall the start of any new channels. Executing channels are allowed to complete. Channel execution resumes when this bit is cleared." ]
            _1,
        }
        impl HaltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HaltW::_0 => 0,
                    HaltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HaltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HaltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HaltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HaltW::_0)
            }
            # [ doc = "Stall the start of any new channels. Executing channels are allowed to complete. Channel execution resumes when this bit is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HaltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLM`" ]
        pub enum ClmW {
            # [ doc = "A minor loop channel link made to itself goes through channel arbitration before being activated again." ]
            _0,
            # [ doc = "A minor loop channel link made to itself does not go through channel arbitration before being activated again. Upon minor loop completion, the channel activates again if that channel has a minor loop channel link enabled and the link channel is itself. This effectively applies the minor loop offsets and restarts the next minor loop." ]
            _1,
        }
        impl ClmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClmW::_0 => 0,
                    ClmW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A minor loop channel link made to itself goes through channel arbitration before being activated again." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClmW::_0)
            }
            # [ doc = "A minor loop channel link made to itself does not go through channel arbitration before being activated again. Upon minor loop completion, the channel activates again if that channel has a minor loop channel link enabled and the link channel is itself. This effectively applies the minor loop offsets and restarts the next minor loop." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClmW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EMLM`" ]
        pub enum EmlmW {
            # [ doc = "Disabled. TCDn.word2 is defined as a 32-bit NBYTES field." ]
            _0,
            # [ doc = "Enabled. TCDn.word2 is redefined to include individual enable fields, an offset field, and the NBYTES field. The individual enable fields allow the minor loop offset to be applied to the source address, the destination address, or both. The NBYTES field is reduced when either offset is enabled." ]
            _1,
        }
        impl EmlmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EmlmW::_0 => 0,
                    EmlmW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EmlmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EmlmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EmlmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disabled. TCDn.word2 is defined as a 32-bit NBYTES field." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EmlmW::_0)
            }
            # [ doc = "Enabled. TCDn.word2 is redefined to include individual enable fields, an offset field, and the NBYTES field. The individual enable fields allow the minor loop offset to be applied to the source address, the destination address, or both. The NBYTES field is reduced when either offset is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EmlmW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECX`" ]
        pub enum EcxW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Cancel the remaining data transfer in the same fashion as the CX bit. Stop the executing channel and force the minor loop to finish. The cancel takes effect after the last write of the current read/write sequence. The ECX bit clears itself after the cancel is honored. In addition to cancelling the transfer, ECX treats the cancel as an error condition, thus updating the Error Status register (DMAx_ES) and generating an optional error interrupt." ]
            _1,
        }
        impl EcxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcxW::_0 => 0,
                    EcxW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcxW::_0)
            }
            # [ doc = "Cancel the remaining data transfer in the same fashion as the CX bit. Stop the executing channel and force the minor loop to finish. The cancel takes effect after the last write of the current read/write sequence. The ECX bit clears itself after the cancel is honored. In addition to cancelling the transfer, ECX treats the cancel as an error condition, thus updating the Error Status register (DMAx_ES) and generating an optional error interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcxW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CX`" ]
        pub enum CxW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "Cancel the remaining data transfer. Stop the executing channel and force the minor loop to finish. The cancel takes effect after the last write of the current read/write sequence. The CX bit clears itself after the cancel has been honored. This cancel retires the channel normally as if the minor loop was completed." ]
            _1,
        }
        impl CxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CxW::_0 => 0,
                    CxW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CxW::_0)
            }
            # [ doc = "Cancel the remaining data transfer. Stop the executing channel and force the minor loop to finish. The cancel takes effect after the last write of the current read/write sequence. The CX bit clears itself after the cancel has been honored. This cancel retires the channel normally as if the minor loop was completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CxW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Enable Debug" ]
            # [ inline ( always ) ]
            pub fn edbg(&self) -> EdbgR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EdbgR { bits }
            }
            # [ doc = "Bit 2 - Enable Round Robin Channel Arbitration" ]
            # [ inline ( always ) ]
            pub fn erca(&self) -> ErcaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ErcaR { bits }
            }
            # [ doc = "Bit 4 - Halt On Error" ]
            # [ inline ( always ) ]
            pub fn hoe(&self) -> HoeR {
                HoeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Halt DMA Operations" ]
            # [ inline ( always ) ]
            pub fn halt(&self) -> HaltR {
                HaltR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Continuous Link Mode" ]
            # [ inline ( always ) ]
            pub fn clm(&self) -> ClmR {
                ClmR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Minor Loop Mapping" ]
            # [ inline ( always ) ]
            pub fn emlm(&self) -> EmlmR {
                EmlmR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Error Cancel Transfer" ]
            # [ inline ( always ) ]
            pub fn ecx(&self) -> EcxR {
                EcxR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Cancel Transfer" ]
            # [ inline ( always ) ]
            pub fn cx(&self) -> CxR {
                CxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 17;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Enable Debug" ]
            # [ inline ( always ) ]
            pub fn edbg(&mut self) -> _EdbgW {
                _EdbgW { w: self }
            }
            # [ doc = "Bit 2 - Enable Round Robin Channel Arbitration" ]
            # [ inline ( always ) ]
            pub fn erca(&mut self) -> _ErcaW {
                _ErcaW { w: self }
            }
            # [ doc = "Bit 4 - Halt On Error" ]
            # [ inline ( always ) ]
            pub fn hoe(&mut self) -> _HoeW {
                _HoeW { w: self }
            }
            # [ doc = "Bit 5 - Halt DMA Operations" ]
            # [ inline ( always ) ]
            pub fn halt(&mut self) -> _HaltW {
                _HaltW { w: self }
            }
            # [ doc = "Bit 6 - Continuous Link Mode" ]
            # [ inline ( always ) ]
            pub fn clm(&mut self) -> _ClmW {
                _ClmW { w: self }
            }
            # [ doc = "Bit 7 - Enable Minor Loop Mapping" ]
            # [ inline ( always ) ]
            pub fn emlm(&mut self) -> _EmlmW {
                _EmlmW { w: self }
            }
            # [ doc = "Bit 16 - Error Cancel Transfer" ]
            # [ inline ( always ) ]
            pub fn ecx(&mut self) -> _EcxW {
                _EcxW { w: self }
            }
            # [ doc = "Bit 17 - Cancel Transfer" ]
            # [ inline ( always ) ]
            pub fn cx(&mut self) -> _CxW {
                _CxW { w: self }
            }
        }
    }
    # [ doc = "Error Status Register" ]
    pub struct Es {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Status Register" ]
    pub mod es {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Es {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `DBE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbeR {
            # [ doc = "No destination bus error" ]
            _0,
            # [ doc = "The last recorded error was a bus error on a destination write" ]
            _1,
        }
        impl DbeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbeR::_0 => 0,
                    DbeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbeR {
                match bits {
                    0 => DbeR::_0,
                    1 => DbeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbeR::_1
            }
        }
        # [ doc = "Possible values of the field `SBE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbeR {
            # [ doc = "No source bus error" ]
            _0,
            # [ doc = "The last recorded error was a bus error on a source read" ]
            _1,
        }
        impl SbeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbeR::_0 => 0,
                    SbeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbeR {
                match bits {
                    0 => SbeR::_0,
                    1 => SbeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbeR::_1
            }
        }
        # [ doc = "Possible values of the field `SGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SgeR {
            # [ doc = "No scatter/gather configuration error" ]
            _0,
            # [ doc = "The last recorded error was a configuration error detected in the TCDn_DLASTSGA field. This field is checked at the beginning of a scatter/gather operation after major loop completion if TCDn_CSR[ESG] is enabled. TCDn_DLASTSGA is not on a 32 byte boundary." ]
            _1,
        }
        impl SgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SgeR::_0 => 0,
                    SgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SgeR {
                match bits {
                    0 => SgeR::_0,
                    1 => SgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SgeR::_1
            }
        }
        # [ doc = "Possible values of the field `NCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NceR {
            # [ doc = "No NBYTES/CITER configuration error" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NceR::_0 => 0,
                    NceR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NceR {
                match bits {
                    0 => NceR::_0,
                    i => NceR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NceR::_0
            }
        }
        # [ doc = "Possible values of the field `DOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DoeR {
            # [ doc = "No destination offset configuration error" ]
            _0,
            # [ doc = "The last recorded error was a configuration error detected in the TCDn_DOFF field. TCDn_DOFF is inconsistent with TCDn_ATTR[DSIZE]." ]
            _1,
        }
        impl DoeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DoeR::_0 => 0,
                    DoeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DoeR {
                match bits {
                    0 => DoeR::_0,
                    1 => DoeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DoeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DoeR::_1
            }
        }
        # [ doc = "Possible values of the field `DAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DaeR {
            # [ doc = "No destination address configuration error" ]
            _0,
            # [ doc = "The last recorded error was a configuration error detected in the TCDn_DADDR field. TCDn_DADDR is inconsistent with TCDn_ATTR[DSIZE]." ]
            _1,
        }
        impl DaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DaeR::_0 => 0,
                    DaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DaeR {
                match bits {
                    0 => DaeR::_0,
                    1 => DaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DaeR::_1
            }
        }
        # [ doc = "Possible values of the field `SOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoeR {
            # [ doc = "No source offset configuration error" ]
            _0,
            # [ doc = "The last recorded error was a configuration error detected in the TCDn_SOFF field. TCDn_SOFF is inconsistent with TCDn_ATTR[SSIZE]." ]
            _1,
        }
        impl SoeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoeR::_0 => 0,
                    SoeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoeR {
                match bits {
                    0 => SoeR::_0,
                    1 => SoeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoeR::_1
            }
        }
        # [ doc = "Possible values of the field `SAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SaeR {
            # [ doc = "No source address configuration error." ]
            _0,
            # [ doc = "The last recorded error was a configuration error detected in the TCDn_SADDR field. TCDn_SADDR is inconsistent with TCDn_ATTR[SSIZE]." ]
            _1,
        }
        impl SaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SaeR::_0 => 0,
                    SaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SaeR {
                match bits {
                    0 => SaeR::_0,
                    1 => SaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SaeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ErrchnR {
            bits: u8,
        }
        impl ErrchnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CPE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpeR {
            # [ doc = "No channel priority error" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl CpeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpeR::_0 => 0,
                    CpeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpeR {
                match bits {
                    0 => CpeR::_0,
                    i => CpeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpeR::_0
            }
        }
        # [ doc = "Possible values of the field `ECX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcxR {
            # [ doc = "No canceled transfers" ]
            _0,
            # [ doc = "The last recorded entry was a canceled transfer by the error cancel transfer input" ]
            _1,
        }
        impl EcxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcxR::_0 => 0,
                    EcxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcxR {
                match bits {
                    0 => EcxR::_0,
                    1 => EcxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcxR::_1
            }
        }
        # [ doc = "Possible values of the field `VLD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VldR {
            # [ doc = "No ERR bits are set." ]
            _0,
            # [ doc = "At least one ERR bit is set indicating a valid error exists that has not been cleared." ]
            _1,
        }
        impl VldR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VldR::_0 => 0,
                    VldR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VldR {
                match bits {
                    0 => VldR::_0,
                    1 => VldR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VldR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VldR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Destination Bus Error" ]
            # [ inline ( always ) ]
            pub fn dbe(&self) -> DbeR {
                DbeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Source Bus Error" ]
            # [ inline ( always ) ]
            pub fn sbe(&self) -> SbeR {
                SbeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Scatter/Gather Configuration Error" ]
            # [ inline ( always ) ]
            pub fn sge(&self) -> SgeR {
                SgeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - NBYTES/CITER Configuration Error" ]
            # [ inline ( always ) ]
            pub fn nce(&self) -> NceR {
                NceR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Destination Offset Error" ]
            # [ inline ( always ) ]
            pub fn doe(&self) -> DoeR {
                DoeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Destination Address Error" ]
            # [ inline ( always ) ]
            pub fn dae(&self) -> DaeR {
                DaeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Source Offset Error" ]
            # [ inline ( always ) ]
            pub fn soe(&self) -> SoeR {
                SoeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Source Address Error" ]
            # [ inline ( always ) ]
            pub fn sae(&self) -> SaeR {
                SaeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:11 - Error Channel Number or Canceled Channel Number" ]
            # [ inline ( always ) ]
            pub fn errchn(&self) -> ErrchnR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ErrchnR { bits }
            }
            # [ doc = "Bit 14 - Channel Priority Error" ]
            # [ inline ( always ) ]
            pub fn cpe(&self) -> CpeR {
                CpeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Transfer Canceled" ]
            # [ inline ( always ) ]
            pub fn ecx(&self) -> EcxR {
                EcxR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - VLD" ]
            # [ inline ( always ) ]
            pub fn vld(&self) -> VldR {
                VldR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 31;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
    }
    # [ doc = "Enable Request Register" ]
    pub struct Erq {
        register: VolatileCell<u32>,
    }
    # [ doc = "Enable Request Register" ]
    pub mod erq {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Erq {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERQ0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq0R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq0R::_0 => 0,
                    Erq0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq0R {
                match bits {
                    0 => Erq0R::_0,
                    1 => Erq0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq0R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq1R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq1R::_0 => 0,
                    Erq1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq1R {
                match bits {
                    0 => Erq1R::_0,
                    1 => Erq1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq1R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq2R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq2R::_0 => 0,
                    Erq2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq2R {
                match bits {
                    0 => Erq2R::_0,
                    1 => Erq2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq2R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq3R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq3R::_0 => 0,
                    Erq3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq3R {
                match bits {
                    0 => Erq3R::_0,
                    1 => Erq3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq3R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq4R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq4R::_0 => 0,
                    Erq4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq4R {
                match bits {
                    0 => Erq4R::_0,
                    1 => Erq4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq4R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq5R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq5R::_0 => 0,
                    Erq5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq5R {
                match bits {
                    0 => Erq5R::_0,
                    1 => Erq5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq5R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq6R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq6R::_0 => 0,
                    Erq6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq6R {
                match bits {
                    0 => Erq6R::_0,
                    1 => Erq6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq6R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq7R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq7R::_0 => 0,
                    Erq7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq7R {
                match bits {
                    0 => Erq7R::_0,
                    1 => Erq7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq7R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq8R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq8R::_0 => 0,
                    Erq8R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq8R {
                match bits {
                    0 => Erq8R::_0,
                    1 => Erq8R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq8R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq8R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq9R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq9R::_0 => 0,
                    Erq9R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq9R {
                match bits {
                    0 => Erq9R::_0,
                    1 => Erq9R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq9R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq9R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq10R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq10R::_0 => 0,
                    Erq10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq10R {
                match bits {
                    0 => Erq10R::_0,
                    1 => Erq10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq10R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq11R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq11R::_0 => 0,
                    Erq11R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq11R {
                match bits {
                    0 => Erq11R::_0,
                    1 => Erq11R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq11R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq11R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq12R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq12R::_0 => 0,
                    Erq12R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq12R {
                match bits {
                    0 => Erq12R::_0,
                    1 => Erq12R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq12R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq12R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq13R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq13R::_0 => 0,
                    Erq13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq13R {
                match bits {
                    0 => Erq13R::_0,
                    1 => Erq13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq13R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq14R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq14R::_0 => 0,
                    Erq14R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq14R {
                match bits {
                    0 => Erq14R::_0,
                    1 => Erq14R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq14R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq14R::_1
            }
        }
        # [ doc = "Possible values of the field `ERQ15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Erq15R {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Erq15R::_0 => 0,
                    Erq15R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Erq15R {
                match bits {
                    0 => Erq15R::_0,
                    1 => Erq15R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Erq15R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Erq15R::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERQ0`" ]
        pub enum Erq0W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq0W::_0 => 0,
                    Erq0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq0W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ1`" ]
        pub enum Erq1W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq1W::_0 => 0,
                    Erq1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq1W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ2`" ]
        pub enum Erq2W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq2W::_0 => 0,
                    Erq2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq2W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ3`" ]
        pub enum Erq3W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq3W::_0 => 0,
                    Erq3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq3W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ4`" ]
        pub enum Erq4W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq4W::_0 => 0,
                    Erq4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq4W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ5`" ]
        pub enum Erq5W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq5W::_0 => 0,
                    Erq5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq5W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ6`" ]
        pub enum Erq6W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq6W::_0 => 0,
                    Erq6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq6W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ7`" ]
        pub enum Erq7W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq7W::_0 => 0,
                    Erq7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq7W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ8`" ]
        pub enum Erq8W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq8W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq8W::_0 => 0,
                    Erq8W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq8W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq8W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq8W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq8W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ9`" ]
        pub enum Erq9W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq9W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq9W::_0 => 0,
                    Erq9W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq9W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq9W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq9W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq9W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ10`" ]
        pub enum Erq10W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq10W::_0 => 0,
                    Erq10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq10W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ11`" ]
        pub enum Erq11W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq11W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq11W::_0 => 0,
                    Erq11W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq11W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq11W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq11W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq11W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ12`" ]
        pub enum Erq12W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq12W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq12W::_0 => 0,
                    Erq12W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq12W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq12W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq12W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq12W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ13`" ]
        pub enum Erq13W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq13W::_0 => 0,
                    Erq13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq13W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ14`" ]
        pub enum Erq14W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq14W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq14W::_0 => 0,
                    Erq14W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq14W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq14W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq14W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq14W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERQ15`" ]
        pub enum Erq15W {
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            _0,
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            _1,
        }
        impl Erq15W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Erq15W::_0 => 0,
                    Erq15W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Erq15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Erq15W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Erq15W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The DMA request signal for the corresponding channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Erq15W::_0)
            }
            # [ doc = "The DMA request signal for the corresponding channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Erq15W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Enable DMA Request 0" ]
            # [ inline ( always ) ]
            pub fn erq0(&self) -> Erq0R {
                Erq0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Enable DMA Request 1" ]
            # [ inline ( always ) ]
            pub fn erq1(&self) -> Erq1R {
                Erq1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Enable DMA Request 2" ]
            # [ inline ( always ) ]
            pub fn erq2(&self) -> Erq2R {
                Erq2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Enable DMA Request 3" ]
            # [ inline ( always ) ]
            pub fn erq3(&self) -> Erq3R {
                Erq3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Enable DMA Request 4" ]
            # [ inline ( always ) ]
            pub fn erq4(&self) -> Erq4R {
                Erq4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Enable DMA Request 5" ]
            # [ inline ( always ) ]
            pub fn erq5(&self) -> Erq5R {
                Erq5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Enable DMA Request 6" ]
            # [ inline ( always ) ]
            pub fn erq6(&self) -> Erq6R {
                Erq6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Enable DMA Request 7" ]
            # [ inline ( always ) ]
            pub fn erq7(&self) -> Erq7R {
                Erq7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Enable DMA Request 8" ]
            # [ inline ( always ) ]
            pub fn erq8(&self) -> Erq8R {
                Erq8R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Enable DMA Request 9" ]
            # [ inline ( always ) ]
            pub fn erq9(&self) -> Erq9R {
                Erq9R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Enable DMA Request 10" ]
            # [ inline ( always ) ]
            pub fn erq10(&self) -> Erq10R {
                Erq10R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 10;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 11 - Enable DMA Request 11" ]
            # [ inline ( always ) ]
            pub fn erq11(&self) -> Erq11R {
                Erq11R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 12 - Enable DMA Request 12" ]
            # [ inline ( always ) ]
            pub fn erq12(&self) -> Erq12R {
                Erq12R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Enable DMA Request 13" ]
            # [ inline ( always ) ]
            pub fn erq13(&self) -> Erq13R {
                Erq13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Enable DMA Request 14" ]
            # [ inline ( always ) ]
            pub fn erq14(&self) -> Erq14R {
                Erq14R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Enable DMA Request 15" ]
            # [ inline ( always ) ]
            pub fn erq15(&self) -> Erq15R {
                Erq15R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Enable DMA Request 0" ]
            # [ inline ( always ) ]
            pub fn erq0(&mut self) -> _Erq0W {
                _Erq0W { w: self }
            }
            # [ doc = "Bit 1 - Enable DMA Request 1" ]
            # [ inline ( always ) ]
            pub fn erq1(&mut self) -> _Erq1W {
                _Erq1W { w: self }
            }
            # [ doc = "Bit 2 - Enable DMA Request 2" ]
            # [ inline ( always ) ]
            pub fn erq2(&mut self) -> _Erq2W {
                _Erq2W { w: self }
            }
            # [ doc = "Bit 3 - Enable DMA Request 3" ]
            # [ inline ( always ) ]
            pub fn erq3(&mut self) -> _Erq3W {
                _Erq3W { w: self }
            }
            # [ doc = "Bit 4 - Enable DMA Request 4" ]
            # [ inline ( always ) ]
            pub fn erq4(&mut self) -> _Erq4W {
                _Erq4W { w: self }
            }
            # [ doc = "Bit 5 - Enable DMA Request 5" ]
            # [ inline ( always ) ]
            pub fn erq5(&mut self) -> _Erq5W {
                _Erq5W { w: self }
            }
            # [ doc = "Bit 6 - Enable DMA Request 6" ]
            # [ inline ( always ) ]
            pub fn erq6(&mut self) -> _Erq6W {
                _Erq6W { w: self }
            }
            # [ doc = "Bit 7 - Enable DMA Request 7" ]
            # [ inline ( always ) ]
            pub fn erq7(&mut self) -> _Erq7W {
                _Erq7W { w: self }
            }
            # [ doc = "Bit 8 - Enable DMA Request 8" ]
            # [ inline ( always ) ]
            pub fn erq8(&mut self) -> _Erq8W {
                _Erq8W { w: self }
            }
            # [ doc = "Bit 9 - Enable DMA Request 9" ]
            # [ inline ( always ) ]
            pub fn erq9(&mut self) -> _Erq9W {
                _Erq9W { w: self }
            }
            # [ doc = "Bit 10 - Enable DMA Request 10" ]
            # [ inline ( always ) ]
            pub fn erq10(&mut self) -> _Erq10W {
                _Erq10W { w: self }
            }
            # [ doc = "Bit 11 - Enable DMA Request 11" ]
            # [ inline ( always ) ]
            pub fn erq11(&mut self) -> _Erq11W {
                _Erq11W { w: self }
            }
            # [ doc = "Bit 12 - Enable DMA Request 12" ]
            # [ inline ( always ) ]
            pub fn erq12(&mut self) -> _Erq12W {
                _Erq12W { w: self }
            }
            # [ doc = "Bit 13 - Enable DMA Request 13" ]
            # [ inline ( always ) ]
            pub fn erq13(&mut self) -> _Erq13W {
                _Erq13W { w: self }
            }
            # [ doc = "Bit 14 - Enable DMA Request 14" ]
            # [ inline ( always ) ]
            pub fn erq14(&mut self) -> _Erq14W {
                _Erq14W { w: self }
            }
            # [ doc = "Bit 15 - Enable DMA Request 15" ]
            # [ inline ( always ) ]
            pub fn erq15(&mut self) -> _Erq15W {
                _Erq15W { w: self }
            }
        }
    }
    # [ doc = "Enable Error Interrupt Register" ]
    pub struct Eei {
        register: VolatileCell<u32>,
    }
    # [ doc = "Enable Error Interrupt Register" ]
    pub mod eei {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eei {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EEI0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei0R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei0R::_0 => 0,
                    Eei0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei0R {
                match bits {
                    0 => Eei0R::_0,
                    1 => Eei0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei0R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei1R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei1R::_0 => 0,
                    Eei1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei1R {
                match bits {
                    0 => Eei1R::_0,
                    1 => Eei1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei1R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei2R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei2R::_0 => 0,
                    Eei2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei2R {
                match bits {
                    0 => Eei2R::_0,
                    1 => Eei2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei2R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei3R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei3R::_0 => 0,
                    Eei3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei3R {
                match bits {
                    0 => Eei3R::_0,
                    1 => Eei3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei3R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei4R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei4R::_0 => 0,
                    Eei4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei4R {
                match bits {
                    0 => Eei4R::_0,
                    1 => Eei4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei4R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei5R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei5R::_0 => 0,
                    Eei5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei5R {
                match bits {
                    0 => Eei5R::_0,
                    1 => Eei5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei5R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei6R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei6R::_0 => 0,
                    Eei6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei6R {
                match bits {
                    0 => Eei6R::_0,
                    1 => Eei6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei6R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei7R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei7R::_0 => 0,
                    Eei7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei7R {
                match bits {
                    0 => Eei7R::_0,
                    1 => Eei7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei7R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei8R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei8R::_0 => 0,
                    Eei8R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei8R {
                match bits {
                    0 => Eei8R::_0,
                    1 => Eei8R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei8R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei8R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei9R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei9R::_0 => 0,
                    Eei9R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei9R {
                match bits {
                    0 => Eei9R::_0,
                    1 => Eei9R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei9R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei9R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei10R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei10R::_0 => 0,
                    Eei10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei10R {
                match bits {
                    0 => Eei10R::_0,
                    1 => Eei10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei10R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei11R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei11R::_0 => 0,
                    Eei11R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei11R {
                match bits {
                    0 => Eei11R::_0,
                    1 => Eei11R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei11R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei11R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei12R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei12R::_0 => 0,
                    Eei12R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei12R {
                match bits {
                    0 => Eei12R::_0,
                    1 => Eei12R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei12R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei12R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei13R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei13R::_0 => 0,
                    Eei13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei13R {
                match bits {
                    0 => Eei13R::_0,
                    1 => Eei13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei13R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei14R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei14R::_0 => 0,
                    Eei14R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei14R {
                match bits {
                    0 => Eei14R::_0,
                    1 => Eei14R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei14R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei14R::_1
            }
        }
        # [ doc = "Possible values of the field `EEI15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eei15R {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eei15R::_0 => 0,
                    Eei15R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eei15R {
                match bits {
                    0 => Eei15R::_0,
                    1 => Eei15R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eei15R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eei15R::_1
            }
        }
        # [ doc = "Values that can be written to the field `EEI0`" ]
        pub enum Eei0W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei0W::_0 => 0,
                    Eei0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei0W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI1`" ]
        pub enum Eei1W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei1W::_0 => 0,
                    Eei1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei1W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI2`" ]
        pub enum Eei2W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei2W::_0 => 0,
                    Eei2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei2W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI3`" ]
        pub enum Eei3W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei3W::_0 => 0,
                    Eei3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei3W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI4`" ]
        pub enum Eei4W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei4W::_0 => 0,
                    Eei4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei4W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI5`" ]
        pub enum Eei5W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei5W::_0 => 0,
                    Eei5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei5W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI6`" ]
        pub enum Eei6W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei6W::_0 => 0,
                    Eei6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei6W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI7`" ]
        pub enum Eei7W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei7W::_0 => 0,
                    Eei7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei7W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI8`" ]
        pub enum Eei8W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei8W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei8W::_0 => 0,
                    Eei8W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei8W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei8W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei8W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei8W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI9`" ]
        pub enum Eei9W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei9W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei9W::_0 => 0,
                    Eei9W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei9W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei9W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei9W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei9W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI10`" ]
        pub enum Eei10W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei10W::_0 => 0,
                    Eei10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei10W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI11`" ]
        pub enum Eei11W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei11W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei11W::_0 => 0,
                    Eei11W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei11W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei11W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei11W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei11W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI12`" ]
        pub enum Eei12W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei12W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei12W::_0 => 0,
                    Eei12W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei12W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei12W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei12W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei12W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI13`" ]
        pub enum Eei13W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei13W::_0 => 0,
                    Eei13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei13W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI14`" ]
        pub enum Eei14W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei14W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei14W::_0 => 0,
                    Eei14W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei14W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei14W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei14W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei14W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EEI15`" ]
        pub enum Eei15W {
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            _0,
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            _1,
        }
        impl Eei15W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eei15W::_0 => 0,
                    Eei15W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eei15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eei15W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eei15W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The error signal for corresponding channel does not generate an error interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eei15W::_0)
            }
            # [ doc = "The assertion of the error signal for corresponding channel generates an error interrupt request" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eei15W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Enable Error Interrupt 0" ]
            # [ inline ( always ) ]
            pub fn eei0(&self) -> Eei0R {
                Eei0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Enable Error Interrupt 1" ]
            # [ inline ( always ) ]
            pub fn eei1(&self) -> Eei1R {
                Eei1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Enable Error Interrupt 2" ]
            # [ inline ( always ) ]
            pub fn eei2(&self) -> Eei2R {
                Eei2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Enable Error Interrupt 3" ]
            # [ inline ( always ) ]
            pub fn eei3(&self) -> Eei3R {
                Eei3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Enable Error Interrupt 4" ]
            # [ inline ( always ) ]
            pub fn eei4(&self) -> Eei4R {
                Eei4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Enable Error Interrupt 5" ]
            # [ inline ( always ) ]
            pub fn eei5(&self) -> Eei5R {
                Eei5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Enable Error Interrupt 6" ]
            # [ inline ( always ) ]
            pub fn eei6(&self) -> Eei6R {
                Eei6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Enable Error Interrupt 7" ]
            # [ inline ( always ) ]
            pub fn eei7(&self) -> Eei7R {
                Eei7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Enable Error Interrupt 8" ]
            # [ inline ( always ) ]
            pub fn eei8(&self) -> Eei8R {
                Eei8R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Enable Error Interrupt 9" ]
            # [ inline ( always ) ]
            pub fn eei9(&self) -> Eei9R {
                Eei9R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Enable Error Interrupt 10" ]
            # [ inline ( always ) ]
            pub fn eei10(&self) -> Eei10R {
                Eei10R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 10;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 11 - Enable Error Interrupt 11" ]
            # [ inline ( always ) ]
            pub fn eei11(&self) -> Eei11R {
                Eei11R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 12 - Enable Error Interrupt 12" ]
            # [ inline ( always ) ]
            pub fn eei12(&self) -> Eei12R {
                Eei12R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Enable Error Interrupt 13" ]
            # [ inline ( always ) ]
            pub fn eei13(&self) -> Eei13R {
                Eei13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Enable Error Interrupt 14" ]
            # [ inline ( always ) ]
            pub fn eei14(&self) -> Eei14R {
                Eei14R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Enable Error Interrupt 15" ]
            # [ inline ( always ) ]
            pub fn eei15(&self) -> Eei15R {
                Eei15R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Enable Error Interrupt 0" ]
            # [ inline ( always ) ]
            pub fn eei0(&mut self) -> _Eei0W {
                _Eei0W { w: self }
            }
            # [ doc = "Bit 1 - Enable Error Interrupt 1" ]
            # [ inline ( always ) ]
            pub fn eei1(&mut self) -> _Eei1W {
                _Eei1W { w: self }
            }
            # [ doc = "Bit 2 - Enable Error Interrupt 2" ]
            # [ inline ( always ) ]
            pub fn eei2(&mut self) -> _Eei2W {
                _Eei2W { w: self }
            }
            # [ doc = "Bit 3 - Enable Error Interrupt 3" ]
            # [ inline ( always ) ]
            pub fn eei3(&mut self) -> _Eei3W {
                _Eei3W { w: self }
            }
            # [ doc = "Bit 4 - Enable Error Interrupt 4" ]
            # [ inline ( always ) ]
            pub fn eei4(&mut self) -> _Eei4W {
                _Eei4W { w: self }
            }
            # [ doc = "Bit 5 - Enable Error Interrupt 5" ]
            # [ inline ( always ) ]
            pub fn eei5(&mut self) -> _Eei5W {
                _Eei5W { w: self }
            }
            # [ doc = "Bit 6 - Enable Error Interrupt 6" ]
            # [ inline ( always ) ]
            pub fn eei6(&mut self) -> _Eei6W {
                _Eei6W { w: self }
            }
            # [ doc = "Bit 7 - Enable Error Interrupt 7" ]
            # [ inline ( always ) ]
            pub fn eei7(&mut self) -> _Eei7W {
                _Eei7W { w: self }
            }
            # [ doc = "Bit 8 - Enable Error Interrupt 8" ]
            # [ inline ( always ) ]
            pub fn eei8(&mut self) -> _Eei8W {
                _Eei8W { w: self }
            }
            # [ doc = "Bit 9 - Enable Error Interrupt 9" ]
            # [ inline ( always ) ]
            pub fn eei9(&mut self) -> _Eei9W {
                _Eei9W { w: self }
            }
            # [ doc = "Bit 10 - Enable Error Interrupt 10" ]
            # [ inline ( always ) ]
            pub fn eei10(&mut self) -> _Eei10W {
                _Eei10W { w: self }
            }
            # [ doc = "Bit 11 - Enable Error Interrupt 11" ]
            # [ inline ( always ) ]
            pub fn eei11(&mut self) -> _Eei11W {
                _Eei11W { w: self }
            }
            # [ doc = "Bit 12 - Enable Error Interrupt 12" ]
            # [ inline ( always ) ]
            pub fn eei12(&mut self) -> _Eei12W {
                _Eei12W { w: self }
            }
            # [ doc = "Bit 13 - Enable Error Interrupt 13" ]
            # [ inline ( always ) ]
            pub fn eei13(&mut self) -> _Eei13W {
                _Eei13W { w: self }
            }
            # [ doc = "Bit 14 - Enable Error Interrupt 14" ]
            # [ inline ( always ) ]
            pub fn eei14(&mut self) -> _Eei14W {
                _Eei14W { w: self }
            }
            # [ doc = "Bit 15 - Enable Error Interrupt 15" ]
            # [ inline ( always ) ]
            pub fn eei15(&mut self) -> _Eei15W {
                _Eei15W { w: self }
            }
        }
    }
    # [ doc = "Clear Enable Error Interrupt Register" ]
    pub struct Ceei {
        register: VolatileCell<u8>,
    }
    # [ doc = "Clear Enable Error Interrupt Register" ]
    pub mod ceei {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Ceei {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CeeiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CeeiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaeeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaeeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Clear Enable Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn ceei(&mut self) -> _CeeiW {
                _CeeiW { w: self }
            }
            # [ doc = "Bit 6 - Clear All Enable Error Interrupts" ]
            # [ inline ( always ) ]
            pub fn caee(&mut self) -> _CaeeW {
                _CaeeW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Set Enable Error Interrupt Register" ]
    pub struct Seei {
        register: VolatileCell<u8>,
    }
    # [ doc = "Set Enable Error Interrupt Register" ]
    pub mod seei {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Seei {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SeeiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SeeiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaeeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaeeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Set Enable Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn seei(&mut self) -> _SeeiW {
                _SeeiW { w: self }
            }
            # [ doc = "Bit 6 - Sets All Enable Error Interrupts" ]
            # [ inline ( always ) ]
            pub fn saee(&mut self) -> _SaeeW {
                _SaeeW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Clear Enable Request Register" ]
    pub struct Cerq {
        register: VolatileCell<u8>,
    }
    # [ doc = "Clear Enable Request Register" ]
    pub mod cerq {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Cerq {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CerqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CerqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaerW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Clear Enable Request" ]
            # [ inline ( always ) ]
            pub fn cerq(&mut self) -> _CerqW {
                _CerqW { w: self }
            }
            # [ doc = "Bit 6 - Clear All Enable Requests" ]
            # [ inline ( always ) ]
            pub fn caer(&mut self) -> _CaerW {
                _CaerW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Set Enable Request Register" ]
    pub struct Serq {
        register: VolatileCell<u8>,
    }
    # [ doc = "Set Enable Request Register" ]
    pub mod serq {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Serq {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SerqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SerqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaerW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Set Enable Request" ]
            # [ inline ( always ) ]
            pub fn serq(&mut self) -> _SerqW {
                _SerqW { w: self }
            }
            # [ doc = "Bit 6 - Set All Enable Requests" ]
            # [ inline ( always ) ]
            pub fn saer(&mut self) -> _SaerW {
                _SaerW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Clear DONE Status Bit Register" ]
    pub struct Cdne {
        register: VolatileCell<u8>,
    }
    # [ doc = "Clear DONE Status Bit Register" ]
    pub mod cdne {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Cdne {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CdneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CdneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CADN`" ]
        pub enum CadnW {
            # [ doc = "Clears only the TCDn_CSR[DONE] bit specified in the CDNE field" ]
            _0,
            # [ doc = "Clears all bits in TCDn_CSR[DONE]" ]
            _1,
        }
        impl CadnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CadnW::_0 => 0,
                    CadnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CadnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CadnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CadnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clears only the TCDn_CSR[DONE] bit specified in the CDNE field" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CadnW::_0)
            }
            # [ doc = "Clears all bits in TCDn_CSR[DONE]" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CadnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Clear DONE Bit" ]
            # [ inline ( always ) ]
            pub fn cdne(&mut self) -> _CdneW {
                _CdneW { w: self }
            }
            # [ doc = "Bit 6 - Clears All DONE Bits" ]
            # [ inline ( always ) ]
            pub fn cadn(&mut self) -> _CadnW {
                _CadnW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Set START Bit Register" ]
    pub struct Ssrt {
        register: VolatileCell<u8>,
    }
    # [ doc = "Set START Bit Register" ]
    pub mod ssrt {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Ssrt {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsrtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsrtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SAST`" ]
        pub enum SastW {
            # [ doc = "Set only the TCDn_CSR[START] bit specified in the SSRT field" ]
            _0,
            # [ doc = "Set all bits in TCDn_CSR[START]" ]
            _1,
        }
        impl SastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SastW::_0 => 0,
                    SastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Set only the TCDn_CSR[START] bit specified in the SSRT field" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SastW::_0)
            }
            # [ doc = "Set all bits in TCDn_CSR[START]" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Set START Bit" ]
            # [ inline ( always ) ]
            pub fn ssrt(&mut self) -> _SsrtW {
                _SsrtW { w: self }
            }
            # [ doc = "Bit 6 - Set All START Bits (activates all channels)" ]
            # [ inline ( always ) ]
            pub fn sast(&mut self) -> _SastW {
                _SastW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Clear Error Register" ]
    pub struct Cerr {
        register: VolatileCell<u8>,
    }
    # [ doc = "Clear Error Register" ]
    pub mod cerr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Cerr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CerrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaeiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaeiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Clear Error Indicator" ]
            # [ inline ( always ) ]
            pub fn cerr(&mut self) -> _CerrW {
                _CerrW { w: self }
            }
            # [ doc = "Bit 6 - Clear All Error Indicators" ]
            # [ inline ( always ) ]
            pub fn caei(&mut self) -> _CaeiW {
                _CaeiW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Clear Interrupt Request Register" ]
    pub struct Cint {
        register: VolatileCell<u8>,
    }
    # [ doc = "Clear Interrupt Request Register" ]
    pub mod cint {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Cint {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CintW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CairW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CairW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOP`" ]
        pub enum NopW {
            # [ doc = "Normal operation" ]
            _0,
            # [ doc = "No operation, ignore the other bits in this register" ]
            _1,
        }
        impl NopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NopW::_0 => 0,
                    NopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NopW::_0)
            }
            # [ doc = "No operation, ignore the other bits in this register" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Clear Interrupt Request" ]
            # [ inline ( always ) ]
            pub fn cint(&mut self) -> _CintW {
                _CintW { w: self }
            }
            # [ doc = "Bit 6 - Clear All Interrupt Requests" ]
            # [ inline ( always ) ]
            pub fn cair(&mut self) -> _CairW {
                _CairW { w: self }
            }
            # [ doc = "Bit 7 - No Op enable" ]
            # [ inline ( always ) ]
            pub fn nop(&mut self) -> _NopW {
                _NopW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Request Register" ]
    pub struct Int {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Request Register" ]
    pub mod int {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Int {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `INT0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int0R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int0R::_0 => 0,
                    Int0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int0R {
                match bits {
                    0 => Int0R::_0,
                    1 => Int0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int0R::_1
            }
        }
        # [ doc = "Possible values of the field `INT1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int1R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int1R::_0 => 0,
                    Int1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int1R {
                match bits {
                    0 => Int1R::_0,
                    1 => Int1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int1R::_1
            }
        }
        # [ doc = "Possible values of the field `INT2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int2R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int2R::_0 => 0,
                    Int2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int2R {
                match bits {
                    0 => Int2R::_0,
                    1 => Int2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int2R::_1
            }
        }
        # [ doc = "Possible values of the field `INT3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int3R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int3R::_0 => 0,
                    Int3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int3R {
                match bits {
                    0 => Int3R::_0,
                    1 => Int3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int3R::_1
            }
        }
        # [ doc = "Possible values of the field `INT4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int4R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int4R::_0 => 0,
                    Int4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int4R {
                match bits {
                    0 => Int4R::_0,
                    1 => Int4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int4R::_1
            }
        }
        # [ doc = "Possible values of the field `INT5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int5R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int5R::_0 => 0,
                    Int5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int5R {
                match bits {
                    0 => Int5R::_0,
                    1 => Int5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int5R::_1
            }
        }
        # [ doc = "Possible values of the field `INT6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int6R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int6R::_0 => 0,
                    Int6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int6R {
                match bits {
                    0 => Int6R::_0,
                    1 => Int6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int6R::_1
            }
        }
        # [ doc = "Possible values of the field `INT7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int7R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int7R::_0 => 0,
                    Int7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int7R {
                match bits {
                    0 => Int7R::_0,
                    1 => Int7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int7R::_1
            }
        }
        # [ doc = "Possible values of the field `INT8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int8R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int8R::_0 => 0,
                    Int8R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int8R {
                match bits {
                    0 => Int8R::_0,
                    1 => Int8R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int8R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int8R::_1
            }
        }
        # [ doc = "Possible values of the field `INT9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int9R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int9R::_0 => 0,
                    Int9R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int9R {
                match bits {
                    0 => Int9R::_0,
                    1 => Int9R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int9R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int9R::_1
            }
        }
        # [ doc = "Possible values of the field `INT10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int10R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int10R::_0 => 0,
                    Int10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int10R {
                match bits {
                    0 => Int10R::_0,
                    1 => Int10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int10R::_1
            }
        }
        # [ doc = "Possible values of the field `INT11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int11R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int11R::_0 => 0,
                    Int11R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int11R {
                match bits {
                    0 => Int11R::_0,
                    1 => Int11R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int11R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int11R::_1
            }
        }
        # [ doc = "Possible values of the field `INT12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int12R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int12R::_0 => 0,
                    Int12R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int12R {
                match bits {
                    0 => Int12R::_0,
                    1 => Int12R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int12R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int12R::_1
            }
        }
        # [ doc = "Possible values of the field `INT13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int13R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int13R::_0 => 0,
                    Int13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int13R {
                match bits {
                    0 => Int13R::_0,
                    1 => Int13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int13R::_1
            }
        }
        # [ doc = "Possible values of the field `INT14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int14R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int14R::_0 => 0,
                    Int14R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int14R {
                match bits {
                    0 => Int14R::_0,
                    1 => Int14R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int14R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int14R::_1
            }
        }
        # [ doc = "Possible values of the field `INT15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Int15R {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Int15R::_0 => 0,
                    Int15R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Int15R {
                match bits {
                    0 => Int15R::_0,
                    1 => Int15R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Int15R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Int15R::_1
            }
        }
        # [ doc = "Values that can be written to the field `INT0`" ]
        pub enum Int0W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int0W::_0 => 0,
                    Int0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int0W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT1`" ]
        pub enum Int1W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int1W::_0 => 0,
                    Int1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int1W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT2`" ]
        pub enum Int2W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int2W::_0 => 0,
                    Int2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int2W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT3`" ]
        pub enum Int3W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int3W::_0 => 0,
                    Int3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int3W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT4`" ]
        pub enum Int4W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int4W::_0 => 0,
                    Int4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int4W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT5`" ]
        pub enum Int5W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int5W::_0 => 0,
                    Int5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int5W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT6`" ]
        pub enum Int6W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int6W::_0 => 0,
                    Int6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int6W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT7`" ]
        pub enum Int7W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int7W::_0 => 0,
                    Int7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int7W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT8`" ]
        pub enum Int8W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int8W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int8W::_0 => 0,
                    Int8W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int8W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int8W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int8W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int8W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT9`" ]
        pub enum Int9W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int9W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int9W::_0 => 0,
                    Int9W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int9W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int9W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int9W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int9W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT10`" ]
        pub enum Int10W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int10W::_0 => 0,
                    Int10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int10W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT11`" ]
        pub enum Int11W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int11W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int11W::_0 => 0,
                    Int11W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int11W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int11W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int11W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int11W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT12`" ]
        pub enum Int12W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int12W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int12W::_0 => 0,
                    Int12W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int12W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int12W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int12W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int12W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT13`" ]
        pub enum Int13W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int13W::_0 => 0,
                    Int13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int13W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT14`" ]
        pub enum Int14W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int14W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int14W::_0 => 0,
                    Int14W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int14W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int14W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int14W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int14W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT15`" ]
        pub enum Int15W {
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            _0,
            # [ doc = "The interrupt request for corresponding channel is active" ]
            _1,
        }
        impl Int15W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Int15W::_0 => 0,
                    Int15W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Int15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Int15W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Int15W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The interrupt request for corresponding channel is cleared" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Int15W::_0)
            }
            # [ doc = "The interrupt request for corresponding channel is active" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Int15W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Interrupt Request 0" ]
            # [ inline ( always ) ]
            pub fn int0(&self) -> Int0R {
                Int0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Interrupt Request 1" ]
            # [ inline ( always ) ]
            pub fn int1(&self) -> Int1R {
                Int1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Interrupt Request 2" ]
            # [ inline ( always ) ]
            pub fn int2(&self) -> Int2R {
                Int2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Interrupt Request 3" ]
            # [ inline ( always ) ]
            pub fn int3(&self) -> Int3R {
                Int3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Interrupt Request 4" ]
            # [ inline ( always ) ]
            pub fn int4(&self) -> Int4R {
                Int4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Interrupt Request 5" ]
            # [ inline ( always ) ]
            pub fn int5(&self) -> Int5R {
                Int5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Interrupt Request 6" ]
            # [ inline ( always ) ]
            pub fn int6(&self) -> Int6R {
                Int6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Interrupt Request 7" ]
            # [ inline ( always ) ]
            pub fn int7(&self) -> Int7R {
                Int7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Interrupt Request 8" ]
            # [ inline ( always ) ]
            pub fn int8(&self) -> Int8R {
                Int8R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Interrupt Request 9" ]
            # [ inline ( always ) ]
            pub fn int9(&self) -> Int9R {
                Int9R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Interrupt Request 10" ]
            # [ inline ( always ) ]
            pub fn int10(&self) -> Int10R {
                Int10R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 10;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 11 - Interrupt Request 11" ]
            # [ inline ( always ) ]
            pub fn int11(&self) -> Int11R {
                Int11R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 12 - Interrupt Request 12" ]
            # [ inline ( always ) ]
            pub fn int12(&self) -> Int12R {
                Int12R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Interrupt Request 13" ]
            # [ inline ( always ) ]
            pub fn int13(&self) -> Int13R {
                Int13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Interrupt Request 14" ]
            # [ inline ( always ) ]
            pub fn int14(&self) -> Int14R {
                Int14R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Interrupt Request 15" ]
            # [ inline ( always ) ]
            pub fn int15(&self) -> Int15R {
                Int15R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Interrupt Request 0" ]
            # [ inline ( always ) ]
            pub fn int0(&mut self) -> _Int0W {
                _Int0W { w: self }
            }
            # [ doc = "Bit 1 - Interrupt Request 1" ]
            # [ inline ( always ) ]
            pub fn int1(&mut self) -> _Int1W {
                _Int1W { w: self }
            }
            # [ doc = "Bit 2 - Interrupt Request 2" ]
            # [ inline ( always ) ]
            pub fn int2(&mut self) -> _Int2W {
                _Int2W { w: self }
            }
            # [ doc = "Bit 3 - Interrupt Request 3" ]
            # [ inline ( always ) ]
            pub fn int3(&mut self) -> _Int3W {
                _Int3W { w: self }
            }
            # [ doc = "Bit 4 - Interrupt Request 4" ]
            # [ inline ( always ) ]
            pub fn int4(&mut self) -> _Int4W {
                _Int4W { w: self }
            }
            # [ doc = "Bit 5 - Interrupt Request 5" ]
            # [ inline ( always ) ]
            pub fn int5(&mut self) -> _Int5W {
                _Int5W { w: self }
            }
            # [ doc = "Bit 6 - Interrupt Request 6" ]
            # [ inline ( always ) ]
            pub fn int6(&mut self) -> _Int6W {
                _Int6W { w: self }
            }
            # [ doc = "Bit 7 - Interrupt Request 7" ]
            # [ inline ( always ) ]
            pub fn int7(&mut self) -> _Int7W {
                _Int7W { w: self }
            }
            # [ doc = "Bit 8 - Interrupt Request 8" ]
            # [ inline ( always ) ]
            pub fn int8(&mut self) -> _Int8W {
                _Int8W { w: self }
            }
            # [ doc = "Bit 9 - Interrupt Request 9" ]
            # [ inline ( always ) ]
            pub fn int9(&mut self) -> _Int9W {
                _Int9W { w: self }
            }
            # [ doc = "Bit 10 - Interrupt Request 10" ]
            # [ inline ( always ) ]
            pub fn int10(&mut self) -> _Int10W {
                _Int10W { w: self }
            }
            # [ doc = "Bit 11 - Interrupt Request 11" ]
            # [ inline ( always ) ]
            pub fn int11(&mut self) -> _Int11W {
                _Int11W { w: self }
            }
            # [ doc = "Bit 12 - Interrupt Request 12" ]
            # [ inline ( always ) ]
            pub fn int12(&mut self) -> _Int12W {
                _Int12W { w: self }
            }
            # [ doc = "Bit 13 - Interrupt Request 13" ]
            # [ inline ( always ) ]
            pub fn int13(&mut self) -> _Int13W {
                _Int13W { w: self }
            }
            # [ doc = "Bit 14 - Interrupt Request 14" ]
            # [ inline ( always ) ]
            pub fn int14(&mut self) -> _Int14W {
                _Int14W { w: self }
            }
            # [ doc = "Bit 15 - Interrupt Request 15" ]
            # [ inline ( always ) ]
            pub fn int15(&mut self) -> _Int15W {
                _Int15W { w: self }
            }
        }
    }
    # [ doc = "Error Register" ]
    pub struct Err {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Register" ]
    pub mod err {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Err {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERR0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err0R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err0R::_0 => 0,
                    Err0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err0R {
                match bits {
                    0 => Err0R::_0,
                    1 => Err0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err0R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err1R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err1R::_0 => 0,
                    Err1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err1R {
                match bits {
                    0 => Err1R::_0,
                    1 => Err1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err1R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err2R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err2R::_0 => 0,
                    Err2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err2R {
                match bits {
                    0 => Err2R::_0,
                    1 => Err2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err2R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err3R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err3R::_0 => 0,
                    Err3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err3R {
                match bits {
                    0 => Err3R::_0,
                    1 => Err3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err3R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err4R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err4R::_0 => 0,
                    Err4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err4R {
                match bits {
                    0 => Err4R::_0,
                    1 => Err4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err4R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err5R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err5R::_0 => 0,
                    Err5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err5R {
                match bits {
                    0 => Err5R::_0,
                    1 => Err5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err5R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err6R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err6R::_0 => 0,
                    Err6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err6R {
                match bits {
                    0 => Err6R::_0,
                    1 => Err6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err6R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err7R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err7R::_0 => 0,
                    Err7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err7R {
                match bits {
                    0 => Err7R::_0,
                    1 => Err7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err7R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err8R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err8R::_0 => 0,
                    Err8R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err8R {
                match bits {
                    0 => Err8R::_0,
                    1 => Err8R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err8R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err8R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err9R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err9R::_0 => 0,
                    Err9R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err9R {
                match bits {
                    0 => Err9R::_0,
                    1 => Err9R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err9R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err9R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err10R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err10R::_0 => 0,
                    Err10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err10R {
                match bits {
                    0 => Err10R::_0,
                    1 => Err10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err10R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err11R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err11R::_0 => 0,
                    Err11R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err11R {
                match bits {
                    0 => Err11R::_0,
                    1 => Err11R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err11R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err11R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err12R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err12R::_0 => 0,
                    Err12R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err12R {
                match bits {
                    0 => Err12R::_0,
                    1 => Err12R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err12R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err12R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err13R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err13R::_0 => 0,
                    Err13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err13R {
                match bits {
                    0 => Err13R::_0,
                    1 => Err13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err13R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err14R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err14R::_0 => 0,
                    Err14R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err14R {
                match bits {
                    0 => Err14R::_0,
                    1 => Err14R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err14R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err14R::_1
            }
        }
        # [ doc = "Possible values of the field `ERR15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Err15R {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Err15R::_0 => 0,
                    Err15R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Err15R {
                match bits {
                    0 => Err15R::_0,
                    1 => Err15R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Err15R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Err15R::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERR0`" ]
        pub enum Err0W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err0W::_0 => 0,
                    Err0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err0W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR1`" ]
        pub enum Err1W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err1W::_0 => 0,
                    Err1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err1W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR2`" ]
        pub enum Err2W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err2W::_0 => 0,
                    Err2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err2W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR3`" ]
        pub enum Err3W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err3W::_0 => 0,
                    Err3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err3W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR4`" ]
        pub enum Err4W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err4W::_0 => 0,
                    Err4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err4W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR5`" ]
        pub enum Err5W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err5W::_0 => 0,
                    Err5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err5W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR6`" ]
        pub enum Err6W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err6W::_0 => 0,
                    Err6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err6W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR7`" ]
        pub enum Err7W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err7W::_0 => 0,
                    Err7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err7W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR8`" ]
        pub enum Err8W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err8W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err8W::_0 => 0,
                    Err8W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err8W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err8W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err8W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err8W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR9`" ]
        pub enum Err9W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err9W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err9W::_0 => 0,
                    Err9W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err9W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err9W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err9W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err9W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR10`" ]
        pub enum Err10W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err10W::_0 => 0,
                    Err10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err10W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR11`" ]
        pub enum Err11W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err11W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err11W::_0 => 0,
                    Err11W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err11W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err11W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err11W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err11W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR12`" ]
        pub enum Err12W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err12W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err12W::_0 => 0,
                    Err12W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err12W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err12W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err12W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err12W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR13`" ]
        pub enum Err13W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err13W::_0 => 0,
                    Err13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err13W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR14`" ]
        pub enum Err14W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err14W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err14W::_0 => 0,
                    Err14W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err14W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err14W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err14W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err14W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERR15`" ]
        pub enum Err15W {
            # [ doc = "An error in this channel has not occurred" ]
            _0,
            # [ doc = "An error in this channel has occurred" ]
            _1,
        }
        impl Err15W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Err15W::_0 => 0,
                    Err15W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Err15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Err15W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Err15W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "An error in this channel has not occurred" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Err15W::_0)
            }
            # [ doc = "An error in this channel has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Err15W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Error In Channel 0" ]
            # [ inline ( always ) ]
            pub fn err0(&self) -> Err0R {
                Err0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Error In Channel 1" ]
            # [ inline ( always ) ]
            pub fn err1(&self) -> Err1R {
                Err1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Error In Channel 2" ]
            # [ inline ( always ) ]
            pub fn err2(&self) -> Err2R {
                Err2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Error In Channel 3" ]
            # [ inline ( always ) ]
            pub fn err3(&self) -> Err3R {
                Err3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Error In Channel 4" ]
            # [ inline ( always ) ]
            pub fn err4(&self) -> Err4R {
                Err4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Error In Channel 5" ]
            # [ inline ( always ) ]
            pub fn err5(&self) -> Err5R {
                Err5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Error In Channel 6" ]
            # [ inline ( always ) ]
            pub fn err6(&self) -> Err6R {
                Err6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Error In Channel 7" ]
            # [ inline ( always ) ]
            pub fn err7(&self) -> Err7R {
                Err7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Error In Channel 8" ]
            # [ inline ( always ) ]
            pub fn err8(&self) -> Err8R {
                Err8R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Error In Channel 9" ]
            # [ inline ( always ) ]
            pub fn err9(&self) -> Err9R {
                Err9R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Error In Channel 10" ]
            # [ inline ( always ) ]
            pub fn err10(&self) -> Err10R {
                Err10R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 10;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 11 - Error In Channel 11" ]
            # [ inline ( always ) ]
            pub fn err11(&self) -> Err11R {
                Err11R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 12 - Error In Channel 12" ]
            # [ inline ( always ) ]
            pub fn err12(&self) -> Err12R {
                Err12R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Error In Channel 13" ]
            # [ inline ( always ) ]
            pub fn err13(&self) -> Err13R {
                Err13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Error In Channel 14" ]
            # [ inline ( always ) ]
            pub fn err14(&self) -> Err14R {
                Err14R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Error In Channel 15" ]
            # [ inline ( always ) ]
            pub fn err15(&self) -> Err15R {
                Err15R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Error In Channel 0" ]
            # [ inline ( always ) ]
            pub fn err0(&mut self) -> _Err0W {
                _Err0W { w: self }
            }
            # [ doc = "Bit 1 - Error In Channel 1" ]
            # [ inline ( always ) ]
            pub fn err1(&mut self) -> _Err1W {
                _Err1W { w: self }
            }
            # [ doc = "Bit 2 - Error In Channel 2" ]
            # [ inline ( always ) ]
            pub fn err2(&mut self) -> _Err2W {
                _Err2W { w: self }
            }
            # [ doc = "Bit 3 - Error In Channel 3" ]
            # [ inline ( always ) ]
            pub fn err3(&mut self) -> _Err3W {
                _Err3W { w: self }
            }
            # [ doc = "Bit 4 - Error In Channel 4" ]
            # [ inline ( always ) ]
            pub fn err4(&mut self) -> _Err4W {
                _Err4W { w: self }
            }
            # [ doc = "Bit 5 - Error In Channel 5" ]
            # [ inline ( always ) ]
            pub fn err5(&mut self) -> _Err5W {
                _Err5W { w: self }
            }
            # [ doc = "Bit 6 - Error In Channel 6" ]
            # [ inline ( always ) ]
            pub fn err6(&mut self) -> _Err6W {
                _Err6W { w: self }
            }
            # [ doc = "Bit 7 - Error In Channel 7" ]
            # [ inline ( always ) ]
            pub fn err7(&mut self) -> _Err7W {
                _Err7W { w: self }
            }
            # [ doc = "Bit 8 - Error In Channel 8" ]
            # [ inline ( always ) ]
            pub fn err8(&mut self) -> _Err8W {
                _Err8W { w: self }
            }
            # [ doc = "Bit 9 - Error In Channel 9" ]
            # [ inline ( always ) ]
            pub fn err9(&mut self) -> _Err9W {
                _Err9W { w: self }
            }
            # [ doc = "Bit 10 - Error In Channel 10" ]
            # [ inline ( always ) ]
            pub fn err10(&mut self) -> _Err10W {
                _Err10W { w: self }
            }
            # [ doc = "Bit 11 - Error In Channel 11" ]
            # [ inline ( always ) ]
            pub fn err11(&mut self) -> _Err11W {
                _Err11W { w: self }
            }
            # [ doc = "Bit 12 - Error In Channel 12" ]
            # [ inline ( always ) ]
            pub fn err12(&mut self) -> _Err12W {
                _Err12W { w: self }
            }
            # [ doc = "Bit 13 - Error In Channel 13" ]
            # [ inline ( always ) ]
            pub fn err13(&mut self) -> _Err13W {
                _Err13W { w: self }
            }
            # [ doc = "Bit 14 - Error In Channel 14" ]
            # [ inline ( always ) ]
            pub fn err14(&mut self) -> _Err14W {
                _Err14W { w: self }
            }
            # [ doc = "Bit 15 - Error In Channel 15" ]
            # [ inline ( always ) ]
            pub fn err15(&mut self) -> _Err15W {
                _Err15W { w: self }
            }
        }
    }
    # [ doc = "Hardware Request Status Register" ]
    pub struct Hrs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Hardware Request Status Register" ]
    pub mod hrs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Hrs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `HRS0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs0R {
            # [ doc = "A hardware service request for channel 0 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 0 is present" ]
            _1,
        }
        impl Hrs0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs0R::_0 => 0,
                    Hrs0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs0R {
                match bits {
                    0 => Hrs0R::_0,
                    1 => Hrs0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs0R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs1R {
            # [ doc = "A hardware service request for channel 1 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 1 is present" ]
            _1,
        }
        impl Hrs1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs1R::_0 => 0,
                    Hrs1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs1R {
                match bits {
                    0 => Hrs1R::_0,
                    1 => Hrs1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs1R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs2R {
            # [ doc = "A hardware service request for channel 2 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 2 is present" ]
            _1,
        }
        impl Hrs2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs2R::_0 => 0,
                    Hrs2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs2R {
                match bits {
                    0 => Hrs2R::_0,
                    1 => Hrs2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs2R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs3R {
            # [ doc = "A hardware service request for channel 3 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 3 is present" ]
            _1,
        }
        impl Hrs3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs3R::_0 => 0,
                    Hrs3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs3R {
                match bits {
                    0 => Hrs3R::_0,
                    1 => Hrs3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs3R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs4R {
            # [ doc = "A hardware service request for channel 4 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 4 is present" ]
            _1,
        }
        impl Hrs4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs4R::_0 => 0,
                    Hrs4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs4R {
                match bits {
                    0 => Hrs4R::_0,
                    1 => Hrs4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs4R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs5R {
            # [ doc = "A hardware service request for channel 5 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 5 is present" ]
            _1,
        }
        impl Hrs5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs5R::_0 => 0,
                    Hrs5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs5R {
                match bits {
                    0 => Hrs5R::_0,
                    1 => Hrs5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs5R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs6R {
            # [ doc = "A hardware service request for channel 6 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 6 is present" ]
            _1,
        }
        impl Hrs6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs6R::_0 => 0,
                    Hrs6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs6R {
                match bits {
                    0 => Hrs6R::_0,
                    1 => Hrs6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs6R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs7R {
            # [ doc = "A hardware service request for channel 7 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 7 is present" ]
            _1,
        }
        impl Hrs7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs7R::_0 => 0,
                    Hrs7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs7R {
                match bits {
                    0 => Hrs7R::_0,
                    1 => Hrs7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs7R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs8R {
            # [ doc = "A hardware service request for channel 8 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 8 is present" ]
            _1,
        }
        impl Hrs8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs8R::_0 => 0,
                    Hrs8R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs8R {
                match bits {
                    0 => Hrs8R::_0,
                    1 => Hrs8R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs8R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs8R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs9R {
            # [ doc = "A hardware service request for channel 9 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 9 is present" ]
            _1,
        }
        impl Hrs9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs9R::_0 => 0,
                    Hrs9R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs9R {
                match bits {
                    0 => Hrs9R::_0,
                    1 => Hrs9R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs9R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs9R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs10R {
            # [ doc = "A hardware service request for channel 10 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 10 is present" ]
            _1,
        }
        impl Hrs10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs10R::_0 => 0,
                    Hrs10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs10R {
                match bits {
                    0 => Hrs10R::_0,
                    1 => Hrs10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs10R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs11R {
            # [ doc = "A hardware service request for channel 11 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 11 is present" ]
            _1,
        }
        impl Hrs11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs11R::_0 => 0,
                    Hrs11R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs11R {
                match bits {
                    0 => Hrs11R::_0,
                    1 => Hrs11R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs11R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs11R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs12R {
            # [ doc = "A hardware service request for channel 12 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 12 is present" ]
            _1,
        }
        impl Hrs12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs12R::_0 => 0,
                    Hrs12R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs12R {
                match bits {
                    0 => Hrs12R::_0,
                    1 => Hrs12R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs12R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs12R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs13R {
            # [ doc = "A hardware service request for channel 13 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 13 is present" ]
            _1,
        }
        impl Hrs13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs13R::_0 => 0,
                    Hrs13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs13R {
                match bits {
                    0 => Hrs13R::_0,
                    1 => Hrs13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs13R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs14R {
            # [ doc = "A hardware service request for channel 14 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 14 is present" ]
            _1,
        }
        impl Hrs14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs14R::_0 => 0,
                    Hrs14R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs14R {
                match bits {
                    0 => Hrs14R::_0,
                    1 => Hrs14R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs14R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs14R::_1
            }
        }
        # [ doc = "Possible values of the field `HRS15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Hrs15R {
            # [ doc = "A hardware service request for channel 15 is not present" ]
            _0,
            # [ doc = "A hardware service request for channel 15 is present" ]
            _1,
        }
        impl Hrs15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Hrs15R::_0 => 0,
                    Hrs15R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Hrs15R {
                match bits {
                    0 => Hrs15R::_0,
                    1 => Hrs15R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Hrs15R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Hrs15R::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Hardware Request Status Channel 0" ]
            # [ inline ( always ) ]
            pub fn hrs0(&self) -> Hrs0R {
                Hrs0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Hardware Request Status Channel 1" ]
            # [ inline ( always ) ]
            pub fn hrs1(&self) -> Hrs1R {
                Hrs1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Hardware Request Status Channel 2" ]
            # [ inline ( always ) ]
            pub fn hrs2(&self) -> Hrs2R {
                Hrs2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Hardware Request Status Channel 3" ]
            # [ inline ( always ) ]
            pub fn hrs3(&self) -> Hrs3R {
                Hrs3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Hardware Request Status Channel 4" ]
            # [ inline ( always ) ]
            pub fn hrs4(&self) -> Hrs4R {
                Hrs4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Hardware Request Status Channel 5" ]
            # [ inline ( always ) ]
            pub fn hrs5(&self) -> Hrs5R {
                Hrs5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Hardware Request Status Channel 6" ]
            # [ inline ( always ) ]
            pub fn hrs6(&self) -> Hrs6R {
                Hrs6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Hardware Request Status Channel 7" ]
            # [ inline ( always ) ]
            pub fn hrs7(&self) -> Hrs7R {
                Hrs7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Hardware Request Status Channel 8" ]
            # [ inline ( always ) ]
            pub fn hrs8(&self) -> Hrs8R {
                Hrs8R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Hardware Request Status Channel 9" ]
            # [ inline ( always ) ]
            pub fn hrs9(&self) -> Hrs9R {
                Hrs9R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Hardware Request Status Channel 10" ]
            # [ inline ( always ) ]
            pub fn hrs10(&self) -> Hrs10R {
                Hrs10R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 10;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 11 - Hardware Request Status Channel 11" ]
            # [ inline ( always ) ]
            pub fn hrs11(&self) -> Hrs11R {
                Hrs11R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 12 - Hardware Request Status Channel 12" ]
            # [ inline ( always ) ]
            pub fn hrs12(&self) -> Hrs12R {
                Hrs12R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Hardware Request Status Channel 13" ]
            # [ inline ( always ) ]
            pub fn hrs13(&self) -> Hrs13R {
                Hrs13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Hardware Request Status Channel 14" ]
            # [ inline ( always ) ]
            pub fn hrs14(&self) -> Hrs14R {
                Hrs14R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Hardware Request Status Channel 15" ]
            # [ inline ( always ) ]
            pub fn hrs15(&self) -> Hrs15R {
                Hrs15R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
    }
    # [ doc = "Enable Asynchronous Request in Stop Register" ]
    pub struct Ears {
        register: VolatileCell<u32>,
    }
    # [ doc = "Enable Asynchronous Request in Stop Register" ]
    pub mod ears {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ears {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EDREQ_0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq0R {
            # [ doc = "Disable asynchronous DMA request for channel 0." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 0." ]
            _1,
        }
        impl Edreq0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq0R::_0 => 0,
                    Edreq0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq0R {
                match bits {
                    0 => Edreq0R::_0,
                    1 => Edreq0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq0R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq1R {
            # [ doc = "Disable asynchronous DMA request for channel 1" ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 1." ]
            _1,
        }
        impl Edreq1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq1R::_0 => 0,
                    Edreq1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq1R {
                match bits {
                    0 => Edreq1R::_0,
                    1 => Edreq1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq1R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq2R {
            # [ doc = "Disable asynchronous DMA request for channel 2." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 2." ]
            _1,
        }
        impl Edreq2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq2R::_0 => 0,
                    Edreq2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq2R {
                match bits {
                    0 => Edreq2R::_0,
                    1 => Edreq2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq2R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq3R {
            # [ doc = "Disable asynchronous DMA request for channel 3." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 3." ]
            _1,
        }
        impl Edreq3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq3R::_0 => 0,
                    Edreq3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq3R {
                match bits {
                    0 => Edreq3R::_0,
                    1 => Edreq3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq3R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq4R {
            # [ doc = "Disable asynchronous DMA request for channel 4." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 4." ]
            _1,
        }
        impl Edreq4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq4R::_0 => 0,
                    Edreq4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq4R {
                match bits {
                    0 => Edreq4R::_0,
                    1 => Edreq4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq4R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq5R {
            # [ doc = "Disable asynchronous DMA request for channel 5." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 5." ]
            _1,
        }
        impl Edreq5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq5R::_0 => 0,
                    Edreq5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq5R {
                match bits {
                    0 => Edreq5R::_0,
                    1 => Edreq5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq5R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq6R {
            # [ doc = "Disable asynchronous DMA request for channel 6." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 6." ]
            _1,
        }
        impl Edreq6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq6R::_0 => 0,
                    Edreq6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq6R {
                match bits {
                    0 => Edreq6R::_0,
                    1 => Edreq6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq6R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq7R {
            # [ doc = "Disable asynchronous DMA request for channel 7." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 7." ]
            _1,
        }
        impl Edreq7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq7R::_0 => 0,
                    Edreq7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq7R {
                match bits {
                    0 => Edreq7R::_0,
                    1 => Edreq7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq7R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq8R {
            # [ doc = "Disable asynchronous DMA request for channel 8." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 8." ]
            _1,
        }
        impl Edreq8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq8R::_0 => 0,
                    Edreq8R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq8R {
                match bits {
                    0 => Edreq8R::_0,
                    1 => Edreq8R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq8R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq8R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq9R {
            # [ doc = "Disable asynchronous DMA request for channel 9." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 9." ]
            _1,
        }
        impl Edreq9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq9R::_0 => 0,
                    Edreq9R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq9R {
                match bits {
                    0 => Edreq9R::_0,
                    1 => Edreq9R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq9R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq9R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq10R {
            # [ doc = "Disable asynchronous DMA request for channel 10." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 10." ]
            _1,
        }
        impl Edreq10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq10R::_0 => 0,
                    Edreq10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq10R {
                match bits {
                    0 => Edreq10R::_0,
                    1 => Edreq10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq10R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq11R {
            # [ doc = "Disable asynchronous DMA request for channel 11." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 11." ]
            _1,
        }
        impl Edreq11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq11R::_0 => 0,
                    Edreq11R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq11R {
                match bits {
                    0 => Edreq11R::_0,
                    1 => Edreq11R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq11R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq11R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq12R {
            # [ doc = "Disable asynchronous DMA request for channel 12." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 12." ]
            _1,
        }
        impl Edreq12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq12R::_0 => 0,
                    Edreq12R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq12R {
                match bits {
                    0 => Edreq12R::_0,
                    1 => Edreq12R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq12R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq12R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq13R {
            # [ doc = "Disable asynchronous DMA request for channel 13." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 13." ]
            _1,
        }
        impl Edreq13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq13R::_0 => 0,
                    Edreq13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq13R {
                match bits {
                    0 => Edreq13R::_0,
                    1 => Edreq13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq13R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq14R {
            # [ doc = "Disable asynchronous DMA request for channel 14." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 14." ]
            _1,
        }
        impl Edreq14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq14R::_0 => 0,
                    Edreq14R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq14R {
                match bits {
                    0 => Edreq14R::_0,
                    1 => Edreq14R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq14R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq14R::_1
            }
        }
        # [ doc = "Possible values of the field `EDREQ_15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Edreq15R {
            # [ doc = "Disable asynchronous DMA request for channel 15." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 15." ]
            _1,
        }
        impl Edreq15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Edreq15R::_0 => 0,
                    Edreq15R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Edreq15R {
                match bits {
                    0 => Edreq15R::_0,
                    1 => Edreq15R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Edreq15R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Edreq15R::_1
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_0`" ]
        pub enum Edreq0W {
            # [ doc = "Disable asynchronous DMA request for channel 0." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 0." ]
            _1,
        }
        impl Edreq0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq0W::_0 => 0,
                    Edreq0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq0W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 0." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_1`" ]
        pub enum Edreq1W {
            # [ doc = "Disable asynchronous DMA request for channel 1" ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 1." ]
            _1,
        }
        impl Edreq1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq1W::_0 => 0,
                    Edreq1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq1W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_2`" ]
        pub enum Edreq2W {
            # [ doc = "Disable asynchronous DMA request for channel 2." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 2." ]
            _1,
        }
        impl Edreq2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq2W::_0 => 0,
                    Edreq2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 2." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq2W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 2." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_3`" ]
        pub enum Edreq3W {
            # [ doc = "Disable asynchronous DMA request for channel 3." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 3." ]
            _1,
        }
        impl Edreq3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq3W::_0 => 0,
                    Edreq3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 3." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq3W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 3." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_4`" ]
        pub enum Edreq4W {
            # [ doc = "Disable asynchronous DMA request for channel 4." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 4." ]
            _1,
        }
        impl Edreq4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq4W::_0 => 0,
                    Edreq4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 4." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq4W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 4." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_5`" ]
        pub enum Edreq5W {
            # [ doc = "Disable asynchronous DMA request for channel 5." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 5." ]
            _1,
        }
        impl Edreq5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq5W::_0 => 0,
                    Edreq5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 5." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq5W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 5." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_6`" ]
        pub enum Edreq6W {
            # [ doc = "Disable asynchronous DMA request for channel 6." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 6." ]
            _1,
        }
        impl Edreq6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq6W::_0 => 0,
                    Edreq6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 6." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq6W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 6." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_7`" ]
        pub enum Edreq7W {
            # [ doc = "Disable asynchronous DMA request for channel 7." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 7." ]
            _1,
        }
        impl Edreq7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq7W::_0 => 0,
                    Edreq7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 7." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq7W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 7." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_8`" ]
        pub enum Edreq8W {
            # [ doc = "Disable asynchronous DMA request for channel 8." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 8." ]
            _1,
        }
        impl Edreq8W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq8W::_0 => 0,
                    Edreq8W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq8W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq8W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 8." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq8W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 8." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq8W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_9`" ]
        pub enum Edreq9W {
            # [ doc = "Disable asynchronous DMA request for channel 9." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 9." ]
            _1,
        }
        impl Edreq9W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq9W::_0 => 0,
                    Edreq9W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq9W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq9W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 9." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq9W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 9." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq9W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_10`" ]
        pub enum Edreq10W {
            # [ doc = "Disable asynchronous DMA request for channel 10." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 10." ]
            _1,
        }
        impl Edreq10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq10W::_0 => 0,
                    Edreq10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 10." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq10W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 10." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_11`" ]
        pub enum Edreq11W {
            # [ doc = "Disable asynchronous DMA request for channel 11." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 11." ]
            _1,
        }
        impl Edreq11W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq11W::_0 => 0,
                    Edreq11W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq11W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq11W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 11." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq11W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 11." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq11W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_12`" ]
        pub enum Edreq12W {
            # [ doc = "Disable asynchronous DMA request for channel 12." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 12." ]
            _1,
        }
        impl Edreq12W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq12W::_0 => 0,
                    Edreq12W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq12W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq12W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 12." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq12W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 12." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq12W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_13`" ]
        pub enum Edreq13W {
            # [ doc = "Disable asynchronous DMA request for channel 13." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 13." ]
            _1,
        }
        impl Edreq13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq13W::_0 => 0,
                    Edreq13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 13." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq13W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 13." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_14`" ]
        pub enum Edreq14W {
            # [ doc = "Disable asynchronous DMA request for channel 14." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 14." ]
            _1,
        }
        impl Edreq14W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq14W::_0 => 0,
                    Edreq14W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq14W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq14W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 14." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq14W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 14." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq14W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EDREQ_15`" ]
        pub enum Edreq15W {
            # [ doc = "Disable asynchronous DMA request for channel 15." ]
            _0,
            # [ doc = "Enable asynchronous DMA request for channel 15." ]
            _1,
        }
        impl Edreq15W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Edreq15W::_0 => 0,
                    Edreq15W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Edreq15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Edreq15W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Edreq15W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable asynchronous DMA request for channel 15." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Edreq15W::_0)
            }
            # [ doc = "Enable asynchronous DMA request for channel 15." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Edreq15W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Enable asynchronous DMA request in stop mode for channel 0." ]
            # [ inline ( always ) ]
            pub fn edreq_0(&self) -> Edreq0R {
                Edreq0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Enable asynchronous DMA request in stop mode for channel 1." ]
            # [ inline ( always ) ]
            pub fn edreq_1(&self) -> Edreq1R {
                Edreq1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Enable asynchronous DMA request in stop mode for channel 2." ]
            # [ inline ( always ) ]
            pub fn edreq_2(&self) -> Edreq2R {
                Edreq2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Enable asynchronous DMA request in stop mode for channel 3." ]
            # [ inline ( always ) ]
            pub fn edreq_3(&self) -> Edreq3R {
                Edreq3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Enable asynchronous DMA request in stop mode for channel 4" ]
            # [ inline ( always ) ]
            pub fn edreq_4(&self) -> Edreq4R {
                Edreq4R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Enable asynchronous DMA request in stop mode for channel 5" ]
            # [ inline ( always ) ]
            pub fn edreq_5(&self) -> Edreq5R {
                Edreq5R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Enable asynchronous DMA request in stop mode for channel 6" ]
            # [ inline ( always ) ]
            pub fn edreq_6(&self) -> Edreq6R {
                Edreq6R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Enable asynchronous DMA request in stop mode for channel 7" ]
            # [ inline ( always ) ]
            pub fn edreq_7(&self) -> Edreq7R {
                Edreq7R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 8 - Enable asynchronous DMA request in stop mode for channel 8" ]
            # [ inline ( always ) ]
            pub fn edreq_8(&self) -> Edreq8R {
                Edreq8R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 9 - Enable asynchronous DMA request in stop mode for channel 9" ]
            # [ inline ( always ) ]
            pub fn edreq_9(&self) -> Edreq9R {
                Edreq9R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Enable asynchronous DMA request in stop mode for channel 10" ]
            # [ inline ( always ) ]
            pub fn edreq_10(&self) -> Edreq10R {
                Edreq10R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 10;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - Enable asynchronous DMA request in stop mode for channel 11" ]
            # [ inline ( always ) ]
            pub fn edreq_11(&self) -> Edreq11R {
                Edreq11R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 11;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 12 - Enable asynchronous DMA request in stop mode for channel 12" ]
            # [ inline ( always ) ]
            pub fn edreq_12(&self) -> Edreq12R {
                Edreq12R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 12;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 13 - Enable asynchronous DMA request in stop mode for channel 13" ]
            # [ inline ( always ) ]
            pub fn edreq_13(&self) -> Edreq13R {
                Edreq13R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Enable asynchronous DMA request in stop mode for channel 14" ]
            # [ inline ( always ) ]
            pub fn edreq_14(&self) -> Edreq14R {
                Edreq14R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Enable asynchronous DMA request in stop mode for channel 15" ]
            # [ inline ( always ) ]
            pub fn edreq_15(&self) -> Edreq15R {
                Edreq15R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Enable asynchronous DMA request in stop mode for channel 0." ]
            # [ inline ( always ) ]
            pub fn edreq_0(&mut self) -> _Edreq0W {
                _Edreq0W { w: self }
            }
            # [ doc = "Bit 1 - Enable asynchronous DMA request in stop mode for channel 1." ]
            # [ inline ( always ) ]
            pub fn edreq_1(&mut self) -> _Edreq1W {
                _Edreq1W { w: self }
            }
            # [ doc = "Bit 2 - Enable asynchronous DMA request in stop mode for channel 2." ]
            # [ inline ( always ) ]
            pub fn edreq_2(&mut self) -> _Edreq2W {
                _Edreq2W { w: self }
            }
            # [ doc = "Bit 3 - Enable asynchronous DMA request in stop mode for channel 3." ]
            # [ inline ( always ) ]
            pub fn edreq_3(&mut self) -> _Edreq3W {
                _Edreq3W { w: self }
            }
            # [ doc = "Bit 4 - Enable asynchronous DMA request in stop mode for channel 4" ]
            # [ inline ( always ) ]
            pub fn edreq_4(&mut self) -> _Edreq4W {
                _Edreq4W { w: self }
            }
            # [ doc = "Bit 5 - Enable asynchronous DMA request in stop mode for channel 5" ]
            # [ inline ( always ) ]
            pub fn edreq_5(&mut self) -> _Edreq5W {
                _Edreq5W { w: self }
            }
            # [ doc = "Bit 6 - Enable asynchronous DMA request in stop mode for channel 6" ]
            # [ inline ( always ) ]
            pub fn edreq_6(&mut self) -> _Edreq6W {
                _Edreq6W { w: self }
            }
            # [ doc = "Bit 7 - Enable asynchronous DMA request in stop mode for channel 7" ]
            # [ inline ( always ) ]
            pub fn edreq_7(&mut self) -> _Edreq7W {
                _Edreq7W { w: self }
            }
            # [ doc = "Bit 8 - Enable asynchronous DMA request in stop mode for channel 8" ]
            # [ inline ( always ) ]
            pub fn edreq_8(&mut self) -> _Edreq8W {
                _Edreq8W { w: self }
            }
            # [ doc = "Bit 9 - Enable asynchronous DMA request in stop mode for channel 9" ]
            # [ inline ( always ) ]
            pub fn edreq_9(&mut self) -> _Edreq9W {
                _Edreq9W { w: self }
            }
            # [ doc = "Bit 10 - Enable asynchronous DMA request in stop mode for channel 10" ]
            # [ inline ( always ) ]
            pub fn edreq_10(&mut self) -> _Edreq10W {
                _Edreq10W { w: self }
            }
            # [ doc = "Bit 11 - Enable asynchronous DMA request in stop mode for channel 11" ]
            # [ inline ( always ) ]
            pub fn edreq_11(&mut self) -> _Edreq11W {
                _Edreq11W { w: self }
            }
            # [ doc = "Bit 12 - Enable asynchronous DMA request in stop mode for channel 12" ]
            # [ inline ( always ) ]
            pub fn edreq_12(&mut self) -> _Edreq12W {
                _Edreq12W { w: self }
            }
            # [ doc = "Bit 13 - Enable asynchronous DMA request in stop mode for channel 13" ]
            # [ inline ( always ) ]
            pub fn edreq_13(&mut self) -> _Edreq13W {
                _Edreq13W { w: self }
            }
            # [ doc = "Bit 14 - Enable asynchronous DMA request in stop mode for channel 14" ]
            # [ inline ( always ) ]
            pub fn edreq_14(&mut self) -> _Edreq14W {
                _Edreq14W { w: self }
            }
            # [ doc = "Bit 15 - Enable asynchronous DMA request in stop mode for channel 15" ]
            # [ inline ( always ) ]
            pub fn edreq_15(&mut self) -> _Edreq15W {
                _Edreq15W { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri3 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri2 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri1 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri0 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri7 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 7 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri6 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 6 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri5 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 5 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri4 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri11 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 11 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri10 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 10 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri9 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 9 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri8 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 8 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri15 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 15 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri14 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 14 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri13 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 13 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "Channel n Priority Register" ]
    pub struct Dchpri12 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel n Priority Register" ]
    pub mod dchpri12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Dchpri12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChpriR {
            bits: u8,
        }
        impl ChpriR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DPA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpaR {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpaR::_0 => 0,
                    DpaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpaR {
                match bits {
                    0 => DpaR::_0,
                    1 => DpaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DpaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DpaR::_1
            }
        }
        # [ doc = "Possible values of the field `ECP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcpR {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcpR::_0 => 0,
                    EcpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcpR {
                match bits {
                    0 => EcpR::_0,
                    1 => EcpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcpR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChpriW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChpriW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DPA`" ]
        pub enum DpaW {
            # [ doc = "Channel n can suspend a lower priority channel." ]
            _0,
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            _1,
        }
        impl DpaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DpaW::_0 => 0,
                    DpaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DpaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DpaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DpaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n can suspend a lower priority channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DpaW::_0)
            }
            # [ doc = "Channel n cannot suspend any channel, regardless of channel priority." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DpaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECP`" ]
        pub enum EcpW {
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            _0,
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            _1,
        }
        impl EcpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcpW::_0 => 0,
                    EcpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel n cannot be suspended by a higher priority channel's service request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcpW::_0)
            }
            # [ doc = "Channel n can be temporarily suspended by the service request of a higher priority channel." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&self) -> ChpriR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ChpriR { bits }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&self) -> DpaR {
                DpaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&self) -> EcpR {
                EcpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel n Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn chpri(&mut self) -> _ChpriW {
                _ChpriW { w: self }
            }
            # [ doc = "Bit 6 - Disable Preempt Ability. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn dpa(&mut self) -> _DpaW {
                _DpaW { w: self }
            }
            # [ doc = "Bit 7 - Enable Channel Preemption. This field resets to 0." ]
            # [ inline ( always ) ]
            pub fn ecp(&mut self) -> _EcpW {
                _EcpW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd0Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd0_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd0Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd0_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd0Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd0_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd0NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd0_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd0NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd0_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd0NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd0_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd0Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd0_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd0Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd0_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd0Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd0_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd0CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd0_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd0CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd0_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd0Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd0_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd0Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd0Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd0_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd0BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd0_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd0BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd0_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd0BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd1Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd1_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd1Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd1_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd1Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd1_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd1NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd1_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd1NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd1_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd1NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd1_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd1Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd1_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd1Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd1_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd1Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd1_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd1CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd1_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd1CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd1_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd1Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd1_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd1Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd1Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd1_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd1BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd1_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd1BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd1_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd1BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd2Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd2_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd2Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd2_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd2Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd2_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd2NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd2_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd2NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd2_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd2NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd2_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd2Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd2_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd2Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd2_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd2Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd2_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd2CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd2_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd2CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd2_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd2Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd2_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd2Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd2Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd2_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd2BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd2_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd2BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd2_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd2BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd3Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd3_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd3Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd3_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd3Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd3_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd3NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd3_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd3NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd3_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd3NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd3_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd3Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd3_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd3Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd3_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd3Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd3_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd3CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd3_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd3CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd3_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd3Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd3_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd3Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd3Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd3_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd3BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd3_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd3BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd3_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd3BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd4Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd4_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd4Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd4_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd4Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd4_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd4NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd4_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd4NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd4_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd4NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd4_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd4Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd4_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd4Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd4_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd4Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd4_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd4CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd4_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd4CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd4_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd4Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd4_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd4Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd4Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd4_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd4BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd4_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd4BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd4_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd4BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd5Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd5_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd5Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd5_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd5Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd5_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd5NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd5_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd5NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd5_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd5NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd5_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd5Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd5_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd5Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd5_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd5Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd5_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd5CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd5_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd5CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd5_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd5Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd5_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd5Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd5Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd5_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd5BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd5_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd5BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd5_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd5BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd6Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd6_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd6Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd6_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd6Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd6_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd6NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd6_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd6NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd6_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd6NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd6_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd6Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd6_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd6Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd6_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd6Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd6_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd6CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd6_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd6CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd6_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd6Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd6_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd6Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd6Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd6_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd6BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd6_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd6BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd6_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd6BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd7Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd7_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd7Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd7_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd7Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd7_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd7NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd7_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd7NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd7_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd7NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd7_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd7Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd7_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd7Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd7_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd7Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd7_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd7CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd7_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd7CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd7_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd7Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd7_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd7Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd7Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd7_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd7BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd7_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd7BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd7_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd7BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd8Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd8_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd8Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd8_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd8Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd8_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd8NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd8_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd8NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd8_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd8NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd8_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd8Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd8_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd8Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd8_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd8Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd8_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd8CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd8_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd8CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd8_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd8Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd8_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd8Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd8Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd8_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd8BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd8_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd8BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd8_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd8BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd9Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd9_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd9Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd9_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd9Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd9_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd9NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd9_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd9NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd9_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd9NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd9_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd9Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd9_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd9Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd9_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd9Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd9_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd9CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd9_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd9CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd9_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd9Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd9_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd9Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd9Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd9_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd9BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd9_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd9BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd9_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd9BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd10Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd10_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd10Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd10_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd10Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd10_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd10NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd10_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd10NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd10_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd10NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd10_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd10Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd10_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd10Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd10_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd10Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd10_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd10CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd10_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd10CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd10_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd10Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd10_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd10Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd10Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd10_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd10BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd10_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd10BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd10_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd10BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd11Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd11_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd11Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd11_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd11Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd11_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd11NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd11_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd11NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd11_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd11NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd11_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd11Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd11_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd11Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd11_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd11Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd11_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd11CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd11_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd11CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd11_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd11Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd11_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd11Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd11Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd11_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd11BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd11_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd11BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd11_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd11BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd12Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd12_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd12Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd12_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd12Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd12_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd12NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd12_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd12NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd12_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd12NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd12_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd12Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd12_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd12Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd12_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd12Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd12_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd12CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd12_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd12CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd12_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd12Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd12_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd12Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd12Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd12_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd12BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd12_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd12BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd12_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd12BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd13Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd13_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd13Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd13_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd13Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd13_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd13NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd13_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd13NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd13_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd13NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd13_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd13Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd13_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd13Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd13_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd13Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd13_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd13CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd13_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd13CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd13_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd13Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd13_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd13Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd13Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd13_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd13BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd13_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd13BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd13_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd13BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd14Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd14_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd14Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd14_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd14Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd14_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd14NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd14_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd14NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd14_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd14NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd14_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd14Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd14_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd14Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd14_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd14Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd14_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd14CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd14_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd14CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd14_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd14Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd14_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd14Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd14Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd14_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd14BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd14_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd14BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd14_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd14BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Source Address" ]
    pub struct Tcd15Saddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Source Address" ]
    pub mod tcd15_saddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15Saddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SaddrR {
            bits: u32,
        }
        impl SaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&self) -> SaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Source Address" ]
            # [ inline ( always ) ]
            pub fn saddr(&mut self) -> _SaddrW {
                _SaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub struct Tcd15Soff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Source Address Offset" ]
    pub mod tcd15_soff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15Soff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SoffR {
            bits: u16,
        }
        impl SoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&self) -> SoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                SoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Source address signed offset" ]
            # [ inline ( always ) ]
            pub fn soff(&mut self) -> _SoffW {
                _SoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub struct Tcd15Attr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Transfer Attributes" ]
    pub mod tcd15_attr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15Attr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DsizeR {
            bits: u8,
        }
        impl DsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DmodR {
            bits: u8,
        }
        impl DmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsizeR {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsizeR::_0 => 0,
                    SsizeR::_1 => 1,
                    SsizeR::_10 => 2,
                    SsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsizeR {
                match bits {
                    0 => SsizeR::_0,
                    1 => SsizeR::_1,
                    2 => SsizeR::_10,
                    i => SsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsizeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsizeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SsizeR::_10
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DsizeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmodW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSIZE`" ]
        pub enum SsizeW {
            # [ doc = "8-bit" ]
            _0,
            # [ doc = "16-bit" ]
            _1,
            # [ doc = "32-bit" ]
            _10,
        }
        impl SsizeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsizeW::_0 => 0,
                    SsizeW::_1 => 1,
                    SsizeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsizeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsizeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsizeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsizeW::_0)
            }
            # [ doc = "16-bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsizeW::_1)
            }
            # [ doc = "32-bit" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SsizeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Source address modulo feature is disabled" ]
            _0,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Source address modulo feature is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&self) -> DsizeR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DsizeR { bits }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&self) -> DmodR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DmodR { bits }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&self) -> SsizeR {
                SsizeR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u16) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Destination data transfer size" ]
            # [ inline ( always ) ]
            pub fn dsize(&mut self) -> _DsizeW {
                _DsizeW { w: self }
            }
            # [ doc = "Bits 3:7 - Destination Address Modulo" ]
            # [ inline ( always ) ]
            pub fn dmod(&mut self) -> _DmodW {
                _DmodW { w: self }
            }
            # [ doc = "Bits 8:10 - Source data transfer size" ]
            # [ inline ( always ) ]
            pub fn ssize(&mut self) -> _SsizeW {
                _SsizeW { w: self }
            }
            # [ doc = "Bits 11:15 - Source Address Modulo" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
        }
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub struct Tcd15NbytesMlno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Minor Byte Count (Minor Loop Mapping Disabled)" ]
    pub mod tcd15_nbytes_mlno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15NbytesMlno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub struct Tcd15NbytesMloffno {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping Enabled and Offset Disabled)" ]
    pub mod tcd15_nbytes_mloffno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15NbytesMloffno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u32,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                NbytesR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:29 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub struct Tcd15NbytesMloffyes {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Signed Minor Loop Offset (Minor Loop Mapping and Offset Enabled)" ]
    pub mod tcd15_nbytes_mloffyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15NbytesMloffyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct NbytesR {
            bits: u16,
        }
        impl NbytesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MloffR {
            bits: u32,
        }
        impl MloffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmloeR {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmloeR::_0 => 0,
                    DmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmloeR {
                match bits {
                    0 => DmloeR::_0,
                    1 => DmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmloeR::_1
            }
        }
        # [ doc = "Possible values of the field `SMLOE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmloeR {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmloeR::_0 => 0,
                    SmloeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmloeR {
                match bits {
                    0 => SmloeR::_0,
                    1 => SmloeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmloeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmloeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NbytesW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NbytesW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MloffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MloffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1048575;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMLOE`" ]
        pub enum DmloeW {
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            _1,
        }
        impl DmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmloeW::_0 => 0,
                    DmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the DADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMLOE`" ]
        pub enum SmloeW {
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            _0,
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            _1,
        }
        impl SmloeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmloeW::_0 => 0,
                    SmloeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmloeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmloeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmloeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minor loop offset is not applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmloeW::_0)
            }
            # [ doc = "The minor loop offset is applied to the SADDR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmloeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&self) -> NbytesR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                NbytesR { bits }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&self) -> MloffR {
                let bits = {
                    const MASK: u32 = 1048575;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MloffR { bits }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&self) -> DmloeR {
                DmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&self) -> SmloeR {
                SmloeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Minor Byte Transfer Count" ]
            # [ inline ( always ) ]
            pub fn nbytes(&mut self) -> _NbytesW {
                _NbytesW { w: self }
            }
            # [ doc = "Bits 10:29 - If SMLOE or DMLOE is set, this field represents a sign-extended offset applied to the source or destination address to form the next-state value after the minor loop completes." ]
            # [ inline ( always ) ]
            pub fn mloff(&mut self) -> _MloffW {
                _MloffW { w: self }
            }
            # [ doc = "Bit 30 - Destination Minor Loop Offset enable" ]
            # [ inline ( always ) ]
            pub fn dmloe(&mut self) -> _DmloeW {
                _DmloeW { w: self }
            }
            # [ doc = "Bit 31 - Source Minor Loop Offset Enable" ]
            # [ inline ( always ) ]
            pub fn smloe(&mut self) -> _SmloeW {
                _SmloeW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub struct Tcd15Slast {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Source Address Adjustment" ]
    pub mod tcd15_slast {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15Slast {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SlastR {
            bits: u32,
        }
        impl SlastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&self) -> SlastR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                SlastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Last Source Address Adjustment" ]
            # [ inline ( always ) ]
            pub fn slast(&mut self) -> _SlastW {
                _SlastW { w: self }
            }
        }
    }
    # [ doc = "TCD Destination Address" ]
    pub struct Tcd15Daddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Destination Address" ]
    pub mod tcd15_daddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15Daddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DaddrR {
            bits: u32,
        }
        impl DaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&self) -> DaddrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Destination Address" ]
            # [ inline ( always ) ]
            pub fn daddr(&mut self) -> _DaddrW {
                _DaddrW { w: self }
            }
        }
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub struct Tcd15Doff {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Signed Destination Address Offset" ]
    pub mod tcd15_doff {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15Doff {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoffR {
            bits: u16,
        }
        impl DoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&self) -> DoffR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DoffR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Destination Address Signed Offset" ]
            # [ inline ( always ) ]
            pub fn doff(&mut self) -> _DoffW {
                _DoffW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd15CiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd15_citer_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15CiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterR {
            bits: u16,
        }
        impl CiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&self) -> CiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer(&mut self) -> _CiterW {
                _CiterW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd15CiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Current Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd15_citer_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15CiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CiterLeR {
            bits: u16,
        }
        impl CiterLeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CiterLeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CiterLeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&self) -> CiterLeR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                CiterLeR { bits }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Current Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn citer_le(&mut self) -> _CiterLeW {
                _CiterLeW { w: self }
            }
            # [ doc = "Bits 9:12 - Minor Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enable channel-to-channel linking on minor-loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub struct Tcd15Dlastsga {
        register: VolatileCell<u32>,
    }
    # [ doc = "TCD Last Destination Address Adjustment/Scatter Gather Address" ]
    pub mod tcd15_dlastsga {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcd15Dlastsga {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlastsgaR {
            bits: u32,
        }
        impl DlastsgaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlastsgaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlastsgaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&self) -> DlastsgaR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DlastsgaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - DLASTSGA" ]
            # [ inline ( always ) ]
            pub fn dlastsga(&mut self) -> _DlastsgaW {
                _DlastsgaW { w: self }
            }
        }
    }
    # [ doc = "TCD Control and Status" ]
    pub struct Tcd15Csr {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Control and Status" ]
    pub mod tcd15_csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `START`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StartR {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StartR::_0 => 0,
                    StartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StartR {
                match bits {
                    0 => StartR::_0,
                    1 => StartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StartR::_1
            }
        }
        # [ doc = "Possible values of the field `INTMAJOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntmajorR {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntmajorR::_0 => 0,
                    IntmajorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntmajorR {
                match bits {
                    0 => IntmajorR::_0,
                    1 => IntmajorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntmajorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntmajorR::_1
            }
        }
        # [ doc = "Possible values of the field `INTHALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InthalfR {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InthalfR::_0 => 0,
                    InthalfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InthalfR {
                match bits {
                    0 => InthalfR::_0,
                    1 => InthalfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InthalfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InthalfR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DreqR {
            bits: u8,
        }
        impl DreqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ESG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsgR {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsgR::_0 => 0,
                    EsgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsgR {
                match bits {
                    0 => EsgR::_0,
                    1 => EsgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsgR::_1
            }
        }
        # [ doc = "Possible values of the field `MAJORELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MajorelinkR {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MajorelinkR::_0 => 0,
                    MajorelinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MajorelinkR {
                match bits {
                    0 => MajorelinkR::_0,
                    1 => MajorelinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MajorelinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MajorelinkR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ActiveR {
            bits: u8,
        }
        impl ActiveR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DoneR {
            bits: u8,
        }
        impl DoneR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorlinkchR {
            bits: u8,
        }
        impl MajorlinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BWC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BwcR {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BwcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BwcR::_0 => 0,
                    BwcR::_10 => 2,
                    BwcR::_11 => 3,
                    BwcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BwcR {
                match bits {
                    0 => BwcR::_0,
                    2 => BwcR::_10,
                    3 => BwcR::_11,
                    i => BwcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BwcR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == BwcR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == BwcR::_11
            }
        }
        # [ doc = "Values that can be written to the field `START`" ]
        pub enum StartW {
            # [ doc = "The channel is not explicitly started." ]
            _0,
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            _1,
        }
        impl StartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StartW::_0 => 0,
                    StartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel is not explicitly started." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StartW::_0)
            }
            # [ doc = "The channel is explicitly started via a software initiated service request." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTMAJOR`" ]
        pub enum IntmajorW {
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            _0,
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            _1,
        }
        impl IntmajorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntmajorW::_0 => 0,
                    IntmajorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntmajorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntmajorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntmajorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The end-of-major loop interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntmajorW::_0)
            }
            # [ doc = "The end-of-major loop interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntmajorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INTHALF`" ]
        pub enum InthalfW {
            # [ doc = "The half-point interrupt is disabled." ]
            _0,
            # [ doc = "The half-point interrupt is enabled." ]
            _1,
        }
        impl InthalfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InthalfW::_0 => 0,
                    InthalfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InthalfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InthalfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InthalfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The half-point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InthalfW::_0)
            }
            # [ doc = "The half-point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InthalfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DreqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DreqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESG`" ]
        pub enum EsgW {
            # [ doc = "The current channel's TCD is normal format." ]
            _0,
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            _1,
        }
        impl EsgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EsgW::_0 => 0,
                    EsgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EsgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EsgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EsgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The current channel's TCD is normal format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EsgW::_0)
            }
            # [ doc = "The current channel's TCD specifies a scatter gather format. The DLASTSGA field provides a memory pointer to the next TCD to be loaded into this channel after the major loop completes its execution." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EsgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAJORELINK`" ]
        pub enum MajorelinkW {
            # [ doc = "The channel-to-channel linking is disabled." ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled." ]
            _1,
        }
        impl MajorelinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MajorelinkW::_0 => 0,
                    MajorelinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorelinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorelinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MajorelinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MajorelinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MajorelinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ActiveW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ActiveW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DoneW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DoneW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MajorlinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MajorlinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BWC`" ]
        pub enum BwcW {
            # [ doc = "No eDMA engine stalls." ]
            _0,
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            _10,
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            _11,
        }
        impl BwcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BwcW::_0 => 0,
                    BwcW::_10 => 2,
                    BwcW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BwcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BwcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BwcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No eDMA engine stalls." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BwcW::_0)
            }
            # [ doc = "eDMA engine stalls for 4 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(BwcW::_10)
            }
            # [ doc = "eDMA engine stalls for 8 cycles after each R/W." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(BwcW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&self) -> StartR {
                StartR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&self) -> IntmajorR {
                IntmajorR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u16) as u8
                                 })
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&self) -> InthalfR {
                InthalfR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u16) as u8
                                })
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&self) -> DreqR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DreqR { bits }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&self) -> EsgR {
                EsgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&self) -> MajorelinkR {
                MajorelinkR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 5;
                                       ((self.bits >> OFFSET) & MASK as u16) as u8
                                   })
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&self) -> ActiveR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                ActiveR { bits }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&self) -> DoneR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                DoneR { bits }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&self) -> MajorlinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                MajorlinkchR { bits }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&self) -> BwcR {
                BwcR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel Start" ]
            # [ inline ( always ) ]
            pub fn start(&mut self) -> _StartW {
                _StartW { w: self }
            }
            # [ doc = "Bit 1 - Enable an interrupt when major iteration count completes." ]
            # [ inline ( always ) ]
            pub fn intmajor(&mut self) -> _IntmajorW {
                _IntmajorW { w: self }
            }
            # [ doc = "Bit 2 - Enable an interrupt when major counter is half complete." ]
            # [ inline ( always ) ]
            pub fn inthalf(&mut self) -> _InthalfW {
                _InthalfW { w: self }
            }
            # [ doc = "Bit 3 - Disable Request" ]
            # [ inline ( always ) ]
            pub fn dreq(&mut self) -> _DreqW {
                _DreqW { w: self }
            }
            # [ doc = "Bit 4 - Enable Scatter/Gather Processing" ]
            # [ inline ( always ) ]
            pub fn esg(&mut self) -> _EsgW {
                _EsgW { w: self }
            }
            # [ doc = "Bit 5 - Enable channel-to-channel linking on major loop complete" ]
            # [ inline ( always ) ]
            pub fn majorelink(&mut self) -> _MajorelinkW {
                _MajorelinkW { w: self }
            }
            # [ doc = "Bit 6 - Channel Active" ]
            # [ inline ( always ) ]
            pub fn active(&mut self) -> _ActiveW {
                _ActiveW { w: self }
            }
            # [ doc = "Bit 7 - Channel Done" ]
            # [ inline ( always ) ]
            pub fn done(&mut self) -> _DoneW {
                _DoneW { w: self }
            }
            # [ doc = "Bits 8:11 - Major Loop Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn majorlinkch(&mut self) -> _MajorlinkchW {
                _MajorlinkchW { w: self }
            }
            # [ doc = "Bits 14:15 - Bandwidth Control" ]
            # [ inline ( always ) ]
            pub fn bwc(&mut self) -> _BwcW {
                _BwcW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub struct Tcd15BiterElinkno {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Disabled)" ]
    pub mod tcd15_biter_elinkno {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15BiterElinkno {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 32767;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:14 - Starting Major Iteration Count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub struct Tcd15BiterElinkyes {
        register: VolatileCell<u16>,
    }
    # [ doc = "TCD Beginning Minor Loop Link, Major Loop Count (Channel Linking Enabled)" ]
    pub mod tcd15_biter_elinkyes {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Tcd15BiterElinkyes {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BiterR {
            bits: u16,
        }
        impl BiterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LinkchR {
            bits: u8,
        }
        impl LinkchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ELINK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElinkR {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElinkR::_0 => 0,
                    ElinkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElinkR {
                match bits {
                    0 => ElinkR::_0,
                    1 => ElinkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElinkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElinkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LinkchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LinkchW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ELINK`" ]
        pub enum ElinkW {
            # [ doc = "The channel-to-channel linking is disabled" ]
            _0,
            # [ doc = "The channel-to-channel linking is enabled" ]
            _1,
        }
        impl ElinkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ElinkW::_0 => 0,
                    ElinkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElinkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElinkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ElinkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel-to-channel linking is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ElinkW::_0)
            }
            # [ doc = "The channel-to-channel linking is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ElinkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&self) -> BiterR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                BiterR { bits }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&self) -> LinkchR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u16) as u8
                };
                LinkchR { bits }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&self) -> ElinkR {
                ElinkR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u16) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Starting major iteration count" ]
            # [ inline ( always ) ]
            pub fn biter(&mut self) -> _BiterW {
                _BiterW { w: self }
            }
            # [ doc = "Bits 9:12 - Link Channel Number" ]
            # [ inline ( always ) ]
            pub fn linkch(&mut self) -> _LinkchW {
                _LinkchW { w: self }
            }
            # [ doc = "Bit 15 - Enables channel-to-channel linking on minor loop complete" ]
            # [ inline ( always ) ]
            pub fn elink(&mut self) -> _ElinkW {
                _ElinkW { w: self }
            }
        }
    }
}
# [ doc = "Enhanced Direct Memory Access" ]
pub struct Dma {
    register_block: dma::RegisterBlock,
}
impl Deref for Dma {
    type Target = dma::RegisterBlock;
    fn deref(&self) -> &dma::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "ERM" ]
pub const ERM: Peripheral<Erm> = unsafe { Peripheral::new(1073840128) };
# [ doc = "ERM" ]
pub mod erm {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - ERM Configuration Register 0" ]
        pub cr0: Cr0,
        _reserved0: [u8; 12usize],
        # [ doc = "0x10 - ERM Status Register 0" ]
        pub sr0: Sr0,
        _reserved1: [u8; 236usize],
        # [ doc = "0x100 - ERM Memory n Error Address Register" ]
        pub ear0: Ear0,
        _reserved2: [u8; 12usize],
        # [ doc = "0x110 - ERM Memory n Error Address Register" ]
        pub ear1: Ear1,
    }
    # [ doc = "ERM Configuration Register 0" ]
    pub struct Cr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ERM Configuration Register 0" ]
    pub mod cr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ENCIE1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Encie1R {
            # [ doc = "Interrupt notification of Memory 1 non-correctable error events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 1 non-correctable error events is enabled." ]
            _1,
        }
        impl Encie1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Encie1R::_0 => 0,
                    Encie1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Encie1R {
                match bits {
                    0 => Encie1R::_0,
                    1 => Encie1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Encie1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Encie1R::_1
            }
        }
        # [ doc = "Possible values of the field `ESCIE1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Escie1R {
            # [ doc = "Interrupt notification of Memory 1 single-bit correction events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 1 single-bit correction events is enabled." ]
            _1,
        }
        impl Escie1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Escie1R::_0 => 0,
                    Escie1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Escie1R {
                match bits {
                    0 => Escie1R::_0,
                    1 => Escie1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Escie1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Escie1R::_1
            }
        }
        # [ doc = "Possible values of the field `ENCIE0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Encie0R {
            # [ doc = "Interrupt notification of Memory 0 non-correctable error events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 0 non-correctable error events is enabled." ]
            _1,
        }
        impl Encie0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Encie0R::_0 => 0,
                    Encie0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Encie0R {
                match bits {
                    0 => Encie0R::_0,
                    1 => Encie0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Encie0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Encie0R::_1
            }
        }
        # [ doc = "Possible values of the field `ESCIE0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Escie0R {
            # [ doc = "Interrupt notification of Memory 0 single-bit correction events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 0 single-bit correction events is enabled." ]
            _1,
        }
        impl Escie0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Escie0R::_0 => 0,
                    Escie0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Escie0R {
                match bits {
                    0 => Escie0R::_0,
                    1 => Escie0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Escie0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Escie0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `ENCIE1`" ]
        pub enum Encie1W {
            # [ doc = "Interrupt notification of Memory 1 non-correctable error events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 1 non-correctable error events is enabled." ]
            _1,
        }
        impl Encie1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Encie1W::_0 => 0,
                    Encie1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Encie1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Encie1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Encie1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt notification of Memory 1 non-correctable error events is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Encie1W::_0)
            }
            # [ doc = "Interrupt notification of Memory 1 non-correctable error events is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Encie1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESCIE1`" ]
        pub enum Escie1W {
            # [ doc = "Interrupt notification of Memory 1 single-bit correction events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 1 single-bit correction events is enabled." ]
            _1,
        }
        impl Escie1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Escie1W::_0 => 0,
                    Escie1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Escie1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Escie1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Escie1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt notification of Memory 1 single-bit correction events is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Escie1W::_0)
            }
            # [ doc = "Interrupt notification of Memory 1 single-bit correction events is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Escie1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENCIE0`" ]
        pub enum Encie0W {
            # [ doc = "Interrupt notification of Memory 0 non-correctable error events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 0 non-correctable error events is enabled." ]
            _1,
        }
        impl Encie0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Encie0W::_0 => 0,
                    Encie0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Encie0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Encie0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Encie0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt notification of Memory 0 non-correctable error events is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Encie0W::_0)
            }
            # [ doc = "Interrupt notification of Memory 0 non-correctable error events is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Encie0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ESCIE0`" ]
        pub enum Escie0W {
            # [ doc = "Interrupt notification of Memory 0 single-bit correction events is disabled." ]
            _0,
            # [ doc = "Interrupt notification of Memory 0 single-bit correction events is enabled." ]
            _1,
        }
        impl Escie0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Escie0W::_0 => 0,
                    Escie0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Escie0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Escie0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Escie0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt notification of Memory 0 single-bit correction events is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Escie0W::_0)
            }
            # [ doc = "Interrupt notification of Memory 0 single-bit correction events is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Escie0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 26 - ENCIE1" ]
            # [ inline ( always ) ]
            pub fn encie1(&self) -> Encie1R {
                Encie1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 26;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 27 - ESCIE1" ]
            # [ inline ( always ) ]
            pub fn escie1(&self) -> Escie1R {
                Escie1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ENCIE0" ]
            # [ inline ( always ) ]
            pub fn encie0(&self) -> Encie0R {
                Encie0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - ESCIE0" ]
            # [ inline ( always ) ]
            pub fn escie0(&self) -> Escie0R {
                Escie0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 26 - ENCIE1" ]
            # [ inline ( always ) ]
            pub fn encie1(&mut self) -> _Encie1W {
                _Encie1W { w: self }
            }
            # [ doc = "Bit 27 - ESCIE1" ]
            # [ inline ( always ) ]
            pub fn escie1(&mut self) -> _Escie1W {
                _Escie1W { w: self }
            }
            # [ doc = "Bit 30 - ENCIE0" ]
            # [ inline ( always ) ]
            pub fn encie0(&mut self) -> _Encie0W {
                _Encie0W { w: self }
            }
            # [ doc = "Bit 31 - ESCIE0" ]
            # [ inline ( always ) ]
            pub fn escie0(&mut self) -> _Escie0W {
                _Escie0W { w: self }
            }
        }
    }
    # [ doc = "ERM Status Register 0" ]
    pub struct Sr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ERM Status Register 0" ]
    pub mod sr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `NCE1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Nce1R {
            # [ doc = "No non-correctable error event on Memory 1 detected" ]
            _0,
            # [ doc = "Non-correctable error event on Memory 1 detected" ]
            _1,
        }
        impl Nce1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Nce1R::_0 => 0,
                    Nce1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Nce1R {
                match bits {
                    0 => Nce1R::_0,
                    1 => Nce1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Nce1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Nce1R::_1
            }
        }
        # [ doc = "Possible values of the field `SBC1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sbc1R {
            # [ doc = "No single-bit correction event on Memory 1 detected" ]
            _0,
            # [ doc = "Single-bit correction event on Memory 1 detected" ]
            _1,
        }
        impl Sbc1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sbc1R::_0 => 0,
                    Sbc1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sbc1R {
                match bits {
                    0 => Sbc1R::_0,
                    1 => Sbc1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sbc1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sbc1R::_1
            }
        }
        # [ doc = "Possible values of the field `NCE0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Nce0R {
            # [ doc = "No non-correctable error event on Memory 0 detected" ]
            _0,
            # [ doc = "Non-correctable error event on Memory 0 detected" ]
            _1,
        }
        impl Nce0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Nce0R::_0 => 0,
                    Nce0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Nce0R {
                match bits {
                    0 => Nce0R::_0,
                    1 => Nce0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Nce0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Nce0R::_1
            }
        }
        # [ doc = "Possible values of the field `SBC0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sbc0R {
            # [ doc = "No single-bit correction event on Memory 0 detected" ]
            _0,
            # [ doc = "Single-bit correction event on Memory 0 detected" ]
            _1,
        }
        impl Sbc0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sbc0R::_0 => 0,
                    Sbc0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sbc0R {
                match bits {
                    0 => Sbc0R::_0,
                    1 => Sbc0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Sbc0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Sbc0R::_1
            }
        }
        # [ doc = "Values that can be written to the field `NCE1`" ]
        pub enum Nce1W {
            # [ doc = "No non-correctable error event on Memory 1 detected" ]
            _0,
            # [ doc = "Non-correctable error event on Memory 1 detected" ]
            _1,
        }
        impl Nce1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Nce1W::_0 => 0,
                    Nce1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Nce1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Nce1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Nce1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No non-correctable error event on Memory 1 detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Nce1W::_0)
            }
            # [ doc = "Non-correctable error event on Memory 1 detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Nce1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBC1`" ]
        pub enum Sbc1W {
            # [ doc = "No single-bit correction event on Memory 1 detected" ]
            _0,
            # [ doc = "Single-bit correction event on Memory 1 detected" ]
            _1,
        }
        impl Sbc1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sbc1W::_0 => 0,
                    Sbc1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sbc1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sbc1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sbc1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No single-bit correction event on Memory 1 detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sbc1W::_0)
            }
            # [ doc = "Single-bit correction event on Memory 1 detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sbc1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NCE0`" ]
        pub enum Nce0W {
            # [ doc = "No non-correctable error event on Memory 0 detected" ]
            _0,
            # [ doc = "Non-correctable error event on Memory 0 detected" ]
            _1,
        }
        impl Nce0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Nce0W::_0 => 0,
                    Nce0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Nce0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Nce0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Nce0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No non-correctable error event on Memory 0 detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Nce0W::_0)
            }
            # [ doc = "Non-correctable error event on Memory 0 detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Nce0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBC0`" ]
        pub enum Sbc0W {
            # [ doc = "No single-bit correction event on Memory 0 detected" ]
            _0,
            # [ doc = "Single-bit correction event on Memory 0 detected" ]
            _1,
        }
        impl Sbc0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sbc0W::_0 => 0,
                    Sbc0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sbc0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sbc0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sbc0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No single-bit correction event on Memory 0 detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Sbc0W::_0)
            }
            # [ doc = "Single-bit correction event on Memory 0 detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Sbc0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 26 - NCE1" ]
            # [ inline ( always ) ]
            pub fn nce1(&self) -> Nce1R {
                Nce1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 26;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 27 - SBC1" ]
            # [ inline ( always ) ]
            pub fn sbc1(&self) -> Sbc1R {
                Sbc1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 27;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - NCE0" ]
            # [ inline ( always ) ]
            pub fn nce0(&self) -> Nce0R {
                Nce0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 31 - SBC0" ]
            # [ inline ( always ) ]
            pub fn sbc0(&self) -> Sbc0R {
                Sbc0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 26 - NCE1" ]
            # [ inline ( always ) ]
            pub fn nce1(&mut self) -> _Nce1W {
                _Nce1W { w: self }
            }
            # [ doc = "Bit 27 - SBC1" ]
            # [ inline ( always ) ]
            pub fn sbc1(&mut self) -> _Sbc1W {
                _Sbc1W { w: self }
            }
            # [ doc = "Bit 30 - NCE0" ]
            # [ inline ( always ) ]
            pub fn nce0(&mut self) -> _Nce0W {
                _Nce0W { w: self }
            }
            # [ doc = "Bit 31 - SBC0" ]
            # [ inline ( always ) ]
            pub fn sbc0(&mut self) -> _Sbc0W {
                _Sbc0W { w: self }
            }
        }
    }
    # [ doc = "ERM Memory n Error Address Register" ]
    pub struct Ear0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ERM Memory n Error Address Register" ]
    pub mod ear0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Ear0 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EarR {
            bits: u32,
        }
        impl EarR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - EAR" ]
            # [ inline ( always ) ]
            pub fn ear(&self) -> EarR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                EarR { bits }
            }
        }
    }
    # [ doc = "ERM Memory n Error Address Register" ]
    pub struct Ear1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ERM Memory n Error Address Register" ]
    pub mod ear1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Ear1 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EarR {
            bits: u32,
        }
        impl EarR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - EAR" ]
            # [ inline ( always ) ]
            pub fn ear(&self) -> EarR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                EarR { bits }
            }
        }
    }
}
# [ doc = "ERM" ]
pub struct Erm {
    register_block: erm::RegisterBlock,
}
impl Deref for Erm {
    type Target = erm::RegisterBlock;
    fn deref(&self) -> &erm::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Error Injection Module" ]
pub const EIM: Peripheral<Eim> = unsafe { Peripheral::new(1073844224) };
# [ doc = "Error Injection Module" ]
pub mod eim {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Error Injection Module Configuration Register" ]
        pub eimcr: Eimcr,
        # [ doc = "0x04 - Error Injection Channel Enable register" ]
        pub eichen: Eichen,
        _reserved0: [u8; 248usize],
        # [ doc = "0x100 - Error Injection Channel Descriptor n, Word0" ]
        pub eichd0_word0: Eichd0Word0,
        # [ doc = "0x104 - Error Injection Channel Descriptor n, Word1" ]
        pub eichd0_word1: Eichd0Word1,
        _reserved1: [u8; 248usize],
        # [ doc = "0x200 - Error Injection Channel Descriptor n, Word0" ]
        pub eichd1_word0: Eichd1Word0,
        # [ doc = "0x204 - Error Injection Channel Descriptor n, Word1" ]
        pub eichd1_word1: Eichd1Word1,
    }
    # [ doc = "Error Injection Module Configuration Register" ]
    pub struct Eimcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Injection Module Configuration Register" ]
    pub mod eimcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eimcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `GEIEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GeienR {
            # [ doc = "Disabled" ]
            _0,
            # [ doc = "Enabled" ]
            _1,
        }
        impl GeienR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GeienR::_0 => 0,
                    GeienR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GeienR {
                match bits {
                    0 => GeienR::_0,
                    1 => GeienR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GeienR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GeienR::_1
            }
        }
        # [ doc = "Values that can be written to the field `GEIEN`" ]
        pub enum GeienW {
            # [ doc = "Disabled" ]
            _0,
            # [ doc = "Enabled" ]
            _1,
        }
        impl GeienW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GeienW::_0 => 0,
                    GeienW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GeienW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GeienW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GeienW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GeienW::_0)
            }
            # [ doc = "Enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GeienW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Global Error Injection Enable" ]
            # [ inline ( always ) ]
            pub fn geien(&self) -> GeienR {
                GeienR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Global Error Injection Enable" ]
            # [ inline ( always ) ]
            pub fn geien(&mut self) -> _GeienW {
                _GeienW { w: self }
            }
        }
    }
    # [ doc = "Error Injection Channel Enable register" ]
    pub struct Eichen {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Injection Channel Enable register" ]
    pub mod eichen {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eichen {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EICH1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eich1enR {
            # [ doc = "Error injection is disabled on Error Injection Channel 1" ]
            _0,
            # [ doc = "Error injection is enabled on Error Injection Channel 1" ]
            _1,
        }
        impl Eich1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eich1enR::_0 => 0,
                    Eich1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eich1enR {
                match bits {
                    0 => Eich1enR::_0,
                    1 => Eich1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eich1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eich1enR::_1
            }
        }
        # [ doc = "Possible values of the field `EICH0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Eich0enR {
            # [ doc = "Error injection is disabled on Error Injection Channel 0" ]
            _0,
            # [ doc = "Error injection is enabled on Error Injection Channel 0" ]
            _1,
        }
        impl Eich0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Eich0enR::_0 => 0,
                    Eich0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Eich0enR {
                match bits {
                    0 => Eich0enR::_0,
                    1 => Eich0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Eich0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Eich0enR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EICH1EN`" ]
        pub enum Eich1enW {
            # [ doc = "Error injection is disabled on Error Injection Channel 1" ]
            _0,
            # [ doc = "Error injection is enabled on Error Injection Channel 1" ]
            _1,
        }
        impl Eich1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eich1enW::_0 => 0,
                    Eich1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eich1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eich1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eich1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Error injection is disabled on Error Injection Channel 1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eich1enW::_0)
            }
            # [ doc = "Error injection is enabled on Error Injection Channel 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eich1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EICH0EN`" ]
        pub enum Eich0enW {
            # [ doc = "Error injection is disabled on Error Injection Channel 0" ]
            _0,
            # [ doc = "Error injection is enabled on Error Injection Channel 0" ]
            _1,
        }
        impl Eich0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Eich0enW::_0 => 0,
                    Eich0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Eich0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Eich0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Eich0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Error injection is disabled on Error Injection Channel 0" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Eich0enW::_0)
            }
            # [ doc = "Error injection is enabled on Error Injection Channel 0" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Eich0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Error Injection Channel 1 Enable" ]
            # [ inline ( always ) ]
            pub fn eich1en(&self) -> Eich1enR {
                Eich1enR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 30;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 31 - Error Injection Channel 0 Enable" ]
            # [ inline ( always ) ]
            pub fn eich0en(&self) -> Eich0enR {
                Eich0enR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 31;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Error Injection Channel 1 Enable" ]
            # [ inline ( always ) ]
            pub fn eich1en(&mut self) -> _Eich1enW {
                _Eich1enW { w: self }
            }
            # [ doc = "Bit 31 - Error Injection Channel 0 Enable" ]
            # [ inline ( always ) ]
            pub fn eich0en(&mut self) -> _Eich0enW {
                _Eich0enW { w: self }
            }
        }
    }
    # [ doc = "Error Injection Channel Descriptor n, Word0" ]
    pub struct Eichd0Word0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Injection Channel Descriptor n, Word0" ]
    pub mod eichd0_word0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eichd0Word0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChkbitMaskR {
            bits: u8,
        }
        impl ChkbitMaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChkbitMaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChkbitMaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 25:31 - Checkbit Mask" ]
            # [ inline ( always ) ]
            pub fn chkbit_mask(&self) -> ChkbitMaskR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ChkbitMaskR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 25:31 - Checkbit Mask" ]
            # [ inline ( always ) ]
            pub fn chkbit_mask(&mut self) -> _ChkbitMaskW {
                _ChkbitMaskW { w: self }
            }
        }
    }
    # [ doc = "Error Injection Channel Descriptor n, Word1" ]
    pub struct Eichd0Word1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Injection Channel Descriptor n, Word1" ]
    pub mod eichd0_word1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eichd0Word1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct B03dataMaskR {
            bits: u32,
        }
        impl B03dataMaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _B03dataMaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _B03dataMaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Data Mask Bytes 0-3" ]
            # [ inline ( always ) ]
            pub fn b0_3data_mask(&self) -> B03dataMaskR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                B03dataMaskR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Data Mask Bytes 0-3" ]
            # [ inline ( always ) ]
            pub fn b0_3data_mask(&mut self) -> _B03dataMaskW {
                _B03dataMaskW { w: self }
            }
        }
    }
    # [ doc = "Error Injection Channel Descriptor n, Word0" ]
    pub struct Eichd1Word0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Injection Channel Descriptor n, Word0" ]
    pub mod eichd1_word0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eichd1Word0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChkbitMaskR {
            bits: u8,
        }
        impl ChkbitMaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChkbitMaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChkbitMaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 25:31 - Checkbit Mask" ]
            # [ inline ( always ) ]
            pub fn chkbit_mask(&self) -> ChkbitMaskR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 25;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ChkbitMaskR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 25:31 - Checkbit Mask" ]
            # [ inline ( always ) ]
            pub fn chkbit_mask(&mut self) -> _ChkbitMaskW {
                _ChkbitMaskW { w: self }
            }
        }
    }
    # [ doc = "Error Injection Channel Descriptor n, Word1" ]
    pub struct Eichd1Word1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Injection Channel Descriptor n, Word1" ]
    pub mod eichd1_word1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Eichd1Word1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct B03dataMaskR {
            bits: u32,
        }
        impl B03dataMaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _B03dataMaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _B03dataMaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Data Mask Bytes 0-3" ]
            # [ inline ( always ) ]
            pub fn b0_3data_mask(&self) -> B03dataMaskR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                B03dataMaskR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Data Mask Bytes 0-3" ]
            # [ inline ( always ) ]
            pub fn b0_3data_mask(&mut self) -> _B03dataMaskW {
                _B03dataMaskW { w: self }
            }
        }
    }
}
# [ doc = "Error Injection Module" ]
pub struct Eim {
    register_block: eim::RegisterBlock,
}
impl Deref for Eim {
    type Target = eim::RegisterBlock;
    fn deref(&self) -> &eim::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "FTFC" ]
pub const FTFC: Peripheral<Ftfc> = unsafe { Peripheral::new(1073872896) };
# [ doc = "FTFC" ]
pub mod ftfc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Flash Status Register" ]
        pub fstat: Fstat,
        # [ doc = "0x01 - Flash Configuration Register" ]
        pub fcnfg: Fcnfg,
        # [ doc = "0x02 - Flash Security Register" ]
        pub fsec: Fsec,
        # [ doc = "0x03 - Flash Option Register" ]
        pub fopt: Fopt,
        # [ doc = "0x04 - Flash Common Command Object Registers" ]
        pub fccob3: Fccob3,
        # [ doc = "0x05 - Flash Common Command Object Registers" ]
        pub fccob2: Fccob2,
        # [ doc = "0x06 - Flash Common Command Object Registers" ]
        pub fccob1: Fccob1,
        # [ doc = "0x07 - Flash Common Command Object Registers" ]
        pub fccob0: Fccob0,
        # [ doc = "0x08 - Flash Common Command Object Registers" ]
        pub fccob7: Fccob7,
        # [ doc = "0x09 - Flash Common Command Object Registers" ]
        pub fccob6: Fccob6,
        # [ doc = "0x0a - Flash Common Command Object Registers" ]
        pub fccob5: Fccob5,
        # [ doc = "0x0b - Flash Common Command Object Registers" ]
        pub fccob4: Fccob4,
        # [ doc = "0x0c - Flash Common Command Object Registers" ]
        pub fccobb: Fccobb,
        # [ doc = "0x0d - Flash Common Command Object Registers" ]
        pub fccoba: Fccoba,
        # [ doc = "0x0e - Flash Common Command Object Registers" ]
        pub fccob9: Fccob9,
        # [ doc = "0x0f - Flash Common Command Object Registers" ]
        pub fccob8: Fccob8,
        # [ doc = "0x10 - Program Flash Protection Registers" ]
        pub fprot3: Fprot3,
        # [ doc = "0x11 - Program Flash Protection Registers" ]
        pub fprot2: Fprot2,
        # [ doc = "0x12 - Program Flash Protection Registers" ]
        pub fprot1: Fprot1,
        # [ doc = "0x13 - Program Flash Protection Registers" ]
        pub fprot0: Fprot0,
        _reserved0: [u8; 2usize],
        # [ doc = "0x16 - EEPROM Protection Register" ]
        pub feprot: Feprot,
        # [ doc = "0x17 - Data Flash Protection Register" ]
        pub fdprot: Fdprot,
        _reserved1: [u8; 20usize],
        # [ doc = "0x2c - Flash CSEc Status Register" ]
        pub fcsestat: Fcsestat,
        _reserved2: [u8; 1usize],
        # [ doc = "0x2e - Flash Error Status Register" ]
        pub ferstat: Ferstat,
        # [ doc = "0x2f - Flash Error Configuration Register" ]
        pub fercnfg: Fercnfg,
    }
    # [ doc = "Flash Status Register" ]
    pub struct Fstat {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Status Register" ]
    pub mod fstat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fstat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mgstat0R {
            bits: u8,
        }
        impl Mgstat0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FPVIOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FpviolR {
            # [ doc = "No protection violation detected" ]
            _0,
            # [ doc = "Protection violation detected" ]
            _1,
        }
        impl FpviolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FpviolR::_0 => 0,
                    FpviolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FpviolR {
                match bits {
                    0 => FpviolR::_0,
                    1 => FpviolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FpviolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FpviolR::_1
            }
        }
        # [ doc = "Possible values of the field `ACCERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AccerrR {
            # [ doc = "No access error detected" ]
            _0,
            # [ doc = "Access error detected" ]
            _1,
        }
        impl AccerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AccerrR::_0 => 0,
                    AccerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AccerrR {
                match bits {
                    0 => AccerrR::_0,
                    1 => AccerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AccerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AccerrR::_1
            }
        }
        # [ doc = "Possible values of the field `RDCOLERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdcolerrR {
            # [ doc = "No collision error detected" ]
            _0,
            # [ doc = "Collision error detected" ]
            _1,
        }
        impl RdcolerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdcolerrR::_0 => 0,
                    RdcolerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdcolerrR {
                match bits {
                    0 => RdcolerrR::_0,
                    1 => RdcolerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdcolerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdcolerrR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcifR {
            bits: u8,
        }
        impl CcifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `FPVIOL`" ]
        pub enum FpviolW {
            # [ doc = "No protection violation detected" ]
            _0,
            # [ doc = "Protection violation detected" ]
            _1,
        }
        impl FpviolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FpviolW::_0 => 0,
                    FpviolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpviolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpviolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FpviolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No protection violation detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FpviolW::_0)
            }
            # [ doc = "Protection violation detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FpviolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ACCERR`" ]
        pub enum AccerrW {
            # [ doc = "No access error detected" ]
            _0,
            # [ doc = "Access error detected" ]
            _1,
        }
        impl AccerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AccerrW::_0 => 0,
                    AccerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AccerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AccerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AccerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No access error detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AccerrW::_0)
            }
            # [ doc = "Access error detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AccerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDCOLERR`" ]
        pub enum RdcolerrW {
            # [ doc = "No collision error detected" ]
            _0,
            # [ doc = "Collision error detected" ]
            _1,
        }
        impl RdcolerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdcolerrW::_0 => 0,
                    RdcolerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdcolerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdcolerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdcolerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No collision error detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdcolerrW::_0)
            }
            # [ doc = "Collision error detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdcolerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcifW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 0 - Memory Controller Command Completion Status Flag" ]
            # [ inline ( always ) ]
            pub fn mgstat0(&self) -> Mgstat0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                Mgstat0R { bits }
            }
            # [ doc = "Bit 4 - Flash Protection Violation Flag" ]
            # [ inline ( always ) ]
            pub fn fpviol(&self) -> FpviolR {
                FpviolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u8) as u8
                               })
            }
            # [ doc = "Bit 5 - Flash Access Error Flag" ]
            # [ inline ( always ) ]
            pub fn accerr(&self) -> AccerrR {
                AccerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u8) as u8
                               })
            }
            # [ doc = "Bit 6 - FTFC Read Collision Error Flag" ]
            # [ inline ( always ) ]
            pub fn rdcolerr(&self) -> RdcolerrR {
                RdcolerrR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u8) as u8
                                 })
            }
            # [ doc = "Bit 7 - Command Complete Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn ccif(&self) -> CcifR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcifR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 128 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Flash Protection Violation Flag" ]
            # [ inline ( always ) ]
            pub fn fpviol(&mut self) -> _FpviolW {
                _FpviolW { w: self }
            }
            # [ doc = "Bit 5 - Flash Access Error Flag" ]
            # [ inline ( always ) ]
            pub fn accerr(&mut self) -> _AccerrW {
                _AccerrW { w: self }
            }
            # [ doc = "Bit 6 - FTFC Read Collision Error Flag" ]
            # [ inline ( always ) ]
            pub fn rdcolerr(&mut self) -> _RdcolerrW {
                _RdcolerrW { w: self }
            }
            # [ doc = "Bit 7 - Command Complete Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn ccif(&mut self) -> _CcifW {
                _CcifW { w: self }
            }
        }
    }
    # [ doc = "Flash Configuration Register" ]
    pub struct Fcnfg {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Configuration Register" ]
    pub mod fcnfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fcnfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EeerdyR {
            bits: u8,
        }
        impl EeerdyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RamrdyR {
            bits: u8,
        }
        impl RamrdyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ERSSUSP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErssuspR {
            # [ doc = "No suspend requested" ]
            _0,
            # [ doc = "Suspend the current Erase Flash Sector command execution" ]
            _1,
        }
        impl ErssuspR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErssuspR::_0 => 0,
                    ErssuspR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErssuspR {
                match bits {
                    0 => ErssuspR::_0,
                    1 => ErssuspR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErssuspR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErssuspR::_1
            }
        }
        # [ doc = "Possible values of the field `ERSAREQ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErsareqR {
            # [ doc = "No request or request complete" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ErsareqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErsareqR::_0 => 0,
                    ErsareqR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErsareqR {
                match bits {
                    0 => ErsareqR::_0,
                    i => ErsareqR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErsareqR::_0
            }
        }
        # [ doc = "Possible values of the field `RDCOLLIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdcollieR {
            # [ doc = "Read collision error interrupt disabled" ]
            _0,
            # [ doc = "Read collision error interrupt enabled. An interrupt request is generated whenever an FTFC read collision error is detected (see the description of FSTAT[RDCOLERR])." ]
            _1,
        }
        impl RdcollieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdcollieR::_0 => 0,
                    RdcollieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdcollieR {
                match bits {
                    0 => RdcollieR::_0,
                    1 => RdcollieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdcollieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdcollieR::_1
            }
        }
        # [ doc = "Possible values of the field `CCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CcieR {
            # [ doc = "Command complete interrupt disabled" ]
            _0,
            # [ doc = "Command complete interrupt enabled. An interrupt request is generated whenever the FSTAT[CCIF] flag is set." ]
            _1,
        }
        impl CcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CcieR::_0 => 0,
                    CcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CcieR {
                match bits {
                    0 => CcieR::_0,
                    1 => CcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CcieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERSSUSP`" ]
        pub enum ErssuspW {
            # [ doc = "No suspend requested" ]
            _0,
            # [ doc = "Suspend the current Erase Flash Sector command execution" ]
            _1,
        }
        impl ErssuspW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErssuspW::_0 => 0,
                    ErssuspW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErssuspW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErssuspW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErssuspW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No suspend requested" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErssuspW::_0)
            }
            # [ doc = "Suspend the current Erase Flash Sector command execution" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErssuspW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDCOLLIE`" ]
        pub enum RdcollieW {
            # [ doc = "Read collision error interrupt disabled" ]
            _0,
            # [ doc = "Read collision error interrupt enabled. An interrupt request is generated whenever an FTFC read collision error is detected (see the description of FSTAT[RDCOLERR])." ]
            _1,
        }
        impl RdcollieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdcollieW::_0 => 0,
                    RdcollieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdcollieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdcollieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdcollieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Read collision error interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdcollieW::_0)
            }
            # [ doc = "Read collision error interrupt enabled. An interrupt request is generated whenever an FTFC read collision error is detected (see the description of FSTAT[RDCOLERR])." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdcollieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CCIE`" ]
        pub enum CcieW {
            # [ doc = "Command complete interrupt disabled" ]
            _0,
            # [ doc = "Command complete interrupt enabled. An interrupt request is generated whenever the FSTAT[CCIF] flag is set." ]
            _1,
        }
        impl CcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CcieW::_0 => 0,
                    CcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Command complete interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CcieW::_0)
            }
            # [ doc = "Command complete interrupt enabled. An interrupt request is generated whenever the FSTAT[CCIF] flag is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 0 - EEERDY" ]
            # [ inline ( always ) ]
            pub fn eeerdy(&self) -> EeerdyR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                EeerdyR { bits }
            }
            # [ doc = "Bit 1 - RAM Ready" ]
            # [ inline ( always ) ]
            pub fn ramrdy(&self) -> RamrdyR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RamrdyR { bits }
            }
            # [ doc = "Bit 4 - Erase Suspend" ]
            # [ inline ( always ) ]
            pub fn erssusp(&self) -> ErssuspR {
                ErssuspR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u8) as u8
                                })
            }
            # [ doc = "Bit 5 - Erase All Request" ]
            # [ inline ( always ) ]
            pub fn ersareq(&self) -> ErsareqR {
                ErsareqR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u8) as u8
                                })
            }
            # [ doc = "Bit 6 - Read Collision Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdcollie(&self) -> RdcollieR {
                RdcollieR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u8) as u8
                                 })
            }
            # [ doc = "Bit 7 - Command Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ccie(&self) -> CcieR {
                CcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Erase Suspend" ]
            # [ inline ( always ) ]
            pub fn erssusp(&mut self) -> _ErssuspW {
                _ErssuspW { w: self }
            }
            # [ doc = "Bit 6 - Read Collision Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdcollie(&mut self) -> _RdcollieW {
                _RdcollieW { w: self }
            }
            # [ doc = "Bit 7 - Command Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ccie(&mut self) -> _CcieW {
                _CcieW { w: self }
            }
        }
    }
    # [ doc = "Flash Security Register" ]
    pub struct Fsec {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Security Register" ]
    pub mod fsec {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        impl super::Fsec {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `SEC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SecR {
            # [ doc = "MCU security status is unsecure (The standard shipping condition of the FTFC is unsecure.)" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SecR::_10 => 2,
                    SecR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SecR {
                match bits {
                    2 => SecR::_10,
                    i => SecR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SecR::_10
            }
        }
        # [ doc = "Possible values of the field `FSLACC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FslaccR {
            # [ doc = "Factory access granted" ]
            _00,
            # [ doc = "Factory access granted" ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl FslaccR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FslaccR::_00 => 0,
                    FslaccR::_11 => 3,
                    FslaccR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FslaccR {
                match bits {
                    0 => FslaccR::_00,
                    3 => FslaccR::_11,
                    i => FslaccR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FslaccR::_00
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FslaccR::_11
            }
        }
        # [ doc = "Possible values of the field `MEEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MeenR {
            # [ doc = "Mass erase is enabled" ]
            _00,
            # [ doc = "Mass erase is enabled" ]
            _01,
            # [ doc = "Mass erase is enabled" ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MeenR::_00 => 0,
                    MeenR::_01 => 1,
                    MeenR::_11 => 3,
                    MeenR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MeenR {
                match bits {
                    0 => MeenR::_00,
                    1 => MeenR::_01,
                    3 => MeenR::_11,
                    i => MeenR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == MeenR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == MeenR::_01
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == MeenR::_11
            }
        }
        # [ doc = "Possible values of the field `KEYEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum KeyenR {
            # [ doc = "Backdoor key access disabled" ]
            _00,
            # [ doc = "Backdoor key access disabled (preferred KEYEN state to disable backdoor key access)" ]
            _01,
            # [ doc = "Backdoor key access enabled" ]
            _10,
            # [ doc = "Backdoor key access disabled" ]
            _11,
        }
        impl KeyenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    KeyenR::_00 => 0,
                    KeyenR::_01 => 1,
                    KeyenR::_10 => 2,
                    KeyenR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> KeyenR {
                match bits {
                    0 => KeyenR::_00,
                    1 => KeyenR::_01,
                    2 => KeyenR::_10,
                    3 => KeyenR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == KeyenR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == KeyenR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == KeyenR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == KeyenR::_11
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Flash Security" ]
            # [ inline ( always ) ]
            pub fn sec(&self) -> SecR {
                SecR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u8) as u8
                            })
            }
            # [ doc = "Bits 2:3 - Factory Failure Analysis Access Code" ]
            # [ inline ( always ) ]
            pub fn fslacc(&self) -> FslaccR {
                FslaccR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u8) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Mass Erase Enable Bits" ]
            # [ inline ( always ) ]
            pub fn meen(&self) -> MeenR {
                MeenR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bits 6:7 - Backdoor Key Security Enable" ]
            # [ inline ( always ) ]
            pub fn keyen(&self) -> KeyenR {
                KeyenR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
        }
    }
    # [ doc = "Flash Option Register" ]
    pub struct Fopt {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Option Register" ]
    pub mod fopt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        impl super::Fopt {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OptR {
            bits: u8,
        }
        impl OptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Nonvolatile Option" ]
            # [ inline ( always ) ]
            pub fn opt(&self) -> OptR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                OptR { bits }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob3 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob2 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob1 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob0 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob7 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob6 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob5 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob4 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccobb {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccobb {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccobb {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccoba {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccoba {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccoba {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob9 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub struct Fccob8 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Common Command Object Registers" ]
    pub mod fccob8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fccob8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CcobnR {
            bits: u8,
        }
        impl CcobnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CcobnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CcobnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&self) -> CcobnR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                CcobnR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CCOBn" ]
            # [ inline ( always ) ]
            pub fn ccobn(&mut self) -> _CcobnW {
                _CcobnW { w: self }
            }
        }
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub struct Fprot3 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub mod fprot3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fprot3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ProtR {
            bits: u8,
        }
        impl ProtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ProtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ProtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&self) -> ProtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ProtR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&mut self) -> _ProtW {
                _ProtW { w: self }
            }
        }
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub struct Fprot2 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub mod fprot2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fprot2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ProtR {
            bits: u8,
        }
        impl ProtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ProtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ProtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&self) -> ProtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ProtR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&mut self) -> _ProtW {
                _ProtW { w: self }
            }
        }
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub struct Fprot1 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub mod fprot1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fprot1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ProtR {
            bits: u8,
        }
        impl ProtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ProtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ProtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&self) -> ProtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ProtR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&mut self) -> _ProtW {
                _ProtW { w: self }
            }
        }
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub struct Fprot0 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Program Flash Protection Registers" ]
    pub mod fprot0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fprot0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ProtR {
            bits: u8,
        }
        impl ProtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ProtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ProtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&self) -> ProtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                ProtR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Program Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn prot(&mut self) -> _ProtW {
                _ProtW { w: self }
            }
        }
    }
    # [ doc = "EEPROM Protection Register" ]
    pub struct Feprot {
        register: VolatileCell<u8>,
    }
    # [ doc = "EEPROM Protection Register" ]
    pub mod feprot {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Feprot {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EprotR {
            bits: u8,
        }
        impl EprotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EprotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EprotW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - EEPROM Region Protect" ]
            # [ inline ( always ) ]
            pub fn eprot(&self) -> EprotR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                EprotR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - EEPROM Region Protect" ]
            # [ inline ( always ) ]
            pub fn eprot(&mut self) -> _EprotW {
                _EprotW { w: self }
            }
        }
    }
    # [ doc = "Data Flash Protection Register" ]
    pub struct Fdprot {
        register: VolatileCell<u8>,
    }
    # [ doc = "Data Flash Protection Register" ]
    pub mod fdprot {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fdprot {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DPROT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DprotR {
            # [ doc = "Data Flash region is protected" ]
            _00000000,
            # [ doc = "Data Flash region is not protected" ]
            _00000001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DprotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DprotR::_00000000 => 0,
                    DprotR::_00000001 => 1,
                    DprotR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DprotR {
                match bits {
                    0 => DprotR::_00000000,
                    1 => DprotR::_00000001,
                    i => DprotR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000000`" ]
            # [ inline ( always ) ]
            pub fn is_00000000(&self) -> bool {
                *self == DprotR::_00000000
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == DprotR::_00000001
            }
        }
        # [ doc = "Values that can be written to the field `DPROT`" ]
        pub enum DprotW {
            # [ doc = "Data Flash region is protected" ]
            _00000000,
            # [ doc = "Data Flash region is not protected" ]
            _00000001,
        }
        impl DprotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DprotW::_00000000 => 0,
                    DprotW::_00000001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DprotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DprotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DprotW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Data Flash region is protected" ]
            # [ inline ( always ) ]
            pub fn _00000000(self) -> &'a mut W {
                self.variant(DprotW::_00000000)
            }
            # [ doc = "Data Flash region is not protected" ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(DprotW::_00000001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn dprot(&self) -> DprotR {
                DprotR::_from({
                                  const MASK: u8 = 255;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data Flash Region Protect" ]
            # [ inline ( always ) ]
            pub fn dprot(&mut self) -> _DprotW {
                _DprotW { w: self }
            }
        }
    }
    # [ doc = "Flash CSEc Status Register" ]
    pub struct Fcsestat {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash CSEc Status Register" ]
    pub mod fcsestat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        impl super::Fcsestat {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BsyR {
            bits: u8,
        }
        impl BsyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SbR {
            bits: u8,
        }
        impl SbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BinR {
            bits: u8,
        }
        impl BinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BfnR {
            bits: u8,
        }
        impl BfnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BokR {
            bits: u8,
        }
        impl BokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RinR {
            bits: u8,
        }
        impl RinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EdbR {
            bits: u8,
        }
        impl EdbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdbR {
            bits: u8,
        }
        impl IdbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 0 - Busy" ]
            # [ inline ( always ) ]
            pub fn bsy(&self) -> BsyR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                BsyR { bits }
            }
            # [ doc = "Bit 1 - Secure Boot" ]
            # [ inline ( always ) ]
            pub fn sb(&self) -> SbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SbR { bits }
            }
            # [ doc = "Bit 2 - Secure Boot Initialization" ]
            # [ inline ( always ) ]
            pub fn bin(&self) -> BinR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                BinR { bits }
            }
            # [ doc = "Bit 3 - Secure Boot Finished" ]
            # [ inline ( always ) ]
            pub fn bfn(&self) -> BfnR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                BfnR { bits }
            }
            # [ doc = "Bit 4 - Secure Boot OK" ]
            # [ inline ( always ) ]
            pub fn bok(&self) -> BokR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                BokR { bits }
            }
            # [ doc = "Bit 5 - Random Number Generator Initialized" ]
            # [ inline ( always ) ]
            pub fn rin(&self) -> RinR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                RinR { bits }
            }
            # [ doc = "Bit 6 - External Debug" ]
            # [ inline ( always ) ]
            pub fn edb(&self) -> EdbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                EdbR { bits }
            }
            # [ doc = "Bit 7 - Internal Debug" ]
            # [ inline ( always ) ]
            pub fn idb(&self) -> IdbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                IdbR { bits }
            }
        }
    }
    # [ doc = "Flash Error Status Register" ]
    pub struct Ferstat {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Error Status Register" ]
    pub mod ferstat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Ferstat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFDIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfdifR {
            # [ doc = "Double bit fault not detected during a valid flash read access from the platform flash controller" ]
            _0,
            # [ doc = "Double bit fault detected (or FERCNFG[FDFD] is set) during a valid flash read access from the platform flash controller" ]
            _1,
        }
        impl DfdifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DfdifR::_0 => 0,
                    DfdifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DfdifR {
                match bits {
                    0 => DfdifR::_0,
                    1 => DfdifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfdifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfdifR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFDIF`" ]
        pub enum DfdifW {
            # [ doc = "Double bit fault not detected during a valid flash read access from the platform flash controller" ]
            _0,
            # [ doc = "Double bit fault detected (or FERCNFG[FDFD] is set) during a valid flash read access from the platform flash controller" ]
            _1,
        }
        impl DfdifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DfdifW::_0 => 0,
                    DfdifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfdifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfdifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfdifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Double bit fault not detected during a valid flash read access from the platform flash controller" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfdifW::_0)
            }
            # [ doc = "Double bit fault detected (or FERCNFG[FDFD] is set) during a valid flash read access from the platform flash controller" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfdifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 1 - Double Bit Fault Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn dfdif(&self) -> DfdifR {
                DfdifR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Double Bit Fault Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn dfdif(&mut self) -> _DfdifW {
                _DfdifW { w: self }
            }
        }
    }
    # [ doc = "Flash Error Configuration Register" ]
    pub struct Fercnfg {
        register: VolatileCell<u8>,
    }
    # [ doc = "Flash Error Configuration Register" ]
    pub mod fercnfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Fercnfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfdieR {
            # [ doc = "Double bit fault detect interrupt disabled" ]
            _0,
            # [ doc = "Double bit fault detect interrupt enabled. An interrupt request is generated whenever the FERSTAT[DFDIF] flag is set." ]
            _1,
        }
        impl DfdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DfdieR::_0 => 0,
                    DfdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DfdieR {
                match bits {
                    0 => DfdieR::_0,
                    1 => DfdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfdieR::_1
            }
        }
        # [ doc = "Possible values of the field `FDFD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdfdR {
            # [ doc = "FERSTAT[DFDIF] sets only if a double bit fault is detected during read access from the platform flash controller" ]
            _0,
            # [ doc = "FERSTAT[DFDIF] sets during any valid flash read access from the platform flash controller. An interrupt request is generated if the DFDIE bit is set." ]
            _1,
        }
        impl FdfdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdfdR::_0 => 0,
                    FdfdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdfdR {
                match bits {
                    0 => FdfdR::_0,
                    1 => FdfdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdfdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdfdR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFDIE`" ]
        pub enum DfdieW {
            # [ doc = "Double bit fault detect interrupt disabled" ]
            _0,
            # [ doc = "Double bit fault detect interrupt enabled. An interrupt request is generated whenever the FERSTAT[DFDIF] flag is set." ]
            _1,
        }
        impl DfdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DfdieW::_0 => 0,
                    DfdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Double bit fault detect interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfdieW::_0)
            }
            # [ doc = "Double bit fault detect interrupt enabled. An interrupt request is generated whenever the FERSTAT[DFDIF] flag is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDFD`" ]
        pub enum FdfdW {
            # [ doc = "FERSTAT[DFDIF] sets only if a double bit fault is detected during read access from the platform flash controller" ]
            _0,
            # [ doc = "FERSTAT[DFDIF] sets during any valid flash read access from the platform flash controller. An interrupt request is generated if the DFDIE bit is set." ]
            _1,
        }
        impl FdfdW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdfdW::_0 => 0,
                    FdfdW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdfdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdfdW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdfdW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FERSTAT[DFDIF] sets only if a double bit fault is detected during read access from the platform flash controller" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdfdW::_0)
            }
            # [ doc = "FERSTAT[DFDIF] sets during any valid flash read access from the platform flash controller. An interrupt request is generated if the DFDIE bit is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdfdW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 1 - Double Bit Fault Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dfdie(&self) -> DfdieR {
                DfdieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
            # [ doc = "Bit 5 - Force Double Bit Fault Detect" ]
            # [ inline ( always ) ]
            pub fn fdfd(&self) -> FdfdR {
                FdfdR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Double Bit Fault Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dfdie(&mut self) -> _DfdieW {
                _DfdieW { w: self }
            }
            # [ doc = "Bit 5 - Force Double Bit Fault Detect" ]
            # [ inline ( always ) ]
            pub fn fdfd(&mut self) -> _FdfdW {
                _FdfdW { w: self }
            }
        }
    }
}
# [ doc = "FTFC" ]
pub struct Ftfc {
    register_block: ftfc::RegisterBlock,
}
impl Deref for Ftfc {
    type Target = ftfc::RegisterBlock;
    fn deref(&self) -> &ftfc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "DMA channel multiplexor" ]
pub const DMAMUX: Peripheral<Dmamux> = unsafe { Peripheral::new(1073876992) };
# [ doc = "DMA channel multiplexor" ]
pub mod dmamux {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Channel Configuration register" ]
        pub chcfg0: Chcfg0,
        # [ doc = "0x01 - Channel Configuration register" ]
        pub chcfg1: Chcfg1,
        # [ doc = "0x02 - Channel Configuration register" ]
        pub chcfg2: Chcfg2,
        # [ doc = "0x03 - Channel Configuration register" ]
        pub chcfg3: Chcfg3,
        # [ doc = "0x04 - Channel Configuration register" ]
        pub chcfg4: Chcfg4,
        # [ doc = "0x05 - Channel Configuration register" ]
        pub chcfg5: Chcfg5,
        # [ doc = "0x06 - Channel Configuration register" ]
        pub chcfg6: Chcfg6,
        # [ doc = "0x07 - Channel Configuration register" ]
        pub chcfg7: Chcfg7,
        # [ doc = "0x08 - Channel Configuration register" ]
        pub chcfg8: Chcfg8,
        # [ doc = "0x09 - Channel Configuration register" ]
        pub chcfg9: Chcfg9,
        # [ doc = "0x0a - Channel Configuration register" ]
        pub chcfg10: Chcfg10,
        # [ doc = "0x0b - Channel Configuration register" ]
        pub chcfg11: Chcfg11,
        # [ doc = "0x0c - Channel Configuration register" ]
        pub chcfg12: Chcfg12,
        # [ doc = "0x0d - Channel Configuration register" ]
        pub chcfg13: Chcfg13,
        # [ doc = "0x0e - Channel Configuration register" ]
        pub chcfg14: Chcfg14,
        # [ doc = "0x0f - Channel Configuration register" ]
        pub chcfg15: Chcfg15,
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg0 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg1 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg2 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg3 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg4 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg5 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg6 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg7 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg8 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg9 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg10 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg11 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg12 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg13 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg14 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
    # [ doc = "Channel Configuration register" ]
    pub struct Chcfg15 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Channel Configuration register" ]
    pub mod chcfg15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Chcfg15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SourceR {
            bits: u8,
        }
        impl SourceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigR {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigR::_0 => 0,
                    TrigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigR {
                match bits {
                    0 => TrigR::_0,
                    1 => TrigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigR::_1
            }
        }
        # [ doc = "Possible values of the field `ENBL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnblR {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnblR::_0 => 0,
                    EnblR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnblR {
                match bits {
                    0 => EnblR::_0,
                    1 => EnblR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnblR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnblR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SourceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SourceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG`" ]
        pub enum TrigW {
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            _0,
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            _1,
        }
        impl TrigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigW::_0 => 0,
                    TrigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Triggering is disabled. If triggering is disabled and ENBL is set, the DMA Channel will simply route the specified source to the DMA channel. (Normal mode)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigW::_0)
            }
            # [ doc = "Triggering is enabled. If triggering is enabled and ENBL is set, the DMAMUX is in Periodic Trigger mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ENBL`" ]
        pub enum EnblW {
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            _0,
            # [ doc = "DMA channel is enabled" ]
            _1,
        }
        impl EnblW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnblW::_0 => 0,
                    EnblW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnblW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnblW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnblW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA channel is disabled. This mode is primarily used during configuration of the DMAMux. The DMA has separate channel enables/disables, which should be used to disable or reconfigure a DMA channel." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnblW::_0)
            }
            # [ doc = "DMA channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnblW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&self) -> SourceR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                SourceR { bits }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&self) -> TrigR {
                TrigR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&self) -> EnblR {
                EnblR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - DMA Channel Source (Slot)" ]
            # [ inline ( always ) ]
            pub fn source(&mut self) -> _SourceW {
                _SourceW { w: self }
            }
            # [ doc = "Bit 6 - DMA Channel Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn trig(&mut self) -> _TrigW {
                _TrigW { w: self }
            }
            # [ doc = "Bit 7 - DMA Channel Enable" ]
            # [ inline ( always ) ]
            pub fn enbl(&mut self) -> _EnblW {
                _EnblW { w: self }
            }
        }
    }
}
# [ doc = "DMA channel multiplexor" ]
pub struct Dmamux {
    register_block: dmamux::RegisterBlock,
}
impl Deref for Dmamux {
    type Target = dmamux::RegisterBlock;
    fn deref(&self) -> &dmamux::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Flex Controller Area Network module" ]
pub const CAN0: Peripheral<Can0> = unsafe { Peripheral::new(1073889280) };
# [ doc = "Flex Controller Area Network module" ]
pub mod can0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Module Configuration Register" ]
        pub mcr: Mcr,
        # [ doc = "0x04 - Control 1 register" ]
        pub ctrl1: Ctrl1,
        # [ doc = "0x08 - Free Running Timer" ]
        pub timer: Timer,
        _reserved0: [u8; 4usize],
        # [ doc = "0x10 - Rx Mailboxes Global Mask Register" ]
        pub rxmgmask: Rxmgmask,
        # [ doc = "0x14 - Rx 14 Mask register" ]
        pub rx14mask: Rx14mask,
        # [ doc = "0x18 - Rx 15 Mask register" ]
        pub rx15mask: Rx15mask,
        # [ doc = "0x1c - Error Counter" ]
        pub ecr: Ecr,
        # [ doc = "0x20 - Error and Status 1 register" ]
        pub esr1: Esr1,
        _reserved1: [u8; 4usize],
        # [ doc = "0x28 - Interrupt Masks 1 register" ]
        pub imask1: Imask1,
        _reserved2: [u8; 4usize],
        # [ doc = "0x30 - Interrupt Flags 1 register" ]
        pub iflag1: Iflag1,
        # [ doc = "0x34 - Control 2 register" ]
        pub ctrl2: Ctrl2,
        # [ doc = "0x38 - Error and Status 2 register" ]
        pub esr2: Esr2,
        _reserved3: [u8; 8usize],
        # [ doc = "0x44 - CRC Register" ]
        pub crcr: Crcr,
        # [ doc = "0x48 - Rx FIFO Global Mask register" ]
        pub rxfgmask: Rxfgmask,
        # [ doc = "0x4c - Rx FIFO Information Register" ]
        pub rxfir: Rxfir,
        # [ doc = "0x50 - CAN Bit Timing Register" ]
        pub cbt: Cbt,
        _reserved4: [u8; 44usize],
        # [ doc = "0x80 - Embedded RAM" ]
        pub embedded_ram0: EmbeddedRam0,
        # [ doc = "0x84 - Embedded RAM" ]
        pub embedded_ram1: EmbeddedRam1,
        # [ doc = "0x88 - Embedded RAM" ]
        pub embedded_ram2: EmbeddedRam2,
        # [ doc = "0x8c - Embedded RAM" ]
        pub embedded_ram3: EmbeddedRam3,
        # [ doc = "0x90 - Embedded RAM" ]
        pub embedded_ram4: EmbeddedRam4,
        # [ doc = "0x94 - Embedded RAM" ]
        pub embedded_ram5: EmbeddedRam5,
        # [ doc = "0x98 - Embedded RAM" ]
        pub embedded_ram6: EmbeddedRam6,
        # [ doc = "0x9c - Embedded RAM" ]
        pub embedded_ram7: EmbeddedRam7,
        # [ doc = "0xa0 - Embedded RAM" ]
        pub embedded_ram8: EmbeddedRam8,
        # [ doc = "0xa4 - Embedded RAM" ]
        pub embedded_ram9: EmbeddedRam9,
        # [ doc = "0xa8 - Embedded RAM" ]
        pub embedded_ram10: EmbeddedRam10,
        # [ doc = "0xac - Embedded RAM" ]
        pub embedded_ram11: EmbeddedRam11,
        # [ doc = "0xb0 - Embedded RAM" ]
        pub embedded_ram12: EmbeddedRam12,
        # [ doc = "0xb4 - Embedded RAM" ]
        pub embedded_ram13: EmbeddedRam13,
        # [ doc = "0xb8 - Embedded RAM" ]
        pub embedded_ram14: EmbeddedRam14,
        # [ doc = "0xbc - Embedded RAM" ]
        pub embedded_ram15: EmbeddedRam15,
        # [ doc = "0xc0 - Embedded RAM" ]
        pub embedded_ram16: EmbeddedRam16,
        # [ doc = "0xc4 - Embedded RAM" ]
        pub embedded_ram17: EmbeddedRam17,
        # [ doc = "0xc8 - Embedded RAM" ]
        pub embedded_ram18: EmbeddedRam18,
        # [ doc = "0xcc - Embedded RAM" ]
        pub embedded_ram19: EmbeddedRam19,
        # [ doc = "0xd0 - Embedded RAM" ]
        pub embedded_ram20: EmbeddedRam20,
        # [ doc = "0xd4 - Embedded RAM" ]
        pub embedded_ram21: EmbeddedRam21,
        # [ doc = "0xd8 - Embedded RAM" ]
        pub embedded_ram22: EmbeddedRam22,
        # [ doc = "0xdc - Embedded RAM" ]
        pub embedded_ram23: EmbeddedRam23,
        # [ doc = "0xe0 - Embedded RAM" ]
        pub embedded_ram24: EmbeddedRam24,
        # [ doc = "0xe4 - Embedded RAM" ]
        pub embedded_ram25: EmbeddedRam25,
        # [ doc = "0xe8 - Embedded RAM" ]
        pub embedded_ram26: EmbeddedRam26,
        # [ doc = "0xec - Embedded RAM" ]
        pub embedded_ram27: EmbeddedRam27,
        # [ doc = "0xf0 - Embedded RAM" ]
        pub embedded_ram28: EmbeddedRam28,
        # [ doc = "0xf4 - Embedded RAM" ]
        pub embedded_ram29: EmbeddedRam29,
        # [ doc = "0xf8 - Embedded RAM" ]
        pub embedded_ram30: EmbeddedRam30,
        # [ doc = "0xfc - Embedded RAM" ]
        pub embedded_ram31: EmbeddedRam31,
        # [ doc = "0x100 - Embedded RAM" ]
        pub embedded_ram32: EmbeddedRam32,
        # [ doc = "0x104 - Embedded RAM" ]
        pub embedded_ram33: EmbeddedRam33,
        # [ doc = "0x108 - Embedded RAM" ]
        pub embedded_ram34: EmbeddedRam34,
        # [ doc = "0x10c - Embedded RAM" ]
        pub embedded_ram35: EmbeddedRam35,
        # [ doc = "0x110 - Embedded RAM" ]
        pub embedded_ram36: EmbeddedRam36,
        # [ doc = "0x114 - Embedded RAM" ]
        pub embedded_ram37: EmbeddedRam37,
        # [ doc = "0x118 - Embedded RAM" ]
        pub embedded_ram38: EmbeddedRam38,
        # [ doc = "0x11c - Embedded RAM" ]
        pub embedded_ram39: EmbeddedRam39,
        # [ doc = "0x120 - Embedded RAM" ]
        pub embedded_ram40: EmbeddedRam40,
        # [ doc = "0x124 - Embedded RAM" ]
        pub embedded_ram41: EmbeddedRam41,
        # [ doc = "0x128 - Embedded RAM" ]
        pub embedded_ram42: EmbeddedRam42,
        # [ doc = "0x12c - Embedded RAM" ]
        pub embedded_ram43: EmbeddedRam43,
        # [ doc = "0x130 - Embedded RAM" ]
        pub embedded_ram44: EmbeddedRam44,
        # [ doc = "0x134 - Embedded RAM" ]
        pub embedded_ram45: EmbeddedRam45,
        # [ doc = "0x138 - Embedded RAM" ]
        pub embedded_ram46: EmbeddedRam46,
        # [ doc = "0x13c - Embedded RAM" ]
        pub embedded_ram47: EmbeddedRam47,
        # [ doc = "0x140 - Embedded RAM" ]
        pub embedded_ram48: EmbeddedRam48,
        # [ doc = "0x144 - Embedded RAM" ]
        pub embedded_ram49: EmbeddedRam49,
        # [ doc = "0x148 - Embedded RAM" ]
        pub embedded_ram50: EmbeddedRam50,
        # [ doc = "0x14c - Embedded RAM" ]
        pub embedded_ram51: EmbeddedRam51,
        # [ doc = "0x150 - Embedded RAM" ]
        pub embedded_ram52: EmbeddedRam52,
        # [ doc = "0x154 - Embedded RAM" ]
        pub embedded_ram53: EmbeddedRam53,
        # [ doc = "0x158 - Embedded RAM" ]
        pub embedded_ram54: EmbeddedRam54,
        # [ doc = "0x15c - Embedded RAM" ]
        pub embedded_ram55: EmbeddedRam55,
        # [ doc = "0x160 - Embedded RAM" ]
        pub embedded_ram56: EmbeddedRam56,
        # [ doc = "0x164 - Embedded RAM" ]
        pub embedded_ram57: EmbeddedRam57,
        # [ doc = "0x168 - Embedded RAM" ]
        pub embedded_ram58: EmbeddedRam58,
        # [ doc = "0x16c - Embedded RAM" ]
        pub embedded_ram59: EmbeddedRam59,
        # [ doc = "0x170 - Embedded RAM" ]
        pub embedded_ram60: EmbeddedRam60,
        # [ doc = "0x174 - Embedded RAM" ]
        pub embedded_ram61: EmbeddedRam61,
        # [ doc = "0x178 - Embedded RAM" ]
        pub embedded_ram62: EmbeddedRam62,
        # [ doc = "0x17c - Embedded RAM" ]
        pub embedded_ram63: EmbeddedRam63,
        # [ doc = "0x180 - Embedded RAM" ]
        pub embedded_ram64: EmbeddedRam64,
        # [ doc = "0x184 - Embedded RAM" ]
        pub embedded_ram65: EmbeddedRam65,
        # [ doc = "0x188 - Embedded RAM" ]
        pub embedded_ram66: EmbeddedRam66,
        # [ doc = "0x18c - Embedded RAM" ]
        pub embedded_ram67: EmbeddedRam67,
        # [ doc = "0x190 - Embedded RAM" ]
        pub embedded_ram68: EmbeddedRam68,
        # [ doc = "0x194 - Embedded RAM" ]
        pub embedded_ram69: EmbeddedRam69,
        # [ doc = "0x198 - Embedded RAM" ]
        pub embedded_ram70: EmbeddedRam70,
        # [ doc = "0x19c - Embedded RAM" ]
        pub embedded_ram71: EmbeddedRam71,
        # [ doc = "0x1a0 - Embedded RAM" ]
        pub embedded_ram72: EmbeddedRam72,
        # [ doc = "0x1a4 - Embedded RAM" ]
        pub embedded_ram73: EmbeddedRam73,
        # [ doc = "0x1a8 - Embedded RAM" ]
        pub embedded_ram74: EmbeddedRam74,
        # [ doc = "0x1ac - Embedded RAM" ]
        pub embedded_ram75: EmbeddedRam75,
        # [ doc = "0x1b0 - Embedded RAM" ]
        pub embedded_ram76: EmbeddedRam76,
        # [ doc = "0x1b4 - Embedded RAM" ]
        pub embedded_ram77: EmbeddedRam77,
        # [ doc = "0x1b8 - Embedded RAM" ]
        pub embedded_ram78: EmbeddedRam78,
        # [ doc = "0x1bc - Embedded RAM" ]
        pub embedded_ram79: EmbeddedRam79,
        # [ doc = "0x1c0 - Embedded RAM" ]
        pub embedded_ram80: EmbeddedRam80,
        # [ doc = "0x1c4 - Embedded RAM" ]
        pub embedded_ram81: EmbeddedRam81,
        # [ doc = "0x1c8 - Embedded RAM" ]
        pub embedded_ram82: EmbeddedRam82,
        # [ doc = "0x1cc - Embedded RAM" ]
        pub embedded_ram83: EmbeddedRam83,
        # [ doc = "0x1d0 - Embedded RAM" ]
        pub embedded_ram84: EmbeddedRam84,
        # [ doc = "0x1d4 - Embedded RAM" ]
        pub embedded_ram85: EmbeddedRam85,
        # [ doc = "0x1d8 - Embedded RAM" ]
        pub embedded_ram86: EmbeddedRam86,
        # [ doc = "0x1dc - Embedded RAM" ]
        pub embedded_ram87: EmbeddedRam87,
        # [ doc = "0x1e0 - Embedded RAM" ]
        pub embedded_ram88: EmbeddedRam88,
        # [ doc = "0x1e4 - Embedded RAM" ]
        pub embedded_ram89: EmbeddedRam89,
        # [ doc = "0x1e8 - Embedded RAM" ]
        pub embedded_ram90: EmbeddedRam90,
        # [ doc = "0x1ec - Embedded RAM" ]
        pub embedded_ram91: EmbeddedRam91,
        # [ doc = "0x1f0 - Embedded RAM" ]
        pub embedded_ram92: EmbeddedRam92,
        # [ doc = "0x1f4 - Embedded RAM" ]
        pub embedded_ram93: EmbeddedRam93,
        # [ doc = "0x1f8 - Embedded RAM" ]
        pub embedded_ram94: EmbeddedRam94,
        # [ doc = "0x1fc - Embedded RAM" ]
        pub embedded_ram95: EmbeddedRam95,
        # [ doc = "0x200 - Embedded RAM" ]
        pub embedded_ram96: EmbeddedRam96,
        # [ doc = "0x204 - Embedded RAM" ]
        pub embedded_ram97: EmbeddedRam97,
        # [ doc = "0x208 - Embedded RAM" ]
        pub embedded_ram98: EmbeddedRam98,
        # [ doc = "0x20c - Embedded RAM" ]
        pub embedded_ram99: EmbeddedRam99,
        # [ doc = "0x210 - Embedded RAM" ]
        pub embedded_ram100: EmbeddedRam100,
        # [ doc = "0x214 - Embedded RAM" ]
        pub embedded_ram101: EmbeddedRam101,
        # [ doc = "0x218 - Embedded RAM" ]
        pub embedded_ram102: EmbeddedRam102,
        # [ doc = "0x21c - Embedded RAM" ]
        pub embedded_ram103: EmbeddedRam103,
        # [ doc = "0x220 - Embedded RAM" ]
        pub embedded_ram104: EmbeddedRam104,
        # [ doc = "0x224 - Embedded RAM" ]
        pub embedded_ram105: EmbeddedRam105,
        # [ doc = "0x228 - Embedded RAM" ]
        pub embedded_ram106: EmbeddedRam106,
        # [ doc = "0x22c - Embedded RAM" ]
        pub embedded_ram107: EmbeddedRam107,
        # [ doc = "0x230 - Embedded RAM" ]
        pub embedded_ram108: EmbeddedRam108,
        # [ doc = "0x234 - Embedded RAM" ]
        pub embedded_ram109: EmbeddedRam109,
        # [ doc = "0x238 - Embedded RAM" ]
        pub embedded_ram110: EmbeddedRam110,
        # [ doc = "0x23c - Embedded RAM" ]
        pub embedded_ram111: EmbeddedRam111,
        # [ doc = "0x240 - Embedded RAM" ]
        pub embedded_ram112: EmbeddedRam112,
        # [ doc = "0x244 - Embedded RAM" ]
        pub embedded_ram113: EmbeddedRam113,
        # [ doc = "0x248 - Embedded RAM" ]
        pub embedded_ram114: EmbeddedRam114,
        # [ doc = "0x24c - Embedded RAM" ]
        pub embedded_ram115: EmbeddedRam115,
        # [ doc = "0x250 - Embedded RAM" ]
        pub embedded_ram116: EmbeddedRam116,
        # [ doc = "0x254 - Embedded RAM" ]
        pub embedded_ram117: EmbeddedRam117,
        # [ doc = "0x258 - Embedded RAM" ]
        pub embedded_ram118: EmbeddedRam118,
        # [ doc = "0x25c - Embedded RAM" ]
        pub embedded_ram119: EmbeddedRam119,
        # [ doc = "0x260 - Embedded RAM" ]
        pub embedded_ram120: EmbeddedRam120,
        # [ doc = "0x264 - Embedded RAM" ]
        pub embedded_ram121: EmbeddedRam121,
        # [ doc = "0x268 - Embedded RAM" ]
        pub embedded_ram122: EmbeddedRam122,
        # [ doc = "0x26c - Embedded RAM" ]
        pub embedded_ram123: EmbeddedRam123,
        # [ doc = "0x270 - Embedded RAM" ]
        pub embedded_ram124: EmbeddedRam124,
        # [ doc = "0x274 - Embedded RAM" ]
        pub embedded_ram125: EmbeddedRam125,
        # [ doc = "0x278 - Embedded RAM" ]
        pub embedded_ram126: EmbeddedRam126,
        # [ doc = "0x27c - Embedded RAM" ]
        pub embedded_ram127: EmbeddedRam127,
        _reserved5: [u8; 1536usize],
        # [ doc = "0x880 - Rx Individual Mask Registers" ]
        pub rximr0: Rximr0,
        # [ doc = "0x884 - Rx Individual Mask Registers" ]
        pub rximr1: Rximr1,
        # [ doc = "0x888 - Rx Individual Mask Registers" ]
        pub rximr2: Rximr2,
        # [ doc = "0x88c - Rx Individual Mask Registers" ]
        pub rximr3: Rximr3,
        # [ doc = "0x890 - Rx Individual Mask Registers" ]
        pub rximr4: Rximr4,
        # [ doc = "0x894 - Rx Individual Mask Registers" ]
        pub rximr5: Rximr5,
        # [ doc = "0x898 - Rx Individual Mask Registers" ]
        pub rximr6: Rximr6,
        # [ doc = "0x89c - Rx Individual Mask Registers" ]
        pub rximr7: Rximr7,
        # [ doc = "0x8a0 - Rx Individual Mask Registers" ]
        pub rximr8: Rximr8,
        # [ doc = "0x8a4 - Rx Individual Mask Registers" ]
        pub rximr9: Rximr9,
        # [ doc = "0x8a8 - Rx Individual Mask Registers" ]
        pub rximr10: Rximr10,
        # [ doc = "0x8ac - Rx Individual Mask Registers" ]
        pub rximr11: Rximr11,
        # [ doc = "0x8b0 - Rx Individual Mask Registers" ]
        pub rximr12: Rximr12,
        # [ doc = "0x8b4 - Rx Individual Mask Registers" ]
        pub rximr13: Rximr13,
        # [ doc = "0x8b8 - Rx Individual Mask Registers" ]
        pub rximr14: Rximr14,
        # [ doc = "0x8bc - Rx Individual Mask Registers" ]
        pub rximr15: Rximr15,
        _reserved6: [u8; 576usize],
        # [ doc = "0xb00 - Pretended Networking Control 1 Register" ]
        pub ctrl1_pn: Ctrl1Pn,
        # [ doc = "0xb04 - Pretended Networking Control 2 Register" ]
        pub ctrl2_pn: Ctrl2Pn,
        # [ doc = "0xb08 - Pretended Networking Wake Up Match Register" ]
        pub wu_mtc: WuMtc,
        # [ doc = "0xb0c - Pretended Networking ID Filter 1 Register" ]
        pub flt_id1: FltId1,
        # [ doc = "0xb10 - Pretended Networking DLC Filter Register" ]
        pub flt_dlc: FltDlc,
        # [ doc = "0xb14 - Pretended Networking Payload Low Filter 1 Register" ]
        pub pl1_lo: Pl1Lo,
        # [ doc = "0xb18 - Pretended Networking Payload High Filter 1 Register" ]
        pub pl1_hi: Pl1Hi,
        # [ doc = "0xb1c - Pretended Networking ID Filter 2 Register / ID Mask Register" ]
        pub flt_id2_idmask: FltId2Idmask,
        # [ doc = "0xb20 - Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
        pub pl2_plmask_lo: Pl2PlmaskLo,
        # [ doc = "0xb24 - Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
        pub pl2_plmask_hi: Pl2PlmaskHi,
        _reserved7: [u8; 24usize],
        # [ doc = "0xb40 - Wake Up Message Buffer Register for C/S" ]
        pub wmb0_cs: Wmb0Cs,
        # [ doc = "0xb44 - Wake Up Message Buffer Register for ID" ]
        pub wmb0_id: Wmb0Id,
        # [ doc = "0xb48 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb0_d03: Wmb0D03,
        # [ doc = "0xb4c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb0_d47: Wmb0D47,
        # [ doc = "0xb50 - Wake Up Message Buffer Register for C/S" ]
        pub wmb1_cs: Wmb1Cs,
        # [ doc = "0xb54 - Wake Up Message Buffer Register for ID" ]
        pub wmb1_id: Wmb1Id,
        # [ doc = "0xb58 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb1_d03: Wmb1D03,
        # [ doc = "0xb5c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb1_d47: Wmb1D47,
        # [ doc = "0xb60 - Wake Up Message Buffer Register for C/S" ]
        pub wmb2_cs: Wmb2Cs,
        # [ doc = "0xb64 - Wake Up Message Buffer Register for ID" ]
        pub wmb2_id: Wmb2Id,
        # [ doc = "0xb68 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb2_d03: Wmb2D03,
        # [ doc = "0xb6c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb2_d47: Wmb2D47,
        # [ doc = "0xb70 - Wake Up Message Buffer Register for C/S" ]
        pub wmb3_cs: Wmb3Cs,
        # [ doc = "0xb74 - Wake Up Message Buffer Register for ID" ]
        pub wmb3_id: Wmb3Id,
        # [ doc = "0xb78 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb3_d03: Wmb3D03,
        # [ doc = "0xb7c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb3_d47: Wmb3D47,
        _reserved8: [u8; 128usize],
        # [ doc = "0xc00 - CAN FD Control Register" ]
        pub fdctrl: Fdctrl,
        # [ doc = "0xc04 - CAN FD Bit Timing Register" ]
        pub fdcbt: Fdcbt,
        # [ doc = "0xc08 - CAN FD CRC Register" ]
        pub fdcrc: Fdcrc,
    }
    # [ doc = "Module Configuration Register" ]
    pub struct Mcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Module Configuration Register" ]
    pub mod mcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MaxmbR {
            bits: u8,
        }
        impl MaxmbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `IDAM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdamR {
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            _00,
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            _01,
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            _10,
            # [ doc = "Format D: All frames rejected." ]
            _11,
        }
        impl IdamR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdamR::_00 => 0,
                    IdamR::_01 => 1,
                    IdamR::_10 => 2,
                    IdamR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdamR {
                match bits {
                    0 => IdamR::_00,
                    1 => IdamR::_01,
                    2 => IdamR::_10,
                    3 => IdamR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == IdamR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == IdamR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == IdamR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == IdamR::_11
            }
        }
        # [ doc = "Possible values of the field `FDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdenR {
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            _1,
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            _0,
        }
        impl FdenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdenR::_1 => 1,
                    FdenR::_0 => 0,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdenR {
                match bits {
                    1 => FdenR::_1,
                    0 => FdenR::_0,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdenR::_1
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdenR::_0
            }
        }
        # [ doc = "Possible values of the field `AEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AenR {
            # [ doc = "Abort disabled." ]
            _0,
            # [ doc = "Abort enabled." ]
            _1,
        }
        impl AenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AenR::_0 => 0,
                    AenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AenR {
                match bits {
                    0 => AenR::_0,
                    1 => AenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AenR::_1
            }
        }
        # [ doc = "Possible values of the field `LPRIOEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LprioenR {
            # [ doc = "Local Priority disabled." ]
            _0,
            # [ doc = "Local Priority enabled." ]
            _1,
        }
        impl LprioenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LprioenR::_0 => 0,
                    LprioenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LprioenR {
                match bits {
                    0 => LprioenR::_0,
                    1 => LprioenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LprioenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LprioenR::_1
            }
        }
        # [ doc = "Possible values of the field `PNET_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PnetEnR {
            # [ doc = "Pretended Networking mode is disabled." ]
            _0,
            # [ doc = "Pretended Networking mode is enabled." ]
            _1,
        }
        impl PnetEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PnetEnR::_0 => 0,
                    PnetEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PnetEnR {
                match bits {
                    0 => PnetEnR::_0,
                    1 => PnetEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PnetEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PnetEnR::_1
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "DMA feature for RX FIFO disabled." ]
            _0,
            # [ doc = "DMA feature for RX FIFO enabled." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `IRMQ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrmqR {
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            _0,
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            _1,
        }
        impl IrmqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrmqR::_0 => 0,
                    IrmqR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrmqR {
                match bits {
                    0 => IrmqR::_0,
                    1 => IrmqR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IrmqR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IrmqR::_1
            }
        }
        # [ doc = "Possible values of the field `SRXDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SrxdisR {
            # [ doc = "Self reception enabled." ]
            _0,
            # [ doc = "Self reception disabled." ]
            _1,
        }
        impl SrxdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SrxdisR::_0 => 0,
                    SrxdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SrxdisR {
                match bits {
                    0 => SrxdisR::_0,
                    1 => SrxdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SrxdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SrxdisR::_1
            }
        }
        # [ doc = "Possible values of the field `LPMACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpmackR {
            # [ doc = "FlexCAN is not in a low-power mode." ]
            _0,
            # [ doc = "FlexCAN is in a low-power mode." ]
            _1,
        }
        impl LpmackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpmackR::_0 => 0,
                    LpmackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpmackR {
                match bits {
                    0 => LpmackR::_0,
                    1 => LpmackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpmackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpmackR::_1
            }
        }
        # [ doc = "Possible values of the field `WRNEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WrnenR {
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            _0,
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl WrnenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WrnenR::_0 => 0,
                    WrnenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WrnenR {
                match bits {
                    0 => WrnenR::_0,
                    1 => WrnenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WrnenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WrnenR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SupvR {
            bits: u8,
        }
        impl SupvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FRZACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrzackR {
            # [ doc = "FlexCAN not in Freeze mode, prescaler running." ]
            _0,
            # [ doc = "FlexCAN in Freeze mode, prescaler stopped." ]
            _1,
        }
        impl FrzackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrzackR::_0 => 0,
                    FrzackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrzackR {
                match bits {
                    0 => FrzackR::_0,
                    1 => FrzackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrzackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrzackR::_1
            }
        }
        # [ doc = "Possible values of the field `SOFTRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoftrstR {
            # [ doc = "No reset request." ]
            _0,
            # [ doc = "Resets the registers affected by soft reset." ]
            _1,
        }
        impl SoftrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoftrstR::_0 => 0,
                    SoftrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoftrstR {
                match bits {
                    0 => SoftrstR::_0,
                    1 => SoftrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoftrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoftrstR::_1
            }
        }
        # [ doc = "Possible values of the field `NOTRDY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NotrdyR {
            # [ doc = "FlexCAN module is either in Normal mode, Listen-Only mode or Loop-Back mode." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NotrdyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NotrdyR::_0 => 0,
                    NotrdyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NotrdyR {
                match bits {
                    0 => NotrdyR::_0,
                    i => NotrdyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NotrdyR::_0
            }
        }
        # [ doc = "Possible values of the field `HALT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HaltR {
            # [ doc = "No Freeze mode request." ]
            _0,
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            _1,
        }
        impl HaltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HaltR::_0 => 0,
                    HaltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HaltR {
                match bits {
                    0 => HaltR::_0,
                    1 => HaltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HaltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HaltR::_1
            }
        }
        # [ doc = "Possible values of the field `RFEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfenR {
            # [ doc = "Rx FIFO not enabled." ]
            _0,
            # [ doc = "Rx FIFO enabled." ]
            _1,
        }
        impl RfenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfenR::_0 => 0,
                    RfenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfenR {
                match bits {
                    0 => RfenR::_0,
                    1 => RfenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfenR::_1
            }
        }
        # [ doc = "Possible values of the field `FRZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrzR {
            # [ doc = "Not enabled to enter Freeze mode." ]
            _0,
            # [ doc = "Enabled to enter Freeze mode." ]
            _1,
        }
        impl FrzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrzR::_0 => 0,
                    FrzR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrzR {
                match bits {
                    0 => FrzR::_0,
                    1 => FrzR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrzR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrzR::_1
            }
        }
        # [ doc = "Possible values of the field `MDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MdisR {
            # [ doc = "Enable the FlexCAN module." ]
            _0,
            # [ doc = "Disable the FlexCAN module." ]
            _1,
        }
        impl MdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MdisR::_0 => 0,
                    MdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MdisR {
                match bits {
                    0 => MdisR::_0,
                    1 => MdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MdisR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MaxmbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MaxmbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDAM`" ]
        pub enum IdamW {
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            _00,
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            _01,
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            _10,
            # [ doc = "Format D: All frames rejected." ]
            _11,
        }
        impl IdamW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdamW::_00 => 0,
                    IdamW::_01 => 1,
                    IdamW::_10 => 2,
                    IdamW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdamW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdamW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdamW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(IdamW::_00)
            }
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(IdamW::_01)
            }
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(IdamW::_10)
            }
            # [ doc = "Format D: All frames rejected." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(IdamW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDEN`" ]
        pub enum FdenW {
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            _1,
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            _0,
        }
        impl FdenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdenW::_1 => 1,
                    FdenW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdenW::_1)
            }
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdenW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AEN`" ]
        pub enum AenW {
            # [ doc = "Abort disabled." ]
            _0,
            # [ doc = "Abort enabled." ]
            _1,
        }
        impl AenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AenW::_0 => 0,
                    AenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Abort disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AenW::_0)
            }
            # [ doc = "Abort enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPRIOEN`" ]
        pub enum LprioenW {
            # [ doc = "Local Priority disabled." ]
            _0,
            # [ doc = "Local Priority enabled." ]
            _1,
        }
        impl LprioenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LprioenW::_0 => 0,
                    LprioenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LprioenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LprioenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LprioenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Local Priority disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LprioenW::_0)
            }
            # [ doc = "Local Priority enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LprioenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PNET_EN`" ]
        pub enum PnetEnW {
            # [ doc = "Pretended Networking mode is disabled." ]
            _0,
            # [ doc = "Pretended Networking mode is enabled." ]
            _1,
        }
        impl PnetEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PnetEnW::_0 => 0,
                    PnetEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PnetEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PnetEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PnetEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pretended Networking mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PnetEnW::_0)
            }
            # [ doc = "Pretended Networking mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PnetEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "DMA feature for RX FIFO disabled." ]
            _0,
            # [ doc = "DMA feature for RX FIFO enabled." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA feature for RX FIFO disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "DMA feature for RX FIFO enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRMQ`" ]
        pub enum IrmqW {
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            _0,
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            _1,
        }
        impl IrmqW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrmqW::_0 => 0,
                    IrmqW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrmqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrmqW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrmqW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IrmqW::_0)
            }
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IrmqW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRXDIS`" ]
        pub enum SrxdisW {
            # [ doc = "Self reception enabled." ]
            _0,
            # [ doc = "Self reception disabled." ]
            _1,
        }
        impl SrxdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SrxdisW::_0 => 0,
                    SrxdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SrxdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SrxdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SrxdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Self reception enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SrxdisW::_0)
            }
            # [ doc = "Self reception disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SrxdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WRNEN`" ]
        pub enum WrnenW {
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            _0,
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl WrnenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WrnenW::_0 => 0,
                    WrnenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WrnenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WrnenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WrnenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WrnenW::_0)
            }
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WrnenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SupvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SupvW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOFTRST`" ]
        pub enum SoftrstW {
            # [ doc = "No reset request." ]
            _0,
            # [ doc = "Resets the registers affected by soft reset." ]
            _1,
        }
        impl SoftrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SoftrstW::_0 => 0,
                    SoftrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoftrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoftrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SoftrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No reset request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SoftrstW::_0)
            }
            # [ doc = "Resets the registers affected by soft reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SoftrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HALT`" ]
        pub enum HaltW {
            # [ doc = "No Freeze mode request." ]
            _0,
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            _1,
        }
        impl HaltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HaltW::_0 => 0,
                    HaltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HaltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HaltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HaltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Freeze mode request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HaltW::_0)
            }
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HaltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RFEN`" ]
        pub enum RfenW {
            # [ doc = "Rx FIFO not enabled." ]
            _0,
            # [ doc = "Rx FIFO enabled." ]
            _1,
        }
        impl RfenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RfenW::_0 => 0,
                    RfenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RfenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RfenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RfenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx FIFO not enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RfenW::_0)
            }
            # [ doc = "Rx FIFO enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RfenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRZ`" ]
        pub enum FrzW {
            # [ doc = "Not enabled to enter Freeze mode." ]
            _0,
            # [ doc = "Enabled to enter Freeze mode." ]
            _1,
        }
        impl FrzW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FrzW::_0 => 0,
                    FrzW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrzW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrzW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FrzW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Not enabled to enter Freeze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FrzW::_0)
            }
            # [ doc = "Enabled to enter Freeze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FrzW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MDIS`" ]
        pub enum MdisW {
            # [ doc = "Enable the FlexCAN module." ]
            _0,
            # [ doc = "Disable the FlexCAN module." ]
            _1,
        }
        impl MdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MdisW::_0 => 0,
                    MdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Enable the FlexCAN module." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MdisW::_0)
            }
            # [ doc = "Disable the FlexCAN module." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Number Of The Last Message Buffer" ]
            # [ inline ( always ) ]
            pub fn maxmb(&self) -> MaxmbR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MaxmbR { bits }
            }
            # [ doc = "Bits 8:9 - ID Acceptance Mode" ]
            # [ inline ( always ) ]
            pub fn idam(&self) -> IdamR {
                IdamR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - CAN FD operation enable" ]
            # [ inline ( always ) ]
            pub fn fden(&self) -> FdenR {
                FdenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Abort Enable" ]
            # [ inline ( always ) ]
            pub fn aen(&self) -> AenR {
                AenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Local Priority Enable" ]
            # [ inline ( always ) ]
            pub fn lprioen(&self) -> LprioenR {
                LprioenR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Pretended Networking Enable" ]
            # [ inline ( always ) ]
            pub fn pnet_en(&self) -> PnetEnR {
                PnetEnR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 15;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Individual Rx Masking And Queue Enable" ]
            # [ inline ( always ) ]
            pub fn irmq(&self) -> IrmqR {
                IrmqR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Self Reception Disable" ]
            # [ inline ( always ) ]
            pub fn srxdis(&self) -> SrxdisR {
                SrxdisR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Low-Power Mode Acknowledge" ]
            # [ inline ( always ) ]
            pub fn lpmack(&self) -> LpmackR {
                LpmackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wrnen(&self) -> WrnenR {
                WrnenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 21;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 23 - Supervisor Mode" ]
            # [ inline ( always ) ]
            pub fn supv(&self) -> SupvR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SupvR { bits }
            }
            # [ doc = "Bit 24 - Freeze Mode Acknowledge" ]
            # [ inline ( always ) ]
            pub fn frzack(&self) -> FrzackR {
                FrzackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 25 - Soft Reset" ]
            # [ inline ( always ) ]
            pub fn softrst(&self) -> SoftrstR {
                SoftrstR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 27 - FlexCAN Not Ready" ]
            # [ inline ( always ) ]
            pub fn notrdy(&self) -> NotrdyR {
                NotrdyR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Halt FlexCAN" ]
            # [ inline ( always ) ]
            pub fn halt(&self) -> HaltR {
                HaltR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 28;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 29 - Rx FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rfen(&self) -> RfenR {
                RfenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - Freeze Enable" ]
            # [ inline ( always ) ]
            pub fn frz(&self) -> FrzR {
                FrzR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Module Disable" ]
            # [ inline ( always ) ]
            pub fn mdis(&self) -> MdisR {
                MdisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3633315855 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Number Of The Last Message Buffer" ]
            # [ inline ( always ) ]
            pub fn maxmb(&mut self) -> _MaxmbW {
                _MaxmbW { w: self }
            }
            # [ doc = "Bits 8:9 - ID Acceptance Mode" ]
            # [ inline ( always ) ]
            pub fn idam(&mut self) -> _IdamW {
                _IdamW { w: self }
            }
            # [ doc = "Bit 11 - CAN FD operation enable" ]
            # [ inline ( always ) ]
            pub fn fden(&mut self) -> _FdenW {
                _FdenW { w: self }
            }
            # [ doc = "Bit 12 - Abort Enable" ]
            # [ inline ( always ) ]
            pub fn aen(&mut self) -> _AenW {
                _AenW { w: self }
            }
            # [ doc = "Bit 13 - Local Priority Enable" ]
            # [ inline ( always ) ]
            pub fn lprioen(&mut self) -> _LprioenW {
                _LprioenW { w: self }
            }
            # [ doc = "Bit 14 - Pretended Networking Enable" ]
            # [ inline ( always ) ]
            pub fn pnet_en(&mut self) -> _PnetEnW {
                _PnetEnW { w: self }
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 16 - Individual Rx Masking And Queue Enable" ]
            # [ inline ( always ) ]
            pub fn irmq(&mut self) -> _IrmqW {
                _IrmqW { w: self }
            }
            # [ doc = "Bit 17 - Self Reception Disable" ]
            # [ inline ( always ) ]
            pub fn srxdis(&mut self) -> _SrxdisW {
                _SrxdisW { w: self }
            }
            # [ doc = "Bit 21 - Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wrnen(&mut self) -> _WrnenW {
                _WrnenW { w: self }
            }
            # [ doc = "Bit 23 - Supervisor Mode" ]
            # [ inline ( always ) ]
            pub fn supv(&mut self) -> _SupvW {
                _SupvW { w: self }
            }
            # [ doc = "Bit 25 - Soft Reset" ]
            # [ inline ( always ) ]
            pub fn softrst(&mut self) -> _SoftrstW {
                _SoftrstW { w: self }
            }
            # [ doc = "Bit 28 - Halt FlexCAN" ]
            # [ inline ( always ) ]
            pub fn halt(&mut self) -> _HaltW {
                _HaltW { w: self }
            }
            # [ doc = "Bit 29 - Rx FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rfen(&mut self) -> _RfenW {
                _RfenW { w: self }
            }
            # [ doc = "Bit 30 - Freeze Enable" ]
            # [ inline ( always ) ]
            pub fn frz(&mut self) -> _FrzW {
                _FrzW { w: self }
            }
            # [ doc = "Bit 31 - Module Disable" ]
            # [ inline ( always ) ]
            pub fn mdis(&mut self) -> _MdisW {
                _MdisW { w: self }
            }
        }
    }
    # [ doc = "Control 1 register" ]
    pub struct Ctrl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control 1 register" ]
    pub mod ctrl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PropsegR {
            bits: u8,
        }
        impl PropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LomR {
            # [ doc = "Listen-Only mode is deactivated." ]
            _0,
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            _1,
        }
        impl LomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LomR::_0 => 0,
                    LomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LomR {
                match bits {
                    0 => LomR::_0,
                    1 => LomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LomR::_1
            }
        }
        # [ doc = "Possible values of the field `LBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbufR {
            # [ doc = "Buffer with highest priority is transmitted first." ]
            _0,
            # [ doc = "Lowest number buffer is transmitted first." ]
            _1,
        }
        impl LbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbufR::_0 => 0,
                    LbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbufR {
                match bits {
                    0 => LbufR::_0,
                    1 => LbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbufR::_1
            }
        }
        # [ doc = "Possible values of the field `TSYN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsynR {
            # [ doc = "Timer Sync feature disabled" ]
            _0,
            # [ doc = "Timer Sync feature enabled" ]
            _1,
        }
        impl TsynR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsynR::_0 => 0,
                    TsynR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsynR {
                match bits {
                    0 => TsynR::_0,
                    1 => TsynR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsynR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsynR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFREC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffrecR {
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            _0,
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            _1,
        }
        impl BoffrecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffrecR::_0 => 0,
                    BoffrecR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffrecR {
                match bits {
                    0 => BoffrecR::_0,
                    1 => BoffrecR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffrecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffrecR::_1
            }
        }
        # [ doc = "Possible values of the field `SMP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmpR {
            # [ doc = "Just one sample is used to determine the bit value." ]
            _0,
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            _1,
        }
        impl SmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmpR::_0 => 0,
                    SmpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmpR {
                match bits {
                    0 => SmpR::_0,
                    1 => SmpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmpR::_1
            }
        }
        # [ doc = "Possible values of the field `RWRNMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwrnmskR {
            # [ doc = "Rx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Rx Warning Interrupt enabled." ]
            _1,
        }
        impl RwrnmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwrnmskR::_0 => 0,
                    RwrnmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwrnmskR {
                match bits {
                    0 => RwrnmskR::_0,
                    1 => RwrnmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwrnmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwrnmskR::_1
            }
        }
        # [ doc = "Possible values of the field `TWRNMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TwrnmskR {
            # [ doc = "Tx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Tx Warning Interrupt enabled." ]
            _1,
        }
        impl TwrnmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TwrnmskR::_0 => 0,
                    TwrnmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TwrnmskR {
                match bits {
                    0 => TwrnmskR::_0,
                    1 => TwrnmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TwrnmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TwrnmskR::_1
            }
        }
        # [ doc = "Possible values of the field `LPB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpbR {
            # [ doc = "Loop Back disabled." ]
            _0,
            # [ doc = "Loop Back enabled." ]
            _1,
        }
        impl LpbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpbR::_0 => 0,
                    LpbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpbR {
                match bits {
                    0 => LpbR::_0,
                    1 => LpbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpbR::_1
            }
        }
        # [ doc = "Possible values of the field `CLKSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksrcR {
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            _0,
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            _1,
        }
        impl ClksrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksrcR::_0 => 0,
                    ClksrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksrcR {
                match bits {
                    0 => ClksrcR::_0,
                    1 => ClksrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ClksrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ClksrcR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrmskR {
            # [ doc = "Error interrupt disabled." ]
            _0,
            # [ doc = "Error interrupt enabled." ]
            _1,
        }
        impl ErrmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrmskR::_0 => 0,
                    ErrmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrmskR {
                match bits {
                    0 => ErrmskR::_0,
                    1 => ErrmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrmskR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffmskR {
            # [ doc = "Bus Off interrupt disabled." ]
            _0,
            # [ doc = "Bus Off interrupt enabled." ]
            _1,
        }
        impl BoffmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffmskR::_0 => 0,
                    BoffmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffmskR {
                match bits {
                    0 => BoffmskR::_0,
                    1 => BoffmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffmskR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pseg2R {
            bits: u8,
        }
        impl Pseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pseg1R {
            bits: u8,
        }
        impl Pseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RjwR {
            bits: u8,
        }
        impl RjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PresdivR {
            bits: u8,
        }
        impl PresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOM`" ]
        pub enum LomW {
            # [ doc = "Listen-Only mode is deactivated." ]
            _0,
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            _1,
        }
        impl LomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LomW::_0 => 0,
                    LomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Listen-Only mode is deactivated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LomW::_0)
            }
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBUF`" ]
        pub enum LbufW {
            # [ doc = "Buffer with highest priority is transmitted first." ]
            _0,
            # [ doc = "Lowest number buffer is transmitted first." ]
            _1,
        }
        impl LbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbufW::_0 => 0,
                    LbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Buffer with highest priority is transmitted first." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbufW::_0)
            }
            # [ doc = "Lowest number buffer is transmitted first." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSYN`" ]
        pub enum TsynW {
            # [ doc = "Timer Sync feature disabled" ]
            _0,
            # [ doc = "Timer Sync feature enabled" ]
            _1,
        }
        impl TsynW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsynW::_0 => 0,
                    TsynW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsynW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsynW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsynW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Sync feature disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsynW::_0)
            }
            # [ doc = "Timer Sync feature enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsynW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFREC`" ]
        pub enum BoffrecW {
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            _0,
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            _1,
        }
        impl BoffrecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffrecW::_0 => 0,
                    BoffrecW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffrecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffrecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffrecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffrecW::_0)
            }
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffrecW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMP`" ]
        pub enum SmpW {
            # [ doc = "Just one sample is used to determine the bit value." ]
            _0,
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            _1,
        }
        impl SmpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmpW::_0 => 0,
                    SmpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Just one sample is used to determine the bit value." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmpW::_0)
            }
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWRNMSK`" ]
        pub enum RwrnmskW {
            # [ doc = "Rx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Rx Warning Interrupt enabled." ]
            _1,
        }
        impl RwrnmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwrnmskW::_0 => 0,
                    RwrnmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwrnmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwrnmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwrnmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx Warning Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwrnmskW::_0)
            }
            # [ doc = "Rx Warning Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwrnmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TWRNMSK`" ]
        pub enum TwrnmskW {
            # [ doc = "Tx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Tx Warning Interrupt enabled." ]
            _1,
        }
        impl TwrnmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TwrnmskW::_0 => 0,
                    TwrnmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TwrnmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TwrnmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TwrnmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Tx Warning Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TwrnmskW::_0)
            }
            # [ doc = "Tx Warning Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TwrnmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPB`" ]
        pub enum LpbW {
            # [ doc = "Loop Back disabled." ]
            _0,
            # [ doc = "Loop Back enabled." ]
            _1,
        }
        impl LpbW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LpbW::_0 => 0,
                    LpbW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LpbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LpbW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LpbW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loop Back disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LpbW::_0)
            }
            # [ doc = "Loop Back enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LpbW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKSRC`" ]
        pub enum ClksrcW {
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            _0,
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            _1,
        }
        impl ClksrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksrcW::_0 => 0,
                    ClksrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClksrcW::_0)
            }
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClksrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRMSK`" ]
        pub enum ErrmskW {
            # [ doc = "Error interrupt disabled." ]
            _0,
            # [ doc = "Error interrupt enabled." ]
            _1,
        }
        impl ErrmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrmskW::_0 => 0,
                    ErrmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrmskW::_0)
            }
            # [ doc = "Error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFMSK`" ]
        pub enum BoffmskW {
            # [ doc = "Bus Off interrupt disabled." ]
            _0,
            # [ doc = "Bus Off interrupt enabled." ]
            _1,
        }
        impl BoffmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffmskW::_0 => 0,
                    BoffmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus Off interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffmskW::_0)
            }
            # [ doc = "Bus Off interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn propseg(&self) -> PropsegR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PropsegR { bits }
            }
            # [ doc = "Bit 3 - Listen-Only Mode" ]
            # [ inline ( always ) ]
            pub fn lom(&self) -> LomR {
                LomR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Lowest Buffer Transmitted First" ]
            # [ inline ( always ) ]
            pub fn lbuf(&self) -> LbufR {
                LbufR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Timer Sync" ]
            # [ inline ( always ) ]
            pub fn tsyn(&self) -> TsynR {
                TsynR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Bus Off Recovery" ]
            # [ inline ( always ) ]
            pub fn boffrec(&self) -> BoffrecR {
                BoffrecR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 6;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 7 - CAN Bit Sampling" ]
            # [ inline ( always ) ]
            pub fn smp(&self) -> SmpR {
                SmpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Rx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn rwrnmsk(&self) -> RwrnmskR {
                RwrnmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 10;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - Tx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn twrnmsk(&self) -> TwrnmskR {
                TwrnmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 11;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 12 - Loop Back Mode" ]
            # [ inline ( always ) ]
            pub fn lpb(&self) -> LpbR {
                LpbR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - CAN Engine Clock Source" ]
            # [ inline ( always ) ]
            pub fn clksrc(&self) -> ClksrcR {
                ClksrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Error Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn errmsk(&self) -> ErrmskR {
                ErrmskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Bus Off Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffmsk(&self) -> BoffmskR {
                BoffmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 16:18 - Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn pseg2(&self) -> Pseg2R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pseg2R { bits }
            }
            # [ doc = "Bits 19:21 - Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn pseg1(&self) -> Pseg1R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pseg1R { bits }
            }
            # [ doc = "Bits 22:23 - Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn rjw(&self) -> RjwR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RjwR { bits }
            }
            # [ doc = "Bits 24:31 - Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn presdiv(&self) -> PresdivR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PresdivR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn propseg(&mut self) -> _PropsegW {
                _PropsegW { w: self }
            }
            # [ doc = "Bit 3 - Listen-Only Mode" ]
            # [ inline ( always ) ]
            pub fn lom(&mut self) -> _LomW {
                _LomW { w: self }
            }
            # [ doc = "Bit 4 - Lowest Buffer Transmitted First" ]
            # [ inline ( always ) ]
            pub fn lbuf(&mut self) -> _LbufW {
                _LbufW { w: self }
            }
            # [ doc = "Bit 5 - Timer Sync" ]
            # [ inline ( always ) ]
            pub fn tsyn(&mut self) -> _TsynW {
                _TsynW { w: self }
            }
            # [ doc = "Bit 6 - Bus Off Recovery" ]
            # [ inline ( always ) ]
            pub fn boffrec(&mut self) -> _BoffrecW {
                _BoffrecW { w: self }
            }
            # [ doc = "Bit 7 - CAN Bit Sampling" ]
            # [ inline ( always ) ]
            pub fn smp(&mut self) -> _SmpW {
                _SmpW { w: self }
            }
            # [ doc = "Bit 10 - Rx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn rwrnmsk(&mut self) -> _RwrnmskW {
                _RwrnmskW { w: self }
            }
            # [ doc = "Bit 11 - Tx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn twrnmsk(&mut self) -> _TwrnmskW {
                _TwrnmskW { w: self }
            }
            # [ doc = "Bit 12 - Loop Back Mode" ]
            # [ inline ( always ) ]
            pub fn lpb(&mut self) -> _LpbW {
                _LpbW { w: self }
            }
            # [ doc = "Bit 13 - CAN Engine Clock Source" ]
            # [ inline ( always ) ]
            pub fn clksrc(&mut self) -> _ClksrcW {
                _ClksrcW { w: self }
            }
            # [ doc = "Bit 14 - Error Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn errmsk(&mut self) -> _ErrmskW {
                _ErrmskW { w: self }
            }
            # [ doc = "Bit 15 - Bus Off Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffmsk(&mut self) -> _BoffmskW {
                _BoffmskW { w: self }
            }
            # [ doc = "Bits 16:18 - Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn pseg2(&mut self) -> _Pseg2W {
                _Pseg2W { w: self }
            }
            # [ doc = "Bits 19:21 - Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn pseg1(&mut self) -> _Pseg1W {
                _Pseg1W { w: self }
            }
            # [ doc = "Bits 22:23 - Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn rjw(&mut self) -> _RjwW {
                _RjwW { w: self }
            }
            # [ doc = "Bits 24:31 - Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn presdiv(&mut self) -> _PresdivW {
                _PresdivW { w: self }
            }
        }
    }
    # [ doc = "Free Running Timer" ]
    pub struct Timer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Free Running Timer" ]
    pub mod timer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimerR {
            bits: u16,
        }
        impl TimerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimerW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn timer(&self) -> TimerR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TimerR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn timer(&mut self) -> _TimerW {
                _TimerW { w: self }
            }
        }
    }
    # [ doc = "Rx Mailboxes Global Mask Register" ]
    pub struct Rxmgmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Mailboxes Global Mask Register" ]
    pub mod rxmgmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rxmgmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MgR {
            bits: u32,
        }
        impl MgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Mailboxes Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mg(&self) -> MgR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MgR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Mailboxes Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mg(&mut self) -> _MgW {
                _MgW { w: self }
            }
        }
    }
    # [ doc = "Rx 14 Mask register" ]
    pub struct Rx14mask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx 14 Mask register" ]
    pub mod rx14mask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rx14mask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Rx14mR {
            bits: u32,
        }
        impl Rx14mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Rx14mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Rx14mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Buffer 14 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx14m(&self) -> Rx14mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Rx14mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Buffer 14 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx14m(&mut self) -> _Rx14mW {
                _Rx14mW { w: self }
            }
        }
    }
    # [ doc = "Rx 15 Mask register" ]
    pub struct Rx15mask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx 15 Mask register" ]
    pub mod rx15mask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rx15mask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Rx15mR {
            bits: u32,
        }
        impl Rx15mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Rx15mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Rx15mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Buffer 15 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx15m(&self) -> Rx15mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Rx15mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Buffer 15 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx15m(&mut self) -> _Rx15mW {
                _Rx15mW { w: self }
            }
        }
    }
    # [ doc = "Error Counter" ]
    pub struct Ecr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Counter" ]
    pub mod ecr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ecr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxerrcntR {
            bits: u8,
        }
        impl TxerrcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxerrcntR {
            bits: u8,
        }
        impl RxerrcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxerrcntFastR {
            bits: u8,
        }
        impl TxerrcntFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxerrcntFastR {
            bits: u8,
        }
        impl RxerrcntFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxerrcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxerrcntW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxerrcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxerrcntW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxerrcntFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxerrcntFastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxerrcntFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxerrcntFastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit Error Counter" ]
            # [ inline ( always ) ]
            pub fn txerrcnt(&self) -> TxerrcntR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxerrcntR { bits }
            }
            # [ doc = "Bits 8:15 - Receive Error Counter" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt(&self) -> RxerrcntR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxerrcntR { bits }
            }
            # [ doc = "Bits 16:23 - Transmit Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn txerrcnt_fast(&self) -> TxerrcntFastR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxerrcntFastR { bits }
            }
            # [ doc = "Bits 24:31 - Receive Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt_fast(&self) -> RxerrcntFastR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxerrcntFastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Transmit Error Counter" ]
            # [ inline ( always ) ]
            pub fn txerrcnt(&mut self) -> _TxerrcntW {
                _TxerrcntW { w: self }
            }
            # [ doc = "Bits 8:15 - Receive Error Counter" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt(&mut self) -> _RxerrcntW {
                _RxerrcntW { w: self }
            }
            # [ doc = "Bits 16:23 - Transmit Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn txerrcnt_fast(&mut self) -> _TxerrcntFastW {
                _TxerrcntFastW { w: self }
            }
            # [ doc = "Bits 24:31 - Receive Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt_fast(&mut self) -> _RxerrcntFastW {
                _RxerrcntFastW { w: self }
            }
        }
    }
    # [ doc = "Error and Status 1 register" ]
    pub struct Esr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error and Status 1 register" ]
    pub mod esr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Esr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERRINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            _1,
        }
        impl ErrintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrintR::_0 => 0,
                    ErrintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrintR {
                match bits {
                    0 => ErrintR::_0,
                    1 => ErrintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrintR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module entered Bus Off state." ]
            _1,
        }
        impl BoffintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffintR::_0 => 0,
                    BoffintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffintR {
                match bits {
                    0 => BoffintR::_0,
                    1 => BoffintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffintR::_1
            }
        }
        # [ doc = "Possible values of the field `RX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxR {
            # [ doc = "FlexCAN is not receiving a message." ]
            _0,
            # [ doc = "FlexCAN is receiving a message." ]
            _1,
        }
        impl RxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxR::_0 => 0,
                    RxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxR {
                match bits {
                    0 => RxR::_0,
                    1 => RxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxR::_1
            }
        }
        # [ doc = "Possible values of the field `FLTCONF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltconfR {
            # [ doc = "Error Active" ]
            _00,
            # [ doc = "Error Passive" ]
            _01,
            # [ doc = "Bus Off" ]
            _1x,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl FltconfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltconfR::_00 => 0,
                    FltconfR::_01 => 1,
                    FltconfR::_1x => 2,
                    FltconfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltconfR {
                match bits {
                    0 => FltconfR::_00,
                    1 => FltconfR::_01,
                    2 => FltconfR::_1x,
                    i => FltconfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FltconfR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FltconfR::_01
            }
            # [ doc = "Checks if the value of the field is `_1x`" ]
            # [ inline ( always ) ]
            pub fn is_1x(&self) -> bool {
                *self == FltconfR::_1x
            }
        }
        # [ doc = "Possible values of the field `TX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxR {
            # [ doc = "FlexCAN is not transmitting a message." ]
            _0,
            # [ doc = "FlexCAN is transmitting a message." ]
            _1,
        }
        impl TxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxR::_0 => 0,
                    TxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxR {
                match bits {
                    0 => TxR::_0,
                    1 => TxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdleR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "CAN bus is now IDLE." ]
            _1,
        }
        impl IdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdleR::_0 => 0,
                    IdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdleR {
                match bits {
                    0 => IdleR::_0,
                    1 => IdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdleR::_1
            }
        }
        # [ doc = "Possible values of the field `RXWRN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxwrnR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "RXERRCNT is greater than or equal to 96." ]
            _1,
        }
        impl RxwrnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxwrnR::_0 => 0,
                    RxwrnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxwrnR {
                match bits {
                    0 => RxwrnR::_0,
                    1 => RxwrnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxwrnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxwrnR::_1
            }
        }
        # [ doc = "Possible values of the field `TXWRN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxwrnR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "TXERRCNT is greater than or equal to 96." ]
            _1,
        }
        impl TxwrnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxwrnR::_0 => 0,
                    TxwrnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxwrnR {
                match bits {
                    0 => TxwrnR::_0,
                    1 => TxwrnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxwrnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxwrnR::_1
            }
        }
        # [ doc = "Possible values of the field `STFERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StferrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Stuffing Error occurred since last read of this register." ]
            _1,
        }
        impl StferrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StferrR::_0 => 0,
                    StferrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StferrR {
                match bits {
                    0 => StferrR::_0,
                    1 => StferrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StferrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StferrR::_1
            }
        }
        # [ doc = "Possible values of the field `FRMERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrmerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Form Error occurred since last read of this register." ]
            _1,
        }
        impl FrmerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrmerrR::_0 => 0,
                    FrmerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrmerrR {
                match bits {
                    0 => FrmerrR::_0,
                    1 => FrmerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrmerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrmerrR::_1
            }
        }
        # [ doc = "Possible values of the field `CRCERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrcerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A CRC error occurred since last read of this register." ]
            _1,
        }
        impl CrcerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrcerrR::_0 => 0,
                    CrcerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrcerrR {
                match bits {
                    0 => CrcerrR::_0,
                    1 => CrcerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrcerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrcerrR::_1
            }
        }
        # [ doc = "Possible values of the field `ACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AckerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "An ACK error occurred since last read of this register." ]
            _1,
        }
        impl AckerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AckerrR::_0 => 0,
                    AckerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AckerrR {
                match bits {
                    0 => AckerrR::_0,
                    1 => AckerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AckerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AckerrR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT0ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit0errR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as dominant is received as recessive." ]
            _1,
        }
        impl Bit0errR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit0errR::_0 => 0,
                    Bit0errR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit0errR {
                match bits {
                    0 => Bit0errR::_0,
                    1 => Bit0errR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit0errR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit0errR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT1ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit1errR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as recessive is received as dominant." ]
            _1,
        }
        impl Bit1errR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit1errR::_0 => 0,
                    Bit1errR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit1errR {
                match bits {
                    0 => Bit1errR::_0,
                    1 => Bit1errR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit1errR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit1errR::_1
            }
        }
        # [ doc = "Possible values of the field `RWRNINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwrnintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl RwrnintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwrnintR::_0 => 0,
                    RwrnintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwrnintR {
                match bits {
                    0 => RwrnintR::_0,
                    1 => RwrnintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwrnintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwrnintR::_1
            }
        }
        # [ doc = "Possible values of the field `TWRNINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TwrnintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl TwrnintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TwrnintR::_0 => 0,
                    TwrnintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TwrnintR {
                match bits {
                    0 => TwrnintR::_0,
                    1 => TwrnintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TwrnintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TwrnintR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchR {
            # [ doc = "FlexCAN is not synchronized to the CAN bus." ]
            _0,
            # [ doc = "FlexCAN is synchronized to the CAN bus." ]
            _1,
        }
        impl SynchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchR::_0 => 0,
                    SynchR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchR {
                match bits {
                    0 => SynchR::_0,
                    1 => SynchR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFDONEINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffdoneintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            _1,
        }
        impl BoffdoneintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffdoneintR::_0 => 0,
                    BoffdoneintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffdoneintR {
                match bits {
                    0 => BoffdoneintR::_0,
                    1 => BoffdoneintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffdoneintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffdoneintR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRINT_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrintFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            _1,
        }
        impl ErrintFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrintFastR::_0 => 0,
                    ErrintFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrintFastR {
                match bits {
                    0 => ErrintFastR::_0,
                    1 => ErrintFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrintFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrintFastR::_1
            }
        }
        # [ doc = "Possible values of the field `ERROVR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrovrR {
            # [ doc = "Overrun has not occurred." ]
            _0,
            # [ doc = "Overrun has occurred." ]
            _1,
        }
        impl ErrovrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrovrR::_0 => 0,
                    ErrovrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrovrR {
                match bits {
                    0 => ErrovrR::_0,
                    1 => ErrovrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrovrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrovrR::_1
            }
        }
        # [ doc = "Possible values of the field `STFERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StferrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Stuffing Error occurred since last read of this register." ]
            _1,
        }
        impl StferrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StferrFastR::_0 => 0,
                    StferrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StferrFastR {
                match bits {
                    0 => StferrFastR::_0,
                    1 => StferrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StferrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StferrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `FRMERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrmerrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Form Error occurred since last read of this register." ]
            _1,
        }
        impl FrmerrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrmerrFastR::_0 => 0,
                    FrmerrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrmerrFastR {
                match bits {
                    0 => FrmerrFastR::_0,
                    1 => FrmerrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrmerrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrmerrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `CRCERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrcerrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A CRC error occurred since last read of this register." ]
            _1,
        }
        impl CrcerrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrcerrFastR::_0 => 0,
                    CrcerrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrcerrFastR {
                match bits {
                    0 => CrcerrFastR::_0,
                    1 => CrcerrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrcerrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrcerrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT0ERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit0errFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as dominant is received as recessive." ]
            _1,
        }
        impl Bit0errFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit0errFastR::_0 => 0,
                    Bit0errFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit0errFastR {
                match bits {
                    0 => Bit0errFastR::_0,
                    1 => Bit0errFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit0errFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit0errFastR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT1ERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit1errFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as recessive is received as dominant." ]
            _1,
        }
        impl Bit1errFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit1errFastR::_0 => 0,
                    Bit1errFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit1errFastR {
                match bits {
                    0 => Bit1errFastR::_0,
                    1 => Bit1errFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit1errFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit1errFastR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERRINT`" ]
        pub enum ErrintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            _1,
        }
        impl ErrintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrintW::_0 => 0,
                    ErrintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrintW::_0)
            }
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFINT`" ]
        pub enum BoffintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module entered Bus Off state." ]
            _1,
        }
        impl BoffintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffintW::_0 => 0,
                    BoffintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffintW::_0)
            }
            # [ doc = "FlexCAN module entered Bus Off state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWRNINT`" ]
        pub enum RwrnintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl RwrnintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwrnintW::_0 => 0,
                    RwrnintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwrnintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwrnintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwrnintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwrnintW::_0)
            }
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwrnintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TWRNINT`" ]
        pub enum TwrnintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl TwrnintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TwrnintW::_0 => 0,
                    TwrnintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TwrnintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TwrnintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TwrnintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TwrnintW::_0)
            }
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TwrnintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFDONEINT`" ]
        pub enum BoffdoneintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            _1,
        }
        impl BoffdoneintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffdoneintW::_0 => 0,
                    BoffdoneintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffdoneintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffdoneintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffdoneintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffdoneintW::_0)
            }
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffdoneintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRINT_FAST`" ]
        pub enum ErrintFastW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            _1,
        }
        impl ErrintFastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrintFastW::_0 => 0,
                    ErrintFastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrintFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrintFastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrintFastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrintFastW::_0)
            }
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrintFastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERROVR`" ]
        pub enum ErrovrW {
            # [ doc = "Overrun has not occurred." ]
            _0,
            # [ doc = "Overrun has occurred." ]
            _1,
        }
        impl ErrovrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrovrW::_0 => 0,
                    ErrovrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrovrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrovrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrovrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Overrun has not occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrovrW::_0)
            }
            # [ doc = "Overrun has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrovrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn errint(&self) -> ErrintR {
                ErrintR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Bus Off Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffint(&self) -> BoffintR {
                BoffintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - FlexCAN In Reception" ]
            # [ inline ( always ) ]
            pub fn rx(&self) -> RxR {
                RxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 3;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 4:5 - Fault Confinement State" ]
            # [ inline ( always ) ]
            pub fn fltconf(&self) -> FltconfR {
                FltconfR::_from({
                                    const MASK: u8 = 3;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - FlexCAN In Transmission" ]
            # [ inline ( always ) ]
            pub fn tx(&self) -> TxR {
                TxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 6;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 7 - IDLE" ]
            # [ inline ( always ) ]
            pub fn idle(&self) -> IdleR {
                IdleR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Rx Error Warning" ]
            # [ inline ( always ) ]
            pub fn rxwrn(&self) -> RxwrnR {
                RxwrnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - TX Error Warning" ]
            # [ inline ( always ) ]
            pub fn txwrn(&self) -> TxwrnR {
                TxwrnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Stuffing Error" ]
            # [ inline ( always ) ]
            pub fn stferr(&self) -> StferrR {
                StferrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Form Error" ]
            # [ inline ( always ) ]
            pub fn frmerr(&self) -> FrmerrR {
                FrmerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Cyclic Redundancy Check Error" ]
            # [ inline ( always ) ]
            pub fn crcerr(&self) -> CrcerrR {
                CrcerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Acknowledge Error" ]
            # [ inline ( always ) ]
            pub fn ackerr(&self) -> AckerrR {
                AckerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Bit0 Error" ]
            # [ inline ( always ) ]
            pub fn bit0err(&self) -> Bit0errR {
                Bit0errR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Bit1 Error" ]
            # [ inline ( always ) ]
            pub fn bit1err(&self) -> Bit1errR {
                Bit1errR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 16 - Rx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rwrnint(&self) -> RwrnintR {
                RwrnintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 17 - Tx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn twrnint(&self) -> TwrnintR {
                TwrnintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - CAN Synchronization Status" ]
            # [ inline ( always ) ]
            pub fn synch(&self) -> SynchR {
                SynchR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 19 - Bus Off Done Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffdoneint(&self) -> BoffdoneintR {
                BoffdoneintR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 19;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 20 - Error Interrupt for errors detected in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn errint_fast(&self) -> ErrintFastR {
                ErrintFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 20;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 21 - Error Overrun bit" ]
            # [ inline ( always ) ]
            pub fn errovr(&self) -> ErrovrR {
                ErrovrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Stuffing Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn stferr_fast(&self) -> StferrFastR {
                StferrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 26;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 27 - Form Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn frmerr_fast(&self) -> FrmerrFastR {
                FrmerrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 27;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 28 - Cyclic Redundancy Check Error in the CRC field of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn crcerr_fast(&self) -> CrcerrFastR {
                CrcerrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 28;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 30 - Bit0 Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn bit0err_fast(&self) -> Bit0errFastR {
                Bit0errFastR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 30;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 31 - Bit1 Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn bit1err_fast(&self) -> Bit1errFastR {
                Bit1errFastR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 31;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn errint(&mut self) -> _ErrintW {
                _ErrintW { w: self }
            }
            # [ doc = "Bit 2 - Bus Off Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffint(&mut self) -> _BoffintW {
                _BoffintW { w: self }
            }
            # [ doc = "Bit 16 - Rx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rwrnint(&mut self) -> _RwrnintW {
                _RwrnintW { w: self }
            }
            # [ doc = "Bit 17 - Tx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn twrnint(&mut self) -> _TwrnintW {
                _TwrnintW { w: self }
            }
            # [ doc = "Bit 19 - Bus Off Done Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffdoneint(&mut self) -> _BoffdoneintW {
                _BoffdoneintW { w: self }
            }
            # [ doc = "Bit 20 - Error Interrupt for errors detected in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn errint_fast(&mut self) -> _ErrintFastW {
                _ErrintFastW { w: self }
            }
            # [ doc = "Bit 21 - Error Overrun bit" ]
            # [ inline ( always ) ]
            pub fn errovr(&mut self) -> _ErrovrW {
                _ErrovrW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Masks 1 register" ]
    pub struct Imask1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Masks 1 register" ]
    pub mod imask1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Imask1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf31to0mR {
            bits: u32,
        }
        impl Buf31to0mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf31to0mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf31to0mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Buffer MB i Mask" ]
            # [ inline ( always ) ]
            pub fn buf31to0m(&self) -> Buf31to0mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Buf31to0mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Buffer MB i Mask" ]
            # [ inline ( always ) ]
            pub fn buf31to0m(&mut self) -> _Buf31to0mW {
                _Buf31to0mW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Flags 1 register" ]
    pub struct Iflag1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Flags 1 register" ]
    pub mod iflag1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Iflag1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `BUF0I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf0iR {
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            _0,
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            _1,
        }
        impl Buf0iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf0iR::_0 => 0,
                    Buf0iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf0iR {
                match bits {
                    0 => Buf0iR::_0,
                    1 => Buf0iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf0iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf0iR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf4to1iR {
            bits: u8,
        }
        impl Buf4to1iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BUF5I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf5iR {
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            _1,
        }
        impl Buf5iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf5iR::_0 => 0,
                    Buf5iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf5iR {
                match bits {
                    0 => Buf5iR::_0,
                    1 => Buf5iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf5iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf5iR::_1
            }
        }
        # [ doc = "Possible values of the field `BUF6I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf6iR {
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf6iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf6iR::_0 => 0,
                    Buf6iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf6iR {
                match bits {
                    0 => Buf6iR::_0,
                    1 => Buf6iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf6iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf6iR::_1
            }
        }
        # [ doc = "Possible values of the field `BUF7I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf7iR {
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf7iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf7iR::_0 => 0,
                    Buf7iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf7iR {
                match bits {
                    0 => Buf7iR::_0,
                    1 => Buf7iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf7iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf7iR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf31to8iR {
            bits: u32,
        }
        impl Buf31to8iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `BUF0I`" ]
        pub enum Buf0iW {
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            _0,
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            _1,
        }
        impl Buf0iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf0iW::_0 => 0,
                    Buf0iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf0iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf0iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf0iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf0iW::_0)
            }
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf0iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf4to1iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf4to1iW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF5I`" ]
        pub enum Buf5iW {
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            _1,
        }
        impl Buf5iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf5iW::_0 => 0,
                    Buf5iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf5iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf5iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf5iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf5iW::_0)
            }
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf5iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF6I`" ]
        pub enum Buf6iW {
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf6iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf6iW::_0 => 0,
                    Buf6iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf6iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf6iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf6iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf6iW::_0)
            }
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf6iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF7I`" ]
        pub enum Buf7iW {
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf7iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf7iW::_0 => 0,
                    Buf7iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf7iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf7iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf7iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf7iW::_0)
            }
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf7iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf31to8iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf31to8iW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 16777215;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Buffer MB0 Interrupt Or Clear FIFO bit" ]
            # [ inline ( always ) ]
            pub fn buf0i(&self) -> Buf0iR {
                Buf0iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 1:4 - Buffer MB i Interrupt Or \"reserved\"" ]
            # [ inline ( always ) ]
            pub fn buf4to1i(&self) -> Buf4to1iR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Buf4to1iR { bits }
            }
            # [ doc = "Bit 5 - Buffer MB5 Interrupt Or \"Frames available in Rx FIFO\"" ]
            # [ inline ( always ) ]
            pub fn buf5i(&self) -> Buf5iR {
                Buf5iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Buffer MB6 Interrupt Or \"Rx FIFO Warning\"" ]
            # [ inline ( always ) ]
            pub fn buf6i(&self) -> Buf6iR {
                Buf6iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Buffer MB7 Interrupt Or \"Rx FIFO Overflow\"" ]
            # [ inline ( always ) ]
            pub fn buf7i(&self) -> Buf7iR {
                Buf7iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:31 - Buffer MBi Interrupt" ]
            # [ inline ( always ) ]
            pub fn buf31to8i(&self) -> Buf31to8iR {
                let bits = {
                    const MASK: u32 = 16777215;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Buf31to8iR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Buffer MB0 Interrupt Or Clear FIFO bit" ]
            # [ inline ( always ) ]
            pub fn buf0i(&mut self) -> _Buf0iW {
                _Buf0iW { w: self }
            }
            # [ doc = "Bits 1:4 - Buffer MB i Interrupt Or \"reserved\"" ]
            # [ inline ( always ) ]
            pub fn buf4to1i(&mut self) -> _Buf4to1iW {
                _Buf4to1iW { w: self }
            }
            # [ doc = "Bit 5 - Buffer MB5 Interrupt Or \"Frames available in Rx FIFO\"" ]
            # [ inline ( always ) ]
            pub fn buf5i(&mut self) -> _Buf5iW {
                _Buf5iW { w: self }
            }
            # [ doc = "Bit 6 - Buffer MB6 Interrupt Or \"Rx FIFO Warning\"" ]
            # [ inline ( always ) ]
            pub fn buf6i(&mut self) -> _Buf6iW {
                _Buf6iW { w: self }
            }
            # [ doc = "Bit 7 - Buffer MB7 Interrupt Or \"Rx FIFO Overflow\"" ]
            # [ inline ( always ) ]
            pub fn buf7i(&mut self) -> _Buf7iW {
                _Buf7iW { w: self }
            }
            # [ doc = "Bits 8:31 - Buffer MBi Interrupt" ]
            # [ inline ( always ) ]
            pub fn buf31to8i(&mut self) -> _Buf31to8iW {
                _Buf31to8iW { w: self }
            }
        }
    }
    # [ doc = "Control 2 register" ]
    pub struct Ctrl2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control 2 register" ]
    pub mod ctrl2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EDFLTDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EdfltdisR {
            # [ doc = "Edge Filter is enabled." ]
            _0,
            # [ doc = "Edge Filter is disabled." ]
            _1,
        }
        impl EdfltdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EdfltdisR::_0 => 0,
                    EdfltdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EdfltdisR {
                match bits {
                    0 => EdfltdisR::_0,
                    1 => EdfltdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EdfltdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EdfltdisR::_1
            }
        }
        # [ doc = "Possible values of the field `ISOCANFDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsocanfdenR {
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            _0,
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            _1,
        }
        impl IsocanfdenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsocanfdenR::_0 => 0,
                    IsocanfdenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsocanfdenR {
                match bits {
                    0 => IsocanfdenR::_0,
                    1 => IsocanfdenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsocanfdenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsocanfdenR::_1
            }
        }
        # [ doc = "Possible values of the field `PREXCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrexcenR {
            # [ doc = "Protocol Exception is disabled." ]
            _0,
            # [ doc = "Protocol Exception is enabled." ]
            _1,
        }
        impl PrexcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrexcenR::_0 => 0,
                    PrexcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrexcenR {
                match bits {
                    0 => PrexcenR::_0,
                    1 => PrexcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrexcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrexcenR::_1
            }
        }
        # [ doc = "Possible values of the field `TIMER_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimerSrcR {
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            _0,
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            _1,
        }
        impl TimerSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimerSrcR::_0 => 0,
                    TimerSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimerSrcR {
                match bits {
                    0 => TimerSrcR::_0,
                    1 => TimerSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimerSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimerSrcR::_1
            }
        }
        # [ doc = "Possible values of the field `EACEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EacenR {
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            _0,
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            _1,
        }
        impl EacenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EacenR::_0 => 0,
                    EacenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EacenR {
                match bits {
                    0 => EacenR::_0,
                    1 => EacenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EacenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EacenR::_1
            }
        }
        # [ doc = "Possible values of the field `RRS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RrsR {
            # [ doc = "Remote Response Frame is generated." ]
            _0,
            # [ doc = "Remote Request Frame is stored." ]
            _1,
        }
        impl RrsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RrsR::_0 => 0,
                    RrsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RrsR {
                match bits {
                    0 => RrsR::_0,
                    1 => RrsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RrsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RrsR::_1
            }
        }
        # [ doc = "Possible values of the field `MRP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MrpR {
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            _0,
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            _1,
        }
        impl MrpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MrpR::_0 => 0,
                    MrpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MrpR {
                match bits {
                    0 => MrpR::_0,
                    1 => MrpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MrpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MrpR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TasdR {
            bits: u8,
        }
        impl TasdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RffnR {
            bits: u8,
        }
        impl RffnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BOFFDONEMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffdonemskR {
            # [ doc = "Bus Off Done interrupt disabled." ]
            _0,
            # [ doc = "Bus Off Done interrupt enabled." ]
            _1,
        }
        impl BoffdonemskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffdonemskR::_0 => 0,
                    BoffdonemskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffdonemskR {
                match bits {
                    0 => BoffdonemskR::_0,
                    1 => BoffdonemskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffdonemskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffdonemskR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRMSK_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrmskFastR {
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            _0,
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            _1,
        }
        impl ErrmskFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrmskFastR::_0 => 0,
                    ErrmskFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrmskFastR {
                match bits {
                    0 => ErrmskFastR::_0,
                    1 => ErrmskFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrmskFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrmskFastR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EDFLTDIS`" ]
        pub enum EdfltdisW {
            # [ doc = "Edge Filter is enabled." ]
            _0,
            # [ doc = "Edge Filter is disabled." ]
            _1,
        }
        impl EdfltdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EdfltdisW::_0 => 0,
                    EdfltdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EdfltdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EdfltdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EdfltdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Edge Filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EdfltdisW::_0)
            }
            # [ doc = "Edge Filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EdfltdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISOCANFDEN`" ]
        pub enum IsocanfdenW {
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            _0,
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            _1,
        }
        impl IsocanfdenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsocanfdenW::_0 => 0,
                    IsocanfdenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsocanfdenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsocanfdenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsocanfdenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsocanfdenW::_0)
            }
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsocanfdenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PREXCEN`" ]
        pub enum PrexcenW {
            # [ doc = "Protocol Exception is disabled." ]
            _0,
            # [ doc = "Protocol Exception is enabled." ]
            _1,
        }
        impl PrexcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrexcenW::_0 => 0,
                    PrexcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrexcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrexcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrexcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Protocol Exception is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PrexcenW::_0)
            }
            # [ doc = "Protocol Exception is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PrexcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMER_SRC`" ]
        pub enum TimerSrcW {
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            _0,
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            _1,
        }
        impl TimerSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimerSrcW::_0 => 0,
                    TimerSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimerSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimerSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimerSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimerSrcW::_0)
            }
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimerSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EACEN`" ]
        pub enum EacenW {
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            _0,
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            _1,
        }
        impl EacenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EacenW::_0 => 0,
                    EacenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EacenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EacenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EacenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EacenW::_0)
            }
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EacenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRS`" ]
        pub enum RrsW {
            # [ doc = "Remote Response Frame is generated." ]
            _0,
            # [ doc = "Remote Request Frame is stored." ]
            _1,
        }
        impl RrsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrsW::_0 => 0,
                    RrsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Remote Response Frame is generated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrsW::_0)
            }
            # [ doc = "Remote Request Frame is stored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MRP`" ]
        pub enum MrpW {
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            _0,
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            _1,
        }
        impl MrpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MrpW::_0 => 0,
                    MrpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MrpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MrpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MrpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MrpW::_0)
            }
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MrpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TasdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TasdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RffnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RffnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFDONEMSK`" ]
        pub enum BoffdonemskW {
            # [ doc = "Bus Off Done interrupt disabled." ]
            _0,
            # [ doc = "Bus Off Done interrupt enabled." ]
            _1,
        }
        impl BoffdonemskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffdonemskW::_0 => 0,
                    BoffdonemskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffdonemskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffdonemskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffdonemskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus Off Done interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffdonemskW::_0)
            }
            # [ doc = "Bus Off Done interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffdonemskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRMSK_FAST`" ]
        pub enum ErrmskFastW {
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            _0,
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            _1,
        }
        impl ErrmskFastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrmskFastW::_0 => 0,
                    ErrmskFastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrmskFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrmskFastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrmskFastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrmskFastW::_0)
            }
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrmskFastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 11 - Edge Filter Disable" ]
            # [ inline ( always ) ]
            pub fn edfltdis(&self) -> EdfltdisR {
                EdfltdisR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 11;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 12 - ISO CAN FD Enable" ]
            # [ inline ( always ) ]
            pub fn isocanfden(&self) -> IsocanfdenR {
                IsocanfdenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 12;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 14 - Protocol Exception Enable" ]
            # [ inline ( always ) ]
            pub fn prexcen(&self) -> PrexcenR {
                PrexcenR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Timer Source" ]
            # [ inline ( always ) ]
            pub fn timer_src(&self) -> TimerSrcR {
                TimerSrcR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 15;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 16 - Entire Frame Arbitration Field Comparison Enable For Rx Mailboxes" ]
            # [ inline ( always ) ]
            pub fn eacen(&self) -> EacenR {
                EacenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 17 - Remote Request Storing" ]
            # [ inline ( always ) ]
            pub fn rrs(&self) -> RrsR {
                RrsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Mailboxes Reception Priority" ]
            # [ inline ( always ) ]
            pub fn mrp(&self) -> MrpR {
                MrpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 19:23 - Tx Arbitration Start Delay" ]
            # [ inline ( always ) ]
            pub fn tasd(&self) -> TasdR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TasdR { bits }
            }
            # [ doc = "Bits 24:27 - Number Of Rx FIFO Filters" ]
            # [ inline ( always ) ]
            pub fn rffn(&self) -> RffnR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RffnR { bits }
            }
            # [ doc = "Bit 30 - Bus Off Done Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffdonemsk(&self) -> BoffdonemskR {
                BoffdonemskR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 30;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 31 - Error Interrupt Mask for errors detected in the Data Phase of fast CAN FD frames" ]
            # [ inline ( always ) ]
            pub fn errmsk_fast(&self) -> ErrmskFastR {
                ErrmskFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 31;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 10485760 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 11 - Edge Filter Disable" ]
            # [ inline ( always ) ]
            pub fn edfltdis(&mut self) -> _EdfltdisW {
                _EdfltdisW { w: self }
            }
            # [ doc = "Bit 12 - ISO CAN FD Enable" ]
            # [ inline ( always ) ]
            pub fn isocanfden(&mut self) -> _IsocanfdenW {
                _IsocanfdenW { w: self }
            }
            # [ doc = "Bit 14 - Protocol Exception Enable" ]
            # [ inline ( always ) ]
            pub fn prexcen(&mut self) -> _PrexcenW {
                _PrexcenW { w: self }
            }
            # [ doc = "Bit 15 - Timer Source" ]
            # [ inline ( always ) ]
            pub fn timer_src(&mut self) -> _TimerSrcW {
                _TimerSrcW { w: self }
            }
            # [ doc = "Bit 16 - Entire Frame Arbitration Field Comparison Enable For Rx Mailboxes" ]
            # [ inline ( always ) ]
            pub fn eacen(&mut self) -> _EacenW {
                _EacenW { w: self }
            }
            # [ doc = "Bit 17 - Remote Request Storing" ]
            # [ inline ( always ) ]
            pub fn rrs(&mut self) -> _RrsW {
                _RrsW { w: self }
            }
            # [ doc = "Bit 18 - Mailboxes Reception Priority" ]
            # [ inline ( always ) ]
            pub fn mrp(&mut self) -> _MrpW {
                _MrpW { w: self }
            }
            # [ doc = "Bits 19:23 - Tx Arbitration Start Delay" ]
            # [ inline ( always ) ]
            pub fn tasd(&mut self) -> _TasdW {
                _TasdW { w: self }
            }
            # [ doc = "Bits 24:27 - Number Of Rx FIFO Filters" ]
            # [ inline ( always ) ]
            pub fn rffn(&mut self) -> _RffnW {
                _RffnW { w: self }
            }
            # [ doc = "Bit 30 - Bus Off Done Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffdonemsk(&mut self) -> _BoffdonemskW {
                _BoffdonemskW { w: self }
            }
            # [ doc = "Bit 31 - Error Interrupt Mask for errors detected in the Data Phase of fast CAN FD frames" ]
            # [ inline ( always ) ]
            pub fn errmsk_fast(&mut self) -> _ErrmskFastW {
                _ErrmskFastW { w: self }
            }
        }
    }
    # [ doc = "Error and Status 2 register" ]
    pub struct Esr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error and Status 2 register" ]
    pub mod esr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Esr2 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `IMB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ImbR {
            # [ doc = "If ESR2[VPS] is asserted, the ESR2[LPTM] is not an inactive Mailbox." ]
            _0,
            # [ doc = "If ESR2[VPS] is asserted, there is at least one inactive Mailbox. LPTM content is the number of the first one." ]
            _1,
        }
        impl ImbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ImbR::_0 => 0,
                    ImbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ImbR {
                match bits {
                    0 => ImbR::_0,
                    1 => ImbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ImbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ImbR::_1
            }
        }
        # [ doc = "Possible values of the field `VPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VpsR {
            # [ doc = "Contents of IMB and LPTM are invalid." ]
            _0,
            # [ doc = "Contents of IMB and LPTM are valid." ]
            _1,
        }
        impl VpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VpsR::_0 => 0,
                    VpsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VpsR {
                match bits {
                    0 => VpsR::_0,
                    1 => VpsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VpsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VpsR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LptmR {
            bits: u8,
        }
        impl LptmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 13 - Inactive Mailbox" ]
            # [ inline ( always ) ]
            pub fn imb(&self) -> ImbR {
                ImbR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Valid Priority Status" ]
            # [ inline ( always ) ]
            pub fn vps(&self) -> VpsR {
                VpsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:22 - Lowest Priority Tx Mailbox" ]
            # [ inline ( always ) ]
            pub fn lptm(&self) -> LptmR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LptmR { bits }
            }
        }
    }
    # [ doc = "CRC Register" ]
    pub struct Crcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "CRC Register" ]
    pub mod crcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Crcr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcrcR {
            bits: u16,
        }
        impl TxcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MbcrcR {
            bits: u8,
        }
        impl MbcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Transmitted CRC value" ]
            # [ inline ( always ) ]
            pub fn txcrc(&self) -> TxcrcR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TxcrcR { bits }
            }
            # [ doc = "Bits 16:22 - CRC Mailbox" ]
            # [ inline ( always ) ]
            pub fn mbcrc(&self) -> MbcrcR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MbcrcR { bits }
            }
        }
    }
    # [ doc = "Rx FIFO Global Mask register" ]
    pub struct Rxfgmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx FIFO Global Mask register" ]
    pub mod rxfgmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rxfgmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FgmR {
            bits: u32,
        }
        impl FgmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FgmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FgmW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx FIFO Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn fgm(&self) -> FgmR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FgmR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx FIFO Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn fgm(&mut self) -> _FgmW {
                _FgmW { w: self }
            }
        }
    }
    # [ doc = "Rx FIFO Information Register" ]
    pub struct Rxfir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx FIFO Information Register" ]
    pub mod rxfir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rxfir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdhitR {
            bits: u16,
        }
        impl IdhitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Identifier Acceptance Filter Hit Indicator" ]
            # [ inline ( always ) ]
            pub fn idhit(&self) -> IdhitR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                IdhitR { bits }
            }
        }
    }
    # [ doc = "CAN Bit Timing Register" ]
    pub struct Cbt {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN Bit Timing Register" ]
    pub mod cbt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cbt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Epseg2R {
            bits: u8,
        }
        impl Epseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Epseg1R {
            bits: u8,
        }
        impl Epseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EpropsegR {
            bits: u8,
        }
        impl EpropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ErjwR {
            bits: u8,
        }
        impl ErjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EpresdivR {
            bits: u16,
        }
        impl EpresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BtfR {
            # [ doc = "Extended bit time definitions disabled." ]
            _0,
            # [ doc = "Extended bit time definitions enabled." ]
            _1,
        }
        impl BtfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BtfR::_0 => 0,
                    BtfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BtfR {
                match bits {
                    0 => BtfR::_0,
                    1 => BtfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BtfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BtfR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Epseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Epseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Epseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Epseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BTF`" ]
        pub enum BtfW {
            # [ doc = "Extended bit time definitions disabled." ]
            _0,
            # [ doc = "Extended bit time definitions enabled." ]
            _1,
        }
        impl BtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BtfW::_0 => 0,
                    BtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Extended bit time definitions disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BtfW::_0)
            }
            # [ doc = "Extended bit time definitions enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Extended Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn epseg2(&self) -> Epseg2R {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Epseg2R { bits }
            }
            # [ doc = "Bits 5:9 - Extended Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn epseg1(&self) -> Epseg1R {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Epseg1R { bits }
            }
            # [ doc = "Bits 10:15 - Extended Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn epropseg(&self) -> EpropsegR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EpropsegR { bits }
            }
            # [ doc = "Bits 16:20 - Extended Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn erjw(&self) -> ErjwR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ErjwR { bits }
            }
            # [ doc = "Bits 21:30 - Extended Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn epresdiv(&self) -> EpresdivR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                EpresdivR { bits }
            }
            # [ doc = "Bit 31 - Bit Timing Format Enable" ]
            # [ inline ( always ) ]
            pub fn btf(&self) -> BtfR {
                BtfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 31;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Extended Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn epseg2(&mut self) -> _Epseg2W {
                _Epseg2W { w: self }
            }
            # [ doc = "Bits 5:9 - Extended Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn epseg1(&mut self) -> _Epseg1W {
                _Epseg1W { w: self }
            }
            # [ doc = "Bits 10:15 - Extended Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn epropseg(&mut self) -> _EpropsegW {
                _EpropsegW { w: self }
            }
            # [ doc = "Bits 16:20 - Extended Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn erjw(&mut self) -> _ErjwW {
                _ErjwW { w: self }
            }
            # [ doc = "Bits 21:30 - Extended Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn epresdiv(&mut self) -> _EpresdivW {
                _EpresdivW { w: self }
            }
            # [ doc = "Bit 31 - Bit Timing Format Enable" ]
            # [ inline ( always ) ]
            pub fn btf(&mut self) -> _BtfW {
                _BtfW { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam32 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram32 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam32 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam33 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram33 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam33 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam34 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram34 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam34 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam35 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram35 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam35 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam36 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram36 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam36 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam37 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram37 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam37 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam38 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram38 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam38 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam39 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram39 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam39 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam40 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram40 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam40 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam41 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram41 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam41 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam42 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram42 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam42 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam43 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram43 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam43 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam44 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram44 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam44 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam45 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram45 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam45 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam46 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram46 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam46 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam47 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam48 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram48 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam48 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam49 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram49 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam49 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam50 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram50 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam50 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam51 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram51 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam51 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam52 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram52 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam52 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam53 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram53 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam53 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam54 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram54 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam54 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam55 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram55 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam55 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam56 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram56 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam56 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam57 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram57 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam57 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam58 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram58 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam58 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam59 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram59 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam59 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam60 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram60 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam60 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam61 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram61 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam61 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam62 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram62 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam62 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam63 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram63 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam63 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam64 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram64 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam64 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam65 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram65 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam65 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam66 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram66 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam66 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam67 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram67 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam67 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam68 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram68 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam68 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam69 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram69 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam69 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam70 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram70 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam70 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam71 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram71 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam71 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam72 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram72 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam72 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam73 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram73 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam73 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam74 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram74 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam74 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam75 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram75 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam75 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam76 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram76 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam76 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam77 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram77 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam77 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam78 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram78 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam78 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam79 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram79 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam79 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam80 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram80 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam80 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam81 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram81 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam81 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam82 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram82 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam82 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam83 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram83 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam83 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam84 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram84 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam84 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam85 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram85 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam85 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam86 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram86 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam86 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam87 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram87 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam87 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam88 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram88 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam88 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam89 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram89 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam89 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam90 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram90 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam90 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam91 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram91 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam91 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam92 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram92 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam92 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam93 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram93 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam93 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam94 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram94 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam94 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam95 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram95 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam95 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam96 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram96 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam96 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam97 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram97 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam97 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam98 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram98 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam98 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam99 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram99 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam99 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam100 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram100 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam100 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam101 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram101 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam101 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam102 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram102 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam102 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam103 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram103 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam103 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam104 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram104 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam104 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam105 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram105 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam105 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam106 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram106 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam106 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam107 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram107 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam107 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam108 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram108 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam108 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam109 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram109 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam109 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam110 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram110 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam110 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam111 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram111 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam111 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam112 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram112 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam112 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam113 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram113 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam113 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam114 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram114 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam114 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam115 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram115 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam115 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam116 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram116 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam116 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam117 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram117 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam117 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam118 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram118 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam118 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam119 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram119 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam119 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam120 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram120 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam120 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam121 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram121 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam121 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam122 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram122 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam122 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam123 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram123 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam123 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam124 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram124 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam124 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam125 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram125 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam125 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam126 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram126 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam126 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam127 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram127 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam127 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Control 1 Register" ]
    pub struct Ctrl1Pn {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Control 1 Register" ]
    pub mod ctrl1_pn {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl1Pn {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcsR {
            # [ doc = "Message ID filtering only" ]
            _00,
            # [ doc = "Message ID filtering and payload filtering" ]
            _01,
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            _10,
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            _11,
        }
        impl FcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcsR::_00 => 0,
                    FcsR::_01 => 1,
                    FcsR::_10 => 2,
                    FcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcsR {
                match bits {
                    0 => FcsR::_00,
                    1 => FcsR::_01,
                    2 => FcsR::_10,
                    3 => FcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FcsR::_11
            }
        }
        # [ doc = "Possible values of the field `IDFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdfsR {
            # [ doc = "Match upon a ID contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl IdfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdfsR::_00 => 0,
                    IdfsR::_01 => 1,
                    IdfsR::_10 => 2,
                    IdfsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdfsR {
                match bits {
                    0 => IdfsR::_00,
                    1 => IdfsR::_01,
                    2 => IdfsR::_10,
                    3 => IdfsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == IdfsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == IdfsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == IdfsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == IdfsR::_11
            }
        }
        # [ doc = "Possible values of the field `PLFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PlfsR {
            # [ doc = "Match upon a payload contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl PlfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PlfsR::_00 => 0,
                    PlfsR::_01 => 1,
                    PlfsR::_10 => 2,
                    PlfsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PlfsR {
                match bits {
                    0 => PlfsR::_00,
                    1 => PlfsR::_01,
                    2 => PlfsR::_10,
                    3 => PlfsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PlfsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PlfsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PlfsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PlfsR::_11
            }
        }
        # [ doc = "Possible values of the field `NMATCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NmatchR {
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            _00000001,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            _00000010,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            _11111111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NmatchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NmatchR::_00000001 => 1,
                    NmatchR::_00000010 => 2,
                    NmatchR::_11111111 => 255,
                    NmatchR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NmatchR {
                match bits {
                    1 => NmatchR::_00000001,
                    2 => NmatchR::_00000010,
                    255 => NmatchR::_11111111,
                    i => NmatchR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == NmatchR::_00000001
            }
            # [ doc = "Checks if the value of the field is `_00000010`" ]
            # [ inline ( always ) ]
            pub fn is_00000010(&self) -> bool {
                *self == NmatchR::_00000010
            }
            # [ doc = "Checks if the value of the field is `_11111111`" ]
            # [ inline ( always ) ]
            pub fn is_11111111(&self) -> bool {
                *self == NmatchR::_11111111
            }
        }
        # [ doc = "Possible values of the field `WUMF_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WumfMskR {
            # [ doc = "Wake up match event is disabled" ]
            _0,
            # [ doc = "Wake up match event is enabled" ]
            _1,
        }
        impl WumfMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WumfMskR::_0 => 0,
                    WumfMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WumfMskR {
                match bits {
                    0 => WumfMskR::_0,
                    1 => WumfMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WumfMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WumfMskR::_1
            }
        }
        # [ doc = "Possible values of the field `WTOF_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WtofMskR {
            # [ doc = "Timeout wake up event is disabled" ]
            _0,
            # [ doc = "Timeout wake up event is enabled" ]
            _1,
        }
        impl WtofMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WtofMskR::_0 => 0,
                    WtofMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WtofMskR {
                match bits {
                    0 => WtofMskR::_0,
                    1 => WtofMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WtofMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WtofMskR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FCS`" ]
        pub enum FcsW {
            # [ doc = "Message ID filtering only" ]
            _00,
            # [ doc = "Message ID filtering and payload filtering" ]
            _01,
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            _10,
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            _11,
        }
        impl FcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcsW::_00 => 0,
                    FcsW::_01 => 1,
                    FcsW::_10 => 2,
                    FcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Message ID filtering only" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FcsW::_00)
            }
            # [ doc = "Message ID filtering and payload filtering" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FcsW::_01)
            }
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FcsW::_10)
            }
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDFS`" ]
        pub enum IdfsW {
            # [ doc = "Match upon a ID contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl IdfsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdfsW::_00 => 0,
                    IdfsW::_01 => 1,
                    IdfsW::_10 => 2,
                    IdfsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdfsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdfsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Match upon a ID contents against an exact target value" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(IdfsW::_00)
            }
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(IdfsW::_01)
            }
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(IdfsW::_10)
            }
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(IdfsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PLFS`" ]
        pub enum PlfsW {
            # [ doc = "Match upon a payload contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl PlfsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PlfsW::_00 => 0,
                    PlfsW::_01 => 1,
                    PlfsW::_10 => 2,
                    PlfsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PlfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PlfsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PlfsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Match upon a payload contents against an exact target value" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PlfsW::_00)
            }
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PlfsW::_01)
            }
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PlfsW::_10)
            }
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PlfsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NMATCH`" ]
        pub enum NmatchW {
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            _00000001,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            _00000010,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            _11111111,
        }
        impl NmatchW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NmatchW::_00000001 => 1,
                    NmatchW::_00000010 => 2,
                    NmatchW::_11111111 => 255,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NmatchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NmatchW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NmatchW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(NmatchW::_00000001)
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _00000010(self) -> &'a mut W {
                self.variant(NmatchW::_00000010)
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _11111111(self) -> &'a mut W {
                self.variant(NmatchW::_11111111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WUMF_MSK`" ]
        pub enum WumfMskW {
            # [ doc = "Wake up match event is disabled" ]
            _0,
            # [ doc = "Wake up match event is enabled" ]
            _1,
        }
        impl WumfMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WumfMskW::_0 => 0,
                    WumfMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WumfMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WumfMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WumfMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Wake up match event is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WumfMskW::_0)
            }
            # [ doc = "Wake up match event is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WumfMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WTOF_MSK`" ]
        pub enum WtofMskW {
            # [ doc = "Timeout wake up event is disabled" ]
            _0,
            # [ doc = "Timeout wake up event is enabled" ]
            _1,
        }
        impl WtofMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WtofMskW::_0 => 0,
                    WtofMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WtofMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WtofMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WtofMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timeout wake up event is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WtofMskW::_0)
            }
            # [ doc = "Timeout wake up event is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WtofMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Filtering Combination Selection" ]
            # [ inline ( always ) ]
            pub fn fcs(&self) -> FcsR {
                FcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 2:3 - ID Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn idfs(&self) -> IdfsR {
                IdfsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 4:5 - Payload Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn plfs(&self) -> PlfsR {
                PlfsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 8:15 - Number of Messages Matching the Same Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn nmatch(&self) -> NmatchR {
                NmatchR::_from({
                                   const MASK: u8 = 255;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wumf_msk(&self) -> WumfMskR {
                WumfMskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wtof_msk(&self) -> WtofMskR {
                WtofMskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 256 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Filtering Combination Selection" ]
            # [ inline ( always ) ]
            pub fn fcs(&mut self) -> _FcsW {
                _FcsW { w: self }
            }
            # [ doc = "Bits 2:3 - ID Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn idfs(&mut self) -> _IdfsW {
                _IdfsW { w: self }
            }
            # [ doc = "Bits 4:5 - Payload Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn plfs(&mut self) -> _PlfsW {
                _PlfsW { w: self }
            }
            # [ doc = "Bits 8:15 - Number of Messages Matching the Same Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn nmatch(&mut self) -> _NmatchW {
                _NmatchW { w: self }
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wumf_msk(&mut self) -> _WumfMskW {
                _WumfMskW { w: self }
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wtof_msk(&mut self) -> _WtofMskW {
                _WtofMskW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Control 2 Register" ]
    pub struct Ctrl2Pn {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Control 2 Register" ]
    pub mod ctrl2_pn {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl2Pn {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MatchtoR {
            bits: u16,
        }
        impl MatchtoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatchtoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatchtoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timeout for No Message Matching the Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn matchto(&self) -> MatchtoR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MatchtoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timeout for No Message Matching the Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn matchto(&mut self) -> _MatchtoW {
                _MatchtoW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Wake Up Match Register" ]
    pub struct WuMtc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Wake Up Match Register" ]
    pub mod wu_mtc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::WuMtc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct McounterR {
            bits: u8,
        }
        impl McounterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WUMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WumfR {
            # [ doc = "No wake up by match event detected" ]
            _0,
            # [ doc = "Wake up by match event detected" ]
            _1,
        }
        impl WumfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WumfR::_0 => 0,
                    WumfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WumfR {
                match bits {
                    0 => WumfR::_0,
                    1 => WumfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WumfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WumfR::_1
            }
        }
        # [ doc = "Possible values of the field `WTOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WtofR {
            # [ doc = "No wake up by timeout event detected" ]
            _0,
            # [ doc = "Wake up by timeout event detected" ]
            _1,
        }
        impl WtofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WtofR::_0 => 0,
                    WtofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WtofR {
                match bits {
                    0 => WtofR::_0,
                    1 => WtofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WtofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WtofR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WUMF`" ]
        pub enum WumfW {
            # [ doc = "No wake up by match event detected" ]
            _0,
            # [ doc = "Wake up by match event detected" ]
            _1,
        }
        impl WumfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WumfW::_0 => 0,
                    WumfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WumfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WumfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WumfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No wake up by match event detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WumfW::_0)
            }
            # [ doc = "Wake up by match event detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WumfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WTOF`" ]
        pub enum WtofW {
            # [ doc = "No wake up by timeout event detected" ]
            _0,
            # [ doc = "Wake up by timeout event detected" ]
            _1,
        }
        impl WtofW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WtofW::_0 => 0,
                    WtofW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WtofW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WtofW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WtofW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No wake up by timeout event detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WtofW::_0)
            }
            # [ doc = "Wake up by timeout event detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WtofW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:15 - Number of Matches while in Pretended Networking" ]
            # [ inline ( always ) ]
            pub fn mcounter(&self) -> McounterR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                McounterR { bits }
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wumf(&self) -> WumfR {
                WumfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wtof(&self) -> WtofR {
                WtofR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wumf(&mut self) -> _WumfW {
                _WumfW { w: self }
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wtof(&mut self) -> _WtofW {
                _WtofW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking ID Filter 1 Register" ]
    pub struct FltId1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking ID Filter 1 Register" ]
    pub mod flt_id1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltId1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltId1R {
            bits: u32,
        }
        impl FltId1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FLT_RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltRtrR {
            # [ doc = "Reject remote frame (accept data frame)" ]
            _0,
            # [ doc = "Accept remote frame" ]
            _1,
        }
        impl FltRtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltRtrR::_0 => 0,
                    FltRtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltRtrR {
                match bits {
                    0 => FltRtrR::_0,
                    1 => FltRtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FltRtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FltRtrR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT_IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltIdeR {
            # [ doc = "Accept standard frame format" ]
            _0,
            # [ doc = "Accept extended frame format" ]
            _1,
        }
        impl FltIdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltIdeR::_0 => 0,
                    FltIdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltIdeR {
                match bits {
                    0 => FltIdeR::_0,
                    1 => FltIdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FltIdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FltIdeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltId1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltId1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 536870911;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT_RTR`" ]
        pub enum FltRtrW {
            # [ doc = "Reject remote frame (accept data frame)" ]
            _0,
            # [ doc = "Accept remote frame" ]
            _1,
        }
        impl FltRtrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltRtrW::_0 => 0,
                    FltRtrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltRtrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltRtrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltRtrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reject remote frame (accept data frame)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FltRtrW::_0)
            }
            # [ doc = "Accept remote frame" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FltRtrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT_IDE`" ]
        pub enum FltIdeW {
            # [ doc = "Accept standard frame format" ]
            _0,
            # [ doc = "Accept extended frame format" ]
            _1,
        }
        impl FltIdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltIdeW::_0 => 0,
                    FltIdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltIdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltIdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltIdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accept standard frame format" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FltIdeW::_0)
            }
            # [ doc = "Accept extended frame format" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FltIdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - ID Filter 1 for Pretended Networking filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id1(&self) -> FltId1R {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FltId1R { bits }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Filter" ]
            # [ inline ( always ) ]
            pub fn flt_rtr(&self) -> FltRtrR {
                FltRtrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 29;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ID Extended Filter" ]
            # [ inline ( always ) ]
            pub fn flt_ide(&self) -> FltIdeR {
                FltIdeR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:28 - ID Filter 1 for Pretended Networking filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id1(&mut self) -> _FltId1W {
                _FltId1W { w: self }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Filter" ]
            # [ inline ( always ) ]
            pub fn flt_rtr(&mut self) -> _FltRtrW {
                _FltRtrW { w: self }
            }
            # [ doc = "Bit 30 - ID Extended Filter" ]
            # [ inline ( always ) ]
            pub fn flt_ide(&mut self) -> _FltIdeW {
                _FltIdeW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking DLC Filter Register" ]
    pub struct FltDlc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking DLC Filter Register" ]
    pub mod flt_dlc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltDlc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltDlcHiR {
            bits: u8,
        }
        impl FltDlcHiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltDlcLoR {
            bits: u8,
        }
        impl FltDlcLoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltDlcHiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltDlcHiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltDlcLoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltDlcLoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Upper Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_hi(&self) -> FltDlcHiR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FltDlcHiR { bits }
            }
            # [ doc = "Bits 16:19 - Lower Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_lo(&self) -> FltDlcLoR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FltDlcLoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 8 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Upper Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_hi(&mut self) -> _FltDlcHiW {
                _FltDlcHiW { w: self }
            }
            # [ doc = "Bits 16:19 - Lower Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_lo(&mut self) -> _FltDlcLoW {
                _FltDlcLoW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload Low Filter 1 Register" ]
    pub struct Pl1Lo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload Low Filter 1 Register" ]
    pub mod pl1_lo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl1Lo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload High Filter 1 Register" ]
    pub struct Pl1Hi {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload High Filter 1 Register" ]
    pub mod pl1_hi {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl1Hi {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&mut self) -> _DataByte7W {
                _DataByte7W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&mut self) -> _DataByte6W {
                _DataByte6W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&mut self) -> _DataByte5W {
                _DataByte5W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&mut self) -> _DataByte4W {
                _DataByte4W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking ID Filter 2 Register / ID Mask Register" ]
    pub struct FltId2Idmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking ID Filter 2 Register / ID Mask Register" ]
    pub mod flt_id2_idmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltId2Idmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltId2IdmaskR {
            bits: u32,
        }
        impl FltId2IdmaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrMskR {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl RtrMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrMskR::_0 => 0,
                    RtrMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrMskR {
                match bits {
                    0 => RtrMskR::_0,
                    1 => RtrMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrMskR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeMskR {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl IdeMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeMskR::_0 => 0,
                    IdeMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeMskR {
                match bits {
                    0 => IdeMskR::_0,
                    1 => IdeMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeMskR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltId2IdmaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltId2IdmaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 536870911;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTR_MSK`" ]
        pub enum RtrMskW {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl RtrMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtrMskW::_0 => 0,
                    RtrMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtrMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtrMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtrMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtrMskW::_0)
            }
            # [ doc = "The corresponding bit in the filter is checked" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtrMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDE_MSK`" ]
        pub enum IdeMskW {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl IdeMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdeMskW::_0 => 0,
                    IdeMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdeMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdeMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdeMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IdeMskW::_0)
            }
            # [ doc = "The corresponding bit in the filter is checked" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IdeMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - ID Filter 2 for Pretended Networking Filtering / ID Mask Bits for Pretended Networking ID Filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id2_idmask(&self) -> FltId2IdmaskR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FltId2IdmaskR { bits }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Mask Bit" ]
            # [ inline ( always ) ]
            pub fn rtr_msk(&self) -> RtrMskR {
                RtrMskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 29;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ID Extended Mask Bit" ]
            # [ inline ( always ) ]
            pub fn ide_msk(&self) -> IdeMskR {
                IdeMskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:28 - ID Filter 2 for Pretended Networking Filtering / ID Mask Bits for Pretended Networking ID Filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id2_idmask(&mut self) -> _FltId2IdmaskW {
                _FltId2IdmaskW { w: self }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Mask Bit" ]
            # [ inline ( always ) ]
            pub fn rtr_msk(&mut self) -> _RtrMskW {
                _RtrMskW { w: self }
            }
            # [ doc = "Bit 30 - ID Extended Mask Bit" ]
            # [ inline ( always ) ]
            pub fn ide_msk(&mut self) -> _IdeMskW {
                _IdeMskW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
    pub struct Pl2PlmaskLo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
    pub mod pl2_plmask_lo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl2PlmaskLo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
    pub struct Pl2PlmaskHi {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
    pub mod pl2_plmask_hi {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl2PlmaskHi {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&mut self) -> _DataByte7W {
                _DataByte7W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&mut self) -> _DataByte6W {
                _DataByte6W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&mut self) -> _DataByte5W {
                _DataByte5W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&mut self) -> _DataByte4W {
                _DataByte4W { w: self }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb0Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb0_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb0Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb0_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb0D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb0_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb0D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb0_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb1Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb1_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb1Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb1_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb1D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb1_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb1D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb1_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb2Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb2_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb2Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb2_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb2D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb2_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb2D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb2_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb3Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb3_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb3Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb3_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb3D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb3_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb3D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb3_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "CAN FD Control Register" ]
    pub struct Fdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD Control Register" ]
    pub mod fdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TdcvalR {
            bits: u8,
        }
        impl TdcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TdcoffR {
            bits: u8,
        }
        impl TdcoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TDCFAIL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdcfailR {
            # [ doc = "Measured loop delay is in range." ]
            _0,
            # [ doc = "Measured loop delay is out of range." ]
            _1,
        }
        impl TdcfailR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdcfailR::_0 => 0,
                    TdcfailR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdcfailR {
                match bits {
                    0 => TdcfailR::_0,
                    1 => TdcfailR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdcfailR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdcfailR::_1
            }
        }
        # [ doc = "Possible values of the field `TDCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdcenR {
            # [ doc = "TDC is disabled" ]
            _0,
            # [ doc = "TDC is enabled" ]
            _1,
        }
        impl TdcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdcenR::_0 => 0,
                    TdcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdcenR {
                match bits {
                    0 => TdcenR::_0,
                    1 => TdcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdcenR::_1
            }
        }
        # [ doc = "Possible values of the field `MBDSR0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mbdsr0R {
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            _00,
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            _01,
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            _10,
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            _11,
        }
        impl Mbdsr0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mbdsr0R::_00 => 0,
                    Mbdsr0R::_01 => 1,
                    Mbdsr0R::_10 => 2,
                    Mbdsr0R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mbdsr0R {
                match bits {
                    0 => Mbdsr0R::_00,
                    1 => Mbdsr0R::_01,
                    2 => Mbdsr0R::_10,
                    3 => Mbdsr0R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Mbdsr0R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Mbdsr0R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Mbdsr0R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Mbdsr0R::_11
            }
        }
        # [ doc = "Possible values of the field `FDRATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdrateR {
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            _0,
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            _1,
        }
        impl FdrateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdrateR::_0 => 0,
                    FdrateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdrateR {
                match bits {
                    0 => FdrateR::_0,
                    1 => FdrateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdrateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdrateR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDCFAIL`" ]
        pub enum TdcfailW {
            # [ doc = "Measured loop delay is in range." ]
            _0,
            # [ doc = "Measured loop delay is out of range." ]
            _1,
        }
        impl TdcfailW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdcfailW::_0 => 0,
                    TdcfailW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcfailW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcfailW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdcfailW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Measured loop delay is in range." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdcfailW::_0)
            }
            # [ doc = "Measured loop delay is out of range." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdcfailW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDCEN`" ]
        pub enum TdcenW {
            # [ doc = "TDC is disabled" ]
            _0,
            # [ doc = "TDC is enabled" ]
            _1,
        }
        impl TdcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdcenW::_0 => 0,
                    TdcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TDC is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdcenW::_0)
            }
            # [ doc = "TDC is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MBDSR0`" ]
        pub enum Mbdsr0W {
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            _00,
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            _01,
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            _10,
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            _11,
        }
        impl Mbdsr0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mbdsr0W::_00 => 0,
                    Mbdsr0W::_01 => 1,
                    Mbdsr0W::_10 => 2,
                    Mbdsr0W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mbdsr0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mbdsr0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mbdsr0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Mbdsr0W::_00)
            }
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Mbdsr0W::_01)
            }
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Mbdsr0W::_10)
            }
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Mbdsr0W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDRATE`" ]
        pub enum FdrateW {
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            _0,
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            _1,
        }
        impl FdrateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdrateW::_0 => 0,
                    FdrateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdrateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdrateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdrateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdrateW::_0)
            }
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdrateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Transceiver Delay Compensation Value" ]
            # [ inline ( always ) ]
            pub fn tdcval(&self) -> TdcvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TdcvalR { bits }
            }
            # [ doc = "Bits 8:12 - Transceiver Delay Compensation Offset" ]
            # [ inline ( always ) ]
            pub fn tdcoff(&self) -> TdcoffR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TdcoffR { bits }
            }
            # [ doc = "Bit 14 - Transceiver Delay Compensation Fail" ]
            # [ inline ( always ) ]
            pub fn tdcfail(&self) -> TdcfailR {
                TdcfailR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Transceiver Delay Compensation Enable" ]
            # [ inline ( always ) ]
            pub fn tdcen(&self) -> TdcenR {
                TdcenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 16:17 - Message Buffer Data Size for Region 0" ]
            # [ inline ( always ) ]
            pub fn mbdsr0(&self) -> Mbdsr0R {
                Mbdsr0R::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - Bit Rate Switch Enable" ]
            # [ inline ( always ) ]
            pub fn fdrate(&self) -> FdrateR {
                FdrateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483904 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 8:12 - Transceiver Delay Compensation Offset" ]
            # [ inline ( always ) ]
            pub fn tdcoff(&mut self) -> _TdcoffW {
                _TdcoffW { w: self }
            }
            # [ doc = "Bit 14 - Transceiver Delay Compensation Fail" ]
            # [ inline ( always ) ]
            pub fn tdcfail(&mut self) -> _TdcfailW {
                _TdcfailW { w: self }
            }
            # [ doc = "Bit 15 - Transceiver Delay Compensation Enable" ]
            # [ inline ( always ) ]
            pub fn tdcen(&mut self) -> _TdcenW {
                _TdcenW { w: self }
            }
            # [ doc = "Bits 16:17 - Message Buffer Data Size for Region 0" ]
            # [ inline ( always ) ]
            pub fn mbdsr0(&mut self) -> _Mbdsr0W {
                _Mbdsr0W { w: self }
            }
            # [ doc = "Bit 31 - Bit Rate Switch Enable" ]
            # [ inline ( always ) ]
            pub fn fdrate(&mut self) -> _FdrateW {
                _FdrateW { w: self }
            }
        }
    }
    # [ doc = "CAN FD Bit Timing Register" ]
    pub struct Fdcbt {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD Bit Timing Register" ]
    pub mod fdcbt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fdcbt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Fpseg2R {
            bits: u8,
        }
        impl Fpseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Fpseg1R {
            bits: u8,
        }
        impl Fpseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FpropsegR {
            bits: u8,
        }
        impl FpropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FrjwR {
            bits: u8,
        }
        impl FrjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FpresdivR {
            bits: u16,
        }
        impl FpresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fpseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fpseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fpseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fpseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Fast Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn fpseg2(&self) -> Fpseg2R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Fpseg2R { bits }
            }
            # [ doc = "Bits 5:7 - Fast Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn fpseg1(&self) -> Fpseg1R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Fpseg1R { bits }
            }
            # [ doc = "Bits 10:14 - Fast Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn fpropseg(&self) -> FpropsegR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FpropsegR { bits }
            }
            # [ doc = "Bits 16:18 - Fast Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn frjw(&self) -> FrjwR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FrjwR { bits }
            }
            # [ doc = "Bits 20:29 - Fast Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn fpresdiv(&self) -> FpresdivR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FpresdivR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Fast Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn fpseg2(&mut self) -> _Fpseg2W {
                _Fpseg2W { w: self }
            }
            # [ doc = "Bits 5:7 - Fast Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn fpseg1(&mut self) -> _Fpseg1W {
                _Fpseg1W { w: self }
            }
            # [ doc = "Bits 10:14 - Fast Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn fpropseg(&mut self) -> _FpropsegW {
                _FpropsegW { w: self }
            }
            # [ doc = "Bits 16:18 - Fast Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn frjw(&mut self) -> _FrjwW {
                _FrjwW { w: self }
            }
            # [ doc = "Bits 20:29 - Fast Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn fpresdiv(&mut self) -> _FpresdivW {
                _FpresdivW { w: self }
            }
        }
    }
    # [ doc = "CAN FD CRC Register" ]
    pub struct Fdcrc {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD CRC Register" ]
    pub mod fdcrc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Fdcrc {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FdTxcrcR {
            bits: u32,
        }
        impl FdTxcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FdMbcrcR {
            bits: u8,
        }
        impl FdMbcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:20 - Extended Transmitted CRC value" ]
            # [ inline ( always ) ]
            pub fn fd_txcrc(&self) -> FdTxcrcR {
                let bits = {
                    const MASK: u32 = 2097151;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FdTxcrcR { bits }
            }
            # [ doc = "Bits 24:30 - CRC Mailbox Number for FD_TXCRC" ]
            # [ inline ( always ) ]
            pub fn fd_mbcrc(&self) -> FdMbcrcR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FdMbcrcR { bits }
            }
        }
    }
}
# [ doc = "Flex Controller Area Network module" ]
pub struct Can0 {
    register_block: can0::RegisterBlock,
}
impl Deref for Can0 {
    type Target = can0::RegisterBlock;
    fn deref(&self) -> &can0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Flex Controller Area Network module" ]
pub const CAN1: Peripheral<Can1> = unsafe { Peripheral::new(1073893376) };
# [ doc = "Flex Controller Area Network module" ]
pub mod can1 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Module Configuration Register" ]
        pub mcr: Mcr,
        # [ doc = "0x04 - Control 1 register" ]
        pub ctrl1: Ctrl1,
        # [ doc = "0x08 - Free Running Timer" ]
        pub timer: Timer,
        _reserved0: [u8; 4usize],
        # [ doc = "0x10 - Rx Mailboxes Global Mask Register" ]
        pub rxmgmask: Rxmgmask,
        # [ doc = "0x14 - Rx 14 Mask register" ]
        pub rx14mask: Rx14mask,
        # [ doc = "0x18 - Rx 15 Mask register" ]
        pub rx15mask: Rx15mask,
        # [ doc = "0x1c - Error Counter" ]
        pub ecr: Ecr,
        # [ doc = "0x20 - Error and Status 1 register" ]
        pub esr1: Esr1,
        _reserved1: [u8; 4usize],
        # [ doc = "0x28 - Interrupt Masks 1 register" ]
        pub imask1: Imask1,
        _reserved2: [u8; 4usize],
        # [ doc = "0x30 - Interrupt Flags 1 register" ]
        pub iflag1: Iflag1,
        # [ doc = "0x34 - Control 2 register" ]
        pub ctrl2: Ctrl2,
        # [ doc = "0x38 - Error and Status 2 register" ]
        pub esr2: Esr2,
        _reserved3: [u8; 8usize],
        # [ doc = "0x44 - CRC Register" ]
        pub crcr: Crcr,
        # [ doc = "0x48 - Rx FIFO Global Mask register" ]
        pub rxfgmask: Rxfgmask,
        # [ doc = "0x4c - Rx FIFO Information Register" ]
        pub rxfir: Rxfir,
        # [ doc = "0x50 - CAN Bit Timing Register" ]
        pub cbt: Cbt,
        _reserved4: [u8; 44usize],
        # [ doc = "0x80 - Embedded RAM" ]
        pub embedded_ram0: EmbeddedRam0,
        # [ doc = "0x84 - Embedded RAM" ]
        pub embedded_ram1: EmbeddedRam1,
        # [ doc = "0x88 - Embedded RAM" ]
        pub embedded_ram2: EmbeddedRam2,
        # [ doc = "0x8c - Embedded RAM" ]
        pub embedded_ram3: EmbeddedRam3,
        # [ doc = "0x90 - Embedded RAM" ]
        pub embedded_ram4: EmbeddedRam4,
        # [ doc = "0x94 - Embedded RAM" ]
        pub embedded_ram5: EmbeddedRam5,
        # [ doc = "0x98 - Embedded RAM" ]
        pub embedded_ram6: EmbeddedRam6,
        # [ doc = "0x9c - Embedded RAM" ]
        pub embedded_ram7: EmbeddedRam7,
        # [ doc = "0xa0 - Embedded RAM" ]
        pub embedded_ram8: EmbeddedRam8,
        # [ doc = "0xa4 - Embedded RAM" ]
        pub embedded_ram9: EmbeddedRam9,
        # [ doc = "0xa8 - Embedded RAM" ]
        pub embedded_ram10: EmbeddedRam10,
        # [ doc = "0xac - Embedded RAM" ]
        pub embedded_ram11: EmbeddedRam11,
        # [ doc = "0xb0 - Embedded RAM" ]
        pub embedded_ram12: EmbeddedRam12,
        # [ doc = "0xb4 - Embedded RAM" ]
        pub embedded_ram13: EmbeddedRam13,
        # [ doc = "0xb8 - Embedded RAM" ]
        pub embedded_ram14: EmbeddedRam14,
        # [ doc = "0xbc - Embedded RAM" ]
        pub embedded_ram15: EmbeddedRam15,
        # [ doc = "0xc0 - Embedded RAM" ]
        pub embedded_ram16: EmbeddedRam16,
        # [ doc = "0xc4 - Embedded RAM" ]
        pub embedded_ram17: EmbeddedRam17,
        # [ doc = "0xc8 - Embedded RAM" ]
        pub embedded_ram18: EmbeddedRam18,
        # [ doc = "0xcc - Embedded RAM" ]
        pub embedded_ram19: EmbeddedRam19,
        # [ doc = "0xd0 - Embedded RAM" ]
        pub embedded_ram20: EmbeddedRam20,
        # [ doc = "0xd4 - Embedded RAM" ]
        pub embedded_ram21: EmbeddedRam21,
        # [ doc = "0xd8 - Embedded RAM" ]
        pub embedded_ram22: EmbeddedRam22,
        # [ doc = "0xdc - Embedded RAM" ]
        pub embedded_ram23: EmbeddedRam23,
        # [ doc = "0xe0 - Embedded RAM" ]
        pub embedded_ram24: EmbeddedRam24,
        # [ doc = "0xe4 - Embedded RAM" ]
        pub embedded_ram25: EmbeddedRam25,
        # [ doc = "0xe8 - Embedded RAM" ]
        pub embedded_ram26: EmbeddedRam26,
        # [ doc = "0xec - Embedded RAM" ]
        pub embedded_ram27: EmbeddedRam27,
        # [ doc = "0xf0 - Embedded RAM" ]
        pub embedded_ram28: EmbeddedRam28,
        # [ doc = "0xf4 - Embedded RAM" ]
        pub embedded_ram29: EmbeddedRam29,
        # [ doc = "0xf8 - Embedded RAM" ]
        pub embedded_ram30: EmbeddedRam30,
        # [ doc = "0xfc - Embedded RAM" ]
        pub embedded_ram31: EmbeddedRam31,
        # [ doc = "0x100 - Embedded RAM" ]
        pub embedded_ram32: EmbeddedRam32,
        # [ doc = "0x104 - Embedded RAM" ]
        pub embedded_ram33: EmbeddedRam33,
        # [ doc = "0x108 - Embedded RAM" ]
        pub embedded_ram34: EmbeddedRam34,
        # [ doc = "0x10c - Embedded RAM" ]
        pub embedded_ram35: EmbeddedRam35,
        # [ doc = "0x110 - Embedded RAM" ]
        pub embedded_ram36: EmbeddedRam36,
        # [ doc = "0x114 - Embedded RAM" ]
        pub embedded_ram37: EmbeddedRam37,
        # [ doc = "0x118 - Embedded RAM" ]
        pub embedded_ram38: EmbeddedRam38,
        # [ doc = "0x11c - Embedded RAM" ]
        pub embedded_ram39: EmbeddedRam39,
        # [ doc = "0x120 - Embedded RAM" ]
        pub embedded_ram40: EmbeddedRam40,
        # [ doc = "0x124 - Embedded RAM" ]
        pub embedded_ram41: EmbeddedRam41,
        # [ doc = "0x128 - Embedded RAM" ]
        pub embedded_ram42: EmbeddedRam42,
        # [ doc = "0x12c - Embedded RAM" ]
        pub embedded_ram43: EmbeddedRam43,
        # [ doc = "0x130 - Embedded RAM" ]
        pub embedded_ram44: EmbeddedRam44,
        # [ doc = "0x134 - Embedded RAM" ]
        pub embedded_ram45: EmbeddedRam45,
        # [ doc = "0x138 - Embedded RAM" ]
        pub embedded_ram46: EmbeddedRam46,
        # [ doc = "0x13c - Embedded RAM" ]
        pub embedded_ram47: EmbeddedRam47,
        # [ doc = "0x140 - Embedded RAM" ]
        pub embedded_ram48: EmbeddedRam48,
        # [ doc = "0x144 - Embedded RAM" ]
        pub embedded_ram49: EmbeddedRam49,
        # [ doc = "0x148 - Embedded RAM" ]
        pub embedded_ram50: EmbeddedRam50,
        # [ doc = "0x14c - Embedded RAM" ]
        pub embedded_ram51: EmbeddedRam51,
        # [ doc = "0x150 - Embedded RAM" ]
        pub embedded_ram52: EmbeddedRam52,
        # [ doc = "0x154 - Embedded RAM" ]
        pub embedded_ram53: EmbeddedRam53,
        # [ doc = "0x158 - Embedded RAM" ]
        pub embedded_ram54: EmbeddedRam54,
        # [ doc = "0x15c - Embedded RAM" ]
        pub embedded_ram55: EmbeddedRam55,
        # [ doc = "0x160 - Embedded RAM" ]
        pub embedded_ram56: EmbeddedRam56,
        # [ doc = "0x164 - Embedded RAM" ]
        pub embedded_ram57: EmbeddedRam57,
        # [ doc = "0x168 - Embedded RAM" ]
        pub embedded_ram58: EmbeddedRam58,
        # [ doc = "0x16c - Embedded RAM" ]
        pub embedded_ram59: EmbeddedRam59,
        # [ doc = "0x170 - Embedded RAM" ]
        pub embedded_ram60: EmbeddedRam60,
        # [ doc = "0x174 - Embedded RAM" ]
        pub embedded_ram61: EmbeddedRam61,
        # [ doc = "0x178 - Embedded RAM" ]
        pub embedded_ram62: EmbeddedRam62,
        # [ doc = "0x17c - Embedded RAM" ]
        pub embedded_ram63: EmbeddedRam63,
        # [ doc = "0x180 - Embedded RAM" ]
        pub embedded_ram64: EmbeddedRam64,
        # [ doc = "0x184 - Embedded RAM" ]
        pub embedded_ram65: EmbeddedRam65,
        # [ doc = "0x188 - Embedded RAM" ]
        pub embedded_ram66: EmbeddedRam66,
        # [ doc = "0x18c - Embedded RAM" ]
        pub embedded_ram67: EmbeddedRam67,
        # [ doc = "0x190 - Embedded RAM" ]
        pub embedded_ram68: EmbeddedRam68,
        # [ doc = "0x194 - Embedded RAM" ]
        pub embedded_ram69: EmbeddedRam69,
        # [ doc = "0x198 - Embedded RAM" ]
        pub embedded_ram70: EmbeddedRam70,
        # [ doc = "0x19c - Embedded RAM" ]
        pub embedded_ram71: EmbeddedRam71,
        # [ doc = "0x1a0 - Embedded RAM" ]
        pub embedded_ram72: EmbeddedRam72,
        # [ doc = "0x1a4 - Embedded RAM" ]
        pub embedded_ram73: EmbeddedRam73,
        # [ doc = "0x1a8 - Embedded RAM" ]
        pub embedded_ram74: EmbeddedRam74,
        # [ doc = "0x1ac - Embedded RAM" ]
        pub embedded_ram75: EmbeddedRam75,
        # [ doc = "0x1b0 - Embedded RAM" ]
        pub embedded_ram76: EmbeddedRam76,
        # [ doc = "0x1b4 - Embedded RAM" ]
        pub embedded_ram77: EmbeddedRam77,
        # [ doc = "0x1b8 - Embedded RAM" ]
        pub embedded_ram78: EmbeddedRam78,
        # [ doc = "0x1bc - Embedded RAM" ]
        pub embedded_ram79: EmbeddedRam79,
        # [ doc = "0x1c0 - Embedded RAM" ]
        pub embedded_ram80: EmbeddedRam80,
        # [ doc = "0x1c4 - Embedded RAM" ]
        pub embedded_ram81: EmbeddedRam81,
        # [ doc = "0x1c8 - Embedded RAM" ]
        pub embedded_ram82: EmbeddedRam82,
        # [ doc = "0x1cc - Embedded RAM" ]
        pub embedded_ram83: EmbeddedRam83,
        # [ doc = "0x1d0 - Embedded RAM" ]
        pub embedded_ram84: EmbeddedRam84,
        # [ doc = "0x1d4 - Embedded RAM" ]
        pub embedded_ram85: EmbeddedRam85,
        # [ doc = "0x1d8 - Embedded RAM" ]
        pub embedded_ram86: EmbeddedRam86,
        # [ doc = "0x1dc - Embedded RAM" ]
        pub embedded_ram87: EmbeddedRam87,
        # [ doc = "0x1e0 - Embedded RAM" ]
        pub embedded_ram88: EmbeddedRam88,
        # [ doc = "0x1e4 - Embedded RAM" ]
        pub embedded_ram89: EmbeddedRam89,
        # [ doc = "0x1e8 - Embedded RAM" ]
        pub embedded_ram90: EmbeddedRam90,
        # [ doc = "0x1ec - Embedded RAM" ]
        pub embedded_ram91: EmbeddedRam91,
        # [ doc = "0x1f0 - Embedded RAM" ]
        pub embedded_ram92: EmbeddedRam92,
        # [ doc = "0x1f4 - Embedded RAM" ]
        pub embedded_ram93: EmbeddedRam93,
        # [ doc = "0x1f8 - Embedded RAM" ]
        pub embedded_ram94: EmbeddedRam94,
        # [ doc = "0x1fc - Embedded RAM" ]
        pub embedded_ram95: EmbeddedRam95,
        # [ doc = "0x200 - Embedded RAM" ]
        pub embedded_ram96: EmbeddedRam96,
        # [ doc = "0x204 - Embedded RAM" ]
        pub embedded_ram97: EmbeddedRam97,
        # [ doc = "0x208 - Embedded RAM" ]
        pub embedded_ram98: EmbeddedRam98,
        # [ doc = "0x20c - Embedded RAM" ]
        pub embedded_ram99: EmbeddedRam99,
        # [ doc = "0x210 - Embedded RAM" ]
        pub embedded_ram100: EmbeddedRam100,
        # [ doc = "0x214 - Embedded RAM" ]
        pub embedded_ram101: EmbeddedRam101,
        # [ doc = "0x218 - Embedded RAM" ]
        pub embedded_ram102: EmbeddedRam102,
        # [ doc = "0x21c - Embedded RAM" ]
        pub embedded_ram103: EmbeddedRam103,
        # [ doc = "0x220 - Embedded RAM" ]
        pub embedded_ram104: EmbeddedRam104,
        # [ doc = "0x224 - Embedded RAM" ]
        pub embedded_ram105: EmbeddedRam105,
        # [ doc = "0x228 - Embedded RAM" ]
        pub embedded_ram106: EmbeddedRam106,
        # [ doc = "0x22c - Embedded RAM" ]
        pub embedded_ram107: EmbeddedRam107,
        # [ doc = "0x230 - Embedded RAM" ]
        pub embedded_ram108: EmbeddedRam108,
        # [ doc = "0x234 - Embedded RAM" ]
        pub embedded_ram109: EmbeddedRam109,
        # [ doc = "0x238 - Embedded RAM" ]
        pub embedded_ram110: EmbeddedRam110,
        # [ doc = "0x23c - Embedded RAM" ]
        pub embedded_ram111: EmbeddedRam111,
        # [ doc = "0x240 - Embedded RAM" ]
        pub embedded_ram112: EmbeddedRam112,
        # [ doc = "0x244 - Embedded RAM" ]
        pub embedded_ram113: EmbeddedRam113,
        # [ doc = "0x248 - Embedded RAM" ]
        pub embedded_ram114: EmbeddedRam114,
        # [ doc = "0x24c - Embedded RAM" ]
        pub embedded_ram115: EmbeddedRam115,
        # [ doc = "0x250 - Embedded RAM" ]
        pub embedded_ram116: EmbeddedRam116,
        # [ doc = "0x254 - Embedded RAM" ]
        pub embedded_ram117: EmbeddedRam117,
        # [ doc = "0x258 - Embedded RAM" ]
        pub embedded_ram118: EmbeddedRam118,
        # [ doc = "0x25c - Embedded RAM" ]
        pub embedded_ram119: EmbeddedRam119,
        # [ doc = "0x260 - Embedded RAM" ]
        pub embedded_ram120: EmbeddedRam120,
        # [ doc = "0x264 - Embedded RAM" ]
        pub embedded_ram121: EmbeddedRam121,
        # [ doc = "0x268 - Embedded RAM" ]
        pub embedded_ram122: EmbeddedRam122,
        # [ doc = "0x26c - Embedded RAM" ]
        pub embedded_ram123: EmbeddedRam123,
        # [ doc = "0x270 - Embedded RAM" ]
        pub embedded_ram124: EmbeddedRam124,
        # [ doc = "0x274 - Embedded RAM" ]
        pub embedded_ram125: EmbeddedRam125,
        # [ doc = "0x278 - Embedded RAM" ]
        pub embedded_ram126: EmbeddedRam126,
        # [ doc = "0x27c - Embedded RAM" ]
        pub embedded_ram127: EmbeddedRam127,
        _reserved5: [u8; 1536usize],
        # [ doc = "0x880 - Rx Individual Mask Registers" ]
        pub rximr0: Rximr0,
        # [ doc = "0x884 - Rx Individual Mask Registers" ]
        pub rximr1: Rximr1,
        # [ doc = "0x888 - Rx Individual Mask Registers" ]
        pub rximr2: Rximr2,
        # [ doc = "0x88c - Rx Individual Mask Registers" ]
        pub rximr3: Rximr3,
        # [ doc = "0x890 - Rx Individual Mask Registers" ]
        pub rximr4: Rximr4,
        # [ doc = "0x894 - Rx Individual Mask Registers" ]
        pub rximr5: Rximr5,
        # [ doc = "0x898 - Rx Individual Mask Registers" ]
        pub rximr6: Rximr6,
        # [ doc = "0x89c - Rx Individual Mask Registers" ]
        pub rximr7: Rximr7,
        # [ doc = "0x8a0 - Rx Individual Mask Registers" ]
        pub rximr8: Rximr8,
        # [ doc = "0x8a4 - Rx Individual Mask Registers" ]
        pub rximr9: Rximr9,
        # [ doc = "0x8a8 - Rx Individual Mask Registers" ]
        pub rximr10: Rximr10,
        # [ doc = "0x8ac - Rx Individual Mask Registers" ]
        pub rximr11: Rximr11,
        # [ doc = "0x8b0 - Rx Individual Mask Registers" ]
        pub rximr12: Rximr12,
        # [ doc = "0x8b4 - Rx Individual Mask Registers" ]
        pub rximr13: Rximr13,
        # [ doc = "0x8b8 - Rx Individual Mask Registers" ]
        pub rximr14: Rximr14,
        # [ doc = "0x8bc - Rx Individual Mask Registers" ]
        pub rximr15: Rximr15,
        _reserved6: [u8; 576usize],
        # [ doc = "0xb00 - Pretended Networking Control 1 Register" ]
        pub ctrl1_pn: Ctrl1Pn,
        # [ doc = "0xb04 - Pretended Networking Control 2 Register" ]
        pub ctrl2_pn: Ctrl2Pn,
        # [ doc = "0xb08 - Pretended Networking Wake Up Match Register" ]
        pub wu_mtc: WuMtc,
        # [ doc = "0xb0c - Pretended Networking ID Filter 1 Register" ]
        pub flt_id1: FltId1,
        # [ doc = "0xb10 - Pretended Networking DLC Filter Register" ]
        pub flt_dlc: FltDlc,
        # [ doc = "0xb14 - Pretended Networking Payload Low Filter 1 Register" ]
        pub pl1_lo: Pl1Lo,
        # [ doc = "0xb18 - Pretended Networking Payload High Filter 1 Register" ]
        pub pl1_hi: Pl1Hi,
        # [ doc = "0xb1c - Pretended Networking ID Filter 2 Register / ID Mask Register" ]
        pub flt_id2_idmask: FltId2Idmask,
        # [ doc = "0xb20 - Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
        pub pl2_plmask_lo: Pl2PlmaskLo,
        # [ doc = "0xb24 - Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
        pub pl2_plmask_hi: Pl2PlmaskHi,
        _reserved7: [u8; 24usize],
        # [ doc = "0xb40 - Wake Up Message Buffer Register for C/S" ]
        pub wmb0_cs: Wmb0Cs,
        # [ doc = "0xb44 - Wake Up Message Buffer Register for ID" ]
        pub wmb0_id: Wmb0Id,
        # [ doc = "0xb48 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb0_d03: Wmb0D03,
        # [ doc = "0xb4c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb0_d47: Wmb0D47,
        # [ doc = "0xb50 - Wake Up Message Buffer Register for C/S" ]
        pub wmb1_cs: Wmb1Cs,
        # [ doc = "0xb54 - Wake Up Message Buffer Register for ID" ]
        pub wmb1_id: Wmb1Id,
        # [ doc = "0xb58 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb1_d03: Wmb1D03,
        # [ doc = "0xb5c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb1_d47: Wmb1D47,
        # [ doc = "0xb60 - Wake Up Message Buffer Register for C/S" ]
        pub wmb2_cs: Wmb2Cs,
        # [ doc = "0xb64 - Wake Up Message Buffer Register for ID" ]
        pub wmb2_id: Wmb2Id,
        # [ doc = "0xb68 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb2_d03: Wmb2D03,
        # [ doc = "0xb6c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb2_d47: Wmb2D47,
        # [ doc = "0xb70 - Wake Up Message Buffer Register for C/S" ]
        pub wmb3_cs: Wmb3Cs,
        # [ doc = "0xb74 - Wake Up Message Buffer Register for ID" ]
        pub wmb3_id: Wmb3Id,
        # [ doc = "0xb78 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb3_d03: Wmb3D03,
        # [ doc = "0xb7c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb3_d47: Wmb3D47,
        _reserved8: [u8; 128usize],
        # [ doc = "0xc00 - CAN FD Control Register" ]
        pub fdctrl: Fdctrl,
        # [ doc = "0xc04 - CAN FD Bit Timing Register" ]
        pub fdcbt: Fdcbt,
        # [ doc = "0xc08 - CAN FD CRC Register" ]
        pub fdcrc: Fdcrc,
    }
    # [ doc = "Module Configuration Register" ]
    pub struct Mcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Module Configuration Register" ]
    pub mod mcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MaxmbR {
            bits: u8,
        }
        impl MaxmbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `IDAM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdamR {
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            _00,
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            _01,
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            _10,
            # [ doc = "Format D: All frames rejected." ]
            _11,
        }
        impl IdamR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdamR::_00 => 0,
                    IdamR::_01 => 1,
                    IdamR::_10 => 2,
                    IdamR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdamR {
                match bits {
                    0 => IdamR::_00,
                    1 => IdamR::_01,
                    2 => IdamR::_10,
                    3 => IdamR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == IdamR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == IdamR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == IdamR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == IdamR::_11
            }
        }
        # [ doc = "Possible values of the field `FDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdenR {
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            _1,
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            _0,
        }
        impl FdenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdenR::_1 => 1,
                    FdenR::_0 => 0,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdenR {
                match bits {
                    1 => FdenR::_1,
                    0 => FdenR::_0,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdenR::_1
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdenR::_0
            }
        }
        # [ doc = "Possible values of the field `AEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AenR {
            # [ doc = "Abort disabled." ]
            _0,
            # [ doc = "Abort enabled." ]
            _1,
        }
        impl AenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AenR::_0 => 0,
                    AenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AenR {
                match bits {
                    0 => AenR::_0,
                    1 => AenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AenR::_1
            }
        }
        # [ doc = "Possible values of the field `LPRIOEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LprioenR {
            # [ doc = "Local Priority disabled." ]
            _0,
            # [ doc = "Local Priority enabled." ]
            _1,
        }
        impl LprioenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LprioenR::_0 => 0,
                    LprioenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LprioenR {
                match bits {
                    0 => LprioenR::_0,
                    1 => LprioenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LprioenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LprioenR::_1
            }
        }
        # [ doc = "Possible values of the field `PNET_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PnetEnR {
            # [ doc = "Pretended Networking mode is disabled." ]
            _0,
            # [ doc = "Pretended Networking mode is enabled." ]
            _1,
        }
        impl PnetEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PnetEnR::_0 => 0,
                    PnetEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PnetEnR {
                match bits {
                    0 => PnetEnR::_0,
                    1 => PnetEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PnetEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PnetEnR::_1
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "DMA feature for RX FIFO disabled." ]
            _0,
            # [ doc = "DMA feature for RX FIFO enabled." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `IRMQ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrmqR {
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            _0,
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            _1,
        }
        impl IrmqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrmqR::_0 => 0,
                    IrmqR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrmqR {
                match bits {
                    0 => IrmqR::_0,
                    1 => IrmqR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IrmqR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IrmqR::_1
            }
        }
        # [ doc = "Possible values of the field `SRXDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SrxdisR {
            # [ doc = "Self reception enabled." ]
            _0,
            # [ doc = "Self reception disabled." ]
            _1,
        }
        impl SrxdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SrxdisR::_0 => 0,
                    SrxdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SrxdisR {
                match bits {
                    0 => SrxdisR::_0,
                    1 => SrxdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SrxdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SrxdisR::_1
            }
        }
        # [ doc = "Possible values of the field `LPMACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpmackR {
            # [ doc = "FlexCAN is not in a low-power mode." ]
            _0,
            # [ doc = "FlexCAN is in a low-power mode." ]
            _1,
        }
        impl LpmackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpmackR::_0 => 0,
                    LpmackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpmackR {
                match bits {
                    0 => LpmackR::_0,
                    1 => LpmackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpmackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpmackR::_1
            }
        }
        # [ doc = "Possible values of the field `WRNEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WrnenR {
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            _0,
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl WrnenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WrnenR::_0 => 0,
                    WrnenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WrnenR {
                match bits {
                    0 => WrnenR::_0,
                    1 => WrnenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WrnenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WrnenR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SupvR {
            bits: u8,
        }
        impl SupvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FRZACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrzackR {
            # [ doc = "FlexCAN not in Freeze mode, prescaler running." ]
            _0,
            # [ doc = "FlexCAN in Freeze mode, prescaler stopped." ]
            _1,
        }
        impl FrzackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrzackR::_0 => 0,
                    FrzackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrzackR {
                match bits {
                    0 => FrzackR::_0,
                    1 => FrzackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrzackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrzackR::_1
            }
        }
        # [ doc = "Possible values of the field `SOFTRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoftrstR {
            # [ doc = "No reset request." ]
            _0,
            # [ doc = "Resets the registers affected by soft reset." ]
            _1,
        }
        impl SoftrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoftrstR::_0 => 0,
                    SoftrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoftrstR {
                match bits {
                    0 => SoftrstR::_0,
                    1 => SoftrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoftrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoftrstR::_1
            }
        }
        # [ doc = "Possible values of the field `NOTRDY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NotrdyR {
            # [ doc = "FlexCAN module is either in Normal mode, Listen-Only mode or Loop-Back mode." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NotrdyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NotrdyR::_0 => 0,
                    NotrdyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NotrdyR {
                match bits {
                    0 => NotrdyR::_0,
                    i => NotrdyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NotrdyR::_0
            }
        }
        # [ doc = "Possible values of the field `HALT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HaltR {
            # [ doc = "No Freeze mode request." ]
            _0,
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            _1,
        }
        impl HaltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HaltR::_0 => 0,
                    HaltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HaltR {
                match bits {
                    0 => HaltR::_0,
                    1 => HaltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HaltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HaltR::_1
            }
        }
        # [ doc = "Possible values of the field `RFEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfenR {
            # [ doc = "Rx FIFO not enabled." ]
            _0,
            # [ doc = "Rx FIFO enabled." ]
            _1,
        }
        impl RfenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfenR::_0 => 0,
                    RfenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfenR {
                match bits {
                    0 => RfenR::_0,
                    1 => RfenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfenR::_1
            }
        }
        # [ doc = "Possible values of the field `FRZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrzR {
            # [ doc = "Not enabled to enter Freeze mode." ]
            _0,
            # [ doc = "Enabled to enter Freeze mode." ]
            _1,
        }
        impl FrzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrzR::_0 => 0,
                    FrzR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrzR {
                match bits {
                    0 => FrzR::_0,
                    1 => FrzR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrzR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrzR::_1
            }
        }
        # [ doc = "Possible values of the field `MDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MdisR {
            # [ doc = "Enable the FlexCAN module." ]
            _0,
            # [ doc = "Disable the FlexCAN module." ]
            _1,
        }
        impl MdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MdisR::_0 => 0,
                    MdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MdisR {
                match bits {
                    0 => MdisR::_0,
                    1 => MdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MdisR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MaxmbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MaxmbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDAM`" ]
        pub enum IdamW {
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            _00,
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            _01,
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            _10,
            # [ doc = "Format D: All frames rejected." ]
            _11,
        }
        impl IdamW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdamW::_00 => 0,
                    IdamW::_01 => 1,
                    IdamW::_10 => 2,
                    IdamW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdamW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdamW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdamW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(IdamW::_00)
            }
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(IdamW::_01)
            }
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(IdamW::_10)
            }
            # [ doc = "Format D: All frames rejected." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(IdamW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDEN`" ]
        pub enum FdenW {
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            _1,
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            _0,
        }
        impl FdenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdenW::_1 => 1,
                    FdenW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdenW::_1)
            }
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdenW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AEN`" ]
        pub enum AenW {
            # [ doc = "Abort disabled." ]
            _0,
            # [ doc = "Abort enabled." ]
            _1,
        }
        impl AenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AenW::_0 => 0,
                    AenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Abort disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AenW::_0)
            }
            # [ doc = "Abort enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPRIOEN`" ]
        pub enum LprioenW {
            # [ doc = "Local Priority disabled." ]
            _0,
            # [ doc = "Local Priority enabled." ]
            _1,
        }
        impl LprioenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LprioenW::_0 => 0,
                    LprioenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LprioenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LprioenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LprioenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Local Priority disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LprioenW::_0)
            }
            # [ doc = "Local Priority enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LprioenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PNET_EN`" ]
        pub enum PnetEnW {
            # [ doc = "Pretended Networking mode is disabled." ]
            _0,
            # [ doc = "Pretended Networking mode is enabled." ]
            _1,
        }
        impl PnetEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PnetEnW::_0 => 0,
                    PnetEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PnetEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PnetEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PnetEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pretended Networking mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PnetEnW::_0)
            }
            # [ doc = "Pretended Networking mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PnetEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "DMA feature for RX FIFO disabled." ]
            _0,
            # [ doc = "DMA feature for RX FIFO enabled." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA feature for RX FIFO disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "DMA feature for RX FIFO enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRMQ`" ]
        pub enum IrmqW {
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            _0,
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            _1,
        }
        impl IrmqW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrmqW::_0 => 0,
                    IrmqW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrmqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrmqW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrmqW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IrmqW::_0)
            }
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IrmqW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRXDIS`" ]
        pub enum SrxdisW {
            # [ doc = "Self reception enabled." ]
            _0,
            # [ doc = "Self reception disabled." ]
            _1,
        }
        impl SrxdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SrxdisW::_0 => 0,
                    SrxdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SrxdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SrxdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SrxdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Self reception enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SrxdisW::_0)
            }
            # [ doc = "Self reception disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SrxdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WRNEN`" ]
        pub enum WrnenW {
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            _0,
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl WrnenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WrnenW::_0 => 0,
                    WrnenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WrnenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WrnenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WrnenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WrnenW::_0)
            }
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WrnenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SupvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SupvW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOFTRST`" ]
        pub enum SoftrstW {
            # [ doc = "No reset request." ]
            _0,
            # [ doc = "Resets the registers affected by soft reset." ]
            _1,
        }
        impl SoftrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SoftrstW::_0 => 0,
                    SoftrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoftrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoftrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SoftrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No reset request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SoftrstW::_0)
            }
            # [ doc = "Resets the registers affected by soft reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SoftrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HALT`" ]
        pub enum HaltW {
            # [ doc = "No Freeze mode request." ]
            _0,
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            _1,
        }
        impl HaltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HaltW::_0 => 0,
                    HaltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HaltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HaltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HaltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Freeze mode request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HaltW::_0)
            }
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HaltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RFEN`" ]
        pub enum RfenW {
            # [ doc = "Rx FIFO not enabled." ]
            _0,
            # [ doc = "Rx FIFO enabled." ]
            _1,
        }
        impl RfenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RfenW::_0 => 0,
                    RfenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RfenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RfenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RfenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx FIFO not enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RfenW::_0)
            }
            # [ doc = "Rx FIFO enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RfenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRZ`" ]
        pub enum FrzW {
            # [ doc = "Not enabled to enter Freeze mode." ]
            _0,
            # [ doc = "Enabled to enter Freeze mode." ]
            _1,
        }
        impl FrzW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FrzW::_0 => 0,
                    FrzW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrzW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrzW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FrzW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Not enabled to enter Freeze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FrzW::_0)
            }
            # [ doc = "Enabled to enter Freeze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FrzW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MDIS`" ]
        pub enum MdisW {
            # [ doc = "Enable the FlexCAN module." ]
            _0,
            # [ doc = "Disable the FlexCAN module." ]
            _1,
        }
        impl MdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MdisW::_0 => 0,
                    MdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Enable the FlexCAN module." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MdisW::_0)
            }
            # [ doc = "Disable the FlexCAN module." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Number Of The Last Message Buffer" ]
            # [ inline ( always ) ]
            pub fn maxmb(&self) -> MaxmbR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MaxmbR { bits }
            }
            # [ doc = "Bits 8:9 - ID Acceptance Mode" ]
            # [ inline ( always ) ]
            pub fn idam(&self) -> IdamR {
                IdamR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - CAN FD operation enable" ]
            # [ inline ( always ) ]
            pub fn fden(&self) -> FdenR {
                FdenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Abort Enable" ]
            # [ inline ( always ) ]
            pub fn aen(&self) -> AenR {
                AenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Local Priority Enable" ]
            # [ inline ( always ) ]
            pub fn lprioen(&self) -> LprioenR {
                LprioenR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Pretended Networking Enable" ]
            # [ inline ( always ) ]
            pub fn pnet_en(&self) -> PnetEnR {
                PnetEnR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 15;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Individual Rx Masking And Queue Enable" ]
            # [ inline ( always ) ]
            pub fn irmq(&self) -> IrmqR {
                IrmqR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Self Reception Disable" ]
            # [ inline ( always ) ]
            pub fn srxdis(&self) -> SrxdisR {
                SrxdisR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Low-Power Mode Acknowledge" ]
            # [ inline ( always ) ]
            pub fn lpmack(&self) -> LpmackR {
                LpmackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wrnen(&self) -> WrnenR {
                WrnenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 21;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 23 - Supervisor Mode" ]
            # [ inline ( always ) ]
            pub fn supv(&self) -> SupvR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SupvR { bits }
            }
            # [ doc = "Bit 24 - Freeze Mode Acknowledge" ]
            # [ inline ( always ) ]
            pub fn frzack(&self) -> FrzackR {
                FrzackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 25 - Soft Reset" ]
            # [ inline ( always ) ]
            pub fn softrst(&self) -> SoftrstR {
                SoftrstR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 27 - FlexCAN Not Ready" ]
            # [ inline ( always ) ]
            pub fn notrdy(&self) -> NotrdyR {
                NotrdyR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Halt FlexCAN" ]
            # [ inline ( always ) ]
            pub fn halt(&self) -> HaltR {
                HaltR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 28;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 29 - Rx FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rfen(&self) -> RfenR {
                RfenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - Freeze Enable" ]
            # [ inline ( always ) ]
            pub fn frz(&self) -> FrzR {
                FrzR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Module Disable" ]
            # [ inline ( always ) ]
            pub fn mdis(&self) -> MdisR {
                MdisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3633315855 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Number Of The Last Message Buffer" ]
            # [ inline ( always ) ]
            pub fn maxmb(&mut self) -> _MaxmbW {
                _MaxmbW { w: self }
            }
            # [ doc = "Bits 8:9 - ID Acceptance Mode" ]
            # [ inline ( always ) ]
            pub fn idam(&mut self) -> _IdamW {
                _IdamW { w: self }
            }
            # [ doc = "Bit 11 - CAN FD operation enable" ]
            # [ inline ( always ) ]
            pub fn fden(&mut self) -> _FdenW {
                _FdenW { w: self }
            }
            # [ doc = "Bit 12 - Abort Enable" ]
            # [ inline ( always ) ]
            pub fn aen(&mut self) -> _AenW {
                _AenW { w: self }
            }
            # [ doc = "Bit 13 - Local Priority Enable" ]
            # [ inline ( always ) ]
            pub fn lprioen(&mut self) -> _LprioenW {
                _LprioenW { w: self }
            }
            # [ doc = "Bit 14 - Pretended Networking Enable" ]
            # [ inline ( always ) ]
            pub fn pnet_en(&mut self) -> _PnetEnW {
                _PnetEnW { w: self }
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 16 - Individual Rx Masking And Queue Enable" ]
            # [ inline ( always ) ]
            pub fn irmq(&mut self) -> _IrmqW {
                _IrmqW { w: self }
            }
            # [ doc = "Bit 17 - Self Reception Disable" ]
            # [ inline ( always ) ]
            pub fn srxdis(&mut self) -> _SrxdisW {
                _SrxdisW { w: self }
            }
            # [ doc = "Bit 21 - Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wrnen(&mut self) -> _WrnenW {
                _WrnenW { w: self }
            }
            # [ doc = "Bit 23 - Supervisor Mode" ]
            # [ inline ( always ) ]
            pub fn supv(&mut self) -> _SupvW {
                _SupvW { w: self }
            }
            # [ doc = "Bit 25 - Soft Reset" ]
            # [ inline ( always ) ]
            pub fn softrst(&mut self) -> _SoftrstW {
                _SoftrstW { w: self }
            }
            # [ doc = "Bit 28 - Halt FlexCAN" ]
            # [ inline ( always ) ]
            pub fn halt(&mut self) -> _HaltW {
                _HaltW { w: self }
            }
            # [ doc = "Bit 29 - Rx FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rfen(&mut self) -> _RfenW {
                _RfenW { w: self }
            }
            # [ doc = "Bit 30 - Freeze Enable" ]
            # [ inline ( always ) ]
            pub fn frz(&mut self) -> _FrzW {
                _FrzW { w: self }
            }
            # [ doc = "Bit 31 - Module Disable" ]
            # [ inline ( always ) ]
            pub fn mdis(&mut self) -> _MdisW {
                _MdisW { w: self }
            }
        }
    }
    # [ doc = "Control 1 register" ]
    pub struct Ctrl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control 1 register" ]
    pub mod ctrl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PropsegR {
            bits: u8,
        }
        impl PropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LomR {
            # [ doc = "Listen-Only mode is deactivated." ]
            _0,
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            _1,
        }
        impl LomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LomR::_0 => 0,
                    LomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LomR {
                match bits {
                    0 => LomR::_0,
                    1 => LomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LomR::_1
            }
        }
        # [ doc = "Possible values of the field `LBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbufR {
            # [ doc = "Buffer with highest priority is transmitted first." ]
            _0,
            # [ doc = "Lowest number buffer is transmitted first." ]
            _1,
        }
        impl LbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbufR::_0 => 0,
                    LbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbufR {
                match bits {
                    0 => LbufR::_0,
                    1 => LbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbufR::_1
            }
        }
        # [ doc = "Possible values of the field `TSYN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsynR {
            # [ doc = "Timer Sync feature disabled" ]
            _0,
            # [ doc = "Timer Sync feature enabled" ]
            _1,
        }
        impl TsynR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsynR::_0 => 0,
                    TsynR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsynR {
                match bits {
                    0 => TsynR::_0,
                    1 => TsynR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsynR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsynR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFREC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffrecR {
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            _0,
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            _1,
        }
        impl BoffrecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffrecR::_0 => 0,
                    BoffrecR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffrecR {
                match bits {
                    0 => BoffrecR::_0,
                    1 => BoffrecR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffrecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffrecR::_1
            }
        }
        # [ doc = "Possible values of the field `SMP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmpR {
            # [ doc = "Just one sample is used to determine the bit value." ]
            _0,
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            _1,
        }
        impl SmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmpR::_0 => 0,
                    SmpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmpR {
                match bits {
                    0 => SmpR::_0,
                    1 => SmpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmpR::_1
            }
        }
        # [ doc = "Possible values of the field `RWRNMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwrnmskR {
            # [ doc = "Rx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Rx Warning Interrupt enabled." ]
            _1,
        }
        impl RwrnmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwrnmskR::_0 => 0,
                    RwrnmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwrnmskR {
                match bits {
                    0 => RwrnmskR::_0,
                    1 => RwrnmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwrnmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwrnmskR::_1
            }
        }
        # [ doc = "Possible values of the field `TWRNMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TwrnmskR {
            # [ doc = "Tx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Tx Warning Interrupt enabled." ]
            _1,
        }
        impl TwrnmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TwrnmskR::_0 => 0,
                    TwrnmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TwrnmskR {
                match bits {
                    0 => TwrnmskR::_0,
                    1 => TwrnmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TwrnmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TwrnmskR::_1
            }
        }
        # [ doc = "Possible values of the field `LPB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpbR {
            # [ doc = "Loop Back disabled." ]
            _0,
            # [ doc = "Loop Back enabled." ]
            _1,
        }
        impl LpbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpbR::_0 => 0,
                    LpbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpbR {
                match bits {
                    0 => LpbR::_0,
                    1 => LpbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpbR::_1
            }
        }
        # [ doc = "Possible values of the field `CLKSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksrcR {
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            _0,
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            _1,
        }
        impl ClksrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksrcR::_0 => 0,
                    ClksrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksrcR {
                match bits {
                    0 => ClksrcR::_0,
                    1 => ClksrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ClksrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ClksrcR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrmskR {
            # [ doc = "Error interrupt disabled." ]
            _0,
            # [ doc = "Error interrupt enabled." ]
            _1,
        }
        impl ErrmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrmskR::_0 => 0,
                    ErrmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrmskR {
                match bits {
                    0 => ErrmskR::_0,
                    1 => ErrmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrmskR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffmskR {
            # [ doc = "Bus Off interrupt disabled." ]
            _0,
            # [ doc = "Bus Off interrupt enabled." ]
            _1,
        }
        impl BoffmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffmskR::_0 => 0,
                    BoffmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffmskR {
                match bits {
                    0 => BoffmskR::_0,
                    1 => BoffmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffmskR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pseg2R {
            bits: u8,
        }
        impl Pseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pseg1R {
            bits: u8,
        }
        impl Pseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RjwR {
            bits: u8,
        }
        impl RjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PresdivR {
            bits: u8,
        }
        impl PresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOM`" ]
        pub enum LomW {
            # [ doc = "Listen-Only mode is deactivated." ]
            _0,
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            _1,
        }
        impl LomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LomW::_0 => 0,
                    LomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Listen-Only mode is deactivated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LomW::_0)
            }
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBUF`" ]
        pub enum LbufW {
            # [ doc = "Buffer with highest priority is transmitted first." ]
            _0,
            # [ doc = "Lowest number buffer is transmitted first." ]
            _1,
        }
        impl LbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbufW::_0 => 0,
                    LbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Buffer with highest priority is transmitted first." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbufW::_0)
            }
            # [ doc = "Lowest number buffer is transmitted first." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSYN`" ]
        pub enum TsynW {
            # [ doc = "Timer Sync feature disabled" ]
            _0,
            # [ doc = "Timer Sync feature enabled" ]
            _1,
        }
        impl TsynW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsynW::_0 => 0,
                    TsynW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsynW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsynW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsynW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Sync feature disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsynW::_0)
            }
            # [ doc = "Timer Sync feature enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsynW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFREC`" ]
        pub enum BoffrecW {
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            _0,
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            _1,
        }
        impl BoffrecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffrecW::_0 => 0,
                    BoffrecW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffrecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffrecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffrecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffrecW::_0)
            }
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffrecW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMP`" ]
        pub enum SmpW {
            # [ doc = "Just one sample is used to determine the bit value." ]
            _0,
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            _1,
        }
        impl SmpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmpW::_0 => 0,
                    SmpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Just one sample is used to determine the bit value." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmpW::_0)
            }
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWRNMSK`" ]
        pub enum RwrnmskW {
            # [ doc = "Rx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Rx Warning Interrupt enabled." ]
            _1,
        }
        impl RwrnmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwrnmskW::_0 => 0,
                    RwrnmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwrnmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwrnmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwrnmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx Warning Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwrnmskW::_0)
            }
            # [ doc = "Rx Warning Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwrnmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TWRNMSK`" ]
        pub enum TwrnmskW {
            # [ doc = "Tx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Tx Warning Interrupt enabled." ]
            _1,
        }
        impl TwrnmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TwrnmskW::_0 => 0,
                    TwrnmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TwrnmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TwrnmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TwrnmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Tx Warning Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TwrnmskW::_0)
            }
            # [ doc = "Tx Warning Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TwrnmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPB`" ]
        pub enum LpbW {
            # [ doc = "Loop Back disabled." ]
            _0,
            # [ doc = "Loop Back enabled." ]
            _1,
        }
        impl LpbW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LpbW::_0 => 0,
                    LpbW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LpbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LpbW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LpbW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loop Back disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LpbW::_0)
            }
            # [ doc = "Loop Back enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LpbW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKSRC`" ]
        pub enum ClksrcW {
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            _0,
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            _1,
        }
        impl ClksrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksrcW::_0 => 0,
                    ClksrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClksrcW::_0)
            }
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClksrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRMSK`" ]
        pub enum ErrmskW {
            # [ doc = "Error interrupt disabled." ]
            _0,
            # [ doc = "Error interrupt enabled." ]
            _1,
        }
        impl ErrmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrmskW::_0 => 0,
                    ErrmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrmskW::_0)
            }
            # [ doc = "Error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFMSK`" ]
        pub enum BoffmskW {
            # [ doc = "Bus Off interrupt disabled." ]
            _0,
            # [ doc = "Bus Off interrupt enabled." ]
            _1,
        }
        impl BoffmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffmskW::_0 => 0,
                    BoffmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus Off interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffmskW::_0)
            }
            # [ doc = "Bus Off interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn propseg(&self) -> PropsegR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PropsegR { bits }
            }
            # [ doc = "Bit 3 - Listen-Only Mode" ]
            # [ inline ( always ) ]
            pub fn lom(&self) -> LomR {
                LomR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Lowest Buffer Transmitted First" ]
            # [ inline ( always ) ]
            pub fn lbuf(&self) -> LbufR {
                LbufR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Timer Sync" ]
            # [ inline ( always ) ]
            pub fn tsyn(&self) -> TsynR {
                TsynR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Bus Off Recovery" ]
            # [ inline ( always ) ]
            pub fn boffrec(&self) -> BoffrecR {
                BoffrecR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 6;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 7 - CAN Bit Sampling" ]
            # [ inline ( always ) ]
            pub fn smp(&self) -> SmpR {
                SmpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Rx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn rwrnmsk(&self) -> RwrnmskR {
                RwrnmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 10;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - Tx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn twrnmsk(&self) -> TwrnmskR {
                TwrnmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 11;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 12 - Loop Back Mode" ]
            # [ inline ( always ) ]
            pub fn lpb(&self) -> LpbR {
                LpbR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - CAN Engine Clock Source" ]
            # [ inline ( always ) ]
            pub fn clksrc(&self) -> ClksrcR {
                ClksrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Error Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn errmsk(&self) -> ErrmskR {
                ErrmskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Bus Off Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffmsk(&self) -> BoffmskR {
                BoffmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 16:18 - Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn pseg2(&self) -> Pseg2R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pseg2R { bits }
            }
            # [ doc = "Bits 19:21 - Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn pseg1(&self) -> Pseg1R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pseg1R { bits }
            }
            # [ doc = "Bits 22:23 - Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn rjw(&self) -> RjwR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RjwR { bits }
            }
            # [ doc = "Bits 24:31 - Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn presdiv(&self) -> PresdivR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PresdivR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn propseg(&mut self) -> _PropsegW {
                _PropsegW { w: self }
            }
            # [ doc = "Bit 3 - Listen-Only Mode" ]
            # [ inline ( always ) ]
            pub fn lom(&mut self) -> _LomW {
                _LomW { w: self }
            }
            # [ doc = "Bit 4 - Lowest Buffer Transmitted First" ]
            # [ inline ( always ) ]
            pub fn lbuf(&mut self) -> _LbufW {
                _LbufW { w: self }
            }
            # [ doc = "Bit 5 - Timer Sync" ]
            # [ inline ( always ) ]
            pub fn tsyn(&mut self) -> _TsynW {
                _TsynW { w: self }
            }
            # [ doc = "Bit 6 - Bus Off Recovery" ]
            # [ inline ( always ) ]
            pub fn boffrec(&mut self) -> _BoffrecW {
                _BoffrecW { w: self }
            }
            # [ doc = "Bit 7 - CAN Bit Sampling" ]
            # [ inline ( always ) ]
            pub fn smp(&mut self) -> _SmpW {
                _SmpW { w: self }
            }
            # [ doc = "Bit 10 - Rx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn rwrnmsk(&mut self) -> _RwrnmskW {
                _RwrnmskW { w: self }
            }
            # [ doc = "Bit 11 - Tx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn twrnmsk(&mut self) -> _TwrnmskW {
                _TwrnmskW { w: self }
            }
            # [ doc = "Bit 12 - Loop Back Mode" ]
            # [ inline ( always ) ]
            pub fn lpb(&mut self) -> _LpbW {
                _LpbW { w: self }
            }
            # [ doc = "Bit 13 - CAN Engine Clock Source" ]
            # [ inline ( always ) ]
            pub fn clksrc(&mut self) -> _ClksrcW {
                _ClksrcW { w: self }
            }
            # [ doc = "Bit 14 - Error Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn errmsk(&mut self) -> _ErrmskW {
                _ErrmskW { w: self }
            }
            # [ doc = "Bit 15 - Bus Off Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffmsk(&mut self) -> _BoffmskW {
                _BoffmskW { w: self }
            }
            # [ doc = "Bits 16:18 - Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn pseg2(&mut self) -> _Pseg2W {
                _Pseg2W { w: self }
            }
            # [ doc = "Bits 19:21 - Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn pseg1(&mut self) -> _Pseg1W {
                _Pseg1W { w: self }
            }
            # [ doc = "Bits 22:23 - Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn rjw(&mut self) -> _RjwW {
                _RjwW { w: self }
            }
            # [ doc = "Bits 24:31 - Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn presdiv(&mut self) -> _PresdivW {
                _PresdivW { w: self }
            }
        }
    }
    # [ doc = "Free Running Timer" ]
    pub struct Timer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Free Running Timer" ]
    pub mod timer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimerR {
            bits: u16,
        }
        impl TimerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimerW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn timer(&self) -> TimerR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TimerR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn timer(&mut self) -> _TimerW {
                _TimerW { w: self }
            }
        }
    }
    # [ doc = "Rx Mailboxes Global Mask Register" ]
    pub struct Rxmgmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Mailboxes Global Mask Register" ]
    pub mod rxmgmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rxmgmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MgR {
            bits: u32,
        }
        impl MgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Mailboxes Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mg(&self) -> MgR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MgR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Mailboxes Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mg(&mut self) -> _MgW {
                _MgW { w: self }
            }
        }
    }
    # [ doc = "Rx 14 Mask register" ]
    pub struct Rx14mask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx 14 Mask register" ]
    pub mod rx14mask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rx14mask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Rx14mR {
            bits: u32,
        }
        impl Rx14mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Rx14mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Rx14mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Buffer 14 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx14m(&self) -> Rx14mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Rx14mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Buffer 14 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx14m(&mut self) -> _Rx14mW {
                _Rx14mW { w: self }
            }
        }
    }
    # [ doc = "Rx 15 Mask register" ]
    pub struct Rx15mask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx 15 Mask register" ]
    pub mod rx15mask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rx15mask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Rx15mR {
            bits: u32,
        }
        impl Rx15mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Rx15mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Rx15mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Buffer 15 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx15m(&self) -> Rx15mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Rx15mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Buffer 15 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx15m(&mut self) -> _Rx15mW {
                _Rx15mW { w: self }
            }
        }
    }
    # [ doc = "Error Counter" ]
    pub struct Ecr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Counter" ]
    pub mod ecr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ecr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxerrcntR {
            bits: u8,
        }
        impl TxerrcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxerrcntR {
            bits: u8,
        }
        impl RxerrcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxerrcntFastR {
            bits: u8,
        }
        impl TxerrcntFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxerrcntFastR {
            bits: u8,
        }
        impl RxerrcntFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxerrcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxerrcntW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxerrcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxerrcntW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxerrcntFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxerrcntFastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxerrcntFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxerrcntFastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit Error Counter" ]
            # [ inline ( always ) ]
            pub fn txerrcnt(&self) -> TxerrcntR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxerrcntR { bits }
            }
            # [ doc = "Bits 8:15 - Receive Error Counter" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt(&self) -> RxerrcntR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxerrcntR { bits }
            }
            # [ doc = "Bits 16:23 - Transmit Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn txerrcnt_fast(&self) -> TxerrcntFastR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxerrcntFastR { bits }
            }
            # [ doc = "Bits 24:31 - Receive Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt_fast(&self) -> RxerrcntFastR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxerrcntFastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Transmit Error Counter" ]
            # [ inline ( always ) ]
            pub fn txerrcnt(&mut self) -> _TxerrcntW {
                _TxerrcntW { w: self }
            }
            # [ doc = "Bits 8:15 - Receive Error Counter" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt(&mut self) -> _RxerrcntW {
                _RxerrcntW { w: self }
            }
            # [ doc = "Bits 16:23 - Transmit Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn txerrcnt_fast(&mut self) -> _TxerrcntFastW {
                _TxerrcntFastW { w: self }
            }
            # [ doc = "Bits 24:31 - Receive Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt_fast(&mut self) -> _RxerrcntFastW {
                _RxerrcntFastW { w: self }
            }
        }
    }
    # [ doc = "Error and Status 1 register" ]
    pub struct Esr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error and Status 1 register" ]
    pub mod esr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Esr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERRINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            _1,
        }
        impl ErrintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrintR::_0 => 0,
                    ErrintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrintR {
                match bits {
                    0 => ErrintR::_0,
                    1 => ErrintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrintR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module entered Bus Off state." ]
            _1,
        }
        impl BoffintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffintR::_0 => 0,
                    BoffintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffintR {
                match bits {
                    0 => BoffintR::_0,
                    1 => BoffintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffintR::_1
            }
        }
        # [ doc = "Possible values of the field `RX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxR {
            # [ doc = "FlexCAN is not receiving a message." ]
            _0,
            # [ doc = "FlexCAN is receiving a message." ]
            _1,
        }
        impl RxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxR::_0 => 0,
                    RxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxR {
                match bits {
                    0 => RxR::_0,
                    1 => RxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxR::_1
            }
        }
        # [ doc = "Possible values of the field `FLTCONF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltconfR {
            # [ doc = "Error Active" ]
            _00,
            # [ doc = "Error Passive" ]
            _01,
            # [ doc = "Bus Off" ]
            _1x,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl FltconfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltconfR::_00 => 0,
                    FltconfR::_01 => 1,
                    FltconfR::_1x => 2,
                    FltconfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltconfR {
                match bits {
                    0 => FltconfR::_00,
                    1 => FltconfR::_01,
                    2 => FltconfR::_1x,
                    i => FltconfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FltconfR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FltconfR::_01
            }
            # [ doc = "Checks if the value of the field is `_1x`" ]
            # [ inline ( always ) ]
            pub fn is_1x(&self) -> bool {
                *self == FltconfR::_1x
            }
        }
        # [ doc = "Possible values of the field `TX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxR {
            # [ doc = "FlexCAN is not transmitting a message." ]
            _0,
            # [ doc = "FlexCAN is transmitting a message." ]
            _1,
        }
        impl TxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxR::_0 => 0,
                    TxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxR {
                match bits {
                    0 => TxR::_0,
                    1 => TxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdleR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "CAN bus is now IDLE." ]
            _1,
        }
        impl IdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdleR::_0 => 0,
                    IdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdleR {
                match bits {
                    0 => IdleR::_0,
                    1 => IdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdleR::_1
            }
        }
        # [ doc = "Possible values of the field `RXWRN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxwrnR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "RXERRCNT is greater than or equal to 96." ]
            _1,
        }
        impl RxwrnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxwrnR::_0 => 0,
                    RxwrnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxwrnR {
                match bits {
                    0 => RxwrnR::_0,
                    1 => RxwrnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxwrnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxwrnR::_1
            }
        }
        # [ doc = "Possible values of the field `TXWRN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxwrnR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "TXERRCNT is greater than or equal to 96." ]
            _1,
        }
        impl TxwrnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxwrnR::_0 => 0,
                    TxwrnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxwrnR {
                match bits {
                    0 => TxwrnR::_0,
                    1 => TxwrnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxwrnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxwrnR::_1
            }
        }
        # [ doc = "Possible values of the field `STFERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StferrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Stuffing Error occurred since last read of this register." ]
            _1,
        }
        impl StferrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StferrR::_0 => 0,
                    StferrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StferrR {
                match bits {
                    0 => StferrR::_0,
                    1 => StferrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StferrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StferrR::_1
            }
        }
        # [ doc = "Possible values of the field `FRMERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrmerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Form Error occurred since last read of this register." ]
            _1,
        }
        impl FrmerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrmerrR::_0 => 0,
                    FrmerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrmerrR {
                match bits {
                    0 => FrmerrR::_0,
                    1 => FrmerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrmerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrmerrR::_1
            }
        }
        # [ doc = "Possible values of the field `CRCERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrcerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A CRC error occurred since last read of this register." ]
            _1,
        }
        impl CrcerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrcerrR::_0 => 0,
                    CrcerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrcerrR {
                match bits {
                    0 => CrcerrR::_0,
                    1 => CrcerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrcerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrcerrR::_1
            }
        }
        # [ doc = "Possible values of the field `ACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AckerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "An ACK error occurred since last read of this register." ]
            _1,
        }
        impl AckerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AckerrR::_0 => 0,
                    AckerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AckerrR {
                match bits {
                    0 => AckerrR::_0,
                    1 => AckerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AckerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AckerrR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT0ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit0errR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as dominant is received as recessive." ]
            _1,
        }
        impl Bit0errR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit0errR::_0 => 0,
                    Bit0errR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit0errR {
                match bits {
                    0 => Bit0errR::_0,
                    1 => Bit0errR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit0errR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit0errR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT1ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit1errR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as recessive is received as dominant." ]
            _1,
        }
        impl Bit1errR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit1errR::_0 => 0,
                    Bit1errR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit1errR {
                match bits {
                    0 => Bit1errR::_0,
                    1 => Bit1errR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit1errR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit1errR::_1
            }
        }
        # [ doc = "Possible values of the field `RWRNINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwrnintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl RwrnintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwrnintR::_0 => 0,
                    RwrnintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwrnintR {
                match bits {
                    0 => RwrnintR::_0,
                    1 => RwrnintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwrnintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwrnintR::_1
            }
        }
        # [ doc = "Possible values of the field `TWRNINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TwrnintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl TwrnintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TwrnintR::_0 => 0,
                    TwrnintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TwrnintR {
                match bits {
                    0 => TwrnintR::_0,
                    1 => TwrnintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TwrnintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TwrnintR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchR {
            # [ doc = "FlexCAN is not synchronized to the CAN bus." ]
            _0,
            # [ doc = "FlexCAN is synchronized to the CAN bus." ]
            _1,
        }
        impl SynchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchR::_0 => 0,
                    SynchR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchR {
                match bits {
                    0 => SynchR::_0,
                    1 => SynchR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFDONEINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffdoneintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            _1,
        }
        impl BoffdoneintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffdoneintR::_0 => 0,
                    BoffdoneintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffdoneintR {
                match bits {
                    0 => BoffdoneintR::_0,
                    1 => BoffdoneintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffdoneintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffdoneintR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRINT_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrintFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            _1,
        }
        impl ErrintFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrintFastR::_0 => 0,
                    ErrintFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrintFastR {
                match bits {
                    0 => ErrintFastR::_0,
                    1 => ErrintFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrintFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrintFastR::_1
            }
        }
        # [ doc = "Possible values of the field `ERROVR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrovrR {
            # [ doc = "Overrun has not occurred." ]
            _0,
            # [ doc = "Overrun has occurred." ]
            _1,
        }
        impl ErrovrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrovrR::_0 => 0,
                    ErrovrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrovrR {
                match bits {
                    0 => ErrovrR::_0,
                    1 => ErrovrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrovrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrovrR::_1
            }
        }
        # [ doc = "Possible values of the field `STFERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StferrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Stuffing Error occurred since last read of this register." ]
            _1,
        }
        impl StferrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StferrFastR::_0 => 0,
                    StferrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StferrFastR {
                match bits {
                    0 => StferrFastR::_0,
                    1 => StferrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StferrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StferrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `FRMERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrmerrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Form Error occurred since last read of this register." ]
            _1,
        }
        impl FrmerrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrmerrFastR::_0 => 0,
                    FrmerrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrmerrFastR {
                match bits {
                    0 => FrmerrFastR::_0,
                    1 => FrmerrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrmerrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrmerrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `CRCERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrcerrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A CRC error occurred since last read of this register." ]
            _1,
        }
        impl CrcerrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrcerrFastR::_0 => 0,
                    CrcerrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrcerrFastR {
                match bits {
                    0 => CrcerrFastR::_0,
                    1 => CrcerrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrcerrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrcerrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT0ERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit0errFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as dominant is received as recessive." ]
            _1,
        }
        impl Bit0errFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit0errFastR::_0 => 0,
                    Bit0errFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit0errFastR {
                match bits {
                    0 => Bit0errFastR::_0,
                    1 => Bit0errFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit0errFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit0errFastR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT1ERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit1errFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as recessive is received as dominant." ]
            _1,
        }
        impl Bit1errFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit1errFastR::_0 => 0,
                    Bit1errFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit1errFastR {
                match bits {
                    0 => Bit1errFastR::_0,
                    1 => Bit1errFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit1errFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit1errFastR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERRINT`" ]
        pub enum ErrintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            _1,
        }
        impl ErrintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrintW::_0 => 0,
                    ErrintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrintW::_0)
            }
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFINT`" ]
        pub enum BoffintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module entered Bus Off state." ]
            _1,
        }
        impl BoffintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffintW::_0 => 0,
                    BoffintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffintW::_0)
            }
            # [ doc = "FlexCAN module entered Bus Off state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWRNINT`" ]
        pub enum RwrnintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl RwrnintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwrnintW::_0 => 0,
                    RwrnintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwrnintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwrnintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwrnintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwrnintW::_0)
            }
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwrnintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TWRNINT`" ]
        pub enum TwrnintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl TwrnintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TwrnintW::_0 => 0,
                    TwrnintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TwrnintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TwrnintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TwrnintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TwrnintW::_0)
            }
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TwrnintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFDONEINT`" ]
        pub enum BoffdoneintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            _1,
        }
        impl BoffdoneintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffdoneintW::_0 => 0,
                    BoffdoneintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffdoneintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffdoneintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffdoneintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffdoneintW::_0)
            }
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffdoneintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRINT_FAST`" ]
        pub enum ErrintFastW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            _1,
        }
        impl ErrintFastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrintFastW::_0 => 0,
                    ErrintFastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrintFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrintFastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrintFastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrintFastW::_0)
            }
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrintFastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERROVR`" ]
        pub enum ErrovrW {
            # [ doc = "Overrun has not occurred." ]
            _0,
            # [ doc = "Overrun has occurred." ]
            _1,
        }
        impl ErrovrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrovrW::_0 => 0,
                    ErrovrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrovrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrovrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrovrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Overrun has not occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrovrW::_0)
            }
            # [ doc = "Overrun has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrovrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn errint(&self) -> ErrintR {
                ErrintR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Bus Off Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffint(&self) -> BoffintR {
                BoffintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - FlexCAN In Reception" ]
            # [ inline ( always ) ]
            pub fn rx(&self) -> RxR {
                RxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 3;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 4:5 - Fault Confinement State" ]
            # [ inline ( always ) ]
            pub fn fltconf(&self) -> FltconfR {
                FltconfR::_from({
                                    const MASK: u8 = 3;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - FlexCAN In Transmission" ]
            # [ inline ( always ) ]
            pub fn tx(&self) -> TxR {
                TxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 6;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 7 - IDLE" ]
            # [ inline ( always ) ]
            pub fn idle(&self) -> IdleR {
                IdleR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Rx Error Warning" ]
            # [ inline ( always ) ]
            pub fn rxwrn(&self) -> RxwrnR {
                RxwrnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - TX Error Warning" ]
            # [ inline ( always ) ]
            pub fn txwrn(&self) -> TxwrnR {
                TxwrnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Stuffing Error" ]
            # [ inline ( always ) ]
            pub fn stferr(&self) -> StferrR {
                StferrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Form Error" ]
            # [ inline ( always ) ]
            pub fn frmerr(&self) -> FrmerrR {
                FrmerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Cyclic Redundancy Check Error" ]
            # [ inline ( always ) ]
            pub fn crcerr(&self) -> CrcerrR {
                CrcerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Acknowledge Error" ]
            # [ inline ( always ) ]
            pub fn ackerr(&self) -> AckerrR {
                AckerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Bit0 Error" ]
            # [ inline ( always ) ]
            pub fn bit0err(&self) -> Bit0errR {
                Bit0errR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Bit1 Error" ]
            # [ inline ( always ) ]
            pub fn bit1err(&self) -> Bit1errR {
                Bit1errR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 16 - Rx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rwrnint(&self) -> RwrnintR {
                RwrnintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 17 - Tx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn twrnint(&self) -> TwrnintR {
                TwrnintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - CAN Synchronization Status" ]
            # [ inline ( always ) ]
            pub fn synch(&self) -> SynchR {
                SynchR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 19 - Bus Off Done Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffdoneint(&self) -> BoffdoneintR {
                BoffdoneintR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 19;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 20 - Error Interrupt for errors detected in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn errint_fast(&self) -> ErrintFastR {
                ErrintFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 20;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 21 - Error Overrun bit" ]
            # [ inline ( always ) ]
            pub fn errovr(&self) -> ErrovrR {
                ErrovrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Stuffing Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn stferr_fast(&self) -> StferrFastR {
                StferrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 26;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 27 - Form Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn frmerr_fast(&self) -> FrmerrFastR {
                FrmerrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 27;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 28 - Cyclic Redundancy Check Error in the CRC field of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn crcerr_fast(&self) -> CrcerrFastR {
                CrcerrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 28;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 30 - Bit0 Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn bit0err_fast(&self) -> Bit0errFastR {
                Bit0errFastR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 30;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 31 - Bit1 Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn bit1err_fast(&self) -> Bit1errFastR {
                Bit1errFastR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 31;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn errint(&mut self) -> _ErrintW {
                _ErrintW { w: self }
            }
            # [ doc = "Bit 2 - Bus Off Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffint(&mut self) -> _BoffintW {
                _BoffintW { w: self }
            }
            # [ doc = "Bit 16 - Rx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rwrnint(&mut self) -> _RwrnintW {
                _RwrnintW { w: self }
            }
            # [ doc = "Bit 17 - Tx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn twrnint(&mut self) -> _TwrnintW {
                _TwrnintW { w: self }
            }
            # [ doc = "Bit 19 - Bus Off Done Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffdoneint(&mut self) -> _BoffdoneintW {
                _BoffdoneintW { w: self }
            }
            # [ doc = "Bit 20 - Error Interrupt for errors detected in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn errint_fast(&mut self) -> _ErrintFastW {
                _ErrintFastW { w: self }
            }
            # [ doc = "Bit 21 - Error Overrun bit" ]
            # [ inline ( always ) ]
            pub fn errovr(&mut self) -> _ErrovrW {
                _ErrovrW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Masks 1 register" ]
    pub struct Imask1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Masks 1 register" ]
    pub mod imask1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Imask1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf31to0mR {
            bits: u32,
        }
        impl Buf31to0mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf31to0mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf31to0mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Buffer MB i Mask" ]
            # [ inline ( always ) ]
            pub fn buf31to0m(&self) -> Buf31to0mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Buf31to0mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Buffer MB i Mask" ]
            # [ inline ( always ) ]
            pub fn buf31to0m(&mut self) -> _Buf31to0mW {
                _Buf31to0mW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Flags 1 register" ]
    pub struct Iflag1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Flags 1 register" ]
    pub mod iflag1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Iflag1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `BUF0I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf0iR {
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            _0,
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            _1,
        }
        impl Buf0iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf0iR::_0 => 0,
                    Buf0iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf0iR {
                match bits {
                    0 => Buf0iR::_0,
                    1 => Buf0iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf0iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf0iR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf4to1iR {
            bits: u8,
        }
        impl Buf4to1iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BUF5I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf5iR {
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            _1,
        }
        impl Buf5iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf5iR::_0 => 0,
                    Buf5iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf5iR {
                match bits {
                    0 => Buf5iR::_0,
                    1 => Buf5iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf5iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf5iR::_1
            }
        }
        # [ doc = "Possible values of the field `BUF6I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf6iR {
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf6iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf6iR::_0 => 0,
                    Buf6iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf6iR {
                match bits {
                    0 => Buf6iR::_0,
                    1 => Buf6iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf6iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf6iR::_1
            }
        }
        # [ doc = "Possible values of the field `BUF7I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf7iR {
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf7iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf7iR::_0 => 0,
                    Buf7iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf7iR {
                match bits {
                    0 => Buf7iR::_0,
                    1 => Buf7iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf7iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf7iR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf31to8iR {
            bits: u32,
        }
        impl Buf31to8iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `BUF0I`" ]
        pub enum Buf0iW {
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            _0,
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            _1,
        }
        impl Buf0iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf0iW::_0 => 0,
                    Buf0iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf0iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf0iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf0iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf0iW::_0)
            }
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf0iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf4to1iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf4to1iW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF5I`" ]
        pub enum Buf5iW {
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            _1,
        }
        impl Buf5iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf5iW::_0 => 0,
                    Buf5iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf5iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf5iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf5iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf5iW::_0)
            }
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf5iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF6I`" ]
        pub enum Buf6iW {
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf6iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf6iW::_0 => 0,
                    Buf6iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf6iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf6iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf6iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf6iW::_0)
            }
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf6iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF7I`" ]
        pub enum Buf7iW {
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf7iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf7iW::_0 => 0,
                    Buf7iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf7iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf7iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf7iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf7iW::_0)
            }
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf7iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf31to8iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf31to8iW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 16777215;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Buffer MB0 Interrupt Or Clear FIFO bit" ]
            # [ inline ( always ) ]
            pub fn buf0i(&self) -> Buf0iR {
                Buf0iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 1:4 - Buffer MB i Interrupt Or \"reserved\"" ]
            # [ inline ( always ) ]
            pub fn buf4to1i(&self) -> Buf4to1iR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Buf4to1iR { bits }
            }
            # [ doc = "Bit 5 - Buffer MB5 Interrupt Or \"Frames available in Rx FIFO\"" ]
            # [ inline ( always ) ]
            pub fn buf5i(&self) -> Buf5iR {
                Buf5iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Buffer MB6 Interrupt Or \"Rx FIFO Warning\"" ]
            # [ inline ( always ) ]
            pub fn buf6i(&self) -> Buf6iR {
                Buf6iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Buffer MB7 Interrupt Or \"Rx FIFO Overflow\"" ]
            # [ inline ( always ) ]
            pub fn buf7i(&self) -> Buf7iR {
                Buf7iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:31 - Buffer MBi Interrupt" ]
            # [ inline ( always ) ]
            pub fn buf31to8i(&self) -> Buf31to8iR {
                let bits = {
                    const MASK: u32 = 16777215;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Buf31to8iR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Buffer MB0 Interrupt Or Clear FIFO bit" ]
            # [ inline ( always ) ]
            pub fn buf0i(&mut self) -> _Buf0iW {
                _Buf0iW { w: self }
            }
            # [ doc = "Bits 1:4 - Buffer MB i Interrupt Or \"reserved\"" ]
            # [ inline ( always ) ]
            pub fn buf4to1i(&mut self) -> _Buf4to1iW {
                _Buf4to1iW { w: self }
            }
            # [ doc = "Bit 5 - Buffer MB5 Interrupt Or \"Frames available in Rx FIFO\"" ]
            # [ inline ( always ) ]
            pub fn buf5i(&mut self) -> _Buf5iW {
                _Buf5iW { w: self }
            }
            # [ doc = "Bit 6 - Buffer MB6 Interrupt Or \"Rx FIFO Warning\"" ]
            # [ inline ( always ) ]
            pub fn buf6i(&mut self) -> _Buf6iW {
                _Buf6iW { w: self }
            }
            # [ doc = "Bit 7 - Buffer MB7 Interrupt Or \"Rx FIFO Overflow\"" ]
            # [ inline ( always ) ]
            pub fn buf7i(&mut self) -> _Buf7iW {
                _Buf7iW { w: self }
            }
            # [ doc = "Bits 8:31 - Buffer MBi Interrupt" ]
            # [ inline ( always ) ]
            pub fn buf31to8i(&mut self) -> _Buf31to8iW {
                _Buf31to8iW { w: self }
            }
        }
    }
    # [ doc = "Control 2 register" ]
    pub struct Ctrl2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control 2 register" ]
    pub mod ctrl2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EDFLTDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EdfltdisR {
            # [ doc = "Edge Filter is enabled." ]
            _0,
            # [ doc = "Edge Filter is disabled." ]
            _1,
        }
        impl EdfltdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EdfltdisR::_0 => 0,
                    EdfltdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EdfltdisR {
                match bits {
                    0 => EdfltdisR::_0,
                    1 => EdfltdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EdfltdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EdfltdisR::_1
            }
        }
        # [ doc = "Possible values of the field `ISOCANFDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsocanfdenR {
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            _0,
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            _1,
        }
        impl IsocanfdenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsocanfdenR::_0 => 0,
                    IsocanfdenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsocanfdenR {
                match bits {
                    0 => IsocanfdenR::_0,
                    1 => IsocanfdenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsocanfdenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsocanfdenR::_1
            }
        }
        # [ doc = "Possible values of the field `PREXCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrexcenR {
            # [ doc = "Protocol Exception is disabled." ]
            _0,
            # [ doc = "Protocol Exception is enabled." ]
            _1,
        }
        impl PrexcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrexcenR::_0 => 0,
                    PrexcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrexcenR {
                match bits {
                    0 => PrexcenR::_0,
                    1 => PrexcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrexcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrexcenR::_1
            }
        }
        # [ doc = "Possible values of the field `TIMER_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimerSrcR {
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            _0,
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            _1,
        }
        impl TimerSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimerSrcR::_0 => 0,
                    TimerSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimerSrcR {
                match bits {
                    0 => TimerSrcR::_0,
                    1 => TimerSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimerSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimerSrcR::_1
            }
        }
        # [ doc = "Possible values of the field `EACEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EacenR {
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            _0,
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            _1,
        }
        impl EacenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EacenR::_0 => 0,
                    EacenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EacenR {
                match bits {
                    0 => EacenR::_0,
                    1 => EacenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EacenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EacenR::_1
            }
        }
        # [ doc = "Possible values of the field `RRS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RrsR {
            # [ doc = "Remote Response Frame is generated." ]
            _0,
            # [ doc = "Remote Request Frame is stored." ]
            _1,
        }
        impl RrsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RrsR::_0 => 0,
                    RrsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RrsR {
                match bits {
                    0 => RrsR::_0,
                    1 => RrsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RrsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RrsR::_1
            }
        }
        # [ doc = "Possible values of the field `MRP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MrpR {
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            _0,
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            _1,
        }
        impl MrpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MrpR::_0 => 0,
                    MrpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MrpR {
                match bits {
                    0 => MrpR::_0,
                    1 => MrpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MrpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MrpR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TasdR {
            bits: u8,
        }
        impl TasdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RffnR {
            bits: u8,
        }
        impl RffnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BOFFDONEMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffdonemskR {
            # [ doc = "Bus Off Done interrupt disabled." ]
            _0,
            # [ doc = "Bus Off Done interrupt enabled." ]
            _1,
        }
        impl BoffdonemskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffdonemskR::_0 => 0,
                    BoffdonemskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffdonemskR {
                match bits {
                    0 => BoffdonemskR::_0,
                    1 => BoffdonemskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffdonemskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffdonemskR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRMSK_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrmskFastR {
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            _0,
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            _1,
        }
        impl ErrmskFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrmskFastR::_0 => 0,
                    ErrmskFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrmskFastR {
                match bits {
                    0 => ErrmskFastR::_0,
                    1 => ErrmskFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrmskFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrmskFastR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EDFLTDIS`" ]
        pub enum EdfltdisW {
            # [ doc = "Edge Filter is enabled." ]
            _0,
            # [ doc = "Edge Filter is disabled." ]
            _1,
        }
        impl EdfltdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EdfltdisW::_0 => 0,
                    EdfltdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EdfltdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EdfltdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EdfltdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Edge Filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EdfltdisW::_0)
            }
            # [ doc = "Edge Filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EdfltdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISOCANFDEN`" ]
        pub enum IsocanfdenW {
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            _0,
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            _1,
        }
        impl IsocanfdenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsocanfdenW::_0 => 0,
                    IsocanfdenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsocanfdenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsocanfdenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsocanfdenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsocanfdenW::_0)
            }
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsocanfdenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PREXCEN`" ]
        pub enum PrexcenW {
            # [ doc = "Protocol Exception is disabled." ]
            _0,
            # [ doc = "Protocol Exception is enabled." ]
            _1,
        }
        impl PrexcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrexcenW::_0 => 0,
                    PrexcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrexcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrexcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrexcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Protocol Exception is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PrexcenW::_0)
            }
            # [ doc = "Protocol Exception is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PrexcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMER_SRC`" ]
        pub enum TimerSrcW {
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            _0,
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            _1,
        }
        impl TimerSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimerSrcW::_0 => 0,
                    TimerSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimerSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimerSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimerSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimerSrcW::_0)
            }
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimerSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EACEN`" ]
        pub enum EacenW {
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            _0,
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            _1,
        }
        impl EacenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EacenW::_0 => 0,
                    EacenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EacenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EacenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EacenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EacenW::_0)
            }
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EacenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRS`" ]
        pub enum RrsW {
            # [ doc = "Remote Response Frame is generated." ]
            _0,
            # [ doc = "Remote Request Frame is stored." ]
            _1,
        }
        impl RrsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrsW::_0 => 0,
                    RrsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Remote Response Frame is generated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrsW::_0)
            }
            # [ doc = "Remote Request Frame is stored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MRP`" ]
        pub enum MrpW {
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            _0,
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            _1,
        }
        impl MrpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MrpW::_0 => 0,
                    MrpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MrpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MrpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MrpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MrpW::_0)
            }
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MrpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TasdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TasdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RffnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RffnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFDONEMSK`" ]
        pub enum BoffdonemskW {
            # [ doc = "Bus Off Done interrupt disabled." ]
            _0,
            # [ doc = "Bus Off Done interrupt enabled." ]
            _1,
        }
        impl BoffdonemskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffdonemskW::_0 => 0,
                    BoffdonemskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffdonemskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffdonemskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffdonemskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus Off Done interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffdonemskW::_0)
            }
            # [ doc = "Bus Off Done interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffdonemskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRMSK_FAST`" ]
        pub enum ErrmskFastW {
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            _0,
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            _1,
        }
        impl ErrmskFastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrmskFastW::_0 => 0,
                    ErrmskFastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrmskFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrmskFastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrmskFastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrmskFastW::_0)
            }
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrmskFastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 11 - Edge Filter Disable" ]
            # [ inline ( always ) ]
            pub fn edfltdis(&self) -> EdfltdisR {
                EdfltdisR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 11;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 12 - ISO CAN FD Enable" ]
            # [ inline ( always ) ]
            pub fn isocanfden(&self) -> IsocanfdenR {
                IsocanfdenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 12;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 14 - Protocol Exception Enable" ]
            # [ inline ( always ) ]
            pub fn prexcen(&self) -> PrexcenR {
                PrexcenR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Timer Source" ]
            # [ inline ( always ) ]
            pub fn timer_src(&self) -> TimerSrcR {
                TimerSrcR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 15;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 16 - Entire Frame Arbitration Field Comparison Enable For Rx Mailboxes" ]
            # [ inline ( always ) ]
            pub fn eacen(&self) -> EacenR {
                EacenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 17 - Remote Request Storing" ]
            # [ inline ( always ) ]
            pub fn rrs(&self) -> RrsR {
                RrsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Mailboxes Reception Priority" ]
            # [ inline ( always ) ]
            pub fn mrp(&self) -> MrpR {
                MrpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 19:23 - Tx Arbitration Start Delay" ]
            # [ inline ( always ) ]
            pub fn tasd(&self) -> TasdR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TasdR { bits }
            }
            # [ doc = "Bits 24:27 - Number Of Rx FIFO Filters" ]
            # [ inline ( always ) ]
            pub fn rffn(&self) -> RffnR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RffnR { bits }
            }
            # [ doc = "Bit 30 - Bus Off Done Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffdonemsk(&self) -> BoffdonemskR {
                BoffdonemskR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 30;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 31 - Error Interrupt Mask for errors detected in the Data Phase of fast CAN FD frames" ]
            # [ inline ( always ) ]
            pub fn errmsk_fast(&self) -> ErrmskFastR {
                ErrmskFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 31;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 10485760 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 11 - Edge Filter Disable" ]
            # [ inline ( always ) ]
            pub fn edfltdis(&mut self) -> _EdfltdisW {
                _EdfltdisW { w: self }
            }
            # [ doc = "Bit 12 - ISO CAN FD Enable" ]
            # [ inline ( always ) ]
            pub fn isocanfden(&mut self) -> _IsocanfdenW {
                _IsocanfdenW { w: self }
            }
            # [ doc = "Bit 14 - Protocol Exception Enable" ]
            # [ inline ( always ) ]
            pub fn prexcen(&mut self) -> _PrexcenW {
                _PrexcenW { w: self }
            }
            # [ doc = "Bit 15 - Timer Source" ]
            # [ inline ( always ) ]
            pub fn timer_src(&mut self) -> _TimerSrcW {
                _TimerSrcW { w: self }
            }
            # [ doc = "Bit 16 - Entire Frame Arbitration Field Comparison Enable For Rx Mailboxes" ]
            # [ inline ( always ) ]
            pub fn eacen(&mut self) -> _EacenW {
                _EacenW { w: self }
            }
            # [ doc = "Bit 17 - Remote Request Storing" ]
            # [ inline ( always ) ]
            pub fn rrs(&mut self) -> _RrsW {
                _RrsW { w: self }
            }
            # [ doc = "Bit 18 - Mailboxes Reception Priority" ]
            # [ inline ( always ) ]
            pub fn mrp(&mut self) -> _MrpW {
                _MrpW { w: self }
            }
            # [ doc = "Bits 19:23 - Tx Arbitration Start Delay" ]
            # [ inline ( always ) ]
            pub fn tasd(&mut self) -> _TasdW {
                _TasdW { w: self }
            }
            # [ doc = "Bits 24:27 - Number Of Rx FIFO Filters" ]
            # [ inline ( always ) ]
            pub fn rffn(&mut self) -> _RffnW {
                _RffnW { w: self }
            }
            # [ doc = "Bit 30 - Bus Off Done Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffdonemsk(&mut self) -> _BoffdonemskW {
                _BoffdonemskW { w: self }
            }
            # [ doc = "Bit 31 - Error Interrupt Mask for errors detected in the Data Phase of fast CAN FD frames" ]
            # [ inline ( always ) ]
            pub fn errmsk_fast(&mut self) -> _ErrmskFastW {
                _ErrmskFastW { w: self }
            }
        }
    }
    # [ doc = "Error and Status 2 register" ]
    pub struct Esr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error and Status 2 register" ]
    pub mod esr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Esr2 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `IMB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ImbR {
            # [ doc = "If ESR2[VPS] is asserted, the ESR2[LPTM] is not an inactive Mailbox." ]
            _0,
            # [ doc = "If ESR2[VPS] is asserted, there is at least one inactive Mailbox. LPTM content is the number of the first one." ]
            _1,
        }
        impl ImbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ImbR::_0 => 0,
                    ImbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ImbR {
                match bits {
                    0 => ImbR::_0,
                    1 => ImbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ImbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ImbR::_1
            }
        }
        # [ doc = "Possible values of the field `VPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VpsR {
            # [ doc = "Contents of IMB and LPTM are invalid." ]
            _0,
            # [ doc = "Contents of IMB and LPTM are valid." ]
            _1,
        }
        impl VpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VpsR::_0 => 0,
                    VpsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VpsR {
                match bits {
                    0 => VpsR::_0,
                    1 => VpsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VpsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VpsR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LptmR {
            bits: u8,
        }
        impl LptmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 13 - Inactive Mailbox" ]
            # [ inline ( always ) ]
            pub fn imb(&self) -> ImbR {
                ImbR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Valid Priority Status" ]
            # [ inline ( always ) ]
            pub fn vps(&self) -> VpsR {
                VpsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:22 - Lowest Priority Tx Mailbox" ]
            # [ inline ( always ) ]
            pub fn lptm(&self) -> LptmR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LptmR { bits }
            }
        }
    }
    # [ doc = "CRC Register" ]
    pub struct Crcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "CRC Register" ]
    pub mod crcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Crcr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcrcR {
            bits: u16,
        }
        impl TxcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MbcrcR {
            bits: u8,
        }
        impl MbcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Transmitted CRC value" ]
            # [ inline ( always ) ]
            pub fn txcrc(&self) -> TxcrcR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TxcrcR { bits }
            }
            # [ doc = "Bits 16:22 - CRC Mailbox" ]
            # [ inline ( always ) ]
            pub fn mbcrc(&self) -> MbcrcR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MbcrcR { bits }
            }
        }
    }
    # [ doc = "Rx FIFO Global Mask register" ]
    pub struct Rxfgmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx FIFO Global Mask register" ]
    pub mod rxfgmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rxfgmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FgmR {
            bits: u32,
        }
        impl FgmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FgmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FgmW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx FIFO Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn fgm(&self) -> FgmR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FgmR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx FIFO Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn fgm(&mut self) -> _FgmW {
                _FgmW { w: self }
            }
        }
    }
    # [ doc = "Rx FIFO Information Register" ]
    pub struct Rxfir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx FIFO Information Register" ]
    pub mod rxfir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rxfir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdhitR {
            bits: u16,
        }
        impl IdhitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Identifier Acceptance Filter Hit Indicator" ]
            # [ inline ( always ) ]
            pub fn idhit(&self) -> IdhitR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                IdhitR { bits }
            }
        }
    }
    # [ doc = "CAN Bit Timing Register" ]
    pub struct Cbt {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN Bit Timing Register" ]
    pub mod cbt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cbt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Epseg2R {
            bits: u8,
        }
        impl Epseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Epseg1R {
            bits: u8,
        }
        impl Epseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EpropsegR {
            bits: u8,
        }
        impl EpropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ErjwR {
            bits: u8,
        }
        impl ErjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EpresdivR {
            bits: u16,
        }
        impl EpresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BtfR {
            # [ doc = "Extended bit time definitions disabled." ]
            _0,
            # [ doc = "Extended bit time definitions enabled." ]
            _1,
        }
        impl BtfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BtfR::_0 => 0,
                    BtfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BtfR {
                match bits {
                    0 => BtfR::_0,
                    1 => BtfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BtfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BtfR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Epseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Epseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Epseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Epseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BTF`" ]
        pub enum BtfW {
            # [ doc = "Extended bit time definitions disabled." ]
            _0,
            # [ doc = "Extended bit time definitions enabled." ]
            _1,
        }
        impl BtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BtfW::_0 => 0,
                    BtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Extended bit time definitions disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BtfW::_0)
            }
            # [ doc = "Extended bit time definitions enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Extended Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn epseg2(&self) -> Epseg2R {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Epseg2R { bits }
            }
            # [ doc = "Bits 5:9 - Extended Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn epseg1(&self) -> Epseg1R {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Epseg1R { bits }
            }
            # [ doc = "Bits 10:15 - Extended Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn epropseg(&self) -> EpropsegR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EpropsegR { bits }
            }
            # [ doc = "Bits 16:20 - Extended Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn erjw(&self) -> ErjwR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ErjwR { bits }
            }
            # [ doc = "Bits 21:30 - Extended Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn epresdiv(&self) -> EpresdivR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                EpresdivR { bits }
            }
            # [ doc = "Bit 31 - Bit Timing Format Enable" ]
            # [ inline ( always ) ]
            pub fn btf(&self) -> BtfR {
                BtfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 31;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Extended Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn epseg2(&mut self) -> _Epseg2W {
                _Epseg2W { w: self }
            }
            # [ doc = "Bits 5:9 - Extended Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn epseg1(&mut self) -> _Epseg1W {
                _Epseg1W { w: self }
            }
            # [ doc = "Bits 10:15 - Extended Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn epropseg(&mut self) -> _EpropsegW {
                _EpropsegW { w: self }
            }
            # [ doc = "Bits 16:20 - Extended Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn erjw(&mut self) -> _ErjwW {
                _ErjwW { w: self }
            }
            # [ doc = "Bits 21:30 - Extended Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn epresdiv(&mut self) -> _EpresdivW {
                _EpresdivW { w: self }
            }
            # [ doc = "Bit 31 - Bit Timing Format Enable" ]
            # [ inline ( always ) ]
            pub fn btf(&mut self) -> _BtfW {
                _BtfW { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam32 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram32 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam32 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam33 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram33 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam33 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam34 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram34 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam34 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam35 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram35 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam35 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam36 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram36 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam36 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam37 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram37 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam37 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam38 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram38 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam38 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam39 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram39 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam39 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam40 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram40 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam40 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam41 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram41 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam41 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam42 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram42 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam42 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam43 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram43 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam43 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam44 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram44 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam44 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam45 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram45 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam45 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam46 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram46 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam46 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam47 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam48 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram48 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam48 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam49 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram49 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam49 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam50 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram50 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam50 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam51 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram51 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam51 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam52 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram52 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam52 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam53 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram53 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam53 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam54 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram54 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam54 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam55 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram55 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam55 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam56 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram56 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam56 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam57 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram57 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam57 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam58 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram58 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam58 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam59 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram59 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam59 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam60 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram60 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam60 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam61 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram61 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam61 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam62 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram62 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam62 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam63 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram63 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam63 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam64 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram64 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam64 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam65 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram65 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam65 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam66 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram66 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam66 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam67 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram67 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam67 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam68 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram68 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam68 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam69 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram69 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam69 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam70 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram70 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam70 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam71 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram71 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam71 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam72 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram72 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam72 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam73 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram73 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam73 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam74 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram74 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam74 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam75 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram75 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam75 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam76 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram76 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam76 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam77 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram77 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam77 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam78 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram78 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam78 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam79 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram79 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam79 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam80 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram80 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam80 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam81 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram81 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam81 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam82 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram82 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam82 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam83 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram83 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam83 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam84 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram84 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam84 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam85 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram85 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam85 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam86 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram86 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam86 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam87 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram87 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam87 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam88 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram88 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam88 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam89 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram89 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam89 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam90 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram90 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam90 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam91 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram91 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam91 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam92 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram92 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam92 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam93 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram93 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam93 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam94 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram94 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam94 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam95 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram95 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam95 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam96 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram96 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam96 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam97 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram97 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam97 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam98 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram98 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam98 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam99 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram99 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam99 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam100 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram100 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam100 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam101 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram101 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam101 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam102 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram102 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam102 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam103 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram103 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam103 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam104 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram104 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam104 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam105 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram105 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam105 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam106 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram106 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam106 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam107 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram107 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam107 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam108 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram108 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam108 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam109 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram109 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam109 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam110 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram110 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam110 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam111 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram111 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam111 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam112 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram112 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam112 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam113 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram113 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam113 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam114 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram114 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam114 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam115 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram115 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam115 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam116 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram116 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam116 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam117 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram117 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam117 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam118 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram118 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam118 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam119 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram119 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam119 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam120 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram120 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam120 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam121 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram121 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam121 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam122 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram122 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam122 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam123 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram123 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam123 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam124 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram124 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam124 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam125 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram125 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam125 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam126 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram126 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam126 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam127 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram127 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam127 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Control 1 Register" ]
    pub struct Ctrl1Pn {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Control 1 Register" ]
    pub mod ctrl1_pn {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl1Pn {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcsR {
            # [ doc = "Message ID filtering only" ]
            _00,
            # [ doc = "Message ID filtering and payload filtering" ]
            _01,
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            _10,
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            _11,
        }
        impl FcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcsR::_00 => 0,
                    FcsR::_01 => 1,
                    FcsR::_10 => 2,
                    FcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcsR {
                match bits {
                    0 => FcsR::_00,
                    1 => FcsR::_01,
                    2 => FcsR::_10,
                    3 => FcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FcsR::_11
            }
        }
        # [ doc = "Possible values of the field `IDFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdfsR {
            # [ doc = "Match upon a ID contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl IdfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdfsR::_00 => 0,
                    IdfsR::_01 => 1,
                    IdfsR::_10 => 2,
                    IdfsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdfsR {
                match bits {
                    0 => IdfsR::_00,
                    1 => IdfsR::_01,
                    2 => IdfsR::_10,
                    3 => IdfsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == IdfsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == IdfsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == IdfsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == IdfsR::_11
            }
        }
        # [ doc = "Possible values of the field `PLFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PlfsR {
            # [ doc = "Match upon a payload contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl PlfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PlfsR::_00 => 0,
                    PlfsR::_01 => 1,
                    PlfsR::_10 => 2,
                    PlfsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PlfsR {
                match bits {
                    0 => PlfsR::_00,
                    1 => PlfsR::_01,
                    2 => PlfsR::_10,
                    3 => PlfsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PlfsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PlfsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PlfsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PlfsR::_11
            }
        }
        # [ doc = "Possible values of the field `NMATCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NmatchR {
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            _00000001,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            _00000010,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            _11111111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NmatchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NmatchR::_00000001 => 1,
                    NmatchR::_00000010 => 2,
                    NmatchR::_11111111 => 255,
                    NmatchR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NmatchR {
                match bits {
                    1 => NmatchR::_00000001,
                    2 => NmatchR::_00000010,
                    255 => NmatchR::_11111111,
                    i => NmatchR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == NmatchR::_00000001
            }
            # [ doc = "Checks if the value of the field is `_00000010`" ]
            # [ inline ( always ) ]
            pub fn is_00000010(&self) -> bool {
                *self == NmatchR::_00000010
            }
            # [ doc = "Checks if the value of the field is `_11111111`" ]
            # [ inline ( always ) ]
            pub fn is_11111111(&self) -> bool {
                *self == NmatchR::_11111111
            }
        }
        # [ doc = "Possible values of the field `WUMF_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WumfMskR {
            # [ doc = "Wake up match event is disabled" ]
            _0,
            # [ doc = "Wake up match event is enabled" ]
            _1,
        }
        impl WumfMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WumfMskR::_0 => 0,
                    WumfMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WumfMskR {
                match bits {
                    0 => WumfMskR::_0,
                    1 => WumfMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WumfMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WumfMskR::_1
            }
        }
        # [ doc = "Possible values of the field `WTOF_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WtofMskR {
            # [ doc = "Timeout wake up event is disabled" ]
            _0,
            # [ doc = "Timeout wake up event is enabled" ]
            _1,
        }
        impl WtofMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WtofMskR::_0 => 0,
                    WtofMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WtofMskR {
                match bits {
                    0 => WtofMskR::_0,
                    1 => WtofMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WtofMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WtofMskR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FCS`" ]
        pub enum FcsW {
            # [ doc = "Message ID filtering only" ]
            _00,
            # [ doc = "Message ID filtering and payload filtering" ]
            _01,
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            _10,
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            _11,
        }
        impl FcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcsW::_00 => 0,
                    FcsW::_01 => 1,
                    FcsW::_10 => 2,
                    FcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Message ID filtering only" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FcsW::_00)
            }
            # [ doc = "Message ID filtering and payload filtering" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FcsW::_01)
            }
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FcsW::_10)
            }
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDFS`" ]
        pub enum IdfsW {
            # [ doc = "Match upon a ID contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl IdfsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdfsW::_00 => 0,
                    IdfsW::_01 => 1,
                    IdfsW::_10 => 2,
                    IdfsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdfsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdfsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Match upon a ID contents against an exact target value" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(IdfsW::_00)
            }
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(IdfsW::_01)
            }
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(IdfsW::_10)
            }
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(IdfsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PLFS`" ]
        pub enum PlfsW {
            # [ doc = "Match upon a payload contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl PlfsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PlfsW::_00 => 0,
                    PlfsW::_01 => 1,
                    PlfsW::_10 => 2,
                    PlfsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PlfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PlfsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PlfsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Match upon a payload contents against an exact target value" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PlfsW::_00)
            }
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PlfsW::_01)
            }
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PlfsW::_10)
            }
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PlfsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NMATCH`" ]
        pub enum NmatchW {
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            _00000001,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            _00000010,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            _11111111,
        }
        impl NmatchW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NmatchW::_00000001 => 1,
                    NmatchW::_00000010 => 2,
                    NmatchW::_11111111 => 255,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NmatchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NmatchW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NmatchW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(NmatchW::_00000001)
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _00000010(self) -> &'a mut W {
                self.variant(NmatchW::_00000010)
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _11111111(self) -> &'a mut W {
                self.variant(NmatchW::_11111111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WUMF_MSK`" ]
        pub enum WumfMskW {
            # [ doc = "Wake up match event is disabled" ]
            _0,
            # [ doc = "Wake up match event is enabled" ]
            _1,
        }
        impl WumfMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WumfMskW::_0 => 0,
                    WumfMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WumfMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WumfMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WumfMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Wake up match event is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WumfMskW::_0)
            }
            # [ doc = "Wake up match event is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WumfMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WTOF_MSK`" ]
        pub enum WtofMskW {
            # [ doc = "Timeout wake up event is disabled" ]
            _0,
            # [ doc = "Timeout wake up event is enabled" ]
            _1,
        }
        impl WtofMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WtofMskW::_0 => 0,
                    WtofMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WtofMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WtofMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WtofMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timeout wake up event is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WtofMskW::_0)
            }
            # [ doc = "Timeout wake up event is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WtofMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Filtering Combination Selection" ]
            # [ inline ( always ) ]
            pub fn fcs(&self) -> FcsR {
                FcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 2:3 - ID Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn idfs(&self) -> IdfsR {
                IdfsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 4:5 - Payload Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn plfs(&self) -> PlfsR {
                PlfsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 8:15 - Number of Messages Matching the Same Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn nmatch(&self) -> NmatchR {
                NmatchR::_from({
                                   const MASK: u8 = 255;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wumf_msk(&self) -> WumfMskR {
                WumfMskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wtof_msk(&self) -> WtofMskR {
                WtofMskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 256 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Filtering Combination Selection" ]
            # [ inline ( always ) ]
            pub fn fcs(&mut self) -> _FcsW {
                _FcsW { w: self }
            }
            # [ doc = "Bits 2:3 - ID Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn idfs(&mut self) -> _IdfsW {
                _IdfsW { w: self }
            }
            # [ doc = "Bits 4:5 - Payload Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn plfs(&mut self) -> _PlfsW {
                _PlfsW { w: self }
            }
            # [ doc = "Bits 8:15 - Number of Messages Matching the Same Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn nmatch(&mut self) -> _NmatchW {
                _NmatchW { w: self }
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wumf_msk(&mut self) -> _WumfMskW {
                _WumfMskW { w: self }
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wtof_msk(&mut self) -> _WtofMskW {
                _WtofMskW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Control 2 Register" ]
    pub struct Ctrl2Pn {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Control 2 Register" ]
    pub mod ctrl2_pn {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl2Pn {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MatchtoR {
            bits: u16,
        }
        impl MatchtoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatchtoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatchtoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timeout for No Message Matching the Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn matchto(&self) -> MatchtoR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MatchtoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timeout for No Message Matching the Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn matchto(&mut self) -> _MatchtoW {
                _MatchtoW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Wake Up Match Register" ]
    pub struct WuMtc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Wake Up Match Register" ]
    pub mod wu_mtc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::WuMtc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct McounterR {
            bits: u8,
        }
        impl McounterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WUMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WumfR {
            # [ doc = "No wake up by match event detected" ]
            _0,
            # [ doc = "Wake up by match event detected" ]
            _1,
        }
        impl WumfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WumfR::_0 => 0,
                    WumfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WumfR {
                match bits {
                    0 => WumfR::_0,
                    1 => WumfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WumfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WumfR::_1
            }
        }
        # [ doc = "Possible values of the field `WTOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WtofR {
            # [ doc = "No wake up by timeout event detected" ]
            _0,
            # [ doc = "Wake up by timeout event detected" ]
            _1,
        }
        impl WtofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WtofR::_0 => 0,
                    WtofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WtofR {
                match bits {
                    0 => WtofR::_0,
                    1 => WtofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WtofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WtofR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WUMF`" ]
        pub enum WumfW {
            # [ doc = "No wake up by match event detected" ]
            _0,
            # [ doc = "Wake up by match event detected" ]
            _1,
        }
        impl WumfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WumfW::_0 => 0,
                    WumfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WumfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WumfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WumfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No wake up by match event detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WumfW::_0)
            }
            # [ doc = "Wake up by match event detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WumfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WTOF`" ]
        pub enum WtofW {
            # [ doc = "No wake up by timeout event detected" ]
            _0,
            # [ doc = "Wake up by timeout event detected" ]
            _1,
        }
        impl WtofW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WtofW::_0 => 0,
                    WtofW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WtofW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WtofW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WtofW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No wake up by timeout event detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WtofW::_0)
            }
            # [ doc = "Wake up by timeout event detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WtofW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:15 - Number of Matches while in Pretended Networking" ]
            # [ inline ( always ) ]
            pub fn mcounter(&self) -> McounterR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                McounterR { bits }
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wumf(&self) -> WumfR {
                WumfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wtof(&self) -> WtofR {
                WtofR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wumf(&mut self) -> _WumfW {
                _WumfW { w: self }
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wtof(&mut self) -> _WtofW {
                _WtofW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking ID Filter 1 Register" ]
    pub struct FltId1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking ID Filter 1 Register" ]
    pub mod flt_id1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltId1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltId1R {
            bits: u32,
        }
        impl FltId1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FLT_RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltRtrR {
            # [ doc = "Reject remote frame (accept data frame)" ]
            _0,
            # [ doc = "Accept remote frame" ]
            _1,
        }
        impl FltRtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltRtrR::_0 => 0,
                    FltRtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltRtrR {
                match bits {
                    0 => FltRtrR::_0,
                    1 => FltRtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FltRtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FltRtrR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT_IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltIdeR {
            # [ doc = "Accept standard frame format" ]
            _0,
            # [ doc = "Accept extended frame format" ]
            _1,
        }
        impl FltIdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltIdeR::_0 => 0,
                    FltIdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltIdeR {
                match bits {
                    0 => FltIdeR::_0,
                    1 => FltIdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FltIdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FltIdeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltId1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltId1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 536870911;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT_RTR`" ]
        pub enum FltRtrW {
            # [ doc = "Reject remote frame (accept data frame)" ]
            _0,
            # [ doc = "Accept remote frame" ]
            _1,
        }
        impl FltRtrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltRtrW::_0 => 0,
                    FltRtrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltRtrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltRtrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltRtrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reject remote frame (accept data frame)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FltRtrW::_0)
            }
            # [ doc = "Accept remote frame" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FltRtrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT_IDE`" ]
        pub enum FltIdeW {
            # [ doc = "Accept standard frame format" ]
            _0,
            # [ doc = "Accept extended frame format" ]
            _1,
        }
        impl FltIdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltIdeW::_0 => 0,
                    FltIdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltIdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltIdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltIdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accept standard frame format" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FltIdeW::_0)
            }
            # [ doc = "Accept extended frame format" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FltIdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - ID Filter 1 for Pretended Networking filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id1(&self) -> FltId1R {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FltId1R { bits }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Filter" ]
            # [ inline ( always ) ]
            pub fn flt_rtr(&self) -> FltRtrR {
                FltRtrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 29;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ID Extended Filter" ]
            # [ inline ( always ) ]
            pub fn flt_ide(&self) -> FltIdeR {
                FltIdeR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:28 - ID Filter 1 for Pretended Networking filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id1(&mut self) -> _FltId1W {
                _FltId1W { w: self }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Filter" ]
            # [ inline ( always ) ]
            pub fn flt_rtr(&mut self) -> _FltRtrW {
                _FltRtrW { w: self }
            }
            # [ doc = "Bit 30 - ID Extended Filter" ]
            # [ inline ( always ) ]
            pub fn flt_ide(&mut self) -> _FltIdeW {
                _FltIdeW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking DLC Filter Register" ]
    pub struct FltDlc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking DLC Filter Register" ]
    pub mod flt_dlc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltDlc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltDlcHiR {
            bits: u8,
        }
        impl FltDlcHiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltDlcLoR {
            bits: u8,
        }
        impl FltDlcLoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltDlcHiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltDlcHiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltDlcLoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltDlcLoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Upper Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_hi(&self) -> FltDlcHiR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FltDlcHiR { bits }
            }
            # [ doc = "Bits 16:19 - Lower Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_lo(&self) -> FltDlcLoR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FltDlcLoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 8 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Upper Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_hi(&mut self) -> _FltDlcHiW {
                _FltDlcHiW { w: self }
            }
            # [ doc = "Bits 16:19 - Lower Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_lo(&mut self) -> _FltDlcLoW {
                _FltDlcLoW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload Low Filter 1 Register" ]
    pub struct Pl1Lo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload Low Filter 1 Register" ]
    pub mod pl1_lo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl1Lo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload High Filter 1 Register" ]
    pub struct Pl1Hi {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload High Filter 1 Register" ]
    pub mod pl1_hi {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl1Hi {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&mut self) -> _DataByte7W {
                _DataByte7W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&mut self) -> _DataByte6W {
                _DataByte6W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&mut self) -> _DataByte5W {
                _DataByte5W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&mut self) -> _DataByte4W {
                _DataByte4W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking ID Filter 2 Register / ID Mask Register" ]
    pub struct FltId2Idmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking ID Filter 2 Register / ID Mask Register" ]
    pub mod flt_id2_idmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltId2Idmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltId2IdmaskR {
            bits: u32,
        }
        impl FltId2IdmaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrMskR {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl RtrMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrMskR::_0 => 0,
                    RtrMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrMskR {
                match bits {
                    0 => RtrMskR::_0,
                    1 => RtrMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrMskR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeMskR {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl IdeMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeMskR::_0 => 0,
                    IdeMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeMskR {
                match bits {
                    0 => IdeMskR::_0,
                    1 => IdeMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeMskR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltId2IdmaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltId2IdmaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 536870911;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTR_MSK`" ]
        pub enum RtrMskW {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl RtrMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtrMskW::_0 => 0,
                    RtrMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtrMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtrMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtrMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtrMskW::_0)
            }
            # [ doc = "The corresponding bit in the filter is checked" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtrMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDE_MSK`" ]
        pub enum IdeMskW {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl IdeMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdeMskW::_0 => 0,
                    IdeMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdeMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdeMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdeMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IdeMskW::_0)
            }
            # [ doc = "The corresponding bit in the filter is checked" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IdeMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - ID Filter 2 for Pretended Networking Filtering / ID Mask Bits for Pretended Networking ID Filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id2_idmask(&self) -> FltId2IdmaskR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FltId2IdmaskR { bits }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Mask Bit" ]
            # [ inline ( always ) ]
            pub fn rtr_msk(&self) -> RtrMskR {
                RtrMskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 29;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ID Extended Mask Bit" ]
            # [ inline ( always ) ]
            pub fn ide_msk(&self) -> IdeMskR {
                IdeMskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:28 - ID Filter 2 for Pretended Networking Filtering / ID Mask Bits for Pretended Networking ID Filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id2_idmask(&mut self) -> _FltId2IdmaskW {
                _FltId2IdmaskW { w: self }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Mask Bit" ]
            # [ inline ( always ) ]
            pub fn rtr_msk(&mut self) -> _RtrMskW {
                _RtrMskW { w: self }
            }
            # [ doc = "Bit 30 - ID Extended Mask Bit" ]
            # [ inline ( always ) ]
            pub fn ide_msk(&mut self) -> _IdeMskW {
                _IdeMskW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
    pub struct Pl2PlmaskLo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
    pub mod pl2_plmask_lo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl2PlmaskLo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
    pub struct Pl2PlmaskHi {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
    pub mod pl2_plmask_hi {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl2PlmaskHi {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&mut self) -> _DataByte7W {
                _DataByte7W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&mut self) -> _DataByte6W {
                _DataByte6W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&mut self) -> _DataByte5W {
                _DataByte5W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&mut self) -> _DataByte4W {
                _DataByte4W { w: self }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb0Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb0_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb0Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb0_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb0D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb0_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb0D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb0_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb1Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb1_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb1Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb1_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb1D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb1_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb1D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb1_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb2Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb2_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb2Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb2_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb2D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb2_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb2D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb2_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb3Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb3_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb3Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb3_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb3D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb3_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb3D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb3_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "CAN FD Control Register" ]
    pub struct Fdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD Control Register" ]
    pub mod fdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TdcvalR {
            bits: u8,
        }
        impl TdcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TdcoffR {
            bits: u8,
        }
        impl TdcoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TDCFAIL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdcfailR {
            # [ doc = "Measured loop delay is in range." ]
            _0,
            # [ doc = "Measured loop delay is out of range." ]
            _1,
        }
        impl TdcfailR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdcfailR::_0 => 0,
                    TdcfailR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdcfailR {
                match bits {
                    0 => TdcfailR::_0,
                    1 => TdcfailR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdcfailR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdcfailR::_1
            }
        }
        # [ doc = "Possible values of the field `TDCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdcenR {
            # [ doc = "TDC is disabled" ]
            _0,
            # [ doc = "TDC is enabled" ]
            _1,
        }
        impl TdcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdcenR::_0 => 0,
                    TdcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdcenR {
                match bits {
                    0 => TdcenR::_0,
                    1 => TdcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdcenR::_1
            }
        }
        # [ doc = "Possible values of the field `MBDSR0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mbdsr0R {
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            _00,
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            _01,
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            _10,
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            _11,
        }
        impl Mbdsr0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mbdsr0R::_00 => 0,
                    Mbdsr0R::_01 => 1,
                    Mbdsr0R::_10 => 2,
                    Mbdsr0R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mbdsr0R {
                match bits {
                    0 => Mbdsr0R::_00,
                    1 => Mbdsr0R::_01,
                    2 => Mbdsr0R::_10,
                    3 => Mbdsr0R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Mbdsr0R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Mbdsr0R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Mbdsr0R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Mbdsr0R::_11
            }
        }
        # [ doc = "Possible values of the field `FDRATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdrateR {
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            _0,
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            _1,
        }
        impl FdrateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdrateR::_0 => 0,
                    FdrateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdrateR {
                match bits {
                    0 => FdrateR::_0,
                    1 => FdrateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdrateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdrateR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDCFAIL`" ]
        pub enum TdcfailW {
            # [ doc = "Measured loop delay is in range." ]
            _0,
            # [ doc = "Measured loop delay is out of range." ]
            _1,
        }
        impl TdcfailW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdcfailW::_0 => 0,
                    TdcfailW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcfailW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcfailW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdcfailW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Measured loop delay is in range." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdcfailW::_0)
            }
            # [ doc = "Measured loop delay is out of range." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdcfailW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDCEN`" ]
        pub enum TdcenW {
            # [ doc = "TDC is disabled" ]
            _0,
            # [ doc = "TDC is enabled" ]
            _1,
        }
        impl TdcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdcenW::_0 => 0,
                    TdcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TDC is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdcenW::_0)
            }
            # [ doc = "TDC is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MBDSR0`" ]
        pub enum Mbdsr0W {
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            _00,
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            _01,
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            _10,
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            _11,
        }
        impl Mbdsr0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mbdsr0W::_00 => 0,
                    Mbdsr0W::_01 => 1,
                    Mbdsr0W::_10 => 2,
                    Mbdsr0W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mbdsr0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mbdsr0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mbdsr0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Mbdsr0W::_00)
            }
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Mbdsr0W::_01)
            }
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Mbdsr0W::_10)
            }
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Mbdsr0W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDRATE`" ]
        pub enum FdrateW {
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            _0,
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            _1,
        }
        impl FdrateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdrateW::_0 => 0,
                    FdrateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdrateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdrateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdrateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdrateW::_0)
            }
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdrateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Transceiver Delay Compensation Value" ]
            # [ inline ( always ) ]
            pub fn tdcval(&self) -> TdcvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TdcvalR { bits }
            }
            # [ doc = "Bits 8:12 - Transceiver Delay Compensation Offset" ]
            # [ inline ( always ) ]
            pub fn tdcoff(&self) -> TdcoffR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TdcoffR { bits }
            }
            # [ doc = "Bit 14 - Transceiver Delay Compensation Fail" ]
            # [ inline ( always ) ]
            pub fn tdcfail(&self) -> TdcfailR {
                TdcfailR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Transceiver Delay Compensation Enable" ]
            # [ inline ( always ) ]
            pub fn tdcen(&self) -> TdcenR {
                TdcenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 16:17 - Message Buffer Data Size for Region 0" ]
            # [ inline ( always ) ]
            pub fn mbdsr0(&self) -> Mbdsr0R {
                Mbdsr0R::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - Bit Rate Switch Enable" ]
            # [ inline ( always ) ]
            pub fn fdrate(&self) -> FdrateR {
                FdrateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483904 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 8:12 - Transceiver Delay Compensation Offset" ]
            # [ inline ( always ) ]
            pub fn tdcoff(&mut self) -> _TdcoffW {
                _TdcoffW { w: self }
            }
            # [ doc = "Bit 14 - Transceiver Delay Compensation Fail" ]
            # [ inline ( always ) ]
            pub fn tdcfail(&mut self) -> _TdcfailW {
                _TdcfailW { w: self }
            }
            # [ doc = "Bit 15 - Transceiver Delay Compensation Enable" ]
            # [ inline ( always ) ]
            pub fn tdcen(&mut self) -> _TdcenW {
                _TdcenW { w: self }
            }
            # [ doc = "Bits 16:17 - Message Buffer Data Size for Region 0" ]
            # [ inline ( always ) ]
            pub fn mbdsr0(&mut self) -> _Mbdsr0W {
                _Mbdsr0W { w: self }
            }
            # [ doc = "Bit 31 - Bit Rate Switch Enable" ]
            # [ inline ( always ) ]
            pub fn fdrate(&mut self) -> _FdrateW {
                _FdrateW { w: self }
            }
        }
    }
    # [ doc = "CAN FD Bit Timing Register" ]
    pub struct Fdcbt {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD Bit Timing Register" ]
    pub mod fdcbt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fdcbt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Fpseg2R {
            bits: u8,
        }
        impl Fpseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Fpseg1R {
            bits: u8,
        }
        impl Fpseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FpropsegR {
            bits: u8,
        }
        impl FpropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FrjwR {
            bits: u8,
        }
        impl FrjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FpresdivR {
            bits: u16,
        }
        impl FpresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fpseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fpseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fpseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fpseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Fast Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn fpseg2(&self) -> Fpseg2R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Fpseg2R { bits }
            }
            # [ doc = "Bits 5:7 - Fast Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn fpseg1(&self) -> Fpseg1R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Fpseg1R { bits }
            }
            # [ doc = "Bits 10:14 - Fast Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn fpropseg(&self) -> FpropsegR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FpropsegR { bits }
            }
            # [ doc = "Bits 16:18 - Fast Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn frjw(&self) -> FrjwR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FrjwR { bits }
            }
            # [ doc = "Bits 20:29 - Fast Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn fpresdiv(&self) -> FpresdivR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FpresdivR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Fast Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn fpseg2(&mut self) -> _Fpseg2W {
                _Fpseg2W { w: self }
            }
            # [ doc = "Bits 5:7 - Fast Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn fpseg1(&mut self) -> _Fpseg1W {
                _Fpseg1W { w: self }
            }
            # [ doc = "Bits 10:14 - Fast Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn fpropseg(&mut self) -> _FpropsegW {
                _FpropsegW { w: self }
            }
            # [ doc = "Bits 16:18 - Fast Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn frjw(&mut self) -> _FrjwW {
                _FrjwW { w: self }
            }
            # [ doc = "Bits 20:29 - Fast Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn fpresdiv(&mut self) -> _FpresdivW {
                _FpresdivW { w: self }
            }
        }
    }
    # [ doc = "CAN FD CRC Register" ]
    pub struct Fdcrc {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD CRC Register" ]
    pub mod fdcrc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Fdcrc {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FdTxcrcR {
            bits: u32,
        }
        impl FdTxcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FdMbcrcR {
            bits: u8,
        }
        impl FdMbcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:20 - Extended Transmitted CRC value" ]
            # [ inline ( always ) ]
            pub fn fd_txcrc(&self) -> FdTxcrcR {
                let bits = {
                    const MASK: u32 = 2097151;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FdTxcrcR { bits }
            }
            # [ doc = "Bits 24:30 - CRC Mailbox Number for FD_TXCRC" ]
            # [ inline ( always ) ]
            pub fn fd_mbcrc(&self) -> FdMbcrcR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FdMbcrcR { bits }
            }
        }
    }
}
# [ doc = "Flex Controller Area Network module" ]
pub struct Can1 {
    register_block: can1::RegisterBlock,
}
impl Deref for Can1 {
    type Target = can1::RegisterBlock;
    fn deref(&self) -> &can1::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Flex Controller Area Network module" ]
pub const CAN2: Peripheral<Can2> = unsafe { Peripheral::new(1073917952) };
# [ doc = "Flex Controller Area Network module" ]
pub mod can2 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Module Configuration Register" ]
        pub mcr: Mcr,
        # [ doc = "0x04 - Control 1 register" ]
        pub ctrl1: Ctrl1,
        # [ doc = "0x08 - Free Running Timer" ]
        pub timer: Timer,
        _reserved0: [u8; 4usize],
        # [ doc = "0x10 - Rx Mailboxes Global Mask Register" ]
        pub rxmgmask: Rxmgmask,
        # [ doc = "0x14 - Rx 14 Mask register" ]
        pub rx14mask: Rx14mask,
        # [ doc = "0x18 - Rx 15 Mask register" ]
        pub rx15mask: Rx15mask,
        # [ doc = "0x1c - Error Counter" ]
        pub ecr: Ecr,
        # [ doc = "0x20 - Error and Status 1 register" ]
        pub esr1: Esr1,
        _reserved1: [u8; 4usize],
        # [ doc = "0x28 - Interrupt Masks 1 register" ]
        pub imask1: Imask1,
        _reserved2: [u8; 4usize],
        # [ doc = "0x30 - Interrupt Flags 1 register" ]
        pub iflag1: Iflag1,
        # [ doc = "0x34 - Control 2 register" ]
        pub ctrl2: Ctrl2,
        # [ doc = "0x38 - Error and Status 2 register" ]
        pub esr2: Esr2,
        _reserved3: [u8; 8usize],
        # [ doc = "0x44 - CRC Register" ]
        pub crcr: Crcr,
        # [ doc = "0x48 - Rx FIFO Global Mask register" ]
        pub rxfgmask: Rxfgmask,
        # [ doc = "0x4c - Rx FIFO Information Register" ]
        pub rxfir: Rxfir,
        # [ doc = "0x50 - CAN Bit Timing Register" ]
        pub cbt: Cbt,
        _reserved4: [u8; 44usize],
        # [ doc = "0x80 - Embedded RAM" ]
        pub embedded_ram0: EmbeddedRam0,
        # [ doc = "0x84 - Embedded RAM" ]
        pub embedded_ram1: EmbeddedRam1,
        # [ doc = "0x88 - Embedded RAM" ]
        pub embedded_ram2: EmbeddedRam2,
        # [ doc = "0x8c - Embedded RAM" ]
        pub embedded_ram3: EmbeddedRam3,
        # [ doc = "0x90 - Embedded RAM" ]
        pub embedded_ram4: EmbeddedRam4,
        # [ doc = "0x94 - Embedded RAM" ]
        pub embedded_ram5: EmbeddedRam5,
        # [ doc = "0x98 - Embedded RAM" ]
        pub embedded_ram6: EmbeddedRam6,
        # [ doc = "0x9c - Embedded RAM" ]
        pub embedded_ram7: EmbeddedRam7,
        # [ doc = "0xa0 - Embedded RAM" ]
        pub embedded_ram8: EmbeddedRam8,
        # [ doc = "0xa4 - Embedded RAM" ]
        pub embedded_ram9: EmbeddedRam9,
        # [ doc = "0xa8 - Embedded RAM" ]
        pub embedded_ram10: EmbeddedRam10,
        # [ doc = "0xac - Embedded RAM" ]
        pub embedded_ram11: EmbeddedRam11,
        # [ doc = "0xb0 - Embedded RAM" ]
        pub embedded_ram12: EmbeddedRam12,
        # [ doc = "0xb4 - Embedded RAM" ]
        pub embedded_ram13: EmbeddedRam13,
        # [ doc = "0xb8 - Embedded RAM" ]
        pub embedded_ram14: EmbeddedRam14,
        # [ doc = "0xbc - Embedded RAM" ]
        pub embedded_ram15: EmbeddedRam15,
        # [ doc = "0xc0 - Embedded RAM" ]
        pub embedded_ram16: EmbeddedRam16,
        # [ doc = "0xc4 - Embedded RAM" ]
        pub embedded_ram17: EmbeddedRam17,
        # [ doc = "0xc8 - Embedded RAM" ]
        pub embedded_ram18: EmbeddedRam18,
        # [ doc = "0xcc - Embedded RAM" ]
        pub embedded_ram19: EmbeddedRam19,
        # [ doc = "0xd0 - Embedded RAM" ]
        pub embedded_ram20: EmbeddedRam20,
        # [ doc = "0xd4 - Embedded RAM" ]
        pub embedded_ram21: EmbeddedRam21,
        # [ doc = "0xd8 - Embedded RAM" ]
        pub embedded_ram22: EmbeddedRam22,
        # [ doc = "0xdc - Embedded RAM" ]
        pub embedded_ram23: EmbeddedRam23,
        # [ doc = "0xe0 - Embedded RAM" ]
        pub embedded_ram24: EmbeddedRam24,
        # [ doc = "0xe4 - Embedded RAM" ]
        pub embedded_ram25: EmbeddedRam25,
        # [ doc = "0xe8 - Embedded RAM" ]
        pub embedded_ram26: EmbeddedRam26,
        # [ doc = "0xec - Embedded RAM" ]
        pub embedded_ram27: EmbeddedRam27,
        # [ doc = "0xf0 - Embedded RAM" ]
        pub embedded_ram28: EmbeddedRam28,
        # [ doc = "0xf4 - Embedded RAM" ]
        pub embedded_ram29: EmbeddedRam29,
        # [ doc = "0xf8 - Embedded RAM" ]
        pub embedded_ram30: EmbeddedRam30,
        # [ doc = "0xfc - Embedded RAM" ]
        pub embedded_ram31: EmbeddedRam31,
        # [ doc = "0x100 - Embedded RAM" ]
        pub embedded_ram32: EmbeddedRam32,
        # [ doc = "0x104 - Embedded RAM" ]
        pub embedded_ram33: EmbeddedRam33,
        # [ doc = "0x108 - Embedded RAM" ]
        pub embedded_ram34: EmbeddedRam34,
        # [ doc = "0x10c - Embedded RAM" ]
        pub embedded_ram35: EmbeddedRam35,
        # [ doc = "0x110 - Embedded RAM" ]
        pub embedded_ram36: EmbeddedRam36,
        # [ doc = "0x114 - Embedded RAM" ]
        pub embedded_ram37: EmbeddedRam37,
        # [ doc = "0x118 - Embedded RAM" ]
        pub embedded_ram38: EmbeddedRam38,
        # [ doc = "0x11c - Embedded RAM" ]
        pub embedded_ram39: EmbeddedRam39,
        # [ doc = "0x120 - Embedded RAM" ]
        pub embedded_ram40: EmbeddedRam40,
        # [ doc = "0x124 - Embedded RAM" ]
        pub embedded_ram41: EmbeddedRam41,
        # [ doc = "0x128 - Embedded RAM" ]
        pub embedded_ram42: EmbeddedRam42,
        # [ doc = "0x12c - Embedded RAM" ]
        pub embedded_ram43: EmbeddedRam43,
        # [ doc = "0x130 - Embedded RAM" ]
        pub embedded_ram44: EmbeddedRam44,
        # [ doc = "0x134 - Embedded RAM" ]
        pub embedded_ram45: EmbeddedRam45,
        # [ doc = "0x138 - Embedded RAM" ]
        pub embedded_ram46: EmbeddedRam46,
        # [ doc = "0x13c - Embedded RAM" ]
        pub embedded_ram47: EmbeddedRam47,
        # [ doc = "0x140 - Embedded RAM" ]
        pub embedded_ram48: EmbeddedRam48,
        # [ doc = "0x144 - Embedded RAM" ]
        pub embedded_ram49: EmbeddedRam49,
        # [ doc = "0x148 - Embedded RAM" ]
        pub embedded_ram50: EmbeddedRam50,
        # [ doc = "0x14c - Embedded RAM" ]
        pub embedded_ram51: EmbeddedRam51,
        # [ doc = "0x150 - Embedded RAM" ]
        pub embedded_ram52: EmbeddedRam52,
        # [ doc = "0x154 - Embedded RAM" ]
        pub embedded_ram53: EmbeddedRam53,
        # [ doc = "0x158 - Embedded RAM" ]
        pub embedded_ram54: EmbeddedRam54,
        # [ doc = "0x15c - Embedded RAM" ]
        pub embedded_ram55: EmbeddedRam55,
        # [ doc = "0x160 - Embedded RAM" ]
        pub embedded_ram56: EmbeddedRam56,
        # [ doc = "0x164 - Embedded RAM" ]
        pub embedded_ram57: EmbeddedRam57,
        # [ doc = "0x168 - Embedded RAM" ]
        pub embedded_ram58: EmbeddedRam58,
        # [ doc = "0x16c - Embedded RAM" ]
        pub embedded_ram59: EmbeddedRam59,
        # [ doc = "0x170 - Embedded RAM" ]
        pub embedded_ram60: EmbeddedRam60,
        # [ doc = "0x174 - Embedded RAM" ]
        pub embedded_ram61: EmbeddedRam61,
        # [ doc = "0x178 - Embedded RAM" ]
        pub embedded_ram62: EmbeddedRam62,
        # [ doc = "0x17c - Embedded RAM" ]
        pub embedded_ram63: EmbeddedRam63,
        # [ doc = "0x180 - Embedded RAM" ]
        pub embedded_ram64: EmbeddedRam64,
        # [ doc = "0x184 - Embedded RAM" ]
        pub embedded_ram65: EmbeddedRam65,
        # [ doc = "0x188 - Embedded RAM" ]
        pub embedded_ram66: EmbeddedRam66,
        # [ doc = "0x18c - Embedded RAM" ]
        pub embedded_ram67: EmbeddedRam67,
        # [ doc = "0x190 - Embedded RAM" ]
        pub embedded_ram68: EmbeddedRam68,
        # [ doc = "0x194 - Embedded RAM" ]
        pub embedded_ram69: EmbeddedRam69,
        # [ doc = "0x198 - Embedded RAM" ]
        pub embedded_ram70: EmbeddedRam70,
        # [ doc = "0x19c - Embedded RAM" ]
        pub embedded_ram71: EmbeddedRam71,
        # [ doc = "0x1a0 - Embedded RAM" ]
        pub embedded_ram72: EmbeddedRam72,
        # [ doc = "0x1a4 - Embedded RAM" ]
        pub embedded_ram73: EmbeddedRam73,
        # [ doc = "0x1a8 - Embedded RAM" ]
        pub embedded_ram74: EmbeddedRam74,
        # [ doc = "0x1ac - Embedded RAM" ]
        pub embedded_ram75: EmbeddedRam75,
        # [ doc = "0x1b0 - Embedded RAM" ]
        pub embedded_ram76: EmbeddedRam76,
        # [ doc = "0x1b4 - Embedded RAM" ]
        pub embedded_ram77: EmbeddedRam77,
        # [ doc = "0x1b8 - Embedded RAM" ]
        pub embedded_ram78: EmbeddedRam78,
        # [ doc = "0x1bc - Embedded RAM" ]
        pub embedded_ram79: EmbeddedRam79,
        # [ doc = "0x1c0 - Embedded RAM" ]
        pub embedded_ram80: EmbeddedRam80,
        # [ doc = "0x1c4 - Embedded RAM" ]
        pub embedded_ram81: EmbeddedRam81,
        # [ doc = "0x1c8 - Embedded RAM" ]
        pub embedded_ram82: EmbeddedRam82,
        # [ doc = "0x1cc - Embedded RAM" ]
        pub embedded_ram83: EmbeddedRam83,
        # [ doc = "0x1d0 - Embedded RAM" ]
        pub embedded_ram84: EmbeddedRam84,
        # [ doc = "0x1d4 - Embedded RAM" ]
        pub embedded_ram85: EmbeddedRam85,
        # [ doc = "0x1d8 - Embedded RAM" ]
        pub embedded_ram86: EmbeddedRam86,
        # [ doc = "0x1dc - Embedded RAM" ]
        pub embedded_ram87: EmbeddedRam87,
        # [ doc = "0x1e0 - Embedded RAM" ]
        pub embedded_ram88: EmbeddedRam88,
        # [ doc = "0x1e4 - Embedded RAM" ]
        pub embedded_ram89: EmbeddedRam89,
        # [ doc = "0x1e8 - Embedded RAM" ]
        pub embedded_ram90: EmbeddedRam90,
        # [ doc = "0x1ec - Embedded RAM" ]
        pub embedded_ram91: EmbeddedRam91,
        # [ doc = "0x1f0 - Embedded RAM" ]
        pub embedded_ram92: EmbeddedRam92,
        # [ doc = "0x1f4 - Embedded RAM" ]
        pub embedded_ram93: EmbeddedRam93,
        # [ doc = "0x1f8 - Embedded RAM" ]
        pub embedded_ram94: EmbeddedRam94,
        # [ doc = "0x1fc - Embedded RAM" ]
        pub embedded_ram95: EmbeddedRam95,
        # [ doc = "0x200 - Embedded RAM" ]
        pub embedded_ram96: EmbeddedRam96,
        # [ doc = "0x204 - Embedded RAM" ]
        pub embedded_ram97: EmbeddedRam97,
        # [ doc = "0x208 - Embedded RAM" ]
        pub embedded_ram98: EmbeddedRam98,
        # [ doc = "0x20c - Embedded RAM" ]
        pub embedded_ram99: EmbeddedRam99,
        # [ doc = "0x210 - Embedded RAM" ]
        pub embedded_ram100: EmbeddedRam100,
        # [ doc = "0x214 - Embedded RAM" ]
        pub embedded_ram101: EmbeddedRam101,
        # [ doc = "0x218 - Embedded RAM" ]
        pub embedded_ram102: EmbeddedRam102,
        # [ doc = "0x21c - Embedded RAM" ]
        pub embedded_ram103: EmbeddedRam103,
        # [ doc = "0x220 - Embedded RAM" ]
        pub embedded_ram104: EmbeddedRam104,
        # [ doc = "0x224 - Embedded RAM" ]
        pub embedded_ram105: EmbeddedRam105,
        # [ doc = "0x228 - Embedded RAM" ]
        pub embedded_ram106: EmbeddedRam106,
        # [ doc = "0x22c - Embedded RAM" ]
        pub embedded_ram107: EmbeddedRam107,
        # [ doc = "0x230 - Embedded RAM" ]
        pub embedded_ram108: EmbeddedRam108,
        # [ doc = "0x234 - Embedded RAM" ]
        pub embedded_ram109: EmbeddedRam109,
        # [ doc = "0x238 - Embedded RAM" ]
        pub embedded_ram110: EmbeddedRam110,
        # [ doc = "0x23c - Embedded RAM" ]
        pub embedded_ram111: EmbeddedRam111,
        # [ doc = "0x240 - Embedded RAM" ]
        pub embedded_ram112: EmbeddedRam112,
        # [ doc = "0x244 - Embedded RAM" ]
        pub embedded_ram113: EmbeddedRam113,
        # [ doc = "0x248 - Embedded RAM" ]
        pub embedded_ram114: EmbeddedRam114,
        # [ doc = "0x24c - Embedded RAM" ]
        pub embedded_ram115: EmbeddedRam115,
        # [ doc = "0x250 - Embedded RAM" ]
        pub embedded_ram116: EmbeddedRam116,
        # [ doc = "0x254 - Embedded RAM" ]
        pub embedded_ram117: EmbeddedRam117,
        # [ doc = "0x258 - Embedded RAM" ]
        pub embedded_ram118: EmbeddedRam118,
        # [ doc = "0x25c - Embedded RAM" ]
        pub embedded_ram119: EmbeddedRam119,
        # [ doc = "0x260 - Embedded RAM" ]
        pub embedded_ram120: EmbeddedRam120,
        # [ doc = "0x264 - Embedded RAM" ]
        pub embedded_ram121: EmbeddedRam121,
        # [ doc = "0x268 - Embedded RAM" ]
        pub embedded_ram122: EmbeddedRam122,
        # [ doc = "0x26c - Embedded RAM" ]
        pub embedded_ram123: EmbeddedRam123,
        # [ doc = "0x270 - Embedded RAM" ]
        pub embedded_ram124: EmbeddedRam124,
        # [ doc = "0x274 - Embedded RAM" ]
        pub embedded_ram125: EmbeddedRam125,
        # [ doc = "0x278 - Embedded RAM" ]
        pub embedded_ram126: EmbeddedRam126,
        # [ doc = "0x27c - Embedded RAM" ]
        pub embedded_ram127: EmbeddedRam127,
        _reserved5: [u8; 1536usize],
        # [ doc = "0x880 - Rx Individual Mask Registers" ]
        pub rximr0: Rximr0,
        # [ doc = "0x884 - Rx Individual Mask Registers" ]
        pub rximr1: Rximr1,
        # [ doc = "0x888 - Rx Individual Mask Registers" ]
        pub rximr2: Rximr2,
        # [ doc = "0x88c - Rx Individual Mask Registers" ]
        pub rximr3: Rximr3,
        # [ doc = "0x890 - Rx Individual Mask Registers" ]
        pub rximr4: Rximr4,
        # [ doc = "0x894 - Rx Individual Mask Registers" ]
        pub rximr5: Rximr5,
        # [ doc = "0x898 - Rx Individual Mask Registers" ]
        pub rximr6: Rximr6,
        # [ doc = "0x89c - Rx Individual Mask Registers" ]
        pub rximr7: Rximr7,
        # [ doc = "0x8a0 - Rx Individual Mask Registers" ]
        pub rximr8: Rximr8,
        # [ doc = "0x8a4 - Rx Individual Mask Registers" ]
        pub rximr9: Rximr9,
        # [ doc = "0x8a8 - Rx Individual Mask Registers" ]
        pub rximr10: Rximr10,
        # [ doc = "0x8ac - Rx Individual Mask Registers" ]
        pub rximr11: Rximr11,
        # [ doc = "0x8b0 - Rx Individual Mask Registers" ]
        pub rximr12: Rximr12,
        # [ doc = "0x8b4 - Rx Individual Mask Registers" ]
        pub rximr13: Rximr13,
        # [ doc = "0x8b8 - Rx Individual Mask Registers" ]
        pub rximr14: Rximr14,
        # [ doc = "0x8bc - Rx Individual Mask Registers" ]
        pub rximr15: Rximr15,
        _reserved6: [u8; 576usize],
        # [ doc = "0xb00 - Pretended Networking Control 1 Register" ]
        pub ctrl1_pn: Ctrl1Pn,
        # [ doc = "0xb04 - Pretended Networking Control 2 Register" ]
        pub ctrl2_pn: Ctrl2Pn,
        # [ doc = "0xb08 - Pretended Networking Wake Up Match Register" ]
        pub wu_mtc: WuMtc,
        # [ doc = "0xb0c - Pretended Networking ID Filter 1 Register" ]
        pub flt_id1: FltId1,
        # [ doc = "0xb10 - Pretended Networking DLC Filter Register" ]
        pub flt_dlc: FltDlc,
        # [ doc = "0xb14 - Pretended Networking Payload Low Filter 1 Register" ]
        pub pl1_lo: Pl1Lo,
        # [ doc = "0xb18 - Pretended Networking Payload High Filter 1 Register" ]
        pub pl1_hi: Pl1Hi,
        # [ doc = "0xb1c - Pretended Networking ID Filter 2 Register / ID Mask Register" ]
        pub flt_id2_idmask: FltId2Idmask,
        # [ doc = "0xb20 - Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
        pub pl2_plmask_lo: Pl2PlmaskLo,
        # [ doc = "0xb24 - Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
        pub pl2_plmask_hi: Pl2PlmaskHi,
        _reserved7: [u8; 24usize],
        # [ doc = "0xb40 - Wake Up Message Buffer Register for C/S" ]
        pub wmb0_cs: Wmb0Cs,
        # [ doc = "0xb44 - Wake Up Message Buffer Register for ID" ]
        pub wmb0_id: Wmb0Id,
        # [ doc = "0xb48 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb0_d03: Wmb0D03,
        # [ doc = "0xb4c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb0_d47: Wmb0D47,
        # [ doc = "0xb50 - Wake Up Message Buffer Register for C/S" ]
        pub wmb1_cs: Wmb1Cs,
        # [ doc = "0xb54 - Wake Up Message Buffer Register for ID" ]
        pub wmb1_id: Wmb1Id,
        # [ doc = "0xb58 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb1_d03: Wmb1D03,
        # [ doc = "0xb5c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb1_d47: Wmb1D47,
        # [ doc = "0xb60 - Wake Up Message Buffer Register for C/S" ]
        pub wmb2_cs: Wmb2Cs,
        # [ doc = "0xb64 - Wake Up Message Buffer Register for ID" ]
        pub wmb2_id: Wmb2Id,
        # [ doc = "0xb68 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb2_d03: Wmb2D03,
        # [ doc = "0xb6c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb2_d47: Wmb2D47,
        # [ doc = "0xb70 - Wake Up Message Buffer Register for C/S" ]
        pub wmb3_cs: Wmb3Cs,
        # [ doc = "0xb74 - Wake Up Message Buffer Register for ID" ]
        pub wmb3_id: Wmb3Id,
        # [ doc = "0xb78 - Wake Up Message Buffer Register for Data 0-3" ]
        pub wmb3_d03: Wmb3D03,
        # [ doc = "0xb7c - Wake Up Message Buffer Register Data 4-7" ]
        pub wmb3_d47: Wmb3D47,
        _reserved8: [u8; 128usize],
        # [ doc = "0xc00 - CAN FD Control Register" ]
        pub fdctrl: Fdctrl,
        # [ doc = "0xc04 - CAN FD Bit Timing Register" ]
        pub fdcbt: Fdcbt,
        # [ doc = "0xc08 - CAN FD CRC Register" ]
        pub fdcrc: Fdcrc,
    }
    # [ doc = "Module Configuration Register" ]
    pub struct Mcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Module Configuration Register" ]
    pub mod mcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MaxmbR {
            bits: u8,
        }
        impl MaxmbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `IDAM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdamR {
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            _00,
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            _01,
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            _10,
            # [ doc = "Format D: All frames rejected." ]
            _11,
        }
        impl IdamR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdamR::_00 => 0,
                    IdamR::_01 => 1,
                    IdamR::_10 => 2,
                    IdamR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdamR {
                match bits {
                    0 => IdamR::_00,
                    1 => IdamR::_01,
                    2 => IdamR::_10,
                    3 => IdamR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == IdamR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == IdamR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == IdamR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == IdamR::_11
            }
        }
        # [ doc = "Possible values of the field `FDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdenR {
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            _1,
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            _0,
        }
        impl FdenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdenR::_1 => 1,
                    FdenR::_0 => 0,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdenR {
                match bits {
                    1 => FdenR::_1,
                    0 => FdenR::_0,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdenR::_1
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdenR::_0
            }
        }
        # [ doc = "Possible values of the field `AEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AenR {
            # [ doc = "Abort disabled." ]
            _0,
            # [ doc = "Abort enabled." ]
            _1,
        }
        impl AenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AenR::_0 => 0,
                    AenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AenR {
                match bits {
                    0 => AenR::_0,
                    1 => AenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AenR::_1
            }
        }
        # [ doc = "Possible values of the field `LPRIOEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LprioenR {
            # [ doc = "Local Priority disabled." ]
            _0,
            # [ doc = "Local Priority enabled." ]
            _1,
        }
        impl LprioenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LprioenR::_0 => 0,
                    LprioenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LprioenR {
                match bits {
                    0 => LprioenR::_0,
                    1 => LprioenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LprioenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LprioenR::_1
            }
        }
        # [ doc = "Possible values of the field `PNET_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PnetEnR {
            # [ doc = "Pretended Networking mode is disabled." ]
            _0,
            # [ doc = "Pretended Networking mode is enabled." ]
            _1,
        }
        impl PnetEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PnetEnR::_0 => 0,
                    PnetEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PnetEnR {
                match bits {
                    0 => PnetEnR::_0,
                    1 => PnetEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PnetEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PnetEnR::_1
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "DMA feature for RX FIFO disabled." ]
            _0,
            # [ doc = "DMA feature for RX FIFO enabled." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `IRMQ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrmqR {
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            _0,
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            _1,
        }
        impl IrmqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrmqR::_0 => 0,
                    IrmqR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrmqR {
                match bits {
                    0 => IrmqR::_0,
                    1 => IrmqR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IrmqR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IrmqR::_1
            }
        }
        # [ doc = "Possible values of the field `SRXDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SrxdisR {
            # [ doc = "Self reception enabled." ]
            _0,
            # [ doc = "Self reception disabled." ]
            _1,
        }
        impl SrxdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SrxdisR::_0 => 0,
                    SrxdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SrxdisR {
                match bits {
                    0 => SrxdisR::_0,
                    1 => SrxdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SrxdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SrxdisR::_1
            }
        }
        # [ doc = "Possible values of the field `LPMACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpmackR {
            # [ doc = "FlexCAN is not in a low-power mode." ]
            _0,
            # [ doc = "FlexCAN is in a low-power mode." ]
            _1,
        }
        impl LpmackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpmackR::_0 => 0,
                    LpmackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpmackR {
                match bits {
                    0 => LpmackR::_0,
                    1 => LpmackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpmackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpmackR::_1
            }
        }
        # [ doc = "Possible values of the field `WRNEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WrnenR {
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            _0,
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl WrnenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WrnenR::_0 => 0,
                    WrnenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WrnenR {
                match bits {
                    0 => WrnenR::_0,
                    1 => WrnenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WrnenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WrnenR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SupvR {
            bits: u8,
        }
        impl SupvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FRZACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrzackR {
            # [ doc = "FlexCAN not in Freeze mode, prescaler running." ]
            _0,
            # [ doc = "FlexCAN in Freeze mode, prescaler stopped." ]
            _1,
        }
        impl FrzackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrzackR::_0 => 0,
                    FrzackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrzackR {
                match bits {
                    0 => FrzackR::_0,
                    1 => FrzackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrzackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrzackR::_1
            }
        }
        # [ doc = "Possible values of the field `SOFTRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoftrstR {
            # [ doc = "No reset request." ]
            _0,
            # [ doc = "Resets the registers affected by soft reset." ]
            _1,
        }
        impl SoftrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoftrstR::_0 => 0,
                    SoftrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoftrstR {
                match bits {
                    0 => SoftrstR::_0,
                    1 => SoftrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoftrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoftrstR::_1
            }
        }
        # [ doc = "Possible values of the field `NOTRDY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NotrdyR {
            # [ doc = "FlexCAN module is either in Normal mode, Listen-Only mode or Loop-Back mode." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NotrdyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NotrdyR::_0 => 0,
                    NotrdyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NotrdyR {
                match bits {
                    0 => NotrdyR::_0,
                    i => NotrdyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NotrdyR::_0
            }
        }
        # [ doc = "Possible values of the field `HALT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HaltR {
            # [ doc = "No Freeze mode request." ]
            _0,
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            _1,
        }
        impl HaltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HaltR::_0 => 0,
                    HaltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HaltR {
                match bits {
                    0 => HaltR::_0,
                    1 => HaltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HaltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HaltR::_1
            }
        }
        # [ doc = "Possible values of the field `RFEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfenR {
            # [ doc = "Rx FIFO not enabled." ]
            _0,
            # [ doc = "Rx FIFO enabled." ]
            _1,
        }
        impl RfenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfenR::_0 => 0,
                    RfenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfenR {
                match bits {
                    0 => RfenR::_0,
                    1 => RfenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfenR::_1
            }
        }
        # [ doc = "Possible values of the field `FRZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrzR {
            # [ doc = "Not enabled to enter Freeze mode." ]
            _0,
            # [ doc = "Enabled to enter Freeze mode." ]
            _1,
        }
        impl FrzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrzR::_0 => 0,
                    FrzR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrzR {
                match bits {
                    0 => FrzR::_0,
                    1 => FrzR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrzR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrzR::_1
            }
        }
        # [ doc = "Possible values of the field `MDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MdisR {
            # [ doc = "Enable the FlexCAN module." ]
            _0,
            # [ doc = "Disable the FlexCAN module." ]
            _1,
        }
        impl MdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MdisR::_0 => 0,
                    MdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MdisR {
                match bits {
                    0 => MdisR::_0,
                    1 => MdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MdisR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MaxmbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MaxmbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDAM`" ]
        pub enum IdamW {
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            _00,
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            _01,
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            _10,
            # [ doc = "Format D: All frames rejected." ]
            _11,
        }
        impl IdamW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdamW::_00 => 0,
                    IdamW::_01 => 1,
                    IdamW::_10 => 2,
                    IdamW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdamW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdamW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdamW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Format A: One full ID (standard and extended) per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(IdamW::_00)
            }
            # [ doc = "Format B: Two full standard IDs or two partial 14-bit (standard and extended) IDs per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(IdamW::_01)
            }
            # [ doc = "Format C: Four partial 8-bit Standard IDs per ID Filter Table element." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(IdamW::_10)
            }
            # [ doc = "Format D: All frames rejected." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(IdamW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDEN`" ]
        pub enum FdenW {
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            _1,
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            _0,
        }
        impl FdenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdenW::_1 => 1,
                    FdenW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CAN FD is enabled. FlexCAN is able to receive and transmit messages in both CAN FD and CAN 2.0 formats." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdenW::_1)
            }
            # [ doc = "CAN FD is disabled. FlexCAN is able to receive and transmit messages in CAN 2.0 format." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdenW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AEN`" ]
        pub enum AenW {
            # [ doc = "Abort disabled." ]
            _0,
            # [ doc = "Abort enabled." ]
            _1,
        }
        impl AenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AenW::_0 => 0,
                    AenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Abort disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AenW::_0)
            }
            # [ doc = "Abort enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPRIOEN`" ]
        pub enum LprioenW {
            # [ doc = "Local Priority disabled." ]
            _0,
            # [ doc = "Local Priority enabled." ]
            _1,
        }
        impl LprioenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LprioenW::_0 => 0,
                    LprioenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LprioenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LprioenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LprioenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Local Priority disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LprioenW::_0)
            }
            # [ doc = "Local Priority enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LprioenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PNET_EN`" ]
        pub enum PnetEnW {
            # [ doc = "Pretended Networking mode is disabled." ]
            _0,
            # [ doc = "Pretended Networking mode is enabled." ]
            _1,
        }
        impl PnetEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PnetEnW::_0 => 0,
                    PnetEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PnetEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PnetEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PnetEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pretended Networking mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PnetEnW::_0)
            }
            # [ doc = "Pretended Networking mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PnetEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "DMA feature for RX FIFO disabled." ]
            _0,
            # [ doc = "DMA feature for RX FIFO enabled." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA feature for RX FIFO disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "DMA feature for RX FIFO enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRMQ`" ]
        pub enum IrmqW {
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            _0,
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            _1,
        }
        impl IrmqW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrmqW::_0 => 0,
                    IrmqW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrmqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrmqW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrmqW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Individual Rx masking and queue feature are disabled. For backward compatibility with legacy applications, the reading of C/S word locks the MB even if it is EMPTY." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IrmqW::_0)
            }
            # [ doc = "Individual Rx masking and queue feature are enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IrmqW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRXDIS`" ]
        pub enum SrxdisW {
            # [ doc = "Self reception enabled." ]
            _0,
            # [ doc = "Self reception disabled." ]
            _1,
        }
        impl SrxdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SrxdisW::_0 => 0,
                    SrxdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SrxdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SrxdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SrxdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Self reception enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SrxdisW::_0)
            }
            # [ doc = "Self reception disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SrxdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WRNEN`" ]
        pub enum WrnenW {
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            _0,
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl WrnenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WrnenW::_0 => 0,
                    WrnenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WrnenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WrnenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WrnenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TWRNINT and RWRNINT bits are zero, independent of the values in the error counters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WrnenW::_0)
            }
            # [ doc = "TWRNINT and RWRNINT bits are set when the respective error counter transitions from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WrnenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SupvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SupvW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOFTRST`" ]
        pub enum SoftrstW {
            # [ doc = "No reset request." ]
            _0,
            # [ doc = "Resets the registers affected by soft reset." ]
            _1,
        }
        impl SoftrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SoftrstW::_0 => 0,
                    SoftrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoftrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoftrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SoftrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No reset request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SoftrstW::_0)
            }
            # [ doc = "Resets the registers affected by soft reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SoftrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HALT`" ]
        pub enum HaltW {
            # [ doc = "No Freeze mode request." ]
            _0,
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            _1,
        }
        impl HaltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HaltW::_0 => 0,
                    HaltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HaltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HaltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HaltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Freeze mode request." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HaltW::_0)
            }
            # [ doc = "Enters Freeze mode if the FRZ bit is asserted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HaltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RFEN`" ]
        pub enum RfenW {
            # [ doc = "Rx FIFO not enabled." ]
            _0,
            # [ doc = "Rx FIFO enabled." ]
            _1,
        }
        impl RfenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RfenW::_0 => 0,
                    RfenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RfenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RfenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RfenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx FIFO not enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RfenW::_0)
            }
            # [ doc = "Rx FIFO enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RfenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRZ`" ]
        pub enum FrzW {
            # [ doc = "Not enabled to enter Freeze mode." ]
            _0,
            # [ doc = "Enabled to enter Freeze mode." ]
            _1,
        }
        impl FrzW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FrzW::_0 => 0,
                    FrzW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrzW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrzW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FrzW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Not enabled to enter Freeze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FrzW::_0)
            }
            # [ doc = "Enabled to enter Freeze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FrzW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MDIS`" ]
        pub enum MdisW {
            # [ doc = "Enable the FlexCAN module." ]
            _0,
            # [ doc = "Disable the FlexCAN module." ]
            _1,
        }
        impl MdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MdisW::_0 => 0,
                    MdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Enable the FlexCAN module." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MdisW::_0)
            }
            # [ doc = "Disable the FlexCAN module." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Number Of The Last Message Buffer" ]
            # [ inline ( always ) ]
            pub fn maxmb(&self) -> MaxmbR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MaxmbR { bits }
            }
            # [ doc = "Bits 8:9 - ID Acceptance Mode" ]
            # [ inline ( always ) ]
            pub fn idam(&self) -> IdamR {
                IdamR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - CAN FD operation enable" ]
            # [ inline ( always ) ]
            pub fn fden(&self) -> FdenR {
                FdenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Abort Enable" ]
            # [ inline ( always ) ]
            pub fn aen(&self) -> AenR {
                AenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Local Priority Enable" ]
            # [ inline ( always ) ]
            pub fn lprioen(&self) -> LprioenR {
                LprioenR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Pretended Networking Enable" ]
            # [ inline ( always ) ]
            pub fn pnet_en(&self) -> PnetEnR {
                PnetEnR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 15;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Individual Rx Masking And Queue Enable" ]
            # [ inline ( always ) ]
            pub fn irmq(&self) -> IrmqR {
                IrmqR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Self Reception Disable" ]
            # [ inline ( always ) ]
            pub fn srxdis(&self) -> SrxdisR {
                SrxdisR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Low-Power Mode Acknowledge" ]
            # [ inline ( always ) ]
            pub fn lpmack(&self) -> LpmackR {
                LpmackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wrnen(&self) -> WrnenR {
                WrnenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 21;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 23 - Supervisor Mode" ]
            # [ inline ( always ) ]
            pub fn supv(&self) -> SupvR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SupvR { bits }
            }
            # [ doc = "Bit 24 - Freeze Mode Acknowledge" ]
            # [ inline ( always ) ]
            pub fn frzack(&self) -> FrzackR {
                FrzackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 25 - Soft Reset" ]
            # [ inline ( always ) ]
            pub fn softrst(&self) -> SoftrstR {
                SoftrstR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 27 - FlexCAN Not Ready" ]
            # [ inline ( always ) ]
            pub fn notrdy(&self) -> NotrdyR {
                NotrdyR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Halt FlexCAN" ]
            # [ inline ( always ) ]
            pub fn halt(&self) -> HaltR {
                HaltR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 28;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 29 - Rx FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rfen(&self) -> RfenR {
                RfenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - Freeze Enable" ]
            # [ inline ( always ) ]
            pub fn frz(&self) -> FrzR {
                FrzR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Module Disable" ]
            # [ inline ( always ) ]
            pub fn mdis(&self) -> MdisR {
                MdisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3633315855 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Number Of The Last Message Buffer" ]
            # [ inline ( always ) ]
            pub fn maxmb(&mut self) -> _MaxmbW {
                _MaxmbW { w: self }
            }
            # [ doc = "Bits 8:9 - ID Acceptance Mode" ]
            # [ inline ( always ) ]
            pub fn idam(&mut self) -> _IdamW {
                _IdamW { w: self }
            }
            # [ doc = "Bit 11 - CAN FD operation enable" ]
            # [ inline ( always ) ]
            pub fn fden(&mut self) -> _FdenW {
                _FdenW { w: self }
            }
            # [ doc = "Bit 12 - Abort Enable" ]
            # [ inline ( always ) ]
            pub fn aen(&mut self) -> _AenW {
                _AenW { w: self }
            }
            # [ doc = "Bit 13 - Local Priority Enable" ]
            # [ inline ( always ) ]
            pub fn lprioen(&mut self) -> _LprioenW {
                _LprioenW { w: self }
            }
            # [ doc = "Bit 14 - Pretended Networking Enable" ]
            # [ inline ( always ) ]
            pub fn pnet_en(&mut self) -> _PnetEnW {
                _PnetEnW { w: self }
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 16 - Individual Rx Masking And Queue Enable" ]
            # [ inline ( always ) ]
            pub fn irmq(&mut self) -> _IrmqW {
                _IrmqW { w: self }
            }
            # [ doc = "Bit 17 - Self Reception Disable" ]
            # [ inline ( always ) ]
            pub fn srxdis(&mut self) -> _SrxdisW {
                _SrxdisW { w: self }
            }
            # [ doc = "Bit 21 - Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wrnen(&mut self) -> _WrnenW {
                _WrnenW { w: self }
            }
            # [ doc = "Bit 23 - Supervisor Mode" ]
            # [ inline ( always ) ]
            pub fn supv(&mut self) -> _SupvW {
                _SupvW { w: self }
            }
            # [ doc = "Bit 25 - Soft Reset" ]
            # [ inline ( always ) ]
            pub fn softrst(&mut self) -> _SoftrstW {
                _SoftrstW { w: self }
            }
            # [ doc = "Bit 28 - Halt FlexCAN" ]
            # [ inline ( always ) ]
            pub fn halt(&mut self) -> _HaltW {
                _HaltW { w: self }
            }
            # [ doc = "Bit 29 - Rx FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rfen(&mut self) -> _RfenW {
                _RfenW { w: self }
            }
            # [ doc = "Bit 30 - Freeze Enable" ]
            # [ inline ( always ) ]
            pub fn frz(&mut self) -> _FrzW {
                _FrzW { w: self }
            }
            # [ doc = "Bit 31 - Module Disable" ]
            # [ inline ( always ) ]
            pub fn mdis(&mut self) -> _MdisW {
                _MdisW { w: self }
            }
        }
    }
    # [ doc = "Control 1 register" ]
    pub struct Ctrl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control 1 register" ]
    pub mod ctrl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PropsegR {
            bits: u8,
        }
        impl PropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LomR {
            # [ doc = "Listen-Only mode is deactivated." ]
            _0,
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            _1,
        }
        impl LomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LomR::_0 => 0,
                    LomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LomR {
                match bits {
                    0 => LomR::_0,
                    1 => LomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LomR::_1
            }
        }
        # [ doc = "Possible values of the field `LBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbufR {
            # [ doc = "Buffer with highest priority is transmitted first." ]
            _0,
            # [ doc = "Lowest number buffer is transmitted first." ]
            _1,
        }
        impl LbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbufR::_0 => 0,
                    LbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbufR {
                match bits {
                    0 => LbufR::_0,
                    1 => LbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbufR::_1
            }
        }
        # [ doc = "Possible values of the field `TSYN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsynR {
            # [ doc = "Timer Sync feature disabled" ]
            _0,
            # [ doc = "Timer Sync feature enabled" ]
            _1,
        }
        impl TsynR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsynR::_0 => 0,
                    TsynR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsynR {
                match bits {
                    0 => TsynR::_0,
                    1 => TsynR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsynR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsynR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFREC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffrecR {
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            _0,
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            _1,
        }
        impl BoffrecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffrecR::_0 => 0,
                    BoffrecR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffrecR {
                match bits {
                    0 => BoffrecR::_0,
                    1 => BoffrecR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffrecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffrecR::_1
            }
        }
        # [ doc = "Possible values of the field `SMP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmpR {
            # [ doc = "Just one sample is used to determine the bit value." ]
            _0,
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            _1,
        }
        impl SmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmpR::_0 => 0,
                    SmpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmpR {
                match bits {
                    0 => SmpR::_0,
                    1 => SmpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmpR::_1
            }
        }
        # [ doc = "Possible values of the field `RWRNMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwrnmskR {
            # [ doc = "Rx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Rx Warning Interrupt enabled." ]
            _1,
        }
        impl RwrnmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwrnmskR::_0 => 0,
                    RwrnmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwrnmskR {
                match bits {
                    0 => RwrnmskR::_0,
                    1 => RwrnmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwrnmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwrnmskR::_1
            }
        }
        # [ doc = "Possible values of the field `TWRNMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TwrnmskR {
            # [ doc = "Tx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Tx Warning Interrupt enabled." ]
            _1,
        }
        impl TwrnmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TwrnmskR::_0 => 0,
                    TwrnmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TwrnmskR {
                match bits {
                    0 => TwrnmskR::_0,
                    1 => TwrnmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TwrnmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TwrnmskR::_1
            }
        }
        # [ doc = "Possible values of the field `LPB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpbR {
            # [ doc = "Loop Back disabled." ]
            _0,
            # [ doc = "Loop Back enabled." ]
            _1,
        }
        impl LpbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpbR::_0 => 0,
                    LpbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpbR {
                match bits {
                    0 => LpbR::_0,
                    1 => LpbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpbR::_1
            }
        }
        # [ doc = "Possible values of the field `CLKSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksrcR {
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            _0,
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            _1,
        }
        impl ClksrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksrcR::_0 => 0,
                    ClksrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksrcR {
                match bits {
                    0 => ClksrcR::_0,
                    1 => ClksrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ClksrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ClksrcR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrmskR {
            # [ doc = "Error interrupt disabled." ]
            _0,
            # [ doc = "Error interrupt enabled." ]
            _1,
        }
        impl ErrmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrmskR::_0 => 0,
                    ErrmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrmskR {
                match bits {
                    0 => ErrmskR::_0,
                    1 => ErrmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrmskR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffmskR {
            # [ doc = "Bus Off interrupt disabled." ]
            _0,
            # [ doc = "Bus Off interrupt enabled." ]
            _1,
        }
        impl BoffmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffmskR::_0 => 0,
                    BoffmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffmskR {
                match bits {
                    0 => BoffmskR::_0,
                    1 => BoffmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffmskR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pseg2R {
            bits: u8,
        }
        impl Pseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pseg1R {
            bits: u8,
        }
        impl Pseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RjwR {
            bits: u8,
        }
        impl RjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PresdivR {
            bits: u8,
        }
        impl PresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOM`" ]
        pub enum LomW {
            # [ doc = "Listen-Only mode is deactivated." ]
            _0,
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            _1,
        }
        impl LomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LomW::_0 => 0,
                    LomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Listen-Only mode is deactivated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LomW::_0)
            }
            # [ doc = "FlexCAN module operates in Listen-Only mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBUF`" ]
        pub enum LbufW {
            # [ doc = "Buffer with highest priority is transmitted first." ]
            _0,
            # [ doc = "Lowest number buffer is transmitted first." ]
            _1,
        }
        impl LbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbufW::_0 => 0,
                    LbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Buffer with highest priority is transmitted first." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbufW::_0)
            }
            # [ doc = "Lowest number buffer is transmitted first." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSYN`" ]
        pub enum TsynW {
            # [ doc = "Timer Sync feature disabled" ]
            _0,
            # [ doc = "Timer Sync feature enabled" ]
            _1,
        }
        impl TsynW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsynW::_0 => 0,
                    TsynW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsynW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsynW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsynW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Sync feature disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsynW::_0)
            }
            # [ doc = "Timer Sync feature enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsynW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFREC`" ]
        pub enum BoffrecW {
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            _0,
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            _1,
        }
        impl BoffrecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffrecW::_0 => 0,
                    BoffrecW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffrecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffrecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffrecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Automatic recovering from Bus Off state enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffrecW::_0)
            }
            # [ doc = "Automatic recovering from Bus Off state disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffrecW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMP`" ]
        pub enum SmpW {
            # [ doc = "Just one sample is used to determine the bit value." ]
            _0,
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            _1,
        }
        impl SmpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmpW::_0 => 0,
                    SmpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Just one sample is used to determine the bit value." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmpW::_0)
            }
            # [ doc = "Three samples are used to determine the value of the received bit: the regular one (sample point) and 2 preceding samples; a majority rule is used." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWRNMSK`" ]
        pub enum RwrnmskW {
            # [ doc = "Rx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Rx Warning Interrupt enabled." ]
            _1,
        }
        impl RwrnmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwrnmskW::_0 => 0,
                    RwrnmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwrnmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwrnmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwrnmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx Warning Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwrnmskW::_0)
            }
            # [ doc = "Rx Warning Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwrnmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TWRNMSK`" ]
        pub enum TwrnmskW {
            # [ doc = "Tx Warning Interrupt disabled." ]
            _0,
            # [ doc = "Tx Warning Interrupt enabled." ]
            _1,
        }
        impl TwrnmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TwrnmskW::_0 => 0,
                    TwrnmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TwrnmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TwrnmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TwrnmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Tx Warning Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TwrnmskW::_0)
            }
            # [ doc = "Tx Warning Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TwrnmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPB`" ]
        pub enum LpbW {
            # [ doc = "Loop Back disabled." ]
            _0,
            # [ doc = "Loop Back enabled." ]
            _1,
        }
        impl LpbW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LpbW::_0 => 0,
                    LpbW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LpbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LpbW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LpbW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loop Back disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LpbW::_0)
            }
            # [ doc = "Loop Back enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LpbW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKSRC`" ]
        pub enum ClksrcW {
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            _0,
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            _1,
        }
        impl ClksrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksrcW::_0 => 0,
                    ClksrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The CAN engine clock source is the oscillator clock. Under this condition, the oscillator clock frequency must be lower than the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClksrcW::_0)
            }
            # [ doc = "The CAN engine clock source is the peripheral clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClksrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRMSK`" ]
        pub enum ErrmskW {
            # [ doc = "Error interrupt disabled." ]
            _0,
            # [ doc = "Error interrupt enabled." ]
            _1,
        }
        impl ErrmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrmskW::_0 => 0,
                    ErrmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrmskW::_0)
            }
            # [ doc = "Error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFMSK`" ]
        pub enum BoffmskW {
            # [ doc = "Bus Off interrupt disabled." ]
            _0,
            # [ doc = "Bus Off interrupt enabled." ]
            _1,
        }
        impl BoffmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffmskW::_0 => 0,
                    BoffmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus Off interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffmskW::_0)
            }
            # [ doc = "Bus Off interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn propseg(&self) -> PropsegR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PropsegR { bits }
            }
            # [ doc = "Bit 3 - Listen-Only Mode" ]
            # [ inline ( always ) ]
            pub fn lom(&self) -> LomR {
                LomR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Lowest Buffer Transmitted First" ]
            # [ inline ( always ) ]
            pub fn lbuf(&self) -> LbufR {
                LbufR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Timer Sync" ]
            # [ inline ( always ) ]
            pub fn tsyn(&self) -> TsynR {
                TsynR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Bus Off Recovery" ]
            # [ inline ( always ) ]
            pub fn boffrec(&self) -> BoffrecR {
                BoffrecR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 6;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 7 - CAN Bit Sampling" ]
            # [ inline ( always ) ]
            pub fn smp(&self) -> SmpR {
                SmpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Rx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn rwrnmsk(&self) -> RwrnmskR {
                RwrnmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 10;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - Tx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn twrnmsk(&self) -> TwrnmskR {
                TwrnmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 11;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 12 - Loop Back Mode" ]
            # [ inline ( always ) ]
            pub fn lpb(&self) -> LpbR {
                LpbR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - CAN Engine Clock Source" ]
            # [ inline ( always ) ]
            pub fn clksrc(&self) -> ClksrcR {
                ClksrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Error Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn errmsk(&self) -> ErrmskR {
                ErrmskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Bus Off Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffmsk(&self) -> BoffmskR {
                BoffmskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 16:18 - Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn pseg2(&self) -> Pseg2R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pseg2R { bits }
            }
            # [ doc = "Bits 19:21 - Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn pseg1(&self) -> Pseg1R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pseg1R { bits }
            }
            # [ doc = "Bits 22:23 - Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn rjw(&self) -> RjwR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RjwR { bits }
            }
            # [ doc = "Bits 24:31 - Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn presdiv(&self) -> PresdivR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PresdivR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn propseg(&mut self) -> _PropsegW {
                _PropsegW { w: self }
            }
            # [ doc = "Bit 3 - Listen-Only Mode" ]
            # [ inline ( always ) ]
            pub fn lom(&mut self) -> _LomW {
                _LomW { w: self }
            }
            # [ doc = "Bit 4 - Lowest Buffer Transmitted First" ]
            # [ inline ( always ) ]
            pub fn lbuf(&mut self) -> _LbufW {
                _LbufW { w: self }
            }
            # [ doc = "Bit 5 - Timer Sync" ]
            # [ inline ( always ) ]
            pub fn tsyn(&mut self) -> _TsynW {
                _TsynW { w: self }
            }
            # [ doc = "Bit 6 - Bus Off Recovery" ]
            # [ inline ( always ) ]
            pub fn boffrec(&mut self) -> _BoffrecW {
                _BoffrecW { w: self }
            }
            # [ doc = "Bit 7 - CAN Bit Sampling" ]
            # [ inline ( always ) ]
            pub fn smp(&mut self) -> _SmpW {
                _SmpW { w: self }
            }
            # [ doc = "Bit 10 - Rx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn rwrnmsk(&mut self) -> _RwrnmskW {
                _RwrnmskW { w: self }
            }
            # [ doc = "Bit 11 - Tx Warning Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn twrnmsk(&mut self) -> _TwrnmskW {
                _TwrnmskW { w: self }
            }
            # [ doc = "Bit 12 - Loop Back Mode" ]
            # [ inline ( always ) ]
            pub fn lpb(&mut self) -> _LpbW {
                _LpbW { w: self }
            }
            # [ doc = "Bit 13 - CAN Engine Clock Source" ]
            # [ inline ( always ) ]
            pub fn clksrc(&mut self) -> _ClksrcW {
                _ClksrcW { w: self }
            }
            # [ doc = "Bit 14 - Error Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn errmsk(&mut self) -> _ErrmskW {
                _ErrmskW { w: self }
            }
            # [ doc = "Bit 15 - Bus Off Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffmsk(&mut self) -> _BoffmskW {
                _BoffmskW { w: self }
            }
            # [ doc = "Bits 16:18 - Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn pseg2(&mut self) -> _Pseg2W {
                _Pseg2W { w: self }
            }
            # [ doc = "Bits 19:21 - Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn pseg1(&mut self) -> _Pseg1W {
                _Pseg1W { w: self }
            }
            # [ doc = "Bits 22:23 - Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn rjw(&mut self) -> _RjwW {
                _RjwW { w: self }
            }
            # [ doc = "Bits 24:31 - Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn presdiv(&mut self) -> _PresdivW {
                _PresdivW { w: self }
            }
        }
    }
    # [ doc = "Free Running Timer" ]
    pub struct Timer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Free Running Timer" ]
    pub mod timer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimerR {
            bits: u16,
        }
        impl TimerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimerW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn timer(&self) -> TimerR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TimerR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn timer(&mut self) -> _TimerW {
                _TimerW { w: self }
            }
        }
    }
    # [ doc = "Rx Mailboxes Global Mask Register" ]
    pub struct Rxmgmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Mailboxes Global Mask Register" ]
    pub mod rxmgmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rxmgmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MgR {
            bits: u32,
        }
        impl MgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Mailboxes Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mg(&self) -> MgR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MgR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Mailboxes Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mg(&mut self) -> _MgW {
                _MgW { w: self }
            }
        }
    }
    # [ doc = "Rx 14 Mask register" ]
    pub struct Rx14mask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx 14 Mask register" ]
    pub mod rx14mask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rx14mask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Rx14mR {
            bits: u32,
        }
        impl Rx14mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Rx14mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Rx14mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Buffer 14 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx14m(&self) -> Rx14mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Rx14mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Buffer 14 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx14m(&mut self) -> _Rx14mW {
                _Rx14mW { w: self }
            }
        }
    }
    # [ doc = "Rx 15 Mask register" ]
    pub struct Rx15mask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx 15 Mask register" ]
    pub mod rx15mask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rx15mask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Rx15mR {
            bits: u32,
        }
        impl Rx15mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Rx15mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Rx15mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx Buffer 15 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx15m(&self) -> Rx15mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Rx15mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx Buffer 15 Mask Bits" ]
            # [ inline ( always ) ]
            pub fn rx15m(&mut self) -> _Rx15mW {
                _Rx15mW { w: self }
            }
        }
    }
    # [ doc = "Error Counter" ]
    pub struct Ecr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error Counter" ]
    pub mod ecr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ecr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxerrcntR {
            bits: u8,
        }
        impl TxerrcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxerrcntR {
            bits: u8,
        }
        impl RxerrcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxerrcntFastR {
            bits: u8,
        }
        impl TxerrcntFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxerrcntFastR {
            bits: u8,
        }
        impl RxerrcntFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxerrcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxerrcntW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxerrcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxerrcntW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxerrcntFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxerrcntFastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxerrcntFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxerrcntFastW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit Error Counter" ]
            # [ inline ( always ) ]
            pub fn txerrcnt(&self) -> TxerrcntR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxerrcntR { bits }
            }
            # [ doc = "Bits 8:15 - Receive Error Counter" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt(&self) -> RxerrcntR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxerrcntR { bits }
            }
            # [ doc = "Bits 16:23 - Transmit Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn txerrcnt_fast(&self) -> TxerrcntFastR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxerrcntFastR { bits }
            }
            # [ doc = "Bits 24:31 - Receive Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt_fast(&self) -> RxerrcntFastR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxerrcntFastR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Transmit Error Counter" ]
            # [ inline ( always ) ]
            pub fn txerrcnt(&mut self) -> _TxerrcntW {
                _TxerrcntW { w: self }
            }
            # [ doc = "Bits 8:15 - Receive Error Counter" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt(&mut self) -> _RxerrcntW {
                _RxerrcntW { w: self }
            }
            # [ doc = "Bits 16:23 - Transmit Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn txerrcnt_fast(&mut self) -> _TxerrcntFastW {
                _TxerrcntFastW { w: self }
            }
            # [ doc = "Bits 24:31 - Receive Error Counter for fast bits" ]
            # [ inline ( always ) ]
            pub fn rxerrcnt_fast(&mut self) -> _RxerrcntFastW {
                _RxerrcntFastW { w: self }
            }
        }
    }
    # [ doc = "Error and Status 1 register" ]
    pub struct Esr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error and Status 1 register" ]
    pub mod esr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Esr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERRINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            _1,
        }
        impl ErrintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrintR::_0 => 0,
                    ErrintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrintR {
                match bits {
                    0 => ErrintR::_0,
                    1 => ErrintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrintR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module entered Bus Off state." ]
            _1,
        }
        impl BoffintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffintR::_0 => 0,
                    BoffintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffintR {
                match bits {
                    0 => BoffintR::_0,
                    1 => BoffintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffintR::_1
            }
        }
        # [ doc = "Possible values of the field `RX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxR {
            # [ doc = "FlexCAN is not receiving a message." ]
            _0,
            # [ doc = "FlexCAN is receiving a message." ]
            _1,
        }
        impl RxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxR::_0 => 0,
                    RxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxR {
                match bits {
                    0 => RxR::_0,
                    1 => RxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxR::_1
            }
        }
        # [ doc = "Possible values of the field `FLTCONF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltconfR {
            # [ doc = "Error Active" ]
            _00,
            # [ doc = "Error Passive" ]
            _01,
            # [ doc = "Bus Off" ]
            _1x,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl FltconfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltconfR::_00 => 0,
                    FltconfR::_01 => 1,
                    FltconfR::_1x => 2,
                    FltconfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltconfR {
                match bits {
                    0 => FltconfR::_00,
                    1 => FltconfR::_01,
                    2 => FltconfR::_1x,
                    i => FltconfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FltconfR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FltconfR::_01
            }
            # [ doc = "Checks if the value of the field is `_1x`" ]
            # [ inline ( always ) ]
            pub fn is_1x(&self) -> bool {
                *self == FltconfR::_1x
            }
        }
        # [ doc = "Possible values of the field `TX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxR {
            # [ doc = "FlexCAN is not transmitting a message." ]
            _0,
            # [ doc = "FlexCAN is transmitting a message." ]
            _1,
        }
        impl TxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxR::_0 => 0,
                    TxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxR {
                match bits {
                    0 => TxR::_0,
                    1 => TxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdleR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "CAN bus is now IDLE." ]
            _1,
        }
        impl IdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdleR::_0 => 0,
                    IdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdleR {
                match bits {
                    0 => IdleR::_0,
                    1 => IdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdleR::_1
            }
        }
        # [ doc = "Possible values of the field `RXWRN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxwrnR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "RXERRCNT is greater than or equal to 96." ]
            _1,
        }
        impl RxwrnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxwrnR::_0 => 0,
                    RxwrnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxwrnR {
                match bits {
                    0 => RxwrnR::_0,
                    1 => RxwrnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxwrnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxwrnR::_1
            }
        }
        # [ doc = "Possible values of the field `TXWRN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxwrnR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "TXERRCNT is greater than or equal to 96." ]
            _1,
        }
        impl TxwrnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxwrnR::_0 => 0,
                    TxwrnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxwrnR {
                match bits {
                    0 => TxwrnR::_0,
                    1 => TxwrnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxwrnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxwrnR::_1
            }
        }
        # [ doc = "Possible values of the field `STFERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StferrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Stuffing Error occurred since last read of this register." ]
            _1,
        }
        impl StferrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StferrR::_0 => 0,
                    StferrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StferrR {
                match bits {
                    0 => StferrR::_0,
                    1 => StferrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StferrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StferrR::_1
            }
        }
        # [ doc = "Possible values of the field `FRMERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrmerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Form Error occurred since last read of this register." ]
            _1,
        }
        impl FrmerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrmerrR::_0 => 0,
                    FrmerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrmerrR {
                match bits {
                    0 => FrmerrR::_0,
                    1 => FrmerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrmerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrmerrR::_1
            }
        }
        # [ doc = "Possible values of the field `CRCERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrcerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A CRC error occurred since last read of this register." ]
            _1,
        }
        impl CrcerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrcerrR::_0 => 0,
                    CrcerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrcerrR {
                match bits {
                    0 => CrcerrR::_0,
                    1 => CrcerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrcerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrcerrR::_1
            }
        }
        # [ doc = "Possible values of the field `ACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AckerrR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "An ACK error occurred since last read of this register." ]
            _1,
        }
        impl AckerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AckerrR::_0 => 0,
                    AckerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AckerrR {
                match bits {
                    0 => AckerrR::_0,
                    1 => AckerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AckerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AckerrR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT0ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit0errR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as dominant is received as recessive." ]
            _1,
        }
        impl Bit0errR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit0errR::_0 => 0,
                    Bit0errR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit0errR {
                match bits {
                    0 => Bit0errR::_0,
                    1 => Bit0errR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit0errR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit0errR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT1ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit1errR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as recessive is received as dominant." ]
            _1,
        }
        impl Bit1errR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit1errR::_0 => 0,
                    Bit1errR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit1errR {
                match bits {
                    0 => Bit1errR::_0,
                    1 => Bit1errR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit1errR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit1errR::_1
            }
        }
        # [ doc = "Possible values of the field `RWRNINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwrnintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl RwrnintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwrnintR::_0 => 0,
                    RwrnintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwrnintR {
                match bits {
                    0 => RwrnintR::_0,
                    1 => RwrnintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwrnintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwrnintR::_1
            }
        }
        # [ doc = "Possible values of the field `TWRNINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TwrnintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl TwrnintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TwrnintR::_0 => 0,
                    TwrnintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TwrnintR {
                match bits {
                    0 => TwrnintR::_0,
                    1 => TwrnintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TwrnintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TwrnintR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchR {
            # [ doc = "FlexCAN is not synchronized to the CAN bus." ]
            _0,
            # [ doc = "FlexCAN is synchronized to the CAN bus." ]
            _1,
        }
        impl SynchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchR::_0 => 0,
                    SynchR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchR {
                match bits {
                    0 => SynchR::_0,
                    1 => SynchR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchR::_1
            }
        }
        # [ doc = "Possible values of the field `BOFFDONEINT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffdoneintR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            _1,
        }
        impl BoffdoneintR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffdoneintR::_0 => 0,
                    BoffdoneintR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffdoneintR {
                match bits {
                    0 => BoffdoneintR::_0,
                    1 => BoffdoneintR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffdoneintR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffdoneintR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRINT_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrintFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            _1,
        }
        impl ErrintFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrintFastR::_0 => 0,
                    ErrintFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrintFastR {
                match bits {
                    0 => ErrintFastR::_0,
                    1 => ErrintFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrintFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrintFastR::_1
            }
        }
        # [ doc = "Possible values of the field `ERROVR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrovrR {
            # [ doc = "Overrun has not occurred." ]
            _0,
            # [ doc = "Overrun has occurred." ]
            _1,
        }
        impl ErrovrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrovrR::_0 => 0,
                    ErrovrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrovrR {
                match bits {
                    0 => ErrovrR::_0,
                    1 => ErrovrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrovrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrovrR::_1
            }
        }
        # [ doc = "Possible values of the field `STFERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StferrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Stuffing Error occurred since last read of this register." ]
            _1,
        }
        impl StferrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StferrFastR::_0 => 0,
                    StferrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StferrFastR {
                match bits {
                    0 => StferrFastR::_0,
                    1 => StferrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StferrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StferrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `FRMERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FrmerrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A Form Error occurred since last read of this register." ]
            _1,
        }
        impl FrmerrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FrmerrFastR::_0 => 0,
                    FrmerrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FrmerrFastR {
                match bits {
                    0 => FrmerrFastR::_0,
                    1 => FrmerrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FrmerrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FrmerrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `CRCERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrcerrFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "A CRC error occurred since last read of this register." ]
            _1,
        }
        impl CrcerrFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrcerrFastR::_0 => 0,
                    CrcerrFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrcerrFastR {
                match bits {
                    0 => CrcerrFastR::_0,
                    1 => CrcerrFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrcerrFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrcerrFastR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT0ERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit0errFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as dominant is received as recessive." ]
            _1,
        }
        impl Bit0errFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit0errFastR::_0 => 0,
                    Bit0errFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit0errFastR {
                match bits {
                    0 => Bit0errFastR::_0,
                    1 => Bit0errFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit0errFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit0errFastR::_1
            }
        }
        # [ doc = "Possible values of the field `BIT1ERR_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Bit1errFastR {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "At least one bit sent as recessive is received as dominant." ]
            _1,
        }
        impl Bit1errFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Bit1errFastR::_0 => 0,
                    Bit1errFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Bit1errFastR {
                match bits {
                    0 => Bit1errFastR::_0,
                    1 => Bit1errFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Bit1errFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Bit1errFastR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERRINT`" ]
        pub enum ErrintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            _1,
        }
        impl ErrintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrintW::_0 => 0,
                    ErrintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrintW::_0)
            }
            # [ doc = "Indicates setting of any Error Bit in the Error and Status Register." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFINT`" ]
        pub enum BoffintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module entered Bus Off state." ]
            _1,
        }
        impl BoffintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffintW::_0 => 0,
                    BoffintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffintW::_0)
            }
            # [ doc = "FlexCAN module entered Bus Off state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWRNINT`" ]
        pub enum RwrnintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl RwrnintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwrnintW::_0 => 0,
                    RwrnintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwrnintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwrnintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwrnintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwrnintW::_0)
            }
            # [ doc = "The Rx error counter transitioned from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwrnintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TWRNINT`" ]
        pub enum TwrnintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            _1,
        }
        impl TwrnintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TwrnintW::_0 => 0,
                    TwrnintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TwrnintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TwrnintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TwrnintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TwrnintW::_0)
            }
            # [ doc = "The Tx error counter transitioned from less than 96 to greater than or equal to 96." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TwrnintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFDONEINT`" ]
        pub enum BoffdoneintW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            _1,
        }
        impl BoffdoneintW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffdoneintW::_0 => 0,
                    BoffdoneintW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffdoneintW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffdoneintW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffdoneintW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffdoneintW::_0)
            }
            # [ doc = "FlexCAN module has completed Bus Off process." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffdoneintW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRINT_FAST`" ]
        pub enum ErrintFastW {
            # [ doc = "No such occurrence." ]
            _0,
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            _1,
        }
        impl ErrintFastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrintFastW::_0 => 0,
                    ErrintFastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrintFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrintFastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrintFastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No such occurrence." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrintFastW::_0)
            }
            # [ doc = "Indicates setting of any Error Bit detected in the Data Phase of CAN FD frames with the BRS bit set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrintFastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERROVR`" ]
        pub enum ErrovrW {
            # [ doc = "Overrun has not occurred." ]
            _0,
            # [ doc = "Overrun has occurred." ]
            _1,
        }
        impl ErrovrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrovrW::_0 => 0,
                    ErrovrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrovrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrovrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrovrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Overrun has not occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrovrW::_0)
            }
            # [ doc = "Overrun has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrovrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn errint(&self) -> ErrintR {
                ErrintR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Bus Off Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffint(&self) -> BoffintR {
                BoffintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - FlexCAN In Reception" ]
            # [ inline ( always ) ]
            pub fn rx(&self) -> RxR {
                RxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 3;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 4:5 - Fault Confinement State" ]
            # [ inline ( always ) ]
            pub fn fltconf(&self) -> FltconfR {
                FltconfR::_from({
                                    const MASK: u8 = 3;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - FlexCAN In Transmission" ]
            # [ inline ( always ) ]
            pub fn tx(&self) -> TxR {
                TxR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 6;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 7 - IDLE" ]
            # [ inline ( always ) ]
            pub fn idle(&self) -> IdleR {
                IdleR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Rx Error Warning" ]
            # [ inline ( always ) ]
            pub fn rxwrn(&self) -> RxwrnR {
                RxwrnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - TX Error Warning" ]
            # [ inline ( always ) ]
            pub fn txwrn(&self) -> TxwrnR {
                TxwrnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Stuffing Error" ]
            # [ inline ( always ) ]
            pub fn stferr(&self) -> StferrR {
                StferrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Form Error" ]
            # [ inline ( always ) ]
            pub fn frmerr(&self) -> FrmerrR {
                FrmerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Cyclic Redundancy Check Error" ]
            # [ inline ( always ) ]
            pub fn crcerr(&self) -> CrcerrR {
                CrcerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Acknowledge Error" ]
            # [ inline ( always ) ]
            pub fn ackerr(&self) -> AckerrR {
                AckerrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Bit0 Error" ]
            # [ inline ( always ) ]
            pub fn bit0err(&self) -> Bit0errR {
                Bit0errR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Bit1 Error" ]
            # [ inline ( always ) ]
            pub fn bit1err(&self) -> Bit1errR {
                Bit1errR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 16 - Rx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rwrnint(&self) -> RwrnintR {
                RwrnintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 17 - Tx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn twrnint(&self) -> TwrnintR {
                TwrnintR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - CAN Synchronization Status" ]
            # [ inline ( always ) ]
            pub fn synch(&self) -> SynchR {
                SynchR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 19 - Bus Off Done Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffdoneint(&self) -> BoffdoneintR {
                BoffdoneintR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 19;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 20 - Error Interrupt for errors detected in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn errint_fast(&self) -> ErrintFastR {
                ErrintFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 20;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 21 - Error Overrun bit" ]
            # [ inline ( always ) ]
            pub fn errovr(&self) -> ErrovrR {
                ErrovrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Stuffing Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn stferr_fast(&self) -> StferrFastR {
                StferrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 26;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 27 - Form Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn frmerr_fast(&self) -> FrmerrFastR {
                FrmerrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 27;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 28 - Cyclic Redundancy Check Error in the CRC field of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn crcerr_fast(&self) -> CrcerrFastR {
                CrcerrFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 28;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 30 - Bit0 Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn bit0err_fast(&self) -> Bit0errFastR {
                Bit0errFastR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 30;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 31 - Bit1 Error in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn bit1err_fast(&self) -> Bit1errFastR {
                Bit1errFastR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 31;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn errint(&mut self) -> _ErrintW {
                _ErrintW { w: self }
            }
            # [ doc = "Bit 2 - Bus Off Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffint(&mut self) -> _BoffintW {
                _BoffintW { w: self }
            }
            # [ doc = "Bit 16 - Rx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rwrnint(&mut self) -> _RwrnintW {
                _RwrnintW { w: self }
            }
            # [ doc = "Bit 17 - Tx Warning Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn twrnint(&mut self) -> _TwrnintW {
                _TwrnintW { w: self }
            }
            # [ doc = "Bit 19 - Bus Off Done Interrupt" ]
            # [ inline ( always ) ]
            pub fn boffdoneint(&mut self) -> _BoffdoneintW {
                _BoffdoneintW { w: self }
            }
            # [ doc = "Bit 20 - Error Interrupt for errors detected in the Data Phase of CAN FD frames with the BRS bit set" ]
            # [ inline ( always ) ]
            pub fn errint_fast(&mut self) -> _ErrintFastW {
                _ErrintFastW { w: self }
            }
            # [ doc = "Bit 21 - Error Overrun bit" ]
            # [ inline ( always ) ]
            pub fn errovr(&mut self) -> _ErrovrW {
                _ErrovrW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Masks 1 register" ]
    pub struct Imask1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Masks 1 register" ]
    pub mod imask1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Imask1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf31to0mR {
            bits: u32,
        }
        impl Buf31to0mR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf31to0mW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf31to0mW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Buffer MB i Mask" ]
            # [ inline ( always ) ]
            pub fn buf31to0m(&self) -> Buf31to0mR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Buf31to0mR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Buffer MB i Mask" ]
            # [ inline ( always ) ]
            pub fn buf31to0m(&mut self) -> _Buf31to0mW {
                _Buf31to0mW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Flags 1 register" ]
    pub struct Iflag1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Flags 1 register" ]
    pub mod iflag1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Iflag1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `BUF0I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf0iR {
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            _0,
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            _1,
        }
        impl Buf0iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf0iR::_0 => 0,
                    Buf0iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf0iR {
                match bits {
                    0 => Buf0iR::_0,
                    1 => Buf0iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf0iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf0iR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf4to1iR {
            bits: u8,
        }
        impl Buf4to1iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BUF5I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf5iR {
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            _1,
        }
        impl Buf5iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf5iR::_0 => 0,
                    Buf5iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf5iR {
                match bits {
                    0 => Buf5iR::_0,
                    1 => Buf5iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf5iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf5iR::_1
            }
        }
        # [ doc = "Possible values of the field `BUF6I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf6iR {
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf6iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf6iR::_0 => 0,
                    Buf6iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf6iR {
                match bits {
                    0 => Buf6iR::_0,
                    1 => Buf6iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf6iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf6iR::_1
            }
        }
        # [ doc = "Possible values of the field `BUF7I`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Buf7iR {
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf7iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Buf7iR::_0 => 0,
                    Buf7iR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Buf7iR {
                match bits {
                    0 => Buf7iR::_0,
                    1 => Buf7iR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Buf7iR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Buf7iR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Buf31to8iR {
            bits: u32,
        }
        impl Buf31to8iR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `BUF0I`" ]
        pub enum Buf0iW {
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            _0,
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            _1,
        }
        impl Buf0iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf0iW::_0 => 0,
                    Buf0iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf0iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf0iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf0iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding buffer has no occurrence of successfully completed transmission or reception when MCR[RFEN]=0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf0iW::_0)
            }
            # [ doc = "The corresponding buffer has successfully completed transmission or reception when MCR[RFEN]=0." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf0iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf4to1iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf4to1iW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF5I`" ]
        pub enum Buf5iW {
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            _1,
        }
        impl Buf5iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf5iW::_0 => 0,
                    Buf5iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf5iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf5iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf5iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB5 completing transmission/reception when MCR[RFEN]=0, or of frame(s) available in the FIFO, when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf5iW::_0)
            }
            # [ doc = "MB5 completed transmission/reception when MCR[RFEN]=0, or frame(s) available in the Rx FIFO when MCR[RFEN]=1. It generates a DMA request in case of MCR[RFEN] and MCR[DMA] are enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf5iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF6I`" ]
        pub enum Buf6iW {
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf6iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf6iW::_0 => 0,
                    Buf6iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf6iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf6iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf6iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB6 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO almost full when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf6iW::_0)
            }
            # [ doc = "MB6 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO almost full when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf6iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BUF7I`" ]
        pub enum Buf7iW {
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            _0,
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            _1,
        }
        impl Buf7iW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Buf7iW::_0 => 0,
                    Buf7iW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf7iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf7iW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Buf7iW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No occurrence of MB7 completing transmission/reception when MCR[RFEN]=0, or of Rx FIFO overflow when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Buf7iW::_0)
            }
            # [ doc = "MB7 completed transmission/reception when MCR[RFEN]=0, or Rx FIFO overflow when MCR[RFEN]=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Buf7iW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Buf31to8iW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Buf31to8iW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 16777215;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Buffer MB0 Interrupt Or Clear FIFO bit" ]
            # [ inline ( always ) ]
            pub fn buf0i(&self) -> Buf0iR {
                Buf0iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 1:4 - Buffer MB i Interrupt Or \"reserved\"" ]
            # [ inline ( always ) ]
            pub fn buf4to1i(&self) -> Buf4to1iR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Buf4to1iR { bits }
            }
            # [ doc = "Bit 5 - Buffer MB5 Interrupt Or \"Frames available in Rx FIFO\"" ]
            # [ inline ( always ) ]
            pub fn buf5i(&self) -> Buf5iR {
                Buf5iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Buffer MB6 Interrupt Or \"Rx FIFO Warning\"" ]
            # [ inline ( always ) ]
            pub fn buf6i(&self) -> Buf6iR {
                Buf6iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Buffer MB7 Interrupt Or \"Rx FIFO Overflow\"" ]
            # [ inline ( always ) ]
            pub fn buf7i(&self) -> Buf7iR {
                Buf7iR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:31 - Buffer MBi Interrupt" ]
            # [ inline ( always ) ]
            pub fn buf31to8i(&self) -> Buf31to8iR {
                let bits = {
                    const MASK: u32 = 16777215;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Buf31to8iR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Buffer MB0 Interrupt Or Clear FIFO bit" ]
            # [ inline ( always ) ]
            pub fn buf0i(&mut self) -> _Buf0iW {
                _Buf0iW { w: self }
            }
            # [ doc = "Bits 1:4 - Buffer MB i Interrupt Or \"reserved\"" ]
            # [ inline ( always ) ]
            pub fn buf4to1i(&mut self) -> _Buf4to1iW {
                _Buf4to1iW { w: self }
            }
            # [ doc = "Bit 5 - Buffer MB5 Interrupt Or \"Frames available in Rx FIFO\"" ]
            # [ inline ( always ) ]
            pub fn buf5i(&mut self) -> _Buf5iW {
                _Buf5iW { w: self }
            }
            # [ doc = "Bit 6 - Buffer MB6 Interrupt Or \"Rx FIFO Warning\"" ]
            # [ inline ( always ) ]
            pub fn buf6i(&mut self) -> _Buf6iW {
                _Buf6iW { w: self }
            }
            # [ doc = "Bit 7 - Buffer MB7 Interrupt Or \"Rx FIFO Overflow\"" ]
            # [ inline ( always ) ]
            pub fn buf7i(&mut self) -> _Buf7iW {
                _Buf7iW { w: self }
            }
            # [ doc = "Bits 8:31 - Buffer MBi Interrupt" ]
            # [ inline ( always ) ]
            pub fn buf31to8i(&mut self) -> _Buf31to8iW {
                _Buf31to8iW { w: self }
            }
        }
    }
    # [ doc = "Control 2 register" ]
    pub struct Ctrl2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control 2 register" ]
    pub mod ctrl2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EDFLTDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EdfltdisR {
            # [ doc = "Edge Filter is enabled." ]
            _0,
            # [ doc = "Edge Filter is disabled." ]
            _1,
        }
        impl EdfltdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EdfltdisR::_0 => 0,
                    EdfltdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EdfltdisR {
                match bits {
                    0 => EdfltdisR::_0,
                    1 => EdfltdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EdfltdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EdfltdisR::_1
            }
        }
        # [ doc = "Possible values of the field `ISOCANFDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsocanfdenR {
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            _0,
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            _1,
        }
        impl IsocanfdenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsocanfdenR::_0 => 0,
                    IsocanfdenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsocanfdenR {
                match bits {
                    0 => IsocanfdenR::_0,
                    1 => IsocanfdenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsocanfdenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsocanfdenR::_1
            }
        }
        # [ doc = "Possible values of the field `PREXCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrexcenR {
            # [ doc = "Protocol Exception is disabled." ]
            _0,
            # [ doc = "Protocol Exception is enabled." ]
            _1,
        }
        impl PrexcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrexcenR::_0 => 0,
                    PrexcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrexcenR {
                match bits {
                    0 => PrexcenR::_0,
                    1 => PrexcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrexcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrexcenR::_1
            }
        }
        # [ doc = "Possible values of the field `TIMER_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimerSrcR {
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            _0,
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            _1,
        }
        impl TimerSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimerSrcR::_0 => 0,
                    TimerSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimerSrcR {
                match bits {
                    0 => TimerSrcR::_0,
                    1 => TimerSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimerSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimerSrcR::_1
            }
        }
        # [ doc = "Possible values of the field `EACEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EacenR {
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            _0,
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            _1,
        }
        impl EacenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EacenR::_0 => 0,
                    EacenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EacenR {
                match bits {
                    0 => EacenR::_0,
                    1 => EacenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EacenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EacenR::_1
            }
        }
        # [ doc = "Possible values of the field `RRS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RrsR {
            # [ doc = "Remote Response Frame is generated." ]
            _0,
            # [ doc = "Remote Request Frame is stored." ]
            _1,
        }
        impl RrsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RrsR::_0 => 0,
                    RrsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RrsR {
                match bits {
                    0 => RrsR::_0,
                    1 => RrsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RrsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RrsR::_1
            }
        }
        # [ doc = "Possible values of the field `MRP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MrpR {
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            _0,
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            _1,
        }
        impl MrpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MrpR::_0 => 0,
                    MrpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MrpR {
                match bits {
                    0 => MrpR::_0,
                    1 => MrpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MrpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MrpR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TasdR {
            bits: u8,
        }
        impl TasdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RffnR {
            bits: u8,
        }
        impl RffnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BOFFDONEMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BoffdonemskR {
            # [ doc = "Bus Off Done interrupt disabled." ]
            _0,
            # [ doc = "Bus Off Done interrupt enabled." ]
            _1,
        }
        impl BoffdonemskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BoffdonemskR::_0 => 0,
                    BoffdonemskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BoffdonemskR {
                match bits {
                    0 => BoffdonemskR::_0,
                    1 => BoffdonemskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BoffdonemskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BoffdonemskR::_1
            }
        }
        # [ doc = "Possible values of the field `ERRMSK_FAST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrmskFastR {
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            _0,
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            _1,
        }
        impl ErrmskFastR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrmskFastR::_0 => 0,
                    ErrmskFastR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrmskFastR {
                match bits {
                    0 => ErrmskFastR::_0,
                    1 => ErrmskFastR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrmskFastR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrmskFastR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EDFLTDIS`" ]
        pub enum EdfltdisW {
            # [ doc = "Edge Filter is enabled." ]
            _0,
            # [ doc = "Edge Filter is disabled." ]
            _1,
        }
        impl EdfltdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EdfltdisW::_0 => 0,
                    EdfltdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EdfltdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EdfltdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EdfltdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Edge Filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EdfltdisW::_0)
            }
            # [ doc = "Edge Filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EdfltdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISOCANFDEN`" ]
        pub enum IsocanfdenW {
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            _0,
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            _1,
        }
        impl IsocanfdenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsocanfdenW::_0 => 0,
                    IsocanfdenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsocanfdenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsocanfdenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsocanfdenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FlexCAN operates using the non-ISO CAN FD protocol." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsocanfdenW::_0)
            }
            # [ doc = "FlexCAN operates using the ISO CAN FD protocol (ISO 11898-1)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsocanfdenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PREXCEN`" ]
        pub enum PrexcenW {
            # [ doc = "Protocol Exception is disabled." ]
            _0,
            # [ doc = "Protocol Exception is enabled." ]
            _1,
        }
        impl PrexcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrexcenW::_0 => 0,
                    PrexcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrexcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrexcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrexcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Protocol Exception is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PrexcenW::_0)
            }
            # [ doc = "Protocol Exception is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PrexcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMER_SRC`" ]
        pub enum TimerSrcW {
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            _0,
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            _1,
        }
        impl TimerSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimerSrcW::_0 => 0,
                    TimerSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimerSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimerSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimerSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The Free Running Timer is clocked by the CAN bit clock, which defines the baud rate on the CAN bus." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimerSrcW::_0)
            }
            # [ doc = "The Free Running Timer is clocked by an external time tick. The period can be either adjusted to be equal to the baud rate on the CAN bus, or a different value as required. See the device specific section for details about the external time tick." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimerSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EACEN`" ]
        pub enum EacenW {
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            _0,
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            _1,
        }
        impl EacenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EacenW::_0 => 0,
                    EacenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EacenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EacenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EacenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Rx Mailbox filter's IDE bit is always compared and RTR is never compared despite mask bits." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EacenW::_0)
            }
            # [ doc = "Enables the comparison of both Rx Mailbox filter's IDE and RTR bit with their corresponding bits within the incoming frame. Mask bits do apply." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EacenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRS`" ]
        pub enum RrsW {
            # [ doc = "Remote Response Frame is generated." ]
            _0,
            # [ doc = "Remote Request Frame is stored." ]
            _1,
        }
        impl RrsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrsW::_0 => 0,
                    RrsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Remote Response Frame is generated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrsW::_0)
            }
            # [ doc = "Remote Request Frame is stored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MRP`" ]
        pub enum MrpW {
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            _0,
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            _1,
        }
        impl MrpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MrpW::_0 => 0,
                    MrpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MrpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MrpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MrpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Matching starts from Rx FIFO and continues on Mailboxes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MrpW::_0)
            }
            # [ doc = "Matching starts from Mailboxes and continues on Rx FIFO." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MrpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TasdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TasdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RffnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RffnW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOFFDONEMSK`" ]
        pub enum BoffdonemskW {
            # [ doc = "Bus Off Done interrupt disabled." ]
            _0,
            # [ doc = "Bus Off Done interrupt enabled." ]
            _1,
        }
        impl BoffdonemskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BoffdonemskW::_0 => 0,
                    BoffdonemskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BoffdonemskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BoffdonemskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BoffdonemskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus Off Done interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BoffdonemskW::_0)
            }
            # [ doc = "Bus Off Done interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BoffdonemskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ERRMSK_FAST`" ]
        pub enum ErrmskFastW {
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            _0,
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            _1,
        }
        impl ErrmskFastW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrmskFastW::_0 => 0,
                    ErrmskFastW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrmskFastW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrmskFastW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrmskFastW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "ERRINT_FAST Error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrmskFastW::_0)
            }
            # [ doc = "ERRINT_FAST Error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrmskFastW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 11 - Edge Filter Disable" ]
            # [ inline ( always ) ]
            pub fn edfltdis(&self) -> EdfltdisR {
                EdfltdisR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 11;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 12 - ISO CAN FD Enable" ]
            # [ inline ( always ) ]
            pub fn isocanfden(&self) -> IsocanfdenR {
                IsocanfdenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 12;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 14 - Protocol Exception Enable" ]
            # [ inline ( always ) ]
            pub fn prexcen(&self) -> PrexcenR {
                PrexcenR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Timer Source" ]
            # [ inline ( always ) ]
            pub fn timer_src(&self) -> TimerSrcR {
                TimerSrcR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 15;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 16 - Entire Frame Arbitration Field Comparison Enable For Rx Mailboxes" ]
            # [ inline ( always ) ]
            pub fn eacen(&self) -> EacenR {
                EacenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 17 - Remote Request Storing" ]
            # [ inline ( always ) ]
            pub fn rrs(&self) -> RrsR {
                RrsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Mailboxes Reception Priority" ]
            # [ inline ( always ) ]
            pub fn mrp(&self) -> MrpR {
                MrpR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 18;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 19:23 - Tx Arbitration Start Delay" ]
            # [ inline ( always ) ]
            pub fn tasd(&self) -> TasdR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TasdR { bits }
            }
            # [ doc = "Bits 24:27 - Number Of Rx FIFO Filters" ]
            # [ inline ( always ) ]
            pub fn rffn(&self) -> RffnR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RffnR { bits }
            }
            # [ doc = "Bit 30 - Bus Off Done Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffdonemsk(&self) -> BoffdonemskR {
                BoffdonemskR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 30;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 31 - Error Interrupt Mask for errors detected in the Data Phase of fast CAN FD frames" ]
            # [ inline ( always ) ]
            pub fn errmsk_fast(&self) -> ErrmskFastR {
                ErrmskFastR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 31;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 10485760 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 11 - Edge Filter Disable" ]
            # [ inline ( always ) ]
            pub fn edfltdis(&mut self) -> _EdfltdisW {
                _EdfltdisW { w: self }
            }
            # [ doc = "Bit 12 - ISO CAN FD Enable" ]
            # [ inline ( always ) ]
            pub fn isocanfden(&mut self) -> _IsocanfdenW {
                _IsocanfdenW { w: self }
            }
            # [ doc = "Bit 14 - Protocol Exception Enable" ]
            # [ inline ( always ) ]
            pub fn prexcen(&mut self) -> _PrexcenW {
                _PrexcenW { w: self }
            }
            # [ doc = "Bit 15 - Timer Source" ]
            # [ inline ( always ) ]
            pub fn timer_src(&mut self) -> _TimerSrcW {
                _TimerSrcW { w: self }
            }
            # [ doc = "Bit 16 - Entire Frame Arbitration Field Comparison Enable For Rx Mailboxes" ]
            # [ inline ( always ) ]
            pub fn eacen(&mut self) -> _EacenW {
                _EacenW { w: self }
            }
            # [ doc = "Bit 17 - Remote Request Storing" ]
            # [ inline ( always ) ]
            pub fn rrs(&mut self) -> _RrsW {
                _RrsW { w: self }
            }
            # [ doc = "Bit 18 - Mailboxes Reception Priority" ]
            # [ inline ( always ) ]
            pub fn mrp(&mut self) -> _MrpW {
                _MrpW { w: self }
            }
            # [ doc = "Bits 19:23 - Tx Arbitration Start Delay" ]
            # [ inline ( always ) ]
            pub fn tasd(&mut self) -> _TasdW {
                _TasdW { w: self }
            }
            # [ doc = "Bits 24:27 - Number Of Rx FIFO Filters" ]
            # [ inline ( always ) ]
            pub fn rffn(&mut self) -> _RffnW {
                _RffnW { w: self }
            }
            # [ doc = "Bit 30 - Bus Off Done Interrupt Mask" ]
            # [ inline ( always ) ]
            pub fn boffdonemsk(&mut self) -> _BoffdonemskW {
                _BoffdonemskW { w: self }
            }
            # [ doc = "Bit 31 - Error Interrupt Mask for errors detected in the Data Phase of fast CAN FD frames" ]
            # [ inline ( always ) ]
            pub fn errmsk_fast(&mut self) -> _ErrmskFastW {
                _ErrmskFastW { w: self }
            }
        }
    }
    # [ doc = "Error and Status 2 register" ]
    pub struct Esr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Error and Status 2 register" ]
    pub mod esr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Esr2 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `IMB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ImbR {
            # [ doc = "If ESR2[VPS] is asserted, the ESR2[LPTM] is not an inactive Mailbox." ]
            _0,
            # [ doc = "If ESR2[VPS] is asserted, there is at least one inactive Mailbox. LPTM content is the number of the first one." ]
            _1,
        }
        impl ImbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ImbR::_0 => 0,
                    ImbR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ImbR {
                match bits {
                    0 => ImbR::_0,
                    1 => ImbR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ImbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ImbR::_1
            }
        }
        # [ doc = "Possible values of the field `VPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VpsR {
            # [ doc = "Contents of IMB and LPTM are invalid." ]
            _0,
            # [ doc = "Contents of IMB and LPTM are valid." ]
            _1,
        }
        impl VpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VpsR::_0 => 0,
                    VpsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VpsR {
                match bits {
                    0 => VpsR::_0,
                    1 => VpsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VpsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VpsR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LptmR {
            bits: u8,
        }
        impl LptmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 13 - Inactive Mailbox" ]
            # [ inline ( always ) ]
            pub fn imb(&self) -> ImbR {
                ImbR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 14 - Valid Priority Status" ]
            # [ inline ( always ) ]
            pub fn vps(&self) -> VpsR {
                VpsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:22 - Lowest Priority Tx Mailbox" ]
            # [ inline ( always ) ]
            pub fn lptm(&self) -> LptmR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LptmR { bits }
            }
        }
    }
    # [ doc = "CRC Register" ]
    pub struct Crcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "CRC Register" ]
    pub mod crcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Crcr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcrcR {
            bits: u16,
        }
        impl TxcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MbcrcR {
            bits: u8,
        }
        impl MbcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:14 - Transmitted CRC value" ]
            # [ inline ( always ) ]
            pub fn txcrc(&self) -> TxcrcR {
                let bits = {
                    const MASK: u16 = 32767;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TxcrcR { bits }
            }
            # [ doc = "Bits 16:22 - CRC Mailbox" ]
            # [ inline ( always ) ]
            pub fn mbcrc(&self) -> MbcrcR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MbcrcR { bits }
            }
        }
    }
    # [ doc = "Rx FIFO Global Mask register" ]
    pub struct Rxfgmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx FIFO Global Mask register" ]
    pub mod rxfgmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rxfgmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FgmR {
            bits: u32,
        }
        impl FgmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FgmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FgmW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Rx FIFO Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn fgm(&self) -> FgmR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FgmR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Rx FIFO Global Mask Bits" ]
            # [ inline ( always ) ]
            pub fn fgm(&mut self) -> _FgmW {
                _FgmW { w: self }
            }
        }
    }
    # [ doc = "Rx FIFO Information Register" ]
    pub struct Rxfir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx FIFO Information Register" ]
    pub mod rxfir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rxfir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdhitR {
            bits: u16,
        }
        impl IdhitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Identifier Acceptance Filter Hit Indicator" ]
            # [ inline ( always ) ]
            pub fn idhit(&self) -> IdhitR {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                IdhitR { bits }
            }
        }
    }
    # [ doc = "CAN Bit Timing Register" ]
    pub struct Cbt {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN Bit Timing Register" ]
    pub mod cbt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cbt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Epseg2R {
            bits: u8,
        }
        impl Epseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Epseg1R {
            bits: u8,
        }
        impl Epseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EpropsegR {
            bits: u8,
        }
        impl EpropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ErjwR {
            bits: u8,
        }
        impl ErjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EpresdivR {
            bits: u16,
        }
        impl EpresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `BTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BtfR {
            # [ doc = "Extended bit time definitions disabled." ]
            _0,
            # [ doc = "Extended bit time definitions enabled." ]
            _1,
        }
        impl BtfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BtfR::_0 => 0,
                    BtfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BtfR {
                match bits {
                    0 => BtfR::_0,
                    1 => BtfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BtfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BtfR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Epseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Epseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Epseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Epseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BTF`" ]
        pub enum BtfW {
            # [ doc = "Extended bit time definitions disabled." ]
            _0,
            # [ doc = "Extended bit time definitions enabled." ]
            _1,
        }
        impl BtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BtfW::_0 => 0,
                    BtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Extended bit time definitions disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BtfW::_0)
            }
            # [ doc = "Extended bit time definitions enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Extended Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn epseg2(&self) -> Epseg2R {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Epseg2R { bits }
            }
            # [ doc = "Bits 5:9 - Extended Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn epseg1(&self) -> Epseg1R {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Epseg1R { bits }
            }
            # [ doc = "Bits 10:15 - Extended Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn epropseg(&self) -> EpropsegR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EpropsegR { bits }
            }
            # [ doc = "Bits 16:20 - Extended Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn erjw(&self) -> ErjwR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ErjwR { bits }
            }
            # [ doc = "Bits 21:30 - Extended Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn epresdiv(&self) -> EpresdivR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                EpresdivR { bits }
            }
            # [ doc = "Bit 31 - Bit Timing Format Enable" ]
            # [ inline ( always ) ]
            pub fn btf(&self) -> BtfR {
                BtfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 31;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Extended Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn epseg2(&mut self) -> _Epseg2W {
                _Epseg2W { w: self }
            }
            # [ doc = "Bits 5:9 - Extended Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn epseg1(&mut self) -> _Epseg1W {
                _Epseg1W { w: self }
            }
            # [ doc = "Bits 10:15 - Extended Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn epropseg(&mut self) -> _EpropsegW {
                _EpropsegW { w: self }
            }
            # [ doc = "Bits 16:20 - Extended Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn erjw(&mut self) -> _ErjwW {
                _ErjwW { w: self }
            }
            # [ doc = "Bits 21:30 - Extended Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn epresdiv(&mut self) -> _EpresdivW {
                _EpresdivW { w: self }
            }
            # [ doc = "Bit 31 - Bit Timing Format Enable" ]
            # [ inline ( always ) ]
            pub fn btf(&mut self) -> _BtfW {
                _BtfW { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam32 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram32 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam32 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam33 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram33 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam33 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam34 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram34 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam34 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam35 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram35 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam35 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam36 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram36 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam36 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam37 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram37 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam37 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam38 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram38 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam38 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam39 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram39 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam39 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam40 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram40 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam40 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam41 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram41 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam41 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam42 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram42 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam42 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam43 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram43 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam43 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam44 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram44 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam44 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam45 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram45 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam45 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam46 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram46 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam46 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam47 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam48 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram48 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam48 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam49 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram49 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam49 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam50 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram50 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam50 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam51 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram51 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam51 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam52 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram52 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam52 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam53 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram53 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam53 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam54 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram54 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam54 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam55 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram55 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam55 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam56 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram56 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam56 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam57 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram57 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam57 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam58 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram58 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam58 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam59 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram59 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam59 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam60 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram60 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam60 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam61 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram61 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam61 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam62 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram62 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam62 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam63 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram63 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam63 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam64 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram64 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam64 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam65 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram65 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam65 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam66 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram66 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam66 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam67 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram67 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam67 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam68 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram68 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam68 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam69 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram69 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam69 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam70 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram70 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam70 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam71 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram71 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam71 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam72 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram72 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam72 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam73 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram73 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam73 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam74 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram74 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam74 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam75 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram75 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam75 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam76 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram76 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam76 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam77 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram77 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam77 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam78 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram78 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam78 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam79 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram79 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam79 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam80 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram80 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam80 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam81 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram81 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam81 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam82 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram82 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam82 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam83 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram83 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam83 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam84 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram84 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam84 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam85 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram85 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam85 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam86 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram86 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam86 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam87 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram87 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam87 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam88 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram88 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam88 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam89 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram89 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam89 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam90 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram90 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam90 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam91 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram91 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam91 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam92 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram92 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam92 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam93 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram93 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam93 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam94 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram94 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam94 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam95 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram95 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam95 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam96 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram96 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam96 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam97 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram97 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam97 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam98 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram98 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam98 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam99 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram99 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam99 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam100 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram100 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam100 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam101 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram101 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam101 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam102 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram102 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam102 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam103 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram103 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam103 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam104 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram104 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam104 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam105 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram105 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam105 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam106 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram106 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam106 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam107 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram107 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam107 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam108 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram108 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam108 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam109 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram109 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam109 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam110 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram110 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam110 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam111 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram111 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam111 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam112 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram112 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam112 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam113 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram113 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam113 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam114 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram114 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam114 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam115 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram115 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam115 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam116 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram116 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam116 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam117 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram117 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam117 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam118 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram118 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam118 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam119 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram119 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam119 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam120 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram120 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam120 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam121 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram121 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam121 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam122 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram122 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam122 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam123 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram123 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam123 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam124 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram124 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam124 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam125 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram125 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam125 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam126 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram126 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam126 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Embedded RAM" ]
    pub struct EmbeddedRam127 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Embedded RAM" ]
    pub mod embedded_ram127 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::EmbeddedRam127 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Data byte 3 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Data byte 2 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Data byte 1 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Data byte 0 of Rx/Tx frame." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub struct Rximr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Rx Individual Mask Registers" ]
    pub mod rximr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rximr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MiR {
            bits: u32,
        }
        impl MiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&self) -> MiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                MiR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Individual Mask Bits" ]
            # [ inline ( always ) ]
            pub fn mi(&mut self) -> _MiW {
                _MiW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Control 1 Register" ]
    pub struct Ctrl1Pn {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Control 1 Register" ]
    pub mod ctrl1_pn {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl1Pn {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcsR {
            # [ doc = "Message ID filtering only" ]
            _00,
            # [ doc = "Message ID filtering and payload filtering" ]
            _01,
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            _10,
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            _11,
        }
        impl FcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcsR::_00 => 0,
                    FcsR::_01 => 1,
                    FcsR::_10 => 2,
                    FcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcsR {
                match bits {
                    0 => FcsR::_00,
                    1 => FcsR::_01,
                    2 => FcsR::_10,
                    3 => FcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FcsR::_11
            }
        }
        # [ doc = "Possible values of the field `IDFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdfsR {
            # [ doc = "Match upon a ID contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl IdfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdfsR::_00 => 0,
                    IdfsR::_01 => 1,
                    IdfsR::_10 => 2,
                    IdfsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdfsR {
                match bits {
                    0 => IdfsR::_00,
                    1 => IdfsR::_01,
                    2 => IdfsR::_10,
                    3 => IdfsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == IdfsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == IdfsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == IdfsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == IdfsR::_11
            }
        }
        # [ doc = "Possible values of the field `PLFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PlfsR {
            # [ doc = "Match upon a payload contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl PlfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PlfsR::_00 => 0,
                    PlfsR::_01 => 1,
                    PlfsR::_10 => 2,
                    PlfsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PlfsR {
                match bits {
                    0 => PlfsR::_00,
                    1 => PlfsR::_01,
                    2 => PlfsR::_10,
                    3 => PlfsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PlfsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PlfsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PlfsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PlfsR::_11
            }
        }
        # [ doc = "Possible values of the field `NMATCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NmatchR {
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            _00000001,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            _00000010,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            _11111111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl NmatchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NmatchR::_00000001 => 1,
                    NmatchR::_00000010 => 2,
                    NmatchR::_11111111 => 255,
                    NmatchR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NmatchR {
                match bits {
                    1 => NmatchR::_00000001,
                    2 => NmatchR::_00000010,
                    255 => NmatchR::_11111111,
                    i => NmatchR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == NmatchR::_00000001
            }
            # [ doc = "Checks if the value of the field is `_00000010`" ]
            # [ inline ( always ) ]
            pub fn is_00000010(&self) -> bool {
                *self == NmatchR::_00000010
            }
            # [ doc = "Checks if the value of the field is `_11111111`" ]
            # [ inline ( always ) ]
            pub fn is_11111111(&self) -> bool {
                *self == NmatchR::_11111111
            }
        }
        # [ doc = "Possible values of the field `WUMF_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WumfMskR {
            # [ doc = "Wake up match event is disabled" ]
            _0,
            # [ doc = "Wake up match event is enabled" ]
            _1,
        }
        impl WumfMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WumfMskR::_0 => 0,
                    WumfMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WumfMskR {
                match bits {
                    0 => WumfMskR::_0,
                    1 => WumfMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WumfMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WumfMskR::_1
            }
        }
        # [ doc = "Possible values of the field `WTOF_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WtofMskR {
            # [ doc = "Timeout wake up event is disabled" ]
            _0,
            # [ doc = "Timeout wake up event is enabled" ]
            _1,
        }
        impl WtofMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WtofMskR::_0 => 0,
                    WtofMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WtofMskR {
                match bits {
                    0 => WtofMskR::_0,
                    1 => WtofMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WtofMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WtofMskR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FCS`" ]
        pub enum FcsW {
            # [ doc = "Message ID filtering only" ]
            _00,
            # [ doc = "Message ID filtering and payload filtering" ]
            _01,
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            _10,
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            _11,
        }
        impl FcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcsW::_00 => 0,
                    FcsW::_01 => 1,
                    FcsW::_10 => 2,
                    FcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Message ID filtering only" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FcsW::_00)
            }
            # [ doc = "Message ID filtering and payload filtering" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FcsW::_01)
            }
            # [ doc = "Message ID filtering occurring a specified number of times." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FcsW::_10)
            }
            # [ doc = "Message ID filtering and payload filtering a specified number of times" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDFS`" ]
        pub enum IdfsW {
            # [ doc = "Match upon a ID contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl IdfsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdfsW::_00 => 0,
                    IdfsW::_01 => 1,
                    IdfsW::_10 => 2,
                    IdfsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdfsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdfsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Match upon a ID contents against an exact target value" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(IdfsW::_00)
            }
            # [ doc = "Match upon a ID value greater than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(IdfsW::_01)
            }
            # [ doc = "Match upon a ID value smaller than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(IdfsW::_10)
            }
            # [ doc = "Match upon a ID value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(IdfsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PLFS`" ]
        pub enum PlfsW {
            # [ doc = "Match upon a payload contents against an exact target value" ]
            _00,
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            _01,
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            _10,
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            _11,
        }
        impl PlfsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PlfsW::_00 => 0,
                    PlfsW::_01 => 1,
                    PlfsW::_10 => 2,
                    PlfsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PlfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PlfsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PlfsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Match upon a payload contents against an exact target value" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PlfsW::_00)
            }
            # [ doc = "Match upon a payload value greater than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PlfsW::_01)
            }
            # [ doc = "Match upon a payload value smaller than or equal to a specified target value" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PlfsW::_10)
            }
            # [ doc = "Match upon a payload value inside a range, greater than or equal to a specified lower limit and smaller than or equal a specified upper limit" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PlfsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NMATCH`" ]
        pub enum NmatchW {
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            _00000001,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            _00000010,
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            _11111111,
        }
        impl NmatchW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NmatchW::_00000001 => 1,
                    NmatchW::_00000010 => 2,
                    NmatchW::_11111111 => 255,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NmatchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NmatchW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NmatchW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL once before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(NmatchW::_00000001)
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL twice before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _00000010(self) -> &'a mut W {
                self.variant(NmatchW::_00000010)
            }
            # [ doc = "Received message must match the predefined filtering criteria for ID and/or PL 255 times before generating a wake up event." ]
            # [ inline ( always ) ]
            pub fn _11111111(self) -> &'a mut W {
                self.variant(NmatchW::_11111111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WUMF_MSK`" ]
        pub enum WumfMskW {
            # [ doc = "Wake up match event is disabled" ]
            _0,
            # [ doc = "Wake up match event is enabled" ]
            _1,
        }
        impl WumfMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WumfMskW::_0 => 0,
                    WumfMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WumfMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WumfMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WumfMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Wake up match event is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WumfMskW::_0)
            }
            # [ doc = "Wake up match event is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WumfMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WTOF_MSK`" ]
        pub enum WtofMskW {
            # [ doc = "Timeout wake up event is disabled" ]
            _0,
            # [ doc = "Timeout wake up event is enabled" ]
            _1,
        }
        impl WtofMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WtofMskW::_0 => 0,
                    WtofMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WtofMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WtofMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WtofMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timeout wake up event is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WtofMskW::_0)
            }
            # [ doc = "Timeout wake up event is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WtofMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Filtering Combination Selection" ]
            # [ inline ( always ) ]
            pub fn fcs(&self) -> FcsR {
                FcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 2:3 - ID Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn idfs(&self) -> IdfsR {
                IdfsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 4:5 - Payload Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn plfs(&self) -> PlfsR {
                PlfsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 8:15 - Number of Messages Matching the Same Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn nmatch(&self) -> NmatchR {
                NmatchR::_from({
                                   const MASK: u8 = 255;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wumf_msk(&self) -> WumfMskR {
                WumfMskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wtof_msk(&self) -> WtofMskR {
                WtofMskR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 256 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Filtering Combination Selection" ]
            # [ inline ( always ) ]
            pub fn fcs(&mut self) -> _FcsW {
                _FcsW { w: self }
            }
            # [ doc = "Bits 2:3 - ID Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn idfs(&mut self) -> _IdfsW {
                _IdfsW { w: self }
            }
            # [ doc = "Bits 4:5 - Payload Filtering Selection" ]
            # [ inline ( always ) ]
            pub fn plfs(&mut self) -> _PlfsW {
                _PlfsW { w: self }
            }
            # [ doc = "Bits 8:15 - Number of Messages Matching the Same Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn nmatch(&mut self) -> _NmatchW {
                _NmatchW { w: self }
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wumf_msk(&mut self) -> _WumfMskW {
                _WumfMskW { w: self }
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Mask Bit" ]
            # [ inline ( always ) ]
            pub fn wtof_msk(&mut self) -> _WtofMskW {
                _WtofMskW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Control 2 Register" ]
    pub struct Ctrl2Pn {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Control 2 Register" ]
    pub mod ctrl2_pn {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl2Pn {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MatchtoR {
            bits: u16,
        }
        impl MatchtoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatchtoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatchtoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timeout for No Message Matching the Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn matchto(&self) -> MatchtoR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                MatchtoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timeout for No Message Matching the Filtering Criteria" ]
            # [ inline ( always ) ]
            pub fn matchto(&mut self) -> _MatchtoW {
                _MatchtoW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Wake Up Match Register" ]
    pub struct WuMtc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Wake Up Match Register" ]
    pub mod wu_mtc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::WuMtc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct McounterR {
            bits: u8,
        }
        impl McounterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WUMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WumfR {
            # [ doc = "No wake up by match event detected" ]
            _0,
            # [ doc = "Wake up by match event detected" ]
            _1,
        }
        impl WumfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WumfR::_0 => 0,
                    WumfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WumfR {
                match bits {
                    0 => WumfR::_0,
                    1 => WumfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WumfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WumfR::_1
            }
        }
        # [ doc = "Possible values of the field `WTOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WtofR {
            # [ doc = "No wake up by timeout event detected" ]
            _0,
            # [ doc = "Wake up by timeout event detected" ]
            _1,
        }
        impl WtofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WtofR::_0 => 0,
                    WtofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WtofR {
                match bits {
                    0 => WtofR::_0,
                    1 => WtofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WtofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WtofR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WUMF`" ]
        pub enum WumfW {
            # [ doc = "No wake up by match event detected" ]
            _0,
            # [ doc = "Wake up by match event detected" ]
            _1,
        }
        impl WumfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WumfW::_0 => 0,
                    WumfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WumfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WumfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WumfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No wake up by match event detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WumfW::_0)
            }
            # [ doc = "Wake up by match event detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WumfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WTOF`" ]
        pub enum WtofW {
            # [ doc = "No wake up by timeout event detected" ]
            _0,
            # [ doc = "Wake up by timeout event detected" ]
            _1,
        }
        impl WtofW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WtofW::_0 => 0,
                    WtofW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WtofW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WtofW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WtofW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No wake up by timeout event detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WtofW::_0)
            }
            # [ doc = "Wake up by timeout event detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WtofW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:15 - Number of Matches while in Pretended Networking" ]
            # [ inline ( always ) ]
            pub fn mcounter(&self) -> McounterR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                McounterR { bits }
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wumf(&self) -> WumfR {
                WumfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wtof(&self) -> WtofR {
                WtofR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 16 - Wake Up by Match Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wumf(&mut self) -> _WumfW {
                _WumfW { w: self }
            }
            # [ doc = "Bit 17 - Wake Up by Timeout Flag Bit" ]
            # [ inline ( always ) ]
            pub fn wtof(&mut self) -> _WtofW {
                _WtofW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking ID Filter 1 Register" ]
    pub struct FltId1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking ID Filter 1 Register" ]
    pub mod flt_id1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltId1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltId1R {
            bits: u32,
        }
        impl FltId1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FLT_RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltRtrR {
            # [ doc = "Reject remote frame (accept data frame)" ]
            _0,
            # [ doc = "Accept remote frame" ]
            _1,
        }
        impl FltRtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltRtrR::_0 => 0,
                    FltRtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltRtrR {
                match bits {
                    0 => FltRtrR::_0,
                    1 => FltRtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FltRtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FltRtrR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT_IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltIdeR {
            # [ doc = "Accept standard frame format" ]
            _0,
            # [ doc = "Accept extended frame format" ]
            _1,
        }
        impl FltIdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltIdeR::_0 => 0,
                    FltIdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltIdeR {
                match bits {
                    0 => FltIdeR::_0,
                    1 => FltIdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FltIdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FltIdeR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltId1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltId1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 536870911;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT_RTR`" ]
        pub enum FltRtrW {
            # [ doc = "Reject remote frame (accept data frame)" ]
            _0,
            # [ doc = "Accept remote frame" ]
            _1,
        }
        impl FltRtrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltRtrW::_0 => 0,
                    FltRtrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltRtrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltRtrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltRtrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reject remote frame (accept data frame)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FltRtrW::_0)
            }
            # [ doc = "Accept remote frame" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FltRtrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT_IDE`" ]
        pub enum FltIdeW {
            # [ doc = "Accept standard frame format" ]
            _0,
            # [ doc = "Accept extended frame format" ]
            _1,
        }
        impl FltIdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltIdeW::_0 => 0,
                    FltIdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltIdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltIdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltIdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Accept standard frame format" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FltIdeW::_0)
            }
            # [ doc = "Accept extended frame format" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FltIdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - ID Filter 1 for Pretended Networking filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id1(&self) -> FltId1R {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FltId1R { bits }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Filter" ]
            # [ inline ( always ) ]
            pub fn flt_rtr(&self) -> FltRtrR {
                FltRtrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 29;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ID Extended Filter" ]
            # [ inline ( always ) ]
            pub fn flt_ide(&self) -> FltIdeR {
                FltIdeR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:28 - ID Filter 1 for Pretended Networking filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id1(&mut self) -> _FltId1W {
                _FltId1W { w: self }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Filter" ]
            # [ inline ( always ) ]
            pub fn flt_rtr(&mut self) -> _FltRtrW {
                _FltRtrW { w: self }
            }
            # [ doc = "Bit 30 - ID Extended Filter" ]
            # [ inline ( always ) ]
            pub fn flt_ide(&mut self) -> _FltIdeW {
                _FltIdeW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking DLC Filter Register" ]
    pub struct FltDlc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking DLC Filter Register" ]
    pub mod flt_dlc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltDlc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltDlcHiR {
            bits: u8,
        }
        impl FltDlcHiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltDlcLoR {
            bits: u8,
        }
        impl FltDlcLoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltDlcHiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltDlcHiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltDlcLoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltDlcLoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Upper Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_hi(&self) -> FltDlcHiR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FltDlcHiR { bits }
            }
            # [ doc = "Bits 16:19 - Lower Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_lo(&self) -> FltDlcLoR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FltDlcLoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 8 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Upper Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_hi(&mut self) -> _FltDlcHiW {
                _FltDlcHiW { w: self }
            }
            # [ doc = "Bits 16:19 - Lower Limit for Length of Data Bytes Filter" ]
            # [ inline ( always ) ]
            pub fn flt_dlc_lo(&mut self) -> _FltDlcLoW {
                _FltDlcLoW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload Low Filter 1 Register" ]
    pub struct Pl1Lo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload Low Filter 1 Register" ]
    pub mod pl1_lo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl1Lo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload High Filter 1 Register" ]
    pub struct Pl1Hi {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload High Filter 1 Register" ]
    pub mod pl1_hi {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl1Hi {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&mut self) -> _DataByte7W {
                _DataByte7W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&mut self) -> _DataByte6W {
                _DataByte6W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&mut self) -> _DataByte5W {
                _DataByte5W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 1 high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&mut self) -> _DataByte4W {
                _DataByte4W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking ID Filter 2 Register / ID Mask Register" ]
    pub struct FltId2Idmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking ID Filter 2 Register / ID Mask Register" ]
    pub mod flt_id2_idmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::FltId2Idmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FltId2IdmaskR {
            bits: u32,
        }
        impl FltId2IdmaskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrMskR {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl RtrMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrMskR::_0 => 0,
                    RtrMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrMskR {
                match bits {
                    0 => RtrMskR::_0,
                    1 => RtrMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrMskR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE_MSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeMskR {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl IdeMskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeMskR::_0 => 0,
                    IdeMskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeMskR {
                match bits {
                    0 => IdeMskR::_0,
                    1 => IdeMskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeMskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeMskR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltId2IdmaskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltId2IdmaskW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 536870911;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTR_MSK`" ]
        pub enum RtrMskW {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl RtrMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtrMskW::_0 => 0,
                    RtrMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtrMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtrMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtrMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtrMskW::_0)
            }
            # [ doc = "The corresponding bit in the filter is checked" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtrMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDE_MSK`" ]
        pub enum IdeMskW {
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            _0,
            # [ doc = "The corresponding bit in the filter is checked" ]
            _1,
        }
        impl IdeMskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdeMskW::_0 => 0,
                    IdeMskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdeMskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdeMskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdeMskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The corresponding bit in the filter is \"don't care\"" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IdeMskW::_0)
            }
            # [ doc = "The corresponding bit in the filter is checked" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IdeMskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - ID Filter 2 for Pretended Networking Filtering / ID Mask Bits for Pretended Networking ID Filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id2_idmask(&self) -> FltId2IdmaskR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FltId2IdmaskR { bits }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Mask Bit" ]
            # [ inline ( always ) ]
            pub fn rtr_msk(&self) -> RtrMskR {
                RtrMskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 29;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 30 - ID Extended Mask Bit" ]
            # [ inline ( always ) ]
            pub fn ide_msk(&self) -> IdeMskR {
                IdeMskR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 30;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:28 - ID Filter 2 for Pretended Networking Filtering / ID Mask Bits for Pretended Networking ID Filtering" ]
            # [ inline ( always ) ]
            pub fn flt_id2_idmask(&mut self) -> _FltId2IdmaskW {
                _FltId2IdmaskW { w: self }
            }
            # [ doc = "Bit 29 - Remote Transmission Request Mask Bit" ]
            # [ inline ( always ) ]
            pub fn rtr_msk(&mut self) -> _RtrMskW {
                _RtrMskW { w: self }
            }
            # [ doc = "Bit 30 - ID Extended Mask Bit" ]
            # [ inline ( always ) ]
            pub fn ide_msk(&mut self) -> _IdeMskW {
                _IdeMskW { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
    pub struct Pl2PlmaskLo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload Low Filter 2 Register / Payload Low Mask Register" ]
    pub mod pl2_plmask_lo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl2PlmaskLo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 3." ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&mut self) -> _DataByte3W {
                _DataByte3W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 2." ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&mut self) -> _DataByte2W {
                _DataByte2W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 1." ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&mut self) -> _DataByte1W {
                _DataByte1W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 low order bits / Payload Mask low order bits for Pretended Networking payload filtering corresponding to the data byte 0." ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&mut self) -> _DataByte0W {
                _DataByte0W { w: self }
            }
        }
    }
    # [ doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
    pub struct Pl2PlmaskHi {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pretended Networking Payload High Filter 2 low order bits / Payload High Mask Register" ]
    pub mod pl2_plmask_hi {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pl2PlmaskHi {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataByte4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataByte4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 7." ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&mut self) -> _DataByte7W {
                _DataByte7W { w: self }
            }
            # [ doc = "Bits 8:15 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 6." ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&mut self) -> _DataByte6W {
                _DataByte6W { w: self }
            }
            # [ doc = "Bits 16:23 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 5." ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&mut self) -> _DataByte5W {
                _DataByte5W { w: self }
            }
            # [ doc = "Bits 24:31 - Payload Filter 2 high order bits / Payload Mask high order bits for Pretended Networking payload filtering corresponding to the data byte 4." ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&mut self) -> _DataByte4W {
                _DataByte4W { w: self }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb0Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb0_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb0Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb0_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb0D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb0_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb0D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb0_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb0D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb1Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb1_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb1Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb1_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb1D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb1_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb1D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb1_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb1D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb2Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb2_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb2Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb2_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb2D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb2_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb2D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb2_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb2D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub struct Wmb3Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for C/S" ]
    pub mod wmb3_cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3Cs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlcR {
            bits: u8,
        }
        impl DlcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtrR {
            # [ doc = "Frame is data one (not remote)" ]
            _0,
            # [ doc = "Frame is a remote one" ]
            _1,
        }
        impl RtrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtrR::_0 => 0,
                    RtrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtrR {
                match bits {
                    0 => RtrR::_0,
                    1 => RtrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RtrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RtrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdeR {
            # [ doc = "Frame format is standard" ]
            _0,
            # [ doc = "Frame format is extended" ]
            _1,
        }
        impl IdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdeR::_0 => 0,
                    IdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdeR {
                match bits {
                    0 => IdeR::_0,
                    1 => IdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SrrR {
            bits: u8,
        }
        impl SrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 16:19 - Length of Data in Bytes" ]
            # [ inline ( always ) ]
            pub fn dlc(&self) -> DlcR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DlcR { bits }
            }
            # [ doc = "Bit 20 - Remote Transmission Request Bit" ]
            # [ inline ( always ) ]
            pub fn rtr(&self) -> RtrR {
                RtrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 20;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 21 - ID Extended Bit" ]
            # [ inline ( always ) ]
            pub fn ide(&self) -> IdeR {
                IdeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Substitute Remote Request" ]
            # [ inline ( always ) ]
            pub fn srr(&self) -> SrrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SrrR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub struct Wmb3Id {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for ID" ]
    pub mod wmb3_id {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3Id {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdR {
            bits: u32,
        }
        impl IdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:28 - Received ID under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn id(&self) -> IdR {
                let bits = {
                    const MASK: u32 = 536870911;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                IdR { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub struct Wmb3D03 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register for Data 0-3" ]
    pub mod wmb3_d03 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3D03 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte3R {
            bits: u8,
        }
        impl DataByte3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte2R {
            bits: u8,
        }
        impl DataByte2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte1R {
            bits: u8,
        }
        impl DataByte1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte0R {
            bits: u8,
        }
        impl DataByte0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 3 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_3(&self) -> DataByte3R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte3R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 2 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_2(&self) -> DataByte2R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte2R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 1 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_1(&self) -> DataByte1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte1R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 0 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_0(&self) -> DataByte0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte0R { bits }
            }
        }
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub struct Wmb3D47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Wake Up Message Buffer Register Data 4-7" ]
    pub mod wmb3_d47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Wmb3D47 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte7R {
            bits: u8,
        }
        impl DataByte7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte6R {
            bits: u8,
        }
        impl DataByte6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte5R {
            bits: u8,
        }
        impl DataByte5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataByte4R {
            bits: u8,
        }
        impl DataByte4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Received payload corresponding to the data byte 7 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_7(&self) -> DataByte7R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte7R { bits }
            }
            # [ doc = "Bits 8:15 - Received payload corresponding to the data byte 6 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_6(&self) -> DataByte6R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte6R { bits }
            }
            # [ doc = "Bits 16:23 - Received payload corresponding to the data byte 5 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_5(&self) -> DataByte5R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte5R { bits }
            }
            # [ doc = "Bits 24:31 - Received payload corresponding to the data byte 4 under Pretended Networking mode" ]
            # [ inline ( always ) ]
            pub fn data_byte_4(&self) -> DataByte4R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataByte4R { bits }
            }
        }
    }
    # [ doc = "CAN FD Control Register" ]
    pub struct Fdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD Control Register" ]
    pub mod fdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TdcvalR {
            bits: u8,
        }
        impl TdcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TdcoffR {
            bits: u8,
        }
        impl TdcoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TDCFAIL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdcfailR {
            # [ doc = "Measured loop delay is in range." ]
            _0,
            # [ doc = "Measured loop delay is out of range." ]
            _1,
        }
        impl TdcfailR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdcfailR::_0 => 0,
                    TdcfailR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdcfailR {
                match bits {
                    0 => TdcfailR::_0,
                    1 => TdcfailR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdcfailR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdcfailR::_1
            }
        }
        # [ doc = "Possible values of the field `TDCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdcenR {
            # [ doc = "TDC is disabled" ]
            _0,
            # [ doc = "TDC is enabled" ]
            _1,
        }
        impl TdcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdcenR::_0 => 0,
                    TdcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdcenR {
                match bits {
                    0 => TdcenR::_0,
                    1 => TdcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdcenR::_1
            }
        }
        # [ doc = "Possible values of the field `MBDSR0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Mbdsr0R {
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            _00,
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            _01,
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            _10,
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            _11,
        }
        impl Mbdsr0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Mbdsr0R::_00 => 0,
                    Mbdsr0R::_01 => 1,
                    Mbdsr0R::_10 => 2,
                    Mbdsr0R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Mbdsr0R {
                match bits {
                    0 => Mbdsr0R::_00,
                    1 => Mbdsr0R::_01,
                    2 => Mbdsr0R::_10,
                    3 => Mbdsr0R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Mbdsr0R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Mbdsr0R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Mbdsr0R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Mbdsr0R::_11
            }
        }
        # [ doc = "Possible values of the field `FDRATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdrateR {
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            _0,
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            _1,
        }
        impl FdrateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdrateR::_0 => 0,
                    FdrateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdrateR {
                match bits {
                    0 => FdrateR::_0,
                    1 => FdrateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdrateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdrateR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcoffW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDCFAIL`" ]
        pub enum TdcfailW {
            # [ doc = "Measured loop delay is in range." ]
            _0,
            # [ doc = "Measured loop delay is out of range." ]
            _1,
        }
        impl TdcfailW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdcfailW::_0 => 0,
                    TdcfailW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcfailW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcfailW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdcfailW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Measured loop delay is in range." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdcfailW::_0)
            }
            # [ doc = "Measured loop delay is out of range." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdcfailW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDCEN`" ]
        pub enum TdcenW {
            # [ doc = "TDC is disabled" ]
            _0,
            # [ doc = "TDC is enabled" ]
            _1,
        }
        impl TdcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdcenW::_0 => 0,
                    TdcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TDC is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdcenW::_0)
            }
            # [ doc = "TDC is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MBDSR0`" ]
        pub enum Mbdsr0W {
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            _00,
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            _01,
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            _10,
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            _11,
        }
        impl Mbdsr0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Mbdsr0W::_00 => 0,
                    Mbdsr0W::_01 => 1,
                    Mbdsr0W::_10 => 2,
                    Mbdsr0W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mbdsr0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mbdsr0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Mbdsr0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Selects 8 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Mbdsr0W::_00)
            }
            # [ doc = "Selects 16 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Mbdsr0W::_01)
            }
            # [ doc = "Selects 32 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Mbdsr0W::_10)
            }
            # [ doc = "Selects 64 bytes per Message Buffer." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Mbdsr0W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDRATE`" ]
        pub enum FdrateW {
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            _0,
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            _1,
        }
        impl FdrateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdrateW::_0 => 0,
                    FdrateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdrateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdrateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdrateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit a frame in nominal rate. The BRS bit in the Tx MB has no effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdrateW::_0)
            }
            # [ doc = "Transmit a frame with bit rate switching if the BRS bit in the Tx MB is recessive." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdrateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Transceiver Delay Compensation Value" ]
            # [ inline ( always ) ]
            pub fn tdcval(&self) -> TdcvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TdcvalR { bits }
            }
            # [ doc = "Bits 8:12 - Transceiver Delay Compensation Offset" ]
            # [ inline ( always ) ]
            pub fn tdcoff(&self) -> TdcoffR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TdcoffR { bits }
            }
            # [ doc = "Bit 14 - Transceiver Delay Compensation Fail" ]
            # [ inline ( always ) ]
            pub fn tdcfail(&self) -> TdcfailR {
                TdcfailR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Transceiver Delay Compensation Enable" ]
            # [ inline ( always ) ]
            pub fn tdcen(&self) -> TdcenR {
                TdcenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 16:17 - Message Buffer Data Size for Region 0" ]
            # [ inline ( always ) ]
            pub fn mbdsr0(&self) -> Mbdsr0R {
                Mbdsr0R::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - Bit Rate Switch Enable" ]
            # [ inline ( always ) ]
            pub fn fdrate(&self) -> FdrateR {
                FdrateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483904 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 8:12 - Transceiver Delay Compensation Offset" ]
            # [ inline ( always ) ]
            pub fn tdcoff(&mut self) -> _TdcoffW {
                _TdcoffW { w: self }
            }
            # [ doc = "Bit 14 - Transceiver Delay Compensation Fail" ]
            # [ inline ( always ) ]
            pub fn tdcfail(&mut self) -> _TdcfailW {
                _TdcfailW { w: self }
            }
            # [ doc = "Bit 15 - Transceiver Delay Compensation Enable" ]
            # [ inline ( always ) ]
            pub fn tdcen(&mut self) -> _TdcenW {
                _TdcenW { w: self }
            }
            # [ doc = "Bits 16:17 - Message Buffer Data Size for Region 0" ]
            # [ inline ( always ) ]
            pub fn mbdsr0(&mut self) -> _Mbdsr0W {
                _Mbdsr0W { w: self }
            }
            # [ doc = "Bit 31 - Bit Rate Switch Enable" ]
            # [ inline ( always ) ]
            pub fn fdrate(&mut self) -> _FdrateW {
                _FdrateW { w: self }
            }
        }
    }
    # [ doc = "CAN FD Bit Timing Register" ]
    pub struct Fdcbt {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD Bit Timing Register" ]
    pub mod fdcbt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fdcbt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Fpseg2R {
            bits: u8,
        }
        impl Fpseg2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Fpseg1R {
            bits: u8,
        }
        impl Fpseg1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FpropsegR {
            bits: u8,
        }
        impl FpropsegR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FrjwR {
            bits: u8,
        }
        impl FrjwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FpresdivR {
            bits: u16,
        }
        impl FpresdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fpseg2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fpseg2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fpseg1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fpseg1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpropsegW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpropsegW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrjwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrjwW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FpresdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FpresdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Fast Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn fpseg2(&self) -> Fpseg2R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Fpseg2R { bits }
            }
            # [ doc = "Bits 5:7 - Fast Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn fpseg1(&self) -> Fpseg1R {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Fpseg1R { bits }
            }
            # [ doc = "Bits 10:14 - Fast Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn fpropseg(&self) -> FpropsegR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FpropsegR { bits }
            }
            # [ doc = "Bits 16:18 - Fast Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn frjw(&self) -> FrjwR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FrjwR { bits }
            }
            # [ doc = "Bits 20:29 - Fast Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn fpresdiv(&self) -> FpresdivR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FpresdivR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Fast Phase Segment 2" ]
            # [ inline ( always ) ]
            pub fn fpseg2(&mut self) -> _Fpseg2W {
                _Fpseg2W { w: self }
            }
            # [ doc = "Bits 5:7 - Fast Phase Segment 1" ]
            # [ inline ( always ) ]
            pub fn fpseg1(&mut self) -> _Fpseg1W {
                _Fpseg1W { w: self }
            }
            # [ doc = "Bits 10:14 - Fast Propagation Segment" ]
            # [ inline ( always ) ]
            pub fn fpropseg(&mut self) -> _FpropsegW {
                _FpropsegW { w: self }
            }
            # [ doc = "Bits 16:18 - Fast Resync Jump Width" ]
            # [ inline ( always ) ]
            pub fn frjw(&mut self) -> _FrjwW {
                _FrjwW { w: self }
            }
            # [ doc = "Bits 20:29 - Fast Prescaler Division Factor" ]
            # [ inline ( always ) ]
            pub fn fpresdiv(&mut self) -> _FpresdivW {
                _FpresdivW { w: self }
            }
        }
    }
    # [ doc = "CAN FD CRC Register" ]
    pub struct Fdcrc {
        register: VolatileCell<u32>,
    }
    # [ doc = "CAN FD CRC Register" ]
    pub mod fdcrc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Fdcrc {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FdTxcrcR {
            bits: u32,
        }
        impl FdTxcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FdMbcrcR {
            bits: u8,
        }
        impl FdMbcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:20 - Extended Transmitted CRC value" ]
            # [ inline ( always ) ]
            pub fn fd_txcrc(&self) -> FdTxcrcR {
                let bits = {
                    const MASK: u32 = 2097151;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                FdTxcrcR { bits }
            }
            # [ doc = "Bits 24:30 - CRC Mailbox Number for FD_TXCRC" ]
            # [ inline ( always ) ]
            pub fn fd_mbcrc(&self) -> FdMbcrcR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FdMbcrcR { bits }
            }
        }
    }
}
# [ doc = "Flex Controller Area Network module" ]
pub struct Can2 {
    register_block: can2::RegisterBlock,
}
impl Deref for Can2 {
    type Target = can2::RegisterBlock;
    fn deref(&self) -> &can2::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "FlexTimer Module" ]
pub const FTM0: Peripheral<Ftm0> = unsafe { Peripheral::new(1073971200) };
# [ doc = "FlexTimer Module" ]
pub mod ftm0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Status And Control" ]
        pub sc: Sc,
        # [ doc = "0x04 - Counter" ]
        pub cnt: Cnt,
        # [ doc = "0x08 - Modulo" ]
        pub mod_: Mod,
        # [ doc = "0x0c - Channel (n) Status And Control" ]
        pub c0sc: C0sc,
        # [ doc = "0x10 - Channel (n) Value" ]
        pub c0v: C0v,
        # [ doc = "0x14 - Channel (n) Status And Control" ]
        pub c1sc: C1sc,
        # [ doc = "0x18 - Channel (n) Value" ]
        pub c1v: C1v,
        # [ doc = "0x1c - Channel (n) Status And Control" ]
        pub c2sc: C2sc,
        # [ doc = "0x20 - Channel (n) Value" ]
        pub c2v: C2v,
        # [ doc = "0x24 - Channel (n) Status And Control" ]
        pub c3sc: C3sc,
        # [ doc = "0x28 - Channel (n) Value" ]
        pub c3v: C3v,
        # [ doc = "0x2c - Channel (n) Status And Control" ]
        pub c4sc: C4sc,
        # [ doc = "0x30 - Channel (n) Value" ]
        pub c4v: C4v,
        # [ doc = "0x34 - Channel (n) Status And Control" ]
        pub c5sc: C5sc,
        # [ doc = "0x38 - Channel (n) Value" ]
        pub c5v: C5v,
        # [ doc = "0x3c - Channel (n) Status And Control" ]
        pub c6sc: C6sc,
        # [ doc = "0x40 - Channel (n) Value" ]
        pub c6v: C6v,
        # [ doc = "0x44 - Channel (n) Status And Control" ]
        pub c7sc: C7sc,
        # [ doc = "0x48 - Channel (n) Value" ]
        pub c7v: C7v,
        # [ doc = "0x4c - Counter Initial Value" ]
        pub cntin: Cntin,
        # [ doc = "0x50 - Capture And Compare Status" ]
        pub status: Status,
        # [ doc = "0x54 - Features Mode Selection" ]
        pub mode: Mode,
        # [ doc = "0x58 - Synchronization" ]
        pub sync: Sync,
        # [ doc = "0x5c - Initial State For Channels Output" ]
        pub outinit: Outinit,
        # [ doc = "0x60 - Output Mask" ]
        pub outmask: Outmask,
        # [ doc = "0x64 - Function For Linked Channels" ]
        pub combine: Combine,
        # [ doc = "0x68 - Deadtime Configuration" ]
        pub deadtime: Deadtime,
        # [ doc = "0x6c - FTM External Trigger" ]
        pub exttrig: Exttrig,
        # [ doc = "0x70 - Channels Polarity" ]
        pub pol: Pol,
        # [ doc = "0x74 - Fault Mode Status" ]
        pub fms: Fms,
        # [ doc = "0x78 - Input Capture Filter Control" ]
        pub filter: Filter,
        # [ doc = "0x7c - Fault Control" ]
        pub fltctrl: Fltctrl,
        # [ doc = "0x80 - Quadrature Decoder Control And Status" ]
        pub qdctrl: Qdctrl,
        # [ doc = "0x84 - Configuration" ]
        pub conf: Conf,
        # [ doc = "0x88 - FTM Fault Input Polarity" ]
        pub fltpol: Fltpol,
        # [ doc = "0x8c - Synchronization Configuration" ]
        pub synconf: Synconf,
        # [ doc = "0x90 - FTM Inverting Control" ]
        pub invctrl: Invctrl,
        # [ doc = "0x94 - FTM Software Output Control" ]
        pub swoctrl: Swoctrl,
        # [ doc = "0x98 - FTM PWM Load" ]
        pub pwmload: Pwmload,
        # [ doc = "0x9c - Half Cycle Register" ]
        pub hcr: Hcr,
        # [ doc = "0xa0 - Pair 0 Deadtime Configuration" ]
        pub pair0deadtime: Pair0deadtime,
        _reserved0: [u8; 4usize],
        # [ doc = "0xa8 - Pair 1 Deadtime Configuration" ]
        pub pair1deadtime: Pair1deadtime,
        _reserved1: [u8; 4usize],
        # [ doc = "0xb0 - Pair 2 Deadtime Configuration" ]
        pub pair2deadtime: Pair2deadtime,
        _reserved2: [u8; 4usize],
        # [ doc = "0xb8 - Pair 3 Deadtime Configuration" ]
        pub pair3deadtime: Pair3deadtime,
    }
    # [ doc = "Status And Control" ]
    pub struct Sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status And Control" ]
    pub mod sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_000 => 0,
                    PsR::_001 => 1,
                    PsR::_010 => 2,
                    PsR::_011 => 3,
                    PsR::_100 => 4,
                    PsR::_101 => 5,
                    PsR::_110 => 6,
                    PsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_000,
                    1 => PsR::_001,
                    2 => PsR::_010,
                    3 => PsR::_011,
                    4 => PsR::_100,
                    5 => PsR::_101,
                    6 => PsR::_110,
                    7 => PsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PsR::_111
            }
        }
        # [ doc = "Possible values of the field `CLKS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksR {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksR::_00 => 0,
                    ClksR::_01 => 1,
                    ClksR::_10 => 2,
                    ClksR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksR {
                match bits {
                    0 => ClksR::_00,
                    1 => ClksR::_01,
                    2 => ClksR::_10,
                    3 => ClksR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ClksR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ClksR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ClksR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ClksR::_11
            }
        }
        # [ doc = "Possible values of the field `CPWMS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpwmsR {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpwmsR::_0 => 0,
                    CpwmsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpwmsR {
                match bits {
                    0 => CpwmsR::_0,
                    1 => CpwmsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpwmsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpwmsR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `RF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfR {
            # [ doc = "A selected reload point did not happen." ]
            _0,
            # [ doc = "A selected reload point happened." ]
            _1,
        }
        impl RfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfR::_0 => 0,
                    RfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfR {
                match bits {
                    0 => RfR::_0,
                    1 => RfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfR::_1
            }
        }
        # [ doc = "Possible values of the field `TOIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ToieR {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ToieR::_0 => 0,
                    ToieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ToieR {
                match bits {
                    0 => ToieR::_0,
                    1 => ToieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ToieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ToieR::_1
            }
        }
        # [ doc = "Possible values of the field `TOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofR {
            # [ doc = "FTM counter has not overflowed." ]
            _0,
            # [ doc = "FTM counter has overflowed." ]
            _1,
        }
        impl TofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofR::_0 => 0,
                    TofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofR {
                match bits {
                    0 => TofR::_0,
                    1 => TofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen0R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen0R::_0 => 0,
                    Pwmen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen0R {
                match bits {
                    0 => Pwmen0R::_0,
                    1 => Pwmen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen0R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen1R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen1R::_0 => 0,
                    Pwmen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen1R {
                match bits {
                    0 => Pwmen1R::_0,
                    1 => Pwmen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen1R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen2R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen2R::_0 => 0,
                    Pwmen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen2R {
                match bits {
                    0 => Pwmen2R::_0,
                    1 => Pwmen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen2R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen3R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen3R::_0 => 0,
                    Pwmen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen3R {
                match bits {
                    0 => Pwmen3R::_0,
                    1 => Pwmen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen3R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen4R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen4R::_0 => 0,
                    Pwmen4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen4R {
                match bits {
                    0 => Pwmen4R::_0,
                    1 => Pwmen4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen4R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen5R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen5R::_0 => 0,
                    Pwmen5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen5R {
                match bits {
                    0 => Pwmen5R::_0,
                    1 => Pwmen5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen5R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen6R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen6R::_0 => 0,
                    Pwmen6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen6R {
                match bits {
                    0 => Pwmen6R::_0,
                    1 => Pwmen6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen6R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen7R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen7R::_0 => 0,
                    Pwmen7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen7R {
                match bits {
                    0 => Pwmen7R::_0,
                    1 => Pwmen7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen7R::_1
            }
        }
        # [ doc = "Possible values of the field `FLTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltpsR {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltpsR::_0000 => 0,
                    FltpsR::_0001 => 1,
                    FltpsR::_0010 => 2,
                    FltpsR::_0011 => 3,
                    FltpsR::_0100 => 4,
                    FltpsR::_0101 => 5,
                    FltpsR::_0110 => 6,
                    FltpsR::_0111 => 7,
                    FltpsR::_1000 => 8,
                    FltpsR::_1001 => 9,
                    FltpsR::_1010 => 10,
                    FltpsR::_1011 => 11,
                    FltpsR::_1100 => 12,
                    FltpsR::_1101 => 13,
                    FltpsR::_1110 => 14,
                    FltpsR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltpsR {
                match bits {
                    0 => FltpsR::_0000,
                    1 => FltpsR::_0001,
                    2 => FltpsR::_0010,
                    3 => FltpsR::_0011,
                    4 => FltpsR::_0100,
                    5 => FltpsR::_0101,
                    6 => FltpsR::_0110,
                    7 => FltpsR::_0111,
                    8 => FltpsR::_1000,
                    9 => FltpsR::_1001,
                    10 => FltpsR::_1010,
                    11 => FltpsR::_1011,
                    12 => FltpsR::_1100,
                    13 => FltpsR::_1101,
                    14 => FltpsR::_1110,
                    15 => FltpsR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == FltpsR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == FltpsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == FltpsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == FltpsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == FltpsR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == FltpsR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == FltpsR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == FltpsR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == FltpsR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == FltpsR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == FltpsR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == FltpsR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == FltpsR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == FltpsR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == FltpsR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == FltpsR::_1111
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_000 => 0,
                    PsW::_001 => 1,
                    PsW::_010 => 2,
                    PsW::_011 => 3,
                    PsW::_100 => 4,
                    PsW::_101 => 5,
                    PsW::_110 => 6,
                    PsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PsW::_000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PsW::_001)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PsW::_010)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PsW::_011)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PsW::_100)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PsW::_101)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PsW::_110)
            }
            # [ doc = "Divide by 128" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKS`" ]
        pub enum ClksW {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksW::_00 => 0,
                    ClksW::_01 => 1,
                    ClksW::_10 => 2,
                    ClksW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ClksW::_00)
            }
            # [ doc = "FTM input clock" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ClksW::_01)
            }
            # [ doc = "Fixed frequency clock" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ClksW::_10)
            }
            # [ doc = "External clock" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ClksW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPWMS`" ]
        pub enum CpwmsW {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpwmsW::_0 => 0,
                    CpwmsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpwmsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpwmsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpwmsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter operates in Up Counting mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpwmsW::_0)
            }
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpwmsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reload point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Reload point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOIE`" ]
        pub enum ToieW {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ToieW::_0 => 0,
                    ToieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ToieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ToieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ToieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ToieW::_0)
            }
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ToieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN0`" ]
        pub enum Pwmen0W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen0W::_0 => 0,
                    Pwmen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen0W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN1`" ]
        pub enum Pwmen1W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen1W::_0 => 0,
                    Pwmen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen1W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN2`" ]
        pub enum Pwmen2W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen2W::_0 => 0,
                    Pwmen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen2W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN3`" ]
        pub enum Pwmen3W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen3W::_0 => 0,
                    Pwmen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen3W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN4`" ]
        pub enum Pwmen4W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen4W::_0 => 0,
                    Pwmen4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen4W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN5`" ]
        pub enum Pwmen5W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen5W::_0 => 0,
                    Pwmen5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen5W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN6`" ]
        pub enum Pwmen6W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen6W::_0 => 0,
                    Pwmen6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen6W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN7`" ]
        pub enum Pwmen7W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen7W::_0 => 0,
                    Pwmen7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen7W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLTPS`" ]
        pub enum FltpsW {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltpsW::_0000 => 0,
                    FltpsW::_0001 => 1,
                    FltpsW::_0010 => 2,
                    FltpsW::_0011 => 3,
                    FltpsW::_0100 => 4,
                    FltpsW::_0101 => 5,
                    FltpsW::_0110 => 6,
                    FltpsW::_0111 => 7,
                    FltpsW::_1000 => 8,
                    FltpsW::_1001 => 9,
                    FltpsW::_1010 => 10,
                    FltpsW::_1011 => 11,
                    FltpsW::_1100 => 12,
                    FltpsW::_1101 => 13,
                    FltpsW::_1110 => 14,
                    FltpsW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltpsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(FltpsW::_0000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(FltpsW::_0001)
            }
            # [ doc = "Divide by 3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(FltpsW::_0010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(FltpsW::_0011)
            }
            # [ doc = "Divide by 5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(FltpsW::_0100)
            }
            # [ doc = "Divide by 6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(FltpsW::_0101)
            }
            # [ doc = "Divide by 7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(FltpsW::_0110)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(FltpsW::_0111)
            }
            # [ doc = "Divide by 9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(FltpsW::_1000)
            }
            # [ doc = "Divide by 10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(FltpsW::_1001)
            }
            # [ doc = "Divide by 11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(FltpsW::_1010)
            }
            # [ doc = "Divide by 12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(FltpsW::_1011)
            }
            # [ doc = "Divide by 13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(FltpsW::_1100)
            }
            # [ doc = "Divide by 14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(FltpsW::_1101)
            }
            # [ doc = "Divide by 15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(FltpsW::_1110)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(FltpsW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&self) -> ClksR {
                ClksR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&self) -> CpwmsR {
                CpwmsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Reload Flag" ]
            # [ inline ( always ) ]
            pub fn rf(&self) -> RfR {
                RfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 7;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&self) -> ToieR {
                ToieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Timer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn tof(&self) -> TofR {
                TofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&self) -> Pwmen0R {
                Pwmen0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&self) -> Pwmen1R {
                Pwmen1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&self) -> Pwmen2R {
                Pwmen2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&self) -> Pwmen3R {
                Pwmen3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&self) -> Pwmen4R {
                Pwmen4R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&self) -> Pwmen5R {
                Pwmen5R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&self) -> Pwmen6R {
                Pwmen6R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&self) -> Pwmen7R {
                Pwmen7R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&self) -> FltpsR {
                FltpsR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&mut self) -> _ClksW {
                _ClksW { w: self }
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&mut self) -> _CpwmsW {
                _CpwmsW { w: self }
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&mut self) -> _ToieW {
                _ToieW { w: self }
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&mut self) -> _Pwmen0W {
                _Pwmen0W { w: self }
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&mut self) -> _Pwmen1W {
                _Pwmen1W { w: self }
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&mut self) -> _Pwmen2W {
                _Pwmen2W { w: self }
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&mut self) -> _Pwmen3W {
                _Pwmen3W { w: self }
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&mut self) -> _Pwmen4W {
                _Pwmen4W { w: self }
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&mut self) -> _Pwmen5W {
                _Pwmen5W { w: self }
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&mut self) -> _Pwmen6W {
                _Pwmen6W { w: self }
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&mut self) -> _Pwmen7W {
                _Pwmen7W { w: self }
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&mut self) -> _FltpsW {
                _FltpsW { w: self }
            }
        }
    }
    # [ doc = "Counter" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CountR {
            bits: u16,
        }
        impl CountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CountW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CountW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&self) -> CountR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&mut self) -> _CountW {
                _CountW { w: self }
            }
        }
    }
    # [ doc = "Modulo" ]
    pub struct Mod {
        register: VolatileCell<u32>,
    }
    # [ doc = "Modulo" ]
    pub mod mod_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mod {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ModR {
            bits: u16,
        }
        impl ModR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&self) -> ModR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ModR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&mut self) -> _ModW {
                _ModW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C0sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c0sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C0v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c0v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C1sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c1sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C1v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c1v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C2sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c2sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C2v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c2v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C3sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c3sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C3v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c3v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C4sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c4sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C4v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c4v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C5sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c5sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C5v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c5v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C6sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c6sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C6v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c6v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C7sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c7sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C7v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c7v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Counter Initial Value" ]
    pub struct Cntin {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter Initial Value" ]
    pub mod cntin {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cntin {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct InitR {
            bits: u16,
        }
        impl InitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&self) -> InitR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                InitR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
        }
    }
    # [ doc = "Capture And Compare Status" ]
    pub struct Status {
        register: VolatileCell<u32>,
    }
    # [ doc = "Capture And Compare Status" ]
    pub mod status {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Status {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `CH0F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch0fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0fR::_0 => 0,
                    Ch0fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0fR {
                match bits {
                    0 => Ch0fR::_0,
                    1 => Ch0fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1fR::_0 => 0,
                    Ch1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1fR {
                match bits {
                    0 => Ch1fR::_0,
                    1 => Ch1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2fR::_0 => 0,
                    Ch2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2fR {
                match bits {
                    0 => Ch2fR::_0,
                    1 => Ch2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch3fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3fR::_0 => 0,
                    Ch3fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3fR {
                match bits {
                    0 => Ch3fR::_0,
                    1 => Ch3fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch4fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4fR::_0 => 0,
                    Ch4fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4fR {
                match bits {
                    0 => Ch4fR::_0,
                    1 => Ch4fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch5fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5fR::_0 => 0,
                    Ch5fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5fR {
                match bits {
                    0 => Ch5fR::_0,
                    1 => Ch5fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch6fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6fR::_0 => 0,
                    Ch6fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6fR {
                match bits {
                    0 => Ch6fR::_0,
                    1 => Ch6fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch7fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7fR::_0 => 0,
                    Ch7fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7fR {
                match bits {
                    0 => Ch7fR::_0,
                    1 => Ch7fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7fR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Flag" ]
            # [ inline ( always ) ]
            pub fn ch0f(&self) -> Ch0fR {
                Ch0fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ch1f(&self) -> Ch1fR {
                Ch1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ch2f(&self) -> Ch2fR {
                Ch2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Flag" ]
            # [ inline ( always ) ]
            pub fn ch3f(&self) -> Ch3fR {
                Ch3fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Flag" ]
            # [ inline ( always ) ]
            pub fn ch4f(&self) -> Ch4fR {
                Ch4fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Flag" ]
            # [ inline ( always ) ]
            pub fn ch5f(&self) -> Ch5fR {
                Ch5fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Flag" ]
            # [ inline ( always ) ]
            pub fn ch6f(&self) -> Ch6fR {
                Ch6fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Flag" ]
            # [ inline ( always ) ]
            pub fn ch7f(&self) -> Ch7fR {
                Ch7fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
    }
    # [ doc = "Features Mode Selection" ]
    pub struct Mode {
        register: VolatileCell<u32>,
    }
    # [ doc = "Features Mode Selection" ]
    pub mod mode {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mode {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FTMEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FtmenR {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FtmenR::_0 => 0,
                    FtmenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FtmenR {
                match bits {
                    0 => FtmenR::_0,
                    1 => FtmenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FtmenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FtmenR::_1
            }
        }
        # [ doc = "Possible values of the field `WPDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpdisR {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpdisR::_0 => 0,
                    WpdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpdisR {
                match bits {
                    0 => WpdisR::_0,
                    1 => WpdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpdisR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PwmsyncR {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PwmsyncR::_0 => 0,
                    PwmsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PwmsyncR {
                match bits {
                    0 => PwmsyncR::_0,
                    1 => PwmsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PwmsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PwmsyncR::_1
            }
        }
        # [ doc = "Possible values of the field `CAPTEST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CaptestR {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CaptestR::_0 => 0,
                    CaptestR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CaptestR {
                match bits {
                    0 => CaptestR::_0,
                    1 => CaptestR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CaptestR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CaptestR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultmR {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultmR::_00 => 0,
                    FaultmR::_01 => 1,
                    FaultmR::_10 => 2,
                    FaultmR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultmR {
                match bits {
                    0 => FaultmR::_00,
                    1 => FaultmR::_01,
                    2 => FaultmR::_10,
                    3 => FaultmR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FaultmR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FaultmR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FaultmR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FaultmR::_11
            }
        }
        # [ doc = "Possible values of the field `FAULTIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultieR {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultieR::_0 => 0,
                    FaultieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultieR {
                match bits {
                    0 => FaultieR::_0,
                    1 => FaultieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FTMEN`" ]
        pub enum FtmenW {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FtmenW::_0 => 0,
                    FtmenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FtmenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FtmenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FtmenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FtmenW::_0)
            }
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FtmenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WPDIS`" ]
        pub enum WpdisW {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpdisW::_0 => 0,
                    WpdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpdisW::_0)
            }
            # [ doc = "Write protection is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMSYNC`" ]
        pub enum PwmsyncW {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PwmsyncW::_0 => 0,
                    PwmsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PwmsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PwmsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PwmsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PwmsyncW::_0)
            }
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PwmsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CAPTEST`" ]
        pub enum CaptestW {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CaptestW::_0 => 0,
                    CaptestW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaptestW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaptestW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CaptestW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Capture test mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CaptestW::_0)
            }
            # [ doc = "Capture test mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CaptestW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTM`" ]
        pub enum FaultmW {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultmW::_00 => 0,
                    FaultmW::_01 => 1,
                    FaultmW::_10 => 2,
                    FaultmW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control is disabled for all channels." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FaultmW::_00)
            }
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FaultmW::_01)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FaultmW::_10)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FaultmW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTIE`" ]
        pub enum FaultieW {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultieW::_0 => 0,
                    FaultieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FaultieW::_0)
            }
            # [ doc = "Fault control interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FaultieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&self) -> FtmenR {
                FtmenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&self) -> WpdisR {
                WpdisR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&self) -> PwmsyncR {
                PwmsyncR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&self) -> CaptestR {
                CaptestR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&self) -> FaultmR {
                FaultmR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&self) -> FaultieR {
                FaultieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 7;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&mut self) -> _FtmenW {
                _FtmenW { w: self }
            }
            # [ doc = "Bit 1 - Initialize The Channels Output" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&mut self) -> _WpdisW {
                _WpdisW { w: self }
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&mut self) -> _PwmsyncW {
                _PwmsyncW { w: self }
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&mut self) -> _CaptestW {
                _CaptestW { w: self }
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&mut self) -> _FaultmW {
                _FaultmW { w: self }
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&mut self) -> _FaultieW {
                _FaultieW { w: self }
            }
        }
    }
    # [ doc = "Synchronization" ]
    pub struct Sync {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization" ]
    pub mod sync {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sync {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CNTMIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntminR {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntminR::_0 => 0,
                    CntminR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntminR {
                match bits {
                    0 => CntminR::_0,
                    1 => CntminR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntminR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntminR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTMAX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntmaxR {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntmaxR::_0 => 0,
                    CntmaxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntmaxR {
                match bits {
                    0 => CntmaxR::_0,
                    1 => CntmaxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntmaxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntmaxR::_1
            }
        }
        # [ doc = "Possible values of the field `REINIT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReinitR {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReinitR::_0 => 0,
                    ReinitR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReinitR {
                match bits {
                    0 => ReinitR::_0,
                    1 => ReinitR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReinitR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReinitR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCHOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchomR {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchomR::_0 => 0,
                    SynchomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchomR {
                match bits {
                    0 => SynchomR::_0,
                    1 => SynchomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchomR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig0R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig0R::_0 => 0,
                    Trig0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig0R {
                match bits {
                    0 => Trig0R::_0,
                    1 => Trig0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig0R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig1R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig1R::_0 => 0,
                    Trig1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig1R {
                match bits {
                    0 => Trig1R::_0,
                    1 => Trig1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig1R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig2R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig2R::_0 => 0,
                    Trig2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig2R {
                match bits {
                    0 => Trig2R::_0,
                    1 => Trig2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig2R::_1
            }
        }
        # [ doc = "Possible values of the field `SWSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsyncR {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsyncR::_0 => 0,
                    SwsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsyncR {
                match bits {
                    0 => SwsyncR::_0,
                    1 => SwsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsyncR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CNTMIN`" ]
        pub enum CntminW {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntminW::_0 => 0,
                    CntminW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntminW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntminW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntminW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minimum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntminW::_0)
            }
            # [ doc = "The minimum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntminW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTMAX`" ]
        pub enum CntmaxW {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntmaxW::_0 => 0,
                    CntmaxW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntmaxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntmaxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntmaxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The maximum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntmaxW::_0)
            }
            # [ doc = "The maximum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntmaxW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REINIT`" ]
        pub enum ReinitW {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReinitW::_0 => 0,
                    ReinitW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReinitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReinitW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReinitW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter continues to count normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReinitW::_0)
            }
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReinitW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCHOM`" ]
        pub enum SynchomW {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SynchomW::_0 => 0,
                    SynchomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SynchomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SynchomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SynchomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SynchomW::_0)
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SynchomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG0`" ]
        pub enum Trig0W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig0W::_0 => 0,
                    Trig0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig0W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG1`" ]
        pub enum Trig1W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig1W::_0 => 0,
                    Trig1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig1W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG2`" ]
        pub enum Trig2W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig2W::_0 => 0,
                    Trig2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig2W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSYNC`" ]
        pub enum SwsyncW {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsyncW::_0 => 0,
                    SwsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software trigger is not selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsyncW::_0)
            }
            # [ doc = "Software trigger is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&self) -> CntminR {
                CntminR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&self) -> CntmaxR {
                CntmaxR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&self) -> ReinitR {
                ReinitR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&self) -> SynchomR {
                SynchomR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&self) -> Trig0R {
                Trig0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&self) -> Trig1R {
                Trig1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&self) -> Trig2R {
                Trig2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&self) -> SwsyncR {
                SwsyncR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&mut self) -> _CntminW {
                _CntminW { w: self }
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&mut self) -> _CntmaxW {
                _CntmaxW { w: self }
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&mut self) -> _ReinitW {
                _ReinitW { w: self }
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&mut self) -> _SynchomW {
                _SynchomW { w: self }
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&mut self) -> _Trig0W {
                _Trig0W { w: self }
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&mut self) -> _Trig1W {
                _Trig1W { w: self }
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&mut self) -> _Trig2W {
                _Trig2W { w: self }
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&mut self) -> _SwsyncW {
                _SwsyncW { w: self }
            }
        }
    }
    # [ doc = "Initial State For Channels Output" ]
    pub struct Outinit {
        register: VolatileCell<u32>,
    }
    # [ doc = "Initial State For Channels Output" ]
    pub mod outinit {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outinit {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0oiR::_0 => 0,
                    Ch0oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0oiR {
                match bits {
                    0 => Ch0oiR::_0,
                    1 => Ch0oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1oiR::_0 => 0,
                    Ch1oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1oiR {
                match bits {
                    0 => Ch1oiR::_0,
                    1 => Ch1oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2oiR::_0 => 0,
                    Ch2oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2oiR {
                match bits {
                    0 => Ch2oiR::_0,
                    1 => Ch2oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3oiR::_0 => 0,
                    Ch3oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3oiR {
                match bits {
                    0 => Ch3oiR::_0,
                    1 => Ch3oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4oiR::_0 => 0,
                    Ch4oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4oiR {
                match bits {
                    0 => Ch4oiR::_0,
                    1 => Ch4oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5oiR::_0 => 0,
                    Ch5oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5oiR {
                match bits {
                    0 => Ch5oiR::_0,
                    1 => Ch5oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6oiR::_0 => 0,
                    Ch6oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6oiR {
                match bits {
                    0 => Ch6oiR::_0,
                    1 => Ch6oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7oiR::_0 => 0,
                    Ch7oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7oiR {
                match bits {
                    0 => Ch7oiR::_0,
                    1 => Ch7oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7oiR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OI`" ]
        pub enum Ch0oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0oiW::_0 => 0,
                    Ch0oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OI`" ]
        pub enum Ch1oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1oiW::_0 => 0,
                    Ch1oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OI`" ]
        pub enum Ch2oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2oiW::_0 => 0,
                    Ch2oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OI`" ]
        pub enum Ch3oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3oiW::_0 => 0,
                    Ch3oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OI`" ]
        pub enum Ch4oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4oiW::_0 => 0,
                    Ch4oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OI`" ]
        pub enum Ch5oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5oiW::_0 => 0,
                    Ch5oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OI`" ]
        pub enum Ch6oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6oiW::_0 => 0,
                    Ch6oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OI`" ]
        pub enum Ch7oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7oiW::_0 => 0,
                    Ch7oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&self) -> Ch0oiR {
                Ch0oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&self) -> Ch1oiR {
                Ch1oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&self) -> Ch2oiR {
                Ch2oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&self) -> Ch3oiR {
                Ch3oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&self) -> Ch4oiR {
                Ch4oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&self) -> Ch5oiR {
                Ch5oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&self) -> Ch6oiR {
                Ch6oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&self) -> Ch7oiR {
                Ch7oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&mut self) -> _Ch0oiW {
                _Ch0oiW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&mut self) -> _Ch1oiW {
                _Ch1oiW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&mut self) -> _Ch2oiW {
                _Ch2oiW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&mut self) -> _Ch3oiW {
                _Ch3oiW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&mut self) -> _Ch4oiW {
                _Ch4oiW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&mut self) -> _Ch5oiW {
                _Ch5oiW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&mut self) -> _Ch6oiW {
                _Ch6oiW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&mut self) -> _Ch7oiW {
                _Ch7oiW { w: self }
            }
        }
    }
    # [ doc = "Output Mask" ]
    pub struct Outmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Output Mask" ]
    pub mod outmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0omR::_0 => 0,
                    Ch0omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0omR {
                match bits {
                    0 => Ch0omR::_0,
                    1 => Ch0omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1omR::_0 => 0,
                    Ch1omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1omR {
                match bits {
                    0 => Ch1omR::_0,
                    1 => Ch1omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2omR::_0 => 0,
                    Ch2omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2omR {
                match bits {
                    0 => Ch2omR::_0,
                    1 => Ch2omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3omR::_0 => 0,
                    Ch3omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3omR {
                match bits {
                    0 => Ch3omR::_0,
                    1 => Ch3omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4omR::_0 => 0,
                    Ch4omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4omR {
                match bits {
                    0 => Ch4omR::_0,
                    1 => Ch4omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5omR::_0 => 0,
                    Ch5omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5omR {
                match bits {
                    0 => Ch5omR::_0,
                    1 => Ch5omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6omR::_0 => 0,
                    Ch6omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6omR {
                match bits {
                    0 => Ch6omR::_0,
                    1 => Ch6omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7omR::_0 => 0,
                    Ch7omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7omR {
                match bits {
                    0 => Ch7omR::_0,
                    1 => Ch7omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7omR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OM`" ]
        pub enum Ch0omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0omW::_0 => 0,
                    Ch0omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OM`" ]
        pub enum Ch1omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1omW::_0 => 0,
                    Ch1omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OM`" ]
        pub enum Ch2omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2omW::_0 => 0,
                    Ch2omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OM`" ]
        pub enum Ch3omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3omW::_0 => 0,
                    Ch3omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OM`" ]
        pub enum Ch4omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4omW::_0 => 0,
                    Ch4omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OM`" ]
        pub enum Ch5omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5omW::_0 => 0,
                    Ch5omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OM`" ]
        pub enum Ch6omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6omW::_0 => 0,
                    Ch6omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OM`" ]
        pub enum Ch7omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7omW::_0 => 0,
                    Ch7omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&self) -> Ch0omR {
                Ch0omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&self) -> Ch1omR {
                Ch1omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&self) -> Ch2omR {
                Ch2omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&self) -> Ch3omR {
                Ch3omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&self) -> Ch4omR {
                Ch4omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&self) -> Ch5omR {
                Ch5omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&self) -> Ch6omR {
                Ch6omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&self) -> Ch7omR {
                Ch7omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&mut self) -> _Ch0omW {
                _Ch0omW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&mut self) -> _Ch1omW {
                _Ch1omW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&mut self) -> _Ch2omW {
                _Ch2omW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&mut self) -> _Ch3omW {
                _Ch3omW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&mut self) -> _Ch4omW {
                _Ch4omW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&mut self) -> _Ch5omW {
                _Ch5omW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&mut self) -> _Ch6omW {
                _Ch6omW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&mut self) -> _Ch7omW {
                _Ch7omW { w: self }
            }
        }
    }
    # [ doc = "Function For Linked Channels" ]
    pub struct Combine {
        register: VolatileCell<u32>,
    }
    # [ doc = "Function For Linked Channels" ]
    pub mod combine {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Combine {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine0R {
            bits: u8,
        }
        impl Combine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp0R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp0R::_0 => 0,
                    Comp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp0R {
                match bits {
                    0 => Comp0R::_0,
                    1 => Comp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen0R {
            bits: u8,
        }
        impl Decapen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap0R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap0R::_0 => 0,
                    Decap0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap0R {
                match bits {
                    0 => Decap0R::_0,
                    1 => Decap0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap0R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten0R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten0R::_0 => 0,
                    Dten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten0R {
                match bits {
                    0 => Dten0R::_0,
                    1 => Dten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten0R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen0R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen0R::_0 => 0,
                    Syncen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen0R {
                match bits {
                    0 => Syncen0R::_0,
                    1 => Syncen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten0R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten0R::_0 => 0,
                    Faulten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten0R {
                match bits {
                    0 => Faulten0R::_0,
                    1 => Faulten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine0R {
            bits: u8,
        }
        impl Mcombine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine1R {
            bits: u8,
        }
        impl Combine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp1R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp1R::_0 => 0,
                    Comp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp1R {
                match bits {
                    0 => Comp1R::_0,
                    1 => Comp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen1R {
            bits: u8,
        }
        impl Decapen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap1R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap1R::_0 => 0,
                    Decap1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap1R {
                match bits {
                    0 => Decap1R::_0,
                    1 => Decap1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap1R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten1R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten1R::_0 => 0,
                    Dten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten1R {
                match bits {
                    0 => Dten1R::_0,
                    1 => Dten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten1R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen1R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen1R::_0 => 0,
                    Syncen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen1R {
                match bits {
                    0 => Syncen1R::_0,
                    1 => Syncen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten1R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten1R::_0 => 0,
                    Faulten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten1R {
                match bits {
                    0 => Faulten1R::_0,
                    1 => Faulten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine1R {
            bits: u8,
        }
        impl Mcombine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine2R {
            bits: u8,
        }
        impl Combine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp2R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp2R::_0 => 0,
                    Comp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp2R {
                match bits {
                    0 => Comp2R::_0,
                    1 => Comp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen2R {
            bits: u8,
        }
        impl Decapen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap2R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap2R::_0 => 0,
                    Decap2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap2R {
                match bits {
                    0 => Decap2R::_0,
                    1 => Decap2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap2R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten2R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten2R::_0 => 0,
                    Dten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten2R {
                match bits {
                    0 => Dten2R::_0,
                    1 => Dten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten2R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen2R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen2R::_0 => 0,
                    Syncen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen2R {
                match bits {
                    0 => Syncen2R::_0,
                    1 => Syncen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten2R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten2R::_0 => 0,
                    Faulten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten2R {
                match bits {
                    0 => Faulten2R::_0,
                    1 => Faulten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine2R {
            bits: u8,
        }
        impl Mcombine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine3R {
            bits: u8,
        }
        impl Combine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp3R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp3R::_0 => 0,
                    Comp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp3R {
                match bits {
                    0 => Comp3R::_0,
                    1 => Comp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen3R {
            bits: u8,
        }
        impl Decapen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap3R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap3R::_0 => 0,
                    Decap3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap3R {
                match bits {
                    0 => Decap3R::_0,
                    1 => Decap3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap3R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten3R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten3R::_0 => 0,
                    Dten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten3R {
                match bits {
                    0 => Dten3R::_0,
                    1 => Dten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten3R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen3R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen3R::_0 => 0,
                    Syncen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen3R {
                match bits {
                    0 => Syncen3R::_0,
                    1 => Syncen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten3R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten3R::_0 => 0,
                    Faulten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten3R {
                match bits {
                    0 => Faulten3R::_0,
                    1 => Faulten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine3R {
            bits: u8,
        }
        impl Mcombine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP0`" ]
        pub enum Comp0W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp0W::_0 => 0,
                    Comp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp0W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP0`" ]
        pub enum Decap0W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap0W::_0 => 0,
                    Decap0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap0W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN0`" ]
        pub enum Dten0W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten0W::_0 => 0,
                    Dten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten0W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN0`" ]
        pub enum Syncen0W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen0W::_0 => 0,
                    Syncen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen0W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN0`" ]
        pub enum Faulten0W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten0W::_0 => 0,
                    Faulten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten0W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP1`" ]
        pub enum Comp1W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp1W::_0 => 0,
                    Comp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp1W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP1`" ]
        pub enum Decap1W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap1W::_0 => 0,
                    Decap1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap1W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN1`" ]
        pub enum Dten1W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten1W::_0 => 0,
                    Dten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten1W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN1`" ]
        pub enum Syncen1W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen1W::_0 => 0,
                    Syncen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen1W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN1`" ]
        pub enum Faulten1W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten1W::_0 => 0,
                    Faulten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten1W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP2`" ]
        pub enum Comp2W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp2W::_0 => 0,
                    Comp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp2W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP2`" ]
        pub enum Decap2W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap2W::_0 => 0,
                    Decap2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap2W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN2`" ]
        pub enum Dten2W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten2W::_0 => 0,
                    Dten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten2W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN2`" ]
        pub enum Syncen2W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen2W::_0 => 0,
                    Syncen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen2W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN2`" ]
        pub enum Faulten2W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten2W::_0 => 0,
                    Faulten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten2W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP3`" ]
        pub enum Comp3W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp3W::_0 => 0,
                    Comp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp3W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP3`" ]
        pub enum Decap3W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap3W::_0 => 0,
                    Decap3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap3W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN3`" ]
        pub enum Dten3W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten3W::_0 => 0,
                    Dten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten3W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN3`" ]
        pub enum Syncen3W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen3W::_0 => 0,
                    Syncen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen3W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN3`" ]
        pub enum Faulten3W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten3W::_0 => 0,
                    Faulten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten3W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&self) -> Combine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine0R { bits }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&self) -> Comp0R {
                Comp0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&self) -> Decapen0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen0R { bits }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&self) -> Decap0R {
                Decap0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&self) -> Dten0R {
                Dten0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&self) -> Syncen0R {
                Syncen0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&self) -> Faulten0R {
                Faulten0R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&self) -> Mcombine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine0R { bits }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&self) -> Combine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine1R { bits }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&self) -> Comp1R {
                Comp1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&self) -> Decapen1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen1R { bits }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&self) -> Decap1R {
                Decap1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&self) -> Dten1R {
                Dten1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&self) -> Syncen1R {
                Syncen1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&self) -> Faulten1R {
                Faulten1R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 14;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&self) -> Mcombine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine1R { bits }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&self) -> Combine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine2R { bits }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&self) -> Comp2R {
                Comp2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 17;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&self) -> Decapen2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen2R { bits }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&self) -> Decap2R {
                Decap2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&self) -> Dten2R {
                Dten2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&self) -> Syncen2R {
                Syncen2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 21;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&self) -> Faulten2R {
                Faulten2R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 22;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&self) -> Mcombine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine2R { bits }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&self) -> Combine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine3R { bits }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&self) -> Comp3R {
                Comp3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&self) -> Decapen3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen3R { bits }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&self) -> Decap3R {
                Decap3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&self) -> Dten3R {
                Dten3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&self) -> Syncen3R {
                Syncen3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 29;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&self) -> Faulten3R {
                Faulten3R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 30;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&self) -> Mcombine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine3R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&mut self) -> _Combine0W {
                _Combine0W { w: self }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&mut self) -> _Comp0W {
                _Comp0W { w: self }
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&mut self) -> _Decapen0W {
                _Decapen0W { w: self }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&mut self) -> _Decap0W {
                _Decap0W { w: self }
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&mut self) -> _Dten0W {
                _Dten0W { w: self }
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&mut self) -> _Syncen0W {
                _Syncen0W { w: self }
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&mut self) -> _Faulten0W {
                _Faulten0W { w: self }
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&mut self) -> _Mcombine0W {
                _Mcombine0W { w: self }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&mut self) -> _Combine1W {
                _Combine1W { w: self }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&mut self) -> _Comp1W {
                _Comp1W { w: self }
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&mut self) -> _Decapen1W {
                _Decapen1W { w: self }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&mut self) -> _Decap1W {
                _Decap1W { w: self }
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&mut self) -> _Dten1W {
                _Dten1W { w: self }
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&mut self) -> _Syncen1W {
                _Syncen1W { w: self }
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&mut self) -> _Faulten1W {
                _Faulten1W { w: self }
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&mut self) -> _Mcombine1W {
                _Mcombine1W { w: self }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&mut self) -> _Combine2W {
                _Combine2W { w: self }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&mut self) -> _Comp2W {
                _Comp2W { w: self }
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&mut self) -> _Decapen2W {
                _Decapen2W { w: self }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&mut self) -> _Decap2W {
                _Decap2W { w: self }
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&mut self) -> _Dten2W {
                _Dten2W { w: self }
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&mut self) -> _Syncen2W {
                _Syncen2W { w: self }
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&mut self) -> _Faulten2W {
                _Faulten2W { w: self }
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&mut self) -> _Mcombine2W {
                _Mcombine2W { w: self }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&mut self) -> _Combine3W {
                _Combine3W { w: self }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&mut self) -> _Comp3W {
                _Comp3W { w: self }
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&mut self) -> _Decapen3W {
                _Decapen3W { w: self }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&mut self) -> _Decap3W {
                _Decap3W { w: self }
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&mut self) -> _Dten3W {
                _Dten3W { w: self }
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&mut self) -> _Syncen3W {
                _Syncen3W { w: self }
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&mut self) -> _Faulten3W {
                _Faulten3W { w: self }
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&mut self) -> _Mcombine3W {
                _Mcombine3W { w: self }
            }
        }
    }
    # [ doc = "Deadtime Configuration" ]
    pub struct Deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Deadtime Configuration" ]
    pub mod deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "FTM External Trigger" ]
    pub struct Exttrig {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM External Trigger" ]
    pub mod exttrig {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Exttrig {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH2TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2trigR::_0 => 0,
                    Ch2trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2trigR {
                match bits {
                    0 => Ch2trigR::_0,
                    1 => Ch2trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3trigR::_0 => 0,
                    Ch3trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3trigR {
                match bits {
                    0 => Ch3trigR::_0,
                    1 => Ch3trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4trigR::_0 => 0,
                    Ch4trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4trigR {
                match bits {
                    0 => Ch4trigR::_0,
                    1 => Ch4trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5trigR::_0 => 0,
                    Ch5trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5trigR {
                match bits {
                    0 => Ch5trigR::_0,
                    1 => Ch5trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0trigR::_0 => 0,
                    Ch0trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0trigR {
                match bits {
                    0 => Ch0trigR::_0,
                    1 => Ch0trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1trigR::_0 => 0,
                    Ch1trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1trigR {
                match bits {
                    0 => Ch1trigR::_0,
                    1 => Ch1trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1trigR::_1
            }
        }
        # [ doc = "Possible values of the field `INITTRIGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InittrigenR {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InittrigenR::_0 => 0,
                    InittrigenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InittrigenR {
                match bits {
                    0 => InittrigenR::_0,
                    1 => InittrigenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InittrigenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InittrigenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigfR {
            # [ doc = "No channel trigger was generated." ]
            _0,
            # [ doc = "A channel trigger was generated." ]
            _1,
        }
        impl TrigfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigfR::_0 => 0,
                    TrigfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigfR {
                match bits {
                    0 => TrigfR::_0,
                    1 => TrigfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigfR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6trigR::_0 => 0,
                    Ch6trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6trigR {
                match bits {
                    0 => Ch6trigR::_0,
                    1 => Ch6trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7trigR::_0 => 0,
                    Ch7trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7trigR {
                match bits {
                    0 => Ch7trigR::_0,
                    1 => Ch7trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7trigR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH2TRIG`" ]
        pub enum Ch2trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2trigW::_0 => 0,
                    Ch2trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3TRIG`" ]
        pub enum Ch3trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3trigW::_0 => 0,
                    Ch3trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4TRIG`" ]
        pub enum Ch4trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4trigW::_0 => 0,
                    Ch4trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5TRIG`" ]
        pub enum Ch5trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5trigW::_0 => 0,
                    Ch5trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0TRIG`" ]
        pub enum Ch0trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0trigW::_0 => 0,
                    Ch0trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1TRIG`" ]
        pub enum Ch1trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1trigW::_0 => 0,
                    Ch1trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INITTRIGEN`" ]
        pub enum InittrigenW {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InittrigenW::_0 => 0,
                    InittrigenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InittrigenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InittrigenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InittrigenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of initialization trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InittrigenW::_0)
            }
            # [ doc = "The generation of initialization trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InittrigenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6TRIG`" ]
        pub enum Ch6trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6trigW::_0 => 0,
                    Ch6trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7TRIG`" ]
        pub enum Ch7trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7trigW::_0 => 0,
                    Ch7trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&self) -> Ch2trigR {
                Ch2trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&self) -> Ch3trigR {
                Ch3trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&self) -> Ch4trigR {
                Ch4trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&self) -> Ch5trigR {
                Ch5trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&self) -> Ch0trigR {
                Ch0trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&self) -> Ch1trigR {
                Ch1trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&self) -> InittrigenR {
                InittrigenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 6;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Channel Trigger Flag" ]
            # [ inline ( always ) ]
            pub fn trigf(&self) -> TrigfR {
                TrigfR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&self) -> Ch6trigR {
                Ch6trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&self) -> Ch7trigR {
                Ch7trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&mut self) -> _Ch2trigW {
                _Ch2trigW { w: self }
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&mut self) -> _Ch3trigW {
                _Ch3trigW { w: self }
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&mut self) -> _Ch4trigW {
                _Ch4trigW { w: self }
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&mut self) -> _Ch5trigW {
                _Ch5trigW { w: self }
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&mut self) -> _Ch0trigW {
                _Ch0trigW { w: self }
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&mut self) -> _Ch1trigW {
                _Ch1trigW { w: self }
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&mut self) -> _InittrigenW {
                _InittrigenW { w: self }
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&mut self) -> _Ch6trigW {
                _Ch6trigW { w: self }
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&mut self) -> _Ch7trigW {
                _Ch7trigW { w: self }
            }
        }
    }
    # [ doc = "Channels Polarity" ]
    pub struct Pol {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channels Polarity" ]
    pub mod pol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `POL0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol0R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol0R::_0 => 0,
                    Pol0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol0R {
                match bits {
                    0 => Pol0R::_0,
                    1 => Pol0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol0R::_1
            }
        }
        # [ doc = "Possible values of the field `POL1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol1R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol1R::_0 => 0,
                    Pol1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol1R {
                match bits {
                    0 => Pol1R::_0,
                    1 => Pol1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol1R::_1
            }
        }
        # [ doc = "Possible values of the field `POL2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol2R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol2R::_0 => 0,
                    Pol2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol2R {
                match bits {
                    0 => Pol2R::_0,
                    1 => Pol2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol2R::_1
            }
        }
        # [ doc = "Possible values of the field `POL3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol3R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol3R::_0 => 0,
                    Pol3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol3R {
                match bits {
                    0 => Pol3R::_0,
                    1 => Pol3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol3R::_1
            }
        }
        # [ doc = "Possible values of the field `POL4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol4R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol4R::_0 => 0,
                    Pol4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol4R {
                match bits {
                    0 => Pol4R::_0,
                    1 => Pol4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol4R::_1
            }
        }
        # [ doc = "Possible values of the field `POL5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol5R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol5R::_0 => 0,
                    Pol5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol5R {
                match bits {
                    0 => Pol5R::_0,
                    1 => Pol5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol5R::_1
            }
        }
        # [ doc = "Possible values of the field `POL6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol6R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol6R::_0 => 0,
                    Pol6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol6R {
                match bits {
                    0 => Pol6R::_0,
                    1 => Pol6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol6R::_1
            }
        }
        # [ doc = "Possible values of the field `POL7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol7R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol7R::_0 => 0,
                    Pol7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol7R {
                match bits {
                    0 => Pol7R::_0,
                    1 => Pol7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol7R::_1
            }
        }
        # [ doc = "Values that can be written to the field `POL0`" ]
        pub enum Pol0W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol0W::_0 => 0,
                    Pol0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol0W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL1`" ]
        pub enum Pol1W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol1W::_0 => 0,
                    Pol1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol1W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL2`" ]
        pub enum Pol2W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol2W::_0 => 0,
                    Pol2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol2W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL3`" ]
        pub enum Pol3W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol3W::_0 => 0,
                    Pol3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol3W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL4`" ]
        pub enum Pol4W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol4W::_0 => 0,
                    Pol4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol4W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL5`" ]
        pub enum Pol5W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol5W::_0 => 0,
                    Pol5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol5W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL6`" ]
        pub enum Pol6W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol6W::_0 => 0,
                    Pol6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol6W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL7`" ]
        pub enum Pol7W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol7W::_0 => 0,
                    Pol7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol7W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&self) -> Pol0R {
                Pol0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&self) -> Pol1R {
                Pol1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&self) -> Pol2R {
                Pol2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&self) -> Pol3R {
                Pol3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&self) -> Pol4R {
                Pol4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&self) -> Pol5R {
                Pol5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&self) -> Pol6R {
                Pol6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&self) -> Pol7R {
                Pol7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&mut self) -> _Pol0W {
                _Pol0W { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&mut self) -> _Pol1W {
                _Pol1W { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&mut self) -> _Pol2W {
                _Pol2W { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&mut self) -> _Pol3W {
                _Pol3W { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&mut self) -> _Pol4W {
                _Pol4W { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&mut self) -> _Pol5W {
                _Pol5W { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&mut self) -> _Pol6W {
                _Pol6W { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&mut self) -> _Pol7W {
                _Pol7W { w: self }
            }
        }
    }
    # [ doc = "Fault Mode Status" ]
    pub struct Fms {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Mode Status" ]
    pub mod fms {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fms {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULTF0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf0R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf0R::_0 => 0,
                    Faultf0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf0R {
                match bits {
                    0 => Faultf0R::_0,
                    1 => Faultf0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf1R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf1R::_0 => 0,
                    Faultf1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf1R {
                match bits {
                    0 => Faultf1R::_0,
                    1 => Faultf1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf2R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf2R::_0 => 0,
                    Faultf2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf2R {
                match bits {
                    0 => Faultf2R::_0,
                    1 => Faultf2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf3R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf3R::_0 => 0,
                    Faultf3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf3R {
                match bits {
                    0 => Faultf3R::_0,
                    1 => Faultf3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultinR {
            # [ doc = "The logic OR of the enabled fault inputs is 0." ]
            _0,
            # [ doc = "The logic OR of the enabled fault inputs is 1." ]
            _1,
        }
        impl FaultinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultinR::_0 => 0,
                    FaultinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultinR {
                match bits {
                    0 => FaultinR::_0,
                    1 => FaultinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultinR::_1
            }
        }
        # [ doc = "Possible values of the field `WPEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpenR {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpenR::_0 => 0,
                    WpenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpenR {
                match bits {
                    0 => WpenR::_0,
                    1 => WpenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpenR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultfR {
            # [ doc = "No fault condition was detected." ]
            _0,
            # [ doc = "A fault condition was detected." ]
            _1,
        }
        impl FaultfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultfR::_0 => 0,
                    FaultfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultfR {
                match bits {
                    0 => FaultfR::_0,
                    1 => FaultfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WPEN`" ]
        pub enum WpenW {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpenW::_0 => 0,
                    WpenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpenW::_0)
            }
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Detection Flag 0" ]
            # [ inline ( always ) ]
            pub fn faultf0(&self) -> Faultf0R {
                Faultf0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Detection Flag 1" ]
            # [ inline ( always ) ]
            pub fn faultf1(&self) -> Faultf1R {
                Faultf1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Detection Flag 2" ]
            # [ inline ( always ) ]
            pub fn faultf2(&self) -> Faultf2R {
                Faultf2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Detection Flag 3" ]
            # [ inline ( always ) ]
            pub fn faultf3(&self) -> Faultf3R {
                Faultf3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Fault Inputs" ]
            # [ inline ( always ) ]
            pub fn faultin(&self) -> FaultinR {
                FaultinR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&self) -> WpenR {
                WpenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Fault Detection Flag" ]
            # [ inline ( always ) ]
            pub fn faultf(&self) -> FaultfR {
                FaultfR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&mut self) -> _WpenW {
                _WpenW { w: self }
            }
        }
    }
    # [ doc = "Input Capture Filter Control" ]
    pub struct Filter {
        register: VolatileCell<u32>,
    }
    # [ doc = "Input Capture Filter Control" ]
    pub mod filter {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Filter {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch0fvalR {
            bits: u8,
        }
        impl Ch0fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch1fvalR {
            bits: u8,
        }
        impl Ch1fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch2fvalR {
            bits: u8,
        }
        impl Ch2fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch3fvalR {
            bits: u8,
        }
        impl Ch3fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&self) -> Ch0fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch0fvalR { bits }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&self) -> Ch1fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch1fvalR { bits }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&self) -> Ch2fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch2fvalR { bits }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&self) -> Ch3fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch3fvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&mut self) -> _Ch0fvalW {
                _Ch0fvalW { w: self }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&mut self) -> _Ch1fvalW {
                _Ch1fvalW { w: self }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&mut self) -> _Ch2fvalW {
                _Ch2fvalW { w: self }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&mut self) -> _Ch3fvalW {
                _Ch3fvalW { w: self }
            }
        }
    }
    # [ doc = "Fault Control" ]
    pub struct Fltctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Control" ]
    pub mod fltctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULT0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault0enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault0enR::_0 => 0,
                    Fault0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault0enR {
                match bits {
                    0 => Fault0enR::_0,
                    1 => Fault0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault1enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault1enR::_0 => 0,
                    Fault1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault1enR {
                match bits {
                    0 => Fault1enR::_0,
                    1 => Fault1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault2enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault2enR::_0 => 0,
                    Fault2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault2enR {
                match bits {
                    0 => Fault2enR::_0,
                    1 => Fault2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault3enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault3enR::_0 => 0,
                    Fault3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault3enR {
                match bits {
                    0 => Fault3enR::_0,
                    1 => Fault3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault3enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr0enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr0enR::_0 => 0,
                    Ffltr0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr0enR {
                match bits {
                    0 => Ffltr0enR::_0,
                    1 => Ffltr0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr1enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr1enR::_0 => 0,
                    Ffltr1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr1enR {
                match bits {
                    0 => Ffltr1enR::_0,
                    1 => Ffltr1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr2enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr2enR::_0 => 0,
                    Ffltr2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr2enR {
                match bits {
                    0 => Ffltr2enR::_0,
                    1 => Ffltr2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr3enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr3enR::_0 => 0,
                    Ffltr3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr3enR {
                match bits {
                    0 => Ffltr3enR::_0,
                    1 => Ffltr3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr3enR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FfvalR {
            bits: u8,
        }
        impl FfvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FSTATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FstateR {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FstateR::_0 => 0,
                    FstateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FstateR {
                match bits {
                    0 => FstateR::_0,
                    1 => FstateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FstateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FstateR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FAULT0EN`" ]
        pub enum Fault0enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault0enW::_0 => 0,
                    Fault0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault0enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT1EN`" ]
        pub enum Fault1enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault1enW::_0 => 0,
                    Fault1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault1enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT2EN`" ]
        pub enum Fault2enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault2enW::_0 => 0,
                    Fault2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault2enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT3EN`" ]
        pub enum Fault3enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault3enW::_0 => 0,
                    Fault3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault3enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR0EN`" ]
        pub enum Ffltr0enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr0enW::_0 => 0,
                    Ffltr0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr0enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR1EN`" ]
        pub enum Ffltr1enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr1enW::_0 => 0,
                    Ffltr1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr1enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR2EN`" ]
        pub enum Ffltr2enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr2enW::_0 => 0,
                    Ffltr2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr2enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR3EN`" ]
        pub enum Ffltr3enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr3enW::_0 => 0,
                    Ffltr3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr3enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FfvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FfvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FSTATE`" ]
        pub enum FstateW {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FstateW::_0 => 0,
                    FstateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FstateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FstateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FstateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FstateW::_0)
            }
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FstateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&self) -> Fault0enR {
                Fault0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&self) -> Fault1enR {
                Fault1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&self) -> Fault2enR {
                Fault2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&self) -> Fault3enR {
                Fault3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&self) -> Ffltr0enR {
                Ffltr0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 4;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&self) -> Ffltr1enR {
                Ffltr1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&self) -> Ffltr2enR {
                Ffltr2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&self) -> Ffltr3enR {
                Ffltr3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&self) -> FfvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FfvalR { bits }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&self) -> FstateR {
                FstateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&mut self) -> _Fault0enW {
                _Fault0enW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&mut self) -> _Fault1enW {
                _Fault1enW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&mut self) -> _Fault2enW {
                _Fault2enW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&mut self) -> _Fault3enW {
                _Fault3enW { w: self }
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&mut self) -> _Ffltr0enW {
                _Ffltr0enW { w: self }
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&mut self) -> _Ffltr1enW {
                _Ffltr1enW { w: self }
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&mut self) -> _Ffltr2enW {
                _Ffltr2enW { w: self }
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&mut self) -> _Ffltr3enW {
                _Ffltr3enW { w: self }
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&mut self) -> _FfvalW {
                _FfvalW { w: self }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&mut self) -> _FstateW {
                _FstateW { w: self }
            }
        }
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub struct Qdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub mod qdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Qdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `QUADEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadenR {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadenR::_0 => 0,
                    QuadenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadenR {
                match bits {
                    0 => QuadenR::_0,
                    1 => QuadenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadenR::_1
            }
        }
        # [ doc = "Possible values of the field `TOFDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofdirR {
            # [ doc = "TOF bit was set on the bottom of counting. There was an FTM counter decrement and FTM counter changes from its minimum value (CNTIN register) to its maximum value (MOD register)." ]
            _0,
            # [ doc = "TOF bit was set on the top of counting. There was an FTM counter increment and FTM counter changes from its maximum value (MOD register) to its minimum value (CNTIN register)." ]
            _1,
        }
        impl TofdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofdirR::_0 => 0,
                    TofdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofdirR {
                match bits {
                    0 => TofdirR::_0,
                    1 => TofdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofdirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadirR {
            # [ doc = "Counting direction is decreasing (FTM counter decrement)." ]
            _0,
            # [ doc = "Counting direction is increasing (FTM counter increment)." ]
            _1,
        }
        impl QuadirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadirR::_0 => 0,
                    QuadirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadirR {
                match bits {
                    0 => QuadirR::_0,
                    1 => QuadirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadmodeR {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadmodeR::_0 => 0,
                    QuadmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadmodeR {
                match bits {
                    0 => QuadmodeR::_0,
                    1 => QuadmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbpolR {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbpolR::_0 => 0,
                    PhbpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbpolR {
                match bits {
                    0 => PhbpolR::_0,
                    1 => PhbpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbpolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhapolR {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhapolR::_0 => 0,
                    PhapolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhapolR {
                match bits {
                    0 => PhapolR::_0,
                    1 => PhapolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhapolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhapolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbfltrenR {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbfltrenR::_0 => 0,
                    PhbfltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbfltrenR {
                match bits {
                    0 => PhbfltrenR::_0,
                    1 => PhbfltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbfltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbfltrenR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhafltrenR {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhafltrenR::_0 => 0,
                    PhafltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhafltrenR {
                match bits {
                    0 => PhafltrenR::_0,
                    1 => PhafltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhafltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhafltrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `QUADEN`" ]
        pub enum QuadenW {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadenW::_0 => 0,
                    QuadenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Quadrature Decoder mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadenW::_0)
            }
            # [ doc = "Quadrature Decoder mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `QUADMODE`" ]
        pub enum QuadmodeW {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadmodeW::_0 => 0,
                    QuadmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A and phase B encoding mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadmodeW::_0)
            }
            # [ doc = "Count and direction encoding mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBPOL`" ]
        pub enum PhbpolW {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbpolW::_0 => 0,
                    PhbpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbpolW::_0)
            }
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAPOL`" ]
        pub enum PhapolW {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhapolW::_0 => 0,
                    PhapolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhapolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhapolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhapolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhapolW::_0)
            }
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhapolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBFLTREN`" ]
        pub enum PhbfltrenW {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbfltrenW::_0 => 0,
                    PhbfltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbfltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbfltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbfltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase B input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbfltrenW::_0)
            }
            # [ doc = "Phase B input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbfltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAFLTREN`" ]
        pub enum PhafltrenW {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhafltrenW::_0 => 0,
                    PhafltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhafltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhafltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhafltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhafltrenW::_0)
            }
            # [ doc = "Phase A input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhafltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&self) -> QuadenR {
                QuadenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Timer Overflow Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn tofdir(&self) -> TofdirR {
                TofdirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadir(&self) -> QuadirR {
                QuadirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&self) -> QuadmodeR {
                QuadmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&self) -> PhbpolR {
                PhbpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&self) -> PhapolR {
                PhapolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&self) -> PhbfltrenR {
                PhbfltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 6;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&self) -> PhafltrenR {
                PhafltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 7;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&mut self) -> _QuadenW {
                _QuadenW { w: self }
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&mut self) -> _QuadmodeW {
                _QuadmodeW { w: self }
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&mut self) -> _PhbpolW {
                _PhbpolW { w: self }
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&mut self) -> _PhapolW {
                _PhapolW { w: self }
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&mut self) -> _PhbfltrenW {
                _PhbfltrenW { w: self }
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&mut self) -> _PhafltrenW {
                _PhafltrenW { w: self }
            }
        }
    }
    # [ doc = "Configuration" ]
    pub struct Conf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration" ]
    pub mod conf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Conf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LdfqR {
            bits: u8,
        }
        impl LdfqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BdmmodeR {
            bits: u8,
        }
        impl BdmmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeenR {
            bits: u8,
        }
        impl GtbeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeoutR {
            bits: u8,
        }
        impl GtbeoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ITRIGR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ItrigrR {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ItrigrR::_0 => 0,
                    ItrigrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ItrigrR {
                match bits {
                    0 => ItrigrR::_0,
                    1 => ItrigrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ItrigrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ItrigrR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdfqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdfqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BdmmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BdmmodeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeoutW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ITRIGR`" ]
        pub enum ItrigrW {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ItrigrW::_0 => 0,
                    ItrigrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ItrigrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ItrigrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ItrigrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ItrigrW::_0)
            }
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ItrigrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&self) -> LdfqR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LdfqR { bits }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&self) -> BdmmodeR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BdmmodeR { bits }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&self) -> GtbeenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeenR { bits }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&self) -> GtbeoutR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeoutR { bits }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&self) -> ItrigrR {
                ItrigrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&mut self) -> _LdfqW {
                _LdfqW { w: self }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&mut self) -> _BdmmodeW {
                _BdmmodeW { w: self }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&mut self) -> _GtbeenW {
                _GtbeenW { w: self }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&mut self) -> _GtbeoutW {
                _GtbeoutW { w: self }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&mut self) -> _ItrigrW {
                _ItrigrW { w: self }
            }
        }
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub struct Fltpol {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub mod fltpol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltpol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FLT0POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt0polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt0polR::_0 => 0,
                    Flt0polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt0polR {
                match bits {
                    0 => Flt0polR::_0,
                    1 => Flt0polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt0polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt0polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT1POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt1polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt1polR::_0 => 0,
                    Flt1polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt1polR {
                match bits {
                    0 => Flt1polR::_0,
                    1 => Flt1polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt1polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt1polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT2POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt2polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt2polR::_0 => 0,
                    Flt2polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt2polR {
                match bits {
                    0 => Flt2polR::_0,
                    1 => Flt2polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt2polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt2polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT3POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt3polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt3polR::_0 => 0,
                    Flt3polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt3polR {
                match bits {
                    0 => Flt3polR::_0,
                    1 => Flt3polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt3polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt3polR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FLT0POL`" ]
        pub enum Flt0polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt0polW::_0 => 0,
                    Flt0polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt0polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt0polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt0polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt0polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt0polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT1POL`" ]
        pub enum Flt1polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt1polW::_0 => 0,
                    Flt1polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt1polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt1polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt1polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt1polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt1polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT2POL`" ]
        pub enum Flt2polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt2polW::_0 => 0,
                    Flt2polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt2polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt2polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt2polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt2polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt2polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT3POL`" ]
        pub enum Flt3polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt3polW::_0 => 0,
                    Flt3polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt3polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt3polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt3polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt3polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt3polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&self) -> Flt0polR {
                Flt0polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&self) -> Flt1polR {
                Flt1polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&self) -> Flt2polR {
                Flt2polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&self) -> Flt3polR {
                Flt3polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&mut self) -> _Flt0polW {
                _Flt0polW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&mut self) -> _Flt1polW {
                _Flt1polW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&mut self) -> _Flt2polW {
                _Flt2polW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&mut self) -> _Flt3polW {
                _Flt3polW { w: self }
            }
        }
    }
    # [ doc = "Synchronization Configuration" ]
    pub struct Synconf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization Configuration" ]
    pub mod synconf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Synconf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HWTRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwtrigmodeR {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwtrigmodeR::_0 => 0,
                    HwtrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwtrigmodeR {
                match bits {
                    0 => HwtrigmodeR::_0,
                    1 => HwtrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwtrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwtrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTINC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntincR {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntincR::_0 => 0,
                    CntincR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntincR {
                match bits {
                    0 => CntincR::_0,
                    1 => CntincR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntincR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntincR::_1
            }
        }
        # [ doc = "Possible values of the field `INVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InvcR {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InvcR::_0 => 0,
                    InvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InvcR {
                match bits {
                    0 => InvcR::_0,
                    1 => InvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwocR {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwocR::_0 => 0,
                    SwocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwocR {
                match bits {
                    0 => SwocR::_0,
                    1 => SwocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwocR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SyncmodeR {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SyncmodeR::_0 => 0,
                    SyncmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SyncmodeR {
                match bits {
                    0 => SyncmodeR::_0,
                    1 => SyncmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SyncmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SyncmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `SWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwrstcntR {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwrstcntR::_0 => 0,
                    SwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwrstcntR {
                match bits {
                    0 => SwrstcntR::_0,
                    1 => SwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `SWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwwrbufR {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwwrbufR::_0 => 0,
                    SwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwwrbufR {
                match bits {
                    0 => SwwrbufR::_0,
                    1 => SwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwomR {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwomR::_0 => 0,
                    SwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwomR {
                match bits {
                    0 => SwomR::_0,
                    1 => SwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwomR::_1
            }
        }
        # [ doc = "Possible values of the field `SWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwinvcR {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwinvcR::_0 => 0,
                    SwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwinvcR {
                match bits {
                    0 => SwinvcR::_0,
                    1 => SwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsocR {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsocR::_0 => 0,
                    SwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsocR {
                match bits {
                    0 => SwsocR::_0,
                    1 => SwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsocR::_1
            }
        }
        # [ doc = "Possible values of the field `HWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwrstcntR {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwrstcntR::_0 => 0,
                    HwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwrstcntR {
                match bits {
                    0 => HwrstcntR::_0,
                    1 => HwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `HWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwwrbufR {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwwrbufR::_0 => 0,
                    HwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwwrbufR {
                match bits {
                    0 => HwwrbufR::_0,
                    1 => HwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `HWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwomR {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwomR::_0 => 0,
                    HwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwomR {
                match bits {
                    0 => HwomR::_0,
                    1 => HwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwomR::_1
            }
        }
        # [ doc = "Possible values of the field `HWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwinvcR {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwinvcR::_0 => 0,
                    HwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwinvcR {
                match bits {
                    0 => HwinvcR::_0,
                    1 => HwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `HWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwsocR {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwsocR::_0 => 0,
                    HwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwsocR {
                match bits {
                    0 => HwsocR::_0,
                    1 => HwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwsocR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HWTRIGMODE`" ]
        pub enum HwtrigmodeW {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwtrigmodeW::_0 => 0,
                    HwtrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwtrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwtrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwtrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_0)
            }
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTINC`" ]
        pub enum CntincW {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntincW::_0 => 0,
                    CntincW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntincW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntincW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntincW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntincW::_0)
            }
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntincW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVC`" ]
        pub enum InvcW {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InvcW::_0 => 0,
                    InvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InvcW::_0)
            }
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOC`" ]
        pub enum SwocW {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwocW::_0 => 0,
                    SwocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwocW::_0)
            }
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCMODE`" ]
        pub enum SyncmodeW {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SyncmodeW::_0 => 0,
                    SyncmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SyncmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SyncmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SyncmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Legacy PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SyncmodeW::_0)
            }
            # [ doc = "Enhanced PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SyncmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWRSTCNT`" ]
        pub enum SwrstcntW {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwrstcntW::_0 => 0,
                    SwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwrstcntW::_0)
            }
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWWRBUF`" ]
        pub enum SwwrbufW {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwwrbufW::_0 => 0,
                    SwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwwrbufW::_0)
            }
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOM`" ]
        pub enum SwomW {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwomW::_0 => 0,
                    SwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwomW::_0)
            }
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWINVC`" ]
        pub enum SwinvcW {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwinvcW::_0 => 0,
                    SwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwinvcW::_0)
            }
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSOC`" ]
        pub enum SwsocW {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsocW::_0 => 0,
                    SwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsocW::_0)
            }
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWRSTCNT`" ]
        pub enum HwrstcntW {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwrstcntW::_0 => 0,
                    HwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwrstcntW::_0)
            }
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWWRBUF`" ]
        pub enum HwwrbufW {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwwrbufW::_0 => 0,
                    HwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwwrbufW::_0)
            }
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWOM`" ]
        pub enum HwomW {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwomW::_0 => 0,
                    HwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwomW::_0)
            }
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWINVC`" ]
        pub enum HwinvcW {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwinvcW::_0 => 0,
                    HwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwinvcW::_0)
            }
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWSOC`" ]
        pub enum HwsocW {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwsocW::_0 => 0,
                    HwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwsocW::_0)
            }
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&self) -> HwtrigmodeR {
                HwtrigmodeR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&self) -> CntincR {
                CntincR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&self) -> InvcR {
                InvcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&self) -> SwocR {
                SwocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&self) -> SyncmodeR {
                SyncmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&self) -> SwrstcntR {
                SwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&self) -> SwwrbufR {
                SwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&self) -> SwomR {
                SwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&self) -> SwinvcR {
                SwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&self) -> SwsocR {
                SwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&self) -> HwrstcntR {
                HwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 16;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&self) -> HwwrbufR {
                HwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&self) -> HwomR {
                HwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&self) -> HwinvcR {
                HwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&self) -> HwsocR {
                HwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&mut self) -> _HwtrigmodeW {
                _HwtrigmodeW { w: self }
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&mut self) -> _CntincW {
                _CntincW { w: self }
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&mut self) -> _InvcW {
                _InvcW { w: self }
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&mut self) -> _SwocW {
                _SwocW { w: self }
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&mut self) -> _SyncmodeW {
                _SyncmodeW { w: self }
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&mut self) -> _SwrstcntW {
                _SwrstcntW { w: self }
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&mut self) -> _SwwrbufW {
                _SwwrbufW { w: self }
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&mut self) -> _SwomW {
                _SwomW { w: self }
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&mut self) -> _SwinvcW {
                _SwinvcW { w: self }
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&mut self) -> _SwsocW {
                _SwsocW { w: self }
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&mut self) -> _HwrstcntW {
                _HwrstcntW { w: self }
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&mut self) -> _HwwrbufW {
                _HwwrbufW { w: self }
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&mut self) -> _HwomW {
                _HwomW { w: self }
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&mut self) -> _HwinvcW {
                _HwinvcW { w: self }
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&mut self) -> _HwsocW {
                _HwsocW { w: self }
            }
        }
    }
    # [ doc = "FTM Inverting Control" ]
    pub struct Invctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Inverting Control" ]
    pub mod invctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Invctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `INV0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv0enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv0enR::_0 => 0,
                    Inv0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv0enR {
                match bits {
                    0 => Inv0enR::_0,
                    1 => Inv0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv0enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv1enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv1enR::_0 => 0,
                    Inv1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv1enR {
                match bits {
                    0 => Inv1enR::_0,
                    1 => Inv1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv1enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv2enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv2enR::_0 => 0,
                    Inv2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv2enR {
                match bits {
                    0 => Inv2enR::_0,
                    1 => Inv2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv2enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv3enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv3enR::_0 => 0,
                    Inv3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv3enR {
                match bits {
                    0 => Inv3enR::_0,
                    1 => Inv3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv3enR::_1
            }
        }
        # [ doc = "Values that can be written to the field `INV0EN`" ]
        pub enum Inv0enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv0enW::_0 => 0,
                    Inv0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv0enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV1EN`" ]
        pub enum Inv1enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv1enW::_0 => 0,
                    Inv1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv1enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV2EN`" ]
        pub enum Inv2enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv2enW::_0 => 0,
                    Inv2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv2enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV3EN`" ]
        pub enum Inv3enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv3enW::_0 => 0,
                    Inv3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv3enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&self) -> Inv0enR {
                Inv0enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&self) -> Inv1enR {
                Inv1enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&self) -> Inv2enR {
                Inv2enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&self) -> Inv3enR {
                Inv3enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&mut self) -> _Inv0enW {
                _Inv0enW { w: self }
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&mut self) -> _Inv1enW {
                _Inv1enW { w: self }
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&mut self) -> _Inv2enW {
                _Inv2enW { w: self }
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&mut self) -> _Inv3enW {
                _Inv3enW { w: self }
            }
        }
    }
    # [ doc = "FTM Software Output Control" ]
    pub struct Swoctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Software Output Control" ]
    pub mod swoctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Swoctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocR::_0 => 0,
                    Ch0ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocR {
                match bits {
                    0 => Ch0ocR::_0,
                    1 => Ch0ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocR::_0 => 0,
                    Ch1ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocR {
                match bits {
                    0 => Ch1ocR::_0,
                    1 => Ch1ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocR::_0 => 0,
                    Ch2ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocR {
                match bits {
                    0 => Ch2ocR::_0,
                    1 => Ch2ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocR::_0 => 0,
                    Ch3ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocR {
                match bits {
                    0 => Ch3ocR::_0,
                    1 => Ch3ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocR::_0 => 0,
                    Ch4ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocR {
                match bits {
                    0 => Ch4ocR::_0,
                    1 => Ch4ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocR::_0 => 0,
                    Ch5ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocR {
                match bits {
                    0 => Ch5ocR::_0,
                    1 => Ch5ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocR::_0 => 0,
                    Ch6ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocR {
                match bits {
                    0 => Ch6ocR::_0,
                    1 => Ch6ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocR::_0 => 0,
                    Ch7ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocR {
                match bits {
                    0 => Ch7ocR::_0,
                    1 => Ch7ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocvR::_0 => 0,
                    Ch0ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocvR {
                match bits {
                    0 => Ch0ocvR::_0,
                    1 => Ch0ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocvR::_0 => 0,
                    Ch1ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocvR {
                match bits {
                    0 => Ch1ocvR::_0,
                    1 => Ch1ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocvR::_0 => 0,
                    Ch2ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocvR {
                match bits {
                    0 => Ch2ocvR::_0,
                    1 => Ch2ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocvR::_0 => 0,
                    Ch3ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocvR {
                match bits {
                    0 => Ch3ocvR::_0,
                    1 => Ch3ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocvR::_0 => 0,
                    Ch4ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocvR {
                match bits {
                    0 => Ch4ocvR::_0,
                    1 => Ch4ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocvR::_0 => 0,
                    Ch5ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocvR {
                match bits {
                    0 => Ch5ocvR::_0,
                    1 => Ch5ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocvR::_0 => 0,
                    Ch6ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocvR {
                match bits {
                    0 => Ch6ocvR::_0,
                    1 => Ch6ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocvR::_0 => 0,
                    Ch7ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocvR {
                match bits {
                    0 => Ch7ocvR::_0,
                    1 => Ch7ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocvR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OC`" ]
        pub enum Ch0ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocW::_0 => 0,
                    Ch0ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OC`" ]
        pub enum Ch1ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocW::_0 => 0,
                    Ch1ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OC`" ]
        pub enum Ch2ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocW::_0 => 0,
                    Ch2ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OC`" ]
        pub enum Ch3ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocW::_0 => 0,
                    Ch3ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OC`" ]
        pub enum Ch4ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocW::_0 => 0,
                    Ch4ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OC`" ]
        pub enum Ch5ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocW::_0 => 0,
                    Ch5ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OC`" ]
        pub enum Ch6ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocW::_0 => 0,
                    Ch6ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OC`" ]
        pub enum Ch7ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocW::_0 => 0,
                    Ch7ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0OCV`" ]
        pub enum Ch0ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocvW::_0 => 0,
                    Ch0ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OCV`" ]
        pub enum Ch1ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocvW::_0 => 0,
                    Ch1ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OCV`" ]
        pub enum Ch2ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocvW::_0 => 0,
                    Ch2ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OCV`" ]
        pub enum Ch3ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocvW::_0 => 0,
                    Ch3ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OCV`" ]
        pub enum Ch4ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocvW::_0 => 0,
                    Ch4ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OCV`" ]
        pub enum Ch5ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocvW::_0 => 0,
                    Ch5ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OCV`" ]
        pub enum Ch6ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocvW::_0 => 0,
                    Ch6ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OCV`" ]
        pub enum Ch7ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocvW::_0 => 0,
                    Ch7ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&self) -> Ch0ocR {
                Ch0ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&self) -> Ch1ocR {
                Ch1ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&self) -> Ch2ocR {
                Ch2ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&self) -> Ch3ocR {
                Ch3ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&self) -> Ch4ocR {
                Ch4ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&self) -> Ch5ocR {
                Ch5ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&self) -> Ch6ocR {
                Ch6ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&self) -> Ch7ocR {
                Ch7ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&self) -> Ch0ocvR {
                Ch0ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&self) -> Ch1ocvR {
                Ch1ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&self) -> Ch2ocvR {
                Ch2ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&self) -> Ch3ocvR {
                Ch3ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&self) -> Ch4ocvR {
                Ch4ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&self) -> Ch5ocvR {
                Ch5ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&self) -> Ch6ocvR {
                Ch6ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&self) -> Ch7ocvR {
                Ch7ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&mut self) -> _Ch0ocW {
                _Ch0ocW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&mut self) -> _Ch1ocW {
                _Ch1ocW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&mut self) -> _Ch2ocW {
                _Ch2ocW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&mut self) -> _Ch3ocW {
                _Ch3ocW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&mut self) -> _Ch4ocW {
                _Ch4ocW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&mut self) -> _Ch5ocW {
                _Ch5ocW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&mut self) -> _Ch6ocW {
                _Ch6ocW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&mut self) -> _Ch7ocW {
                _Ch7ocW { w: self }
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&mut self) -> _Ch0ocvW {
                _Ch0ocvW { w: self }
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&mut self) -> _Ch1ocvW {
                _Ch1ocvW { w: self }
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&mut self) -> _Ch2ocvW {
                _Ch2ocvW { w: self }
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&mut self) -> _Ch3ocvW {
                _Ch3ocvW { w: self }
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&mut self) -> _Ch4ocvW {
                _Ch4ocvW { w: self }
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&mut self) -> _Ch5ocvW {
                _Ch5ocvW { w: self }
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&mut self) -> _Ch6ocvW {
                _Ch6ocvW { w: self }
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&mut self) -> _Ch7ocvW {
                _Ch7ocvW { w: self }
            }
        }
    }
    # [ doc = "FTM PWM Load" ]
    pub struct Pwmload {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM PWM Load" ]
    pub mod pwmload {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pwmload {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0selR::_0 => 0,
                    Ch0selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0selR {
                match bits {
                    0 => Ch0selR::_0,
                    1 => Ch0selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1selR::_0 => 0,
                    Ch1selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1selR {
                match bits {
                    0 => Ch1selR::_0,
                    1 => Ch1selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2selR::_0 => 0,
                    Ch2selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2selR {
                match bits {
                    0 => Ch2selR::_0,
                    1 => Ch2selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3selR::_0 => 0,
                    Ch3selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3selR {
                match bits {
                    0 => Ch3selR::_0,
                    1 => Ch3selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4selR::_0 => 0,
                    Ch4selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4selR {
                match bits {
                    0 => Ch4selR::_0,
                    1 => Ch4selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5selR::_0 => 0,
                    Ch5selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5selR {
                match bits {
                    0 => Ch5selR::_0,
                    1 => Ch5selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6selR::_0 => 0,
                    Ch6selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6selR {
                match bits {
                    0 => Ch6selR::_0,
                    1 => Ch6selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7selR::_0 => 0,
                    Ch7selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7selR {
                match bits {
                    0 => Ch7selR::_0,
                    1 => Ch7selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7selR::_1
            }
        }
        # [ doc = "Possible values of the field `HCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HcselR {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HcselR::_0 => 0,
                    HcselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HcselR {
                match bits {
                    0 => HcselR::_0,
                    1 => HcselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HcselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HcselR::_1
            }
        }
        # [ doc = "Possible values of the field `LDOK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LdokR {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LdokR::_0 => 0,
                    LdokR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LdokR {
                match bits {
                    0 => LdokR::_0,
                    1 => LdokR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LdokR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LdokR::_1
            }
        }
        # [ doc = "Possible values of the field `GLEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GlenR {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GlenR::_0 => 0,
                    GlenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GlenR {
                match bits {
                    0 => GlenR::_0,
                    1 => GlenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GlenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GlenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0SEL`" ]
        pub enum Ch0selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0selW::_0 => 0,
                    Ch0selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1SEL`" ]
        pub enum Ch1selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1selW::_0 => 0,
                    Ch1selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2SEL`" ]
        pub enum Ch2selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2selW::_0 => 0,
                    Ch2selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3SEL`" ]
        pub enum Ch3selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3selW::_0 => 0,
                    Ch3selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4SEL`" ]
        pub enum Ch4selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4selW::_0 => 0,
                    Ch4selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5SEL`" ]
        pub enum Ch5selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5selW::_0 => 0,
                    Ch5selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6SEL`" ]
        pub enum Ch6selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6selW::_0 => 0,
                    Ch6selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7SEL`" ]
        pub enum Ch7selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7selW::_0 => 0,
                    Ch7selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HCSEL`" ]
        pub enum HcselW {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HcselW::_0 => 0,
                    HcselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HcselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HcselW::_0)
            }
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HcselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LDOK`" ]
        pub enum LdokW {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LdokW::_0 => 0,
                    LdokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LdokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loading updated values is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LdokW::_0)
            }
            # [ doc = "Loading updated values is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LdokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLEN`" ]
        pub enum GlenW {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GlenW::_0 => 0,
                    GlenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GlenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GlenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GlenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Global Load Ok disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GlenW::_0)
            }
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GlenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLDOK`" ]
        pub enum GldokW {
            # [ doc = "No action." ]
            _0,
            # [ doc = "LDOK bit is set." ]
            _1,
        }
        impl GldokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GldokW::_0 => 0,
                    GldokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GldokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GldokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GldokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No action." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GldokW::_0)
            }
            # [ doc = "LDOK bit is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GldokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&self) -> Ch0selR {
                Ch0selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&self) -> Ch1selR {
                Ch1selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&self) -> Ch2selR {
                Ch2selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&self) -> Ch3selR {
                Ch3selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&self) -> Ch4selR {
                Ch4selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&self) -> Ch5selR {
                Ch5selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&self) -> Ch6selR {
                Ch6selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&self) -> Ch7selR {
                Ch7selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&self) -> HcselR {
                HcselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&self) -> LdokR {
                LdokR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&self) -> GlenR {
                GlenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&mut self) -> _Ch0selW {
                _Ch0selW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&mut self) -> _Ch1selW {
                _Ch1selW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&mut self) -> _Ch2selW {
                _Ch2selW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&mut self) -> _Ch3selW {
                _Ch3selW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&mut self) -> _Ch4selW {
                _Ch4selW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&mut self) -> _Ch5selW {
                _Ch5selW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&mut self) -> _Ch6selW {
                _Ch6selW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&mut self) -> _Ch7selW {
                _Ch7selW { w: self }
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&mut self) -> _HcselW {
                _HcselW { w: self }
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&mut self) -> _LdokW {
                _LdokW { w: self }
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&mut self) -> _GlenW {
                _GlenW { w: self }
            }
            # [ doc = "Bit 11 - Global Load OK" ]
            # [ inline ( always ) ]
            pub fn gldok(&mut self) -> _GldokW {
                _GldokW { w: self }
            }
        }
    }
    # [ doc = "Half Cycle Register" ]
    pub struct Hcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Half Cycle Register" ]
    pub mod hcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Hcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HcvalR {
            bits: u16,
        }
        impl HcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&self) -> HcvalR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                HcvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&mut self) -> _HcvalW {
                _HcvalW { w: self }
            }
        }
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub struct Pair0deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub mod pair0deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair0deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub struct Pair1deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub mod pair1deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair1deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub struct Pair2deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub mod pair2deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair2deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub struct Pair3deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub mod pair3deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair3deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
}
# [ doc = "FlexTimer Module" ]
pub struct Ftm0 {
    register_block: ftm0::RegisterBlock,
}
impl Deref for Ftm0 {
    type Target = ftm0::RegisterBlock;
    fn deref(&self) -> &ftm0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "FlexTimer Module" ]
pub const FTM1: Peripheral<Ftm1> = unsafe { Peripheral::new(1073975296) };
# [ doc = "FlexTimer Module" ]
pub mod ftm1 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Status And Control" ]
        pub sc: Sc,
        # [ doc = "0x04 - Counter" ]
        pub cnt: Cnt,
        # [ doc = "0x08 - Modulo" ]
        pub mod_: Mod,
        # [ doc = "0x0c - Channel (n) Status And Control" ]
        pub c0sc: C0sc,
        # [ doc = "0x10 - Channel (n) Value" ]
        pub c0v: C0v,
        # [ doc = "0x14 - Channel (n) Status And Control" ]
        pub c1sc: C1sc,
        # [ doc = "0x18 - Channel (n) Value" ]
        pub c1v: C1v,
        # [ doc = "0x1c - Channel (n) Status And Control" ]
        pub c2sc: C2sc,
        # [ doc = "0x20 - Channel (n) Value" ]
        pub c2v: C2v,
        # [ doc = "0x24 - Channel (n) Status And Control" ]
        pub c3sc: C3sc,
        # [ doc = "0x28 - Channel (n) Value" ]
        pub c3v: C3v,
        # [ doc = "0x2c - Channel (n) Status And Control" ]
        pub c4sc: C4sc,
        # [ doc = "0x30 - Channel (n) Value" ]
        pub c4v: C4v,
        # [ doc = "0x34 - Channel (n) Status And Control" ]
        pub c5sc: C5sc,
        # [ doc = "0x38 - Channel (n) Value" ]
        pub c5v: C5v,
        # [ doc = "0x3c - Channel (n) Status And Control" ]
        pub c6sc: C6sc,
        # [ doc = "0x40 - Channel (n) Value" ]
        pub c6v: C6v,
        # [ doc = "0x44 - Channel (n) Status And Control" ]
        pub c7sc: C7sc,
        # [ doc = "0x48 - Channel (n) Value" ]
        pub c7v: C7v,
        # [ doc = "0x4c - Counter Initial Value" ]
        pub cntin: Cntin,
        # [ doc = "0x50 - Capture And Compare Status" ]
        pub status: Status,
        # [ doc = "0x54 - Features Mode Selection" ]
        pub mode: Mode,
        # [ doc = "0x58 - Synchronization" ]
        pub sync: Sync,
        # [ doc = "0x5c - Initial State For Channels Output" ]
        pub outinit: Outinit,
        # [ doc = "0x60 - Output Mask" ]
        pub outmask: Outmask,
        # [ doc = "0x64 - Function For Linked Channels" ]
        pub combine: Combine,
        # [ doc = "0x68 - Deadtime Configuration" ]
        pub deadtime: Deadtime,
        # [ doc = "0x6c - FTM External Trigger" ]
        pub exttrig: Exttrig,
        # [ doc = "0x70 - Channels Polarity" ]
        pub pol: Pol,
        # [ doc = "0x74 - Fault Mode Status" ]
        pub fms: Fms,
        # [ doc = "0x78 - Input Capture Filter Control" ]
        pub filter: Filter,
        # [ doc = "0x7c - Fault Control" ]
        pub fltctrl: Fltctrl,
        # [ doc = "0x80 - Quadrature Decoder Control And Status" ]
        pub qdctrl: Qdctrl,
        # [ doc = "0x84 - Configuration" ]
        pub conf: Conf,
        # [ doc = "0x88 - FTM Fault Input Polarity" ]
        pub fltpol: Fltpol,
        # [ doc = "0x8c - Synchronization Configuration" ]
        pub synconf: Synconf,
        # [ doc = "0x90 - FTM Inverting Control" ]
        pub invctrl: Invctrl,
        # [ doc = "0x94 - FTM Software Output Control" ]
        pub swoctrl: Swoctrl,
        # [ doc = "0x98 - FTM PWM Load" ]
        pub pwmload: Pwmload,
        # [ doc = "0x9c - Half Cycle Register" ]
        pub hcr: Hcr,
        # [ doc = "0xa0 - Pair 0 Deadtime Configuration" ]
        pub pair0deadtime: Pair0deadtime,
        _reserved0: [u8; 4usize],
        # [ doc = "0xa8 - Pair 1 Deadtime Configuration" ]
        pub pair1deadtime: Pair1deadtime,
        _reserved1: [u8; 4usize],
        # [ doc = "0xb0 - Pair 2 Deadtime Configuration" ]
        pub pair2deadtime: Pair2deadtime,
        _reserved2: [u8; 4usize],
        # [ doc = "0xb8 - Pair 3 Deadtime Configuration" ]
        pub pair3deadtime: Pair3deadtime,
    }
    # [ doc = "Status And Control" ]
    pub struct Sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status And Control" ]
    pub mod sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_000 => 0,
                    PsR::_001 => 1,
                    PsR::_010 => 2,
                    PsR::_011 => 3,
                    PsR::_100 => 4,
                    PsR::_101 => 5,
                    PsR::_110 => 6,
                    PsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_000,
                    1 => PsR::_001,
                    2 => PsR::_010,
                    3 => PsR::_011,
                    4 => PsR::_100,
                    5 => PsR::_101,
                    6 => PsR::_110,
                    7 => PsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PsR::_111
            }
        }
        # [ doc = "Possible values of the field `CLKS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksR {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksR::_00 => 0,
                    ClksR::_01 => 1,
                    ClksR::_10 => 2,
                    ClksR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksR {
                match bits {
                    0 => ClksR::_00,
                    1 => ClksR::_01,
                    2 => ClksR::_10,
                    3 => ClksR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ClksR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ClksR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ClksR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ClksR::_11
            }
        }
        # [ doc = "Possible values of the field `CPWMS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpwmsR {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpwmsR::_0 => 0,
                    CpwmsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpwmsR {
                match bits {
                    0 => CpwmsR::_0,
                    1 => CpwmsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpwmsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpwmsR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `RF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfR {
            # [ doc = "A selected reload point did not happen." ]
            _0,
            # [ doc = "A selected reload point happened." ]
            _1,
        }
        impl RfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfR::_0 => 0,
                    RfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfR {
                match bits {
                    0 => RfR::_0,
                    1 => RfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfR::_1
            }
        }
        # [ doc = "Possible values of the field `TOIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ToieR {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ToieR::_0 => 0,
                    ToieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ToieR {
                match bits {
                    0 => ToieR::_0,
                    1 => ToieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ToieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ToieR::_1
            }
        }
        # [ doc = "Possible values of the field `TOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofR {
            # [ doc = "FTM counter has not overflowed." ]
            _0,
            # [ doc = "FTM counter has overflowed." ]
            _1,
        }
        impl TofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofR::_0 => 0,
                    TofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofR {
                match bits {
                    0 => TofR::_0,
                    1 => TofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen0R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen0R::_0 => 0,
                    Pwmen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen0R {
                match bits {
                    0 => Pwmen0R::_0,
                    1 => Pwmen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen0R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen1R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen1R::_0 => 0,
                    Pwmen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen1R {
                match bits {
                    0 => Pwmen1R::_0,
                    1 => Pwmen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen1R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen2R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen2R::_0 => 0,
                    Pwmen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen2R {
                match bits {
                    0 => Pwmen2R::_0,
                    1 => Pwmen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen2R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen3R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen3R::_0 => 0,
                    Pwmen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen3R {
                match bits {
                    0 => Pwmen3R::_0,
                    1 => Pwmen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen3R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen4R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen4R::_0 => 0,
                    Pwmen4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen4R {
                match bits {
                    0 => Pwmen4R::_0,
                    1 => Pwmen4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen4R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen5R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen5R::_0 => 0,
                    Pwmen5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen5R {
                match bits {
                    0 => Pwmen5R::_0,
                    1 => Pwmen5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen5R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen6R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen6R::_0 => 0,
                    Pwmen6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen6R {
                match bits {
                    0 => Pwmen6R::_0,
                    1 => Pwmen6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen6R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen7R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen7R::_0 => 0,
                    Pwmen7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen7R {
                match bits {
                    0 => Pwmen7R::_0,
                    1 => Pwmen7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen7R::_1
            }
        }
        # [ doc = "Possible values of the field `FLTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltpsR {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltpsR::_0000 => 0,
                    FltpsR::_0001 => 1,
                    FltpsR::_0010 => 2,
                    FltpsR::_0011 => 3,
                    FltpsR::_0100 => 4,
                    FltpsR::_0101 => 5,
                    FltpsR::_0110 => 6,
                    FltpsR::_0111 => 7,
                    FltpsR::_1000 => 8,
                    FltpsR::_1001 => 9,
                    FltpsR::_1010 => 10,
                    FltpsR::_1011 => 11,
                    FltpsR::_1100 => 12,
                    FltpsR::_1101 => 13,
                    FltpsR::_1110 => 14,
                    FltpsR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltpsR {
                match bits {
                    0 => FltpsR::_0000,
                    1 => FltpsR::_0001,
                    2 => FltpsR::_0010,
                    3 => FltpsR::_0011,
                    4 => FltpsR::_0100,
                    5 => FltpsR::_0101,
                    6 => FltpsR::_0110,
                    7 => FltpsR::_0111,
                    8 => FltpsR::_1000,
                    9 => FltpsR::_1001,
                    10 => FltpsR::_1010,
                    11 => FltpsR::_1011,
                    12 => FltpsR::_1100,
                    13 => FltpsR::_1101,
                    14 => FltpsR::_1110,
                    15 => FltpsR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == FltpsR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == FltpsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == FltpsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == FltpsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == FltpsR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == FltpsR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == FltpsR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == FltpsR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == FltpsR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == FltpsR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == FltpsR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == FltpsR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == FltpsR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == FltpsR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == FltpsR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == FltpsR::_1111
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_000 => 0,
                    PsW::_001 => 1,
                    PsW::_010 => 2,
                    PsW::_011 => 3,
                    PsW::_100 => 4,
                    PsW::_101 => 5,
                    PsW::_110 => 6,
                    PsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PsW::_000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PsW::_001)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PsW::_010)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PsW::_011)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PsW::_100)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PsW::_101)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PsW::_110)
            }
            # [ doc = "Divide by 128" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKS`" ]
        pub enum ClksW {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksW::_00 => 0,
                    ClksW::_01 => 1,
                    ClksW::_10 => 2,
                    ClksW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ClksW::_00)
            }
            # [ doc = "FTM input clock" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ClksW::_01)
            }
            # [ doc = "Fixed frequency clock" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ClksW::_10)
            }
            # [ doc = "External clock" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ClksW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPWMS`" ]
        pub enum CpwmsW {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpwmsW::_0 => 0,
                    CpwmsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpwmsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpwmsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpwmsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter operates in Up Counting mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpwmsW::_0)
            }
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpwmsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reload point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Reload point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOIE`" ]
        pub enum ToieW {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ToieW::_0 => 0,
                    ToieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ToieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ToieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ToieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ToieW::_0)
            }
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ToieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN0`" ]
        pub enum Pwmen0W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen0W::_0 => 0,
                    Pwmen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen0W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN1`" ]
        pub enum Pwmen1W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen1W::_0 => 0,
                    Pwmen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen1W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN2`" ]
        pub enum Pwmen2W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen2W::_0 => 0,
                    Pwmen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen2W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN3`" ]
        pub enum Pwmen3W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen3W::_0 => 0,
                    Pwmen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen3W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN4`" ]
        pub enum Pwmen4W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen4W::_0 => 0,
                    Pwmen4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen4W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN5`" ]
        pub enum Pwmen5W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen5W::_0 => 0,
                    Pwmen5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen5W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN6`" ]
        pub enum Pwmen6W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen6W::_0 => 0,
                    Pwmen6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen6W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN7`" ]
        pub enum Pwmen7W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen7W::_0 => 0,
                    Pwmen7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen7W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLTPS`" ]
        pub enum FltpsW {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltpsW::_0000 => 0,
                    FltpsW::_0001 => 1,
                    FltpsW::_0010 => 2,
                    FltpsW::_0011 => 3,
                    FltpsW::_0100 => 4,
                    FltpsW::_0101 => 5,
                    FltpsW::_0110 => 6,
                    FltpsW::_0111 => 7,
                    FltpsW::_1000 => 8,
                    FltpsW::_1001 => 9,
                    FltpsW::_1010 => 10,
                    FltpsW::_1011 => 11,
                    FltpsW::_1100 => 12,
                    FltpsW::_1101 => 13,
                    FltpsW::_1110 => 14,
                    FltpsW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltpsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(FltpsW::_0000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(FltpsW::_0001)
            }
            # [ doc = "Divide by 3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(FltpsW::_0010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(FltpsW::_0011)
            }
            # [ doc = "Divide by 5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(FltpsW::_0100)
            }
            # [ doc = "Divide by 6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(FltpsW::_0101)
            }
            # [ doc = "Divide by 7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(FltpsW::_0110)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(FltpsW::_0111)
            }
            # [ doc = "Divide by 9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(FltpsW::_1000)
            }
            # [ doc = "Divide by 10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(FltpsW::_1001)
            }
            # [ doc = "Divide by 11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(FltpsW::_1010)
            }
            # [ doc = "Divide by 12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(FltpsW::_1011)
            }
            # [ doc = "Divide by 13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(FltpsW::_1100)
            }
            # [ doc = "Divide by 14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(FltpsW::_1101)
            }
            # [ doc = "Divide by 15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(FltpsW::_1110)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(FltpsW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&self) -> ClksR {
                ClksR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&self) -> CpwmsR {
                CpwmsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Reload Flag" ]
            # [ inline ( always ) ]
            pub fn rf(&self) -> RfR {
                RfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 7;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&self) -> ToieR {
                ToieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Timer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn tof(&self) -> TofR {
                TofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&self) -> Pwmen0R {
                Pwmen0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&self) -> Pwmen1R {
                Pwmen1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&self) -> Pwmen2R {
                Pwmen2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&self) -> Pwmen3R {
                Pwmen3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&self) -> Pwmen4R {
                Pwmen4R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&self) -> Pwmen5R {
                Pwmen5R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&self) -> Pwmen6R {
                Pwmen6R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&self) -> Pwmen7R {
                Pwmen7R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&self) -> FltpsR {
                FltpsR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&mut self) -> _ClksW {
                _ClksW { w: self }
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&mut self) -> _CpwmsW {
                _CpwmsW { w: self }
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&mut self) -> _ToieW {
                _ToieW { w: self }
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&mut self) -> _Pwmen0W {
                _Pwmen0W { w: self }
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&mut self) -> _Pwmen1W {
                _Pwmen1W { w: self }
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&mut self) -> _Pwmen2W {
                _Pwmen2W { w: self }
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&mut self) -> _Pwmen3W {
                _Pwmen3W { w: self }
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&mut self) -> _Pwmen4W {
                _Pwmen4W { w: self }
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&mut self) -> _Pwmen5W {
                _Pwmen5W { w: self }
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&mut self) -> _Pwmen6W {
                _Pwmen6W { w: self }
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&mut self) -> _Pwmen7W {
                _Pwmen7W { w: self }
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&mut self) -> _FltpsW {
                _FltpsW { w: self }
            }
        }
    }
    # [ doc = "Counter" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CountR {
            bits: u16,
        }
        impl CountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CountW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CountW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&self) -> CountR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&mut self) -> _CountW {
                _CountW { w: self }
            }
        }
    }
    # [ doc = "Modulo" ]
    pub struct Mod {
        register: VolatileCell<u32>,
    }
    # [ doc = "Modulo" ]
    pub mod mod_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mod {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ModR {
            bits: u16,
        }
        impl ModR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&self) -> ModR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ModR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&mut self) -> _ModW {
                _ModW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C0sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c0sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C0v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c0v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C1sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c1sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C1v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c1v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C2sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c2sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C2v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c2v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C3sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c3sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C3v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c3v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C4sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c4sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C4v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c4v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C5sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c5sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C5v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c5v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C6sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c6sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C6v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c6v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C7sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c7sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C7v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c7v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Counter Initial Value" ]
    pub struct Cntin {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter Initial Value" ]
    pub mod cntin {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cntin {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct InitR {
            bits: u16,
        }
        impl InitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&self) -> InitR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                InitR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
        }
    }
    # [ doc = "Capture And Compare Status" ]
    pub struct Status {
        register: VolatileCell<u32>,
    }
    # [ doc = "Capture And Compare Status" ]
    pub mod status {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Status {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `CH0F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch0fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0fR::_0 => 0,
                    Ch0fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0fR {
                match bits {
                    0 => Ch0fR::_0,
                    1 => Ch0fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1fR::_0 => 0,
                    Ch1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1fR {
                match bits {
                    0 => Ch1fR::_0,
                    1 => Ch1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2fR::_0 => 0,
                    Ch2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2fR {
                match bits {
                    0 => Ch2fR::_0,
                    1 => Ch2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch3fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3fR::_0 => 0,
                    Ch3fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3fR {
                match bits {
                    0 => Ch3fR::_0,
                    1 => Ch3fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch4fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4fR::_0 => 0,
                    Ch4fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4fR {
                match bits {
                    0 => Ch4fR::_0,
                    1 => Ch4fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch5fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5fR::_0 => 0,
                    Ch5fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5fR {
                match bits {
                    0 => Ch5fR::_0,
                    1 => Ch5fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch6fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6fR::_0 => 0,
                    Ch6fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6fR {
                match bits {
                    0 => Ch6fR::_0,
                    1 => Ch6fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch7fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7fR::_0 => 0,
                    Ch7fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7fR {
                match bits {
                    0 => Ch7fR::_0,
                    1 => Ch7fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7fR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Flag" ]
            # [ inline ( always ) ]
            pub fn ch0f(&self) -> Ch0fR {
                Ch0fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ch1f(&self) -> Ch1fR {
                Ch1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ch2f(&self) -> Ch2fR {
                Ch2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Flag" ]
            # [ inline ( always ) ]
            pub fn ch3f(&self) -> Ch3fR {
                Ch3fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Flag" ]
            # [ inline ( always ) ]
            pub fn ch4f(&self) -> Ch4fR {
                Ch4fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Flag" ]
            # [ inline ( always ) ]
            pub fn ch5f(&self) -> Ch5fR {
                Ch5fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Flag" ]
            # [ inline ( always ) ]
            pub fn ch6f(&self) -> Ch6fR {
                Ch6fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Flag" ]
            # [ inline ( always ) ]
            pub fn ch7f(&self) -> Ch7fR {
                Ch7fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
    }
    # [ doc = "Features Mode Selection" ]
    pub struct Mode {
        register: VolatileCell<u32>,
    }
    # [ doc = "Features Mode Selection" ]
    pub mod mode {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mode {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FTMEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FtmenR {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FtmenR::_0 => 0,
                    FtmenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FtmenR {
                match bits {
                    0 => FtmenR::_0,
                    1 => FtmenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FtmenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FtmenR::_1
            }
        }
        # [ doc = "Possible values of the field `WPDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpdisR {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpdisR::_0 => 0,
                    WpdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpdisR {
                match bits {
                    0 => WpdisR::_0,
                    1 => WpdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpdisR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PwmsyncR {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PwmsyncR::_0 => 0,
                    PwmsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PwmsyncR {
                match bits {
                    0 => PwmsyncR::_0,
                    1 => PwmsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PwmsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PwmsyncR::_1
            }
        }
        # [ doc = "Possible values of the field `CAPTEST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CaptestR {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CaptestR::_0 => 0,
                    CaptestR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CaptestR {
                match bits {
                    0 => CaptestR::_0,
                    1 => CaptestR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CaptestR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CaptestR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultmR {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultmR::_00 => 0,
                    FaultmR::_01 => 1,
                    FaultmR::_10 => 2,
                    FaultmR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultmR {
                match bits {
                    0 => FaultmR::_00,
                    1 => FaultmR::_01,
                    2 => FaultmR::_10,
                    3 => FaultmR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FaultmR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FaultmR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FaultmR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FaultmR::_11
            }
        }
        # [ doc = "Possible values of the field `FAULTIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultieR {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultieR::_0 => 0,
                    FaultieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultieR {
                match bits {
                    0 => FaultieR::_0,
                    1 => FaultieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FTMEN`" ]
        pub enum FtmenW {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FtmenW::_0 => 0,
                    FtmenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FtmenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FtmenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FtmenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FtmenW::_0)
            }
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FtmenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WPDIS`" ]
        pub enum WpdisW {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpdisW::_0 => 0,
                    WpdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpdisW::_0)
            }
            # [ doc = "Write protection is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMSYNC`" ]
        pub enum PwmsyncW {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PwmsyncW::_0 => 0,
                    PwmsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PwmsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PwmsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PwmsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PwmsyncW::_0)
            }
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PwmsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CAPTEST`" ]
        pub enum CaptestW {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CaptestW::_0 => 0,
                    CaptestW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaptestW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaptestW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CaptestW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Capture test mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CaptestW::_0)
            }
            # [ doc = "Capture test mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CaptestW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTM`" ]
        pub enum FaultmW {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultmW::_00 => 0,
                    FaultmW::_01 => 1,
                    FaultmW::_10 => 2,
                    FaultmW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control is disabled for all channels." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FaultmW::_00)
            }
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FaultmW::_01)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FaultmW::_10)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FaultmW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTIE`" ]
        pub enum FaultieW {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultieW::_0 => 0,
                    FaultieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FaultieW::_0)
            }
            # [ doc = "Fault control interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FaultieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&self) -> FtmenR {
                FtmenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&self) -> WpdisR {
                WpdisR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&self) -> PwmsyncR {
                PwmsyncR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&self) -> CaptestR {
                CaptestR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&self) -> FaultmR {
                FaultmR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&self) -> FaultieR {
                FaultieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 7;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&mut self) -> _FtmenW {
                _FtmenW { w: self }
            }
            # [ doc = "Bit 1 - Initialize The Channels Output" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&mut self) -> _WpdisW {
                _WpdisW { w: self }
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&mut self) -> _PwmsyncW {
                _PwmsyncW { w: self }
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&mut self) -> _CaptestW {
                _CaptestW { w: self }
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&mut self) -> _FaultmW {
                _FaultmW { w: self }
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&mut self) -> _FaultieW {
                _FaultieW { w: self }
            }
        }
    }
    # [ doc = "Synchronization" ]
    pub struct Sync {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization" ]
    pub mod sync {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sync {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CNTMIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntminR {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntminR::_0 => 0,
                    CntminR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntminR {
                match bits {
                    0 => CntminR::_0,
                    1 => CntminR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntminR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntminR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTMAX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntmaxR {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntmaxR::_0 => 0,
                    CntmaxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntmaxR {
                match bits {
                    0 => CntmaxR::_0,
                    1 => CntmaxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntmaxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntmaxR::_1
            }
        }
        # [ doc = "Possible values of the field `REINIT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReinitR {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReinitR::_0 => 0,
                    ReinitR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReinitR {
                match bits {
                    0 => ReinitR::_0,
                    1 => ReinitR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReinitR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReinitR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCHOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchomR {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchomR::_0 => 0,
                    SynchomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchomR {
                match bits {
                    0 => SynchomR::_0,
                    1 => SynchomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchomR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig0R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig0R::_0 => 0,
                    Trig0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig0R {
                match bits {
                    0 => Trig0R::_0,
                    1 => Trig0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig0R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig1R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig1R::_0 => 0,
                    Trig1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig1R {
                match bits {
                    0 => Trig1R::_0,
                    1 => Trig1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig1R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig2R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig2R::_0 => 0,
                    Trig2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig2R {
                match bits {
                    0 => Trig2R::_0,
                    1 => Trig2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig2R::_1
            }
        }
        # [ doc = "Possible values of the field `SWSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsyncR {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsyncR::_0 => 0,
                    SwsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsyncR {
                match bits {
                    0 => SwsyncR::_0,
                    1 => SwsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsyncR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CNTMIN`" ]
        pub enum CntminW {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntminW::_0 => 0,
                    CntminW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntminW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntminW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntminW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minimum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntminW::_0)
            }
            # [ doc = "The minimum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntminW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTMAX`" ]
        pub enum CntmaxW {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntmaxW::_0 => 0,
                    CntmaxW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntmaxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntmaxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntmaxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The maximum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntmaxW::_0)
            }
            # [ doc = "The maximum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntmaxW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REINIT`" ]
        pub enum ReinitW {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReinitW::_0 => 0,
                    ReinitW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReinitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReinitW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReinitW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter continues to count normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReinitW::_0)
            }
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReinitW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCHOM`" ]
        pub enum SynchomW {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SynchomW::_0 => 0,
                    SynchomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SynchomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SynchomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SynchomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SynchomW::_0)
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SynchomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG0`" ]
        pub enum Trig0W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig0W::_0 => 0,
                    Trig0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig0W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG1`" ]
        pub enum Trig1W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig1W::_0 => 0,
                    Trig1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig1W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG2`" ]
        pub enum Trig2W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig2W::_0 => 0,
                    Trig2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig2W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSYNC`" ]
        pub enum SwsyncW {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsyncW::_0 => 0,
                    SwsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software trigger is not selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsyncW::_0)
            }
            # [ doc = "Software trigger is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&self) -> CntminR {
                CntminR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&self) -> CntmaxR {
                CntmaxR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&self) -> ReinitR {
                ReinitR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&self) -> SynchomR {
                SynchomR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&self) -> Trig0R {
                Trig0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&self) -> Trig1R {
                Trig1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&self) -> Trig2R {
                Trig2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&self) -> SwsyncR {
                SwsyncR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&mut self) -> _CntminW {
                _CntminW { w: self }
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&mut self) -> _CntmaxW {
                _CntmaxW { w: self }
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&mut self) -> _ReinitW {
                _ReinitW { w: self }
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&mut self) -> _SynchomW {
                _SynchomW { w: self }
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&mut self) -> _Trig0W {
                _Trig0W { w: self }
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&mut self) -> _Trig1W {
                _Trig1W { w: self }
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&mut self) -> _Trig2W {
                _Trig2W { w: self }
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&mut self) -> _SwsyncW {
                _SwsyncW { w: self }
            }
        }
    }
    # [ doc = "Initial State For Channels Output" ]
    pub struct Outinit {
        register: VolatileCell<u32>,
    }
    # [ doc = "Initial State For Channels Output" ]
    pub mod outinit {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outinit {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0oiR::_0 => 0,
                    Ch0oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0oiR {
                match bits {
                    0 => Ch0oiR::_0,
                    1 => Ch0oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1oiR::_0 => 0,
                    Ch1oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1oiR {
                match bits {
                    0 => Ch1oiR::_0,
                    1 => Ch1oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2oiR::_0 => 0,
                    Ch2oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2oiR {
                match bits {
                    0 => Ch2oiR::_0,
                    1 => Ch2oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3oiR::_0 => 0,
                    Ch3oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3oiR {
                match bits {
                    0 => Ch3oiR::_0,
                    1 => Ch3oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4oiR::_0 => 0,
                    Ch4oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4oiR {
                match bits {
                    0 => Ch4oiR::_0,
                    1 => Ch4oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5oiR::_0 => 0,
                    Ch5oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5oiR {
                match bits {
                    0 => Ch5oiR::_0,
                    1 => Ch5oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6oiR::_0 => 0,
                    Ch6oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6oiR {
                match bits {
                    0 => Ch6oiR::_0,
                    1 => Ch6oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7oiR::_0 => 0,
                    Ch7oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7oiR {
                match bits {
                    0 => Ch7oiR::_0,
                    1 => Ch7oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7oiR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OI`" ]
        pub enum Ch0oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0oiW::_0 => 0,
                    Ch0oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OI`" ]
        pub enum Ch1oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1oiW::_0 => 0,
                    Ch1oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OI`" ]
        pub enum Ch2oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2oiW::_0 => 0,
                    Ch2oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OI`" ]
        pub enum Ch3oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3oiW::_0 => 0,
                    Ch3oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OI`" ]
        pub enum Ch4oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4oiW::_0 => 0,
                    Ch4oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OI`" ]
        pub enum Ch5oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5oiW::_0 => 0,
                    Ch5oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OI`" ]
        pub enum Ch6oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6oiW::_0 => 0,
                    Ch6oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OI`" ]
        pub enum Ch7oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7oiW::_0 => 0,
                    Ch7oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&self) -> Ch0oiR {
                Ch0oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&self) -> Ch1oiR {
                Ch1oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&self) -> Ch2oiR {
                Ch2oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&self) -> Ch3oiR {
                Ch3oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&self) -> Ch4oiR {
                Ch4oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&self) -> Ch5oiR {
                Ch5oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&self) -> Ch6oiR {
                Ch6oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&self) -> Ch7oiR {
                Ch7oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&mut self) -> _Ch0oiW {
                _Ch0oiW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&mut self) -> _Ch1oiW {
                _Ch1oiW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&mut self) -> _Ch2oiW {
                _Ch2oiW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&mut self) -> _Ch3oiW {
                _Ch3oiW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&mut self) -> _Ch4oiW {
                _Ch4oiW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&mut self) -> _Ch5oiW {
                _Ch5oiW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&mut self) -> _Ch6oiW {
                _Ch6oiW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&mut self) -> _Ch7oiW {
                _Ch7oiW { w: self }
            }
        }
    }
    # [ doc = "Output Mask" ]
    pub struct Outmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Output Mask" ]
    pub mod outmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0omR::_0 => 0,
                    Ch0omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0omR {
                match bits {
                    0 => Ch0omR::_0,
                    1 => Ch0omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1omR::_0 => 0,
                    Ch1omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1omR {
                match bits {
                    0 => Ch1omR::_0,
                    1 => Ch1omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2omR::_0 => 0,
                    Ch2omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2omR {
                match bits {
                    0 => Ch2omR::_0,
                    1 => Ch2omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3omR::_0 => 0,
                    Ch3omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3omR {
                match bits {
                    0 => Ch3omR::_0,
                    1 => Ch3omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4omR::_0 => 0,
                    Ch4omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4omR {
                match bits {
                    0 => Ch4omR::_0,
                    1 => Ch4omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5omR::_0 => 0,
                    Ch5omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5omR {
                match bits {
                    0 => Ch5omR::_0,
                    1 => Ch5omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6omR::_0 => 0,
                    Ch6omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6omR {
                match bits {
                    0 => Ch6omR::_0,
                    1 => Ch6omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7omR::_0 => 0,
                    Ch7omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7omR {
                match bits {
                    0 => Ch7omR::_0,
                    1 => Ch7omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7omR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OM`" ]
        pub enum Ch0omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0omW::_0 => 0,
                    Ch0omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OM`" ]
        pub enum Ch1omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1omW::_0 => 0,
                    Ch1omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OM`" ]
        pub enum Ch2omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2omW::_0 => 0,
                    Ch2omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OM`" ]
        pub enum Ch3omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3omW::_0 => 0,
                    Ch3omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OM`" ]
        pub enum Ch4omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4omW::_0 => 0,
                    Ch4omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OM`" ]
        pub enum Ch5omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5omW::_0 => 0,
                    Ch5omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OM`" ]
        pub enum Ch6omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6omW::_0 => 0,
                    Ch6omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OM`" ]
        pub enum Ch7omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7omW::_0 => 0,
                    Ch7omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&self) -> Ch0omR {
                Ch0omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&self) -> Ch1omR {
                Ch1omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&self) -> Ch2omR {
                Ch2omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&self) -> Ch3omR {
                Ch3omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&self) -> Ch4omR {
                Ch4omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&self) -> Ch5omR {
                Ch5omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&self) -> Ch6omR {
                Ch6omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&self) -> Ch7omR {
                Ch7omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&mut self) -> _Ch0omW {
                _Ch0omW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&mut self) -> _Ch1omW {
                _Ch1omW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&mut self) -> _Ch2omW {
                _Ch2omW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&mut self) -> _Ch3omW {
                _Ch3omW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&mut self) -> _Ch4omW {
                _Ch4omW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&mut self) -> _Ch5omW {
                _Ch5omW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&mut self) -> _Ch6omW {
                _Ch6omW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&mut self) -> _Ch7omW {
                _Ch7omW { w: self }
            }
        }
    }
    # [ doc = "Function For Linked Channels" ]
    pub struct Combine {
        register: VolatileCell<u32>,
    }
    # [ doc = "Function For Linked Channels" ]
    pub mod combine {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Combine {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine0R {
            bits: u8,
        }
        impl Combine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp0R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp0R::_0 => 0,
                    Comp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp0R {
                match bits {
                    0 => Comp0R::_0,
                    1 => Comp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen0R {
            bits: u8,
        }
        impl Decapen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap0R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap0R::_0 => 0,
                    Decap0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap0R {
                match bits {
                    0 => Decap0R::_0,
                    1 => Decap0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap0R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten0R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten0R::_0 => 0,
                    Dten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten0R {
                match bits {
                    0 => Dten0R::_0,
                    1 => Dten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten0R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen0R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen0R::_0 => 0,
                    Syncen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen0R {
                match bits {
                    0 => Syncen0R::_0,
                    1 => Syncen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten0R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten0R::_0 => 0,
                    Faulten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten0R {
                match bits {
                    0 => Faulten0R::_0,
                    1 => Faulten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine0R {
            bits: u8,
        }
        impl Mcombine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine1R {
            bits: u8,
        }
        impl Combine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp1R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp1R::_0 => 0,
                    Comp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp1R {
                match bits {
                    0 => Comp1R::_0,
                    1 => Comp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen1R {
            bits: u8,
        }
        impl Decapen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap1R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap1R::_0 => 0,
                    Decap1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap1R {
                match bits {
                    0 => Decap1R::_0,
                    1 => Decap1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap1R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten1R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten1R::_0 => 0,
                    Dten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten1R {
                match bits {
                    0 => Dten1R::_0,
                    1 => Dten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten1R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen1R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen1R::_0 => 0,
                    Syncen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen1R {
                match bits {
                    0 => Syncen1R::_0,
                    1 => Syncen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten1R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten1R::_0 => 0,
                    Faulten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten1R {
                match bits {
                    0 => Faulten1R::_0,
                    1 => Faulten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine1R {
            bits: u8,
        }
        impl Mcombine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine2R {
            bits: u8,
        }
        impl Combine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp2R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp2R::_0 => 0,
                    Comp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp2R {
                match bits {
                    0 => Comp2R::_0,
                    1 => Comp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen2R {
            bits: u8,
        }
        impl Decapen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap2R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap2R::_0 => 0,
                    Decap2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap2R {
                match bits {
                    0 => Decap2R::_0,
                    1 => Decap2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap2R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten2R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten2R::_0 => 0,
                    Dten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten2R {
                match bits {
                    0 => Dten2R::_0,
                    1 => Dten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten2R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen2R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen2R::_0 => 0,
                    Syncen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen2R {
                match bits {
                    0 => Syncen2R::_0,
                    1 => Syncen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten2R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten2R::_0 => 0,
                    Faulten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten2R {
                match bits {
                    0 => Faulten2R::_0,
                    1 => Faulten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine2R {
            bits: u8,
        }
        impl Mcombine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine3R {
            bits: u8,
        }
        impl Combine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp3R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp3R::_0 => 0,
                    Comp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp3R {
                match bits {
                    0 => Comp3R::_0,
                    1 => Comp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen3R {
            bits: u8,
        }
        impl Decapen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap3R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap3R::_0 => 0,
                    Decap3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap3R {
                match bits {
                    0 => Decap3R::_0,
                    1 => Decap3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap3R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten3R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten3R::_0 => 0,
                    Dten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten3R {
                match bits {
                    0 => Dten3R::_0,
                    1 => Dten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten3R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen3R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen3R::_0 => 0,
                    Syncen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen3R {
                match bits {
                    0 => Syncen3R::_0,
                    1 => Syncen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten3R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten3R::_0 => 0,
                    Faulten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten3R {
                match bits {
                    0 => Faulten3R::_0,
                    1 => Faulten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine3R {
            bits: u8,
        }
        impl Mcombine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP0`" ]
        pub enum Comp0W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp0W::_0 => 0,
                    Comp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp0W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP0`" ]
        pub enum Decap0W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap0W::_0 => 0,
                    Decap0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap0W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN0`" ]
        pub enum Dten0W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten0W::_0 => 0,
                    Dten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten0W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN0`" ]
        pub enum Syncen0W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen0W::_0 => 0,
                    Syncen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen0W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN0`" ]
        pub enum Faulten0W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten0W::_0 => 0,
                    Faulten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten0W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP1`" ]
        pub enum Comp1W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp1W::_0 => 0,
                    Comp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp1W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP1`" ]
        pub enum Decap1W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap1W::_0 => 0,
                    Decap1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap1W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN1`" ]
        pub enum Dten1W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten1W::_0 => 0,
                    Dten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten1W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN1`" ]
        pub enum Syncen1W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen1W::_0 => 0,
                    Syncen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen1W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN1`" ]
        pub enum Faulten1W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten1W::_0 => 0,
                    Faulten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten1W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP2`" ]
        pub enum Comp2W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp2W::_0 => 0,
                    Comp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp2W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP2`" ]
        pub enum Decap2W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap2W::_0 => 0,
                    Decap2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap2W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN2`" ]
        pub enum Dten2W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten2W::_0 => 0,
                    Dten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten2W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN2`" ]
        pub enum Syncen2W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen2W::_0 => 0,
                    Syncen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen2W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN2`" ]
        pub enum Faulten2W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten2W::_0 => 0,
                    Faulten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten2W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP3`" ]
        pub enum Comp3W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp3W::_0 => 0,
                    Comp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp3W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP3`" ]
        pub enum Decap3W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap3W::_0 => 0,
                    Decap3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap3W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN3`" ]
        pub enum Dten3W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten3W::_0 => 0,
                    Dten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten3W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN3`" ]
        pub enum Syncen3W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen3W::_0 => 0,
                    Syncen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen3W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN3`" ]
        pub enum Faulten3W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten3W::_0 => 0,
                    Faulten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten3W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&self) -> Combine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine0R { bits }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&self) -> Comp0R {
                Comp0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&self) -> Decapen0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen0R { bits }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&self) -> Decap0R {
                Decap0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&self) -> Dten0R {
                Dten0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&self) -> Syncen0R {
                Syncen0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&self) -> Faulten0R {
                Faulten0R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&self) -> Mcombine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine0R { bits }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&self) -> Combine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine1R { bits }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&self) -> Comp1R {
                Comp1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&self) -> Decapen1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen1R { bits }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&self) -> Decap1R {
                Decap1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&self) -> Dten1R {
                Dten1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&self) -> Syncen1R {
                Syncen1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&self) -> Faulten1R {
                Faulten1R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 14;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&self) -> Mcombine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine1R { bits }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&self) -> Combine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine2R { bits }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&self) -> Comp2R {
                Comp2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 17;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&self) -> Decapen2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen2R { bits }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&self) -> Decap2R {
                Decap2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&self) -> Dten2R {
                Dten2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&self) -> Syncen2R {
                Syncen2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 21;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&self) -> Faulten2R {
                Faulten2R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 22;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&self) -> Mcombine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine2R { bits }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&self) -> Combine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine3R { bits }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&self) -> Comp3R {
                Comp3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&self) -> Decapen3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen3R { bits }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&self) -> Decap3R {
                Decap3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&self) -> Dten3R {
                Dten3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&self) -> Syncen3R {
                Syncen3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 29;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&self) -> Faulten3R {
                Faulten3R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 30;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&self) -> Mcombine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine3R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&mut self) -> _Combine0W {
                _Combine0W { w: self }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&mut self) -> _Comp0W {
                _Comp0W { w: self }
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&mut self) -> _Decapen0W {
                _Decapen0W { w: self }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&mut self) -> _Decap0W {
                _Decap0W { w: self }
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&mut self) -> _Dten0W {
                _Dten0W { w: self }
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&mut self) -> _Syncen0W {
                _Syncen0W { w: self }
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&mut self) -> _Faulten0W {
                _Faulten0W { w: self }
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&mut self) -> _Mcombine0W {
                _Mcombine0W { w: self }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&mut self) -> _Combine1W {
                _Combine1W { w: self }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&mut self) -> _Comp1W {
                _Comp1W { w: self }
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&mut self) -> _Decapen1W {
                _Decapen1W { w: self }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&mut self) -> _Decap1W {
                _Decap1W { w: self }
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&mut self) -> _Dten1W {
                _Dten1W { w: self }
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&mut self) -> _Syncen1W {
                _Syncen1W { w: self }
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&mut self) -> _Faulten1W {
                _Faulten1W { w: self }
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&mut self) -> _Mcombine1W {
                _Mcombine1W { w: self }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&mut self) -> _Combine2W {
                _Combine2W { w: self }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&mut self) -> _Comp2W {
                _Comp2W { w: self }
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&mut self) -> _Decapen2W {
                _Decapen2W { w: self }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&mut self) -> _Decap2W {
                _Decap2W { w: self }
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&mut self) -> _Dten2W {
                _Dten2W { w: self }
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&mut self) -> _Syncen2W {
                _Syncen2W { w: self }
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&mut self) -> _Faulten2W {
                _Faulten2W { w: self }
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&mut self) -> _Mcombine2W {
                _Mcombine2W { w: self }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&mut self) -> _Combine3W {
                _Combine3W { w: self }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&mut self) -> _Comp3W {
                _Comp3W { w: self }
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&mut self) -> _Decapen3W {
                _Decapen3W { w: self }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&mut self) -> _Decap3W {
                _Decap3W { w: self }
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&mut self) -> _Dten3W {
                _Dten3W { w: self }
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&mut self) -> _Syncen3W {
                _Syncen3W { w: self }
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&mut self) -> _Faulten3W {
                _Faulten3W { w: self }
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&mut self) -> _Mcombine3W {
                _Mcombine3W { w: self }
            }
        }
    }
    # [ doc = "Deadtime Configuration" ]
    pub struct Deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Deadtime Configuration" ]
    pub mod deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "FTM External Trigger" ]
    pub struct Exttrig {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM External Trigger" ]
    pub mod exttrig {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Exttrig {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH2TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2trigR::_0 => 0,
                    Ch2trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2trigR {
                match bits {
                    0 => Ch2trigR::_0,
                    1 => Ch2trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3trigR::_0 => 0,
                    Ch3trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3trigR {
                match bits {
                    0 => Ch3trigR::_0,
                    1 => Ch3trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4trigR::_0 => 0,
                    Ch4trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4trigR {
                match bits {
                    0 => Ch4trigR::_0,
                    1 => Ch4trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5trigR::_0 => 0,
                    Ch5trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5trigR {
                match bits {
                    0 => Ch5trigR::_0,
                    1 => Ch5trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0trigR::_0 => 0,
                    Ch0trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0trigR {
                match bits {
                    0 => Ch0trigR::_0,
                    1 => Ch0trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1trigR::_0 => 0,
                    Ch1trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1trigR {
                match bits {
                    0 => Ch1trigR::_0,
                    1 => Ch1trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1trigR::_1
            }
        }
        # [ doc = "Possible values of the field `INITTRIGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InittrigenR {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InittrigenR::_0 => 0,
                    InittrigenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InittrigenR {
                match bits {
                    0 => InittrigenR::_0,
                    1 => InittrigenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InittrigenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InittrigenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigfR {
            # [ doc = "No channel trigger was generated." ]
            _0,
            # [ doc = "A channel trigger was generated." ]
            _1,
        }
        impl TrigfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigfR::_0 => 0,
                    TrigfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigfR {
                match bits {
                    0 => TrigfR::_0,
                    1 => TrigfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigfR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6trigR::_0 => 0,
                    Ch6trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6trigR {
                match bits {
                    0 => Ch6trigR::_0,
                    1 => Ch6trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7trigR::_0 => 0,
                    Ch7trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7trigR {
                match bits {
                    0 => Ch7trigR::_0,
                    1 => Ch7trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7trigR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH2TRIG`" ]
        pub enum Ch2trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2trigW::_0 => 0,
                    Ch2trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3TRIG`" ]
        pub enum Ch3trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3trigW::_0 => 0,
                    Ch3trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4TRIG`" ]
        pub enum Ch4trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4trigW::_0 => 0,
                    Ch4trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5TRIG`" ]
        pub enum Ch5trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5trigW::_0 => 0,
                    Ch5trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0TRIG`" ]
        pub enum Ch0trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0trigW::_0 => 0,
                    Ch0trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1TRIG`" ]
        pub enum Ch1trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1trigW::_0 => 0,
                    Ch1trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INITTRIGEN`" ]
        pub enum InittrigenW {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InittrigenW::_0 => 0,
                    InittrigenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InittrigenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InittrigenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InittrigenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of initialization trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InittrigenW::_0)
            }
            # [ doc = "The generation of initialization trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InittrigenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6TRIG`" ]
        pub enum Ch6trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6trigW::_0 => 0,
                    Ch6trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7TRIG`" ]
        pub enum Ch7trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7trigW::_0 => 0,
                    Ch7trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&self) -> Ch2trigR {
                Ch2trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&self) -> Ch3trigR {
                Ch3trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&self) -> Ch4trigR {
                Ch4trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&self) -> Ch5trigR {
                Ch5trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&self) -> Ch0trigR {
                Ch0trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&self) -> Ch1trigR {
                Ch1trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&self) -> InittrigenR {
                InittrigenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 6;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Channel Trigger Flag" ]
            # [ inline ( always ) ]
            pub fn trigf(&self) -> TrigfR {
                TrigfR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&self) -> Ch6trigR {
                Ch6trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&self) -> Ch7trigR {
                Ch7trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&mut self) -> _Ch2trigW {
                _Ch2trigW { w: self }
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&mut self) -> _Ch3trigW {
                _Ch3trigW { w: self }
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&mut self) -> _Ch4trigW {
                _Ch4trigW { w: self }
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&mut self) -> _Ch5trigW {
                _Ch5trigW { w: self }
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&mut self) -> _Ch0trigW {
                _Ch0trigW { w: self }
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&mut self) -> _Ch1trigW {
                _Ch1trigW { w: self }
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&mut self) -> _InittrigenW {
                _InittrigenW { w: self }
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&mut self) -> _Ch6trigW {
                _Ch6trigW { w: self }
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&mut self) -> _Ch7trigW {
                _Ch7trigW { w: self }
            }
        }
    }
    # [ doc = "Channels Polarity" ]
    pub struct Pol {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channels Polarity" ]
    pub mod pol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `POL0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol0R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol0R::_0 => 0,
                    Pol0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol0R {
                match bits {
                    0 => Pol0R::_0,
                    1 => Pol0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol0R::_1
            }
        }
        # [ doc = "Possible values of the field `POL1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol1R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol1R::_0 => 0,
                    Pol1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol1R {
                match bits {
                    0 => Pol1R::_0,
                    1 => Pol1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol1R::_1
            }
        }
        # [ doc = "Possible values of the field `POL2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol2R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol2R::_0 => 0,
                    Pol2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol2R {
                match bits {
                    0 => Pol2R::_0,
                    1 => Pol2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol2R::_1
            }
        }
        # [ doc = "Possible values of the field `POL3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol3R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol3R::_0 => 0,
                    Pol3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol3R {
                match bits {
                    0 => Pol3R::_0,
                    1 => Pol3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol3R::_1
            }
        }
        # [ doc = "Possible values of the field `POL4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol4R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol4R::_0 => 0,
                    Pol4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol4R {
                match bits {
                    0 => Pol4R::_0,
                    1 => Pol4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol4R::_1
            }
        }
        # [ doc = "Possible values of the field `POL5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol5R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol5R::_0 => 0,
                    Pol5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol5R {
                match bits {
                    0 => Pol5R::_0,
                    1 => Pol5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol5R::_1
            }
        }
        # [ doc = "Possible values of the field `POL6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol6R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol6R::_0 => 0,
                    Pol6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol6R {
                match bits {
                    0 => Pol6R::_0,
                    1 => Pol6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol6R::_1
            }
        }
        # [ doc = "Possible values of the field `POL7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol7R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol7R::_0 => 0,
                    Pol7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol7R {
                match bits {
                    0 => Pol7R::_0,
                    1 => Pol7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol7R::_1
            }
        }
        # [ doc = "Values that can be written to the field `POL0`" ]
        pub enum Pol0W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol0W::_0 => 0,
                    Pol0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol0W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL1`" ]
        pub enum Pol1W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol1W::_0 => 0,
                    Pol1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol1W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL2`" ]
        pub enum Pol2W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol2W::_0 => 0,
                    Pol2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol2W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL3`" ]
        pub enum Pol3W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol3W::_0 => 0,
                    Pol3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol3W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL4`" ]
        pub enum Pol4W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol4W::_0 => 0,
                    Pol4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol4W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL5`" ]
        pub enum Pol5W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol5W::_0 => 0,
                    Pol5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol5W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL6`" ]
        pub enum Pol6W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol6W::_0 => 0,
                    Pol6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol6W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL7`" ]
        pub enum Pol7W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol7W::_0 => 0,
                    Pol7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol7W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&self) -> Pol0R {
                Pol0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&self) -> Pol1R {
                Pol1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&self) -> Pol2R {
                Pol2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&self) -> Pol3R {
                Pol3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&self) -> Pol4R {
                Pol4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&self) -> Pol5R {
                Pol5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&self) -> Pol6R {
                Pol6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&self) -> Pol7R {
                Pol7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&mut self) -> _Pol0W {
                _Pol0W { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&mut self) -> _Pol1W {
                _Pol1W { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&mut self) -> _Pol2W {
                _Pol2W { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&mut self) -> _Pol3W {
                _Pol3W { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&mut self) -> _Pol4W {
                _Pol4W { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&mut self) -> _Pol5W {
                _Pol5W { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&mut self) -> _Pol6W {
                _Pol6W { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&mut self) -> _Pol7W {
                _Pol7W { w: self }
            }
        }
    }
    # [ doc = "Fault Mode Status" ]
    pub struct Fms {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Mode Status" ]
    pub mod fms {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fms {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULTF0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf0R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf0R::_0 => 0,
                    Faultf0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf0R {
                match bits {
                    0 => Faultf0R::_0,
                    1 => Faultf0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf1R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf1R::_0 => 0,
                    Faultf1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf1R {
                match bits {
                    0 => Faultf1R::_0,
                    1 => Faultf1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf2R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf2R::_0 => 0,
                    Faultf2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf2R {
                match bits {
                    0 => Faultf2R::_0,
                    1 => Faultf2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf3R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf3R::_0 => 0,
                    Faultf3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf3R {
                match bits {
                    0 => Faultf3R::_0,
                    1 => Faultf3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultinR {
            # [ doc = "The logic OR of the enabled fault inputs is 0." ]
            _0,
            # [ doc = "The logic OR of the enabled fault inputs is 1." ]
            _1,
        }
        impl FaultinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultinR::_0 => 0,
                    FaultinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultinR {
                match bits {
                    0 => FaultinR::_0,
                    1 => FaultinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultinR::_1
            }
        }
        # [ doc = "Possible values of the field `WPEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpenR {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpenR::_0 => 0,
                    WpenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpenR {
                match bits {
                    0 => WpenR::_0,
                    1 => WpenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpenR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultfR {
            # [ doc = "No fault condition was detected." ]
            _0,
            # [ doc = "A fault condition was detected." ]
            _1,
        }
        impl FaultfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultfR::_0 => 0,
                    FaultfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultfR {
                match bits {
                    0 => FaultfR::_0,
                    1 => FaultfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WPEN`" ]
        pub enum WpenW {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpenW::_0 => 0,
                    WpenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpenW::_0)
            }
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Detection Flag 0" ]
            # [ inline ( always ) ]
            pub fn faultf0(&self) -> Faultf0R {
                Faultf0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Detection Flag 1" ]
            # [ inline ( always ) ]
            pub fn faultf1(&self) -> Faultf1R {
                Faultf1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Detection Flag 2" ]
            # [ inline ( always ) ]
            pub fn faultf2(&self) -> Faultf2R {
                Faultf2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Detection Flag 3" ]
            # [ inline ( always ) ]
            pub fn faultf3(&self) -> Faultf3R {
                Faultf3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Fault Inputs" ]
            # [ inline ( always ) ]
            pub fn faultin(&self) -> FaultinR {
                FaultinR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&self) -> WpenR {
                WpenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Fault Detection Flag" ]
            # [ inline ( always ) ]
            pub fn faultf(&self) -> FaultfR {
                FaultfR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&mut self) -> _WpenW {
                _WpenW { w: self }
            }
        }
    }
    # [ doc = "Input Capture Filter Control" ]
    pub struct Filter {
        register: VolatileCell<u32>,
    }
    # [ doc = "Input Capture Filter Control" ]
    pub mod filter {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Filter {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch0fvalR {
            bits: u8,
        }
        impl Ch0fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch1fvalR {
            bits: u8,
        }
        impl Ch1fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch2fvalR {
            bits: u8,
        }
        impl Ch2fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch3fvalR {
            bits: u8,
        }
        impl Ch3fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&self) -> Ch0fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch0fvalR { bits }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&self) -> Ch1fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch1fvalR { bits }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&self) -> Ch2fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch2fvalR { bits }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&self) -> Ch3fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch3fvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&mut self) -> _Ch0fvalW {
                _Ch0fvalW { w: self }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&mut self) -> _Ch1fvalW {
                _Ch1fvalW { w: self }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&mut self) -> _Ch2fvalW {
                _Ch2fvalW { w: self }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&mut self) -> _Ch3fvalW {
                _Ch3fvalW { w: self }
            }
        }
    }
    # [ doc = "Fault Control" ]
    pub struct Fltctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Control" ]
    pub mod fltctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULT0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault0enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault0enR::_0 => 0,
                    Fault0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault0enR {
                match bits {
                    0 => Fault0enR::_0,
                    1 => Fault0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault1enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault1enR::_0 => 0,
                    Fault1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault1enR {
                match bits {
                    0 => Fault1enR::_0,
                    1 => Fault1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault2enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault2enR::_0 => 0,
                    Fault2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault2enR {
                match bits {
                    0 => Fault2enR::_0,
                    1 => Fault2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault3enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault3enR::_0 => 0,
                    Fault3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault3enR {
                match bits {
                    0 => Fault3enR::_0,
                    1 => Fault3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault3enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr0enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr0enR::_0 => 0,
                    Ffltr0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr0enR {
                match bits {
                    0 => Ffltr0enR::_0,
                    1 => Ffltr0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr1enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr1enR::_0 => 0,
                    Ffltr1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr1enR {
                match bits {
                    0 => Ffltr1enR::_0,
                    1 => Ffltr1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr2enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr2enR::_0 => 0,
                    Ffltr2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr2enR {
                match bits {
                    0 => Ffltr2enR::_0,
                    1 => Ffltr2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr3enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr3enR::_0 => 0,
                    Ffltr3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr3enR {
                match bits {
                    0 => Ffltr3enR::_0,
                    1 => Ffltr3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr3enR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FfvalR {
            bits: u8,
        }
        impl FfvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FSTATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FstateR {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FstateR::_0 => 0,
                    FstateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FstateR {
                match bits {
                    0 => FstateR::_0,
                    1 => FstateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FstateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FstateR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FAULT0EN`" ]
        pub enum Fault0enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault0enW::_0 => 0,
                    Fault0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault0enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT1EN`" ]
        pub enum Fault1enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault1enW::_0 => 0,
                    Fault1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault1enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT2EN`" ]
        pub enum Fault2enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault2enW::_0 => 0,
                    Fault2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault2enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT3EN`" ]
        pub enum Fault3enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault3enW::_0 => 0,
                    Fault3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault3enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR0EN`" ]
        pub enum Ffltr0enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr0enW::_0 => 0,
                    Ffltr0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr0enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR1EN`" ]
        pub enum Ffltr1enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr1enW::_0 => 0,
                    Ffltr1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr1enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR2EN`" ]
        pub enum Ffltr2enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr2enW::_0 => 0,
                    Ffltr2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr2enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR3EN`" ]
        pub enum Ffltr3enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr3enW::_0 => 0,
                    Ffltr3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr3enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FfvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FfvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FSTATE`" ]
        pub enum FstateW {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FstateW::_0 => 0,
                    FstateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FstateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FstateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FstateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FstateW::_0)
            }
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FstateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&self) -> Fault0enR {
                Fault0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&self) -> Fault1enR {
                Fault1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&self) -> Fault2enR {
                Fault2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&self) -> Fault3enR {
                Fault3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&self) -> Ffltr0enR {
                Ffltr0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 4;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&self) -> Ffltr1enR {
                Ffltr1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&self) -> Ffltr2enR {
                Ffltr2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&self) -> Ffltr3enR {
                Ffltr3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&self) -> FfvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FfvalR { bits }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&self) -> FstateR {
                FstateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&mut self) -> _Fault0enW {
                _Fault0enW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&mut self) -> _Fault1enW {
                _Fault1enW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&mut self) -> _Fault2enW {
                _Fault2enW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&mut self) -> _Fault3enW {
                _Fault3enW { w: self }
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&mut self) -> _Ffltr0enW {
                _Ffltr0enW { w: self }
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&mut self) -> _Ffltr1enW {
                _Ffltr1enW { w: self }
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&mut self) -> _Ffltr2enW {
                _Ffltr2enW { w: self }
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&mut self) -> _Ffltr3enW {
                _Ffltr3enW { w: self }
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&mut self) -> _FfvalW {
                _FfvalW { w: self }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&mut self) -> _FstateW {
                _FstateW { w: self }
            }
        }
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub struct Qdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub mod qdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Qdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `QUADEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadenR {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadenR::_0 => 0,
                    QuadenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadenR {
                match bits {
                    0 => QuadenR::_0,
                    1 => QuadenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadenR::_1
            }
        }
        # [ doc = "Possible values of the field `TOFDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofdirR {
            # [ doc = "TOF bit was set on the bottom of counting. There was an FTM counter decrement and FTM counter changes from its minimum value (CNTIN register) to its maximum value (MOD register)." ]
            _0,
            # [ doc = "TOF bit was set on the top of counting. There was an FTM counter increment and FTM counter changes from its maximum value (MOD register) to its minimum value (CNTIN register)." ]
            _1,
        }
        impl TofdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofdirR::_0 => 0,
                    TofdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofdirR {
                match bits {
                    0 => TofdirR::_0,
                    1 => TofdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofdirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadirR {
            # [ doc = "Counting direction is decreasing (FTM counter decrement)." ]
            _0,
            # [ doc = "Counting direction is increasing (FTM counter increment)." ]
            _1,
        }
        impl QuadirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadirR::_0 => 0,
                    QuadirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadirR {
                match bits {
                    0 => QuadirR::_0,
                    1 => QuadirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadmodeR {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadmodeR::_0 => 0,
                    QuadmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadmodeR {
                match bits {
                    0 => QuadmodeR::_0,
                    1 => QuadmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbpolR {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbpolR::_0 => 0,
                    PhbpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbpolR {
                match bits {
                    0 => PhbpolR::_0,
                    1 => PhbpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbpolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhapolR {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhapolR::_0 => 0,
                    PhapolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhapolR {
                match bits {
                    0 => PhapolR::_0,
                    1 => PhapolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhapolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhapolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbfltrenR {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbfltrenR::_0 => 0,
                    PhbfltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbfltrenR {
                match bits {
                    0 => PhbfltrenR::_0,
                    1 => PhbfltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbfltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbfltrenR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhafltrenR {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhafltrenR::_0 => 0,
                    PhafltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhafltrenR {
                match bits {
                    0 => PhafltrenR::_0,
                    1 => PhafltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhafltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhafltrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `QUADEN`" ]
        pub enum QuadenW {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadenW::_0 => 0,
                    QuadenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Quadrature Decoder mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadenW::_0)
            }
            # [ doc = "Quadrature Decoder mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `QUADMODE`" ]
        pub enum QuadmodeW {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadmodeW::_0 => 0,
                    QuadmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A and phase B encoding mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadmodeW::_0)
            }
            # [ doc = "Count and direction encoding mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBPOL`" ]
        pub enum PhbpolW {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbpolW::_0 => 0,
                    PhbpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbpolW::_0)
            }
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAPOL`" ]
        pub enum PhapolW {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhapolW::_0 => 0,
                    PhapolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhapolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhapolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhapolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhapolW::_0)
            }
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhapolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBFLTREN`" ]
        pub enum PhbfltrenW {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbfltrenW::_0 => 0,
                    PhbfltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbfltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbfltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbfltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase B input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbfltrenW::_0)
            }
            # [ doc = "Phase B input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbfltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAFLTREN`" ]
        pub enum PhafltrenW {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhafltrenW::_0 => 0,
                    PhafltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhafltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhafltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhafltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhafltrenW::_0)
            }
            # [ doc = "Phase A input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhafltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&self) -> QuadenR {
                QuadenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Timer Overflow Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn tofdir(&self) -> TofdirR {
                TofdirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadir(&self) -> QuadirR {
                QuadirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&self) -> QuadmodeR {
                QuadmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&self) -> PhbpolR {
                PhbpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&self) -> PhapolR {
                PhapolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&self) -> PhbfltrenR {
                PhbfltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 6;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&self) -> PhafltrenR {
                PhafltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 7;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&mut self) -> _QuadenW {
                _QuadenW { w: self }
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&mut self) -> _QuadmodeW {
                _QuadmodeW { w: self }
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&mut self) -> _PhbpolW {
                _PhbpolW { w: self }
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&mut self) -> _PhapolW {
                _PhapolW { w: self }
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&mut self) -> _PhbfltrenW {
                _PhbfltrenW { w: self }
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&mut self) -> _PhafltrenW {
                _PhafltrenW { w: self }
            }
        }
    }
    # [ doc = "Configuration" ]
    pub struct Conf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration" ]
    pub mod conf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Conf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LdfqR {
            bits: u8,
        }
        impl LdfqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BdmmodeR {
            bits: u8,
        }
        impl BdmmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeenR {
            bits: u8,
        }
        impl GtbeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeoutR {
            bits: u8,
        }
        impl GtbeoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ITRIGR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ItrigrR {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ItrigrR::_0 => 0,
                    ItrigrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ItrigrR {
                match bits {
                    0 => ItrigrR::_0,
                    1 => ItrigrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ItrigrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ItrigrR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdfqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdfqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BdmmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BdmmodeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeoutW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ITRIGR`" ]
        pub enum ItrigrW {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ItrigrW::_0 => 0,
                    ItrigrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ItrigrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ItrigrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ItrigrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ItrigrW::_0)
            }
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ItrigrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&self) -> LdfqR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LdfqR { bits }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&self) -> BdmmodeR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BdmmodeR { bits }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&self) -> GtbeenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeenR { bits }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&self) -> GtbeoutR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeoutR { bits }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&self) -> ItrigrR {
                ItrigrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&mut self) -> _LdfqW {
                _LdfqW { w: self }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&mut self) -> _BdmmodeW {
                _BdmmodeW { w: self }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&mut self) -> _GtbeenW {
                _GtbeenW { w: self }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&mut self) -> _GtbeoutW {
                _GtbeoutW { w: self }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&mut self) -> _ItrigrW {
                _ItrigrW { w: self }
            }
        }
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub struct Fltpol {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub mod fltpol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltpol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FLT0POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt0polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt0polR::_0 => 0,
                    Flt0polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt0polR {
                match bits {
                    0 => Flt0polR::_0,
                    1 => Flt0polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt0polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt0polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT1POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt1polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt1polR::_0 => 0,
                    Flt1polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt1polR {
                match bits {
                    0 => Flt1polR::_0,
                    1 => Flt1polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt1polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt1polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT2POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt2polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt2polR::_0 => 0,
                    Flt2polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt2polR {
                match bits {
                    0 => Flt2polR::_0,
                    1 => Flt2polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt2polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt2polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT3POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt3polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt3polR::_0 => 0,
                    Flt3polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt3polR {
                match bits {
                    0 => Flt3polR::_0,
                    1 => Flt3polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt3polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt3polR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FLT0POL`" ]
        pub enum Flt0polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt0polW::_0 => 0,
                    Flt0polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt0polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt0polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt0polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt0polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt0polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT1POL`" ]
        pub enum Flt1polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt1polW::_0 => 0,
                    Flt1polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt1polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt1polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt1polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt1polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt1polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT2POL`" ]
        pub enum Flt2polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt2polW::_0 => 0,
                    Flt2polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt2polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt2polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt2polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt2polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt2polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT3POL`" ]
        pub enum Flt3polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt3polW::_0 => 0,
                    Flt3polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt3polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt3polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt3polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt3polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt3polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&self) -> Flt0polR {
                Flt0polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&self) -> Flt1polR {
                Flt1polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&self) -> Flt2polR {
                Flt2polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&self) -> Flt3polR {
                Flt3polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&mut self) -> _Flt0polW {
                _Flt0polW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&mut self) -> _Flt1polW {
                _Flt1polW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&mut self) -> _Flt2polW {
                _Flt2polW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&mut self) -> _Flt3polW {
                _Flt3polW { w: self }
            }
        }
    }
    # [ doc = "Synchronization Configuration" ]
    pub struct Synconf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization Configuration" ]
    pub mod synconf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Synconf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HWTRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwtrigmodeR {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwtrigmodeR::_0 => 0,
                    HwtrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwtrigmodeR {
                match bits {
                    0 => HwtrigmodeR::_0,
                    1 => HwtrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwtrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwtrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTINC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntincR {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntincR::_0 => 0,
                    CntincR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntincR {
                match bits {
                    0 => CntincR::_0,
                    1 => CntincR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntincR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntincR::_1
            }
        }
        # [ doc = "Possible values of the field `INVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InvcR {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InvcR::_0 => 0,
                    InvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InvcR {
                match bits {
                    0 => InvcR::_0,
                    1 => InvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwocR {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwocR::_0 => 0,
                    SwocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwocR {
                match bits {
                    0 => SwocR::_0,
                    1 => SwocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwocR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SyncmodeR {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SyncmodeR::_0 => 0,
                    SyncmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SyncmodeR {
                match bits {
                    0 => SyncmodeR::_0,
                    1 => SyncmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SyncmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SyncmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `SWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwrstcntR {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwrstcntR::_0 => 0,
                    SwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwrstcntR {
                match bits {
                    0 => SwrstcntR::_0,
                    1 => SwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `SWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwwrbufR {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwwrbufR::_0 => 0,
                    SwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwwrbufR {
                match bits {
                    0 => SwwrbufR::_0,
                    1 => SwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwomR {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwomR::_0 => 0,
                    SwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwomR {
                match bits {
                    0 => SwomR::_0,
                    1 => SwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwomR::_1
            }
        }
        # [ doc = "Possible values of the field `SWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwinvcR {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwinvcR::_0 => 0,
                    SwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwinvcR {
                match bits {
                    0 => SwinvcR::_0,
                    1 => SwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsocR {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsocR::_0 => 0,
                    SwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsocR {
                match bits {
                    0 => SwsocR::_0,
                    1 => SwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsocR::_1
            }
        }
        # [ doc = "Possible values of the field `HWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwrstcntR {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwrstcntR::_0 => 0,
                    HwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwrstcntR {
                match bits {
                    0 => HwrstcntR::_0,
                    1 => HwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `HWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwwrbufR {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwwrbufR::_0 => 0,
                    HwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwwrbufR {
                match bits {
                    0 => HwwrbufR::_0,
                    1 => HwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `HWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwomR {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwomR::_0 => 0,
                    HwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwomR {
                match bits {
                    0 => HwomR::_0,
                    1 => HwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwomR::_1
            }
        }
        # [ doc = "Possible values of the field `HWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwinvcR {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwinvcR::_0 => 0,
                    HwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwinvcR {
                match bits {
                    0 => HwinvcR::_0,
                    1 => HwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `HWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwsocR {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwsocR::_0 => 0,
                    HwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwsocR {
                match bits {
                    0 => HwsocR::_0,
                    1 => HwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwsocR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HWTRIGMODE`" ]
        pub enum HwtrigmodeW {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwtrigmodeW::_0 => 0,
                    HwtrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwtrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwtrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwtrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_0)
            }
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTINC`" ]
        pub enum CntincW {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntincW::_0 => 0,
                    CntincW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntincW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntincW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntincW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntincW::_0)
            }
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntincW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVC`" ]
        pub enum InvcW {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InvcW::_0 => 0,
                    InvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InvcW::_0)
            }
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOC`" ]
        pub enum SwocW {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwocW::_0 => 0,
                    SwocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwocW::_0)
            }
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCMODE`" ]
        pub enum SyncmodeW {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SyncmodeW::_0 => 0,
                    SyncmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SyncmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SyncmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SyncmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Legacy PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SyncmodeW::_0)
            }
            # [ doc = "Enhanced PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SyncmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWRSTCNT`" ]
        pub enum SwrstcntW {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwrstcntW::_0 => 0,
                    SwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwrstcntW::_0)
            }
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWWRBUF`" ]
        pub enum SwwrbufW {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwwrbufW::_0 => 0,
                    SwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwwrbufW::_0)
            }
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOM`" ]
        pub enum SwomW {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwomW::_0 => 0,
                    SwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwomW::_0)
            }
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWINVC`" ]
        pub enum SwinvcW {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwinvcW::_0 => 0,
                    SwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwinvcW::_0)
            }
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSOC`" ]
        pub enum SwsocW {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsocW::_0 => 0,
                    SwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsocW::_0)
            }
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWRSTCNT`" ]
        pub enum HwrstcntW {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwrstcntW::_0 => 0,
                    HwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwrstcntW::_0)
            }
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWWRBUF`" ]
        pub enum HwwrbufW {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwwrbufW::_0 => 0,
                    HwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwwrbufW::_0)
            }
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWOM`" ]
        pub enum HwomW {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwomW::_0 => 0,
                    HwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwomW::_0)
            }
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWINVC`" ]
        pub enum HwinvcW {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwinvcW::_0 => 0,
                    HwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwinvcW::_0)
            }
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWSOC`" ]
        pub enum HwsocW {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwsocW::_0 => 0,
                    HwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwsocW::_0)
            }
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&self) -> HwtrigmodeR {
                HwtrigmodeR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&self) -> CntincR {
                CntincR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&self) -> InvcR {
                InvcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&self) -> SwocR {
                SwocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&self) -> SyncmodeR {
                SyncmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&self) -> SwrstcntR {
                SwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&self) -> SwwrbufR {
                SwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&self) -> SwomR {
                SwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&self) -> SwinvcR {
                SwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&self) -> SwsocR {
                SwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&self) -> HwrstcntR {
                HwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 16;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&self) -> HwwrbufR {
                HwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&self) -> HwomR {
                HwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&self) -> HwinvcR {
                HwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&self) -> HwsocR {
                HwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&mut self) -> _HwtrigmodeW {
                _HwtrigmodeW { w: self }
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&mut self) -> _CntincW {
                _CntincW { w: self }
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&mut self) -> _InvcW {
                _InvcW { w: self }
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&mut self) -> _SwocW {
                _SwocW { w: self }
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&mut self) -> _SyncmodeW {
                _SyncmodeW { w: self }
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&mut self) -> _SwrstcntW {
                _SwrstcntW { w: self }
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&mut self) -> _SwwrbufW {
                _SwwrbufW { w: self }
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&mut self) -> _SwomW {
                _SwomW { w: self }
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&mut self) -> _SwinvcW {
                _SwinvcW { w: self }
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&mut self) -> _SwsocW {
                _SwsocW { w: self }
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&mut self) -> _HwrstcntW {
                _HwrstcntW { w: self }
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&mut self) -> _HwwrbufW {
                _HwwrbufW { w: self }
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&mut self) -> _HwomW {
                _HwomW { w: self }
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&mut self) -> _HwinvcW {
                _HwinvcW { w: self }
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&mut self) -> _HwsocW {
                _HwsocW { w: self }
            }
        }
    }
    # [ doc = "FTM Inverting Control" ]
    pub struct Invctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Inverting Control" ]
    pub mod invctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Invctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `INV0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv0enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv0enR::_0 => 0,
                    Inv0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv0enR {
                match bits {
                    0 => Inv0enR::_0,
                    1 => Inv0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv0enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv1enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv1enR::_0 => 0,
                    Inv1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv1enR {
                match bits {
                    0 => Inv1enR::_0,
                    1 => Inv1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv1enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv2enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv2enR::_0 => 0,
                    Inv2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv2enR {
                match bits {
                    0 => Inv2enR::_0,
                    1 => Inv2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv2enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv3enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv3enR::_0 => 0,
                    Inv3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv3enR {
                match bits {
                    0 => Inv3enR::_0,
                    1 => Inv3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv3enR::_1
            }
        }
        # [ doc = "Values that can be written to the field `INV0EN`" ]
        pub enum Inv0enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv0enW::_0 => 0,
                    Inv0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv0enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV1EN`" ]
        pub enum Inv1enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv1enW::_0 => 0,
                    Inv1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv1enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV2EN`" ]
        pub enum Inv2enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv2enW::_0 => 0,
                    Inv2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv2enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV3EN`" ]
        pub enum Inv3enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv3enW::_0 => 0,
                    Inv3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv3enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&self) -> Inv0enR {
                Inv0enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&self) -> Inv1enR {
                Inv1enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&self) -> Inv2enR {
                Inv2enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&self) -> Inv3enR {
                Inv3enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&mut self) -> _Inv0enW {
                _Inv0enW { w: self }
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&mut self) -> _Inv1enW {
                _Inv1enW { w: self }
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&mut self) -> _Inv2enW {
                _Inv2enW { w: self }
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&mut self) -> _Inv3enW {
                _Inv3enW { w: self }
            }
        }
    }
    # [ doc = "FTM Software Output Control" ]
    pub struct Swoctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Software Output Control" ]
    pub mod swoctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Swoctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocR::_0 => 0,
                    Ch0ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocR {
                match bits {
                    0 => Ch0ocR::_0,
                    1 => Ch0ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocR::_0 => 0,
                    Ch1ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocR {
                match bits {
                    0 => Ch1ocR::_0,
                    1 => Ch1ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocR::_0 => 0,
                    Ch2ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocR {
                match bits {
                    0 => Ch2ocR::_0,
                    1 => Ch2ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocR::_0 => 0,
                    Ch3ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocR {
                match bits {
                    0 => Ch3ocR::_0,
                    1 => Ch3ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocR::_0 => 0,
                    Ch4ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocR {
                match bits {
                    0 => Ch4ocR::_0,
                    1 => Ch4ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocR::_0 => 0,
                    Ch5ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocR {
                match bits {
                    0 => Ch5ocR::_0,
                    1 => Ch5ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocR::_0 => 0,
                    Ch6ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocR {
                match bits {
                    0 => Ch6ocR::_0,
                    1 => Ch6ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocR::_0 => 0,
                    Ch7ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocR {
                match bits {
                    0 => Ch7ocR::_0,
                    1 => Ch7ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocvR::_0 => 0,
                    Ch0ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocvR {
                match bits {
                    0 => Ch0ocvR::_0,
                    1 => Ch0ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocvR::_0 => 0,
                    Ch1ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocvR {
                match bits {
                    0 => Ch1ocvR::_0,
                    1 => Ch1ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocvR::_0 => 0,
                    Ch2ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocvR {
                match bits {
                    0 => Ch2ocvR::_0,
                    1 => Ch2ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocvR::_0 => 0,
                    Ch3ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocvR {
                match bits {
                    0 => Ch3ocvR::_0,
                    1 => Ch3ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocvR::_0 => 0,
                    Ch4ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocvR {
                match bits {
                    0 => Ch4ocvR::_0,
                    1 => Ch4ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocvR::_0 => 0,
                    Ch5ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocvR {
                match bits {
                    0 => Ch5ocvR::_0,
                    1 => Ch5ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocvR::_0 => 0,
                    Ch6ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocvR {
                match bits {
                    0 => Ch6ocvR::_0,
                    1 => Ch6ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocvR::_0 => 0,
                    Ch7ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocvR {
                match bits {
                    0 => Ch7ocvR::_0,
                    1 => Ch7ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocvR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OC`" ]
        pub enum Ch0ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocW::_0 => 0,
                    Ch0ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OC`" ]
        pub enum Ch1ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocW::_0 => 0,
                    Ch1ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OC`" ]
        pub enum Ch2ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocW::_0 => 0,
                    Ch2ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OC`" ]
        pub enum Ch3ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocW::_0 => 0,
                    Ch3ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OC`" ]
        pub enum Ch4ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocW::_0 => 0,
                    Ch4ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OC`" ]
        pub enum Ch5ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocW::_0 => 0,
                    Ch5ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OC`" ]
        pub enum Ch6ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocW::_0 => 0,
                    Ch6ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OC`" ]
        pub enum Ch7ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocW::_0 => 0,
                    Ch7ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0OCV`" ]
        pub enum Ch0ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocvW::_0 => 0,
                    Ch0ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OCV`" ]
        pub enum Ch1ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocvW::_0 => 0,
                    Ch1ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OCV`" ]
        pub enum Ch2ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocvW::_0 => 0,
                    Ch2ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OCV`" ]
        pub enum Ch3ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocvW::_0 => 0,
                    Ch3ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OCV`" ]
        pub enum Ch4ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocvW::_0 => 0,
                    Ch4ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OCV`" ]
        pub enum Ch5ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocvW::_0 => 0,
                    Ch5ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OCV`" ]
        pub enum Ch6ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocvW::_0 => 0,
                    Ch6ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OCV`" ]
        pub enum Ch7ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocvW::_0 => 0,
                    Ch7ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&self) -> Ch0ocR {
                Ch0ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&self) -> Ch1ocR {
                Ch1ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&self) -> Ch2ocR {
                Ch2ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&self) -> Ch3ocR {
                Ch3ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&self) -> Ch4ocR {
                Ch4ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&self) -> Ch5ocR {
                Ch5ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&self) -> Ch6ocR {
                Ch6ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&self) -> Ch7ocR {
                Ch7ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&self) -> Ch0ocvR {
                Ch0ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&self) -> Ch1ocvR {
                Ch1ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&self) -> Ch2ocvR {
                Ch2ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&self) -> Ch3ocvR {
                Ch3ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&self) -> Ch4ocvR {
                Ch4ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&self) -> Ch5ocvR {
                Ch5ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&self) -> Ch6ocvR {
                Ch6ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&self) -> Ch7ocvR {
                Ch7ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&mut self) -> _Ch0ocW {
                _Ch0ocW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&mut self) -> _Ch1ocW {
                _Ch1ocW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&mut self) -> _Ch2ocW {
                _Ch2ocW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&mut self) -> _Ch3ocW {
                _Ch3ocW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&mut self) -> _Ch4ocW {
                _Ch4ocW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&mut self) -> _Ch5ocW {
                _Ch5ocW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&mut self) -> _Ch6ocW {
                _Ch6ocW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&mut self) -> _Ch7ocW {
                _Ch7ocW { w: self }
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&mut self) -> _Ch0ocvW {
                _Ch0ocvW { w: self }
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&mut self) -> _Ch1ocvW {
                _Ch1ocvW { w: self }
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&mut self) -> _Ch2ocvW {
                _Ch2ocvW { w: self }
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&mut self) -> _Ch3ocvW {
                _Ch3ocvW { w: self }
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&mut self) -> _Ch4ocvW {
                _Ch4ocvW { w: self }
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&mut self) -> _Ch5ocvW {
                _Ch5ocvW { w: self }
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&mut self) -> _Ch6ocvW {
                _Ch6ocvW { w: self }
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&mut self) -> _Ch7ocvW {
                _Ch7ocvW { w: self }
            }
        }
    }
    # [ doc = "FTM PWM Load" ]
    pub struct Pwmload {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM PWM Load" ]
    pub mod pwmload {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pwmload {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0selR::_0 => 0,
                    Ch0selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0selR {
                match bits {
                    0 => Ch0selR::_0,
                    1 => Ch0selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1selR::_0 => 0,
                    Ch1selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1selR {
                match bits {
                    0 => Ch1selR::_0,
                    1 => Ch1selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2selR::_0 => 0,
                    Ch2selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2selR {
                match bits {
                    0 => Ch2selR::_0,
                    1 => Ch2selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3selR::_0 => 0,
                    Ch3selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3selR {
                match bits {
                    0 => Ch3selR::_0,
                    1 => Ch3selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4selR::_0 => 0,
                    Ch4selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4selR {
                match bits {
                    0 => Ch4selR::_0,
                    1 => Ch4selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5selR::_0 => 0,
                    Ch5selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5selR {
                match bits {
                    0 => Ch5selR::_0,
                    1 => Ch5selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6selR::_0 => 0,
                    Ch6selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6selR {
                match bits {
                    0 => Ch6selR::_0,
                    1 => Ch6selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7selR::_0 => 0,
                    Ch7selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7selR {
                match bits {
                    0 => Ch7selR::_0,
                    1 => Ch7selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7selR::_1
            }
        }
        # [ doc = "Possible values of the field `HCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HcselR {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HcselR::_0 => 0,
                    HcselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HcselR {
                match bits {
                    0 => HcselR::_0,
                    1 => HcselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HcselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HcselR::_1
            }
        }
        # [ doc = "Possible values of the field `LDOK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LdokR {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LdokR::_0 => 0,
                    LdokR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LdokR {
                match bits {
                    0 => LdokR::_0,
                    1 => LdokR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LdokR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LdokR::_1
            }
        }
        # [ doc = "Possible values of the field `GLEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GlenR {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GlenR::_0 => 0,
                    GlenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GlenR {
                match bits {
                    0 => GlenR::_0,
                    1 => GlenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GlenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GlenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0SEL`" ]
        pub enum Ch0selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0selW::_0 => 0,
                    Ch0selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1SEL`" ]
        pub enum Ch1selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1selW::_0 => 0,
                    Ch1selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2SEL`" ]
        pub enum Ch2selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2selW::_0 => 0,
                    Ch2selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3SEL`" ]
        pub enum Ch3selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3selW::_0 => 0,
                    Ch3selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4SEL`" ]
        pub enum Ch4selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4selW::_0 => 0,
                    Ch4selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5SEL`" ]
        pub enum Ch5selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5selW::_0 => 0,
                    Ch5selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6SEL`" ]
        pub enum Ch6selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6selW::_0 => 0,
                    Ch6selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7SEL`" ]
        pub enum Ch7selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7selW::_0 => 0,
                    Ch7selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HCSEL`" ]
        pub enum HcselW {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HcselW::_0 => 0,
                    HcselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HcselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HcselW::_0)
            }
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HcselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LDOK`" ]
        pub enum LdokW {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LdokW::_0 => 0,
                    LdokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LdokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loading updated values is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LdokW::_0)
            }
            # [ doc = "Loading updated values is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LdokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLEN`" ]
        pub enum GlenW {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GlenW::_0 => 0,
                    GlenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GlenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GlenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GlenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Global Load Ok disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GlenW::_0)
            }
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GlenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLDOK`" ]
        pub enum GldokW {
            # [ doc = "No action." ]
            _0,
            # [ doc = "LDOK bit is set." ]
            _1,
        }
        impl GldokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GldokW::_0 => 0,
                    GldokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GldokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GldokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GldokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No action." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GldokW::_0)
            }
            # [ doc = "LDOK bit is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GldokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&self) -> Ch0selR {
                Ch0selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&self) -> Ch1selR {
                Ch1selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&self) -> Ch2selR {
                Ch2selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&self) -> Ch3selR {
                Ch3selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&self) -> Ch4selR {
                Ch4selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&self) -> Ch5selR {
                Ch5selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&self) -> Ch6selR {
                Ch6selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&self) -> Ch7selR {
                Ch7selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&self) -> HcselR {
                HcselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&self) -> LdokR {
                LdokR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&self) -> GlenR {
                GlenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&mut self) -> _Ch0selW {
                _Ch0selW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&mut self) -> _Ch1selW {
                _Ch1selW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&mut self) -> _Ch2selW {
                _Ch2selW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&mut self) -> _Ch3selW {
                _Ch3selW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&mut self) -> _Ch4selW {
                _Ch4selW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&mut self) -> _Ch5selW {
                _Ch5selW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&mut self) -> _Ch6selW {
                _Ch6selW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&mut self) -> _Ch7selW {
                _Ch7selW { w: self }
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&mut self) -> _HcselW {
                _HcselW { w: self }
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&mut self) -> _LdokW {
                _LdokW { w: self }
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&mut self) -> _GlenW {
                _GlenW { w: self }
            }
            # [ doc = "Bit 11 - Global Load OK" ]
            # [ inline ( always ) ]
            pub fn gldok(&mut self) -> _GldokW {
                _GldokW { w: self }
            }
        }
    }
    # [ doc = "Half Cycle Register" ]
    pub struct Hcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Half Cycle Register" ]
    pub mod hcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Hcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HcvalR {
            bits: u16,
        }
        impl HcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&self) -> HcvalR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                HcvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&mut self) -> _HcvalW {
                _HcvalW { w: self }
            }
        }
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub struct Pair0deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub mod pair0deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair0deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub struct Pair1deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub mod pair1deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair1deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub struct Pair2deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub mod pair2deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair2deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub struct Pair3deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub mod pair3deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair3deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
}
# [ doc = "FlexTimer Module" ]
pub struct Ftm1 {
    register_block: ftm1::RegisterBlock,
}
impl Deref for Ftm1 {
    type Target = ftm1::RegisterBlock;
    fn deref(&self) -> &ftm1::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "FlexTimer Module" ]
pub const FTM2: Peripheral<Ftm2> = unsafe { Peripheral::new(1073979392) };
# [ doc = "FlexTimer Module" ]
pub mod ftm2 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Status And Control" ]
        pub sc: Sc,
        # [ doc = "0x04 - Counter" ]
        pub cnt: Cnt,
        # [ doc = "0x08 - Modulo" ]
        pub mod_: Mod,
        # [ doc = "0x0c - Channel (n) Status And Control" ]
        pub c0sc: C0sc,
        # [ doc = "0x10 - Channel (n) Value" ]
        pub c0v: C0v,
        # [ doc = "0x14 - Channel (n) Status And Control" ]
        pub c1sc: C1sc,
        # [ doc = "0x18 - Channel (n) Value" ]
        pub c1v: C1v,
        # [ doc = "0x1c - Channel (n) Status And Control" ]
        pub c2sc: C2sc,
        # [ doc = "0x20 - Channel (n) Value" ]
        pub c2v: C2v,
        # [ doc = "0x24 - Channel (n) Status And Control" ]
        pub c3sc: C3sc,
        # [ doc = "0x28 - Channel (n) Value" ]
        pub c3v: C3v,
        # [ doc = "0x2c - Channel (n) Status And Control" ]
        pub c4sc: C4sc,
        # [ doc = "0x30 - Channel (n) Value" ]
        pub c4v: C4v,
        # [ doc = "0x34 - Channel (n) Status And Control" ]
        pub c5sc: C5sc,
        # [ doc = "0x38 - Channel (n) Value" ]
        pub c5v: C5v,
        # [ doc = "0x3c - Channel (n) Status And Control" ]
        pub c6sc: C6sc,
        # [ doc = "0x40 - Channel (n) Value" ]
        pub c6v: C6v,
        # [ doc = "0x44 - Channel (n) Status And Control" ]
        pub c7sc: C7sc,
        # [ doc = "0x48 - Channel (n) Value" ]
        pub c7v: C7v,
        # [ doc = "0x4c - Counter Initial Value" ]
        pub cntin: Cntin,
        # [ doc = "0x50 - Capture And Compare Status" ]
        pub status: Status,
        # [ doc = "0x54 - Features Mode Selection" ]
        pub mode: Mode,
        # [ doc = "0x58 - Synchronization" ]
        pub sync: Sync,
        # [ doc = "0x5c - Initial State For Channels Output" ]
        pub outinit: Outinit,
        # [ doc = "0x60 - Output Mask" ]
        pub outmask: Outmask,
        # [ doc = "0x64 - Function For Linked Channels" ]
        pub combine: Combine,
        # [ doc = "0x68 - Deadtime Configuration" ]
        pub deadtime: Deadtime,
        # [ doc = "0x6c - FTM External Trigger" ]
        pub exttrig: Exttrig,
        # [ doc = "0x70 - Channels Polarity" ]
        pub pol: Pol,
        # [ doc = "0x74 - Fault Mode Status" ]
        pub fms: Fms,
        # [ doc = "0x78 - Input Capture Filter Control" ]
        pub filter: Filter,
        # [ doc = "0x7c - Fault Control" ]
        pub fltctrl: Fltctrl,
        # [ doc = "0x80 - Quadrature Decoder Control And Status" ]
        pub qdctrl: Qdctrl,
        # [ doc = "0x84 - Configuration" ]
        pub conf: Conf,
        # [ doc = "0x88 - FTM Fault Input Polarity" ]
        pub fltpol: Fltpol,
        # [ doc = "0x8c - Synchronization Configuration" ]
        pub synconf: Synconf,
        # [ doc = "0x90 - FTM Inverting Control" ]
        pub invctrl: Invctrl,
        # [ doc = "0x94 - FTM Software Output Control" ]
        pub swoctrl: Swoctrl,
        # [ doc = "0x98 - FTM PWM Load" ]
        pub pwmload: Pwmload,
        # [ doc = "0x9c - Half Cycle Register" ]
        pub hcr: Hcr,
        # [ doc = "0xa0 - Pair 0 Deadtime Configuration" ]
        pub pair0deadtime: Pair0deadtime,
        _reserved0: [u8; 4usize],
        # [ doc = "0xa8 - Pair 1 Deadtime Configuration" ]
        pub pair1deadtime: Pair1deadtime,
        _reserved1: [u8; 4usize],
        # [ doc = "0xb0 - Pair 2 Deadtime Configuration" ]
        pub pair2deadtime: Pair2deadtime,
        _reserved2: [u8; 4usize],
        # [ doc = "0xb8 - Pair 3 Deadtime Configuration" ]
        pub pair3deadtime: Pair3deadtime,
    }
    # [ doc = "Status And Control" ]
    pub struct Sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status And Control" ]
    pub mod sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_000 => 0,
                    PsR::_001 => 1,
                    PsR::_010 => 2,
                    PsR::_011 => 3,
                    PsR::_100 => 4,
                    PsR::_101 => 5,
                    PsR::_110 => 6,
                    PsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_000,
                    1 => PsR::_001,
                    2 => PsR::_010,
                    3 => PsR::_011,
                    4 => PsR::_100,
                    5 => PsR::_101,
                    6 => PsR::_110,
                    7 => PsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PsR::_111
            }
        }
        # [ doc = "Possible values of the field `CLKS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksR {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksR::_00 => 0,
                    ClksR::_01 => 1,
                    ClksR::_10 => 2,
                    ClksR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksR {
                match bits {
                    0 => ClksR::_00,
                    1 => ClksR::_01,
                    2 => ClksR::_10,
                    3 => ClksR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ClksR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ClksR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ClksR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ClksR::_11
            }
        }
        # [ doc = "Possible values of the field `CPWMS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpwmsR {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpwmsR::_0 => 0,
                    CpwmsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpwmsR {
                match bits {
                    0 => CpwmsR::_0,
                    1 => CpwmsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpwmsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpwmsR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `RF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfR {
            # [ doc = "A selected reload point did not happen." ]
            _0,
            # [ doc = "A selected reload point happened." ]
            _1,
        }
        impl RfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfR::_0 => 0,
                    RfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfR {
                match bits {
                    0 => RfR::_0,
                    1 => RfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfR::_1
            }
        }
        # [ doc = "Possible values of the field `TOIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ToieR {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ToieR::_0 => 0,
                    ToieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ToieR {
                match bits {
                    0 => ToieR::_0,
                    1 => ToieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ToieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ToieR::_1
            }
        }
        # [ doc = "Possible values of the field `TOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofR {
            # [ doc = "FTM counter has not overflowed." ]
            _0,
            # [ doc = "FTM counter has overflowed." ]
            _1,
        }
        impl TofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofR::_0 => 0,
                    TofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofR {
                match bits {
                    0 => TofR::_0,
                    1 => TofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen0R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen0R::_0 => 0,
                    Pwmen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen0R {
                match bits {
                    0 => Pwmen0R::_0,
                    1 => Pwmen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen0R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen1R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen1R::_0 => 0,
                    Pwmen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen1R {
                match bits {
                    0 => Pwmen1R::_0,
                    1 => Pwmen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen1R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen2R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen2R::_0 => 0,
                    Pwmen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen2R {
                match bits {
                    0 => Pwmen2R::_0,
                    1 => Pwmen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen2R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen3R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen3R::_0 => 0,
                    Pwmen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen3R {
                match bits {
                    0 => Pwmen3R::_0,
                    1 => Pwmen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen3R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen4R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen4R::_0 => 0,
                    Pwmen4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen4R {
                match bits {
                    0 => Pwmen4R::_0,
                    1 => Pwmen4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen4R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen5R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen5R::_0 => 0,
                    Pwmen5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen5R {
                match bits {
                    0 => Pwmen5R::_0,
                    1 => Pwmen5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen5R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen6R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen6R::_0 => 0,
                    Pwmen6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen6R {
                match bits {
                    0 => Pwmen6R::_0,
                    1 => Pwmen6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen6R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen7R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen7R::_0 => 0,
                    Pwmen7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen7R {
                match bits {
                    0 => Pwmen7R::_0,
                    1 => Pwmen7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen7R::_1
            }
        }
        # [ doc = "Possible values of the field `FLTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltpsR {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltpsR::_0000 => 0,
                    FltpsR::_0001 => 1,
                    FltpsR::_0010 => 2,
                    FltpsR::_0011 => 3,
                    FltpsR::_0100 => 4,
                    FltpsR::_0101 => 5,
                    FltpsR::_0110 => 6,
                    FltpsR::_0111 => 7,
                    FltpsR::_1000 => 8,
                    FltpsR::_1001 => 9,
                    FltpsR::_1010 => 10,
                    FltpsR::_1011 => 11,
                    FltpsR::_1100 => 12,
                    FltpsR::_1101 => 13,
                    FltpsR::_1110 => 14,
                    FltpsR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltpsR {
                match bits {
                    0 => FltpsR::_0000,
                    1 => FltpsR::_0001,
                    2 => FltpsR::_0010,
                    3 => FltpsR::_0011,
                    4 => FltpsR::_0100,
                    5 => FltpsR::_0101,
                    6 => FltpsR::_0110,
                    7 => FltpsR::_0111,
                    8 => FltpsR::_1000,
                    9 => FltpsR::_1001,
                    10 => FltpsR::_1010,
                    11 => FltpsR::_1011,
                    12 => FltpsR::_1100,
                    13 => FltpsR::_1101,
                    14 => FltpsR::_1110,
                    15 => FltpsR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == FltpsR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == FltpsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == FltpsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == FltpsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == FltpsR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == FltpsR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == FltpsR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == FltpsR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == FltpsR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == FltpsR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == FltpsR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == FltpsR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == FltpsR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == FltpsR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == FltpsR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == FltpsR::_1111
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_000 => 0,
                    PsW::_001 => 1,
                    PsW::_010 => 2,
                    PsW::_011 => 3,
                    PsW::_100 => 4,
                    PsW::_101 => 5,
                    PsW::_110 => 6,
                    PsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PsW::_000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PsW::_001)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PsW::_010)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PsW::_011)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PsW::_100)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PsW::_101)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PsW::_110)
            }
            # [ doc = "Divide by 128" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKS`" ]
        pub enum ClksW {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksW::_00 => 0,
                    ClksW::_01 => 1,
                    ClksW::_10 => 2,
                    ClksW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ClksW::_00)
            }
            # [ doc = "FTM input clock" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ClksW::_01)
            }
            # [ doc = "Fixed frequency clock" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ClksW::_10)
            }
            # [ doc = "External clock" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ClksW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPWMS`" ]
        pub enum CpwmsW {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpwmsW::_0 => 0,
                    CpwmsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpwmsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpwmsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpwmsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter operates in Up Counting mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpwmsW::_0)
            }
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpwmsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reload point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Reload point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOIE`" ]
        pub enum ToieW {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ToieW::_0 => 0,
                    ToieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ToieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ToieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ToieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ToieW::_0)
            }
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ToieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN0`" ]
        pub enum Pwmen0W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen0W::_0 => 0,
                    Pwmen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen0W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN1`" ]
        pub enum Pwmen1W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen1W::_0 => 0,
                    Pwmen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen1W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN2`" ]
        pub enum Pwmen2W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen2W::_0 => 0,
                    Pwmen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen2W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN3`" ]
        pub enum Pwmen3W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen3W::_0 => 0,
                    Pwmen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen3W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN4`" ]
        pub enum Pwmen4W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen4W::_0 => 0,
                    Pwmen4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen4W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN5`" ]
        pub enum Pwmen5W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen5W::_0 => 0,
                    Pwmen5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen5W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN6`" ]
        pub enum Pwmen6W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen6W::_0 => 0,
                    Pwmen6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen6W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN7`" ]
        pub enum Pwmen7W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen7W::_0 => 0,
                    Pwmen7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen7W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLTPS`" ]
        pub enum FltpsW {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltpsW::_0000 => 0,
                    FltpsW::_0001 => 1,
                    FltpsW::_0010 => 2,
                    FltpsW::_0011 => 3,
                    FltpsW::_0100 => 4,
                    FltpsW::_0101 => 5,
                    FltpsW::_0110 => 6,
                    FltpsW::_0111 => 7,
                    FltpsW::_1000 => 8,
                    FltpsW::_1001 => 9,
                    FltpsW::_1010 => 10,
                    FltpsW::_1011 => 11,
                    FltpsW::_1100 => 12,
                    FltpsW::_1101 => 13,
                    FltpsW::_1110 => 14,
                    FltpsW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltpsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(FltpsW::_0000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(FltpsW::_0001)
            }
            # [ doc = "Divide by 3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(FltpsW::_0010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(FltpsW::_0011)
            }
            # [ doc = "Divide by 5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(FltpsW::_0100)
            }
            # [ doc = "Divide by 6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(FltpsW::_0101)
            }
            # [ doc = "Divide by 7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(FltpsW::_0110)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(FltpsW::_0111)
            }
            # [ doc = "Divide by 9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(FltpsW::_1000)
            }
            # [ doc = "Divide by 10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(FltpsW::_1001)
            }
            # [ doc = "Divide by 11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(FltpsW::_1010)
            }
            # [ doc = "Divide by 12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(FltpsW::_1011)
            }
            # [ doc = "Divide by 13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(FltpsW::_1100)
            }
            # [ doc = "Divide by 14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(FltpsW::_1101)
            }
            # [ doc = "Divide by 15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(FltpsW::_1110)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(FltpsW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&self) -> ClksR {
                ClksR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&self) -> CpwmsR {
                CpwmsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Reload Flag" ]
            # [ inline ( always ) ]
            pub fn rf(&self) -> RfR {
                RfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 7;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&self) -> ToieR {
                ToieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Timer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn tof(&self) -> TofR {
                TofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&self) -> Pwmen0R {
                Pwmen0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&self) -> Pwmen1R {
                Pwmen1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&self) -> Pwmen2R {
                Pwmen2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&self) -> Pwmen3R {
                Pwmen3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&self) -> Pwmen4R {
                Pwmen4R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&self) -> Pwmen5R {
                Pwmen5R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&self) -> Pwmen6R {
                Pwmen6R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&self) -> Pwmen7R {
                Pwmen7R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&self) -> FltpsR {
                FltpsR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&mut self) -> _ClksW {
                _ClksW { w: self }
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&mut self) -> _CpwmsW {
                _CpwmsW { w: self }
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&mut self) -> _ToieW {
                _ToieW { w: self }
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&mut self) -> _Pwmen0W {
                _Pwmen0W { w: self }
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&mut self) -> _Pwmen1W {
                _Pwmen1W { w: self }
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&mut self) -> _Pwmen2W {
                _Pwmen2W { w: self }
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&mut self) -> _Pwmen3W {
                _Pwmen3W { w: self }
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&mut self) -> _Pwmen4W {
                _Pwmen4W { w: self }
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&mut self) -> _Pwmen5W {
                _Pwmen5W { w: self }
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&mut self) -> _Pwmen6W {
                _Pwmen6W { w: self }
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&mut self) -> _Pwmen7W {
                _Pwmen7W { w: self }
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&mut self) -> _FltpsW {
                _FltpsW { w: self }
            }
        }
    }
    # [ doc = "Counter" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CountR {
            bits: u16,
        }
        impl CountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CountW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CountW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&self) -> CountR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&mut self) -> _CountW {
                _CountW { w: self }
            }
        }
    }
    # [ doc = "Modulo" ]
    pub struct Mod {
        register: VolatileCell<u32>,
    }
    # [ doc = "Modulo" ]
    pub mod mod_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mod {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ModR {
            bits: u16,
        }
        impl ModR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&self) -> ModR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ModR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&mut self) -> _ModW {
                _ModW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C0sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c0sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C0v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c0v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C1sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c1sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C1v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c1v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C2sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c2sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C2v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c2v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C3sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c3sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C3v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c3v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C4sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c4sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C4v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c4v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C5sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c5sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C5v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c5v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C6sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c6sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C6v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c6v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C7sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c7sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C7v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c7v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Counter Initial Value" ]
    pub struct Cntin {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter Initial Value" ]
    pub mod cntin {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cntin {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct InitR {
            bits: u16,
        }
        impl InitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&self) -> InitR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                InitR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
        }
    }
    # [ doc = "Capture And Compare Status" ]
    pub struct Status {
        register: VolatileCell<u32>,
    }
    # [ doc = "Capture And Compare Status" ]
    pub mod status {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Status {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `CH0F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch0fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0fR::_0 => 0,
                    Ch0fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0fR {
                match bits {
                    0 => Ch0fR::_0,
                    1 => Ch0fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1fR::_0 => 0,
                    Ch1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1fR {
                match bits {
                    0 => Ch1fR::_0,
                    1 => Ch1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2fR::_0 => 0,
                    Ch2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2fR {
                match bits {
                    0 => Ch2fR::_0,
                    1 => Ch2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch3fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3fR::_0 => 0,
                    Ch3fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3fR {
                match bits {
                    0 => Ch3fR::_0,
                    1 => Ch3fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch4fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4fR::_0 => 0,
                    Ch4fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4fR {
                match bits {
                    0 => Ch4fR::_0,
                    1 => Ch4fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch5fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5fR::_0 => 0,
                    Ch5fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5fR {
                match bits {
                    0 => Ch5fR::_0,
                    1 => Ch5fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch6fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6fR::_0 => 0,
                    Ch6fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6fR {
                match bits {
                    0 => Ch6fR::_0,
                    1 => Ch6fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch7fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7fR::_0 => 0,
                    Ch7fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7fR {
                match bits {
                    0 => Ch7fR::_0,
                    1 => Ch7fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7fR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Flag" ]
            # [ inline ( always ) ]
            pub fn ch0f(&self) -> Ch0fR {
                Ch0fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ch1f(&self) -> Ch1fR {
                Ch1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ch2f(&self) -> Ch2fR {
                Ch2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Flag" ]
            # [ inline ( always ) ]
            pub fn ch3f(&self) -> Ch3fR {
                Ch3fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Flag" ]
            # [ inline ( always ) ]
            pub fn ch4f(&self) -> Ch4fR {
                Ch4fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Flag" ]
            # [ inline ( always ) ]
            pub fn ch5f(&self) -> Ch5fR {
                Ch5fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Flag" ]
            # [ inline ( always ) ]
            pub fn ch6f(&self) -> Ch6fR {
                Ch6fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Flag" ]
            # [ inline ( always ) ]
            pub fn ch7f(&self) -> Ch7fR {
                Ch7fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
    }
    # [ doc = "Features Mode Selection" ]
    pub struct Mode {
        register: VolatileCell<u32>,
    }
    # [ doc = "Features Mode Selection" ]
    pub mod mode {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mode {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FTMEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FtmenR {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FtmenR::_0 => 0,
                    FtmenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FtmenR {
                match bits {
                    0 => FtmenR::_0,
                    1 => FtmenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FtmenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FtmenR::_1
            }
        }
        # [ doc = "Possible values of the field `WPDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpdisR {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpdisR::_0 => 0,
                    WpdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpdisR {
                match bits {
                    0 => WpdisR::_0,
                    1 => WpdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpdisR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PwmsyncR {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PwmsyncR::_0 => 0,
                    PwmsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PwmsyncR {
                match bits {
                    0 => PwmsyncR::_0,
                    1 => PwmsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PwmsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PwmsyncR::_1
            }
        }
        # [ doc = "Possible values of the field `CAPTEST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CaptestR {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CaptestR::_0 => 0,
                    CaptestR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CaptestR {
                match bits {
                    0 => CaptestR::_0,
                    1 => CaptestR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CaptestR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CaptestR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultmR {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultmR::_00 => 0,
                    FaultmR::_01 => 1,
                    FaultmR::_10 => 2,
                    FaultmR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultmR {
                match bits {
                    0 => FaultmR::_00,
                    1 => FaultmR::_01,
                    2 => FaultmR::_10,
                    3 => FaultmR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FaultmR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FaultmR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FaultmR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FaultmR::_11
            }
        }
        # [ doc = "Possible values of the field `FAULTIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultieR {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultieR::_0 => 0,
                    FaultieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultieR {
                match bits {
                    0 => FaultieR::_0,
                    1 => FaultieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FTMEN`" ]
        pub enum FtmenW {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FtmenW::_0 => 0,
                    FtmenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FtmenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FtmenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FtmenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FtmenW::_0)
            }
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FtmenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WPDIS`" ]
        pub enum WpdisW {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpdisW::_0 => 0,
                    WpdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpdisW::_0)
            }
            # [ doc = "Write protection is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMSYNC`" ]
        pub enum PwmsyncW {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PwmsyncW::_0 => 0,
                    PwmsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PwmsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PwmsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PwmsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PwmsyncW::_0)
            }
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PwmsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CAPTEST`" ]
        pub enum CaptestW {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CaptestW::_0 => 0,
                    CaptestW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaptestW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaptestW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CaptestW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Capture test mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CaptestW::_0)
            }
            # [ doc = "Capture test mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CaptestW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTM`" ]
        pub enum FaultmW {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultmW::_00 => 0,
                    FaultmW::_01 => 1,
                    FaultmW::_10 => 2,
                    FaultmW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control is disabled for all channels." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FaultmW::_00)
            }
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FaultmW::_01)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FaultmW::_10)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FaultmW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTIE`" ]
        pub enum FaultieW {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultieW::_0 => 0,
                    FaultieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FaultieW::_0)
            }
            # [ doc = "Fault control interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FaultieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&self) -> FtmenR {
                FtmenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&self) -> WpdisR {
                WpdisR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&self) -> PwmsyncR {
                PwmsyncR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&self) -> CaptestR {
                CaptestR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&self) -> FaultmR {
                FaultmR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&self) -> FaultieR {
                FaultieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 7;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&mut self) -> _FtmenW {
                _FtmenW { w: self }
            }
            # [ doc = "Bit 1 - Initialize The Channels Output" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&mut self) -> _WpdisW {
                _WpdisW { w: self }
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&mut self) -> _PwmsyncW {
                _PwmsyncW { w: self }
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&mut self) -> _CaptestW {
                _CaptestW { w: self }
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&mut self) -> _FaultmW {
                _FaultmW { w: self }
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&mut self) -> _FaultieW {
                _FaultieW { w: self }
            }
        }
    }
    # [ doc = "Synchronization" ]
    pub struct Sync {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization" ]
    pub mod sync {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sync {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CNTMIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntminR {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntminR::_0 => 0,
                    CntminR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntminR {
                match bits {
                    0 => CntminR::_0,
                    1 => CntminR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntminR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntminR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTMAX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntmaxR {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntmaxR::_0 => 0,
                    CntmaxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntmaxR {
                match bits {
                    0 => CntmaxR::_0,
                    1 => CntmaxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntmaxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntmaxR::_1
            }
        }
        # [ doc = "Possible values of the field `REINIT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReinitR {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReinitR::_0 => 0,
                    ReinitR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReinitR {
                match bits {
                    0 => ReinitR::_0,
                    1 => ReinitR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReinitR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReinitR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCHOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchomR {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchomR::_0 => 0,
                    SynchomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchomR {
                match bits {
                    0 => SynchomR::_0,
                    1 => SynchomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchomR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig0R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig0R::_0 => 0,
                    Trig0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig0R {
                match bits {
                    0 => Trig0R::_0,
                    1 => Trig0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig0R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig1R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig1R::_0 => 0,
                    Trig1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig1R {
                match bits {
                    0 => Trig1R::_0,
                    1 => Trig1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig1R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig2R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig2R::_0 => 0,
                    Trig2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig2R {
                match bits {
                    0 => Trig2R::_0,
                    1 => Trig2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig2R::_1
            }
        }
        # [ doc = "Possible values of the field `SWSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsyncR {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsyncR::_0 => 0,
                    SwsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsyncR {
                match bits {
                    0 => SwsyncR::_0,
                    1 => SwsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsyncR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CNTMIN`" ]
        pub enum CntminW {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntminW::_0 => 0,
                    CntminW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntminW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntminW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntminW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minimum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntminW::_0)
            }
            # [ doc = "The minimum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntminW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTMAX`" ]
        pub enum CntmaxW {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntmaxW::_0 => 0,
                    CntmaxW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntmaxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntmaxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntmaxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The maximum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntmaxW::_0)
            }
            # [ doc = "The maximum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntmaxW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REINIT`" ]
        pub enum ReinitW {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReinitW::_0 => 0,
                    ReinitW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReinitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReinitW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReinitW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter continues to count normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReinitW::_0)
            }
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReinitW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCHOM`" ]
        pub enum SynchomW {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SynchomW::_0 => 0,
                    SynchomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SynchomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SynchomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SynchomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SynchomW::_0)
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SynchomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG0`" ]
        pub enum Trig0W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig0W::_0 => 0,
                    Trig0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig0W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG1`" ]
        pub enum Trig1W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig1W::_0 => 0,
                    Trig1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig1W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG2`" ]
        pub enum Trig2W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig2W::_0 => 0,
                    Trig2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig2W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSYNC`" ]
        pub enum SwsyncW {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsyncW::_0 => 0,
                    SwsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software trigger is not selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsyncW::_0)
            }
            # [ doc = "Software trigger is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&self) -> CntminR {
                CntminR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&self) -> CntmaxR {
                CntmaxR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&self) -> ReinitR {
                ReinitR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&self) -> SynchomR {
                SynchomR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&self) -> Trig0R {
                Trig0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&self) -> Trig1R {
                Trig1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&self) -> Trig2R {
                Trig2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&self) -> SwsyncR {
                SwsyncR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&mut self) -> _CntminW {
                _CntminW { w: self }
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&mut self) -> _CntmaxW {
                _CntmaxW { w: self }
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&mut self) -> _ReinitW {
                _ReinitW { w: self }
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&mut self) -> _SynchomW {
                _SynchomW { w: self }
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&mut self) -> _Trig0W {
                _Trig0W { w: self }
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&mut self) -> _Trig1W {
                _Trig1W { w: self }
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&mut self) -> _Trig2W {
                _Trig2W { w: self }
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&mut self) -> _SwsyncW {
                _SwsyncW { w: self }
            }
        }
    }
    # [ doc = "Initial State For Channels Output" ]
    pub struct Outinit {
        register: VolatileCell<u32>,
    }
    # [ doc = "Initial State For Channels Output" ]
    pub mod outinit {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outinit {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0oiR::_0 => 0,
                    Ch0oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0oiR {
                match bits {
                    0 => Ch0oiR::_0,
                    1 => Ch0oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1oiR::_0 => 0,
                    Ch1oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1oiR {
                match bits {
                    0 => Ch1oiR::_0,
                    1 => Ch1oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2oiR::_0 => 0,
                    Ch2oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2oiR {
                match bits {
                    0 => Ch2oiR::_0,
                    1 => Ch2oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3oiR::_0 => 0,
                    Ch3oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3oiR {
                match bits {
                    0 => Ch3oiR::_0,
                    1 => Ch3oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4oiR::_0 => 0,
                    Ch4oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4oiR {
                match bits {
                    0 => Ch4oiR::_0,
                    1 => Ch4oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5oiR::_0 => 0,
                    Ch5oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5oiR {
                match bits {
                    0 => Ch5oiR::_0,
                    1 => Ch5oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6oiR::_0 => 0,
                    Ch6oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6oiR {
                match bits {
                    0 => Ch6oiR::_0,
                    1 => Ch6oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7oiR::_0 => 0,
                    Ch7oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7oiR {
                match bits {
                    0 => Ch7oiR::_0,
                    1 => Ch7oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7oiR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OI`" ]
        pub enum Ch0oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0oiW::_0 => 0,
                    Ch0oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OI`" ]
        pub enum Ch1oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1oiW::_0 => 0,
                    Ch1oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OI`" ]
        pub enum Ch2oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2oiW::_0 => 0,
                    Ch2oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OI`" ]
        pub enum Ch3oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3oiW::_0 => 0,
                    Ch3oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OI`" ]
        pub enum Ch4oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4oiW::_0 => 0,
                    Ch4oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OI`" ]
        pub enum Ch5oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5oiW::_0 => 0,
                    Ch5oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OI`" ]
        pub enum Ch6oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6oiW::_0 => 0,
                    Ch6oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OI`" ]
        pub enum Ch7oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7oiW::_0 => 0,
                    Ch7oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&self) -> Ch0oiR {
                Ch0oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&self) -> Ch1oiR {
                Ch1oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&self) -> Ch2oiR {
                Ch2oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&self) -> Ch3oiR {
                Ch3oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&self) -> Ch4oiR {
                Ch4oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&self) -> Ch5oiR {
                Ch5oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&self) -> Ch6oiR {
                Ch6oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&self) -> Ch7oiR {
                Ch7oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&mut self) -> _Ch0oiW {
                _Ch0oiW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&mut self) -> _Ch1oiW {
                _Ch1oiW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&mut self) -> _Ch2oiW {
                _Ch2oiW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&mut self) -> _Ch3oiW {
                _Ch3oiW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&mut self) -> _Ch4oiW {
                _Ch4oiW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&mut self) -> _Ch5oiW {
                _Ch5oiW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&mut self) -> _Ch6oiW {
                _Ch6oiW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&mut self) -> _Ch7oiW {
                _Ch7oiW { w: self }
            }
        }
    }
    # [ doc = "Output Mask" ]
    pub struct Outmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Output Mask" ]
    pub mod outmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0omR::_0 => 0,
                    Ch0omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0omR {
                match bits {
                    0 => Ch0omR::_0,
                    1 => Ch0omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1omR::_0 => 0,
                    Ch1omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1omR {
                match bits {
                    0 => Ch1omR::_0,
                    1 => Ch1omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2omR::_0 => 0,
                    Ch2omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2omR {
                match bits {
                    0 => Ch2omR::_0,
                    1 => Ch2omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3omR::_0 => 0,
                    Ch3omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3omR {
                match bits {
                    0 => Ch3omR::_0,
                    1 => Ch3omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4omR::_0 => 0,
                    Ch4omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4omR {
                match bits {
                    0 => Ch4omR::_0,
                    1 => Ch4omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5omR::_0 => 0,
                    Ch5omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5omR {
                match bits {
                    0 => Ch5omR::_0,
                    1 => Ch5omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6omR::_0 => 0,
                    Ch6omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6omR {
                match bits {
                    0 => Ch6omR::_0,
                    1 => Ch6omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7omR::_0 => 0,
                    Ch7omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7omR {
                match bits {
                    0 => Ch7omR::_0,
                    1 => Ch7omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7omR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OM`" ]
        pub enum Ch0omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0omW::_0 => 0,
                    Ch0omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OM`" ]
        pub enum Ch1omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1omW::_0 => 0,
                    Ch1omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OM`" ]
        pub enum Ch2omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2omW::_0 => 0,
                    Ch2omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OM`" ]
        pub enum Ch3omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3omW::_0 => 0,
                    Ch3omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OM`" ]
        pub enum Ch4omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4omW::_0 => 0,
                    Ch4omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OM`" ]
        pub enum Ch5omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5omW::_0 => 0,
                    Ch5omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OM`" ]
        pub enum Ch6omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6omW::_0 => 0,
                    Ch6omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OM`" ]
        pub enum Ch7omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7omW::_0 => 0,
                    Ch7omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&self) -> Ch0omR {
                Ch0omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&self) -> Ch1omR {
                Ch1omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&self) -> Ch2omR {
                Ch2omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&self) -> Ch3omR {
                Ch3omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&self) -> Ch4omR {
                Ch4omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&self) -> Ch5omR {
                Ch5omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&self) -> Ch6omR {
                Ch6omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&self) -> Ch7omR {
                Ch7omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&mut self) -> _Ch0omW {
                _Ch0omW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&mut self) -> _Ch1omW {
                _Ch1omW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&mut self) -> _Ch2omW {
                _Ch2omW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&mut self) -> _Ch3omW {
                _Ch3omW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&mut self) -> _Ch4omW {
                _Ch4omW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&mut self) -> _Ch5omW {
                _Ch5omW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&mut self) -> _Ch6omW {
                _Ch6omW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&mut self) -> _Ch7omW {
                _Ch7omW { w: self }
            }
        }
    }
    # [ doc = "Function For Linked Channels" ]
    pub struct Combine {
        register: VolatileCell<u32>,
    }
    # [ doc = "Function For Linked Channels" ]
    pub mod combine {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Combine {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine0R {
            bits: u8,
        }
        impl Combine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp0R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp0R::_0 => 0,
                    Comp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp0R {
                match bits {
                    0 => Comp0R::_0,
                    1 => Comp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen0R {
            bits: u8,
        }
        impl Decapen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap0R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap0R::_0 => 0,
                    Decap0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap0R {
                match bits {
                    0 => Decap0R::_0,
                    1 => Decap0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap0R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten0R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten0R::_0 => 0,
                    Dten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten0R {
                match bits {
                    0 => Dten0R::_0,
                    1 => Dten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten0R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen0R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen0R::_0 => 0,
                    Syncen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen0R {
                match bits {
                    0 => Syncen0R::_0,
                    1 => Syncen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten0R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten0R::_0 => 0,
                    Faulten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten0R {
                match bits {
                    0 => Faulten0R::_0,
                    1 => Faulten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine0R {
            bits: u8,
        }
        impl Mcombine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine1R {
            bits: u8,
        }
        impl Combine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp1R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp1R::_0 => 0,
                    Comp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp1R {
                match bits {
                    0 => Comp1R::_0,
                    1 => Comp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen1R {
            bits: u8,
        }
        impl Decapen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap1R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap1R::_0 => 0,
                    Decap1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap1R {
                match bits {
                    0 => Decap1R::_0,
                    1 => Decap1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap1R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten1R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten1R::_0 => 0,
                    Dten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten1R {
                match bits {
                    0 => Dten1R::_0,
                    1 => Dten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten1R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen1R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen1R::_0 => 0,
                    Syncen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen1R {
                match bits {
                    0 => Syncen1R::_0,
                    1 => Syncen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten1R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten1R::_0 => 0,
                    Faulten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten1R {
                match bits {
                    0 => Faulten1R::_0,
                    1 => Faulten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine1R {
            bits: u8,
        }
        impl Mcombine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine2R {
            bits: u8,
        }
        impl Combine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp2R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp2R::_0 => 0,
                    Comp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp2R {
                match bits {
                    0 => Comp2R::_0,
                    1 => Comp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen2R {
            bits: u8,
        }
        impl Decapen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap2R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap2R::_0 => 0,
                    Decap2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap2R {
                match bits {
                    0 => Decap2R::_0,
                    1 => Decap2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap2R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten2R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten2R::_0 => 0,
                    Dten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten2R {
                match bits {
                    0 => Dten2R::_0,
                    1 => Dten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten2R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen2R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen2R::_0 => 0,
                    Syncen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen2R {
                match bits {
                    0 => Syncen2R::_0,
                    1 => Syncen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten2R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten2R::_0 => 0,
                    Faulten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten2R {
                match bits {
                    0 => Faulten2R::_0,
                    1 => Faulten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine2R {
            bits: u8,
        }
        impl Mcombine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine3R {
            bits: u8,
        }
        impl Combine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp3R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp3R::_0 => 0,
                    Comp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp3R {
                match bits {
                    0 => Comp3R::_0,
                    1 => Comp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen3R {
            bits: u8,
        }
        impl Decapen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap3R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap3R::_0 => 0,
                    Decap3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap3R {
                match bits {
                    0 => Decap3R::_0,
                    1 => Decap3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap3R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten3R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten3R::_0 => 0,
                    Dten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten3R {
                match bits {
                    0 => Dten3R::_0,
                    1 => Dten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten3R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen3R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen3R::_0 => 0,
                    Syncen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen3R {
                match bits {
                    0 => Syncen3R::_0,
                    1 => Syncen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten3R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten3R::_0 => 0,
                    Faulten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten3R {
                match bits {
                    0 => Faulten3R::_0,
                    1 => Faulten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine3R {
            bits: u8,
        }
        impl Mcombine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP0`" ]
        pub enum Comp0W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp0W::_0 => 0,
                    Comp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp0W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP0`" ]
        pub enum Decap0W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap0W::_0 => 0,
                    Decap0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap0W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN0`" ]
        pub enum Dten0W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten0W::_0 => 0,
                    Dten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten0W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN0`" ]
        pub enum Syncen0W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen0W::_0 => 0,
                    Syncen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen0W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN0`" ]
        pub enum Faulten0W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten0W::_0 => 0,
                    Faulten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten0W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP1`" ]
        pub enum Comp1W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp1W::_0 => 0,
                    Comp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp1W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP1`" ]
        pub enum Decap1W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap1W::_0 => 0,
                    Decap1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap1W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN1`" ]
        pub enum Dten1W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten1W::_0 => 0,
                    Dten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten1W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN1`" ]
        pub enum Syncen1W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen1W::_0 => 0,
                    Syncen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen1W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN1`" ]
        pub enum Faulten1W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten1W::_0 => 0,
                    Faulten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten1W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP2`" ]
        pub enum Comp2W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp2W::_0 => 0,
                    Comp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp2W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP2`" ]
        pub enum Decap2W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap2W::_0 => 0,
                    Decap2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap2W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN2`" ]
        pub enum Dten2W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten2W::_0 => 0,
                    Dten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten2W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN2`" ]
        pub enum Syncen2W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen2W::_0 => 0,
                    Syncen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen2W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN2`" ]
        pub enum Faulten2W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten2W::_0 => 0,
                    Faulten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten2W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP3`" ]
        pub enum Comp3W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp3W::_0 => 0,
                    Comp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp3W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP3`" ]
        pub enum Decap3W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap3W::_0 => 0,
                    Decap3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap3W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN3`" ]
        pub enum Dten3W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten3W::_0 => 0,
                    Dten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten3W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN3`" ]
        pub enum Syncen3W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen3W::_0 => 0,
                    Syncen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen3W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN3`" ]
        pub enum Faulten3W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten3W::_0 => 0,
                    Faulten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten3W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&self) -> Combine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine0R { bits }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&self) -> Comp0R {
                Comp0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&self) -> Decapen0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen0R { bits }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&self) -> Decap0R {
                Decap0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&self) -> Dten0R {
                Dten0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&self) -> Syncen0R {
                Syncen0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&self) -> Faulten0R {
                Faulten0R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&self) -> Mcombine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine0R { bits }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&self) -> Combine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine1R { bits }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&self) -> Comp1R {
                Comp1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&self) -> Decapen1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen1R { bits }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&self) -> Decap1R {
                Decap1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&self) -> Dten1R {
                Dten1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&self) -> Syncen1R {
                Syncen1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&self) -> Faulten1R {
                Faulten1R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 14;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&self) -> Mcombine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine1R { bits }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&self) -> Combine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine2R { bits }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&self) -> Comp2R {
                Comp2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 17;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&self) -> Decapen2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen2R { bits }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&self) -> Decap2R {
                Decap2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&self) -> Dten2R {
                Dten2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&self) -> Syncen2R {
                Syncen2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 21;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&self) -> Faulten2R {
                Faulten2R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 22;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&self) -> Mcombine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine2R { bits }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&self) -> Combine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine3R { bits }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&self) -> Comp3R {
                Comp3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&self) -> Decapen3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen3R { bits }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&self) -> Decap3R {
                Decap3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&self) -> Dten3R {
                Dten3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&self) -> Syncen3R {
                Syncen3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 29;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&self) -> Faulten3R {
                Faulten3R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 30;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&self) -> Mcombine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine3R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&mut self) -> _Combine0W {
                _Combine0W { w: self }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&mut self) -> _Comp0W {
                _Comp0W { w: self }
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&mut self) -> _Decapen0W {
                _Decapen0W { w: self }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&mut self) -> _Decap0W {
                _Decap0W { w: self }
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&mut self) -> _Dten0W {
                _Dten0W { w: self }
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&mut self) -> _Syncen0W {
                _Syncen0W { w: self }
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&mut self) -> _Faulten0W {
                _Faulten0W { w: self }
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&mut self) -> _Mcombine0W {
                _Mcombine0W { w: self }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&mut self) -> _Combine1W {
                _Combine1W { w: self }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&mut self) -> _Comp1W {
                _Comp1W { w: self }
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&mut self) -> _Decapen1W {
                _Decapen1W { w: self }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&mut self) -> _Decap1W {
                _Decap1W { w: self }
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&mut self) -> _Dten1W {
                _Dten1W { w: self }
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&mut self) -> _Syncen1W {
                _Syncen1W { w: self }
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&mut self) -> _Faulten1W {
                _Faulten1W { w: self }
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&mut self) -> _Mcombine1W {
                _Mcombine1W { w: self }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&mut self) -> _Combine2W {
                _Combine2W { w: self }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&mut self) -> _Comp2W {
                _Comp2W { w: self }
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&mut self) -> _Decapen2W {
                _Decapen2W { w: self }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&mut self) -> _Decap2W {
                _Decap2W { w: self }
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&mut self) -> _Dten2W {
                _Dten2W { w: self }
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&mut self) -> _Syncen2W {
                _Syncen2W { w: self }
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&mut self) -> _Faulten2W {
                _Faulten2W { w: self }
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&mut self) -> _Mcombine2W {
                _Mcombine2W { w: self }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&mut self) -> _Combine3W {
                _Combine3W { w: self }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&mut self) -> _Comp3W {
                _Comp3W { w: self }
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&mut self) -> _Decapen3W {
                _Decapen3W { w: self }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&mut self) -> _Decap3W {
                _Decap3W { w: self }
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&mut self) -> _Dten3W {
                _Dten3W { w: self }
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&mut self) -> _Syncen3W {
                _Syncen3W { w: self }
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&mut self) -> _Faulten3W {
                _Faulten3W { w: self }
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&mut self) -> _Mcombine3W {
                _Mcombine3W { w: self }
            }
        }
    }
    # [ doc = "Deadtime Configuration" ]
    pub struct Deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Deadtime Configuration" ]
    pub mod deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "FTM External Trigger" ]
    pub struct Exttrig {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM External Trigger" ]
    pub mod exttrig {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Exttrig {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH2TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2trigR::_0 => 0,
                    Ch2trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2trigR {
                match bits {
                    0 => Ch2trigR::_0,
                    1 => Ch2trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3trigR::_0 => 0,
                    Ch3trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3trigR {
                match bits {
                    0 => Ch3trigR::_0,
                    1 => Ch3trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4trigR::_0 => 0,
                    Ch4trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4trigR {
                match bits {
                    0 => Ch4trigR::_0,
                    1 => Ch4trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5trigR::_0 => 0,
                    Ch5trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5trigR {
                match bits {
                    0 => Ch5trigR::_0,
                    1 => Ch5trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0trigR::_0 => 0,
                    Ch0trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0trigR {
                match bits {
                    0 => Ch0trigR::_0,
                    1 => Ch0trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1trigR::_0 => 0,
                    Ch1trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1trigR {
                match bits {
                    0 => Ch1trigR::_0,
                    1 => Ch1trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1trigR::_1
            }
        }
        # [ doc = "Possible values of the field `INITTRIGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InittrigenR {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InittrigenR::_0 => 0,
                    InittrigenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InittrigenR {
                match bits {
                    0 => InittrigenR::_0,
                    1 => InittrigenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InittrigenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InittrigenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigfR {
            # [ doc = "No channel trigger was generated." ]
            _0,
            # [ doc = "A channel trigger was generated." ]
            _1,
        }
        impl TrigfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigfR::_0 => 0,
                    TrigfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigfR {
                match bits {
                    0 => TrigfR::_0,
                    1 => TrigfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigfR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6trigR::_0 => 0,
                    Ch6trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6trigR {
                match bits {
                    0 => Ch6trigR::_0,
                    1 => Ch6trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7trigR::_0 => 0,
                    Ch7trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7trigR {
                match bits {
                    0 => Ch7trigR::_0,
                    1 => Ch7trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7trigR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH2TRIG`" ]
        pub enum Ch2trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2trigW::_0 => 0,
                    Ch2trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3TRIG`" ]
        pub enum Ch3trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3trigW::_0 => 0,
                    Ch3trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4TRIG`" ]
        pub enum Ch4trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4trigW::_0 => 0,
                    Ch4trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5TRIG`" ]
        pub enum Ch5trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5trigW::_0 => 0,
                    Ch5trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0TRIG`" ]
        pub enum Ch0trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0trigW::_0 => 0,
                    Ch0trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1TRIG`" ]
        pub enum Ch1trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1trigW::_0 => 0,
                    Ch1trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INITTRIGEN`" ]
        pub enum InittrigenW {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InittrigenW::_0 => 0,
                    InittrigenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InittrigenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InittrigenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InittrigenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of initialization trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InittrigenW::_0)
            }
            # [ doc = "The generation of initialization trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InittrigenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6TRIG`" ]
        pub enum Ch6trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6trigW::_0 => 0,
                    Ch6trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7TRIG`" ]
        pub enum Ch7trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7trigW::_0 => 0,
                    Ch7trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&self) -> Ch2trigR {
                Ch2trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&self) -> Ch3trigR {
                Ch3trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&self) -> Ch4trigR {
                Ch4trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&self) -> Ch5trigR {
                Ch5trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&self) -> Ch0trigR {
                Ch0trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&self) -> Ch1trigR {
                Ch1trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&self) -> InittrigenR {
                InittrigenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 6;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Channel Trigger Flag" ]
            # [ inline ( always ) ]
            pub fn trigf(&self) -> TrigfR {
                TrigfR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&self) -> Ch6trigR {
                Ch6trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&self) -> Ch7trigR {
                Ch7trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&mut self) -> _Ch2trigW {
                _Ch2trigW { w: self }
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&mut self) -> _Ch3trigW {
                _Ch3trigW { w: self }
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&mut self) -> _Ch4trigW {
                _Ch4trigW { w: self }
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&mut self) -> _Ch5trigW {
                _Ch5trigW { w: self }
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&mut self) -> _Ch0trigW {
                _Ch0trigW { w: self }
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&mut self) -> _Ch1trigW {
                _Ch1trigW { w: self }
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&mut self) -> _InittrigenW {
                _InittrigenW { w: self }
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&mut self) -> _Ch6trigW {
                _Ch6trigW { w: self }
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&mut self) -> _Ch7trigW {
                _Ch7trigW { w: self }
            }
        }
    }
    # [ doc = "Channels Polarity" ]
    pub struct Pol {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channels Polarity" ]
    pub mod pol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `POL0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol0R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol0R::_0 => 0,
                    Pol0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol0R {
                match bits {
                    0 => Pol0R::_0,
                    1 => Pol0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol0R::_1
            }
        }
        # [ doc = "Possible values of the field `POL1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol1R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol1R::_0 => 0,
                    Pol1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol1R {
                match bits {
                    0 => Pol1R::_0,
                    1 => Pol1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol1R::_1
            }
        }
        # [ doc = "Possible values of the field `POL2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol2R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol2R::_0 => 0,
                    Pol2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol2R {
                match bits {
                    0 => Pol2R::_0,
                    1 => Pol2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol2R::_1
            }
        }
        # [ doc = "Possible values of the field `POL3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol3R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol3R::_0 => 0,
                    Pol3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol3R {
                match bits {
                    0 => Pol3R::_0,
                    1 => Pol3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol3R::_1
            }
        }
        # [ doc = "Possible values of the field `POL4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol4R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol4R::_0 => 0,
                    Pol4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol4R {
                match bits {
                    0 => Pol4R::_0,
                    1 => Pol4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol4R::_1
            }
        }
        # [ doc = "Possible values of the field `POL5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol5R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol5R::_0 => 0,
                    Pol5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol5R {
                match bits {
                    0 => Pol5R::_0,
                    1 => Pol5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol5R::_1
            }
        }
        # [ doc = "Possible values of the field `POL6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol6R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol6R::_0 => 0,
                    Pol6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol6R {
                match bits {
                    0 => Pol6R::_0,
                    1 => Pol6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol6R::_1
            }
        }
        # [ doc = "Possible values of the field `POL7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol7R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol7R::_0 => 0,
                    Pol7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol7R {
                match bits {
                    0 => Pol7R::_0,
                    1 => Pol7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol7R::_1
            }
        }
        # [ doc = "Values that can be written to the field `POL0`" ]
        pub enum Pol0W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol0W::_0 => 0,
                    Pol0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol0W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL1`" ]
        pub enum Pol1W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol1W::_0 => 0,
                    Pol1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol1W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL2`" ]
        pub enum Pol2W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol2W::_0 => 0,
                    Pol2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol2W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL3`" ]
        pub enum Pol3W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol3W::_0 => 0,
                    Pol3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol3W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL4`" ]
        pub enum Pol4W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol4W::_0 => 0,
                    Pol4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol4W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL5`" ]
        pub enum Pol5W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol5W::_0 => 0,
                    Pol5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol5W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL6`" ]
        pub enum Pol6W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol6W::_0 => 0,
                    Pol6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol6W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL7`" ]
        pub enum Pol7W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol7W::_0 => 0,
                    Pol7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol7W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&self) -> Pol0R {
                Pol0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&self) -> Pol1R {
                Pol1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&self) -> Pol2R {
                Pol2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&self) -> Pol3R {
                Pol3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&self) -> Pol4R {
                Pol4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&self) -> Pol5R {
                Pol5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&self) -> Pol6R {
                Pol6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&self) -> Pol7R {
                Pol7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&mut self) -> _Pol0W {
                _Pol0W { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&mut self) -> _Pol1W {
                _Pol1W { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&mut self) -> _Pol2W {
                _Pol2W { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&mut self) -> _Pol3W {
                _Pol3W { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&mut self) -> _Pol4W {
                _Pol4W { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&mut self) -> _Pol5W {
                _Pol5W { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&mut self) -> _Pol6W {
                _Pol6W { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&mut self) -> _Pol7W {
                _Pol7W { w: self }
            }
        }
    }
    # [ doc = "Fault Mode Status" ]
    pub struct Fms {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Mode Status" ]
    pub mod fms {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fms {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULTF0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf0R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf0R::_0 => 0,
                    Faultf0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf0R {
                match bits {
                    0 => Faultf0R::_0,
                    1 => Faultf0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf1R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf1R::_0 => 0,
                    Faultf1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf1R {
                match bits {
                    0 => Faultf1R::_0,
                    1 => Faultf1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf2R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf2R::_0 => 0,
                    Faultf2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf2R {
                match bits {
                    0 => Faultf2R::_0,
                    1 => Faultf2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf3R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf3R::_0 => 0,
                    Faultf3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf3R {
                match bits {
                    0 => Faultf3R::_0,
                    1 => Faultf3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultinR {
            # [ doc = "The logic OR of the enabled fault inputs is 0." ]
            _0,
            # [ doc = "The logic OR of the enabled fault inputs is 1." ]
            _1,
        }
        impl FaultinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultinR::_0 => 0,
                    FaultinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultinR {
                match bits {
                    0 => FaultinR::_0,
                    1 => FaultinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultinR::_1
            }
        }
        # [ doc = "Possible values of the field `WPEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpenR {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpenR::_0 => 0,
                    WpenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpenR {
                match bits {
                    0 => WpenR::_0,
                    1 => WpenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpenR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultfR {
            # [ doc = "No fault condition was detected." ]
            _0,
            # [ doc = "A fault condition was detected." ]
            _1,
        }
        impl FaultfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultfR::_0 => 0,
                    FaultfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultfR {
                match bits {
                    0 => FaultfR::_0,
                    1 => FaultfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WPEN`" ]
        pub enum WpenW {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpenW::_0 => 0,
                    WpenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpenW::_0)
            }
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Detection Flag 0" ]
            # [ inline ( always ) ]
            pub fn faultf0(&self) -> Faultf0R {
                Faultf0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Detection Flag 1" ]
            # [ inline ( always ) ]
            pub fn faultf1(&self) -> Faultf1R {
                Faultf1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Detection Flag 2" ]
            # [ inline ( always ) ]
            pub fn faultf2(&self) -> Faultf2R {
                Faultf2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Detection Flag 3" ]
            # [ inline ( always ) ]
            pub fn faultf3(&self) -> Faultf3R {
                Faultf3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Fault Inputs" ]
            # [ inline ( always ) ]
            pub fn faultin(&self) -> FaultinR {
                FaultinR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&self) -> WpenR {
                WpenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Fault Detection Flag" ]
            # [ inline ( always ) ]
            pub fn faultf(&self) -> FaultfR {
                FaultfR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&mut self) -> _WpenW {
                _WpenW { w: self }
            }
        }
    }
    # [ doc = "Input Capture Filter Control" ]
    pub struct Filter {
        register: VolatileCell<u32>,
    }
    # [ doc = "Input Capture Filter Control" ]
    pub mod filter {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Filter {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch0fvalR {
            bits: u8,
        }
        impl Ch0fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch1fvalR {
            bits: u8,
        }
        impl Ch1fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch2fvalR {
            bits: u8,
        }
        impl Ch2fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch3fvalR {
            bits: u8,
        }
        impl Ch3fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&self) -> Ch0fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch0fvalR { bits }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&self) -> Ch1fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch1fvalR { bits }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&self) -> Ch2fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch2fvalR { bits }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&self) -> Ch3fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch3fvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&mut self) -> _Ch0fvalW {
                _Ch0fvalW { w: self }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&mut self) -> _Ch1fvalW {
                _Ch1fvalW { w: self }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&mut self) -> _Ch2fvalW {
                _Ch2fvalW { w: self }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&mut self) -> _Ch3fvalW {
                _Ch3fvalW { w: self }
            }
        }
    }
    # [ doc = "Fault Control" ]
    pub struct Fltctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Control" ]
    pub mod fltctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULT0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault0enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault0enR::_0 => 0,
                    Fault0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault0enR {
                match bits {
                    0 => Fault0enR::_0,
                    1 => Fault0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault1enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault1enR::_0 => 0,
                    Fault1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault1enR {
                match bits {
                    0 => Fault1enR::_0,
                    1 => Fault1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault2enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault2enR::_0 => 0,
                    Fault2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault2enR {
                match bits {
                    0 => Fault2enR::_0,
                    1 => Fault2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault3enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault3enR::_0 => 0,
                    Fault3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault3enR {
                match bits {
                    0 => Fault3enR::_0,
                    1 => Fault3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault3enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr0enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr0enR::_0 => 0,
                    Ffltr0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr0enR {
                match bits {
                    0 => Ffltr0enR::_0,
                    1 => Ffltr0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr1enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr1enR::_0 => 0,
                    Ffltr1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr1enR {
                match bits {
                    0 => Ffltr1enR::_0,
                    1 => Ffltr1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr2enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr2enR::_0 => 0,
                    Ffltr2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr2enR {
                match bits {
                    0 => Ffltr2enR::_0,
                    1 => Ffltr2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr3enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr3enR::_0 => 0,
                    Ffltr3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr3enR {
                match bits {
                    0 => Ffltr3enR::_0,
                    1 => Ffltr3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr3enR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FfvalR {
            bits: u8,
        }
        impl FfvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FSTATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FstateR {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FstateR::_0 => 0,
                    FstateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FstateR {
                match bits {
                    0 => FstateR::_0,
                    1 => FstateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FstateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FstateR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FAULT0EN`" ]
        pub enum Fault0enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault0enW::_0 => 0,
                    Fault0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault0enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT1EN`" ]
        pub enum Fault1enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault1enW::_0 => 0,
                    Fault1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault1enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT2EN`" ]
        pub enum Fault2enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault2enW::_0 => 0,
                    Fault2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault2enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT3EN`" ]
        pub enum Fault3enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault3enW::_0 => 0,
                    Fault3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault3enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR0EN`" ]
        pub enum Ffltr0enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr0enW::_0 => 0,
                    Ffltr0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr0enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR1EN`" ]
        pub enum Ffltr1enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr1enW::_0 => 0,
                    Ffltr1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr1enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR2EN`" ]
        pub enum Ffltr2enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr2enW::_0 => 0,
                    Ffltr2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr2enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR3EN`" ]
        pub enum Ffltr3enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr3enW::_0 => 0,
                    Ffltr3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr3enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FfvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FfvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FSTATE`" ]
        pub enum FstateW {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FstateW::_0 => 0,
                    FstateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FstateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FstateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FstateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FstateW::_0)
            }
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FstateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&self) -> Fault0enR {
                Fault0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&self) -> Fault1enR {
                Fault1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&self) -> Fault2enR {
                Fault2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&self) -> Fault3enR {
                Fault3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&self) -> Ffltr0enR {
                Ffltr0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 4;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&self) -> Ffltr1enR {
                Ffltr1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&self) -> Ffltr2enR {
                Ffltr2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&self) -> Ffltr3enR {
                Ffltr3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&self) -> FfvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FfvalR { bits }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&self) -> FstateR {
                FstateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&mut self) -> _Fault0enW {
                _Fault0enW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&mut self) -> _Fault1enW {
                _Fault1enW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&mut self) -> _Fault2enW {
                _Fault2enW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&mut self) -> _Fault3enW {
                _Fault3enW { w: self }
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&mut self) -> _Ffltr0enW {
                _Ffltr0enW { w: self }
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&mut self) -> _Ffltr1enW {
                _Ffltr1enW { w: self }
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&mut self) -> _Ffltr2enW {
                _Ffltr2enW { w: self }
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&mut self) -> _Ffltr3enW {
                _Ffltr3enW { w: self }
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&mut self) -> _FfvalW {
                _FfvalW { w: self }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&mut self) -> _FstateW {
                _FstateW { w: self }
            }
        }
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub struct Qdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub mod qdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Qdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `QUADEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadenR {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadenR::_0 => 0,
                    QuadenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadenR {
                match bits {
                    0 => QuadenR::_0,
                    1 => QuadenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadenR::_1
            }
        }
        # [ doc = "Possible values of the field `TOFDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofdirR {
            # [ doc = "TOF bit was set on the bottom of counting. There was an FTM counter decrement and FTM counter changes from its minimum value (CNTIN register) to its maximum value (MOD register)." ]
            _0,
            # [ doc = "TOF bit was set on the top of counting. There was an FTM counter increment and FTM counter changes from its maximum value (MOD register) to its minimum value (CNTIN register)." ]
            _1,
        }
        impl TofdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofdirR::_0 => 0,
                    TofdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofdirR {
                match bits {
                    0 => TofdirR::_0,
                    1 => TofdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofdirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadirR {
            # [ doc = "Counting direction is decreasing (FTM counter decrement)." ]
            _0,
            # [ doc = "Counting direction is increasing (FTM counter increment)." ]
            _1,
        }
        impl QuadirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadirR::_0 => 0,
                    QuadirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadirR {
                match bits {
                    0 => QuadirR::_0,
                    1 => QuadirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadmodeR {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadmodeR::_0 => 0,
                    QuadmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadmodeR {
                match bits {
                    0 => QuadmodeR::_0,
                    1 => QuadmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbpolR {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbpolR::_0 => 0,
                    PhbpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbpolR {
                match bits {
                    0 => PhbpolR::_0,
                    1 => PhbpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbpolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhapolR {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhapolR::_0 => 0,
                    PhapolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhapolR {
                match bits {
                    0 => PhapolR::_0,
                    1 => PhapolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhapolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhapolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbfltrenR {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbfltrenR::_0 => 0,
                    PhbfltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbfltrenR {
                match bits {
                    0 => PhbfltrenR::_0,
                    1 => PhbfltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbfltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbfltrenR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhafltrenR {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhafltrenR::_0 => 0,
                    PhafltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhafltrenR {
                match bits {
                    0 => PhafltrenR::_0,
                    1 => PhafltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhafltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhafltrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `QUADEN`" ]
        pub enum QuadenW {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadenW::_0 => 0,
                    QuadenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Quadrature Decoder mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadenW::_0)
            }
            # [ doc = "Quadrature Decoder mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `QUADMODE`" ]
        pub enum QuadmodeW {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadmodeW::_0 => 0,
                    QuadmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A and phase B encoding mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadmodeW::_0)
            }
            # [ doc = "Count and direction encoding mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBPOL`" ]
        pub enum PhbpolW {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbpolW::_0 => 0,
                    PhbpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbpolW::_0)
            }
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAPOL`" ]
        pub enum PhapolW {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhapolW::_0 => 0,
                    PhapolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhapolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhapolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhapolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhapolW::_0)
            }
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhapolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBFLTREN`" ]
        pub enum PhbfltrenW {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbfltrenW::_0 => 0,
                    PhbfltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbfltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbfltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbfltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase B input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbfltrenW::_0)
            }
            # [ doc = "Phase B input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbfltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAFLTREN`" ]
        pub enum PhafltrenW {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhafltrenW::_0 => 0,
                    PhafltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhafltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhafltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhafltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhafltrenW::_0)
            }
            # [ doc = "Phase A input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhafltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&self) -> QuadenR {
                QuadenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Timer Overflow Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn tofdir(&self) -> TofdirR {
                TofdirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadir(&self) -> QuadirR {
                QuadirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&self) -> QuadmodeR {
                QuadmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&self) -> PhbpolR {
                PhbpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&self) -> PhapolR {
                PhapolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&self) -> PhbfltrenR {
                PhbfltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 6;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&self) -> PhafltrenR {
                PhafltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 7;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&mut self) -> _QuadenW {
                _QuadenW { w: self }
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&mut self) -> _QuadmodeW {
                _QuadmodeW { w: self }
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&mut self) -> _PhbpolW {
                _PhbpolW { w: self }
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&mut self) -> _PhapolW {
                _PhapolW { w: self }
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&mut self) -> _PhbfltrenW {
                _PhbfltrenW { w: self }
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&mut self) -> _PhafltrenW {
                _PhafltrenW { w: self }
            }
        }
    }
    # [ doc = "Configuration" ]
    pub struct Conf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration" ]
    pub mod conf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Conf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LdfqR {
            bits: u8,
        }
        impl LdfqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BdmmodeR {
            bits: u8,
        }
        impl BdmmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeenR {
            bits: u8,
        }
        impl GtbeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeoutR {
            bits: u8,
        }
        impl GtbeoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ITRIGR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ItrigrR {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ItrigrR::_0 => 0,
                    ItrigrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ItrigrR {
                match bits {
                    0 => ItrigrR::_0,
                    1 => ItrigrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ItrigrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ItrigrR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdfqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdfqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BdmmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BdmmodeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeoutW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ITRIGR`" ]
        pub enum ItrigrW {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ItrigrW::_0 => 0,
                    ItrigrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ItrigrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ItrigrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ItrigrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ItrigrW::_0)
            }
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ItrigrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&self) -> LdfqR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LdfqR { bits }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&self) -> BdmmodeR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BdmmodeR { bits }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&self) -> GtbeenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeenR { bits }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&self) -> GtbeoutR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeoutR { bits }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&self) -> ItrigrR {
                ItrigrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&mut self) -> _LdfqW {
                _LdfqW { w: self }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&mut self) -> _BdmmodeW {
                _BdmmodeW { w: self }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&mut self) -> _GtbeenW {
                _GtbeenW { w: self }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&mut self) -> _GtbeoutW {
                _GtbeoutW { w: self }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&mut self) -> _ItrigrW {
                _ItrigrW { w: self }
            }
        }
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub struct Fltpol {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub mod fltpol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltpol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FLT0POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt0polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt0polR::_0 => 0,
                    Flt0polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt0polR {
                match bits {
                    0 => Flt0polR::_0,
                    1 => Flt0polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt0polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt0polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT1POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt1polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt1polR::_0 => 0,
                    Flt1polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt1polR {
                match bits {
                    0 => Flt1polR::_0,
                    1 => Flt1polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt1polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt1polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT2POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt2polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt2polR::_0 => 0,
                    Flt2polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt2polR {
                match bits {
                    0 => Flt2polR::_0,
                    1 => Flt2polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt2polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt2polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT3POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt3polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt3polR::_0 => 0,
                    Flt3polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt3polR {
                match bits {
                    0 => Flt3polR::_0,
                    1 => Flt3polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt3polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt3polR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FLT0POL`" ]
        pub enum Flt0polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt0polW::_0 => 0,
                    Flt0polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt0polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt0polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt0polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt0polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt0polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT1POL`" ]
        pub enum Flt1polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt1polW::_0 => 0,
                    Flt1polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt1polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt1polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt1polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt1polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt1polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT2POL`" ]
        pub enum Flt2polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt2polW::_0 => 0,
                    Flt2polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt2polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt2polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt2polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt2polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt2polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT3POL`" ]
        pub enum Flt3polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt3polW::_0 => 0,
                    Flt3polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt3polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt3polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt3polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt3polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt3polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&self) -> Flt0polR {
                Flt0polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&self) -> Flt1polR {
                Flt1polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&self) -> Flt2polR {
                Flt2polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&self) -> Flt3polR {
                Flt3polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&mut self) -> _Flt0polW {
                _Flt0polW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&mut self) -> _Flt1polW {
                _Flt1polW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&mut self) -> _Flt2polW {
                _Flt2polW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&mut self) -> _Flt3polW {
                _Flt3polW { w: self }
            }
        }
    }
    # [ doc = "Synchronization Configuration" ]
    pub struct Synconf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization Configuration" ]
    pub mod synconf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Synconf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HWTRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwtrigmodeR {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwtrigmodeR::_0 => 0,
                    HwtrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwtrigmodeR {
                match bits {
                    0 => HwtrigmodeR::_0,
                    1 => HwtrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwtrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwtrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTINC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntincR {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntincR::_0 => 0,
                    CntincR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntincR {
                match bits {
                    0 => CntincR::_0,
                    1 => CntincR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntincR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntincR::_1
            }
        }
        # [ doc = "Possible values of the field `INVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InvcR {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InvcR::_0 => 0,
                    InvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InvcR {
                match bits {
                    0 => InvcR::_0,
                    1 => InvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwocR {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwocR::_0 => 0,
                    SwocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwocR {
                match bits {
                    0 => SwocR::_0,
                    1 => SwocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwocR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SyncmodeR {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SyncmodeR::_0 => 0,
                    SyncmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SyncmodeR {
                match bits {
                    0 => SyncmodeR::_0,
                    1 => SyncmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SyncmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SyncmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `SWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwrstcntR {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwrstcntR::_0 => 0,
                    SwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwrstcntR {
                match bits {
                    0 => SwrstcntR::_0,
                    1 => SwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `SWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwwrbufR {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwwrbufR::_0 => 0,
                    SwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwwrbufR {
                match bits {
                    0 => SwwrbufR::_0,
                    1 => SwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwomR {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwomR::_0 => 0,
                    SwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwomR {
                match bits {
                    0 => SwomR::_0,
                    1 => SwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwomR::_1
            }
        }
        # [ doc = "Possible values of the field `SWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwinvcR {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwinvcR::_0 => 0,
                    SwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwinvcR {
                match bits {
                    0 => SwinvcR::_0,
                    1 => SwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsocR {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsocR::_0 => 0,
                    SwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsocR {
                match bits {
                    0 => SwsocR::_0,
                    1 => SwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsocR::_1
            }
        }
        # [ doc = "Possible values of the field `HWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwrstcntR {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwrstcntR::_0 => 0,
                    HwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwrstcntR {
                match bits {
                    0 => HwrstcntR::_0,
                    1 => HwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `HWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwwrbufR {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwwrbufR::_0 => 0,
                    HwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwwrbufR {
                match bits {
                    0 => HwwrbufR::_0,
                    1 => HwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `HWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwomR {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwomR::_0 => 0,
                    HwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwomR {
                match bits {
                    0 => HwomR::_0,
                    1 => HwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwomR::_1
            }
        }
        # [ doc = "Possible values of the field `HWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwinvcR {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwinvcR::_0 => 0,
                    HwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwinvcR {
                match bits {
                    0 => HwinvcR::_0,
                    1 => HwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `HWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwsocR {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwsocR::_0 => 0,
                    HwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwsocR {
                match bits {
                    0 => HwsocR::_0,
                    1 => HwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwsocR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HWTRIGMODE`" ]
        pub enum HwtrigmodeW {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwtrigmodeW::_0 => 0,
                    HwtrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwtrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwtrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwtrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_0)
            }
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTINC`" ]
        pub enum CntincW {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntincW::_0 => 0,
                    CntincW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntincW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntincW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntincW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntincW::_0)
            }
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntincW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVC`" ]
        pub enum InvcW {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InvcW::_0 => 0,
                    InvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InvcW::_0)
            }
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOC`" ]
        pub enum SwocW {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwocW::_0 => 0,
                    SwocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwocW::_0)
            }
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCMODE`" ]
        pub enum SyncmodeW {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SyncmodeW::_0 => 0,
                    SyncmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SyncmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SyncmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SyncmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Legacy PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SyncmodeW::_0)
            }
            # [ doc = "Enhanced PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SyncmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWRSTCNT`" ]
        pub enum SwrstcntW {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwrstcntW::_0 => 0,
                    SwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwrstcntW::_0)
            }
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWWRBUF`" ]
        pub enum SwwrbufW {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwwrbufW::_0 => 0,
                    SwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwwrbufW::_0)
            }
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOM`" ]
        pub enum SwomW {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwomW::_0 => 0,
                    SwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwomW::_0)
            }
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWINVC`" ]
        pub enum SwinvcW {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwinvcW::_0 => 0,
                    SwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwinvcW::_0)
            }
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSOC`" ]
        pub enum SwsocW {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsocW::_0 => 0,
                    SwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsocW::_0)
            }
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWRSTCNT`" ]
        pub enum HwrstcntW {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwrstcntW::_0 => 0,
                    HwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwrstcntW::_0)
            }
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWWRBUF`" ]
        pub enum HwwrbufW {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwwrbufW::_0 => 0,
                    HwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwwrbufW::_0)
            }
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWOM`" ]
        pub enum HwomW {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwomW::_0 => 0,
                    HwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwomW::_0)
            }
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWINVC`" ]
        pub enum HwinvcW {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwinvcW::_0 => 0,
                    HwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwinvcW::_0)
            }
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWSOC`" ]
        pub enum HwsocW {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwsocW::_0 => 0,
                    HwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwsocW::_0)
            }
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&self) -> HwtrigmodeR {
                HwtrigmodeR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&self) -> CntincR {
                CntincR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&self) -> InvcR {
                InvcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&self) -> SwocR {
                SwocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&self) -> SyncmodeR {
                SyncmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&self) -> SwrstcntR {
                SwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&self) -> SwwrbufR {
                SwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&self) -> SwomR {
                SwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&self) -> SwinvcR {
                SwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&self) -> SwsocR {
                SwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&self) -> HwrstcntR {
                HwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 16;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&self) -> HwwrbufR {
                HwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&self) -> HwomR {
                HwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&self) -> HwinvcR {
                HwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&self) -> HwsocR {
                HwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&mut self) -> _HwtrigmodeW {
                _HwtrigmodeW { w: self }
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&mut self) -> _CntincW {
                _CntincW { w: self }
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&mut self) -> _InvcW {
                _InvcW { w: self }
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&mut self) -> _SwocW {
                _SwocW { w: self }
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&mut self) -> _SyncmodeW {
                _SyncmodeW { w: self }
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&mut self) -> _SwrstcntW {
                _SwrstcntW { w: self }
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&mut self) -> _SwwrbufW {
                _SwwrbufW { w: self }
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&mut self) -> _SwomW {
                _SwomW { w: self }
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&mut self) -> _SwinvcW {
                _SwinvcW { w: self }
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&mut self) -> _SwsocW {
                _SwsocW { w: self }
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&mut self) -> _HwrstcntW {
                _HwrstcntW { w: self }
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&mut self) -> _HwwrbufW {
                _HwwrbufW { w: self }
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&mut self) -> _HwomW {
                _HwomW { w: self }
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&mut self) -> _HwinvcW {
                _HwinvcW { w: self }
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&mut self) -> _HwsocW {
                _HwsocW { w: self }
            }
        }
    }
    # [ doc = "FTM Inverting Control" ]
    pub struct Invctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Inverting Control" ]
    pub mod invctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Invctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `INV0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv0enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv0enR::_0 => 0,
                    Inv0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv0enR {
                match bits {
                    0 => Inv0enR::_0,
                    1 => Inv0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv0enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv1enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv1enR::_0 => 0,
                    Inv1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv1enR {
                match bits {
                    0 => Inv1enR::_0,
                    1 => Inv1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv1enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv2enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv2enR::_0 => 0,
                    Inv2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv2enR {
                match bits {
                    0 => Inv2enR::_0,
                    1 => Inv2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv2enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv3enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv3enR::_0 => 0,
                    Inv3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv3enR {
                match bits {
                    0 => Inv3enR::_0,
                    1 => Inv3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv3enR::_1
            }
        }
        # [ doc = "Values that can be written to the field `INV0EN`" ]
        pub enum Inv0enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv0enW::_0 => 0,
                    Inv0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv0enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV1EN`" ]
        pub enum Inv1enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv1enW::_0 => 0,
                    Inv1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv1enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV2EN`" ]
        pub enum Inv2enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv2enW::_0 => 0,
                    Inv2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv2enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV3EN`" ]
        pub enum Inv3enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv3enW::_0 => 0,
                    Inv3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv3enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&self) -> Inv0enR {
                Inv0enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&self) -> Inv1enR {
                Inv1enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&self) -> Inv2enR {
                Inv2enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&self) -> Inv3enR {
                Inv3enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&mut self) -> _Inv0enW {
                _Inv0enW { w: self }
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&mut self) -> _Inv1enW {
                _Inv1enW { w: self }
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&mut self) -> _Inv2enW {
                _Inv2enW { w: self }
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&mut self) -> _Inv3enW {
                _Inv3enW { w: self }
            }
        }
    }
    # [ doc = "FTM Software Output Control" ]
    pub struct Swoctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Software Output Control" ]
    pub mod swoctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Swoctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocR::_0 => 0,
                    Ch0ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocR {
                match bits {
                    0 => Ch0ocR::_0,
                    1 => Ch0ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocR::_0 => 0,
                    Ch1ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocR {
                match bits {
                    0 => Ch1ocR::_0,
                    1 => Ch1ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocR::_0 => 0,
                    Ch2ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocR {
                match bits {
                    0 => Ch2ocR::_0,
                    1 => Ch2ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocR::_0 => 0,
                    Ch3ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocR {
                match bits {
                    0 => Ch3ocR::_0,
                    1 => Ch3ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocR::_0 => 0,
                    Ch4ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocR {
                match bits {
                    0 => Ch4ocR::_0,
                    1 => Ch4ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocR::_0 => 0,
                    Ch5ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocR {
                match bits {
                    0 => Ch5ocR::_0,
                    1 => Ch5ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocR::_0 => 0,
                    Ch6ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocR {
                match bits {
                    0 => Ch6ocR::_0,
                    1 => Ch6ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocR::_0 => 0,
                    Ch7ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocR {
                match bits {
                    0 => Ch7ocR::_0,
                    1 => Ch7ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocvR::_0 => 0,
                    Ch0ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocvR {
                match bits {
                    0 => Ch0ocvR::_0,
                    1 => Ch0ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocvR::_0 => 0,
                    Ch1ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocvR {
                match bits {
                    0 => Ch1ocvR::_0,
                    1 => Ch1ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocvR::_0 => 0,
                    Ch2ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocvR {
                match bits {
                    0 => Ch2ocvR::_0,
                    1 => Ch2ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocvR::_0 => 0,
                    Ch3ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocvR {
                match bits {
                    0 => Ch3ocvR::_0,
                    1 => Ch3ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocvR::_0 => 0,
                    Ch4ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocvR {
                match bits {
                    0 => Ch4ocvR::_0,
                    1 => Ch4ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocvR::_0 => 0,
                    Ch5ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocvR {
                match bits {
                    0 => Ch5ocvR::_0,
                    1 => Ch5ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocvR::_0 => 0,
                    Ch6ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocvR {
                match bits {
                    0 => Ch6ocvR::_0,
                    1 => Ch6ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocvR::_0 => 0,
                    Ch7ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocvR {
                match bits {
                    0 => Ch7ocvR::_0,
                    1 => Ch7ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocvR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OC`" ]
        pub enum Ch0ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocW::_0 => 0,
                    Ch0ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OC`" ]
        pub enum Ch1ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocW::_0 => 0,
                    Ch1ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OC`" ]
        pub enum Ch2ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocW::_0 => 0,
                    Ch2ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OC`" ]
        pub enum Ch3ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocW::_0 => 0,
                    Ch3ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OC`" ]
        pub enum Ch4ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocW::_0 => 0,
                    Ch4ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OC`" ]
        pub enum Ch5ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocW::_0 => 0,
                    Ch5ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OC`" ]
        pub enum Ch6ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocW::_0 => 0,
                    Ch6ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OC`" ]
        pub enum Ch7ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocW::_0 => 0,
                    Ch7ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0OCV`" ]
        pub enum Ch0ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocvW::_0 => 0,
                    Ch0ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OCV`" ]
        pub enum Ch1ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocvW::_0 => 0,
                    Ch1ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OCV`" ]
        pub enum Ch2ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocvW::_0 => 0,
                    Ch2ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OCV`" ]
        pub enum Ch3ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocvW::_0 => 0,
                    Ch3ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OCV`" ]
        pub enum Ch4ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocvW::_0 => 0,
                    Ch4ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OCV`" ]
        pub enum Ch5ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocvW::_0 => 0,
                    Ch5ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OCV`" ]
        pub enum Ch6ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocvW::_0 => 0,
                    Ch6ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OCV`" ]
        pub enum Ch7ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocvW::_0 => 0,
                    Ch7ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&self) -> Ch0ocR {
                Ch0ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&self) -> Ch1ocR {
                Ch1ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&self) -> Ch2ocR {
                Ch2ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&self) -> Ch3ocR {
                Ch3ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&self) -> Ch4ocR {
                Ch4ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&self) -> Ch5ocR {
                Ch5ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&self) -> Ch6ocR {
                Ch6ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&self) -> Ch7ocR {
                Ch7ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&self) -> Ch0ocvR {
                Ch0ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&self) -> Ch1ocvR {
                Ch1ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&self) -> Ch2ocvR {
                Ch2ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&self) -> Ch3ocvR {
                Ch3ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&self) -> Ch4ocvR {
                Ch4ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&self) -> Ch5ocvR {
                Ch5ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&self) -> Ch6ocvR {
                Ch6ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&self) -> Ch7ocvR {
                Ch7ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&mut self) -> _Ch0ocW {
                _Ch0ocW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&mut self) -> _Ch1ocW {
                _Ch1ocW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&mut self) -> _Ch2ocW {
                _Ch2ocW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&mut self) -> _Ch3ocW {
                _Ch3ocW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&mut self) -> _Ch4ocW {
                _Ch4ocW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&mut self) -> _Ch5ocW {
                _Ch5ocW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&mut self) -> _Ch6ocW {
                _Ch6ocW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&mut self) -> _Ch7ocW {
                _Ch7ocW { w: self }
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&mut self) -> _Ch0ocvW {
                _Ch0ocvW { w: self }
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&mut self) -> _Ch1ocvW {
                _Ch1ocvW { w: self }
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&mut self) -> _Ch2ocvW {
                _Ch2ocvW { w: self }
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&mut self) -> _Ch3ocvW {
                _Ch3ocvW { w: self }
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&mut self) -> _Ch4ocvW {
                _Ch4ocvW { w: self }
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&mut self) -> _Ch5ocvW {
                _Ch5ocvW { w: self }
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&mut self) -> _Ch6ocvW {
                _Ch6ocvW { w: self }
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&mut self) -> _Ch7ocvW {
                _Ch7ocvW { w: self }
            }
        }
    }
    # [ doc = "FTM PWM Load" ]
    pub struct Pwmload {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM PWM Load" ]
    pub mod pwmload {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pwmload {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0selR::_0 => 0,
                    Ch0selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0selR {
                match bits {
                    0 => Ch0selR::_0,
                    1 => Ch0selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1selR::_0 => 0,
                    Ch1selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1selR {
                match bits {
                    0 => Ch1selR::_0,
                    1 => Ch1selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2selR::_0 => 0,
                    Ch2selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2selR {
                match bits {
                    0 => Ch2selR::_0,
                    1 => Ch2selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3selR::_0 => 0,
                    Ch3selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3selR {
                match bits {
                    0 => Ch3selR::_0,
                    1 => Ch3selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4selR::_0 => 0,
                    Ch4selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4selR {
                match bits {
                    0 => Ch4selR::_0,
                    1 => Ch4selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5selR::_0 => 0,
                    Ch5selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5selR {
                match bits {
                    0 => Ch5selR::_0,
                    1 => Ch5selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6selR::_0 => 0,
                    Ch6selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6selR {
                match bits {
                    0 => Ch6selR::_0,
                    1 => Ch6selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7selR::_0 => 0,
                    Ch7selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7selR {
                match bits {
                    0 => Ch7selR::_0,
                    1 => Ch7selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7selR::_1
            }
        }
        # [ doc = "Possible values of the field `HCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HcselR {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HcselR::_0 => 0,
                    HcselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HcselR {
                match bits {
                    0 => HcselR::_0,
                    1 => HcselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HcselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HcselR::_1
            }
        }
        # [ doc = "Possible values of the field `LDOK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LdokR {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LdokR::_0 => 0,
                    LdokR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LdokR {
                match bits {
                    0 => LdokR::_0,
                    1 => LdokR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LdokR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LdokR::_1
            }
        }
        # [ doc = "Possible values of the field `GLEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GlenR {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GlenR::_0 => 0,
                    GlenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GlenR {
                match bits {
                    0 => GlenR::_0,
                    1 => GlenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GlenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GlenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0SEL`" ]
        pub enum Ch0selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0selW::_0 => 0,
                    Ch0selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1SEL`" ]
        pub enum Ch1selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1selW::_0 => 0,
                    Ch1selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2SEL`" ]
        pub enum Ch2selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2selW::_0 => 0,
                    Ch2selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3SEL`" ]
        pub enum Ch3selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3selW::_0 => 0,
                    Ch3selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4SEL`" ]
        pub enum Ch4selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4selW::_0 => 0,
                    Ch4selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5SEL`" ]
        pub enum Ch5selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5selW::_0 => 0,
                    Ch5selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6SEL`" ]
        pub enum Ch6selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6selW::_0 => 0,
                    Ch6selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7SEL`" ]
        pub enum Ch7selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7selW::_0 => 0,
                    Ch7selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HCSEL`" ]
        pub enum HcselW {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HcselW::_0 => 0,
                    HcselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HcselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HcselW::_0)
            }
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HcselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LDOK`" ]
        pub enum LdokW {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LdokW::_0 => 0,
                    LdokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LdokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loading updated values is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LdokW::_0)
            }
            # [ doc = "Loading updated values is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LdokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLEN`" ]
        pub enum GlenW {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GlenW::_0 => 0,
                    GlenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GlenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GlenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GlenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Global Load Ok disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GlenW::_0)
            }
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GlenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLDOK`" ]
        pub enum GldokW {
            # [ doc = "No action." ]
            _0,
            # [ doc = "LDOK bit is set." ]
            _1,
        }
        impl GldokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GldokW::_0 => 0,
                    GldokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GldokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GldokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GldokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No action." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GldokW::_0)
            }
            # [ doc = "LDOK bit is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GldokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&self) -> Ch0selR {
                Ch0selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&self) -> Ch1selR {
                Ch1selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&self) -> Ch2selR {
                Ch2selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&self) -> Ch3selR {
                Ch3selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&self) -> Ch4selR {
                Ch4selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&self) -> Ch5selR {
                Ch5selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&self) -> Ch6selR {
                Ch6selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&self) -> Ch7selR {
                Ch7selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&self) -> HcselR {
                HcselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&self) -> LdokR {
                LdokR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&self) -> GlenR {
                GlenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&mut self) -> _Ch0selW {
                _Ch0selW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&mut self) -> _Ch1selW {
                _Ch1selW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&mut self) -> _Ch2selW {
                _Ch2selW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&mut self) -> _Ch3selW {
                _Ch3selW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&mut self) -> _Ch4selW {
                _Ch4selW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&mut self) -> _Ch5selW {
                _Ch5selW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&mut self) -> _Ch6selW {
                _Ch6selW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&mut self) -> _Ch7selW {
                _Ch7selW { w: self }
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&mut self) -> _HcselW {
                _HcselW { w: self }
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&mut self) -> _LdokW {
                _LdokW { w: self }
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&mut self) -> _GlenW {
                _GlenW { w: self }
            }
            # [ doc = "Bit 11 - Global Load OK" ]
            # [ inline ( always ) ]
            pub fn gldok(&mut self) -> _GldokW {
                _GldokW { w: self }
            }
        }
    }
    # [ doc = "Half Cycle Register" ]
    pub struct Hcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Half Cycle Register" ]
    pub mod hcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Hcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HcvalR {
            bits: u16,
        }
        impl HcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&self) -> HcvalR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                HcvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&mut self) -> _HcvalW {
                _HcvalW { w: self }
            }
        }
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub struct Pair0deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub mod pair0deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair0deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub struct Pair1deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub mod pair1deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair1deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub struct Pair2deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub mod pair2deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair2deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub struct Pair3deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub mod pair3deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair3deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
}
# [ doc = "FlexTimer Module" ]
pub struct Ftm2 {
    register_block: ftm2::RegisterBlock,
}
impl Deref for Ftm2 {
    type Target = ftm2::RegisterBlock;
    fn deref(&self) -> &ftm2::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "FlexTimer Module" ]
pub const FTM3: Peripheral<Ftm3> = unsafe { Peripheral::new(1073897472) };
# [ doc = "FlexTimer Module" ]
pub mod ftm3 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Status And Control" ]
        pub sc: Sc,
        # [ doc = "0x04 - Counter" ]
        pub cnt: Cnt,
        # [ doc = "0x08 - Modulo" ]
        pub mod_: Mod,
        # [ doc = "0x0c - Channel (n) Status And Control" ]
        pub c0sc: C0sc,
        # [ doc = "0x10 - Channel (n) Value" ]
        pub c0v: C0v,
        # [ doc = "0x14 - Channel (n) Status And Control" ]
        pub c1sc: C1sc,
        # [ doc = "0x18 - Channel (n) Value" ]
        pub c1v: C1v,
        # [ doc = "0x1c - Channel (n) Status And Control" ]
        pub c2sc: C2sc,
        # [ doc = "0x20 - Channel (n) Value" ]
        pub c2v: C2v,
        # [ doc = "0x24 - Channel (n) Status And Control" ]
        pub c3sc: C3sc,
        # [ doc = "0x28 - Channel (n) Value" ]
        pub c3v: C3v,
        # [ doc = "0x2c - Channel (n) Status And Control" ]
        pub c4sc: C4sc,
        # [ doc = "0x30 - Channel (n) Value" ]
        pub c4v: C4v,
        # [ doc = "0x34 - Channel (n) Status And Control" ]
        pub c5sc: C5sc,
        # [ doc = "0x38 - Channel (n) Value" ]
        pub c5v: C5v,
        # [ doc = "0x3c - Channel (n) Status And Control" ]
        pub c6sc: C6sc,
        # [ doc = "0x40 - Channel (n) Value" ]
        pub c6v: C6v,
        # [ doc = "0x44 - Channel (n) Status And Control" ]
        pub c7sc: C7sc,
        # [ doc = "0x48 - Channel (n) Value" ]
        pub c7v: C7v,
        # [ doc = "0x4c - Counter Initial Value" ]
        pub cntin: Cntin,
        # [ doc = "0x50 - Capture And Compare Status" ]
        pub status: Status,
        # [ doc = "0x54 - Features Mode Selection" ]
        pub mode: Mode,
        # [ doc = "0x58 - Synchronization" ]
        pub sync: Sync,
        # [ doc = "0x5c - Initial State For Channels Output" ]
        pub outinit: Outinit,
        # [ doc = "0x60 - Output Mask" ]
        pub outmask: Outmask,
        # [ doc = "0x64 - Function For Linked Channels" ]
        pub combine: Combine,
        # [ doc = "0x68 - Deadtime Configuration" ]
        pub deadtime: Deadtime,
        # [ doc = "0x6c - FTM External Trigger" ]
        pub exttrig: Exttrig,
        # [ doc = "0x70 - Channels Polarity" ]
        pub pol: Pol,
        # [ doc = "0x74 - Fault Mode Status" ]
        pub fms: Fms,
        # [ doc = "0x78 - Input Capture Filter Control" ]
        pub filter: Filter,
        # [ doc = "0x7c - Fault Control" ]
        pub fltctrl: Fltctrl,
        # [ doc = "0x80 - Quadrature Decoder Control And Status" ]
        pub qdctrl: Qdctrl,
        # [ doc = "0x84 - Configuration" ]
        pub conf: Conf,
        # [ doc = "0x88 - FTM Fault Input Polarity" ]
        pub fltpol: Fltpol,
        # [ doc = "0x8c - Synchronization Configuration" ]
        pub synconf: Synconf,
        # [ doc = "0x90 - FTM Inverting Control" ]
        pub invctrl: Invctrl,
        # [ doc = "0x94 - FTM Software Output Control" ]
        pub swoctrl: Swoctrl,
        # [ doc = "0x98 - FTM PWM Load" ]
        pub pwmload: Pwmload,
        # [ doc = "0x9c - Half Cycle Register" ]
        pub hcr: Hcr,
        # [ doc = "0xa0 - Pair 0 Deadtime Configuration" ]
        pub pair0deadtime: Pair0deadtime,
        _reserved0: [u8; 4usize],
        # [ doc = "0xa8 - Pair 1 Deadtime Configuration" ]
        pub pair1deadtime: Pair1deadtime,
        _reserved1: [u8; 4usize],
        # [ doc = "0xb0 - Pair 2 Deadtime Configuration" ]
        pub pair2deadtime: Pair2deadtime,
        _reserved2: [u8; 4usize],
        # [ doc = "0xb8 - Pair 3 Deadtime Configuration" ]
        pub pair3deadtime: Pair3deadtime,
    }
    # [ doc = "Status And Control" ]
    pub struct Sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status And Control" ]
    pub mod sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_000 => 0,
                    PsR::_001 => 1,
                    PsR::_010 => 2,
                    PsR::_011 => 3,
                    PsR::_100 => 4,
                    PsR::_101 => 5,
                    PsR::_110 => 6,
                    PsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_000,
                    1 => PsR::_001,
                    2 => PsR::_010,
                    3 => PsR::_011,
                    4 => PsR::_100,
                    5 => PsR::_101,
                    6 => PsR::_110,
                    7 => PsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PsR::_111
            }
        }
        # [ doc = "Possible values of the field `CLKS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClksR {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClksR::_00 => 0,
                    ClksR::_01 => 1,
                    ClksR::_10 => 2,
                    ClksR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClksR {
                match bits {
                    0 => ClksR::_00,
                    1 => ClksR::_01,
                    2 => ClksR::_10,
                    3 => ClksR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ClksR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ClksR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ClksR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ClksR::_11
            }
        }
        # [ doc = "Possible values of the field `CPWMS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpwmsR {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpwmsR::_0 => 0,
                    CpwmsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpwmsR {
                match bits {
                    0 => CpwmsR::_0,
                    1 => CpwmsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpwmsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpwmsR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `RF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RfR {
            # [ doc = "A selected reload point did not happen." ]
            _0,
            # [ doc = "A selected reload point happened." ]
            _1,
        }
        impl RfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RfR::_0 => 0,
                    RfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RfR {
                match bits {
                    0 => RfR::_0,
                    1 => RfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RfR::_1
            }
        }
        # [ doc = "Possible values of the field `TOIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ToieR {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ToieR::_0 => 0,
                    ToieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ToieR {
                match bits {
                    0 => ToieR::_0,
                    1 => ToieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ToieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ToieR::_1
            }
        }
        # [ doc = "Possible values of the field `TOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofR {
            # [ doc = "FTM counter has not overflowed." ]
            _0,
            # [ doc = "FTM counter has overflowed." ]
            _1,
        }
        impl TofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofR::_0 => 0,
                    TofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofR {
                match bits {
                    0 => TofR::_0,
                    1 => TofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen0R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen0R::_0 => 0,
                    Pwmen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen0R {
                match bits {
                    0 => Pwmen0R::_0,
                    1 => Pwmen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen0R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen1R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen1R::_0 => 0,
                    Pwmen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen1R {
                match bits {
                    0 => Pwmen1R::_0,
                    1 => Pwmen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen1R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen2R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen2R::_0 => 0,
                    Pwmen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen2R {
                match bits {
                    0 => Pwmen2R::_0,
                    1 => Pwmen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen2R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen3R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen3R::_0 => 0,
                    Pwmen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen3R {
                match bits {
                    0 => Pwmen3R::_0,
                    1 => Pwmen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen3R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen4R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen4R::_0 => 0,
                    Pwmen4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen4R {
                match bits {
                    0 => Pwmen4R::_0,
                    1 => Pwmen4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen4R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen5R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen5R::_0 => 0,
                    Pwmen5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen5R {
                match bits {
                    0 => Pwmen5R::_0,
                    1 => Pwmen5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen5R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen6R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen6R::_0 => 0,
                    Pwmen6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen6R {
                match bits {
                    0 => Pwmen6R::_0,
                    1 => Pwmen6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen6R::_1
            }
        }
        # [ doc = "Possible values of the field `PWMEN7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pwmen7R {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pwmen7R::_0 => 0,
                    Pwmen7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pwmen7R {
                match bits {
                    0 => Pwmen7R::_0,
                    1 => Pwmen7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pwmen7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pwmen7R::_1
            }
        }
        # [ doc = "Possible values of the field `FLTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FltpsR {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FltpsR::_0000 => 0,
                    FltpsR::_0001 => 1,
                    FltpsR::_0010 => 2,
                    FltpsR::_0011 => 3,
                    FltpsR::_0100 => 4,
                    FltpsR::_0101 => 5,
                    FltpsR::_0110 => 6,
                    FltpsR::_0111 => 7,
                    FltpsR::_1000 => 8,
                    FltpsR::_1001 => 9,
                    FltpsR::_1010 => 10,
                    FltpsR::_1011 => 11,
                    FltpsR::_1100 => 12,
                    FltpsR::_1101 => 13,
                    FltpsR::_1110 => 14,
                    FltpsR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FltpsR {
                match bits {
                    0 => FltpsR::_0000,
                    1 => FltpsR::_0001,
                    2 => FltpsR::_0010,
                    3 => FltpsR::_0011,
                    4 => FltpsR::_0100,
                    5 => FltpsR::_0101,
                    6 => FltpsR::_0110,
                    7 => FltpsR::_0111,
                    8 => FltpsR::_1000,
                    9 => FltpsR::_1001,
                    10 => FltpsR::_1010,
                    11 => FltpsR::_1011,
                    12 => FltpsR::_1100,
                    13 => FltpsR::_1101,
                    14 => FltpsR::_1110,
                    15 => FltpsR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == FltpsR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == FltpsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == FltpsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == FltpsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == FltpsR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == FltpsR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == FltpsR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == FltpsR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == FltpsR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == FltpsR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == FltpsR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == FltpsR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == FltpsR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == FltpsR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == FltpsR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == FltpsR::_1111
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 4" ]
            _010,
            # [ doc = "Divide by 8" ]
            _011,
            # [ doc = "Divide by 16" ]
            _100,
            # [ doc = "Divide by 32" ]
            _101,
            # [ doc = "Divide by 64" ]
            _110,
            # [ doc = "Divide by 128" ]
            _111,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_000 => 0,
                    PsW::_001 => 1,
                    PsW::_010 => 2,
                    PsW::_011 => 3,
                    PsW::_100 => 4,
                    PsW::_101 => 5,
                    PsW::_110 => 6,
                    PsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PsW::_000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PsW::_001)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PsW::_010)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PsW::_011)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PsW::_100)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PsW::_101)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PsW::_110)
            }
            # [ doc = "Divide by 128" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKS`" ]
        pub enum ClksW {
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            _00,
            # [ doc = "FTM input clock" ]
            _01,
            # [ doc = "Fixed frequency clock" ]
            _10,
            # [ doc = "External clock" ]
            _11,
        }
        impl ClksW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClksW::_00 => 0,
                    ClksW::_01 => 1,
                    ClksW::_10 => 2,
                    ClksW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClksW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClksW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClksW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No clock selected. This in effect disables the FTM counter." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ClksW::_00)
            }
            # [ doc = "FTM input clock" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ClksW::_01)
            }
            # [ doc = "Fixed frequency clock" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ClksW::_10)
            }
            # [ doc = "External clock" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ClksW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPWMS`" ]
        pub enum CpwmsW {
            # [ doc = "FTM counter operates in Up Counting mode." ]
            _0,
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            _1,
        }
        impl CpwmsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpwmsW::_0 => 0,
                    CpwmsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpwmsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpwmsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpwmsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter operates in Up Counting mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpwmsW::_0)
            }
            # [ doc = "FTM counter operates in Up-Down Counting mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpwmsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Reload point interrupt is disabled." ]
            _0,
            # [ doc = "Reload point interrupt is enabled." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reload point interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Reload point interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOIE`" ]
        pub enum ToieW {
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            _0,
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            _1,
        }
        impl ToieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ToieW::_0 => 0,
                    ToieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ToieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ToieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ToieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable TOF interrupts. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ToieW::_0)
            }
            # [ doc = "Enable TOF interrupts. An interrupt is generated when TOF equals one." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ToieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN0`" ]
        pub enum Pwmen0W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen0W::_0 => 0,
                    Pwmen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen0W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN1`" ]
        pub enum Pwmen1W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen1W::_0 => 0,
                    Pwmen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen1W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN2`" ]
        pub enum Pwmen2W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen2W::_0 => 0,
                    Pwmen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen2W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN3`" ]
        pub enum Pwmen3W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen3W::_0 => 0,
                    Pwmen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen3W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN4`" ]
        pub enum Pwmen4W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen4W::_0 => 0,
                    Pwmen4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen4W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN5`" ]
        pub enum Pwmen5W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen5W::_0 => 0,
                    Pwmen5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen5W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN6`" ]
        pub enum Pwmen6W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen6W::_0 => 0,
                    Pwmen6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen6W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMEN7`" ]
        pub enum Pwmen7W {
            # [ doc = "Channel output port is disabled" ]
            _0,
            # [ doc = "Channel output port is enabled" ]
            _1,
        }
        impl Pwmen7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pwmen7W::_0 => 0,
                    Pwmen7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pwmen7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pwmen7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pwmen7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output port is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pwmen7W::_0)
            }
            # [ doc = "Channel output port is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pwmen7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLTPS`" ]
        pub enum FltpsW {
            # [ doc = "Divide by 1" ]
            _0000,
            # [ doc = "Divide by 2" ]
            _0001,
            # [ doc = "Divide by 3" ]
            _0010,
            # [ doc = "Divide by 4" ]
            _0011,
            # [ doc = "Divide by 5" ]
            _0100,
            # [ doc = "Divide by 6" ]
            _0101,
            # [ doc = "Divide by 7" ]
            _0110,
            # [ doc = "Divide by 8" ]
            _0111,
            # [ doc = "Divide by 9" ]
            _1000,
            # [ doc = "Divide by 10" ]
            _1001,
            # [ doc = "Divide by 11" ]
            _1010,
            # [ doc = "Divide by 12" ]
            _1011,
            # [ doc = "Divide by 13" ]
            _1100,
            # [ doc = "Divide by 14" ]
            _1101,
            # [ doc = "Divide by 15" ]
            _1110,
            # [ doc = "Divide by 16" ]
            _1111,
        }
        impl FltpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FltpsW::_0000 => 0,
                    FltpsW::_0001 => 1,
                    FltpsW::_0010 => 2,
                    FltpsW::_0011 => 3,
                    FltpsW::_0100 => 4,
                    FltpsW::_0101 => 5,
                    FltpsW::_0110 => 6,
                    FltpsW::_0111 => 7,
                    FltpsW::_1000 => 8,
                    FltpsW::_1001 => 9,
                    FltpsW::_1010 => 10,
                    FltpsW::_1011 => 11,
                    FltpsW::_1100 => 12,
                    FltpsW::_1101 => 13,
                    FltpsW::_1110 => 14,
                    FltpsW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FltpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FltpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FltpsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(FltpsW::_0000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(FltpsW::_0001)
            }
            # [ doc = "Divide by 3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(FltpsW::_0010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(FltpsW::_0011)
            }
            # [ doc = "Divide by 5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(FltpsW::_0100)
            }
            # [ doc = "Divide by 6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(FltpsW::_0101)
            }
            # [ doc = "Divide by 7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(FltpsW::_0110)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(FltpsW::_0111)
            }
            # [ doc = "Divide by 9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(FltpsW::_1000)
            }
            # [ doc = "Divide by 10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(FltpsW::_1001)
            }
            # [ doc = "Divide by 11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(FltpsW::_1010)
            }
            # [ doc = "Divide by 12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(FltpsW::_1011)
            }
            # [ doc = "Divide by 13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(FltpsW::_1100)
            }
            # [ doc = "Divide by 14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(FltpsW::_1101)
            }
            # [ doc = "Divide by 15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(FltpsW::_1110)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(FltpsW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&self) -> ClksR {
                ClksR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&self) -> CpwmsR {
                CpwmsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Reload Flag" ]
            # [ inline ( always ) ]
            pub fn rf(&self) -> RfR {
                RfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 7;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&self) -> ToieR {
                ToieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Timer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn tof(&self) -> TofR {
                TofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&self) -> Pwmen0R {
                Pwmen0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&self) -> Pwmen1R {
                Pwmen1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&self) -> Pwmen2R {
                Pwmen2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&self) -> Pwmen3R {
                Pwmen3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&self) -> Pwmen4R {
                Pwmen4R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&self) -> Pwmen5R {
                Pwmen5R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 21;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&self) -> Pwmen6R {
                Pwmen6R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&self) -> Pwmen7R {
                Pwmen7R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&self) -> FltpsR {
                FltpsR::_from({
                                  const MASK: u8 = 15;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Prescale Factor Selection" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bits 3:4 - Clock Source Selection" ]
            # [ inline ( always ) ]
            pub fn clks(&mut self) -> _ClksW {
                _ClksW { w: self }
            }
            # [ doc = "Bit 5 - Center-Aligned PWM Select" ]
            # [ inline ( always ) ]
            pub fn cpwms(&mut self) -> _CpwmsW {
                _CpwmsW { w: self }
            }
            # [ doc = "Bit 6 - Reload Point Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 8 - Timer Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&mut self) -> _ToieW {
                _ToieW { w: self }
            }
            # [ doc = "Bit 16 - Channel 0 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen0(&mut self) -> _Pwmen0W {
                _Pwmen0W { w: self }
            }
            # [ doc = "Bit 17 - Channel 1 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen1(&mut self) -> _Pwmen1W {
                _Pwmen1W { w: self }
            }
            # [ doc = "Bit 18 - Channel 2 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen2(&mut self) -> _Pwmen2W {
                _Pwmen2W { w: self }
            }
            # [ doc = "Bit 19 - Channel 3 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen3(&mut self) -> _Pwmen3W {
                _Pwmen3W { w: self }
            }
            # [ doc = "Bit 20 - Channel 4 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen4(&mut self) -> _Pwmen4W {
                _Pwmen4W { w: self }
            }
            # [ doc = "Bit 21 - Channel 5 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen5(&mut self) -> _Pwmen5W {
                _Pwmen5W { w: self }
            }
            # [ doc = "Bit 22 - Channel 6 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen6(&mut self) -> _Pwmen6W {
                _Pwmen6W { w: self }
            }
            # [ doc = "Bit 23 - Channel 7 PWM enable bit" ]
            # [ inline ( always ) ]
            pub fn pwmen7(&mut self) -> _Pwmen7W {
                _Pwmen7W { w: self }
            }
            # [ doc = "Bits 24:27 - Filter Prescaler" ]
            # [ inline ( always ) ]
            pub fn fltps(&mut self) -> _FltpsW {
                _FltpsW { w: self }
            }
        }
    }
    # [ doc = "Counter" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CountR {
            bits: u16,
        }
        impl CountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CountW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CountW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&self) -> CountR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn count(&mut self) -> _CountW {
                _CountW { w: self }
            }
        }
    }
    # [ doc = "Modulo" ]
    pub struct Mod {
        register: VolatileCell<u32>,
    }
    # [ doc = "Modulo" ]
    pub mod mod_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mod {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ModR {
            bits: u16,
        }
        impl ModR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&self) -> ModR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ModR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - MOD" ]
            # [ inline ( always ) ]
            pub fn mod_(&mut self) -> _ModW {
                _ModW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C0sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c0sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C0v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c0v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C1sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c1sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C1v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c1v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C2sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c2sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C2v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c2v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C3sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c3sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C3v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c3v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C3v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C4sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c4sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C4v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c4v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C4v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C5sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c5sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C5v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c5v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C5v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C6sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c6sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C6v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c6v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C6v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub struct C7sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Status And Control" ]
    pub mod c7sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaR {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaR::_0 => 0,
                    DmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaR {
                match bits {
                    0 => DmaR::_0,
                    1 => DmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaR::_1
            }
        }
        # [ doc = "Possible values of the field `ICRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IcrstR {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IcrstR::_0 => 0,
                    IcrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IcrstR {
                match bits {
                    0 => IcrstR::_0,
                    1 => IcrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IcrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IcrstR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsaR {
            bits: u8,
        }
        impl ElsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ElsbR {
            bits: u8,
        }
        impl ElsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsaR {
            bits: u8,
        }
        impl MsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MsbR {
            bits: u8,
        }
        impl MsbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CHIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChieR {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChieR::_0 => 0,
                    ChieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChieR {
                match bits {
                    0 => ChieR::_0,
                    1 => ChieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChieR::_1
            }
        }
        # [ doc = "Possible values of the field `CHF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChfR {
            # [ doc = "No channel (n) event has occurred." ]
            _0,
            # [ doc = "A channel (n) event has occurred." ]
            _1,
        }
        impl ChfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChfR::_0 => 0,
                    ChfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChfR {
                match bits {
                    0 => ChfR::_0,
                    1 => ChfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChfR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigmodeR {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigmodeR::_0 => 0,
                    TrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigmodeR {
                match bits {
                    0 => TrigmodeR::_0,
                    1 => TrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CHIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChisR {
            # [ doc = "The channel (n) input is zero." ]
            _0,
            # [ doc = "The channel (n) input is one." ]
            _1,
        }
        impl ChisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChisR::_0 => 0,
                    ChisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChisR {
                match bits {
                    0 => ChisR::_0,
                    1 => ChisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChisR::_1
            }
        }
        # [ doc = "Possible values of the field `CHOV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChovR {
            # [ doc = "The channel (n) output is zero." ]
            _0,
            # [ doc = "The channel (n) output is one." ]
            _1,
        }
        impl ChovR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChovR::_0 => 0,
                    ChovR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChovR {
                match bits {
                    0 => ChovR::_0,
                    1 => ChovR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChovR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChovR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DMA`" ]
        pub enum DmaW {
            # [ doc = "Disable DMA transfers." ]
            _0,
            # [ doc = "Enable DMA transfers." ]
            _1,
        }
        impl DmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaW::_0 => 0,
                    DmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaW::_0)
            }
            # [ doc = "Enable DMA transfers." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ICRST`" ]
        pub enum IcrstW {
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            _0,
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            _1,
        }
        impl IcrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IcrstW::_0 => 0,
                    IcrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IcrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IcrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IcrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter is not reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IcrstW::_0)
            }
            # [ doc = "FTM counter is reset when the selected channel (n) input event is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IcrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ElsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ElsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHIE`" ]
        pub enum ChieW {
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            _0,
            # [ doc = "Enable channel (n) interrupt." ]
            _1,
        }
        impl ChieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChieW::_0 => 0,
                    ChieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable channel (n) interrupt. Use software polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChieW::_0)
            }
            # [ doc = "Enable channel (n) interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIGMODE`" ]
        pub enum TrigmodeW {
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            _0,
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            _1,
        }
        impl TrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrigmodeW::_0 => 0,
                    TrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel outputs will generate the normal PWM outputs without generating a pulse." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrigmodeW::_0)
            }
            # [ doc = "If a match in the channel occurs, a trigger generation on channel output will happen. The trigger pulse width has one FTM clock cycle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&self) -> DmaR {
                DmaR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&self) -> IcrstR {
                IcrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&self) -> ElsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsaR { bits }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&self) -> ElsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ElsbR { bits }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&self) -> MsaR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsaR { bits }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&self) -> MsbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MsbR { bits }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&self) -> ChieR {
                ChieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel (n) Flag" ]
            # [ inline ( always ) ]
            pub fn chf(&self) -> ChfR {
                ChfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&self) -> TrigmodeR {
                TrigmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - Channel (n) Input State" ]
            # [ inline ( always ) ]
            pub fn chis(&self) -> ChisR {
                ChisR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Channel (n) Output Value" ]
            # [ inline ( always ) ]
            pub fn chov(&self) -> ChovR {
                ChovR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dma(&mut self) -> _DmaW {
                _DmaW { w: self }
            }
            # [ doc = "Bit 1 - FTM counter reset by the selected input capture event." ]
            # [ inline ( always ) ]
            pub fn icrst(&mut self) -> _IcrstW {
                _IcrstW { w: self }
            }
            # [ doc = "Bit 2 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsa(&mut self) -> _ElsaW {
                _ElsaW { w: self }
            }
            # [ doc = "Bit 3 - Channel (n) Edge or Level Select" ]
            # [ inline ( always ) ]
            pub fn elsb(&mut self) -> _ElsbW {
                _ElsbW { w: self }
            }
            # [ doc = "Bit 4 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msa(&mut self) -> _MsaW {
                _MsaW { w: self }
            }
            # [ doc = "Bit 5 - Channel (n) Mode Select" ]
            # [ inline ( always ) ]
            pub fn msb(&mut self) -> _MsbW {
                _MsbW { w: self }
            }
            # [ doc = "Bit 6 - Channel (n) Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn chie(&mut self) -> _ChieW {
                _ChieW { w: self }
            }
            # [ doc = "Bit 8 - Trigger mode control" ]
            # [ inline ( always ) ]
            pub fn trigmode(&mut self) -> _TrigmodeW {
                _TrigmodeW { w: self }
            }
        }
    }
    # [ doc = "Channel (n) Value" ]
    pub struct C7v {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel (n) Value" ]
    pub mod c7v {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C7v {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ValR {
            bits: u16,
        }
        impl ValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ValW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&self) -> ValR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ValR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Channel Value" ]
            # [ inline ( always ) ]
            pub fn val(&mut self) -> _ValW {
                _ValW { w: self }
            }
        }
    }
    # [ doc = "Counter Initial Value" ]
    pub struct Cntin {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter Initial Value" ]
    pub mod cntin {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cntin {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct InitR {
            bits: u16,
        }
        impl InitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&self) -> InitR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                InitR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - INIT" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
        }
    }
    # [ doc = "Capture And Compare Status" ]
    pub struct Status {
        register: VolatileCell<u32>,
    }
    # [ doc = "Capture And Compare Status" ]
    pub mod status {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Status {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `CH0F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch0fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0fR::_0 => 0,
                    Ch0fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0fR {
                match bits {
                    0 => Ch0fR::_0,
                    1 => Ch0fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1fR::_0 => 0,
                    Ch1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1fR {
                match bits {
                    0 => Ch1fR::_0,
                    1 => Ch1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2fR::_0 => 0,
                    Ch2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2fR {
                match bits {
                    0 => Ch2fR::_0,
                    1 => Ch2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch3fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3fR::_0 => 0,
                    Ch3fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3fR {
                match bits {
                    0 => Ch3fR::_0,
                    1 => Ch3fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch4fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4fR::_0 => 0,
                    Ch4fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4fR {
                match bits {
                    0 => Ch4fR::_0,
                    1 => Ch4fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch5fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5fR::_0 => 0,
                    Ch5fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5fR {
                match bits {
                    0 => Ch5fR::_0,
                    1 => Ch5fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch6fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6fR::_0 => 0,
                    Ch6fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6fR {
                match bits {
                    0 => Ch6fR::_0,
                    1 => Ch6fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6fR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7fR {
            # [ doc = "No channel event has occurred." ]
            _0,
            # [ doc = "A channel event has occurred." ]
            _1,
        }
        impl Ch7fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7fR::_0 => 0,
                    Ch7fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7fR {
                match bits {
                    0 => Ch7fR::_0,
                    1 => Ch7fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7fR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Flag" ]
            # [ inline ( always ) ]
            pub fn ch0f(&self) -> Ch0fR {
                Ch0fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ch1f(&self) -> Ch1fR {
                Ch1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ch2f(&self) -> Ch2fR {
                Ch2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Flag" ]
            # [ inline ( always ) ]
            pub fn ch3f(&self) -> Ch3fR {
                Ch3fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Flag" ]
            # [ inline ( always ) ]
            pub fn ch4f(&self) -> Ch4fR {
                Ch4fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Flag" ]
            # [ inline ( always ) ]
            pub fn ch5f(&self) -> Ch5fR {
                Ch5fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Flag" ]
            # [ inline ( always ) ]
            pub fn ch6f(&self) -> Ch6fR {
                Ch6fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Flag" ]
            # [ inline ( always ) ]
            pub fn ch7f(&self) -> Ch7fR {
                Ch7fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
    }
    # [ doc = "Features Mode Selection" ]
    pub struct Mode {
        register: VolatileCell<u32>,
    }
    # [ doc = "Features Mode Selection" ]
    pub mod mode {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mode {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FTMEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FtmenR {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FtmenR::_0 => 0,
                    FtmenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FtmenR {
                match bits {
                    0 => FtmenR::_0,
                    1 => FtmenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FtmenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FtmenR::_1
            }
        }
        # [ doc = "Possible values of the field `WPDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpdisR {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpdisR::_0 => 0,
                    WpdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpdisR {
                match bits {
                    0 => WpdisR::_0,
                    1 => WpdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpdisR::_1
            }
        }
        # [ doc = "Possible values of the field `PWMSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PwmsyncR {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PwmsyncR::_0 => 0,
                    PwmsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PwmsyncR {
                match bits {
                    0 => PwmsyncR::_0,
                    1 => PwmsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PwmsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PwmsyncR::_1
            }
        }
        # [ doc = "Possible values of the field `CAPTEST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CaptestR {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CaptestR::_0 => 0,
                    CaptestR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CaptestR {
                match bits {
                    0 => CaptestR::_0,
                    1 => CaptestR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CaptestR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CaptestR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultmR {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultmR::_00 => 0,
                    FaultmR::_01 => 1,
                    FaultmR::_10 => 2,
                    FaultmR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultmR {
                match bits {
                    0 => FaultmR::_00,
                    1 => FaultmR::_01,
                    2 => FaultmR::_10,
                    3 => FaultmR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == FaultmR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == FaultmR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == FaultmR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FaultmR::_11
            }
        }
        # [ doc = "Possible values of the field `FAULTIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultieR {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultieR::_0 => 0,
                    FaultieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultieR {
                match bits {
                    0 => FaultieR::_0,
                    1 => FaultieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FTMEN`" ]
        pub enum FtmenW {
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            _0,
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            _1,
        }
        impl FtmenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FtmenW::_0 => 0,
                    FtmenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FtmenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FtmenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FtmenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TPM compatibility. Free running counter and synchronization compatible with TPM." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FtmenW::_0)
            }
            # [ doc = "Free running counter and synchronization are different from TPM behavior." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FtmenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WPDIS`" ]
        pub enum WpdisW {
            # [ doc = "Write protection is enabled." ]
            _0,
            # [ doc = "Write protection is disabled." ]
            _1,
        }
        impl WpdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpdisW::_0 => 0,
                    WpdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpdisW::_0)
            }
            # [ doc = "Write protection is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PWMSYNC`" ]
        pub enum PwmsyncW {
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            _0,
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            _1,
        }
        impl PwmsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PwmsyncW::_0 => 0,
                    PwmsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PwmsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PwmsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PwmsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No restrictions. Software and hardware triggers can be used by MOD, CnV, OUTMASK, and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PwmsyncW::_0)
            }
            # [ doc = "Software trigger can only be used by MOD and CnV synchronization, and hardware triggers can only be used by OUTMASK and FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PwmsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CAPTEST`" ]
        pub enum CaptestW {
            # [ doc = "Capture test mode is disabled." ]
            _0,
            # [ doc = "Capture test mode is enabled." ]
            _1,
        }
        impl CaptestW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CaptestW::_0 => 0,
                    CaptestW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CaptestW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CaptestW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CaptestW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Capture test mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CaptestW::_0)
            }
            # [ doc = "Capture test mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CaptestW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTM`" ]
        pub enum FaultmW {
            # [ doc = "Fault control is disabled for all channels." ]
            _00,
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            _01,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            _10,
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            _11,
        }
        impl FaultmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultmW::_00 => 0,
                    FaultmW::_01 => 1,
                    FaultmW::_10 => 2,
                    FaultmW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control is disabled for all channels." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(FaultmW::_00)
            }
            # [ doc = "Fault control is enabled for even channels only (channels 0, 2, 4, and 6), and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(FaultmW::_01)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the manual fault clearing." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(FaultmW::_10)
            }
            # [ doc = "Fault control is enabled for all channels, and the selected mode is the automatic fault clearing." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(FaultmW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTIE`" ]
        pub enum FaultieW {
            # [ doc = "Fault control interrupt is disabled." ]
            _0,
            # [ doc = "Fault control interrupt is enabled." ]
            _1,
        }
        impl FaultieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FaultieW::_0 => 0,
                    FaultieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FaultieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FaultieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FaultieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault control interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FaultieW::_0)
            }
            # [ doc = "Fault control interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FaultieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&self) -> FtmenR {
                FtmenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&self) -> WpdisR {
                WpdisR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&self) -> PwmsyncR {
                PwmsyncR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&self) -> CaptestR {
                CaptestR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&self) -> FaultmR {
                FaultmR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&self) -> FaultieR {
                FaultieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 7;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - FTM Enable" ]
            # [ inline ( always ) ]
            pub fn ftmen(&mut self) -> _FtmenW {
                _FtmenW { w: self }
            }
            # [ doc = "Bit 1 - Initialize The Channels Output" ]
            # [ inline ( always ) ]
            pub fn init(&mut self) -> _InitW {
                _InitW { w: self }
            }
            # [ doc = "Bit 2 - Write Protection Disable" ]
            # [ inline ( always ) ]
            pub fn wpdis(&mut self) -> _WpdisW {
                _WpdisW { w: self }
            }
            # [ doc = "Bit 3 - PWM Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn pwmsync(&mut self) -> _PwmsyncW {
                _PwmsyncW { w: self }
            }
            # [ doc = "Bit 4 - Capture Test Mode Enable" ]
            # [ inline ( always ) ]
            pub fn captest(&mut self) -> _CaptestW {
                _CaptestW { w: self }
            }
            # [ doc = "Bits 5:6 - Fault Control Mode" ]
            # [ inline ( always ) ]
            pub fn faultm(&mut self) -> _FaultmW {
                _FaultmW { w: self }
            }
            # [ doc = "Bit 7 - Fault Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn faultie(&mut self) -> _FaultieW {
                _FaultieW { w: self }
            }
        }
    }
    # [ doc = "Synchronization" ]
    pub struct Sync {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization" ]
    pub mod sync {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sync {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CNTMIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntminR {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntminR::_0 => 0,
                    CntminR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntminR {
                match bits {
                    0 => CntminR::_0,
                    1 => CntminR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntminR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntminR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTMAX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntmaxR {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntmaxR::_0 => 0,
                    CntmaxR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntmaxR {
                match bits {
                    0 => CntmaxR::_0,
                    1 => CntmaxR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntmaxR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntmaxR::_1
            }
        }
        # [ doc = "Possible values of the field `REINIT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReinitR {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReinitR::_0 => 0,
                    ReinitR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReinitR {
                match bits {
                    0 => ReinitR::_0,
                    1 => ReinitR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReinitR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReinitR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCHOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SynchomR {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SynchomR::_0 => 0,
                    SynchomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SynchomR {
                match bits {
                    0 => SynchomR::_0,
                    1 => SynchomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SynchomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SynchomR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig0R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig0R::_0 => 0,
                    Trig0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig0R {
                match bits {
                    0 => Trig0R::_0,
                    1 => Trig0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig0R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig1R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig1R::_0 => 0,
                    Trig1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig1R {
                match bits {
                    0 => Trig1R::_0,
                    1 => Trig1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig1R::_1
            }
        }
        # [ doc = "Possible values of the field `TRIG2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Trig2R {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Trig2R::_0 => 0,
                    Trig2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Trig2R {
                match bits {
                    0 => Trig2R::_0,
                    1 => Trig2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Trig2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Trig2R::_1
            }
        }
        # [ doc = "Possible values of the field `SWSYNC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsyncR {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsyncR::_0 => 0,
                    SwsyncR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsyncR {
                match bits {
                    0 => SwsyncR::_0,
                    1 => SwsyncR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsyncR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsyncR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CNTMIN`" ]
        pub enum CntminW {
            # [ doc = "The minimum loading point is disabled." ]
            _0,
            # [ doc = "The minimum loading point is enabled." ]
            _1,
        }
        impl CntminW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntminW::_0 => 0,
                    CntminW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntminW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntminW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntminW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The minimum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntminW::_0)
            }
            # [ doc = "The minimum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntminW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTMAX`" ]
        pub enum CntmaxW {
            # [ doc = "The maximum loading point is disabled." ]
            _0,
            # [ doc = "The maximum loading point is enabled." ]
            _1,
        }
        impl CntmaxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntmaxW::_0 => 0,
                    CntmaxW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntmaxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntmaxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntmaxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The maximum loading point is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntmaxW::_0)
            }
            # [ doc = "The maximum loading point is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntmaxW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REINIT`" ]
        pub enum ReinitW {
            # [ doc = "FTM counter continues to count normally." ]
            _0,
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            _1,
        }
        impl ReinitW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReinitW::_0 => 0,
                    ReinitW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReinitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReinitW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReinitW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM counter continues to count normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReinitW::_0)
            }
            # [ doc = "FTM counter is updated with its initial value when the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReinitW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCHOM`" ]
        pub enum SynchomW {
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            _0,
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            _1,
        }
        impl SynchomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SynchomW::_0 => 0,
                    SynchomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SynchomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SynchomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SynchomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer in all rising edges of the FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SynchomW::_0)
            }
            # [ doc = "OUTMASK register is updated with the value of its buffer only by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SynchomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG0`" ]
        pub enum Trig0W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig0W::_0 => 0,
                    Trig0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig0W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG1`" ]
        pub enum Trig1W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig1W::_0 => 0,
                    Trig1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig1W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRIG2`" ]
        pub enum Trig2W {
            # [ doc = "Trigger is disabled." ]
            _0,
            # [ doc = "Trigger is enabled." ]
            _1,
        }
        impl Trig2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Trig2W::_0 => 0,
                    Trig2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Trig2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Trig2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Trig2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Trig2W::_0)
            }
            # [ doc = "Trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Trig2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSYNC`" ]
        pub enum SwsyncW {
            # [ doc = "Software trigger is not selected." ]
            _0,
            # [ doc = "Software trigger is selected." ]
            _1,
        }
        impl SwsyncW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsyncW::_0 => 0,
                    SwsyncW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsyncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsyncW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsyncW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software trigger is not selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsyncW::_0)
            }
            # [ doc = "Software trigger is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsyncW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&self) -> CntminR {
                CntminR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&self) -> CntmaxR {
                CntmaxR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&self) -> ReinitR {
                ReinitR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&self) -> SynchomR {
                SynchomR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&self) -> Trig0R {
                Trig0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&self) -> Trig1R {
                Trig1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&self) -> Trig2R {
                Trig2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&self) -> SwsyncR {
                SwsyncR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Minimum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmin(&mut self) -> _CntminW {
                _CntminW { w: self }
            }
            # [ doc = "Bit 1 - Maximum Loading Point Enable" ]
            # [ inline ( always ) ]
            pub fn cntmax(&mut self) -> _CntmaxW {
                _CntmaxW { w: self }
            }
            # [ doc = "Bit 2 - FTM Counter Reinitialization by Synchronization" ]
            # [ inline ( always ) ]
            pub fn reinit(&mut self) -> _ReinitW {
                _ReinitW { w: self }
            }
            # [ doc = "Bit 3 - Output Mask Synchronization" ]
            # [ inline ( always ) ]
            pub fn synchom(&mut self) -> _SynchomW {
                _SynchomW { w: self }
            }
            # [ doc = "Bit 4 - PWM Synchronization Hardware Trigger 0" ]
            # [ inline ( always ) ]
            pub fn trig0(&mut self) -> _Trig0W {
                _Trig0W { w: self }
            }
            # [ doc = "Bit 5 - PWM Synchronization Hardware Trigger 1" ]
            # [ inline ( always ) ]
            pub fn trig1(&mut self) -> _Trig1W {
                _Trig1W { w: self }
            }
            # [ doc = "Bit 6 - PWM Synchronization Hardware Trigger 2" ]
            # [ inline ( always ) ]
            pub fn trig2(&mut self) -> _Trig2W {
                _Trig2W { w: self }
            }
            # [ doc = "Bit 7 - PWM Synchronization Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swsync(&mut self) -> _SwsyncW {
                _SwsyncW { w: self }
            }
        }
    }
    # [ doc = "Initial State For Channels Output" ]
    pub struct Outinit {
        register: VolatileCell<u32>,
    }
    # [ doc = "Initial State For Channels Output" ]
    pub mod outinit {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outinit {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0oiR::_0 => 0,
                    Ch0oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0oiR {
                match bits {
                    0 => Ch0oiR::_0,
                    1 => Ch0oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1oiR::_0 => 0,
                    Ch1oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1oiR {
                match bits {
                    0 => Ch1oiR::_0,
                    1 => Ch1oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2oiR::_0 => 0,
                    Ch2oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2oiR {
                match bits {
                    0 => Ch2oiR::_0,
                    1 => Ch2oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3oiR::_0 => 0,
                    Ch3oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3oiR {
                match bits {
                    0 => Ch3oiR::_0,
                    1 => Ch3oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4oiR::_0 => 0,
                    Ch4oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4oiR {
                match bits {
                    0 => Ch4oiR::_0,
                    1 => Ch4oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5oiR::_0 => 0,
                    Ch5oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5oiR {
                match bits {
                    0 => Ch5oiR::_0,
                    1 => Ch5oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6oiR::_0 => 0,
                    Ch6oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6oiR {
                match bits {
                    0 => Ch6oiR::_0,
                    1 => Ch6oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6oiR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7oiR {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7oiR::_0 => 0,
                    Ch7oiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7oiR {
                match bits {
                    0 => Ch7oiR::_0,
                    1 => Ch7oiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7oiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7oiR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OI`" ]
        pub enum Ch0oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch0oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0oiW::_0 => 0,
                    Ch0oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OI`" ]
        pub enum Ch1oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch1oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1oiW::_0 => 0,
                    Ch1oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OI`" ]
        pub enum Ch2oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch2oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2oiW::_0 => 0,
                    Ch2oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OI`" ]
        pub enum Ch3oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch3oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3oiW::_0 => 0,
                    Ch3oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OI`" ]
        pub enum Ch4oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch4oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4oiW::_0 => 0,
                    Ch4oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OI`" ]
        pub enum Ch5oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch5oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5oiW::_0 => 0,
                    Ch5oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OI`" ]
        pub enum Ch6oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch6oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6oiW::_0 => 0,
                    Ch6oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OI`" ]
        pub enum Ch7oiW {
            # [ doc = "The initialization value is 0." ]
            _0,
            # [ doc = "The initialization value is 1." ]
            _1,
        }
        impl Ch7oiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7oiW::_0 => 0,
                    Ch7oiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7oiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7oiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7oiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The initialization value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7oiW::_0)
            }
            # [ doc = "The initialization value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7oiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&self) -> Ch0oiR {
                Ch0oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&self) -> Ch1oiR {
                Ch1oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&self) -> Ch2oiR {
                Ch2oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&self) -> Ch3oiR {
                Ch3oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&self) -> Ch4oiR {
                Ch4oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&self) -> Ch5oiR {
                Ch5oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&self) -> Ch6oiR {
                Ch6oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&self) -> Ch7oiR {
                Ch7oiR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch0oi(&mut self) -> _Ch0oiW {
                _Ch0oiW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch1oi(&mut self) -> _Ch1oiW {
                _Ch1oiW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch2oi(&mut self) -> _Ch2oiW {
                _Ch2oiW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch3oi(&mut self) -> _Ch3oiW {
                _Ch3oiW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch4oi(&mut self) -> _Ch4oiW {
                _Ch4oiW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch5oi(&mut self) -> _Ch5oiW {
                _Ch5oiW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch6oi(&mut self) -> _Ch6oiW {
                _Ch6oiW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Initialization Value" ]
            # [ inline ( always ) ]
            pub fn ch7oi(&mut self) -> _Ch7oiW {
                _Ch7oiW { w: self }
            }
        }
    }
    # [ doc = "Output Mask" ]
    pub struct Outmask {
        register: VolatileCell<u32>,
    }
    # [ doc = "Output Mask" ]
    pub mod outmask {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Outmask {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0omR::_0 => 0,
                    Ch0omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0omR {
                match bits {
                    0 => Ch0omR::_0,
                    1 => Ch0omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1omR::_0 => 0,
                    Ch1omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1omR {
                match bits {
                    0 => Ch1omR::_0,
                    1 => Ch1omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2omR::_0 => 0,
                    Ch2omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2omR {
                match bits {
                    0 => Ch2omR::_0,
                    1 => Ch2omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3omR::_0 => 0,
                    Ch3omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3omR {
                match bits {
                    0 => Ch3omR::_0,
                    1 => Ch3omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4omR::_0 => 0,
                    Ch4omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4omR {
                match bits {
                    0 => Ch4omR::_0,
                    1 => Ch4omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5omR::_0 => 0,
                    Ch5omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5omR {
                match bits {
                    0 => Ch5omR::_0,
                    1 => Ch5omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6omR::_0 => 0,
                    Ch6omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6omR {
                match bits {
                    0 => Ch6omR::_0,
                    1 => Ch6omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6omR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7omR {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7omR::_0 => 0,
                    Ch7omR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7omR {
                match bits {
                    0 => Ch7omR::_0,
                    1 => Ch7omR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7omR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7omR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OM`" ]
        pub enum Ch0omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch0omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0omW::_0 => 0,
                    Ch0omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OM`" ]
        pub enum Ch1omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch1omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1omW::_0 => 0,
                    Ch1omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OM`" ]
        pub enum Ch2omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch2omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2omW::_0 => 0,
                    Ch2omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OM`" ]
        pub enum Ch3omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch3omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3omW::_0 => 0,
                    Ch3omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OM`" ]
        pub enum Ch4omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch4omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4omW::_0 => 0,
                    Ch4omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OM`" ]
        pub enum Ch5omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch5omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5omW::_0 => 0,
                    Ch5omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OM`" ]
        pub enum Ch6omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch6omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6omW::_0 => 0,
                    Ch6omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OM`" ]
        pub enum Ch7omW {
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            _0,
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            _1,
        }
        impl Ch7omW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7omW::_0 => 0,
                    Ch7omW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7omW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7omW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7omW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel output is not masked. It continues to operate normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7omW::_0)
            }
            # [ doc = "Channel output is masked. It is forced to its inactive state." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7omW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&self) -> Ch0omR {
                Ch0omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&self) -> Ch1omR {
                Ch1omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&self) -> Ch2omR {
                Ch2omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&self) -> Ch3omR {
                Ch3omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&self) -> Ch4omR {
                Ch4omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&self) -> Ch5omR {
                Ch5omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&self) -> Ch6omR {
                Ch6omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&self) -> Ch7omR {
                Ch7omR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch0om(&mut self) -> _Ch0omW {
                _Ch0omW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch1om(&mut self) -> _Ch1omW {
                _Ch1omW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch2om(&mut self) -> _Ch2omW {
                _Ch2omW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch3om(&mut self) -> _Ch3omW {
                _Ch3omW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch4om(&mut self) -> _Ch4omW {
                _Ch4omW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch5om(&mut self) -> _Ch5omW {
                _Ch5omW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch6om(&mut self) -> _Ch6omW {
                _Ch6omW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Output Mask" ]
            # [ inline ( always ) ]
            pub fn ch7om(&mut self) -> _Ch7omW {
                _Ch7omW { w: self }
            }
        }
    }
    # [ doc = "Function For Linked Channels" ]
    pub struct Combine {
        register: VolatileCell<u32>,
    }
    # [ doc = "Function For Linked Channels" ]
    pub mod combine {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Combine {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine0R {
            bits: u8,
        }
        impl Combine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp0R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp0R::_0 => 0,
                    Comp0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp0R {
                match bits {
                    0 => Comp0R::_0,
                    1 => Comp0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen0R {
            bits: u8,
        }
        impl Decapen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap0R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap0R::_0 => 0,
                    Decap0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap0R {
                match bits {
                    0 => Decap0R::_0,
                    1 => Decap0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap0R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten0R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten0R::_0 => 0,
                    Dten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten0R {
                match bits {
                    0 => Dten0R::_0,
                    1 => Dten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten0R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen0R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen0R::_0 => 0,
                    Syncen0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen0R {
                match bits {
                    0 => Syncen0R::_0,
                    1 => Syncen0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten0R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten0R::_0 => 0,
                    Faulten0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten0R {
                match bits {
                    0 => Faulten0R::_0,
                    1 => Faulten0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten0R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine0R {
            bits: u8,
        }
        impl Mcombine0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine1R {
            bits: u8,
        }
        impl Combine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp1R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp1R::_0 => 0,
                    Comp1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp1R {
                match bits {
                    0 => Comp1R::_0,
                    1 => Comp1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen1R {
            bits: u8,
        }
        impl Decapen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap1R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap1R::_0 => 0,
                    Decap1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap1R {
                match bits {
                    0 => Decap1R::_0,
                    1 => Decap1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap1R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten1R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten1R::_0 => 0,
                    Dten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten1R {
                match bits {
                    0 => Dten1R::_0,
                    1 => Dten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten1R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen1R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen1R::_0 => 0,
                    Syncen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen1R {
                match bits {
                    0 => Syncen1R::_0,
                    1 => Syncen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten1R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten1R::_0 => 0,
                    Faulten1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten1R {
                match bits {
                    0 => Faulten1R::_0,
                    1 => Faulten1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten1R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine1R {
            bits: u8,
        }
        impl Mcombine1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine2R {
            bits: u8,
        }
        impl Combine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp2R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp2R::_0 => 0,
                    Comp2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp2R {
                match bits {
                    0 => Comp2R::_0,
                    1 => Comp2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen2R {
            bits: u8,
        }
        impl Decapen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap2R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap2R::_0 => 0,
                    Decap2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap2R {
                match bits {
                    0 => Decap2R::_0,
                    1 => Decap2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap2R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten2R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten2R::_0 => 0,
                    Dten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten2R {
                match bits {
                    0 => Dten2R::_0,
                    1 => Dten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten2R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen2R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen2R::_0 => 0,
                    Syncen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen2R {
                match bits {
                    0 => Syncen2R::_0,
                    1 => Syncen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten2R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten2R::_0 => 0,
                    Faulten2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten2R {
                match bits {
                    0 => Faulten2R::_0,
                    1 => Faulten2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten2R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine2R {
            bits: u8,
        }
        impl Mcombine2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Combine3R {
            bits: u8,
        }
        impl Combine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `COMP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Comp3R {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Comp3R::_0 => 0,
                    Comp3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Comp3R {
                match bits {
                    0 => Comp3R::_0,
                    1 => Comp3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Comp3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Comp3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Decapen3R {
            bits: u8,
        }
        impl Decapen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DECAP3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Decap3R {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Decap3R::_0 => 0,
                    Decap3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Decap3R {
                match bits {
                    0 => Decap3R::_0,
                    1 => Decap3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Decap3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Decap3R::_1
            }
        }
        # [ doc = "Possible values of the field `DTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Dten3R {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Dten3R::_0 => 0,
                    Dten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Dten3R {
                match bits {
                    0 => Dten3R::_0,
                    1 => Dten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Dten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Dten3R::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Syncen3R {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Syncen3R::_0 => 0,
                    Syncen3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Syncen3R {
                match bits {
                    0 => Syncen3R::_0,
                    1 => Syncen3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Syncen3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Syncen3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTEN3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faulten3R {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faulten3R::_0 => 0,
                    Faulten3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faulten3R {
                match bits {
                    0 => Faulten3R::_0,
                    1 => Faulten3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faulten3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faulten3R::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Mcombine3R {
            bits: u8,
        }
        impl Mcombine3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP0`" ]
        pub enum Comp0W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp0W::_0 => 0,
                    Comp0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp0W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP0`" ]
        pub enum Decap0W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap0W::_0 => 0,
                    Decap0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap0W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN0`" ]
        pub enum Dten0W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten0W::_0 => 0,
                    Dten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten0W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN0`" ]
        pub enum Syncen0W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen0W::_0 => 0,
                    Syncen0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen0W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN0`" ]
        pub enum Faulten0W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten0W::_0 => 0,
                    Faulten0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten0W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP1`" ]
        pub enum Comp1W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp1W::_0 => 0,
                    Comp1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp1W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP1`" ]
        pub enum Decap1W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap1W::_0 => 0,
                    Decap1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap1W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN1`" ]
        pub enum Dten1W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten1W::_0 => 0,
                    Dten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten1W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN1`" ]
        pub enum Syncen1W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen1W::_0 => 0,
                    Syncen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen1W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN1`" ]
        pub enum Faulten1W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten1W::_0 => 0,
                    Faulten1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten1W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP2`" ]
        pub enum Comp2W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp2W::_0 => 0,
                    Comp2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp2W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP2`" ]
        pub enum Decap2W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap2W::_0 => 0,
                    Decap2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap2W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN2`" ]
        pub enum Dten2W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten2W::_0 => 0,
                    Dten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten2W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN2`" ]
        pub enum Syncen2W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen2W::_0 => 0,
                    Syncen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen2W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN2`" ]
        pub enum Faulten2W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten2W::_0 => 0,
                    Faulten2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten2W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Combine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Combine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COMP3`" ]
        pub enum Comp3W {
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            _0,
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            _1,
        }
        impl Comp3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Comp3W::_0 => 0,
                    Comp3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Comp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Comp3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Comp3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel (n+1) output is the same as the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Comp3W::_0)
            }
            # [ doc = "The channel (n+1) output is the complement of the channel (n) output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Comp3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decapen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decapen3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DECAP3`" ]
        pub enum Decap3W {
            # [ doc = "The dual edge captures are inactive." ]
            _0,
            # [ doc = "The dual edge captures are active." ]
            _1,
        }
        impl Decap3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Decap3W::_0 => 0,
                    Decap3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Decap3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Decap3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Decap3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dual edge captures are inactive." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Decap3W::_0)
            }
            # [ doc = "The dual edge captures are active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Decap3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTEN3`" ]
        pub enum Dten3W {
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            _0,
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            _1,
        }
        impl Dten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Dten3W::_0 => 0,
                    Dten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Dten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The deadtime insertion in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Dten3W::_0)
            }
            # [ doc = "The deadtime insertion in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Dten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCEN3`" ]
        pub enum Syncen3W {
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            _0,
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            _1,
        }
        impl Syncen3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Syncen3W::_0 => 0,
                    Syncen3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Syncen3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Syncen3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Syncen3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The PWM synchronization in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Syncen3W::_0)
            }
            # [ doc = "The PWM synchronization in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Syncen3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULTEN3`" ]
        pub enum Faulten3W {
            # [ doc = "The fault control in this pair of channels is disabled." ]
            _0,
            # [ doc = "The fault control in this pair of channels is enabled." ]
            _1,
        }
        impl Faulten3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Faulten3W::_0 => 0,
                    Faulten3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Faulten3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Faulten3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Faulten3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault control in this pair of channels is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Faulten3W::_0)
            }
            # [ doc = "The fault control in this pair of channels is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Faulten3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Mcombine3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Mcombine3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&self) -> Combine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine0R { bits }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&self) -> Comp0R {
                Comp0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&self) -> Decapen0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen0R { bits }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&self) -> Decap0R {
                Decap0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&self) -> Dten0R {
                Dten0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&self) -> Syncen0R {
                Syncen0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&self) -> Faulten0R {
                Faulten0R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&self) -> Mcombine0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine0R { bits }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&self) -> Combine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine1R { bits }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&self) -> Comp1R {
                Comp1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&self) -> Decapen1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen1R { bits }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&self) -> Decap1R {
                Decap1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&self) -> Dten1R {
                Dten1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&self) -> Syncen1R {
                Syncen1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&self) -> Faulten1R {
                Faulten1R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 14;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&self) -> Mcombine1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 15;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine1R { bits }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&self) -> Combine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine2R { bits }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&self) -> Comp2R {
                Comp2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 17;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&self) -> Decapen2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen2R { bits }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&self) -> Decap2R {
                Decap2R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&self) -> Dten2R {
                Dten2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&self) -> Syncen2R {
                Syncen2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 21;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&self) -> Faulten2R {
                Faulten2R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 22;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&self) -> Mcombine2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine2R { bits }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&self) -> Combine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Combine3R { bits }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&self) -> Comp3R {
                Comp3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&self) -> Decapen3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Decapen3R { bits }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&self) -> Decap3R {
                Decap3R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&self) -> Dten3R {
                Dten3R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&self) -> Syncen3R {
                Syncen3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 29;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&self) -> Faulten3R {
                Faulten3R::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 30;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&self) -> Mcombine3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Mcombine3R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Combine Channels For n = 0" ]
            # [ inline ( always ) ]
            pub fn combine0(&mut self) -> _Combine0W {
                _Combine0W { w: self }
            }
            # [ doc = "Bit 1 - Complement Of Channel (n) For n = 0" ]
            # [ inline ( always ) ]
            pub fn comp0(&mut self) -> _Comp0W {
                _Comp0W { w: self }
            }
            # [ doc = "Bit 2 - Dual Edge Capture Mode Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn decapen0(&mut self) -> _Decapen0W {
                _Decapen0W { w: self }
            }
            # [ doc = "Bit 3 - Dual Edge Capture Mode Captures For n = 0" ]
            # [ inline ( always ) ]
            pub fn decap0(&mut self) -> _Decap0W {
                _Decap0W { w: self }
            }
            # [ doc = "Bit 4 - Deadtime Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn dten0(&mut self) -> _Dten0W {
                _Dten0W { w: self }
            }
            # [ doc = "Bit 5 - Synchronization Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn syncen0(&mut self) -> _Syncen0W {
                _Syncen0W { w: self }
            }
            # [ doc = "Bit 6 - Fault Control Enable For n = 0" ]
            # [ inline ( always ) ]
            pub fn faulten0(&mut self) -> _Faulten0W {
                _Faulten0W { w: self }
            }
            # [ doc = "Bit 7 - Modified Combine Mode For n = 0" ]
            # [ inline ( always ) ]
            pub fn mcombine0(&mut self) -> _Mcombine0W {
                _Mcombine0W { w: self }
            }
            # [ doc = "Bit 8 - Combine Channels For n = 2" ]
            # [ inline ( always ) ]
            pub fn combine1(&mut self) -> _Combine1W {
                _Combine1W { w: self }
            }
            # [ doc = "Bit 9 - Complement Of Channel (n) For n = 2" ]
            # [ inline ( always ) ]
            pub fn comp1(&mut self) -> _Comp1W {
                _Comp1W { w: self }
            }
            # [ doc = "Bit 10 - Dual Edge Capture Mode Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn decapen1(&mut self) -> _Decapen1W {
                _Decapen1W { w: self }
            }
            # [ doc = "Bit 11 - Dual Edge Capture Mode Captures For n = 2" ]
            # [ inline ( always ) ]
            pub fn decap1(&mut self) -> _Decap1W {
                _Decap1W { w: self }
            }
            # [ doc = "Bit 12 - Deadtime Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn dten1(&mut self) -> _Dten1W {
                _Dten1W { w: self }
            }
            # [ doc = "Bit 13 - Synchronization Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn syncen1(&mut self) -> _Syncen1W {
                _Syncen1W { w: self }
            }
            # [ doc = "Bit 14 - Fault Control Enable For n = 2" ]
            # [ inline ( always ) ]
            pub fn faulten1(&mut self) -> _Faulten1W {
                _Faulten1W { w: self }
            }
            # [ doc = "Bit 15 - Modified Combine Mode For n = 2" ]
            # [ inline ( always ) ]
            pub fn mcombine1(&mut self) -> _Mcombine1W {
                _Mcombine1W { w: self }
            }
            # [ doc = "Bit 16 - Combine Channels For n = 4" ]
            # [ inline ( always ) ]
            pub fn combine2(&mut self) -> _Combine2W {
                _Combine2W { w: self }
            }
            # [ doc = "Bit 17 - Complement Of Channel (n) For n = 4" ]
            # [ inline ( always ) ]
            pub fn comp2(&mut self) -> _Comp2W {
                _Comp2W { w: self }
            }
            # [ doc = "Bit 18 - Dual Edge Capture Mode Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn decapen2(&mut self) -> _Decapen2W {
                _Decapen2W { w: self }
            }
            # [ doc = "Bit 19 - Dual Edge Capture Mode Captures For n = 4" ]
            # [ inline ( always ) ]
            pub fn decap2(&mut self) -> _Decap2W {
                _Decap2W { w: self }
            }
            # [ doc = "Bit 20 - Deadtime Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn dten2(&mut self) -> _Dten2W {
                _Dten2W { w: self }
            }
            # [ doc = "Bit 21 - Synchronization Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn syncen2(&mut self) -> _Syncen2W {
                _Syncen2W { w: self }
            }
            # [ doc = "Bit 22 - Fault Control Enable For n = 4" ]
            # [ inline ( always ) ]
            pub fn faulten2(&mut self) -> _Faulten2W {
                _Faulten2W { w: self }
            }
            # [ doc = "Bit 23 - Modified Combine Mode For n = 4" ]
            # [ inline ( always ) ]
            pub fn mcombine2(&mut self) -> _Mcombine2W {
                _Mcombine2W { w: self }
            }
            # [ doc = "Bit 24 - Combine Channels For n = 6" ]
            # [ inline ( always ) ]
            pub fn combine3(&mut self) -> _Combine3W {
                _Combine3W { w: self }
            }
            # [ doc = "Bit 25 - Complement Of Channel (n) for n = 6" ]
            # [ inline ( always ) ]
            pub fn comp3(&mut self) -> _Comp3W {
                _Comp3W { w: self }
            }
            # [ doc = "Bit 26 - Dual Edge Capture Mode Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn decapen3(&mut self) -> _Decapen3W {
                _Decapen3W { w: self }
            }
            # [ doc = "Bit 27 - Dual Edge Capture Mode Captures For n = 6" ]
            # [ inline ( always ) ]
            pub fn decap3(&mut self) -> _Decap3W {
                _Decap3W { w: self }
            }
            # [ doc = "Bit 28 - Deadtime Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn dten3(&mut self) -> _Dten3W {
                _Dten3W { w: self }
            }
            # [ doc = "Bit 29 - Synchronization Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn syncen3(&mut self) -> _Syncen3W {
                _Syncen3W { w: self }
            }
            # [ doc = "Bit 30 - Fault Control Enable For n = 6" ]
            # [ inline ( always ) ]
            pub fn faulten3(&mut self) -> _Faulten3W {
                _Faulten3W { w: self }
            }
            # [ doc = "Bit 31 - Modified Combine Mode For n = 6" ]
            # [ inline ( always ) ]
            pub fn mcombine3(&mut self) -> _Mcombine3W {
                _Mcombine3W { w: self }
            }
        }
    }
    # [ doc = "Deadtime Configuration" ]
    pub struct Deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Deadtime Configuration" ]
    pub mod deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "FTM External Trigger" ]
    pub struct Exttrig {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM External Trigger" ]
    pub mod exttrig {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Exttrig {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH2TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2trigR::_0 => 0,
                    Ch2trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2trigR {
                match bits {
                    0 => Ch2trigR::_0,
                    1 => Ch2trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3trigR::_0 => 0,
                    Ch3trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3trigR {
                match bits {
                    0 => Ch3trigR::_0,
                    1 => Ch3trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4trigR::_0 => 0,
                    Ch4trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4trigR {
                match bits {
                    0 => Ch4trigR::_0,
                    1 => Ch4trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5trigR::_0 => 0,
                    Ch5trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5trigR {
                match bits {
                    0 => Ch5trigR::_0,
                    1 => Ch5trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0trigR::_0 => 0,
                    Ch0trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0trigR {
                match bits {
                    0 => Ch0trigR::_0,
                    1 => Ch0trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1trigR::_0 => 0,
                    Ch1trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1trigR {
                match bits {
                    0 => Ch1trigR::_0,
                    1 => Ch1trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1trigR::_1
            }
        }
        # [ doc = "Possible values of the field `INITTRIGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InittrigenR {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InittrigenR::_0 => 0,
                    InittrigenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InittrigenR {
                match bits {
                    0 => InittrigenR::_0,
                    1 => InittrigenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InittrigenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InittrigenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRIGF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrigfR {
            # [ doc = "No channel trigger was generated." ]
            _0,
            # [ doc = "A channel trigger was generated." ]
            _1,
        }
        impl TrigfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrigfR::_0 => 0,
                    TrigfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrigfR {
                match bits {
                    0 => TrigfR::_0,
                    1 => TrigfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrigfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrigfR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6trigR::_0 => 0,
                    Ch6trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6trigR {
                match bits {
                    0 => Ch6trigR::_0,
                    1 => Ch6trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6trigR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7TRIG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7trigR {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7trigR::_0 => 0,
                    Ch7trigR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7trigR {
                match bits {
                    0 => Ch7trigR::_0,
                    1 => Ch7trigR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7trigR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7trigR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH2TRIG`" ]
        pub enum Ch2trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch2trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2trigW::_0 => 0,
                    Ch2trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3TRIG`" ]
        pub enum Ch3trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch3trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3trigW::_0 => 0,
                    Ch3trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4TRIG`" ]
        pub enum Ch4trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch4trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4trigW::_0 => 0,
                    Ch4trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5TRIG`" ]
        pub enum Ch5trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch5trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5trigW::_0 => 0,
                    Ch5trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0TRIG`" ]
        pub enum Ch0trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch0trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0trigW::_0 => 0,
                    Ch0trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1TRIG`" ]
        pub enum Ch1trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch1trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1trigW::_0 => 0,
                    Ch1trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INITTRIGEN`" ]
        pub enum InittrigenW {
            # [ doc = "The generation of initialization trigger is disabled." ]
            _0,
            # [ doc = "The generation of initialization trigger is enabled." ]
            _1,
        }
        impl InittrigenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InittrigenW::_0 => 0,
                    InittrigenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InittrigenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InittrigenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InittrigenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of initialization trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InittrigenW::_0)
            }
            # [ doc = "The generation of initialization trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InittrigenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6TRIG`" ]
        pub enum Ch6trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch6trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6trigW::_0 => 0,
                    Ch6trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7TRIG`" ]
        pub enum Ch7trigW {
            # [ doc = "The generation of this external trigger is disabled." ]
            _0,
            # [ doc = "The generation of this external trigger is enabled." ]
            _1,
        }
        impl Ch7trigW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7trigW::_0 => 0,
                    Ch7trigW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7trigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7trigW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7trigW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The generation of this external trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7trigW::_0)
            }
            # [ doc = "The generation of this external trigger is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7trigW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&self) -> Ch2trigR {
                Ch2trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&self) -> Ch3trigR {
                Ch3trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&self) -> Ch4trigR {
                Ch4trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&self) -> Ch5trigR {
                Ch5trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&self) -> Ch0trigR {
                Ch0trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&self) -> Ch1trigR {
                Ch1trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&self) -> InittrigenR {
                InittrigenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 6;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Channel Trigger Flag" ]
            # [ inline ( always ) ]
            pub fn trigf(&self) -> TrigfR {
                TrigfR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&self) -> Ch6trigR {
                Ch6trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&self) -> Ch7trigR {
                Ch7trigR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 2 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch2trig(&mut self) -> _Ch2trigW {
                _Ch2trigW { w: self }
            }
            # [ doc = "Bit 1 - Channel 3 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch3trig(&mut self) -> _Ch3trigW {
                _Ch3trigW { w: self }
            }
            # [ doc = "Bit 2 - Channel 4 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch4trig(&mut self) -> _Ch4trigW {
                _Ch4trigW { w: self }
            }
            # [ doc = "Bit 3 - Channel 5 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch5trig(&mut self) -> _Ch5trigW {
                _Ch5trigW { w: self }
            }
            # [ doc = "Bit 4 - Channel 0 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch0trig(&mut self) -> _Ch0trigW {
                _Ch0trigW { w: self }
            }
            # [ doc = "Bit 5 - Channel 1 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch1trig(&mut self) -> _Ch1trigW {
                _Ch1trigW { w: self }
            }
            # [ doc = "Bit 6 - Initialization Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn inittrigen(&mut self) -> _InittrigenW {
                _InittrigenW { w: self }
            }
            # [ doc = "Bit 8 - Channel 6 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch6trig(&mut self) -> _Ch6trigW {
                _Ch6trigW { w: self }
            }
            # [ doc = "Bit 9 - Channel 7 External Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn ch7trig(&mut self) -> _Ch7trigW {
                _Ch7trigW { w: self }
            }
        }
    }
    # [ doc = "Channels Polarity" ]
    pub struct Pol {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channels Polarity" ]
    pub mod pol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `POL0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol0R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol0R::_0 => 0,
                    Pol0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol0R {
                match bits {
                    0 => Pol0R::_0,
                    1 => Pol0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol0R::_1
            }
        }
        # [ doc = "Possible values of the field `POL1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol1R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol1R::_0 => 0,
                    Pol1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol1R {
                match bits {
                    0 => Pol1R::_0,
                    1 => Pol1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol1R::_1
            }
        }
        # [ doc = "Possible values of the field `POL2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol2R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol2R::_0 => 0,
                    Pol2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol2R {
                match bits {
                    0 => Pol2R::_0,
                    1 => Pol2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol2R::_1
            }
        }
        # [ doc = "Possible values of the field `POL3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol3R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol3R::_0 => 0,
                    Pol3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol3R {
                match bits {
                    0 => Pol3R::_0,
                    1 => Pol3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol3R::_1
            }
        }
        # [ doc = "Possible values of the field `POL4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol4R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol4R::_0 => 0,
                    Pol4R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol4R {
                match bits {
                    0 => Pol4R::_0,
                    1 => Pol4R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol4R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol4R::_1
            }
        }
        # [ doc = "Possible values of the field `POL5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol5R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol5R::_0 => 0,
                    Pol5R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol5R {
                match bits {
                    0 => Pol5R::_0,
                    1 => Pol5R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol5R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol5R::_1
            }
        }
        # [ doc = "Possible values of the field `POL6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol6R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol6R::_0 => 0,
                    Pol6R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol6R {
                match bits {
                    0 => Pol6R::_0,
                    1 => Pol6R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol6R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol6R::_1
            }
        }
        # [ doc = "Possible values of the field `POL7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pol7R {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pol7R::_0 => 0,
                    Pol7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pol7R {
                match bits {
                    0 => Pol7R::_0,
                    1 => Pol7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pol7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pol7R::_1
            }
        }
        # [ doc = "Values that can be written to the field `POL0`" ]
        pub enum Pol0W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol0W::_0 => 0,
                    Pol0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol0W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL1`" ]
        pub enum Pol1W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol1W::_0 => 0,
                    Pol1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol1W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL2`" ]
        pub enum Pol2W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol2W::_0 => 0,
                    Pol2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol2W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL3`" ]
        pub enum Pol3W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol3W::_0 => 0,
                    Pol3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol3W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL4`" ]
        pub enum Pol4W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol4W::_0 => 0,
                    Pol4W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol4W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol4W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL5`" ]
        pub enum Pol5W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol5W::_0 => 0,
                    Pol5W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol5W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol5W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL6`" ]
        pub enum Pol6W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol6W::_0 => 0,
                    Pol6W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol6W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol6W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `POL7`" ]
        pub enum Pol7W {
            # [ doc = "The channel polarity is active high." ]
            _0,
            # [ doc = "The channel polarity is active low." ]
            _1,
        }
        impl Pol7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pol7W::_0 => 0,
                    Pol7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pol7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pol7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pol7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel polarity is active high." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pol7W::_0)
            }
            # [ doc = "The channel polarity is active low." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pol7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&self) -> Pol0R {
                Pol0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&self) -> Pol1R {
                Pol1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&self) -> Pol2R {
                Pol2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&self) -> Pol3R {
                Pol3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&self) -> Pol4R {
                Pol4R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&self) -> Pol5R {
                Pol5R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&self) -> Pol6R {
                Pol6R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&self) -> Pol7R {
                Pol7R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol0(&mut self) -> _Pol0W {
                _Pol0W { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol1(&mut self) -> _Pol1W {
                _Pol1W { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol2(&mut self) -> _Pol2W {
                _Pol2W { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol3(&mut self) -> _Pol3W {
                _Pol3W { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol4(&mut self) -> _Pol4W {
                _Pol4W { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol5(&mut self) -> _Pol5W {
                _Pol5W { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol6(&mut self) -> _Pol6W {
                _Pol6W { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Polarity" ]
            # [ inline ( always ) ]
            pub fn pol7(&mut self) -> _Pol7W {
                _Pol7W { w: self }
            }
        }
    }
    # [ doc = "Fault Mode Status" ]
    pub struct Fms {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Mode Status" ]
    pub mod fms {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fms {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULTF0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf0R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf0R::_0 => 0,
                    Faultf0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf0R {
                match bits {
                    0 => Faultf0R::_0,
                    1 => Faultf0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf0R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf1R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf1R::_0 => 0,
                    Faultf1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf1R {
                match bits {
                    0 => Faultf1R::_0,
                    1 => Faultf1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf1R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf2R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf2R::_0 => 0,
                    Faultf2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf2R {
                match bits {
                    0 => Faultf2R::_0,
                    1 => Faultf2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf2R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Faultf3R {
            # [ doc = "No fault condition was detected at the fault input." ]
            _0,
            # [ doc = "A fault condition was detected at the fault input." ]
            _1,
        }
        impl Faultf3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Faultf3R::_0 => 0,
                    Faultf3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Faultf3R {
                match bits {
                    0 => Faultf3R::_0,
                    1 => Faultf3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Faultf3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Faultf3R::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultinR {
            # [ doc = "The logic OR of the enabled fault inputs is 0." ]
            _0,
            # [ doc = "The logic OR of the enabled fault inputs is 1." ]
            _1,
        }
        impl FaultinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultinR::_0 => 0,
                    FaultinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultinR {
                match bits {
                    0 => FaultinR::_0,
                    1 => FaultinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultinR::_1
            }
        }
        # [ doc = "Possible values of the field `WPEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WpenR {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WpenR::_0 => 0,
                    WpenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WpenR {
                match bits {
                    0 => WpenR::_0,
                    1 => WpenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WpenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WpenR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FaultfR {
            # [ doc = "No fault condition was detected." ]
            _0,
            # [ doc = "A fault condition was detected." ]
            _1,
        }
        impl FaultfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FaultfR::_0 => 0,
                    FaultfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FaultfR {
                match bits {
                    0 => FaultfR::_0,
                    1 => FaultfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FaultfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FaultfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WPEN`" ]
        pub enum WpenW {
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            _0,
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            _1,
        }
        impl WpenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WpenW::_0 => 0,
                    WpenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WpenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WpenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WpenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write protection is disabled. Write protected bits can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WpenW::_0)
            }
            # [ doc = "Write protection is enabled. Write protected bits cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WpenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Detection Flag 0" ]
            # [ inline ( always ) ]
            pub fn faultf0(&self) -> Faultf0R {
                Faultf0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Detection Flag 1" ]
            # [ inline ( always ) ]
            pub fn faultf1(&self) -> Faultf1R {
                Faultf1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Detection Flag 2" ]
            # [ inline ( always ) ]
            pub fn faultf2(&self) -> Faultf2R {
                Faultf2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Detection Flag 3" ]
            # [ inline ( always ) ]
            pub fn faultf3(&self) -> Faultf3R {
                Faultf3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 5 - Fault Inputs" ]
            # [ inline ( always ) ]
            pub fn faultin(&self) -> FaultinR {
                FaultinR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 5;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&self) -> WpenR {
                WpenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Fault Detection Flag" ]
            # [ inline ( always ) ]
            pub fn faultf(&self) -> FaultfR {
                FaultfR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 6 - Write Protection Enable" ]
            # [ inline ( always ) ]
            pub fn wpen(&mut self) -> _WpenW {
                _WpenW { w: self }
            }
        }
    }
    # [ doc = "Input Capture Filter Control" ]
    pub struct Filter {
        register: VolatileCell<u32>,
    }
    # [ doc = "Input Capture Filter Control" ]
    pub mod filter {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Filter {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch0fvalR {
            bits: u8,
        }
        impl Ch0fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch1fvalR {
            bits: u8,
        }
        impl Ch1fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch2fvalR {
            bits: u8,
        }
        impl Ch2fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch3fvalR {
            bits: u8,
        }
        impl Ch3fvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3fvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3fvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&self) -> Ch0fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch0fvalR { bits }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&self) -> Ch1fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch1fvalR { bits }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&self) -> Ch2fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch2fvalR { bits }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&self) -> Ch3fvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch3fvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Channel 0 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch0fval(&mut self) -> _Ch0fvalW {
                _Ch0fvalW { w: self }
            }
            # [ doc = "Bits 4:7 - Channel 1 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch1fval(&mut self) -> _Ch1fvalW {
                _Ch1fvalW { w: self }
            }
            # [ doc = "Bits 8:11 - Channel 2 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch2fval(&mut self) -> _Ch2fvalW {
                _Ch2fvalW { w: self }
            }
            # [ doc = "Bits 12:15 - Channel 3 Input Filter" ]
            # [ inline ( always ) ]
            pub fn ch3fval(&mut self) -> _Ch3fvalW {
                _Ch3fvalW { w: self }
            }
        }
    }
    # [ doc = "Fault Control" ]
    pub struct Fltctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fault Control" ]
    pub mod fltctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FAULT0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault0enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault0enR::_0 => 0,
                    Fault0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault0enR {
                match bits {
                    0 => Fault0enR::_0,
                    1 => Fault0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault1enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault1enR::_0 => 0,
                    Fault1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault1enR {
                match bits {
                    0 => Fault1enR::_0,
                    1 => Fault1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault2enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault2enR::_0 => 0,
                    Fault2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault2enR {
                match bits {
                    0 => Fault2enR::_0,
                    1 => Fault2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FAULT3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fault3enR {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fault3enR::_0 => 0,
                    Fault3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fault3enR {
                match bits {
                    0 => Fault3enR::_0,
                    1 => Fault3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Fault3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Fault3enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr0enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr0enR::_0 => 0,
                    Ffltr0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr0enR {
                match bits {
                    0 => Ffltr0enR::_0,
                    1 => Ffltr0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr0enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr1enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr1enR::_0 => 0,
                    Ffltr1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr1enR {
                match bits {
                    0 => Ffltr1enR::_0,
                    1 => Ffltr1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr1enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr2enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr2enR::_0 => 0,
                    Ffltr2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr2enR {
                match bits {
                    0 => Ffltr2enR::_0,
                    1 => Ffltr2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr2enR::_1
            }
        }
        # [ doc = "Possible values of the field `FFLTR3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ffltr3enR {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ffltr3enR::_0 => 0,
                    Ffltr3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ffltr3enR {
                match bits {
                    0 => Ffltr3enR::_0,
                    1 => Ffltr3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ffltr3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ffltr3enR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FfvalR {
            bits: u8,
        }
        impl FfvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FSTATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FstateR {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FstateR::_0 => 0,
                    FstateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FstateR {
                match bits {
                    0 => FstateR::_0,
                    1 => FstateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FstateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FstateR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FAULT0EN`" ]
        pub enum Fault0enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault0enW::_0 => 0,
                    Fault0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault0enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT1EN`" ]
        pub enum Fault1enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault1enW::_0 => 0,
                    Fault1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault1enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT2EN`" ]
        pub enum Fault2enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault2enW::_0 => 0,
                    Fault2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault2enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FAULT3EN`" ]
        pub enum Fault3enW {
            # [ doc = "Fault input is disabled." ]
            _0,
            # [ doc = "Fault input is enabled." ]
            _1,
        }
        impl Fault3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fault3enW::_0 => 0,
                    Fault3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fault3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fault3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fault3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Fault3enW::_0)
            }
            # [ doc = "Fault input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Fault3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR0EN`" ]
        pub enum Ffltr0enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr0enW::_0 => 0,
                    Ffltr0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr0enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR1EN`" ]
        pub enum Ffltr1enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr1enW::_0 => 0,
                    Ffltr1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr1enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR2EN`" ]
        pub enum Ffltr2enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr2enW::_0 => 0,
                    Ffltr2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr2enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FFLTR3EN`" ]
        pub enum Ffltr3enW {
            # [ doc = "Fault input filter is disabled." ]
            _0,
            # [ doc = "Fault input filter is enabled." ]
            _1,
        }
        impl Ffltr3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ffltr3enW::_0 => 0,
                    Ffltr3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ffltr3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ffltr3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ffltr3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fault input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ffltr3enW::_0)
            }
            # [ doc = "Fault input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ffltr3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FfvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FfvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FSTATE`" ]
        pub enum FstateW {
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            _0,
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            _1,
        }
        impl FstateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FstateW::_0 => 0,
                    FstateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FstateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FstateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FstateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM outputs will be placed into safe values when fault events in ongoing (defined by POL bits)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FstateW::_0)
            }
            # [ doc = "FTM outputs will be tri-stated when fault event is ongoing" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FstateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&self) -> Fault0enR {
                Fault0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&self) -> Fault1enR {
                Fault1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&self) -> Fault2enR {
                Fault2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&self) -> Fault3enR {
                Fault3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&self) -> Ffltr0enR {
                Ffltr0enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 4;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&self) -> Ffltr1enR {
                Ffltr1enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&self) -> Ffltr2enR {
                Ffltr2enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 6;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&self) -> Ffltr3enR {
                Ffltr3enR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&self) -> FfvalR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FfvalR { bits }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&self) -> FstateR {
                FstateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Enable" ]
            # [ inline ( always ) ]
            pub fn fault0en(&mut self) -> _Fault0enW {
                _Fault0enW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Enable" ]
            # [ inline ( always ) ]
            pub fn fault1en(&mut self) -> _Fault1enW {
                _Fault1enW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Enable" ]
            # [ inline ( always ) ]
            pub fn fault2en(&mut self) -> _Fault2enW {
                _Fault2enW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Enable" ]
            # [ inline ( always ) ]
            pub fn fault3en(&mut self) -> _Fault3enW {
                _Fault3enW { w: self }
            }
            # [ doc = "Bit 4 - Fault Input 0 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr0en(&mut self) -> _Ffltr0enW {
                _Ffltr0enW { w: self }
            }
            # [ doc = "Bit 5 - Fault Input 1 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr1en(&mut self) -> _Ffltr1enW {
                _Ffltr1enW { w: self }
            }
            # [ doc = "Bit 6 - Fault Input 2 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr2en(&mut self) -> _Ffltr2enW {
                _Ffltr2enW { w: self }
            }
            # [ doc = "Bit 7 - Fault Input 3 Filter Enable" ]
            # [ inline ( always ) ]
            pub fn ffltr3en(&mut self) -> _Ffltr3enW {
                _Ffltr3enW { w: self }
            }
            # [ doc = "Bits 8:11 - Fault Input Filter" ]
            # [ inline ( always ) ]
            pub fn ffval(&mut self) -> _FfvalW {
                _FfvalW { w: self }
            }
            # [ doc = "Bit 15 - Fault output state" ]
            # [ inline ( always ) ]
            pub fn fstate(&mut self) -> _FstateW {
                _FstateW { w: self }
            }
        }
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub struct Qdctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Quadrature Decoder Control And Status" ]
    pub mod qdctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Qdctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `QUADEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadenR {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadenR::_0 => 0,
                    QuadenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadenR {
                match bits {
                    0 => QuadenR::_0,
                    1 => QuadenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadenR::_1
            }
        }
        # [ doc = "Possible values of the field `TOFDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofdirR {
            # [ doc = "TOF bit was set on the bottom of counting. There was an FTM counter decrement and FTM counter changes from its minimum value (CNTIN register) to its maximum value (MOD register)." ]
            _0,
            # [ doc = "TOF bit was set on the top of counting. There was an FTM counter increment and FTM counter changes from its maximum value (MOD register) to its minimum value (CNTIN register)." ]
            _1,
        }
        impl TofdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofdirR::_0 => 0,
                    TofdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofdirR {
                match bits {
                    0 => TofdirR::_0,
                    1 => TofdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofdirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadirR {
            # [ doc = "Counting direction is decreasing (FTM counter decrement)." ]
            _0,
            # [ doc = "Counting direction is increasing (FTM counter increment)." ]
            _1,
        }
        impl QuadirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadirR::_0 => 0,
                    QuadirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadirR {
                match bits {
                    0 => QuadirR::_0,
                    1 => QuadirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadirR::_1
            }
        }
        # [ doc = "Possible values of the field `QUADMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum QuadmodeR {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    QuadmodeR::_0 => 0,
                    QuadmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> QuadmodeR {
                match bits {
                    0 => QuadmodeR::_0,
                    1 => QuadmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == QuadmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == QuadmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbpolR {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbpolR::_0 => 0,
                    PhbpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbpolR {
                match bits {
                    0 => PhbpolR::_0,
                    1 => PhbpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbpolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhapolR {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhapolR::_0 => 0,
                    PhapolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhapolR {
                match bits {
                    0 => PhapolR::_0,
                    1 => PhapolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhapolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhapolR::_1
            }
        }
        # [ doc = "Possible values of the field `PHBFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhbfltrenR {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhbfltrenR::_0 => 0,
                    PhbfltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhbfltrenR {
                match bits {
                    0 => PhbfltrenR::_0,
                    1 => PhbfltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhbfltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhbfltrenR::_1
            }
        }
        # [ doc = "Possible values of the field `PHAFLTREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PhafltrenR {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PhafltrenR::_0 => 0,
                    PhafltrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PhafltrenR {
                match bits {
                    0 => PhafltrenR::_0,
                    1 => PhafltrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PhafltrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PhafltrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `QUADEN`" ]
        pub enum QuadenW {
            # [ doc = "Quadrature Decoder mode is disabled." ]
            _0,
            # [ doc = "Quadrature Decoder mode is enabled." ]
            _1,
        }
        impl QuadenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadenW::_0 => 0,
                    QuadenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Quadrature Decoder mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadenW::_0)
            }
            # [ doc = "Quadrature Decoder mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `QUADMODE`" ]
        pub enum QuadmodeW {
            # [ doc = "Phase A and phase B encoding mode." ]
            _0,
            # [ doc = "Count and direction encoding mode." ]
            _1,
        }
        impl QuadmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    QuadmodeW::_0 => 0,
                    QuadmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _QuadmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _QuadmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: QuadmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A and phase B encoding mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(QuadmodeW::_0)
            }
            # [ doc = "Count and direction encoding mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(QuadmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBPOL`" ]
        pub enum PhbpolW {
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhbpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbpolW::_0 => 0,
                    PhbpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase B input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbpolW::_0)
            }
            # [ doc = "Inverted polarity. Phase B input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAPOL`" ]
        pub enum PhapolW {
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            _0,
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            _1,
        }
        impl PhapolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhapolW::_0 => 0,
                    PhapolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhapolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhapolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhapolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal polarity. Phase A input signal is not inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhapolW::_0)
            }
            # [ doc = "Inverted polarity. Phase A input signal is inverted before identifying the rising and falling edges of this signal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhapolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHBFLTREN`" ]
        pub enum PhbfltrenW {
            # [ doc = "Phase B input filter is disabled." ]
            _0,
            # [ doc = "Phase B input filter is enabled." ]
            _1,
        }
        impl PhbfltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhbfltrenW::_0 => 0,
                    PhbfltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhbfltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhbfltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhbfltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase B input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhbfltrenW::_0)
            }
            # [ doc = "Phase B input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhbfltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PHAFLTREN`" ]
        pub enum PhafltrenW {
            # [ doc = "Phase A input filter is disabled." ]
            _0,
            # [ doc = "Phase A input filter is enabled." ]
            _1,
        }
        impl PhafltrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PhafltrenW::_0 => 0,
                    PhafltrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhafltrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhafltrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PhafltrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Phase A input filter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PhafltrenW::_0)
            }
            # [ doc = "Phase A input filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PhafltrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&self) -> QuadenR {
                QuadenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Timer Overflow Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn tofdir(&self) -> TofdirR {
                TofdirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - FTM Counter Direction In Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadir(&self) -> QuadirR {
                QuadirR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&self) -> QuadmodeR {
                QuadmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&self) -> PhbpolR {
                PhbpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&self) -> PhapolR {
                PhapolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&self) -> PhbfltrenR {
                PhbfltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 6;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&self) -> PhafltrenR {
                PhafltrenR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 7;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Quadrature Decoder Mode Enable" ]
            # [ inline ( always ) ]
            pub fn quaden(&mut self) -> _QuadenW {
                _QuadenW { w: self }
            }
            # [ doc = "Bit 3 - Quadrature Decoder Mode" ]
            # [ inline ( always ) ]
            pub fn quadmode(&mut self) -> _QuadmodeW {
                _QuadmodeW { w: self }
            }
            # [ doc = "Bit 4 - Phase B Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phbpol(&mut self) -> _PhbpolW {
                _PhbpolW { w: self }
            }
            # [ doc = "Bit 5 - Phase A Input Polarity" ]
            # [ inline ( always ) ]
            pub fn phapol(&mut self) -> _PhapolW {
                _PhapolW { w: self }
            }
            # [ doc = "Bit 6 - Phase B Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phbfltren(&mut self) -> _PhbfltrenW {
                _PhbfltrenW { w: self }
            }
            # [ doc = "Bit 7 - Phase A Input Filter Enable" ]
            # [ inline ( always ) ]
            pub fn phafltren(&mut self) -> _PhafltrenW {
                _PhafltrenW { w: self }
            }
        }
    }
    # [ doc = "Configuration" ]
    pub struct Conf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration" ]
    pub mod conf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Conf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LdfqR {
            bits: u8,
        }
        impl LdfqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BdmmodeR {
            bits: u8,
        }
        impl BdmmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeenR {
            bits: u8,
        }
        impl GtbeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GtbeoutR {
            bits: u8,
        }
        impl GtbeoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ITRIGR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ItrigrR {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ItrigrR::_0 => 0,
                    ItrigrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ItrigrR {
                match bits {
                    0 => ItrigrR::_0,
                    1 => ItrigrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ItrigrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ItrigrR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdfqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdfqW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BdmmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BdmmodeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GtbeoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GtbeoutW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ITRIGR`" ]
        pub enum ItrigrW {
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            _0,
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            _1,
        }
        impl ItrigrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ItrigrW::_0 => 0,
                    ItrigrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ItrigrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ItrigrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ItrigrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Initialization trigger is generated on counter wrap events." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ItrigrW::_0)
            }
            # [ doc = "Initialization trigger is generated when a reload point is reached." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ItrigrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&self) -> LdfqR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LdfqR { bits }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&self) -> BdmmodeR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BdmmodeR { bits }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&self) -> GtbeenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeenR { bits }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&self) -> GtbeoutR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 10;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GtbeoutR { bits }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&self) -> ItrigrR {
                ItrigrR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Frequency of the Reload Opportunities" ]
            # [ inline ( always ) ]
            pub fn ldfq(&mut self) -> _LdfqW {
                _LdfqW { w: self }
            }
            # [ doc = "Bits 6:7 - Debug Mode" ]
            # [ inline ( always ) ]
            pub fn bdmmode(&mut self) -> _BdmmodeW {
                _BdmmodeW { w: self }
            }
            # [ doc = "Bit 9 - Global Time Base Enable" ]
            # [ inline ( always ) ]
            pub fn gtbeen(&mut self) -> _GtbeenW {
                _GtbeenW { w: self }
            }
            # [ doc = "Bit 10 - Global Time Base Output" ]
            # [ inline ( always ) ]
            pub fn gtbeout(&mut self) -> _GtbeoutW {
                _GtbeoutW { w: self }
            }
            # [ doc = "Bit 11 - Initialization trigger on Reload Point" ]
            # [ inline ( always ) ]
            pub fn itrigr(&mut self) -> _ItrigrW {
                _ItrigrW { w: self }
            }
        }
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub struct Fltpol {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Fault Input Polarity" ]
    pub mod fltpol {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fltpol {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FLT0POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt0polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt0polR::_0 => 0,
                    Flt0polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt0polR {
                match bits {
                    0 => Flt0polR::_0,
                    1 => Flt0polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt0polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt0polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT1POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt1polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt1polR::_0 => 0,
                    Flt1polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt1polR {
                match bits {
                    0 => Flt1polR::_0,
                    1 => Flt1polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt1polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt1polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT2POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt2polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt2polR::_0 => 0,
                    Flt2polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt2polR {
                match bits {
                    0 => Flt2polR::_0,
                    1 => Flt2polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt2polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt2polR::_1
            }
        }
        # [ doc = "Possible values of the field `FLT3POL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Flt3polR {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Flt3polR::_0 => 0,
                    Flt3polR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Flt3polR {
                match bits {
                    0 => Flt3polR::_0,
                    1 => Flt3polR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Flt3polR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Flt3polR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FLT0POL`" ]
        pub enum Flt0polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt0polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt0polW::_0 => 0,
                    Flt0polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt0polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt0polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt0polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt0polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt0polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT1POL`" ]
        pub enum Flt1polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt1polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt1polW::_0 => 0,
                    Flt1polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt1polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt1polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt1polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt1polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt1polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT2POL`" ]
        pub enum Flt2polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt2polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt2polW::_0 => 0,
                    Flt2polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt2polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt2polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt2polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt2polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt2polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLT3POL`" ]
        pub enum Flt3polW {
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            _0,
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            _1,
        }
        impl Flt3polW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Flt3polW::_0 => 0,
                    Flt3polW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Flt3polW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Flt3polW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Flt3polW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The fault input polarity is active high. A 1 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Flt3polW::_0)
            }
            # [ doc = "The fault input polarity is active low. A 0 at the fault input indicates a fault." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Flt3polW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&self) -> Flt0polR {
                Flt0polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&self) -> Flt1polR {
                Flt1polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&self) -> Flt2polR {
                Flt2polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&self) -> Flt3polR {
                Flt3polR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fault Input 0 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt0pol(&mut self) -> _Flt0polW {
                _Flt0polW { w: self }
            }
            # [ doc = "Bit 1 - Fault Input 1 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt1pol(&mut self) -> _Flt1polW {
                _Flt1polW { w: self }
            }
            # [ doc = "Bit 2 - Fault Input 2 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt2pol(&mut self) -> _Flt2polW {
                _Flt2polW { w: self }
            }
            # [ doc = "Bit 3 - Fault Input 3 Polarity" ]
            # [ inline ( always ) ]
            pub fn flt3pol(&mut self) -> _Flt3polW {
                _Flt3polW { w: self }
            }
        }
    }
    # [ doc = "Synchronization Configuration" ]
    pub struct Synconf {
        register: VolatileCell<u32>,
    }
    # [ doc = "Synchronization Configuration" ]
    pub mod synconf {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Synconf {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HWTRIGMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwtrigmodeR {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwtrigmodeR::_0 => 0,
                    HwtrigmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwtrigmodeR {
                match bits {
                    0 => HwtrigmodeR::_0,
                    1 => HwtrigmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwtrigmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwtrigmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `CNTINC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CntincR {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CntincR::_0 => 0,
                    CntincR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CntincR {
                match bits {
                    0 => CntincR::_0,
                    1 => CntincR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CntincR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CntincR::_1
            }
        }
        # [ doc = "Possible values of the field `INVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InvcR {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InvcR::_0 => 0,
                    InvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InvcR {
                match bits {
                    0 => InvcR::_0,
                    1 => InvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwocR {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwocR::_0 => 0,
                    SwocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwocR {
                match bits {
                    0 => SwocR::_0,
                    1 => SwocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwocR::_1
            }
        }
        # [ doc = "Possible values of the field `SYNCMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SyncmodeR {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SyncmodeR::_0 => 0,
                    SyncmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SyncmodeR {
                match bits {
                    0 => SyncmodeR::_0,
                    1 => SyncmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SyncmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SyncmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `SWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwrstcntR {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwrstcntR::_0 => 0,
                    SwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwrstcntR {
                match bits {
                    0 => SwrstcntR::_0,
                    1 => SwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `SWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwwrbufR {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwwrbufR::_0 => 0,
                    SwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwwrbufR {
                match bits {
                    0 => SwwrbufR::_0,
                    1 => SwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `SWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwomR {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwomR::_0 => 0,
                    SwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwomR {
                match bits {
                    0 => SwomR::_0,
                    1 => SwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwomR::_1
            }
        }
        # [ doc = "Possible values of the field `SWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwinvcR {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwinvcR::_0 => 0,
                    SwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwinvcR {
                match bits {
                    0 => SwinvcR::_0,
                    1 => SwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `SWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwsocR {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwsocR::_0 => 0,
                    SwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwsocR {
                match bits {
                    0 => SwsocR::_0,
                    1 => SwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwsocR::_1
            }
        }
        # [ doc = "Possible values of the field `HWRSTCNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwrstcntR {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwrstcntR::_0 => 0,
                    HwrstcntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwrstcntR {
                match bits {
                    0 => HwrstcntR::_0,
                    1 => HwrstcntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwrstcntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwrstcntR::_1
            }
        }
        # [ doc = "Possible values of the field `HWWRBUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwwrbufR {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwwrbufR::_0 => 0,
                    HwwrbufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwwrbufR {
                match bits {
                    0 => HwwrbufR::_0,
                    1 => HwwrbufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwwrbufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwwrbufR::_1
            }
        }
        # [ doc = "Possible values of the field `HWOM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwomR {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwomR::_0 => 0,
                    HwomR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwomR {
                match bits {
                    0 => HwomR::_0,
                    1 => HwomR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwomR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwomR::_1
            }
        }
        # [ doc = "Possible values of the field `HWINVC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwinvcR {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwinvcR::_0 => 0,
                    HwinvcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwinvcR {
                match bits {
                    0 => HwinvcR::_0,
                    1 => HwinvcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwinvcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwinvcR::_1
            }
        }
        # [ doc = "Possible values of the field `HWSOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HwsocR {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HwsocR::_0 => 0,
                    HwsocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HwsocR {
                match bits {
                    0 => HwsocR::_0,
                    1 => HwsocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HwsocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HwsocR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HWTRIGMODE`" ]
        pub enum HwtrigmodeW {
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _0,
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            _1,
        }
        impl HwtrigmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwtrigmodeW::_0 => 0,
                    HwtrigmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwtrigmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwtrigmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwtrigmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM clears the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_0)
            }
            # [ doc = "FTM does not clear the TRIGj bit when the hardware trigger j is detected, where j = 0, 1,2." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwtrigmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CNTINC`" ]
        pub enum CntincW {
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl CntincW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CntincW::_0 => 0,
                    CntincW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntincW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntincW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CntincW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CNTIN register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CntincW::_0)
            }
            # [ doc = "CNTIN register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CntincW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVC`" ]
        pub enum InvcW {
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl InvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InvcW::_0 => 0,
                    InvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "INVCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InvcW::_0)
            }
            # [ doc = "INVCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOC`" ]
        pub enum SwocW {
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            _0,
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            _1,
        }
        impl SwocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwocW::_0 => 0,
                    SwocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SWOCTRL register is updated with its buffer value at all rising edges of FTM input clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwocW::_0)
            }
            # [ doc = "SWOCTRL register is updated with its buffer value by the PWM synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SYNCMODE`" ]
        pub enum SyncmodeW {
            # [ doc = "Legacy PWM synchronization is selected." ]
            _0,
            # [ doc = "Enhanced PWM synchronization is selected." ]
            _1,
        }
        impl SyncmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SyncmodeW::_0 => 0,
                    SyncmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SyncmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SyncmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SyncmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Legacy PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SyncmodeW::_0)
            }
            # [ doc = "Enhanced PWM synchronization is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SyncmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWRSTCNT`" ]
        pub enum SwrstcntW {
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl SwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwrstcntW::_0 => 0,
                    SwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwrstcntW::_0)
            }
            # [ doc = "The software trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWWRBUF`" ]
        pub enum SwwrbufW {
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl SwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwwrbufW::_0 => 0,
                    SwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwwrbufW::_0)
            }
            # [ doc = "The software trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWOM`" ]
        pub enum SwomW {
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl SwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwomW::_0 => 0,
                    SwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwomW::_0)
            }
            # [ doc = "The software trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWINVC`" ]
        pub enum SwinvcW {
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl SwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwinvcW::_0 => 0,
                    SwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwinvcW::_0)
            }
            # [ doc = "The software trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWSOC`" ]
        pub enum SwsocW {
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl SwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwsocW::_0 => 0,
                    SwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwsocW::_0)
            }
            # [ doc = "The software trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWRSTCNT`" ]
        pub enum HwrstcntW {
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            _1,
        }
        impl HwrstcntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwrstcntW::_0 => 0,
                    HwrstcntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwrstcntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwrstcntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwrstcntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwrstcntW::_0)
            }
            # [ doc = "A hardware trigger activates the FTM counter synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwrstcntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWWRBUF`" ]
        pub enum HwwrbufW {
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            _1,
        }
        impl HwwrbufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwwrbufW::_0 => 0,
                    HwwrbufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwwrbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwwrbufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwwrbufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwwrbufW::_0)
            }
            # [ doc = "A hardware trigger activates MOD, HCR, CNTIN, and CV registers synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwwrbufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWOM`" ]
        pub enum HwomW {
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            _1,
        }
        impl HwomW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwomW::_0 => 0,
                    HwomW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwomW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwomW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwomW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwomW::_0)
            }
            # [ doc = "A hardware trigger activates the OUTMASK register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwomW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWINVC`" ]
        pub enum HwinvcW {
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            _1,
        }
        impl HwinvcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwinvcW::_0 => 0,
                    HwinvcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwinvcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwinvcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwinvcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwinvcW::_0)
            }
            # [ doc = "A hardware trigger activates the INVCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwinvcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HWSOC`" ]
        pub enum HwsocW {
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            _0,
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            _1,
        }
        impl HwsocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HwsocW::_0 => 0,
                    HwsocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HwsocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HwsocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HwsocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A hardware trigger does not activate the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HwsocW::_0)
            }
            # [ doc = "A hardware trigger activates the SWOCTRL register synchronization." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HwsocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&self) -> HwtrigmodeR {
                HwtrigmodeR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&self) -> CntincR {
                CntincR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&self) -> InvcR {
                InvcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&self) -> SwocR {
                SwocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&self) -> SyncmodeR {
                SyncmodeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 7;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&self) -> SwrstcntR {
                SwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&self) -> SwwrbufR {
                SwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&self) -> SwomR {
                SwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&self) -> SwinvcR {
                SwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&self) -> SwsocR {
                SwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&self) -> HwrstcntR {
                HwrstcntR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 16;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&self) -> HwwrbufR {
                HwwrbufR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 17;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&self) -> HwomR {
                HwomR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&self) -> HwinvcR {
                HwinvcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 19;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&self) -> HwsocR {
                HwsocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Hardware Trigger Mode" ]
            # [ inline ( always ) ]
            pub fn hwtrigmode(&mut self) -> _HwtrigmodeW {
                _HwtrigmodeW { w: self }
            }
            # [ doc = "Bit 2 - CNTIN Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn cntinc(&mut self) -> _CntincW {
                _CntincW { w: self }
            }
            # [ doc = "Bit 4 - INVCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn invc(&mut self) -> _InvcW {
                _InvcW { w: self }
            }
            # [ doc = "Bit 5 - SWOCTRL Register Synchronization" ]
            # [ inline ( always ) ]
            pub fn swoc(&mut self) -> _SwocW {
                _SwocW { w: self }
            }
            # [ doc = "Bit 7 - Synchronization Mode" ]
            # [ inline ( always ) ]
            pub fn syncmode(&mut self) -> _SyncmodeW {
                _SyncmodeW { w: self }
            }
            # [ doc = "Bit 8 - FTM counter synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swrstcnt(&mut self) -> _SwrstcntW {
                _SwrstcntW { w: self }
            }
            # [ doc = "Bit 9 - MOD, HCR, CNTIN, and CV registers synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swwrbuf(&mut self) -> _SwwrbufW {
                _SwwrbufW { w: self }
            }
            # [ doc = "Bit 10 - Output mask synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swom(&mut self) -> _SwomW {
                _SwomW { w: self }
            }
            # [ doc = "Bit 11 - Inverting control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swinvc(&mut self) -> _SwinvcW {
                _SwinvcW { w: self }
            }
            # [ doc = "Bit 12 - Software output control synchronization is activated by the software trigger" ]
            # [ inline ( always ) ]
            pub fn swsoc(&mut self) -> _SwsocW {
                _SwsocW { w: self }
            }
            # [ doc = "Bit 16 - FTM counter synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwrstcnt(&mut self) -> _HwrstcntW {
                _HwrstcntW { w: self }
            }
            # [ doc = "Bit 17 - MOD, HCR, CNTIN, and CV registers synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwwrbuf(&mut self) -> _HwwrbufW {
                _HwwrbufW { w: self }
            }
            # [ doc = "Bit 18 - Output mask synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwom(&mut self) -> _HwomW {
                _HwomW { w: self }
            }
            # [ doc = "Bit 19 - Inverting control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwinvc(&mut self) -> _HwinvcW {
                _HwinvcW { w: self }
            }
            # [ doc = "Bit 20 - Software output control synchronization is activated by a hardware trigger" ]
            # [ inline ( always ) ]
            pub fn hwsoc(&mut self) -> _HwsocW {
                _HwsocW { w: self }
            }
        }
    }
    # [ doc = "FTM Inverting Control" ]
    pub struct Invctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Inverting Control" ]
    pub mod invctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Invctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `INV0EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv0enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv0enR::_0 => 0,
                    Inv0enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv0enR {
                match bits {
                    0 => Inv0enR::_0,
                    1 => Inv0enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv0enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv0enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV1EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv1enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv1enR::_0 => 0,
                    Inv1enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv1enR {
                match bits {
                    0 => Inv1enR::_0,
                    1 => Inv1enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv1enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv1enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV2EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv2enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv2enR::_0 => 0,
                    Inv2enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv2enR {
                match bits {
                    0 => Inv2enR::_0,
                    1 => Inv2enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv2enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv2enR::_1
            }
        }
        # [ doc = "Possible values of the field `INV3EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Inv3enR {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Inv3enR::_0 => 0,
                    Inv3enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Inv3enR {
                match bits {
                    0 => Inv3enR::_0,
                    1 => Inv3enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Inv3enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Inv3enR::_1
            }
        }
        # [ doc = "Values that can be written to the field `INV0EN`" ]
        pub enum Inv0enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv0enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv0enW::_0 => 0,
                    Inv0enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv0enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv0enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv0enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv0enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv0enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV1EN`" ]
        pub enum Inv1enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv1enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv1enW::_0 => 0,
                    Inv1enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv1enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv1enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv1enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv1enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv1enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV2EN`" ]
        pub enum Inv2enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv2enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv2enW::_0 => 0,
                    Inv2enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv2enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv2enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv2enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv2enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv2enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INV3EN`" ]
        pub enum Inv3enW {
            # [ doc = "Inverting is disabled." ]
            _0,
            # [ doc = "Inverting is enabled." ]
            _1,
        }
        impl Inv3enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Inv3enW::_0 => 0,
                    Inv3enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Inv3enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Inv3enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Inv3enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Inverting is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Inv3enW::_0)
            }
            # [ doc = "Inverting is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Inv3enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&self) -> Inv0enR {
                Inv0enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&self) -> Inv1enR {
                Inv1enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&self) -> Inv2enR {
                Inv2enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&self) -> Inv3enR {
                Inv3enR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pair Channels 0 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv0en(&mut self) -> _Inv0enW {
                _Inv0enW { w: self }
            }
            # [ doc = "Bit 1 - Pair Channels 1 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv1en(&mut self) -> _Inv1enW {
                _Inv1enW { w: self }
            }
            # [ doc = "Bit 2 - Pair Channels 2 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv2en(&mut self) -> _Inv2enW {
                _Inv2enW { w: self }
            }
            # [ doc = "Bit 3 - Pair Channels 3 Inverting Enable" ]
            # [ inline ( always ) ]
            pub fn inv3en(&mut self) -> _Inv3enW {
                _Inv3enW { w: self }
            }
        }
    }
    # [ doc = "FTM Software Output Control" ]
    pub struct Swoctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Software Output Control" ]
    pub mod swoctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Swoctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocR::_0 => 0,
                    Ch0ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocR {
                match bits {
                    0 => Ch0ocR::_0,
                    1 => Ch0ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocR::_0 => 0,
                    Ch1ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocR {
                match bits {
                    0 => Ch1ocR::_0,
                    1 => Ch1ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocR::_0 => 0,
                    Ch2ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocR {
                match bits {
                    0 => Ch2ocR::_0,
                    1 => Ch2ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocR::_0 => 0,
                    Ch3ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocR {
                match bits {
                    0 => Ch3ocR::_0,
                    1 => Ch3ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocR::_0 => 0,
                    Ch4ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocR {
                match bits {
                    0 => Ch4ocR::_0,
                    1 => Ch4ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocR::_0 => 0,
                    Ch5ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocR {
                match bits {
                    0 => Ch5ocR::_0,
                    1 => Ch5ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocR::_0 => 0,
                    Ch6ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocR {
                match bits {
                    0 => Ch6ocR::_0,
                    1 => Ch6ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocR {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocR::_0 => 0,
                    Ch7ocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocR {
                match bits {
                    0 => Ch7ocR::_0,
                    1 => Ch7ocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocR::_1
            }
        }
        # [ doc = "Possible values of the field `CH0OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0ocvR::_0 => 0,
                    Ch0ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0ocvR {
                match bits {
                    0 => Ch0ocvR::_0,
                    1 => Ch0ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1ocvR::_0 => 0,
                    Ch1ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1ocvR {
                match bits {
                    0 => Ch1ocvR::_0,
                    1 => Ch1ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2ocvR::_0 => 0,
                    Ch2ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2ocvR {
                match bits {
                    0 => Ch2ocvR::_0,
                    1 => Ch2ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3ocvR::_0 => 0,
                    Ch3ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3ocvR {
                match bits {
                    0 => Ch3ocvR::_0,
                    1 => Ch3ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4ocvR::_0 => 0,
                    Ch4ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4ocvR {
                match bits {
                    0 => Ch4ocvR::_0,
                    1 => Ch4ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5ocvR::_0 => 0,
                    Ch5ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5ocvR {
                match bits {
                    0 => Ch5ocvR::_0,
                    1 => Ch5ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6ocvR::_0 => 0,
                    Ch6ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6ocvR {
                match bits {
                    0 => Ch6ocvR::_0,
                    1 => Ch6ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6ocvR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7OCV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7ocvR {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7ocvR::_0 => 0,
                    Ch7ocvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7ocvR {
                match bits {
                    0 => Ch7ocvR::_0,
                    1 => Ch7ocvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7ocvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7ocvR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0OC`" ]
        pub enum Ch0ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch0ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocW::_0 => 0,
                    Ch0ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OC`" ]
        pub enum Ch1ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch1ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocW::_0 => 0,
                    Ch1ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OC`" ]
        pub enum Ch2ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch2ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocW::_0 => 0,
                    Ch2ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OC`" ]
        pub enum Ch3ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch3ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocW::_0 => 0,
                    Ch3ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OC`" ]
        pub enum Ch4ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch4ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocW::_0 => 0,
                    Ch4ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OC`" ]
        pub enum Ch5ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch5ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocW::_0 => 0,
                    Ch5ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OC`" ]
        pub enum Ch6ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch6ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocW::_0 => 0,
                    Ch6ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OC`" ]
        pub enum Ch7ocW {
            # [ doc = "The channel output is not affected by software output control." ]
            _0,
            # [ doc = "The channel output is affected by software output control." ]
            _1,
        }
        impl Ch7ocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocW::_0 => 0,
                    Ch7ocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel output is not affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocW::_0)
            }
            # [ doc = "The channel output is affected by software output control." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH0OCV`" ]
        pub enum Ch0ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch0ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0ocvW::_0 => 0,
                    Ch0ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1OCV`" ]
        pub enum Ch1ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch1ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1ocvW::_0 => 0,
                    Ch1ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2OCV`" ]
        pub enum Ch2ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch2ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2ocvW::_0 => 0,
                    Ch2ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3OCV`" ]
        pub enum Ch3ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch3ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3ocvW::_0 => 0,
                    Ch3ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4OCV`" ]
        pub enum Ch4ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch4ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4ocvW::_0 => 0,
                    Ch4ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5OCV`" ]
        pub enum Ch5ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch5ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5ocvW::_0 => 0,
                    Ch5ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6OCV`" ]
        pub enum Ch6ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch6ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6ocvW::_0 => 0,
                    Ch6ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7OCV`" ]
        pub enum Ch7ocvW {
            # [ doc = "The software output control forces 0 to the channel output." ]
            _0,
            # [ doc = "The software output control forces 1 to the channel output." ]
            _1,
        }
        impl Ch7ocvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7ocvW::_0 => 0,
                    Ch7ocvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7ocvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7ocvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7ocvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The software output control forces 0 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7ocvW::_0)
            }
            # [ doc = "The software output control forces 1 to the channel output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7ocvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&self) -> Ch0ocR {
                Ch0ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&self) -> Ch1ocR {
                Ch1ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&self) -> Ch2ocR {
                Ch2ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&self) -> Ch3ocR {
                Ch3ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&self) -> Ch4ocR {
                Ch4ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&self) -> Ch5ocR {
                Ch5ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&self) -> Ch6ocR {
                Ch6ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&self) -> Ch7ocR {
                Ch7ocR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&self) -> Ch0ocvR {
                Ch0ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&self) -> Ch1ocvR {
                Ch1ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&self) -> Ch2ocvR {
                Ch2ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&self) -> Ch3ocvR {
                Ch3ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&self) -> Ch4ocvR {
                Ch4ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&self) -> Ch5ocvR {
                Ch5ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&self) -> Ch6ocvR {
                Ch6ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 14;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&self) -> Ch7ocvR {
                Ch7ocvR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch0oc(&mut self) -> _Ch0ocW {
                _Ch0ocW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch1oc(&mut self) -> _Ch1ocW {
                _Ch1ocW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch2oc(&mut self) -> _Ch2ocW {
                _Ch2ocW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch3oc(&mut self) -> _Ch3ocW {
                _Ch3ocW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch4oc(&mut self) -> _Ch4ocW {
                _Ch4ocW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch5oc(&mut self) -> _Ch5ocW {
                _Ch5ocW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch6oc(&mut self) -> _Ch6ocW {
                _Ch6ocW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Software Output Control Enable" ]
            # [ inline ( always ) ]
            pub fn ch7oc(&mut self) -> _Ch7ocW {
                _Ch7ocW { w: self }
            }
            # [ doc = "Bit 8 - Channel 0 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch0ocv(&mut self) -> _Ch0ocvW {
                _Ch0ocvW { w: self }
            }
            # [ doc = "Bit 9 - Channel 1 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch1ocv(&mut self) -> _Ch1ocvW {
                _Ch1ocvW { w: self }
            }
            # [ doc = "Bit 10 - Channel 2 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch2ocv(&mut self) -> _Ch2ocvW {
                _Ch2ocvW { w: self }
            }
            # [ doc = "Bit 11 - Channel 3 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch3ocv(&mut self) -> _Ch3ocvW {
                _Ch3ocvW { w: self }
            }
            # [ doc = "Bit 12 - Channel 4 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch4ocv(&mut self) -> _Ch4ocvW {
                _Ch4ocvW { w: self }
            }
            # [ doc = "Bit 13 - Channel 5 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch5ocv(&mut self) -> _Ch5ocvW {
                _Ch5ocvW { w: self }
            }
            # [ doc = "Bit 14 - Channel 6 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch6ocv(&mut self) -> _Ch6ocvW {
                _Ch6ocvW { w: self }
            }
            # [ doc = "Bit 15 - Channel 7 Software Output Control Value" ]
            # [ inline ( always ) ]
            pub fn ch7ocv(&mut self) -> _Ch7ocvW {
                _Ch7ocvW { w: self }
            }
        }
    }
    # [ doc = "FTM PWM Load" ]
    pub struct Pwmload {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM PWM Load" ]
    pub mod pwmload {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pwmload {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CH0SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch0selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch0selR::_0 => 0,
                    Ch0selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch0selR {
                match bits {
                    0 => Ch0selR::_0,
                    1 => Ch0selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch0selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch0selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH1SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch1selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch1selR::_0 => 0,
                    Ch1selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch1selR {
                match bits {
                    0 => Ch1selR::_0,
                    1 => Ch1selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch1selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch1selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH2SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch2selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch2selR::_0 => 0,
                    Ch2selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch2selR {
                match bits {
                    0 => Ch2selR::_0,
                    1 => Ch2selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch2selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch2selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH3SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch3selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch3selR::_0 => 0,
                    Ch3selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch3selR {
                match bits {
                    0 => Ch3selR::_0,
                    1 => Ch3selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch3selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch3selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH4SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch4selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch4selR::_0 => 0,
                    Ch4selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch4selR {
                match bits {
                    0 => Ch4selR::_0,
                    1 => Ch4selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch4selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch4selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH5SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch5selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch5selR::_0 => 0,
                    Ch5selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch5selR {
                match bits {
                    0 => Ch5selR::_0,
                    1 => Ch5selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch5selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch5selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH6SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch6selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch6selR::_0 => 0,
                    Ch6selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch6selR {
                match bits {
                    0 => Ch6selR::_0,
                    1 => Ch6selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch6selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch6selR::_1
            }
        }
        # [ doc = "Possible values of the field `CH7SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ch7selR {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ch7selR::_0 => 0,
                    Ch7selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ch7selR {
                match bits {
                    0 => Ch7selR::_0,
                    1 => Ch7selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ch7selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ch7selR::_1
            }
        }
        # [ doc = "Possible values of the field `HCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HcselR {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HcselR::_0 => 0,
                    HcselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HcselR {
                match bits {
                    0 => HcselR::_0,
                    1 => HcselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HcselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HcselR::_1
            }
        }
        # [ doc = "Possible values of the field `LDOK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LdokR {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LdokR::_0 => 0,
                    LdokR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LdokR {
                match bits {
                    0 => LdokR::_0,
                    1 => LdokR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LdokR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LdokR::_1
            }
        }
        # [ doc = "Possible values of the field `GLEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GlenR {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GlenR::_0 => 0,
                    GlenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GlenR {
                match bits {
                    0 => GlenR::_0,
                    1 => GlenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GlenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GlenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CH0SEL`" ]
        pub enum Ch0selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch0selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch0selW::_0 => 0,
                    Ch0selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch0selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch0selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch0selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH1SEL`" ]
        pub enum Ch1selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch1selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch1selW::_0 => 0,
                    Ch1selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch1selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch1selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch1selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH2SEL`" ]
        pub enum Ch2selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch2selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch2selW::_0 => 0,
                    Ch2selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch2selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch2selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch2selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH3SEL`" ]
        pub enum Ch3selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch3selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch3selW::_0 => 0,
                    Ch3selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch3selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch3selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch3selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH4SEL`" ]
        pub enum Ch4selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch4selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch4selW::_0 => 0,
                    Ch4selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch4selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch4selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch4selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH5SEL`" ]
        pub enum Ch5selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch5selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch5selW::_0 => 0,
                    Ch5selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch5selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch5selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch5selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH6SEL`" ]
        pub enum Ch6selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch6selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch6selW::_0 => 0,
                    Ch6selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch6selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch6selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch6selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CH7SEL`" ]
        pub enum Ch7selW {
            # [ doc = "Channel match is not included as a reload opportunity." ]
            _0,
            # [ doc = "Channel match is included as a reload opportunity." ]
            _1,
        }
        impl Ch7selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ch7selW::_0 => 0,
                    Ch7selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ch7selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel match is not included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ch7selW::_0)
            }
            # [ doc = "Channel match is included as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ch7selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HCSEL`" ]
        pub enum HcselW {
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            _0,
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            _1,
        }
        impl HcselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HcselW::_0 => 0,
                    HcselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HcselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Half cycle reload is disabled and it is not considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HcselW::_0)
            }
            # [ doc = "Half cycle reload is enabled and it is considered as a reload opportunity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HcselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LDOK`" ]
        pub enum LdokW {
            # [ doc = "Loading updated values is disabled." ]
            _0,
            # [ doc = "Loading updated values is enabled." ]
            _1,
        }
        impl LdokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LdokW::_0 => 0,
                    LdokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LdokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Loading updated values is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LdokW::_0)
            }
            # [ doc = "Loading updated values is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LdokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLEN`" ]
        pub enum GlenW {
            # [ doc = "Global Load Ok disabled." ]
            _0,
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            _1,
        }
        impl GlenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GlenW::_0 => 0,
                    GlenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GlenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GlenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GlenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Global Load Ok disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GlenW::_0)
            }
            # [ doc = "Global Load OK enabled. A pulse event on the module global load input sets the LDOK bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GlenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GLDOK`" ]
        pub enum GldokW {
            # [ doc = "No action." ]
            _0,
            # [ doc = "LDOK bit is set." ]
            _1,
        }
        impl GldokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GldokW::_0 => 0,
                    GldokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GldokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GldokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GldokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No action." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GldokW::_0)
            }
            # [ doc = "LDOK bit is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GldokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&self) -> Ch0selR {
                Ch0selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&self) -> Ch1selR {
                Ch1selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&self) -> Ch2selR {
                Ch2selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&self) -> Ch3selR {
                Ch3selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&self) -> Ch4selR {
                Ch4selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&self) -> Ch5selR {
                Ch5selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&self) -> Ch6selR {
                Ch6selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&self) -> Ch7selR {
                Ch7selR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&self) -> HcselR {
                HcselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&self) -> LdokR {
                LdokR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&self) -> GlenR {
                GlenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Select" ]
            # [ inline ( always ) ]
            pub fn ch0sel(&mut self) -> _Ch0selW {
                _Ch0selW { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Select" ]
            # [ inline ( always ) ]
            pub fn ch1sel(&mut self) -> _Ch1selW {
                _Ch1selW { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Select" ]
            # [ inline ( always ) ]
            pub fn ch2sel(&mut self) -> _Ch2selW {
                _Ch2selW { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Select" ]
            # [ inline ( always ) ]
            pub fn ch3sel(&mut self) -> _Ch3selW {
                _Ch3selW { w: self }
            }
            # [ doc = "Bit 4 - Channel 4 Select" ]
            # [ inline ( always ) ]
            pub fn ch4sel(&mut self) -> _Ch4selW {
                _Ch4selW { w: self }
            }
            # [ doc = "Bit 5 - Channel 5 Select" ]
            # [ inline ( always ) ]
            pub fn ch5sel(&mut self) -> _Ch5selW {
                _Ch5selW { w: self }
            }
            # [ doc = "Bit 6 - Channel 6 Select" ]
            # [ inline ( always ) ]
            pub fn ch6sel(&mut self) -> _Ch6selW {
                _Ch6selW { w: self }
            }
            # [ doc = "Bit 7 - Channel 7 Select" ]
            # [ inline ( always ) ]
            pub fn ch7sel(&mut self) -> _Ch7selW {
                _Ch7selW { w: self }
            }
            # [ doc = "Bit 8 - Half Cycle Select" ]
            # [ inline ( always ) ]
            pub fn hcsel(&mut self) -> _HcselW {
                _HcselW { w: self }
            }
            # [ doc = "Bit 9 - Load Enable" ]
            # [ inline ( always ) ]
            pub fn ldok(&mut self) -> _LdokW {
                _LdokW { w: self }
            }
            # [ doc = "Bit 10 - Global Load Enable" ]
            # [ inline ( always ) ]
            pub fn glen(&mut self) -> _GlenW {
                _GlenW { w: self }
            }
            # [ doc = "Bit 11 - Global Load OK" ]
            # [ inline ( always ) ]
            pub fn gldok(&mut self) -> _GldokW {
                _GldokW { w: self }
            }
        }
    }
    # [ doc = "Half Cycle Register" ]
    pub struct Hcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Half Cycle Register" ]
    pub mod hcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Hcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HcvalR {
            bits: u16,
        }
        impl HcvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HcvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HcvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&self) -> HcvalR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                HcvalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Half Cycle Value" ]
            # [ inline ( always ) ]
            pub fn hcval(&mut self) -> _HcvalW {
                _HcvalW { w: self }
            }
        }
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub struct Pair0deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 0 Deadtime Configuration" ]
    pub mod pair0deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair0deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub struct Pair1deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 1 Deadtime Configuration" ]
    pub mod pair1deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair1deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub struct Pair2deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 2 Deadtime Configuration" ]
    pub mod pair2deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair2deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub struct Pair3deadtime {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pair 3 Deadtime Configuration" ]
    pub mod pair3deadtime {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pair3deadtime {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalR {
            bits: u8,
        }
        impl DtvalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `DTPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DtpsR {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DtpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DtpsR::_0x => 0,
                    DtpsR::_10 => 2,
                    DtpsR::_11 => 3,
                    DtpsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DtpsR {
                match bits {
                    0 => DtpsR::_0x,
                    2 => DtpsR::_10,
                    3 => DtpsR::_11,
                    i => DtpsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0x`" ]
            # [ inline ( always ) ]
            pub fn is_0x(&self) -> bool {
                *self == DtpsR::_0x
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DtpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DtpsR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DtvalexR {
            bits: u8,
        }
        impl DtvalexR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DTPS`" ]
        pub enum DtpsW {
            # [ doc = "Divide the FTM input clock by 1." ]
            _0x,
            # [ doc = "Divide the FTM input clock by 4." ]
            _10,
            # [ doc = "Divide the FTM input clock by 16." ]
            _11,
        }
        impl DtpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DtpsW::_0x => 0,
                    DtpsW::_10 => 2,
                    DtpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DtpsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide the FTM input clock by 1." ]
            # [ inline ( always ) ]
            pub fn _0x(self) -> &'a mut W {
                self.variant(DtpsW::_0x)
            }
            # [ doc = "Divide the FTM input clock by 4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DtpsW::_10)
            }
            # [ doc = "Divide the FTM input clock by 16." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DtpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DtvalexW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DtvalexW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&self) -> DtvalR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalR { bits }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&self) -> DtpsR {
                DtpsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&self) -> DtvalexR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DtvalexR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtval(&mut self) -> _DtvalW {
                _DtvalW { w: self }
            }
            # [ doc = "Bits 6:7 - Deadtime Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn dtps(&mut self) -> _DtpsW {
                _DtpsW { w: self }
            }
            # [ doc = "Bits 16:19 - Extended Deadtime Value" ]
            # [ inline ( always ) ]
            pub fn dtvalex(&mut self) -> _DtvalexW {
                _DtvalexW { w: self }
            }
        }
    }
}
# [ doc = "FlexTimer Module" ]
pub struct Ftm3 {
    register_block: ftm3::RegisterBlock,
}
impl Deref for Ftm3 {
    type Target = ftm3::RegisterBlock;
    fn deref(&self) -> &ftm3::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Analog-to-Digital Converter" ]
pub const ADC0: Peripheral<Adc0> = unsafe { Peripheral::new(1073983488) };
# [ doc = "Analog-to-Digital Converter" ]
pub mod adc0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - ADC Status and Control Register 1" ]
        pub sc1a: Sc1,
        # [ doc = "0x04 - ADC Status and Control Register 1" ]
        pub sc1b: Sc1,
        # [ doc = "0x08 - ADC Status and Control Register 1" ]
        pub sc1c: Sc1,
        # [ doc = "0x0c - ADC Status and Control Register 1" ]
        pub sc1d: Sc1,
        # [ doc = "0x10 - ADC Status and Control Register 1" ]
        pub sc1e: Sc1,
        # [ doc = "0x14 - ADC Status and Control Register 1" ]
        pub sc1f: Sc1,
        # [ doc = "0x18 - ADC Status and Control Register 1" ]
        pub sc1g: Sc1,
        # [ doc = "0x1c - ADC Status and Control Register 1" ]
        pub sc1h: Sc1,
        # [ doc = "0x20 - ADC Status and Control Register 1" ]
        pub sc1i: Sc1,
        # [ doc = "0x24 - ADC Status and Control Register 1" ]
        pub sc1j: Sc1,
        # [ doc = "0x28 - ADC Status and Control Register 1" ]
        pub sc1k: Sc1,
        # [ doc = "0x2c - ADC Status and Control Register 1" ]
        pub sc1l: Sc1,
        # [ doc = "0x30 - ADC Status and Control Register 1" ]
        pub sc1m: Sc1,
        # [ doc = "0x34 - ADC Status and Control Register 1" ]
        pub sc1n: Sc1,
        # [ doc = "0x38 - ADC Status and Control Register 1" ]
        pub sc1o: Sc1,
        # [ doc = "0x3c - ADC Status and Control Register 1" ]
        pub sc1p: Sc1,
        # [ doc = "0x40 - ADC Configuration Register 1" ]
        pub cfg1: Cfg1,
        # [ doc = "0x44 - ADC Configuration Register 2" ]
        pub cfg2: Cfg2,
        # [ doc = "0x48 - ADC Data Result Registers" ]
        pub ra: R,
        # [ doc = "0x4c - ADC Data Result Registers" ]
        pub rb: R,
        # [ doc = "0x50 - ADC Data Result Registers" ]
        pub rc: R,
        # [ doc = "0x54 - ADC Data Result Registers" ]
        pub rd: R,
        # [ doc = "0x58 - ADC Data Result Registers" ]
        pub re: R,
        # [ doc = "0x5c - ADC Data Result Registers" ]
        pub rf: R,
        # [ doc = "0x60 - ADC Data Result Registers" ]
        pub rg: R,
        # [ doc = "0x64 - ADC Data Result Registers" ]
        pub rh: R,
        # [ doc = "0x68 - ADC Data Result Registers" ]
        pub ri: R,
        # [ doc = "0x6c - ADC Data Result Registers" ]
        pub rj: R,
        # [ doc = "0x70 - ADC Data Result Registers" ]
        pub rk: R,
        # [ doc = "0x74 - ADC Data Result Registers" ]
        pub rl: R,
        # [ doc = "0x78 - ADC Data Result Registers" ]
        pub rm: R,
        # [ doc = "0x7c - ADC Data Result Registers" ]
        pub rn: R,
        # [ doc = "0x80 - ADC Data Result Registers" ]
        pub ro: R,
        # [ doc = "0x84 - ADC Data Result Registers" ]
        pub rp: R,
        # [ doc = "0x88 - Compare Value Registers" ]
        pub cv1: Cv,
        # [ doc = "0x8c - Compare Value Registers" ]
        pub cv2: Cv,
        # [ doc = "0x90 - Status and Control Register 2" ]
        pub sc2: Sc2,
        # [ doc = "0x94 - Status and Control Register 3" ]
        pub sc3: Sc3,
        # [ doc = "0x98 - BASE Offset Register" ]
        pub base_ofs: BaseOfs,
        # [ doc = "0x9c - ADC Offset Correction Register" ]
        pub ofs: Ofs,
        # [ doc = "0xa0 - USER Offset Correction Register" ]
        pub usr_ofs: UsrOfs,
        # [ doc = "0xa4 - ADC X Offset Correction Register" ]
        pub xofs: Xofs,
        # [ doc = "0xa8 - ADC Y Offset Correction Register" ]
        pub yofs: Yofs,
        # [ doc = "0xac - ADC Gain Register" ]
        pub g: G,
        # [ doc = "0xb0 - ADC User Gain Register" ]
        pub ug: Ug,
        # [ doc = "0xb4 - ADC General Calibration Value Register S" ]
        pub clps: Clps,
        # [ doc = "0xb8 - ADC Plus-Side General Calibration Value Register 3" ]
        pub clp3: Clp3,
        # [ doc = "0xbc - ADC Plus-Side General Calibration Value Register 2" ]
        pub clp2: Clp2,
        # [ doc = "0xc0 - ADC Plus-Side General Calibration Value Register 1" ]
        pub clp1: Clp1,
        # [ doc = "0xc4 - ADC Plus-Side General Calibration Value Register 0" ]
        pub clp0: Clp0,
        # [ doc = "0xc8 - ADC Plus-Side General Calibration Value Register X" ]
        pub clpx: Clpx,
        # [ doc = "0xcc - ADC Plus-Side General Calibration Value Register 9" ]
        pub clp9: Clp9,
        # [ doc = "0xd0 - ADC General Calibration Offset Value Register S" ]
        pub clps_ofs: ClpsOfs,
        # [ doc = "0xd4 - ADC Plus-Side General Calibration Offset Value Register 3" ]
        pub clp3_ofs: Clp3Ofs,
        # [ doc = "0xd8 - ADC Plus-Side General Calibration Offset Value Register 2" ]
        pub clp2_ofs: Clp2Ofs,
        # [ doc = "0xdc - ADC Plus-Side General Calibration Offset Value Register 1" ]
        pub clp1_ofs: Clp1Ofs,
        # [ doc = "0xe0 - ADC Plus-Side General Calibration Offset Value Register 0" ]
        pub clp0_ofs: Clp0Ofs,
        # [ doc = "0xe4 - ADC Plus-Side General Calibration Offset Value Register X" ]
        pub clpx_ofs: ClpxOfs,
        # [ doc = "0xe8 - ADC Plus-Side General Calibration Offset Value Register 9" ]
        pub clp9_ofs: Clp9Ofs,
    }
    # [ doc = "ADC Status and Control Register 1" ]
    pub struct Sc1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Status and Control Register 1" ]
    pub mod sc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdchR {
            # [ doc = "Exernal channel 0 is selected as input." ]
            _00000,
            # [ doc = "Exernal channel 1 is selected as input." ]
            _00001,
            # [ doc = "Exernal channel 2 is selected as input." ]
            _00010,
            # [ doc = "Exernal channel 3 is selected as input." ]
            _00011,
            # [ doc = "Exernal channel 4 is selected as input." ]
            _00100,
            # [ doc = "Exernal channel 5 is selected as input." ]
            _00101,
            # [ doc = "Exernal channel 6 is selected as input." ]
            _00110,
            # [ doc = "Exernal channel 7 is selected as input." ]
            _00111,
            # [ doc = "Exernal channel 8 is selected as input." ]
            _01000,
            # [ doc = "Exernal channel 9 is selected as input." ]
            _01001,
            # [ doc = "Exernal channel 10 is selected as input." ]
            _01010,
            # [ doc = "Exernal channel 11 is selected as input." ]
            _01011,
            # [ doc = "Exernal channel 12 is selected as input." ]
            _01100,
            # [ doc = "Exernal channel 13 is selected as input." ]
            _01101,
            # [ doc = "Exernal channel 14 is selected as input." ]
            _01110,
            # [ doc = "Exernal channel 15 is selected as input." ]
            _01111,
            # [ doc = "Exernal channel 18 is selected as input." ]
            _10010,
            # [ doc = "Exernal channel 19 is selected as input." ]
            _10011,
            # [ doc = "Internal channel 0 is selected as input." ]
            _10101,
            # [ doc = "Internal channel 1 is selected as input." ]
            _10110,
            # [ doc = "Internal channel 2 is selected as input." ]
            _10111,
            # [ doc = "Temp Sensor" ]
            _11010,
            # [ doc = "Band Gap" ]
            _11011,
            # [ doc = "Internal channel 3 is selected as input." ]
            _11100,
            # [ doc = "VREFSH is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11101,
            # [ doc = "VREFSL is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11110,
            # [ doc = "Module is disabled" ]
            _11111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl AdchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdchR::_00000 => 0,
                    AdchR::_00001 => 1,
                    AdchR::_00010 => 2,
                    AdchR::_00011 => 3,
                    AdchR::_00100 => 4,
                    AdchR::_00101 => 5,
                    AdchR::_00110 => 6,
                    AdchR::_00111 => 7,
                    AdchR::_01000 => 8,
                    AdchR::_01001 => 9,
                    AdchR::_01010 => 10,
                    AdchR::_01011 => 11,
                    AdchR::_01100 => 12,
                    AdchR::_01101 => 13,
                    AdchR::_01110 => 14,
                    AdchR::_01111 => 15,
                    AdchR::_10010 => 18,
                    AdchR::_10011 => 19,
                    AdchR::_10101 => 21,
                    AdchR::_10110 => 22,
                    AdchR::_10111 => 23,
                    AdchR::_11010 => 26,
                    AdchR::_11011 => 27,
                    AdchR::_11100 => 28,
                    AdchR::_11101 => 29,
                    AdchR::_11110 => 30,
                    AdchR::_11111 => 31,
                    AdchR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdchR {
                match bits {
                    0 => AdchR::_00000,
                    1 => AdchR::_00001,
                    2 => AdchR::_00010,
                    3 => AdchR::_00011,
                    4 => AdchR::_00100,
                    5 => AdchR::_00101,
                    6 => AdchR::_00110,
                    7 => AdchR::_00111,
                    8 => AdchR::_01000,
                    9 => AdchR::_01001,
                    10 => AdchR::_01010,
                    11 => AdchR::_01011,
                    12 => AdchR::_01100,
                    13 => AdchR::_01101,
                    14 => AdchR::_01110,
                    15 => AdchR::_01111,
                    18 => AdchR::_10010,
                    19 => AdchR::_10011,
                    21 => AdchR::_10101,
                    22 => AdchR::_10110,
                    23 => AdchR::_10111,
                    26 => AdchR::_11010,
                    27 => AdchR::_11011,
                    28 => AdchR::_11100,
                    29 => AdchR::_11101,
                    30 => AdchR::_11110,
                    31 => AdchR::_11111,
                    i => AdchR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000`" ]
            # [ inline ( always ) ]
            pub fn is_00000(&self) -> bool {
                *self == AdchR::_00000
            }
            # [ doc = "Checks if the value of the field is `_00001`" ]
            # [ inline ( always ) ]
            pub fn is_00001(&self) -> bool {
                *self == AdchR::_00001
            }
            # [ doc = "Checks if the value of the field is `_00010`" ]
            # [ inline ( always ) ]
            pub fn is_00010(&self) -> bool {
                *self == AdchR::_00010
            }
            # [ doc = "Checks if the value of the field is `_00011`" ]
            # [ inline ( always ) ]
            pub fn is_00011(&self) -> bool {
                *self == AdchR::_00011
            }
            # [ doc = "Checks if the value of the field is `_00100`" ]
            # [ inline ( always ) ]
            pub fn is_00100(&self) -> bool {
                *self == AdchR::_00100
            }
            # [ doc = "Checks if the value of the field is `_00101`" ]
            # [ inline ( always ) ]
            pub fn is_00101(&self) -> bool {
                *self == AdchR::_00101
            }
            # [ doc = "Checks if the value of the field is `_00110`" ]
            # [ inline ( always ) ]
            pub fn is_00110(&self) -> bool {
                *self == AdchR::_00110
            }
            # [ doc = "Checks if the value of the field is `_00111`" ]
            # [ inline ( always ) ]
            pub fn is_00111(&self) -> bool {
                *self == AdchR::_00111
            }
            # [ doc = "Checks if the value of the field is `_01000`" ]
            # [ inline ( always ) ]
            pub fn is_01000(&self) -> bool {
                *self == AdchR::_01000
            }
            # [ doc = "Checks if the value of the field is `_01001`" ]
            # [ inline ( always ) ]
            pub fn is_01001(&self) -> bool {
                *self == AdchR::_01001
            }
            # [ doc = "Checks if the value of the field is `_01010`" ]
            # [ inline ( always ) ]
            pub fn is_01010(&self) -> bool {
                *self == AdchR::_01010
            }
            # [ doc = "Checks if the value of the field is `_01011`" ]
            # [ inline ( always ) ]
            pub fn is_01011(&self) -> bool {
                *self == AdchR::_01011
            }
            # [ doc = "Checks if the value of the field is `_01100`" ]
            # [ inline ( always ) ]
            pub fn is_01100(&self) -> bool {
                *self == AdchR::_01100
            }
            # [ doc = "Checks if the value of the field is `_01101`" ]
            # [ inline ( always ) ]
            pub fn is_01101(&self) -> bool {
                *self == AdchR::_01101
            }
            # [ doc = "Checks if the value of the field is `_01110`" ]
            # [ inline ( always ) ]
            pub fn is_01110(&self) -> bool {
                *self == AdchR::_01110
            }
            # [ doc = "Checks if the value of the field is `_01111`" ]
            # [ inline ( always ) ]
            pub fn is_01111(&self) -> bool {
                *self == AdchR::_01111
            }
            # [ doc = "Checks if the value of the field is `_10010`" ]
            # [ inline ( always ) ]
            pub fn is_10010(&self) -> bool {
                *self == AdchR::_10010
            }
            # [ doc = "Checks if the value of the field is `_10011`" ]
            # [ inline ( always ) ]
            pub fn is_10011(&self) -> bool {
                *self == AdchR::_10011
            }
            # [ doc = "Checks if the value of the field is `_10101`" ]
            # [ inline ( always ) ]
            pub fn is_10101(&self) -> bool {
                *self == AdchR::_10101
            }
            # [ doc = "Checks if the value of the field is `_10110`" ]
            # [ inline ( always ) ]
            pub fn is_10110(&self) -> bool {
                *self == AdchR::_10110
            }
            # [ doc = "Checks if the value of the field is `_10111`" ]
            # [ inline ( always ) ]
            pub fn is_10111(&self) -> bool {
                *self == AdchR::_10111
            }
            # [ doc = "Checks if the value of the field is `_11010`" ]
            # [ inline ( always ) ]
            pub fn is_11010(&self) -> bool {
                *self == AdchR::_11010
            }
            # [ doc = "Checks if the value of the field is `_11011`" ]
            # [ inline ( always ) ]
            pub fn is_11011(&self) -> bool {
                *self == AdchR::_11011
            }
            # [ doc = "Checks if the value of the field is `_11100`" ]
            # [ inline ( always ) ]
            pub fn is_11100(&self) -> bool {
                *self == AdchR::_11100
            }
            # [ doc = "Checks if the value of the field is `_11101`" ]
            # [ inline ( always ) ]
            pub fn is_11101(&self) -> bool {
                *self == AdchR::_11101
            }
            # [ doc = "Checks if the value of the field is `_11110`" ]
            # [ inline ( always ) ]
            pub fn is_11110(&self) -> bool {
                *self == AdchR::_11110
            }
            # [ doc = "Checks if the value of the field is `_11111`" ]
            # [ inline ( always ) ]
            pub fn is_11111(&self) -> bool {
                *self == AdchR::_11111
            }
        }
        # [ doc = "Possible values of the field `AIEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AienR {
            # [ doc = "Conversion complete interrupt is disabled." ]
            _0,
            # [ doc = "Conversion complete interrupt is enabled." ]
            _1,
        }
        impl AienR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AienR::_0 => 0,
                    AienR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AienR {
                match bits {
                    0 => AienR::_0,
                    1 => AienR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AienR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AienR::_1
            }
        }
        # [ doc = "Possible values of the field `COCO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CocoR {
            # [ doc = "Conversion is not completed." ]
            _0,
            # [ doc = "Conversion is completed." ]
            _1,
        }
        impl CocoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CocoR::_0 => 0,
                    CocoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CocoR {
                match bits {
                    0 => CocoR::_0,
                    1 => CocoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CocoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CocoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ADCH`" ]
        pub enum AdchW {
            # [ doc = "Exernal channel 0 is selected as input." ]
            _00000,
            # [ doc = "Exernal channel 1 is selected as input." ]
            _00001,
            # [ doc = "Exernal channel 2 is selected as input." ]
            _00010,
            # [ doc = "Exernal channel 3 is selected as input." ]
            _00011,
            # [ doc = "Exernal channel 4 is selected as input." ]
            _00100,
            # [ doc = "Exernal channel 5 is selected as input." ]
            _00101,
            # [ doc = "Exernal channel 6 is selected as input." ]
            _00110,
            # [ doc = "Exernal channel 7 is selected as input." ]
            _00111,
            # [ doc = "Exernal channel 8 is selected as input." ]
            _01000,
            # [ doc = "Exernal channel 9 is selected as input." ]
            _01001,
            # [ doc = "Exernal channel 10 is selected as input." ]
            _01010,
            # [ doc = "Exernal channel 11 is selected as input." ]
            _01011,
            # [ doc = "Exernal channel 12 is selected as input." ]
            _01100,
            # [ doc = "Exernal channel 13 is selected as input." ]
            _01101,
            # [ doc = "Exernal channel 14 is selected as input." ]
            _01110,
            # [ doc = "Exernal channel 15 is selected as input." ]
            _01111,
            # [ doc = "Exernal channel 18 is selected as input." ]
            _10010,
            # [ doc = "Exernal channel 19 is selected as input." ]
            _10011,
            # [ doc = "Internal channel 0 is selected as input." ]
            _10101,
            # [ doc = "Internal channel 1 is selected as input." ]
            _10110,
            # [ doc = "Internal channel 2 is selected as input." ]
            _10111,
            # [ doc = "Temp Sensor" ]
            _11010,
            # [ doc = "Band Gap" ]
            _11011,
            # [ doc = "Internal channel 3 is selected as input." ]
            _11100,
            # [ doc = "VREFSH is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11101,
            # [ doc = "VREFSL is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11110,
            # [ doc = "Module is disabled" ]
            _11111,
        }
        impl AdchW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdchW::_00000 => 0,
                    AdchW::_00001 => 1,
                    AdchW::_00010 => 2,
                    AdchW::_00011 => 3,
                    AdchW::_00100 => 4,
                    AdchW::_00101 => 5,
                    AdchW::_00110 => 6,
                    AdchW::_00111 => 7,
                    AdchW::_01000 => 8,
                    AdchW::_01001 => 9,
                    AdchW::_01010 => 10,
                    AdchW::_01011 => 11,
                    AdchW::_01100 => 12,
                    AdchW::_01101 => 13,
                    AdchW::_01110 => 14,
                    AdchW::_01111 => 15,
                    AdchW::_10010 => 18,
                    AdchW::_10011 => 19,
                    AdchW::_10101 => 21,
                    AdchW::_10110 => 22,
                    AdchW::_10111 => 23,
                    AdchW::_11010 => 26,
                    AdchW::_11011 => 27,
                    AdchW::_11100 => 28,
                    AdchW::_11101 => 29,
                    AdchW::_11110 => 30,
                    AdchW::_11111 => 31,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdchW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdchW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Exernal channel 0 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00000(self) -> &'a mut W {
                self.variant(AdchW::_00000)
            }
            # [ doc = "Exernal channel 1 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00001(self) -> &'a mut W {
                self.variant(AdchW::_00001)
            }
            # [ doc = "Exernal channel 2 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00010(self) -> &'a mut W {
                self.variant(AdchW::_00010)
            }
            # [ doc = "Exernal channel 3 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00011(self) -> &'a mut W {
                self.variant(AdchW::_00011)
            }
            # [ doc = "Exernal channel 4 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00100(self) -> &'a mut W {
                self.variant(AdchW::_00100)
            }
            # [ doc = "Exernal channel 5 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00101(self) -> &'a mut W {
                self.variant(AdchW::_00101)
            }
            # [ doc = "Exernal channel 6 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00110(self) -> &'a mut W {
                self.variant(AdchW::_00110)
            }
            # [ doc = "Exernal channel 7 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00111(self) -> &'a mut W {
                self.variant(AdchW::_00111)
            }
            # [ doc = "Exernal channel 8 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01000(self) -> &'a mut W {
                self.variant(AdchW::_01000)
            }
            # [ doc = "Exernal channel 9 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01001(self) -> &'a mut W {
                self.variant(AdchW::_01001)
            }
            # [ doc = "Exernal channel 10 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01010(self) -> &'a mut W {
                self.variant(AdchW::_01010)
            }
            # [ doc = "Exernal channel 11 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01011(self) -> &'a mut W {
                self.variant(AdchW::_01011)
            }
            # [ doc = "Exernal channel 12 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01100(self) -> &'a mut W {
                self.variant(AdchW::_01100)
            }
            # [ doc = "Exernal channel 13 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01101(self) -> &'a mut W {
                self.variant(AdchW::_01101)
            }
            # [ doc = "Exernal channel 14 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01110(self) -> &'a mut W {
                self.variant(AdchW::_01110)
            }
            # [ doc = "Exernal channel 15 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01111(self) -> &'a mut W {
                self.variant(AdchW::_01111)
            }
            # [ doc = "Exernal channel 18 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10010(self) -> &'a mut W {
                self.variant(AdchW::_10010)
            }
            # [ doc = "Exernal channel 19 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10011(self) -> &'a mut W {
                self.variant(AdchW::_10011)
            }
            # [ doc = "Internal channel 0 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10101(self) -> &'a mut W {
                self.variant(AdchW::_10101)
            }
            # [ doc = "Internal channel 1 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10110(self) -> &'a mut W {
                self.variant(AdchW::_10110)
            }
            # [ doc = "Internal channel 2 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10111(self) -> &'a mut W {
                self.variant(AdchW::_10111)
            }
            # [ doc = "Temp Sensor" ]
            # [ inline ( always ) ]
            pub fn _11010(self) -> &'a mut W {
                self.variant(AdchW::_11010)
            }
            # [ doc = "Band Gap" ]
            # [ inline ( always ) ]
            pub fn _11011(self) -> &'a mut W {
                self.variant(AdchW::_11011)
            }
            # [ doc = "Internal channel 3 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _11100(self) -> &'a mut W {
                self.variant(AdchW::_11100)
            }
            # [ doc = "VREFSH is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            # [ inline ( always ) ]
            pub fn _11101(self) -> &'a mut W {
                self.variant(AdchW::_11101)
            }
            # [ doc = "VREFSL is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            # [ inline ( always ) ]
            pub fn _11110(self) -> &'a mut W {
                self.variant(AdchW::_11110)
            }
            # [ doc = "Module is disabled" ]
            # [ inline ( always ) ]
            pub fn _11111(self) -> &'a mut W {
                self.variant(AdchW::_11111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AIEN`" ]
        pub enum AienW {
            # [ doc = "Conversion complete interrupt is disabled." ]
            _0,
            # [ doc = "Conversion complete interrupt is enabled." ]
            _1,
        }
        impl AienW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AienW::_0 => 0,
                    AienW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AienW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AienW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AienW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Conversion complete interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AienW::_0)
            }
            # [ doc = "Conversion complete interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AienW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Input channel select" ]
            # [ inline ( always ) ]
            pub fn adch(&self) -> AdchR {
                AdchR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn aien(&self) -> AienR {
                AienR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Conversion Complete Flag" ]
            # [ inline ( always ) ]
            pub fn coco(&self) -> CocoR {
                CocoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 31 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Input channel select" ]
            # [ inline ( always ) ]
            pub fn adch(&mut self) -> _AdchW {
                _AdchW { w: self }
            }
            # [ doc = "Bit 6 - Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn aien(&mut self) -> _AienW {
                _AienW { w: self }
            }
        }
    }
    # [ doc = "ADC Configuration Register 1" ]
    pub struct Cfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Configuration Register 1" ]
    pub mod cfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfg1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADICLK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdiclkR {
            # [ doc = "Alternate clock 1 (ADC_ALTCLK1)" ]
            _00,
            # [ doc = "Alternate clock 2 (ADC_ALTCLK2)" ]
            _01,
            # [ doc = "Alternate clock 3 (ADC_ALTCLK3)" ]
            _10,
            # [ doc = "Alternate clock 4 (ADC_ALTCLK4)" ]
            _11,
        }
        impl AdiclkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdiclkR::_00 => 0,
                    AdiclkR::_01 => 1,
                    AdiclkR::_10 => 2,
                    AdiclkR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdiclkR {
                match bits {
                    0 => AdiclkR::_00,
                    1 => AdiclkR::_01,
                    2 => AdiclkR::_10,
                    3 => AdiclkR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == AdiclkR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == AdiclkR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == AdiclkR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == AdiclkR::_11
            }
        }
        # [ doc = "Possible values of the field `MODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ModeR {
            # [ doc = "8-bit conversion." ]
            _00,
            # [ doc = "12-bit conversion." ]
            _01,
            # [ doc = "10-bit conversion." ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ModeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ModeR::_00 => 0,
                    ModeR::_01 => 1,
                    ModeR::_10 => 2,
                    ModeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ModeR {
                match bits {
                    0 => ModeR::_00,
                    1 => ModeR::_01,
                    2 => ModeR::_10,
                    i => ModeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ModeR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ModeR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ModeR::_10
            }
        }
        # [ doc = "Possible values of the field `ADIV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdivR {
            # [ doc = "The divide ratio is 1 and the clock rate is input clock." ]
            _00,
            # [ doc = "The divide ratio is 2 and the clock rate is (input clock)/2." ]
            _01,
            # [ doc = "The divide ratio is 4 and the clock rate is (input clock)/4." ]
            _10,
            # [ doc = "The divide ratio is 8 and the clock rate is (input clock)/8." ]
            _11,
        }
        impl AdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdivR::_00 => 0,
                    AdivR::_01 => 1,
                    AdivR::_10 => 2,
                    AdivR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdivR {
                match bits {
                    0 => AdivR::_00,
                    1 => AdivR::_01,
                    2 => AdivR::_10,
                    3 => AdivR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == AdivR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == AdivR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == AdivR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == AdivR::_11
            }
        }
        # [ doc = "Values that can be written to the field `ADICLK`" ]
        pub enum AdiclkW {
            # [ doc = "Alternate clock 1 (ADC_ALTCLK1)" ]
            _00,
            # [ doc = "Alternate clock 2 (ADC_ALTCLK2)" ]
            _01,
            # [ doc = "Alternate clock 3 (ADC_ALTCLK3)" ]
            _10,
            # [ doc = "Alternate clock 4 (ADC_ALTCLK4)" ]
            _11,
        }
        impl AdiclkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdiclkW::_00 => 0,
                    AdiclkW::_01 => 1,
                    AdiclkW::_10 => 2,
                    AdiclkW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdiclkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdiclkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdiclkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Alternate clock 1 (ADC_ALTCLK1)" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(AdiclkW::_00)
            }
            # [ doc = "Alternate clock 2 (ADC_ALTCLK2)" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(AdiclkW::_01)
            }
            # [ doc = "Alternate clock 3 (ADC_ALTCLK3)" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(AdiclkW::_10)
            }
            # [ doc = "Alternate clock 4 (ADC_ALTCLK4)" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(AdiclkW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MODE`" ]
        pub enum ModeW {
            # [ doc = "8-bit conversion." ]
            _00,
            # [ doc = "12-bit conversion." ]
            _01,
            # [ doc = "10-bit conversion." ]
            _10,
        }
        impl ModeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ModeW::_00 => 0,
                    ModeW::_01 => 1,
                    ModeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ModeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit conversion." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ModeW::_00)
            }
            # [ doc = "12-bit conversion." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ModeW::_01)
            }
            # [ doc = "10-bit conversion." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ModeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADIV`" ]
        pub enum AdivW {
            # [ doc = "The divide ratio is 1 and the clock rate is input clock." ]
            _00,
            # [ doc = "The divide ratio is 2 and the clock rate is (input clock)/2." ]
            _01,
            # [ doc = "The divide ratio is 4 and the clock rate is (input clock)/4." ]
            _10,
            # [ doc = "The divide ratio is 8 and the clock rate is (input clock)/8." ]
            _11,
        }
        impl AdivW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdivW::_00 => 0,
                    AdivW::_01 => 1,
                    AdivW::_10 => 2,
                    AdivW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdivW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdivW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The divide ratio is 1 and the clock rate is input clock." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(AdivW::_00)
            }
            # [ doc = "The divide ratio is 2 and the clock rate is (input clock)/2." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(AdivW::_01)
            }
            # [ doc = "The divide ratio is 4 and the clock rate is (input clock)/4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(AdivW::_10)
            }
            # [ doc = "The divide ratio is 8 and the clock rate is (input clock)/8." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(AdivW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClrltrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClrltrgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Input Clock Select" ]
            # [ inline ( always ) ]
            pub fn adiclk(&self) -> AdiclkR {
                AdiclkR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 2:3 - Conversion mode selection" ]
            # [ inline ( always ) ]
            pub fn mode(&self) -> ModeR {
                ModeR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 5:6 - Clock Divide Select" ]
            # [ inline ( always ) ]
            pub fn adiv(&self) -> AdivR {
                AdivR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Input Clock Select" ]
            # [ inline ( always ) ]
            pub fn adiclk(&mut self) -> _AdiclkW {
                _AdiclkW { w: self }
            }
            # [ doc = "Bits 2:3 - Conversion mode selection" ]
            # [ inline ( always ) ]
            pub fn mode(&mut self) -> _ModeW {
                _ModeW { w: self }
            }
            # [ doc = "Bits 5:6 - Clock Divide Select" ]
            # [ inline ( always ) ]
            pub fn adiv(&mut self) -> _AdivW {
                _AdivW { w: self }
            }
            # [ doc = "Bit 8 - Clear Latch Trigger in Trigger Handler Block" ]
            # [ inline ( always ) ]
            pub fn clrltrg(&mut self) -> _ClrltrgW {
                _ClrltrgW { w: self }
            }
        }
    }
    # [ doc = "ADC Configuration Register 2" ]
    pub struct Cfg2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Configuration Register 2" ]
    pub mod cfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfg2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SmpltsR {
            bits: u8,
        }
        impl SmpltsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmpltsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmpltsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Sample Time Select" ]
            # [ inline ( always ) ]
            pub fn smplts(&self) -> SmpltsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SmpltsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Sample Time Select" ]
            # [ inline ( always ) ]
            pub fn smplts(&mut self) -> _SmpltsW {
                _SmpltsW { w: self }
            }
        }
    }
    # [ doc = "ADC Data Result Registers" ]
    pub struct R {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Data Result Registers" ]
    pub mod r {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::R {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DR {
            bits: u16,
        }
        impl DR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - Data result" ]
            # [ inline ( always ) ]
            pub fn d(&self) -> DR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DR { bits }
            }
        }
    }
    # [ doc = "Compare Value Registers" ]
    pub struct Cv {
        register: VolatileCell<u32>,
    }
    # [ doc = "Compare Value Registers" ]
    pub mod cv {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cv {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CvR {
            bits: u16,
        }
        impl CvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CvW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Compare Value." ]
            # [ inline ( always ) ]
            pub fn cv(&self) -> CvR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CvR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Compare Value." ]
            # [ inline ( always ) ]
            pub fn cv(&mut self) -> _CvW {
                _CvW { w: self }
            }
        }
    }
    # [ doc = "Status and Control Register 2" ]
    pub struct Sc2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status and Control Register 2" ]
    pub mod sc2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `REFSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RefselR {
            # [ doc = "Default voltage reference pin pair, that is, external pins VREFH and VREFL" ]
            _00,
            # [ doc = "Alternate reference voltage, that is, VALTH. This voltage may be additional external pin or internal source depending on the MCU configuration. See the chip configuration information for details specific to this MCU." ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RefselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RefselR::_00 => 0,
                    RefselR::_01 => 1,
                    RefselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RefselR {
                match bits {
                    0 => RefselR::_00,
                    1 => RefselR::_01,
                    i => RefselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == RefselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == RefselR::_01
            }
        }
        # [ doc = "Possible values of the field `DMAEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaenR {
            # [ doc = "DMA is disabled." ]
            _0,
            # [ doc = "DMA is enabled and will assert the ADC DMA request during an ADC conversion complete event , which is indicated when any SC1n[COCO] flag is asserted." ]
            _1,
        }
        impl DmaenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaenR::_0 => 0,
                    DmaenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaenR {
                match bits {
                    0 => DmaenR::_0,
                    1 => DmaenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaenR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct AcrenR {
            bits: u8,
        }
        impl AcrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct AcfgtR {
            bits: u8,
        }
        impl AcfgtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ACFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AcfeR {
            # [ doc = "Compare function disabled." ]
            _0,
            # [ doc = "Compare function enabled." ]
            _1,
        }
        impl AcfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AcfeR::_0 => 0,
                    AcfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AcfeR {
                match bits {
                    0 => AcfeR::_0,
                    1 => AcfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AcfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AcfeR::_1
            }
        }
        # [ doc = "Possible values of the field `ADTRG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdtrgR {
            # [ doc = "Software trigger selected." ]
            _0,
            # [ doc = "Hardware trigger selected." ]
            _1,
        }
        impl AdtrgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdtrgR::_0 => 0,
                    AdtrgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdtrgR {
                match bits {
                    0 => AdtrgR::_0,
                    1 => AdtrgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdtrgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdtrgR::_1
            }
        }
        # [ doc = "Possible values of the field `ADACT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdactR {
            # [ doc = "Conversion not in progress." ]
            _0,
            # [ doc = "Conversion in progress." ]
            _1,
        }
        impl AdactR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdactR::_0 => 0,
                    AdactR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdactR {
                match bits {
                    0 => AdactR::_0,
                    1 => AdactR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdactR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdactR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgprnumR {
            bits: u8,
        }
        impl TrgprnumR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRGSTLAT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgstlatR {
            # [ doc = "No trigger request has been latched" ]
            _0,
            # [ doc = "A trigger request has been latched" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TrgstlatR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgstlatR::_0 => 0,
                    TrgstlatR::_1 => 1,
                    TrgstlatR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgstlatR {
                match bits {
                    0 => TrgstlatR::_0,
                    1 => TrgstlatR::_1,
                    i => TrgstlatR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgstlatR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgstlatR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGSTERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgsterrR {
            # [ doc = "No error has occurred" ]
            _0,
            # [ doc = "An error has occurred" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TrgsterrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgsterrR::_0 => 0,
                    TrgsterrR::_1 => 1,
                    TrgsterrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgsterrR {
                match bits {
                    0 => TrgsterrR::_0,
                    1 => TrgsterrR::_1,
                    i => TrgsterrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgsterrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgsterrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `REFSEL`" ]
        pub enum RefselW {
            # [ doc = "Default voltage reference pin pair, that is, external pins VREFH and VREFL" ]
            _00,
            # [ doc = "Alternate reference voltage, that is, VALTH. This voltage may be additional external pin or internal source depending on the MCU configuration. See the chip configuration information for details specific to this MCU." ]
            _01,
        }
        impl RefselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RefselW::_00 => 0,
                    RefselW::_01 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RefselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RefselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RefselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Default voltage reference pin pair, that is, external pins VREFH and VREFL" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(RefselW::_00)
            }
            # [ doc = "Alternate reference voltage, that is, VALTH. This voltage may be additional external pin or internal source depending on the MCU configuration. See the chip configuration information for details specific to this MCU." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(RefselW::_01)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMAEN`" ]
        pub enum DmaenW {
            # [ doc = "DMA is disabled." ]
            _0,
            # [ doc = "DMA is enabled and will assert the ADC DMA request during an ADC conversion complete event , which is indicated when any SC1n[COCO] flag is asserted." ]
            _1,
        }
        impl DmaenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaenW::_0 => 0,
                    DmaenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaenW::_0)
            }
            # [ doc = "DMA is enabled and will assert the ADC DMA request during an ADC conversion complete event , which is indicated when any SC1n[COCO] flag is asserted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AcrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AcrenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AcfgtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AcfgtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ACFE`" ]
        pub enum AcfeW {
            # [ doc = "Compare function disabled." ]
            _0,
            # [ doc = "Compare function enabled." ]
            _1,
        }
        impl AcfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AcfeW::_0 => 0,
                    AcfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AcfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AcfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AcfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Compare function disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AcfeW::_0)
            }
            # [ doc = "Compare function enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AcfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADTRG`" ]
        pub enum AdtrgW {
            # [ doc = "Software trigger selected." ]
            _0,
            # [ doc = "Hardware trigger selected." ]
            _1,
        }
        impl AdtrgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdtrgW::_0 => 0,
                    AdtrgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdtrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdtrgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdtrgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software trigger selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AdtrgW::_0)
            }
            # [ doc = "Hardware trigger selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AdtrgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Voltage Reference Selection" ]
            # [ inline ( always ) ]
            pub fn refsel(&self) -> RefselR {
                RefselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&self) -> DmaenR {
                DmaenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Compare Function Range Enable" ]
            # [ inline ( always ) ]
            pub fn acren(&self) -> AcrenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AcrenR { bits }
            }
            # [ doc = "Bit 4 - Compare Function Greater Than Enable" ]
            # [ inline ( always ) ]
            pub fn acfgt(&self) -> AcfgtR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AcfgtR { bits }
            }
            # [ doc = "Bit 5 - Compare Function Enable" ]
            # [ inline ( always ) ]
            pub fn acfe(&self) -> AcfeR {
                AcfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Conversion Trigger Select" ]
            # [ inline ( always ) ]
            pub fn adtrg(&self) -> AdtrgR {
                AdtrgR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Conversion Active" ]
            # [ inline ( always ) ]
            pub fn adact(&self) -> AdactR {
                AdactR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 13:14 - Trigger Process Number" ]
            # [ inline ( always ) ]
            pub fn trgprnum(&self) -> TrgprnumR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgprnumR { bits }
            }
            # [ doc = "Bits 16:19 - Trigger Status" ]
            # [ inline ( always ) ]
            pub fn trgstlat(&self) -> TrgstlatR {
                TrgstlatR::_from({
                                     const MASK: u8 = 15;
                                     const OFFSET: u8 = 16;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 24:27 - Error in Multiplexed Trigger Request" ]
            # [ inline ( always ) ]
            pub fn trgsterr(&self) -> TrgsterrR {
                TrgsterrR::_from({
                                     const MASK: u8 = 15;
                                     const OFFSET: u8 = 24;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Voltage Reference Selection" ]
            # [ inline ( always ) ]
            pub fn refsel(&mut self) -> _RefselW {
                _RefselW { w: self }
            }
            # [ doc = "Bit 2 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&mut self) -> _DmaenW {
                _DmaenW { w: self }
            }
            # [ doc = "Bit 3 - Compare Function Range Enable" ]
            # [ inline ( always ) ]
            pub fn acren(&mut self) -> _AcrenW {
                _AcrenW { w: self }
            }
            # [ doc = "Bit 4 - Compare Function Greater Than Enable" ]
            # [ inline ( always ) ]
            pub fn acfgt(&mut self) -> _AcfgtW {
                _AcfgtW { w: self }
            }
            # [ doc = "Bit 5 - Compare Function Enable" ]
            # [ inline ( always ) ]
            pub fn acfe(&mut self) -> _AcfeW {
                _AcfeW { w: self }
            }
            # [ doc = "Bit 6 - Conversion Trigger Select" ]
            # [ inline ( always ) ]
            pub fn adtrg(&mut self) -> _AdtrgW {
                _AdtrgW { w: self }
            }
        }
    }
    # [ doc = "Status and Control Register 3" ]
    pub struct Sc3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status and Control Register 3" ]
    pub mod sc3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `AVGS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvgsR {
            # [ doc = "4 samples averaged." ]
            _00,
            # [ doc = "8 samples averaged." ]
            _01,
            # [ doc = "16 samples averaged." ]
            _10,
            # [ doc = "32 samples averaged." ]
            _11,
        }
        impl AvgsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvgsR::_00 => 0,
                    AvgsR::_01 => 1,
                    AvgsR::_10 => 2,
                    AvgsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvgsR {
                match bits {
                    0 => AvgsR::_00,
                    1 => AvgsR::_01,
                    2 => AvgsR::_10,
                    3 => AvgsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == AvgsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == AvgsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == AvgsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == AvgsR::_11
            }
        }
        # [ doc = "Possible values of the field `AVGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvgeR {
            # [ doc = "Hardware average function disabled." ]
            _0,
            # [ doc = "Hardware average function enabled." ]
            _1,
        }
        impl AvgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvgeR::_0 => 0,
                    AvgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvgeR {
                match bits {
                    0 => AvgeR::_0,
                    1 => AvgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AvgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AvgeR::_1
            }
        }
        # [ doc = "Possible values of the field `ADCO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdcoR {
            # [ doc = "One conversion will be performed (or one set of conversions, if AVGE is set) after a conversion is initiated." ]
            _0,
            # [ doc = "Continuous conversions will be performed (or continuous sets of conversions, if AVGE is set) after a conversion is initiated." ]
            _1,
        }
        impl AdcoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdcoR::_0 => 0,
                    AdcoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdcoR {
                match bits {
                    0 => AdcoR::_0,
                    1 => AdcoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdcoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdcoR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CalR {
            bits: u8,
        }
        impl CalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `AVGS`" ]
        pub enum AvgsW {
            # [ doc = "4 samples averaged." ]
            _00,
            # [ doc = "8 samples averaged." ]
            _01,
            # [ doc = "16 samples averaged." ]
            _10,
            # [ doc = "32 samples averaged." ]
            _11,
        }
        impl AvgsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvgsW::_00 => 0,
                    AvgsW::_01 => 1,
                    AvgsW::_10 => 2,
                    AvgsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvgsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvgsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvgsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "4 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(AvgsW::_00)
            }
            # [ doc = "8 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(AvgsW::_01)
            }
            # [ doc = "16 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(AvgsW::_10)
            }
            # [ doc = "32 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(AvgsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AVGE`" ]
        pub enum AvgeW {
            # [ doc = "Hardware average function disabled." ]
            _0,
            # [ doc = "Hardware average function enabled." ]
            _1,
        }
        impl AvgeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvgeW::_0 => 0,
                    AvgeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvgeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvgeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvgeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware average function disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AvgeW::_0)
            }
            # [ doc = "Hardware average function enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AvgeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADCO`" ]
        pub enum AdcoW {
            # [ doc = "One conversion will be performed (or one set of conversions, if AVGE is set) after a conversion is initiated." ]
            _0,
            # [ doc = "Continuous conversions will be performed (or continuous sets of conversions, if AVGE is set) after a conversion is initiated." ]
            _1,
        }
        impl AdcoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdcoW::_0 => 0,
                    AdcoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdcoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdcoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "One conversion will be performed (or one set of conversions, if AVGE is set) after a conversion is initiated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AdcoW::_0)
            }
            # [ doc = "Continuous conversions will be performed (or continuous sets of conversions, if AVGE is set) after a conversion is initiated." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AdcoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Hardware Average Select" ]
            # [ inline ( always ) ]
            pub fn avgs(&self) -> AvgsR {
                AvgsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Hardware Average Enable" ]
            # [ inline ( always ) ]
            pub fn avge(&self) -> AvgeR {
                AvgeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Continuous Conversion Enable" ]
            # [ inline ( always ) ]
            pub fn adco(&self) -> AdcoR {
                AdcoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Calibration" ]
            # [ inline ( always ) ]
            pub fn cal(&self) -> CalR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Hardware Average Select" ]
            # [ inline ( always ) ]
            pub fn avgs(&mut self) -> _AvgsW {
                _AvgsW { w: self }
            }
            # [ doc = "Bit 2 - Hardware Average Enable" ]
            # [ inline ( always ) ]
            pub fn avge(&mut self) -> _AvgeW {
                _AvgeW { w: self }
            }
            # [ doc = "Bit 3 - Continuous Conversion Enable" ]
            # [ inline ( always ) ]
            pub fn adco(&mut self) -> _AdcoW {
                _AdcoW { w: self }
            }
            # [ doc = "Bit 7 - Calibration" ]
            # [ inline ( always ) ]
            pub fn cal(&mut self) -> _CalW {
                _CalW { w: self }
            }
        }
    }
    # [ doc = "BASE Offset Register" ]
    pub struct BaseOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "BASE Offset Register" ]
    pub mod base_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::BaseOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BaOfsR {
            bits: u8,
        }
        impl BaOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BaOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BaOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Base Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ba_ofs(&self) -> BaOfsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BaOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 64 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Base Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ba_ofs(&mut self) -> _BaOfsW {
                _BaOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Offset Correction Register" ]
    pub struct Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Offset Correction Register" ]
    pub mod ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OfsR {
            bits: u16,
        }
        impl OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ofs(&self) -> OfsR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ofs(&mut self) -> _OfsW {
                _OfsW { w: self }
            }
        }
    }
    # [ doc = "USER Offset Correction Register" ]
    pub struct UsrOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "USER Offset Correction Register" ]
    pub mod usr_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::UsrOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct UsrOfsR {
            bits: u8,
        }
        impl UsrOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _UsrOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UsrOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - USER Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn usr_ofs(&self) -> UsrOfsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                UsrOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - USER Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn usr_ofs(&mut self) -> _UsrOfsW {
                _UsrOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC X Offset Correction Register" ]
    pub struct Xofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC X Offset Correction Register" ]
    pub mod xofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Xofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct XofsR {
            bits: u8,
        }
        impl XofsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _XofsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XofsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - X offset error correction value" ]
            # [ inline ( always ) ]
            pub fn xofs(&self) -> XofsR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XofsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 48 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - X offset error correction value" ]
            # [ inline ( always ) ]
            pub fn xofs(&mut self) -> _XofsW {
                _XofsW { w: self }
            }
        }
    }
    # [ doc = "ADC Y Offset Correction Register" ]
    pub struct Yofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Y Offset Correction Register" ]
    pub mod yofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Yofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct YofsR {
            bits: u8,
        }
        impl YofsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _YofsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _YofsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Y offset error correction value" ]
            # [ inline ( always ) ]
            pub fn yofs(&self) -> YofsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                YofsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 55 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Y offset error correction value" ]
            # [ inline ( always ) ]
            pub fn yofs(&mut self) -> _YofsW {
                _YofsW { w: self }
            }
        }
    }
    # [ doc = "ADC Gain Register" ]
    pub struct G {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Gain Register" ]
    pub mod g {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::G {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GR {
            bits: u16,
        }
        impl GR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 2047;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:10 - Gain error adjustment factor for the overall conversion" ]
            # [ inline ( always ) ]
            pub fn g(&self) -> GR {
                let bits = {
                    const MASK: u16 = 2047;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                GR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 752 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:10 - Gain error adjustment factor for the overall conversion" ]
            # [ inline ( always ) ]
            pub fn g(&mut self) -> _GW {
                _GW { w: self }
            }
        }
    }
    # [ doc = "ADC User Gain Register" ]
    pub struct Ug {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC User Gain Register" ]
    pub mod ug {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ug {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct UgR {
            bits: u16,
        }
        impl UgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _UgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - User gain error correction value" ]
            # [ inline ( always ) ]
            pub fn ug(&self) -> UgR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                UgR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - User gain error correction value" ]
            # [ inline ( always ) ]
            pub fn ug(&mut self) -> _UgW {
                _UgW { w: self }
            }
        }
    }
    # [ doc = "ADC General Calibration Value Register S" ]
    pub struct Clps {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC General Calibration Value Register S" ]
    pub mod clps {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clps {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpsR {
            bits: u8,
        }
        impl ClpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clps(&self) -> ClpsR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClpsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 46 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clps(&mut self) -> _ClpsW {
                _ClpsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 3" ]
    pub struct Clp3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 3" ]
    pub mod clp3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp3R {
            bits: u16,
        }
        impl Clp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp3(&self) -> Clp3R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp3R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 384 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp3(&mut self) -> _Clp3W {
                _Clp3W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 2" ]
    pub struct Clp2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 2" ]
    pub mod clp2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp2R {
            bits: u16,
        }
        impl Clp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp2(&self) -> Clp2R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 184 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp2(&mut self) -> _Clp2W {
                _Clp2W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 1" ]
    pub struct Clp1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 1" ]
    pub mod clp1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp1R {
            bits: u16,
        }
        impl Clp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp1(&self) -> Clp1R {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 92 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp1(&mut self) -> _Clp1W {
                _Clp1W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 0" ]
    pub struct Clp0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 0" ]
    pub mod clp0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp0R {
            bits: u8,
        }
        impl Clp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp0(&self) -> Clp0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 46 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp0(&mut self) -> _Clp0W {
                _Clp0W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register X" ]
    pub struct Clpx {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register X" ]
    pub mod clpx {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clpx {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpxR {
            bits: u8,
        }
        impl ClpxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpxW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clpx(&self) -> ClpxR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClpxR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clpx(&mut self) -> _ClpxW {
                _ClpxW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 9" ]
    pub struct Clp9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 9" ]
    pub mod clp9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp9R {
            bits: u8,
        }
        impl Clp9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp9(&self) -> Clp9R {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp9R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp9(&mut self) -> _Clp9W {
                _Clp9W { w: self }
            }
        }
    }
    # [ doc = "ADC General Calibration Offset Value Register S" ]
    pub struct ClpsOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC General Calibration Offset Value Register S" ]
    pub mod clps_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::ClpsOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpsOfsR {
            bits: u8,
        }
        impl ClpsOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpsOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpsOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLPS Offset" ]
            # [ inline ( always ) ]
            pub fn clps_ofs(&self) -> ClpsOfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClpsOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLPS Offset" ]
            # [ inline ( always ) ]
            pub fn clps_ofs(&mut self) -> _ClpsOfsW {
                _ClpsOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 3" ]
    pub struct Clp3Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 3" ]
    pub mod clp3_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp3Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp3OfsR {
            bits: u8,
        }
        impl Clp3OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp3OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp3OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP3 Offset" ]
            # [ inline ( always ) ]
            pub fn clp3_ofs(&self) -> Clp3OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp3OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP3 Offset" ]
            # [ inline ( always ) ]
            pub fn clp3_ofs(&mut self) -> _Clp3OfsW {
                _Clp3OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 2" ]
    pub struct Clp2Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 2" ]
    pub mod clp2_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp2Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp2OfsR {
            bits: u8,
        }
        impl Clp2OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp2OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp2OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP2 Offset" ]
            # [ inline ( always ) ]
            pub fn clp2_ofs(&self) -> Clp2OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp2OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP2 Offset" ]
            # [ inline ( always ) ]
            pub fn clp2_ofs(&mut self) -> _Clp2OfsW {
                _Clp2OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 1" ]
    pub struct Clp1Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 1" ]
    pub mod clp1_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp1Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp1OfsR {
            bits: u8,
        }
        impl Clp1OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp1OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp1OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP1 Offset" ]
            # [ inline ( always ) ]
            pub fn clp1_ofs(&self) -> Clp1OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp1OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP1 Offset" ]
            # [ inline ( always ) ]
            pub fn clp1_ofs(&mut self) -> _Clp1OfsW {
                _Clp1OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 0" ]
    pub struct Clp0Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 0" ]
    pub mod clp0_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp0Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp0OfsR {
            bits: u8,
        }
        impl Clp0OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp0OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp0OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP0 Offset" ]
            # [ inline ( always ) ]
            pub fn clp0_ofs(&self) -> Clp0OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp0OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP0 Offset" ]
            # [ inline ( always ) ]
            pub fn clp0_ofs(&mut self) -> _Clp0OfsW {
                _Clp0OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register X" ]
    pub struct ClpxOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register X" ]
    pub mod clpx_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::ClpxOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpxOfsR {
            bits: u16,
        }
        impl ClpxOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpxOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpxOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - CLPX Offset" ]
            # [ inline ( always ) ]
            pub fn clpx_ofs(&self) -> ClpxOfsR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ClpxOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1088 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - CLPX Offset" ]
            # [ inline ( always ) ]
            pub fn clpx_ofs(&mut self) -> _ClpxOfsW {
                _ClpxOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 9" ]
    pub struct Clp9Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 9" ]
    pub mod clp9_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp9Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp9OfsR {
            bits: u16,
        }
        impl Clp9OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp9OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp9OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - CLP9 Offset" ]
            # [ inline ( always ) ]
            pub fn clp9_ofs(&self) -> Clp9OfsR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp9OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 576 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - CLP9 Offset" ]
            # [ inline ( always ) ]
            pub fn clp9_ofs(&mut self) -> _Clp9OfsW {
                _Clp9OfsW { w: self }
            }
        }
    }
}
# [ doc = "Analog-to-Digital Converter" ]
pub struct Adc0 {
    register_block: adc0::RegisterBlock,
}
impl Deref for Adc0 {
    type Target = adc0::RegisterBlock;
    fn deref(&self) -> &adc0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Analog-to-Digital Converter" ]
pub const ADC1: Peripheral<Adc1> = unsafe { Peripheral::new(1073901568) };
# [ doc = "Analog-to-Digital Converter" ]
pub mod adc1 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - ADC Status and Control Register 1" ]
        pub sc1a: Sc1,
        # [ doc = "0x04 - ADC Status and Control Register 1" ]
        pub sc1b: Sc1,
        # [ doc = "0x08 - ADC Status and Control Register 1" ]
        pub sc1c: Sc1,
        # [ doc = "0x0c - ADC Status and Control Register 1" ]
        pub sc1d: Sc1,
        # [ doc = "0x10 - ADC Status and Control Register 1" ]
        pub sc1e: Sc1,
        # [ doc = "0x14 - ADC Status and Control Register 1" ]
        pub sc1f: Sc1,
        # [ doc = "0x18 - ADC Status and Control Register 1" ]
        pub sc1g: Sc1,
        # [ doc = "0x1c - ADC Status and Control Register 1" ]
        pub sc1h: Sc1,
        # [ doc = "0x20 - ADC Status and Control Register 1" ]
        pub sc1i: Sc1,
        # [ doc = "0x24 - ADC Status and Control Register 1" ]
        pub sc1j: Sc1,
        # [ doc = "0x28 - ADC Status and Control Register 1" ]
        pub sc1k: Sc1,
        # [ doc = "0x2c - ADC Status and Control Register 1" ]
        pub sc1l: Sc1,
        # [ doc = "0x30 - ADC Status and Control Register 1" ]
        pub sc1m: Sc1,
        # [ doc = "0x34 - ADC Status and Control Register 1" ]
        pub sc1n: Sc1,
        # [ doc = "0x38 - ADC Status and Control Register 1" ]
        pub sc1o: Sc1,
        # [ doc = "0x3c - ADC Status and Control Register 1" ]
        pub sc1p: Sc1,
        # [ doc = "0x40 - ADC Configuration Register 1" ]
        pub cfg1: Cfg1,
        # [ doc = "0x44 - ADC Configuration Register 2" ]
        pub cfg2: Cfg2,
        # [ doc = "0x48 - ADC Data Result Registers" ]
        pub ra: R,
        # [ doc = "0x4c - ADC Data Result Registers" ]
        pub rb: R,
        # [ doc = "0x50 - ADC Data Result Registers" ]
        pub rc: R,
        # [ doc = "0x54 - ADC Data Result Registers" ]
        pub rd: R,
        # [ doc = "0x58 - ADC Data Result Registers" ]
        pub re: R,
        # [ doc = "0x5c - ADC Data Result Registers" ]
        pub rf: R,
        # [ doc = "0x60 - ADC Data Result Registers" ]
        pub rg: R,
        # [ doc = "0x64 - ADC Data Result Registers" ]
        pub rh: R,
        # [ doc = "0x68 - ADC Data Result Registers" ]
        pub ri: R,
        # [ doc = "0x6c - ADC Data Result Registers" ]
        pub rj: R,
        # [ doc = "0x70 - ADC Data Result Registers" ]
        pub rk: R,
        # [ doc = "0x74 - ADC Data Result Registers" ]
        pub rl: R,
        # [ doc = "0x78 - ADC Data Result Registers" ]
        pub rm: R,
        # [ doc = "0x7c - ADC Data Result Registers" ]
        pub rn: R,
        # [ doc = "0x80 - ADC Data Result Registers" ]
        pub ro: R,
        # [ doc = "0x84 - ADC Data Result Registers" ]
        pub rp: R,
        # [ doc = "0x88 - Compare Value Registers" ]
        pub cv1: Cv,
        # [ doc = "0x8c - Compare Value Registers" ]
        pub cv2: Cv,
        # [ doc = "0x90 - Status and Control Register 2" ]
        pub sc2: Sc2,
        # [ doc = "0x94 - Status and Control Register 3" ]
        pub sc3: Sc3,
        # [ doc = "0x98 - BASE Offset Register" ]
        pub base_ofs: BaseOfs,
        # [ doc = "0x9c - ADC Offset Correction Register" ]
        pub ofs: Ofs,
        # [ doc = "0xa0 - USER Offset Correction Register" ]
        pub usr_ofs: UsrOfs,
        # [ doc = "0xa4 - ADC X Offset Correction Register" ]
        pub xofs: Xofs,
        # [ doc = "0xa8 - ADC Y Offset Correction Register" ]
        pub yofs: Yofs,
        # [ doc = "0xac - ADC Gain Register" ]
        pub g: G,
        # [ doc = "0xb0 - ADC User Gain Register" ]
        pub ug: Ug,
        # [ doc = "0xb4 - ADC General Calibration Value Register S" ]
        pub clps: Clps,
        # [ doc = "0xb8 - ADC Plus-Side General Calibration Value Register 3" ]
        pub clp3: Clp3,
        # [ doc = "0xbc - ADC Plus-Side General Calibration Value Register 2" ]
        pub clp2: Clp2,
        # [ doc = "0xc0 - ADC Plus-Side General Calibration Value Register 1" ]
        pub clp1: Clp1,
        # [ doc = "0xc4 - ADC Plus-Side General Calibration Value Register 0" ]
        pub clp0: Clp0,
        # [ doc = "0xc8 - ADC Plus-Side General Calibration Value Register X" ]
        pub clpx: Clpx,
        # [ doc = "0xcc - ADC Plus-Side General Calibration Value Register 9" ]
        pub clp9: Clp9,
        # [ doc = "0xd0 - ADC General Calibration Offset Value Register S" ]
        pub clps_ofs: ClpsOfs,
        # [ doc = "0xd4 - ADC Plus-Side General Calibration Offset Value Register 3" ]
        pub clp3_ofs: Clp3Ofs,
        # [ doc = "0xd8 - ADC Plus-Side General Calibration Offset Value Register 2" ]
        pub clp2_ofs: Clp2Ofs,
        # [ doc = "0xdc - ADC Plus-Side General Calibration Offset Value Register 1" ]
        pub clp1_ofs: Clp1Ofs,
        # [ doc = "0xe0 - ADC Plus-Side General Calibration Offset Value Register 0" ]
        pub clp0_ofs: Clp0Ofs,
        # [ doc = "0xe4 - ADC Plus-Side General Calibration Offset Value Register X" ]
        pub clpx_ofs: ClpxOfs,
        # [ doc = "0xe8 - ADC Plus-Side General Calibration Offset Value Register 9" ]
        pub clp9_ofs: Clp9Ofs,
    }
    # [ doc = "ADC Status and Control Register 1" ]
    pub struct Sc1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Status and Control Register 1" ]
    pub mod sc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdchR {
            # [ doc = "Exernal channel 0 is selected as input." ]
            _00000,
            # [ doc = "Exernal channel 1 is selected as input." ]
            _00001,
            # [ doc = "Exernal channel 2 is selected as input." ]
            _00010,
            # [ doc = "Exernal channel 3 is selected as input." ]
            _00011,
            # [ doc = "Exernal channel 4 is selected as input." ]
            _00100,
            # [ doc = "Exernal channel 5 is selected as input." ]
            _00101,
            # [ doc = "Exernal channel 6 is selected as input." ]
            _00110,
            # [ doc = "Exernal channel 7 is selected as input." ]
            _00111,
            # [ doc = "Exernal channel 8 is selected as input." ]
            _01000,
            # [ doc = "Exernal channel 9 is selected as input." ]
            _01001,
            # [ doc = "Exernal channel 10 is selected as input." ]
            _01010,
            # [ doc = "Exernal channel 11 is selected as input." ]
            _01011,
            # [ doc = "Exernal channel 12 is selected as input." ]
            _01100,
            # [ doc = "Exernal channel 13 is selected as input." ]
            _01101,
            # [ doc = "Exernal channel 14 is selected as input." ]
            _01110,
            # [ doc = "Exernal channel 15 is selected as input." ]
            _01111,
            # [ doc = "Exernal channel 18 is selected as input." ]
            _10010,
            # [ doc = "Exernal channel 19 is selected as input." ]
            _10011,
            # [ doc = "Internal channel 0 is selected as input." ]
            _10101,
            # [ doc = "Internal channel 1 is selected as input." ]
            _10110,
            # [ doc = "Internal channel 2 is selected as input." ]
            _10111,
            # [ doc = "Temp Sensor" ]
            _11010,
            # [ doc = "Band Gap" ]
            _11011,
            # [ doc = "Internal channel 3 is selected as input." ]
            _11100,
            # [ doc = "VREFSH is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11101,
            # [ doc = "VREFSL is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11110,
            # [ doc = "Module is disabled" ]
            _11111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl AdchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdchR::_00000 => 0,
                    AdchR::_00001 => 1,
                    AdchR::_00010 => 2,
                    AdchR::_00011 => 3,
                    AdchR::_00100 => 4,
                    AdchR::_00101 => 5,
                    AdchR::_00110 => 6,
                    AdchR::_00111 => 7,
                    AdchR::_01000 => 8,
                    AdchR::_01001 => 9,
                    AdchR::_01010 => 10,
                    AdchR::_01011 => 11,
                    AdchR::_01100 => 12,
                    AdchR::_01101 => 13,
                    AdchR::_01110 => 14,
                    AdchR::_01111 => 15,
                    AdchR::_10010 => 18,
                    AdchR::_10011 => 19,
                    AdchR::_10101 => 21,
                    AdchR::_10110 => 22,
                    AdchR::_10111 => 23,
                    AdchR::_11010 => 26,
                    AdchR::_11011 => 27,
                    AdchR::_11100 => 28,
                    AdchR::_11101 => 29,
                    AdchR::_11110 => 30,
                    AdchR::_11111 => 31,
                    AdchR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdchR {
                match bits {
                    0 => AdchR::_00000,
                    1 => AdchR::_00001,
                    2 => AdchR::_00010,
                    3 => AdchR::_00011,
                    4 => AdchR::_00100,
                    5 => AdchR::_00101,
                    6 => AdchR::_00110,
                    7 => AdchR::_00111,
                    8 => AdchR::_01000,
                    9 => AdchR::_01001,
                    10 => AdchR::_01010,
                    11 => AdchR::_01011,
                    12 => AdchR::_01100,
                    13 => AdchR::_01101,
                    14 => AdchR::_01110,
                    15 => AdchR::_01111,
                    18 => AdchR::_10010,
                    19 => AdchR::_10011,
                    21 => AdchR::_10101,
                    22 => AdchR::_10110,
                    23 => AdchR::_10111,
                    26 => AdchR::_11010,
                    27 => AdchR::_11011,
                    28 => AdchR::_11100,
                    29 => AdchR::_11101,
                    30 => AdchR::_11110,
                    31 => AdchR::_11111,
                    i => AdchR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000`" ]
            # [ inline ( always ) ]
            pub fn is_00000(&self) -> bool {
                *self == AdchR::_00000
            }
            # [ doc = "Checks if the value of the field is `_00001`" ]
            # [ inline ( always ) ]
            pub fn is_00001(&self) -> bool {
                *self == AdchR::_00001
            }
            # [ doc = "Checks if the value of the field is `_00010`" ]
            # [ inline ( always ) ]
            pub fn is_00010(&self) -> bool {
                *self == AdchR::_00010
            }
            # [ doc = "Checks if the value of the field is `_00011`" ]
            # [ inline ( always ) ]
            pub fn is_00011(&self) -> bool {
                *self == AdchR::_00011
            }
            # [ doc = "Checks if the value of the field is `_00100`" ]
            # [ inline ( always ) ]
            pub fn is_00100(&self) -> bool {
                *self == AdchR::_00100
            }
            # [ doc = "Checks if the value of the field is `_00101`" ]
            # [ inline ( always ) ]
            pub fn is_00101(&self) -> bool {
                *self == AdchR::_00101
            }
            # [ doc = "Checks if the value of the field is `_00110`" ]
            # [ inline ( always ) ]
            pub fn is_00110(&self) -> bool {
                *self == AdchR::_00110
            }
            # [ doc = "Checks if the value of the field is `_00111`" ]
            # [ inline ( always ) ]
            pub fn is_00111(&self) -> bool {
                *self == AdchR::_00111
            }
            # [ doc = "Checks if the value of the field is `_01000`" ]
            # [ inline ( always ) ]
            pub fn is_01000(&self) -> bool {
                *self == AdchR::_01000
            }
            # [ doc = "Checks if the value of the field is `_01001`" ]
            # [ inline ( always ) ]
            pub fn is_01001(&self) -> bool {
                *self == AdchR::_01001
            }
            # [ doc = "Checks if the value of the field is `_01010`" ]
            # [ inline ( always ) ]
            pub fn is_01010(&self) -> bool {
                *self == AdchR::_01010
            }
            # [ doc = "Checks if the value of the field is `_01011`" ]
            # [ inline ( always ) ]
            pub fn is_01011(&self) -> bool {
                *self == AdchR::_01011
            }
            # [ doc = "Checks if the value of the field is `_01100`" ]
            # [ inline ( always ) ]
            pub fn is_01100(&self) -> bool {
                *self == AdchR::_01100
            }
            # [ doc = "Checks if the value of the field is `_01101`" ]
            # [ inline ( always ) ]
            pub fn is_01101(&self) -> bool {
                *self == AdchR::_01101
            }
            # [ doc = "Checks if the value of the field is `_01110`" ]
            # [ inline ( always ) ]
            pub fn is_01110(&self) -> bool {
                *self == AdchR::_01110
            }
            # [ doc = "Checks if the value of the field is `_01111`" ]
            # [ inline ( always ) ]
            pub fn is_01111(&self) -> bool {
                *self == AdchR::_01111
            }
            # [ doc = "Checks if the value of the field is `_10010`" ]
            # [ inline ( always ) ]
            pub fn is_10010(&self) -> bool {
                *self == AdchR::_10010
            }
            # [ doc = "Checks if the value of the field is `_10011`" ]
            # [ inline ( always ) ]
            pub fn is_10011(&self) -> bool {
                *self == AdchR::_10011
            }
            # [ doc = "Checks if the value of the field is `_10101`" ]
            # [ inline ( always ) ]
            pub fn is_10101(&self) -> bool {
                *self == AdchR::_10101
            }
            # [ doc = "Checks if the value of the field is `_10110`" ]
            # [ inline ( always ) ]
            pub fn is_10110(&self) -> bool {
                *self == AdchR::_10110
            }
            # [ doc = "Checks if the value of the field is `_10111`" ]
            # [ inline ( always ) ]
            pub fn is_10111(&self) -> bool {
                *self == AdchR::_10111
            }
            # [ doc = "Checks if the value of the field is `_11010`" ]
            # [ inline ( always ) ]
            pub fn is_11010(&self) -> bool {
                *self == AdchR::_11010
            }
            # [ doc = "Checks if the value of the field is `_11011`" ]
            # [ inline ( always ) ]
            pub fn is_11011(&self) -> bool {
                *self == AdchR::_11011
            }
            # [ doc = "Checks if the value of the field is `_11100`" ]
            # [ inline ( always ) ]
            pub fn is_11100(&self) -> bool {
                *self == AdchR::_11100
            }
            # [ doc = "Checks if the value of the field is `_11101`" ]
            # [ inline ( always ) ]
            pub fn is_11101(&self) -> bool {
                *self == AdchR::_11101
            }
            # [ doc = "Checks if the value of the field is `_11110`" ]
            # [ inline ( always ) ]
            pub fn is_11110(&self) -> bool {
                *self == AdchR::_11110
            }
            # [ doc = "Checks if the value of the field is `_11111`" ]
            # [ inline ( always ) ]
            pub fn is_11111(&self) -> bool {
                *self == AdchR::_11111
            }
        }
        # [ doc = "Possible values of the field `AIEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AienR {
            # [ doc = "Conversion complete interrupt is disabled." ]
            _0,
            # [ doc = "Conversion complete interrupt is enabled." ]
            _1,
        }
        impl AienR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AienR::_0 => 0,
                    AienR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AienR {
                match bits {
                    0 => AienR::_0,
                    1 => AienR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AienR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AienR::_1
            }
        }
        # [ doc = "Possible values of the field `COCO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CocoR {
            # [ doc = "Conversion is not completed." ]
            _0,
            # [ doc = "Conversion is completed." ]
            _1,
        }
        impl CocoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CocoR::_0 => 0,
                    CocoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CocoR {
                match bits {
                    0 => CocoR::_0,
                    1 => CocoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CocoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CocoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ADCH`" ]
        pub enum AdchW {
            # [ doc = "Exernal channel 0 is selected as input." ]
            _00000,
            # [ doc = "Exernal channel 1 is selected as input." ]
            _00001,
            # [ doc = "Exernal channel 2 is selected as input." ]
            _00010,
            # [ doc = "Exernal channel 3 is selected as input." ]
            _00011,
            # [ doc = "Exernal channel 4 is selected as input." ]
            _00100,
            # [ doc = "Exernal channel 5 is selected as input." ]
            _00101,
            # [ doc = "Exernal channel 6 is selected as input." ]
            _00110,
            # [ doc = "Exernal channel 7 is selected as input." ]
            _00111,
            # [ doc = "Exernal channel 8 is selected as input." ]
            _01000,
            # [ doc = "Exernal channel 9 is selected as input." ]
            _01001,
            # [ doc = "Exernal channel 10 is selected as input." ]
            _01010,
            # [ doc = "Exernal channel 11 is selected as input." ]
            _01011,
            # [ doc = "Exernal channel 12 is selected as input." ]
            _01100,
            # [ doc = "Exernal channel 13 is selected as input." ]
            _01101,
            # [ doc = "Exernal channel 14 is selected as input." ]
            _01110,
            # [ doc = "Exernal channel 15 is selected as input." ]
            _01111,
            # [ doc = "Exernal channel 18 is selected as input." ]
            _10010,
            # [ doc = "Exernal channel 19 is selected as input." ]
            _10011,
            # [ doc = "Internal channel 0 is selected as input." ]
            _10101,
            # [ doc = "Internal channel 1 is selected as input." ]
            _10110,
            # [ doc = "Internal channel 2 is selected as input." ]
            _10111,
            # [ doc = "Temp Sensor" ]
            _11010,
            # [ doc = "Band Gap" ]
            _11011,
            # [ doc = "Internal channel 3 is selected as input." ]
            _11100,
            # [ doc = "VREFSH is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11101,
            # [ doc = "VREFSL is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            _11110,
            # [ doc = "Module is disabled" ]
            _11111,
        }
        impl AdchW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdchW::_00000 => 0,
                    AdchW::_00001 => 1,
                    AdchW::_00010 => 2,
                    AdchW::_00011 => 3,
                    AdchW::_00100 => 4,
                    AdchW::_00101 => 5,
                    AdchW::_00110 => 6,
                    AdchW::_00111 => 7,
                    AdchW::_01000 => 8,
                    AdchW::_01001 => 9,
                    AdchW::_01010 => 10,
                    AdchW::_01011 => 11,
                    AdchW::_01100 => 12,
                    AdchW::_01101 => 13,
                    AdchW::_01110 => 14,
                    AdchW::_01111 => 15,
                    AdchW::_10010 => 18,
                    AdchW::_10011 => 19,
                    AdchW::_10101 => 21,
                    AdchW::_10110 => 22,
                    AdchW::_10111 => 23,
                    AdchW::_11010 => 26,
                    AdchW::_11011 => 27,
                    AdchW::_11100 => 28,
                    AdchW::_11101 => 29,
                    AdchW::_11110 => 30,
                    AdchW::_11111 => 31,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdchW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdchW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Exernal channel 0 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00000(self) -> &'a mut W {
                self.variant(AdchW::_00000)
            }
            # [ doc = "Exernal channel 1 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00001(self) -> &'a mut W {
                self.variant(AdchW::_00001)
            }
            # [ doc = "Exernal channel 2 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00010(self) -> &'a mut W {
                self.variant(AdchW::_00010)
            }
            # [ doc = "Exernal channel 3 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00011(self) -> &'a mut W {
                self.variant(AdchW::_00011)
            }
            # [ doc = "Exernal channel 4 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00100(self) -> &'a mut W {
                self.variant(AdchW::_00100)
            }
            # [ doc = "Exernal channel 5 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00101(self) -> &'a mut W {
                self.variant(AdchW::_00101)
            }
            # [ doc = "Exernal channel 6 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00110(self) -> &'a mut W {
                self.variant(AdchW::_00110)
            }
            # [ doc = "Exernal channel 7 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _00111(self) -> &'a mut W {
                self.variant(AdchW::_00111)
            }
            # [ doc = "Exernal channel 8 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01000(self) -> &'a mut W {
                self.variant(AdchW::_01000)
            }
            # [ doc = "Exernal channel 9 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01001(self) -> &'a mut W {
                self.variant(AdchW::_01001)
            }
            # [ doc = "Exernal channel 10 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01010(self) -> &'a mut W {
                self.variant(AdchW::_01010)
            }
            # [ doc = "Exernal channel 11 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01011(self) -> &'a mut W {
                self.variant(AdchW::_01011)
            }
            # [ doc = "Exernal channel 12 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01100(self) -> &'a mut W {
                self.variant(AdchW::_01100)
            }
            # [ doc = "Exernal channel 13 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01101(self) -> &'a mut W {
                self.variant(AdchW::_01101)
            }
            # [ doc = "Exernal channel 14 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01110(self) -> &'a mut W {
                self.variant(AdchW::_01110)
            }
            # [ doc = "Exernal channel 15 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _01111(self) -> &'a mut W {
                self.variant(AdchW::_01111)
            }
            # [ doc = "Exernal channel 18 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10010(self) -> &'a mut W {
                self.variant(AdchW::_10010)
            }
            # [ doc = "Exernal channel 19 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10011(self) -> &'a mut W {
                self.variant(AdchW::_10011)
            }
            # [ doc = "Internal channel 0 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10101(self) -> &'a mut W {
                self.variant(AdchW::_10101)
            }
            # [ doc = "Internal channel 1 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10110(self) -> &'a mut W {
                self.variant(AdchW::_10110)
            }
            # [ doc = "Internal channel 2 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _10111(self) -> &'a mut W {
                self.variant(AdchW::_10111)
            }
            # [ doc = "Temp Sensor" ]
            # [ inline ( always ) ]
            pub fn _11010(self) -> &'a mut W {
                self.variant(AdchW::_11010)
            }
            # [ doc = "Band Gap" ]
            # [ inline ( always ) ]
            pub fn _11011(self) -> &'a mut W {
                self.variant(AdchW::_11011)
            }
            # [ doc = "Internal channel 3 is selected as input." ]
            # [ inline ( always ) ]
            pub fn _11100(self) -> &'a mut W {
                self.variant(AdchW::_11100)
            }
            # [ doc = "VREFSH is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            # [ inline ( always ) ]
            pub fn _11101(self) -> &'a mut W {
                self.variant(AdchW::_11101)
            }
            # [ doc = "VREFSL is selected as input. Voltage reference selected is determined by SC2[REFSEL]." ]
            # [ inline ( always ) ]
            pub fn _11110(self) -> &'a mut W {
                self.variant(AdchW::_11110)
            }
            # [ doc = "Module is disabled" ]
            # [ inline ( always ) ]
            pub fn _11111(self) -> &'a mut W {
                self.variant(AdchW::_11111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AIEN`" ]
        pub enum AienW {
            # [ doc = "Conversion complete interrupt is disabled." ]
            _0,
            # [ doc = "Conversion complete interrupt is enabled." ]
            _1,
        }
        impl AienW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AienW::_0 => 0,
                    AienW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AienW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AienW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AienW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Conversion complete interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AienW::_0)
            }
            # [ doc = "Conversion complete interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AienW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Input channel select" ]
            # [ inline ( always ) ]
            pub fn adch(&self) -> AdchR {
                AdchR::_from({
                                 const MASK: u8 = 31;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn aien(&self) -> AienR {
                AienR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Conversion Complete Flag" ]
            # [ inline ( always ) ]
            pub fn coco(&self) -> CocoR {
                CocoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 31 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Input channel select" ]
            # [ inline ( always ) ]
            pub fn adch(&mut self) -> _AdchW {
                _AdchW { w: self }
            }
            # [ doc = "Bit 6 - Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn aien(&mut self) -> _AienW {
                _AienW { w: self }
            }
        }
    }
    # [ doc = "ADC Configuration Register 1" ]
    pub struct Cfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Configuration Register 1" ]
    pub mod cfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfg1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADICLK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdiclkR {
            # [ doc = "Alternate clock 1 (ADC_ALTCLK1)" ]
            _00,
            # [ doc = "Alternate clock 2 (ADC_ALTCLK2)" ]
            _01,
            # [ doc = "Alternate clock 3 (ADC_ALTCLK3)" ]
            _10,
            # [ doc = "Alternate clock 4 (ADC_ALTCLK4)" ]
            _11,
        }
        impl AdiclkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdiclkR::_00 => 0,
                    AdiclkR::_01 => 1,
                    AdiclkR::_10 => 2,
                    AdiclkR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdiclkR {
                match bits {
                    0 => AdiclkR::_00,
                    1 => AdiclkR::_01,
                    2 => AdiclkR::_10,
                    3 => AdiclkR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == AdiclkR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == AdiclkR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == AdiclkR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == AdiclkR::_11
            }
        }
        # [ doc = "Possible values of the field `MODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ModeR {
            # [ doc = "8-bit conversion." ]
            _00,
            # [ doc = "12-bit conversion." ]
            _01,
            # [ doc = "10-bit conversion." ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ModeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ModeR::_00 => 0,
                    ModeR::_01 => 1,
                    ModeR::_10 => 2,
                    ModeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ModeR {
                match bits {
                    0 => ModeR::_00,
                    1 => ModeR::_01,
                    2 => ModeR::_10,
                    i => ModeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ModeR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ModeR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ModeR::_10
            }
        }
        # [ doc = "Possible values of the field `ADIV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdivR {
            # [ doc = "The divide ratio is 1 and the clock rate is input clock." ]
            _00,
            # [ doc = "The divide ratio is 2 and the clock rate is (input clock)/2." ]
            _01,
            # [ doc = "The divide ratio is 4 and the clock rate is (input clock)/4." ]
            _10,
            # [ doc = "The divide ratio is 8 and the clock rate is (input clock)/8." ]
            _11,
        }
        impl AdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdivR::_00 => 0,
                    AdivR::_01 => 1,
                    AdivR::_10 => 2,
                    AdivR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdivR {
                match bits {
                    0 => AdivR::_00,
                    1 => AdivR::_01,
                    2 => AdivR::_10,
                    3 => AdivR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == AdivR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == AdivR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == AdivR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == AdivR::_11
            }
        }
        # [ doc = "Values that can be written to the field `ADICLK`" ]
        pub enum AdiclkW {
            # [ doc = "Alternate clock 1 (ADC_ALTCLK1)" ]
            _00,
            # [ doc = "Alternate clock 2 (ADC_ALTCLK2)" ]
            _01,
            # [ doc = "Alternate clock 3 (ADC_ALTCLK3)" ]
            _10,
            # [ doc = "Alternate clock 4 (ADC_ALTCLK4)" ]
            _11,
        }
        impl AdiclkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdiclkW::_00 => 0,
                    AdiclkW::_01 => 1,
                    AdiclkW::_10 => 2,
                    AdiclkW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdiclkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdiclkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdiclkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Alternate clock 1 (ADC_ALTCLK1)" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(AdiclkW::_00)
            }
            # [ doc = "Alternate clock 2 (ADC_ALTCLK2)" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(AdiclkW::_01)
            }
            # [ doc = "Alternate clock 3 (ADC_ALTCLK3)" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(AdiclkW::_10)
            }
            # [ doc = "Alternate clock 4 (ADC_ALTCLK4)" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(AdiclkW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MODE`" ]
        pub enum ModeW {
            # [ doc = "8-bit conversion." ]
            _00,
            # [ doc = "12-bit conversion." ]
            _01,
            # [ doc = "10-bit conversion." ]
            _10,
        }
        impl ModeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ModeW::_00 => 0,
                    ModeW::_01 => 1,
                    ModeW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ModeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "8-bit conversion." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ModeW::_00)
            }
            # [ doc = "12-bit conversion." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ModeW::_01)
            }
            # [ doc = "10-bit conversion." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ModeW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADIV`" ]
        pub enum AdivW {
            # [ doc = "The divide ratio is 1 and the clock rate is input clock." ]
            _00,
            # [ doc = "The divide ratio is 2 and the clock rate is (input clock)/2." ]
            _01,
            # [ doc = "The divide ratio is 4 and the clock rate is (input clock)/4." ]
            _10,
            # [ doc = "The divide ratio is 8 and the clock rate is (input clock)/8." ]
            _11,
        }
        impl AdivW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdivW::_00 => 0,
                    AdivW::_01 => 1,
                    AdivW::_10 => 2,
                    AdivW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdivW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdivW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The divide ratio is 1 and the clock rate is input clock." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(AdivW::_00)
            }
            # [ doc = "The divide ratio is 2 and the clock rate is (input clock)/2." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(AdivW::_01)
            }
            # [ doc = "The divide ratio is 4 and the clock rate is (input clock)/4." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(AdivW::_10)
            }
            # [ doc = "The divide ratio is 8 and the clock rate is (input clock)/8." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(AdivW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClrltrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClrltrgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Input Clock Select" ]
            # [ inline ( always ) ]
            pub fn adiclk(&self) -> AdiclkR {
                AdiclkR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 2:3 - Conversion mode selection" ]
            # [ inline ( always ) ]
            pub fn mode(&self) -> ModeR {
                ModeR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 5:6 - Clock Divide Select" ]
            # [ inline ( always ) ]
            pub fn adiv(&self) -> AdivR {
                AdivR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Input Clock Select" ]
            # [ inline ( always ) ]
            pub fn adiclk(&mut self) -> _AdiclkW {
                _AdiclkW { w: self }
            }
            # [ doc = "Bits 2:3 - Conversion mode selection" ]
            # [ inline ( always ) ]
            pub fn mode(&mut self) -> _ModeW {
                _ModeW { w: self }
            }
            # [ doc = "Bits 5:6 - Clock Divide Select" ]
            # [ inline ( always ) ]
            pub fn adiv(&mut self) -> _AdivW {
                _AdivW { w: self }
            }
            # [ doc = "Bit 8 - Clear Latch Trigger in Trigger Handler Block" ]
            # [ inline ( always ) ]
            pub fn clrltrg(&mut self) -> _ClrltrgW {
                _ClrltrgW { w: self }
            }
        }
    }
    # [ doc = "ADC Configuration Register 2" ]
    pub struct Cfg2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Configuration Register 2" ]
    pub mod cfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfg2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SmpltsR {
            bits: u8,
        }
        impl SmpltsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmpltsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmpltsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Sample Time Select" ]
            # [ inline ( always ) ]
            pub fn smplts(&self) -> SmpltsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SmpltsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Sample Time Select" ]
            # [ inline ( always ) ]
            pub fn smplts(&mut self) -> _SmpltsW {
                _SmpltsW { w: self }
            }
        }
    }
    # [ doc = "ADC Data Result Registers" ]
    pub struct R {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Data Result Registers" ]
    pub mod r {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::R {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DR {
            bits: u16,
        }
        impl DR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - Data result" ]
            # [ inline ( always ) ]
            pub fn d(&self) -> DR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DR { bits }
            }
        }
    }
    # [ doc = "Compare Value Registers" ]
    pub struct Cv {
        register: VolatileCell<u32>,
    }
    # [ doc = "Compare Value Registers" ]
    pub mod cv {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cv {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CvR {
            bits: u16,
        }
        impl CvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CvW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Compare Value." ]
            # [ inline ( always ) ]
            pub fn cv(&self) -> CvR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CvR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Compare Value." ]
            # [ inline ( always ) ]
            pub fn cv(&mut self) -> _CvW {
                _CvW { w: self }
            }
        }
    }
    # [ doc = "Status and Control Register 2" ]
    pub struct Sc2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status and Control Register 2" ]
    pub mod sc2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `REFSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RefselR {
            # [ doc = "Default voltage reference pin pair, that is, external pins VREFH and VREFL" ]
            _00,
            # [ doc = "Alternate reference voltage, that is, VALTH. This voltage may be additional external pin or internal source depending on the MCU configuration. See the chip configuration information for details specific to this MCU." ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RefselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RefselR::_00 => 0,
                    RefselR::_01 => 1,
                    RefselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RefselR {
                match bits {
                    0 => RefselR::_00,
                    1 => RefselR::_01,
                    i => RefselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == RefselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == RefselR::_01
            }
        }
        # [ doc = "Possible values of the field `DMAEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaenR {
            # [ doc = "DMA is disabled." ]
            _0,
            # [ doc = "DMA is enabled and will assert the ADC DMA request during an ADC conversion complete event , which is indicated when any SC1n[COCO] flag is asserted." ]
            _1,
        }
        impl DmaenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaenR::_0 => 0,
                    DmaenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaenR {
                match bits {
                    0 => DmaenR::_0,
                    1 => DmaenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaenR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct AcrenR {
            bits: u8,
        }
        impl AcrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct AcfgtR {
            bits: u8,
        }
        impl AcfgtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ACFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AcfeR {
            # [ doc = "Compare function disabled." ]
            _0,
            # [ doc = "Compare function enabled." ]
            _1,
        }
        impl AcfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AcfeR::_0 => 0,
                    AcfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AcfeR {
                match bits {
                    0 => AcfeR::_0,
                    1 => AcfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AcfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AcfeR::_1
            }
        }
        # [ doc = "Possible values of the field `ADTRG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdtrgR {
            # [ doc = "Software trigger selected." ]
            _0,
            # [ doc = "Hardware trigger selected." ]
            _1,
        }
        impl AdtrgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdtrgR::_0 => 0,
                    AdtrgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdtrgR {
                match bits {
                    0 => AdtrgR::_0,
                    1 => AdtrgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdtrgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdtrgR::_1
            }
        }
        # [ doc = "Possible values of the field `ADACT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdactR {
            # [ doc = "Conversion not in progress." ]
            _0,
            # [ doc = "Conversion in progress." ]
            _1,
        }
        impl AdactR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdactR::_0 => 0,
                    AdactR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdactR {
                match bits {
                    0 => AdactR::_0,
                    1 => AdactR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdactR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdactR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgprnumR {
            bits: u8,
        }
        impl TrgprnumR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRGSTLAT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgstlatR {
            # [ doc = "No trigger request has been latched" ]
            _0,
            # [ doc = "A trigger request has been latched" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TrgstlatR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgstlatR::_0 => 0,
                    TrgstlatR::_1 => 1,
                    TrgstlatR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgstlatR {
                match bits {
                    0 => TrgstlatR::_0,
                    1 => TrgstlatR::_1,
                    i => TrgstlatR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgstlatR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgstlatR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGSTERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgsterrR {
            # [ doc = "No error has occurred" ]
            _0,
            # [ doc = "An error has occurred" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TrgsterrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgsterrR::_0 => 0,
                    TrgsterrR::_1 => 1,
                    TrgsterrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgsterrR {
                match bits {
                    0 => TrgsterrR::_0,
                    1 => TrgsterrR::_1,
                    i => TrgsterrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgsterrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgsterrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `REFSEL`" ]
        pub enum RefselW {
            # [ doc = "Default voltage reference pin pair, that is, external pins VREFH and VREFL" ]
            _00,
            # [ doc = "Alternate reference voltage, that is, VALTH. This voltage may be additional external pin or internal source depending on the MCU configuration. See the chip configuration information for details specific to this MCU." ]
            _01,
        }
        impl RefselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RefselW::_00 => 0,
                    RefselW::_01 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RefselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RefselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RefselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Default voltage reference pin pair, that is, external pins VREFH and VREFL" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(RefselW::_00)
            }
            # [ doc = "Alternate reference voltage, that is, VALTH. This voltage may be additional external pin or internal source depending on the MCU configuration. See the chip configuration information for details specific to this MCU." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(RefselW::_01)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMAEN`" ]
        pub enum DmaenW {
            # [ doc = "DMA is disabled." ]
            _0,
            # [ doc = "DMA is enabled and will assert the ADC DMA request during an ADC conversion complete event , which is indicated when any SC1n[COCO] flag is asserted." ]
            _1,
        }
        impl DmaenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaenW::_0 => 0,
                    DmaenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaenW::_0)
            }
            # [ doc = "DMA is enabled and will assert the ADC DMA request during an ADC conversion complete event , which is indicated when any SC1n[COCO] flag is asserted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AcrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AcrenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AcfgtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AcfgtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ACFE`" ]
        pub enum AcfeW {
            # [ doc = "Compare function disabled." ]
            _0,
            # [ doc = "Compare function enabled." ]
            _1,
        }
        impl AcfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AcfeW::_0 => 0,
                    AcfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AcfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AcfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AcfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Compare function disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AcfeW::_0)
            }
            # [ doc = "Compare function enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AcfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADTRG`" ]
        pub enum AdtrgW {
            # [ doc = "Software trigger selected." ]
            _0,
            # [ doc = "Hardware trigger selected." ]
            _1,
        }
        impl AdtrgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdtrgW::_0 => 0,
                    AdtrgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdtrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdtrgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdtrgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software trigger selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AdtrgW::_0)
            }
            # [ doc = "Hardware trigger selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AdtrgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Voltage Reference Selection" ]
            # [ inline ( always ) ]
            pub fn refsel(&self) -> RefselR {
                RefselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&self) -> DmaenR {
                DmaenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Compare Function Range Enable" ]
            # [ inline ( always ) ]
            pub fn acren(&self) -> AcrenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AcrenR { bits }
            }
            # [ doc = "Bit 4 - Compare Function Greater Than Enable" ]
            # [ inline ( always ) ]
            pub fn acfgt(&self) -> AcfgtR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AcfgtR { bits }
            }
            # [ doc = "Bit 5 - Compare Function Enable" ]
            # [ inline ( always ) ]
            pub fn acfe(&self) -> AcfeR {
                AcfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Conversion Trigger Select" ]
            # [ inline ( always ) ]
            pub fn adtrg(&self) -> AdtrgR {
                AdtrgR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Conversion Active" ]
            # [ inline ( always ) ]
            pub fn adact(&self) -> AdactR {
                AdactR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 13:14 - Trigger Process Number" ]
            # [ inline ( always ) ]
            pub fn trgprnum(&self) -> TrgprnumR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 13;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgprnumR { bits }
            }
            # [ doc = "Bits 16:19 - Trigger Status" ]
            # [ inline ( always ) ]
            pub fn trgstlat(&self) -> TrgstlatR {
                TrgstlatR::_from({
                                     const MASK: u8 = 15;
                                     const OFFSET: u8 = 16;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 24:27 - Error in Multiplexed Trigger Request" ]
            # [ inline ( always ) ]
            pub fn trgsterr(&self) -> TrgsterrR {
                TrgsterrR::_from({
                                     const MASK: u8 = 15;
                                     const OFFSET: u8 = 24;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Voltage Reference Selection" ]
            # [ inline ( always ) ]
            pub fn refsel(&mut self) -> _RefselW {
                _RefselW { w: self }
            }
            # [ doc = "Bit 2 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&mut self) -> _DmaenW {
                _DmaenW { w: self }
            }
            # [ doc = "Bit 3 - Compare Function Range Enable" ]
            # [ inline ( always ) ]
            pub fn acren(&mut self) -> _AcrenW {
                _AcrenW { w: self }
            }
            # [ doc = "Bit 4 - Compare Function Greater Than Enable" ]
            # [ inline ( always ) ]
            pub fn acfgt(&mut self) -> _AcfgtW {
                _AcfgtW { w: self }
            }
            # [ doc = "Bit 5 - Compare Function Enable" ]
            # [ inline ( always ) ]
            pub fn acfe(&mut self) -> _AcfeW {
                _AcfeW { w: self }
            }
            # [ doc = "Bit 6 - Conversion Trigger Select" ]
            # [ inline ( always ) ]
            pub fn adtrg(&mut self) -> _AdtrgW {
                _AdtrgW { w: self }
            }
        }
    }
    # [ doc = "Status and Control Register 3" ]
    pub struct Sc3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status and Control Register 3" ]
    pub mod sc3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `AVGS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvgsR {
            # [ doc = "4 samples averaged." ]
            _00,
            # [ doc = "8 samples averaged." ]
            _01,
            # [ doc = "16 samples averaged." ]
            _10,
            # [ doc = "32 samples averaged." ]
            _11,
        }
        impl AvgsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvgsR::_00 => 0,
                    AvgsR::_01 => 1,
                    AvgsR::_10 => 2,
                    AvgsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvgsR {
                match bits {
                    0 => AvgsR::_00,
                    1 => AvgsR::_01,
                    2 => AvgsR::_10,
                    3 => AvgsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == AvgsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == AvgsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == AvgsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == AvgsR::_11
            }
        }
        # [ doc = "Possible values of the field `AVGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvgeR {
            # [ doc = "Hardware average function disabled." ]
            _0,
            # [ doc = "Hardware average function enabled." ]
            _1,
        }
        impl AvgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvgeR::_0 => 0,
                    AvgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvgeR {
                match bits {
                    0 => AvgeR::_0,
                    1 => AvgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AvgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AvgeR::_1
            }
        }
        # [ doc = "Possible values of the field `ADCO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdcoR {
            # [ doc = "One conversion will be performed (or one set of conversions, if AVGE is set) after a conversion is initiated." ]
            _0,
            # [ doc = "Continuous conversions will be performed (or continuous sets of conversions, if AVGE is set) after a conversion is initiated." ]
            _1,
        }
        impl AdcoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdcoR::_0 => 0,
                    AdcoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdcoR {
                match bits {
                    0 => AdcoR::_0,
                    1 => AdcoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdcoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdcoR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CalR {
            bits: u8,
        }
        impl CalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `AVGS`" ]
        pub enum AvgsW {
            # [ doc = "4 samples averaged." ]
            _00,
            # [ doc = "8 samples averaged." ]
            _01,
            # [ doc = "16 samples averaged." ]
            _10,
            # [ doc = "32 samples averaged." ]
            _11,
        }
        impl AvgsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvgsW::_00 => 0,
                    AvgsW::_01 => 1,
                    AvgsW::_10 => 2,
                    AvgsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvgsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvgsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvgsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "4 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(AvgsW::_00)
            }
            # [ doc = "8 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(AvgsW::_01)
            }
            # [ doc = "16 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(AvgsW::_10)
            }
            # [ doc = "32 samples averaged." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(AvgsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AVGE`" ]
        pub enum AvgeW {
            # [ doc = "Hardware average function disabled." ]
            _0,
            # [ doc = "Hardware average function enabled." ]
            _1,
        }
        impl AvgeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvgeW::_0 => 0,
                    AvgeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvgeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvgeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvgeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware average function disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AvgeW::_0)
            }
            # [ doc = "Hardware average function enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AvgeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADCO`" ]
        pub enum AdcoW {
            # [ doc = "One conversion will be performed (or one set of conversions, if AVGE is set) after a conversion is initiated." ]
            _0,
            # [ doc = "Continuous conversions will be performed (or continuous sets of conversions, if AVGE is set) after a conversion is initiated." ]
            _1,
        }
        impl AdcoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdcoW::_0 => 0,
                    AdcoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdcoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdcoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "One conversion will be performed (or one set of conversions, if AVGE is set) after a conversion is initiated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AdcoW::_0)
            }
            # [ doc = "Continuous conversions will be performed (or continuous sets of conversions, if AVGE is set) after a conversion is initiated." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AdcoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Hardware Average Select" ]
            # [ inline ( always ) ]
            pub fn avgs(&self) -> AvgsR {
                AvgsR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Hardware Average Enable" ]
            # [ inline ( always ) ]
            pub fn avge(&self) -> AvgeR {
                AvgeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Continuous Conversion Enable" ]
            # [ inline ( always ) ]
            pub fn adco(&self) -> AdcoR {
                AdcoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Calibration" ]
            # [ inline ( always ) ]
            pub fn cal(&self) -> CalR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Hardware Average Select" ]
            # [ inline ( always ) ]
            pub fn avgs(&mut self) -> _AvgsW {
                _AvgsW { w: self }
            }
            # [ doc = "Bit 2 - Hardware Average Enable" ]
            # [ inline ( always ) ]
            pub fn avge(&mut self) -> _AvgeW {
                _AvgeW { w: self }
            }
            # [ doc = "Bit 3 - Continuous Conversion Enable" ]
            # [ inline ( always ) ]
            pub fn adco(&mut self) -> _AdcoW {
                _AdcoW { w: self }
            }
            # [ doc = "Bit 7 - Calibration" ]
            # [ inline ( always ) ]
            pub fn cal(&mut self) -> _CalW {
                _CalW { w: self }
            }
        }
    }
    # [ doc = "BASE Offset Register" ]
    pub struct BaseOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "BASE Offset Register" ]
    pub mod base_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::BaseOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BaOfsR {
            bits: u8,
        }
        impl BaOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BaOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BaOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Base Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ba_ofs(&self) -> BaOfsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                BaOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 64 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Base Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ba_ofs(&mut self) -> _BaOfsW {
                _BaOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Offset Correction Register" ]
    pub struct Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Offset Correction Register" ]
    pub mod ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OfsR {
            bits: u16,
        }
        impl OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ofs(&self) -> OfsR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn ofs(&mut self) -> _OfsW {
                _OfsW { w: self }
            }
        }
    }
    # [ doc = "USER Offset Correction Register" ]
    pub struct UsrOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "USER Offset Correction Register" ]
    pub mod usr_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::UsrOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct UsrOfsR {
            bits: u8,
        }
        impl UsrOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _UsrOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UsrOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - USER Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn usr_ofs(&self) -> UsrOfsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                UsrOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - USER Offset Error Correction Value" ]
            # [ inline ( always ) ]
            pub fn usr_ofs(&mut self) -> _UsrOfsW {
                _UsrOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC X Offset Correction Register" ]
    pub struct Xofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC X Offset Correction Register" ]
    pub mod xofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Xofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct XofsR {
            bits: u8,
        }
        impl XofsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _XofsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _XofsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - X offset error correction value" ]
            # [ inline ( always ) ]
            pub fn xofs(&self) -> XofsR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                XofsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 48 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - X offset error correction value" ]
            # [ inline ( always ) ]
            pub fn xofs(&mut self) -> _XofsW {
                _XofsW { w: self }
            }
        }
    }
    # [ doc = "ADC Y Offset Correction Register" ]
    pub struct Yofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Y Offset Correction Register" ]
    pub mod yofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Yofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct YofsR {
            bits: u8,
        }
        impl YofsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _YofsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _YofsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Y offset error correction value" ]
            # [ inline ( always ) ]
            pub fn yofs(&self) -> YofsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                YofsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 55 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Y offset error correction value" ]
            # [ inline ( always ) ]
            pub fn yofs(&mut self) -> _YofsW {
                _YofsW { w: self }
            }
        }
    }
    # [ doc = "ADC Gain Register" ]
    pub struct G {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Gain Register" ]
    pub mod g {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::G {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GR {
            bits: u16,
        }
        impl GR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 2047;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:10 - Gain error adjustment factor for the overall conversion" ]
            # [ inline ( always ) ]
            pub fn g(&self) -> GR {
                let bits = {
                    const MASK: u16 = 2047;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                GR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 752 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:10 - Gain error adjustment factor for the overall conversion" ]
            # [ inline ( always ) ]
            pub fn g(&mut self) -> _GW {
                _GW { w: self }
            }
        }
    }
    # [ doc = "ADC User Gain Register" ]
    pub struct Ug {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC User Gain Register" ]
    pub mod ug {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ug {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct UgR {
            bits: u16,
        }
        impl UgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _UgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - User gain error correction value" ]
            # [ inline ( always ) ]
            pub fn ug(&self) -> UgR {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                UgR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - User gain error correction value" ]
            # [ inline ( always ) ]
            pub fn ug(&mut self) -> _UgW {
                _UgW { w: self }
            }
        }
    }
    # [ doc = "ADC General Calibration Value Register S" ]
    pub struct Clps {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC General Calibration Value Register S" ]
    pub mod clps {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clps {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpsR {
            bits: u8,
        }
        impl ClpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clps(&self) -> ClpsR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClpsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 46 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clps(&mut self) -> _ClpsW {
                _ClpsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 3" ]
    pub struct Clp3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 3" ]
    pub mod clp3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp3R {
            bits: u16,
        }
        impl Clp3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp3(&self) -> Clp3R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp3R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 384 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp3(&mut self) -> _Clp3W {
                _Clp3W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 2" ]
    pub struct Clp2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 2" ]
    pub mod clp2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp2R {
            bits: u16,
        }
        impl Clp2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp2(&self) -> Clp2R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 184 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp2(&mut self) -> _Clp2W {
                _Clp2W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 1" ]
    pub struct Clp1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 1" ]
    pub mod clp1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp1R {
            bits: u16,
        }
        impl Clp1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 511;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:8 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp1(&self) -> Clp1R {
                let bits = {
                    const MASK: u16 = 511;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 92 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:8 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp1(&mut self) -> _Clp1W {
                _Clp1W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 0" ]
    pub struct Clp0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 0" ]
    pub mod clp0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp0R {
            bits: u8,
        }
        impl Clp0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp0(&self) -> Clp0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 46 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp0(&mut self) -> _Clp0W {
                _Clp0W { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register X" ]
    pub struct Clpx {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register X" ]
    pub mod clpx {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clpx {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpxR {
            bits: u8,
        }
        impl ClpxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpxW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clpx(&self) -> ClpxR {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClpxR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clpx(&mut self) -> _ClpxW {
                _ClpxW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 9" ]
    pub struct Clp9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Value Register 9" ]
    pub mod clp9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp9R {
            bits: u8,
        }
        impl Clp9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 127;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp9(&self) -> Clp9R {
                let bits = {
                    const MASK: u8 = 127;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp9R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:6 - Calibration Value" ]
            # [ inline ( always ) ]
            pub fn clp9(&mut self) -> _Clp9W {
                _Clp9W { w: self }
            }
        }
    }
    # [ doc = "ADC General Calibration Offset Value Register S" ]
    pub struct ClpsOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC General Calibration Offset Value Register S" ]
    pub mod clps_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::ClpsOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpsOfsR {
            bits: u8,
        }
        impl ClpsOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpsOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpsOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLPS Offset" ]
            # [ inline ( always ) ]
            pub fn clps_ofs(&self) -> ClpsOfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClpsOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLPS Offset" ]
            # [ inline ( always ) ]
            pub fn clps_ofs(&mut self) -> _ClpsOfsW {
                _ClpsOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 3" ]
    pub struct Clp3Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 3" ]
    pub mod clp3_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp3Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp3OfsR {
            bits: u8,
        }
        impl Clp3OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp3OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp3OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP3 Offset" ]
            # [ inline ( always ) ]
            pub fn clp3_ofs(&self) -> Clp3OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp3OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP3 Offset" ]
            # [ inline ( always ) ]
            pub fn clp3_ofs(&mut self) -> _Clp3OfsW {
                _Clp3OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 2" ]
    pub struct Clp2Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 2" ]
    pub mod clp2_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp2Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp2OfsR {
            bits: u8,
        }
        impl Clp2OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp2OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp2OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP2 Offset" ]
            # [ inline ( always ) ]
            pub fn clp2_ofs(&self) -> Clp2OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp2OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP2 Offset" ]
            # [ inline ( always ) ]
            pub fn clp2_ofs(&mut self) -> _Clp2OfsW {
                _Clp2OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 1" ]
    pub struct Clp1Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 1" ]
    pub mod clp1_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp1Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp1OfsR {
            bits: u8,
        }
        impl Clp1OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp1OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp1OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP1 Offset" ]
            # [ inline ( always ) ]
            pub fn clp1_ofs(&self) -> Clp1OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp1OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP1 Offset" ]
            # [ inline ( always ) ]
            pub fn clp1_ofs(&mut self) -> _Clp1OfsW {
                _Clp1OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 0" ]
    pub struct Clp0Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 0" ]
    pub mod clp0_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp0Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp0OfsR {
            bits: u8,
        }
        impl Clp0OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp0OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp0OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - CLP0 Offset" ]
            # [ inline ( always ) ]
            pub fn clp0_ofs(&self) -> Clp0OfsR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Clp0OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - CLP0 Offset" ]
            # [ inline ( always ) ]
            pub fn clp0_ofs(&mut self) -> _Clp0OfsW {
                _Clp0OfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register X" ]
    pub struct ClpxOfs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register X" ]
    pub mod clpx_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::ClpxOfs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClpxOfsR {
            bits: u16,
        }
        impl ClpxOfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClpxOfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClpxOfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - CLPX Offset" ]
            # [ inline ( always ) ]
            pub fn clpx_ofs(&self) -> ClpxOfsR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ClpxOfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1088 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - CLPX Offset" ]
            # [ inline ( always ) ]
            pub fn clpx_ofs(&mut self) -> _ClpxOfsW {
                _ClpxOfsW { w: self }
            }
        }
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 9" ]
    pub struct Clp9Ofs {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Plus-Side General Calibration Offset Value Register 9" ]
    pub mod clp9_ofs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clp9Ofs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Clp9OfsR {
            bits: u16,
        }
        impl Clp9OfsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Clp9OfsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Clp9OfsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - CLP9 Offset" ]
            # [ inline ( always ) ]
            pub fn clp9_ofs(&self) -> Clp9OfsR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Clp9OfsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 576 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - CLP9 Offset" ]
            # [ inline ( always ) ]
            pub fn clp9_ofs(&mut self) -> _Clp9OfsW {
                _Clp9OfsW { w: self }
            }
        }
    }
}
# [ doc = "Analog-to-Digital Converter" ]
pub struct Adc1 {
    register_block: adc1::RegisterBlock,
}
impl Deref for Adc1 {
    type Target = adc1::RegisterBlock;
    fn deref(&self) -> &adc1::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub const LPSPI0: Peripheral<Lpspi0> = unsafe { Peripheral::new(1073922048) };
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub mod lpspi0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        _reserved0: [u8; 8usize],
        # [ doc = "0x10 - Control Register" ]
        pub cr: Cr,
        # [ doc = "0x14 - Status Register" ]
        pub sr: Sr,
        # [ doc = "0x18 - Interrupt Enable Register" ]
        pub ier: Ier,
        # [ doc = "0x1c - DMA Enable Register" ]
        pub der: Der,
        # [ doc = "0x20 - Configuration Register 0" ]
        pub cfgr0: Cfgr0,
        # [ doc = "0x24 - Configuration Register 1" ]
        pub cfgr1: Cfgr1,
        _reserved1: [u8; 8usize],
        # [ doc = "0x30 - Data Match Register 0" ]
        pub dmr0: Dmr0,
        # [ doc = "0x34 - Data Match Register 1" ]
        pub dmr1: Dmr1,
        _reserved2: [u8; 8usize],
        # [ doc = "0x40 - Clock Configuration Register" ]
        pub ccr: Ccr,
        _reserved3: [u8; 20usize],
        # [ doc = "0x58 - FIFO Control Register" ]
        pub fcr: Fcr,
        # [ doc = "0x5c - FIFO Status Register" ]
        pub fsr: Fsr,
        # [ doc = "0x60 - Transmit Command Register" ]
        pub tcr: Tcr,
        # [ doc = "0x64 - Transmit Data Register" ]
        pub tdr: Tdr,
        _reserved4: [u8; 8usize],
        # [ doc = "0x70 - Receive Status Register" ]
        pub rsr: Rsr,
        # [ doc = "0x74 - Receive Data Register" ]
        pub rdr: Rdr,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set supporting 32-bit shift register." ]
            _0000000000000100,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000100 => 4,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    4 => FeatureR::_0000000000000100,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000100`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000100(&self) -> bool {
                *self == FeatureR::_0000000000000100
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Module Identification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxfifoR {
            bits: u8,
        }
        impl TxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxfifoR {
            bits: u8,
        }
        impl RxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn txfifo(&self) -> TxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxfifoR { bits }
            }
            # [ doc = "Bits 8:15 - Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn rxfifo(&self) -> RxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxfifoR { bits }
            }
        }
    }
    # [ doc = "Control Register" ]
    pub struct Cr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control Register" ]
    pub mod cr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MenR {
            # [ doc = "Module is disabled." ]
            _0,
            # [ doc = "Module is enabled." ]
            _1,
        }
        impl MenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MenR::_0 => 0,
                    MenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MenR {
                match bits {
                    0 => MenR::_0,
                    1 => MenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MenR::_1
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozenR {
            # [ doc = "Module is enabled in Doze mode." ]
            _0,
            # [ doc = "Module is disabled in Doze mode." ]
            _1,
        }
        impl DozenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozenR::_0 => 0,
                    DozenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozenR {
                match bits {
                    0 => DozenR::_0,
                    1 => DozenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozenR::_1
            }
        }
        # [ doc = "Possible values of the field `DBGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgenR {
            # [ doc = "Module is disabled in debug mode." ]
            _0,
            # [ doc = "Module is enabled in debug mode." ]
            _1,
        }
        impl DbgenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgenR::_0 => 0,
                    DbgenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgenR {
                match bits {
                    0 => DbgenR::_0,
                    1 => DbgenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MEN`" ]
        pub enum MenW {
            # [ doc = "Module is disabled." ]
            _0,
            # [ doc = "Module is enabled." ]
            _1,
        }
        impl MenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MenW::_0 => 0,
                    MenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MenW::_0)
            }
            # [ doc = "Module is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master logic is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Master logic is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEN`" ]
        pub enum DozenW {
            # [ doc = "Module is enabled in Doze mode." ]
            _0,
            # [ doc = "Module is disabled in Doze mode." ]
            _1,
        }
        impl DozenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozenW::_0 => 0,
                    DozenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozenW::_0)
            }
            # [ doc = "Module is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBGEN`" ]
        pub enum DbgenW {
            # [ doc = "Module is disabled in debug mode." ]
            _0,
            # [ doc = "Module is enabled in debug mode." ]
            _1,
        }
        impl DbgenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgenW::_0 => 0,
                    DbgenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is disabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgenW::_0)
            }
            # [ doc = "Module is enabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTF`" ]
        pub enum RtfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Transmit FIFO is reset." ]
            _1,
        }
        impl RtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtfW::_0 => 0,
                    RtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtfW::_0)
            }
            # [ doc = "Transmit FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRF`" ]
        pub enum RrfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Receive FIFO is reset." ]
            _1,
        }
        impl RrfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrfW::_0 => 0,
                    RrfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrfW::_0)
            }
            # [ doc = "Receive FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Module Enable" ]
            # [ inline ( always ) ]
            pub fn men(&self) -> MenR {
                MenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&self) -> DozenR {
                DozenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&self) -> DbgenR {
                DbgenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Module Enable" ]
            # [ inline ( always ) ]
            pub fn men(&mut self) -> _MenW {
                _MenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&mut self) -> _DozenW {
                _DozenW { w: self }
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&mut self) -> _DbgenW {
                _DbgenW { w: self }
            }
            # [ doc = "Bit 8 - Reset Transmit FIFO" ]
            # [ inline ( always ) ]
            pub fn rtf(&mut self) -> _RtfW {
                _RtfW { w: self }
            }
            # [ doc = "Bit 9 - Reset Receive FIFO" ]
            # [ inline ( always ) ]
            pub fn rrf(&mut self) -> _RrfW {
                _RrfW { w: self }
            }
        }
    }
    # [ doc = "Status Register" ]
    pub struct Sr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status Register" ]
    pub mod sr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdfR {
            # [ doc = "Transmit data not requested." ]
            _0,
            # [ doc = "Transmit data is requested." ]
            _1,
        }
        impl TdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdfR::_0 => 0,
                    TdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdfR {
                match bits {
                    0 => TdfR::_0,
                    1 => TdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdfR::_1
            }
        }
        # [ doc = "Possible values of the field `RDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdfR {
            # [ doc = "Receive Data is not ready." ]
            _0,
            # [ doc = "Receive data is ready." ]
            _1,
        }
        impl RdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdfR::_0 => 0,
                    RdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdfR {
                match bits {
                    0 => RdfR::_0,
                    1 => RdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdfR::_1
            }
        }
        # [ doc = "Possible values of the field `WCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WcfR {
            # [ doc = "Transfer word not completed." ]
            _0,
            # [ doc = "Transfer word completed." ]
            _1,
        }
        impl WcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WcfR::_0 => 0,
                    WcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WcfR {
                match bits {
                    0 => WcfR::_0,
                    1 => WcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WcfR::_1
            }
        }
        # [ doc = "Possible values of the field `FCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcfR {
            # [ doc = "Frame transfer has not completed." ]
            _0,
            # [ doc = "Frame transfer has completed." ]
            _1,
        }
        impl FcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcfR::_0 => 0,
                    FcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcfR {
                match bits {
                    0 => FcfR::_0,
                    1 => FcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcfR {
            # [ doc = "All transfers have not completed." ]
            _0,
            # [ doc = "All transfers have completed." ]
            _1,
        }
        impl TcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcfR::_0 => 0,
                    TcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcfR {
                match bits {
                    0 => TcfR::_0,
                    1 => TcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TefR {
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            _0,
            # [ doc = "Transmit FIFO underrun has occurred" ]
            _1,
        }
        impl TefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TefR::_0 => 0,
                    TefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TefR {
                match bits {
                    0 => TefR::_0,
                    1 => TefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TefR::_1
            }
        }
        # [ doc = "Possible values of the field `REF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RefR {
            # [ doc = "Receive FIFO has not overflowed." ]
            _0,
            # [ doc = "Receive FIFO has overflowed." ]
            _1,
        }
        impl RefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RefR::_0 => 0,
                    RefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RefR {
                match bits {
                    0 => RefR::_0,
                    1 => RefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RefR::_1
            }
        }
        # [ doc = "Possible values of the field `DMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmfR {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmfR::_0 => 0,
                    DmfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmfR {
                match bits {
                    0 => DmfR::_0,
                    1 => DmfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmfR::_1
            }
        }
        # [ doc = "Possible values of the field `MBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MbfR {
            # [ doc = "LPSPI is idle." ]
            _0,
            # [ doc = "LPSPI is busy." ]
            _1,
        }
        impl MbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MbfR::_0 => 0,
                    MbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MbfR {
                match bits {
                    0 => MbfR::_0,
                    1 => MbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MbfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WCF`" ]
        pub enum WcfW {
            # [ doc = "Transfer word not completed." ]
            _0,
            # [ doc = "Transfer word completed." ]
            _1,
        }
        impl WcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WcfW::_0 => 0,
                    WcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfer word not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WcfW::_0)
            }
            # [ doc = "Transfer word completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FCF`" ]
        pub enum FcfW {
            # [ doc = "Frame transfer has not completed." ]
            _0,
            # [ doc = "Frame transfer has completed." ]
            _1,
        }
        impl FcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcfW::_0 => 0,
                    FcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Frame transfer has not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FcfW::_0)
            }
            # [ doc = "Frame transfer has completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCF`" ]
        pub enum TcfW {
            # [ doc = "All transfers have not completed." ]
            _0,
            # [ doc = "All transfers have completed." ]
            _1,
        }
        impl TcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcfW::_0 => 0,
                    TcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "All transfers have not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcfW::_0)
            }
            # [ doc = "All transfers have completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TEF`" ]
        pub enum TefW {
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            _0,
            # [ doc = "Transmit FIFO underrun has occurred" ]
            _1,
        }
        impl TefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TefW::_0 => 0,
                    TefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TefW::_0)
            }
            # [ doc = "Transmit FIFO underrun has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REF`" ]
        pub enum RefW {
            # [ doc = "Receive FIFO has not overflowed." ]
            _0,
            # [ doc = "Receive FIFO has overflowed." ]
            _1,
        }
        impl RefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RefW::_0 => 0,
                    RefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive FIFO has not overflowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RefW::_0)
            }
            # [ doc = "Receive FIFO has overflowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMF`" ]
        pub enum DmfW {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmfW::_0 => 0,
                    DmfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Have not received matching data." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmfW::_0)
            }
            # [ doc = "Have received matching data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Flag" ]
            # [ inline ( always ) ]
            pub fn tdf(&self) -> TdfR {
                TdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Receive Data Flag" ]
            # [ inline ( always ) ]
            pub fn rdf(&self) -> RdfR {
                RdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Word Complete Flag" ]
            # [ inline ( always ) ]
            pub fn wcf(&self) -> WcfR {
                WcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Frame Complete Flag" ]
            # [ inline ( always ) ]
            pub fn fcf(&self) -> FcfR {
                FcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Transfer Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&self) -> TcfR {
                TcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Transmit Error Flag" ]
            # [ inline ( always ) ]
            pub fn tef(&self) -> TefR {
                TefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 11;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Receive Error Flag" ]
            # [ inline ( always ) ]
            pub fn ref_(&self) -> RefR {
                RefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&self) -> DmfR {
                DmfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Module Busy Flag" ]
            # [ inline ( always ) ]
            pub fn mbf(&self) -> MbfR {
                MbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Word Complete Flag" ]
            # [ inline ( always ) ]
            pub fn wcf(&mut self) -> _WcfW {
                _WcfW { w: self }
            }
            # [ doc = "Bit 9 - Frame Complete Flag" ]
            # [ inline ( always ) ]
            pub fn fcf(&mut self) -> _FcfW {
                _FcfW { w: self }
            }
            # [ doc = "Bit 10 - Transfer Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&mut self) -> _TcfW {
                _TcfW { w: self }
            }
            # [ doc = "Bit 11 - Transmit Error Flag" ]
            # [ inline ( always ) ]
            pub fn tef(&mut self) -> _TefW {
                _TefW { w: self }
            }
            # [ doc = "Bit 12 - Receive Error Flag" ]
            # [ inline ( always ) ]
            pub fn ref_(&mut self) -> _RefW {
                _RefW { w: self }
            }
            # [ doc = "Bit 13 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&mut self) -> _DmfW {
                _DmfW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Enable Register" ]
    pub struct Ier {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Enable Register" ]
    pub mod ier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdieR::_0 => 0,
                    TdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdieR {
                match bits {
                    0 => TdieR::_0,
                    1 => TdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdieR::_0 => 0,
                    RdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdieR {
                match bits {
                    0 => RdieR::_0,
                    1 => RdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdieR::_1
            }
        }
        # [ doc = "Possible values of the field `WCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WcieR::_0 => 0,
                    WcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WcieR {
                match bits {
                    0 => WcieR::_0,
                    1 => WcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WcieR::_1
            }
        }
        # [ doc = "Possible values of the field `FCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcieR::_0 => 0,
                    FcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcieR {
                match bits {
                    0 => FcieR::_0,
                    1 => FcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcieR::_0 => 0,
                    TcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcieR {
                match bits {
                    0 => TcieR::_0,
                    1 => TcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TeieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TeieR::_0 => 0,
                    TeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TeieR {
                match bits {
                    0 => TeieR::_0,
                    1 => TeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TeieR::_1
            }
        }
        # [ doc = "Possible values of the field `REIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl ReieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReieR::_0 => 0,
                    ReieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReieR {
                match bits {
                    0 => ReieR::_0,
                    1 => ReieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReieR::_1
            }
        }
        # [ doc = "Possible values of the field `DMIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmieR::_0 => 0,
                    DmieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmieR {
                match bits {
                    0 => DmieR::_0,
                    1 => DmieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDIE`" ]
        pub enum TdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdieW::_0 => 0,
                    TdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdieW::_0)
            }
            # [ doc = "Interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDIE`" ]
        pub enum RdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdieW::_0 => 0,
                    RdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WCIE`" ]
        pub enum WcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WcieW::_0 => 0,
                    WcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FCIE`" ]
        pub enum FcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcieW::_0 => 0,
                    FcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCIE`" ]
        pub enum TcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcieW::_0 => 0,
                    TcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TEIE`" ]
        pub enum TeieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TeieW::_0 => 0,
                    TeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TeieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REIE`" ]
        pub enum ReieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl ReieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReieW::_0 => 0,
                    ReieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMIE`" ]
        pub enum DmieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmieW::_0 => 0,
                    DmieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&self) -> TdieR {
                TdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&self) -> RdieR {
                RdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Word Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wcie(&self) -> WcieR {
                WcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Frame Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fcie(&self) -> FcieR {
                FcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Transfer Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tcie(&self) -> TcieR {
                TcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Transmit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&self) -> TeieR {
                TeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Receive Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn reie(&self) -> ReieR {
                ReieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 13 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&self) -> DmieR {
                DmieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&mut self) -> _TdieW {
                _TdieW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&mut self) -> _RdieW {
                _RdieW { w: self }
            }
            # [ doc = "Bit 8 - Word Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wcie(&mut self) -> _WcieW {
                _WcieW { w: self }
            }
            # [ doc = "Bit 9 - Frame Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fcie(&mut self) -> _FcieW {
                _FcieW { w: self }
            }
            # [ doc = "Bit 10 - Transfer Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tcie(&mut self) -> _TcieW {
                _TcieW { w: self }
            }
            # [ doc = "Bit 11 - Transmit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&mut self) -> _TeieW {
                _TeieW { w: self }
            }
            # [ doc = "Bit 12 - Receive Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn reie(&mut self) -> _ReieW {
                _ReieW { w: self }
            }
            # [ doc = "Bit 13 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&mut self) -> _DmieW {
                _DmieW { w: self }
            }
        }
    }
    # [ doc = "DMA Enable Register" ]
    pub struct Der {
        register: VolatileCell<u32>,
    }
    # [ doc = "DMA Enable Register" ]
    pub mod der {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Der {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TddeR::_0 => 0,
                    TddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TddeR {
                match bits {
                    0 => TddeR::_0,
                    1 => TddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TddeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RddeR::_0 => 0,
                    RddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RddeR {
                match bits {
                    0 => RddeR::_0,
                    1 => RddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RddeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDDE`" ]
        pub enum TddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TddeW::_0 => 0,
                    TddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TddeW::_0)
            }
            # [ doc = "DMA request enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDDE`" ]
        pub enum RddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RddeW::_0 => 0,
                    RddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RddeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&self) -> TddeR {
                TddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&self) -> RddeR {
                RddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&mut self) -> _TddeW {
                _TddeW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&mut self) -> _RddeW {
                _RddeW { w: self }
            }
        }
    }
    # [ doc = "Configuration Register 0" ]
    pub struct Cfgr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration Register 0" ]
    pub mod cfgr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfgr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrenR {
            # [ doc = "Host request is disabled." ]
            _0,
            # [ doc = "Host request is enabled." ]
            _1,
        }
        impl HrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrenR::_0 => 0,
                    HrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrenR {
                match bits {
                    0 => HrenR::_0,
                    1 => HrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrenR::_1
            }
        }
        # [ doc = "Possible values of the field `HRPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrpolR {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrpolR::_0 => 0,
                    HrpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrpolR {
                match bits {
                    0 => HrpolR::_0,
                    1 => HrpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrpolR::_1
            }
        }
        # [ doc = "Possible values of the field `HRSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrselR {
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrselR::_0 => 0,
                    HrselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrselR {
                match bits {
                    0 => HrselR::_0,
                    1 => HrselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrselR::_1
            }
        }
        # [ doc = "Possible values of the field `CIRFIFO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CirfifoR {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CirfifoR::_0 => 0,
                    CirfifoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CirfifoR {
                match bits {
                    0 => CirfifoR::_0,
                    1 => CirfifoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CirfifoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CirfifoR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmoR {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the DMF is set." ]
            _1,
        }
        impl RdmoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmoR::_0 => 0,
                    RdmoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmoR {
                match bits {
                    0 => RdmoR::_0,
                    1 => RdmoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HREN`" ]
        pub enum HrenW {
            # [ doc = "Host request is disabled." ]
            _0,
            # [ doc = "Host request is enabled." ]
            _1,
        }
        impl HrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrenW::_0 => 0,
                    HrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrenW::_0)
            }
            # [ doc = "Host request is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRPOL`" ]
        pub enum HrpolW {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrpolW::_0 => 0,
                    HrpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrpolW::_0)
            }
            # [ doc = "Active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRSEL`" ]
        pub enum HrselW {
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrselW::_0 => 0,
                    HrselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrselW::_0)
            }
            # [ doc = "Host request input is input trigger." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CIRFIFO`" ]
        pub enum CirfifoW {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CirfifoW::_0 => 0,
                    CirfifoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CirfifoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CirfifoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CirfifoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Circular FIFO is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CirfifoW::_0)
            }
            # [ doc = "Circular FIFO is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CirfifoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMO`" ]
        pub enum RdmoW {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the DMF is set." ]
            _1,
        }
        impl RdmoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmoW::_0 => 0,
                    RdmoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmoW::_0)
            }
            # [ doc = "Received data is discarded unless the DMF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&self) -> HrenR {
                HrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&self) -> HrpolR {
                HrpolR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&self) -> HrselR {
                HrselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&self) -> CirfifoR {
                CirfifoR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&self) -> RdmoR {
                RdmoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&mut self) -> _HrenW {
                _HrenW { w: self }
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&mut self) -> _HrpolW {
                _HrpolW { w: self }
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&mut self) -> _HrselW {
                _HrselW { w: self }
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&mut self) -> _CirfifoW {
                _CirfifoW { w: self }
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&mut self) -> _RdmoW {
                _RdmoW { w: self }
            }
        }
    }
    # [ doc = "Configuration Register 1" ]
    pub struct Cfgr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration Register 1" ]
    pub mod cfgr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfgr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MASTER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MasterR {
            # [ doc = "Slave mode." ]
            _0,
            # [ doc = "Master mode." ]
            _1,
        }
        impl MasterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MasterR::_0 => 0,
                    MasterR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MasterR {
                match bits {
                    0 => MasterR::_0,
                    1 => MasterR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MasterR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MasterR::_1
            }
        }
        # [ doc = "Possible values of the field `SAMPLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SampleR {
            # [ doc = "Input data sampled on SCK edge." ]
            _0,
            # [ doc = "Input data sampled on delayed SCK edge." ]
            _1,
        }
        impl SampleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SampleR::_0 => 0,
                    SampleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SampleR {
                match bits {
                    0 => SampleR::_0,
                    1 => SampleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SampleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SampleR::_1
            }
        }
        # [ doc = "Possible values of the field `AUTOPCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AutopcsR {
            # [ doc = "Automatic PCS generation disabled." ]
            _0,
            # [ doc = "Automatic PCS generation enabled." ]
            _1,
        }
        impl AutopcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AutopcsR::_0 => 0,
                    AutopcsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AutopcsR {
                match bits {
                    0 => AutopcsR::_0,
                    1 => AutopcsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AutopcsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AutopcsR::_1
            }
        }
        # [ doc = "Possible values of the field `NOSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NostallR {
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            _0,
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            _1,
        }
        impl NostallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NostallR::_0 => 0,
                    NostallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NostallR {
                match bits {
                    0 => NostallR::_0,
                    1 => NostallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NostallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NostallR::_1
            }
        }
        # [ doc = "Possible values of the field `PCSPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcspolR {
            # [ doc = "The PCSx is active low." ]
            _0000,
            # [ doc = "The PCSx is active high." ]
            _0001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PcspolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcspolR::_0000 => 0,
                    PcspolR::_0001 => 1,
                    PcspolR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcspolR {
                match bits {
                    0 => PcspolR::_0000,
                    1 => PcspolR::_0001,
                    i => PcspolR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == PcspolR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == PcspolR::_0001
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Match is disabled." ]
            _000,
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            _010,
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            _011,
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            _100,
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            _101,
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _110,
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_000 => 0,
                    MatcfgR::_010 => 2,
                    MatcfgR::_011 => 3,
                    MatcfgR::_100 => 4,
                    MatcfgR::_101 => 5,
                    MatcfgR::_110 => 6,
                    MatcfgR::_111 => 7,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_000,
                    2 => MatcfgR::_010,
                    3 => MatcfgR::_011,
                    4 => MatcfgR::_100,
                    5 => MatcfgR::_101,
                    6 => MatcfgR::_110,
                    7 => MatcfgR::_111,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MatcfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MatcfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MatcfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MatcfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MatcfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MatcfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MatcfgR::_111
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            _00,
            # [ doc = "SIN is used for both input and output data." ]
            _01,
            # [ doc = "SOUT is used for both input and output data." ]
            _10,
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_00 => 0,
                    PincfgR::_01 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_00,
                    1 => PincfgR::_01,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PincfgR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PincfgR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `OUTCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OutcfgR {
            # [ doc = "Output data retains last value when chip select is negated." ]
            _0,
            # [ doc = "Output data is tristated when chip select is negated." ]
            _1,
        }
        impl OutcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OutcfgR::_0 => 0,
                    OutcfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OutcfgR {
                match bits {
                    0 => OutcfgR::_0,
                    1 => OutcfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OutcfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OutcfgR::_1
            }
        }
        # [ doc = "Possible values of the field `PCSCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcscfgR {
            # [ doc = "PCS[3:2] are enabled." ]
            _0,
            # [ doc = "PCS[3:2] are disabled." ]
            _1,
        }
        impl PcscfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcscfgR::_0 => 0,
                    PcscfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcscfgR {
                match bits {
                    0 => PcscfgR::_0,
                    1 => PcscfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PcscfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PcscfgR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MASTER`" ]
        pub enum MasterW {
            # [ doc = "Slave mode." ]
            _0,
            # [ doc = "Master mode." ]
            _1,
        }
        impl MasterW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MasterW::_0 => 0,
                    MasterW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MasterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MasterW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MasterW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MasterW::_0)
            }
            # [ doc = "Master mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MasterW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SAMPLE`" ]
        pub enum SampleW {
            # [ doc = "Input data sampled on SCK edge." ]
            _0,
            # [ doc = "Input data sampled on delayed SCK edge." ]
            _1,
        }
        impl SampleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SampleW::_0 => 0,
                    SampleW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SampleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SampleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SampleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Input data sampled on SCK edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SampleW::_0)
            }
            # [ doc = "Input data sampled on delayed SCK edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SampleW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AUTOPCS`" ]
        pub enum AutopcsW {
            # [ doc = "Automatic PCS generation disabled." ]
            _0,
            # [ doc = "Automatic PCS generation enabled." ]
            _1,
        }
        impl AutopcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AutopcsW::_0 => 0,
                    AutopcsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AutopcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AutopcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AutopcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Automatic PCS generation disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AutopcsW::_0)
            }
            # [ doc = "Automatic PCS generation enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AutopcsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOSTALL`" ]
        pub enum NostallW {
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            _0,
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            _1,
        }
        impl NostallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NostallW::_0 => 0,
                    NostallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NostallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NostallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NostallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NostallW::_0)
            }
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NostallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCSPOL`" ]
        pub enum PcspolW {
            # [ doc = "The PCSx is active low." ]
            _0000,
            # [ doc = "The PCSx is active high." ]
            _0001,
        }
        impl PcspolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcspolW::_0000 => 0,
                    PcspolW::_0001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcspolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcspolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcspolW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The PCSx is active low." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(PcspolW::_0000)
            }
            # [ doc = "The PCSx is active high." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(PcspolW::_0001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Match is disabled." ]
            _000,
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            _010,
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            _011,
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            _100,
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            _101,
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _110,
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _111,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_000 => 0,
                    MatcfgW::_010 => 2,
                    MatcfgW::_011 => 3,
                    MatcfgW::_100 => 4,
                    MatcfgW::_101 => 5,
                    MatcfgW::_110 => 6,
                    MatcfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Match is disabled." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MatcfgW::_000)
            }
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MatcfgW::_010)
            }
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MatcfgW::_011)
            }
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MatcfgW::_100)
            }
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MatcfgW::_101)
            }
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MatcfgW::_110)
            }
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MatcfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            _00,
            # [ doc = "SIN is used for both input and output data." ]
            _01,
            # [ doc = "SOUT is used for both input and output data." ]
            _10,
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_00 => 0,
                    PincfgW::_01 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PincfgW::_00)
            }
            # [ doc = "SIN is used for both input and output data." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PincfgW::_01)
            }
            # [ doc = "SOUT is used for both input and output data." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OUTCFG`" ]
        pub enum OutcfgW {
            # [ doc = "Output data retains last value when chip select is negated." ]
            _0,
            # [ doc = "Output data is tristated when chip select is negated." ]
            _1,
        }
        impl OutcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OutcfgW::_0 => 0,
                    OutcfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OutcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OutcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OutcfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output data retains last value when chip select is negated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OutcfgW::_0)
            }
            # [ doc = "Output data is tristated when chip select is negated." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OutcfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCSCFG`" ]
        pub enum PcscfgW {
            # [ doc = "PCS[3:2] are enabled." ]
            _0,
            # [ doc = "PCS[3:2] are disabled." ]
            _1,
        }
        impl PcscfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcscfgW::_0 => 0,
                    PcscfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcscfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcscfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcscfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PCS[3:2] are enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PcscfgW::_0)
            }
            # [ doc = "PCS[3:2] are disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PcscfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Master Mode" ]
            # [ inline ( always ) ]
            pub fn master(&self) -> MasterR {
                MasterR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Sample Point" ]
            # [ inline ( always ) ]
            pub fn sample(&self) -> SampleR {
                SampleR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Automatic PCS" ]
            # [ inline ( always ) ]
            pub fn autopcs(&self) -> AutopcsR {
                AutopcsR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - No Stall" ]
            # [ inline ( always ) ]
            pub fn nostall(&self) -> NostallR {
                NostallR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 8:11 - Peripheral Chip Select Polarity" ]
            # [ inline ( always ) ]
            pub fn pcspol(&self) -> PcspolR {
                PcspolR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Output Config" ]
            # [ inline ( always ) ]
            pub fn outcfg(&self) -> OutcfgR {
                OutcfgR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 26;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 27 - Peripheral Chip Select Configuration" ]
            # [ inline ( always ) ]
            pub fn pcscfg(&self) -> PcscfgR {
                PcscfgR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Master Mode" ]
            # [ inline ( always ) ]
            pub fn master(&mut self) -> _MasterW {
                _MasterW { w: self }
            }
            # [ doc = "Bit 1 - Sample Point" ]
            # [ inline ( always ) ]
            pub fn sample(&mut self) -> _SampleW {
                _SampleW { w: self }
            }
            # [ doc = "Bit 2 - Automatic PCS" ]
            # [ inline ( always ) ]
            pub fn autopcs(&mut self) -> _AutopcsW {
                _AutopcsW { w: self }
            }
            # [ doc = "Bit 3 - No Stall" ]
            # [ inline ( always ) ]
            pub fn nostall(&mut self) -> _NostallW {
                _NostallW { w: self }
            }
            # [ doc = "Bits 8:11 - Peripheral Chip Select Polarity" ]
            # [ inline ( always ) ]
            pub fn pcspol(&mut self) -> _PcspolW {
                _PcspolW { w: self }
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bits 24:25 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 26 - Output Config" ]
            # [ inline ( always ) ]
            pub fn outcfg(&mut self) -> _OutcfgW {
                _OutcfgW { w: self }
            }
            # [ doc = "Bit 27 - Peripheral Chip Select Configuration" ]
            # [ inline ( always ) ]
            pub fn pcscfg(&mut self) -> _PcscfgW {
                _PcscfgW { w: self }
            }
        }
    }
    # [ doc = "Data Match Register 0" ]
    pub struct Dmr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Data Match Register 0" ]
    pub mod dmr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dmr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match0R {
            bits: u32,
        }
        impl Match0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&self) -> Match0R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Match0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&mut self) -> _Match0W {
                _Match0W { w: self }
            }
        }
    }
    # [ doc = "Data Match Register 1" ]
    pub struct Dmr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Data Match Register 1" ]
    pub mod dmr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dmr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match1R {
            bits: u32,
        }
        impl Match1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&self) -> Match1R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Match1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&mut self) -> _Match1W {
                _Match1W { w: self }
            }
        }
    }
    # [ doc = "Clock Configuration Register" ]
    pub struct Ccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Clock Configuration Register" ]
    pub mod ccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SckdivR {
            bits: u8,
        }
        impl SckdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DbtR {
            bits: u8,
        }
        impl DbtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PcssckR {
            bits: u8,
        }
        impl PcssckR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SckpcsR {
            bits: u8,
        }
        impl SckpcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SckdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SckdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcssckW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcssckW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SckpcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SckpcsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - SCK Divider" ]
            # [ inline ( always ) ]
            pub fn sckdiv(&self) -> SckdivR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SckdivR { bits }
            }
            # [ doc = "Bits 8:15 - Delay Between Transfers" ]
            # [ inline ( always ) ]
            pub fn dbt(&self) -> DbtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DbtR { bits }
            }
            # [ doc = "Bits 16:23 - PCS to SCK Delay" ]
            # [ inline ( always ) ]
            pub fn pcssck(&self) -> PcssckR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PcssckR { bits }
            }
            # [ doc = "Bits 24:31 - SCK to PCS Delay" ]
            # [ inline ( always ) ]
            pub fn sckpcs(&self) -> SckpcsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SckpcsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - SCK Divider" ]
            # [ inline ( always ) ]
            pub fn sckdiv(&mut self) -> _SckdivW {
                _SckdivW { w: self }
            }
            # [ doc = "Bits 8:15 - Delay Between Transfers" ]
            # [ inline ( always ) ]
            pub fn dbt(&mut self) -> _DbtW {
                _DbtW { w: self }
            }
            # [ doc = "Bits 16:23 - PCS to SCK Delay" ]
            # [ inline ( always ) ]
            pub fn pcssck(&mut self) -> _PcssckW {
                _PcssckW { w: self }
            }
            # [ doc = "Bits 24:31 - SCK to PCS Delay" ]
            # [ inline ( always ) ]
            pub fn sckpcs(&mut self) -> _SckpcsW {
                _SckpcsW { w: self }
            }
        }
    }
    # [ doc = "FIFO Control Register" ]
    pub struct Fcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "FIFO Control Register" ]
    pub mod fcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
    # [ doc = "FIFO Status Register" ]
    pub struct Fsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "FIFO Status Register" ]
    pub mod fsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Fsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Transmit FIFO Count" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:18 - Receive FIFO Count" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
    }
    # [ doc = "Transmit Command Register" ]
    pub struct Tcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Transmit Command Register" ]
    pub mod tcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FrameszR {
            bits: u16,
        }
        impl FrameszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WIDTH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WidthR {
            # [ doc = "Single bit transfer." ]
            _00,
            # [ doc = "Two bit transfer." ]
            _01,
            # [ doc = "Four bit transfer." ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl WidthR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WidthR::_00 => 0,
                    WidthR::_01 => 1,
                    WidthR::_10 => 2,
                    WidthR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WidthR {
                match bits {
                    0 => WidthR::_00,
                    1 => WidthR::_01,
                    2 => WidthR::_10,
                    i => WidthR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == WidthR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == WidthR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == WidthR::_10
            }
        }
        # [ doc = "Possible values of the field `TXMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxmskR {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Mask transmit data." ]
            _1,
        }
        impl TxmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxmskR::_0 => 0,
                    TxmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxmskR {
                match bits {
                    0 => TxmskR::_0,
                    1 => TxmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxmskR::_1
            }
        }
        # [ doc = "Possible values of the field `RXMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxmskR {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Receive data is masked." ]
            _1,
        }
        impl RxmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxmskR::_0 => 0,
                    RxmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxmskR {
                match bits {
                    0 => RxmskR::_0,
                    1 => RxmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxmskR::_1
            }
        }
        # [ doc = "Possible values of the field `CONTC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContcR {
            # [ doc = "Command word for start of new transfer." ]
            _0,
            # [ doc = "Command word for continuing transfer." ]
            _1,
        }
        impl ContcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContcR::_0 => 0,
                    ContcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContcR {
                match bits {
                    0 => ContcR::_0,
                    1 => ContcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContcR::_1
            }
        }
        # [ doc = "Possible values of the field `CONT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContR {
            # [ doc = "Continuous transfer disabled." ]
            _0,
            # [ doc = "Continuous transfer enabled." ]
            _1,
        }
        impl ContR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContR::_0 => 0,
                    ContR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContR {
                match bits {
                    0 => ContR::_0,
                    1 => ContR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContR::_1
            }
        }
        # [ doc = "Possible values of the field `BYSW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ByswR {
            # [ doc = "Byte swap disabled." ]
            _0,
            # [ doc = "Byte swap enabled." ]
            _1,
        }
        impl ByswR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ByswR::_0 => 0,
                    ByswR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ByswR {
                match bits {
                    0 => ByswR::_0,
                    1 => ByswR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ByswR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ByswR::_1
            }
        }
        # [ doc = "Possible values of the field `LSBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LsbfR {
            # [ doc = "Data is transferred MSB first." ]
            _0,
            # [ doc = "Data is transferred LSB first." ]
            _1,
        }
        impl LsbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LsbfR::_0 => 0,
                    LsbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LsbfR {
                match bits {
                    0 => LsbfR::_0,
                    1 => LsbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LsbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LsbfR::_1
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            _00,
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            _01,
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            _10,
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            _11,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_00 => 0,
                    PcsR::_01 => 1,
                    PcsR::_10 => 2,
                    PcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_00,
                    1 => PcsR::_01,
                    2 => PcsR::_10,
                    3 => PcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PcsR::_11
            }
        }
        # [ doc = "Possible values of the field `PRESCALE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescaleR {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescaleR::_000 => 0,
                    PrescaleR::_001 => 1,
                    PrescaleR::_010 => 2,
                    PrescaleR::_011 => 3,
                    PrescaleR::_100 => 4,
                    PrescaleR::_101 => 5,
                    PrescaleR::_110 => 6,
                    PrescaleR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescaleR {
                match bits {
                    0 => PrescaleR::_000,
                    1 => PrescaleR::_001,
                    2 => PrescaleR::_010,
                    3 => PrescaleR::_011,
                    4 => PrescaleR::_100,
                    5 => PrescaleR::_101,
                    6 => PrescaleR::_110,
                    7 => PrescaleR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PrescaleR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PrescaleR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PrescaleR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PrescaleR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PrescaleR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PrescaleR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PrescaleR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PrescaleR::_111
            }
        }
        # [ doc = "Possible values of the field `CPHA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CphaR {
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            _0,
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            _1,
        }
        impl CphaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CphaR::_0 => 0,
                    CphaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CphaR {
                match bits {
                    0 => CphaR::_0,
                    1 => CphaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CphaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CphaR::_1
            }
        }
        # [ doc = "Possible values of the field `CPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpolR {
            # [ doc = "The inactive state value of SCK is low." ]
            _0,
            # [ doc = "The inactive state value of SCK is high." ]
            _1,
        }
        impl CpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpolR::_0 => 0,
                    CpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpolR {
                match bits {
                    0 => CpolR::_0,
                    1 => CpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpolR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrameszW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrameszW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WIDTH`" ]
        pub enum WidthW {
            # [ doc = "Single bit transfer." ]
            _00,
            # [ doc = "Two bit transfer." ]
            _01,
            # [ doc = "Four bit transfer." ]
            _10,
        }
        impl WidthW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WidthW::_00 => 0,
                    WidthW::_01 => 1,
                    WidthW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WidthW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WidthW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WidthW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Single bit transfer." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(WidthW::_00)
            }
            # [ doc = "Two bit transfer." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(WidthW::_01)
            }
            # [ doc = "Four bit transfer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(WidthW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXMSK`" ]
        pub enum TxmskW {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Mask transmit data." ]
            _1,
        }
        impl TxmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxmskW::_0 => 0,
                    TxmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxmskW::_0)
            }
            # [ doc = "Mask transmit data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXMSK`" ]
        pub enum RxmskW {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Receive data is masked." ]
            _1,
        }
        impl RxmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxmskW::_0 => 0,
                    RxmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxmskW::_0)
            }
            # [ doc = "Receive data is masked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONTC`" ]
        pub enum ContcW {
            # [ doc = "Command word for start of new transfer." ]
            _0,
            # [ doc = "Command word for continuing transfer." ]
            _1,
        }
        impl ContcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContcW::_0 => 0,
                    ContcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Command word for start of new transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContcW::_0)
            }
            # [ doc = "Command word for continuing transfer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONT`" ]
        pub enum ContW {
            # [ doc = "Continuous transfer disabled." ]
            _0,
            # [ doc = "Continuous transfer enabled." ]
            _1,
        }
        impl ContW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContW::_0 => 0,
                    ContW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Continuous transfer disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContW::_0)
            }
            # [ doc = "Continuous transfer enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BYSW`" ]
        pub enum ByswW {
            # [ doc = "Byte swap disabled." ]
            _0,
            # [ doc = "Byte swap enabled." ]
            _1,
        }
        impl ByswW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ByswW::_0 => 0,
                    ByswW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ByswW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ByswW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ByswW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Byte swap disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ByswW::_0)
            }
            # [ doc = "Byte swap enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ByswW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LSBF`" ]
        pub enum LsbfW {
            # [ doc = "Data is transferred MSB first." ]
            _0,
            # [ doc = "Data is transferred LSB first." ]
            _1,
        }
        impl LsbfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LsbfW::_0 => 0,
                    LsbfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LsbfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LsbfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LsbfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data is transferred MSB first." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LsbfW::_0)
            }
            # [ doc = "Data is transferred LSB first." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LsbfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            _00,
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            _01,
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            _10,
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            _11,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_00 => 0,
                    PcsW::_01 => 1,
                    PcsW::_10 => 2,
                    PcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PcsW::_00)
            }
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PcsW::_01)
            }
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PcsW::_10)
            }
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALE`" ]
        pub enum PrescaleW {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescaleW::_000 => 0,
                    PrescaleW::_001 => 1,
                    PrescaleW::_010 => 2,
                    PrescaleW::_011 => 3,
                    PrescaleW::_100 => 4,
                    PrescaleW::_101 => 5,
                    PrescaleW::_110 => 6,
                    PrescaleW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescaleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescaleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescaleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PrescaleW::_000)
            }
            # [ doc = "Divide by 2." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PrescaleW::_001)
            }
            # [ doc = "Divide by 4." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PrescaleW::_010)
            }
            # [ doc = "Divide by 8." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PrescaleW::_011)
            }
            # [ doc = "Divide by 16." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PrescaleW::_100)
            }
            # [ doc = "Divide by 32." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PrescaleW::_101)
            }
            # [ doc = "Divide by 64." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PrescaleW::_110)
            }
            # [ doc = "Divide by 128." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PrescaleW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPHA`" ]
        pub enum CphaW {
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            _0,
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            _1,
        }
        impl CphaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CphaW::_0 => 0,
                    CphaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CphaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CphaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CphaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CphaW::_0)
            }
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CphaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPOL`" ]
        pub enum CpolW {
            # [ doc = "The inactive state value of SCK is low." ]
            _0,
            # [ doc = "The inactive state value of SCK is high." ]
            _1,
        }
        impl CpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpolW::_0 => 0,
                    CpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The inactive state value of SCK is low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpolW::_0)
            }
            # [ doc = "The inactive state value of SCK is high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - Frame Size" ]
            # [ inline ( always ) ]
            pub fn framesz(&self) -> FrameszR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FrameszR { bits }
            }
            # [ doc = "Bits 16:17 - Transfer Width" ]
            # [ inline ( always ) ]
            pub fn width(&self) -> WidthR {
                WidthR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Transmit Data Mask" ]
            # [ inline ( always ) ]
            pub fn txmsk(&self) -> TxmskR {
                TxmskR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 19 - Receive Data Mask" ]
            # [ inline ( always ) ]
            pub fn rxmsk(&self) -> RxmskR {
                RxmskR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 19;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 20 - Continuing Command" ]
            # [ inline ( always ) ]
            pub fn contc(&self) -> ContcR {
                ContcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Continuous Transfer" ]
            # [ inline ( always ) ]
            pub fn cont(&self) -> ContR {
                ContR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Byte Swap" ]
            # [ inline ( always ) ]
            pub fn bysw(&self) -> ByswR {
                ByswR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - LSB First" ]
            # [ inline ( always ) ]
            pub fn lsbf(&self) -> LsbfR {
                LsbfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 23;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:25 - Peripheral Chip Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 27:29 - Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&self) -> PrescaleR {
                PrescaleR::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 27;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 30 - Clock Phase" ]
            # [ inline ( always ) ]
            pub fn cpha(&self) -> CphaR {
                CphaR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 31 - Clock Polarity" ]
            # [ inline ( always ) ]
            pub fn cpol(&self) -> CpolR {
                CpolR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 31 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - Frame Size" ]
            # [ inline ( always ) ]
            pub fn framesz(&mut self) -> _FrameszW {
                _FrameszW { w: self }
            }
            # [ doc = "Bits 16:17 - Transfer Width" ]
            # [ inline ( always ) ]
            pub fn width(&mut self) -> _WidthW {
                _WidthW { w: self }
            }
            # [ doc = "Bit 18 - Transmit Data Mask" ]
            # [ inline ( always ) ]
            pub fn txmsk(&mut self) -> _TxmskW {
                _TxmskW { w: self }
            }
            # [ doc = "Bit 19 - Receive Data Mask" ]
            # [ inline ( always ) ]
            pub fn rxmsk(&mut self) -> _RxmskW {
                _RxmskW { w: self }
            }
            # [ doc = "Bit 20 - Continuing Command" ]
            # [ inline ( always ) ]
            pub fn contc(&mut self) -> _ContcW {
                _ContcW { w: self }
            }
            # [ doc = "Bit 21 - Continuous Transfer" ]
            # [ inline ( always ) ]
            pub fn cont(&mut self) -> _ContW {
                _ContW { w: self }
            }
            # [ doc = "Bit 22 - Byte Swap" ]
            # [ inline ( always ) ]
            pub fn bysw(&mut self) -> _ByswW {
                _ByswW { w: self }
            }
            # [ doc = "Bit 23 - LSB First" ]
            # [ inline ( always ) ]
            pub fn lsbf(&mut self) -> _LsbfW {
                _LsbfW { w: self }
            }
            # [ doc = "Bits 24:25 - Peripheral Chip Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bits 27:29 - Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&mut self) -> _PrescaleW {
                _PrescaleW { w: self }
            }
            # [ doc = "Bit 30 - Clock Phase" ]
            # [ inline ( always ) ]
            pub fn cpha(&mut self) -> _CphaW {
                _CphaW { w: self }
            }
            # [ doc = "Bit 31 - Clock Polarity" ]
            # [ inline ( always ) ]
            pub fn cpol(&mut self) -> _CpolW {
                _CpolW { w: self }
            }
        }
    }
    # [ doc = "Transmit Data Register" ]
    pub struct Tdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Transmit Data Register" ]
    pub mod tdr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tdr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Transmit Data" ]
            # [ inline ( always ) ]
            pub fn data(&mut self) -> _DataW {
                _DataW { w: self }
            }
        }
    }
    # [ doc = "Receive Status Register" ]
    pub struct Rsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Receive Status Register" ]
    pub mod rsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `SOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SofR {
            # [ doc = "Subsequent data word received after LPSPI_PCS assertion." ]
            _0,
            # [ doc = "First data word received after LPSPI_PCS assertion." ]
            _1,
        }
        impl SofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SofR::_0 => 0,
                    SofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SofR {
                match bits {
                    0 => SofR::_0,
                    1 => SofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SofR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPTY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptyR {
            # [ doc = "RX FIFO is not empty." ]
            _0,
            # [ doc = "RX FIFO is empty." ]
            _1,
        }
        impl RxemptyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptyR::_0 => 0,
                    RxemptyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptyR {
                match bits {
                    0 => RxemptyR::_0,
                    1 => RxemptyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptyR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Start Of Frame" ]
            # [ inline ( always ) ]
            pub fn sof(&self) -> SofR {
                SofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - RX FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn rxempty(&self) -> RxemptyR {
                RxemptyR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
    }
    # [ doc = "Receive Data Register" ]
    pub struct Rdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Receive Data Register" ]
    pub mod rdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rdr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataR {
            bits: u32,
        }
        impl DataR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Receive Data" ]
            # [ inline ( always ) ]
            pub fn data(&self) -> DataR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DataR { bits }
            }
        }
    }
}
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub struct Lpspi0 {
    register_block: lpspi0::RegisterBlock,
}
impl Deref for Lpspi0 {
    type Target = lpspi0::RegisterBlock;
    fn deref(&self) -> &lpspi0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub const LPSPI1: Peripheral<Lpspi1> = unsafe { Peripheral::new(1073926144) };
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub mod lpspi1 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        _reserved0: [u8; 8usize],
        # [ doc = "0x10 - Control Register" ]
        pub cr: Cr,
        # [ doc = "0x14 - Status Register" ]
        pub sr: Sr,
        # [ doc = "0x18 - Interrupt Enable Register" ]
        pub ier: Ier,
        # [ doc = "0x1c - DMA Enable Register" ]
        pub der: Der,
        # [ doc = "0x20 - Configuration Register 0" ]
        pub cfgr0: Cfgr0,
        # [ doc = "0x24 - Configuration Register 1" ]
        pub cfgr1: Cfgr1,
        _reserved1: [u8; 8usize],
        # [ doc = "0x30 - Data Match Register 0" ]
        pub dmr0: Dmr0,
        # [ doc = "0x34 - Data Match Register 1" ]
        pub dmr1: Dmr1,
        _reserved2: [u8; 8usize],
        # [ doc = "0x40 - Clock Configuration Register" ]
        pub ccr: Ccr,
        _reserved3: [u8; 20usize],
        # [ doc = "0x58 - FIFO Control Register" ]
        pub fcr: Fcr,
        # [ doc = "0x5c - FIFO Status Register" ]
        pub fsr: Fsr,
        # [ doc = "0x60 - Transmit Command Register" ]
        pub tcr: Tcr,
        # [ doc = "0x64 - Transmit Data Register" ]
        pub tdr: Tdr,
        _reserved4: [u8; 8usize],
        # [ doc = "0x70 - Receive Status Register" ]
        pub rsr: Rsr,
        # [ doc = "0x74 - Receive Data Register" ]
        pub rdr: Rdr,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set supporting 32-bit shift register." ]
            _0000000000000100,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000100 => 4,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    4 => FeatureR::_0000000000000100,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000100`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000100(&self) -> bool {
                *self == FeatureR::_0000000000000100
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Module Identification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxfifoR {
            bits: u8,
        }
        impl TxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxfifoR {
            bits: u8,
        }
        impl RxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn txfifo(&self) -> TxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxfifoR { bits }
            }
            # [ doc = "Bits 8:15 - Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn rxfifo(&self) -> RxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxfifoR { bits }
            }
        }
    }
    # [ doc = "Control Register" ]
    pub struct Cr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control Register" ]
    pub mod cr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MenR {
            # [ doc = "Module is disabled." ]
            _0,
            # [ doc = "Module is enabled." ]
            _1,
        }
        impl MenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MenR::_0 => 0,
                    MenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MenR {
                match bits {
                    0 => MenR::_0,
                    1 => MenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MenR::_1
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozenR {
            # [ doc = "Module is enabled in Doze mode." ]
            _0,
            # [ doc = "Module is disabled in Doze mode." ]
            _1,
        }
        impl DozenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozenR::_0 => 0,
                    DozenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozenR {
                match bits {
                    0 => DozenR::_0,
                    1 => DozenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozenR::_1
            }
        }
        # [ doc = "Possible values of the field `DBGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgenR {
            # [ doc = "Module is disabled in debug mode." ]
            _0,
            # [ doc = "Module is enabled in debug mode." ]
            _1,
        }
        impl DbgenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgenR::_0 => 0,
                    DbgenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgenR {
                match bits {
                    0 => DbgenR::_0,
                    1 => DbgenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MEN`" ]
        pub enum MenW {
            # [ doc = "Module is disabled." ]
            _0,
            # [ doc = "Module is enabled." ]
            _1,
        }
        impl MenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MenW::_0 => 0,
                    MenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MenW::_0)
            }
            # [ doc = "Module is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master logic is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Master logic is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEN`" ]
        pub enum DozenW {
            # [ doc = "Module is enabled in Doze mode." ]
            _0,
            # [ doc = "Module is disabled in Doze mode." ]
            _1,
        }
        impl DozenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozenW::_0 => 0,
                    DozenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozenW::_0)
            }
            # [ doc = "Module is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBGEN`" ]
        pub enum DbgenW {
            # [ doc = "Module is disabled in debug mode." ]
            _0,
            # [ doc = "Module is enabled in debug mode." ]
            _1,
        }
        impl DbgenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgenW::_0 => 0,
                    DbgenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is disabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgenW::_0)
            }
            # [ doc = "Module is enabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTF`" ]
        pub enum RtfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Transmit FIFO is reset." ]
            _1,
        }
        impl RtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtfW::_0 => 0,
                    RtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtfW::_0)
            }
            # [ doc = "Transmit FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRF`" ]
        pub enum RrfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Receive FIFO is reset." ]
            _1,
        }
        impl RrfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrfW::_0 => 0,
                    RrfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrfW::_0)
            }
            # [ doc = "Receive FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Module Enable" ]
            # [ inline ( always ) ]
            pub fn men(&self) -> MenR {
                MenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&self) -> DozenR {
                DozenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&self) -> DbgenR {
                DbgenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Module Enable" ]
            # [ inline ( always ) ]
            pub fn men(&mut self) -> _MenW {
                _MenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&mut self) -> _DozenW {
                _DozenW { w: self }
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&mut self) -> _DbgenW {
                _DbgenW { w: self }
            }
            # [ doc = "Bit 8 - Reset Transmit FIFO" ]
            # [ inline ( always ) ]
            pub fn rtf(&mut self) -> _RtfW {
                _RtfW { w: self }
            }
            # [ doc = "Bit 9 - Reset Receive FIFO" ]
            # [ inline ( always ) ]
            pub fn rrf(&mut self) -> _RrfW {
                _RrfW { w: self }
            }
        }
    }
    # [ doc = "Status Register" ]
    pub struct Sr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status Register" ]
    pub mod sr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdfR {
            # [ doc = "Transmit data not requested." ]
            _0,
            # [ doc = "Transmit data is requested." ]
            _1,
        }
        impl TdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdfR::_0 => 0,
                    TdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdfR {
                match bits {
                    0 => TdfR::_0,
                    1 => TdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdfR::_1
            }
        }
        # [ doc = "Possible values of the field `RDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdfR {
            # [ doc = "Receive Data is not ready." ]
            _0,
            # [ doc = "Receive data is ready." ]
            _1,
        }
        impl RdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdfR::_0 => 0,
                    RdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdfR {
                match bits {
                    0 => RdfR::_0,
                    1 => RdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdfR::_1
            }
        }
        # [ doc = "Possible values of the field `WCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WcfR {
            # [ doc = "Transfer word not completed." ]
            _0,
            # [ doc = "Transfer word completed." ]
            _1,
        }
        impl WcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WcfR::_0 => 0,
                    WcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WcfR {
                match bits {
                    0 => WcfR::_0,
                    1 => WcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WcfR::_1
            }
        }
        # [ doc = "Possible values of the field `FCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcfR {
            # [ doc = "Frame transfer has not completed." ]
            _0,
            # [ doc = "Frame transfer has completed." ]
            _1,
        }
        impl FcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcfR::_0 => 0,
                    FcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcfR {
                match bits {
                    0 => FcfR::_0,
                    1 => FcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcfR {
            # [ doc = "All transfers have not completed." ]
            _0,
            # [ doc = "All transfers have completed." ]
            _1,
        }
        impl TcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcfR::_0 => 0,
                    TcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcfR {
                match bits {
                    0 => TcfR::_0,
                    1 => TcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TefR {
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            _0,
            # [ doc = "Transmit FIFO underrun has occurred" ]
            _1,
        }
        impl TefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TefR::_0 => 0,
                    TefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TefR {
                match bits {
                    0 => TefR::_0,
                    1 => TefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TefR::_1
            }
        }
        # [ doc = "Possible values of the field `REF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RefR {
            # [ doc = "Receive FIFO has not overflowed." ]
            _0,
            # [ doc = "Receive FIFO has overflowed." ]
            _1,
        }
        impl RefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RefR::_0 => 0,
                    RefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RefR {
                match bits {
                    0 => RefR::_0,
                    1 => RefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RefR::_1
            }
        }
        # [ doc = "Possible values of the field `DMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmfR {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmfR::_0 => 0,
                    DmfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmfR {
                match bits {
                    0 => DmfR::_0,
                    1 => DmfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmfR::_1
            }
        }
        # [ doc = "Possible values of the field `MBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MbfR {
            # [ doc = "LPSPI is idle." ]
            _0,
            # [ doc = "LPSPI is busy." ]
            _1,
        }
        impl MbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MbfR::_0 => 0,
                    MbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MbfR {
                match bits {
                    0 => MbfR::_0,
                    1 => MbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MbfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WCF`" ]
        pub enum WcfW {
            # [ doc = "Transfer word not completed." ]
            _0,
            # [ doc = "Transfer word completed." ]
            _1,
        }
        impl WcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WcfW::_0 => 0,
                    WcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfer word not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WcfW::_0)
            }
            # [ doc = "Transfer word completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FCF`" ]
        pub enum FcfW {
            # [ doc = "Frame transfer has not completed." ]
            _0,
            # [ doc = "Frame transfer has completed." ]
            _1,
        }
        impl FcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcfW::_0 => 0,
                    FcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Frame transfer has not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FcfW::_0)
            }
            # [ doc = "Frame transfer has completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCF`" ]
        pub enum TcfW {
            # [ doc = "All transfers have not completed." ]
            _0,
            # [ doc = "All transfers have completed." ]
            _1,
        }
        impl TcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcfW::_0 => 0,
                    TcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "All transfers have not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcfW::_0)
            }
            # [ doc = "All transfers have completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TEF`" ]
        pub enum TefW {
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            _0,
            # [ doc = "Transmit FIFO underrun has occurred" ]
            _1,
        }
        impl TefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TefW::_0 => 0,
                    TefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TefW::_0)
            }
            # [ doc = "Transmit FIFO underrun has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REF`" ]
        pub enum RefW {
            # [ doc = "Receive FIFO has not overflowed." ]
            _0,
            # [ doc = "Receive FIFO has overflowed." ]
            _1,
        }
        impl RefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RefW::_0 => 0,
                    RefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive FIFO has not overflowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RefW::_0)
            }
            # [ doc = "Receive FIFO has overflowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMF`" ]
        pub enum DmfW {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmfW::_0 => 0,
                    DmfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Have not received matching data." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmfW::_0)
            }
            # [ doc = "Have received matching data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Flag" ]
            # [ inline ( always ) ]
            pub fn tdf(&self) -> TdfR {
                TdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Receive Data Flag" ]
            # [ inline ( always ) ]
            pub fn rdf(&self) -> RdfR {
                RdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Word Complete Flag" ]
            # [ inline ( always ) ]
            pub fn wcf(&self) -> WcfR {
                WcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Frame Complete Flag" ]
            # [ inline ( always ) ]
            pub fn fcf(&self) -> FcfR {
                FcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Transfer Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&self) -> TcfR {
                TcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Transmit Error Flag" ]
            # [ inline ( always ) ]
            pub fn tef(&self) -> TefR {
                TefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 11;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Receive Error Flag" ]
            # [ inline ( always ) ]
            pub fn ref_(&self) -> RefR {
                RefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&self) -> DmfR {
                DmfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Module Busy Flag" ]
            # [ inline ( always ) ]
            pub fn mbf(&self) -> MbfR {
                MbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Word Complete Flag" ]
            # [ inline ( always ) ]
            pub fn wcf(&mut self) -> _WcfW {
                _WcfW { w: self }
            }
            # [ doc = "Bit 9 - Frame Complete Flag" ]
            # [ inline ( always ) ]
            pub fn fcf(&mut self) -> _FcfW {
                _FcfW { w: self }
            }
            # [ doc = "Bit 10 - Transfer Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&mut self) -> _TcfW {
                _TcfW { w: self }
            }
            # [ doc = "Bit 11 - Transmit Error Flag" ]
            # [ inline ( always ) ]
            pub fn tef(&mut self) -> _TefW {
                _TefW { w: self }
            }
            # [ doc = "Bit 12 - Receive Error Flag" ]
            # [ inline ( always ) ]
            pub fn ref_(&mut self) -> _RefW {
                _RefW { w: self }
            }
            # [ doc = "Bit 13 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&mut self) -> _DmfW {
                _DmfW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Enable Register" ]
    pub struct Ier {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Enable Register" ]
    pub mod ier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdieR::_0 => 0,
                    TdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdieR {
                match bits {
                    0 => TdieR::_0,
                    1 => TdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdieR::_0 => 0,
                    RdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdieR {
                match bits {
                    0 => RdieR::_0,
                    1 => RdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdieR::_1
            }
        }
        # [ doc = "Possible values of the field `WCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WcieR::_0 => 0,
                    WcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WcieR {
                match bits {
                    0 => WcieR::_0,
                    1 => WcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WcieR::_1
            }
        }
        # [ doc = "Possible values of the field `FCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcieR::_0 => 0,
                    FcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcieR {
                match bits {
                    0 => FcieR::_0,
                    1 => FcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcieR::_0 => 0,
                    TcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcieR {
                match bits {
                    0 => TcieR::_0,
                    1 => TcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TeieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TeieR::_0 => 0,
                    TeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TeieR {
                match bits {
                    0 => TeieR::_0,
                    1 => TeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TeieR::_1
            }
        }
        # [ doc = "Possible values of the field `REIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl ReieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReieR::_0 => 0,
                    ReieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReieR {
                match bits {
                    0 => ReieR::_0,
                    1 => ReieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReieR::_1
            }
        }
        # [ doc = "Possible values of the field `DMIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmieR::_0 => 0,
                    DmieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmieR {
                match bits {
                    0 => DmieR::_0,
                    1 => DmieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDIE`" ]
        pub enum TdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdieW::_0 => 0,
                    TdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdieW::_0)
            }
            # [ doc = "Interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDIE`" ]
        pub enum RdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdieW::_0 => 0,
                    RdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WCIE`" ]
        pub enum WcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WcieW::_0 => 0,
                    WcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FCIE`" ]
        pub enum FcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcieW::_0 => 0,
                    FcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCIE`" ]
        pub enum TcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcieW::_0 => 0,
                    TcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TEIE`" ]
        pub enum TeieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TeieW::_0 => 0,
                    TeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TeieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REIE`" ]
        pub enum ReieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl ReieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReieW::_0 => 0,
                    ReieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMIE`" ]
        pub enum DmieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmieW::_0 => 0,
                    DmieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&self) -> TdieR {
                TdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&self) -> RdieR {
                RdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Word Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wcie(&self) -> WcieR {
                WcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Frame Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fcie(&self) -> FcieR {
                FcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Transfer Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tcie(&self) -> TcieR {
                TcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Transmit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&self) -> TeieR {
                TeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Receive Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn reie(&self) -> ReieR {
                ReieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 13 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&self) -> DmieR {
                DmieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&mut self) -> _TdieW {
                _TdieW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&mut self) -> _RdieW {
                _RdieW { w: self }
            }
            # [ doc = "Bit 8 - Word Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wcie(&mut self) -> _WcieW {
                _WcieW { w: self }
            }
            # [ doc = "Bit 9 - Frame Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fcie(&mut self) -> _FcieW {
                _FcieW { w: self }
            }
            # [ doc = "Bit 10 - Transfer Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tcie(&mut self) -> _TcieW {
                _TcieW { w: self }
            }
            # [ doc = "Bit 11 - Transmit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&mut self) -> _TeieW {
                _TeieW { w: self }
            }
            # [ doc = "Bit 12 - Receive Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn reie(&mut self) -> _ReieW {
                _ReieW { w: self }
            }
            # [ doc = "Bit 13 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&mut self) -> _DmieW {
                _DmieW { w: self }
            }
        }
    }
    # [ doc = "DMA Enable Register" ]
    pub struct Der {
        register: VolatileCell<u32>,
    }
    # [ doc = "DMA Enable Register" ]
    pub mod der {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Der {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TddeR::_0 => 0,
                    TddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TddeR {
                match bits {
                    0 => TddeR::_0,
                    1 => TddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TddeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RddeR::_0 => 0,
                    RddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RddeR {
                match bits {
                    0 => RddeR::_0,
                    1 => RddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RddeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDDE`" ]
        pub enum TddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TddeW::_0 => 0,
                    TddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TddeW::_0)
            }
            # [ doc = "DMA request enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDDE`" ]
        pub enum RddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RddeW::_0 => 0,
                    RddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RddeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&self) -> TddeR {
                TddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&self) -> RddeR {
                RddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&mut self) -> _TddeW {
                _TddeW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&mut self) -> _RddeW {
                _RddeW { w: self }
            }
        }
    }
    # [ doc = "Configuration Register 0" ]
    pub struct Cfgr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration Register 0" ]
    pub mod cfgr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfgr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrenR {
            # [ doc = "Host request is disabled." ]
            _0,
            # [ doc = "Host request is enabled." ]
            _1,
        }
        impl HrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrenR::_0 => 0,
                    HrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrenR {
                match bits {
                    0 => HrenR::_0,
                    1 => HrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrenR::_1
            }
        }
        # [ doc = "Possible values of the field `HRPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrpolR {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrpolR::_0 => 0,
                    HrpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrpolR {
                match bits {
                    0 => HrpolR::_0,
                    1 => HrpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrpolR::_1
            }
        }
        # [ doc = "Possible values of the field `HRSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrselR {
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrselR::_0 => 0,
                    HrselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrselR {
                match bits {
                    0 => HrselR::_0,
                    1 => HrselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrselR::_1
            }
        }
        # [ doc = "Possible values of the field `CIRFIFO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CirfifoR {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CirfifoR::_0 => 0,
                    CirfifoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CirfifoR {
                match bits {
                    0 => CirfifoR::_0,
                    1 => CirfifoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CirfifoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CirfifoR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmoR {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the DMF is set." ]
            _1,
        }
        impl RdmoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmoR::_0 => 0,
                    RdmoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmoR {
                match bits {
                    0 => RdmoR::_0,
                    1 => RdmoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HREN`" ]
        pub enum HrenW {
            # [ doc = "Host request is disabled." ]
            _0,
            # [ doc = "Host request is enabled." ]
            _1,
        }
        impl HrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrenW::_0 => 0,
                    HrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrenW::_0)
            }
            # [ doc = "Host request is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRPOL`" ]
        pub enum HrpolW {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrpolW::_0 => 0,
                    HrpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrpolW::_0)
            }
            # [ doc = "Active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRSEL`" ]
        pub enum HrselW {
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrselW::_0 => 0,
                    HrselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrselW::_0)
            }
            # [ doc = "Host request input is input trigger." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CIRFIFO`" ]
        pub enum CirfifoW {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CirfifoW::_0 => 0,
                    CirfifoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CirfifoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CirfifoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CirfifoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Circular FIFO is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CirfifoW::_0)
            }
            # [ doc = "Circular FIFO is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CirfifoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMO`" ]
        pub enum RdmoW {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the DMF is set." ]
            _1,
        }
        impl RdmoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmoW::_0 => 0,
                    RdmoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmoW::_0)
            }
            # [ doc = "Received data is discarded unless the DMF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&self) -> HrenR {
                HrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&self) -> HrpolR {
                HrpolR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&self) -> HrselR {
                HrselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&self) -> CirfifoR {
                CirfifoR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&self) -> RdmoR {
                RdmoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&mut self) -> _HrenW {
                _HrenW { w: self }
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&mut self) -> _HrpolW {
                _HrpolW { w: self }
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&mut self) -> _HrselW {
                _HrselW { w: self }
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&mut self) -> _CirfifoW {
                _CirfifoW { w: self }
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&mut self) -> _RdmoW {
                _RdmoW { w: self }
            }
        }
    }
    # [ doc = "Configuration Register 1" ]
    pub struct Cfgr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration Register 1" ]
    pub mod cfgr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfgr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MASTER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MasterR {
            # [ doc = "Slave mode." ]
            _0,
            # [ doc = "Master mode." ]
            _1,
        }
        impl MasterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MasterR::_0 => 0,
                    MasterR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MasterR {
                match bits {
                    0 => MasterR::_0,
                    1 => MasterR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MasterR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MasterR::_1
            }
        }
        # [ doc = "Possible values of the field `SAMPLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SampleR {
            # [ doc = "Input data sampled on SCK edge." ]
            _0,
            # [ doc = "Input data sampled on delayed SCK edge." ]
            _1,
        }
        impl SampleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SampleR::_0 => 0,
                    SampleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SampleR {
                match bits {
                    0 => SampleR::_0,
                    1 => SampleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SampleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SampleR::_1
            }
        }
        # [ doc = "Possible values of the field `AUTOPCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AutopcsR {
            # [ doc = "Automatic PCS generation disabled." ]
            _0,
            # [ doc = "Automatic PCS generation enabled." ]
            _1,
        }
        impl AutopcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AutopcsR::_0 => 0,
                    AutopcsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AutopcsR {
                match bits {
                    0 => AutopcsR::_0,
                    1 => AutopcsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AutopcsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AutopcsR::_1
            }
        }
        # [ doc = "Possible values of the field `NOSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NostallR {
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            _0,
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            _1,
        }
        impl NostallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NostallR::_0 => 0,
                    NostallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NostallR {
                match bits {
                    0 => NostallR::_0,
                    1 => NostallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NostallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NostallR::_1
            }
        }
        # [ doc = "Possible values of the field `PCSPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcspolR {
            # [ doc = "The PCSx is active low." ]
            _0000,
            # [ doc = "The PCSx is active high." ]
            _0001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PcspolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcspolR::_0000 => 0,
                    PcspolR::_0001 => 1,
                    PcspolR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcspolR {
                match bits {
                    0 => PcspolR::_0000,
                    1 => PcspolR::_0001,
                    i => PcspolR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == PcspolR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == PcspolR::_0001
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Match is disabled." ]
            _000,
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            _010,
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            _011,
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            _100,
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            _101,
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _110,
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_000 => 0,
                    MatcfgR::_010 => 2,
                    MatcfgR::_011 => 3,
                    MatcfgR::_100 => 4,
                    MatcfgR::_101 => 5,
                    MatcfgR::_110 => 6,
                    MatcfgR::_111 => 7,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_000,
                    2 => MatcfgR::_010,
                    3 => MatcfgR::_011,
                    4 => MatcfgR::_100,
                    5 => MatcfgR::_101,
                    6 => MatcfgR::_110,
                    7 => MatcfgR::_111,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MatcfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MatcfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MatcfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MatcfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MatcfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MatcfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MatcfgR::_111
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            _00,
            # [ doc = "SIN is used for both input and output data." ]
            _01,
            # [ doc = "SOUT is used for both input and output data." ]
            _10,
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_00 => 0,
                    PincfgR::_01 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_00,
                    1 => PincfgR::_01,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PincfgR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PincfgR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `OUTCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OutcfgR {
            # [ doc = "Output data retains last value when chip select is negated." ]
            _0,
            # [ doc = "Output data is tristated when chip select is negated." ]
            _1,
        }
        impl OutcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OutcfgR::_0 => 0,
                    OutcfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OutcfgR {
                match bits {
                    0 => OutcfgR::_0,
                    1 => OutcfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OutcfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OutcfgR::_1
            }
        }
        # [ doc = "Possible values of the field `PCSCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcscfgR {
            # [ doc = "PCS[3:2] are enabled." ]
            _0,
            # [ doc = "PCS[3:2] are disabled." ]
            _1,
        }
        impl PcscfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcscfgR::_0 => 0,
                    PcscfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcscfgR {
                match bits {
                    0 => PcscfgR::_0,
                    1 => PcscfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PcscfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PcscfgR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MASTER`" ]
        pub enum MasterW {
            # [ doc = "Slave mode." ]
            _0,
            # [ doc = "Master mode." ]
            _1,
        }
        impl MasterW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MasterW::_0 => 0,
                    MasterW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MasterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MasterW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MasterW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MasterW::_0)
            }
            # [ doc = "Master mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MasterW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SAMPLE`" ]
        pub enum SampleW {
            # [ doc = "Input data sampled on SCK edge." ]
            _0,
            # [ doc = "Input data sampled on delayed SCK edge." ]
            _1,
        }
        impl SampleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SampleW::_0 => 0,
                    SampleW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SampleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SampleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SampleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Input data sampled on SCK edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SampleW::_0)
            }
            # [ doc = "Input data sampled on delayed SCK edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SampleW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AUTOPCS`" ]
        pub enum AutopcsW {
            # [ doc = "Automatic PCS generation disabled." ]
            _0,
            # [ doc = "Automatic PCS generation enabled." ]
            _1,
        }
        impl AutopcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AutopcsW::_0 => 0,
                    AutopcsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AutopcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AutopcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AutopcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Automatic PCS generation disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AutopcsW::_0)
            }
            # [ doc = "Automatic PCS generation enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AutopcsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOSTALL`" ]
        pub enum NostallW {
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            _0,
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            _1,
        }
        impl NostallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NostallW::_0 => 0,
                    NostallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NostallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NostallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NostallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NostallW::_0)
            }
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NostallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCSPOL`" ]
        pub enum PcspolW {
            # [ doc = "The PCSx is active low." ]
            _0000,
            # [ doc = "The PCSx is active high." ]
            _0001,
        }
        impl PcspolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcspolW::_0000 => 0,
                    PcspolW::_0001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcspolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcspolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcspolW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The PCSx is active low." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(PcspolW::_0000)
            }
            # [ doc = "The PCSx is active high." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(PcspolW::_0001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Match is disabled." ]
            _000,
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            _010,
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            _011,
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            _100,
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            _101,
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _110,
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _111,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_000 => 0,
                    MatcfgW::_010 => 2,
                    MatcfgW::_011 => 3,
                    MatcfgW::_100 => 4,
                    MatcfgW::_101 => 5,
                    MatcfgW::_110 => 6,
                    MatcfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Match is disabled." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MatcfgW::_000)
            }
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MatcfgW::_010)
            }
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MatcfgW::_011)
            }
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MatcfgW::_100)
            }
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MatcfgW::_101)
            }
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MatcfgW::_110)
            }
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MatcfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            _00,
            # [ doc = "SIN is used for both input and output data." ]
            _01,
            # [ doc = "SOUT is used for both input and output data." ]
            _10,
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_00 => 0,
                    PincfgW::_01 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PincfgW::_00)
            }
            # [ doc = "SIN is used for both input and output data." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PincfgW::_01)
            }
            # [ doc = "SOUT is used for both input and output data." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OUTCFG`" ]
        pub enum OutcfgW {
            # [ doc = "Output data retains last value when chip select is negated." ]
            _0,
            # [ doc = "Output data is tristated when chip select is negated." ]
            _1,
        }
        impl OutcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OutcfgW::_0 => 0,
                    OutcfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OutcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OutcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OutcfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output data retains last value when chip select is negated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OutcfgW::_0)
            }
            # [ doc = "Output data is tristated when chip select is negated." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OutcfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCSCFG`" ]
        pub enum PcscfgW {
            # [ doc = "PCS[3:2] are enabled." ]
            _0,
            # [ doc = "PCS[3:2] are disabled." ]
            _1,
        }
        impl PcscfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcscfgW::_0 => 0,
                    PcscfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcscfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcscfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcscfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PCS[3:2] are enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PcscfgW::_0)
            }
            # [ doc = "PCS[3:2] are disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PcscfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Master Mode" ]
            # [ inline ( always ) ]
            pub fn master(&self) -> MasterR {
                MasterR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Sample Point" ]
            # [ inline ( always ) ]
            pub fn sample(&self) -> SampleR {
                SampleR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Automatic PCS" ]
            # [ inline ( always ) ]
            pub fn autopcs(&self) -> AutopcsR {
                AutopcsR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - No Stall" ]
            # [ inline ( always ) ]
            pub fn nostall(&self) -> NostallR {
                NostallR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 8:11 - Peripheral Chip Select Polarity" ]
            # [ inline ( always ) ]
            pub fn pcspol(&self) -> PcspolR {
                PcspolR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Output Config" ]
            # [ inline ( always ) ]
            pub fn outcfg(&self) -> OutcfgR {
                OutcfgR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 26;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 27 - Peripheral Chip Select Configuration" ]
            # [ inline ( always ) ]
            pub fn pcscfg(&self) -> PcscfgR {
                PcscfgR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Master Mode" ]
            # [ inline ( always ) ]
            pub fn master(&mut self) -> _MasterW {
                _MasterW { w: self }
            }
            # [ doc = "Bit 1 - Sample Point" ]
            # [ inline ( always ) ]
            pub fn sample(&mut self) -> _SampleW {
                _SampleW { w: self }
            }
            # [ doc = "Bit 2 - Automatic PCS" ]
            # [ inline ( always ) ]
            pub fn autopcs(&mut self) -> _AutopcsW {
                _AutopcsW { w: self }
            }
            # [ doc = "Bit 3 - No Stall" ]
            # [ inline ( always ) ]
            pub fn nostall(&mut self) -> _NostallW {
                _NostallW { w: self }
            }
            # [ doc = "Bits 8:11 - Peripheral Chip Select Polarity" ]
            # [ inline ( always ) ]
            pub fn pcspol(&mut self) -> _PcspolW {
                _PcspolW { w: self }
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bits 24:25 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 26 - Output Config" ]
            # [ inline ( always ) ]
            pub fn outcfg(&mut self) -> _OutcfgW {
                _OutcfgW { w: self }
            }
            # [ doc = "Bit 27 - Peripheral Chip Select Configuration" ]
            # [ inline ( always ) ]
            pub fn pcscfg(&mut self) -> _PcscfgW {
                _PcscfgW { w: self }
            }
        }
    }
    # [ doc = "Data Match Register 0" ]
    pub struct Dmr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Data Match Register 0" ]
    pub mod dmr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dmr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match0R {
            bits: u32,
        }
        impl Match0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&self) -> Match0R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Match0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&mut self) -> _Match0W {
                _Match0W { w: self }
            }
        }
    }
    # [ doc = "Data Match Register 1" ]
    pub struct Dmr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Data Match Register 1" ]
    pub mod dmr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dmr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match1R {
            bits: u32,
        }
        impl Match1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&self) -> Match1R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Match1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&mut self) -> _Match1W {
                _Match1W { w: self }
            }
        }
    }
    # [ doc = "Clock Configuration Register" ]
    pub struct Ccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Clock Configuration Register" ]
    pub mod ccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SckdivR {
            bits: u8,
        }
        impl SckdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DbtR {
            bits: u8,
        }
        impl DbtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PcssckR {
            bits: u8,
        }
        impl PcssckR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SckpcsR {
            bits: u8,
        }
        impl SckpcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SckdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SckdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcssckW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcssckW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SckpcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SckpcsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - SCK Divider" ]
            # [ inline ( always ) ]
            pub fn sckdiv(&self) -> SckdivR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SckdivR { bits }
            }
            # [ doc = "Bits 8:15 - Delay Between Transfers" ]
            # [ inline ( always ) ]
            pub fn dbt(&self) -> DbtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DbtR { bits }
            }
            # [ doc = "Bits 16:23 - PCS to SCK Delay" ]
            # [ inline ( always ) ]
            pub fn pcssck(&self) -> PcssckR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PcssckR { bits }
            }
            # [ doc = "Bits 24:31 - SCK to PCS Delay" ]
            # [ inline ( always ) ]
            pub fn sckpcs(&self) -> SckpcsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SckpcsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - SCK Divider" ]
            # [ inline ( always ) ]
            pub fn sckdiv(&mut self) -> _SckdivW {
                _SckdivW { w: self }
            }
            # [ doc = "Bits 8:15 - Delay Between Transfers" ]
            # [ inline ( always ) ]
            pub fn dbt(&mut self) -> _DbtW {
                _DbtW { w: self }
            }
            # [ doc = "Bits 16:23 - PCS to SCK Delay" ]
            # [ inline ( always ) ]
            pub fn pcssck(&mut self) -> _PcssckW {
                _PcssckW { w: self }
            }
            # [ doc = "Bits 24:31 - SCK to PCS Delay" ]
            # [ inline ( always ) ]
            pub fn sckpcs(&mut self) -> _SckpcsW {
                _SckpcsW { w: self }
            }
        }
    }
    # [ doc = "FIFO Control Register" ]
    pub struct Fcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "FIFO Control Register" ]
    pub mod fcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
    # [ doc = "FIFO Status Register" ]
    pub struct Fsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "FIFO Status Register" ]
    pub mod fsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Fsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Transmit FIFO Count" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:18 - Receive FIFO Count" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
    }
    # [ doc = "Transmit Command Register" ]
    pub struct Tcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Transmit Command Register" ]
    pub mod tcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FrameszR {
            bits: u16,
        }
        impl FrameszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WIDTH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WidthR {
            # [ doc = "Single bit transfer." ]
            _00,
            # [ doc = "Two bit transfer." ]
            _01,
            # [ doc = "Four bit transfer." ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl WidthR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WidthR::_00 => 0,
                    WidthR::_01 => 1,
                    WidthR::_10 => 2,
                    WidthR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WidthR {
                match bits {
                    0 => WidthR::_00,
                    1 => WidthR::_01,
                    2 => WidthR::_10,
                    i => WidthR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == WidthR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == WidthR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == WidthR::_10
            }
        }
        # [ doc = "Possible values of the field `TXMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxmskR {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Mask transmit data." ]
            _1,
        }
        impl TxmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxmskR::_0 => 0,
                    TxmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxmskR {
                match bits {
                    0 => TxmskR::_0,
                    1 => TxmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxmskR::_1
            }
        }
        # [ doc = "Possible values of the field `RXMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxmskR {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Receive data is masked." ]
            _1,
        }
        impl RxmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxmskR::_0 => 0,
                    RxmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxmskR {
                match bits {
                    0 => RxmskR::_0,
                    1 => RxmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxmskR::_1
            }
        }
        # [ doc = "Possible values of the field `CONTC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContcR {
            # [ doc = "Command word for start of new transfer." ]
            _0,
            # [ doc = "Command word for continuing transfer." ]
            _1,
        }
        impl ContcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContcR::_0 => 0,
                    ContcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContcR {
                match bits {
                    0 => ContcR::_0,
                    1 => ContcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContcR::_1
            }
        }
        # [ doc = "Possible values of the field `CONT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContR {
            # [ doc = "Continuous transfer disabled." ]
            _0,
            # [ doc = "Continuous transfer enabled." ]
            _1,
        }
        impl ContR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContR::_0 => 0,
                    ContR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContR {
                match bits {
                    0 => ContR::_0,
                    1 => ContR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContR::_1
            }
        }
        # [ doc = "Possible values of the field `BYSW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ByswR {
            # [ doc = "Byte swap disabled." ]
            _0,
            # [ doc = "Byte swap enabled." ]
            _1,
        }
        impl ByswR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ByswR::_0 => 0,
                    ByswR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ByswR {
                match bits {
                    0 => ByswR::_0,
                    1 => ByswR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ByswR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ByswR::_1
            }
        }
        # [ doc = "Possible values of the field `LSBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LsbfR {
            # [ doc = "Data is transferred MSB first." ]
            _0,
            # [ doc = "Data is transferred LSB first." ]
            _1,
        }
        impl LsbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LsbfR::_0 => 0,
                    LsbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LsbfR {
                match bits {
                    0 => LsbfR::_0,
                    1 => LsbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LsbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LsbfR::_1
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            _00,
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            _01,
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            _10,
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            _11,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_00 => 0,
                    PcsR::_01 => 1,
                    PcsR::_10 => 2,
                    PcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_00,
                    1 => PcsR::_01,
                    2 => PcsR::_10,
                    3 => PcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PcsR::_11
            }
        }
        # [ doc = "Possible values of the field `PRESCALE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescaleR {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescaleR::_000 => 0,
                    PrescaleR::_001 => 1,
                    PrescaleR::_010 => 2,
                    PrescaleR::_011 => 3,
                    PrescaleR::_100 => 4,
                    PrescaleR::_101 => 5,
                    PrescaleR::_110 => 6,
                    PrescaleR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescaleR {
                match bits {
                    0 => PrescaleR::_000,
                    1 => PrescaleR::_001,
                    2 => PrescaleR::_010,
                    3 => PrescaleR::_011,
                    4 => PrescaleR::_100,
                    5 => PrescaleR::_101,
                    6 => PrescaleR::_110,
                    7 => PrescaleR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PrescaleR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PrescaleR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PrescaleR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PrescaleR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PrescaleR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PrescaleR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PrescaleR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PrescaleR::_111
            }
        }
        # [ doc = "Possible values of the field `CPHA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CphaR {
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            _0,
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            _1,
        }
        impl CphaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CphaR::_0 => 0,
                    CphaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CphaR {
                match bits {
                    0 => CphaR::_0,
                    1 => CphaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CphaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CphaR::_1
            }
        }
        # [ doc = "Possible values of the field `CPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpolR {
            # [ doc = "The inactive state value of SCK is low." ]
            _0,
            # [ doc = "The inactive state value of SCK is high." ]
            _1,
        }
        impl CpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpolR::_0 => 0,
                    CpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpolR {
                match bits {
                    0 => CpolR::_0,
                    1 => CpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpolR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrameszW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrameszW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WIDTH`" ]
        pub enum WidthW {
            # [ doc = "Single bit transfer." ]
            _00,
            # [ doc = "Two bit transfer." ]
            _01,
            # [ doc = "Four bit transfer." ]
            _10,
        }
        impl WidthW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WidthW::_00 => 0,
                    WidthW::_01 => 1,
                    WidthW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WidthW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WidthW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WidthW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Single bit transfer." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(WidthW::_00)
            }
            # [ doc = "Two bit transfer." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(WidthW::_01)
            }
            # [ doc = "Four bit transfer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(WidthW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXMSK`" ]
        pub enum TxmskW {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Mask transmit data." ]
            _1,
        }
        impl TxmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxmskW::_0 => 0,
                    TxmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxmskW::_0)
            }
            # [ doc = "Mask transmit data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXMSK`" ]
        pub enum RxmskW {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Receive data is masked." ]
            _1,
        }
        impl RxmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxmskW::_0 => 0,
                    RxmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxmskW::_0)
            }
            # [ doc = "Receive data is masked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONTC`" ]
        pub enum ContcW {
            # [ doc = "Command word for start of new transfer." ]
            _0,
            # [ doc = "Command word for continuing transfer." ]
            _1,
        }
        impl ContcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContcW::_0 => 0,
                    ContcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Command word for start of new transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContcW::_0)
            }
            # [ doc = "Command word for continuing transfer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONT`" ]
        pub enum ContW {
            # [ doc = "Continuous transfer disabled." ]
            _0,
            # [ doc = "Continuous transfer enabled." ]
            _1,
        }
        impl ContW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContW::_0 => 0,
                    ContW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Continuous transfer disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContW::_0)
            }
            # [ doc = "Continuous transfer enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BYSW`" ]
        pub enum ByswW {
            # [ doc = "Byte swap disabled." ]
            _0,
            # [ doc = "Byte swap enabled." ]
            _1,
        }
        impl ByswW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ByswW::_0 => 0,
                    ByswW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ByswW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ByswW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ByswW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Byte swap disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ByswW::_0)
            }
            # [ doc = "Byte swap enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ByswW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LSBF`" ]
        pub enum LsbfW {
            # [ doc = "Data is transferred MSB first." ]
            _0,
            # [ doc = "Data is transferred LSB first." ]
            _1,
        }
        impl LsbfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LsbfW::_0 => 0,
                    LsbfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LsbfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LsbfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LsbfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data is transferred MSB first." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LsbfW::_0)
            }
            # [ doc = "Data is transferred LSB first." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LsbfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            _00,
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            _01,
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            _10,
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            _11,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_00 => 0,
                    PcsW::_01 => 1,
                    PcsW::_10 => 2,
                    PcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PcsW::_00)
            }
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PcsW::_01)
            }
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PcsW::_10)
            }
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALE`" ]
        pub enum PrescaleW {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescaleW::_000 => 0,
                    PrescaleW::_001 => 1,
                    PrescaleW::_010 => 2,
                    PrescaleW::_011 => 3,
                    PrescaleW::_100 => 4,
                    PrescaleW::_101 => 5,
                    PrescaleW::_110 => 6,
                    PrescaleW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescaleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescaleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescaleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PrescaleW::_000)
            }
            # [ doc = "Divide by 2." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PrescaleW::_001)
            }
            # [ doc = "Divide by 4." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PrescaleW::_010)
            }
            # [ doc = "Divide by 8." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PrescaleW::_011)
            }
            # [ doc = "Divide by 16." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PrescaleW::_100)
            }
            # [ doc = "Divide by 32." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PrescaleW::_101)
            }
            # [ doc = "Divide by 64." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PrescaleW::_110)
            }
            # [ doc = "Divide by 128." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PrescaleW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPHA`" ]
        pub enum CphaW {
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            _0,
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            _1,
        }
        impl CphaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CphaW::_0 => 0,
                    CphaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CphaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CphaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CphaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CphaW::_0)
            }
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CphaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPOL`" ]
        pub enum CpolW {
            # [ doc = "The inactive state value of SCK is low." ]
            _0,
            # [ doc = "The inactive state value of SCK is high." ]
            _1,
        }
        impl CpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpolW::_0 => 0,
                    CpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The inactive state value of SCK is low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpolW::_0)
            }
            # [ doc = "The inactive state value of SCK is high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - Frame Size" ]
            # [ inline ( always ) ]
            pub fn framesz(&self) -> FrameszR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FrameszR { bits }
            }
            # [ doc = "Bits 16:17 - Transfer Width" ]
            # [ inline ( always ) ]
            pub fn width(&self) -> WidthR {
                WidthR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Transmit Data Mask" ]
            # [ inline ( always ) ]
            pub fn txmsk(&self) -> TxmskR {
                TxmskR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 19 - Receive Data Mask" ]
            # [ inline ( always ) ]
            pub fn rxmsk(&self) -> RxmskR {
                RxmskR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 19;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 20 - Continuing Command" ]
            # [ inline ( always ) ]
            pub fn contc(&self) -> ContcR {
                ContcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Continuous Transfer" ]
            # [ inline ( always ) ]
            pub fn cont(&self) -> ContR {
                ContR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Byte Swap" ]
            # [ inline ( always ) ]
            pub fn bysw(&self) -> ByswR {
                ByswR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - LSB First" ]
            # [ inline ( always ) ]
            pub fn lsbf(&self) -> LsbfR {
                LsbfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 23;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:25 - Peripheral Chip Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 27:29 - Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&self) -> PrescaleR {
                PrescaleR::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 27;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 30 - Clock Phase" ]
            # [ inline ( always ) ]
            pub fn cpha(&self) -> CphaR {
                CphaR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 31 - Clock Polarity" ]
            # [ inline ( always ) ]
            pub fn cpol(&self) -> CpolR {
                CpolR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 31 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - Frame Size" ]
            # [ inline ( always ) ]
            pub fn framesz(&mut self) -> _FrameszW {
                _FrameszW { w: self }
            }
            # [ doc = "Bits 16:17 - Transfer Width" ]
            # [ inline ( always ) ]
            pub fn width(&mut self) -> _WidthW {
                _WidthW { w: self }
            }
            # [ doc = "Bit 18 - Transmit Data Mask" ]
            # [ inline ( always ) ]
            pub fn txmsk(&mut self) -> _TxmskW {
                _TxmskW { w: self }
            }
            # [ doc = "Bit 19 - Receive Data Mask" ]
            # [ inline ( always ) ]
            pub fn rxmsk(&mut self) -> _RxmskW {
                _RxmskW { w: self }
            }
            # [ doc = "Bit 20 - Continuing Command" ]
            # [ inline ( always ) ]
            pub fn contc(&mut self) -> _ContcW {
                _ContcW { w: self }
            }
            # [ doc = "Bit 21 - Continuous Transfer" ]
            # [ inline ( always ) ]
            pub fn cont(&mut self) -> _ContW {
                _ContW { w: self }
            }
            # [ doc = "Bit 22 - Byte Swap" ]
            # [ inline ( always ) ]
            pub fn bysw(&mut self) -> _ByswW {
                _ByswW { w: self }
            }
            # [ doc = "Bit 23 - LSB First" ]
            # [ inline ( always ) ]
            pub fn lsbf(&mut self) -> _LsbfW {
                _LsbfW { w: self }
            }
            # [ doc = "Bits 24:25 - Peripheral Chip Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bits 27:29 - Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&mut self) -> _PrescaleW {
                _PrescaleW { w: self }
            }
            # [ doc = "Bit 30 - Clock Phase" ]
            # [ inline ( always ) ]
            pub fn cpha(&mut self) -> _CphaW {
                _CphaW { w: self }
            }
            # [ doc = "Bit 31 - Clock Polarity" ]
            # [ inline ( always ) ]
            pub fn cpol(&mut self) -> _CpolW {
                _CpolW { w: self }
            }
        }
    }
    # [ doc = "Transmit Data Register" ]
    pub struct Tdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Transmit Data Register" ]
    pub mod tdr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tdr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Transmit Data" ]
            # [ inline ( always ) ]
            pub fn data(&mut self) -> _DataW {
                _DataW { w: self }
            }
        }
    }
    # [ doc = "Receive Status Register" ]
    pub struct Rsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Receive Status Register" ]
    pub mod rsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `SOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SofR {
            # [ doc = "Subsequent data word received after LPSPI_PCS assertion." ]
            _0,
            # [ doc = "First data word received after LPSPI_PCS assertion." ]
            _1,
        }
        impl SofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SofR::_0 => 0,
                    SofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SofR {
                match bits {
                    0 => SofR::_0,
                    1 => SofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SofR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPTY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptyR {
            # [ doc = "RX FIFO is not empty." ]
            _0,
            # [ doc = "RX FIFO is empty." ]
            _1,
        }
        impl RxemptyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptyR::_0 => 0,
                    RxemptyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptyR {
                match bits {
                    0 => RxemptyR::_0,
                    1 => RxemptyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptyR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Start Of Frame" ]
            # [ inline ( always ) ]
            pub fn sof(&self) -> SofR {
                SofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - RX FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn rxempty(&self) -> RxemptyR {
                RxemptyR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
    }
    # [ doc = "Receive Data Register" ]
    pub struct Rdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Receive Data Register" ]
    pub mod rdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rdr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataR {
            bits: u32,
        }
        impl DataR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Receive Data" ]
            # [ inline ( always ) ]
            pub fn data(&self) -> DataR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DataR { bits }
            }
        }
    }
}
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub struct Lpspi1 {
    register_block: lpspi1::RegisterBlock,
}
impl Deref for Lpspi1 {
    type Target = lpspi1::RegisterBlock;
    fn deref(&self) -> &lpspi1::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub const LPSPI2: Peripheral<Lpspi2> = unsafe { Peripheral::new(1073930240) };
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub mod lpspi2 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        _reserved0: [u8; 8usize],
        # [ doc = "0x10 - Control Register" ]
        pub cr: Cr,
        # [ doc = "0x14 - Status Register" ]
        pub sr: Sr,
        # [ doc = "0x18 - Interrupt Enable Register" ]
        pub ier: Ier,
        # [ doc = "0x1c - DMA Enable Register" ]
        pub der: Der,
        # [ doc = "0x20 - Configuration Register 0" ]
        pub cfgr0: Cfgr0,
        # [ doc = "0x24 - Configuration Register 1" ]
        pub cfgr1: Cfgr1,
        _reserved1: [u8; 8usize],
        # [ doc = "0x30 - Data Match Register 0" ]
        pub dmr0: Dmr0,
        # [ doc = "0x34 - Data Match Register 1" ]
        pub dmr1: Dmr1,
        _reserved2: [u8; 8usize],
        # [ doc = "0x40 - Clock Configuration Register" ]
        pub ccr: Ccr,
        _reserved3: [u8; 20usize],
        # [ doc = "0x58 - FIFO Control Register" ]
        pub fcr: Fcr,
        # [ doc = "0x5c - FIFO Status Register" ]
        pub fsr: Fsr,
        # [ doc = "0x60 - Transmit Command Register" ]
        pub tcr: Tcr,
        # [ doc = "0x64 - Transmit Data Register" ]
        pub tdr: Tdr,
        _reserved4: [u8; 8usize],
        # [ doc = "0x70 - Receive Status Register" ]
        pub rsr: Rsr,
        # [ doc = "0x74 - Receive Data Register" ]
        pub rdr: Rdr,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set supporting 32-bit shift register." ]
            _0000000000000100,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000100 => 4,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    4 => FeatureR::_0000000000000100,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000100`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000100(&self) -> bool {
                *self == FeatureR::_0000000000000100
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Module Identification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxfifoR {
            bits: u8,
        }
        impl TxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxfifoR {
            bits: u8,
        }
        impl RxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn txfifo(&self) -> TxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxfifoR { bits }
            }
            # [ doc = "Bits 8:15 - Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn rxfifo(&self) -> RxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxfifoR { bits }
            }
        }
    }
    # [ doc = "Control Register" ]
    pub struct Cr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Control Register" ]
    pub mod cr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MenR {
            # [ doc = "Module is disabled." ]
            _0,
            # [ doc = "Module is enabled." ]
            _1,
        }
        impl MenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MenR::_0 => 0,
                    MenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MenR {
                match bits {
                    0 => MenR::_0,
                    1 => MenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MenR::_1
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozenR {
            # [ doc = "Module is enabled in Doze mode." ]
            _0,
            # [ doc = "Module is disabled in Doze mode." ]
            _1,
        }
        impl DozenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozenR::_0 => 0,
                    DozenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozenR {
                match bits {
                    0 => DozenR::_0,
                    1 => DozenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozenR::_1
            }
        }
        # [ doc = "Possible values of the field `DBGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgenR {
            # [ doc = "Module is disabled in debug mode." ]
            _0,
            # [ doc = "Module is enabled in debug mode." ]
            _1,
        }
        impl DbgenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgenR::_0 => 0,
                    DbgenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgenR {
                match bits {
                    0 => DbgenR::_0,
                    1 => DbgenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MEN`" ]
        pub enum MenW {
            # [ doc = "Module is disabled." ]
            _0,
            # [ doc = "Module is enabled." ]
            _1,
        }
        impl MenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MenW::_0 => 0,
                    MenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MenW::_0)
            }
            # [ doc = "Module is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master logic is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Master logic is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEN`" ]
        pub enum DozenW {
            # [ doc = "Module is enabled in Doze mode." ]
            _0,
            # [ doc = "Module is disabled in Doze mode." ]
            _1,
        }
        impl DozenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozenW::_0 => 0,
                    DozenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozenW::_0)
            }
            # [ doc = "Module is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBGEN`" ]
        pub enum DbgenW {
            # [ doc = "Module is disabled in debug mode." ]
            _0,
            # [ doc = "Module is enabled in debug mode." ]
            _1,
        }
        impl DbgenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgenW::_0 => 0,
                    DbgenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is disabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgenW::_0)
            }
            # [ doc = "Module is enabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTF`" ]
        pub enum RtfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Transmit FIFO is reset." ]
            _1,
        }
        impl RtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtfW::_0 => 0,
                    RtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtfW::_0)
            }
            # [ doc = "Transmit FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRF`" ]
        pub enum RrfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Receive FIFO is reset." ]
            _1,
        }
        impl RrfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrfW::_0 => 0,
                    RrfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrfW::_0)
            }
            # [ doc = "Receive FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Module Enable" ]
            # [ inline ( always ) ]
            pub fn men(&self) -> MenR {
                MenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&self) -> DozenR {
                DozenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&self) -> DbgenR {
                DbgenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Module Enable" ]
            # [ inline ( always ) ]
            pub fn men(&mut self) -> _MenW {
                _MenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&mut self) -> _DozenW {
                _DozenW { w: self }
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&mut self) -> _DbgenW {
                _DbgenW { w: self }
            }
            # [ doc = "Bit 8 - Reset Transmit FIFO" ]
            # [ inline ( always ) ]
            pub fn rtf(&mut self) -> _RtfW {
                _RtfW { w: self }
            }
            # [ doc = "Bit 9 - Reset Receive FIFO" ]
            # [ inline ( always ) ]
            pub fn rrf(&mut self) -> _RrfW {
                _RrfW { w: self }
            }
        }
    }
    # [ doc = "Status Register" ]
    pub struct Sr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status Register" ]
    pub mod sr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdfR {
            # [ doc = "Transmit data not requested." ]
            _0,
            # [ doc = "Transmit data is requested." ]
            _1,
        }
        impl TdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdfR::_0 => 0,
                    TdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdfR {
                match bits {
                    0 => TdfR::_0,
                    1 => TdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdfR::_1
            }
        }
        # [ doc = "Possible values of the field `RDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdfR {
            # [ doc = "Receive Data is not ready." ]
            _0,
            # [ doc = "Receive data is ready." ]
            _1,
        }
        impl RdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdfR::_0 => 0,
                    RdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdfR {
                match bits {
                    0 => RdfR::_0,
                    1 => RdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdfR::_1
            }
        }
        # [ doc = "Possible values of the field `WCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WcfR {
            # [ doc = "Transfer word not completed." ]
            _0,
            # [ doc = "Transfer word completed." ]
            _1,
        }
        impl WcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WcfR::_0 => 0,
                    WcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WcfR {
                match bits {
                    0 => WcfR::_0,
                    1 => WcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WcfR::_1
            }
        }
        # [ doc = "Possible values of the field `FCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcfR {
            # [ doc = "Frame transfer has not completed." ]
            _0,
            # [ doc = "Frame transfer has completed." ]
            _1,
        }
        impl FcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcfR::_0 => 0,
                    FcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcfR {
                match bits {
                    0 => FcfR::_0,
                    1 => FcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcfR {
            # [ doc = "All transfers have not completed." ]
            _0,
            # [ doc = "All transfers have completed." ]
            _1,
        }
        impl TcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcfR::_0 => 0,
                    TcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcfR {
                match bits {
                    0 => TcfR::_0,
                    1 => TcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TefR {
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            _0,
            # [ doc = "Transmit FIFO underrun has occurred" ]
            _1,
        }
        impl TefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TefR::_0 => 0,
                    TefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TefR {
                match bits {
                    0 => TefR::_0,
                    1 => TefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TefR::_1
            }
        }
        # [ doc = "Possible values of the field `REF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RefR {
            # [ doc = "Receive FIFO has not overflowed." ]
            _0,
            # [ doc = "Receive FIFO has overflowed." ]
            _1,
        }
        impl RefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RefR::_0 => 0,
                    RefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RefR {
                match bits {
                    0 => RefR::_0,
                    1 => RefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RefR::_1
            }
        }
        # [ doc = "Possible values of the field `DMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmfR {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmfR::_0 => 0,
                    DmfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmfR {
                match bits {
                    0 => DmfR::_0,
                    1 => DmfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmfR::_1
            }
        }
        # [ doc = "Possible values of the field `MBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MbfR {
            # [ doc = "LPSPI is idle." ]
            _0,
            # [ doc = "LPSPI is busy." ]
            _1,
        }
        impl MbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MbfR::_0 => 0,
                    MbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MbfR {
                match bits {
                    0 => MbfR::_0,
                    1 => MbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MbfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `WCF`" ]
        pub enum WcfW {
            # [ doc = "Transfer word not completed." ]
            _0,
            # [ doc = "Transfer word completed." ]
            _1,
        }
        impl WcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WcfW::_0 => 0,
                    WcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfer word not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WcfW::_0)
            }
            # [ doc = "Transfer word completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FCF`" ]
        pub enum FcfW {
            # [ doc = "Frame transfer has not completed." ]
            _0,
            # [ doc = "Frame transfer has completed." ]
            _1,
        }
        impl FcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcfW::_0 => 0,
                    FcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Frame transfer has not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FcfW::_0)
            }
            # [ doc = "Frame transfer has completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCF`" ]
        pub enum TcfW {
            # [ doc = "All transfers have not completed." ]
            _0,
            # [ doc = "All transfers have completed." ]
            _1,
        }
        impl TcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcfW::_0 => 0,
                    TcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "All transfers have not completed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcfW::_0)
            }
            # [ doc = "All transfers have completed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TEF`" ]
        pub enum TefW {
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            _0,
            # [ doc = "Transmit FIFO underrun has occurred" ]
            _1,
        }
        impl TefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TefW::_0 => 0,
                    TefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit FIFO underrun has not occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TefW::_0)
            }
            # [ doc = "Transmit FIFO underrun has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REF`" ]
        pub enum RefW {
            # [ doc = "Receive FIFO has not overflowed." ]
            _0,
            # [ doc = "Receive FIFO has overflowed." ]
            _1,
        }
        impl RefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RefW::_0 => 0,
                    RefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive FIFO has not overflowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RefW::_0)
            }
            # [ doc = "Receive FIFO has overflowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMF`" ]
        pub enum DmfW {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmfW::_0 => 0,
                    DmfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Have not received matching data." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmfW::_0)
            }
            # [ doc = "Have received matching data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Flag" ]
            # [ inline ( always ) ]
            pub fn tdf(&self) -> TdfR {
                TdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Receive Data Flag" ]
            # [ inline ( always ) ]
            pub fn rdf(&self) -> RdfR {
                RdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Word Complete Flag" ]
            # [ inline ( always ) ]
            pub fn wcf(&self) -> WcfR {
                WcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - Frame Complete Flag" ]
            # [ inline ( always ) ]
            pub fn fcf(&self) -> FcfR {
                FcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Transfer Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&self) -> TcfR {
                TcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Transmit Error Flag" ]
            # [ inline ( always ) ]
            pub fn tef(&self) -> TefR {
                TefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 11;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Receive Error Flag" ]
            # [ inline ( always ) ]
            pub fn ref_(&self) -> RefR {
                RefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&self) -> DmfR {
                DmfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 13;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Module Busy Flag" ]
            # [ inline ( always ) ]
            pub fn mbf(&self) -> MbfR {
                MbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Word Complete Flag" ]
            # [ inline ( always ) ]
            pub fn wcf(&mut self) -> _WcfW {
                _WcfW { w: self }
            }
            # [ doc = "Bit 9 - Frame Complete Flag" ]
            # [ inline ( always ) ]
            pub fn fcf(&mut self) -> _FcfW {
                _FcfW { w: self }
            }
            # [ doc = "Bit 10 - Transfer Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&mut self) -> _TcfW {
                _TcfW { w: self }
            }
            # [ doc = "Bit 11 - Transmit Error Flag" ]
            # [ inline ( always ) ]
            pub fn tef(&mut self) -> _TefW {
                _TefW { w: self }
            }
            # [ doc = "Bit 12 - Receive Error Flag" ]
            # [ inline ( always ) ]
            pub fn ref_(&mut self) -> _RefW {
                _RefW { w: self }
            }
            # [ doc = "Bit 13 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&mut self) -> _DmfW {
                _DmfW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Enable Register" ]
    pub struct Ier {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Enable Register" ]
    pub mod ier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdieR::_0 => 0,
                    TdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdieR {
                match bits {
                    0 => TdieR::_0,
                    1 => TdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdieR::_0 => 0,
                    RdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdieR {
                match bits {
                    0 => RdieR::_0,
                    1 => RdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdieR::_1
            }
        }
        # [ doc = "Possible values of the field `WCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WcieR::_0 => 0,
                    WcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WcieR {
                match bits {
                    0 => WcieR::_0,
                    1 => WcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WcieR::_1
            }
        }
        # [ doc = "Possible values of the field `FCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FcieR::_0 => 0,
                    FcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FcieR {
                match bits {
                    0 => FcieR::_0,
                    1 => FcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcieR::_0 => 0,
                    TcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcieR {
                match bits {
                    0 => TcieR::_0,
                    1 => TcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TeieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TeieR::_0 => 0,
                    TeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TeieR {
                match bits {
                    0 => TeieR::_0,
                    1 => TeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TeieR::_1
            }
        }
        # [ doc = "Possible values of the field `REIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl ReieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReieR::_0 => 0,
                    ReieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReieR {
                match bits {
                    0 => ReieR::_0,
                    1 => ReieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReieR::_1
            }
        }
        # [ doc = "Possible values of the field `DMIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmieR::_0 => 0,
                    DmieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmieR {
                match bits {
                    0 => DmieR::_0,
                    1 => DmieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDIE`" ]
        pub enum TdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdieW::_0 => 0,
                    TdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdieW::_0)
            }
            # [ doc = "Interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDIE`" ]
        pub enum RdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdieW::_0 => 0,
                    RdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WCIE`" ]
        pub enum WcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WcieW::_0 => 0,
                    WcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FCIE`" ]
        pub enum FcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FcieW::_0 => 0,
                    FcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCIE`" ]
        pub enum TcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcieW::_0 => 0,
                    TcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TEIE`" ]
        pub enum TeieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TeieW::_0 => 0,
                    TeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TeieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `REIE`" ]
        pub enum ReieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl ReieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReieW::_0 => 0,
                    ReieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMIE`" ]
        pub enum DmieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmieW::_0 => 0,
                    DmieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&self) -> TdieR {
                TdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&self) -> RdieR {
                RdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Word Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wcie(&self) -> WcieR {
                WcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Frame Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fcie(&self) -> FcieR {
                FcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Transfer Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tcie(&self) -> TcieR {
                TcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Transmit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&self) -> TeieR {
                TeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Receive Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn reie(&self) -> ReieR {
                ReieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 13 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&self) -> DmieR {
                DmieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&mut self) -> _TdieW {
                _TdieW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&mut self) -> _RdieW {
                _RdieW { w: self }
            }
            # [ doc = "Bit 8 - Word Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn wcie(&mut self) -> _WcieW {
                _WcieW { w: self }
            }
            # [ doc = "Bit 9 - Frame Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fcie(&mut self) -> _FcieW {
                _FcieW { w: self }
            }
            # [ doc = "Bit 10 - Transfer Complete Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tcie(&mut self) -> _TcieW {
                _TcieW { w: self }
            }
            # [ doc = "Bit 11 - Transmit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&mut self) -> _TeieW {
                _TeieW { w: self }
            }
            # [ doc = "Bit 12 - Receive Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn reie(&mut self) -> _ReieW {
                _ReieW { w: self }
            }
            # [ doc = "Bit 13 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&mut self) -> _DmieW {
                _DmieW { w: self }
            }
        }
    }
    # [ doc = "DMA Enable Register" ]
    pub struct Der {
        register: VolatileCell<u32>,
    }
    # [ doc = "DMA Enable Register" ]
    pub mod der {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Der {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TddeR::_0 => 0,
                    TddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TddeR {
                match bits {
                    0 => TddeR::_0,
                    1 => TddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TddeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RddeR::_0 => 0,
                    RddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RddeR {
                match bits {
                    0 => RddeR::_0,
                    1 => RddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RddeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDDE`" ]
        pub enum TddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TddeW::_0 => 0,
                    TddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TddeW::_0)
            }
            # [ doc = "DMA request enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDDE`" ]
        pub enum RddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RddeW::_0 => 0,
                    RddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RddeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&self) -> TddeR {
                TddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&self) -> RddeR {
                RddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&mut self) -> _TddeW {
                _TddeW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&mut self) -> _RddeW {
                _RddeW { w: self }
            }
        }
    }
    # [ doc = "Configuration Register 0" ]
    pub struct Cfgr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration Register 0" ]
    pub mod cfgr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfgr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrenR {
            # [ doc = "Host request is disabled." ]
            _0,
            # [ doc = "Host request is enabled." ]
            _1,
        }
        impl HrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrenR::_0 => 0,
                    HrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrenR {
                match bits {
                    0 => HrenR::_0,
                    1 => HrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrenR::_1
            }
        }
        # [ doc = "Possible values of the field `HRPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrpolR {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrpolR::_0 => 0,
                    HrpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrpolR {
                match bits {
                    0 => HrpolR::_0,
                    1 => HrpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrpolR::_1
            }
        }
        # [ doc = "Possible values of the field `HRSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrselR {
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrselR::_0 => 0,
                    HrselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrselR {
                match bits {
                    0 => HrselR::_0,
                    1 => HrselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrselR::_1
            }
        }
        # [ doc = "Possible values of the field `CIRFIFO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CirfifoR {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CirfifoR::_0 => 0,
                    CirfifoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CirfifoR {
                match bits {
                    0 => CirfifoR::_0,
                    1 => CirfifoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CirfifoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CirfifoR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmoR {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the DMF is set." ]
            _1,
        }
        impl RdmoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmoR::_0 => 0,
                    RdmoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmoR {
                match bits {
                    0 => RdmoR::_0,
                    1 => RdmoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HREN`" ]
        pub enum HrenW {
            # [ doc = "Host request is disabled." ]
            _0,
            # [ doc = "Host request is enabled." ]
            _1,
        }
        impl HrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrenW::_0 => 0,
                    HrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrenW::_0)
            }
            # [ doc = "Host request is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRPOL`" ]
        pub enum HrpolW {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrpolW::_0 => 0,
                    HrpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrpolW::_0)
            }
            # [ doc = "Active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRSEL`" ]
        pub enum HrselW {
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrselW::_0 => 0,
                    HrselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request input is pin LPSPI_HREQ." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrselW::_0)
            }
            # [ doc = "Host request input is input trigger." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CIRFIFO`" ]
        pub enum CirfifoW {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CirfifoW::_0 => 0,
                    CirfifoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CirfifoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CirfifoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CirfifoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Circular FIFO is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CirfifoW::_0)
            }
            # [ doc = "Circular FIFO is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CirfifoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMO`" ]
        pub enum RdmoW {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the DMF is set." ]
            _1,
        }
        impl RdmoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmoW::_0 => 0,
                    RdmoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmoW::_0)
            }
            # [ doc = "Received data is discarded unless the DMF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&self) -> HrenR {
                HrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&self) -> HrpolR {
                HrpolR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&self) -> HrselR {
                HrselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&self) -> CirfifoR {
                CirfifoR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&self) -> RdmoR {
                RdmoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&mut self) -> _HrenW {
                _HrenW { w: self }
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&mut self) -> _HrpolW {
                _HrpolW { w: self }
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&mut self) -> _HrselW {
                _HrselW { w: self }
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&mut self) -> _CirfifoW {
                _CirfifoW { w: self }
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&mut self) -> _RdmoW {
                _RdmoW { w: self }
            }
        }
    }
    # [ doc = "Configuration Register 1" ]
    pub struct Cfgr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Configuration Register 1" ]
    pub mod cfgr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cfgr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MASTER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MasterR {
            # [ doc = "Slave mode." ]
            _0,
            # [ doc = "Master mode." ]
            _1,
        }
        impl MasterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MasterR::_0 => 0,
                    MasterR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MasterR {
                match bits {
                    0 => MasterR::_0,
                    1 => MasterR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MasterR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MasterR::_1
            }
        }
        # [ doc = "Possible values of the field `SAMPLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SampleR {
            # [ doc = "Input data sampled on SCK edge." ]
            _0,
            # [ doc = "Input data sampled on delayed SCK edge." ]
            _1,
        }
        impl SampleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SampleR::_0 => 0,
                    SampleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SampleR {
                match bits {
                    0 => SampleR::_0,
                    1 => SampleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SampleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SampleR::_1
            }
        }
        # [ doc = "Possible values of the field `AUTOPCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AutopcsR {
            # [ doc = "Automatic PCS generation disabled." ]
            _0,
            # [ doc = "Automatic PCS generation enabled." ]
            _1,
        }
        impl AutopcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AutopcsR::_0 => 0,
                    AutopcsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AutopcsR {
                match bits {
                    0 => AutopcsR::_0,
                    1 => AutopcsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AutopcsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AutopcsR::_1
            }
        }
        # [ doc = "Possible values of the field `NOSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NostallR {
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            _0,
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            _1,
        }
        impl NostallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NostallR::_0 => 0,
                    NostallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NostallR {
                match bits {
                    0 => NostallR::_0,
                    1 => NostallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NostallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NostallR::_1
            }
        }
        # [ doc = "Possible values of the field `PCSPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcspolR {
            # [ doc = "The PCSx is active low." ]
            _0000,
            # [ doc = "The PCSx is active high." ]
            _0001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PcspolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcspolR::_0000 => 0,
                    PcspolR::_0001 => 1,
                    PcspolR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcspolR {
                match bits {
                    0 => PcspolR::_0000,
                    1 => PcspolR::_0001,
                    i => PcspolR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == PcspolR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == PcspolR::_0001
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Match is disabled." ]
            _000,
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            _010,
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            _011,
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            _100,
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            _101,
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _110,
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_000 => 0,
                    MatcfgR::_010 => 2,
                    MatcfgR::_011 => 3,
                    MatcfgR::_100 => 4,
                    MatcfgR::_101 => 5,
                    MatcfgR::_110 => 6,
                    MatcfgR::_111 => 7,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_000,
                    2 => MatcfgR::_010,
                    3 => MatcfgR::_011,
                    4 => MatcfgR::_100,
                    5 => MatcfgR::_101,
                    6 => MatcfgR::_110,
                    7 => MatcfgR::_111,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MatcfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MatcfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MatcfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MatcfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MatcfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MatcfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MatcfgR::_111
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            _00,
            # [ doc = "SIN is used for both input and output data." ]
            _01,
            # [ doc = "SOUT is used for both input and output data." ]
            _10,
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_00 => 0,
                    PincfgR::_01 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_00,
                    1 => PincfgR::_01,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PincfgR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PincfgR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `OUTCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OutcfgR {
            # [ doc = "Output data retains last value when chip select is negated." ]
            _0,
            # [ doc = "Output data is tristated when chip select is negated." ]
            _1,
        }
        impl OutcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OutcfgR::_0 => 0,
                    OutcfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OutcfgR {
                match bits {
                    0 => OutcfgR::_0,
                    1 => OutcfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OutcfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OutcfgR::_1
            }
        }
        # [ doc = "Possible values of the field `PCSCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcscfgR {
            # [ doc = "PCS[3:2] are enabled." ]
            _0,
            # [ doc = "PCS[3:2] are disabled." ]
            _1,
        }
        impl PcscfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcscfgR::_0 => 0,
                    PcscfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcscfgR {
                match bits {
                    0 => PcscfgR::_0,
                    1 => PcscfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PcscfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PcscfgR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MASTER`" ]
        pub enum MasterW {
            # [ doc = "Slave mode." ]
            _0,
            # [ doc = "Master mode." ]
            _1,
        }
        impl MasterW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MasterW::_0 => 0,
                    MasterW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MasterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MasterW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MasterW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MasterW::_0)
            }
            # [ doc = "Master mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MasterW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SAMPLE`" ]
        pub enum SampleW {
            # [ doc = "Input data sampled on SCK edge." ]
            _0,
            # [ doc = "Input data sampled on delayed SCK edge." ]
            _1,
        }
        impl SampleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SampleW::_0 => 0,
                    SampleW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SampleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SampleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SampleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Input data sampled on SCK edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SampleW::_0)
            }
            # [ doc = "Input data sampled on delayed SCK edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SampleW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AUTOPCS`" ]
        pub enum AutopcsW {
            # [ doc = "Automatic PCS generation disabled." ]
            _0,
            # [ doc = "Automatic PCS generation enabled." ]
            _1,
        }
        impl AutopcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AutopcsW::_0 => 0,
                    AutopcsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AutopcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AutopcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AutopcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Automatic PCS generation disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AutopcsW::_0)
            }
            # [ doc = "Automatic PCS generation enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AutopcsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NOSTALL`" ]
        pub enum NostallW {
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            _0,
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            _1,
        }
        impl NostallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NostallW::_0 => 0,
                    NostallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NostallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NostallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NostallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfers will stall when transmit FIFO is empty or receive FIFO is full." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NostallW::_0)
            }
            # [ doc = "Transfers will not stall, allowing transmit FIFO underrun or receive FIFO overrun to occur." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NostallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCSPOL`" ]
        pub enum PcspolW {
            # [ doc = "The PCSx is active low." ]
            _0000,
            # [ doc = "The PCSx is active high." ]
            _0001,
        }
        impl PcspolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcspolW::_0000 => 0,
                    PcspolW::_0001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcspolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcspolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcspolW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The PCSx is active low." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(PcspolW::_0000)
            }
            # [ doc = "The PCSx is active high." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(PcspolW::_0001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Match is disabled." ]
            _000,
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            _010,
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            _011,
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            _100,
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            _101,
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _110,
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            _111,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_000 => 0,
                    MatcfgW::_010 => 2,
                    MatcfgW::_011 => 3,
                    MatcfgW::_100 => 4,
                    MatcfgW::_101 => 5,
                    MatcfgW::_110 => 6,
                    MatcfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Match is disabled." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MatcfgW::_000)
            }
            # [ doc = "010b - Match is enabled, if 1st data word equals MATCH0 OR MATCH1, i.e., (1st data word = MATCH0 + MATCH1)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MatcfgW::_010)
            }
            # [ doc = "011b - Match is enabled, if any data word equals MATCH0 OR MATCH1, i.e., (any data word = MATCH0 + MATCH1)" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MatcfgW::_011)
            }
            # [ doc = "100b - Match is enabled, if 1st data word equals MATCH0 AND 2nd data word equals MATCH1, i.e., [(1st data word = MATCH0) * (2nd data word = MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MatcfgW::_100)
            }
            # [ doc = "101b - Match is enabled, if any data word equals MATCH0 AND the next data word equals MATCH1, i.e., [(any data word = MATCH0) * (next data word = MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MatcfgW::_101)
            }
            # [ doc = "110b - Match is enabled, if (1st data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(1st data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MatcfgW::_110)
            }
            # [ doc = "111b - Match is enabled, if (any data word AND MATCH1) equals (MATCH0 AND MATCH1), i.e., [(any data word * MATCH1) = (MATCH0 * MATCH1)]" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MatcfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            _00,
            # [ doc = "SIN is used for both input and output data." ]
            _01,
            # [ doc = "SOUT is used for both input and output data." ]
            _10,
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_00 => 0,
                    PincfgW::_01 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SIN is used for input data and SOUT for output data." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PincfgW::_00)
            }
            # [ doc = "SIN is used for both input and output data." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PincfgW::_01)
            }
            # [ doc = "SOUT is used for both input and output data." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "SOUT is used for input data and SIN for output data." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OUTCFG`" ]
        pub enum OutcfgW {
            # [ doc = "Output data retains last value when chip select is negated." ]
            _0,
            # [ doc = "Output data is tristated when chip select is negated." ]
            _1,
        }
        impl OutcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OutcfgW::_0 => 0,
                    OutcfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OutcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OutcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OutcfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output data retains last value when chip select is negated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OutcfgW::_0)
            }
            # [ doc = "Output data is tristated when chip select is negated." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OutcfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCSCFG`" ]
        pub enum PcscfgW {
            # [ doc = "PCS[3:2] are enabled." ]
            _0,
            # [ doc = "PCS[3:2] are disabled." ]
            _1,
        }
        impl PcscfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcscfgW::_0 => 0,
                    PcscfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcscfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcscfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcscfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PCS[3:2] are enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PcscfgW::_0)
            }
            # [ doc = "PCS[3:2] are disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PcscfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Master Mode" ]
            # [ inline ( always ) ]
            pub fn master(&self) -> MasterR {
                MasterR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Sample Point" ]
            # [ inline ( always ) ]
            pub fn sample(&self) -> SampleR {
                SampleR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Automatic PCS" ]
            # [ inline ( always ) ]
            pub fn autopcs(&self) -> AutopcsR {
                AutopcsR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - No Stall" ]
            # [ inline ( always ) ]
            pub fn nostall(&self) -> NostallR {
                NostallR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 8:11 - Peripheral Chip Select Polarity" ]
            # [ inline ( always ) ]
            pub fn pcspol(&self) -> PcspolR {
                PcspolR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Output Config" ]
            # [ inline ( always ) ]
            pub fn outcfg(&self) -> OutcfgR {
                OutcfgR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 26;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 27 - Peripheral Chip Select Configuration" ]
            # [ inline ( always ) ]
            pub fn pcscfg(&self) -> PcscfgR {
                PcscfgR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Master Mode" ]
            # [ inline ( always ) ]
            pub fn master(&mut self) -> _MasterW {
                _MasterW { w: self }
            }
            # [ doc = "Bit 1 - Sample Point" ]
            # [ inline ( always ) ]
            pub fn sample(&mut self) -> _SampleW {
                _SampleW { w: self }
            }
            # [ doc = "Bit 2 - Automatic PCS" ]
            # [ inline ( always ) ]
            pub fn autopcs(&mut self) -> _AutopcsW {
                _AutopcsW { w: self }
            }
            # [ doc = "Bit 3 - No Stall" ]
            # [ inline ( always ) ]
            pub fn nostall(&mut self) -> _NostallW {
                _NostallW { w: self }
            }
            # [ doc = "Bits 8:11 - Peripheral Chip Select Polarity" ]
            # [ inline ( always ) ]
            pub fn pcspol(&mut self) -> _PcspolW {
                _PcspolW { w: self }
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bits 24:25 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 26 - Output Config" ]
            # [ inline ( always ) ]
            pub fn outcfg(&mut self) -> _OutcfgW {
                _OutcfgW { w: self }
            }
            # [ doc = "Bit 27 - Peripheral Chip Select Configuration" ]
            # [ inline ( always ) ]
            pub fn pcscfg(&mut self) -> _PcscfgW {
                _PcscfgW { w: self }
            }
        }
    }
    # [ doc = "Data Match Register 0" ]
    pub struct Dmr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Data Match Register 0" ]
    pub mod dmr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dmr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match0R {
            bits: u32,
        }
        impl Match0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&self) -> Match0R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Match0R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&mut self) -> _Match0W {
                _Match0W { w: self }
            }
        }
    }
    # [ doc = "Data Match Register 1" ]
    pub struct Dmr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Data Match Register 1" ]
    pub mod dmr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dmr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match1R {
            bits: u32,
        }
        impl Match1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&self) -> Match1R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Match1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&mut self) -> _Match1W {
                _Match1W { w: self }
            }
        }
    }
    # [ doc = "Clock Configuration Register" ]
    pub struct Ccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Clock Configuration Register" ]
    pub mod ccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SckdivR {
            bits: u8,
        }
        impl SckdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DbtR {
            bits: u8,
        }
        impl DbtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PcssckR {
            bits: u8,
        }
        impl PcssckR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SckpcsR {
            bits: u8,
        }
        impl SckpcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SckdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SckdivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbtW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcssckW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcssckW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SckpcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SckpcsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - SCK Divider" ]
            # [ inline ( always ) ]
            pub fn sckdiv(&self) -> SckdivR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SckdivR { bits }
            }
            # [ doc = "Bits 8:15 - Delay Between Transfers" ]
            # [ inline ( always ) ]
            pub fn dbt(&self) -> DbtR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DbtR { bits }
            }
            # [ doc = "Bits 16:23 - PCS to SCK Delay" ]
            # [ inline ( always ) ]
            pub fn pcssck(&self) -> PcssckR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PcssckR { bits }
            }
            # [ doc = "Bits 24:31 - SCK to PCS Delay" ]
            # [ inline ( always ) ]
            pub fn sckpcs(&self) -> SckpcsR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SckpcsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - SCK Divider" ]
            # [ inline ( always ) ]
            pub fn sckdiv(&mut self) -> _SckdivW {
                _SckdivW { w: self }
            }
            # [ doc = "Bits 8:15 - Delay Between Transfers" ]
            # [ inline ( always ) ]
            pub fn dbt(&mut self) -> _DbtW {
                _DbtW { w: self }
            }
            # [ doc = "Bits 16:23 - PCS to SCK Delay" ]
            # [ inline ( always ) ]
            pub fn pcssck(&mut self) -> _PcssckW {
                _PcssckW { w: self }
            }
            # [ doc = "Bits 24:31 - SCK to PCS Delay" ]
            # [ inline ( always ) ]
            pub fn sckpcs(&mut self) -> _SckpcsW {
                _SckpcsW { w: self }
            }
        }
    }
    # [ doc = "FIFO Control Register" ]
    pub struct Fcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "FIFO Control Register" ]
    pub mod fcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
    # [ doc = "FIFO Status Register" ]
    pub struct Fsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "FIFO Status Register" ]
    pub mod fsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Fsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Transmit FIFO Count" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:18 - Receive FIFO Count" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
    }
    # [ doc = "Transmit Command Register" ]
    pub struct Tcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Transmit Command Register" ]
    pub mod tcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FrameszR {
            bits: u16,
        }
        impl FrameszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WIDTH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WidthR {
            # [ doc = "Single bit transfer." ]
            _00,
            # [ doc = "Two bit transfer." ]
            _01,
            # [ doc = "Four bit transfer." ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl WidthR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WidthR::_00 => 0,
                    WidthR::_01 => 1,
                    WidthR::_10 => 2,
                    WidthR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WidthR {
                match bits {
                    0 => WidthR::_00,
                    1 => WidthR::_01,
                    2 => WidthR::_10,
                    i => WidthR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == WidthR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == WidthR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == WidthR::_10
            }
        }
        # [ doc = "Possible values of the field `TXMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxmskR {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Mask transmit data." ]
            _1,
        }
        impl TxmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxmskR::_0 => 0,
                    TxmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxmskR {
                match bits {
                    0 => TxmskR::_0,
                    1 => TxmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxmskR::_1
            }
        }
        # [ doc = "Possible values of the field `RXMSK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxmskR {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Receive data is masked." ]
            _1,
        }
        impl RxmskR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxmskR::_0 => 0,
                    RxmskR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxmskR {
                match bits {
                    0 => RxmskR::_0,
                    1 => RxmskR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxmskR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxmskR::_1
            }
        }
        # [ doc = "Possible values of the field `CONTC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContcR {
            # [ doc = "Command word for start of new transfer." ]
            _0,
            # [ doc = "Command word for continuing transfer." ]
            _1,
        }
        impl ContcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContcR::_0 => 0,
                    ContcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContcR {
                match bits {
                    0 => ContcR::_0,
                    1 => ContcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContcR::_1
            }
        }
        # [ doc = "Possible values of the field `CONT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContR {
            # [ doc = "Continuous transfer disabled." ]
            _0,
            # [ doc = "Continuous transfer enabled." ]
            _1,
        }
        impl ContR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContR::_0 => 0,
                    ContR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContR {
                match bits {
                    0 => ContR::_0,
                    1 => ContR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContR::_1
            }
        }
        # [ doc = "Possible values of the field `BYSW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ByswR {
            # [ doc = "Byte swap disabled." ]
            _0,
            # [ doc = "Byte swap enabled." ]
            _1,
        }
        impl ByswR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ByswR::_0 => 0,
                    ByswR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ByswR {
                match bits {
                    0 => ByswR::_0,
                    1 => ByswR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ByswR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ByswR::_1
            }
        }
        # [ doc = "Possible values of the field `LSBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LsbfR {
            # [ doc = "Data is transferred MSB first." ]
            _0,
            # [ doc = "Data is transferred LSB first." ]
            _1,
        }
        impl LsbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LsbfR::_0 => 0,
                    LsbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LsbfR {
                match bits {
                    0 => LsbfR::_0,
                    1 => LsbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LsbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LsbfR::_1
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            _00,
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            _01,
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            _10,
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            _11,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_00 => 0,
                    PcsR::_01 => 1,
                    PcsR::_10 => 2,
                    PcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_00,
                    1 => PcsR::_01,
                    2 => PcsR::_10,
                    3 => PcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PcsR::_11
            }
        }
        # [ doc = "Possible values of the field `PRESCALE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescaleR {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescaleR::_000 => 0,
                    PrescaleR::_001 => 1,
                    PrescaleR::_010 => 2,
                    PrescaleR::_011 => 3,
                    PrescaleR::_100 => 4,
                    PrescaleR::_101 => 5,
                    PrescaleR::_110 => 6,
                    PrescaleR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescaleR {
                match bits {
                    0 => PrescaleR::_000,
                    1 => PrescaleR::_001,
                    2 => PrescaleR::_010,
                    3 => PrescaleR::_011,
                    4 => PrescaleR::_100,
                    5 => PrescaleR::_101,
                    6 => PrescaleR::_110,
                    7 => PrescaleR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PrescaleR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PrescaleR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PrescaleR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PrescaleR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PrescaleR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PrescaleR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PrescaleR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PrescaleR::_111
            }
        }
        # [ doc = "Possible values of the field `CPHA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CphaR {
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            _0,
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            _1,
        }
        impl CphaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CphaR::_0 => 0,
                    CphaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CphaR {
                match bits {
                    0 => CphaR::_0,
                    1 => CphaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CphaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CphaR::_1
            }
        }
        # [ doc = "Possible values of the field `CPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpolR {
            # [ doc = "The inactive state value of SCK is low." ]
            _0,
            # [ doc = "The inactive state value of SCK is high." ]
            _1,
        }
        impl CpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpolR::_0 => 0,
                    CpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpolR {
                match bits {
                    0 => CpolR::_0,
                    1 => CpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpolR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FrameszW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FrameszW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WIDTH`" ]
        pub enum WidthW {
            # [ doc = "Single bit transfer." ]
            _00,
            # [ doc = "Two bit transfer." ]
            _01,
            # [ doc = "Four bit transfer." ]
            _10,
        }
        impl WidthW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WidthW::_00 => 0,
                    WidthW::_01 => 1,
                    WidthW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WidthW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WidthW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WidthW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Single bit transfer." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(WidthW::_00)
            }
            # [ doc = "Two bit transfer." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(WidthW::_01)
            }
            # [ doc = "Four bit transfer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(WidthW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXMSK`" ]
        pub enum TxmskW {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Mask transmit data." ]
            _1,
        }
        impl TxmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxmskW::_0 => 0,
                    TxmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxmskW::_0)
            }
            # [ doc = "Mask transmit data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXMSK`" ]
        pub enum RxmskW {
            # [ doc = "Normal transfer." ]
            _0,
            # [ doc = "Receive data is masked." ]
            _1,
        }
        impl RxmskW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxmskW::_0 => 0,
                    RxmskW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxmskW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxmskW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxmskW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxmskW::_0)
            }
            # [ doc = "Receive data is masked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxmskW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONTC`" ]
        pub enum ContcW {
            # [ doc = "Command word for start of new transfer." ]
            _0,
            # [ doc = "Command word for continuing transfer." ]
            _1,
        }
        impl ContcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContcW::_0 => 0,
                    ContcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Command word for start of new transfer." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContcW::_0)
            }
            # [ doc = "Command word for continuing transfer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONT`" ]
        pub enum ContW {
            # [ doc = "Continuous transfer disabled." ]
            _0,
            # [ doc = "Continuous transfer enabled." ]
            _1,
        }
        impl ContW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContW::_0 => 0,
                    ContW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Continuous transfer disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContW::_0)
            }
            # [ doc = "Continuous transfer enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BYSW`" ]
        pub enum ByswW {
            # [ doc = "Byte swap disabled." ]
            _0,
            # [ doc = "Byte swap enabled." ]
            _1,
        }
        impl ByswW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ByswW::_0 => 0,
                    ByswW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ByswW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ByswW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ByswW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Byte swap disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ByswW::_0)
            }
            # [ doc = "Byte swap enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ByswW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LSBF`" ]
        pub enum LsbfW {
            # [ doc = "Data is transferred MSB first." ]
            _0,
            # [ doc = "Data is transferred LSB first." ]
            _1,
        }
        impl LsbfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LsbfW::_0 => 0,
                    LsbfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LsbfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LsbfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LsbfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data is transferred MSB first." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LsbfW::_0)
            }
            # [ doc = "Data is transferred LSB first." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LsbfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            _00,
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            _01,
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            _10,
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            _11,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_00 => 0,
                    PcsW::_01 => 1,
                    PcsW::_10 => 2,
                    PcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transfer using LPSPI_PCS[0]" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PcsW::_00)
            }
            # [ doc = "Transfer using LPSPI_PCS[1]" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PcsW::_01)
            }
            # [ doc = "Transfer using LPSPI_PCS[2]" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PcsW::_10)
            }
            # [ doc = "Transfer using LPSPI_PCS[3]" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALE`" ]
        pub enum PrescaleW {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescaleW::_000 => 0,
                    PrescaleW::_001 => 1,
                    PrescaleW::_010 => 2,
                    PrescaleW::_011 => 3,
                    PrescaleW::_100 => 4,
                    PrescaleW::_101 => 5,
                    PrescaleW::_110 => 6,
                    PrescaleW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescaleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescaleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescaleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PrescaleW::_000)
            }
            # [ doc = "Divide by 2." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PrescaleW::_001)
            }
            # [ doc = "Divide by 4." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PrescaleW::_010)
            }
            # [ doc = "Divide by 8." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PrescaleW::_011)
            }
            # [ doc = "Divide by 16." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PrescaleW::_100)
            }
            # [ doc = "Divide by 32." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PrescaleW::_101)
            }
            # [ doc = "Divide by 64." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PrescaleW::_110)
            }
            # [ doc = "Divide by 128." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PrescaleW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPHA`" ]
        pub enum CphaW {
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            _0,
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            _1,
        }
        impl CphaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CphaW::_0 => 0,
                    CphaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CphaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CphaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CphaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data is captured on the leading edge of SCK and changed on the following edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CphaW::_0)
            }
            # [ doc = "Data is changed on the leading edge of SCK and captured on the following edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CphaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPOL`" ]
        pub enum CpolW {
            # [ doc = "The inactive state value of SCK is low." ]
            _0,
            # [ doc = "The inactive state value of SCK is high." ]
            _1,
        }
        impl CpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpolW::_0 => 0,
                    CpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The inactive state value of SCK is low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpolW::_0)
            }
            # [ doc = "The inactive state value of SCK is high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - Frame Size" ]
            # [ inline ( always ) ]
            pub fn framesz(&self) -> FrameszR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FrameszR { bits }
            }
            # [ doc = "Bits 16:17 - Transfer Width" ]
            # [ inline ( always ) ]
            pub fn width(&self) -> WidthR {
                WidthR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 18 - Transmit Data Mask" ]
            # [ inline ( always ) ]
            pub fn txmsk(&self) -> TxmskR {
                TxmskR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 19 - Receive Data Mask" ]
            # [ inline ( always ) ]
            pub fn rxmsk(&self) -> RxmskR {
                RxmskR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 19;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 20 - Continuing Command" ]
            # [ inline ( always ) ]
            pub fn contc(&self) -> ContcR {
                ContcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 20;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 21 - Continuous Transfer" ]
            # [ inline ( always ) ]
            pub fn cont(&self) -> ContR {
                ContR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Byte Swap" ]
            # [ inline ( always ) ]
            pub fn bysw(&self) -> ByswR {
                ByswR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - LSB First" ]
            # [ inline ( always ) ]
            pub fn lsbf(&self) -> LsbfR {
                LsbfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 23;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:25 - Peripheral Chip Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 27:29 - Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&self) -> PrescaleR {
                PrescaleR::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 27;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 30 - Clock Phase" ]
            # [ inline ( always ) ]
            pub fn cpha(&self) -> CphaR {
                CphaR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 31 - Clock Polarity" ]
            # [ inline ( always ) ]
            pub fn cpol(&self) -> CpolR {
                CpolR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 31;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 31 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - Frame Size" ]
            # [ inline ( always ) ]
            pub fn framesz(&mut self) -> _FrameszW {
                _FrameszW { w: self }
            }
            # [ doc = "Bits 16:17 - Transfer Width" ]
            # [ inline ( always ) ]
            pub fn width(&mut self) -> _WidthW {
                _WidthW { w: self }
            }
            # [ doc = "Bit 18 - Transmit Data Mask" ]
            # [ inline ( always ) ]
            pub fn txmsk(&mut self) -> _TxmskW {
                _TxmskW { w: self }
            }
            # [ doc = "Bit 19 - Receive Data Mask" ]
            # [ inline ( always ) ]
            pub fn rxmsk(&mut self) -> _RxmskW {
                _RxmskW { w: self }
            }
            # [ doc = "Bit 20 - Continuing Command" ]
            # [ inline ( always ) ]
            pub fn contc(&mut self) -> _ContcW {
                _ContcW { w: self }
            }
            # [ doc = "Bit 21 - Continuous Transfer" ]
            # [ inline ( always ) ]
            pub fn cont(&mut self) -> _ContW {
                _ContW { w: self }
            }
            # [ doc = "Bit 22 - Byte Swap" ]
            # [ inline ( always ) ]
            pub fn bysw(&mut self) -> _ByswW {
                _ByswW { w: self }
            }
            # [ doc = "Bit 23 - LSB First" ]
            # [ inline ( always ) ]
            pub fn lsbf(&mut self) -> _LsbfW {
                _LsbfW { w: self }
            }
            # [ doc = "Bits 24:25 - Peripheral Chip Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bits 27:29 - Prescaler Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&mut self) -> _PrescaleW {
                _PrescaleW { w: self }
            }
            # [ doc = "Bit 30 - Clock Phase" ]
            # [ inline ( always ) ]
            pub fn cpha(&mut self) -> _CphaW {
                _CphaW { w: self }
            }
            # [ doc = "Bit 31 - Clock Polarity" ]
            # [ inline ( always ) ]
            pub fn cpol(&mut self) -> _CpolW {
                _CpolW { w: self }
            }
        }
    }
    # [ doc = "Transmit Data Register" ]
    pub struct Tdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Transmit Data Register" ]
    pub mod tdr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tdr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Transmit Data" ]
            # [ inline ( always ) ]
            pub fn data(&mut self) -> _DataW {
                _DataW { w: self }
            }
        }
    }
    # [ doc = "Receive Status Register" ]
    pub struct Rsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Receive Status Register" ]
    pub mod rsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `SOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SofR {
            # [ doc = "Subsequent data word received after LPSPI_PCS assertion." ]
            _0,
            # [ doc = "First data word received after LPSPI_PCS assertion." ]
            _1,
        }
        impl SofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SofR::_0 => 0,
                    SofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SofR {
                match bits {
                    0 => SofR::_0,
                    1 => SofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SofR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPTY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptyR {
            # [ doc = "RX FIFO is not empty." ]
            _0,
            # [ doc = "RX FIFO is empty." ]
            _1,
        }
        impl RxemptyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptyR::_0 => 0,
                    RxemptyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptyR {
                match bits {
                    0 => RxemptyR::_0,
                    1 => RxemptyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptyR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Start Of Frame" ]
            # [ inline ( always ) ]
            pub fn sof(&self) -> SofR {
                SofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - RX FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn rxempty(&self) -> RxemptyR {
                RxemptyR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
    }
    # [ doc = "Receive Data Register" ]
    pub struct Rdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Receive Data Register" ]
    pub mod rdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Rdr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataR {
            bits: u32,
        }
        impl DataR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Receive Data" ]
            # [ inline ( always ) ]
            pub fn data(&self) -> DataR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DataR { bits }
            }
        }
    }
}
# [ doc = "The LPSPI Memory Map/Register Definition can be found here." ]
pub struct Lpspi2 {
    register_block: lpspi2::RegisterBlock,
}
impl Deref for Lpspi2 {
    type Target = lpspi2::RegisterBlock;
    fn deref(&self) -> &lpspi2::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Programmable Delay Block" ]
pub const PDB0: Peripheral<Pdb0> = unsafe { Peripheral::new(1073963008) };
# [ doc = "Programmable Delay Block" ]
pub mod pdb0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Status and Control register" ]
        pub sc: Sc,
        # [ doc = "0x04 - Modulus register" ]
        pub mod_: Mod,
        # [ doc = "0x08 - Counter register" ]
        pub cnt: Cnt,
        # [ doc = "0x0c - Interrupt Delay register" ]
        pub idly: Idly,
        # [ doc = "0x10 - Channel n Control register 1" ]
        pub ch0c1: Chc1,
        # [ doc = "0x14 - Channel n Status register" ]
        pub ch0s: Chs,
        # [ doc = "0x18 - Channel n Delay 0 register" ]
        pub ch0dly0: Chdly0,
        # [ doc = "0x1c - Channel n Delay 1 register" ]
        pub ch0dly1: Chdly1,
        # [ doc = "0x20 - Channel n Delay 2 register" ]
        pub ch0dly2: Chdly2,
        # [ doc = "0x24 - Channel n Delay 3 register" ]
        pub ch0dly3: Chdly3,
        # [ doc = "0x28 - Channel n Delay 4 register" ]
        pub ch0dly4: Chdly4,
        # [ doc = "0x2c - Channel n Delay 5 register" ]
        pub ch0dly5: Chdly5,
        # [ doc = "0x30 - Channel n Delay 6 register" ]
        pub ch0dly6: Chdly6,
        # [ doc = "0x34 - Channel n Delay 7 register" ]
        pub ch0dly7: Chdly7,
        # [ doc = "0x38 - Channel n Control register 1" ]
        pub ch1c1: Chc1,
        # [ doc = "0x3c - Channel n Status register" ]
        pub ch1s: Chs,
        # [ doc = "0x40 - Channel n Delay 0 register" ]
        pub ch1dly0: Chdly0,
        # [ doc = "0x44 - Channel n Delay 1 register" ]
        pub ch1dly1: Chdly1,
        # [ doc = "0x48 - Channel n Delay 2 register" ]
        pub ch1dly2: Chdly2,
        # [ doc = "0x4c - Channel n Delay 3 register" ]
        pub ch1dly3: Chdly3,
        # [ doc = "0x50 - Channel n Delay 4 register" ]
        pub ch1dly4: Chdly4,
        # [ doc = "0x54 - Channel n Delay 5 register" ]
        pub ch1dly5: Chdly5,
        # [ doc = "0x58 - Channel n Delay 6 register" ]
        pub ch1dly6: Chdly6,
        # [ doc = "0x5c - Channel n Delay 7 register" ]
        pub ch1dly7: Chdly7,
        _reserved0: [u8; 304usize],
        # [ doc = "0x190 - Pulse-Out n Enable register" ]
        pub poen: Poen,
        # [ doc = "0x194 - Pulse-Out n Delay register" ]
        pub podly: Podly,
    }
    # [ doc = "Status and Control register" ]
    pub struct Sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status and Control register" ]
    pub mod sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LdokR {
            bits: u8,
        }
        impl LdokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CONT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContR {
            # [ doc = "PDB operation in One-Shot mode" ]
            _0,
            # [ doc = "PDB operation in Continuous mode" ]
            _1,
        }
        impl ContR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContR::_0 => 0,
                    ContR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContR {
                match bits {
                    0 => ContR::_0,
                    1 => ContR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContR::_1
            }
        }
        # [ doc = "Possible values of the field `MULT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MultR {
            # [ doc = "Multiplication factor is 1." ]
            _00,
            # [ doc = "Multiplication factor is 10." ]
            _01,
            # [ doc = "Multiplication factor is 20." ]
            _10,
            # [ doc = "Multiplication factor is 40." ]
            _11,
        }
        impl MultR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MultR::_00 => 0,
                    MultR::_01 => 1,
                    MultR::_10 => 2,
                    MultR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MultR {
                match bits {
                    0 => MultR::_00,
                    1 => MultR::_01,
                    2 => MultR::_10,
                    3 => MultR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == MultR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == MultR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == MultR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == MultR::_11
            }
        }
        # [ doc = "Possible values of the field `PDBIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbieR {
            # [ doc = "PDB interrupt disabled." ]
            _0,
            # [ doc = "PDB interrupt enabled." ]
            _1,
        }
        impl PdbieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbieR::_0 => 0,
                    PdbieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbieR {
                match bits {
                    0 => PdbieR::_0,
                    1 => PdbieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbieR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdbifR {
            bits: u8,
        }
        impl PdbifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PDBEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbenR {
            # [ doc = "PDB disabled. Counter is off." ]
            _0,
            # [ doc = "PDB enabled." ]
            _1,
        }
        impl PdbenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbenR::_0 => 0,
                    PdbenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbenR {
                match bits {
                    0 => PdbenR::_0,
                    1 => PdbenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgselR {
            # [ doc = "Trigger-In 0 is selected." ]
            _0000,
            # [ doc = "Trigger-In 1 is selected." ]
            _0001,
            # [ doc = "Trigger-In 2 is selected." ]
            _0010,
            # [ doc = "Trigger-In 3 is selected." ]
            _0011,
            # [ doc = "Trigger-In 4 is selected." ]
            _0100,
            # [ doc = "Trigger-In 5 is selected." ]
            _0101,
            # [ doc = "Trigger-In 6 is selected." ]
            _0110,
            # [ doc = "Trigger-In 7 is selected." ]
            _0111,
            # [ doc = "Trigger-In 8 is selected." ]
            _1000,
            # [ doc = "Trigger-In 9 is selected." ]
            _1001,
            # [ doc = "Trigger-In 10 is selected." ]
            _1010,
            # [ doc = "Trigger-In 11 is selected." ]
            _1011,
            # [ doc = "Trigger-In 12 is selected." ]
            _1100,
            # [ doc = "Trigger-In 13 is selected." ]
            _1101,
            # [ doc = "Trigger-In 14 is selected." ]
            _1110,
            # [ doc = "Software trigger is selected." ]
            _1111,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgselR::_0000 => 0,
                    TrgselR::_0001 => 1,
                    TrgselR::_0010 => 2,
                    TrgselR::_0011 => 3,
                    TrgselR::_0100 => 4,
                    TrgselR::_0101 => 5,
                    TrgselR::_0110 => 6,
                    TrgselR::_0111 => 7,
                    TrgselR::_1000 => 8,
                    TrgselR::_1001 => 9,
                    TrgselR::_1010 => 10,
                    TrgselR::_1011 => 11,
                    TrgselR::_1100 => 12,
                    TrgselR::_1101 => 13,
                    TrgselR::_1110 => 14,
                    TrgselR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgselR {
                match bits {
                    0 => TrgselR::_0000,
                    1 => TrgselR::_0001,
                    2 => TrgselR::_0010,
                    3 => TrgselR::_0011,
                    4 => TrgselR::_0100,
                    5 => TrgselR::_0101,
                    6 => TrgselR::_0110,
                    7 => TrgselR::_0111,
                    8 => TrgselR::_1000,
                    9 => TrgselR::_1001,
                    10 => TrgselR::_1010,
                    11 => TrgselR::_1011,
                    12 => TrgselR::_1100,
                    13 => TrgselR::_1101,
                    14 => TrgselR::_1110,
                    15 => TrgselR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == TrgselR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == TrgselR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == TrgselR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == TrgselR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == TrgselR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == TrgselR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == TrgselR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == TrgselR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == TrgselR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == TrgselR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == TrgselR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == TrgselR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == TrgselR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == TrgselR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == TrgselR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == TrgselR::_1111
            }
        }
        # [ doc = "Possible values of the field `PRESCALER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescalerR {
            # [ doc = "Counting uses the peripheral clock divided by MULT (the multiplication factor)." ]
            _000,
            # [ doc = "Counting uses the peripheral clock divided by 2 x MULT (the multiplication factor)." ]
            _001,
            # [ doc = "Counting uses the peripheral clock divided by 4 x MULT (the multiplication factor)." ]
            _010,
            # [ doc = "Counting uses the peripheral clock divided by 8 x MULT (the multiplication factor)." ]
            _011,
            # [ doc = "Counting uses the peripheral clock divided by 16 x MULT (the multiplication factor)." ]
            _100,
            # [ doc = "Counting uses the peripheral clock divided by 32 x MULT (the multiplication factor)." ]
            _101,
            # [ doc = "Counting uses the peripheral clock divided by 64 x MULT (the multiplication factor)." ]
            _110,
            # [ doc = "Counting uses the peripheral clock divided by 128 x MULT (the multiplication factor)." ]
            _111,
        }
        impl PrescalerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescalerR::_000 => 0,
                    PrescalerR::_001 => 1,
                    PrescalerR::_010 => 2,
                    PrescalerR::_011 => 3,
                    PrescalerR::_100 => 4,
                    PrescalerR::_101 => 5,
                    PrescalerR::_110 => 6,
                    PrescalerR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescalerR {
                match bits {
                    0 => PrescalerR::_000,
                    1 => PrescalerR::_001,
                    2 => PrescalerR::_010,
                    3 => PrescalerR::_011,
                    4 => PrescalerR::_100,
                    5 => PrescalerR::_101,
                    6 => PrescalerR::_110,
                    7 => PrescalerR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PrescalerR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PrescalerR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PrescalerR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PrescalerR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PrescalerR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PrescalerR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PrescalerR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PrescalerR::_111
            }
        }
        # [ doc = "Possible values of the field `DMAEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaenR {
            # [ doc = "DMA disabled." ]
            _0,
            # [ doc = "DMA enabled." ]
            _1,
        }
        impl DmaenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaenR::_0 => 0,
                    DmaenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaenR {
                match bits {
                    0 => DmaenR::_0,
                    1 => DmaenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaenR::_1
            }
        }
        # [ doc = "Possible values of the field `PDBEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbeieR {
            # [ doc = "PDB sequence error interrupt disabled." ]
            _0,
            # [ doc = "PDB sequence error interrupt enabled." ]
            _1,
        }
        impl PdbeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbeieR::_0 => 0,
                    PdbeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbeieR {
                match bits {
                    0 => PdbeieR::_0,
                    1 => PdbeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbeieR::_1
            }
        }
        # [ doc = "Possible values of the field `LDMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LdmodR {
            # [ doc = "The internal registers are loaded with the values from their buffers, immediately after 1 is written to LDOK." ]
            _00,
            # [ doc = "The internal registers are loaded with the values from their buffers when the PDB counter (CNT) = MOD + 1 CNT delay elapsed, after 1 is written to LDOK." ]
            _01,
            # [ doc = "The internal registers are loaded with the values from their buffers when a trigger input event is detected, after 1 is written to LDOK." ]
            _10,
            # [ doc = "The internal registers are loaded with the values from their buffers when either the PDB counter (CNT) = MOD + 1 CNT delay elapsed, or a trigger input event is detected, after 1 is written to LDOK." ]
            _11,
        }
        impl LdmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LdmodR::_00 => 0,
                    LdmodR::_01 => 1,
                    LdmodR::_10 => 2,
                    LdmodR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LdmodR {
                match bits {
                    0 => LdmodR::_00,
                    1 => LdmodR::_01,
                    2 => LdmodR::_10,
                    3 => LdmodR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == LdmodR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == LdmodR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == LdmodR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == LdmodR::_11
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdokW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONT`" ]
        pub enum ContW {
            # [ doc = "PDB operation in One-Shot mode" ]
            _0,
            # [ doc = "PDB operation in Continuous mode" ]
            _1,
        }
        impl ContW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContW::_0 => 0,
                    ContW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB operation in One-Shot mode" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContW::_0)
            }
            # [ doc = "PDB operation in Continuous mode" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MULT`" ]
        pub enum MultW {
            # [ doc = "Multiplication factor is 1." ]
            _00,
            # [ doc = "Multiplication factor is 10." ]
            _01,
            # [ doc = "Multiplication factor is 20." ]
            _10,
            # [ doc = "Multiplication factor is 40." ]
            _11,
        }
        impl MultW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MultW::_00 => 0,
                    MultW::_01 => 1,
                    MultW::_10 => 2,
                    MultW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MultW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MultW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MultW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Multiplication factor is 1." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(MultW::_00)
            }
            # [ doc = "Multiplication factor is 10." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(MultW::_01)
            }
            # [ doc = "Multiplication factor is 20." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(MultW::_10)
            }
            # [ doc = "Multiplication factor is 40." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(MultW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDBIE`" ]
        pub enum PdbieW {
            # [ doc = "PDB interrupt disabled." ]
            _0,
            # [ doc = "PDB interrupt enabled." ]
            _1,
        }
        impl PdbieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbieW::_0 => 0,
                    PdbieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbieW::_0)
            }
            # [ doc = "PDB interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbifW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDBEN`" ]
        pub enum PdbenW {
            # [ doc = "PDB disabled. Counter is off." ]
            _0,
            # [ doc = "PDB enabled." ]
            _1,
        }
        impl PdbenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbenW::_0 => 0,
                    PdbenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB disabled. Counter is off." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbenW::_0)
            }
            # [ doc = "PDB enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGSEL`" ]
        pub enum TrgselW {
            # [ doc = "Trigger-In 0 is selected." ]
            _0000,
            # [ doc = "Trigger-In 1 is selected." ]
            _0001,
            # [ doc = "Trigger-In 2 is selected." ]
            _0010,
            # [ doc = "Trigger-In 3 is selected." ]
            _0011,
            # [ doc = "Trigger-In 4 is selected." ]
            _0100,
            # [ doc = "Trigger-In 5 is selected." ]
            _0101,
            # [ doc = "Trigger-In 6 is selected." ]
            _0110,
            # [ doc = "Trigger-In 7 is selected." ]
            _0111,
            # [ doc = "Trigger-In 8 is selected." ]
            _1000,
            # [ doc = "Trigger-In 9 is selected." ]
            _1001,
            # [ doc = "Trigger-In 10 is selected." ]
            _1010,
            # [ doc = "Trigger-In 11 is selected." ]
            _1011,
            # [ doc = "Trigger-In 12 is selected." ]
            _1100,
            # [ doc = "Trigger-In 13 is selected." ]
            _1101,
            # [ doc = "Trigger-In 14 is selected." ]
            _1110,
            # [ doc = "Software trigger is selected." ]
            _1111,
        }
        impl TrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgselW::_0000 => 0,
                    TrgselW::_0001 => 1,
                    TrgselW::_0010 => 2,
                    TrgselW::_0011 => 3,
                    TrgselW::_0100 => 4,
                    TrgselW::_0101 => 5,
                    TrgselW::_0110 => 6,
                    TrgselW::_0111 => 7,
                    TrgselW::_1000 => 8,
                    TrgselW::_1001 => 9,
                    TrgselW::_1010 => 10,
                    TrgselW::_1011 => 11,
                    TrgselW::_1100 => 12,
                    TrgselW::_1101 => 13,
                    TrgselW::_1110 => 14,
                    TrgselW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger-In 0 is selected." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(TrgselW::_0000)
            }
            # [ doc = "Trigger-In 1 is selected." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(TrgselW::_0001)
            }
            # [ doc = "Trigger-In 2 is selected." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(TrgselW::_0010)
            }
            # [ doc = "Trigger-In 3 is selected." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(TrgselW::_0011)
            }
            # [ doc = "Trigger-In 4 is selected." ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(TrgselW::_0100)
            }
            # [ doc = "Trigger-In 5 is selected." ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(TrgselW::_0101)
            }
            # [ doc = "Trigger-In 6 is selected." ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(TrgselW::_0110)
            }
            # [ doc = "Trigger-In 7 is selected." ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(TrgselW::_0111)
            }
            # [ doc = "Trigger-In 8 is selected." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(TrgselW::_1000)
            }
            # [ doc = "Trigger-In 9 is selected." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(TrgselW::_1001)
            }
            # [ doc = "Trigger-In 10 is selected." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(TrgselW::_1010)
            }
            # [ doc = "Trigger-In 11 is selected." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(TrgselW::_1011)
            }
            # [ doc = "Trigger-In 12 is selected." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(TrgselW::_1100)
            }
            # [ doc = "Trigger-In 13 is selected." ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(TrgselW::_1101)
            }
            # [ doc = "Trigger-In 14 is selected." ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(TrgselW::_1110)
            }
            # [ doc = "Software trigger is selected." ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(TrgselW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALER`" ]
        pub enum PrescalerW {
            # [ doc = "Counting uses the peripheral clock divided by MULT (the multiplication factor)." ]
            _000,
            # [ doc = "Counting uses the peripheral clock divided by 2 x MULT (the multiplication factor)." ]
            _001,
            # [ doc = "Counting uses the peripheral clock divided by 4 x MULT (the multiplication factor)." ]
            _010,
            # [ doc = "Counting uses the peripheral clock divided by 8 x MULT (the multiplication factor)." ]
            _011,
            # [ doc = "Counting uses the peripheral clock divided by 16 x MULT (the multiplication factor)." ]
            _100,
            # [ doc = "Counting uses the peripheral clock divided by 32 x MULT (the multiplication factor)." ]
            _101,
            # [ doc = "Counting uses the peripheral clock divided by 64 x MULT (the multiplication factor)." ]
            _110,
            # [ doc = "Counting uses the peripheral clock divided by 128 x MULT (the multiplication factor)." ]
            _111,
        }
        impl PrescalerW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescalerW::_000 => 0,
                    PrescalerW::_001 => 1,
                    PrescalerW::_010 => 2,
                    PrescalerW::_011 => 3,
                    PrescalerW::_100 => 4,
                    PrescalerW::_101 => 5,
                    PrescalerW::_110 => 6,
                    PrescalerW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescalerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescalerW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescalerW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Counting uses the peripheral clock divided by MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PrescalerW::_000)
            }
            # [ doc = "Counting uses the peripheral clock divided by 2 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PrescalerW::_001)
            }
            # [ doc = "Counting uses the peripheral clock divided by 4 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PrescalerW::_010)
            }
            # [ doc = "Counting uses the peripheral clock divided by 8 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PrescalerW::_011)
            }
            # [ doc = "Counting uses the peripheral clock divided by 16 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PrescalerW::_100)
            }
            # [ doc = "Counting uses the peripheral clock divided by 32 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PrescalerW::_101)
            }
            # [ doc = "Counting uses the peripheral clock divided by 64 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PrescalerW::_110)
            }
            # [ doc = "Counting uses the peripheral clock divided by 128 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PrescalerW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMAEN`" ]
        pub enum DmaenW {
            # [ doc = "DMA disabled." ]
            _0,
            # [ doc = "DMA enabled." ]
            _1,
        }
        impl DmaenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaenW::_0 => 0,
                    DmaenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaenW::_0)
            }
            # [ doc = "DMA enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwtrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwtrigW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDBEIE`" ]
        pub enum PdbeieW {
            # [ doc = "PDB sequence error interrupt disabled." ]
            _0,
            # [ doc = "PDB sequence error interrupt enabled." ]
            _1,
        }
        impl PdbeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbeieW::_0 => 0,
                    PdbeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB sequence error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbeieW::_0)
            }
            # [ doc = "PDB sequence error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LDMOD`" ]
        pub enum LdmodW {
            # [ doc = "The internal registers are loaded with the values from their buffers, immediately after 1 is written to LDOK." ]
            _00,
            # [ doc = "The internal registers are loaded with the values from their buffers when the PDB counter (CNT) = MOD + 1 CNT delay elapsed, after 1 is written to LDOK." ]
            _01,
            # [ doc = "The internal registers are loaded with the values from their buffers when a trigger input event is detected, after 1 is written to LDOK." ]
            _10,
            # [ doc = "The internal registers are loaded with the values from their buffers when either the PDB counter (CNT) = MOD + 1 CNT delay elapsed, or a trigger input event is detected, after 1 is written to LDOK." ]
            _11,
        }
        impl LdmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LdmodW::_00 => 0,
                    LdmodW::_01 => 1,
                    LdmodW::_10 => 2,
                    LdmodW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LdmodW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The internal registers are loaded with the values from their buffers, immediately after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(LdmodW::_00)
            }
            # [ doc = "The internal registers are loaded with the values from their buffers when the PDB counter (CNT) = MOD + 1 CNT delay elapsed, after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(LdmodW::_01)
            }
            # [ doc = "The internal registers are loaded with the values from their buffers when a trigger input event is detected, after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(LdmodW::_10)
            }
            # [ doc = "The internal registers are loaded with the values from their buffers when either the PDB counter (CNT) = MOD + 1 CNT delay elapsed, or a trigger input event is detected, after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(LdmodW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Load OK" ]
            # [ inline ( always ) ]
            pub fn ldok(&self) -> LdokR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LdokR { bits }
            }
            # [ doc = "Bit 1 - Continuous Mode Enable" ]
            # [ inline ( always ) ]
            pub fn cont(&self) -> ContR {
                ContR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 2:3 - Multiplication Factor Select for Prescaler" ]
            # [ inline ( always ) ]
            pub fn mult(&self) -> MultR {
                MultR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - PDB Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbie(&self) -> PdbieR {
                PdbieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - PDB Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn pdbif(&self) -> PdbifR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PdbifR { bits }
            }
            # [ doc = "Bit 7 - PDB Enable" ]
            # [ inline ( always ) ]
            pub fn pdben(&self) -> PdbenR {
                PdbenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:11 - Trigger Input Source Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                TrgselR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 12:14 - Prescaler Divider Select" ]
            # [ inline ( always ) ]
            pub fn prescaler(&self) -> PrescalerR {
                PrescalerR::_from({
                                      const MASK: u8 = 7;
                                      const OFFSET: u8 = 12;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&self) -> DmaenR {
                DmaenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 17 - PDB Sequence Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbeie(&self) -> PdbeieR {
                PdbeieR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 18:19 - Load Mode Select" ]
            # [ inline ( always ) ]
            pub fn ldmod(&self) -> LdmodR {
                LdmodR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Load OK" ]
            # [ inline ( always ) ]
            pub fn ldok(&mut self) -> _LdokW {
                _LdokW { w: self }
            }
            # [ doc = "Bit 1 - Continuous Mode Enable" ]
            # [ inline ( always ) ]
            pub fn cont(&mut self) -> _ContW {
                _ContW { w: self }
            }
            # [ doc = "Bits 2:3 - Multiplication Factor Select for Prescaler" ]
            # [ inline ( always ) ]
            pub fn mult(&mut self) -> _MultW {
                _MultW { w: self }
            }
            # [ doc = "Bit 5 - PDB Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbie(&mut self) -> _PdbieW {
                _PdbieW { w: self }
            }
            # [ doc = "Bit 6 - PDB Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn pdbif(&mut self) -> _PdbifW {
                _PdbifW { w: self }
            }
            # [ doc = "Bit 7 - PDB Enable" ]
            # [ inline ( always ) ]
            pub fn pdben(&mut self) -> _PdbenW {
                _PdbenW { w: self }
            }
            # [ doc = "Bits 8:11 - Trigger Input Source Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
            # [ doc = "Bits 12:14 - Prescaler Divider Select" ]
            # [ inline ( always ) ]
            pub fn prescaler(&mut self) -> _PrescalerW {
                _PrescalerW { w: self }
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&mut self) -> _DmaenW {
                _DmaenW { w: self }
            }
            # [ doc = "Bit 16 - Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swtrig(&mut self) -> _SwtrigW {
                _SwtrigW { w: self }
            }
            # [ doc = "Bit 17 - PDB Sequence Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbeie(&mut self) -> _PdbeieW {
                _PdbeieW { w: self }
            }
            # [ doc = "Bits 18:19 - Load Mode Select" ]
            # [ inline ( always ) ]
            pub fn ldmod(&mut self) -> _LdmodW {
                _LdmodW { w: self }
            }
        }
    }
    # [ doc = "Modulus register" ]
    pub struct Mod {
        register: VolatileCell<u32>,
    }
    # [ doc = "Modulus register" ]
    pub mod mod_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mod {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ModR {
            bits: u16,
        }
        impl ModR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Modulus" ]
            # [ inline ( always ) ]
            pub fn mod_(&self) -> ModR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ModR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Modulus" ]
            # [ inline ( always ) ]
            pub fn mod_(&mut self) -> _ModW {
                _ModW { w: self }
            }
        }
    }
    # [ doc = "Counter register" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter register" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CntR {
            bits: u16,
        }
        impl CntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Counter" ]
            # [ inline ( always ) ]
            pub fn cnt(&self) -> CntR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CntR { bits }
            }
        }
    }
    # [ doc = "Interrupt Delay register" ]
    pub struct Idly {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Delay register" ]
    pub mod idly {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Idly {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdlyR {
            bits: u16,
        }
        impl IdlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Interrupt Delay" ]
            # [ inline ( always ) ]
            pub fn idly(&self) -> IdlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                IdlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Interrupt Delay" ]
            # [ inline ( always ) ]
            pub fn idly(&mut self) -> _IdlyW {
                _IdlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Control register 1" ]
    pub struct Chc1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Control register 1" ]
    pub mod chc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnR {
            # [ doc = "PDB channel's corresponding pre-trigger disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger enabled." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl EnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnR::_0 => 0,
                    EnR::_1 => 1,
                    EnR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnR {
                match bits {
                    0 => EnR::_0,
                    1 => EnR::_1,
                    i => EnR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnR::_1
            }
        }
        # [ doc = "Possible values of the field `TOS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TosR {
            # [ doc = "PDB channel's corresponding pre-trigger is in bypassed mode. The pre-trigger asserts one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SWTRIG is written with 1." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger asserts when the counter reaches the channel delay register and one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SETRIG is written with 1." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TosR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TosR::_0 => 0,
                    TosR::_1 => 1,
                    TosR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TosR {
                match bits {
                    0 => TosR::_0,
                    1 => TosR::_1,
                    i => TosR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TosR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TosR::_1
            }
        }
        # [ doc = "Possible values of the field `BB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BbR {
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation enabled." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BbR::_0 => 0,
                    BbR::_1 => 1,
                    BbR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BbR {
                match bits {
                    0 => BbR::_0,
                    1 => BbR::_1,
                    i => BbR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BbR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EN`" ]
        pub enum EnW {
            # [ doc = "PDB channel's corresponding pre-trigger disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger enabled." ]
            _1,
        }
        impl EnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnW::_0 => 0,
                    EnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB channel's corresponding pre-trigger disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnW::_0)
            }
            # [ doc = "PDB channel's corresponding pre-trigger enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOS`" ]
        pub enum TosW {
            # [ doc = "PDB channel's corresponding pre-trigger is in bypassed mode. The pre-trigger asserts one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SWTRIG is written with 1." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger asserts when the counter reaches the channel delay register and one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SETRIG is written with 1." ]
            _1,
        }
        impl TosW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TosW::_0 => 0,
                    TosW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TosW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TosW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TosW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB channel's corresponding pre-trigger is in bypassed mode. The pre-trigger asserts one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SWTRIG is written with 1." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TosW::_0)
            }
            # [ doc = "PDB channel's corresponding pre-trigger asserts when the counter reaches the channel delay register and one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SETRIG is written with 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TosW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BB`" ]
        pub enum BbW {
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation enabled." ]
            _1,
        }
        impl BbW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BbW::_0 => 0,
                    BbW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BbW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BbW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BbW::_0)
            }
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BbW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - PDB Channel Pre-Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn en(&self) -> EnR {
                EnR::_from({
                               const MASK: u8 = 255;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:15 - PDB Channel Pre-Trigger Output Select" ]
            # [ inline ( always ) ]
            pub fn tos(&self) -> TosR {
                TosR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:23 - PDB Channel Pre-Trigger Back-to-Back Operation Enable" ]
            # [ inline ( always ) ]
            pub fn bb(&self) -> BbR {
                BbR::_from({
                               const MASK: u8 = 255;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - PDB Channel Pre-Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn en(&mut self) -> _EnW {
                _EnW { w: self }
            }
            # [ doc = "Bits 8:15 - PDB Channel Pre-Trigger Output Select" ]
            # [ inline ( always ) ]
            pub fn tos(&mut self) -> _TosW {
                _TosW { w: self }
            }
            # [ doc = "Bits 16:23 - PDB Channel Pre-Trigger Back-to-Back Operation Enable" ]
            # [ inline ( always ) ]
            pub fn bb(&mut self) -> _BbW {
                _BbW { w: self }
            }
        }
    }
    # [ doc = "Channel n Status register" ]
    pub struct Chs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Status register" ]
    pub mod chs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrR {
            # [ doc = "Sequence error not detected on PDB channel's corresponding pre-trigger." ]
            _0,
            # [ doc = "Sequence error detected on PDB channel's corresponding pre-trigger. ADCn block can be triggered for a conversion by one pre-trigger from PDB channel n. When one conversion, which is triggered by one of the pre-triggers from PDB channel n, is in progress, new trigger from PDB channel's corresponding pre-trigger m cannot be accepted by ADCn, and ERR[m] is set. Writing 0's to clear the sequence error flags." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ErrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrR::_0 => 0,
                    ErrR::_1 => 1,
                    ErrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrR {
                match bits {
                    0 => ErrR::_0,
                    1 => ErrR::_1,
                    i => ErrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CfR {
            bits: u8,
        }
        impl CfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `ERR`" ]
        pub enum ErrW {
            # [ doc = "Sequence error not detected on PDB channel's corresponding pre-trigger." ]
            _0,
            # [ doc = "Sequence error detected on PDB channel's corresponding pre-trigger. ADCn block can be triggered for a conversion by one pre-trigger from PDB channel n. When one conversion, which is triggered by one of the pre-triggers from PDB channel n, is in progress, new trigger from PDB channel's corresponding pre-trigger m cannot be accepted by ADCn, and ERR[m] is set. Writing 0's to clear the sequence error flags." ]
            _1,
        }
        impl ErrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrW::_0 => 0,
                    ErrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Sequence error not detected on PDB channel's corresponding pre-trigger." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrW::_0)
            }
            # [ doc = "Sequence error detected on PDB channel's corresponding pre-trigger. ADCn block can be triggered for a conversion by one pre-trigger from PDB channel n. When one conversion, which is triggered by one of the pre-triggers from PDB channel n, is in progress, new trigger from PDB channel's corresponding pre-trigger m cannot be accepted by ADCn, and ERR[m] is set. Writing 0's to clear the sequence error flags." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CfW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - PDB Channel Sequence Error Flags" ]
            # [ inline ( always ) ]
            pub fn err(&self) -> ErrR {
                ErrR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:23 - PDB Channel Flags" ]
            # [ inline ( always ) ]
            pub fn cf(&self) -> CfR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CfR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - PDB Channel Sequence Error Flags" ]
            # [ inline ( always ) ]
            pub fn err(&mut self) -> _ErrW {
                _ErrW { w: self }
            }
            # [ doc = "Bits 16:23 - PDB Channel Flags" ]
            # [ inline ( always ) ]
            pub fn cf(&mut self) -> _CfW {
                _CfW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 0 register" ]
    pub struct Chdly0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 0 register" ]
    pub mod chdly0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 1 register" ]
    pub struct Chdly1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 1 register" ]
    pub mod chdly1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 2 register" ]
    pub struct Chdly2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 2 register" ]
    pub mod chdly2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 3 register" ]
    pub struct Chdly3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 3 register" ]
    pub mod chdly3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 4 register" ]
    pub struct Chdly4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 4 register" ]
    pub mod chdly4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 5 register" ]
    pub struct Chdly5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 5 register" ]
    pub mod chdly5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 6 register" ]
    pub struct Chdly6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 6 register" ]
    pub mod chdly6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 7 register" ]
    pub struct Chdly7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 7 register" ]
    pub mod chdly7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Pulse-Out n Enable register" ]
    pub struct Poen {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pulse-Out n Enable register" ]
    pub mod poen {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Poen {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `POEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PoenR {
            # [ doc = "PDB Pulse-Out disabled" ]
            _0,
            # [ doc = "PDB Pulse-Out enabled" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PoenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PoenR::_0 => 0,
                    PoenR::_1 => 1,
                    PoenR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PoenR {
                match bits {
                    0 => PoenR::_0,
                    1 => PoenR::_1,
                    i => PoenR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PoenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PoenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `POEN`" ]
        pub enum PoenW {
            # [ doc = "PDB Pulse-Out disabled" ]
            _0,
            # [ doc = "PDB Pulse-Out enabled" ]
            _1,
        }
        impl PoenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PoenW::_0 => 0,
                    PoenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PoenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PoenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PoenW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB Pulse-Out disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PoenW::_0)
            }
            # [ doc = "PDB Pulse-Out enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PoenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - PDB Pulse-Out Enable" ]
            # [ inline ( always ) ]
            pub fn poen(&self) -> PoenR {
                PoenR::_from({
                                 const MASK: u8 = 255;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - PDB Pulse-Out Enable" ]
            # [ inline ( always ) ]
            pub fn poen(&mut self) -> _PoenW {
                _PoenW { w: self }
            }
        }
    }
    # [ doc = "Pulse-Out n Delay register" ]
    pub struct Podly {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pulse-Out n Delay register" ]
    pub mod podly {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Podly {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly2R {
            bits: u16,
        }
        impl Dly2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly1R {
            bits: u16,
        }
        impl Dly1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Pulse-Out Delay 2" ]
            # [ inline ( always ) ]
            pub fn dly2(&self) -> Dly2R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Dly2R { bits }
            }
            # [ doc = "Bits 16:31 - PDB Pulse-Out Delay 1" ]
            # [ inline ( always ) ]
            pub fn dly1(&self) -> Dly1R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Dly1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Pulse-Out Delay 2" ]
            # [ inline ( always ) ]
            pub fn dly2(&mut self) -> _Dly2W {
                _Dly2W { w: self }
            }
            # [ doc = "Bits 16:31 - PDB Pulse-Out Delay 1" ]
            # [ inline ( always ) ]
            pub fn dly1(&mut self) -> _Dly1W {
                _Dly1W { w: self }
            }
        }
    }
    # [ doc = "PDB0_DLY2 register." ]
    pub struct Dly2 {
        register: VolatileCell<u16>,
    }
    # [ doc = "PDB0_DLY2 register." ]
    pub mod dly2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Dly2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly2R {
            bits: u16,
        }
        impl Dly2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - DLY2" ]
            # [ inline ( always ) ]
            pub fn dly2(&self) -> Dly2R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                Dly2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - DLY2" ]
            # [ inline ( always ) ]
            pub fn dly2(&mut self) -> _Dly2W {
                _Dly2W { w: self }
            }
        }
    }
    # [ doc = "PDB0_DLY1 register." ]
    pub struct Dly1 {
        register: VolatileCell<u16>,
    }
    # [ doc = "PDB0_DLY1 register." ]
    pub mod dly1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Dly1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly1R {
            bits: u16,
        }
        impl Dly1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - DLY1" ]
            # [ inline ( always ) ]
            pub fn dly1(&self) -> Dly1R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                Dly1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - DLY1" ]
            # [ inline ( always ) ]
            pub fn dly1(&mut self) -> _Dly1W {
                _Dly1W { w: self }
            }
        }
    }
}
# [ doc = "Programmable Delay Block" ]
pub struct Pdb0 {
    register_block: pdb0::RegisterBlock,
}
impl Deref for Pdb0 {
    type Target = pdb0::RegisterBlock;
    fn deref(&self) -> &pdb0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Programmable Delay Block" ]
pub const PDB1: Peripheral<Pdb1> = unsafe { Peripheral::new(1073942528) };
# [ doc = "Programmable Delay Block" ]
pub mod pdb1 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Status and Control register" ]
        pub sc: Sc,
        # [ doc = "0x04 - Modulus register" ]
        pub mod_: Mod,
        # [ doc = "0x08 - Counter register" ]
        pub cnt: Cnt,
        # [ doc = "0x0c - Interrupt Delay register" ]
        pub idly: Idly,
        # [ doc = "0x10 - Channel n Control register 1" ]
        pub ch0c1: Chc1,
        # [ doc = "0x14 - Channel n Status register" ]
        pub ch0s: Chs,
        # [ doc = "0x18 - Channel n Delay 0 register" ]
        pub ch0dly0: Chdly0,
        # [ doc = "0x1c - Channel n Delay 1 register" ]
        pub ch0dly1: Chdly1,
        # [ doc = "0x20 - Channel n Delay 2 register" ]
        pub ch0dly2: Chdly2,
        # [ doc = "0x24 - Channel n Delay 3 register" ]
        pub ch0dly3: Chdly3,
        # [ doc = "0x28 - Channel n Delay 4 register" ]
        pub ch0dly4: Chdly4,
        # [ doc = "0x2c - Channel n Delay 5 register" ]
        pub ch0dly5: Chdly5,
        # [ doc = "0x30 - Channel n Delay 6 register" ]
        pub ch0dly6: Chdly6,
        # [ doc = "0x34 - Channel n Delay 7 register" ]
        pub ch0dly7: Chdly7,
        # [ doc = "0x38 - Channel n Control register 1" ]
        pub ch1c1: Chc1,
        # [ doc = "0x3c - Channel n Status register" ]
        pub ch1s: Chs,
        # [ doc = "0x40 - Channel n Delay 0 register" ]
        pub ch1dly0: Chdly0,
        # [ doc = "0x44 - Channel n Delay 1 register" ]
        pub ch1dly1: Chdly1,
        # [ doc = "0x48 - Channel n Delay 2 register" ]
        pub ch1dly2: Chdly2,
        # [ doc = "0x4c - Channel n Delay 3 register" ]
        pub ch1dly3: Chdly3,
        # [ doc = "0x50 - Channel n Delay 4 register" ]
        pub ch1dly4: Chdly4,
        # [ doc = "0x54 - Channel n Delay 5 register" ]
        pub ch1dly5: Chdly5,
        # [ doc = "0x58 - Channel n Delay 6 register" ]
        pub ch1dly6: Chdly6,
        # [ doc = "0x5c - Channel n Delay 7 register" ]
        pub ch1dly7: Chdly7,
        _reserved0: [u8; 304usize],
        # [ doc = "0x190 - Pulse-Out n Enable register" ]
        pub poen: Poen,
        # [ doc = "0x194 - Pulse-Out n Delay register" ]
        pub podly: Podly,
    }
    # [ doc = "Status and Control register" ]
    pub struct Sc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Status and Control register" ]
    pub mod sc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LdokR {
            bits: u8,
        }
        impl LdokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CONT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ContR {
            # [ doc = "PDB operation in One-Shot mode" ]
            _0,
            # [ doc = "PDB operation in Continuous mode" ]
            _1,
        }
        impl ContR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ContR::_0 => 0,
                    ContR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ContR {
                match bits {
                    0 => ContR::_0,
                    1 => ContR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ContR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ContR::_1
            }
        }
        # [ doc = "Possible values of the field `MULT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MultR {
            # [ doc = "Multiplication factor is 1." ]
            _00,
            # [ doc = "Multiplication factor is 10." ]
            _01,
            # [ doc = "Multiplication factor is 20." ]
            _10,
            # [ doc = "Multiplication factor is 40." ]
            _11,
        }
        impl MultR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MultR::_00 => 0,
                    MultR::_01 => 1,
                    MultR::_10 => 2,
                    MultR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MultR {
                match bits {
                    0 => MultR::_00,
                    1 => MultR::_01,
                    2 => MultR::_10,
                    3 => MultR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == MultR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == MultR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == MultR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == MultR::_11
            }
        }
        # [ doc = "Possible values of the field `PDBIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbieR {
            # [ doc = "PDB interrupt disabled." ]
            _0,
            # [ doc = "PDB interrupt enabled." ]
            _1,
        }
        impl PdbieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbieR::_0 => 0,
                    PdbieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbieR {
                match bits {
                    0 => PdbieR::_0,
                    1 => PdbieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbieR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdbifR {
            bits: u8,
        }
        impl PdbifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PDBEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbenR {
            # [ doc = "PDB disabled. Counter is off." ]
            _0,
            # [ doc = "PDB enabled." ]
            _1,
        }
        impl PdbenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbenR::_0 => 0,
                    PdbenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbenR {
                match bits {
                    0 => PdbenR::_0,
                    1 => PdbenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgselR {
            # [ doc = "Trigger-In 0 is selected." ]
            _0000,
            # [ doc = "Trigger-In 1 is selected." ]
            _0001,
            # [ doc = "Trigger-In 2 is selected." ]
            _0010,
            # [ doc = "Trigger-In 3 is selected." ]
            _0011,
            # [ doc = "Trigger-In 4 is selected." ]
            _0100,
            # [ doc = "Trigger-In 5 is selected." ]
            _0101,
            # [ doc = "Trigger-In 6 is selected." ]
            _0110,
            # [ doc = "Trigger-In 7 is selected." ]
            _0111,
            # [ doc = "Trigger-In 8 is selected." ]
            _1000,
            # [ doc = "Trigger-In 9 is selected." ]
            _1001,
            # [ doc = "Trigger-In 10 is selected." ]
            _1010,
            # [ doc = "Trigger-In 11 is selected." ]
            _1011,
            # [ doc = "Trigger-In 12 is selected." ]
            _1100,
            # [ doc = "Trigger-In 13 is selected." ]
            _1101,
            # [ doc = "Trigger-In 14 is selected." ]
            _1110,
            # [ doc = "Software trigger is selected." ]
            _1111,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgselR::_0000 => 0,
                    TrgselR::_0001 => 1,
                    TrgselR::_0010 => 2,
                    TrgselR::_0011 => 3,
                    TrgselR::_0100 => 4,
                    TrgselR::_0101 => 5,
                    TrgselR::_0110 => 6,
                    TrgselR::_0111 => 7,
                    TrgselR::_1000 => 8,
                    TrgselR::_1001 => 9,
                    TrgselR::_1010 => 10,
                    TrgselR::_1011 => 11,
                    TrgselR::_1100 => 12,
                    TrgselR::_1101 => 13,
                    TrgselR::_1110 => 14,
                    TrgselR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgselR {
                match bits {
                    0 => TrgselR::_0000,
                    1 => TrgselR::_0001,
                    2 => TrgselR::_0010,
                    3 => TrgselR::_0011,
                    4 => TrgselR::_0100,
                    5 => TrgselR::_0101,
                    6 => TrgselR::_0110,
                    7 => TrgselR::_0111,
                    8 => TrgselR::_1000,
                    9 => TrgselR::_1001,
                    10 => TrgselR::_1010,
                    11 => TrgselR::_1011,
                    12 => TrgselR::_1100,
                    13 => TrgselR::_1101,
                    14 => TrgselR::_1110,
                    15 => TrgselR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == TrgselR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == TrgselR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == TrgselR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == TrgselR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == TrgselR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == TrgselR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == TrgselR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == TrgselR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == TrgselR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == TrgselR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == TrgselR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == TrgselR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == TrgselR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == TrgselR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == TrgselR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == TrgselR::_1111
            }
        }
        # [ doc = "Possible values of the field `PRESCALER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescalerR {
            # [ doc = "Counting uses the peripheral clock divided by MULT (the multiplication factor)." ]
            _000,
            # [ doc = "Counting uses the peripheral clock divided by 2 x MULT (the multiplication factor)." ]
            _001,
            # [ doc = "Counting uses the peripheral clock divided by 4 x MULT (the multiplication factor)." ]
            _010,
            # [ doc = "Counting uses the peripheral clock divided by 8 x MULT (the multiplication factor)." ]
            _011,
            # [ doc = "Counting uses the peripheral clock divided by 16 x MULT (the multiplication factor)." ]
            _100,
            # [ doc = "Counting uses the peripheral clock divided by 32 x MULT (the multiplication factor)." ]
            _101,
            # [ doc = "Counting uses the peripheral clock divided by 64 x MULT (the multiplication factor)." ]
            _110,
            # [ doc = "Counting uses the peripheral clock divided by 128 x MULT (the multiplication factor)." ]
            _111,
        }
        impl PrescalerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescalerR::_000 => 0,
                    PrescalerR::_001 => 1,
                    PrescalerR::_010 => 2,
                    PrescalerR::_011 => 3,
                    PrescalerR::_100 => 4,
                    PrescalerR::_101 => 5,
                    PrescalerR::_110 => 6,
                    PrescalerR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescalerR {
                match bits {
                    0 => PrescalerR::_000,
                    1 => PrescalerR::_001,
                    2 => PrescalerR::_010,
                    3 => PrescalerR::_011,
                    4 => PrescalerR::_100,
                    5 => PrescalerR::_101,
                    6 => PrescalerR::_110,
                    7 => PrescalerR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PrescalerR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PrescalerR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PrescalerR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PrescalerR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PrescalerR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PrescalerR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PrescalerR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PrescalerR::_111
            }
        }
        # [ doc = "Possible values of the field `DMAEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaenR {
            # [ doc = "DMA disabled." ]
            _0,
            # [ doc = "DMA enabled." ]
            _1,
        }
        impl DmaenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaenR::_0 => 0,
                    DmaenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaenR {
                match bits {
                    0 => DmaenR::_0,
                    1 => DmaenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaenR::_1
            }
        }
        # [ doc = "Possible values of the field `PDBEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbeieR {
            # [ doc = "PDB sequence error interrupt disabled." ]
            _0,
            # [ doc = "PDB sequence error interrupt enabled." ]
            _1,
        }
        impl PdbeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbeieR::_0 => 0,
                    PdbeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbeieR {
                match bits {
                    0 => PdbeieR::_0,
                    1 => PdbeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbeieR::_1
            }
        }
        # [ doc = "Possible values of the field `LDMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LdmodR {
            # [ doc = "The internal registers are loaded with the values from their buffers, immediately after 1 is written to LDOK." ]
            _00,
            # [ doc = "The internal registers are loaded with the values from their buffers when the PDB counter (CNT) = MOD + 1 CNT delay elapsed, after 1 is written to LDOK." ]
            _01,
            # [ doc = "The internal registers are loaded with the values from their buffers when a trigger input event is detected, after 1 is written to LDOK." ]
            _10,
            # [ doc = "The internal registers are loaded with the values from their buffers when either the PDB counter (CNT) = MOD + 1 CNT delay elapsed, or a trigger input event is detected, after 1 is written to LDOK." ]
            _11,
        }
        impl LdmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LdmodR::_00 => 0,
                    LdmodR::_01 => 1,
                    LdmodR::_10 => 2,
                    LdmodR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LdmodR {
                match bits {
                    0 => LdmodR::_00,
                    1 => LdmodR::_01,
                    2 => LdmodR::_10,
                    3 => LdmodR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == LdmodR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == LdmodR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == LdmodR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == LdmodR::_11
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdokW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CONT`" ]
        pub enum ContW {
            # [ doc = "PDB operation in One-Shot mode" ]
            _0,
            # [ doc = "PDB operation in Continuous mode" ]
            _1,
        }
        impl ContW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ContW::_0 => 0,
                    ContW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ContW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ContW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ContW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB operation in One-Shot mode" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ContW::_0)
            }
            # [ doc = "PDB operation in Continuous mode" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ContW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MULT`" ]
        pub enum MultW {
            # [ doc = "Multiplication factor is 1." ]
            _00,
            # [ doc = "Multiplication factor is 10." ]
            _01,
            # [ doc = "Multiplication factor is 20." ]
            _10,
            # [ doc = "Multiplication factor is 40." ]
            _11,
        }
        impl MultW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MultW::_00 => 0,
                    MultW::_01 => 1,
                    MultW::_10 => 2,
                    MultW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MultW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MultW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MultW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Multiplication factor is 1." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(MultW::_00)
            }
            # [ doc = "Multiplication factor is 10." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(MultW::_01)
            }
            # [ doc = "Multiplication factor is 20." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(MultW::_10)
            }
            # [ doc = "Multiplication factor is 40." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(MultW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDBIE`" ]
        pub enum PdbieW {
            # [ doc = "PDB interrupt disabled." ]
            _0,
            # [ doc = "PDB interrupt enabled." ]
            _1,
        }
        impl PdbieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbieW::_0 => 0,
                    PdbieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbieW::_0)
            }
            # [ doc = "PDB interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbifW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDBEN`" ]
        pub enum PdbenW {
            # [ doc = "PDB disabled. Counter is off." ]
            _0,
            # [ doc = "PDB enabled." ]
            _1,
        }
        impl PdbenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbenW::_0 => 0,
                    PdbenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB disabled. Counter is off." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbenW::_0)
            }
            # [ doc = "PDB enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGSEL`" ]
        pub enum TrgselW {
            # [ doc = "Trigger-In 0 is selected." ]
            _0000,
            # [ doc = "Trigger-In 1 is selected." ]
            _0001,
            # [ doc = "Trigger-In 2 is selected." ]
            _0010,
            # [ doc = "Trigger-In 3 is selected." ]
            _0011,
            # [ doc = "Trigger-In 4 is selected." ]
            _0100,
            # [ doc = "Trigger-In 5 is selected." ]
            _0101,
            # [ doc = "Trigger-In 6 is selected." ]
            _0110,
            # [ doc = "Trigger-In 7 is selected." ]
            _0111,
            # [ doc = "Trigger-In 8 is selected." ]
            _1000,
            # [ doc = "Trigger-In 9 is selected." ]
            _1001,
            # [ doc = "Trigger-In 10 is selected." ]
            _1010,
            # [ doc = "Trigger-In 11 is selected." ]
            _1011,
            # [ doc = "Trigger-In 12 is selected." ]
            _1100,
            # [ doc = "Trigger-In 13 is selected." ]
            _1101,
            # [ doc = "Trigger-In 14 is selected." ]
            _1110,
            # [ doc = "Software trigger is selected." ]
            _1111,
        }
        impl TrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgselW::_0000 => 0,
                    TrgselW::_0001 => 1,
                    TrgselW::_0010 => 2,
                    TrgselW::_0011 => 3,
                    TrgselW::_0100 => 4,
                    TrgselW::_0101 => 5,
                    TrgselW::_0110 => 6,
                    TrgselW::_0111 => 7,
                    TrgselW::_1000 => 8,
                    TrgselW::_1001 => 9,
                    TrgselW::_1010 => 10,
                    TrgselW::_1011 => 11,
                    TrgselW::_1100 => 12,
                    TrgselW::_1101 => 13,
                    TrgselW::_1110 => 14,
                    TrgselW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger-In 0 is selected." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(TrgselW::_0000)
            }
            # [ doc = "Trigger-In 1 is selected." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(TrgselW::_0001)
            }
            # [ doc = "Trigger-In 2 is selected." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(TrgselW::_0010)
            }
            # [ doc = "Trigger-In 3 is selected." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(TrgselW::_0011)
            }
            # [ doc = "Trigger-In 4 is selected." ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(TrgselW::_0100)
            }
            # [ doc = "Trigger-In 5 is selected." ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(TrgselW::_0101)
            }
            # [ doc = "Trigger-In 6 is selected." ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(TrgselW::_0110)
            }
            # [ doc = "Trigger-In 7 is selected." ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(TrgselW::_0111)
            }
            # [ doc = "Trigger-In 8 is selected." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(TrgselW::_1000)
            }
            # [ doc = "Trigger-In 9 is selected." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(TrgselW::_1001)
            }
            # [ doc = "Trigger-In 10 is selected." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(TrgselW::_1010)
            }
            # [ doc = "Trigger-In 11 is selected." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(TrgselW::_1011)
            }
            # [ doc = "Trigger-In 12 is selected." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(TrgselW::_1100)
            }
            # [ doc = "Trigger-In 13 is selected." ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(TrgselW::_1101)
            }
            # [ doc = "Trigger-In 14 is selected." ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(TrgselW::_1110)
            }
            # [ doc = "Software trigger is selected." ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(TrgselW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALER`" ]
        pub enum PrescalerW {
            # [ doc = "Counting uses the peripheral clock divided by MULT (the multiplication factor)." ]
            _000,
            # [ doc = "Counting uses the peripheral clock divided by 2 x MULT (the multiplication factor)." ]
            _001,
            # [ doc = "Counting uses the peripheral clock divided by 4 x MULT (the multiplication factor)." ]
            _010,
            # [ doc = "Counting uses the peripheral clock divided by 8 x MULT (the multiplication factor)." ]
            _011,
            # [ doc = "Counting uses the peripheral clock divided by 16 x MULT (the multiplication factor)." ]
            _100,
            # [ doc = "Counting uses the peripheral clock divided by 32 x MULT (the multiplication factor)." ]
            _101,
            # [ doc = "Counting uses the peripheral clock divided by 64 x MULT (the multiplication factor)." ]
            _110,
            # [ doc = "Counting uses the peripheral clock divided by 128 x MULT (the multiplication factor)." ]
            _111,
        }
        impl PrescalerW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescalerW::_000 => 0,
                    PrescalerW::_001 => 1,
                    PrescalerW::_010 => 2,
                    PrescalerW::_011 => 3,
                    PrescalerW::_100 => 4,
                    PrescalerW::_101 => 5,
                    PrescalerW::_110 => 6,
                    PrescalerW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescalerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescalerW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescalerW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Counting uses the peripheral clock divided by MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PrescalerW::_000)
            }
            # [ doc = "Counting uses the peripheral clock divided by 2 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PrescalerW::_001)
            }
            # [ doc = "Counting uses the peripheral clock divided by 4 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PrescalerW::_010)
            }
            # [ doc = "Counting uses the peripheral clock divided by 8 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PrescalerW::_011)
            }
            # [ doc = "Counting uses the peripheral clock divided by 16 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PrescalerW::_100)
            }
            # [ doc = "Counting uses the peripheral clock divided by 32 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PrescalerW::_101)
            }
            # [ doc = "Counting uses the peripheral clock divided by 64 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PrescalerW::_110)
            }
            # [ doc = "Counting uses the peripheral clock divided by 128 x MULT (the multiplication factor)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PrescalerW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMAEN`" ]
        pub enum DmaenW {
            # [ doc = "DMA disabled." ]
            _0,
            # [ doc = "DMA enabled." ]
            _1,
        }
        impl DmaenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaenW::_0 => 0,
                    DmaenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaenW::_0)
            }
            # [ doc = "DMA enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwtrigW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwtrigW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDBEIE`" ]
        pub enum PdbeieW {
            # [ doc = "PDB sequence error interrupt disabled." ]
            _0,
            # [ doc = "PDB sequence error interrupt enabled." ]
            _1,
        }
        impl PdbeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbeieW::_0 => 0,
                    PdbeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB sequence error interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbeieW::_0)
            }
            # [ doc = "PDB sequence error interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LDMOD`" ]
        pub enum LdmodW {
            # [ doc = "The internal registers are loaded with the values from their buffers, immediately after 1 is written to LDOK." ]
            _00,
            # [ doc = "The internal registers are loaded with the values from their buffers when the PDB counter (CNT) = MOD + 1 CNT delay elapsed, after 1 is written to LDOK." ]
            _01,
            # [ doc = "The internal registers are loaded with the values from their buffers when a trigger input event is detected, after 1 is written to LDOK." ]
            _10,
            # [ doc = "The internal registers are loaded with the values from their buffers when either the PDB counter (CNT) = MOD + 1 CNT delay elapsed, or a trigger input event is detected, after 1 is written to LDOK." ]
            _11,
        }
        impl LdmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LdmodW::_00 => 0,
                    LdmodW::_01 => 1,
                    LdmodW::_10 => 2,
                    LdmodW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LdmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LdmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LdmodW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The internal registers are loaded with the values from their buffers, immediately after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(LdmodW::_00)
            }
            # [ doc = "The internal registers are loaded with the values from their buffers when the PDB counter (CNT) = MOD + 1 CNT delay elapsed, after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(LdmodW::_01)
            }
            # [ doc = "The internal registers are loaded with the values from their buffers when a trigger input event is detected, after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(LdmodW::_10)
            }
            # [ doc = "The internal registers are loaded with the values from their buffers when either the PDB counter (CNT) = MOD + 1 CNT delay elapsed, or a trigger input event is detected, after 1 is written to LDOK." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(LdmodW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Load OK" ]
            # [ inline ( always ) ]
            pub fn ldok(&self) -> LdokR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LdokR { bits }
            }
            # [ doc = "Bit 1 - Continuous Mode Enable" ]
            # [ inline ( always ) ]
            pub fn cont(&self) -> ContR {
                ContR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 2:3 - Multiplication Factor Select for Prescaler" ]
            # [ inline ( always ) ]
            pub fn mult(&self) -> MultR {
                MultR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - PDB Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbie(&self) -> PdbieR {
                PdbieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - PDB Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn pdbif(&self) -> PdbifR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PdbifR { bits }
            }
            # [ doc = "Bit 7 - PDB Enable" ]
            # [ inline ( always ) ]
            pub fn pdben(&self) -> PdbenR {
                PdbenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:11 - Trigger Input Source Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                TrgselR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 12:14 - Prescaler Divider Select" ]
            # [ inline ( always ) ]
            pub fn prescaler(&self) -> PrescalerR {
                PrescalerR::_from({
                                      const MASK: u8 = 7;
                                      const OFFSET: u8 = 12;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&self) -> DmaenR {
                DmaenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 17 - PDB Sequence Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbeie(&self) -> PdbeieR {
                PdbeieR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 17;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 18:19 - Load Mode Select" ]
            # [ inline ( always ) ]
            pub fn ldmod(&self) -> LdmodR {
                LdmodR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 18;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Load OK" ]
            # [ inline ( always ) ]
            pub fn ldok(&mut self) -> _LdokW {
                _LdokW { w: self }
            }
            # [ doc = "Bit 1 - Continuous Mode Enable" ]
            # [ inline ( always ) ]
            pub fn cont(&mut self) -> _ContW {
                _ContW { w: self }
            }
            # [ doc = "Bits 2:3 - Multiplication Factor Select for Prescaler" ]
            # [ inline ( always ) ]
            pub fn mult(&mut self) -> _MultW {
                _MultW { w: self }
            }
            # [ doc = "Bit 5 - PDB Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbie(&mut self) -> _PdbieW {
                _PdbieW { w: self }
            }
            # [ doc = "Bit 6 - PDB Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn pdbif(&mut self) -> _PdbifW {
                _PdbifW { w: self }
            }
            # [ doc = "Bit 7 - PDB Enable" ]
            # [ inline ( always ) ]
            pub fn pdben(&mut self) -> _PdbenW {
                _PdbenW { w: self }
            }
            # [ doc = "Bits 8:11 - Trigger Input Source Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
            # [ doc = "Bits 12:14 - Prescaler Divider Select" ]
            # [ inline ( always ) ]
            pub fn prescaler(&mut self) -> _PrescalerW {
                _PrescalerW { w: self }
            }
            # [ doc = "Bit 15 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&mut self) -> _DmaenW {
                _DmaenW { w: self }
            }
            # [ doc = "Bit 16 - Software Trigger" ]
            # [ inline ( always ) ]
            pub fn swtrig(&mut self) -> _SwtrigW {
                _SwtrigW { w: self }
            }
            # [ doc = "Bit 17 - PDB Sequence Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pdbeie(&mut self) -> _PdbeieW {
                _PdbeieW { w: self }
            }
            # [ doc = "Bits 18:19 - Load Mode Select" ]
            # [ inline ( always ) ]
            pub fn ldmod(&mut self) -> _LdmodW {
                _LdmodW { w: self }
            }
        }
    }
    # [ doc = "Modulus register" ]
    pub struct Mod {
        register: VolatileCell<u32>,
    }
    # [ doc = "Modulus register" ]
    pub mod mod_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mod {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ModR {
            bits: u16,
        }
        impl ModR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Modulus" ]
            # [ inline ( always ) ]
            pub fn mod_(&self) -> ModR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                ModR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Modulus" ]
            # [ inline ( always ) ]
            pub fn mod_(&mut self) -> _ModW {
                _ModW { w: self }
            }
        }
    }
    # [ doc = "Counter register" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Counter register" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CntR {
            bits: u16,
        }
        impl CntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Counter" ]
            # [ inline ( always ) ]
            pub fn cnt(&self) -> CntR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CntR { bits }
            }
        }
    }
    # [ doc = "Interrupt Delay register" ]
    pub struct Idly {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Delay register" ]
    pub mod idly {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Idly {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IdlyR {
            bits: u16,
        }
        impl IdlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Interrupt Delay" ]
            # [ inline ( always ) ]
            pub fn idly(&self) -> IdlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                IdlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Interrupt Delay" ]
            # [ inline ( always ) ]
            pub fn idly(&mut self) -> _IdlyW {
                _IdlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Control register 1" ]
    pub struct Chc1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Control register 1" ]
    pub mod chc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnR {
            # [ doc = "PDB channel's corresponding pre-trigger disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger enabled." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl EnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnR::_0 => 0,
                    EnR::_1 => 1,
                    EnR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnR {
                match bits {
                    0 => EnR::_0,
                    1 => EnR::_1,
                    i => EnR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnR::_1
            }
        }
        # [ doc = "Possible values of the field `TOS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TosR {
            # [ doc = "PDB channel's corresponding pre-trigger is in bypassed mode. The pre-trigger asserts one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SWTRIG is written with 1." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger asserts when the counter reaches the channel delay register and one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SETRIG is written with 1." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TosR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TosR::_0 => 0,
                    TosR::_1 => 1,
                    TosR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TosR {
                match bits {
                    0 => TosR::_0,
                    1 => TosR::_1,
                    i => TosR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TosR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TosR::_1
            }
        }
        # [ doc = "Possible values of the field `BB`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BbR {
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation enabled." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl BbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BbR::_0 => 0,
                    BbR::_1 => 1,
                    BbR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BbR {
                match bits {
                    0 => BbR::_0,
                    1 => BbR::_1,
                    i => BbR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BbR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BbR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EN`" ]
        pub enum EnW {
            # [ doc = "PDB channel's corresponding pre-trigger disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger enabled." ]
            _1,
        }
        impl EnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnW::_0 => 0,
                    EnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB channel's corresponding pre-trigger disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnW::_0)
            }
            # [ doc = "PDB channel's corresponding pre-trigger enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOS`" ]
        pub enum TosW {
            # [ doc = "PDB channel's corresponding pre-trigger is in bypassed mode. The pre-trigger asserts one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SWTRIG is written with 1." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger asserts when the counter reaches the channel delay register and one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SETRIG is written with 1." ]
            _1,
        }
        impl TosW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TosW::_0 => 0,
                    TosW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TosW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TosW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TosW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB channel's corresponding pre-trigger is in bypassed mode. The pre-trigger asserts one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SWTRIG is written with 1." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TosW::_0)
            }
            # [ doc = "PDB channel's corresponding pre-trigger asserts when the counter reaches the channel delay register and one peripheral clock cycle after a rising edge is detected on selected trigger input source or software trigger is selected and SETRIG is written with 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TosW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BB`" ]
        pub enum BbW {
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation disabled." ]
            _0,
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation enabled." ]
            _1,
        }
        impl BbW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BbW::_0 => 0,
                    BbW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BbW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BbW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BbW::_0)
            }
            # [ doc = "PDB channel's corresponding pre-trigger back-to-back operation enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BbW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - PDB Channel Pre-Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn en(&self) -> EnR {
                EnR::_from({
                               const MASK: u8 = 255;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:15 - PDB Channel Pre-Trigger Output Select" ]
            # [ inline ( always ) ]
            pub fn tos(&self) -> TosR {
                TosR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:23 - PDB Channel Pre-Trigger Back-to-Back Operation Enable" ]
            # [ inline ( always ) ]
            pub fn bb(&self) -> BbR {
                BbR::_from({
                               const MASK: u8 = 255;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - PDB Channel Pre-Trigger Enable" ]
            # [ inline ( always ) ]
            pub fn en(&mut self) -> _EnW {
                _EnW { w: self }
            }
            # [ doc = "Bits 8:15 - PDB Channel Pre-Trigger Output Select" ]
            # [ inline ( always ) ]
            pub fn tos(&mut self) -> _TosW {
                _TosW { w: self }
            }
            # [ doc = "Bits 16:23 - PDB Channel Pre-Trigger Back-to-Back Operation Enable" ]
            # [ inline ( always ) ]
            pub fn bb(&mut self) -> _BbW {
                _BbW { w: self }
            }
        }
    }
    # [ doc = "Channel n Status register" ]
    pub struct Chs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Status register" ]
    pub mod chs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErrR {
            # [ doc = "Sequence error not detected on PDB channel's corresponding pre-trigger." ]
            _0,
            # [ doc = "Sequence error detected on PDB channel's corresponding pre-trigger. ADCn block can be triggered for a conversion by one pre-trigger from PDB channel n. When one conversion, which is triggered by one of the pre-triggers from PDB channel n, is in progress, new trigger from PDB channel's corresponding pre-trigger m cannot be accepted by ADCn, and ERR[m] is set. Writing 0's to clear the sequence error flags." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ErrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErrR::_0 => 0,
                    ErrR::_1 => 1,
                    ErrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErrR {
                match bits {
                    0 => ErrR::_0,
                    1 => ErrR::_1,
                    i => ErrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErrR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CfR {
            bits: u8,
        }
        impl CfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `ERR`" ]
        pub enum ErrW {
            # [ doc = "Sequence error not detected on PDB channel's corresponding pre-trigger." ]
            _0,
            # [ doc = "Sequence error detected on PDB channel's corresponding pre-trigger. ADCn block can be triggered for a conversion by one pre-trigger from PDB channel n. When one conversion, which is triggered by one of the pre-triggers from PDB channel n, is in progress, new trigger from PDB channel's corresponding pre-trigger m cannot be accepted by ADCn, and ERR[m] is set. Writing 0's to clear the sequence error flags." ]
            _1,
        }
        impl ErrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErrW::_0 => 0,
                    ErrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Sequence error not detected on PDB channel's corresponding pre-trigger." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErrW::_0)
            }
            # [ doc = "Sequence error detected on PDB channel's corresponding pre-trigger. ADCn block can be triggered for a conversion by one pre-trigger from PDB channel n. When one conversion, which is triggered by one of the pre-triggers from PDB channel n, is in progress, new trigger from PDB channel's corresponding pre-trigger m cannot be accepted by ADCn, and ERR[m] is set. Writing 0's to clear the sequence error flags." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CfW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - PDB Channel Sequence Error Flags" ]
            # [ inline ( always ) ]
            pub fn err(&self) -> ErrR {
                ErrR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 16:23 - PDB Channel Flags" ]
            # [ inline ( always ) ]
            pub fn cf(&self) -> CfR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CfR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - PDB Channel Sequence Error Flags" ]
            # [ inline ( always ) ]
            pub fn err(&mut self) -> _ErrW {
                _ErrW { w: self }
            }
            # [ doc = "Bits 16:23 - PDB Channel Flags" ]
            # [ inline ( always ) ]
            pub fn cf(&mut self) -> _CfW {
                _CfW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 0 register" ]
    pub struct Chdly0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 0 register" ]
    pub mod chdly0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 1 register" ]
    pub struct Chdly1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 1 register" ]
    pub mod chdly1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 2 register" ]
    pub struct Chdly2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 2 register" ]
    pub mod chdly2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 3 register" ]
    pub struct Chdly3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 3 register" ]
    pub mod chdly3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 4 register" ]
    pub struct Chdly4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 4 register" ]
    pub mod chdly4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 5 register" ]
    pub struct Chdly5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 5 register" ]
    pub mod chdly5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 6 register" ]
    pub struct Chdly6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 6 register" ]
    pub mod chdly6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Channel n Delay 7 register" ]
    pub struct Chdly7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Channel n Delay 7 register" ]
    pub mod chdly7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chdly7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DlyR {
            bits: u16,
        }
        impl DlyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DlyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DlyW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&self) -> DlyR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                DlyR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Channel Delay" ]
            # [ inline ( always ) ]
            pub fn dly(&mut self) -> _DlyW {
                _DlyW { w: self }
            }
        }
    }
    # [ doc = "Pulse-Out n Enable register" ]
    pub struct Poen {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pulse-Out n Enable register" ]
    pub mod poen {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Poen {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `POEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PoenR {
            # [ doc = "PDB Pulse-Out disabled" ]
            _0,
            # [ doc = "PDB Pulse-Out enabled" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PoenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PoenR::_0 => 0,
                    PoenR::_1 => 1,
                    PoenR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PoenR {
                match bits {
                    0 => PoenR::_0,
                    1 => PoenR::_1,
                    i => PoenR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PoenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PoenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `POEN`" ]
        pub enum PoenW {
            # [ doc = "PDB Pulse-Out disabled" ]
            _0,
            # [ doc = "PDB Pulse-Out enabled" ]
            _1,
        }
        impl PoenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PoenW::_0 => 0,
                    PoenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PoenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PoenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PoenW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB Pulse-Out disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PoenW::_0)
            }
            # [ doc = "PDB Pulse-Out enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PoenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - PDB Pulse-Out Enable" ]
            # [ inline ( always ) ]
            pub fn poen(&self) -> PoenR {
                PoenR::_from({
                                 const MASK: u8 = 255;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - PDB Pulse-Out Enable" ]
            # [ inline ( always ) ]
            pub fn poen(&mut self) -> _PoenW {
                _PoenW { w: self }
            }
        }
    }
    # [ doc = "Pulse-Out n Delay register" ]
    pub struct Podly {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pulse-Out n Delay register" ]
    pub mod podly {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Podly {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly2R {
            bits: u16,
        }
        impl Dly2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly1R {
            bits: u16,
        }
        impl Dly1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - PDB Pulse-Out Delay 2" ]
            # [ inline ( always ) ]
            pub fn dly2(&self) -> Dly2R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Dly2R { bits }
            }
            # [ doc = "Bits 16:31 - PDB Pulse-Out Delay 1" ]
            # [ inline ( always ) ]
            pub fn dly1(&self) -> Dly1R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Dly1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - PDB Pulse-Out Delay 2" ]
            # [ inline ( always ) ]
            pub fn dly2(&mut self) -> _Dly2W {
                _Dly2W { w: self }
            }
            # [ doc = "Bits 16:31 - PDB Pulse-Out Delay 1" ]
            # [ inline ( always ) ]
            pub fn dly1(&mut self) -> _Dly1W {
                _Dly1W { w: self }
            }
        }
    }
    # [ doc = "PDB1_DLY2 register." ]
    pub struct Dly2 {
        register: VolatileCell<u16>,
    }
    # [ doc = "PDB1_DLY2 register." ]
    pub mod dly2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Dly2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly2R {
            bits: u16,
        }
        impl Dly2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - DLY2" ]
            # [ inline ( always ) ]
            pub fn dly2(&self) -> Dly2R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                Dly2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - DLY2" ]
            # [ inline ( always ) ]
            pub fn dly2(&mut self) -> _Dly2W {
                _Dly2W { w: self }
            }
        }
    }
    # [ doc = "PDB1_DLY1 register." ]
    pub struct Dly1 {
        register: VolatileCell<u16>,
    }
    # [ doc = "PDB1_DLY1 register." ]
    pub mod dly1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Dly1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Dly1R {
            bits: u16,
        }
        impl Dly1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Dly1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Dly1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - DLY1" ]
            # [ inline ( always ) ]
            pub fn dly1(&self) -> Dly1R {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                Dly1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - DLY1" ]
            # [ inline ( always ) ]
            pub fn dly1(&mut self) -> _Dly1W {
                _Dly1W { w: self }
            }
        }
    }
}
# [ doc = "Programmable Delay Block" ]
pub struct Pdb1 {
    register_block: pdb1::RegisterBlock,
}
impl Deref for Pdb1 {
    type Target = pdb1::RegisterBlock;
    fn deref(&self) -> &pdb1::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Cyclic Redundancy Check" ]
pub const CRC: Peripheral<Crc> = unsafe { Peripheral::new(1073946624) };
# [ doc = "Cyclic Redundancy Check" ]
pub mod crc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - CRC Data register" ]
        pub data: Data,
        # [ doc = "0x04 - CRC Polynomial register" ]
        pub gpoly: Gpoly,
        # [ doc = "0x08 - CRC Control register" ]
        pub ctrl: Ctrl,
    }
    # [ doc = "CRC Data register" ]
    pub struct Data {
        register: VolatileCell<u32>,
    }
    # [ doc = "CRC Data register" ]
    pub mod data {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Data {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LlR {
            bits: u8,
        }
        impl LlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LuR {
            bits: u8,
        }
        impl LuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HlR {
            bits: u8,
        }
        impl HlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HuR {
            bits: u8,
        }
        impl HuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRC Low Lower Byte" ]
            # [ inline ( always ) ]
            pub fn ll(&self) -> LlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LlR { bits }
            }
            # [ doc = "Bits 8:15 - CRC Low Upper Byte" ]
            # [ inline ( always ) ]
            pub fn lu(&self) -> LuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LuR { bits }
            }
            # [ doc = "Bits 16:23 - CRC High Lower Byte" ]
            # [ inline ( always ) ]
            pub fn hl(&self) -> HlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HlR { bits }
            }
            # [ doc = "Bits 24:31 - CRC High Upper Byte" ]
            # [ inline ( always ) ]
            pub fn hu(&self) -> HuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                HuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4294967295 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRC Low Lower Byte" ]
            # [ inline ( always ) ]
            pub fn ll(&mut self) -> _LlW {
                _LlW { w: self }
            }
            # [ doc = "Bits 8:15 - CRC Low Upper Byte" ]
            # [ inline ( always ) ]
            pub fn lu(&mut self) -> _LuW {
                _LuW { w: self }
            }
            # [ doc = "Bits 16:23 - CRC High Lower Byte" ]
            # [ inline ( always ) ]
            pub fn hl(&mut self) -> _HlW {
                _HlW { w: self }
            }
            # [ doc = "Bits 24:31 - CRC High Upper Byte" ]
            # [ inline ( always ) ]
            pub fn hu(&mut self) -> _HuW {
                _HuW { w: self }
            }
        }
    }
    # [ doc = "CRC_DATAL register." ]
    pub struct Datal {
        register: VolatileCell<u16>,
    }
    # [ doc = "CRC_DATAL register." ]
    pub mod datal {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Datal {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatalR {
            bits: u16,
        }
        impl DatalR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatalW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatalW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - DATAL stores the lower 16 bits of the 16/32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datal(&self) -> DatalR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DatalR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - DATAL stores the lower 16 bits of the 16/32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datal(&mut self) -> _DatalW {
                _DatalW { w: self }
            }
        }
    }
    # [ doc = "CRC_DATALL register." ]
    pub struct Datall {
        register: VolatileCell<u8>,
    }
    # [ doc = "CRC_DATALL register." ]
    pub mod datall {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Datall {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatallR {
            bits: u8,
        }
        impl DatallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatallW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit DATA" ]
            # [ inline ( always ) ]
            pub fn datall(&self) -> DatallR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                DatallR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 255 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - CRCLL stores the first 8 bits of the 32 bit DATA" ]
            # [ inline ( always ) ]
            pub fn datall(&mut self) -> _DatallW {
                _DatallW { w: self }
            }
        }
    }
    # [ doc = "CRC_DATALU register." ]
    pub struct Datalu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CRC_DATALU register." ]
    pub mod datalu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Datalu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataluR {
            bits: u8,
        }
        impl DataluR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataluW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataluW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - DATALL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datalu(&self) -> DataluR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                DataluR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 255 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - DATALL stores the second 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datalu(&mut self) -> _DataluW {
                _DataluW { w: self }
            }
        }
    }
    # [ doc = "CRC_DATAH register." ]
    pub struct Datah {
        register: VolatileCell<u16>,
    }
    # [ doc = "CRC_DATAH register." ]
    pub mod datah {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u16,
        }
        impl super::Datah {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatahR {
            bits: u16,
        }
        impl DatahR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatahW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatahW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u16) << OFFSET);
                self.w.bits |= ((bits & MASK) as u16) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:15 - DATAH stores the high 16 bits of the 16/32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datah(&self) -> DatahR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u16) as u16
                };
                DatahR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 65535 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - DATAH stores the high 16 bits of the 16/32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datah(&mut self) -> _DatahW {
                _DatahW { w: self }
            }
        }
    }
    # [ doc = "CRC_DATAHL register." ]
    pub struct Datahl {
        register: VolatileCell<u8>,
    }
    # [ doc = "CRC_DATAHL register." ]
    pub mod datahl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Datahl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatahlR {
            bits: u8,
        }
        impl DatahlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatahlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatahlW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - DATAHL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datahl(&self) -> DatahlR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                DatahlR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 255 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - DATAHL stores the third 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datahl(&mut self) -> _DatahlW {
                _DatahlW { w: self }
            }
        }
    }
    # [ doc = "CRC_DATAHU register." ]
    pub struct Datahu {
        register: VolatileCell<u8>,
    }
    # [ doc = "CRC_DATAHU register." ]
    pub mod datahu {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Datahu {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatahuR {
            bits: u8,
        }
        impl DatahuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatahuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatahuW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:7 - DATAHU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datahu(&self) -> DatahuR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                DatahuR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 255 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - DATAHU stores the fourth 8 bits of the 32 bit CRC" ]
            # [ inline ( always ) ]
            pub fn datahu(&mut self) -> _DatahuW {
                _DatahuW { w: self }
            }
        }
    }
    # [ doc = "CRC Polynomial register" ]
    pub struct Gpoly {
        register: VolatileCell<u32>,
    }
    # [ doc = "CRC Polynomial register" ]
    pub mod gpoly {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpoly {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LowR {
            bits: u16,
        }
        impl LowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct HighR {
            bits: u16,
        }
        impl HighR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LowW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HighW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HighW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Low Polynominal Half-word" ]
            # [ inline ( always ) ]
            pub fn low(&self) -> LowR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                LowR { bits }
            }
            # [ doc = "Bits 16:31 - High Polynominal Half-word" ]
            # [ inline ( always ) ]
            pub fn high(&self) -> HighR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                HighR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4129 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Low Polynominal Half-word" ]
            # [ inline ( always ) ]
            pub fn low(&mut self) -> _LowW {
                _LowW { w: self }
            }
            # [ doc = "Bits 16:31 - High Polynominal Half-word" ]
            # [ inline ( always ) ]
            pub fn high(&mut self) -> _HighW {
                _HighW { w: self }
            }
        }
    }
    # [ doc = "CRC Control register" ]
    pub struct Ctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "CRC Control register" ]
    pub mod ctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TCRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcrcR {
            # [ doc = "16-bit CRC protocol." ]
            _0,
            # [ doc = "32-bit CRC protocol." ]
            _1,
        }
        impl TcrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcrcR::_0 => 0,
                    TcrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcrcR {
                match bits {
                    0 => TcrcR::_0,
                    1 => TcrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcrcR::_1
            }
        }
        # [ doc = "Possible values of the field `WAS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WasR {
            # [ doc = "Writes to the CRC data register are data values." ]
            _0,
            # [ doc = "Writes to the CRC data register are seed values." ]
            _1,
        }
        impl WasR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WasR::_0 => 0,
                    WasR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WasR {
                match bits {
                    0 => WasR::_0,
                    1 => WasR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WasR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WasR::_1
            }
        }
        # [ doc = "Possible values of the field `FXOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FxorR {
            # [ doc = "No XOR on reading." ]
            _0,
            # [ doc = "Invert or complement the read value of the CRC Data register." ]
            _1,
        }
        impl FxorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FxorR::_0 => 0,
                    FxorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FxorR {
                match bits {
                    0 => FxorR::_0,
                    1 => FxorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FxorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FxorR::_1
            }
        }
        # [ doc = "Possible values of the field `TOTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TotrR {
            # [ doc = "No transposition." ]
            _00,
            # [ doc = "Bits in bytes are transposed; bytes are not transposed." ]
            _01,
            # [ doc = "Both bits in bytes and bytes are transposed." ]
            _10,
            # [ doc = "Only bytes are transposed; no bits in a byte are transposed." ]
            _11,
        }
        impl TotrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TotrR::_00 => 0,
                    TotrR::_01 => 1,
                    TotrR::_10 => 2,
                    TotrR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TotrR {
                match bits {
                    0 => TotrR::_00,
                    1 => TotrR::_01,
                    2 => TotrR::_10,
                    3 => TotrR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TotrR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TotrR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TotrR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TotrR::_11
            }
        }
        # [ doc = "Possible values of the field `TOT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TotR {
            # [ doc = "No transposition." ]
            _00,
            # [ doc = "Bits in bytes are transposed; bytes are not transposed." ]
            _01,
            # [ doc = "Both bits in bytes and bytes are transposed." ]
            _10,
            # [ doc = "Only bytes are transposed; no bits in a byte are transposed." ]
            _11,
        }
        impl TotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TotR::_00 => 0,
                    TotR::_01 => 1,
                    TotR::_10 => 2,
                    TotR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TotR {
                match bits {
                    0 => TotR::_00,
                    1 => TotR::_01,
                    2 => TotR::_10,
                    3 => TotR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TotR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TotR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TotR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TotR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TCRC`" ]
        pub enum TcrcW {
            # [ doc = "16-bit CRC protocol." ]
            _0,
            # [ doc = "32-bit CRC protocol." ]
            _1,
        }
        impl TcrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcrcW::_0 => 0,
                    TcrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "16-bit CRC protocol." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcrcW::_0)
            }
            # [ doc = "32-bit CRC protocol." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WAS`" ]
        pub enum WasW {
            # [ doc = "Writes to the CRC data register are data values." ]
            _0,
            # [ doc = "Writes to the CRC data register are seed values." ]
            _1,
        }
        impl WasW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WasW::_0 => 0,
                    WasW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WasW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WasW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WasW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the CRC data register are data values." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WasW::_0)
            }
            # [ doc = "Writes to the CRC data register are seed values." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WasW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FXOR`" ]
        pub enum FxorW {
            # [ doc = "No XOR on reading." ]
            _0,
            # [ doc = "Invert or complement the read value of the CRC Data register." ]
            _1,
        }
        impl FxorW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FxorW::_0 => 0,
                    FxorW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FxorW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FxorW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FxorW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No XOR on reading." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FxorW::_0)
            }
            # [ doc = "Invert or complement the read value of the CRC Data register." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FxorW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOTR`" ]
        pub enum TotrW {
            # [ doc = "No transposition." ]
            _00,
            # [ doc = "Bits in bytes are transposed; bytes are not transposed." ]
            _01,
            # [ doc = "Both bits in bytes and bytes are transposed." ]
            _10,
            # [ doc = "Only bytes are transposed; no bits in a byte are transposed." ]
            _11,
        }
        impl TotrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TotrW::_00 => 0,
                    TotrW::_01 => 1,
                    TotrW::_10 => 2,
                    TotrW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TotrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TotrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TotrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No transposition." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TotrW::_00)
            }
            # [ doc = "Bits in bytes are transposed; bytes are not transposed." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TotrW::_01)
            }
            # [ doc = "Both bits in bytes and bytes are transposed." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TotrW::_10)
            }
            # [ doc = "Only bytes are transposed; no bits in a byte are transposed." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TotrW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOT`" ]
        pub enum TotW {
            # [ doc = "No transposition." ]
            _00,
            # [ doc = "Bits in bytes are transposed; bytes are not transposed." ]
            _01,
            # [ doc = "Both bits in bytes and bytes are transposed." ]
            _10,
            # [ doc = "Only bytes are transposed; no bits in a byte are transposed." ]
            _11,
        }
        impl TotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TotW::_00 => 0,
                    TotW::_01 => 1,
                    TotW::_10 => 2,
                    TotW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No transposition." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TotW::_00)
            }
            # [ doc = "Bits in bytes are transposed; bytes are not transposed." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TotW::_01)
            }
            # [ doc = "Both bits in bytes and bytes are transposed." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TotW::_10)
            }
            # [ doc = "Only bytes are transposed; no bits in a byte are transposed." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TotW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 24 - TCRC" ]
            # [ inline ( always ) ]
            pub fn tcrc(&self) -> TcrcR {
                TcrcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 25 - Write CRC Data Register As Seed" ]
            # [ inline ( always ) ]
            pub fn was(&self) -> WasR {
                WasR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Complement Read Of CRC Data Register" ]
            # [ inline ( always ) ]
            pub fn fxor(&self) -> FxorR {
                FxorR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 26;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 28:29 - Type Of Transpose For Read" ]
            # [ inline ( always ) ]
            pub fn totr(&self) -> TotrR {
                TotrR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 28;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 30:31 - Type Of Transpose For Writes" ]
            # [ inline ( always ) ]
            pub fn tot(&self) -> TotR {
                TotR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 24 - TCRC" ]
            # [ inline ( always ) ]
            pub fn tcrc(&mut self) -> _TcrcW {
                _TcrcW { w: self }
            }
            # [ doc = "Bit 25 - Write CRC Data Register As Seed" ]
            # [ inline ( always ) ]
            pub fn was(&mut self) -> _WasW {
                _WasW { w: self }
            }
            # [ doc = "Bit 26 - Complement Read Of CRC Data Register" ]
            # [ inline ( always ) ]
            pub fn fxor(&mut self) -> _FxorW {
                _FxorW { w: self }
            }
            # [ doc = "Bits 28:29 - Type Of Transpose For Read" ]
            # [ inline ( always ) ]
            pub fn totr(&mut self) -> _TotrW {
                _TotrW { w: self }
            }
            # [ doc = "Bits 30:31 - Type Of Transpose For Writes" ]
            # [ inline ( always ) ]
            pub fn tot(&mut self) -> _TotW {
                _TotW { w: self }
            }
        }
    }
}
# [ doc = "Cyclic Redundancy Check" ]
pub struct Crc {
    register_block: crc::RegisterBlock,
}
impl Deref for Crc {
    type Target = crc::RegisterBlock;
    fn deref(&self) -> &crc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Low Power Periodic Interrupt Timer (LPIT)" ]
pub const LPIT0: Peripheral<Lpit0> = unsafe { Peripheral::new(1073967104) };
# [ doc = "Low Power Periodic Interrupt Timer (LPIT)" ]
pub mod lpit0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - Module Control Register" ]
        pub mcr: Mcr,
        # [ doc = "0x0c - Module Status Register" ]
        pub msr: Msr,
        # [ doc = "0x10 - Module Interrupt Enable Register" ]
        pub mier: Mier,
        # [ doc = "0x14 - Set Timer Enable Register" ]
        pub setten: Setten,
        # [ doc = "0x18 - Clear Timer Enable Register" ]
        pub clrten: Clrten,
        _reserved0: [u8; 4usize],
        # [ doc = "0x20 - Timer Value Register" ]
        pub tval0: Tval0,
        # [ doc = "0x24 - Current Timer Value" ]
        pub cval0: Cval0,
        # [ doc = "0x28 - Timer Control Register" ]
        pub tctrl0: Tctrl0,
        _reserved1: [u8; 4usize],
        # [ doc = "0x30 - Timer Value Register" ]
        pub tval1: Tval1,
        # [ doc = "0x34 - Current Timer Value" ]
        pub cval1: Cval1,
        # [ doc = "0x38 - Timer Control Register" ]
        pub tctrl1: Tctrl1,
        _reserved2: [u8; 4usize],
        # [ doc = "0x40 - Timer Value Register" ]
        pub tval2: Tval2,
        # [ doc = "0x44 - Current Timer Value" ]
        pub cval2: Cval2,
        # [ doc = "0x48 - Timer Control Register" ]
        pub tctrl2: Tctrl2,
        _reserved3: [u8; 4usize],
        # [ doc = "0x50 - Timer Value Register" ]
        pub tval3: Tval3,
        # [ doc = "0x54 - Current Timer Value" ]
        pub cval3: Cval3,
        # [ doc = "0x58 - Timer Control Register" ]
        pub tctrl3: Tctrl3,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FeatureR {
            bits: u16,
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                FeatureR { bits }
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ChannelR {
            bits: u8,
        }
        impl ChannelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ExtTrigR {
            bits: u8,
        }
        impl ExtTrigR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Number of Timer Channels" ]
            # [ inline ( always ) ]
            pub fn channel(&self) -> ChannelR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ChannelR { bits }
            }
            # [ doc = "Bits 8:15 - Number of External Trigger Inputs" ]
            # [ inline ( always ) ]
            pub fn ext_trig(&self) -> ExtTrigR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ExtTrigR { bits }
            }
        }
    }
    # [ doc = "Module Control Register" ]
    pub struct Mcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Module Control Register" ]
    pub mod mcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `M_CEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MCenR {
            # [ doc = "Peripheral clock to timers is disabled" ]
            _0,
            # [ doc = "Peripheral clock to timers is enabled" ]
            _1,
        }
        impl MCenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MCenR::_0 => 0,
                    MCenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MCenR {
                match bits {
                    0 => MCenR::_0,
                    1 => MCenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MCenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MCenR::_1
            }
        }
        # [ doc = "Possible values of the field `SW_RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwRstR {
            # [ doc = "Timer channels and registers are not reset" ]
            _0,
            # [ doc = "Timer channels and registers are reset" ]
            _1,
        }
        impl SwRstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwRstR::_0 => 0,
                    SwRstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwRstR {
                match bits {
                    0 => SwRstR::_0,
                    1 => SwRstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwRstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwRstR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZE_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozeEnR {
            # [ doc = "Timer channels are stopped in DOZE mode" ]
            _0,
            # [ doc = "Timer channels continue to run in DOZE mode" ]
            _1,
        }
        impl DozeEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozeEnR::_0 => 0,
                    DozeEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozeEnR {
                match bits {
                    0 => DozeEnR::_0,
                    1 => DozeEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozeEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozeEnR::_1
            }
        }
        # [ doc = "Possible values of the field `DBG_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgEnR {
            # [ doc = "Timer channels are stopped in Debug mode" ]
            _0,
            # [ doc = "Timer channels continue to run in Debug mode" ]
            _1,
        }
        impl DbgEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgEnR::_0 => 0,
                    DbgEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgEnR {
                match bits {
                    0 => DbgEnR::_0,
                    1 => DbgEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgEnR::_1
            }
        }
        # [ doc = "Values that can be written to the field `M_CEN`" ]
        pub enum MCenW {
            # [ doc = "Peripheral clock to timers is disabled" ]
            _0,
            # [ doc = "Peripheral clock to timers is enabled" ]
            _1,
        }
        impl MCenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MCenW::_0 => 0,
                    MCenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MCenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MCenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MCenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Peripheral clock to timers is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MCenW::_0)
            }
            # [ doc = "Peripheral clock to timers is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MCenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SW_RST`" ]
        pub enum SwRstW {
            # [ doc = "Timer channels and registers are not reset" ]
            _0,
            # [ doc = "Timer channels and registers are reset" ]
            _1,
        }
        impl SwRstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwRstW::_0 => 0,
                    SwRstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwRstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwRstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwRstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer channels and registers are not reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwRstW::_0)
            }
            # [ doc = "Timer channels and registers are reset" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwRstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZE_EN`" ]
        pub enum DozeEnW {
            # [ doc = "Timer channels are stopped in DOZE mode" ]
            _0,
            # [ doc = "Timer channels continue to run in DOZE mode" ]
            _1,
        }
        impl DozeEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozeEnW::_0 => 0,
                    DozeEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozeEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozeEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozeEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer channels are stopped in DOZE mode" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozeEnW::_0)
            }
            # [ doc = "Timer channels continue to run in DOZE mode" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozeEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBG_EN`" ]
        pub enum DbgEnW {
            # [ doc = "Timer channels are stopped in Debug mode" ]
            _0,
            # [ doc = "Timer channels continue to run in Debug mode" ]
            _1,
        }
        impl DbgEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgEnW::_0 => 0,
                    DbgEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer channels are stopped in Debug mode" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgEnW::_0)
            }
            # [ doc = "Timer channels continue to run in Debug mode" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Module Clock Enable" ]
            # [ inline ( always ) ]
            pub fn m_cen(&self) -> MCenR {
                MCenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Software Reset Bit" ]
            # [ inline ( always ) ]
            pub fn sw_rst(&self) -> SwRstR {
                SwRstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - DOZE Mode Enable Bit" ]
            # [ inline ( always ) ]
            pub fn doze_en(&self) -> DozeEnR {
                DozeEnR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Debug Enable Bit" ]
            # [ inline ( always ) ]
            pub fn dbg_en(&self) -> DbgEnR {
                DbgEnR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Module Clock Enable" ]
            # [ inline ( always ) ]
            pub fn m_cen(&mut self) -> _MCenW {
                _MCenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset Bit" ]
            # [ inline ( always ) ]
            pub fn sw_rst(&mut self) -> _SwRstW {
                _SwRstW { w: self }
            }
            # [ doc = "Bit 2 - DOZE Mode Enable Bit" ]
            # [ inline ( always ) ]
            pub fn doze_en(&mut self) -> _DozeEnW {
                _DozeEnW { w: self }
            }
            # [ doc = "Bit 3 - Debug Enable Bit" ]
            # [ inline ( always ) ]
            pub fn dbg_en(&mut self) -> _DbgEnW {
                _DbgEnW { w: self }
            }
        }
    }
    # [ doc = "Module Status Register" ]
    pub struct Msr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Module Status Register" ]
    pub mod msr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Msr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIF0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tif0R {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tif0R::_0 => 0,
                    Tif0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tif0R {
                match bits {
                    0 => Tif0R::_0,
                    1 => Tif0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tif0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tif0R::_1
            }
        }
        # [ doc = "Possible values of the field `TIF1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tif1R {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tif1R::_0 => 0,
                    Tif1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tif1R {
                match bits {
                    0 => Tif1R::_0,
                    1 => Tif1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tif1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tif1R::_1
            }
        }
        # [ doc = "Possible values of the field `TIF2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tif2R {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tif2R::_0 => 0,
                    Tif2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tif2R {
                match bits {
                    0 => Tif2R::_0,
                    1 => Tif2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tif2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tif2R::_1
            }
        }
        # [ doc = "Possible values of the field `TIF3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tif3R {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tif3R::_0 => 0,
                    Tif3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tif3R {
                match bits {
                    0 => Tif3R::_0,
                    1 => Tif3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tif3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tif3R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TIF0`" ]
        pub enum Tif0W {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tif0W::_0 => 0,
                    Tif0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tif0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tif0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tif0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer has not timed out" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tif0W::_0)
            }
            # [ doc = "Timeout has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tif0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIF1`" ]
        pub enum Tif1W {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tif1W::_0 => 0,
                    Tif1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tif1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tif1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tif1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer has not timed out" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tif1W::_0)
            }
            # [ doc = "Timeout has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tif1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIF2`" ]
        pub enum Tif2W {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tif2W::_0 => 0,
                    Tif2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tif2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tif2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tif2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer has not timed out" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tif2W::_0)
            }
            # [ doc = "Timeout has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tif2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIF3`" ]
        pub enum Tif3W {
            # [ doc = "Timer has not timed out" ]
            _0,
            # [ doc = "Timeout has occurred" ]
            _1,
        }
        impl Tif3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tif3W::_0 => 0,
                    Tif3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tif3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tif3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tif3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer has not timed out" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tif3W::_0)
            }
            # [ doc = "Timeout has occurred" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tif3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif0(&self) -> Tif0R {
                Tif0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif1(&self) -> Tif1R {
                Tif1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif2(&self) -> Tif2R {
                Tif2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif3(&self) -> Tif3R {
                Tif3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif0(&mut self) -> _Tif0W {
                _Tif0W { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif1(&mut self) -> _Tif1W {
                _Tif1W { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif2(&mut self) -> _Tif2W {
                _Tif2W { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Timer Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn tif3(&mut self) -> _Tif3W {
                _Tif3W { w: self }
            }
        }
    }
    # [ doc = "Module Interrupt Enable Register" ]
    pub struct Mier {
        register: VolatileCell<u32>,
    }
    # [ doc = "Module Interrupt Enable Register" ]
    pub mod mier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIE0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tie0R {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tie0R::_0 => 0,
                    Tie0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tie0R {
                match bits {
                    0 => Tie0R::_0,
                    1 => Tie0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tie0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tie0R::_1
            }
        }
        # [ doc = "Possible values of the field `TIE1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tie1R {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tie1R::_0 => 0,
                    Tie1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tie1R {
                match bits {
                    0 => Tie1R::_0,
                    1 => Tie1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tie1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tie1R::_1
            }
        }
        # [ doc = "Possible values of the field `TIE2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tie2R {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tie2R::_0 => 0,
                    Tie2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tie2R {
                match bits {
                    0 => Tie2R::_0,
                    1 => Tie2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tie2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tie2R::_1
            }
        }
        # [ doc = "Possible values of the field `TIE3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Tie3R {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Tie3R::_0 => 0,
                    Tie3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Tie3R {
                match bits {
                    0 => Tie3R::_0,
                    1 => Tie3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Tie3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Tie3R::_1
            }
        }
        # [ doc = "Values that can be written to the field `TIE0`" ]
        pub enum Tie0W {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tie0W::_0 => 0,
                    Tie0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tie0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tie0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tie0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt generation is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tie0W::_0)
            }
            # [ doc = "Interrupt generation is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tie0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE1`" ]
        pub enum Tie1W {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tie1W::_0 => 0,
                    Tie1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tie1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tie1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tie1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt generation is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tie1W::_0)
            }
            # [ doc = "Interrupt generation is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tie1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE2`" ]
        pub enum Tie2W {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tie2W::_0 => 0,
                    Tie2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tie2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tie2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tie2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt generation is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tie2W::_0)
            }
            # [ doc = "Interrupt generation is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tie2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE3`" ]
        pub enum Tie3W {
            # [ doc = "Interrupt generation is disabled" ]
            _0,
            # [ doc = "Interrupt generation is enabled" ]
            _1,
        }
        impl Tie3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Tie3W::_0 => 0,
                    Tie3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Tie3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Tie3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Tie3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt generation is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Tie3W::_0)
            }
            # [ doc = "Interrupt generation is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Tie3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Channel 0 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie0(&self) -> Tie0R {
                Tie0R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Channel 1 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie1(&self) -> Tie1R {
                Tie1R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Channel 2 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie2(&self) -> Tie2R {
                Tie2R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Channel 3 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie3(&self) -> Tie3R {
                Tie3R::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Channel 0 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie0(&mut self) -> _Tie0W {
                _Tie0W { w: self }
            }
            # [ doc = "Bit 1 - Channel 1 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie1(&mut self) -> _Tie1W {
                _Tie1W { w: self }
            }
            # [ doc = "Bit 2 - Channel 2 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie2(&mut self) -> _Tie2W {
                _Tie2W { w: self }
            }
            # [ doc = "Bit 3 - Channel 3 Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie3(&mut self) -> _Tie3W {
                _Tie3W { w: self }
            }
        }
    }
    # [ doc = "Set Timer Enable Register" ]
    pub struct Setten {
        register: VolatileCell<u32>,
    }
    # [ doc = "Set Timer Enable Register" ]
    pub mod setten {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Setten {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SET_T_EN_0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SetTEn0R {
            # [ doc = "No effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 0" ]
            _1,
        }
        impl SetTEn0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SetTEn0R::_0 => 0,
                    SetTEn0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SetTEn0R {
                match bits {
                    0 => SetTEn0R::_0,
                    1 => SetTEn0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SetTEn0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SetTEn0R::_1
            }
        }
        # [ doc = "Possible values of the field `SET_T_EN_1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SetTEn1R {
            # [ doc = "No Effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 1" ]
            _1,
        }
        impl SetTEn1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SetTEn1R::_0 => 0,
                    SetTEn1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SetTEn1R {
                match bits {
                    0 => SetTEn1R::_0,
                    1 => SetTEn1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SetTEn1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SetTEn1R::_1
            }
        }
        # [ doc = "Possible values of the field `SET_T_EN_2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SetTEn2R {
            # [ doc = "No Effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 2" ]
            _1,
        }
        impl SetTEn2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SetTEn2R::_0 => 0,
                    SetTEn2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SetTEn2R {
                match bits {
                    0 => SetTEn2R::_0,
                    1 => SetTEn2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SetTEn2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SetTEn2R::_1
            }
        }
        # [ doc = "Possible values of the field `SET_T_EN_3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SetTEn3R {
            # [ doc = "No effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 3" ]
            _1,
        }
        impl SetTEn3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SetTEn3R::_0 => 0,
                    SetTEn3R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SetTEn3R {
                match bits {
                    0 => SetTEn3R::_0,
                    1 => SetTEn3R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SetTEn3R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SetTEn3R::_1
            }
        }
        # [ doc = "Values that can be written to the field `SET_T_EN_0`" ]
        pub enum SetTEn0W {
            # [ doc = "No effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 0" ]
            _1,
        }
        impl SetTEn0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SetTEn0W::_0 => 0,
                    SetTEn0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SetTEn0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SetTEn0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SetTEn0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SetTEn0W::_0)
            }
            # [ doc = "Enables the Timer Channel 0" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SetTEn0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SET_T_EN_1`" ]
        pub enum SetTEn1W {
            # [ doc = "No Effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 1" ]
            _1,
        }
        impl SetTEn1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SetTEn1W::_0 => 0,
                    SetTEn1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SetTEn1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SetTEn1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SetTEn1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Effect" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SetTEn1W::_0)
            }
            # [ doc = "Enables the Timer Channel 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SetTEn1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SET_T_EN_2`" ]
        pub enum SetTEn2W {
            # [ doc = "No Effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 2" ]
            _1,
        }
        impl SetTEn2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SetTEn2W::_0 => 0,
                    SetTEn2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SetTEn2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SetTEn2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SetTEn2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Effect" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SetTEn2W::_0)
            }
            # [ doc = "Enables the Timer Channel 2" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SetTEn2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SET_T_EN_3`" ]
        pub enum SetTEn3W {
            # [ doc = "No effect" ]
            _0,
            # [ doc = "Enables the Timer Channel 3" ]
            _1,
        }
        impl SetTEn3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SetTEn3W::_0 => 0,
                    SetTEn3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SetTEn3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _SetTEn3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SetTEn3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SetTEn3W::_0)
            }
            # [ doc = "Enables the Timer Channel 3" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SetTEn3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Set Timer 0 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_0(&self) -> SetTEn0R {
                SetTEn0R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Set Timer 1 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_1(&self) -> SetTEn1R {
                SetTEn1R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Set Timer 2 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_2(&self) -> SetTEn2R {
                SetTEn2R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 3 - Set Timer 3 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_3(&self) -> SetTEn3R {
                SetTEn3R::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 3;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Set Timer 0 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_0(&mut self) -> _SetTEn0W {
                _SetTEn0W { w: self }
            }
            # [ doc = "Bit 1 - Set Timer 1 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_1(&mut self) -> _SetTEn1W {
                _SetTEn1W { w: self }
            }
            # [ doc = "Bit 2 - Set Timer 2 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_2(&mut self) -> _SetTEn2W {
                _SetTEn2W { w: self }
            }
            # [ doc = "Bit 3 - Set Timer 3 Enable" ]
            # [ inline ( always ) ]
            pub fn set_t_en_3(&mut self) -> _SetTEn3W {
                _SetTEn3W { w: self }
            }
        }
    }
    # [ doc = "Clear Timer Enable Register" ]
    pub struct Clrten {
        register: VolatileCell<u32>,
    }
    # [ doc = "Clear Timer Enable Register" ]
    pub mod clrten {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clrten {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Values that can be written to the field `CLR_T_EN_0`" ]
        pub enum ClrTEn0W {
            # [ doc = "No action" ]
            _0,
            # [ doc = "Clear T_EN bit for Timer Channel 0" ]
            _1,
        }
        impl ClrTEn0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClrTEn0W::_0 => 0,
                    ClrTEn0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClrTEn0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClrTEn0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClrTEn0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No action" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClrTEn0W::_0)
            }
            # [ doc = "Clear T_EN bit for Timer Channel 0" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClrTEn0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLR_T_EN_1`" ]
        pub enum ClrTEn1W {
            # [ doc = "No Action" ]
            _0,
            # [ doc = "Clear T_EN bit for Timer Channel 1" ]
            _1,
        }
        impl ClrTEn1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClrTEn1W::_0 => 0,
                    ClrTEn1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClrTEn1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClrTEn1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClrTEn1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Action" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClrTEn1W::_0)
            }
            # [ doc = "Clear T_EN bit for Timer Channel 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClrTEn1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLR_T_EN_2`" ]
        pub enum ClrTEn2W {
            # [ doc = "No Action" ]
            _0,
            # [ doc = "Clear T_EN bit for Timer Channel 2" ]
            _1,
        }
        impl ClrTEn2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClrTEn2W::_0 => 0,
                    ClrTEn2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClrTEn2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClrTEn2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClrTEn2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Action" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClrTEn2W::_0)
            }
            # [ doc = "Clear T_EN bit for Timer Channel 2" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClrTEn2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLR_T_EN_3`" ]
        pub enum ClrTEn3W {
            # [ doc = "No Action" ]
            _0,
            # [ doc = "Clear T_EN bit for Timer Channel 3" ]
            _1,
        }
        impl ClrTEn3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClrTEn3W::_0 => 0,
                    ClrTEn3W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClrTEn3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClrTEn3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClrTEn3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No Action" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClrTEn3W::_0)
            }
            # [ doc = "Clear T_EN bit for Timer Channel 3" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClrTEn3W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Clear Timer 0 Enable" ]
            # [ inline ( always ) ]
            pub fn clr_t_en_0(&mut self) -> _ClrTEn0W {
                _ClrTEn0W { w: self }
            }
            # [ doc = "Bit 1 - Clear Timer 1 Enable" ]
            # [ inline ( always ) ]
            pub fn clr_t_en_1(&mut self) -> _ClrTEn1W {
                _ClrTEn1W { w: self }
            }
            # [ doc = "Bit 2 - Clear Timer 2 Enable" ]
            # [ inline ( always ) ]
            pub fn clr_t_en_2(&mut self) -> _ClrTEn2W {
                _ClrTEn2W { w: self }
            }
            # [ doc = "Bit 3 - Clear Timer 3 Enable" ]
            # [ inline ( always ) ]
            pub fn clr_t_en_3(&mut self) -> _ClrTEn3W {
                _ClrTEn3W { w: self }
            }
        }
    }
    # [ doc = "Timer Value Register" ]
    pub struct Tval0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Value Register" ]
    pub mod tval0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tval0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TMR_VAL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TmrValR {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl TmrValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    TmrValR::_0 => 0,
                    TmrValR::_1 => 1,
                    TmrValR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> TmrValR {
                match bits {
                    0 => TmrValR::_0,
                    1 => TmrValR::_1,
                    i => TmrValR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TmrValR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TmrValR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TMR_VAL`" ]
        pub enum TmrValW {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
        }
        impl TmrValW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    TmrValW::_0 => 0,
                    TmrValW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TmrValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TmrValW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TmrValW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TmrValW::_0)
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TmrValW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&self) -> TmrValR {
                TmrValR::_from({
                                   const MASK: u32 = 4294967295;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u32
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&mut self) -> _TmrValW {
                _TmrValW { w: self }
            }
        }
    }
    # [ doc = "Current Timer Value" ]
    pub struct Cval0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Current Timer Value" ]
    pub mod cval0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cval0 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmrCurValR {
            bits: u32,
        }
        impl TmrCurValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Current Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_cur_val(&self) -> TmrCurValR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TmrCurValR { bits }
            }
        }
    }
    # [ doc = "Timer Control Register" ]
    pub struct Tctrl0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control Register" ]
    pub mod tctrl0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tctrl0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `T_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TEnR {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TEnR::_0 => 0,
                    TEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TEnR {
                match bits {
                    0 => TEnR::_0,
                    1 => TEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TEnR::_1
            }
        }
        # [ doc = "Possible values of the field `CHAIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChainR {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChainR::_0 => 0,
                    ChainR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChainR {
                match bits {
                    0 => ChainR::_0,
                    1 => ChainR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChainR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChainR::_1
            }
        }
        # [ doc = "Possible values of the field `MODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ModeR {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ModeR::_0 => 0,
                    ModeR::_1 => 1,
                    ModeR::_10 => 2,
                    ModeR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ModeR {
                match bits {
                    0 => ModeR::_0,
                    1 => ModeR::_1,
                    2 => ModeR::_10,
                    3 => ModeR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ModeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ModeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ModeR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ModeR::_11
            }
        }
        # [ doc = "Possible values of the field `TSOT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsotR {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsotR::_0 => 0,
                    TsotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsotR {
                match bits {
                    0 => TsotR::_0,
                    1 => TsotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsotR::_1
            }
        }
        # [ doc = "Possible values of the field `TSOI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsoiR {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsoiR::_0 => 0,
                    TsoiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsoiR {
                match bits {
                    0 => TsoiR::_0,
                    1 => TsoiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsoiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsoiR::_1
            }
        }
        # [ doc = "Possible values of the field `TROT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrotR {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrotR::_0 => 0,
                    TrotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrotR {
                match bits {
                    0 => TrotR::_0,
                    1 => TrotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrotR::_1
            }
        }
        # [ doc = "Possible values of the field `TRG_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgSrcR {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgSrcR::_0 => 0,
                    TrgSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgSrcR {
                match bits {
                    0 => TrgSrcR::_0,
                    1 => TrgSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgSrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgSelR {
            bits: u8,
        }
        impl TrgSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `T_EN`" ]
        pub enum TEnW {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TEnW::_0 => 0,
                    TEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TEnW::_0)
            }
            # [ doc = "Timer Channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHAIN`" ]
        pub enum ChainW {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChainW::_0 => 0,
                    ChainW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChainW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChainW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChainW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChainW::_0)
            }
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChainW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MODE`" ]
        pub enum ModeW {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ModeW::_0 => 0,
                    ModeW::_1 => 1,
                    ModeW::_10 => 2,
                    ModeW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ModeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "32-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ModeW::_0)
            }
            # [ doc = "Dual 16-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ModeW::_1)
            }
            # [ doc = "32-bit Trigger Accumulator" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ModeW::_10)
            }
            # [ doc = "32-bit Trigger Input Capture" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ModeW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOT`" ]
        pub enum TsotW {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsotW::_0 => 0,
                    TsotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsotW::_0)
            }
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOI`" ]
        pub enum TsoiW {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsoiW::_0 => 0,
                    TsoiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsoiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsoiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsoiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel timer does not stop after timeout." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsoiW::_0)
            }
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsoiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TROT`" ]
        pub enum TrotW {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrotW::_0 => 0,
                    TrotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer will not reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrotW::_0)
            }
            # [ doc = "Timer will reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRG_SRC`" ]
        pub enum TrgSrcW {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgSrcW::_0 => 0,
                    TrgSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger source selected in external" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgSrcW::_0)
            }
            # [ doc = "Trigger source selected is the internal trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSelW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&self) -> TEnR {
                TEnR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&self) -> ChainR {
                ChainR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&self) -> ModeR {
                ModeR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&self) -> TsotR {
                TsotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&self) -> TsoiR {
                TsoiR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&self) -> TrotR {
                TrotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&self) -> TrgSrcR {
                TrgSrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&self) -> TrgSelR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgSelR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&mut self) -> _TEnW {
                _TEnW { w: self }
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&mut self) -> _ChainW {
                _ChainW { w: self }
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&mut self) -> _ModeW {
                _ModeW { w: self }
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&mut self) -> _TsotW {
                _TsotW { w: self }
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&mut self) -> _TsoiW {
                _TsoiW { w: self }
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&mut self) -> _TrotW {
                _TrotW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&mut self) -> _TrgSrcW {
                _TrgSrcW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&mut self) -> _TrgSelW {
                _TrgSelW { w: self }
            }
        }
    }
    # [ doc = "Timer Value Register" ]
    pub struct Tval1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Value Register" ]
    pub mod tval1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tval1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TMR_VAL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TmrValR {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl TmrValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    TmrValR::_0 => 0,
                    TmrValR::_1 => 1,
                    TmrValR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> TmrValR {
                match bits {
                    0 => TmrValR::_0,
                    1 => TmrValR::_1,
                    i => TmrValR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TmrValR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TmrValR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TMR_VAL`" ]
        pub enum TmrValW {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
        }
        impl TmrValW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    TmrValW::_0 => 0,
                    TmrValW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TmrValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TmrValW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TmrValW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TmrValW::_0)
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TmrValW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&self) -> TmrValR {
                TmrValR::_from({
                                   const MASK: u32 = 4294967295;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u32
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&mut self) -> _TmrValW {
                _TmrValW { w: self }
            }
        }
    }
    # [ doc = "Current Timer Value" ]
    pub struct Cval1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Current Timer Value" ]
    pub mod cval1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cval1 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmrCurValR {
            bits: u32,
        }
        impl TmrCurValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Current Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_cur_val(&self) -> TmrCurValR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TmrCurValR { bits }
            }
        }
    }
    # [ doc = "Timer Control Register" ]
    pub struct Tctrl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control Register" ]
    pub mod tctrl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tctrl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `T_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TEnR {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TEnR::_0 => 0,
                    TEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TEnR {
                match bits {
                    0 => TEnR::_0,
                    1 => TEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TEnR::_1
            }
        }
        # [ doc = "Possible values of the field `CHAIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChainR {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChainR::_0 => 0,
                    ChainR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChainR {
                match bits {
                    0 => ChainR::_0,
                    1 => ChainR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChainR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChainR::_1
            }
        }
        # [ doc = "Possible values of the field `MODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ModeR {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ModeR::_0 => 0,
                    ModeR::_1 => 1,
                    ModeR::_10 => 2,
                    ModeR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ModeR {
                match bits {
                    0 => ModeR::_0,
                    1 => ModeR::_1,
                    2 => ModeR::_10,
                    3 => ModeR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ModeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ModeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ModeR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ModeR::_11
            }
        }
        # [ doc = "Possible values of the field `TSOT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsotR {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsotR::_0 => 0,
                    TsotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsotR {
                match bits {
                    0 => TsotR::_0,
                    1 => TsotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsotR::_1
            }
        }
        # [ doc = "Possible values of the field `TSOI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsoiR {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsoiR::_0 => 0,
                    TsoiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsoiR {
                match bits {
                    0 => TsoiR::_0,
                    1 => TsoiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsoiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsoiR::_1
            }
        }
        # [ doc = "Possible values of the field `TROT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrotR {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrotR::_0 => 0,
                    TrotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrotR {
                match bits {
                    0 => TrotR::_0,
                    1 => TrotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrotR::_1
            }
        }
        # [ doc = "Possible values of the field `TRG_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgSrcR {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgSrcR::_0 => 0,
                    TrgSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgSrcR {
                match bits {
                    0 => TrgSrcR::_0,
                    1 => TrgSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgSrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgSelR {
            bits: u8,
        }
        impl TrgSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `T_EN`" ]
        pub enum TEnW {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TEnW::_0 => 0,
                    TEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TEnW::_0)
            }
            # [ doc = "Timer Channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHAIN`" ]
        pub enum ChainW {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChainW::_0 => 0,
                    ChainW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChainW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChainW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChainW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChainW::_0)
            }
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChainW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MODE`" ]
        pub enum ModeW {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ModeW::_0 => 0,
                    ModeW::_1 => 1,
                    ModeW::_10 => 2,
                    ModeW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ModeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "32-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ModeW::_0)
            }
            # [ doc = "Dual 16-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ModeW::_1)
            }
            # [ doc = "32-bit Trigger Accumulator" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ModeW::_10)
            }
            # [ doc = "32-bit Trigger Input Capture" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ModeW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOT`" ]
        pub enum TsotW {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsotW::_0 => 0,
                    TsotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsotW::_0)
            }
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOI`" ]
        pub enum TsoiW {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsoiW::_0 => 0,
                    TsoiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsoiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsoiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsoiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel timer does not stop after timeout." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsoiW::_0)
            }
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsoiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TROT`" ]
        pub enum TrotW {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrotW::_0 => 0,
                    TrotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer will not reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrotW::_0)
            }
            # [ doc = "Timer will reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRG_SRC`" ]
        pub enum TrgSrcW {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgSrcW::_0 => 0,
                    TrgSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger source selected in external" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgSrcW::_0)
            }
            # [ doc = "Trigger source selected is the internal trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSelW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&self) -> TEnR {
                TEnR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&self) -> ChainR {
                ChainR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&self) -> ModeR {
                ModeR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&self) -> TsotR {
                TsotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&self) -> TsoiR {
                TsoiR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&self) -> TrotR {
                TrotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&self) -> TrgSrcR {
                TrgSrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&self) -> TrgSelR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgSelR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&mut self) -> _TEnW {
                _TEnW { w: self }
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&mut self) -> _ChainW {
                _ChainW { w: self }
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&mut self) -> _ModeW {
                _ModeW { w: self }
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&mut self) -> _TsotW {
                _TsotW { w: self }
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&mut self) -> _TsoiW {
                _TsoiW { w: self }
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&mut self) -> _TrotW {
                _TrotW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&mut self) -> _TrgSrcW {
                _TrgSrcW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&mut self) -> _TrgSelW {
                _TrgSelW { w: self }
            }
        }
    }
    # [ doc = "Timer Value Register" ]
    pub struct Tval2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Value Register" ]
    pub mod tval2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tval2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TMR_VAL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TmrValR {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl TmrValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    TmrValR::_0 => 0,
                    TmrValR::_1 => 1,
                    TmrValR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> TmrValR {
                match bits {
                    0 => TmrValR::_0,
                    1 => TmrValR::_1,
                    i => TmrValR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TmrValR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TmrValR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TMR_VAL`" ]
        pub enum TmrValW {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
        }
        impl TmrValW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    TmrValW::_0 => 0,
                    TmrValW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TmrValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TmrValW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TmrValW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TmrValW::_0)
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TmrValW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&self) -> TmrValR {
                TmrValR::_from({
                                   const MASK: u32 = 4294967295;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u32
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&mut self) -> _TmrValW {
                _TmrValW { w: self }
            }
        }
    }
    # [ doc = "Current Timer Value" ]
    pub struct Cval2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Current Timer Value" ]
    pub mod cval2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cval2 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmrCurValR {
            bits: u32,
        }
        impl TmrCurValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Current Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_cur_val(&self) -> TmrCurValR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TmrCurValR { bits }
            }
        }
    }
    # [ doc = "Timer Control Register" ]
    pub struct Tctrl2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control Register" ]
    pub mod tctrl2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tctrl2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `T_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TEnR {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TEnR::_0 => 0,
                    TEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TEnR {
                match bits {
                    0 => TEnR::_0,
                    1 => TEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TEnR::_1
            }
        }
        # [ doc = "Possible values of the field `CHAIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChainR {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChainR::_0 => 0,
                    ChainR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChainR {
                match bits {
                    0 => ChainR::_0,
                    1 => ChainR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChainR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChainR::_1
            }
        }
        # [ doc = "Possible values of the field `MODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ModeR {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ModeR::_0 => 0,
                    ModeR::_1 => 1,
                    ModeR::_10 => 2,
                    ModeR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ModeR {
                match bits {
                    0 => ModeR::_0,
                    1 => ModeR::_1,
                    2 => ModeR::_10,
                    3 => ModeR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ModeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ModeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ModeR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ModeR::_11
            }
        }
        # [ doc = "Possible values of the field `TSOT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsotR {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsotR::_0 => 0,
                    TsotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsotR {
                match bits {
                    0 => TsotR::_0,
                    1 => TsotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsotR::_1
            }
        }
        # [ doc = "Possible values of the field `TSOI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsoiR {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsoiR::_0 => 0,
                    TsoiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsoiR {
                match bits {
                    0 => TsoiR::_0,
                    1 => TsoiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsoiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsoiR::_1
            }
        }
        # [ doc = "Possible values of the field `TROT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrotR {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrotR::_0 => 0,
                    TrotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrotR {
                match bits {
                    0 => TrotR::_0,
                    1 => TrotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrotR::_1
            }
        }
        # [ doc = "Possible values of the field `TRG_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgSrcR {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgSrcR::_0 => 0,
                    TrgSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgSrcR {
                match bits {
                    0 => TrgSrcR::_0,
                    1 => TrgSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgSrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgSelR {
            bits: u8,
        }
        impl TrgSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `T_EN`" ]
        pub enum TEnW {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TEnW::_0 => 0,
                    TEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TEnW::_0)
            }
            # [ doc = "Timer Channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHAIN`" ]
        pub enum ChainW {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChainW::_0 => 0,
                    ChainW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChainW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChainW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChainW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChainW::_0)
            }
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChainW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MODE`" ]
        pub enum ModeW {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ModeW::_0 => 0,
                    ModeW::_1 => 1,
                    ModeW::_10 => 2,
                    ModeW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ModeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "32-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ModeW::_0)
            }
            # [ doc = "Dual 16-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ModeW::_1)
            }
            # [ doc = "32-bit Trigger Accumulator" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ModeW::_10)
            }
            # [ doc = "32-bit Trigger Input Capture" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ModeW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOT`" ]
        pub enum TsotW {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsotW::_0 => 0,
                    TsotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsotW::_0)
            }
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOI`" ]
        pub enum TsoiW {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsoiW::_0 => 0,
                    TsoiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsoiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsoiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsoiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel timer does not stop after timeout." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsoiW::_0)
            }
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsoiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TROT`" ]
        pub enum TrotW {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrotW::_0 => 0,
                    TrotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer will not reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrotW::_0)
            }
            # [ doc = "Timer will reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRG_SRC`" ]
        pub enum TrgSrcW {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgSrcW::_0 => 0,
                    TrgSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger source selected in external" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgSrcW::_0)
            }
            # [ doc = "Trigger source selected is the internal trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSelW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&self) -> TEnR {
                TEnR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&self) -> ChainR {
                ChainR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&self) -> ModeR {
                ModeR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&self) -> TsotR {
                TsotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&self) -> TsoiR {
                TsoiR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&self) -> TrotR {
                TrotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&self) -> TrgSrcR {
                TrgSrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&self) -> TrgSelR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgSelR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&mut self) -> _TEnW {
                _TEnW { w: self }
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&mut self) -> _ChainW {
                _ChainW { w: self }
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&mut self) -> _ModeW {
                _ModeW { w: self }
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&mut self) -> _TsotW {
                _TsotW { w: self }
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&mut self) -> _TsoiW {
                _TsoiW { w: self }
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&mut self) -> _TrotW {
                _TrotW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&mut self) -> _TrgSrcW {
                _TrgSrcW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&mut self) -> _TrgSelW {
                _TrgSelW { w: self }
            }
        }
    }
    # [ doc = "Timer Value Register" ]
    pub struct Tval3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Value Register" ]
    pub mod tval3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tval3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TMR_VAL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TmrValR {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl TmrValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    TmrValR::_0 => 0,
                    TmrValR::_1 => 1,
                    TmrValR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> TmrValR {
                match bits {
                    0 => TmrValR::_0,
                    1 => TmrValR::_1,
                    i => TmrValR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TmrValR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TmrValR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TMR_VAL`" ]
        pub enum TmrValW {
            # [ doc = "Invalid load value in compare modes." ]
            _0,
            # [ doc = "Invalid load value in compare modes." ]
            _1,
        }
        impl TmrValW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    TmrValW::_0 => 0,
                    TmrValW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TmrValW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TmrValW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TmrValW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TmrValW::_0)
            }
            # [ doc = "Invalid load value in compare modes." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TmrValW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&self) -> TmrValR {
                TmrValR::_from({
                                   const MASK: u32 = 4294967295;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u32
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_val(&mut self) -> _TmrValW {
                _TmrValW { w: self }
            }
        }
    }
    # [ doc = "Current Timer Value" ]
    pub struct Cval3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Current Timer Value" ]
    pub mod cval3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Cval3 {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TmrCurValR {
            bits: u32,
        }
        impl TmrCurValR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Current Timer Value" ]
            # [ inline ( always ) ]
            pub fn tmr_cur_val(&self) -> TmrCurValR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TmrCurValR { bits }
            }
        }
    }
    # [ doc = "Timer Control Register" ]
    pub struct Tctrl3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control Register" ]
    pub mod tctrl3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tctrl3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `T_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TEnR {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TEnR::_0 => 0,
                    TEnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TEnR {
                match bits {
                    0 => TEnR::_0,
                    1 => TEnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TEnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TEnR::_1
            }
        }
        # [ doc = "Possible values of the field `CHAIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ChainR {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ChainR::_0 => 0,
                    ChainR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ChainR {
                match bits {
                    0 => ChainR::_0,
                    1 => ChainR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ChainR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ChainR::_1
            }
        }
        # [ doc = "Possible values of the field `MODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ModeR {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ModeR::_0 => 0,
                    ModeR::_1 => 1,
                    ModeR::_10 => 2,
                    ModeR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ModeR {
                match bits {
                    0 => ModeR::_0,
                    1 => ModeR::_1,
                    2 => ModeR::_10,
                    3 => ModeR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ModeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ModeR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ModeR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ModeR::_11
            }
        }
        # [ doc = "Possible values of the field `TSOT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsotR {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsotR::_0 => 0,
                    TsotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsotR {
                match bits {
                    0 => TsotR::_0,
                    1 => TsotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsotR::_1
            }
        }
        # [ doc = "Possible values of the field `TSOI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsoiR {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsoiR::_0 => 0,
                    TsoiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsoiR {
                match bits {
                    0 => TsoiR::_0,
                    1 => TsoiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsoiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsoiR::_1
            }
        }
        # [ doc = "Possible values of the field `TROT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrotR {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrotR::_0 => 0,
                    TrotR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrotR {
                match bits {
                    0 => TrotR::_0,
                    1 => TrotR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrotR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrotR::_1
            }
        }
        # [ doc = "Possible values of the field `TRG_SRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgSrcR {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgSrcR::_0 => 0,
                    TrgSrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgSrcR {
                match bits {
                    0 => TrgSrcR::_0,
                    1 => TrgSrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgSrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgSrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgSelR {
            bits: u8,
        }
        impl TrgSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `T_EN`" ]
        pub enum TEnW {
            # [ doc = "Timer Channel is disabled" ]
            _0,
            # [ doc = "Timer Channel is enabled" ]
            _1,
        }
        impl TEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TEnW::_0 => 0,
                    TEnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TEnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Channel is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TEnW::_0)
            }
            # [ doc = "Timer Channel is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TEnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CHAIN`" ]
        pub enum ChainW {
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            _0,
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            _1,
        }
        impl ChainW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ChainW::_0 => 0,
                    ChainW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ChainW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ChainW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ChainW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel Chaining is disabled. Channel Timer runs independently." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ChainW::_0)
            }
            # [ doc = "Channel Chaining is enabled. Timer decrements on previous channel's timeout" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ChainW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MODE`" ]
        pub enum ModeW {
            # [ doc = "32-bit Periodic Counter" ]
            _0,
            # [ doc = "Dual 16-bit Periodic Counter" ]
            _1,
            # [ doc = "32-bit Trigger Accumulator" ]
            _10,
            # [ doc = "32-bit Trigger Input Capture" ]
            _11,
        }
        impl ModeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ModeW::_0 => 0,
                    ModeW::_1 => 1,
                    ModeW::_10 => 2,
                    ModeW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ModeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ModeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ModeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "32-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ModeW::_0)
            }
            # [ doc = "Dual 16-bit Periodic Counter" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ModeW::_1)
            }
            # [ doc = "32-bit Trigger Accumulator" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ModeW::_10)
            }
            # [ doc = "32-bit Trigger Input Capture" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ModeW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOT`" ]
        pub enum TsotW {
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            _0,
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            _1,
        }
        impl TsotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsotW::_0 => 0,
                    TsotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer starts to decrement immediately based on restart condition (controlled by TSOI bit)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsotW::_0)
            }
            # [ doc = "Timer starts to decrement when rising edge on selected trigger is detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSOI`" ]
        pub enum TsoiW {
            # [ doc = "The channel timer does not stop after timeout." ]
            _0,
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            _1,
        }
        impl TsoiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsoiW::_0 => 0,
                    TsoiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsoiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsoiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsoiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The channel timer does not stop after timeout." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsoiW::_0)
            }
            # [ doc = "The channel timer will stop after a timeout, and the channel timer will restart based on TSOT. When TSOT = 0, the channel timer will restart after a rising edge on the T_EN bit is detected (which means that the timer channel is disabled and then enabled); when TSOT = 1, the channel timer will restart after a rising edge on the selected trigger is detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsoiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TROT`" ]
        pub enum TrotW {
            # [ doc = "Timer will not reload on selected trigger" ]
            _0,
            # [ doc = "Timer will reload on selected trigger" ]
            _1,
        }
        impl TrotW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrotW::_0 => 0,
                    TrotW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrotW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrotW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrotW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer will not reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrotW::_0)
            }
            # [ doc = "Timer will reload on selected trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrotW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRG_SRC`" ]
        pub enum TrgSrcW {
            # [ doc = "Trigger source selected in external" ]
            _0,
            # [ doc = "Trigger source selected is the internal trigger" ]
            _1,
        }
        impl TrgSrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgSrcW::_0 => 0,
                    TrgSrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgSrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger source selected in external" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgSrcW::_0)
            }
            # [ doc = "Trigger source selected is the internal trigger" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgSrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgSelW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&self) -> TEnR {
                TEnR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&self) -> ChainR {
                ChainR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&self) -> ModeR {
                ModeR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&self) -> TsotR {
                TsotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&self) -> TsoiR {
                TsoiR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&self) -> TrotR {
                TrotR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&self) -> TrgSrcR {
                TrgSrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&self) -> TrgSelR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgSelR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn t_en(&mut self) -> _TEnW {
                _TEnW { w: self }
            }
            # [ doc = "Bit 1 - Chain Channel" ]
            # [ inline ( always ) ]
            pub fn chain(&mut self) -> _ChainW {
                _ChainW { w: self }
            }
            # [ doc = "Bits 2:3 - Timer Operation Mode" ]
            # [ inline ( always ) ]
            pub fn mode(&mut self) -> _ModeW {
                _ModeW { w: self }
            }
            # [ doc = "Bit 16 - Timer Start On Trigger" ]
            # [ inline ( always ) ]
            pub fn tsot(&mut self) -> _TsotW {
                _TsotW { w: self }
            }
            # [ doc = "Bit 17 - Timer Stop On Interrupt" ]
            # [ inline ( always ) ]
            pub fn tsoi(&mut self) -> _TsoiW {
                _TsoiW { w: self }
            }
            # [ doc = "Bit 18 - Timer Reload On Trigger" ]
            # [ inline ( always ) ]
            pub fn trot(&mut self) -> _TrotW {
                _TrotW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trg_src(&mut self) -> _TrgSrcW {
                _TrgSrcW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trg_sel(&mut self) -> _TrgSelW {
                _TrgSelW { w: self }
            }
        }
    }
}
# [ doc = "Low Power Periodic Interrupt Timer (LPIT)" ]
pub struct Lpit0 {
    register_block: lpit0::RegisterBlock,
}
impl Deref for Lpit0 {
    type Target = lpit0::RegisterBlock;
    fn deref(&self) -> &lpit0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Secure Real Time Clock" ]
pub const RTC: Peripheral<Rtc> = unsafe { Peripheral::new(1073991680) };
# [ doc = "Secure Real Time Clock" ]
pub mod rtc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - RTC Time Seconds Register" ]
        pub tsr: Tsr,
        # [ doc = "0x04 - RTC Time Prescaler Register" ]
        pub tpr: Tpr,
        # [ doc = "0x08 - RTC Time Alarm Register" ]
        pub tar: Tar,
        # [ doc = "0x0c - RTC Time Compensation Register" ]
        pub tcr: Tcr,
        # [ doc = "0x10 - RTC Control Register" ]
        pub cr: Cr,
        # [ doc = "0x14 - RTC Status Register" ]
        pub sr: Sr,
        # [ doc = "0x18 - RTC Lock Register" ]
        pub lr: Lr,
        # [ doc = "0x1c - RTC Interrupt Enable Register" ]
        pub ier: Ier,
    }
    # [ doc = "RTC Time Seconds Register" ]
    pub struct Tsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Time Seconds Register" ]
    pub mod tsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tsr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TsrR {
            bits: u32,
        }
        impl TsrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Time Seconds Register" ]
            # [ inline ( always ) ]
            pub fn tsr(&self) -> TsrR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TsrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Time Seconds Register" ]
            # [ inline ( always ) ]
            pub fn tsr(&mut self) -> _TsrW {
                _TsrW { w: self }
            }
        }
    }
    # [ doc = "RTC Time Prescaler Register" ]
    pub struct Tpr {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Time Prescaler Register" ]
    pub mod tpr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tpr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TprR {
            bits: u16,
        }
        impl TprR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TprW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TprW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Time Prescaler Register" ]
            # [ inline ( always ) ]
            pub fn tpr(&self) -> TprR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                TprR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Time Prescaler Register" ]
            # [ inline ( always ) ]
            pub fn tpr(&mut self) -> _TprW {
                _TprW { w: self }
            }
        }
    }
    # [ doc = "RTC Time Alarm Register" ]
    pub struct Tar {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Time Alarm Register" ]
    pub mod tar {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tar {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TarR {
            bits: u32,
        }
        impl TarR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TarW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TarW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Time Alarm Register" ]
            # [ inline ( always ) ]
            pub fn tar(&self) -> TarR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                TarR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Time Alarm Register" ]
            # [ inline ( always ) ]
            pub fn tar(&mut self) -> _TarW {
                _TarW { w: self }
            }
        }
    }
    # [ doc = "RTC Time Compensation Register" ]
    pub struct Tcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Time Compensation Register" ]
    pub mod tcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Tcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TCR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcrR {
            # [ doc = "Time Prescaler Register overflows every 32896 clock cycles." ]
            _10000000,
            # [ doc = "Time Prescaler Register overflows every 32895 clock cycles." ]
            _10000001,
            # [ doc = "Time Prescaler Register overflows every 32769 clock cycles." ]
            _11111111,
            # [ doc = "Time Prescaler Register overflows every 32768 clock cycles." ]
            _00000000,
            # [ doc = "Time Prescaler Register overflows every 32767 clock cycles." ]
            _00000001,
            # [ doc = "Time Prescaler Register overflows every 32642 clock cycles." ]
            _01111110,
            # [ doc = "Time Prescaler Register overflows every 32641 clock cycles." ]
            _01111111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TcrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcrR::_10000000 => 128,
                    TcrR::_10000001 => 129,
                    TcrR::_11111111 => 255,
                    TcrR::_00000000 => 0,
                    TcrR::_00000001 => 1,
                    TcrR::_01111110 => 126,
                    TcrR::_01111111 => 127,
                    TcrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcrR {
                match bits {
                    128 => TcrR::_10000000,
                    129 => TcrR::_10000001,
                    255 => TcrR::_11111111,
                    0 => TcrR::_00000000,
                    1 => TcrR::_00000001,
                    126 => TcrR::_01111110,
                    127 => TcrR::_01111111,
                    i => TcrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_10000000`" ]
            # [ inline ( always ) ]
            pub fn is_10000000(&self) -> bool {
                *self == TcrR::_10000000
            }
            # [ doc = "Checks if the value of the field is `_10000001`" ]
            # [ inline ( always ) ]
            pub fn is_10000001(&self) -> bool {
                *self == TcrR::_10000001
            }
            # [ doc = "Checks if the value of the field is `_11111111`" ]
            # [ inline ( always ) ]
            pub fn is_11111111(&self) -> bool {
                *self == TcrR::_11111111
            }
            # [ doc = "Checks if the value of the field is `_00000000`" ]
            # [ inline ( always ) ]
            pub fn is_00000000(&self) -> bool {
                *self == TcrR::_00000000
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == TcrR::_00000001
            }
            # [ doc = "Checks if the value of the field is `_01111110`" ]
            # [ inline ( always ) ]
            pub fn is_01111110(&self) -> bool {
                *self == TcrR::_01111110
            }
            # [ doc = "Checks if the value of the field is `_01111111`" ]
            # [ inline ( always ) ]
            pub fn is_01111111(&self) -> bool {
                *self == TcrR::_01111111
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CirR {
            bits: u8,
        }
        impl CirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TcvR {
            bits: u8,
        }
        impl TcvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CicR {
            bits: u8,
        }
        impl CicR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `TCR`" ]
        pub enum TcrW {
            # [ doc = "Time Prescaler Register overflows every 32896 clock cycles." ]
            _10000000,
            # [ doc = "Time Prescaler Register overflows every 32895 clock cycles." ]
            _10000001,
            # [ doc = "Time Prescaler Register overflows every 32769 clock cycles." ]
            _11111111,
            # [ doc = "Time Prescaler Register overflows every 32768 clock cycles." ]
            _00000000,
            # [ doc = "Time Prescaler Register overflows every 32767 clock cycles." ]
            _00000001,
            # [ doc = "Time Prescaler Register overflows every 32642 clock cycles." ]
            _01111110,
            # [ doc = "Time Prescaler Register overflows every 32641 clock cycles." ]
            _01111111,
        }
        impl TcrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcrW::_10000000 => 128,
                    TcrW::_10000001 => 129,
                    TcrW::_11111111 => 255,
                    TcrW::_00000000 => 0,
                    TcrW::_00000001 => 1,
                    TcrW::_01111110 => 126,
                    TcrW::_01111111 => 127,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Time Prescaler Register overflows every 32896 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _10000000(self) -> &'a mut W {
                self.variant(TcrW::_10000000)
            }
            # [ doc = "Time Prescaler Register overflows every 32895 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _10000001(self) -> &'a mut W {
                self.variant(TcrW::_10000001)
            }
            # [ doc = "Time Prescaler Register overflows every 32769 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _11111111(self) -> &'a mut W {
                self.variant(TcrW::_11111111)
            }
            # [ doc = "Time Prescaler Register overflows every 32768 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _00000000(self) -> &'a mut W {
                self.variant(TcrW::_00000000)
            }
            # [ doc = "Time Prescaler Register overflows every 32767 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(TcrW::_00000001)
            }
            # [ doc = "Time Prescaler Register overflows every 32642 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _01111110(self) -> &'a mut W {
                self.variant(TcrW::_01111110)
            }
            # [ doc = "Time Prescaler Register overflows every 32641 clock cycles." ]
            # [ inline ( always ) ]
            pub fn _01111111(self) -> &'a mut W {
                self.variant(TcrW::_01111111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CirW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CirW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Time Compensation Register" ]
            # [ inline ( always ) ]
            pub fn tcr(&self) -> TcrR {
                TcrR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:15 - Compensation Interval Register" ]
            # [ inline ( always ) ]
            pub fn cir(&self) -> CirR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CirR { bits }
            }
            # [ doc = "Bits 16:23 - Time Compensation Value" ]
            # [ inline ( always ) ]
            pub fn tcv(&self) -> TcvR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TcvR { bits }
            }
            # [ doc = "Bits 24:31 - Compensation Interval Counter" ]
            # [ inline ( always ) ]
            pub fn cic(&self) -> CicR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CicR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Time Compensation Register" ]
            # [ inline ( always ) ]
            pub fn tcr(&mut self) -> _TcrW {
                _TcrW { w: self }
            }
            # [ doc = "Bits 8:15 - Compensation Interval Register" ]
            # [ inline ( always ) ]
            pub fn cir(&mut self) -> _CirW {
                _CirW { w: self }
            }
        }
    }
    # [ doc = "RTC Control Register" ]
    pub struct Cr {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Control Register" ]
    pub mod cr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SWR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwrR {
            # [ doc = "No effect." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SwrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwrR::_0 => 0,
                    SwrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwrR {
                match bits {
                    0 => SwrR::_0,
                    i => SwrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwrR::_0
            }
        }
        # [ doc = "Possible values of the field `SUP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SupR {
            # [ doc = "Non-supervisor mode write accesses are not supported and generate a bus error." ]
            _0,
            # [ doc = "Non-supervisor mode write accesses are supported." ]
            _1,
        }
        impl SupR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SupR::_0 => 0,
                    SupR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SupR {
                match bits {
                    0 => SupR::_0,
                    1 => SupR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SupR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SupR::_1
            }
        }
        # [ doc = "Possible values of the field `UM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum UmR {
            # [ doc = "Registers cannot be written when locked." ]
            _0,
            # [ doc = "Registers can be written when locked under limited conditions." ]
            _1,
        }
        impl UmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    UmR::_0 => 0,
                    UmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> UmR {
                match bits {
                    0 => UmR::_0,
                    1 => UmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == UmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == UmR::_1
            }
        }
        # [ doc = "Possible values of the field `CPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpsR {
            # [ doc = "The prescaler output clock (as configured by TSIC) is output on RTC_CLKOUT." ]
            _0,
            # [ doc = "The RTC 32kHz crystal clock is output on RTC_CLKOUT, provided it is output to other peripherals." ]
            _1,
        }
        impl CpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpsR::_0 => 0,
                    CpsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpsR {
                match bits {
                    0 => CpsR::_0,
                    1 => CpsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpsR::_1
            }
        }
        # [ doc = "Possible values of the field `LPOS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LposR {
            # [ doc = "RTC prescaler increments using 32kHz crystal." ]
            _0,
            # [ doc = "RTC prescaler increments using 1kHz LPO, bits [4:0] of the prescaler are ignored." ]
            _1,
        }
        impl LposR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LposR::_0 => 0,
                    LposR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LposR {
                match bits {
                    0 => LposR::_0,
                    1 => LposR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LposR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LposR::_1
            }
        }
        # [ doc = "Possible values of the field `CPE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpeR {
            # [ doc = "Disable RTC_CLKOUT pin." ]
            _0,
            # [ doc = "Enable RTC_CLKOUT pin." ]
            _1,
        }
        impl CpeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpeR::_0 => 0,
                    CpeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpeR {
                match bits {
                    0 => CpeR::_0,
                    1 => CpeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SWR`" ]
        pub enum SwrW {
            # [ doc = "No effect." ]
            _0,
        }
        impl SwrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwrW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwrW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SUP`" ]
        pub enum SupW {
            # [ doc = "Non-supervisor mode write accesses are not supported and generate a bus error." ]
            _0,
            # [ doc = "Non-supervisor mode write accesses are supported." ]
            _1,
        }
        impl SupW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SupW::_0 => 0,
                    SupW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SupW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SupW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SupW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-supervisor mode write accesses are not supported and generate a bus error." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SupW::_0)
            }
            # [ doc = "Non-supervisor mode write accesses are supported." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SupW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `UM`" ]
        pub enum UmW {
            # [ doc = "Registers cannot be written when locked." ]
            _0,
            # [ doc = "Registers can be written when locked under limited conditions." ]
            _1,
        }
        impl UmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    UmW::_0 => 0,
                    UmW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _UmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: UmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Registers cannot be written when locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(UmW::_0)
            }
            # [ doc = "Registers can be written when locked under limited conditions." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(UmW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPS`" ]
        pub enum CpsW {
            # [ doc = "The prescaler output clock (as configured by TSIC) is output on RTC_CLKOUT." ]
            _0,
            # [ doc = "The RTC 32kHz crystal clock is output on RTC_CLKOUT, provided it is output to other peripherals." ]
            _1,
        }
        impl CpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpsW::_0 => 0,
                    CpsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The prescaler output clock (as configured by TSIC) is output on RTC_CLKOUT." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpsW::_0)
            }
            # [ doc = "The RTC 32kHz crystal clock is output on RTC_CLKOUT, provided it is output to other peripherals." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPOS`" ]
        pub enum LposW {
            # [ doc = "RTC prescaler increments using 32kHz crystal." ]
            _0,
            # [ doc = "RTC prescaler increments using 1kHz LPO, bits [4:0] of the prescaler are ignored." ]
            _1,
        }
        impl LposW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LposW::_0 => 0,
                    LposW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LposW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LposW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LposW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "RTC prescaler increments using 32kHz crystal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LposW::_0)
            }
            # [ doc = "RTC prescaler increments using 1kHz LPO, bits [4:0] of the prescaler are ignored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LposW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPE`" ]
        pub enum CpeW {
            # [ doc = "Disable RTC_CLKOUT pin." ]
            _0,
            # [ doc = "Enable RTC_CLKOUT pin." ]
            _1,
        }
        impl CpeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpeW::_0 => 0,
                    CpeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable RTC_CLKOUT pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpeW::_0)
            }
            # [ doc = "Enable RTC_CLKOUT pin." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn swr(&self) -> SwrR {
                SwrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Supervisor Access" ]
            # [ inline ( always ) ]
            pub fn sup(&self) -> SupR {
                SupR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Update Mode" ]
            # [ inline ( always ) ]
            pub fn um(&self) -> UmR {
                UmR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 3;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 5 - Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn cps(&self) -> CpsR {
                CpsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - LPO Select" ]
            # [ inline ( always ) ]
            pub fn lpos(&self) -> LposR {
                LposR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Clock Pin Enable" ]
            # [ inline ( always ) ]
            pub fn cpe(&self) -> CpeR {
                CpeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn swr(&mut self) -> _SwrW {
                _SwrW { w: self }
            }
            # [ doc = "Bit 2 - Supervisor Access" ]
            # [ inline ( always ) ]
            pub fn sup(&mut self) -> _SupW {
                _SupW { w: self }
            }
            # [ doc = "Bit 3 - Update Mode" ]
            # [ inline ( always ) ]
            pub fn um(&mut self) -> _UmW {
                _UmW { w: self }
            }
            # [ doc = "Bit 5 - Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn cps(&mut self) -> _CpsW {
                _CpsW { w: self }
            }
            # [ doc = "Bit 7 - LPO Select" ]
            # [ inline ( always ) ]
            pub fn lpos(&mut self) -> _LposW {
                _LposW { w: self }
            }
            # [ doc = "Bit 24 - Clock Pin Enable" ]
            # [ inline ( always ) ]
            pub fn cpe(&mut self) -> _CpeW {
                _CpeW { w: self }
            }
        }
    }
    # [ doc = "RTC Status Register" ]
    pub struct Sr {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Status Register" ]
    pub mod sr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TifR {
            # [ doc = "Time is valid." ]
            _0,
            # [ doc = "Time is invalid and time counter is read as zero." ]
            _1,
        }
        impl TifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TifR::_0 => 0,
                    TifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TifR {
                match bits {
                    0 => TifR::_0,
                    1 => TifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TifR::_1
            }
        }
        # [ doc = "Possible values of the field `TOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TofR {
            # [ doc = "Time overflow has not occurred." ]
            _0,
            # [ doc = "Time overflow has occurred and time counter is read as zero." ]
            _1,
        }
        impl TofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TofR::_0 => 0,
                    TofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TofR {
                match bits {
                    0 => TofR::_0,
                    1 => TofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TofR::_1
            }
        }
        # [ doc = "Possible values of the field `TAF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TafR {
            # [ doc = "Time alarm has not occurred." ]
            _0,
            # [ doc = "Time alarm has occurred." ]
            _1,
        }
        impl TafR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TafR::_0 => 0,
                    TafR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TafR {
                match bits {
                    0 => TafR::_0,
                    1 => TafR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TafR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TafR::_1
            }
        }
        # [ doc = "Possible values of the field `TCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TceR {
            # [ doc = "Time counter is disabled." ]
            _0,
            # [ doc = "Time counter is enabled." ]
            _1,
        }
        impl TceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TceR::_0 => 0,
                    TceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TceR {
                match bits {
                    0 => TceR::_0,
                    1 => TceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TceR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TCE`" ]
        pub enum TceW {
            # [ doc = "Time counter is disabled." ]
            _0,
            # [ doc = "Time counter is enabled." ]
            _1,
        }
        impl TceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TceW::_0 => 0,
                    TceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Time counter is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TceW::_0)
            }
            # [ doc = "Time counter is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Time Invalid Flag" ]
            # [ inline ( always ) ]
            pub fn tif(&self) -> TifR {
                TifR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Time Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn tof(&self) -> TofR {
                TofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Time Alarm Flag" ]
            # [ inline ( always ) ]
            pub fn taf(&self) -> TafR {
                TafR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Time Counter Enable" ]
            # [ inline ( always ) ]
            pub fn tce(&self) -> TceR {
                TceR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Time Counter Enable" ]
            # [ inline ( always ) ]
            pub fn tce(&mut self) -> _TceW {
                _TceW { w: self }
            }
        }
    }
    # [ doc = "RTC Lock Register" ]
    pub struct Lr {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Lock Register" ]
    pub mod lr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TCL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TclR {
            # [ doc = "Time Compensation Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Time Compensation Register is not locked and writes complete as normal." ]
            _1,
        }
        impl TclR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TclR::_0 => 0,
                    TclR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TclR {
                match bits {
                    0 => TclR::_0,
                    1 => TclR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TclR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TclR::_1
            }
        }
        # [ doc = "Possible values of the field `CRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CrlR {
            # [ doc = "Control Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Control Register is not locked and writes complete as normal." ]
            _1,
        }
        impl CrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CrlR::_0 => 0,
                    CrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CrlR {
                match bits {
                    0 => CrlR::_0,
                    1 => CrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CrlR::_1
            }
        }
        # [ doc = "Possible values of the field `SRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SrlR {
            # [ doc = "Status Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Status Register is not locked and writes complete as normal." ]
            _1,
        }
        impl SrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SrlR::_0 => 0,
                    SrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SrlR {
                match bits {
                    0 => SrlR::_0,
                    1 => SrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SrlR::_1
            }
        }
        # [ doc = "Possible values of the field `LRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LrlR {
            # [ doc = "Lock Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Lock Register is not locked and writes complete as normal." ]
            _1,
        }
        impl LrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LrlR::_0 => 0,
                    LrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LrlR {
                match bits {
                    0 => LrlR::_0,
                    1 => LrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LrlR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TCL`" ]
        pub enum TclW {
            # [ doc = "Time Compensation Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Time Compensation Register is not locked and writes complete as normal." ]
            _1,
        }
        impl TclW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TclW::_0 => 0,
                    TclW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TclW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TclW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TclW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Time Compensation Register is locked and writes are ignored." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TclW::_0)
            }
            # [ doc = "Time Compensation Register is not locked and writes complete as normal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TclW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CRL`" ]
        pub enum CrlW {
            # [ doc = "Control Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Control Register is not locked and writes complete as normal." ]
            _1,
        }
        impl CrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CrlW::_0 => 0,
                    CrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Control Register is locked and writes are ignored." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CrlW::_0)
            }
            # [ doc = "Control Register is not locked and writes complete as normal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRL`" ]
        pub enum SrlW {
            # [ doc = "Status Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Status Register is not locked and writes complete as normal." ]
            _1,
        }
        impl SrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SrlW::_0 => 0,
                    SrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Status Register is locked and writes are ignored." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SrlW::_0)
            }
            # [ doc = "Status Register is not locked and writes complete as normal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LRL`" ]
        pub enum LrlW {
            # [ doc = "Lock Register is locked and writes are ignored." ]
            _0,
            # [ doc = "Lock Register is not locked and writes complete as normal." ]
            _1,
        }
        impl LrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LrlW::_0 => 0,
                    LrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Lock Register is locked and writes are ignored." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LrlW::_0)
            }
            # [ doc = "Lock Register is not locked and writes complete as normal." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 3 - Time Compensation Lock" ]
            # [ inline ( always ) ]
            pub fn tcl(&self) -> TclR {
                TclR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Control Register Lock" ]
            # [ inline ( always ) ]
            pub fn crl(&self) -> CrlR {
                CrlR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Status Register Lock" ]
            # [ inline ( always ) ]
            pub fn srl(&self) -> SrlR {
                SrlR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 5;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Lock Register Lock" ]
            # [ inline ( always ) ]
            pub fn lrl(&self) -> LrlR {
                LrlR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 255 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 3 - Time Compensation Lock" ]
            # [ inline ( always ) ]
            pub fn tcl(&mut self) -> _TclW {
                _TclW { w: self }
            }
            # [ doc = "Bit 4 - Control Register Lock" ]
            # [ inline ( always ) ]
            pub fn crl(&mut self) -> _CrlW {
                _CrlW { w: self }
            }
            # [ doc = "Bit 5 - Status Register Lock" ]
            # [ inline ( always ) ]
            pub fn srl(&mut self) -> _SrlW {
                _SrlW { w: self }
            }
            # [ doc = "Bit 6 - Lock Register Lock" ]
            # [ inline ( always ) ]
            pub fn lrl(&mut self) -> _LrlW {
                _LrlW { w: self }
            }
        }
    }
    # [ doc = "RTC Interrupt Enable Register" ]
    pub struct Ier {
        register: VolatileCell<u32>,
    }
    # [ doc = "RTC Interrupt Enable Register" ]
    pub mod ier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TiieR {
            # [ doc = "Time invalid flag does not generate an interrupt." ]
            _0,
            # [ doc = "Time invalid flag does generate an interrupt." ]
            _1,
        }
        impl TiieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TiieR::_0 => 0,
                    TiieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TiieR {
                match bits {
                    0 => TiieR::_0,
                    1 => TiieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TiieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TiieR::_1
            }
        }
        # [ doc = "Possible values of the field `TOIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ToieR {
            # [ doc = "Time overflow flag does not generate an interrupt." ]
            _0,
            # [ doc = "Time overflow flag does generate an interrupt." ]
            _1,
        }
        impl ToieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ToieR::_0 => 0,
                    ToieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ToieR {
                match bits {
                    0 => ToieR::_0,
                    1 => ToieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ToieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ToieR::_1
            }
        }
        # [ doc = "Possible values of the field `TAIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TaieR {
            # [ doc = "Time alarm flag does not generate an interrupt." ]
            _0,
            # [ doc = "Time alarm flag does generate an interrupt." ]
            _1,
        }
        impl TaieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TaieR::_0 => 0,
                    TaieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TaieR {
                match bits {
                    0 => TaieR::_0,
                    1 => TaieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TaieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TaieR::_1
            }
        }
        # [ doc = "Possible values of the field `TSIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsieR {
            # [ doc = "Seconds interrupt is disabled." ]
            _0,
            # [ doc = "Seconds interrupt is enabled." ]
            _1,
        }
        impl TsieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsieR::_0 => 0,
                    TsieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsieR {
                match bits {
                    0 => TsieR::_0,
                    1 => TsieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TsieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TsieR::_1
            }
        }
        # [ doc = "Possible values of the field `TSIC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TsicR {
            # [ doc = "1 Hz." ]
            _000,
            # [ doc = "2 Hz." ]
            _001,
            # [ doc = "4 Hz." ]
            _010,
            # [ doc = "8 Hz." ]
            _011,
            # [ doc = "16 Hz." ]
            _100,
            # [ doc = "32 Hz." ]
            _101,
            # [ doc = "64 Hz." ]
            _110,
            # [ doc = "128 Hz." ]
            _111,
        }
        impl TsicR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TsicR::_000 => 0,
                    TsicR::_001 => 1,
                    TsicR::_010 => 2,
                    TsicR::_011 => 3,
                    TsicR::_100 => 4,
                    TsicR::_101 => 5,
                    TsicR::_110 => 6,
                    TsicR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TsicR {
                match bits {
                    0 => TsicR::_000,
                    1 => TsicR::_001,
                    2 => TsicR::_010,
                    3 => TsicR::_011,
                    4 => TsicR::_100,
                    5 => TsicR::_101,
                    6 => TsicR::_110,
                    7 => TsicR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == TsicR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == TsicR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == TsicR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == TsicR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TsicR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TsicR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TsicR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TsicR::_111
            }
        }
        # [ doc = "Values that can be written to the field `TIIE`" ]
        pub enum TiieW {
            # [ doc = "Time invalid flag does not generate an interrupt." ]
            _0,
            # [ doc = "Time invalid flag does generate an interrupt." ]
            _1,
        }
        impl TiieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TiieW::_0 => 0,
                    TiieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TiieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TiieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TiieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Time invalid flag does not generate an interrupt." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TiieW::_0)
            }
            # [ doc = "Time invalid flag does generate an interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TiieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TOIE`" ]
        pub enum ToieW {
            # [ doc = "Time overflow flag does not generate an interrupt." ]
            _0,
            # [ doc = "Time overflow flag does generate an interrupt." ]
            _1,
        }
        impl ToieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ToieW::_0 => 0,
                    ToieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ToieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ToieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ToieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Time overflow flag does not generate an interrupt." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ToieW::_0)
            }
            # [ doc = "Time overflow flag does generate an interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ToieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TAIE`" ]
        pub enum TaieW {
            # [ doc = "Time alarm flag does not generate an interrupt." ]
            _0,
            # [ doc = "Time alarm flag does generate an interrupt." ]
            _1,
        }
        impl TaieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TaieW::_0 => 0,
                    TaieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TaieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TaieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TaieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Time alarm flag does not generate an interrupt." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TaieW::_0)
            }
            # [ doc = "Time alarm flag does generate an interrupt." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TaieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSIE`" ]
        pub enum TsieW {
            # [ doc = "Seconds interrupt is disabled." ]
            _0,
            # [ doc = "Seconds interrupt is enabled." ]
            _1,
        }
        impl TsieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsieW::_0 => 0,
                    TsieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Seconds interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TsieW::_0)
            }
            # [ doc = "Seconds interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TsieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSIC`" ]
        pub enum TsicW {
            # [ doc = "1 Hz." ]
            _000,
            # [ doc = "2 Hz." ]
            _001,
            # [ doc = "4 Hz." ]
            _010,
            # [ doc = "8 Hz." ]
            _011,
            # [ doc = "16 Hz." ]
            _100,
            # [ doc = "32 Hz." ]
            _101,
            # [ doc = "64 Hz." ]
            _110,
            # [ doc = "128 Hz." ]
            _111,
        }
        impl TsicW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TsicW::_000 => 0,
                    TsicW::_001 => 1,
                    TsicW::_010 => 2,
                    TsicW::_011 => 3,
                    TsicW::_100 => 4,
                    TsicW::_101 => 5,
                    TsicW::_110 => 6,
                    TsicW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsicW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsicW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TsicW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1 Hz." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(TsicW::_000)
            }
            # [ doc = "2 Hz." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(TsicW::_001)
            }
            # [ doc = "4 Hz." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(TsicW::_010)
            }
            # [ doc = "8 Hz." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(TsicW::_011)
            }
            # [ doc = "16 Hz." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TsicW::_100)
            }
            # [ doc = "32 Hz." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TsicW::_101)
            }
            # [ doc = "64 Hz." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TsicW::_110)
            }
            # [ doc = "128 Hz." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TsicW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Time Invalid Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tiie(&self) -> TiieR {
                TiieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Time Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&self) -> ToieR {
                ToieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Time Alarm Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn taie(&self) -> TaieR {
                TaieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - Time Seconds Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tsie(&self) -> TsieR {
                TsieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 4;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 16:18 - Timer Seconds Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn tsic(&self) -> TsicR {
                TsicR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 7 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Time Invalid Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tiie(&mut self) -> _TiieW {
                _TiieW { w: self }
            }
            # [ doc = "Bit 1 - Time Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn toie(&mut self) -> _ToieW {
                _ToieW { w: self }
            }
            # [ doc = "Bit 2 - Time Alarm Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn taie(&mut self) -> _TaieW {
                _TaieW { w: self }
            }
            # [ doc = "Bit 4 - Time Seconds Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tsie(&mut self) -> _TsieW {
                _TsieW { w: self }
            }
            # [ doc = "Bits 16:18 - Timer Seconds Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn tsic(&mut self) -> _TsicW {
                _TsicW { w: self }
            }
        }
    }
}
# [ doc = "Secure Real Time Clock" ]
pub struct Rtc {
    register_block: rtc::RegisterBlock,
}
impl Deref for Rtc {
    type Target = rtc::RegisterBlock;
    fn deref(&self) -> &rtc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Low Power Timer" ]
pub const LPTMR0: Peripheral<Lptmr0> = unsafe { Peripheral::new(1074003968) };
# [ doc = "Low Power Timer" ]
pub mod lptmr0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Low Power Timer Control Status Register" ]
        pub csr: Csr,
        # [ doc = "0x04 - Low Power Timer Prescale Register" ]
        pub psr: Psr,
        # [ doc = "0x08 - Low Power Timer Compare Register" ]
        pub cmr: Cmr,
        # [ doc = "0x0c - Low Power Timer Counter Register" ]
        pub cnr: Cnr,
    }
    # [ doc = "Low Power Timer Control Status Register" ]
    pub struct Csr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Low Power Timer Control Status Register" ]
    pub mod csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Csr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TenR {
            # [ doc = "LPTMR is disabled and internal logic is reset." ]
            _0,
            # [ doc = "LPTMR is enabled." ]
            _1,
        }
        impl TenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TenR::_0 => 0,
                    TenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TenR {
                match bits {
                    0 => TenR::_0,
                    1 => TenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TenR::_1
            }
        }
        # [ doc = "Possible values of the field `TMS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TmsR {
            # [ doc = "Time Counter mode." ]
            _0,
            # [ doc = "Pulse Counter mode." ]
            _1,
        }
        impl TmsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TmsR::_0 => 0,
                    TmsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TmsR {
                match bits {
                    0 => TmsR::_0,
                    1 => TmsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TmsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TmsR::_1
            }
        }
        # [ doc = "Possible values of the field `TFC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TfcR {
            # [ doc = "CNR is reset whenever TCF is set." ]
            _0,
            # [ doc = "CNR is reset on overflow." ]
            _1,
        }
        impl TfcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TfcR::_0 => 0,
                    TfcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TfcR {
                match bits {
                    0 => TfcR::_0,
                    1 => TfcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TfcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TfcR::_1
            }
        }
        # [ doc = "Possible values of the field `TPP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TppR {
            # [ doc = "Pulse Counter input source is active-high, and the CNR will increment on the rising-edge." ]
            _0,
            # [ doc = "Pulse Counter input source is active-low, and the CNR will increment on the falling-edge." ]
            _1,
        }
        impl TppR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TppR::_0 => 0,
                    TppR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TppR {
                match bits {
                    0 => TppR::_0,
                    1 => TppR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TppR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TppR::_1
            }
        }
        # [ doc = "Possible values of the field `TPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TpsR {
            # [ doc = "Pulse counter input 0 is selected." ]
            _00,
            # [ doc = "Pulse counter input 1 is selected." ]
            _01,
            # [ doc = "Pulse counter input 2 is selected." ]
            _10,
            # [ doc = "Pulse counter input 3 is selected." ]
            _11,
        }
        impl TpsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TpsR::_00 => 0,
                    TpsR::_01 => 1,
                    TpsR::_10 => 2,
                    TpsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TpsR {
                match bits {
                    0 => TpsR::_00,
                    1 => TpsR::_01,
                    2 => TpsR::_10,
                    3 => TpsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TpsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TpsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TpsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TpsR::_11
            }
        }
        # [ doc = "Possible values of the field `TIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TieR {
            # [ doc = "Timer interrupt disabled." ]
            _0,
            # [ doc = "Timer interrupt enabled." ]
            _1,
        }
        impl TieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TieR::_0 => 0,
                    TieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TieR {
                match bits {
                    0 => TieR::_0,
                    1 => TieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcfR {
            # [ doc = "The value of CNR is not equal to CMR and increments." ]
            _0,
            # [ doc = "The value of CNR is equal to CMR and increments." ]
            _1,
        }
        impl TcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcfR::_0 => 0,
                    TcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcfR {
                match bits {
                    0 => TcfR::_0,
                    1 => TcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcfR::_1
            }
        }
        # [ doc = "Possible values of the field `TDRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdreR {
            # [ doc = "Timer DMA Request disabled." ]
            _0,
            # [ doc = "Timer DMA Request enabled." ]
            _1,
        }
        impl TdreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdreR::_0 => 0,
                    TdreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdreR {
                match bits {
                    0 => TdreR::_0,
                    1 => TdreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdreR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TEN`" ]
        pub enum TenW {
            # [ doc = "LPTMR is disabled and internal logic is reset." ]
            _0,
            # [ doc = "LPTMR is enabled." ]
            _1,
        }
        impl TenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TenW::_0 => 0,
                    TenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LPTMR is disabled and internal logic is reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TenW::_0)
            }
            # [ doc = "LPTMR is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TMS`" ]
        pub enum TmsW {
            # [ doc = "Time Counter mode." ]
            _0,
            # [ doc = "Pulse Counter mode." ]
            _1,
        }
        impl TmsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TmsW::_0 => 0,
                    TmsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TmsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TmsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TmsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Time Counter mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TmsW::_0)
            }
            # [ doc = "Pulse Counter mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TmsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TFC`" ]
        pub enum TfcW {
            # [ doc = "CNR is reset whenever TCF is set." ]
            _0,
            # [ doc = "CNR is reset on overflow." ]
            _1,
        }
        impl TfcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TfcW::_0 => 0,
                    TfcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TfcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TfcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TfcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CNR is reset whenever TCF is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TfcW::_0)
            }
            # [ doc = "CNR is reset on overflow." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TfcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TPP`" ]
        pub enum TppW {
            # [ doc = "Pulse Counter input source is active-high, and the CNR will increment on the rising-edge." ]
            _0,
            # [ doc = "Pulse Counter input source is active-low, and the CNR will increment on the falling-edge." ]
            _1,
        }
        impl TppW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TppW::_0 => 0,
                    TppW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TppW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TppW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TppW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pulse Counter input source is active-high, and the CNR will increment on the rising-edge." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TppW::_0)
            }
            # [ doc = "Pulse Counter input source is active-low, and the CNR will increment on the falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TppW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TPS`" ]
        pub enum TpsW {
            # [ doc = "Pulse counter input 0 is selected." ]
            _00,
            # [ doc = "Pulse counter input 1 is selected." ]
            _01,
            # [ doc = "Pulse counter input 2 is selected." ]
            _10,
            # [ doc = "Pulse counter input 3 is selected." ]
            _11,
        }
        impl TpsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TpsW::_00 => 0,
                    TpsW::_01 => 1,
                    TpsW::_10 => 2,
                    TpsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TpsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TpsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TpsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pulse counter input 0 is selected." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TpsW::_00)
            }
            # [ doc = "Pulse counter input 1 is selected." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TpsW::_01)
            }
            # [ doc = "Pulse counter input 2 is selected." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TpsW::_10)
            }
            # [ doc = "Pulse counter input 3 is selected." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TpsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE`" ]
        pub enum TieW {
            # [ doc = "Timer interrupt disabled." ]
            _0,
            # [ doc = "Timer interrupt enabled." ]
            _1,
        }
        impl TieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TieW::_0 => 0,
                    TieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TieW::_0)
            }
            # [ doc = "Timer interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCF`" ]
        pub enum TcfW {
            # [ doc = "The value of CNR is not equal to CMR and increments." ]
            _0,
            # [ doc = "The value of CNR is equal to CMR and increments." ]
            _1,
        }
        impl TcfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcfW::_0 => 0,
                    TcfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The value of CNR is not equal to CMR and increments." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcfW::_0)
            }
            # [ doc = "The value of CNR is equal to CMR and increments." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDRE`" ]
        pub enum TdreW {
            # [ doc = "Timer DMA Request disabled." ]
            _0,
            # [ doc = "Timer DMA Request enabled." ]
            _1,
        }
        impl TdreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdreW::_0 => 0,
                    TdreW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer DMA Request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdreW::_0)
            }
            # [ doc = "Timer DMA Request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdreW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn ten(&self) -> TenR {
                TenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Timer Mode Select" ]
            # [ inline ( always ) ]
            pub fn tms(&self) -> TmsR {
                TmsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Timer Free-Running Counter" ]
            # [ inline ( always ) ]
            pub fn tfc(&self) -> TfcR {
                TfcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn tpp(&self) -> TppR {
                TppR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 4:5 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn tps(&self) -> TpsR {
                TpsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 6 - Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&self) -> TieR {
                TieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Timer Compare Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&self) -> TcfR {
                TcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Timer DMA Request Enable" ]
            # [ inline ( always ) ]
            pub fn tdre(&self) -> TdreR {
                TdreR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn ten(&mut self) -> _TenW {
                _TenW { w: self }
            }
            # [ doc = "Bit 1 - Timer Mode Select" ]
            # [ inline ( always ) ]
            pub fn tms(&mut self) -> _TmsW {
                _TmsW { w: self }
            }
            # [ doc = "Bit 2 - Timer Free-Running Counter" ]
            # [ inline ( always ) ]
            pub fn tfc(&mut self) -> _TfcW {
                _TfcW { w: self }
            }
            # [ doc = "Bit 3 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn tpp(&mut self) -> _TppW {
                _TppW { w: self }
            }
            # [ doc = "Bits 4:5 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn tps(&mut self) -> _TpsW {
                _TpsW { w: self }
            }
            # [ doc = "Bit 6 - Timer Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&mut self) -> _TieW {
                _TieW { w: self }
            }
            # [ doc = "Bit 7 - Timer Compare Flag" ]
            # [ inline ( always ) ]
            pub fn tcf(&mut self) -> _TcfW {
                _TcfW { w: self }
            }
            # [ doc = "Bit 8 - Timer DMA Request Enable" ]
            # [ inline ( always ) ]
            pub fn tdre(&mut self) -> _TdreW {
                _TdreW { w: self }
            }
        }
    }
    # [ doc = "Low Power Timer Prescale Register" ]
    pub struct Psr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Low Power Timer Prescale Register" ]
    pub mod psr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Psr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Prescaler/glitch filter clock 0 selected." ]
            _00,
            # [ doc = "Prescaler/glitch filter clock 1 selected." ]
            _01,
            # [ doc = "Prescaler/glitch filter clock 2 selected." ]
            _10,
            # [ doc = "Prescaler/glitch filter clock 3 selected." ]
            _11,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_00 => 0,
                    PcsR::_01 => 1,
                    PcsR::_10 => 2,
                    PcsR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_00,
                    1 => PcsR::_01,
                    2 => PcsR::_10,
                    3 => PcsR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PcsR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PcsR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PcsR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PcsR::_11
            }
        }
        # [ doc = "Possible values of the field `PBYP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PbypR {
            # [ doc = "Prescaler/glitch filter is enabled." ]
            _0,
            # [ doc = "Prescaler/glitch filter is bypassed." ]
            _1,
        }
        impl PbypR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PbypR::_0 => 0,
                    PbypR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PbypR {
                match bits {
                    0 => PbypR::_0,
                    1 => PbypR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PbypR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PbypR::_1
            }
        }
        # [ doc = "Possible values of the field `PRESCALE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescaleR {
            # [ doc = "Prescaler divides the prescaler clock by 2; glitch filter does not support this configuration." ]
            _0000,
            # [ doc = "Prescaler divides the prescaler clock by 4; glitch filter recognizes change on input pin after 2 rising clock edges." ]
            _0001,
            # [ doc = "Prescaler divides the prescaler clock by 8; glitch filter recognizes change on input pin after 4 rising clock edges." ]
            _0010,
            # [ doc = "Prescaler divides the prescaler clock by 16; glitch filter recognizes change on input pin after 8 rising clock edges." ]
            _0011,
            # [ doc = "Prescaler divides the prescaler clock by 32; glitch filter recognizes change on input pin after 16 rising clock edges." ]
            _0100,
            # [ doc = "Prescaler divides the prescaler clock by 64; glitch filter recognizes change on input pin after 32 rising clock edges." ]
            _0101,
            # [ doc = "Prescaler divides the prescaler clock by 128; glitch filter recognizes change on input pin after 64 rising clock edges." ]
            _0110,
            # [ doc = "Prescaler divides the prescaler clock by 256; glitch filter recognizes change on input pin after 128 rising clock edges." ]
            _0111,
            # [ doc = "Prescaler divides the prescaler clock by 512; glitch filter recognizes change on input pin after 256 rising clock edges." ]
            _1000,
            # [ doc = "Prescaler divides the prescaler clock by 1024; glitch filter recognizes change on input pin after 512 rising clock edges." ]
            _1001,
            # [ doc = "Prescaler divides the prescaler clock by 2048; glitch filter recognizes change on input pin after 1024 rising clock edges." ]
            _1010,
            # [ doc = "Prescaler divides the prescaler clock by 4096; glitch filter recognizes change on input pin after 2048 rising clock edges." ]
            _1011,
            # [ doc = "Prescaler divides the prescaler clock by 8192; glitch filter recognizes change on input pin after 4096 rising clock edges." ]
            _1100,
            # [ doc = "Prescaler divides the prescaler clock by 16,384; glitch filter recognizes change on input pin after 8192 rising clock edges." ]
            _1101,
            # [ doc = "Prescaler divides the prescaler clock by 32,768; glitch filter recognizes change on input pin after 16,384 rising clock edges." ]
            _1110,
            # [ doc = "Prescaler divides the prescaler clock by 65,536; glitch filter recognizes change on input pin after 32,768 rising clock edges." ]
            _1111,
        }
        impl PrescaleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescaleR::_0000 => 0,
                    PrescaleR::_0001 => 1,
                    PrescaleR::_0010 => 2,
                    PrescaleR::_0011 => 3,
                    PrescaleR::_0100 => 4,
                    PrescaleR::_0101 => 5,
                    PrescaleR::_0110 => 6,
                    PrescaleR::_0111 => 7,
                    PrescaleR::_1000 => 8,
                    PrescaleR::_1001 => 9,
                    PrescaleR::_1010 => 10,
                    PrescaleR::_1011 => 11,
                    PrescaleR::_1100 => 12,
                    PrescaleR::_1101 => 13,
                    PrescaleR::_1110 => 14,
                    PrescaleR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescaleR {
                match bits {
                    0 => PrescaleR::_0000,
                    1 => PrescaleR::_0001,
                    2 => PrescaleR::_0010,
                    3 => PrescaleR::_0011,
                    4 => PrescaleR::_0100,
                    5 => PrescaleR::_0101,
                    6 => PrescaleR::_0110,
                    7 => PrescaleR::_0111,
                    8 => PrescaleR::_1000,
                    9 => PrescaleR::_1001,
                    10 => PrescaleR::_1010,
                    11 => PrescaleR::_1011,
                    12 => PrescaleR::_1100,
                    13 => PrescaleR::_1101,
                    14 => PrescaleR::_1110,
                    15 => PrescaleR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == PrescaleR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == PrescaleR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == PrescaleR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == PrescaleR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == PrescaleR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == PrescaleR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == PrescaleR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == PrescaleR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == PrescaleR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == PrescaleR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == PrescaleR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == PrescaleR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == PrescaleR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == PrescaleR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == PrescaleR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == PrescaleR::_1111
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Prescaler/glitch filter clock 0 selected." ]
            _00,
            # [ doc = "Prescaler/glitch filter clock 1 selected." ]
            _01,
            # [ doc = "Prescaler/glitch filter clock 2 selected." ]
            _10,
            # [ doc = "Prescaler/glitch filter clock 3 selected." ]
            _11,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_00 => 0,
                    PcsW::_01 => 1,
                    PcsW::_10 => 2,
                    PcsW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Prescaler/glitch filter clock 0 selected." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(PcsW::_00)
            }
            # [ doc = "Prescaler/glitch filter clock 1 selected." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(PcsW::_01)
            }
            # [ doc = "Prescaler/glitch filter clock 2 selected." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PcsW::_10)
            }
            # [ doc = "Prescaler/glitch filter clock 3 selected." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PcsW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PBYP`" ]
        pub enum PbypW {
            # [ doc = "Prescaler/glitch filter is enabled." ]
            _0,
            # [ doc = "Prescaler/glitch filter is bypassed." ]
            _1,
        }
        impl PbypW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PbypW::_0 => 0,
                    PbypW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PbypW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PbypW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PbypW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Prescaler/glitch filter is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PbypW::_0)
            }
            # [ doc = "Prescaler/glitch filter is bypassed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PbypW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALE`" ]
        pub enum PrescaleW {
            # [ doc = "Prescaler divides the prescaler clock by 2; glitch filter does not support this configuration." ]
            _0000,
            # [ doc = "Prescaler divides the prescaler clock by 4; glitch filter recognizes change on input pin after 2 rising clock edges." ]
            _0001,
            # [ doc = "Prescaler divides the prescaler clock by 8; glitch filter recognizes change on input pin after 4 rising clock edges." ]
            _0010,
            # [ doc = "Prescaler divides the prescaler clock by 16; glitch filter recognizes change on input pin after 8 rising clock edges." ]
            _0011,
            # [ doc = "Prescaler divides the prescaler clock by 32; glitch filter recognizes change on input pin after 16 rising clock edges." ]
            _0100,
            # [ doc = "Prescaler divides the prescaler clock by 64; glitch filter recognizes change on input pin after 32 rising clock edges." ]
            _0101,
            # [ doc = "Prescaler divides the prescaler clock by 128; glitch filter recognizes change on input pin after 64 rising clock edges." ]
            _0110,
            # [ doc = "Prescaler divides the prescaler clock by 256; glitch filter recognizes change on input pin after 128 rising clock edges." ]
            _0111,
            # [ doc = "Prescaler divides the prescaler clock by 512; glitch filter recognizes change on input pin after 256 rising clock edges." ]
            _1000,
            # [ doc = "Prescaler divides the prescaler clock by 1024; glitch filter recognizes change on input pin after 512 rising clock edges." ]
            _1001,
            # [ doc = "Prescaler divides the prescaler clock by 2048; glitch filter recognizes change on input pin after 1024 rising clock edges." ]
            _1010,
            # [ doc = "Prescaler divides the prescaler clock by 4096; glitch filter recognizes change on input pin after 2048 rising clock edges." ]
            _1011,
            # [ doc = "Prescaler divides the prescaler clock by 8192; glitch filter recognizes change on input pin after 4096 rising clock edges." ]
            _1100,
            # [ doc = "Prescaler divides the prescaler clock by 16,384; glitch filter recognizes change on input pin after 8192 rising clock edges." ]
            _1101,
            # [ doc = "Prescaler divides the prescaler clock by 32,768; glitch filter recognizes change on input pin after 16,384 rising clock edges." ]
            _1110,
            # [ doc = "Prescaler divides the prescaler clock by 65,536; glitch filter recognizes change on input pin after 32,768 rising clock edges." ]
            _1111,
        }
        impl PrescaleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescaleW::_0000 => 0,
                    PrescaleW::_0001 => 1,
                    PrescaleW::_0010 => 2,
                    PrescaleW::_0011 => 3,
                    PrescaleW::_0100 => 4,
                    PrescaleW::_0101 => 5,
                    PrescaleW::_0110 => 6,
                    PrescaleW::_0111 => 7,
                    PrescaleW::_1000 => 8,
                    PrescaleW::_1001 => 9,
                    PrescaleW::_1010 => 10,
                    PrescaleW::_1011 => 11,
                    PrescaleW::_1100 => 12,
                    PrescaleW::_1101 => 13,
                    PrescaleW::_1110 => 14,
                    PrescaleW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescaleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescaleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescaleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Prescaler divides the prescaler clock by 2; glitch filter does not support this configuration." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(PrescaleW::_0000)
            }
            # [ doc = "Prescaler divides the prescaler clock by 4; glitch filter recognizes change on input pin after 2 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(PrescaleW::_0001)
            }
            # [ doc = "Prescaler divides the prescaler clock by 8; glitch filter recognizes change on input pin after 4 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(PrescaleW::_0010)
            }
            # [ doc = "Prescaler divides the prescaler clock by 16; glitch filter recognizes change on input pin after 8 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(PrescaleW::_0011)
            }
            # [ doc = "Prescaler divides the prescaler clock by 32; glitch filter recognizes change on input pin after 16 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(PrescaleW::_0100)
            }
            # [ doc = "Prescaler divides the prescaler clock by 64; glitch filter recognizes change on input pin after 32 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(PrescaleW::_0101)
            }
            # [ doc = "Prescaler divides the prescaler clock by 128; glitch filter recognizes change on input pin after 64 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(PrescaleW::_0110)
            }
            # [ doc = "Prescaler divides the prescaler clock by 256; glitch filter recognizes change on input pin after 128 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(PrescaleW::_0111)
            }
            # [ doc = "Prescaler divides the prescaler clock by 512; glitch filter recognizes change on input pin after 256 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(PrescaleW::_1000)
            }
            # [ doc = "Prescaler divides the prescaler clock by 1024; glitch filter recognizes change on input pin after 512 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(PrescaleW::_1001)
            }
            # [ doc = "Prescaler divides the prescaler clock by 2048; glitch filter recognizes change on input pin after 1024 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(PrescaleW::_1010)
            }
            # [ doc = "Prescaler divides the prescaler clock by 4096; glitch filter recognizes change on input pin after 2048 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(PrescaleW::_1011)
            }
            # [ doc = "Prescaler divides the prescaler clock by 8192; glitch filter recognizes change on input pin after 4096 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(PrescaleW::_1100)
            }
            # [ doc = "Prescaler divides the prescaler clock by 16,384; glitch filter recognizes change on input pin after 8192 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(PrescaleW::_1101)
            }
            # [ doc = "Prescaler divides the prescaler clock by 32,768; glitch filter recognizes change on input pin after 16,384 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(PrescaleW::_1110)
            }
            # [ doc = "Prescaler divides the prescaler clock by 65,536; glitch filter recognizes change on input pin after 32,768 rising clock edges." ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(PrescaleW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Prescaler Clock Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Prescaler Bypass" ]
            # [ inline ( always ) ]
            pub fn pbyp(&self) -> PbypR {
                PbypR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 3:6 - Prescale Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&self) -> PrescaleR {
                PrescaleR::_from({
                                     const MASK: u8 = 15;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Prescaler Clock Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 2 - Prescaler Bypass" ]
            # [ inline ( always ) ]
            pub fn pbyp(&mut self) -> _PbypW {
                _PbypW { w: self }
            }
            # [ doc = "Bits 3:6 - Prescale Value" ]
            # [ inline ( always ) ]
            pub fn prescale(&mut self) -> _PrescaleW {
                _PrescaleW { w: self }
            }
        }
    }
    # [ doc = "Low Power Timer Compare Register" ]
    pub struct Cmr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Low Power Timer Compare Register" ]
    pub mod cmr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cmr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CompareR {
            bits: u16,
        }
        impl CompareR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CompareW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CompareW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Compare Value" ]
            # [ inline ( always ) ]
            pub fn compare(&self) -> CompareR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CompareR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Compare Value" ]
            # [ inline ( always ) ]
            pub fn compare(&mut self) -> _CompareW {
                _CompareW { w: self }
            }
        }
    }
    # [ doc = "Low Power Timer Counter Register" ]
    pub struct Cnr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Low Power Timer Counter Register" ]
    pub mod cnr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cnr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CounterR {
            bits: u16,
        }
        impl CounterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CounterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CounterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn counter(&self) -> CounterR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CounterR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Counter Value" ]
            # [ inline ( always ) ]
            pub fn counter(&mut self) -> _CounterW {
                _CounterW { w: self }
            }
        }
    }
}
# [ doc = "Low Power Timer" ]
pub struct Lptmr0 {
    register_block: lptmr0::RegisterBlock,
}
impl Deref for Lptmr0 {
    type Target = lptmr0::RegisterBlock;
    fn deref(&self) -> &lptmr0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "System Integration Module" ]
pub const SIM: Peripheral<Sim> = unsafe { Peripheral::new(1074036736) };
# [ doc = "System Integration Module" ]
pub mod sim {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        _reserved0: [u8; 4usize],
        # [ doc = "0x04 - Chip Control register" ]
        pub chipctl: Chipctl,
        _reserved1: [u8; 4usize],
        # [ doc = "0x0c - FTM Option Register 0" ]
        pub ftmopt0: Ftmopt0,
        # [ doc = "0x10 - LPO Clock Select Register" ]
        pub lpoclks: Lpoclks,
        _reserved2: [u8; 4usize],
        # [ doc = "0x18 - ADC Options Register" ]
        pub adcopt: Adcopt,
        # [ doc = "0x1c - FTM Option Register 1" ]
        pub ftmopt1: Ftmopt1,
        # [ doc = "0x20 - Miscellaneous control register 0" ]
        pub misctrl0: Misctrl0,
        # [ doc = "0x24 - System Device Identification Register" ]
        pub sdid: Sdid,
        _reserved3: [u8; 24usize],
        # [ doc = "0x40 - Platform Clock Gating Control Register" ]
        pub platcgc: Platcgc,
        _reserved4: [u8; 8usize],
        # [ doc = "0x4c - Flash Configuration Register 1" ]
        pub fcfg1: Fcfg1,
        _reserved5: [u8; 4usize],
        # [ doc = "0x54 - Unique Identification Register High" ]
        pub uidh: Uidh,
        # [ doc = "0x58 - Unique Identification Register Mid-High" ]
        pub uidmh: Uidmh,
        # [ doc = "0x5c - Unique Identification Register Mid Low" ]
        pub uidml: Uidml,
        # [ doc = "0x60 - Unique Identification Register Low" ]
        pub uidl: Uidl,
        _reserved6: [u8; 4usize],
        # [ doc = "0x68 - System Clock Divider Register 4" ]
        pub clkdiv4: Clkdiv4,
        # [ doc = "0x6c - Miscellaneous Control register 1" ]
        pub misctrl1: Misctrl1,
    }
    # [ doc = "Chip Control register" ]
    pub struct Chipctl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Chip Control register" ]
    pub mod chipctl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Chipctl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADC_INTERLEAVE_EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdcInterleaveEnR {
            # [ doc = "Interleaving disabled. No channel pair interleaved. Interleaved channels are individually connected to pins. PTC0 is connected to ADC0_SE8. PTC1 is connected to ADC0_SE9. PTB15 is connected to ADC1_SE14. PTB16 is connected to ADC1_SE15. PTB0 is connected to ADC0_SE4. PTB1 is connected to ADC0_SE5. PTB13 is connected to ADC1_SE8. PTB14 is connected to ADC1_SE9." ]
            _0000,
            # [ doc = "PTB14 to ADC1_SE9 and ADC0_SE9" ]
            _1xxx,
            # [ doc = "PTB13 to ADC1_SE8 and ADC0_SE8" ]
            X1xx,
            # [ doc = "PTB1 to ADC0_SE5 and ADC1_SE15" ]
            Xx1x,
            # [ doc = "PTB0 to ADC0_SE4 and ADC1_SE14" ]
            Xxx1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl AdcInterleaveEnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdcInterleaveEnR::_0000 => 0,
                    AdcInterleaveEnR::_1xxx => 8,
                    AdcInterleaveEnR::X1xx => 4,
                    AdcInterleaveEnR::Xx1x => 2,
                    AdcInterleaveEnR::Xxx1 => 1,
                    AdcInterleaveEnR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdcInterleaveEnR {
                match bits {
                    0 => AdcInterleaveEnR::_0000,
                    8 => AdcInterleaveEnR::_1xxx,
                    4 => AdcInterleaveEnR::X1xx,
                    2 => AdcInterleaveEnR::Xx1x,
                    1 => AdcInterleaveEnR::Xxx1,
                    i => AdcInterleaveEnR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == AdcInterleaveEnR::_0000
            }
            # [ doc = "Checks if the value of the field is `_1xxx`" ]
            # [ inline ( always ) ]
            pub fn is_1xxx(&self) -> bool {
                *self == AdcInterleaveEnR::_1xxx
            }
            # [ doc = "Checks if the value of the field is `X1xx`" ]
            # [ inline ( always ) ]
            pub fn is_x1xx(&self) -> bool {
                *self == AdcInterleaveEnR::X1xx
            }
            # [ doc = "Checks if the value of the field is `Xx1x`" ]
            # [ inline ( always ) ]
            pub fn is_xx1x(&self) -> bool {
                *self == AdcInterleaveEnR::Xx1x
            }
            # [ doc = "Checks if the value of the field is `Xxx1`" ]
            # [ inline ( always ) ]
            pub fn is_xxx1(&self) -> bool {
                *self == AdcInterleaveEnR::Xxx1
            }
        }
        # [ doc = "Possible values of the field `CLKOUTSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClkoutselR {
            # [ doc = "SCG CLKOUT" ]
            _0000,
            # [ doc = "SOSC DIV2 CLK" ]
            _0010,
            # [ doc = "SIRC DIV2 CLK" ]
            _0100,
            # [ doc = "For S32K148: QSPI SFIF_CLK_HYP: Divide by 2 clock (configured through SCLKCONFIG[5]) for HyperRAM going to sfif clock to QSPI; For others: Reserved" ]
            _0101,
            # [ doc = "FIRC DIV2 CLK" ]
            _0110,
            # [ doc = "HCLK" ]
            _0111,
            # [ doc = "SPLL DIV2 CLK" ]
            _1000,
            # [ doc = "BUS_CLK" ]
            _1001,
            # [ doc = "LPO128K_CLK" ]
            _1010,
            # [ doc = "For S32K148: QSPI IPG_CLK; For others: Reserved" ]
            _1011,
            # [ doc = "LPO_CLK as selected by SIM_LPOCLKS[LPOCLKSEL]" ]
            _1100,
            # [ doc = "For S32K148: QSPI IPG_CLK_SFIF; For others: Reserved" ]
            _1101,
            # [ doc = "RTC_CLK as selected by SIM_LPOCLKS[RTCCLKSEL]" ]
            _1110,
            # [ doc = "For S32K148: QSPI IPG_CLK_2XSFIF; For others: Reserved" ]
            _1111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ClkoutselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClkoutselR::_0000 => 0,
                    ClkoutselR::_0010 => 2,
                    ClkoutselR::_0100 => 4,
                    ClkoutselR::_0101 => 5,
                    ClkoutselR::_0110 => 6,
                    ClkoutselR::_0111 => 7,
                    ClkoutselR::_1000 => 8,
                    ClkoutselR::_1001 => 9,
                    ClkoutselR::_1010 => 10,
                    ClkoutselR::_1011 => 11,
                    ClkoutselR::_1100 => 12,
                    ClkoutselR::_1101 => 13,
                    ClkoutselR::_1110 => 14,
                    ClkoutselR::_1111 => 15,
                    ClkoutselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClkoutselR {
                match bits {
                    0 => ClkoutselR::_0000,
                    2 => ClkoutselR::_0010,
                    4 => ClkoutselR::_0100,
                    5 => ClkoutselR::_0101,
                    6 => ClkoutselR::_0110,
                    7 => ClkoutselR::_0111,
                    8 => ClkoutselR::_1000,
                    9 => ClkoutselR::_1001,
                    10 => ClkoutselR::_1010,
                    11 => ClkoutselR::_1011,
                    12 => ClkoutselR::_1100,
                    13 => ClkoutselR::_1101,
                    14 => ClkoutselR::_1110,
                    15 => ClkoutselR::_1111,
                    i => ClkoutselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == ClkoutselR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == ClkoutselR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == ClkoutselR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == ClkoutselR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == ClkoutselR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == ClkoutselR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == ClkoutselR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == ClkoutselR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == ClkoutselR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == ClkoutselR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == ClkoutselR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == ClkoutselR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == ClkoutselR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == ClkoutselR::_1111
            }
        }
        # [ doc = "Possible values of the field `CLKOUTDIV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClkoutdivR {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 3" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 5" ]
            _100,
            # [ doc = "Divide by 6" ]
            _101,
            # [ doc = "Divide by 7" ]
            _110,
            # [ doc = "Divide by 8" ]
            _111,
        }
        impl ClkoutdivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClkoutdivR::_000 => 0,
                    ClkoutdivR::_001 => 1,
                    ClkoutdivR::_010 => 2,
                    ClkoutdivR::_011 => 3,
                    ClkoutdivR::_100 => 4,
                    ClkoutdivR::_101 => 5,
                    ClkoutdivR::_110 => 6,
                    ClkoutdivR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClkoutdivR {
                match bits {
                    0 => ClkoutdivR::_000,
                    1 => ClkoutdivR::_001,
                    2 => ClkoutdivR::_010,
                    3 => ClkoutdivR::_011,
                    4 => ClkoutdivR::_100,
                    5 => ClkoutdivR::_101,
                    6 => ClkoutdivR::_110,
                    7 => ClkoutdivR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == ClkoutdivR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == ClkoutdivR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == ClkoutdivR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == ClkoutdivR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == ClkoutdivR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == ClkoutdivR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == ClkoutdivR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == ClkoutdivR::_111
            }
        }
        # [ doc = "Possible values of the field `CLKOUTEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClkoutenR {
            # [ doc = "Clockout disable" ]
            _0,
            # [ doc = "Clockout enable" ]
            _1,
        }
        impl ClkoutenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClkoutenR::_0 => 0,
                    ClkoutenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClkoutenR {
                match bits {
                    0 => ClkoutenR::_0,
                    1 => ClkoutenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ClkoutenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ClkoutenR::_1
            }
        }
        # [ doc = "Possible values of the field `TRACECLK_SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TraceclkSelR {
            # [ doc = "Core clock" ]
            _0,
            # [ doc = "Platform clock" ]
            _1,
        }
        impl TraceclkSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TraceclkSelR::_0 => 0,
                    TraceclkSelR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TraceclkSelR {
                match bits {
                    0 => TraceclkSelR::_0,
                    1 => TraceclkSelR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TraceclkSelR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TraceclkSelR::_1
            }
        }
        # [ doc = "Possible values of the field `PDB_BB_SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PdbBbSelR {
            # [ doc = "PDB0 channel 0 back-to-back operation with ADC0 COCO[7:0] and PDB1 channel 0 back-to-back operation with ADC1 COCO[7:0]" ]
            _0,
            # [ doc = "Channel 0 of PDB0 and PDB1 back-to-back operation with COCO[7:0] of ADC0 and ADC1." ]
            _1,
        }
        impl PdbBbSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PdbBbSelR::_0 => 0,
                    PdbBbSelR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PdbBbSelR {
                match bits {
                    0 => PdbBbSelR::_0,
                    1 => PdbBbSelR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PdbBbSelR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PdbBbSelR::_1
            }
        }
        # [ doc = "Possible values of the field `ADC_SUPPLY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdcSupplyR {
            # [ doc = "5 V input VDD supply (VDD)" ]
            _000,
            # [ doc = "5 V input analog supply (VDDA)" ]
            _001,
            # [ doc = "ADC Reference Supply (VREFH)" ]
            _010,
            # [ doc = "3.3 V Oscillator Regulator Output (VDD_3V)" ]
            _011,
            # [ doc = "3.3 V flash regulator output (VDD_flash_3V)" ]
            _100,
            # [ doc = "1.2 V core regulator output (VDD_LV)" ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl AdcSupplyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdcSupplyR::_000 => 0,
                    AdcSupplyR::_001 => 1,
                    AdcSupplyR::_010 => 2,
                    AdcSupplyR::_011 => 3,
                    AdcSupplyR::_100 => 4,
                    AdcSupplyR::_101 => 5,
                    AdcSupplyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdcSupplyR {
                match bits {
                    0 => AdcSupplyR::_000,
                    1 => AdcSupplyR::_001,
                    2 => AdcSupplyR::_010,
                    3 => AdcSupplyR::_011,
                    4 => AdcSupplyR::_100,
                    5 => AdcSupplyR::_101,
                    i => AdcSupplyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == AdcSupplyR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == AdcSupplyR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == AdcSupplyR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == AdcSupplyR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == AdcSupplyR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == AdcSupplyR::_101
            }
        }
        # [ doc = "Possible values of the field `ADC_SUPPLYEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdcSupplyenR {
            # [ doc = "Disable internal supply monitoring" ]
            _0,
            # [ doc = "Enable internal supply monitoring" ]
            _1,
        }
        impl AdcSupplyenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdcSupplyenR::_0 => 0,
                    AdcSupplyenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdcSupplyenR {
                match bits {
                    0 => AdcSupplyenR::_0,
                    1 => AdcSupplyenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdcSupplyenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdcSupplyenR::_1
            }
        }
        # [ doc = "Possible values of the field `SRAMU_RETEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SramuRetenR {
            # [ doc = "SRAMU contents are retained across resets" ]
            _0,
            # [ doc = "No SRAMU retention" ]
            _1,
        }
        impl SramuRetenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SramuRetenR::_0 => 0,
                    SramuRetenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SramuRetenR {
                match bits {
                    0 => SramuRetenR::_0,
                    1 => SramuRetenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SramuRetenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SramuRetenR::_1
            }
        }
        # [ doc = "Possible values of the field `SRAML_RETEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SramlRetenR {
            # [ doc = "SRAML contents are retained across resets" ]
            _0,
            # [ doc = "No SRAML retention" ]
            _1,
        }
        impl SramlRetenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SramlRetenR::_0 => 0,
                    SramlRetenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SramlRetenR {
                match bits {
                    0 => SramlRetenR::_0,
                    1 => SramlRetenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SramlRetenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SramlRetenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ADC_INTERLEAVE_EN`" ]
        pub enum AdcInterleaveEnW {
            # [ doc = "Interleaving disabled. No channel pair interleaved. Interleaved channels are individually connected to pins. PTC0 is connected to ADC0_SE8. PTC1 is connected to ADC0_SE9. PTB15 is connected to ADC1_SE14. PTB16 is connected to ADC1_SE15. PTB0 is connected to ADC0_SE4. PTB1 is connected to ADC0_SE5. PTB13 is connected to ADC1_SE8. PTB14 is connected to ADC1_SE9." ]
            _0000,
            # [ doc = "PTB14 to ADC1_SE9 and ADC0_SE9" ]
            _1xxx,
            # [ doc = "PTB13 to ADC1_SE8 and ADC0_SE8" ]
            X1xx,
            # [ doc = "PTB1 to ADC0_SE5 and ADC1_SE15" ]
            Xx1x,
            # [ doc = "PTB0 to ADC0_SE4 and ADC1_SE14" ]
            Xxx1,
        }
        impl AdcInterleaveEnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdcInterleaveEnW::_0000 => 0,
                    AdcInterleaveEnW::_1xxx => 8,
                    AdcInterleaveEnW::X1xx => 4,
                    AdcInterleaveEnW::Xx1x => 2,
                    AdcInterleaveEnW::Xxx1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdcInterleaveEnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdcInterleaveEnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdcInterleaveEnW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interleaving disabled. No channel pair interleaved. Interleaved channels are individually connected to pins. PTC0 is connected to ADC0_SE8. PTC1 is connected to ADC0_SE9. PTB15 is connected to ADC1_SE14. PTB16 is connected to ADC1_SE15. PTB0 is connected to ADC0_SE4. PTB1 is connected to ADC0_SE5. PTB13 is connected to ADC1_SE8. PTB14 is connected to ADC1_SE9." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(AdcInterleaveEnW::_0000)
            }
            # [ doc = "PTB14 to ADC1_SE9 and ADC0_SE9" ]
            # [ inline ( always ) ]
            pub fn _1xxx(self) -> &'a mut W {
                self.variant(AdcInterleaveEnW::_1xxx)
            }
            # [ doc = "PTB13 to ADC1_SE8 and ADC0_SE8" ]
            # [ inline ( always ) ]
            pub fn x1xx(self) -> &'a mut W {
                self.variant(AdcInterleaveEnW::X1xx)
            }
            # [ doc = "PTB1 to ADC0_SE5 and ADC1_SE15" ]
            # [ inline ( always ) ]
            pub fn xx1x(self) -> &'a mut W {
                self.variant(AdcInterleaveEnW::Xx1x)
            }
            # [ doc = "PTB0 to ADC0_SE4 and ADC1_SE14" ]
            # [ inline ( always ) ]
            pub fn xxx1(self) -> &'a mut W {
                self.variant(AdcInterleaveEnW::Xxx1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKOUTSEL`" ]
        pub enum ClkoutselW {
            # [ doc = "SCG CLKOUT" ]
            _0000,
            # [ doc = "SOSC DIV2 CLK" ]
            _0010,
            # [ doc = "SIRC DIV2 CLK" ]
            _0100,
            # [ doc = "For S32K148: QSPI SFIF_CLK_HYP: Divide by 2 clock (configured through SCLKCONFIG[5]) for HyperRAM going to sfif clock to QSPI; For others: Reserved" ]
            _0101,
            # [ doc = "FIRC DIV2 CLK" ]
            _0110,
            # [ doc = "HCLK" ]
            _0111,
            # [ doc = "SPLL DIV2 CLK" ]
            _1000,
            # [ doc = "BUS_CLK" ]
            _1001,
            # [ doc = "LPO128K_CLK" ]
            _1010,
            # [ doc = "For S32K148: QSPI IPG_CLK; For others: Reserved" ]
            _1011,
            # [ doc = "LPO_CLK as selected by SIM_LPOCLKS[LPOCLKSEL]" ]
            _1100,
            # [ doc = "For S32K148: QSPI IPG_CLK_SFIF; For others: Reserved" ]
            _1101,
            # [ doc = "RTC_CLK as selected by SIM_LPOCLKS[RTCCLKSEL]" ]
            _1110,
            # [ doc = "For S32K148: QSPI IPG_CLK_2XSFIF; For others: Reserved" ]
            _1111,
        }
        impl ClkoutselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClkoutselW::_0000 => 0,
                    ClkoutselW::_0010 => 2,
                    ClkoutselW::_0100 => 4,
                    ClkoutselW::_0101 => 5,
                    ClkoutselW::_0110 => 6,
                    ClkoutselW::_0111 => 7,
                    ClkoutselW::_1000 => 8,
                    ClkoutselW::_1001 => 9,
                    ClkoutselW::_1010 => 10,
                    ClkoutselW::_1011 => 11,
                    ClkoutselW::_1100 => 12,
                    ClkoutselW::_1101 => 13,
                    ClkoutselW::_1110 => 14,
                    ClkoutselW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkoutselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkoutselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClkoutselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "SCG CLKOUT" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(ClkoutselW::_0000)
            }
            # [ doc = "SOSC DIV2 CLK" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(ClkoutselW::_0010)
            }
            # [ doc = "SIRC DIV2 CLK" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(ClkoutselW::_0100)
            }
            # [ doc = "For S32K148: QSPI SFIF_CLK_HYP: Divide by 2 clock (configured through SCLKCONFIG[5]) for HyperRAM going to sfif clock to QSPI; For others: Reserved" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(ClkoutselW::_0101)
            }
            # [ doc = "FIRC DIV2 CLK" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(ClkoutselW::_0110)
            }
            # [ doc = "HCLK" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(ClkoutselW::_0111)
            }
            # [ doc = "SPLL DIV2 CLK" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(ClkoutselW::_1000)
            }
            # [ doc = "BUS_CLK" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(ClkoutselW::_1001)
            }
            # [ doc = "LPO128K_CLK" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(ClkoutselW::_1010)
            }
            # [ doc = "For S32K148: QSPI IPG_CLK; For others: Reserved" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(ClkoutselW::_1011)
            }
            # [ doc = "LPO_CLK as selected by SIM_LPOCLKS[LPOCLKSEL]" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(ClkoutselW::_1100)
            }
            # [ doc = "For S32K148: QSPI IPG_CLK_SFIF; For others: Reserved" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(ClkoutselW::_1101)
            }
            # [ doc = "RTC_CLK as selected by SIM_LPOCLKS[RTCCLKSEL]" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(ClkoutselW::_1110)
            }
            # [ doc = "For S32K148: QSPI IPG_CLK_2XSFIF; For others: Reserved" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(ClkoutselW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKOUTDIV`" ]
        pub enum ClkoutdivW {
            # [ doc = "Divide by 1" ]
            _000,
            # [ doc = "Divide by 2" ]
            _001,
            # [ doc = "Divide by 3" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 5" ]
            _100,
            # [ doc = "Divide by 6" ]
            _101,
            # [ doc = "Divide by 7" ]
            _110,
            # [ doc = "Divide by 8" ]
            _111,
        }
        impl ClkoutdivW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClkoutdivW::_000 => 0,
                    ClkoutdivW::_001 => 1,
                    ClkoutdivW::_010 => 2,
                    ClkoutdivW::_011 => 3,
                    ClkoutdivW::_100 => 4,
                    ClkoutdivW::_101 => 5,
                    ClkoutdivW::_110 => 6,
                    ClkoutdivW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkoutdivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkoutdivW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClkoutdivW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(ClkoutdivW::_000)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(ClkoutdivW::_001)
            }
            # [ doc = "Divide by 3" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(ClkoutdivW::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(ClkoutdivW::_011)
            }
            # [ doc = "Divide by 5" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(ClkoutdivW::_100)
            }
            # [ doc = "Divide by 6" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(ClkoutdivW::_101)
            }
            # [ doc = "Divide by 7" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(ClkoutdivW::_110)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(ClkoutdivW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKOUTEN`" ]
        pub enum ClkoutenW {
            # [ doc = "Clockout disable" ]
            _0,
            # [ doc = "Clockout enable" ]
            _1,
        }
        impl ClkoutenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClkoutenW::_0 => 0,
                    ClkoutenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkoutenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkoutenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClkoutenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clockout disable" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClkoutenW::_0)
            }
            # [ doc = "Clockout enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClkoutenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRACECLK_SEL`" ]
        pub enum TraceclkSelW {
            # [ doc = "Core clock" ]
            _0,
            # [ doc = "Platform clock" ]
            _1,
        }
        impl TraceclkSelW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TraceclkSelW::_0 => 0,
                    TraceclkSelW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TraceclkSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TraceclkSelW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TraceclkSelW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Core clock" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TraceclkSelW::_0)
            }
            # [ doc = "Platform clock" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TraceclkSelW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PDB_BB_SEL`" ]
        pub enum PdbBbSelW {
            # [ doc = "PDB0 channel 0 back-to-back operation with ADC0 COCO[7:0] and PDB1 channel 0 back-to-back operation with ADC1 COCO[7:0]" ]
            _0,
            # [ doc = "Channel 0 of PDB0 and PDB1 back-to-back operation with COCO[7:0] of ADC0 and ADC1." ]
            _1,
        }
        impl PdbBbSelW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PdbBbSelW::_0 => 0,
                    PdbBbSelW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdbBbSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdbBbSelW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PdbBbSelW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB0 channel 0 back-to-back operation with ADC0 COCO[7:0] and PDB1 channel 0 back-to-back operation with ADC1 COCO[7:0]" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PdbBbSelW::_0)
            }
            # [ doc = "Channel 0 of PDB0 and PDB1 back-to-back operation with COCO[7:0] of ADC0 and ADC1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PdbBbSelW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC_SUPPLY`" ]
        pub enum AdcSupplyW {
            # [ doc = "5 V input VDD supply (VDD)" ]
            _000,
            # [ doc = "5 V input analog supply (VDDA)" ]
            _001,
            # [ doc = "ADC Reference Supply (VREFH)" ]
            _010,
            # [ doc = "3.3 V Oscillator Regulator Output (VDD_3V)" ]
            _011,
            # [ doc = "3.3 V flash regulator output (VDD_flash_3V)" ]
            _100,
            # [ doc = "1.2 V core regulator output (VDD_LV)" ]
            _101,
        }
        impl AdcSupplyW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdcSupplyW::_000 => 0,
                    AdcSupplyW::_001 => 1,
                    AdcSupplyW::_010 => 2,
                    AdcSupplyW::_011 => 3,
                    AdcSupplyW::_100 => 4,
                    AdcSupplyW::_101 => 5,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdcSupplyW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdcSupplyW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdcSupplyW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "5 V input VDD supply (VDD)" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(AdcSupplyW::_000)
            }
            # [ doc = "5 V input analog supply (VDDA)" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(AdcSupplyW::_001)
            }
            # [ doc = "ADC Reference Supply (VREFH)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(AdcSupplyW::_010)
            }
            # [ doc = "3.3 V Oscillator Regulator Output (VDD_3V)" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(AdcSupplyW::_011)
            }
            # [ doc = "3.3 V flash regulator output (VDD_flash_3V)" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(AdcSupplyW::_100)
            }
            # [ doc = "1.2 V core regulator output (VDD_LV)" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(AdcSupplyW::_101)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC_SUPPLYEN`" ]
        pub enum AdcSupplyenW {
            # [ doc = "Disable internal supply monitoring" ]
            _0,
            # [ doc = "Enable internal supply monitoring" ]
            _1,
        }
        impl AdcSupplyenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdcSupplyenW::_0 => 0,
                    AdcSupplyenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdcSupplyenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdcSupplyenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdcSupplyenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable internal supply monitoring" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AdcSupplyenW::_0)
            }
            # [ doc = "Enable internal supply monitoring" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AdcSupplyenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRAMU_RETEN`" ]
        pub enum SramuRetenW {
            # [ doc = "SRAMU contents are retained across resets" ]
            _0,
            # [ doc = "No SRAMU retention" ]
            _1,
        }
        impl SramuRetenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SramuRetenW::_0 => 0,
                    SramuRetenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SramuRetenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SramuRetenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SramuRetenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SRAMU contents are retained across resets" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SramuRetenW::_0)
            }
            # [ doc = "No SRAMU retention" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SramuRetenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRAML_RETEN`" ]
        pub enum SramlRetenW {
            # [ doc = "SRAML contents are retained across resets" ]
            _0,
            # [ doc = "No SRAML retention" ]
            _1,
        }
        impl SramlRetenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SramlRetenW::_0 => 0,
                    SramlRetenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SramlRetenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SramlRetenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SramlRetenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SRAML contents are retained across resets" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SramlRetenW::_0)
            }
            # [ doc = "No SRAML retention" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SramlRetenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - ADC interleave channel enable" ]
            # [ inline ( always ) ]
            pub fn adc_interleave_en(&self) -> AdcInterleaveEnR {
                AdcInterleaveEnR::_from({
                                            const MASK: u8 = 15;
                                            const OFFSET: u8 = 0;
                                            ((self.bits >> OFFSET) & MASK as u32) as u8
                                        })
            }
            # [ doc = "Bits 4:7 - CLKOUT Select" ]
            # [ inline ( always ) ]
            pub fn clkoutsel(&self) -> ClkoutselR {
                ClkoutselR::_from({
                                      const MASK: u8 = 15;
                                      const OFFSET: u8 = 4;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bits 8:10 - CLKOUT Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn clkoutdiv(&self) -> ClkoutdivR {
                ClkoutdivR::_from({
                                      const MASK: u8 = 7;
                                      const OFFSET: u8 = 8;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 11 - CLKOUT enable" ]
            # [ inline ( always ) ]
            pub fn clkouten(&self) -> ClkoutenR {
                ClkoutenR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 11;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 12 - Debug trace clock select" ]
            # [ inline ( always ) ]
            pub fn traceclk_sel(&self) -> TraceclkSelR {
                TraceclkSelR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 12;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 13 - PDB back-to-back select" ]
            # [ inline ( always ) ]
            pub fn pdb_bb_sel(&self) -> PdbBbSelR {
                PdbBbSelR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 13;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 16:18 - ADC_SUPPLY" ]
            # [ inline ( always ) ]
            pub fn adc_supply(&self) -> AdcSupplyR {
                AdcSupplyR::_from({
                                      const MASK: u8 = 7;
                                      const OFFSET: u8 = 16;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 19 - ADC_SUPPLYEN" ]
            # [ inline ( always ) ]
            pub fn adc_supplyen(&self) -> AdcSupplyenR {
                AdcSupplyenR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 19;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 20 - SRAMU_RETEN" ]
            # [ inline ( always ) ]
            pub fn sramu_reten(&self) -> SramuRetenR {
                SramuRetenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 20;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 21 - SRAML_RETEN" ]
            # [ inline ( always ) ]
            pub fn sraml_reten(&self) -> SramlRetenR {
                SramlRetenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 21;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3145728 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - ADC interleave channel enable" ]
            # [ inline ( always ) ]
            pub fn adc_interleave_en(&mut self) -> _AdcInterleaveEnW {
                _AdcInterleaveEnW { w: self }
            }
            # [ doc = "Bits 4:7 - CLKOUT Select" ]
            # [ inline ( always ) ]
            pub fn clkoutsel(&mut self) -> _ClkoutselW {
                _ClkoutselW { w: self }
            }
            # [ doc = "Bits 8:10 - CLKOUT Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn clkoutdiv(&mut self) -> _ClkoutdivW {
                _ClkoutdivW { w: self }
            }
            # [ doc = "Bit 11 - CLKOUT enable" ]
            # [ inline ( always ) ]
            pub fn clkouten(&mut self) -> _ClkoutenW {
                _ClkoutenW { w: self }
            }
            # [ doc = "Bit 12 - Debug trace clock select" ]
            # [ inline ( always ) ]
            pub fn traceclk_sel(&mut self) -> _TraceclkSelW {
                _TraceclkSelW { w: self }
            }
            # [ doc = "Bit 13 - PDB back-to-back select" ]
            # [ inline ( always ) ]
            pub fn pdb_bb_sel(&mut self) -> _PdbBbSelW {
                _PdbBbSelW { w: self }
            }
            # [ doc = "Bits 16:18 - ADC_SUPPLY" ]
            # [ inline ( always ) ]
            pub fn adc_supply(&mut self) -> _AdcSupplyW {
                _AdcSupplyW { w: self }
            }
            # [ doc = "Bit 19 - ADC_SUPPLYEN" ]
            # [ inline ( always ) ]
            pub fn adc_supplyen(&mut self) -> _AdcSupplyenW {
                _AdcSupplyenW { w: self }
            }
            # [ doc = "Bit 20 - SRAMU_RETEN" ]
            # [ inline ( always ) ]
            pub fn sramu_reten(&mut self) -> _SramuRetenW {
                _SramuRetenW { w: self }
            }
            # [ doc = "Bit 21 - SRAML_RETEN" ]
            # [ inline ( always ) ]
            pub fn sraml_reten(&mut self) -> _SramlRetenW {
                _SramlRetenW { w: self }
            }
        }
    }
    # [ doc = "FTM Option Register 0" ]
    pub struct Ftmopt0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Option Register 0" ]
    pub mod ftmopt0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ftmopt0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FTM0FLTxSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm0fltxSelR {
            # [ doc = "FTM0_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM0 out" ]
            _001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm0fltxSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm0fltxSelR::_000 => 0,
                    Ftm0fltxSelR::_001 => 1,
                    Ftm0fltxSelR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm0fltxSelR {
                match bits {
                    0 => Ftm0fltxSelR::_000,
                    1 => Ftm0fltxSelR::_001,
                    i => Ftm0fltxSelR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Ftm0fltxSelR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Ftm0fltxSelR::_001
            }
        }
        # [ doc = "Possible values of the field `FTM1FLTxSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm1fltxSelR {
            # [ doc = "FTM1_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM1 out" ]
            _001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm1fltxSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm1fltxSelR::_000 => 0,
                    Ftm1fltxSelR::_001 => 1,
                    Ftm1fltxSelR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm1fltxSelR {
                match bits {
                    0 => Ftm1fltxSelR::_000,
                    1 => Ftm1fltxSelR::_001,
                    i => Ftm1fltxSelR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Ftm1fltxSelR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Ftm1fltxSelR::_001
            }
        }
        # [ doc = "Possible values of the field `FTM2FLTxSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm2fltxSelR {
            # [ doc = "FTM2_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM2 out" ]
            _001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm2fltxSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm2fltxSelR::_000 => 0,
                    Ftm2fltxSelR::_001 => 1,
                    Ftm2fltxSelR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm2fltxSelR {
                match bits {
                    0 => Ftm2fltxSelR::_000,
                    1 => Ftm2fltxSelR::_001,
                    i => Ftm2fltxSelR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Ftm2fltxSelR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Ftm2fltxSelR::_001
            }
        }
        # [ doc = "Possible values of the field `FTM3FLTxSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm3fltxSelR {
            # [ doc = "FTM3_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM3 out" ]
            _001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm3fltxSelR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm3fltxSelR::_000 => 0,
                    Ftm3fltxSelR::_001 => 1,
                    Ftm3fltxSelR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm3fltxSelR {
                match bits {
                    0 => Ftm3fltxSelR::_000,
                    1 => Ftm3fltxSelR::_001,
                    i => Ftm3fltxSelR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Ftm3fltxSelR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Ftm3fltxSelR::_001
            }
        }
        # [ doc = "Possible values of the field `FTM0CLKSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm0clkselR {
            # [ doc = "FTM0 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM0 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM0 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm0clkselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm0clkselR::_00 => 0,
                    Ftm0clkselR::_01 => 1,
                    Ftm0clkselR::_10 => 2,
                    Ftm0clkselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm0clkselR {
                match bits {
                    0 => Ftm0clkselR::_00,
                    1 => Ftm0clkselR::_01,
                    2 => Ftm0clkselR::_10,
                    3 => Ftm0clkselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Ftm0clkselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Ftm0clkselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Ftm0clkselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Ftm0clkselR::_11
            }
        }
        # [ doc = "Possible values of the field `FTM1CLKSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm1clkselR {
            # [ doc = "FTM1 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM1 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM1 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm1clkselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm1clkselR::_00 => 0,
                    Ftm1clkselR::_01 => 1,
                    Ftm1clkselR::_10 => 2,
                    Ftm1clkselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm1clkselR {
                match bits {
                    0 => Ftm1clkselR::_00,
                    1 => Ftm1clkselR::_01,
                    2 => Ftm1clkselR::_10,
                    3 => Ftm1clkselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Ftm1clkselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Ftm1clkselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Ftm1clkselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Ftm1clkselR::_11
            }
        }
        # [ doc = "Possible values of the field `FTM2CLKSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm2clkselR {
            # [ doc = "FTM2 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM2 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM2 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm2clkselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm2clkselR::_00 => 0,
                    Ftm2clkselR::_01 => 1,
                    Ftm2clkselR::_10 => 2,
                    Ftm2clkselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm2clkselR {
                match bits {
                    0 => Ftm2clkselR::_00,
                    1 => Ftm2clkselR::_01,
                    2 => Ftm2clkselR::_10,
                    3 => Ftm2clkselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Ftm2clkselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Ftm2clkselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Ftm2clkselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Ftm2clkselR::_11
            }
        }
        # [ doc = "Possible values of the field `FTM3CLKSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm3clkselR {
            # [ doc = "FTM3 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM3 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM3 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm3clkselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm3clkselR::_00 => 0,
                    Ftm3clkselR::_01 => 1,
                    Ftm3clkselR::_10 => 2,
                    Ftm3clkselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm3clkselR {
                match bits {
                    0 => Ftm3clkselR::_00,
                    1 => Ftm3clkselR::_01,
                    2 => Ftm3clkselR::_10,
                    3 => Ftm3clkselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Ftm3clkselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Ftm3clkselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Ftm3clkselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == Ftm3clkselR::_11
            }
        }
        # [ doc = "Values that can be written to the field `FTM0FLTxSEL`" ]
        pub enum Ftm0fltxSelW {
            # [ doc = "FTM0_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM0 out" ]
            _001,
        }
        impl Ftm0fltxSelW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm0fltxSelW::_000 => 0,
                    Ftm0fltxSelW::_001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm0fltxSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm0fltxSelW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm0fltxSelW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "FTM0_FLTx pin" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Ftm0fltxSelW::_000)
            }
            # [ doc = "TRGMUX_FTM0 out" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Ftm0fltxSelW::_001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM1FLTxSEL`" ]
        pub enum Ftm1fltxSelW {
            # [ doc = "FTM1_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM1 out" ]
            _001,
        }
        impl Ftm1fltxSelW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm1fltxSelW::_000 => 0,
                    Ftm1fltxSelW::_001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm1fltxSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm1fltxSelW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm1fltxSelW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "FTM1_FLTx pin" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Ftm1fltxSelW::_000)
            }
            # [ doc = "TRGMUX_FTM1 out" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Ftm1fltxSelW::_001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM2FLTxSEL`" ]
        pub enum Ftm2fltxSelW {
            # [ doc = "FTM2_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM2 out" ]
            _001,
        }
        impl Ftm2fltxSelW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm2fltxSelW::_000 => 0,
                    Ftm2fltxSelW::_001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm2fltxSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm2fltxSelW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm2fltxSelW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "FTM2_FLTx pin" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Ftm2fltxSelW::_000)
            }
            # [ doc = "TRGMUX_FTM2 out" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Ftm2fltxSelW::_001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM3FLTxSEL`" ]
        pub enum Ftm3fltxSelW {
            # [ doc = "FTM3_FLTx pin" ]
            _000,
            # [ doc = "TRGMUX_FTM3 out" ]
            _001,
        }
        impl Ftm3fltxSelW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm3fltxSelW::_000 => 0,
                    Ftm3fltxSelW::_001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm3fltxSelW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm3fltxSelW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm3fltxSelW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "FTM3_FLTx pin" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Ftm3fltxSelW::_000)
            }
            # [ doc = "TRGMUX_FTM3 out" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Ftm3fltxSelW::_001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM0CLKSEL`" ]
        pub enum Ftm0clkselW {
            # [ doc = "FTM0 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM0 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM0 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm0clkselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm0clkselW::_00 => 0,
                    Ftm0clkselW::_01 => 1,
                    Ftm0clkselW::_10 => 2,
                    Ftm0clkselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm0clkselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm0clkselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm0clkselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM0 external clock driven by TCLK0 pin." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Ftm0clkselW::_00)
            }
            # [ doc = "FTM0 external clock driven by TCLK1 pin." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Ftm0clkselW::_01)
            }
            # [ doc = "FTM0 external clock driven by TCLK2 pin." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Ftm0clkselW::_10)
            }
            # [ doc = "No clock input" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Ftm0clkselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM1CLKSEL`" ]
        pub enum Ftm1clkselW {
            # [ doc = "FTM1 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM1 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM1 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm1clkselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm1clkselW::_00 => 0,
                    Ftm1clkselW::_01 => 1,
                    Ftm1clkselW::_10 => 2,
                    Ftm1clkselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm1clkselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm1clkselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm1clkselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM1 external clock driven by TCLK0 pin." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Ftm1clkselW::_00)
            }
            # [ doc = "FTM1 external clock driven by TCLK1 pin." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Ftm1clkselW::_01)
            }
            # [ doc = "FTM1 external clock driven by TCLK2 pin." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Ftm1clkselW::_10)
            }
            # [ doc = "No clock input" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Ftm1clkselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM2CLKSEL`" ]
        pub enum Ftm2clkselW {
            # [ doc = "FTM2 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM2 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM2 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm2clkselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm2clkselW::_00 => 0,
                    Ftm2clkselW::_01 => 1,
                    Ftm2clkselW::_10 => 2,
                    Ftm2clkselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm2clkselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm2clkselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm2clkselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM2 external clock driven by TCLK0 pin." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Ftm2clkselW::_00)
            }
            # [ doc = "FTM2 external clock driven by TCLK1 pin." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Ftm2clkselW::_01)
            }
            # [ doc = "FTM2 external clock driven by TCLK2 pin." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Ftm2clkselW::_10)
            }
            # [ doc = "No clock input" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Ftm2clkselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM3CLKSEL`" ]
        pub enum Ftm3clkselW {
            # [ doc = "FTM3 external clock driven by TCLK0 pin." ]
            _00,
            # [ doc = "FTM3 external clock driven by TCLK1 pin." ]
            _01,
            # [ doc = "FTM3 external clock driven by TCLK2 pin." ]
            _10,
            # [ doc = "No clock input" ]
            _11,
        }
        impl Ftm3clkselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm3clkselW::_00 => 0,
                    Ftm3clkselW::_01 => 1,
                    Ftm3clkselW::_10 => 2,
                    Ftm3clkselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm3clkselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm3clkselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm3clkselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM3 external clock driven by TCLK0 pin." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Ftm3clkselW::_00)
            }
            # [ doc = "FTM3 external clock driven by TCLK1 pin." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Ftm3clkselW::_01)
            }
            # [ doc = "FTM3 external clock driven by TCLK2 pin." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Ftm3clkselW::_10)
            }
            # [ doc = "No clock input" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(Ftm3clkselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - FTM0 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm0fltx_sel(&self) -> Ftm0fltxSelR {
                Ftm0fltxSelR::_from({
                                        const MASK: u8 = 7;
                                        const OFFSET: u8 = 0;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bits 4:6 - FTM1 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm1fltx_sel(&self) -> Ftm1fltxSelR {
                Ftm1fltxSelR::_from({
                                        const MASK: u8 = 7;
                                        const OFFSET: u8 = 4;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bits 8:10 - FTM2 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm2fltx_sel(&self) -> Ftm2fltxSelR {
                Ftm2fltxSelR::_from({
                                        const MASK: u8 = 7;
                                        const OFFSET: u8 = 8;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bits 12:14 - FTM3 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm3fltx_sel(&self) -> Ftm3fltxSelR {
                Ftm3fltxSelR::_from({
                                        const MASK: u8 = 7;
                                        const OFFSET: u8 = 12;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bits 24:25 - FTM0 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm0clksel(&self) -> Ftm0clkselR {
                Ftm0clkselR::_from({
                                       const MASK: u8 = 3;
                                       const OFFSET: u8 = 24;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 26:27 - FTM1 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm1clksel(&self) -> Ftm1clkselR {
                Ftm1clkselR::_from({
                                       const MASK: u8 = 3;
                                       const OFFSET: u8 = 26;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 28:29 - FTM2 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm2clksel(&self) -> Ftm2clkselR {
                Ftm2clkselR::_from({
                                       const MASK: u8 = 3;
                                       const OFFSET: u8 = 28;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 30:31 - FTM3 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm3clksel(&self) -> Ftm3clkselR {
                Ftm3clkselR::_from({
                                       const MASK: u8 = 3;
                                       const OFFSET: u8 = 30;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - FTM0 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm0fltx_sel(&mut self) -> _Ftm0fltxSelW {
                _Ftm0fltxSelW { w: self }
            }
            # [ doc = "Bits 4:6 - FTM1 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm1fltx_sel(&mut self) -> _Ftm1fltxSelW {
                _Ftm1fltxSelW { w: self }
            }
            # [ doc = "Bits 8:10 - FTM2 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm2fltx_sel(&mut self) -> _Ftm2fltxSelW {
                _Ftm2fltxSelW { w: self }
            }
            # [ doc = "Bits 12:14 - FTM3 Fault X Select" ]
            # [ inline ( always ) ]
            pub fn ftm3fltx_sel(&mut self) -> _Ftm3fltxSelW {
                _Ftm3fltxSelW { w: self }
            }
            # [ doc = "Bits 24:25 - FTM0 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm0clksel(&mut self) -> _Ftm0clkselW {
                _Ftm0clkselW { w: self }
            }
            # [ doc = "Bits 26:27 - FTM1 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm1clksel(&mut self) -> _Ftm1clkselW {
                _Ftm1clkselW { w: self }
            }
            # [ doc = "Bits 28:29 - FTM2 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm2clksel(&mut self) -> _Ftm2clkselW {
                _Ftm2clkselW { w: self }
            }
            # [ doc = "Bits 30:31 - FTM3 External Clock Pin Select" ]
            # [ inline ( always ) ]
            pub fn ftm3clksel(&mut self) -> _Ftm3clkselW {
                _Ftm3clkselW { w: self }
            }
        }
    }
    # [ doc = "LPO Clock Select Register" ]
    pub struct Lpoclks {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPO Clock Select Register" ]
    pub mod lpoclks {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lpoclks {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `LPO1KCLKEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Lpo1kclkenR {
            # [ doc = "Disable 1 kHz LPO_CLK output" ]
            _0,
            # [ doc = "Enable 1 kHz LPO_CLK output" ]
            _1,
        }
        impl Lpo1kclkenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Lpo1kclkenR::_0 => 0,
                    Lpo1kclkenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Lpo1kclkenR {
                match bits {
                    0 => Lpo1kclkenR::_0,
                    1 => Lpo1kclkenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Lpo1kclkenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Lpo1kclkenR::_1
            }
        }
        # [ doc = "Possible values of the field `LPO32KCLKEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Lpo32kclkenR {
            # [ doc = "Disable 32 kHz LPO_CLK output" ]
            _0,
            # [ doc = "Enable 32 kHz LPO_CLK output" ]
            _1,
        }
        impl Lpo32kclkenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Lpo32kclkenR::_0 => 0,
                    Lpo32kclkenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Lpo32kclkenR {
                match bits {
                    0 => Lpo32kclkenR::_0,
                    1 => Lpo32kclkenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Lpo32kclkenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Lpo32kclkenR::_1
            }
        }
        # [ doc = "Possible values of the field `LPOCLKSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpoclkselR {
            # [ doc = "128 kHz LPO_CLK" ]
            _00,
            # [ doc = "No clock" ]
            _01,
            # [ doc = "32 kHz LPO_CLK which is derived from the 128 kHz LPO_CLK" ]
            _10,
            # [ doc = "1 kHz LPO_CLK which is derived from the 128 kHz LPO_CLK" ]
            _11,
        }
        impl LpoclkselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpoclkselR::_00 => 0,
                    LpoclkselR::_01 => 1,
                    LpoclkselR::_10 => 2,
                    LpoclkselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpoclkselR {
                match bits {
                    0 => LpoclkselR::_00,
                    1 => LpoclkselR::_01,
                    2 => LpoclkselR::_10,
                    3 => LpoclkselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == LpoclkselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == LpoclkselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == LpoclkselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == LpoclkselR::_11
            }
        }
        # [ doc = "Possible values of the field `RTCCLKSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RtcclkselR {
            # [ doc = "SOSCDIV1_CLK" ]
            _00,
            # [ doc = "32 kHz LPO_CLK" ]
            _01,
            # [ doc = "RTC_CLKIN clock" ]
            _10,
            # [ doc = "FIRCDIV1_CLK" ]
            _11,
        }
        impl RtcclkselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RtcclkselR::_00 => 0,
                    RtcclkselR::_01 => 1,
                    RtcclkselR::_10 => 2,
                    RtcclkselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RtcclkselR {
                match bits {
                    0 => RtcclkselR::_00,
                    1 => RtcclkselR::_01,
                    2 => RtcclkselR::_10,
                    3 => RtcclkselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == RtcclkselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == RtcclkselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == RtcclkselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == RtcclkselR::_11
            }
        }
        # [ doc = "Values that can be written to the field `LPO1KCLKEN`" ]
        pub enum Lpo1kclkenW {
            # [ doc = "Disable 1 kHz LPO_CLK output" ]
            _0,
            # [ doc = "Enable 1 kHz LPO_CLK output" ]
            _1,
        }
        impl Lpo1kclkenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Lpo1kclkenW::_0 => 0,
                    Lpo1kclkenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Lpo1kclkenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Lpo1kclkenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Lpo1kclkenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable 1 kHz LPO_CLK output" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Lpo1kclkenW::_0)
            }
            # [ doc = "Enable 1 kHz LPO_CLK output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Lpo1kclkenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPO32KCLKEN`" ]
        pub enum Lpo32kclkenW {
            # [ doc = "Disable 32 kHz LPO_CLK output" ]
            _0,
            # [ doc = "Enable 32 kHz LPO_CLK output" ]
            _1,
        }
        impl Lpo32kclkenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Lpo32kclkenW::_0 => 0,
                    Lpo32kclkenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Lpo32kclkenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Lpo32kclkenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Lpo32kclkenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable 32 kHz LPO_CLK output" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Lpo32kclkenW::_0)
            }
            # [ doc = "Enable 32 kHz LPO_CLK output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Lpo32kclkenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPOCLKSEL`" ]
        pub enum LpoclkselW {
            # [ doc = "128 kHz LPO_CLK" ]
            _00,
            # [ doc = "No clock" ]
            _01,
            # [ doc = "32 kHz LPO_CLK which is derived from the 128 kHz LPO_CLK" ]
            _10,
            # [ doc = "1 kHz LPO_CLK which is derived from the 128 kHz LPO_CLK" ]
            _11,
        }
        impl LpoclkselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LpoclkselW::_00 => 0,
                    LpoclkselW::_01 => 1,
                    LpoclkselW::_10 => 2,
                    LpoclkselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LpoclkselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LpoclkselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LpoclkselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "128 kHz LPO_CLK" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(LpoclkselW::_00)
            }
            # [ doc = "No clock" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(LpoclkselW::_01)
            }
            # [ doc = "32 kHz LPO_CLK which is derived from the 128 kHz LPO_CLK" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(LpoclkselW::_10)
            }
            # [ doc = "1 kHz LPO_CLK which is derived from the 128 kHz LPO_CLK" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(LpoclkselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTCCLKSEL`" ]
        pub enum RtcclkselW {
            # [ doc = "SOSCDIV1_CLK" ]
            _00,
            # [ doc = "32 kHz LPO_CLK" ]
            _01,
            # [ doc = "RTC_CLKIN clock" ]
            _10,
            # [ doc = "FIRCDIV1_CLK" ]
            _11,
        }
        impl RtcclkselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtcclkselW::_00 => 0,
                    RtcclkselW::_01 => 1,
                    RtcclkselW::_10 => 2,
                    RtcclkselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtcclkselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtcclkselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtcclkselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "SOSCDIV1_CLK" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(RtcclkselW::_00)
            }
            # [ doc = "32 kHz LPO_CLK" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(RtcclkselW::_01)
            }
            # [ doc = "RTC_CLKIN clock" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(RtcclkselW::_10)
            }
            # [ doc = "FIRCDIV1_CLK" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(RtcclkselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - 1 kHz LPO_CLK enable" ]
            # [ inline ( always ) ]
            pub fn lpo1kclken(&self) -> Lpo1kclkenR {
                Lpo1kclkenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 1 - 32 kHz LPO_CLK enable" ]
            # [ inline ( always ) ]
            pub fn lpo32kclken(&self) -> Lpo32kclkenR {
                Lpo32kclkenR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 1;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bits 2:3 - LPO clock source select" ]
            # [ inline ( always ) ]
            pub fn lpoclksel(&self) -> LpoclkselR {
                LpoclkselR::_from({
                                      const MASK: u8 = 3;
                                      const OFFSET: u8 = 2;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bits 4:5 - 32 kHz clock source select" ]
            # [ inline ( always ) ]
            pub fn rtcclksel(&self) -> RtcclkselR {
                RtcclkselR::_from({
                                      const MASK: u8 = 3;
                                      const OFFSET: u8 = 4;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - 1 kHz LPO_CLK enable" ]
            # [ inline ( always ) ]
            pub fn lpo1kclken(&mut self) -> _Lpo1kclkenW {
                _Lpo1kclkenW { w: self }
            }
            # [ doc = "Bit 1 - 32 kHz LPO_CLK enable" ]
            # [ inline ( always ) ]
            pub fn lpo32kclken(&mut self) -> _Lpo32kclkenW {
                _Lpo32kclkenW { w: self }
            }
            # [ doc = "Bits 2:3 - LPO clock source select" ]
            # [ inline ( always ) ]
            pub fn lpoclksel(&mut self) -> _LpoclkselW {
                _LpoclkselW { w: self }
            }
            # [ doc = "Bits 4:5 - 32 kHz clock source select" ]
            # [ inline ( always ) ]
            pub fn rtcclksel(&mut self) -> _RtcclkselW {
                _RtcclkselW { w: self }
            }
        }
    }
    # [ doc = "ADC Options Register" ]
    pub struct Adcopt {
        register: VolatileCell<u32>,
    }
    # [ doc = "ADC Options Register" ]
    pub mod adcopt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Adcopt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADC0TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Adc0trgselR {
            # [ doc = "PDB output" ]
            _0,
            # [ doc = "TRGMUX output" ]
            _1,
        }
        impl Adc0trgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Adc0trgselR::_0 => 0,
                    Adc0trgselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Adc0trgselR {
                match bits {
                    0 => Adc0trgselR::_0,
                    1 => Adc0trgselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Adc0trgselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Adc0trgselR::_1
            }
        }
        # [ doc = "Possible values of the field `ADC0SWPRETRG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Adc0swpretrgR {
            # [ doc = "Software pretrigger disabled" ]
            _000,
            # [ doc = "Reserved (do not use)" ]
            _001,
            # [ doc = "Reserved (do not use)" ]
            _010,
            # [ doc = "Reserved (do not use)" ]
            _011,
            # [ doc = "Software pretrigger 0" ]
            _100,
            # [ doc = "Software pretrigger 1" ]
            _101,
            # [ doc = "Software pretrigger 2" ]
            _110,
            # [ doc = "Software pretrigger 3" ]
            _111,
        }
        impl Adc0swpretrgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Adc0swpretrgR::_000 => 0,
                    Adc0swpretrgR::_001 => 1,
                    Adc0swpretrgR::_010 => 2,
                    Adc0swpretrgR::_011 => 3,
                    Adc0swpretrgR::_100 => 4,
                    Adc0swpretrgR::_101 => 5,
                    Adc0swpretrgR::_110 => 6,
                    Adc0swpretrgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Adc0swpretrgR {
                match bits {
                    0 => Adc0swpretrgR::_000,
                    1 => Adc0swpretrgR::_001,
                    2 => Adc0swpretrgR::_010,
                    3 => Adc0swpretrgR::_011,
                    4 => Adc0swpretrgR::_100,
                    5 => Adc0swpretrgR::_101,
                    6 => Adc0swpretrgR::_110,
                    7 => Adc0swpretrgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Adc0swpretrgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Adc0swpretrgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Adc0swpretrgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Adc0swpretrgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Adc0swpretrgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Adc0swpretrgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Adc0swpretrgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Adc0swpretrgR::_111
            }
        }
        # [ doc = "Possible values of the field `ADC0PRETRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Adc0pretrgselR {
            # [ doc = "PDB pretrigger (default)" ]
            _00,
            # [ doc = "TRGMUX pretrigger" ]
            _01,
            # [ doc = "Software pretrigger" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Adc0pretrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Adc0pretrgselR::_00 => 0,
                    Adc0pretrgselR::_01 => 1,
                    Adc0pretrgselR::_10 => 2,
                    Adc0pretrgselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Adc0pretrgselR {
                match bits {
                    0 => Adc0pretrgselR::_00,
                    1 => Adc0pretrgselR::_01,
                    2 => Adc0pretrgselR::_10,
                    i => Adc0pretrgselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Adc0pretrgselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Adc0pretrgselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Adc0pretrgselR::_10
            }
        }
        # [ doc = "Possible values of the field `ADC1TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Adc1trgselR {
            # [ doc = "PDB output" ]
            _0,
            # [ doc = "TRGMUX output" ]
            _1,
        }
        impl Adc1trgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Adc1trgselR::_0 => 0,
                    Adc1trgselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Adc1trgselR {
                match bits {
                    0 => Adc1trgselR::_0,
                    1 => Adc1trgselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Adc1trgselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Adc1trgselR::_1
            }
        }
        # [ doc = "Possible values of the field `ADC1SWPRETRG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Adc1swpretrgR {
            # [ doc = "Software pretrigger disabled" ]
            _000,
            # [ doc = "Reserved (do not use)" ]
            _001,
            # [ doc = "Reserved (do not use)" ]
            _010,
            # [ doc = "Reserved (do not use)" ]
            _011,
            # [ doc = "Software pretrigger 0" ]
            _100,
            # [ doc = "Software pretrigger 1" ]
            _101,
            # [ doc = "Software pretrigger 2" ]
            _110,
            # [ doc = "Software pretrigger 3" ]
            _111,
        }
        impl Adc1swpretrgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Adc1swpretrgR::_000 => 0,
                    Adc1swpretrgR::_001 => 1,
                    Adc1swpretrgR::_010 => 2,
                    Adc1swpretrgR::_011 => 3,
                    Adc1swpretrgR::_100 => 4,
                    Adc1swpretrgR::_101 => 5,
                    Adc1swpretrgR::_110 => 6,
                    Adc1swpretrgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Adc1swpretrgR {
                match bits {
                    0 => Adc1swpretrgR::_000,
                    1 => Adc1swpretrgR::_001,
                    2 => Adc1swpretrgR::_010,
                    3 => Adc1swpretrgR::_011,
                    4 => Adc1swpretrgR::_100,
                    5 => Adc1swpretrgR::_101,
                    6 => Adc1swpretrgR::_110,
                    7 => Adc1swpretrgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Adc1swpretrgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Adc1swpretrgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Adc1swpretrgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Adc1swpretrgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Adc1swpretrgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Adc1swpretrgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Adc1swpretrgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Adc1swpretrgR::_111
            }
        }
        # [ doc = "Possible values of the field `ADC1PRETRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Adc1pretrgselR {
            # [ doc = "PDB pretrigger (default)" ]
            _00,
            # [ doc = "TRGMUX pretrigger" ]
            _01,
            # [ doc = "Software pretrigger" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Adc1pretrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Adc1pretrgselR::_00 => 0,
                    Adc1pretrgselR::_01 => 1,
                    Adc1pretrgselR::_10 => 2,
                    Adc1pretrgselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Adc1pretrgselR {
                match bits {
                    0 => Adc1pretrgselR::_00,
                    1 => Adc1pretrgselR::_01,
                    2 => Adc1pretrgselR::_10,
                    i => Adc1pretrgselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Adc1pretrgselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Adc1pretrgselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == Adc1pretrgselR::_10
            }
        }
        # [ doc = "Values that can be written to the field `ADC0TRGSEL`" ]
        pub enum Adc0trgselW {
            # [ doc = "PDB output" ]
            _0,
            # [ doc = "TRGMUX output" ]
            _1,
        }
        impl Adc0trgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Adc0trgselW::_0 => 0,
                    Adc0trgselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Adc0trgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Adc0trgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Adc0trgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB output" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Adc0trgselW::_0)
            }
            # [ doc = "TRGMUX output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Adc0trgselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC0SWPRETRG`" ]
        pub enum Adc0swpretrgW {
            # [ doc = "Software pretrigger disabled" ]
            _000,
            # [ doc = "Reserved (do not use)" ]
            _001,
            # [ doc = "Reserved (do not use)" ]
            _010,
            # [ doc = "Reserved (do not use)" ]
            _011,
            # [ doc = "Software pretrigger 0" ]
            _100,
            # [ doc = "Software pretrigger 1" ]
            _101,
            # [ doc = "Software pretrigger 2" ]
            _110,
            # [ doc = "Software pretrigger 3" ]
            _111,
        }
        impl Adc0swpretrgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Adc0swpretrgW::_000 => 0,
                    Adc0swpretrgW::_001 => 1,
                    Adc0swpretrgW::_010 => 2,
                    Adc0swpretrgW::_011 => 3,
                    Adc0swpretrgW::_100 => 4,
                    Adc0swpretrgW::_101 => 5,
                    Adc0swpretrgW::_110 => 6,
                    Adc0swpretrgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Adc0swpretrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Adc0swpretrgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Adc0swpretrgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software pretrigger disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_000)
            }
            # [ doc = "Reserved (do not use)" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_001)
            }
            # [ doc = "Reserved (do not use)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_010)
            }
            # [ doc = "Reserved (do not use)" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_011)
            }
            # [ doc = "Software pretrigger 0" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_100)
            }
            # [ doc = "Software pretrigger 1" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_101)
            }
            # [ doc = "Software pretrigger 2" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_110)
            }
            # [ doc = "Software pretrigger 3" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Adc0swpretrgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC0PRETRGSEL`" ]
        pub enum Adc0pretrgselW {
            # [ doc = "PDB pretrigger (default)" ]
            _00,
            # [ doc = "TRGMUX pretrigger" ]
            _01,
            # [ doc = "Software pretrigger" ]
            _10,
        }
        impl Adc0pretrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Adc0pretrgselW::_00 => 0,
                    Adc0pretrgselW::_01 => 1,
                    Adc0pretrgselW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Adc0pretrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Adc0pretrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Adc0pretrgselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB pretrigger (default)" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Adc0pretrgselW::_00)
            }
            # [ doc = "TRGMUX pretrigger" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Adc0pretrgselW::_01)
            }
            # [ doc = "Software pretrigger" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Adc0pretrgselW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC1TRGSEL`" ]
        pub enum Adc1trgselW {
            # [ doc = "PDB output" ]
            _0,
            # [ doc = "TRGMUX output" ]
            _1,
        }
        impl Adc1trgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Adc1trgselW::_0 => 0,
                    Adc1trgselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Adc1trgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Adc1trgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Adc1trgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PDB output" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Adc1trgselW::_0)
            }
            # [ doc = "TRGMUX output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Adc1trgselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC1SWPRETRG`" ]
        pub enum Adc1swpretrgW {
            # [ doc = "Software pretrigger disabled" ]
            _000,
            # [ doc = "Reserved (do not use)" ]
            _001,
            # [ doc = "Reserved (do not use)" ]
            _010,
            # [ doc = "Reserved (do not use)" ]
            _011,
            # [ doc = "Software pretrigger 0" ]
            _100,
            # [ doc = "Software pretrigger 1" ]
            _101,
            # [ doc = "Software pretrigger 2" ]
            _110,
            # [ doc = "Software pretrigger 3" ]
            _111,
        }
        impl Adc1swpretrgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Adc1swpretrgW::_000 => 0,
                    Adc1swpretrgW::_001 => 1,
                    Adc1swpretrgW::_010 => 2,
                    Adc1swpretrgW::_011 => 3,
                    Adc1swpretrgW::_100 => 4,
                    Adc1swpretrgW::_101 => 5,
                    Adc1swpretrgW::_110 => 6,
                    Adc1swpretrgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Adc1swpretrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Adc1swpretrgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Adc1swpretrgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software pretrigger disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_000)
            }
            # [ doc = "Reserved (do not use)" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_001)
            }
            # [ doc = "Reserved (do not use)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_010)
            }
            # [ doc = "Reserved (do not use)" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_011)
            }
            # [ doc = "Software pretrigger 0" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_100)
            }
            # [ doc = "Software pretrigger 1" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_101)
            }
            # [ doc = "Software pretrigger 2" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_110)
            }
            # [ doc = "Software pretrigger 3" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Adc1swpretrgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADC1PRETRGSEL`" ]
        pub enum Adc1pretrgselW {
            # [ doc = "PDB pretrigger (default)" ]
            _00,
            # [ doc = "TRGMUX pretrigger" ]
            _01,
            # [ doc = "Software pretrigger" ]
            _10,
        }
        impl Adc1pretrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Adc1pretrgselW::_00 => 0,
                    Adc1pretrgselW::_01 => 1,
                    Adc1pretrgselW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Adc1pretrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Adc1pretrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Adc1pretrgselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "PDB pretrigger (default)" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Adc1pretrgselW::_00)
            }
            # [ doc = "TRGMUX pretrigger" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Adc1pretrgselW::_01)
            }
            # [ doc = "Software pretrigger" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(Adc1pretrgselW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - ADC0 trigger source select" ]
            # [ inline ( always ) ]
            pub fn adc0trgsel(&self) -> Adc0trgselR {
                Adc0trgselR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 1:3 - ADC0 software pretrigger sources" ]
            # [ inline ( always ) ]
            pub fn adc0swpretrg(&self) -> Adc0swpretrgR {
                Adc0swpretrgR::_from({
                                         const MASK: u8 = 7;
                                         const OFFSET: u8 = 1;
                                         ((self.bits >> OFFSET) & MASK as u32) as u8
                                     })
            }
            # [ doc = "Bits 4:5 - ADC0 pretrigger source select" ]
            # [ inline ( always ) ]
            pub fn adc0pretrgsel(&self) -> Adc0pretrgselR {
                Adc0pretrgselR::_from({
                                          const MASK: u8 = 3;
                                          const OFFSET: u8 = 4;
                                          ((self.bits >> OFFSET) & MASK as u32) as u8
                                      })
            }
            # [ doc = "Bit 8 - ADC1 trigger source select" ]
            # [ inline ( always ) ]
            pub fn adc1trgsel(&self) -> Adc1trgselR {
                Adc1trgselR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 8;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 9:11 - ADC1 software pretrigger sources" ]
            # [ inline ( always ) ]
            pub fn adc1swpretrg(&self) -> Adc1swpretrgR {
                Adc1swpretrgR::_from({
                                         const MASK: u8 = 7;
                                         const OFFSET: u8 = 9;
                                         ((self.bits >> OFFSET) & MASK as u32) as u8
                                     })
            }
            # [ doc = "Bits 12:13 - ADC1 pretrigger source select" ]
            # [ inline ( always ) ]
            pub fn adc1pretrgsel(&self) -> Adc1pretrgselR {
                Adc1pretrgselR::_from({
                                          const MASK: u8 = 3;
                                          const OFFSET: u8 = 12;
                                          ((self.bits >> OFFSET) & MASK as u32) as u8
                                      })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - ADC0 trigger source select" ]
            # [ inline ( always ) ]
            pub fn adc0trgsel(&mut self) -> _Adc0trgselW {
                _Adc0trgselW { w: self }
            }
            # [ doc = "Bits 1:3 - ADC0 software pretrigger sources" ]
            # [ inline ( always ) ]
            pub fn adc0swpretrg(&mut self) -> _Adc0swpretrgW {
                _Adc0swpretrgW { w: self }
            }
            # [ doc = "Bits 4:5 - ADC0 pretrigger source select" ]
            # [ inline ( always ) ]
            pub fn adc0pretrgsel(&mut self) -> _Adc0pretrgselW {
                _Adc0pretrgselW { w: self }
            }
            # [ doc = "Bit 8 - ADC1 trigger source select" ]
            # [ inline ( always ) ]
            pub fn adc1trgsel(&mut self) -> _Adc1trgselW {
                _Adc1trgselW { w: self }
            }
            # [ doc = "Bits 9:11 - ADC1 software pretrigger sources" ]
            # [ inline ( always ) ]
            pub fn adc1swpretrg(&mut self) -> _Adc1swpretrgW {
                _Adc1swpretrgW { w: self }
            }
            # [ doc = "Bits 12:13 - ADC1 pretrigger source select" ]
            # [ inline ( always ) ]
            pub fn adc1pretrgsel(&mut self) -> _Adc1pretrgselW {
                _Adc1pretrgselW { w: self }
            }
        }
    }
    # [ doc = "FTM Option Register 1" ]
    pub struct Ftmopt1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "FTM Option Register 1" ]
    pub mod ftmopt1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ftmopt1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ftm0syncbitR {
            bits: u8,
        }
        impl Ftm0syncbitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ftm1syncbitR {
            bits: u8,
        }
        impl Ftm1syncbitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ftm2syncbitR {
            bits: u8,
        }
        impl Ftm2syncbitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ftm3syncbitR {
            bits: u8,
        }
        impl Ftm3syncbitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FTM1CH0SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm1ch0selR {
            # [ doc = "FTM1_CH0 input" ]
            _00,
            # [ doc = "CMP0 output" ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm1ch0selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm1ch0selR::_00 => 0,
                    Ftm1ch0selR::_01 => 1,
                    Ftm1ch0selR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm1ch0selR {
                match bits {
                    0 => Ftm1ch0selR::_00,
                    1 => Ftm1ch0selR::_01,
                    i => Ftm1ch0selR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Ftm1ch0selR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Ftm1ch0selR::_01
            }
        }
        # [ doc = "Possible values of the field `FTM2CH0SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm2ch0selR {
            # [ doc = "FTM2_CH0 input" ]
            _00,
            # [ doc = "CMP0 output" ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm2ch0selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm2ch0selR::_00 => 0,
                    Ftm2ch0selR::_01 => 1,
                    Ftm2ch0selR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm2ch0selR {
                match bits {
                    0 => Ftm2ch0selR::_00,
                    1 => Ftm2ch0selR::_01,
                    i => Ftm2ch0selR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == Ftm2ch0selR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == Ftm2ch0selR::_01
            }
        }
        # [ doc = "Possible values of the field `FTM2CH1SEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm2ch1selR {
            # [ doc = "FTM2_CH1 input" ]
            _0,
            # [ doc = "exclusive OR of FTM2_CH0,FTM2_CH1,and FTM1_CH1" ]
            _1,
        }
        impl Ftm2ch1selR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm2ch1selR::_0 => 0,
                    Ftm2ch1selR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm2ch1selR {
                match bits {
                    0 => Ftm2ch1selR::_0,
                    1 => Ftm2ch1selR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ftm2ch1selR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ftm2ch1selR::_1
            }
        }
        # [ doc = "Possible values of the field `FTMGLDOK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FtmgldokR {
            # [ doc = "FTM Global load mechanism disabled." ]
            _0,
            # [ doc = "FTM Global load mechanism enabled" ]
            _1,
        }
        impl FtmgldokR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FtmgldokR::_0 => 0,
                    FtmgldokR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FtmgldokR {
                match bits {
                    0 => FtmgldokR::_0,
                    1 => FtmgldokR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FtmgldokR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FtmgldokR::_1
            }
        }
        # [ doc = "Possible values of the field `FTM0_OUTSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm0OutselR {
            # [ doc = "No modulation with FTM1_CH1" ]
            _00000000,
            # [ doc = "Modulation with FTM1_CH1" ]
            _00000001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm0OutselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm0OutselR::_00000000 => 0,
                    Ftm0OutselR::_00000001 => 1,
                    Ftm0OutselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm0OutselR {
                match bits {
                    0 => Ftm0OutselR::_00000000,
                    1 => Ftm0OutselR::_00000001,
                    i => Ftm0OutselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000000`" ]
            # [ inline ( always ) ]
            pub fn is_00000000(&self) -> bool {
                *self == Ftm0OutselR::_00000000
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == Ftm0OutselR::_00000001
            }
        }
        # [ doc = "Possible values of the field `FTM3_OUTSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm3OutselR {
            # [ doc = "No modulation with FTM2_CH1" ]
            _00000000,
            # [ doc = "Modulation with FTM2_CH1" ]
            _00000001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl Ftm3OutselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm3OutselR::_00000000 => 0,
                    Ftm3OutselR::_00000001 => 1,
                    Ftm3OutselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm3OutselR {
                match bits {
                    0 => Ftm3OutselR::_00000000,
                    1 => Ftm3OutselR::_00000001,
                    i => Ftm3OutselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000000`" ]
            # [ inline ( always ) ]
            pub fn is_00000000(&self) -> bool {
                *self == Ftm3OutselR::_00000000
            }
            # [ doc = "Checks if the value of the field is `_00000001`" ]
            # [ inline ( always ) ]
            pub fn is_00000001(&self) -> bool {
                *self == Ftm3OutselR::_00000001
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm0syncbitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm0syncbitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm1syncbitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm1syncbitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm2syncbitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm2syncbitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm3syncbitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm3syncbitW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM1CH0SEL`" ]
        pub enum Ftm1ch0selW {
            # [ doc = "FTM1_CH0 input" ]
            _00,
            # [ doc = "CMP0 output" ]
            _01,
        }
        impl Ftm1ch0selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm1ch0selW::_00 => 0,
                    Ftm1ch0selW::_01 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm1ch0selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm1ch0selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm1ch0selW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "FTM1_CH0 input" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Ftm1ch0selW::_00)
            }
            # [ doc = "CMP0 output" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Ftm1ch0selW::_01)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM2CH0SEL`" ]
        pub enum Ftm2ch0selW {
            # [ doc = "FTM2_CH0 input" ]
            _00,
            # [ doc = "CMP0 output" ]
            _01,
        }
        impl Ftm2ch0selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm2ch0selW::_00 => 0,
                    Ftm2ch0selW::_01 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm2ch0selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm2ch0selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm2ch0selW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "FTM2_CH0 input" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(Ftm2ch0selW::_00)
            }
            # [ doc = "CMP0 output" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(Ftm2ch0selW::_01)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM2CH1SEL`" ]
        pub enum Ftm2ch1selW {
            # [ doc = "FTM2_CH1 input" ]
            _0,
            # [ doc = "exclusive OR of FTM2_CH0,FTM2_CH1,and FTM1_CH1" ]
            _1,
        }
        impl Ftm2ch1selW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm2ch1selW::_0 => 0,
                    Ftm2ch1selW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm2ch1selW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm2ch1selW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm2ch1selW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM2_CH1 input" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ftm2ch1selW::_0)
            }
            # [ doc = "exclusive OR of FTM2_CH0,FTM2_CH1,and FTM1_CH1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ftm2ch1selW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTMGLDOK`" ]
        pub enum FtmgldokW {
            # [ doc = "FTM Global load mechanism disabled." ]
            _0,
            # [ doc = "FTM Global load mechanism enabled" ]
            _1,
        }
        impl FtmgldokW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FtmgldokW::_0 => 0,
                    FtmgldokW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FtmgldokW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FtmgldokW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FtmgldokW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FTM Global load mechanism disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FtmgldokW::_0)
            }
            # [ doc = "FTM Global load mechanism enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FtmgldokW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM0_OUTSEL`" ]
        pub enum Ftm0OutselW {
            # [ doc = "No modulation with FTM1_CH1" ]
            _00000000,
            # [ doc = "Modulation with FTM1_CH1" ]
            _00000001,
        }
        impl Ftm0OutselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm0OutselW::_00000000 => 0,
                    Ftm0OutselW::_00000001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm0OutselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm0OutselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm0OutselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No modulation with FTM1_CH1" ]
            # [ inline ( always ) ]
            pub fn _00000000(self) -> &'a mut W {
                self.variant(Ftm0OutselW::_00000000)
            }
            # [ doc = "Modulation with FTM1_CH1" ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(Ftm0OutselW::_00000001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM3_OUTSEL`" ]
        pub enum Ftm3OutselW {
            # [ doc = "No modulation with FTM2_CH1" ]
            _00000000,
            # [ doc = "Modulation with FTM2_CH1" ]
            _00000001,
        }
        impl Ftm3OutselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm3OutselW::_00000000 => 0,
                    Ftm3OutselW::_00000001 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm3OutselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm3OutselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm3OutselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No modulation with FTM2_CH1" ]
            # [ inline ( always ) ]
            pub fn _00000000(self) -> &'a mut W {
                self.variant(Ftm3OutselW::_00000000)
            }
            # [ doc = "Modulation with FTM2_CH1" ]
            # [ inline ( always ) ]
            pub fn _00000001(self) -> &'a mut W {
                self.variant(Ftm3OutselW::_00000001)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - FTM0 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm0syncbit(&self) -> Ftm0syncbitR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ftm0syncbitR { bits }
            }
            # [ doc = "Bit 1 - FTM1 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm1syncbit(&self) -> Ftm1syncbitR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ftm1syncbitR { bits }
            }
            # [ doc = "Bit 2 - FTM2 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm2syncbit(&self) -> Ftm2syncbitR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ftm2syncbitR { bits }
            }
            # [ doc = "Bit 3 - FTM3 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm3syncbit(&self) -> Ftm3syncbitR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ftm3syncbitR { bits }
            }
            # [ doc = "Bits 4:5 - FTM1 CH0 Select" ]
            # [ inline ( always ) ]
            pub fn ftm1ch0sel(&self) -> Ftm1ch0selR {
                Ftm1ch0selR::_from({
                                       const MASK: u8 = 3;
                                       const OFFSET: u8 = 4;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 6:7 - FTM2 CH0 Select" ]
            # [ inline ( always ) ]
            pub fn ftm2ch0sel(&self) -> Ftm2ch0selR {
                Ftm2ch0selR::_from({
                                       const MASK: u8 = 3;
                                       const OFFSET: u8 = 6;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 8 - FTM2 CH1 Select" ]
            # [ inline ( always ) ]
            pub fn ftm2ch1sel(&self) -> Ftm2ch1selR {
                Ftm2ch1selR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 8;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 15 - FTM global load enable" ]
            # [ inline ( always ) ]
            pub fn ftmgldok(&self) -> FtmgldokR {
                FtmgldokR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 15;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 16:23 - FTM0 channel modulation select with FTM1_CH1" ]
            # [ inline ( always ) ]
            pub fn ftm0_outsel(&self) -> Ftm0OutselR {
                Ftm0OutselR::_from({
                                       const MASK: u8 = 255;
                                       const OFFSET: u8 = 16;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bits 24:31 - FTM3 channel modulation select with FTM2_CH1" ]
            # [ inline ( always ) ]
            pub fn ftm3_outsel(&self) -> Ftm3OutselR {
                Ftm3OutselR::_from({
                                       const MASK: u8 = 255;
                                       const OFFSET: u8 = 24;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - FTM0 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm0syncbit(&mut self) -> _Ftm0syncbitW {
                _Ftm0syncbitW { w: self }
            }
            # [ doc = "Bit 1 - FTM1 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm1syncbit(&mut self) -> _Ftm1syncbitW {
                _Ftm1syncbitW { w: self }
            }
            # [ doc = "Bit 2 - FTM2 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm2syncbit(&mut self) -> _Ftm2syncbitW {
                _Ftm2syncbitW { w: self }
            }
            # [ doc = "Bit 3 - FTM3 Sync Bit" ]
            # [ inline ( always ) ]
            pub fn ftm3syncbit(&mut self) -> _Ftm3syncbitW {
                _Ftm3syncbitW { w: self }
            }
            # [ doc = "Bits 4:5 - FTM1 CH0 Select" ]
            # [ inline ( always ) ]
            pub fn ftm1ch0sel(&mut self) -> _Ftm1ch0selW {
                _Ftm1ch0selW { w: self }
            }
            # [ doc = "Bits 6:7 - FTM2 CH0 Select" ]
            # [ inline ( always ) ]
            pub fn ftm2ch0sel(&mut self) -> _Ftm2ch0selW {
                _Ftm2ch0selW { w: self }
            }
            # [ doc = "Bit 8 - FTM2 CH1 Select" ]
            # [ inline ( always ) ]
            pub fn ftm2ch1sel(&mut self) -> _Ftm2ch1selW {
                _Ftm2ch1selW { w: self }
            }
            # [ doc = "Bit 15 - FTM global load enable" ]
            # [ inline ( always ) ]
            pub fn ftmgldok(&mut self) -> _FtmgldokW {
                _FtmgldokW { w: self }
            }
            # [ doc = "Bits 16:23 - FTM0 channel modulation select with FTM1_CH1" ]
            # [ inline ( always ) ]
            pub fn ftm0_outsel(&mut self) -> _Ftm0OutselW {
                _Ftm0OutselW { w: self }
            }
            # [ doc = "Bits 24:31 - FTM3 channel modulation select with FTM2_CH1" ]
            # [ inline ( always ) ]
            pub fn ftm3_outsel(&mut self) -> _Ftm3OutselW {
                _Ftm3OutselW { w: self }
            }
        }
    }
    # [ doc = "Miscellaneous control register 0" ]
    pub struct Misctrl0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Miscellaneous control register 0" ]
    pub mod misctrl0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Misctrl0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FTM0_OBE_CTRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm0ObeCtrlR {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm0ObeCtrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm0ObeCtrlR::_0 => 0,
                    Ftm0ObeCtrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm0ObeCtrlR {
                match bits {
                    0 => Ftm0ObeCtrlR::_0,
                    1 => Ftm0ObeCtrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ftm0ObeCtrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ftm0ObeCtrlR::_1
            }
        }
        # [ doc = "Possible values of the field `FTM1_OBE_CTRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm1ObeCtrlR {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm1ObeCtrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm1ObeCtrlR::_0 => 0,
                    Ftm1ObeCtrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm1ObeCtrlR {
                match bits {
                    0 => Ftm1ObeCtrlR::_0,
                    1 => Ftm1ObeCtrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ftm1ObeCtrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ftm1ObeCtrlR::_1
            }
        }
        # [ doc = "Possible values of the field `FTM2_OBE_CTRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm2ObeCtrlR {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm2ObeCtrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm2ObeCtrlR::_0 => 0,
                    Ftm2ObeCtrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm2ObeCtrlR {
                match bits {
                    0 => Ftm2ObeCtrlR::_0,
                    1 => Ftm2ObeCtrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ftm2ObeCtrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ftm2ObeCtrlR::_1
            }
        }
        # [ doc = "Possible values of the field `FTM3_OBE_CTRL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ftm3ObeCtrlR {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm3ObeCtrlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ftm3ObeCtrlR::_0 => 0,
                    Ftm3ObeCtrlR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ftm3ObeCtrlR {
                match bits {
                    0 => Ftm3ObeCtrlR::_0,
                    1 => Ftm3ObeCtrlR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ftm3ObeCtrlR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ftm3ObeCtrlR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FTM0_OBE_CTRL`" ]
        pub enum Ftm0ObeCtrlW {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm0ObeCtrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm0ObeCtrlW::_0 => 0,
                    Ftm0ObeCtrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm0ObeCtrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm0ObeCtrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm0ObeCtrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ftm0ObeCtrlW::_0)
            }
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ftm0ObeCtrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM1_OBE_CTRL`" ]
        pub enum Ftm1ObeCtrlW {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm1ObeCtrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm1ObeCtrlW::_0 => 0,
                    Ftm1ObeCtrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm1ObeCtrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm1ObeCtrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm1ObeCtrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ftm1ObeCtrlW::_0)
            }
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ftm1ObeCtrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM2_OBE_CTRL`" ]
        pub enum Ftm2ObeCtrlW {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm2ObeCtrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm2ObeCtrlW::_0 => 0,
                    Ftm2ObeCtrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm2ObeCtrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm2ObeCtrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm2ObeCtrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ftm2ObeCtrlW::_0)
            }
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ftm2ObeCtrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FTM3_OBE_CTRL`" ]
        pub enum Ftm3ObeCtrlW {
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            _0,
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            _1,
        }
        impl Ftm3ObeCtrlW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ftm3ObeCtrlW::_0 => 0,
                    Ftm3ObeCtrlW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ftm3ObeCtrlW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ftm3ObeCtrlW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ftm3ObeCtrlW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The FTM channel output is put to safe state when the FTM counter is enabled and the FTM channel output is enabled by Fault Control (FTM_MODE[FAULTM]!=2'b00 and FTM_FLTCTRL[FSTATE]=1'b0) and PWM is enabled (FTM_SC[PWMENn] = 1'b1). Otherwise the channel output is tristated." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ftm3ObeCtrlW::_0)
            }
            # [ doc = "The FTM channel output state is retained when the channel is in output mode. The output channel is tristated when the channel is in input capture [DECAPEN=1'b0, COMBINE=1'b0, MSnB:MSnA=2'b00] or dual edge capture mode [DECAPEN=1'b1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ftm3ObeCtrlW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 16 - FTM0 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm0_obe_ctrl(&self) -> Ftm0ObeCtrlR {
                Ftm0ObeCtrlR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 16;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 17 - FTM1 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm1_obe_ctrl(&self) -> Ftm1ObeCtrlR {
                Ftm1ObeCtrlR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 17;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 18 - FTM2 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm2_obe_ctrl(&self) -> Ftm2ObeCtrlR {
                Ftm2ObeCtrlR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 18;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 19 - FTM3 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm3_obe_ctrl(&self) -> Ftm3ObeCtrlR {
                Ftm3ObeCtrlR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 19;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 16 - FTM0 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm0_obe_ctrl(&mut self) -> _Ftm0ObeCtrlW {
                _Ftm0ObeCtrlW { w: self }
            }
            # [ doc = "Bit 17 - FTM1 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm1_obe_ctrl(&mut self) -> _Ftm1ObeCtrlW {
                _Ftm1ObeCtrlW { w: self }
            }
            # [ doc = "Bit 18 - FTM2 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm2_obe_ctrl(&mut self) -> _Ftm2ObeCtrlW {
                _Ftm2ObeCtrlW { w: self }
            }
            # [ doc = "Bit 19 - FTM3 OBE CTRL bit" ]
            # [ inline ( always ) ]
            pub fn ftm3_obe_ctrl(&mut self) -> _Ftm3ObeCtrlW {
                _Ftm3ObeCtrlW { w: self }
            }
        }
    }
    # [ doc = "System Device Identification Register" ]
    pub struct Sdid {
        register: VolatileCell<u32>,
    }
    # [ doc = "System Device Identification Register" ]
    pub mod sdid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Sdid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FeaturesR {
            bits: u8,
        }
        impl FeaturesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PACKAGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PackageR {
            # [ doc = "48 LQFP" ]
            _0010,
            # [ doc = "64 LQFP" ]
            _0011,
            # [ doc = "100 LQFP" ]
            _0100,
            # [ doc = "144 LQFP" ]
            _0110,
            # [ doc = "176 LQFP" ]
            _0111,
            # [ doc = "100 MAP BGA" ]
            _1000,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PackageR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PackageR::_0010 => 2,
                    PackageR::_0011 => 3,
                    PackageR::_0100 => 4,
                    PackageR::_0110 => 6,
                    PackageR::_0111 => 7,
                    PackageR::_1000 => 8,
                    PackageR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PackageR {
                match bits {
                    2 => PackageR::_0010,
                    3 => PackageR::_0011,
                    4 => PackageR::_0100,
                    6 => PackageR::_0110,
                    7 => PackageR::_0111,
                    8 => PackageR::_1000,
                    i => PackageR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == PackageR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == PackageR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == PackageR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == PackageR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == PackageR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == PackageR::_1000
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RevidR {
            bits: u8,
        }
        impl RevidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RAMSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RamsizeR {
            # [ doc = "128 KB (S32K148), Reserved (others)" ]
            _0111,
            # [ doc = "160 KB (S32K148) , Reserved (others)" ]
            _1001,
            # [ doc = "192 KB (S32K148), 16 KB (S32K142), Reserved (others)" ]
            _1011,
            # [ doc = "48 KB (S32K144), 24 KB (S32K142), Reserved (others)" ]
            _1101,
            # [ doc = "256 KB (S32K148), 64 KB (S32K144), 32 KB (S32K142)" ]
            _1111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RamsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RamsizeR::_0111 => 7,
                    RamsizeR::_1001 => 9,
                    RamsizeR::_1011 => 11,
                    RamsizeR::_1101 => 13,
                    RamsizeR::_1111 => 15,
                    RamsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RamsizeR {
                match bits {
                    7 => RamsizeR::_0111,
                    9 => RamsizeR::_1001,
                    11 => RamsizeR::_1011,
                    13 => RamsizeR::_1101,
                    15 => RamsizeR::_1111,
                    i => RamsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == RamsizeR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == RamsizeR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == RamsizeR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == RamsizeR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == RamsizeR::_1111
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DerivateR {
            bits: u8,
        }
        impl DerivateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SubseriesR {
            bits: u8,
        }
        impl SubseriesR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct GenerationR {
            bits: u8,
        }
        impl GenerationR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Features" ]
            # [ inline ( always ) ]
            pub fn features(&self) -> FeaturesR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FeaturesR { bits }
            }
            # [ doc = "Bits 8:11 - Package" ]
            # [ inline ( always ) ]
            pub fn package(&self) -> PackageR {
                PackageR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 12:15 - Device revision number" ]
            # [ inline ( always ) ]
            pub fn revid(&self) -> RevidR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RevidR { bits }
            }
            # [ doc = "Bits 16:19 - RAM size" ]
            # [ inline ( always ) ]
            pub fn ramsize(&self) -> RamsizeR {
                RamsizeR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 20:23 - Derivate" ]
            # [ inline ( always ) ]
            pub fn derivate(&self) -> DerivateR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DerivateR { bits }
            }
            # [ doc = "Bits 24:27 - Subseries" ]
            # [ inline ( always ) ]
            pub fn subseries(&self) -> SubseriesR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SubseriesR { bits }
            }
            # [ doc = "Bits 28:31 - S32K product series generation" ]
            # [ inline ( always ) ]
            pub fn generation(&self) -> GenerationR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 28;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                GenerationR { bits }
            }
        }
    }
    # [ doc = "Platform Clock Gating Control Register" ]
    pub struct Platcgc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Platform Clock Gating Control Register" ]
    pub mod platcgc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Platcgc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGCMSCM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcmscmR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcmscmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcmscmR::_0 => 0,
                    CgcmscmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcmscmR {
                match bits {
                    0 => CgcmscmR::_0,
                    1 => CgcmscmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcmscmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcmscmR::_1
            }
        }
        # [ doc = "Possible values of the field `CGCMPU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcmpuR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcmpuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcmpuR::_0 => 0,
                    CgcmpuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcmpuR {
                match bits {
                    0 => CgcmpuR::_0,
                    1 => CgcmpuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcmpuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcmpuR::_1
            }
        }
        # [ doc = "Possible values of the field `CGCDMA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcdmaR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcdmaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcdmaR::_0 => 0,
                    CgcdmaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcdmaR {
                match bits {
                    0 => CgcdmaR::_0,
                    1 => CgcdmaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcdmaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcdmaR::_1
            }
        }
        # [ doc = "Possible values of the field `CGCERM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcermR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcermR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcermR::_0 => 0,
                    CgcermR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcermR {
                match bits {
                    0 => CgcermR::_0,
                    1 => CgcermR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcermR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcermR::_1
            }
        }
        # [ doc = "Possible values of the field `CGCEIM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgceimR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgceimR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgceimR::_0 => 0,
                    CgceimR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgceimR {
                match bits {
                    0 => CgceimR::_0,
                    1 => CgceimR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgceimR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgceimR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGCMSCM`" ]
        pub enum CgcmscmW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcmscmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcmscmW::_0 => 0,
                    CgcmscmW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcmscmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcmscmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcmscmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcmscmW::_0)
            }
            # [ doc = "Clock enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcmscmW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGCMPU`" ]
        pub enum CgcmpuW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcmpuW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcmpuW::_0 => 0,
                    CgcmpuW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcmpuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcmpuW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcmpuW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcmpuW::_0)
            }
            # [ doc = "Clock enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcmpuW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGCDMA`" ]
        pub enum CgcdmaW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcdmaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcdmaW::_0 => 0,
                    CgcdmaW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcdmaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcdmaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcdmaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcdmaW::_0)
            }
            # [ doc = "Clock enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcdmaW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGCERM`" ]
        pub enum CgcermW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgcermW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcermW::_0 => 0,
                    CgcermW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcermW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcermW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcermW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcermW::_0)
            }
            # [ doc = "Clock enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcermW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGCEIM`" ]
        pub enum CgceimW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled" ]
            _1,
        }
        impl CgceimW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgceimW::_0 => 0,
                    CgceimW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgceimW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgceimW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgceimW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgceimW::_0)
            }
            # [ doc = "Clock enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgceimW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - MSCM Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcmscm(&self) -> CgcmscmR {
                CgcmscmR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - MPU Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcmpu(&self) -> CgcmpuR {
                CgcmpuR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - DMA Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcdma(&self) -> CgcdmaR {
                CgcdmaR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - ERM Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcerm(&self) -> CgcermR {
                CgcermR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - EIM Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgceim(&self) -> CgceimR {
                CgceimR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 31 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - MSCM Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcmscm(&mut self) -> _CgcmscmW {
                _CgcmscmW { w: self }
            }
            # [ doc = "Bit 1 - MPU Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcmpu(&mut self) -> _CgcmpuW {
                _CgcmpuW { w: self }
            }
            # [ doc = "Bit 2 - DMA Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcdma(&mut self) -> _CgcdmaW {
                _CgcdmaW { w: self }
            }
            # [ doc = "Bit 3 - ERM Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgcerm(&mut self) -> _CgcermW {
                _CgcermW { w: self }
            }
            # [ doc = "Bit 4 - EIM Clock Gating Control" ]
            # [ inline ( always ) ]
            pub fn cgceim(&mut self) -> _CgceimW {
                _CgceimW { w: self }
            }
        }
    }
    # [ doc = "Flash Configuration Register 1" ]
    pub struct Fcfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Flash Configuration Register 1" ]
    pub mod fcfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fcfg1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DepartR {
            bits: u8,
        }
        impl DepartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `EEERAMSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EeeramsizeR {
            # [ doc = "4 KB" ]
            _0010,
            # [ doc = "2 KB" ]
            _0011,
            # [ doc = "1 KB" ]
            _0100,
            # [ doc = "512 Bytes" ]
            _0101,
            # [ doc = "256 Bytes" ]
            _0110,
            # [ doc = "128 Bytes" ]
            _0111,
            # [ doc = "64 Bytes" ]
            _1000,
            # [ doc = "32 Bytes" ]
            _1001,
            # [ doc = "0 Bytes" ]
            _1111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl EeeramsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EeeramsizeR::_0010 => 2,
                    EeeramsizeR::_0011 => 3,
                    EeeramsizeR::_0100 => 4,
                    EeeramsizeR::_0101 => 5,
                    EeeramsizeR::_0110 => 6,
                    EeeramsizeR::_0111 => 7,
                    EeeramsizeR::_1000 => 8,
                    EeeramsizeR::_1001 => 9,
                    EeeramsizeR::_1111 => 15,
                    EeeramsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EeeramsizeR {
                match bits {
                    2 => EeeramsizeR::_0010,
                    3 => EeeramsizeR::_0011,
                    4 => EeeramsizeR::_0100,
                    5 => EeeramsizeR::_0101,
                    6 => EeeramsizeR::_0110,
                    7 => EeeramsizeR::_0111,
                    8 => EeeramsizeR::_1000,
                    9 => EeeramsizeR::_1001,
                    15 => EeeramsizeR::_1111,
                    i => EeeramsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == EeeramsizeR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == EeeramsizeR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == EeeramsizeR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == EeeramsizeR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == EeeramsizeR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == EeeramsizeR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == EeeramsizeR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == EeeramsizeR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == EeeramsizeR::_1111
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 12:15 - FlexNVM partition" ]
            # [ inline ( always ) ]
            pub fn depart(&self) -> DepartR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 12;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DepartR { bits }
            }
            # [ doc = "Bits 16:19 - EEE SRAM SIZE" ]
            # [ inline ( always ) ]
            pub fn eeeramsize(&self) -> EeeramsizeR {
                EeeramsizeR::_from({
                                       const MASK: u8 = 15;
                                       const OFFSET: u8 = 16;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "Unique Identification Register High" ]
    pub struct Uidh {
        register: VolatileCell<u32>,
    }
    # [ doc = "Unique Identification Register High" ]
    pub mod uidh {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Uidh {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Uid12796R {
            bits: u32,
        }
        impl Uid12796R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Unique Identification" ]
            # [ inline ( always ) ]
            pub fn uid127_96(&self) -> Uid12796R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Uid12796R { bits }
            }
        }
    }
    # [ doc = "Unique Identification Register Mid-High" ]
    pub struct Uidmh {
        register: VolatileCell<u32>,
    }
    # [ doc = "Unique Identification Register Mid-High" ]
    pub mod uidmh {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Uidmh {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Uid9564R {
            bits: u32,
        }
        impl Uid9564R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Unique Identification" ]
            # [ inline ( always ) ]
            pub fn uid95_64(&self) -> Uid9564R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Uid9564R { bits }
            }
        }
    }
    # [ doc = "Unique Identification Register Mid Low" ]
    pub struct Uidml {
        register: VolatileCell<u32>,
    }
    # [ doc = "Unique Identification Register Mid Low" ]
    pub mod uidml {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Uidml {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Uid6332R {
            bits: u32,
        }
        impl Uid6332R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Unique Identification" ]
            # [ inline ( always ) ]
            pub fn uid63_32(&self) -> Uid6332R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Uid6332R { bits }
            }
        }
    }
    # [ doc = "Unique Identification Register Low" ]
    pub struct Uidl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Unique Identification Register Low" ]
    pub mod uidl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Uidl {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Uid310R {
            bits: u32,
        }
        impl Uid310R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Unique Identification" ]
            # [ inline ( always ) ]
            pub fn uid31_0(&self) -> Uid310R {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                Uid310R { bits }
            }
        }
    }
    # [ doc = "System Clock Divider Register 4" ]
    pub struct Clkdiv4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "System Clock Divider Register 4" ]
    pub mod clkdiv4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clkdiv4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TracefracR {
            bits: u8,
        }
        impl TracefracR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TracedivR {
            bits: u8,
        }
        impl TracedivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TRACEDIVEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TracedivenR {
            # [ doc = "Debug trace divider disabled" ]
            _0,
            # [ doc = "Debug trace divider enabled" ]
            _1,
        }
        impl TracedivenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TracedivenR::_0 => 0,
                    TracedivenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TracedivenR {
                match bits {
                    0 => TracedivenR::_0,
                    1 => TracedivenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TracedivenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TracedivenR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TracefracW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TracefracW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TracedivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TracedivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRACEDIVEN`" ]
        pub enum TracedivenW {
            # [ doc = "Debug trace divider disabled" ]
            _0,
            # [ doc = "Debug trace divider enabled" ]
            _1,
        }
        impl TracedivenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TracedivenW::_0 => 0,
                    TracedivenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TracedivenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TracedivenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TracedivenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Debug trace divider disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TracedivenW::_0)
            }
            # [ doc = "Debug trace divider enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TracedivenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Trace Clock Divider fraction To configure TRACEDIV and TRACEFRAC, you must first clear TRACEDIVEN to disable the trace clock divide function." ]
            # [ inline ( always ) ]
            pub fn tracefrac(&self) -> TracefracR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TracefracR { bits }
            }
            # [ doc = "Bits 1:3 - Trace Clock Divider value To configure TRACEDIV, you must first disable TRACEDIVEN, then enable it after setting TRACEDIV." ]
            # [ inline ( always ) ]
            pub fn tracediv(&self) -> TracedivR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TracedivR { bits }
            }
            # [ doc = "Bit 28 - Debug Trace Divider control" ]
            # [ inline ( always ) ]
            pub fn tracediven(&self) -> TracedivenR {
                TracedivenR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 28;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 268435456 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Trace Clock Divider fraction To configure TRACEDIV and TRACEFRAC, you must first clear TRACEDIVEN to disable the trace clock divide function." ]
            # [ inline ( always ) ]
            pub fn tracefrac(&mut self) -> _TracefracW {
                _TracefracW { w: self }
            }
            # [ doc = "Bits 1:3 - Trace Clock Divider value To configure TRACEDIV, you must first disable TRACEDIVEN, then enable it after setting TRACEDIV." ]
            # [ inline ( always ) ]
            pub fn tracediv(&mut self) -> _TracedivW {
                _TracedivW { w: self }
            }
            # [ doc = "Bit 28 - Debug Trace Divider control" ]
            # [ inline ( always ) ]
            pub fn tracediven(&mut self) -> _TracedivenW {
                _TracedivenW { w: self }
            }
        }
    }
    # [ doc = "Miscellaneous Control register 1" ]
    pub struct Misctrl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Miscellaneous Control register 1" ]
    pub mod misctrl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Misctrl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SwTrgR {
            bits: u8,
        }
        impl SwTrgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwTrgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwTrgW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Software trigger to TRGMUX. Writing to this bit generates software trigger to peripherals through TRGMUX (Refer to Figure: Trigger interconnectivity)." ]
            # [ inline ( always ) ]
            pub fn sw_trg(&self) -> SwTrgR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SwTrgR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Software trigger to TRGMUX. Writing to this bit generates software trigger to peripherals through TRGMUX (Refer to Figure: Trigger interconnectivity)." ]
            # [ inline ( always ) ]
            pub fn sw_trg(&mut self) -> _SwTrgW {
                _SwTrgW { w: self }
            }
        }
    }
}
# [ doc = "System Integration Module" ]
pub struct Sim {
    register_block: sim::RegisterBlock,
}
impl Deref for Sim {
    type Target = sim::RegisterBlock;
    fn deref(&self) -> &sim::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub const PORTA: Peripheral<Porta> = unsafe { Peripheral::new(1074040832) };
# [ doc = "Pin Control and Interrupts" ]
pub mod porta {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Pin Control Register n" ]
        pub pcr0: Pcr0,
        # [ doc = "0x04 - Pin Control Register n" ]
        pub pcr1: Pcr1,
        # [ doc = "0x08 - Pin Control Register n" ]
        pub pcr2: Pcr2,
        # [ doc = "0x0c - Pin Control Register n" ]
        pub pcr3: Pcr3,
        # [ doc = "0x10 - Pin Control Register n" ]
        pub pcr4: Pcr4,
        # [ doc = "0x14 - Pin Control Register n" ]
        pub pcr5: Pcr5,
        # [ doc = "0x18 - Pin Control Register n" ]
        pub pcr6: Pcr6,
        # [ doc = "0x1c - Pin Control Register n" ]
        pub pcr7: Pcr7,
        # [ doc = "0x20 - Pin Control Register n" ]
        pub pcr8: Pcr8,
        # [ doc = "0x24 - Pin Control Register n" ]
        pub pcr9: Pcr9,
        # [ doc = "0x28 - Pin Control Register n" ]
        pub pcr10: Pcr10,
        # [ doc = "0x2c - Pin Control Register n" ]
        pub pcr11: Pcr11,
        # [ doc = "0x30 - Pin Control Register n" ]
        pub pcr12: Pcr12,
        # [ doc = "0x34 - Pin Control Register n" ]
        pub pcr13: Pcr13,
        # [ doc = "0x38 - Pin Control Register n" ]
        pub pcr14: Pcr14,
        # [ doc = "0x3c - Pin Control Register n" ]
        pub pcr15: Pcr15,
        # [ doc = "0x40 - Pin Control Register n" ]
        pub pcr16: Pcr16,
        # [ doc = "0x44 - Pin Control Register n" ]
        pub pcr17: Pcr17,
        # [ doc = "0x48 - Pin Control Register n" ]
        pub pcr18: Pcr18,
        # [ doc = "0x4c - Pin Control Register n" ]
        pub pcr19: Pcr19,
        # [ doc = "0x50 - Pin Control Register n" ]
        pub pcr20: Pcr20,
        # [ doc = "0x54 - Pin Control Register n" ]
        pub pcr21: Pcr21,
        # [ doc = "0x58 - Pin Control Register n" ]
        pub pcr22: Pcr22,
        # [ doc = "0x5c - Pin Control Register n" ]
        pub pcr23: Pcr23,
        # [ doc = "0x60 - Pin Control Register n" ]
        pub pcr24: Pcr24,
        # [ doc = "0x64 - Pin Control Register n" ]
        pub pcr25: Pcr25,
        # [ doc = "0x68 - Pin Control Register n" ]
        pub pcr26: Pcr26,
        # [ doc = "0x6c - Pin Control Register n" ]
        pub pcr27: Pcr27,
        # [ doc = "0x70 - Pin Control Register n" ]
        pub pcr28: Pcr28,
        # [ doc = "0x74 - Pin Control Register n" ]
        pub pcr29: Pcr29,
        # [ doc = "0x78 - Pin Control Register n" ]
        pub pcr30: Pcr30,
        # [ doc = "0x7c - Pin Control Register n" ]
        pub pcr31: Pcr31,
        # [ doc = "0x80 - Global Pin Control Low Register" ]
        pub gpclr: Gpclr,
        # [ doc = "0x84 - Global Pin Control High Register" ]
        pub gpchr: Gpchr,
        _reserved0: [u8; 24usize],
        # [ doc = "0xa0 - Interrupt Status Flag Register" ]
        pub isfr: Isfr,
        _reserved1: [u8; 28usize],
        # [ doc = "0xc0 - Digital Filter Enable Register" ]
        pub dfer: Dfer,
        # [ doc = "0xc4 - Digital Filter Clock Register" ]
        pub dfcr: Dfcr,
        # [ doc = "0xc8 - Digital Filter Width Register" ]
        pub dfwr: Dfwr,
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1795 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `PFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PfeR {
            # [ doc = "Passive input filter is disabled on the corresponding pin." ]
            _0,
            # [ doc = "Passive input filter is enabled on the corresponding pin, if the pin is configured as a digital input. Refer to the device data sheet for filter characteristics." ]
            _1,
        }
        impl PfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PfeR::_0 => 0,
                    PfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PfeR {
                match bits {
                    0 => PfeR::_0,
                    1 => PfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PfeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PFE`" ]
        pub enum PfeW {
            # [ doc = "Passive input filter is disabled on the corresponding pin." ]
            _0,
            # [ doc = "Passive input filter is enabled on the corresponding pin, if the pin is configured as a digital input. Refer to the device data sheet for filter characteristics." ]
            _1,
        }
        impl PfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PfeW::_0 => 0,
                    PfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Passive input filter is disabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PfeW::_0)
            }
            # [ doc = "Passive input filter is enabled on the corresponding pin, if the pin is configured as a digital input. Refer to the device data sheet for filter characteristics." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 4 - Passive Filter Enable" ]
            # [ inline ( always ) ]
            pub fn pfe(&self) -> PfeR {
                PfeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1793 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 4 - Passive Filter Enable" ]
            # [ inline ( always ) ]
            pub fn pfe(&mut self) -> _PfeW {
                _PfeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1792 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub struct Gpclr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub mod gpclr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpclr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control High Register" ]
    pub struct Gpchr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control High Register" ]
    pub mod gpchr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpchr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub struct Isfr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub mod isfr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Isfr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                    IsfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    i => IsfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub struct Dfer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub mod dfer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfeR {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl DfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    DfeR::_0 => 0,
                    DfeR::_1 => 1,
                    DfeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> DfeR {
                match bits {
                    0 => DfeR::_0,
                    1 => DfeR::_1,
                    i => DfeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFE`" ]
        pub enum DfeW {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl DfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    DfeW::_0 => 0,
                    DfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfeW::_0)
            }
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&self) -> DfeR {
                DfeR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&mut self) -> _DfeW {
                _DfeW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub struct Dfcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub mod dfcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CsR {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CsR::_0 => 0,
                    CsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CsR {
                match bits {
                    0 => CsR::_0,
                    1 => CsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CsR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CS`" ]
        pub enum CsW {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CsW::_0 => 0,
                    CsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Digital filters are clocked by the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CsW::_0)
            }
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&self) -> CsR {
                CsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&mut self) -> _CsW {
                _CsW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Width Register" ]
    pub struct Dfwr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Width Register" ]
    pub mod dfwr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfwr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltR {
            bits: u8,
        }
        impl FiltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&self) -> FiltR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&mut self) -> _FiltW {
                _FiltW { w: self }
            }
        }
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub struct Porta {
    register_block: porta::RegisterBlock,
}
impl Deref for Porta {
    type Target = porta::RegisterBlock;
    fn deref(&self) -> &porta::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub const PORTB: Peripheral<Portb> = unsafe { Peripheral::new(1074044928) };
# [ doc = "Pin Control and Interrupts" ]
pub mod portb {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Pin Control Register n" ]
        pub pcr0: Pcr0,
        # [ doc = "0x04 - Pin Control Register n" ]
        pub pcr1: Pcr1,
        # [ doc = "0x08 - Pin Control Register n" ]
        pub pcr2: Pcr2,
        # [ doc = "0x0c - Pin Control Register n" ]
        pub pcr3: Pcr3,
        # [ doc = "0x10 - Pin Control Register n" ]
        pub pcr4: Pcr4,
        # [ doc = "0x14 - Pin Control Register n" ]
        pub pcr5: Pcr5,
        # [ doc = "0x18 - Pin Control Register n" ]
        pub pcr6: Pcr6,
        # [ doc = "0x1c - Pin Control Register n" ]
        pub pcr7: Pcr7,
        # [ doc = "0x20 - Pin Control Register n" ]
        pub pcr8: Pcr8,
        # [ doc = "0x24 - Pin Control Register n" ]
        pub pcr9: Pcr9,
        # [ doc = "0x28 - Pin Control Register n" ]
        pub pcr10: Pcr10,
        # [ doc = "0x2c - Pin Control Register n" ]
        pub pcr11: Pcr11,
        # [ doc = "0x30 - Pin Control Register n" ]
        pub pcr12: Pcr12,
        # [ doc = "0x34 - Pin Control Register n" ]
        pub pcr13: Pcr13,
        # [ doc = "0x38 - Pin Control Register n" ]
        pub pcr14: Pcr14,
        # [ doc = "0x3c - Pin Control Register n" ]
        pub pcr15: Pcr15,
        # [ doc = "0x40 - Pin Control Register n" ]
        pub pcr16: Pcr16,
        # [ doc = "0x44 - Pin Control Register n" ]
        pub pcr17: Pcr17,
        # [ doc = "0x48 - Pin Control Register n" ]
        pub pcr18: Pcr18,
        # [ doc = "0x4c - Pin Control Register n" ]
        pub pcr19: Pcr19,
        # [ doc = "0x50 - Pin Control Register n" ]
        pub pcr20: Pcr20,
        # [ doc = "0x54 - Pin Control Register n" ]
        pub pcr21: Pcr21,
        # [ doc = "0x58 - Pin Control Register n" ]
        pub pcr22: Pcr22,
        # [ doc = "0x5c - Pin Control Register n" ]
        pub pcr23: Pcr23,
        # [ doc = "0x60 - Pin Control Register n" ]
        pub pcr24: Pcr24,
        # [ doc = "0x64 - Pin Control Register n" ]
        pub pcr25: Pcr25,
        # [ doc = "0x68 - Pin Control Register n" ]
        pub pcr26: Pcr26,
        # [ doc = "0x6c - Pin Control Register n" ]
        pub pcr27: Pcr27,
        # [ doc = "0x70 - Pin Control Register n" ]
        pub pcr28: Pcr28,
        # [ doc = "0x74 - Pin Control Register n" ]
        pub pcr29: Pcr29,
        # [ doc = "0x78 - Pin Control Register n" ]
        pub pcr30: Pcr30,
        # [ doc = "0x7c - Pin Control Register n" ]
        pub pcr31: Pcr31,
        # [ doc = "0x80 - Global Pin Control Low Register" ]
        pub gpclr: Gpclr,
        # [ doc = "0x84 - Global Pin Control High Register" ]
        pub gpchr: Gpchr,
        _reserved0: [u8; 24usize],
        # [ doc = "0xa0 - Interrupt Status Flag Register" ]
        pub isfr: Isfr,
        _reserved1: [u8; 28usize],
        # [ doc = "0xc0 - Digital Filter Enable Register" ]
        pub dfer: Dfer,
        # [ doc = "0xc4 - Digital Filter Clock Register" ]
        pub dfcr: Dfcr,
        # [ doc = "0xc8 - Digital Filter Width Register" ]
        pub dfwr: Dfwr,
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub struct Gpclr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub mod gpclr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpclr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control High Register" ]
    pub struct Gpchr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control High Register" ]
    pub mod gpchr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpchr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub struct Isfr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub mod isfr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Isfr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                    IsfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    i => IsfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub struct Dfer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub mod dfer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfeR {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl DfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    DfeR::_0 => 0,
                    DfeR::_1 => 1,
                    DfeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> DfeR {
                match bits {
                    0 => DfeR::_0,
                    1 => DfeR::_1,
                    i => DfeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFE`" ]
        pub enum DfeW {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl DfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    DfeW::_0 => 0,
                    DfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfeW::_0)
            }
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&self) -> DfeR {
                DfeR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&mut self) -> _DfeW {
                _DfeW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub struct Dfcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub mod dfcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CsR {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CsR::_0 => 0,
                    CsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CsR {
                match bits {
                    0 => CsR::_0,
                    1 => CsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CsR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CS`" ]
        pub enum CsW {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CsW::_0 => 0,
                    CsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Digital filters are clocked by the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CsW::_0)
            }
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&self) -> CsR {
                CsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&mut self) -> _CsW {
                _CsW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Width Register" ]
    pub struct Dfwr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Width Register" ]
    pub mod dfwr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfwr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltR {
            bits: u8,
        }
        impl FiltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&self) -> FiltR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&mut self) -> _FiltW {
                _FiltW { w: self }
            }
        }
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub struct Portb {
    register_block: portb::RegisterBlock,
}
impl Deref for Portb {
    type Target = portb::RegisterBlock;
    fn deref(&self) -> &portb::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub const PORTC: Peripheral<Portc> = unsafe { Peripheral::new(1074049024) };
# [ doc = "Pin Control and Interrupts" ]
pub mod portc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Pin Control Register n" ]
        pub pcr0: Pcr0,
        # [ doc = "0x04 - Pin Control Register n" ]
        pub pcr1: Pcr1,
        # [ doc = "0x08 - Pin Control Register n" ]
        pub pcr2: Pcr2,
        # [ doc = "0x0c - Pin Control Register n" ]
        pub pcr3: Pcr3,
        # [ doc = "0x10 - Pin Control Register n" ]
        pub pcr4: Pcr4,
        # [ doc = "0x14 - Pin Control Register n" ]
        pub pcr5: Pcr5,
        # [ doc = "0x18 - Pin Control Register n" ]
        pub pcr6: Pcr6,
        # [ doc = "0x1c - Pin Control Register n" ]
        pub pcr7: Pcr7,
        # [ doc = "0x20 - Pin Control Register n" ]
        pub pcr8: Pcr8,
        # [ doc = "0x24 - Pin Control Register n" ]
        pub pcr9: Pcr9,
        # [ doc = "0x28 - Pin Control Register n" ]
        pub pcr10: Pcr10,
        # [ doc = "0x2c - Pin Control Register n" ]
        pub pcr11: Pcr11,
        # [ doc = "0x30 - Pin Control Register n" ]
        pub pcr12: Pcr12,
        # [ doc = "0x34 - Pin Control Register n" ]
        pub pcr13: Pcr13,
        # [ doc = "0x38 - Pin Control Register n" ]
        pub pcr14: Pcr14,
        # [ doc = "0x3c - Pin Control Register n" ]
        pub pcr15: Pcr15,
        # [ doc = "0x40 - Pin Control Register n" ]
        pub pcr16: Pcr16,
        # [ doc = "0x44 - Pin Control Register n" ]
        pub pcr17: Pcr17,
        # [ doc = "0x48 - Pin Control Register n" ]
        pub pcr18: Pcr18,
        # [ doc = "0x4c - Pin Control Register n" ]
        pub pcr19: Pcr19,
        # [ doc = "0x50 - Pin Control Register n" ]
        pub pcr20: Pcr20,
        # [ doc = "0x54 - Pin Control Register n" ]
        pub pcr21: Pcr21,
        # [ doc = "0x58 - Pin Control Register n" ]
        pub pcr22: Pcr22,
        # [ doc = "0x5c - Pin Control Register n" ]
        pub pcr23: Pcr23,
        # [ doc = "0x60 - Pin Control Register n" ]
        pub pcr24: Pcr24,
        # [ doc = "0x64 - Pin Control Register n" ]
        pub pcr25: Pcr25,
        # [ doc = "0x68 - Pin Control Register n" ]
        pub pcr26: Pcr26,
        # [ doc = "0x6c - Pin Control Register n" ]
        pub pcr27: Pcr27,
        # [ doc = "0x70 - Pin Control Register n" ]
        pub pcr28: Pcr28,
        # [ doc = "0x74 - Pin Control Register n" ]
        pub pcr29: Pcr29,
        # [ doc = "0x78 - Pin Control Register n" ]
        pub pcr30: Pcr30,
        # [ doc = "0x7c - Pin Control Register n" ]
        pub pcr31: Pcr31,
        # [ doc = "0x80 - Global Pin Control Low Register" ]
        pub gpclr: Gpclr,
        # [ doc = "0x84 - Global Pin Control High Register" ]
        pub gpchr: Gpchr,
        _reserved0: [u8; 24usize],
        # [ doc = "0xa0 - Interrupt Status Flag Register" ]
        pub isfr: Isfr,
        _reserved1: [u8; 28usize],
        # [ doc = "0xc0 - Digital Filter Enable Register" ]
        pub dfer: Dfer,
        # [ doc = "0xc4 - Digital Filter Clock Register" ]
        pub dfcr: Dfcr,
        # [ doc = "0xc8 - Digital Filter Width Register" ]
        pub dfwr: Dfwr,
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1792 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1792 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub struct Gpclr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub mod gpclr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpclr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control High Register" ]
    pub struct Gpchr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control High Register" ]
    pub mod gpchr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpchr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub struct Isfr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub mod isfr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Isfr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                    IsfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    i => IsfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub struct Dfer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub mod dfer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfeR {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl DfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    DfeR::_0 => 0,
                    DfeR::_1 => 1,
                    DfeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> DfeR {
                match bits {
                    0 => DfeR::_0,
                    1 => DfeR::_1,
                    i => DfeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFE`" ]
        pub enum DfeW {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl DfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    DfeW::_0 => 0,
                    DfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfeW::_0)
            }
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&self) -> DfeR {
                DfeR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&mut self) -> _DfeW {
                _DfeW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub struct Dfcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub mod dfcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CsR {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CsR::_0 => 0,
                    CsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CsR {
                match bits {
                    0 => CsR::_0,
                    1 => CsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CsR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CS`" ]
        pub enum CsW {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CsW::_0 => 0,
                    CsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Digital filters are clocked by the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CsW::_0)
            }
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&self) -> CsR {
                CsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&mut self) -> _CsW {
                _CsW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Width Register" ]
    pub struct Dfwr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Width Register" ]
    pub mod dfwr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfwr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltR {
            bits: u8,
        }
        impl FiltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&self) -> FiltR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&mut self) -> _FiltW {
                _FiltW { w: self }
            }
        }
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub struct Portc {
    register_block: portc::RegisterBlock,
}
impl Deref for Portc {
    type Target = portc::RegisterBlock;
    fn deref(&self) -> &portc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub const PORTD: Peripheral<Portd> = unsafe { Peripheral::new(1074053120) };
# [ doc = "Pin Control and Interrupts" ]
pub mod portd {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Pin Control Register n" ]
        pub pcr0: Pcr0,
        # [ doc = "0x04 - Pin Control Register n" ]
        pub pcr1: Pcr1,
        # [ doc = "0x08 - Pin Control Register n" ]
        pub pcr2: Pcr2,
        # [ doc = "0x0c - Pin Control Register n" ]
        pub pcr3: Pcr3,
        # [ doc = "0x10 - Pin Control Register n" ]
        pub pcr4: Pcr4,
        # [ doc = "0x14 - Pin Control Register n" ]
        pub pcr5: Pcr5,
        # [ doc = "0x18 - Pin Control Register n" ]
        pub pcr6: Pcr6,
        # [ doc = "0x1c - Pin Control Register n" ]
        pub pcr7: Pcr7,
        # [ doc = "0x20 - Pin Control Register n" ]
        pub pcr8: Pcr8,
        # [ doc = "0x24 - Pin Control Register n" ]
        pub pcr9: Pcr9,
        # [ doc = "0x28 - Pin Control Register n" ]
        pub pcr10: Pcr10,
        # [ doc = "0x2c - Pin Control Register n" ]
        pub pcr11: Pcr11,
        # [ doc = "0x30 - Pin Control Register n" ]
        pub pcr12: Pcr12,
        # [ doc = "0x34 - Pin Control Register n" ]
        pub pcr13: Pcr13,
        # [ doc = "0x38 - Pin Control Register n" ]
        pub pcr14: Pcr14,
        # [ doc = "0x3c - Pin Control Register n" ]
        pub pcr15: Pcr15,
        # [ doc = "0x40 - Pin Control Register n" ]
        pub pcr16: Pcr16,
        # [ doc = "0x44 - Pin Control Register n" ]
        pub pcr17: Pcr17,
        # [ doc = "0x48 - Pin Control Register n" ]
        pub pcr18: Pcr18,
        # [ doc = "0x4c - Pin Control Register n" ]
        pub pcr19: Pcr19,
        # [ doc = "0x50 - Pin Control Register n" ]
        pub pcr20: Pcr20,
        # [ doc = "0x54 - Pin Control Register n" ]
        pub pcr21: Pcr21,
        # [ doc = "0x58 - Pin Control Register n" ]
        pub pcr22: Pcr22,
        # [ doc = "0x5c - Pin Control Register n" ]
        pub pcr23: Pcr23,
        # [ doc = "0x60 - Pin Control Register n" ]
        pub pcr24: Pcr24,
        # [ doc = "0x64 - Pin Control Register n" ]
        pub pcr25: Pcr25,
        # [ doc = "0x68 - Pin Control Register n" ]
        pub pcr26: Pcr26,
        # [ doc = "0x6c - Pin Control Register n" ]
        pub pcr27: Pcr27,
        # [ doc = "0x70 - Pin Control Register n" ]
        pub pcr28: Pcr28,
        # [ doc = "0x74 - Pin Control Register n" ]
        pub pcr29: Pcr29,
        # [ doc = "0x78 - Pin Control Register n" ]
        pub pcr30: Pcr30,
        # [ doc = "0x7c - Pin Control Register n" ]
        pub pcr31: Pcr31,
        # [ doc = "0x80 - Global Pin Control Low Register" ]
        pub gpclr: Gpclr,
        # [ doc = "0x84 - Global Pin Control High Register" ]
        pub gpchr: Gpchr,
        _reserved0: [u8; 24usize],
        # [ doc = "0xa0 - Interrupt Status Flag Register" ]
        pub isfr: Isfr,
        _reserved1: [u8; 28usize],
        # [ doc = "0xc0 - Digital Filter Enable Register" ]
        pub dfer: Dfer,
        # [ doc = "0xc4 - Digital Filter Clock Register" ]
        pub dfcr: Dfcr,
        # [ doc = "0xc8 - Digital Filter Width Register" ]
        pub dfwr: Dfwr,
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `PFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PfeR {
            # [ doc = "Passive input filter is disabled on the corresponding pin." ]
            _0,
            # [ doc = "Passive input filter is enabled on the corresponding pin, if the pin is configured as a digital input. Refer to the device data sheet for filter characteristics." ]
            _1,
        }
        impl PfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PfeR::_0 => 0,
                    PfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PfeR {
                match bits {
                    0 => PfeR::_0,
                    1 => PfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PfeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PFE`" ]
        pub enum PfeW {
            # [ doc = "Passive input filter is disabled on the corresponding pin." ]
            _0,
            # [ doc = "Passive input filter is enabled on the corresponding pin, if the pin is configured as a digital input. Refer to the device data sheet for filter characteristics." ]
            _1,
        }
        impl PfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PfeW::_0 => 0,
                    PfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Passive input filter is disabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PfeW::_0)
            }
            # [ doc = "Passive input filter is enabled on the corresponding pin, if the pin is configured as a digital input. Refer to the device data sheet for filter characteristics." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 4 - Passive Filter Enable" ]
            # [ inline ( always ) ]
            pub fn pfe(&self) -> PfeR {
                PfeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 4 - Passive Filter Enable" ]
            # [ inline ( always ) ]
            pub fn pfe(&mut self) -> _PfeW {
                _PfeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub struct Gpclr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub mod gpclr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpclr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control High Register" ]
    pub struct Gpchr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control High Register" ]
    pub mod gpchr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpchr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub struct Isfr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub mod isfr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Isfr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                    IsfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    i => IsfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub struct Dfer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub mod dfer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfeR {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl DfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    DfeR::_0 => 0,
                    DfeR::_1 => 1,
                    DfeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> DfeR {
                match bits {
                    0 => DfeR::_0,
                    1 => DfeR::_1,
                    i => DfeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFE`" ]
        pub enum DfeW {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl DfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    DfeW::_0 => 0,
                    DfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfeW::_0)
            }
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&self) -> DfeR {
                DfeR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&mut self) -> _DfeW {
                _DfeW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub struct Dfcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub mod dfcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CsR {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CsR::_0 => 0,
                    CsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CsR {
                match bits {
                    0 => CsR::_0,
                    1 => CsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CsR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CS`" ]
        pub enum CsW {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CsW::_0 => 0,
                    CsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Digital filters are clocked by the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CsW::_0)
            }
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&self) -> CsR {
                CsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&mut self) -> _CsW {
                _CsW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Width Register" ]
    pub struct Dfwr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Width Register" ]
    pub mod dfwr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfwr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltR {
            bits: u8,
        }
        impl FiltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&self) -> FiltR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&mut self) -> _FiltW {
                _FiltW { w: self }
            }
        }
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub struct Portd {
    register_block: portd::RegisterBlock,
}
impl Deref for Portd {
    type Target = portd::RegisterBlock;
    fn deref(&self) -> &portd::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub const PORTE: Peripheral<Porte> = unsafe { Peripheral::new(1074057216) };
# [ doc = "Pin Control and Interrupts" ]
pub mod porte {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Pin Control Register n" ]
        pub pcr0: Pcr0,
        # [ doc = "0x04 - Pin Control Register n" ]
        pub pcr1: Pcr1,
        # [ doc = "0x08 - Pin Control Register n" ]
        pub pcr2: Pcr2,
        # [ doc = "0x0c - Pin Control Register n" ]
        pub pcr3: Pcr3,
        # [ doc = "0x10 - Pin Control Register n" ]
        pub pcr4: Pcr4,
        # [ doc = "0x14 - Pin Control Register n" ]
        pub pcr5: Pcr5,
        # [ doc = "0x18 - Pin Control Register n" ]
        pub pcr6: Pcr6,
        # [ doc = "0x1c - Pin Control Register n" ]
        pub pcr7: Pcr7,
        # [ doc = "0x20 - Pin Control Register n" ]
        pub pcr8: Pcr8,
        # [ doc = "0x24 - Pin Control Register n" ]
        pub pcr9: Pcr9,
        # [ doc = "0x28 - Pin Control Register n" ]
        pub pcr10: Pcr10,
        # [ doc = "0x2c - Pin Control Register n" ]
        pub pcr11: Pcr11,
        # [ doc = "0x30 - Pin Control Register n" ]
        pub pcr12: Pcr12,
        # [ doc = "0x34 - Pin Control Register n" ]
        pub pcr13: Pcr13,
        # [ doc = "0x38 - Pin Control Register n" ]
        pub pcr14: Pcr14,
        # [ doc = "0x3c - Pin Control Register n" ]
        pub pcr15: Pcr15,
        # [ doc = "0x40 - Pin Control Register n" ]
        pub pcr16: Pcr16,
        # [ doc = "0x44 - Pin Control Register n" ]
        pub pcr17: Pcr17,
        # [ doc = "0x48 - Pin Control Register n" ]
        pub pcr18: Pcr18,
        # [ doc = "0x4c - Pin Control Register n" ]
        pub pcr19: Pcr19,
        # [ doc = "0x50 - Pin Control Register n" ]
        pub pcr20: Pcr20,
        # [ doc = "0x54 - Pin Control Register n" ]
        pub pcr21: Pcr21,
        # [ doc = "0x58 - Pin Control Register n" ]
        pub pcr22: Pcr22,
        # [ doc = "0x5c - Pin Control Register n" ]
        pub pcr23: Pcr23,
        # [ doc = "0x60 - Pin Control Register n" ]
        pub pcr24: Pcr24,
        # [ doc = "0x64 - Pin Control Register n" ]
        pub pcr25: Pcr25,
        # [ doc = "0x68 - Pin Control Register n" ]
        pub pcr26: Pcr26,
        # [ doc = "0x6c - Pin Control Register n" ]
        pub pcr27: Pcr27,
        # [ doc = "0x70 - Pin Control Register n" ]
        pub pcr28: Pcr28,
        # [ doc = "0x74 - Pin Control Register n" ]
        pub pcr29: Pcr29,
        # [ doc = "0x78 - Pin Control Register n" ]
        pub pcr30: Pcr30,
        # [ doc = "0x7c - Pin Control Register n" ]
        pub pcr31: Pcr31,
        # [ doc = "0x80 - Global Pin Control Low Register" ]
        pub gpclr: Gpclr,
        # [ doc = "0x84 - Global Pin Control High Register" ]
        pub gpchr: Gpchr,
        _reserved0: [u8; 24usize],
        # [ doc = "0xa0 - Interrupt Status Flag Register" ]
        pub isfr: Isfr,
        _reserved1: [u8; 28usize],
        # [ doc = "0xc0 - Digital Filter Enable Register" ]
        pub dfer: Dfer,
        # [ doc = "0xc4 - Digital Filter Clock Register" ]
        pub dfcr: Dfcr,
        # [ doc = "0xc8 - Digital Filter Width Register" ]
        pub dfwr: Dfwr,
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `DSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DseR {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DseR::_0 => 0,
                    DseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DseR {
                match bits {
                    0 => DseR::_0,
                    1 => DseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DseR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DSE`" ]
        pub enum DseW {
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _0,
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            _1,
        }
        impl DseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DseW::_0 => 0,
                    DseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DseW::_0)
            }
            # [ doc = "High drive strength is configured on the corresponding pin, if pin is configured as a digital output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&self) -> DseR {
                DseR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 6 - Drive Strength Enable" ]
            # [ inline ( always ) ]
            pub fn dse(&mut self) -> _DseW {
                _DseW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Pin Control Register n" ]
    pub struct Pcr31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin Control Register n" ]
    pub mod pcr31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcr31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PsR {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PsR::_0 => 0,
                    PsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PsR {
                match bits {
                    0 => PsR::_0,
                    1 => PsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PsR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `MUX`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MuxR {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MuxR::_000 => 0,
                    MuxR::_001 => 1,
                    MuxR::_010 => 2,
                    MuxR::_011 => 3,
                    MuxR::_100 => 4,
                    MuxR::_101 => 5,
                    MuxR::_110 => 6,
                    MuxR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MuxR {
                match bits {
                    0 => MuxR::_000,
                    1 => MuxR::_001,
                    2 => MuxR::_010,
                    3 => MuxR::_011,
                    4 => MuxR::_100,
                    5 => MuxR::_101,
                    6 => MuxR::_110,
                    7 => MuxR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MuxR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MuxR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MuxR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MuxR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MuxR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MuxR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MuxR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MuxR::_111
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `IRQC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrqcR {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl IrqcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrqcR::_0000 => 0,
                    IrqcR::_0001 => 1,
                    IrqcR::_0010 => 2,
                    IrqcR::_0011 => 3,
                    IrqcR::_1000 => 8,
                    IrqcR::_1001 => 9,
                    IrqcR::_1010 => 10,
                    IrqcR::_1011 => 11,
                    IrqcR::_1100 => 12,
                    IrqcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrqcR {
                match bits {
                    0 => IrqcR::_0000,
                    1 => IrqcR::_0001,
                    2 => IrqcR::_0010,
                    3 => IrqcR::_0011,
                    8 => IrqcR::_1000,
                    9 => IrqcR::_1001,
                    10 => IrqcR::_1010,
                    11 => IrqcR::_1011,
                    12 => IrqcR::_1100,
                    i => IrqcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == IrqcR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == IrqcR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == IrqcR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == IrqcR::_0011
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == IrqcR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == IrqcR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == IrqcR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == IrqcR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == IrqcR::_1100
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PS`" ]
        pub enum PsW {
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _0,
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            _1,
        }
        impl PsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PsW::_0 => 0,
                    PsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pulldown resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PsW::_0)
            }
            # [ doc = "Internal pullup resistor is enabled on the corresponding pin, if the corresponding PE field is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            _0,
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Internal pullup or pulldown resistor is not enabled on the corresponding pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Internal pullup or pulldown resistor is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MUX`" ]
        pub enum MuxW {
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            _000,
            # [ doc = "Alternative 1 (GPIO)." ]
            _001,
            # [ doc = "Alternative 2 (chip-specific)." ]
            _010,
            # [ doc = "Alternative 3 (chip-specific)." ]
            _011,
            # [ doc = "Alternative 4 (chip-specific)." ]
            _100,
            # [ doc = "Alternative 5 (chip-specific)." ]
            _101,
            # [ doc = "Alternative 6 (chip-specific)." ]
            _110,
            # [ doc = "Alternative 7 (chip-specific)." ]
            _111,
        }
        impl MuxW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MuxW::_000 => 0,
                    MuxW::_001 => 1,
                    MuxW::_010 => 2,
                    MuxW::_011 => 3,
                    MuxW::_100 => 4,
                    MuxW::_101 => 5,
                    MuxW::_110 => 6,
                    MuxW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MuxW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MuxW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MuxW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin disabled (Alternative 0) (analog)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MuxW::_000)
            }
            # [ doc = "Alternative 1 (GPIO)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MuxW::_001)
            }
            # [ doc = "Alternative 2 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MuxW::_010)
            }
            # [ doc = "Alternative 3 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MuxW::_011)
            }
            # [ doc = "Alternative 4 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MuxW::_100)
            }
            # [ doc = "Alternative 5 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MuxW::_101)
            }
            # [ doc = "Alternative 6 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MuxW::_110)
            }
            # [ doc = "Alternative 7 (chip-specific)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MuxW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            _0,
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Control Register fields [15:0] are not locked." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Pin Control Register fields [15:0] are locked and cannot be updated until the next system reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IRQC`" ]
        pub enum IrqcW {
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            _0000,
            # [ doc = "ISF flag and DMA request on rising edge." ]
            _0001,
            # [ doc = "ISF flag and DMA request on falling edge." ]
            _0010,
            # [ doc = "ISF flag and DMA request on either edge." ]
            _0011,
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            _1000,
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            _1001,
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            _1010,
            # [ doc = "ISF flag and Interrupt on either edge." ]
            _1011,
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            _1100,
        }
        impl IrqcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrqcW::_0000 => 0,
                    IrqcW::_0001 => 1,
                    IrqcW::_0010 => 2,
                    IrqcW::_0011 => 3,
                    IrqcW::_1000 => 8,
                    IrqcW::_1001 => 9,
                    IrqcW::_1010 => 10,
                    IrqcW::_1011 => 11,
                    IrqcW::_1100 => 12,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrqcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrqcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrqcW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Interrupt Status Flag (ISF) is disabled." ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(IrqcW::_0000)
            }
            # [ doc = "ISF flag and DMA request on rising edge." ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(IrqcW::_0001)
            }
            # [ doc = "ISF flag and DMA request on falling edge." ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(IrqcW::_0010)
            }
            # [ doc = "ISF flag and DMA request on either edge." ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(IrqcW::_0011)
            }
            # [ doc = "ISF flag and Interrupt when logic 0." ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(IrqcW::_1000)
            }
            # [ doc = "ISF flag and Interrupt on rising-edge." ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(IrqcW::_1001)
            }
            # [ doc = "ISF flag and Interrupt on falling-edge." ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(IrqcW::_1010)
            }
            # [ doc = "ISF flag and Interrupt on either edge." ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(IrqcW::_1011)
            }
            # [ doc = "ISF flag and Interrupt when logic 1." ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(IrqcW::_1100)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&self) -> PsR {
                PsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&self) -> MuxR {
                MuxR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&self) -> IrqcR {
                IrqcR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Pull Select" ]
            # [ inline ( always ) ]
            pub fn ps(&mut self) -> _PsW {
                _PsW { w: self }
            }
            # [ doc = "Bit 1 - Pull Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bits 8:10 - Pin Mux Control" ]
            # [ inline ( always ) ]
            pub fn mux(&mut self) -> _MuxW {
                _MuxW { w: self }
            }
            # [ doc = "Bit 15 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bits 16:19 - Interrupt Configuration" ]
            # [ inline ( always ) ]
            pub fn irqc(&mut self) -> _IrqcW {
                _IrqcW { w: self }
            }
            # [ doc = "Bit 24 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub struct Gpclr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control Low Register" ]
    pub mod gpclr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpclr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Global Pin Control High Register" ]
    pub struct Gpchr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Global Pin Control High Register" ]
    pub mod gpchr {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Gpchr {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpwdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpwdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GPWE`" ]
        pub enum GpweW {
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            _0,
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            _1,
        }
        impl GpweW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u16 {
                match *self {
                    GpweW::_0 => 0,
                    GpweW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GpweW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GpweW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GpweW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Corresponding Pin Control Register is not updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GpweW::_0)
            }
            # [ doc = "Corresponding Pin Control Register is updated with the value in GPWD." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GpweW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Global Pin Write Data" ]
            # [ inline ( always ) ]
            pub fn gpwd(&mut self) -> _GpwdW {
                _GpwdW { w: self }
            }
            # [ doc = "Bits 16:31 - Global Pin Write Enable" ]
            # [ inline ( always ) ]
            pub fn gpwe(&mut self) -> _GpweW {
                _GpweW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub struct Isfr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Status Flag Register" ]
    pub mod isfr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Isfr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ISF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IsfR {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl IsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    IsfR::_0 => 0,
                    IsfR::_1 => 1,
                    IsfR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> IsfR {
                match bits {
                    0 => IsfR::_0,
                    1 => IsfR::_1,
                    i => IsfR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IsfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ISF`" ]
        pub enum IsfW {
            # [ doc = "Configured interrupt is not detected." ]
            _0,
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            _1,
        }
        impl IsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    IsfW::_0 => 0,
                    IsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IsfW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Configured interrupt is not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IsfW::_0)
            }
            # [ doc = "Configured interrupt is detected. If the pin is configured to generate a DMA request, then the corresponding flag will be cleared automatically at the completion of the requested DMA transfer. Otherwise, the flag remains set until a logic 1 is written to the flag. If the pin is configured for a level sensitive interrupt and the pin remains asserted, then the flag is set again immediately after it is cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&self) -> IsfR {
                IsfR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Interrupt Status Flag" ]
            # [ inline ( always ) ]
            pub fn isf(&mut self) -> _IsfW {
                _IsfW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub struct Dfer {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Enable Register" ]
    pub mod dfer {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfer {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DfeR {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u32),
        }
        impl DfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                match *self {
                    DfeR::_0 => 0,
                    DfeR::_1 => 1,
                    DfeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u32) -> DfeR {
                match bits {
                    0 => DfeR::_0,
                    1 => DfeR::_1,
                    i => DfeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DfeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DFE`" ]
        pub enum DfeW {
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            _0,
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            _1,
        }
        impl DfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u32 {
                match *self {
                    DfeW::_0 => 0,
                    DfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DfeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Digital filter is disabled on the corresponding pin and output of the digital filter is reset to zero." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DfeW::_0)
            }
            # [ doc = "Digital filter is enabled on the corresponding pin, if the pin is configured as a digital input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&self) -> DfeR {
                DfeR::_from({
                                const MASK: u32 = 4294967295;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u32
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Digital Filter Enable" ]
            # [ inline ( always ) ]
            pub fn dfe(&mut self) -> _DfeW {
                _DfeW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub struct Dfcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Clock Register" ]
    pub mod dfcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CsR {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CsR::_0 => 0,
                    CsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CsR {
                match bits {
                    0 => CsR::_0,
                    1 => CsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CsR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CS`" ]
        pub enum CsW {
            # [ doc = "Digital filters are clocked by the bus clock." ]
            _0,
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            _1,
        }
        impl CsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CsW::_0 => 0,
                    CsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Digital filters are clocked by the bus clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CsW::_0)
            }
            # [ doc = "Digital filters are clocked by the LPO clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&self) -> CsR {
                CsR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Clock Source" ]
            # [ inline ( always ) ]
            pub fn cs(&mut self) -> _CsW {
                _CsW { w: self }
            }
        }
    }
    # [ doc = "Digital Filter Width Register" ]
    pub struct Dfwr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Digital Filter Width Register" ]
    pub mod dfwr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Dfwr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltR {
            bits: u8,
        }
        impl FiltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&self) -> FiltR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - Filter Length" ]
            # [ inline ( always ) ]
            pub fn filt(&mut self) -> _FiltW {
                _FiltW { w: self }
            }
        }
    }
}
# [ doc = "Pin Control and Interrupts" ]
pub struct Porte {
    register_block: porte::RegisterBlock,
}
impl Deref for Porte {
    type Target = porte::RegisterBlock;
    fn deref(&self) -> &porte::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Watchdog timer" ]
pub const WDOG: Peripheral<Wdog> = unsafe { Peripheral::new(1074077696) };
# [ doc = "Watchdog timer" ]
pub mod wdog {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Watchdog Control and Status Register" ]
        pub cs: Cs,
        # [ doc = "0x04 - Watchdog Counter Register" ]
        pub cnt: Cnt,
        # [ doc = "0x08 - Watchdog Timeout Value Register" ]
        pub toval: Toval,
        # [ doc = "0x0c - Watchdog Window Register" ]
        pub win: Win,
    }
    # [ doc = "Watchdog Control and Status Register" ]
    pub struct Cs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Watchdog Control and Status Register" ]
    pub mod cs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `STOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StopR {
            # [ doc = "Watchdog disabled in chip stop mode." ]
            _0,
            # [ doc = "Watchdog enabled in chip stop mode." ]
            _1,
        }
        impl StopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StopR::_0 => 0,
                    StopR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StopR {
                match bits {
                    0 => StopR::_0,
                    1 => StopR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == StopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == StopR::_1
            }
        }
        # [ doc = "Possible values of the field `WAIT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WaitR {
            # [ doc = "Watchdog disabled in chip wait mode." ]
            _0,
            # [ doc = "Watchdog enabled in chip wait mode." ]
            _1,
        }
        impl WaitR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WaitR::_0 => 0,
                    WaitR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WaitR {
                match bits {
                    0 => WaitR::_0,
                    1 => WaitR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WaitR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WaitR::_1
            }
        }
        # [ doc = "Possible values of the field `DBG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgR {
            # [ doc = "Watchdog disabled in chip debug mode." ]
            _0,
            # [ doc = "Watchdog enabled in chip debug mode." ]
            _1,
        }
        impl DbgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgR::_0 => 0,
                    DbgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgR {
                match bits {
                    0 => DbgR::_0,
                    1 => DbgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgR::_1
            }
        }
        # [ doc = "Possible values of the field `TST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstR {
            # [ doc = "Watchdog test mode disabled." ]
            _00,
            # [ doc = "Watchdog user mode enabled. (Watchdog test mode disabled.) After testing the watchdog, software should use this setting to indicate that the watchdog is functioning normally in user mode." ]
            _01,
            # [ doc = "Watchdog test mode enabled, only the low byte is used. CNT[CNTLOW] is compared with TOVAL[TOVALLOW]." ]
            _10,
            # [ doc = "Watchdog test mode enabled, only the high byte is used. CNT[CNTHIGH] is compared with TOVAL[TOVALHIGH]." ]
            _11,
        }
        impl TstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstR::_00 => 0,
                    TstR::_01 => 1,
                    TstR::_10 => 2,
                    TstR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstR {
                match bits {
                    0 => TstR::_00,
                    1 => TstR::_01,
                    2 => TstR::_10,
                    3 => TstR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TstR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TstR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TstR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TstR::_11
            }
        }
        # [ doc = "Possible values of the field `UPDATE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum UpdateR {
            # [ doc = "Updates not allowed. After the initial configuration, the watchdog cannot be later modified without forcing a reset." ]
            _0,
            # [ doc = "Updates allowed. Software can modify the watchdog configuration registers within 8'd128 bus clocks after performing the unlock write sequence." ]
            _1,
        }
        impl UpdateR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    UpdateR::_0 => 0,
                    UpdateR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> UpdateR {
                match bits {
                    0 => UpdateR::_0,
                    1 => UpdateR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == UpdateR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == UpdateR::_1
            }
        }
        # [ doc = "Possible values of the field `INT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IntR {
            # [ doc = "Watchdog interrupts are disabled. Watchdog resets are not delayed." ]
            _0,
            # [ doc = "Watchdog interrupts are enabled. Watchdog resets are delayed by 8'd128 bus clocks from the interrupt vector fetch." ]
            _1,
        }
        impl IntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IntR::_0 => 0,
                    IntR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IntR {
                match bits {
                    0 => IntR::_0,
                    1 => IntR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IntR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IntR::_1
            }
        }
        # [ doc = "Possible values of the field `EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnR {
            # [ doc = "Watchdog disabled." ]
            _0,
            # [ doc = "Watchdog enabled." ]
            _1,
        }
        impl EnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnR::_0 => 0,
                    EnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnR {
                match bits {
                    0 => EnR::_0,
                    1 => EnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnR::_1
            }
        }
        # [ doc = "Possible values of the field `CLK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClkR {
            # [ doc = "Bus clock" ]
            _00,
            # [ doc = "LPO clock" ]
            _01,
            # [ doc = "INTCLK (internal clock)" ]
            _10,
            # [ doc = "ERCLK (external reference clock)" ]
            _11,
        }
        impl ClkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClkR::_00 => 0,
                    ClkR::_01 => 1,
                    ClkR::_10 => 2,
                    ClkR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClkR {
                match bits {
                    0 => ClkR::_00,
                    1 => ClkR::_01,
                    2 => ClkR::_10,
                    3 => ClkR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == ClkR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == ClkR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == ClkR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == ClkR::_11
            }
        }
        # [ doc = "Possible values of the field `RCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RcsR {
            # [ doc = "Reconfiguring WDOG." ]
            _0,
            # [ doc = "Reconfiguration is successful." ]
            _1,
        }
        impl RcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RcsR::_0 => 0,
                    RcsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RcsR {
                match bits {
                    0 => RcsR::_0,
                    1 => RcsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RcsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RcsR::_1
            }
        }
        # [ doc = "Possible values of the field `ULK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum UlkR {
            # [ doc = "WDOG is locked." ]
            _0,
            # [ doc = "WDOG is unlocked." ]
            _1,
        }
        impl UlkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    UlkR::_0 => 0,
                    UlkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> UlkR {
                match bits {
                    0 => UlkR::_0,
                    1 => UlkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == UlkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == UlkR::_1
            }
        }
        # [ doc = "Possible values of the field `PRES`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PresR {
            # [ doc = "256 prescaler disabled." ]
            _0,
            # [ doc = "256 prescaler enabled." ]
            _1,
        }
        impl PresR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PresR::_0 => 0,
                    PresR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PresR {
                match bits {
                    0 => PresR::_0,
                    1 => PresR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PresR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PresR::_1
            }
        }
        # [ doc = "Possible values of the field `CMD32EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Cmd32enR {
            # [ doc = "Disables support for 32-bit refresh/unlock command write words. Only 16-bit or 8-bit is supported." ]
            _0,
            # [ doc = "Enables support for 32-bit refresh/unlock command write words. 16-bit or 8-bit is NOT supported." ]
            _1,
        }
        impl Cmd32enR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Cmd32enR::_0 => 0,
                    Cmd32enR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Cmd32enR {
                match bits {
                    0 => Cmd32enR::_0,
                    1 => Cmd32enR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Cmd32enR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Cmd32enR::_1
            }
        }
        # [ doc = "Possible values of the field `FLG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FlgR {
            # [ doc = "No interrupt occurred." ]
            _0,
            # [ doc = "An interrupt occurred." ]
            _1,
        }
        impl FlgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FlgR::_0 => 0,
                    FlgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FlgR {
                match bits {
                    0 => FlgR::_0,
                    1 => FlgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FlgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FlgR::_1
            }
        }
        # [ doc = "Possible values of the field `WIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WinR {
            # [ doc = "Window mode disabled." ]
            _0,
            # [ doc = "Window mode enabled." ]
            _1,
        }
        impl WinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WinR::_0 => 0,
                    WinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WinR {
                match bits {
                    0 => WinR::_0,
                    1 => WinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WinR::_1
            }
        }
        # [ doc = "Values that can be written to the field `STOP`" ]
        pub enum StopW {
            # [ doc = "Watchdog disabled in chip stop mode." ]
            _0,
            # [ doc = "Watchdog enabled in chip stop mode." ]
            _1,
        }
        impl StopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StopW::_0 => 0,
                    StopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Watchdog disabled in chip stop mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(StopW::_0)
            }
            # [ doc = "Watchdog enabled in chip stop mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(StopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WAIT`" ]
        pub enum WaitW {
            # [ doc = "Watchdog disabled in chip wait mode." ]
            _0,
            # [ doc = "Watchdog enabled in chip wait mode." ]
            _1,
        }
        impl WaitW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WaitW::_0 => 0,
                    WaitW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WaitW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WaitW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WaitW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Watchdog disabled in chip wait mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WaitW::_0)
            }
            # [ doc = "Watchdog enabled in chip wait mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WaitW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBG`" ]
        pub enum DbgW {
            # [ doc = "Watchdog disabled in chip debug mode." ]
            _0,
            # [ doc = "Watchdog enabled in chip debug mode." ]
            _1,
        }
        impl DbgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgW::_0 => 0,
                    DbgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Watchdog disabled in chip debug mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgW::_0)
            }
            # [ doc = "Watchdog enabled in chip debug mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TST`" ]
        pub enum TstW {
            # [ doc = "Watchdog test mode disabled." ]
            _00,
            # [ doc = "Watchdog user mode enabled. (Watchdog test mode disabled.) After testing the watchdog, software should use this setting to indicate that the watchdog is functioning normally in user mode." ]
            _01,
            # [ doc = "Watchdog test mode enabled, only the low byte is used. CNT[CNTLOW] is compared with TOVAL[TOVALLOW]." ]
            _10,
            # [ doc = "Watchdog test mode enabled, only the high byte is used. CNT[CNTHIGH] is compared with TOVAL[TOVALHIGH]." ]
            _11,
        }
        impl TstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstW::_00 => 0,
                    TstW::_01 => 1,
                    TstW::_10 => 2,
                    TstW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Watchdog test mode disabled." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TstW::_00)
            }
            # [ doc = "Watchdog user mode enabled. (Watchdog test mode disabled.) After testing the watchdog, software should use this setting to indicate that the watchdog is functioning normally in user mode." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TstW::_01)
            }
            # [ doc = "Watchdog test mode enabled, only the low byte is used. CNT[CNTLOW] is compared with TOVAL[TOVALLOW]." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TstW::_10)
            }
            # [ doc = "Watchdog test mode enabled, only the high byte is used. CNT[CNTHIGH] is compared with TOVAL[TOVALHIGH]." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TstW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `UPDATE`" ]
        pub enum UpdateW {
            # [ doc = "Updates not allowed. After the initial configuration, the watchdog cannot be later modified without forcing a reset." ]
            _0,
            # [ doc = "Updates allowed. Software can modify the watchdog configuration registers within 8'd128 bus clocks after performing the unlock write sequence." ]
            _1,
        }
        impl UpdateW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    UpdateW::_0 => 0,
                    UpdateW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _UpdateW<'a> {
            w: &'a mut W,
        }
        impl<'a> _UpdateW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: UpdateW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Updates not allowed. After the initial configuration, the watchdog cannot be later modified without forcing a reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(UpdateW::_0)
            }
            # [ doc = "Updates allowed. Software can modify the watchdog configuration registers within 8'd128 bus clocks after performing the unlock write sequence." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(UpdateW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INT`" ]
        pub enum IntW {
            # [ doc = "Watchdog interrupts are disabled. Watchdog resets are not delayed." ]
            _0,
            # [ doc = "Watchdog interrupts are enabled. Watchdog resets are delayed by 8'd128 bus clocks from the interrupt vector fetch." ]
            _1,
        }
        impl IntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IntW::_0 => 0,
                    IntW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Watchdog interrupts are disabled. Watchdog resets are not delayed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IntW::_0)
            }
            # [ doc = "Watchdog interrupts are enabled. Watchdog resets are delayed by 8'd128 bus clocks from the interrupt vector fetch." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IntW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EN`" ]
        pub enum EnW {
            # [ doc = "Watchdog disabled." ]
            _0,
            # [ doc = "Watchdog enabled." ]
            _1,
        }
        impl EnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnW::_0 => 0,
                    EnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Watchdog disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnW::_0)
            }
            # [ doc = "Watchdog enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLK`" ]
        pub enum ClkW {
            # [ doc = "Bus clock" ]
            _00,
            # [ doc = "LPO clock" ]
            _01,
            # [ doc = "INTCLK (internal clock)" ]
            _10,
            # [ doc = "ERCLK (external reference clock)" ]
            _11,
        }
        impl ClkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClkW::_00 => 0,
                    ClkW::_01 => 1,
                    ClkW::_10 => 2,
                    ClkW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Bus clock" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(ClkW::_00)
            }
            # [ doc = "LPO clock" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(ClkW::_01)
            }
            # [ doc = "INTCLK (internal clock)" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(ClkW::_10)
            }
            # [ doc = "ERCLK (external reference clock)" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(ClkW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PRES`" ]
        pub enum PresW {
            # [ doc = "256 prescaler disabled." ]
            _0,
            # [ doc = "256 prescaler enabled." ]
            _1,
        }
        impl PresW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PresW::_0 => 0,
                    PresW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PresW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PresW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PresW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "256 prescaler disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PresW::_0)
            }
            # [ doc = "256 prescaler enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PresW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CMD32EN`" ]
        pub enum Cmd32enW {
            # [ doc = "Disables support for 32-bit refresh/unlock command write words. Only 16-bit or 8-bit is supported." ]
            _0,
            # [ doc = "Enables support for 32-bit refresh/unlock command write words. 16-bit or 8-bit is NOT supported." ]
            _1,
        }
        impl Cmd32enW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Cmd32enW::_0 => 0,
                    Cmd32enW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Cmd32enW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Cmd32enW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Cmd32enW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disables support for 32-bit refresh/unlock command write words. Only 16-bit or 8-bit is supported." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Cmd32enW::_0)
            }
            # [ doc = "Enables support for 32-bit refresh/unlock command write words. 16-bit or 8-bit is NOT supported." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Cmd32enW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FLG`" ]
        pub enum FlgW {
            # [ doc = "No interrupt occurred." ]
            _0,
            # [ doc = "An interrupt occurred." ]
            _1,
        }
        impl FlgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FlgW::_0 => 0,
                    FlgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FlgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FlgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FlgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No interrupt occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FlgW::_0)
            }
            # [ doc = "An interrupt occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FlgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WIN`" ]
        pub enum WinW {
            # [ doc = "Window mode disabled." ]
            _0,
            # [ doc = "Window mode enabled." ]
            _1,
        }
        impl WinW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WinW::_0 => 0,
                    WinW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WinW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WinW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WinW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Window mode disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WinW::_0)
            }
            # [ doc = "Window mode enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WinW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Stop Enable" ]
            # [ inline ( always ) ]
            pub fn stop(&self) -> StopR {
                StopR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Wait Enable" ]
            # [ inline ( always ) ]
            pub fn wait(&self) -> WaitR {
                WaitR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbg(&self) -> DbgR {
                DbgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 3:4 - Watchdog Test" ]
            # [ inline ( always ) ]
            pub fn tst(&self) -> TstR {
                TstR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Allow updates" ]
            # [ inline ( always ) ]
            pub fn update(&self) -> UpdateR {
                UpdateR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 6 - Watchdog Interrupt" ]
            # [ inline ( always ) ]
            pub fn int(&self) -> IntR {
                IntR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Watchdog Enable" ]
            # [ inline ( always ) ]
            pub fn en(&self) -> EnR {
                EnR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 7;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 8:9 - Watchdog Clock" ]
            # [ inline ( always ) ]
            pub fn clk(&self) -> ClkR {
                ClkR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Reconfiguration Success" ]
            # [ inline ( always ) ]
            pub fn rcs(&self) -> RcsR {
                RcsR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Unlock status" ]
            # [ inline ( always ) ]
            pub fn ulk(&self) -> UlkR {
                UlkR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 11;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Watchdog prescaler" ]
            # [ inline ( always ) ]
            pub fn pres(&self) -> PresR {
                PresR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 13 - Enables or disables WDOG support for 32-bit (otherwise 16-bit or 8-bit) refresh/unlock command write words" ]
            # [ inline ( always ) ]
            pub fn cmd32en(&self) -> Cmd32enR {
                Cmd32enR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 14 - Watchdog Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn flg(&self) -> FlgR {
                FlgR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - Watchdog Window" ]
            # [ inline ( always ) ]
            pub fn win(&self) -> WinR {
                WinR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 15;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 10624 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Stop Enable" ]
            # [ inline ( always ) ]
            pub fn stop(&mut self) -> _StopW {
                _StopW { w: self }
            }
            # [ doc = "Bit 1 - Wait Enable" ]
            # [ inline ( always ) ]
            pub fn wait(&mut self) -> _WaitW {
                _WaitW { w: self }
            }
            # [ doc = "Bit 2 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbg(&mut self) -> _DbgW {
                _DbgW { w: self }
            }
            # [ doc = "Bits 3:4 - Watchdog Test" ]
            # [ inline ( always ) ]
            pub fn tst(&mut self) -> _TstW {
                _TstW { w: self }
            }
            # [ doc = "Bit 5 - Allow updates" ]
            # [ inline ( always ) ]
            pub fn update(&mut self) -> _UpdateW {
                _UpdateW { w: self }
            }
            # [ doc = "Bit 6 - Watchdog Interrupt" ]
            # [ inline ( always ) ]
            pub fn int(&mut self) -> _IntW {
                _IntW { w: self }
            }
            # [ doc = "Bit 7 - Watchdog Enable" ]
            # [ inline ( always ) ]
            pub fn en(&mut self) -> _EnW {
                _EnW { w: self }
            }
            # [ doc = "Bits 8:9 - Watchdog Clock" ]
            # [ inline ( always ) ]
            pub fn clk(&mut self) -> _ClkW {
                _ClkW { w: self }
            }
            # [ doc = "Bit 12 - Watchdog prescaler" ]
            # [ inline ( always ) ]
            pub fn pres(&mut self) -> _PresW {
                _PresW { w: self }
            }
            # [ doc = "Bit 13 - Enables or disables WDOG support for 32-bit (otherwise 16-bit or 8-bit) refresh/unlock command write words" ]
            # [ inline ( always ) ]
            pub fn cmd32en(&mut self) -> _Cmd32enW {
                _Cmd32enW { w: self }
            }
            # [ doc = "Bit 14 - Watchdog Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn flg(&mut self) -> _FlgW {
                _FlgW { w: self }
            }
            # [ doc = "Bit 15 - Watchdog Window" ]
            # [ inline ( always ) ]
            pub fn win(&mut self) -> _WinW {
                _WinW { w: self }
            }
        }
    }
    # [ doc = "Watchdog Counter Register" ]
    pub struct Cnt {
        register: VolatileCell<u32>,
    }
    # [ doc = "Watchdog Counter Register" ]
    pub mod cnt {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cnt {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CntlowR {
            bits: u8,
        }
        impl CntlowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CnthighR {
            bits: u8,
        }
        impl CnthighR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CntlowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CntlowW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CnthighW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CnthighW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Low byte of the Watchdog Counter" ]
            # [ inline ( always ) ]
            pub fn cntlow(&self) -> CntlowR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CntlowR { bits }
            }
            # [ doc = "Bits 8:15 - High byte of the Watchdog Counter" ]
            # [ inline ( always ) ]
            pub fn cnthigh(&self) -> CnthighR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CnthighR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Low byte of the Watchdog Counter" ]
            # [ inline ( always ) ]
            pub fn cntlow(&mut self) -> _CntlowW {
                _CntlowW { w: self }
            }
            # [ doc = "Bits 8:15 - High byte of the Watchdog Counter" ]
            # [ inline ( always ) ]
            pub fn cnthigh(&mut self) -> _CnthighW {
                _CnthighW { w: self }
            }
        }
    }
    # [ doc = "Watchdog Timeout Value Register" ]
    pub struct Toval {
        register: VolatileCell<u32>,
    }
    # [ doc = "Watchdog Timeout Value Register" ]
    pub mod toval {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Toval {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TovallowR {
            bits: u8,
        }
        impl TovallowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TovalhighR {
            bits: u8,
        }
        impl TovalhighR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TovallowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TovallowW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TovalhighW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TovalhighW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Low byte of the timeout value" ]
            # [ inline ( always ) ]
            pub fn tovallow(&self) -> TovallowR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TovallowR { bits }
            }
            # [ doc = "Bits 8:15 - High byte of the timeout value" ]
            # [ inline ( always ) ]
            pub fn tovalhigh(&self) -> TovalhighR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TovalhighR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1024 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Low byte of the timeout value" ]
            # [ inline ( always ) ]
            pub fn tovallow(&mut self) -> _TovallowW {
                _TovallowW { w: self }
            }
            # [ doc = "Bits 8:15 - High byte of the timeout value" ]
            # [ inline ( always ) ]
            pub fn tovalhigh(&mut self) -> _TovalhighW {
                _TovalhighW { w: self }
            }
        }
    }
    # [ doc = "Watchdog Window Register" ]
    pub struct Win {
        register: VolatileCell<u32>,
    }
    # [ doc = "Watchdog Window Register" ]
    pub mod win {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Win {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct WinlowR {
            bits: u8,
        }
        impl WinlowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct WinhighR {
            bits: u8,
        }
        impl WinhighR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WinlowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WinlowW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WinhighW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WinhighW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Low byte of Watchdog Window" ]
            # [ inline ( always ) ]
            pub fn winlow(&self) -> WinlowR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                WinlowR { bits }
            }
            # [ doc = "Bits 8:15 - High byte of Watchdog Window" ]
            # [ inline ( always ) ]
            pub fn winhigh(&self) -> WinhighR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                WinhighR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Low byte of Watchdog Window" ]
            # [ inline ( always ) ]
            pub fn winlow(&mut self) -> _WinlowW {
                _WinlowW { w: self }
            }
            # [ doc = "Bits 8:15 - High byte of Watchdog Window" ]
            # [ inline ( always ) ]
            pub fn winhigh(&mut self) -> _WinhighW {
                _WinhighW { w: self }
            }
        }
    }
}
# [ doc = "Watchdog timer" ]
pub struct Wdog {
    register_block: wdog::RegisterBlock,
}
impl Deref for Wdog {
    type Target = wdog::RegisterBlock;
    fn deref(&self) -> &wdog::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "The FLEXIO Memory Map/Register Definition can be found here." ]
pub const FLEXIO: Peripheral<Flexio> = unsafe { Peripheral::new(1074110464) };
# [ doc = "The FLEXIO Memory Map/Register Definition can be found here." ]
pub mod flexio {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - FlexIO Control Register" ]
        pub ctrl: Ctrl,
        # [ doc = "0x0c - Pin State Register" ]
        pub pin: Pin,
        # [ doc = "0x10 - Shifter Status Register" ]
        pub shiftstat: Shiftstat,
        # [ doc = "0x14 - Shifter Error Register" ]
        pub shifterr: Shifterr,
        # [ doc = "0x18 - Timer Status Register" ]
        pub timstat: Timstat,
        _reserved0: [u8; 4usize],
        # [ doc = "0x20 - Shifter Status Interrupt Enable" ]
        pub shiftsien: Shiftsien,
        # [ doc = "0x24 - Shifter Error Interrupt Enable" ]
        pub shifteien: Shifteien,
        # [ doc = "0x28 - Timer Interrupt Enable Register" ]
        pub timien: Timien,
        _reserved1: [u8; 4usize],
        # [ doc = "0x30 - Shifter Status DMA Enable" ]
        pub shiftsden: Shiftsden,
        _reserved2: [u8; 76usize],
        # [ doc = "0x80 - Shifter Control N Register" ]
        pub shiftctl0: Shiftctl0,
        # [ doc = "0x84 - Shifter Control N Register" ]
        pub shiftctl1: Shiftctl1,
        # [ doc = "0x88 - Shifter Control N Register" ]
        pub shiftctl2: Shiftctl2,
        # [ doc = "0x8c - Shifter Control N Register" ]
        pub shiftctl3: Shiftctl3,
        _reserved3: [u8; 112usize],
        # [ doc = "0x100 - Shifter Configuration N Register" ]
        pub shiftcfg0: Shiftcfg0,
        # [ doc = "0x104 - Shifter Configuration N Register" ]
        pub shiftcfg1: Shiftcfg1,
        # [ doc = "0x108 - Shifter Configuration N Register" ]
        pub shiftcfg2: Shiftcfg2,
        # [ doc = "0x10c - Shifter Configuration N Register" ]
        pub shiftcfg3: Shiftcfg3,
        _reserved4: [u8; 240usize],
        # [ doc = "0x200 - Shifter Buffer N Register" ]
        pub shiftbuf0: Shiftbuf0,
        # [ doc = "0x204 - Shifter Buffer N Register" ]
        pub shiftbuf1: Shiftbuf1,
        # [ doc = "0x208 - Shifter Buffer N Register" ]
        pub shiftbuf2: Shiftbuf2,
        # [ doc = "0x20c - Shifter Buffer N Register" ]
        pub shiftbuf3: Shiftbuf3,
        _reserved5: [u8; 112usize],
        # [ doc = "0x280 - Shifter Buffer N Bit Swapped Register" ]
        pub shiftbufbis0: Shiftbufbis0,
        # [ doc = "0x284 - Shifter Buffer N Bit Swapped Register" ]
        pub shiftbufbis1: Shiftbufbis1,
        # [ doc = "0x288 - Shifter Buffer N Bit Swapped Register" ]
        pub shiftbufbis2: Shiftbufbis2,
        # [ doc = "0x28c - Shifter Buffer N Bit Swapped Register" ]
        pub shiftbufbis3: Shiftbufbis3,
        _reserved6: [u8; 112usize],
        # [ doc = "0x300 - Shifter Buffer N Byte Swapped Register" ]
        pub shiftbufbys0: Shiftbufbys0,
        # [ doc = "0x304 - Shifter Buffer N Byte Swapped Register" ]
        pub shiftbufbys1: Shiftbufbys1,
        # [ doc = "0x308 - Shifter Buffer N Byte Swapped Register" ]
        pub shiftbufbys2: Shiftbufbys2,
        # [ doc = "0x30c - Shifter Buffer N Byte Swapped Register" ]
        pub shiftbufbys3: Shiftbufbys3,
        _reserved7: [u8; 112usize],
        # [ doc = "0x380 - Shifter Buffer N Bit Byte Swapped Register" ]
        pub shiftbufbbs0: Shiftbufbbs0,
        # [ doc = "0x384 - Shifter Buffer N Bit Byte Swapped Register" ]
        pub shiftbufbbs1: Shiftbufbbs1,
        # [ doc = "0x388 - Shifter Buffer N Bit Byte Swapped Register" ]
        pub shiftbufbbs2: Shiftbufbbs2,
        # [ doc = "0x38c - Shifter Buffer N Bit Byte Swapped Register" ]
        pub shiftbufbbs3: Shiftbufbbs3,
        _reserved8: [u8; 112usize],
        # [ doc = "0x400 - Timer Control N Register" ]
        pub timctl0: Timctl0,
        # [ doc = "0x404 - Timer Control N Register" ]
        pub timctl1: Timctl1,
        # [ doc = "0x408 - Timer Control N Register" ]
        pub timctl2: Timctl2,
        # [ doc = "0x40c - Timer Control N Register" ]
        pub timctl3: Timctl3,
        _reserved9: [u8; 112usize],
        # [ doc = "0x480 - Timer Configuration N Register" ]
        pub timcfg0: Timcfg0,
        # [ doc = "0x484 - Timer Configuration N Register" ]
        pub timcfg1: Timcfg1,
        # [ doc = "0x488 - Timer Configuration N Register" ]
        pub timcfg2: Timcfg2,
        # [ doc = "0x48c - Timer Configuration N Register" ]
        pub timcfg3: Timcfg3,
        _reserved10: [u8; 112usize],
        # [ doc = "0x500 - Timer Compare N Register" ]
        pub timcmp0: Timcmp0,
        # [ doc = "0x504 - Timer Compare N Register" ]
        pub timcmp1: Timcmp1,
        # [ doc = "0x508 - Timer Compare N Register" ]
        pub timcmp2: Timcmp2,
        # [ doc = "0x50c - Timer Compare N Register" ]
        pub timcmp3: Timcmp3,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard features implemented." ]
            _0000000000000000,
            # [ doc = "Supports state, logic and parallel modes." ]
            _0000000000000001,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000000 => 0,
                    FeatureR::_0000000000000001 => 1,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    0 => FeatureR::_0000000000000000,
                    1 => FeatureR::_0000000000000001,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000000`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000000(&self) -> bool {
                *self == FeatureR::_0000000000000000
            }
            # [ doc = "Checks if the value of the field is `_0000000000000001`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000001(&self) -> bool {
                *self == FeatureR::_0000000000000001
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Specification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShifterR {
            bits: u8,
        }
        impl ShifterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimerR {
            bits: u8,
        }
        impl TimerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinR {
            bits: u8,
        }
        impl PinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TriggerR {
            bits: u8,
        }
        impl TriggerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Shifter Number" ]
            # [ inline ( always ) ]
            pub fn shifter(&self) -> ShifterR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ShifterR { bits }
            }
            # [ doc = "Bits 8:15 - Timer Number" ]
            # [ inline ( always ) ]
            pub fn timer(&self) -> TimerR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TimerR { bits }
            }
            # [ doc = "Bits 16:23 - Pin Number" ]
            # [ inline ( always ) ]
            pub fn pin(&self) -> PinR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinR { bits }
            }
            # [ doc = "Bits 24:31 - Trigger Number" ]
            # [ inline ( always ) ]
            pub fn trigger(&self) -> TriggerR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TriggerR { bits }
            }
        }
    }
    # [ doc = "FlexIO Control Register" ]
    pub struct Ctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "FlexIO Control Register" ]
    pub mod ctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FLEXEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FlexenR {
            # [ doc = "FlexIO module is disabled." ]
            _0,
            # [ doc = "FlexIO module is enabled." ]
            _1,
        }
        impl FlexenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FlexenR::_0 => 0,
                    FlexenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FlexenR {
                match bits {
                    0 => FlexenR::_0,
                    1 => FlexenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FlexenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FlexenR::_1
            }
        }
        # [ doc = "Possible values of the field `SWRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwrstR {
            # [ doc = "Software reset is disabled" ]
            _0,
            # [ doc = "Software reset is enabled, all FlexIO registers except the Control Register are reset." ]
            _1,
        }
        impl SwrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwrstR::_0 => 0,
                    SwrstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwrstR {
                match bits {
                    0 => SwrstR::_0,
                    1 => SwrstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwrstR::_1
            }
        }
        # [ doc = "Possible values of the field `FASTACC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FastaccR {
            # [ doc = "Configures for normal register accesses to FlexIO" ]
            _0,
            # [ doc = "Configures for fast register accesses to FlexIO" ]
            _1,
        }
        impl FastaccR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FastaccR::_0 => 0,
                    FastaccR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FastaccR {
                match bits {
                    0 => FastaccR::_0,
                    1 => FastaccR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FastaccR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FastaccR::_1
            }
        }
        # [ doc = "Possible values of the field `DBGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgeR {
            # [ doc = "FlexIO is disabled in debug modes." ]
            _0,
            # [ doc = "FlexIO is enabled in debug modes" ]
            _1,
        }
        impl DbgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgeR::_0 => 0,
                    DbgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgeR {
                match bits {
                    0 => DbgeR::_0,
                    1 => DbgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgeR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozenR {
            # [ doc = "FlexIO enabled in Doze modes." ]
            _0,
            # [ doc = "FlexIO disabled in Doze modes." ]
            _1,
        }
        impl DozenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozenR::_0 => 0,
                    DozenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozenR {
                match bits {
                    0 => DozenR::_0,
                    1 => DozenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FLEXEN`" ]
        pub enum FlexenW {
            # [ doc = "FlexIO module is disabled." ]
            _0,
            # [ doc = "FlexIO module is enabled." ]
            _1,
        }
        impl FlexenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FlexenW::_0 => 0,
                    FlexenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FlexenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FlexenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FlexenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FlexIO module is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FlexenW::_0)
            }
            # [ doc = "FlexIO module is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FlexenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWRST`" ]
        pub enum SwrstW {
            # [ doc = "Software reset is disabled" ]
            _0,
            # [ doc = "Software reset is enabled, all FlexIO registers except the Control Register are reset." ]
            _1,
        }
        impl SwrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwrstW::_0 => 0,
                    SwrstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwrstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Software reset is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwrstW::_0)
            }
            # [ doc = "Software reset is enabled, all FlexIO registers except the Control Register are reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwrstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FASTACC`" ]
        pub enum FastaccW {
            # [ doc = "Configures for normal register accesses to FlexIO" ]
            _0,
            # [ doc = "Configures for fast register accesses to FlexIO" ]
            _1,
        }
        impl FastaccW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FastaccW::_0 => 0,
                    FastaccW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FastaccW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FastaccW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FastaccW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configures for normal register accesses to FlexIO" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FastaccW::_0)
            }
            # [ doc = "Configures for fast register accesses to FlexIO" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FastaccW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBGE`" ]
        pub enum DbgeW {
            # [ doc = "FlexIO is disabled in debug modes." ]
            _0,
            # [ doc = "FlexIO is enabled in debug modes" ]
            _1,
        }
        impl DbgeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgeW::_0 => 0,
                    DbgeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FlexIO is disabled in debug modes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgeW::_0)
            }
            # [ doc = "FlexIO is enabled in debug modes" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEN`" ]
        pub enum DozenW {
            # [ doc = "FlexIO enabled in Doze modes." ]
            _0,
            # [ doc = "FlexIO disabled in Doze modes." ]
            _1,
        }
        impl DozenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozenW::_0 => 0,
                    DozenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FlexIO enabled in Doze modes." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozenW::_0)
            }
            # [ doc = "FlexIO disabled in Doze modes." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - FlexIO Enable" ]
            # [ inline ( always ) ]
            pub fn flexen(&self) -> FlexenR {
                FlexenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn swrst(&self) -> SwrstR {
                SwrstR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Fast Access" ]
            # [ inline ( always ) ]
            pub fn fastacc(&self) -> FastaccR {
                FastaccR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 2;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 30 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbge(&self) -> DbgeR {
                DbgeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 31 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&self) -> DozenR {
                DozenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - FlexIO Enable" ]
            # [ inline ( always ) ]
            pub fn flexen(&mut self) -> _FlexenW {
                _FlexenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn swrst(&mut self) -> _SwrstW {
                _SwrstW { w: self }
            }
            # [ doc = "Bit 2 - Fast Access" ]
            # [ inline ( always ) ]
            pub fn fastacc(&mut self) -> _FastaccW {
                _FastaccW { w: self }
            }
            # [ doc = "Bit 30 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbge(&mut self) -> _DbgeW {
                _DbgeW { w: self }
            }
            # [ doc = "Bit 31 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&mut self) -> _DozenW {
                _DozenW { w: self }
            }
        }
    }
    # [ doc = "Pin State Register" ]
    pub struct Pin {
        register: VolatileCell<u32>,
    }
    # [ doc = "Pin State Register" ]
    pub mod pin {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pin {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdiR {
            bits: u8,
        }
        impl PdiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Pin Data Input" ]
            # [ inline ( always ) ]
            pub fn pdi(&self) -> PdiR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PdiR { bits }
            }
        }
    }
    # [ doc = "Shifter Status Register" ]
    pub struct Shiftstat {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Status Register" ]
    pub mod shiftstat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftstat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SsfR {
            bits: u8,
        }
        impl SsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsfW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Shifter Status Flag" ]
            # [ inline ( always ) ]
            pub fn ssf(&self) -> SsfR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SsfR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Shifter Status Flag" ]
            # [ inline ( always ) ]
            pub fn ssf(&mut self) -> _SsfW {
                _SsfW { w: self }
            }
        }
    }
    # [ doc = "Shifter Error Register" ]
    pub struct Shifterr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Error Register" ]
    pub mod shifterr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shifterr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SefR {
            bits: u8,
        }
        impl SefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SefW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Shifter Error Flags" ]
            # [ inline ( always ) ]
            pub fn sef(&self) -> SefR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SefR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Shifter Error Flags" ]
            # [ inline ( always ) ]
            pub fn sef(&mut self) -> _SefW {
                _SefW { w: self }
            }
        }
    }
    # [ doc = "Timer Status Register" ]
    pub struct Timstat {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Status Register" ]
    pub mod timstat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timstat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TsfR {
            bits: u8,
        }
        impl TsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TsfW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Timer Status Flags" ]
            # [ inline ( always ) ]
            pub fn tsf(&self) -> TsfR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TsfR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Timer Status Flags" ]
            # [ inline ( always ) ]
            pub fn tsf(&mut self) -> _TsfW {
                _TsfW { w: self }
            }
        }
    }
    # [ doc = "Shifter Status Interrupt Enable" ]
    pub struct Shiftsien {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Status Interrupt Enable" ]
    pub mod shiftsien {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftsien {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SsieR {
            bits: u8,
        }
        impl SsieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsieW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Shifter Status Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ssie(&self) -> SsieR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SsieR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Shifter Status Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ssie(&mut self) -> _SsieW {
                _SsieW { w: self }
            }
        }
    }
    # [ doc = "Shifter Error Interrupt Enable" ]
    pub struct Shifteien {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Error Interrupt Enable" ]
    pub mod shifteien {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shifteien {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SeieR {
            bits: u8,
        }
        impl SeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SeieW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Shifter Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn seie(&self) -> SeieR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SeieR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Shifter Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn seie(&mut self) -> _SeieW {
                _SeieW { w: self }
            }
        }
    }
    # [ doc = "Timer Interrupt Enable Register" ]
    pub struct Timien {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Interrupt Enable Register" ]
    pub mod timien {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timien {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TeieR {
            bits: u8,
        }
        impl TeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeieW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Timer Status Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&self) -> TeieR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TeieR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Timer Status Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn teie(&mut self) -> _TeieW {
                _TeieW { w: self }
            }
        }
    }
    # [ doc = "Shifter Status DMA Enable" ]
    pub struct Shiftsden {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Status DMA Enable" ]
    pub mod shiftsden {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftsden {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SsdeR {
            bits: u8,
        }
        impl SsdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsdeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Shifter Status DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ssde(&self) -> SsdeR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SsdeR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Shifter Status DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ssde(&mut self) -> _SsdeW {
                _SsdeW { w: self }
            }
        }
    }
    # [ doc = "Shifter Control N Register" ]
    pub struct Shiftctl0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Control N Register" ]
    pub mod shiftctl0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftctl0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_1 => 1,
                    SmodR::_10 => 2,
                    SmodR::_100 => 4,
                    SmodR::_101 => 5,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    1 => SmodR::_1,
                    2 => SmodR::_10,
                    4 => SmodR::_100,
                    5 => SmodR::_101,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SmodR::_10
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == SmodR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == SmodR::_101
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimpolR {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimpolR::_0 => 0,
                    TimpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimpolR {
                match bits {
                    0 => TimpolR::_0,
                    1 => TimpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimselR {
            bits: u8,
        }
        impl TimselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                    SmodW::_1 => 1,
                    SmodW::_10 => 2,
                    SmodW::_100 => 4,
                    SmodW::_101 => 5,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmodW::_1)
            }
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SmodW::_10)
            }
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(SmodW::_100)
            }
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(SmodW::_101)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shifter pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Shifter pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Shifter pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMPOL`" ]
        pub enum TimpolW {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimpolW::_0 => 0,
                    TimpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shift on posedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimpolW::_0)
            }
            # [ doc = "Shift on negedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&self) -> TimpolR {
                TimpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&self) -> TimselR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TimselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&mut self) -> _TimpolW {
                _TimpolW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&mut self) -> _TimselW {
                _TimselW { w: self }
            }
        }
    }
    # [ doc = "Shifter Control N Register" ]
    pub struct Shiftctl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Control N Register" ]
    pub mod shiftctl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftctl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_1 => 1,
                    SmodR::_10 => 2,
                    SmodR::_100 => 4,
                    SmodR::_101 => 5,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    1 => SmodR::_1,
                    2 => SmodR::_10,
                    4 => SmodR::_100,
                    5 => SmodR::_101,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SmodR::_10
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == SmodR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == SmodR::_101
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimpolR {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimpolR::_0 => 0,
                    TimpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimpolR {
                match bits {
                    0 => TimpolR::_0,
                    1 => TimpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimselR {
            bits: u8,
        }
        impl TimselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                    SmodW::_1 => 1,
                    SmodW::_10 => 2,
                    SmodW::_100 => 4,
                    SmodW::_101 => 5,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmodW::_1)
            }
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SmodW::_10)
            }
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(SmodW::_100)
            }
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(SmodW::_101)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shifter pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Shifter pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Shifter pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMPOL`" ]
        pub enum TimpolW {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimpolW::_0 => 0,
                    TimpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shift on posedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimpolW::_0)
            }
            # [ doc = "Shift on negedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&self) -> TimpolR {
                TimpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&self) -> TimselR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TimselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&mut self) -> _TimpolW {
                _TimpolW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&mut self) -> _TimselW {
                _TimselW { w: self }
            }
        }
    }
    # [ doc = "Shifter Control N Register" ]
    pub struct Shiftctl2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Control N Register" ]
    pub mod shiftctl2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftctl2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_1 => 1,
                    SmodR::_10 => 2,
                    SmodR::_100 => 4,
                    SmodR::_101 => 5,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    1 => SmodR::_1,
                    2 => SmodR::_10,
                    4 => SmodR::_100,
                    5 => SmodR::_101,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SmodR::_10
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == SmodR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == SmodR::_101
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimpolR {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimpolR::_0 => 0,
                    TimpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimpolR {
                match bits {
                    0 => TimpolR::_0,
                    1 => TimpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimselR {
            bits: u8,
        }
        impl TimselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                    SmodW::_1 => 1,
                    SmodW::_10 => 2,
                    SmodW::_100 => 4,
                    SmodW::_101 => 5,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmodW::_1)
            }
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SmodW::_10)
            }
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(SmodW::_100)
            }
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(SmodW::_101)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shifter pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Shifter pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Shifter pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMPOL`" ]
        pub enum TimpolW {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimpolW::_0 => 0,
                    TimpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shift on posedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimpolW::_0)
            }
            # [ doc = "Shift on negedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&self) -> TimpolR {
                TimpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&self) -> TimselR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TimselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&mut self) -> _TimpolW {
                _TimpolW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&mut self) -> _TimselW {
                _TimselW { w: self }
            }
        }
    }
    # [ doc = "Shifter Control N Register" ]
    pub struct Shiftctl3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Control N Register" ]
    pub mod shiftctl3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftctl3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmodR {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl SmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmodR::_0 => 0,
                    SmodR::_1 => 1,
                    SmodR::_10 => 2,
                    SmodR::_100 => 4,
                    SmodR::_101 => 5,
                    SmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmodR {
                match bits {
                    0 => SmodR::_0,
                    1 => SmodR::_1,
                    2 => SmodR::_10,
                    4 => SmodR::_100,
                    5 => SmodR::_101,
                    i => SmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SmodR::_10
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == SmodR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == SmodR::_101
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimpolR {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimpolR::_0 => 0,
                    TimpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimpolR {
                match bits {
                    0 => TimpolR::_0,
                    1 => TimpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TimselR {
            bits: u8,
        }
        impl TimselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `SMOD`" ]
        pub enum SmodW {
            # [ doc = "Disabled." ]
            _0,
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            _1,
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            _10,
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            _100,
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            _101,
        }
        impl SmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmodW::_0 => 0,
                    SmodW::_1 => 1,
                    SmodW::_10 => 2,
                    SmodW::_100 => 4,
                    SmodW::_101 => 5,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmodW::_0)
            }
            # [ doc = "Receive mode. Captures the current Shifter content into the SHIFTBUF on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmodW::_1)
            }
            # [ doc = "Transmit mode. Load SHIFTBUF contents into the Shifter on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SmodW::_10)
            }
            # [ doc = "Match Store mode. Shifter data is compared to SHIFTBUF content on expiration of the Timer." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(SmodW::_100)
            }
            # [ doc = "Match Continuous mode. Shifter data is continuously compared to SHIFTBUF contents." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(SmodW::_101)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Shifter pin output disabled" ]
            _0,
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Shifter pin bidirectional output data" ]
            _10,
            # [ doc = "Shifter pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shifter pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Shifter pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Shifter pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Shifter pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMPOL`" ]
        pub enum TimpolW {
            # [ doc = "Shift on posedge of Shift clock" ]
            _0,
            # [ doc = "Shift on negedge of Shift clock" ]
            _1,
        }
        impl TimpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimpolW::_0 => 0,
                    TimpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Shift on posedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimpolW::_0)
            }
            # [ doc = "Shift on negedge of Shift clock" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&self) -> SmodR {
                SmodR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&self) -> TimpolR {
                TimpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&self) -> TimselR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TimselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Shifter Mode" ]
            # [ inline ( always ) ]
            pub fn smod(&mut self) -> _SmodW {
                _SmodW { w: self }
            }
            # [ doc = "Bit 7 - Shifter Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Shifter Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Shifter Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 23 - Timer Polarity" ]
            # [ inline ( always ) ]
            pub fn timpol(&mut self) -> _TimpolW {
                _TimpolW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Select" ]
            # [ inline ( always ) ]
            pub fn timsel(&mut self) -> _TimselW {
                _TimselW { w: self }
            }
        }
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub struct Shiftcfg0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub mod shiftcfg0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftcfg0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstartR {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstartR::_0 => 0,
                    SstartR::_1 => 1,
                    SstartR::_10 => 2,
                    SstartR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstartR {
                match bits {
                    0 => SstartR::_0,
                    1 => SstartR::_1,
                    2 => SstartR::_10,
                    3 => SstartR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstartR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstartR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstartR::_11
            }
        }
        # [ doc = "Possible values of the field `SSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstopR {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstopR::_0 => 0,
                    SstopR::_1 => 1,
                    SstopR::_10 => 2,
                    SstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstopR {
                match bits {
                    0 => SstopR::_0,
                    1 => SstopR::_1,
                    2 => SstopR::_10,
                    3 => SstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstopR::_11
            }
        }
        # [ doc = "Possible values of the field `INSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InsrcR {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InsrcR::_0 => 0,
                    InsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InsrcR {
                match bits {
                    0 => InsrcR::_0,
                    1 => InsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InsrcR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SSTART`" ]
        pub enum SstartW {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstartW::_0 => 0,
                    SstartW::_1 => 1,
                    SstartW::_10 => 2,
                    SstartW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstartW::_0)
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstartW::_1)
            }
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstartW::_10)
            }
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstartW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSTOP`" ]
        pub enum SstopW {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstopW::_0 => 0,
                    SstopW::_1 => 1,
                    SstopW::_10 => 2,
                    SstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstopW::_0)
            }
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstopW::_1)
            }
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstopW::_10)
            }
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INSRC`" ]
        pub enum InsrcW {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InsrcW::_0 => 0,
                    InsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InsrcW::_0)
            }
            # [ doc = "Shifter N+1 Output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&self) -> SstartR {
                SstartR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&self) -> SstopR {
                SstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&self) -> InsrcR {
                InsrcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&mut self) -> _SstartW {
                _SstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&mut self) -> _SstopW {
                _SstopW { w: self }
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&mut self) -> _InsrcW {
                _InsrcW { w: self }
            }
        }
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub struct Shiftcfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub mod shiftcfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftcfg1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstartR {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstartR::_0 => 0,
                    SstartR::_1 => 1,
                    SstartR::_10 => 2,
                    SstartR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstartR {
                match bits {
                    0 => SstartR::_0,
                    1 => SstartR::_1,
                    2 => SstartR::_10,
                    3 => SstartR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstartR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstartR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstartR::_11
            }
        }
        # [ doc = "Possible values of the field `SSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstopR {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstopR::_0 => 0,
                    SstopR::_1 => 1,
                    SstopR::_10 => 2,
                    SstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstopR {
                match bits {
                    0 => SstopR::_0,
                    1 => SstopR::_1,
                    2 => SstopR::_10,
                    3 => SstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstopR::_11
            }
        }
        # [ doc = "Possible values of the field `INSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InsrcR {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InsrcR::_0 => 0,
                    InsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InsrcR {
                match bits {
                    0 => InsrcR::_0,
                    1 => InsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InsrcR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SSTART`" ]
        pub enum SstartW {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstartW::_0 => 0,
                    SstartW::_1 => 1,
                    SstartW::_10 => 2,
                    SstartW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstartW::_0)
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstartW::_1)
            }
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstartW::_10)
            }
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstartW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSTOP`" ]
        pub enum SstopW {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstopW::_0 => 0,
                    SstopW::_1 => 1,
                    SstopW::_10 => 2,
                    SstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstopW::_0)
            }
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstopW::_1)
            }
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstopW::_10)
            }
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INSRC`" ]
        pub enum InsrcW {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InsrcW::_0 => 0,
                    InsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InsrcW::_0)
            }
            # [ doc = "Shifter N+1 Output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&self) -> SstartR {
                SstartR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&self) -> SstopR {
                SstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&self) -> InsrcR {
                InsrcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&mut self) -> _SstartW {
                _SstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&mut self) -> _SstopW {
                _SstopW { w: self }
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&mut self) -> _InsrcW {
                _InsrcW { w: self }
            }
        }
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub struct Shiftcfg2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub mod shiftcfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftcfg2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstartR {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstartR::_0 => 0,
                    SstartR::_1 => 1,
                    SstartR::_10 => 2,
                    SstartR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstartR {
                match bits {
                    0 => SstartR::_0,
                    1 => SstartR::_1,
                    2 => SstartR::_10,
                    3 => SstartR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstartR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstartR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstartR::_11
            }
        }
        # [ doc = "Possible values of the field `SSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstopR {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstopR::_0 => 0,
                    SstopR::_1 => 1,
                    SstopR::_10 => 2,
                    SstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstopR {
                match bits {
                    0 => SstopR::_0,
                    1 => SstopR::_1,
                    2 => SstopR::_10,
                    3 => SstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstopR::_11
            }
        }
        # [ doc = "Possible values of the field `INSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InsrcR {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InsrcR::_0 => 0,
                    InsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InsrcR {
                match bits {
                    0 => InsrcR::_0,
                    1 => InsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InsrcR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SSTART`" ]
        pub enum SstartW {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstartW::_0 => 0,
                    SstartW::_1 => 1,
                    SstartW::_10 => 2,
                    SstartW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstartW::_0)
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstartW::_1)
            }
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstartW::_10)
            }
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstartW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSTOP`" ]
        pub enum SstopW {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstopW::_0 => 0,
                    SstopW::_1 => 1,
                    SstopW::_10 => 2,
                    SstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstopW::_0)
            }
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstopW::_1)
            }
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstopW::_10)
            }
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INSRC`" ]
        pub enum InsrcW {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InsrcW::_0 => 0,
                    InsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InsrcW::_0)
            }
            # [ doc = "Shifter N+1 Output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&self) -> SstartR {
                SstartR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&self) -> SstopR {
                SstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&self) -> InsrcR {
                InsrcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&mut self) -> _SstartW {
                _SstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&mut self) -> _SstopW {
                _SstopW { w: self }
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&mut self) -> _InsrcW {
                _InsrcW { w: self }
            }
        }
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub struct Shiftcfg3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Configuration N Register" ]
    pub mod shiftcfg3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftcfg3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstartR {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstartR::_0 => 0,
                    SstartR::_1 => 1,
                    SstartR::_10 => 2,
                    SstartR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstartR {
                match bits {
                    0 => SstartR::_0,
                    1 => SstartR::_1,
                    2 => SstartR::_10,
                    3 => SstartR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstartR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstartR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstartR::_11
            }
        }
        # [ doc = "Possible values of the field `SSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SstopR {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SstopR::_0 => 0,
                    SstopR::_1 => 1,
                    SstopR::_10 => 2,
                    SstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SstopR {
                match bits {
                    0 => SstopR::_0,
                    1 => SstopR::_1,
                    2 => SstopR::_10,
                    3 => SstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SstopR::_11
            }
        }
        # [ doc = "Possible values of the field `INSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InsrcR {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InsrcR::_0 => 0,
                    InsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InsrcR {
                match bits {
                    0 => InsrcR::_0,
                    1 => InsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InsrcR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SSTART`" ]
        pub enum SstartW {
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            _0,
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            _1,
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            _11,
        }
        impl SstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstartW::_0 => 0,
                    SstartW::_1 => 1,
                    SstartW::_10 => 2,
                    SstartW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on enable" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstartW::_0)
            }
            # [ doc = "Start bit disabled for transmitter/receiver/match store, transmitter loads data on first shift" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstartW::_1)
            }
            # [ doc = "Transmitter outputs start bit value 0 before loading data on first shift, receiver/match store sets error flag if start bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstartW::_10)
            }
            # [ doc = "Transmitter outputs start bit value 1 before loading data on first shift, receiver/match store sets error flag if start bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstartW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSTOP`" ]
        pub enum SstopW {
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            _0,
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            _1,
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            _10,
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            _11,
        }
        impl SstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SstopW::_0 => 0,
                    SstopW::_1 => 1,
                    SstopW::_10 => 2,
                    SstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SstopW::_0)
            }
            # [ doc = "Reserved for transmitter/receiver/match store" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SstopW::_1)
            }
            # [ doc = "Transmitter outputs stop bit value 0 on store, receiver/match store sets error flag if stop bit is not 0" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SstopW::_10)
            }
            # [ doc = "Transmitter outputs stop bit value 1 on store, receiver/match store sets error flag if stop bit is not 1" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INSRC`" ]
        pub enum InsrcW {
            # [ doc = "Pin" ]
            _0,
            # [ doc = "Shifter N+1 Output" ]
            _1,
        }
        impl InsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InsrcW::_0 => 0,
                    InsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InsrcW::_0)
            }
            # [ doc = "Shifter N+1 Output" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&self) -> SstartR {
                SstartR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&self) -> SstopR {
                SstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&self) -> InsrcR {
                InsrcR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Shifter Start bit" ]
            # [ inline ( always ) ]
            pub fn sstart(&mut self) -> _SstartW {
                _SstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Shifter Stop bit" ]
            # [ inline ( always ) ]
            pub fn sstop(&mut self) -> _SstopW {
                _SstopW { w: self }
            }
            # [ doc = "Bit 8 - Input Source" ]
            # [ inline ( always ) ]
            pub fn insrc(&mut self) -> _InsrcW {
                _InsrcW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub struct Shiftbuf0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub mod shiftbuf0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbuf0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufR {
            bits: u32,
        }
        impl ShiftbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&self) -> ShiftbufR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&mut self) -> _ShiftbufW {
                _ShiftbufW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub struct Shiftbuf1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub mod shiftbuf1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbuf1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufR {
            bits: u32,
        }
        impl ShiftbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&self) -> ShiftbufR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&mut self) -> _ShiftbufW {
                _ShiftbufW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub struct Shiftbuf2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub mod shiftbuf2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbuf2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufR {
            bits: u32,
        }
        impl ShiftbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&self) -> ShiftbufR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&mut self) -> _ShiftbufW {
                _ShiftbufW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub struct Shiftbuf3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Register" ]
    pub mod shiftbuf3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbuf3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufR {
            bits: u32,
        }
        impl ShiftbufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&self) -> ShiftbufR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbuf(&mut self) -> _ShiftbufW {
                _ShiftbufW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub struct Shiftbufbis0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub mod shiftbufbis0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbis0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbisR {
            bits: u32,
        }
        impl ShiftbufbisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbisW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&self) -> ShiftbufbisR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbisR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&mut self) -> _ShiftbufbisW {
                _ShiftbufbisW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub struct Shiftbufbis1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub mod shiftbufbis1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbis1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbisR {
            bits: u32,
        }
        impl ShiftbufbisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbisW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&self) -> ShiftbufbisR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbisR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&mut self) -> _ShiftbufbisW {
                _ShiftbufbisW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub struct Shiftbufbis2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub mod shiftbufbis2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbis2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbisR {
            bits: u32,
        }
        impl ShiftbufbisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbisW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&self) -> ShiftbufbisR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbisR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&mut self) -> _ShiftbufbisW {
                _ShiftbufbisW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub struct Shiftbufbis3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Swapped Register" ]
    pub mod shiftbufbis3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbis3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbisR {
            bits: u32,
        }
        impl ShiftbufbisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbisW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&self) -> ShiftbufbisR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbisR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbis(&mut self) -> _ShiftbufbisW {
                _ShiftbufbisW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub struct Shiftbufbys0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub mod shiftbufbys0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbys0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbysR {
            bits: u32,
        }
        impl ShiftbufbysR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbysW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbysW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&self) -> ShiftbufbysR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbysR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&mut self) -> _ShiftbufbysW {
                _ShiftbufbysW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub struct Shiftbufbys1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub mod shiftbufbys1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbys1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbysR {
            bits: u32,
        }
        impl ShiftbufbysR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbysW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbysW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&self) -> ShiftbufbysR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbysR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&mut self) -> _ShiftbufbysW {
                _ShiftbufbysW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub struct Shiftbufbys2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub mod shiftbufbys2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbys2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbysR {
            bits: u32,
        }
        impl ShiftbufbysR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbysW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbysW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&self) -> ShiftbufbysR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbysR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&mut self) -> _ShiftbufbysW {
                _ShiftbufbysW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub struct Shiftbufbys3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Byte Swapped Register" ]
    pub mod shiftbufbys3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbys3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbysR {
            bits: u32,
        }
        impl ShiftbufbysR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbysW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbysW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&self) -> ShiftbufbysR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbysR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbys(&mut self) -> _ShiftbufbysW {
                _ShiftbufbysW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub struct Shiftbufbbs0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub mod shiftbufbbs0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbbs0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbbsR {
            bits: u32,
        }
        impl ShiftbufbbsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbbsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbbsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&self) -> ShiftbufbbsR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbbsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&mut self) -> _ShiftbufbbsW {
                _ShiftbufbbsW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub struct Shiftbufbbs1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub mod shiftbufbbs1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbbs1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbbsR {
            bits: u32,
        }
        impl ShiftbufbbsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbbsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbbsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&self) -> ShiftbufbbsR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbbsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&mut self) -> _ShiftbufbbsW {
                _ShiftbufbbsW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub struct Shiftbufbbs2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub mod shiftbufbbs2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbbs2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbbsR {
            bits: u32,
        }
        impl ShiftbufbbsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbbsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbbsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&self) -> ShiftbufbbsR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbbsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&mut self) -> _ShiftbufbbsW {
                _ShiftbufbbsW { w: self }
            }
        }
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub struct Shiftbufbbs3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Shifter Buffer N Bit Byte Swapped Register" ]
    pub mod shiftbufbbs3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Shiftbufbbs3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ShiftbufbbsR {
            bits: u32,
        }
        impl ShiftbufbbsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ShiftbufbbsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ShiftbufbbsW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&self) -> ShiftbufbbsR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                ShiftbufbbsR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Shift Buffer" ]
            # [ inline ( always ) ]
            pub fn shiftbufbbs(&mut self) -> _ShiftbufbbsW {
                _ShiftbufbbsW { w: self }
            }
        }
    }
    # [ doc = "Timer Control N Register" ]
    pub struct Timctl0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control N Register" ]
    pub mod timctl0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timctl0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimodR {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimodR::_0 => 0,
                    TimodR::_1 => 1,
                    TimodR::_10 => 2,
                    TimodR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimodR {
                match bits {
                    0 => TimodR::_0,
                    1 => TimodR::_1,
                    2 => TimodR::_10,
                    3 => TimodR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimodR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimodR::_11
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TRGSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgsrcR {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgsrcR::_0 => 0,
                    TrgsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgsrcR {
                match bits {
                    0 => TrgsrcR::_0,
                    1 => TrgsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgpolR {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgpolR::_0 => 0,
                    TrgpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgpolR {
                match bits {
                    0 => TrgpolR::_0,
                    1 => TrgpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgselR {
            bits: u8,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `TIMOD`" ]
        pub enum TimodW {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimodW::_0 => 0,
                    TimodW::_1 => 1,
                    TimodW::_10 => 2,
                    TimodW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimodW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimodW::_0)
            }
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimodW::_1)
            }
            # [ doc = "Dual 8-bit counters PWM mode." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimodW::_10)
            }
            # [ doc = "Single 16-bit counter mode." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimodW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Timer pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Timer pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGSRC`" ]
        pub enum TrgsrcW {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgsrcW::_0 => 0,
                    TrgsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "External trigger selected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgsrcW::_0)
            }
            # [ doc = "Internal trigger selected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGPOL`" ]
        pub enum TrgpolW {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgpolW::_0 => 0,
                    TrgpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgpolW::_0)
            }
            # [ doc = "Trigger active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&self) -> TimodR {
                TimodR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&self) -> TrgsrcR {
                TrgsrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&self) -> TrgpolR {
                TrgpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&mut self) -> _TimodW {
                _TimodW { w: self }
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&mut self) -> _TrgsrcW {
                _TrgsrcW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&mut self) -> _TrgpolW {
                _TrgpolW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "Timer Control N Register" ]
    pub struct Timctl1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control N Register" ]
    pub mod timctl1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timctl1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimodR {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimodR::_0 => 0,
                    TimodR::_1 => 1,
                    TimodR::_10 => 2,
                    TimodR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimodR {
                match bits {
                    0 => TimodR::_0,
                    1 => TimodR::_1,
                    2 => TimodR::_10,
                    3 => TimodR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimodR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimodR::_11
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TRGSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgsrcR {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgsrcR::_0 => 0,
                    TrgsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgsrcR {
                match bits {
                    0 => TrgsrcR::_0,
                    1 => TrgsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgpolR {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgpolR::_0 => 0,
                    TrgpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgpolR {
                match bits {
                    0 => TrgpolR::_0,
                    1 => TrgpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgselR {
            bits: u8,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `TIMOD`" ]
        pub enum TimodW {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimodW::_0 => 0,
                    TimodW::_1 => 1,
                    TimodW::_10 => 2,
                    TimodW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimodW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimodW::_0)
            }
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimodW::_1)
            }
            # [ doc = "Dual 8-bit counters PWM mode." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimodW::_10)
            }
            # [ doc = "Single 16-bit counter mode." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimodW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Timer pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Timer pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGSRC`" ]
        pub enum TrgsrcW {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgsrcW::_0 => 0,
                    TrgsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "External trigger selected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgsrcW::_0)
            }
            # [ doc = "Internal trigger selected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGPOL`" ]
        pub enum TrgpolW {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgpolW::_0 => 0,
                    TrgpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgpolW::_0)
            }
            # [ doc = "Trigger active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&self) -> TimodR {
                TimodR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&self) -> TrgsrcR {
                TrgsrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&self) -> TrgpolR {
                TrgpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&mut self) -> _TimodW {
                _TimodW { w: self }
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&mut self) -> _TrgsrcW {
                _TrgsrcW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&mut self) -> _TrgpolW {
                _TrgpolW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "Timer Control N Register" ]
    pub struct Timctl2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control N Register" ]
    pub mod timctl2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timctl2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimodR {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimodR::_0 => 0,
                    TimodR::_1 => 1,
                    TimodR::_10 => 2,
                    TimodR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimodR {
                match bits {
                    0 => TimodR::_0,
                    1 => TimodR::_1,
                    2 => TimodR::_10,
                    3 => TimodR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimodR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimodR::_11
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TRGSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgsrcR {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgsrcR::_0 => 0,
                    TrgsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgsrcR {
                match bits {
                    0 => TrgsrcR::_0,
                    1 => TrgsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgpolR {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgpolR::_0 => 0,
                    TrgpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgpolR {
                match bits {
                    0 => TrgpolR::_0,
                    1 => TrgpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgselR {
            bits: u8,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `TIMOD`" ]
        pub enum TimodW {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimodW::_0 => 0,
                    TimodW::_1 => 1,
                    TimodW::_10 => 2,
                    TimodW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimodW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimodW::_0)
            }
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimodW::_1)
            }
            # [ doc = "Dual 8-bit counters PWM mode." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimodW::_10)
            }
            # [ doc = "Single 16-bit counter mode." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimodW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Timer pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Timer pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGSRC`" ]
        pub enum TrgsrcW {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgsrcW::_0 => 0,
                    TrgsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "External trigger selected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgsrcW::_0)
            }
            # [ doc = "Internal trigger selected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGPOL`" ]
        pub enum TrgpolW {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgpolW::_0 => 0,
                    TrgpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgpolW::_0)
            }
            # [ doc = "Trigger active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&self) -> TimodR {
                TimodR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&self) -> TrgsrcR {
                TrgsrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&self) -> TrgpolR {
                TrgpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&mut self) -> _TimodW {
                _TimodW { w: self }
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&mut self) -> _TrgsrcW {
                _TrgsrcW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&mut self) -> _TrgpolW {
                _TrgpolW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "Timer Control N Register" ]
    pub struct Timctl3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Control N Register" ]
    pub mod timctl3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timctl3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TIMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimodR {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimodR::_0 => 0,
                    TimodR::_1 => 1,
                    TimodR::_10 => 2,
                    TimodR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimodR {
                match bits {
                    0 => TimodR::_0,
                    1 => TimodR::_1,
                    2 => TimodR::_10,
                    3 => TimodR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimodR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimodR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimodR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimodR::_11
            }
        }
        # [ doc = "Possible values of the field `PINPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinpolR {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinpolR::_0 => 0,
                    PinpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinpolR {
                match bits {
                    0 => PinpolR::_0,
                    1 => PinpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinselR {
            bits: u8,
        }
        impl PinselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_0 => 0,
                    PincfgR::_1 => 1,
                    PincfgR::_10 => 2,
                    PincfgR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_0,
                    1 => PincfgR::_1,
                    2 => PincfgR::_10,
                    3 => PincfgR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PincfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PincfgR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == PincfgR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == PincfgR::_11
            }
        }
        # [ doc = "Possible values of the field `TRGSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgsrcR {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgsrcR::_0 => 0,
                    TrgsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgsrcR {
                match bits {
                    0 => TrgsrcR::_0,
                    1 => TrgsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `TRGPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgpolR {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgpolR::_0 => 0,
                    TrgpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgpolR {
                match bits {
                    0 => TrgpolR::_0,
                    1 => TrgpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TrgpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TrgpolR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TrgselR {
            bits: u8,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `TIMOD`" ]
        pub enum TimodW {
            # [ doc = "Timer Disabled." ]
            _0,
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            _1,
            # [ doc = "Dual 8-bit counters PWM mode." ]
            _10,
            # [ doc = "Single 16-bit counter mode." ]
            _11,
        }
        impl TimodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimodW::_0 => 0,
                    TimodW::_1 => 1,
                    TimodW::_10 => 2,
                    TimodW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimodW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer Disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimodW::_0)
            }
            # [ doc = "Dual 8-bit counters baud/bit mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimodW::_1)
            }
            # [ doc = "Dual 8-bit counters PWM mode." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimodW::_10)
            }
            # [ doc = "Single 16-bit counter mode." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimodW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINPOL`" ]
        pub enum PinpolW {
            # [ doc = "Pin is active high" ]
            _0,
            # [ doc = "Pin is active low" ]
            _1,
        }
        impl PinpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinpolW::_0 => 0,
                    PinpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin is active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinpolW::_0)
            }
            # [ doc = "Pin is active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "Timer pin output disabled" ]
            _0,
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            _1,
            # [ doc = "Timer pin bidirectional output data" ]
            _10,
            # [ doc = "Timer pin output" ]
            _11,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_0 => 0,
                    PincfgW::_1 => 1,
                    PincfgW::_10 => 2,
                    PincfgW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer pin output disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PincfgW::_0)
            }
            # [ doc = "Timer pin open drain or bidirectional output enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PincfgW::_1)
            }
            # [ doc = "Timer pin bidirectional output data" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(PincfgW::_10)
            }
            # [ doc = "Timer pin output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(PincfgW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGSRC`" ]
        pub enum TrgsrcW {
            # [ doc = "External trigger selected" ]
            _0,
            # [ doc = "Internal trigger selected" ]
            _1,
        }
        impl TrgsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgsrcW::_0 => 0,
                    TrgsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "External trigger selected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgsrcW::_0)
            }
            # [ doc = "Internal trigger selected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TRGPOL`" ]
        pub enum TrgpolW {
            # [ doc = "Trigger active high" ]
            _0,
            # [ doc = "Trigger active low" ]
            _1,
        }
        impl TrgpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgpolW::_0 => 0,
                    TrgpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Trigger active high" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TrgpolW::_0)
            }
            # [ doc = "Trigger active low" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TrgpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&self) -> TimodR {
                TimodR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&self) -> PinpolR {
                PinpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&self) -> PinselR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PinselR { bits }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&self) -> TrgsrcR {
                TrgsrcR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&self) -> TrgpolR {
                TrgpolR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TrgselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Timer Mode" ]
            # [ inline ( always ) ]
            pub fn timod(&mut self) -> _TimodW {
                _TimodW { w: self }
            }
            # [ doc = "Bit 7 - Timer Pin Polarity" ]
            # [ inline ( always ) ]
            pub fn pinpol(&mut self) -> _PinpolW {
                _PinpolW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Pin Select" ]
            # [ inline ( always ) ]
            pub fn pinsel(&mut self) -> _PinselW {
                _PinselW { w: self }
            }
            # [ doc = "Bits 16:17 - Timer Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
            # [ doc = "Bit 22 - Trigger Source" ]
            # [ inline ( always ) ]
            pub fn trgsrc(&mut self) -> _TrgsrcW {
                _TrgsrcW { w: self }
            }
            # [ doc = "Bit 23 - Trigger Polarity" ]
            # [ inline ( always ) ]
            pub fn trgpol(&mut self) -> _TrgpolW {
                _TrgpolW { w: self }
            }
            # [ doc = "Bits 24:27 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "Timer Configuration N Register" ]
    pub struct Timcfg0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Configuration N Register" ]
    pub mod timcfg0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcfg0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstartR {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstartR::_0 => 0,
                    TstartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstartR {
                match bits {
                    0 => TstartR::_0,
                    1 => TstartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstartR::_1
            }
        }
        # [ doc = "Possible values of the field `TSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstopR {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstopR::_0 => 0,
                    TstopR::_1 => 1,
                    TstopR::_10 => 2,
                    TstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstopR {
                match bits {
                    0 => TstopR::_0,
                    1 => TstopR::_1,
                    2 => TstopR::_10,
                    3 => TstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TstopR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMENA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimenaR {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimenaR::_0 => 0,
                    TimenaR::_1 => 1,
                    TimenaR::_10 => 2,
                    TimenaR::_11 => 3,
                    TimenaR::_100 => 4,
                    TimenaR::_101 => 5,
                    TimenaR::_110 => 6,
                    TimenaR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimenaR {
                match bits {
                    0 => TimenaR::_0,
                    1 => TimenaR::_1,
                    2 => TimenaR::_10,
                    3 => TimenaR::_11,
                    4 => TimenaR::_100,
                    5 => TimenaR::_101,
                    6 => TimenaR::_110,
                    7 => TimenaR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimenaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimenaR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimenaR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimenaR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimenaR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimenaR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimenaR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimenaR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdisR {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdisR::_0 => 0,
                    TimdisR::_1 => 1,
                    TimdisR::_10 => 2,
                    TimdisR::_11 => 3,
                    TimdisR::_100 => 4,
                    TimdisR::_101 => 5,
                    TimdisR::_110 => 6,
                    TimdisR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdisR {
                match bits {
                    0 => TimdisR::_0,
                    1 => TimdisR::_1,
                    2 => TimdisR::_10,
                    3 => TimdisR::_11,
                    4 => TimdisR::_100,
                    5 => TimdisR::_101,
                    6 => TimdisR::_110,
                    i => TimdisR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdisR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdisR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdisR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimdisR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimdisR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimdisR::_110
            }
        }
        # [ doc = "Possible values of the field `TIMRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimrstR {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimrstR::_0 => 0,
                    TimrstR::_10 => 2,
                    TimrstR::_11 => 3,
                    TimrstR::_100 => 4,
                    TimrstR::_110 => 6,
                    TimrstR::_111 => 7,
                    TimrstR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimrstR {
                match bits {
                    0 => TimrstR::_0,
                    2 => TimrstR::_10,
                    3 => TimrstR::_11,
                    4 => TimrstR::_100,
                    6 => TimrstR::_110,
                    7 => TimrstR::_111,
                    i => TimrstR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimrstR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimrstR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimrstR::_100
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimrstR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimrstR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDEC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdecR {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdecR::_0 => 0,
                    TimdecR::_1 => 1,
                    TimdecR::_10 => 2,
                    TimdecR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdecR {
                match bits {
                    0 => TimdecR::_0,
                    1 => TimdecR::_1,
                    2 => TimdecR::_10,
                    3 => TimdecR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdecR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdecR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdecR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMOUT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimoutR {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimoutR::_0 => 0,
                    TimoutR::_1 => 1,
                    TimoutR::_10 => 2,
                    TimoutR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimoutR {
                match bits {
                    0 => TimoutR::_0,
                    1 => TimoutR::_1,
                    2 => TimoutR::_10,
                    3 => TimoutR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimoutR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimoutR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimoutR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimoutR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TSTART`" ]
        pub enum TstartW {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstartW::_0 => 0,
                    TstartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstartW::_0)
            }
            # [ doc = "Start bit enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSTOP`" ]
        pub enum TstopW {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstopW::_0 => 0,
                    TstopW::_1 => 1,
                    TstopW::_10 => 2,
                    TstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstopW::_0)
            }
            # [ doc = "Stop bit is enabled on timer compare" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstopW::_1)
            }
            # [ doc = "Stop bit is enabled on timer disable" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TstopW::_10)
            }
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMENA`" ]
        pub enum TimenaW {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimenaW::_0 => 0,
                    TimenaW::_1 => 1,
                    TimenaW::_10 => 2,
                    TimenaW::_11 => 3,
                    TimenaW::_100 => 4,
                    TimenaW::_101 => 5,
                    TimenaW::_110 => 6,
                    TimenaW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimenaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimenaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimenaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer always enabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimenaW::_0)
            }
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimenaW::_1)
            }
            # [ doc = "Timer enabled on Trigger high" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimenaW::_10)
            }
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimenaW::_11)
            }
            # [ doc = "Timer enabled on Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimenaW::_100)
            }
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimenaW::_101)
            }
            # [ doc = "Timer enabled on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimenaW::_110)
            }
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimenaW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDIS`" ]
        pub enum TimdisW {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
        }
        impl TimdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdisW::_0 => 0,
                    TimdisW::_1 => 1,
                    TimdisW::_10 => 2,
                    TimdisW::_11 => 3,
                    TimdisW::_100 => 4,
                    TimdisW::_101 => 5,
                    TimdisW::_110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdisW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdisW::_0)
            }
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdisW::_1)
            }
            # [ doc = "Timer disabled on Timer compare" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdisW::_10)
            }
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdisW::_11)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimdisW::_100)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimdisW::_101)
            }
            # [ doc = "Timer disabled on Trigger falling edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimdisW::_110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMRST`" ]
        pub enum TimrstW {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
        }
        impl TimrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimrstW::_0 => 0,
                    TimrstW::_10 => 2,
                    TimrstW::_11 => 3,
                    TimrstW::_100 => 4,
                    TimrstW::_110 => 6,
                    TimrstW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimrstW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimrstW::_0)
            }
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimrstW::_10)
            }
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimrstW::_11)
            }
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimrstW::_100)
            }
            # [ doc = "Timer reset on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimrstW::_110)
            }
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimrstW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDEC`" ]
        pub enum TimdecW {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdecW::_0 => 0,
                    TimdecW::_1 => 1,
                    TimdecW::_10 => 2,
                    TimdecW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdecW::_0)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdecW::_1)
            }
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdecW::_10)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdecW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMOUT`" ]
        pub enum TimoutW {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimoutW::_0 => 0,
                    TimoutW::_1 => 1,
                    TimoutW::_10 => 2,
                    TimoutW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimoutW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimoutW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimoutW::_0)
            }
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimoutW::_1)
            }
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimoutW::_10)
            }
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimoutW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&self) -> TstartR {
                TstartR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&self) -> TstopR {
                TstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&self) -> TimenaR {
                TimenaR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&self) -> TimdisR {
                TimdisR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&self) -> TimrstR {
                TimrstR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&self) -> TimdecR {
                TimdecR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&self) -> TimoutR {
                TimoutR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&mut self) -> _TstartW {
                _TstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&mut self) -> _TstopW {
                _TstopW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&mut self) -> _TimenaW {
                _TimenaW { w: self }
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&mut self) -> _TimdisW {
                _TimdisW { w: self }
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&mut self) -> _TimrstW {
                _TimrstW { w: self }
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&mut self) -> _TimdecW {
                _TimdecW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&mut self) -> _TimoutW {
                _TimoutW { w: self }
            }
        }
    }
    # [ doc = "Timer Configuration N Register" ]
    pub struct Timcfg1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Configuration N Register" ]
    pub mod timcfg1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcfg1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstartR {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstartR::_0 => 0,
                    TstartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstartR {
                match bits {
                    0 => TstartR::_0,
                    1 => TstartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstartR::_1
            }
        }
        # [ doc = "Possible values of the field `TSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstopR {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstopR::_0 => 0,
                    TstopR::_1 => 1,
                    TstopR::_10 => 2,
                    TstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstopR {
                match bits {
                    0 => TstopR::_0,
                    1 => TstopR::_1,
                    2 => TstopR::_10,
                    3 => TstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TstopR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMENA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimenaR {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimenaR::_0 => 0,
                    TimenaR::_1 => 1,
                    TimenaR::_10 => 2,
                    TimenaR::_11 => 3,
                    TimenaR::_100 => 4,
                    TimenaR::_101 => 5,
                    TimenaR::_110 => 6,
                    TimenaR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimenaR {
                match bits {
                    0 => TimenaR::_0,
                    1 => TimenaR::_1,
                    2 => TimenaR::_10,
                    3 => TimenaR::_11,
                    4 => TimenaR::_100,
                    5 => TimenaR::_101,
                    6 => TimenaR::_110,
                    7 => TimenaR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimenaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimenaR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimenaR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimenaR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimenaR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimenaR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimenaR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimenaR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdisR {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdisR::_0 => 0,
                    TimdisR::_1 => 1,
                    TimdisR::_10 => 2,
                    TimdisR::_11 => 3,
                    TimdisR::_100 => 4,
                    TimdisR::_101 => 5,
                    TimdisR::_110 => 6,
                    TimdisR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdisR {
                match bits {
                    0 => TimdisR::_0,
                    1 => TimdisR::_1,
                    2 => TimdisR::_10,
                    3 => TimdisR::_11,
                    4 => TimdisR::_100,
                    5 => TimdisR::_101,
                    6 => TimdisR::_110,
                    i => TimdisR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdisR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdisR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdisR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimdisR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimdisR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimdisR::_110
            }
        }
        # [ doc = "Possible values of the field `TIMRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimrstR {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimrstR::_0 => 0,
                    TimrstR::_10 => 2,
                    TimrstR::_11 => 3,
                    TimrstR::_100 => 4,
                    TimrstR::_110 => 6,
                    TimrstR::_111 => 7,
                    TimrstR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimrstR {
                match bits {
                    0 => TimrstR::_0,
                    2 => TimrstR::_10,
                    3 => TimrstR::_11,
                    4 => TimrstR::_100,
                    6 => TimrstR::_110,
                    7 => TimrstR::_111,
                    i => TimrstR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimrstR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimrstR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimrstR::_100
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimrstR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimrstR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDEC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdecR {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdecR::_0 => 0,
                    TimdecR::_1 => 1,
                    TimdecR::_10 => 2,
                    TimdecR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdecR {
                match bits {
                    0 => TimdecR::_0,
                    1 => TimdecR::_1,
                    2 => TimdecR::_10,
                    3 => TimdecR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdecR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdecR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdecR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMOUT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimoutR {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimoutR::_0 => 0,
                    TimoutR::_1 => 1,
                    TimoutR::_10 => 2,
                    TimoutR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimoutR {
                match bits {
                    0 => TimoutR::_0,
                    1 => TimoutR::_1,
                    2 => TimoutR::_10,
                    3 => TimoutR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimoutR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimoutR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimoutR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimoutR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TSTART`" ]
        pub enum TstartW {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstartW::_0 => 0,
                    TstartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstartW::_0)
            }
            # [ doc = "Start bit enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSTOP`" ]
        pub enum TstopW {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstopW::_0 => 0,
                    TstopW::_1 => 1,
                    TstopW::_10 => 2,
                    TstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstopW::_0)
            }
            # [ doc = "Stop bit is enabled on timer compare" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstopW::_1)
            }
            # [ doc = "Stop bit is enabled on timer disable" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TstopW::_10)
            }
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMENA`" ]
        pub enum TimenaW {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimenaW::_0 => 0,
                    TimenaW::_1 => 1,
                    TimenaW::_10 => 2,
                    TimenaW::_11 => 3,
                    TimenaW::_100 => 4,
                    TimenaW::_101 => 5,
                    TimenaW::_110 => 6,
                    TimenaW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimenaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimenaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimenaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer always enabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimenaW::_0)
            }
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimenaW::_1)
            }
            # [ doc = "Timer enabled on Trigger high" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimenaW::_10)
            }
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimenaW::_11)
            }
            # [ doc = "Timer enabled on Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimenaW::_100)
            }
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimenaW::_101)
            }
            # [ doc = "Timer enabled on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimenaW::_110)
            }
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimenaW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDIS`" ]
        pub enum TimdisW {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
        }
        impl TimdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdisW::_0 => 0,
                    TimdisW::_1 => 1,
                    TimdisW::_10 => 2,
                    TimdisW::_11 => 3,
                    TimdisW::_100 => 4,
                    TimdisW::_101 => 5,
                    TimdisW::_110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdisW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdisW::_0)
            }
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdisW::_1)
            }
            # [ doc = "Timer disabled on Timer compare" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdisW::_10)
            }
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdisW::_11)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimdisW::_100)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimdisW::_101)
            }
            # [ doc = "Timer disabled on Trigger falling edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimdisW::_110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMRST`" ]
        pub enum TimrstW {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
        }
        impl TimrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimrstW::_0 => 0,
                    TimrstW::_10 => 2,
                    TimrstW::_11 => 3,
                    TimrstW::_100 => 4,
                    TimrstW::_110 => 6,
                    TimrstW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimrstW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimrstW::_0)
            }
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimrstW::_10)
            }
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimrstW::_11)
            }
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimrstW::_100)
            }
            # [ doc = "Timer reset on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimrstW::_110)
            }
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimrstW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDEC`" ]
        pub enum TimdecW {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdecW::_0 => 0,
                    TimdecW::_1 => 1,
                    TimdecW::_10 => 2,
                    TimdecW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdecW::_0)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdecW::_1)
            }
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdecW::_10)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdecW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMOUT`" ]
        pub enum TimoutW {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimoutW::_0 => 0,
                    TimoutW::_1 => 1,
                    TimoutW::_10 => 2,
                    TimoutW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimoutW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimoutW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimoutW::_0)
            }
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimoutW::_1)
            }
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimoutW::_10)
            }
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimoutW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&self) -> TstartR {
                TstartR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&self) -> TstopR {
                TstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&self) -> TimenaR {
                TimenaR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&self) -> TimdisR {
                TimdisR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&self) -> TimrstR {
                TimrstR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&self) -> TimdecR {
                TimdecR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&self) -> TimoutR {
                TimoutR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&mut self) -> _TstartW {
                _TstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&mut self) -> _TstopW {
                _TstopW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&mut self) -> _TimenaW {
                _TimenaW { w: self }
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&mut self) -> _TimdisW {
                _TimdisW { w: self }
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&mut self) -> _TimrstW {
                _TimrstW { w: self }
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&mut self) -> _TimdecW {
                _TimdecW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&mut self) -> _TimoutW {
                _TimoutW { w: self }
            }
        }
    }
    # [ doc = "Timer Configuration N Register" ]
    pub struct Timcfg2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Configuration N Register" ]
    pub mod timcfg2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcfg2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstartR {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstartR::_0 => 0,
                    TstartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstartR {
                match bits {
                    0 => TstartR::_0,
                    1 => TstartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstartR::_1
            }
        }
        # [ doc = "Possible values of the field `TSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstopR {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstopR::_0 => 0,
                    TstopR::_1 => 1,
                    TstopR::_10 => 2,
                    TstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstopR {
                match bits {
                    0 => TstopR::_0,
                    1 => TstopR::_1,
                    2 => TstopR::_10,
                    3 => TstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TstopR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMENA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimenaR {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimenaR::_0 => 0,
                    TimenaR::_1 => 1,
                    TimenaR::_10 => 2,
                    TimenaR::_11 => 3,
                    TimenaR::_100 => 4,
                    TimenaR::_101 => 5,
                    TimenaR::_110 => 6,
                    TimenaR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimenaR {
                match bits {
                    0 => TimenaR::_0,
                    1 => TimenaR::_1,
                    2 => TimenaR::_10,
                    3 => TimenaR::_11,
                    4 => TimenaR::_100,
                    5 => TimenaR::_101,
                    6 => TimenaR::_110,
                    7 => TimenaR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimenaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimenaR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimenaR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimenaR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimenaR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimenaR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimenaR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimenaR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdisR {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdisR::_0 => 0,
                    TimdisR::_1 => 1,
                    TimdisR::_10 => 2,
                    TimdisR::_11 => 3,
                    TimdisR::_100 => 4,
                    TimdisR::_101 => 5,
                    TimdisR::_110 => 6,
                    TimdisR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdisR {
                match bits {
                    0 => TimdisR::_0,
                    1 => TimdisR::_1,
                    2 => TimdisR::_10,
                    3 => TimdisR::_11,
                    4 => TimdisR::_100,
                    5 => TimdisR::_101,
                    6 => TimdisR::_110,
                    i => TimdisR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdisR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdisR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdisR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimdisR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimdisR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimdisR::_110
            }
        }
        # [ doc = "Possible values of the field `TIMRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimrstR {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimrstR::_0 => 0,
                    TimrstR::_10 => 2,
                    TimrstR::_11 => 3,
                    TimrstR::_100 => 4,
                    TimrstR::_110 => 6,
                    TimrstR::_111 => 7,
                    TimrstR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimrstR {
                match bits {
                    0 => TimrstR::_0,
                    2 => TimrstR::_10,
                    3 => TimrstR::_11,
                    4 => TimrstR::_100,
                    6 => TimrstR::_110,
                    7 => TimrstR::_111,
                    i => TimrstR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimrstR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimrstR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimrstR::_100
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimrstR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimrstR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDEC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdecR {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdecR::_0 => 0,
                    TimdecR::_1 => 1,
                    TimdecR::_10 => 2,
                    TimdecR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdecR {
                match bits {
                    0 => TimdecR::_0,
                    1 => TimdecR::_1,
                    2 => TimdecR::_10,
                    3 => TimdecR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdecR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdecR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdecR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMOUT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimoutR {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimoutR::_0 => 0,
                    TimoutR::_1 => 1,
                    TimoutR::_10 => 2,
                    TimoutR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimoutR {
                match bits {
                    0 => TimoutR::_0,
                    1 => TimoutR::_1,
                    2 => TimoutR::_10,
                    3 => TimoutR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimoutR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimoutR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimoutR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimoutR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TSTART`" ]
        pub enum TstartW {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstartW::_0 => 0,
                    TstartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstartW::_0)
            }
            # [ doc = "Start bit enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSTOP`" ]
        pub enum TstopW {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstopW::_0 => 0,
                    TstopW::_1 => 1,
                    TstopW::_10 => 2,
                    TstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstopW::_0)
            }
            # [ doc = "Stop bit is enabled on timer compare" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstopW::_1)
            }
            # [ doc = "Stop bit is enabled on timer disable" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TstopW::_10)
            }
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMENA`" ]
        pub enum TimenaW {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimenaW::_0 => 0,
                    TimenaW::_1 => 1,
                    TimenaW::_10 => 2,
                    TimenaW::_11 => 3,
                    TimenaW::_100 => 4,
                    TimenaW::_101 => 5,
                    TimenaW::_110 => 6,
                    TimenaW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimenaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimenaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimenaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer always enabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimenaW::_0)
            }
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimenaW::_1)
            }
            # [ doc = "Timer enabled on Trigger high" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimenaW::_10)
            }
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimenaW::_11)
            }
            # [ doc = "Timer enabled on Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimenaW::_100)
            }
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimenaW::_101)
            }
            # [ doc = "Timer enabled on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimenaW::_110)
            }
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimenaW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDIS`" ]
        pub enum TimdisW {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
        }
        impl TimdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdisW::_0 => 0,
                    TimdisW::_1 => 1,
                    TimdisW::_10 => 2,
                    TimdisW::_11 => 3,
                    TimdisW::_100 => 4,
                    TimdisW::_101 => 5,
                    TimdisW::_110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdisW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdisW::_0)
            }
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdisW::_1)
            }
            # [ doc = "Timer disabled on Timer compare" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdisW::_10)
            }
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdisW::_11)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimdisW::_100)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimdisW::_101)
            }
            # [ doc = "Timer disabled on Trigger falling edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimdisW::_110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMRST`" ]
        pub enum TimrstW {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
        }
        impl TimrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimrstW::_0 => 0,
                    TimrstW::_10 => 2,
                    TimrstW::_11 => 3,
                    TimrstW::_100 => 4,
                    TimrstW::_110 => 6,
                    TimrstW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimrstW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimrstW::_0)
            }
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimrstW::_10)
            }
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimrstW::_11)
            }
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimrstW::_100)
            }
            # [ doc = "Timer reset on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimrstW::_110)
            }
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimrstW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDEC`" ]
        pub enum TimdecW {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdecW::_0 => 0,
                    TimdecW::_1 => 1,
                    TimdecW::_10 => 2,
                    TimdecW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdecW::_0)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdecW::_1)
            }
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdecW::_10)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdecW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMOUT`" ]
        pub enum TimoutW {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimoutW::_0 => 0,
                    TimoutW::_1 => 1,
                    TimoutW::_10 => 2,
                    TimoutW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimoutW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimoutW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimoutW::_0)
            }
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimoutW::_1)
            }
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimoutW::_10)
            }
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimoutW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&self) -> TstartR {
                TstartR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&self) -> TstopR {
                TstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&self) -> TimenaR {
                TimenaR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&self) -> TimdisR {
                TimdisR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&self) -> TimrstR {
                TimrstR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&self) -> TimdecR {
                TimdecR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&self) -> TimoutR {
                TimoutR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&mut self) -> _TstartW {
                _TstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&mut self) -> _TstopW {
                _TstopW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&mut self) -> _TimenaW {
                _TimenaW { w: self }
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&mut self) -> _TimdisW {
                _TimdisW { w: self }
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&mut self) -> _TimrstW {
                _TimrstW { w: self }
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&mut self) -> _TimdecW {
                _TimdecW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&mut self) -> _TimoutW {
                _TimoutW { w: self }
            }
        }
    }
    # [ doc = "Timer Configuration N Register" ]
    pub struct Timcfg3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Configuration N Register" ]
    pub mod timcfg3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcfg3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TSTART`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstartR {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstartR::_0 => 0,
                    TstartR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstartR {
                match bits {
                    0 => TstartR::_0,
                    1 => TstartR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstartR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstartR::_1
            }
        }
        # [ doc = "Possible values of the field `TSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TstopR {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TstopR::_0 => 0,
                    TstopR::_1 => 1,
                    TstopR::_10 => 2,
                    TstopR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TstopR {
                match bits {
                    0 => TstopR::_0,
                    1 => TstopR::_1,
                    2 => TstopR::_10,
                    3 => TstopR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TstopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TstopR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TstopR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TstopR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMENA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimenaR {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimenaR::_0 => 0,
                    TimenaR::_1 => 1,
                    TimenaR::_10 => 2,
                    TimenaR::_11 => 3,
                    TimenaR::_100 => 4,
                    TimenaR::_101 => 5,
                    TimenaR::_110 => 6,
                    TimenaR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimenaR {
                match bits {
                    0 => TimenaR::_0,
                    1 => TimenaR::_1,
                    2 => TimenaR::_10,
                    3 => TimenaR::_11,
                    4 => TimenaR::_100,
                    5 => TimenaR::_101,
                    6 => TimenaR::_110,
                    7 => TimenaR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimenaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimenaR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimenaR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimenaR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimenaR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimenaR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimenaR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimenaR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdisR {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdisR::_0 => 0,
                    TimdisR::_1 => 1,
                    TimdisR::_10 => 2,
                    TimdisR::_11 => 3,
                    TimdisR::_100 => 4,
                    TimdisR::_101 => 5,
                    TimdisR::_110 => 6,
                    TimdisR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdisR {
                match bits {
                    0 => TimdisR::_0,
                    1 => TimdisR::_1,
                    2 => TimdisR::_10,
                    3 => TimdisR::_11,
                    4 => TimdisR::_100,
                    5 => TimdisR::_101,
                    6 => TimdisR::_110,
                    i => TimdisR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdisR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdisR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdisR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimdisR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TimdisR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimdisR::_110
            }
        }
        # [ doc = "Possible values of the field `TIMRST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimrstR {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl TimrstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimrstR::_0 => 0,
                    TimrstR::_10 => 2,
                    TimrstR::_11 => 3,
                    TimrstR::_100 => 4,
                    TimrstR::_110 => 6,
                    TimrstR::_111 => 7,
                    TimrstR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimrstR {
                match bits {
                    0 => TimrstR::_0,
                    2 => TimrstR::_10,
                    3 => TimrstR::_11,
                    4 => TimrstR::_100,
                    6 => TimrstR::_110,
                    7 => TimrstR::_111,
                    i => TimrstR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimrstR::_0
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimrstR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimrstR::_11
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TimrstR::_100
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TimrstR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TimrstR::_111
            }
        }
        # [ doc = "Possible values of the field `TIMDEC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimdecR {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimdecR::_0 => 0,
                    TimdecR::_1 => 1,
                    TimdecR::_10 => 2,
                    TimdecR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimdecR {
                match bits {
                    0 => TimdecR::_0,
                    1 => TimdecR::_1,
                    2 => TimdecR::_10,
                    3 => TimdecR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimdecR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimdecR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimdecR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimdecR::_11
            }
        }
        # [ doc = "Possible values of the field `TIMOUT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimoutR {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimoutR::_0 => 0,
                    TimoutR::_1 => 1,
                    TimoutR::_10 => 2,
                    TimoutR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimoutR {
                match bits {
                    0 => TimoutR::_0,
                    1 => TimoutR::_1,
                    2 => TimoutR::_10,
                    3 => TimoutR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimoutR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimoutR::_1
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TimoutR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TimoutR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TSTART`" ]
        pub enum TstartW {
            # [ doc = "Start bit disabled" ]
            _0,
            # [ doc = "Start bit enabled" ]
            _1,
        }
        impl TstartW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstartW::_0 => 0,
                    TstartW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstartW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstartW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstartW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Start bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstartW::_0)
            }
            # [ doc = "Start bit enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstartW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TSTOP`" ]
        pub enum TstopW {
            # [ doc = "Stop bit disabled" ]
            _0,
            # [ doc = "Stop bit is enabled on timer compare" ]
            _1,
            # [ doc = "Stop bit is enabled on timer disable" ]
            _10,
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            _11,
        }
        impl TstopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TstopW::_0 => 0,
                    TstopW::_1 => 1,
                    TstopW::_10 => 2,
                    TstopW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TstopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TstopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TstopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Stop bit disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TstopW::_0)
            }
            # [ doc = "Stop bit is enabled on timer compare" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TstopW::_1)
            }
            # [ doc = "Stop bit is enabled on timer disable" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TstopW::_10)
            }
            # [ doc = "Stop bit is enabled on timer compare and timer disable" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TstopW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMENA`" ]
        pub enum TimenaW {
            # [ doc = "Timer always enabled" ]
            _0,
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            _1,
            # [ doc = "Timer enabled on Trigger high" ]
            _10,
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            _11,
            # [ doc = "Timer enabled on Pin rising edge" ]
            _100,
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            _101,
            # [ doc = "Timer enabled on Trigger rising edge" ]
            _110,
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            _111,
        }
        impl TimenaW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimenaW::_0 => 0,
                    TimenaW::_1 => 1,
                    TimenaW::_10 => 2,
                    TimenaW::_11 => 3,
                    TimenaW::_100 => 4,
                    TimenaW::_101 => 5,
                    TimenaW::_110 => 6,
                    TimenaW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimenaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimenaW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimenaW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer always enabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimenaW::_0)
            }
            # [ doc = "Timer enabled on Timer N-1 enable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimenaW::_1)
            }
            # [ doc = "Timer enabled on Trigger high" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimenaW::_10)
            }
            # [ doc = "Timer enabled on Trigger high and Pin high" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimenaW::_11)
            }
            # [ doc = "Timer enabled on Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimenaW::_100)
            }
            # [ doc = "Timer enabled on Pin rising edge and Trigger high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimenaW::_101)
            }
            # [ doc = "Timer enabled on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimenaW::_110)
            }
            # [ doc = "Timer enabled on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimenaW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDIS`" ]
        pub enum TimdisW {
            # [ doc = "Timer never disabled" ]
            _0,
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            _1,
            # [ doc = "Timer disabled on Timer compare" ]
            _10,
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            _11,
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            _100,
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            _101,
            # [ doc = "Timer disabled on Trigger falling edge" ]
            _110,
        }
        impl TimdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdisW::_0 => 0,
                    TimdisW::_1 => 1,
                    TimdisW::_10 => 2,
                    TimdisW::_11 => 3,
                    TimdisW::_100 => 4,
                    TimdisW::_101 => 5,
                    TimdisW::_110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdisW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdisW::_0)
            }
            # [ doc = "Timer disabled on Timer N-1 disable" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdisW::_1)
            }
            # [ doc = "Timer disabled on Timer compare" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdisW::_10)
            }
            # [ doc = "Timer disabled on Timer compare and Trigger Low" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdisW::_11)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimdisW::_100)
            }
            # [ doc = "Timer disabled on Pin rising or falling edge provided Trigger is high" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(TimdisW::_101)
            }
            # [ doc = "Timer disabled on Trigger falling edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimdisW::_110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMRST`" ]
        pub enum TimrstW {
            # [ doc = "Timer never reset" ]
            _0,
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            _10,
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            _11,
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            _100,
            # [ doc = "Timer reset on Trigger rising edge" ]
            _110,
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            _111,
        }
        impl TimrstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimrstW::_0 => 0,
                    TimrstW::_10 => 2,
                    TimrstW::_11 => 3,
                    TimrstW::_100 => 4,
                    TimrstW::_110 => 6,
                    TimrstW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimrstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimrstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimrstW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Timer never reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimrstW::_0)
            }
            # [ doc = "Timer reset on Timer Pin equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimrstW::_10)
            }
            # [ doc = "Timer reset on Timer Trigger equal to Timer Output" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimrstW::_11)
            }
            # [ doc = "Timer reset on Timer Pin rising edge" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(TimrstW::_100)
            }
            # [ doc = "Timer reset on Trigger rising edge" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(TimrstW::_110)
            }
            # [ doc = "Timer reset on Trigger rising or falling edge" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(TimrstW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMDEC`" ]
        pub enum TimdecW {
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            _0,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            _1,
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            _10,
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            _11,
        }
        impl TimdecW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimdecW::_0 => 0,
                    TimdecW::_1 => 1,
                    TimdecW::_10 => 2,
                    TimdecW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimdecW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimdecW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimdecW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Decrement counter on FlexIO clock, Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimdecW::_0)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Timer output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimdecW::_1)
            }
            # [ doc = "Decrement counter on Pin input (both edges), Shift clock equals Pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimdecW::_10)
            }
            # [ doc = "Decrement counter on Trigger input (both edges), Shift clock equals Trigger input." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimdecW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMOUT`" ]
        pub enum TimoutW {
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            _0,
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            _1,
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            _10,
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            _11,
        }
        impl TimoutW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimoutW::_0 => 0,
                    TimoutW::_1 => 1,
                    TimoutW::_10 => 2,
                    TimoutW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimoutW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimoutW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimoutW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Timer output is logic one when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimoutW::_0)
            }
            # [ doc = "Timer output is logic zero when enabled and is not affected by timer reset" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimoutW::_1)
            }
            # [ doc = "Timer output is logic one when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TimoutW::_10)
            }
            # [ doc = "Timer output is logic zero when enabled and on timer reset" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TimoutW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&self) -> TstartR {
                TstartR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&self) -> TstopR {
                TstopR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&self) -> TimenaR {
                TimenaR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 8;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&self) -> TimdisR {
                TimdisR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&self) -> TimrstR {
                TimrstR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&self) -> TimdecR {
                TimdecR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&self) -> TimoutR {
                TimoutR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Timer Start Bit" ]
            # [ inline ( always ) ]
            pub fn tstart(&mut self) -> _TstartW {
                _TstartW { w: self }
            }
            # [ doc = "Bits 4:5 - Timer Stop Bit" ]
            # [ inline ( always ) ]
            pub fn tstop(&mut self) -> _TstopW {
                _TstopW { w: self }
            }
            # [ doc = "Bits 8:10 - Timer Enable" ]
            # [ inline ( always ) ]
            pub fn timena(&mut self) -> _TimenaW {
                _TimenaW { w: self }
            }
            # [ doc = "Bits 12:14 - Timer Disable" ]
            # [ inline ( always ) ]
            pub fn timdis(&mut self) -> _TimdisW {
                _TimdisW { w: self }
            }
            # [ doc = "Bits 16:18 - Timer Reset" ]
            # [ inline ( always ) ]
            pub fn timrst(&mut self) -> _TimrstW {
                _TimrstW { w: self }
            }
            # [ doc = "Bits 20:21 - Timer Decrement" ]
            # [ inline ( always ) ]
            pub fn timdec(&mut self) -> _TimdecW {
                _TimdecW { w: self }
            }
            # [ doc = "Bits 24:25 - Timer Output" ]
            # [ inline ( always ) ]
            pub fn timout(&mut self) -> _TimoutW {
                _TimoutW { w: self }
            }
        }
    }
    # [ doc = "Timer Compare N Register" ]
    pub struct Timcmp0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Compare N Register" ]
    pub mod timcmp0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcmp0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CmpR {
            bits: u16,
        }
        impl CmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CmpW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&self) -> CmpR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CmpR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&mut self) -> _CmpW {
                _CmpW { w: self }
            }
        }
    }
    # [ doc = "Timer Compare N Register" ]
    pub struct Timcmp1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Compare N Register" ]
    pub mod timcmp1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcmp1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CmpR {
            bits: u16,
        }
        impl CmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CmpW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&self) -> CmpR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CmpR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&mut self) -> _CmpW {
                _CmpW { w: self }
            }
        }
    }
    # [ doc = "Timer Compare N Register" ]
    pub struct Timcmp2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Compare N Register" ]
    pub mod timcmp2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcmp2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CmpR {
            bits: u16,
        }
        impl CmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CmpW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&self) -> CmpR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CmpR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&mut self) -> _CmpW {
                _CmpW { w: self }
            }
        }
    }
    # [ doc = "Timer Compare N Register" ]
    pub struct Timcmp3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Timer Compare N Register" ]
    pub mod timcmp3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Timcmp3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CmpR {
            bits: u16,
        }
        impl CmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CmpW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 65535;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&self) -> CmpR {
                let bits = {
                    const MASK: u16 = 65535;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CmpR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:15 - Timer Compare Value" ]
            # [ inline ( always ) ]
            pub fn cmp(&mut self) -> _CmpW {
                _CmpW { w: self }
            }
        }
    }
}
# [ doc = "The FLEXIO Memory Map/Register Definition can be found here." ]
pub struct Flexio {
    register_block: flexio::RegisterBlock,
}
impl Deref for Flexio {
    type Target = flexio::RegisterBlock;
    fn deref(&self) -> &flexio::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "External Watchdog Monitor" ]
pub const EWM: Peripheral<Ewm> = unsafe { Peripheral::new(1074139136) };
# [ doc = "External Watchdog Monitor" ]
pub mod ewm {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Control Register" ]
        pub ctrl: Ctrl,
        # [ doc = "0x01 - Service Register" ]
        pub serv: Serv,
        # [ doc = "0x02 - Compare Low Register" ]
        pub cmpl: Cmpl,
        # [ doc = "0x03 - Compare High Register" ]
        pub cmph: Cmph,
        _reserved0: [u8; 1usize],
        # [ doc = "0x05 - Clock Prescaler Register" ]
        pub clkprescaler: Clkprescaler,
    }
    # [ doc = "Control Register" ]
    pub struct Ctrl {
        register: VolatileCell<u8>,
    }
    # [ doc = "Control Register" ]
    pub mod ctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Ctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EwmenR {
            bits: u8,
        }
        impl EwmenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct AssinR {
            bits: u8,
        }
        impl AssinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct InenR {
            bits: u8,
        }
        impl InenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct IntenR {
            bits: u8,
        }
        impl IntenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EwmenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EwmenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AssinW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AssinW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IntenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IntenW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 0 - EWM enable." ]
            # [ inline ( always ) ]
            pub fn ewmen(&self) -> EwmenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                EwmenR { bits }
            }
            # [ doc = "Bit 1 - EWM_in's Assertion State Select." ]
            # [ inline ( always ) ]
            pub fn assin(&self) -> AssinR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                AssinR { bits }
            }
            # [ doc = "Bit 2 - Input Enable." ]
            # [ inline ( always ) ]
            pub fn inen(&self) -> InenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                InenR { bits }
            }
            # [ doc = "Bit 3 - Interrupt Enable." ]
            # [ inline ( always ) ]
            pub fn inten(&self) -> IntenR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                IntenR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - EWM enable." ]
            # [ inline ( always ) ]
            pub fn ewmen(&mut self) -> _EwmenW {
                _EwmenW { w: self }
            }
            # [ doc = "Bit 1 - EWM_in's Assertion State Select." ]
            # [ inline ( always ) ]
            pub fn assin(&mut self) -> _AssinW {
                _AssinW { w: self }
            }
            # [ doc = "Bit 2 - Input Enable." ]
            # [ inline ( always ) ]
            pub fn inen(&mut self) -> _InenW {
                _InenW { w: self }
            }
            # [ doc = "Bit 3 - Interrupt Enable." ]
            # [ inline ( always ) ]
            pub fn inten(&mut self) -> _IntenW {
                _IntenW { w: self }
            }
        }
    }
    # [ doc = "Service Register" ]
    pub struct Serv {
        register: VolatileCell<u8>,
    }
    # [ doc = "Service Register" ]
    pub mod serv {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Serv {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ServiceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ServiceW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - SERVICE" ]
            # [ inline ( always ) ]
            pub fn service(&mut self) -> _ServiceW {
                _ServiceW { w: self }
            }
        }
    }
    # [ doc = "Compare Low Register" ]
    pub struct Cmpl {
        register: VolatileCell<u8>,
    }
    # [ doc = "Compare Low Register" ]
    pub mod cmpl {
        impl super::Cmpl {}
    }
    # [ doc = "Compare High Register" ]
    pub struct Cmph {
        register: VolatileCell<u8>,
    }
    # [ doc = "Compare High Register" ]
    pub mod cmph {
        impl super::Cmph {}
    }
    # [ doc = "Clock Prescaler Register" ]
    pub struct Clkprescaler {
        register: VolatileCell<u8>,
    }
    # [ doc = "Clock Prescaler Register" ]
    pub mod clkprescaler {
        impl super::Clkprescaler {}
    }
}
# [ doc = "External Watchdog Monitor" ]
pub struct Ewm {
    register_block: ewm::RegisterBlock,
}
impl Deref for Ewm {
    type Target = ewm::RegisterBlock;
    fn deref(&self) -> &ewm::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "TRGMUX" ]
pub const TRGMUX: Peripheral<Trgmux> = unsafe { Peripheral::new(1074147328) };
# [ doc = "TRGMUX" ]
pub mod trgmux {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - TRGMUX DMAMUX0 Register" ]
        pub trgmux_dmamux0: TrgmuxDmamux0,
        # [ doc = "0x04 - TRGMUX EXTOUT0 Register" ]
        pub trgmux_extout0: TrgmuxExtout0,
        # [ doc = "0x08 - TRGMUX EXTOUT1 Register" ]
        pub trgmux_extout1: TrgmuxExtout1,
        # [ doc = "0x0c - TRGMUX ADC0 Register" ]
        pub trgmux_adc0: TrgmuxAdc0,
        # [ doc = "0x10 - TRGMUX ADC1 Register" ]
        pub trgmux_adc1: TrgmuxAdc1,
        # [ doc = "0x14 - TRGMUX Reserved Register 5" ]
        pub trgmuxdummy5: Trgmuxdummy5,
        # [ doc = "0x18 - TRGMUX Reserved Register 6" ]
        pub trgmuxdummy6: Trgmuxdummy6,
        # [ doc = "0x1c - TRGMUX CMP0 Register" ]
        pub trgmux_cmp0: TrgmuxCmp0,
        # [ doc = "0x20 - TRGMUX Reserved Register 8" ]
        pub trgmuxdummy8: Trgmuxdummy8,
        # [ doc = "0x24 - TRGMUX Reserved Register 9" ]
        pub trgmuxdummy9: Trgmuxdummy9,
        # [ doc = "0x28 - TRGMUX FTM0 Register" ]
        pub trgmux_ftm0: TrgmuxFtm0,
        # [ doc = "0x2c - TRGMUX FTM1 Register" ]
        pub trgmux_ftm1: TrgmuxFtm1,
        # [ doc = "0x30 - TRGMUX FTM2 Register" ]
        pub trgmux_ftm2: TrgmuxFtm2,
        # [ doc = "0x34 - TRGMUX FTM3 Register" ]
        pub trgmux_ftm3: TrgmuxFtm3,
        # [ doc = "0x38 - TRGMUX PDB0 Register" ]
        pub trgmux_pdb0: TrgmuxPdb0,
        # [ doc = "0x3c - TRGMUX PDB1 Register" ]
        pub trgmux_pdb1: TrgmuxPdb1,
        # [ doc = "0x40 - TRGMUX Reserved Register 16" ]
        pub trgmuxdummy16: Trgmuxdummy16,
        # [ doc = "0x44 - TRGMUX FLEXIO Register" ]
        pub trgmux_flexio: TrgmuxFlexio,
        # [ doc = "0x48 - TRGMUX LPIT0 Register" ]
        pub trgmux_lpit0: TrgmuxLpit0,
        # [ doc = "0x4c - TRGMUX LPUART0 Register" ]
        pub trgmux_lpuart0: TrgmuxLpuart0,
        # [ doc = "0x50 - TRGMUX LPUART1 Register" ]
        pub trgmux_lpuart1: TrgmuxLpuart1,
        # [ doc = "0x54 - TRGMUX LPI2C0 Register" ]
        pub trgmux_lpi2c0: TrgmuxLpi2c0,
        # [ doc = "0x58 - TRGMUX Reserved Register 22" ]
        pub trgmuxdummy22: Trgmuxdummy22,
        # [ doc = "0x5c - TRGMUX LPSPI0 Register" ]
        pub trgmux_lpspi0: TrgmuxLpspi0,
        # [ doc = "0x60 - TRGMUX LPSPI1 Register" ]
        pub trgmux_lpspi1: TrgmuxLpspi1,
        # [ doc = "0x64 - TRGMUX LPTMR0 Register" ]
        pub trgmux_lptmr0: TrgmuxLptmr0,
    }
    # [ doc = "TRGMUX DMAMUX0 Register" ]
    pub struct TrgmuxDmamux0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX DMAMUX0 Register" ]
    pub mod trgmux_dmamux0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxDmamux0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX EXTOUT0 Register" ]
    pub struct TrgmuxExtout0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX EXTOUT0 Register" ]
    pub mod trgmux_extout0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxExtout0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX EXTOUT1 Register" ]
    pub struct TrgmuxExtout1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX EXTOUT1 Register" ]
    pub mod trgmux_extout1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxExtout1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX ADC0 Register" ]
    pub struct TrgmuxAdc0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX ADC0 Register" ]
    pub mod trgmux_adc0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxAdc0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX ADC1 Register" ]
    pub struct TrgmuxAdc1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX ADC1 Register" ]
    pub mod trgmux_adc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxAdc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX Reserved Register 5" ]
    pub struct Trgmuxdummy5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX Reserved Register 5" ]
    pub mod trgmuxdummy5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Trgmuxdummy5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "TRGMUX Reserved Register 6" ]
    pub struct Trgmuxdummy6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX Reserved Register 6" ]
    pub mod trgmuxdummy6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Trgmuxdummy6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "TRGMUX CMP0 Register" ]
    pub struct TrgmuxCmp0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX CMP0 Register" ]
    pub mod trgmux_cmp0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxCmp0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX Reserved Register 8" ]
    pub struct Trgmuxdummy8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX Reserved Register 8" ]
    pub mod trgmuxdummy8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Trgmuxdummy8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "TRGMUX Reserved Register 9" ]
    pub struct Trgmuxdummy9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX Reserved Register 9" ]
    pub mod trgmuxdummy9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Trgmuxdummy9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "TRGMUX FTM0 Register" ]
    pub struct TrgmuxFtm0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX FTM0 Register" ]
    pub mod trgmux_ftm0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxFtm0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX FTM1 Register" ]
    pub struct TrgmuxFtm1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX FTM1 Register" ]
    pub mod trgmux_ftm1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxFtm1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX FTM2 Register" ]
    pub struct TrgmuxFtm2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX FTM2 Register" ]
    pub mod trgmux_ftm2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxFtm2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX FTM3 Register" ]
    pub struct TrgmuxFtm3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX FTM3 Register" ]
    pub mod trgmux_ftm3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxFtm3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX PDB0 Register" ]
    pub struct TrgmuxPdb0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX PDB0 Register" ]
    pub mod trgmux_pdb0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxPdb0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX PDB1 Register" ]
    pub struct TrgmuxPdb1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX PDB1 Register" ]
    pub mod trgmux_pdb1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxPdb1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX Reserved Register 16" ]
    pub struct Trgmuxdummy16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX Reserved Register 16" ]
    pub mod trgmuxdummy16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Trgmuxdummy16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "TRGMUX FLEXIO Register" ]
    pub struct TrgmuxFlexio {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX FLEXIO Register" ]
    pub mod trgmux_flexio {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxFlexio {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX LPIT0 Register" ]
    pub struct TrgmuxLpit0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPIT0 Register" ]
    pub mod trgmux_lpit0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLpit0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel1R {
            bits: u8,
        }
        impl Sel1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel2R {
            bits: u8,
        }
        impl Sel2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel3R {
            bits: u8,
        }
        impl Sel3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&self) -> Sel1R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel1R { bits }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&self) -> Sel2R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel2R { bits }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&self) -> Sel3R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel3R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bits 8:13 - Trigger MUX Input 1 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel1(&mut self) -> _Sel1W {
                _Sel1W { w: self }
            }
            # [ doc = "Bits 16:21 - Trigger MUX Input 2 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel2(&mut self) -> _Sel2W {
                _Sel2W { w: self }
            }
            # [ doc = "Bits 24:29 - Trigger MUX Input 3 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel3(&mut self) -> _Sel3W {
                _Sel3W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX LPUART0 Register" ]
    pub struct TrgmuxLpuart0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPUART0 Register" ]
    pub mod trgmux_lpuart0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLpuart0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX LPUART1 Register" ]
    pub struct TrgmuxLpuart1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPUART1 Register" ]
    pub mod trgmux_lpuart1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLpuart1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX LPI2C0 Register" ]
    pub struct TrgmuxLpi2c0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPI2C0 Register" ]
    pub mod trgmux_lpi2c0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLpi2c0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX Reserved Register 22" ]
    pub struct Trgmuxdummy22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX Reserved Register 22" ]
    pub mod trgmuxdummy22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Trgmuxdummy22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "TRGMUX LPSPI0 Register" ]
    pub struct TrgmuxLpspi0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPSPI0 Register" ]
    pub mod trgmux_lpspi0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLpspi0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX LPSPI1 Register" ]
    pub struct TrgmuxLpspi1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPSPI1 Register" ]
    pub mod trgmux_lpspi1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLpspi1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "TRGMUX LPTMR0 Register" ]
    pub struct TrgmuxLptmr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "TRGMUX LPTMR0 Register" ]
    pub mod trgmux_lptmr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::TrgmuxLptmr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Sel0R {
            bits: u8,
        }
        impl Sel0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sel0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sel0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Register can be written." ]
            _0,
            # [ doc = "Register cannot be written until the next system Reset." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Register cannot be written until the next system Reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&self) -> Sel0R {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Sel0R { bits }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Trigger MUX Input 0 Source Select" ]
            # [ inline ( always ) ]
            pub fn sel0(&mut self) -> _Sel0W {
                _Sel0W { w: self }
            }
            # [ doc = "Bit 31 - TRGMUX register lock." ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
}
# [ doc = "TRGMUX" ]
pub struct Trgmux {
    register_block: trgmux::RegisterBlock,
}
impl Deref for Trgmux {
    type Target = trgmux::RegisterBlock;
    fn deref(&self) -> &trgmux::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "System Clock Generator" ]
pub const SCG: Peripheral<Scg> = unsafe { Peripheral::new(1074151424) };
# [ doc = "System Clock Generator" ]
pub mod scg {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        _reserved0: [u8; 8usize],
        # [ doc = "0x10 - Clock Status Register" ]
        pub csr: Csr,
        # [ doc = "0x14 - Run Clock Control Register" ]
        pub rccr: Rccr,
        # [ doc = "0x18 - VLPR Clock Control Register" ]
        pub vccr: Vccr,
        # [ doc = "0x1c - HSRUN Clock Control Register" ]
        pub hccr: Hccr,
        # [ doc = "0x20 - SCG CLKOUT Configuration Register" ]
        pub clkoutcnfg: Clkoutcnfg,
        _reserved1: [u8; 220usize],
        # [ doc = "0x100 - System OSC Control Status Register" ]
        pub sosccsr: Sosccsr,
        # [ doc = "0x104 - System OSC Divide Register" ]
        pub soscdiv: Soscdiv,
        # [ doc = "0x108 - System Oscillator Configuration Register" ]
        pub sosccfg: Sosccfg,
        _reserved2: [u8; 244usize],
        # [ doc = "0x200 - Slow IRC Control Status Register" ]
        pub sirccsr: Sirccsr,
        # [ doc = "0x204 - Slow IRC Divide Register" ]
        pub sircdiv: Sircdiv,
        # [ doc = "0x208 - Slow IRC Configuration Register" ]
        pub sirccfg: Sirccfg,
        _reserved3: [u8; 244usize],
        # [ doc = "0x300 - Fast IRC Control Status Register" ]
        pub firccsr: Firccsr,
        # [ doc = "0x304 - Fast IRC Divide Register" ]
        pub fircdiv: Fircdiv,
        # [ doc = "0x308 - Fast IRC Configuration Register" ]
        pub firccfg: Firccfg,
        _reserved4: [u8; 756usize],
        # [ doc = "0x600 - System PLL Control Status Register" ]
        pub spllcsr: Spllcsr,
        # [ doc = "0x604 - System PLL Divide Register" ]
        pub splldiv: Splldiv,
        # [ doc = "0x608 - System PLL Configuration Register" ]
        pub spllcfg: Spllcfg,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct VersionR {
            bits: u32,
        }
        impl VersionR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - SCG Version Number" ]
            # [ inline ( always ) ]
            pub fn version(&self) -> VersionR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                VersionR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClkpresR {
            bits: u8,
        }
        impl ClkpresR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DivpresR {
            bits: u8,
        }
        impl DivpresR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Clock Present" ]
            # [ inline ( always ) ]
            pub fn clkpres(&self) -> ClkpresR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClkpresR { bits }
            }
            # [ doc = "Bits 27:31 - Divider Present" ]
            # [ inline ( always ) ]
            pub fn divpres(&self) -> DivpresR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 27;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DivpresR { bits }
            }
        }
    }
    # [ doc = "Clock Status Register" ]
    pub struct Csr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Clock Status Register" ]
    pub mod csr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Csr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `DIVSLOW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivslowR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DivslowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivslowR::_0000 => 0,
                    DivslowR::_0001 => 1,
                    DivslowR::_0010 => 2,
                    DivslowR::_0011 => 3,
                    DivslowR::_0100 => 4,
                    DivslowR::_0101 => 5,
                    DivslowR::_0110 => 6,
                    DivslowR::_0111 => 7,
                    DivslowR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivslowR {
                match bits {
                    0 => DivslowR::_0000,
                    1 => DivslowR::_0001,
                    2 => DivslowR::_0010,
                    3 => DivslowR::_0011,
                    4 => DivslowR::_0100,
                    5 => DivslowR::_0101,
                    6 => DivslowR::_0110,
                    7 => DivslowR::_0111,
                    i => DivslowR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivslowR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivslowR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivslowR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivslowR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivslowR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivslowR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivslowR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivslowR::_0111
            }
        }
        # [ doc = "Possible values of the field `DIVBUS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivbusR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivbusR::_0000 => 0,
                    DivbusR::_0001 => 1,
                    DivbusR::_0010 => 2,
                    DivbusR::_0011 => 3,
                    DivbusR::_0100 => 4,
                    DivbusR::_0101 => 5,
                    DivbusR::_0110 => 6,
                    DivbusR::_0111 => 7,
                    DivbusR::_1000 => 8,
                    DivbusR::_1001 => 9,
                    DivbusR::_1010 => 10,
                    DivbusR::_1011 => 11,
                    DivbusR::_1100 => 12,
                    DivbusR::_1101 => 13,
                    DivbusR::_1110 => 14,
                    DivbusR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivbusR {
                match bits {
                    0 => DivbusR::_0000,
                    1 => DivbusR::_0001,
                    2 => DivbusR::_0010,
                    3 => DivbusR::_0011,
                    4 => DivbusR::_0100,
                    5 => DivbusR::_0101,
                    6 => DivbusR::_0110,
                    7 => DivbusR::_0111,
                    8 => DivbusR::_1000,
                    9 => DivbusR::_1001,
                    10 => DivbusR::_1010,
                    11 => DivbusR::_1011,
                    12 => DivbusR::_1100,
                    13 => DivbusR::_1101,
                    14 => DivbusR::_1110,
                    15 => DivbusR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivbusR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivbusR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivbusR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivbusR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivbusR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivbusR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivbusR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivbusR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivbusR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivbusR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivbusR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivbusR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivbusR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivbusR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivbusR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivbusR::_1111
            }
        }
        # [ doc = "Possible values of the field `DIVCORE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivcoreR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivcoreR::_0000 => 0,
                    DivcoreR::_0001 => 1,
                    DivcoreR::_0010 => 2,
                    DivcoreR::_0011 => 3,
                    DivcoreR::_0100 => 4,
                    DivcoreR::_0101 => 5,
                    DivcoreR::_0110 => 6,
                    DivcoreR::_0111 => 7,
                    DivcoreR::_1000 => 8,
                    DivcoreR::_1001 => 9,
                    DivcoreR::_1010 => 10,
                    DivcoreR::_1011 => 11,
                    DivcoreR::_1100 => 12,
                    DivcoreR::_1101 => 13,
                    DivcoreR::_1110 => 14,
                    DivcoreR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivcoreR {
                match bits {
                    0 => DivcoreR::_0000,
                    1 => DivcoreR::_0001,
                    2 => DivcoreR::_0010,
                    3 => DivcoreR::_0011,
                    4 => DivcoreR::_0100,
                    5 => DivcoreR::_0101,
                    6 => DivcoreR::_0110,
                    7 => DivcoreR::_0111,
                    8 => DivcoreR::_1000,
                    9 => DivcoreR::_1001,
                    10 => DivcoreR::_1010,
                    11 => DivcoreR::_1011,
                    12 => DivcoreR::_1100,
                    13 => DivcoreR::_1101,
                    14 => DivcoreR::_1110,
                    15 => DivcoreR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivcoreR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivcoreR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivcoreR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivcoreR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivcoreR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivcoreR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivcoreR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivcoreR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivcoreR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivcoreR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivcoreR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivcoreR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivcoreR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivcoreR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivcoreR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivcoreR::_1111
            }
        }
        # [ doc = "Possible values of the field `SCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ScsR {
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ScsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ScsR::_0001 => 1,
                    ScsR::_0010 => 2,
                    ScsR::_0011 => 3,
                    ScsR::_0110 => 6,
                    ScsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ScsR {
                match bits {
                    1 => ScsR::_0001,
                    2 => ScsR::_0010,
                    3 => ScsR::_0011,
                    6 => ScsR::_0110,
                    i => ScsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == ScsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == ScsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == ScsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == ScsR::_0110
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&self) -> DivslowR {
                DivslowR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&self) -> DivbusR {
                DivbusR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&self) -> DivcoreR {
                DivcoreR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&self) -> ScsR {
                ScsR::_from({
                                const MASK: u8 = 15;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
    }
    # [ doc = "Run Clock Control Register" ]
    pub struct Rccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Run Clock Control Register" ]
    pub mod rccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DIVSLOW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivslowR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DivslowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivslowR::_0000 => 0,
                    DivslowR::_0001 => 1,
                    DivslowR::_0010 => 2,
                    DivslowR::_0011 => 3,
                    DivslowR::_0100 => 4,
                    DivslowR::_0101 => 5,
                    DivslowR::_0110 => 6,
                    DivslowR::_0111 => 7,
                    DivslowR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivslowR {
                match bits {
                    0 => DivslowR::_0000,
                    1 => DivslowR::_0001,
                    2 => DivslowR::_0010,
                    3 => DivslowR::_0011,
                    4 => DivslowR::_0100,
                    5 => DivslowR::_0101,
                    6 => DivslowR::_0110,
                    7 => DivslowR::_0111,
                    i => DivslowR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivslowR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivslowR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivslowR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivslowR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivslowR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivslowR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivslowR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivslowR::_0111
            }
        }
        # [ doc = "Possible values of the field `DIVBUS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivbusR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivbusR::_0000 => 0,
                    DivbusR::_0001 => 1,
                    DivbusR::_0010 => 2,
                    DivbusR::_0011 => 3,
                    DivbusR::_0100 => 4,
                    DivbusR::_0101 => 5,
                    DivbusR::_0110 => 6,
                    DivbusR::_0111 => 7,
                    DivbusR::_1000 => 8,
                    DivbusR::_1001 => 9,
                    DivbusR::_1010 => 10,
                    DivbusR::_1011 => 11,
                    DivbusR::_1100 => 12,
                    DivbusR::_1101 => 13,
                    DivbusR::_1110 => 14,
                    DivbusR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivbusR {
                match bits {
                    0 => DivbusR::_0000,
                    1 => DivbusR::_0001,
                    2 => DivbusR::_0010,
                    3 => DivbusR::_0011,
                    4 => DivbusR::_0100,
                    5 => DivbusR::_0101,
                    6 => DivbusR::_0110,
                    7 => DivbusR::_0111,
                    8 => DivbusR::_1000,
                    9 => DivbusR::_1001,
                    10 => DivbusR::_1010,
                    11 => DivbusR::_1011,
                    12 => DivbusR::_1100,
                    13 => DivbusR::_1101,
                    14 => DivbusR::_1110,
                    15 => DivbusR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivbusR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivbusR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivbusR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivbusR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivbusR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivbusR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivbusR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivbusR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivbusR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivbusR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivbusR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivbusR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivbusR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivbusR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivbusR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivbusR::_1111
            }
        }
        # [ doc = "Possible values of the field `DIVCORE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivcoreR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivcoreR::_0000 => 0,
                    DivcoreR::_0001 => 1,
                    DivcoreR::_0010 => 2,
                    DivcoreR::_0011 => 3,
                    DivcoreR::_0100 => 4,
                    DivcoreR::_0101 => 5,
                    DivcoreR::_0110 => 6,
                    DivcoreR::_0111 => 7,
                    DivcoreR::_1000 => 8,
                    DivcoreR::_1001 => 9,
                    DivcoreR::_1010 => 10,
                    DivcoreR::_1011 => 11,
                    DivcoreR::_1100 => 12,
                    DivcoreR::_1101 => 13,
                    DivcoreR::_1110 => 14,
                    DivcoreR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivcoreR {
                match bits {
                    0 => DivcoreR::_0000,
                    1 => DivcoreR::_0001,
                    2 => DivcoreR::_0010,
                    3 => DivcoreR::_0011,
                    4 => DivcoreR::_0100,
                    5 => DivcoreR::_0101,
                    6 => DivcoreR::_0110,
                    7 => DivcoreR::_0111,
                    8 => DivcoreR::_1000,
                    9 => DivcoreR::_1001,
                    10 => DivcoreR::_1010,
                    11 => DivcoreR::_1011,
                    12 => DivcoreR::_1100,
                    13 => DivcoreR::_1101,
                    14 => DivcoreR::_1110,
                    15 => DivcoreR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivcoreR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivcoreR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivcoreR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivcoreR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivcoreR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivcoreR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivcoreR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivcoreR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivcoreR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivcoreR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivcoreR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivcoreR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivcoreR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivcoreR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivcoreR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivcoreR::_1111
            }
        }
        # [ doc = "Possible values of the field `SCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ScsR {
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ScsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ScsR::_0001 => 1,
                    ScsR::_0010 => 2,
                    ScsR::_0011 => 3,
                    ScsR::_0110 => 6,
                    ScsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ScsR {
                match bits {
                    1 => ScsR::_0001,
                    2 => ScsR::_0010,
                    3 => ScsR::_0011,
                    6 => ScsR::_0110,
                    i => ScsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == ScsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == ScsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == ScsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == ScsR::_0110
            }
        }
        # [ doc = "Values that can be written to the field `DIVSLOW`" ]
        pub enum DivslowW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
        }
        impl DivslowW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivslowW::_0000 => 0,
                    DivslowW::_0001 => 1,
                    DivslowW::_0010 => 2,
                    DivslowW::_0011 => 3,
                    DivslowW::_0100 => 4,
                    DivslowW::_0101 => 5,
                    DivslowW::_0110 => 6,
                    DivslowW::_0111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivslowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivslowW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivslowW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivslowW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivslowW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivslowW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivslowW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivslowW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivslowW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivslowW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivslowW::_0111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DIVBUS`" ]
        pub enum DivbusW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivbusW::_0000 => 0,
                    DivbusW::_0001 => 1,
                    DivbusW::_0010 => 2,
                    DivbusW::_0011 => 3,
                    DivbusW::_0100 => 4,
                    DivbusW::_0101 => 5,
                    DivbusW::_0110 => 6,
                    DivbusW::_0111 => 7,
                    DivbusW::_1000 => 8,
                    DivbusW::_1001 => 9,
                    DivbusW::_1010 => 10,
                    DivbusW::_1011 => 11,
                    DivbusW::_1100 => 12,
                    DivbusW::_1101 => 13,
                    DivbusW::_1110 => 14,
                    DivbusW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivbusW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivbusW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivbusW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivbusW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivbusW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivbusW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivbusW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivbusW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivbusW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivbusW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivbusW::_0111)
            }
            # [ doc = "Divide-by-9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(DivbusW::_1000)
            }
            # [ doc = "Divide-by-10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(DivbusW::_1001)
            }
            # [ doc = "Divide-by-11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(DivbusW::_1010)
            }
            # [ doc = "Divide-by-12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(DivbusW::_1011)
            }
            # [ doc = "Divide-by-13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(DivbusW::_1100)
            }
            # [ doc = "Divide-by-14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(DivbusW::_1101)
            }
            # [ doc = "Divide-by-15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(DivbusW::_1110)
            }
            # [ doc = "Divide-by-16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(DivbusW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DIVCORE`" ]
        pub enum DivcoreW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivcoreW::_0000 => 0,
                    DivcoreW::_0001 => 1,
                    DivcoreW::_0010 => 2,
                    DivcoreW::_0011 => 3,
                    DivcoreW::_0100 => 4,
                    DivcoreW::_0101 => 5,
                    DivcoreW::_0110 => 6,
                    DivcoreW::_0111 => 7,
                    DivcoreW::_1000 => 8,
                    DivcoreW::_1001 => 9,
                    DivcoreW::_1010 => 10,
                    DivcoreW::_1011 => 11,
                    DivcoreW::_1100 => 12,
                    DivcoreW::_1101 => 13,
                    DivcoreW::_1110 => 14,
                    DivcoreW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivcoreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivcoreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivcoreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivcoreW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivcoreW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivcoreW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivcoreW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivcoreW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivcoreW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivcoreW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivcoreW::_0111)
            }
            # [ doc = "Divide-by-9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(DivcoreW::_1000)
            }
            # [ doc = "Divide-by-10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(DivcoreW::_1001)
            }
            # [ doc = "Divide-by-11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(DivcoreW::_1010)
            }
            # [ doc = "Divide-by-12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(DivcoreW::_1011)
            }
            # [ doc = "Divide-by-13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(DivcoreW::_1100)
            }
            # [ doc = "Divide-by-14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(DivcoreW::_1101)
            }
            # [ doc = "Divide-by-15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(DivcoreW::_1110)
            }
            # [ doc = "Divide-by-16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(DivcoreW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SCS`" ]
        pub enum ScsW {
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
        }
        impl ScsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ScsW::_0001 => 1,
                    ScsW::_0010 => 2,
                    ScsW::_0011 => 3,
                    ScsW::_0110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ScsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ScsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ScsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "System OSC (SOSC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(ScsW::_0001)
            }
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(ScsW::_0010)
            }
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(ScsW::_0011)
            }
            # [ doc = "System PLL (SPLL_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(ScsW::_0110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&self) -> DivslowR {
                DivslowR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&self) -> DivbusR {
                DivbusR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&self) -> DivcoreR {
                DivcoreR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&self) -> ScsR {
                ScsR::_from({
                                const MASK: u8 = 15;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 50331649 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&mut self) -> _DivslowW {
                _DivslowW { w: self }
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&mut self) -> _DivbusW {
                _DivbusW { w: self }
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&mut self) -> _DivcoreW {
                _DivcoreW { w: self }
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&mut self) -> _ScsW {
                _ScsW { w: self }
            }
        }
    }
    # [ doc = "VLPR Clock Control Register" ]
    pub struct Vccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "VLPR Clock Control Register" ]
    pub mod vccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Vccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DIVSLOW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivslowR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DivslowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivslowR::_0000 => 0,
                    DivslowR::_0001 => 1,
                    DivslowR::_0010 => 2,
                    DivslowR::_0011 => 3,
                    DivslowR::_0100 => 4,
                    DivslowR::_0101 => 5,
                    DivslowR::_0110 => 6,
                    DivslowR::_0111 => 7,
                    DivslowR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivslowR {
                match bits {
                    0 => DivslowR::_0000,
                    1 => DivslowR::_0001,
                    2 => DivslowR::_0010,
                    3 => DivslowR::_0011,
                    4 => DivslowR::_0100,
                    5 => DivslowR::_0101,
                    6 => DivslowR::_0110,
                    7 => DivslowR::_0111,
                    i => DivslowR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivslowR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivslowR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivslowR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivslowR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivslowR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivslowR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivslowR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivslowR::_0111
            }
        }
        # [ doc = "Possible values of the field `DIVBUS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivbusR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivbusR::_0000 => 0,
                    DivbusR::_0001 => 1,
                    DivbusR::_0010 => 2,
                    DivbusR::_0011 => 3,
                    DivbusR::_0100 => 4,
                    DivbusR::_0101 => 5,
                    DivbusR::_0110 => 6,
                    DivbusR::_0111 => 7,
                    DivbusR::_1000 => 8,
                    DivbusR::_1001 => 9,
                    DivbusR::_1010 => 10,
                    DivbusR::_1011 => 11,
                    DivbusR::_1100 => 12,
                    DivbusR::_1101 => 13,
                    DivbusR::_1110 => 14,
                    DivbusR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivbusR {
                match bits {
                    0 => DivbusR::_0000,
                    1 => DivbusR::_0001,
                    2 => DivbusR::_0010,
                    3 => DivbusR::_0011,
                    4 => DivbusR::_0100,
                    5 => DivbusR::_0101,
                    6 => DivbusR::_0110,
                    7 => DivbusR::_0111,
                    8 => DivbusR::_1000,
                    9 => DivbusR::_1001,
                    10 => DivbusR::_1010,
                    11 => DivbusR::_1011,
                    12 => DivbusR::_1100,
                    13 => DivbusR::_1101,
                    14 => DivbusR::_1110,
                    15 => DivbusR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivbusR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivbusR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivbusR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivbusR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivbusR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivbusR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivbusR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivbusR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivbusR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivbusR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivbusR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivbusR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivbusR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivbusR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivbusR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivbusR::_1111
            }
        }
        # [ doc = "Possible values of the field `DIVCORE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivcoreR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivcoreR::_0000 => 0,
                    DivcoreR::_0001 => 1,
                    DivcoreR::_0010 => 2,
                    DivcoreR::_0011 => 3,
                    DivcoreR::_0100 => 4,
                    DivcoreR::_0101 => 5,
                    DivcoreR::_0110 => 6,
                    DivcoreR::_0111 => 7,
                    DivcoreR::_1000 => 8,
                    DivcoreR::_1001 => 9,
                    DivcoreR::_1010 => 10,
                    DivcoreR::_1011 => 11,
                    DivcoreR::_1100 => 12,
                    DivcoreR::_1101 => 13,
                    DivcoreR::_1110 => 14,
                    DivcoreR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivcoreR {
                match bits {
                    0 => DivcoreR::_0000,
                    1 => DivcoreR::_0001,
                    2 => DivcoreR::_0010,
                    3 => DivcoreR::_0011,
                    4 => DivcoreR::_0100,
                    5 => DivcoreR::_0101,
                    6 => DivcoreR::_0110,
                    7 => DivcoreR::_0111,
                    8 => DivcoreR::_1000,
                    9 => DivcoreR::_1001,
                    10 => DivcoreR::_1010,
                    11 => DivcoreR::_1011,
                    12 => DivcoreR::_1100,
                    13 => DivcoreR::_1101,
                    14 => DivcoreR::_1110,
                    15 => DivcoreR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivcoreR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivcoreR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivcoreR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivcoreR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivcoreR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivcoreR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivcoreR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivcoreR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivcoreR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivcoreR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivcoreR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivcoreR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivcoreR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivcoreR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivcoreR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivcoreR::_1111
            }
        }
        # [ doc = "Possible values of the field `SCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ScsR {
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ScsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ScsR::_0010 => 2,
                    ScsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ScsR {
                match bits {
                    2 => ScsR::_0010,
                    i => ScsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == ScsR::_0010
            }
        }
        # [ doc = "Values that can be written to the field `DIVSLOW`" ]
        pub enum DivslowW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
        }
        impl DivslowW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivslowW::_0000 => 0,
                    DivslowW::_0001 => 1,
                    DivslowW::_0010 => 2,
                    DivslowW::_0011 => 3,
                    DivslowW::_0100 => 4,
                    DivslowW::_0101 => 5,
                    DivslowW::_0110 => 6,
                    DivslowW::_0111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivslowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivslowW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivslowW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivslowW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivslowW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivslowW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivslowW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivslowW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivslowW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivslowW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivslowW::_0111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DIVBUS`" ]
        pub enum DivbusW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivbusW::_0000 => 0,
                    DivbusW::_0001 => 1,
                    DivbusW::_0010 => 2,
                    DivbusW::_0011 => 3,
                    DivbusW::_0100 => 4,
                    DivbusW::_0101 => 5,
                    DivbusW::_0110 => 6,
                    DivbusW::_0111 => 7,
                    DivbusW::_1000 => 8,
                    DivbusW::_1001 => 9,
                    DivbusW::_1010 => 10,
                    DivbusW::_1011 => 11,
                    DivbusW::_1100 => 12,
                    DivbusW::_1101 => 13,
                    DivbusW::_1110 => 14,
                    DivbusW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivbusW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivbusW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivbusW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivbusW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivbusW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivbusW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivbusW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivbusW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivbusW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivbusW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivbusW::_0111)
            }
            # [ doc = "Divide-by-9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(DivbusW::_1000)
            }
            # [ doc = "Divide-by-10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(DivbusW::_1001)
            }
            # [ doc = "Divide-by-11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(DivbusW::_1010)
            }
            # [ doc = "Divide-by-12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(DivbusW::_1011)
            }
            # [ doc = "Divide-by-13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(DivbusW::_1100)
            }
            # [ doc = "Divide-by-14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(DivbusW::_1101)
            }
            # [ doc = "Divide-by-15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(DivbusW::_1110)
            }
            # [ doc = "Divide-by-16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(DivbusW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DIVCORE`" ]
        pub enum DivcoreW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivcoreW::_0000 => 0,
                    DivcoreW::_0001 => 1,
                    DivcoreW::_0010 => 2,
                    DivcoreW::_0011 => 3,
                    DivcoreW::_0100 => 4,
                    DivcoreW::_0101 => 5,
                    DivcoreW::_0110 => 6,
                    DivcoreW::_0111 => 7,
                    DivcoreW::_1000 => 8,
                    DivcoreW::_1001 => 9,
                    DivcoreW::_1010 => 10,
                    DivcoreW::_1011 => 11,
                    DivcoreW::_1100 => 12,
                    DivcoreW::_1101 => 13,
                    DivcoreW::_1110 => 14,
                    DivcoreW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivcoreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivcoreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivcoreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivcoreW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivcoreW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivcoreW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivcoreW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivcoreW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivcoreW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivcoreW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivcoreW::_0111)
            }
            # [ doc = "Divide-by-9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(DivcoreW::_1000)
            }
            # [ doc = "Divide-by-10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(DivcoreW::_1001)
            }
            # [ doc = "Divide-by-11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(DivcoreW::_1010)
            }
            # [ doc = "Divide-by-12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(DivcoreW::_1011)
            }
            # [ doc = "Divide-by-13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(DivcoreW::_1100)
            }
            # [ doc = "Divide-by-14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(DivcoreW::_1101)
            }
            # [ doc = "Divide-by-15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(DivcoreW::_1110)
            }
            # [ doc = "Divide-by-16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(DivcoreW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SCS`" ]
        pub enum ScsW {
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
        }
        impl ScsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ScsW::_0010 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ScsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ScsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ScsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(ScsW::_0010)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&self) -> DivslowR {
                DivslowR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&self) -> DivbusR {
                DivbusR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&self) -> DivcoreR {
                DivcoreR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&self) -> ScsR {
                ScsR::_from({
                                const MASK: u8 = 15;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 33554433 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&mut self) -> _DivslowW {
                _DivslowW { w: self }
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&mut self) -> _DivbusW {
                _DivbusW { w: self }
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&mut self) -> _DivcoreW {
                _DivcoreW { w: self }
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&mut self) -> _ScsW {
                _ScsW { w: self }
            }
        }
    }
    # [ doc = "HSRUN Clock Control Register" ]
    pub struct Hccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "HSRUN Clock Control Register" ]
    pub mod hccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Hccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DIVSLOW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivslowR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DivslowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivslowR::_0000 => 0,
                    DivslowR::_0001 => 1,
                    DivslowR::_0010 => 2,
                    DivslowR::_0011 => 3,
                    DivslowR::_0100 => 4,
                    DivslowR::_0101 => 5,
                    DivslowR::_0110 => 6,
                    DivslowR::_0111 => 7,
                    DivslowR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivslowR {
                match bits {
                    0 => DivslowR::_0000,
                    1 => DivslowR::_0001,
                    2 => DivslowR::_0010,
                    3 => DivslowR::_0011,
                    4 => DivslowR::_0100,
                    5 => DivslowR::_0101,
                    6 => DivslowR::_0110,
                    7 => DivslowR::_0111,
                    i => DivslowR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivslowR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivslowR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivslowR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivslowR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivslowR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivslowR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivslowR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivslowR::_0111
            }
        }
        # [ doc = "Possible values of the field `DIVBUS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivbusR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivbusR::_0000 => 0,
                    DivbusR::_0001 => 1,
                    DivbusR::_0010 => 2,
                    DivbusR::_0011 => 3,
                    DivbusR::_0100 => 4,
                    DivbusR::_0101 => 5,
                    DivbusR::_0110 => 6,
                    DivbusR::_0111 => 7,
                    DivbusR::_1000 => 8,
                    DivbusR::_1001 => 9,
                    DivbusR::_1010 => 10,
                    DivbusR::_1011 => 11,
                    DivbusR::_1100 => 12,
                    DivbusR::_1101 => 13,
                    DivbusR::_1110 => 14,
                    DivbusR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivbusR {
                match bits {
                    0 => DivbusR::_0000,
                    1 => DivbusR::_0001,
                    2 => DivbusR::_0010,
                    3 => DivbusR::_0011,
                    4 => DivbusR::_0100,
                    5 => DivbusR::_0101,
                    6 => DivbusR::_0110,
                    7 => DivbusR::_0111,
                    8 => DivbusR::_1000,
                    9 => DivbusR::_1001,
                    10 => DivbusR::_1010,
                    11 => DivbusR::_1011,
                    12 => DivbusR::_1100,
                    13 => DivbusR::_1101,
                    14 => DivbusR::_1110,
                    15 => DivbusR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivbusR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivbusR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivbusR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivbusR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivbusR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivbusR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivbusR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivbusR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivbusR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivbusR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivbusR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivbusR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivbusR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivbusR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivbusR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivbusR::_1111
            }
        }
        # [ doc = "Possible values of the field `DIVCORE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DivcoreR {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DivcoreR::_0000 => 0,
                    DivcoreR::_0001 => 1,
                    DivcoreR::_0010 => 2,
                    DivcoreR::_0011 => 3,
                    DivcoreR::_0100 => 4,
                    DivcoreR::_0101 => 5,
                    DivcoreR::_0110 => 6,
                    DivcoreR::_0111 => 7,
                    DivcoreR::_1000 => 8,
                    DivcoreR::_1001 => 9,
                    DivcoreR::_1010 => 10,
                    DivcoreR::_1011 => 11,
                    DivcoreR::_1100 => 12,
                    DivcoreR::_1101 => 13,
                    DivcoreR::_1110 => 14,
                    DivcoreR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DivcoreR {
                match bits {
                    0 => DivcoreR::_0000,
                    1 => DivcoreR::_0001,
                    2 => DivcoreR::_0010,
                    3 => DivcoreR::_0011,
                    4 => DivcoreR::_0100,
                    5 => DivcoreR::_0101,
                    6 => DivcoreR::_0110,
                    7 => DivcoreR::_0111,
                    8 => DivcoreR::_1000,
                    9 => DivcoreR::_1001,
                    10 => DivcoreR::_1010,
                    11 => DivcoreR::_1011,
                    12 => DivcoreR::_1100,
                    13 => DivcoreR::_1101,
                    14 => DivcoreR::_1110,
                    15 => DivcoreR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == DivcoreR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == DivcoreR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == DivcoreR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == DivcoreR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == DivcoreR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == DivcoreR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == DivcoreR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == DivcoreR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == DivcoreR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == DivcoreR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == DivcoreR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == DivcoreR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == DivcoreR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == DivcoreR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == DivcoreR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == DivcoreR::_1111
            }
        }
        # [ doc = "Possible values of the field `SCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ScsR {
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ScsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ScsR::_0001 => 1,
                    ScsR::_0010 => 2,
                    ScsR::_0011 => 3,
                    ScsR::_0110 => 6,
                    ScsR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ScsR {
                match bits {
                    1 => ScsR::_0001,
                    2 => ScsR::_0010,
                    3 => ScsR::_0011,
                    6 => ScsR::_0110,
                    i => ScsR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == ScsR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == ScsR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == ScsR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == ScsR::_0110
            }
        }
        # [ doc = "Values that can be written to the field `DIVSLOW`" ]
        pub enum DivslowW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
        }
        impl DivslowW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivslowW::_0000 => 0,
                    DivslowW::_0001 => 1,
                    DivslowW::_0010 => 2,
                    DivslowW::_0011 => 3,
                    DivslowW::_0100 => 4,
                    DivslowW::_0101 => 5,
                    DivslowW::_0110 => 6,
                    DivslowW::_0111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivslowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivslowW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivslowW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivslowW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivslowW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivslowW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivslowW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivslowW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivslowW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivslowW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivslowW::_0111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DIVBUS`" ]
        pub enum DivbusW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivbusW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivbusW::_0000 => 0,
                    DivbusW::_0001 => 1,
                    DivbusW::_0010 => 2,
                    DivbusW::_0011 => 3,
                    DivbusW::_0100 => 4,
                    DivbusW::_0101 => 5,
                    DivbusW::_0110 => 6,
                    DivbusW::_0111 => 7,
                    DivbusW::_1000 => 8,
                    DivbusW::_1001 => 9,
                    DivbusW::_1010 => 10,
                    DivbusW::_1011 => 11,
                    DivbusW::_1100 => 12,
                    DivbusW::_1101 => 13,
                    DivbusW::_1110 => 14,
                    DivbusW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivbusW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivbusW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivbusW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivbusW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivbusW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivbusW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivbusW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivbusW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivbusW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivbusW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivbusW::_0111)
            }
            # [ doc = "Divide-by-9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(DivbusW::_1000)
            }
            # [ doc = "Divide-by-10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(DivbusW::_1001)
            }
            # [ doc = "Divide-by-11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(DivbusW::_1010)
            }
            # [ doc = "Divide-by-12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(DivbusW::_1011)
            }
            # [ doc = "Divide-by-13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(DivbusW::_1100)
            }
            # [ doc = "Divide-by-14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(DivbusW::_1101)
            }
            # [ doc = "Divide-by-15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(DivbusW::_1110)
            }
            # [ doc = "Divide-by-16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(DivbusW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DIVCORE`" ]
        pub enum DivcoreW {
            # [ doc = "Divide-by-1" ]
            _0000,
            # [ doc = "Divide-by-2" ]
            _0001,
            # [ doc = "Divide-by-3" ]
            _0010,
            # [ doc = "Divide-by-4" ]
            _0011,
            # [ doc = "Divide-by-5" ]
            _0100,
            # [ doc = "Divide-by-6" ]
            _0101,
            # [ doc = "Divide-by-7" ]
            _0110,
            # [ doc = "Divide-by-8" ]
            _0111,
            # [ doc = "Divide-by-9" ]
            _1000,
            # [ doc = "Divide-by-10" ]
            _1001,
            # [ doc = "Divide-by-11" ]
            _1010,
            # [ doc = "Divide-by-12" ]
            _1011,
            # [ doc = "Divide-by-13" ]
            _1100,
            # [ doc = "Divide-by-14" ]
            _1101,
            # [ doc = "Divide-by-15" ]
            _1110,
            # [ doc = "Divide-by-16" ]
            _1111,
        }
        impl DivcoreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DivcoreW::_0000 => 0,
                    DivcoreW::_0001 => 1,
                    DivcoreW::_0010 => 2,
                    DivcoreW::_0011 => 3,
                    DivcoreW::_0100 => 4,
                    DivcoreW::_0101 => 5,
                    DivcoreW::_0110 => 6,
                    DivcoreW::_0111 => 7,
                    DivcoreW::_1000 => 8,
                    DivcoreW::_1001 => 9,
                    DivcoreW::_1010 => 10,
                    DivcoreW::_1011 => 11,
                    DivcoreW::_1100 => 12,
                    DivcoreW::_1101 => 13,
                    DivcoreW::_1110 => 14,
                    DivcoreW::_1111 => 15,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DivcoreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DivcoreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DivcoreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide-by-1" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(DivcoreW::_0000)
            }
            # [ doc = "Divide-by-2" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(DivcoreW::_0001)
            }
            # [ doc = "Divide-by-3" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(DivcoreW::_0010)
            }
            # [ doc = "Divide-by-4" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(DivcoreW::_0011)
            }
            # [ doc = "Divide-by-5" ]
            # [ inline ( always ) ]
            pub fn _0100(self) -> &'a mut W {
                self.variant(DivcoreW::_0100)
            }
            # [ doc = "Divide-by-6" ]
            # [ inline ( always ) ]
            pub fn _0101(self) -> &'a mut W {
                self.variant(DivcoreW::_0101)
            }
            # [ doc = "Divide-by-7" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(DivcoreW::_0110)
            }
            # [ doc = "Divide-by-8" ]
            # [ inline ( always ) ]
            pub fn _0111(self) -> &'a mut W {
                self.variant(DivcoreW::_0111)
            }
            # [ doc = "Divide-by-9" ]
            # [ inline ( always ) ]
            pub fn _1000(self) -> &'a mut W {
                self.variant(DivcoreW::_1000)
            }
            # [ doc = "Divide-by-10" ]
            # [ inline ( always ) ]
            pub fn _1001(self) -> &'a mut W {
                self.variant(DivcoreW::_1001)
            }
            # [ doc = "Divide-by-11" ]
            # [ inline ( always ) ]
            pub fn _1010(self) -> &'a mut W {
                self.variant(DivcoreW::_1010)
            }
            # [ doc = "Divide-by-12" ]
            # [ inline ( always ) ]
            pub fn _1011(self) -> &'a mut W {
                self.variant(DivcoreW::_1011)
            }
            # [ doc = "Divide-by-13" ]
            # [ inline ( always ) ]
            pub fn _1100(self) -> &'a mut W {
                self.variant(DivcoreW::_1100)
            }
            # [ doc = "Divide-by-14" ]
            # [ inline ( always ) ]
            pub fn _1101(self) -> &'a mut W {
                self.variant(DivcoreW::_1101)
            }
            # [ doc = "Divide-by-15" ]
            # [ inline ( always ) ]
            pub fn _1110(self) -> &'a mut W {
                self.variant(DivcoreW::_1110)
            }
            # [ doc = "Divide-by-16" ]
            # [ inline ( always ) ]
            pub fn _1111(self) -> &'a mut W {
                self.variant(DivcoreW::_1111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SCS`" ]
        pub enum ScsW {
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
        }
        impl ScsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ScsW::_0001 => 1,
                    ScsW::_0010 => 2,
                    ScsW::_0011 => 3,
                    ScsW::_0110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ScsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ScsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ScsW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "System OSC (SOSC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(ScsW::_0001)
            }
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(ScsW::_0010)
            }
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(ScsW::_0011)
            }
            # [ doc = "System PLL (SPLL_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(ScsW::_0110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&self) -> DivslowR {
                DivslowR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&self) -> DivbusR {
                DivbusR::_from({
                                   const MASK: u8 = 15;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&self) -> DivcoreR {
                DivcoreR::_from({
                                    const MASK: u8 = 15;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&self) -> ScsR {
                ScsR::_from({
                                const MASK: u8 = 15;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 50331649 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Slow Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divslow(&mut self) -> _DivslowW {
                _DivslowW { w: self }
            }
            # [ doc = "Bits 4:7 - Bus Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divbus(&mut self) -> _DivbusW {
                _DivbusW { w: self }
            }
            # [ doc = "Bits 16:19 - Core Clock Divide Ratio" ]
            # [ inline ( always ) ]
            pub fn divcore(&mut self) -> _DivcoreW {
                _DivcoreW { w: self }
            }
            # [ doc = "Bits 24:27 - System Clock Source" ]
            # [ inline ( always ) ]
            pub fn scs(&mut self) -> _ScsW {
                _ScsW { w: self }
            }
        }
    }
    # [ doc = "SCG CLKOUT Configuration Register" ]
    pub struct Clkoutcnfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "SCG CLKOUT Configuration Register" ]
    pub mod clkoutcnfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Clkoutcnfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CLKOUTSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClkoutselR {
            # [ doc = "SCG SLOW Clock" ]
            _0000,
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl ClkoutselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClkoutselR::_0000 => 0,
                    ClkoutselR::_0001 => 1,
                    ClkoutselR::_0010 => 2,
                    ClkoutselR::_0011 => 3,
                    ClkoutselR::_0110 => 6,
                    ClkoutselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClkoutselR {
                match bits {
                    0 => ClkoutselR::_0000,
                    1 => ClkoutselR::_0001,
                    2 => ClkoutselR::_0010,
                    3 => ClkoutselR::_0011,
                    6 => ClkoutselR::_0110,
                    i => ClkoutselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == ClkoutselR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == ClkoutselR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == ClkoutselR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == ClkoutselR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == ClkoutselR::_0110
            }
        }
        # [ doc = "Values that can be written to the field `CLKOUTSEL`" ]
        pub enum ClkoutselW {
            # [ doc = "SCG SLOW Clock" ]
            _0000,
            # [ doc = "System OSC (SOSC_CLK)" ]
            _0001,
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            _0010,
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            _0011,
            # [ doc = "System PLL (SPLL_CLK)" ]
            _0110,
        }
        impl ClkoutselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClkoutselW::_0000 => 0,
                    ClkoutselW::_0001 => 1,
                    ClkoutselW::_0010 => 2,
                    ClkoutselW::_0011 => 3,
                    ClkoutselW::_0110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkoutselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkoutselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClkoutselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "SCG SLOW Clock" ]
            # [ inline ( always ) ]
            pub fn _0000(self) -> &'a mut W {
                self.variant(ClkoutselW::_0000)
            }
            # [ doc = "System OSC (SOSC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0001(self) -> &'a mut W {
                self.variant(ClkoutselW::_0001)
            }
            # [ doc = "Slow IRC (SIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0010(self) -> &'a mut W {
                self.variant(ClkoutselW::_0010)
            }
            # [ doc = "Fast IRC (FIRC_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0011(self) -> &'a mut W {
                self.variant(ClkoutselW::_0011)
            }
            # [ doc = "System PLL (SPLL_CLK)" ]
            # [ inline ( always ) ]
            pub fn _0110(self) -> &'a mut W {
                self.variant(ClkoutselW::_0110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:27 - SCG Clkout Select" ]
            # [ inline ( always ) ]
            pub fn clkoutsel(&self) -> ClkoutselR {
                ClkoutselR::_from({
                                      const MASK: u8 = 15;
                                      const OFFSET: u8 = 24;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 50331648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:27 - SCG Clkout Select" ]
            # [ inline ( always ) ]
            pub fn clkoutsel(&mut self) -> _ClkoutselW {
                _ClkoutselW { w: self }
            }
        }
    }
    # [ doc = "System OSC Control Status Register" ]
    pub struct Sosccsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "System OSC Control Status Register" ]
    pub mod sosccsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sosccsr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SOSCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoscenR {
            # [ doc = "System OSC is disabled" ]
            _0,
            # [ doc = "System OSC is enabled" ]
            _1,
        }
        impl SoscenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoscenR::_0 => 0,
                    SoscenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoscenR {
                match bits {
                    0 => SoscenR::_0,
                    1 => SoscenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoscenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoscenR::_1
            }
        }
        # [ doc = "Possible values of the field `SOSCCM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SosccmR {
            # [ doc = "System OSC Clock Monitor is disabled" ]
            _0,
            # [ doc = "System OSC Clock Monitor is enabled" ]
            _1,
        }
        impl SosccmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SosccmR::_0 => 0,
                    SosccmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SosccmR {
                match bits {
                    0 => SosccmR::_0,
                    1 => SosccmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SosccmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SosccmR::_1
            }
        }
        # [ doc = "Possible values of the field `SOSCCMRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SosccmreR {
            # [ doc = "Clock Monitor generates interrupt when error detected" ]
            _0,
            # [ doc = "Clock Monitor generates reset when error detected" ]
            _1,
        }
        impl SosccmreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SosccmreR::_0 => 0,
                    SosccmreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SosccmreR {
                match bits {
                    0 => SosccmreR::_0,
                    1 => SosccmreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SosccmreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SosccmreR::_1
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "This Control Status Register can be written." ]
            _0,
            # [ doc = "This Control Status Register cannot be written." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `SOSCVLD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoscvldR {
            # [ doc = "System OSC is not enabled or clock is not valid" ]
            _0,
            # [ doc = "System OSC is enabled and output clock is valid" ]
            _1,
        }
        impl SoscvldR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoscvldR::_0 => 0,
                    SoscvldR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoscvldR {
                match bits {
                    0 => SoscvldR::_0,
                    1 => SoscvldR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoscvldR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoscvldR::_1
            }
        }
        # [ doc = "Possible values of the field `SOSCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoscselR {
            # [ doc = "System OSC is not the system clock source" ]
            _0,
            # [ doc = "System OSC is the system clock source" ]
            _1,
        }
        impl SoscselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoscselR::_0 => 0,
                    SoscselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoscselR {
                match bits {
                    0 => SoscselR::_0,
                    1 => SoscselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoscselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoscselR::_1
            }
        }
        # [ doc = "Possible values of the field `SOSCERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SoscerrR {
            # [ doc = "System OSC Clock Monitor is disabled or has not detected an error" ]
            _0,
            # [ doc = "System OSC Clock Monitor is enabled and detected an error" ]
            _1,
        }
        impl SoscerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SoscerrR::_0 => 0,
                    SoscerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SoscerrR {
                match bits {
                    0 => SoscerrR::_0,
                    1 => SoscerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SoscerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SoscerrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SOSCEN`" ]
        pub enum SoscenW {
            # [ doc = "System OSC is disabled" ]
            _0,
            # [ doc = "System OSC is enabled" ]
            _1,
        }
        impl SoscenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SoscenW::_0 => 0,
                    SoscenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoscenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoscenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SoscenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "System OSC is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SoscenW::_0)
            }
            # [ doc = "System OSC is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SoscenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOSCCM`" ]
        pub enum SosccmW {
            # [ doc = "System OSC Clock Monitor is disabled" ]
            _0,
            # [ doc = "System OSC Clock Monitor is enabled" ]
            _1,
        }
        impl SosccmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SosccmW::_0 => 0,
                    SosccmW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SosccmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SosccmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SosccmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "System OSC Clock Monitor is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SosccmW::_0)
            }
            # [ doc = "System OSC Clock Monitor is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SosccmW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOSCCMRE`" ]
        pub enum SosccmreW {
            # [ doc = "Clock Monitor generates interrupt when error detected" ]
            _0,
            # [ doc = "Clock Monitor generates reset when error detected" ]
            _1,
        }
        impl SosccmreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SosccmreW::_0 => 0,
                    SosccmreW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SosccmreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SosccmreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SosccmreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock Monitor generates interrupt when error detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SosccmreW::_0)
            }
            # [ doc = "Clock Monitor generates reset when error detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SosccmreW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "This Control Status Register can be written." ]
            _0,
            # [ doc = "This Control Status Register cannot be written." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "This Control Status Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "This Control Status Register cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOSCERR`" ]
        pub enum SoscerrW {
            # [ doc = "System OSC Clock Monitor is disabled or has not detected an error" ]
            _0,
            # [ doc = "System OSC Clock Monitor is enabled and detected an error" ]
            _1,
        }
        impl SoscerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SoscerrW::_0 => 0,
                    SoscerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SoscerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SoscerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SoscerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "System OSC Clock Monitor is disabled or has not detected an error" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SoscerrW::_0)
            }
            # [ doc = "System OSC Clock Monitor is enabled and detected an error" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SoscerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - System OSC Enable" ]
            # [ inline ( always ) ]
            pub fn soscen(&self) -> SoscenR {
                SoscenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - System OSC Clock Monitor" ]
            # [ inline ( always ) ]
            pub fn sosccm(&self) -> SosccmR {
                SosccmR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 17 - System OSC Clock Monitor Reset Enable" ]
            # [ inline ( always ) ]
            pub fn sosccmre(&self) -> SosccmreR {
                SosccmreR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 17;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 23;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 24 - System OSC Valid" ]
            # [ inline ( always ) ]
            pub fn soscvld(&self) -> SoscvldR {
                SoscvldR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 24;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 25 - System OSC Selected" ]
            # [ inline ( always ) ]
            pub fn soscsel(&self) -> SoscselR {
                SoscselR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 26 - System OSC Clock Error" ]
            # [ inline ( always ) ]
            pub fn soscerr(&self) -> SoscerrR {
                SoscerrR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 26;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - System OSC Enable" ]
            # [ inline ( always ) ]
            pub fn soscen(&mut self) -> _SoscenW {
                _SoscenW { w: self }
            }
            # [ doc = "Bit 16 - System OSC Clock Monitor" ]
            # [ inline ( always ) ]
            pub fn sosccm(&mut self) -> _SosccmW {
                _SosccmW { w: self }
            }
            # [ doc = "Bit 17 - System OSC Clock Monitor Reset Enable" ]
            # [ inline ( always ) ]
            pub fn sosccmre(&mut self) -> _SosccmreW {
                _SosccmreW { w: self }
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bit 26 - System OSC Clock Error" ]
            # [ inline ( always ) ]
            pub fn soscerr(&mut self) -> _SoscerrW {
                _SoscerrW { w: self }
            }
        }
    }
    # [ doc = "System OSC Divide Register" ]
    pub struct Soscdiv {
        register: VolatileCell<u32>,
    }
    # [ doc = "System OSC Divide Register" ]
    pub mod soscdiv {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Soscdiv {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SOSCDIV1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Soscdiv1R {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Soscdiv1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Soscdiv1R::_000 => 0,
                    Soscdiv1R::_001 => 1,
                    Soscdiv1R::_010 => 2,
                    Soscdiv1R::_011 => 3,
                    Soscdiv1R::_100 => 4,
                    Soscdiv1R::_101 => 5,
                    Soscdiv1R::_110 => 6,
                    Soscdiv1R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Soscdiv1R {
                match bits {
                    0 => Soscdiv1R::_000,
                    1 => Soscdiv1R::_001,
                    2 => Soscdiv1R::_010,
                    3 => Soscdiv1R::_011,
                    4 => Soscdiv1R::_100,
                    5 => Soscdiv1R::_101,
                    6 => Soscdiv1R::_110,
                    7 => Soscdiv1R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Soscdiv1R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Soscdiv1R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Soscdiv1R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Soscdiv1R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Soscdiv1R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Soscdiv1R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Soscdiv1R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Soscdiv1R::_111
            }
        }
        # [ doc = "Possible values of the field `SOSCDIV2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Soscdiv2R {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Soscdiv2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Soscdiv2R::_000 => 0,
                    Soscdiv2R::_001 => 1,
                    Soscdiv2R::_010 => 2,
                    Soscdiv2R::_011 => 3,
                    Soscdiv2R::_100 => 4,
                    Soscdiv2R::_101 => 5,
                    Soscdiv2R::_110 => 6,
                    Soscdiv2R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Soscdiv2R {
                match bits {
                    0 => Soscdiv2R::_000,
                    1 => Soscdiv2R::_001,
                    2 => Soscdiv2R::_010,
                    3 => Soscdiv2R::_011,
                    4 => Soscdiv2R::_100,
                    5 => Soscdiv2R::_101,
                    6 => Soscdiv2R::_110,
                    7 => Soscdiv2R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Soscdiv2R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Soscdiv2R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Soscdiv2R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Soscdiv2R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Soscdiv2R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Soscdiv2R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Soscdiv2R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Soscdiv2R::_111
            }
        }
        # [ doc = "Values that can be written to the field `SOSCDIV1`" ]
        pub enum Soscdiv1W {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Soscdiv1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Soscdiv1W::_000 => 0,
                    Soscdiv1W::_001 => 1,
                    Soscdiv1W::_010 => 2,
                    Soscdiv1W::_011 => 3,
                    Soscdiv1W::_100 => 4,
                    Soscdiv1W::_101 => 5,
                    Soscdiv1W::_110 => 6,
                    Soscdiv1W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Soscdiv1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Soscdiv1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Soscdiv1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Soscdiv1W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Soscdiv1W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Soscdiv1W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Soscdiv1W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Soscdiv1W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Soscdiv1W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Soscdiv1W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Soscdiv1W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SOSCDIV2`" ]
        pub enum Soscdiv2W {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Soscdiv2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Soscdiv2W::_000 => 0,
                    Soscdiv2W::_001 => 1,
                    Soscdiv2W::_010 => 2,
                    Soscdiv2W::_011 => 3,
                    Soscdiv2W::_100 => 4,
                    Soscdiv2W::_101 => 5,
                    Soscdiv2W::_110 => 6,
                    Soscdiv2W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Soscdiv2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Soscdiv2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Soscdiv2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Soscdiv2W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Soscdiv2W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Soscdiv2W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Soscdiv2W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Soscdiv2W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Soscdiv2W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Soscdiv2W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Soscdiv2W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - System OSC Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn soscdiv1(&self) -> Soscdiv1R {
                Soscdiv1R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:10 - System OSC Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn soscdiv2(&self) -> Soscdiv2R {
                Soscdiv2R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - System OSC Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn soscdiv1(&mut self) -> _Soscdiv1W {
                _Soscdiv1W { w: self }
            }
            # [ doc = "Bits 8:10 - System OSC Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn soscdiv2(&mut self) -> _Soscdiv2W {
                _Soscdiv2W { w: self }
            }
        }
    }
    # [ doc = "System Oscillator Configuration Register" ]
    pub struct Sosccfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "System Oscillator Configuration Register" ]
    pub mod sosccfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sosccfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `EREFS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErefsR {
            # [ doc = "External reference clock selected" ]
            _0,
            # [ doc = "Internal crystal oscillator of OSC selected." ]
            _1,
        }
        impl ErefsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErefsR::_0 => 0,
                    ErefsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErefsR {
                match bits {
                    0 => ErefsR::_0,
                    1 => ErefsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErefsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErefsR::_1
            }
        }
        # [ doc = "Possible values of the field `HGO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HgoR {
            # [ doc = "Configure crystal oscillator for low-gain operation" ]
            _0,
            # [ doc = "Configure crystal oscillator for high-gain operation" ]
            _1,
        }
        impl HgoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HgoR::_0 => 0,
                    HgoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HgoR {
                match bits {
                    0 => HgoR::_0,
                    1 => HgoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HgoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HgoR::_1
            }
        }
        # [ doc = "Possible values of the field `RANGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RangeR {
            # [ doc = "Low frequency range selected for the crystal oscillator" ]
            _01,
            # [ doc = "Medium frequency range selected for the crytstal oscillator" ]
            _10,
            # [ doc = "High frequency range selected for the crystal oscillator" ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RangeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RangeR::_01 => 1,
                    RangeR::_10 => 2,
                    RangeR::_11 => 3,
                    RangeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RangeR {
                match bits {
                    1 => RangeR::_01,
                    2 => RangeR::_10,
                    3 => RangeR::_11,
                    i => RangeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == RangeR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == RangeR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == RangeR::_11
            }
        }
        # [ doc = "Values that can be written to the field `EREFS`" ]
        pub enum ErefsW {
            # [ doc = "External reference clock selected" ]
            _0,
            # [ doc = "Internal crystal oscillator of OSC selected." ]
            _1,
        }
        impl ErefsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErefsW::_0 => 0,
                    ErefsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErefsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErefsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErefsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "External reference clock selected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErefsW::_0)
            }
            # [ doc = "Internal crystal oscillator of OSC selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErefsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HGO`" ]
        pub enum HgoW {
            # [ doc = "Configure crystal oscillator for low-gain operation" ]
            _0,
            # [ doc = "Configure crystal oscillator for high-gain operation" ]
            _1,
        }
        impl HgoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HgoW::_0 => 0,
                    HgoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HgoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HgoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HgoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configure crystal oscillator for low-gain operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HgoW::_0)
            }
            # [ doc = "Configure crystal oscillator for high-gain operation" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HgoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RANGE`" ]
        pub enum RangeW {
            # [ doc = "Low frequency range selected for the crystal oscillator" ]
            _01,
            # [ doc = "Medium frequency range selected for the crytstal oscillator" ]
            _10,
            # [ doc = "High frequency range selected for the crystal oscillator" ]
            _11,
        }
        impl RangeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RangeW::_01 => 1,
                    RangeW::_10 => 2,
                    RangeW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RangeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RangeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RangeW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Low frequency range selected for the crystal oscillator" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(RangeW::_01)
            }
            # [ doc = "Medium frequency range selected for the crytstal oscillator" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(RangeW::_10)
            }
            # [ doc = "High frequency range selected for the crystal oscillator" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(RangeW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 2 - External Reference Select" ]
            # [ inline ( always ) ]
            pub fn erefs(&self) -> ErefsR {
                ErefsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - High Gain Oscillator Select" ]
            # [ inline ( always ) ]
            pub fn hgo(&self) -> HgoR {
                HgoR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 4:5 - System OSC Range Select" ]
            # [ inline ( always ) ]
            pub fn range(&self) -> RangeR {
                RangeR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 16 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 2 - External Reference Select" ]
            # [ inline ( always ) ]
            pub fn erefs(&mut self) -> _ErefsW {
                _ErefsW { w: self }
            }
            # [ doc = "Bit 3 - High Gain Oscillator Select" ]
            # [ inline ( always ) ]
            pub fn hgo(&mut self) -> _HgoW {
                _HgoW { w: self }
            }
            # [ doc = "Bits 4:5 - System OSC Range Select" ]
            # [ inline ( always ) ]
            pub fn range(&mut self) -> _RangeW {
                _RangeW { w: self }
            }
        }
    }
    # [ doc = "Slow IRC Control Status Register" ]
    pub struct Sirccsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slow IRC Control Status Register" ]
    pub mod sirccsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sirccsr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SIRCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SircenR {
            # [ doc = "Slow IRC is disabled" ]
            _0,
            # [ doc = "Slow IRC is enabled" ]
            _1,
        }
        impl SircenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SircenR::_0 => 0,
                    SircenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SircenR {
                match bits {
                    0 => SircenR::_0,
                    1 => SircenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SircenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SircenR::_1
            }
        }
        # [ doc = "Possible values of the field `SIRCSTEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SircstenR {
            # [ doc = "Slow IRC is disabled in supported Stop modes" ]
            _0,
            # [ doc = "Slow IRC is enabled in supported Stop modes" ]
            _1,
        }
        impl SircstenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SircstenR::_0 => 0,
                    SircstenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SircstenR {
                match bits {
                    0 => SircstenR::_0,
                    1 => SircstenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SircstenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SircstenR::_1
            }
        }
        # [ doc = "Possible values of the field `SIRCLPEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SirclpenR {
            # [ doc = "Slow IRC is disabled in VLP modes" ]
            _0,
            # [ doc = "Slow IRC is enabled in VLP modes" ]
            _1,
        }
        impl SirclpenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SirclpenR::_0 => 0,
                    SirclpenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SirclpenR {
                match bits {
                    0 => SirclpenR::_0,
                    1 => SirclpenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SirclpenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SirclpenR::_1
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Control Status Register can be written." ]
            _0,
            # [ doc = "Control Status Register cannot be written." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `SIRCVLD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SircvldR {
            # [ doc = "Slow IRC is not enabled or clock is not valid" ]
            _0,
            # [ doc = "Slow IRC is enabled and output clock is valid" ]
            _1,
        }
        impl SircvldR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SircvldR::_0 => 0,
                    SircvldR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SircvldR {
                match bits {
                    0 => SircvldR::_0,
                    1 => SircvldR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SircvldR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SircvldR::_1
            }
        }
        # [ doc = "Possible values of the field `SIRCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SircselR {
            # [ doc = "Slow IRC is not the system clock source" ]
            _0,
            # [ doc = "Slow IRC is the system clock source" ]
            _1,
        }
        impl SircselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SircselR::_0 => 0,
                    SircselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SircselR {
                match bits {
                    0 => SircselR::_0,
                    1 => SircselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SircselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SircselR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SIRCEN`" ]
        pub enum SircenW {
            # [ doc = "Slow IRC is disabled" ]
            _0,
            # [ doc = "Slow IRC is enabled" ]
            _1,
        }
        impl SircenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SircenW::_0 => 0,
                    SircenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SircenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SircenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SircenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slow IRC is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SircenW::_0)
            }
            # [ doc = "Slow IRC is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SircenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SIRCSTEN`" ]
        pub enum SircstenW {
            # [ doc = "Slow IRC is disabled in supported Stop modes" ]
            _0,
            # [ doc = "Slow IRC is enabled in supported Stop modes" ]
            _1,
        }
        impl SircstenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SircstenW::_0 => 0,
                    SircstenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SircstenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SircstenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SircstenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slow IRC is disabled in supported Stop modes" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SircstenW::_0)
            }
            # [ doc = "Slow IRC is enabled in supported Stop modes" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SircstenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SIRCLPEN`" ]
        pub enum SirclpenW {
            # [ doc = "Slow IRC is disabled in VLP modes" ]
            _0,
            # [ doc = "Slow IRC is enabled in VLP modes" ]
            _1,
        }
        impl SirclpenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SirclpenW::_0 => 0,
                    SirclpenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SirclpenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SirclpenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SirclpenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slow IRC is disabled in VLP modes" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SirclpenW::_0)
            }
            # [ doc = "Slow IRC is enabled in VLP modes" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SirclpenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Control Status Register can be written." ]
            _0,
            # [ doc = "Control Status Register cannot be written." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Control Status Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Control Status Register cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Slow IRC Enable" ]
            # [ inline ( always ) ]
            pub fn sircen(&self) -> SircenR {
                SircenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Slow IRC Stop Enable" ]
            # [ inline ( always ) ]
            pub fn sircsten(&self) -> SircstenR {
                SircstenR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 1;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 2 - Slow IRC Low Power Enable" ]
            # [ inline ( always ) ]
            pub fn sirclpen(&self) -> SirclpenR {
                SirclpenR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 23;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 24 - Slow IRC Valid" ]
            # [ inline ( always ) ]
            pub fn sircvld(&self) -> SircvldR {
                SircvldR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 24;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 25 - Slow IRC Selected" ]
            # [ inline ( always ) ]
            pub fn sircsel(&self) -> SircselR {
                SircselR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 16777221 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Slow IRC Enable" ]
            # [ inline ( always ) ]
            pub fn sircen(&mut self) -> _SircenW {
                _SircenW { w: self }
            }
            # [ doc = "Bit 1 - Slow IRC Stop Enable" ]
            # [ inline ( always ) ]
            pub fn sircsten(&mut self) -> _SircstenW {
                _SircstenW { w: self }
            }
            # [ doc = "Bit 2 - Slow IRC Low Power Enable" ]
            # [ inline ( always ) ]
            pub fn sirclpen(&mut self) -> _SirclpenW {
                _SirclpenW { w: self }
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
        }
    }
    # [ doc = "Slow IRC Divide Register" ]
    pub struct Sircdiv {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slow IRC Divide Register" ]
    pub mod sircdiv {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sircdiv {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SIRCDIV1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sircdiv1R {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Sircdiv1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sircdiv1R::_000 => 0,
                    Sircdiv1R::_001 => 1,
                    Sircdiv1R::_010 => 2,
                    Sircdiv1R::_011 => 3,
                    Sircdiv1R::_100 => 4,
                    Sircdiv1R::_101 => 5,
                    Sircdiv1R::_110 => 6,
                    Sircdiv1R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sircdiv1R {
                match bits {
                    0 => Sircdiv1R::_000,
                    1 => Sircdiv1R::_001,
                    2 => Sircdiv1R::_010,
                    3 => Sircdiv1R::_011,
                    4 => Sircdiv1R::_100,
                    5 => Sircdiv1R::_101,
                    6 => Sircdiv1R::_110,
                    7 => Sircdiv1R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Sircdiv1R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Sircdiv1R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Sircdiv1R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Sircdiv1R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Sircdiv1R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Sircdiv1R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Sircdiv1R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Sircdiv1R::_111
            }
        }
        # [ doc = "Possible values of the field `SIRCDIV2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Sircdiv2R {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Sircdiv2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Sircdiv2R::_000 => 0,
                    Sircdiv2R::_001 => 1,
                    Sircdiv2R::_010 => 2,
                    Sircdiv2R::_011 => 3,
                    Sircdiv2R::_100 => 4,
                    Sircdiv2R::_101 => 5,
                    Sircdiv2R::_110 => 6,
                    Sircdiv2R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Sircdiv2R {
                match bits {
                    0 => Sircdiv2R::_000,
                    1 => Sircdiv2R::_001,
                    2 => Sircdiv2R::_010,
                    3 => Sircdiv2R::_011,
                    4 => Sircdiv2R::_100,
                    5 => Sircdiv2R::_101,
                    6 => Sircdiv2R::_110,
                    7 => Sircdiv2R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Sircdiv2R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Sircdiv2R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Sircdiv2R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Sircdiv2R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Sircdiv2R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Sircdiv2R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Sircdiv2R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Sircdiv2R::_111
            }
        }
        # [ doc = "Values that can be written to the field `SIRCDIV1`" ]
        pub enum Sircdiv1W {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Sircdiv1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sircdiv1W::_000 => 0,
                    Sircdiv1W::_001 => 1,
                    Sircdiv1W::_010 => 2,
                    Sircdiv1W::_011 => 3,
                    Sircdiv1W::_100 => 4,
                    Sircdiv1W::_101 => 5,
                    Sircdiv1W::_110 => 6,
                    Sircdiv1W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sircdiv1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sircdiv1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sircdiv1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Sircdiv1W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Sircdiv1W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Sircdiv1W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Sircdiv1W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Sircdiv1W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Sircdiv1W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Sircdiv1W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Sircdiv1W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SIRCDIV2`" ]
        pub enum Sircdiv2W {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Sircdiv2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Sircdiv2W::_000 => 0,
                    Sircdiv2W::_001 => 1,
                    Sircdiv2W::_010 => 2,
                    Sircdiv2W::_011 => 3,
                    Sircdiv2W::_100 => 4,
                    Sircdiv2W::_101 => 5,
                    Sircdiv2W::_110 => 6,
                    Sircdiv2W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Sircdiv2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Sircdiv2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Sircdiv2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Sircdiv2W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Sircdiv2W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Sircdiv2W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Sircdiv2W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Sircdiv2W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Sircdiv2W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Sircdiv2W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Sircdiv2W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Slow IRC Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn sircdiv1(&self) -> Sircdiv1R {
                Sircdiv1R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:10 - Slow IRC Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn sircdiv2(&self) -> Sircdiv2R {
                Sircdiv2R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Slow IRC Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn sircdiv1(&mut self) -> _Sircdiv1W {
                _Sircdiv1W { w: self }
            }
            # [ doc = "Bits 8:10 - Slow IRC Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn sircdiv2(&mut self) -> _Sircdiv2W {
                _Sircdiv2W { w: self }
            }
        }
    }
    # [ doc = "Slow IRC Configuration Register" ]
    pub struct Sirccfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slow IRC Configuration Register" ]
    pub mod sirccfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sirccfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RANGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RangeR {
            # [ doc = "Slow IRC low range clock (2 MHz)" ]
            _0,
            # [ doc = "Slow IRC high range clock (8 MHz )" ]
            _1,
        }
        impl RangeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RangeR::_0 => 0,
                    RangeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RangeR {
                match bits {
                    0 => RangeR::_0,
                    1 => RangeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RangeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RangeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RANGE`" ]
        pub enum RangeW {
            # [ doc = "Slow IRC low range clock (2 MHz)" ]
            _0,
            # [ doc = "Slow IRC high range clock (8 MHz )" ]
            _1,
        }
        impl RangeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RangeW::_0 => 0,
                    RangeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RangeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RangeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RangeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slow IRC low range clock (2 MHz)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RangeW::_0)
            }
            # [ doc = "Slow IRC high range clock (8 MHz )" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RangeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Frequency Range" ]
            # [ inline ( always ) ]
            pub fn range(&self) -> RangeR {
                RangeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Frequency Range" ]
            # [ inline ( always ) ]
            pub fn range(&mut self) -> _RangeW {
                _RangeW { w: self }
            }
        }
    }
    # [ doc = "Fast IRC Control Status Register" ]
    pub struct Firccsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fast IRC Control Status Register" ]
    pub mod firccsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Firccsr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FIRCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FircenR {
            # [ doc = "Fast IRC is disabled" ]
            _0,
            # [ doc = "Fast IRC is enabled" ]
            _1,
        }
        impl FircenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FircenR::_0 => 0,
                    FircenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FircenR {
                match bits {
                    0 => FircenR::_0,
                    1 => FircenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FircenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FircenR::_1
            }
        }
        # [ doc = "Possible values of the field `FIRCREGOFF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FircregoffR {
            # [ doc = "Fast IRC Regulator is enabled." ]
            _0,
            # [ doc = "Fast IRC Regulator is disabled." ]
            _1,
        }
        impl FircregoffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FircregoffR::_0 => 0,
                    FircregoffR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FircregoffR {
                match bits {
                    0 => FircregoffR::_0,
                    1 => FircregoffR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FircregoffR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FircregoffR::_1
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Control Status Register can be written." ]
            _0,
            # [ doc = "Control Status Register cannot be written." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `FIRCVLD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FircvldR {
            # [ doc = "Fast IRC is not enabled or clock is not valid." ]
            _0,
            # [ doc = "Fast IRC is enabled and output clock is valid. The clock is valid once there is an output clock from the FIRC analog." ]
            _1,
        }
        impl FircvldR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FircvldR::_0 => 0,
                    FircvldR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FircvldR {
                match bits {
                    0 => FircvldR::_0,
                    1 => FircvldR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FircvldR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FircvldR::_1
            }
        }
        # [ doc = "Possible values of the field `FIRCSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FircselR {
            # [ doc = "Fast IRC is not the system clock source" ]
            _0,
            # [ doc = "Fast IRC is the system clock source" ]
            _1,
        }
        impl FircselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FircselR::_0 => 0,
                    FircselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FircselR {
                match bits {
                    0 => FircselR::_0,
                    1 => FircselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FircselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FircselR::_1
            }
        }
        # [ doc = "Possible values of the field `FIRCERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FircerrR {
            # [ doc = "Error not detected with the Fast IRC trimming." ]
            _0,
            # [ doc = "Error detected with the Fast IRC trimming." ]
            _1,
        }
        impl FircerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FircerrR::_0 => 0,
                    FircerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FircerrR {
                match bits {
                    0 => FircerrR::_0,
                    1 => FircerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FircerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FircerrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FIRCEN`" ]
        pub enum FircenW {
            # [ doc = "Fast IRC is disabled" ]
            _0,
            # [ doc = "Fast IRC is enabled" ]
            _1,
        }
        impl FircenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FircenW::_0 => 0,
                    FircenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FircenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FircenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FircenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fast IRC is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FircenW::_0)
            }
            # [ doc = "Fast IRC is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FircenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FIRCREGOFF`" ]
        pub enum FircregoffW {
            # [ doc = "Fast IRC Regulator is enabled." ]
            _0,
            # [ doc = "Fast IRC Regulator is disabled." ]
            _1,
        }
        impl FircregoffW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FircregoffW::_0 => 0,
                    FircregoffW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FircregoffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FircregoffW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FircregoffW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fast IRC Regulator is enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FircregoffW::_0)
            }
            # [ doc = "Fast IRC Regulator is disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FircregoffW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Control Status Register can be written." ]
            _0,
            # [ doc = "Control Status Register cannot be written." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Control Status Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Control Status Register cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FIRCERR`" ]
        pub enum FircerrW {
            # [ doc = "Error not detected with the Fast IRC trimming." ]
            _0,
            # [ doc = "Error detected with the Fast IRC trimming." ]
            _1,
        }
        impl FircerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FircerrW::_0 => 0,
                    FircerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FircerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FircerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FircerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Error not detected with the Fast IRC trimming." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FircerrW::_0)
            }
            # [ doc = "Error detected with the Fast IRC trimming." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FircerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Fast IRC Enable" ]
            # [ inline ( always ) ]
            pub fn fircen(&self) -> FircenR {
                FircenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Fast IRC Regulator Enable" ]
            # [ inline ( always ) ]
            pub fn fircregoff(&self) -> FircregoffR {
                FircregoffR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 3;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 23;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 24 - Fast IRC Valid status" ]
            # [ inline ( always ) ]
            pub fn fircvld(&self) -> FircvldR {
                FircvldR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 24;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 25 - Fast IRC Selected status" ]
            # [ inline ( always ) ]
            pub fn fircsel(&self) -> FircselR {
                FircselR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 26 - Fast IRC Clock Error" ]
            # [ inline ( always ) ]
            pub fn fircerr(&self) -> FircerrR {
                FircerrR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 26;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 50331649 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Fast IRC Enable" ]
            # [ inline ( always ) ]
            pub fn fircen(&mut self) -> _FircenW {
                _FircenW { w: self }
            }
            # [ doc = "Bit 3 - Fast IRC Regulator Enable" ]
            # [ inline ( always ) ]
            pub fn fircregoff(&mut self) -> _FircregoffW {
                _FircregoffW { w: self }
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bit 26 - Fast IRC Clock Error" ]
            # [ inline ( always ) ]
            pub fn fircerr(&mut self) -> _FircerrW {
                _FircerrW { w: self }
            }
        }
    }
    # [ doc = "Fast IRC Divide Register" ]
    pub struct Fircdiv {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fast IRC Divide Register" ]
    pub mod fircdiv {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fircdiv {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FIRCDIV1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fircdiv1R {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Fircdiv1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fircdiv1R::_000 => 0,
                    Fircdiv1R::_001 => 1,
                    Fircdiv1R::_010 => 2,
                    Fircdiv1R::_011 => 3,
                    Fircdiv1R::_100 => 4,
                    Fircdiv1R::_101 => 5,
                    Fircdiv1R::_110 => 6,
                    Fircdiv1R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fircdiv1R {
                match bits {
                    0 => Fircdiv1R::_000,
                    1 => Fircdiv1R::_001,
                    2 => Fircdiv1R::_010,
                    3 => Fircdiv1R::_011,
                    4 => Fircdiv1R::_100,
                    5 => Fircdiv1R::_101,
                    6 => Fircdiv1R::_110,
                    7 => Fircdiv1R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Fircdiv1R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Fircdiv1R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Fircdiv1R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Fircdiv1R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Fircdiv1R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Fircdiv1R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Fircdiv1R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Fircdiv1R::_111
            }
        }
        # [ doc = "Possible values of the field `FIRCDIV2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Fircdiv2R {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Fircdiv2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Fircdiv2R::_000 => 0,
                    Fircdiv2R::_001 => 1,
                    Fircdiv2R::_010 => 2,
                    Fircdiv2R::_011 => 3,
                    Fircdiv2R::_100 => 4,
                    Fircdiv2R::_101 => 5,
                    Fircdiv2R::_110 => 6,
                    Fircdiv2R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Fircdiv2R {
                match bits {
                    0 => Fircdiv2R::_000,
                    1 => Fircdiv2R::_001,
                    2 => Fircdiv2R::_010,
                    3 => Fircdiv2R::_011,
                    4 => Fircdiv2R::_100,
                    5 => Fircdiv2R::_101,
                    6 => Fircdiv2R::_110,
                    7 => Fircdiv2R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Fircdiv2R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Fircdiv2R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Fircdiv2R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Fircdiv2R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Fircdiv2R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Fircdiv2R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Fircdiv2R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Fircdiv2R::_111
            }
        }
        # [ doc = "Values that can be written to the field `FIRCDIV1`" ]
        pub enum Fircdiv1W {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Fircdiv1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fircdiv1W::_000 => 0,
                    Fircdiv1W::_001 => 1,
                    Fircdiv1W::_010 => 2,
                    Fircdiv1W::_011 => 3,
                    Fircdiv1W::_100 => 4,
                    Fircdiv1W::_101 => 5,
                    Fircdiv1W::_110 => 6,
                    Fircdiv1W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fircdiv1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fircdiv1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fircdiv1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Fircdiv1W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Fircdiv1W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Fircdiv1W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Fircdiv1W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Fircdiv1W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Fircdiv1W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Fircdiv1W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Fircdiv1W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FIRCDIV2`" ]
        pub enum Fircdiv2W {
            # [ doc = "Output disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Fircdiv2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Fircdiv2W::_000 => 0,
                    Fircdiv2W::_001 => 1,
                    Fircdiv2W::_010 => 2,
                    Fircdiv2W::_011 => 3,
                    Fircdiv2W::_100 => 4,
                    Fircdiv2W::_101 => 5,
                    Fircdiv2W::_110 => 6,
                    Fircdiv2W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Fircdiv2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Fircdiv2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Fircdiv2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Output disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Fircdiv2W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Fircdiv2W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Fircdiv2W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Fircdiv2W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Fircdiv2W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Fircdiv2W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Fircdiv2W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Fircdiv2W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Fast IRC Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn fircdiv1(&self) -> Fircdiv1R {
                Fircdiv1R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:10 - Fast IRC Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn fircdiv2(&self) -> Fircdiv2R {
                Fircdiv2R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Fast IRC Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn fircdiv1(&mut self) -> _Fircdiv1W {
                _Fircdiv1W { w: self }
            }
            # [ doc = "Bits 8:10 - Fast IRC Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn fircdiv2(&mut self) -> _Fircdiv2W {
                _Fircdiv2W { w: self }
            }
        }
    }
    # [ doc = "Fast IRC Configuration Register" ]
    pub struct Firccfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "Fast IRC Configuration Register" ]
    pub mod firccfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Firccfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RANGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RangeR {
            # [ doc = "Fast IRC is trimmed to 48 MHz" ]
            _00,
            # [ doc = "Fast IRC is trimmed to 52 MHz" ]
            _01,
            # [ doc = "Fast IRC is trimmed to 56 MHz" ]
            _10,
            # [ doc = "Fast IRC is trimmed to 60 MHz" ]
            _11,
        }
        impl RangeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RangeR::_00 => 0,
                    RangeR::_01 => 1,
                    RangeR::_10 => 2,
                    RangeR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RangeR {
                match bits {
                    0 => RangeR::_00,
                    1 => RangeR::_01,
                    2 => RangeR::_10,
                    3 => RangeR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == RangeR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == RangeR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == RangeR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == RangeR::_11
            }
        }
        # [ doc = "Values that can be written to the field `RANGE`" ]
        pub enum RangeW {
            # [ doc = "Fast IRC is trimmed to 48 MHz" ]
            _00,
            # [ doc = "Fast IRC is trimmed to 52 MHz" ]
            _01,
            # [ doc = "Fast IRC is trimmed to 56 MHz" ]
            _10,
            # [ doc = "Fast IRC is trimmed to 60 MHz" ]
            _11,
        }
        impl RangeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RangeW::_00 => 0,
                    RangeW::_01 => 1,
                    RangeW::_10 => 2,
                    RangeW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RangeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RangeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RangeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fast IRC is trimmed to 48 MHz" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(RangeW::_00)
            }
            # [ doc = "Fast IRC is trimmed to 52 MHz" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(RangeW::_01)
            }
            # [ doc = "Fast IRC is trimmed to 56 MHz" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(RangeW::_10)
            }
            # [ doc = "Fast IRC is trimmed to 60 MHz" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(RangeW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Frequency Range" ]
            # [ inline ( always ) ]
            pub fn range(&self) -> RangeR {
                RangeR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Frequency Range" ]
            # [ inline ( always ) ]
            pub fn range(&mut self) -> _RangeW {
                _RangeW { w: self }
            }
        }
    }
    # [ doc = "System PLL Control Status Register" ]
    pub struct Spllcsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "System PLL Control Status Register" ]
    pub mod spllcsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Spllcsr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SPLLEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpllenR {
            # [ doc = "System PLL is disabled" ]
            _0,
            # [ doc = "System PLL is enabled" ]
            _1,
        }
        impl SpllenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpllenR::_0 => 0,
                    SpllenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpllenR {
                match bits {
                    0 => SpllenR::_0,
                    1 => SpllenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpllenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpllenR::_1
            }
        }
        # [ doc = "Possible values of the field `SPLLCM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpllcmR {
            # [ doc = "System PLL Clock Monitor is disabled" ]
            _0,
            # [ doc = "System PLL Clock Monitor is enabled" ]
            _1,
        }
        impl SpllcmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpllcmR::_0 => 0,
                    SpllcmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpllcmR {
                match bits {
                    0 => SpllcmR::_0,
                    1 => SpllcmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpllcmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpllcmR::_1
            }
        }
        # [ doc = "Possible values of the field `SPLLCMRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpllcmreR {
            # [ doc = "Clock Monitor generates interrupt when error detected" ]
            _0,
            # [ doc = "Clock Monitor generates reset when error detected" ]
            _1,
        }
        impl SpllcmreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpllcmreR::_0 => 0,
                    SpllcmreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpllcmreR {
                match bits {
                    0 => SpllcmreR::_0,
                    1 => SpllcmreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpllcmreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpllcmreR::_1
            }
        }
        # [ doc = "Possible values of the field `LK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LkR {
            # [ doc = "Control Status Register can be written." ]
            _0,
            # [ doc = "Control Status Register cannot be written." ]
            _1,
        }
        impl LkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LkR::_0 => 0,
                    LkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LkR {
                match bits {
                    0 => LkR::_0,
                    1 => LkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LkR::_1
            }
        }
        # [ doc = "Possible values of the field `SPLLVLD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpllvldR {
            # [ doc = "System PLL is not enabled or clock is not valid" ]
            _0,
            # [ doc = "System PLL is enabled and output clock is valid" ]
            _1,
        }
        impl SpllvldR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpllvldR::_0 => 0,
                    SpllvldR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpllvldR {
                match bits {
                    0 => SpllvldR::_0,
                    1 => SpllvldR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpllvldR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpllvldR::_1
            }
        }
        # [ doc = "Possible values of the field `SPLLSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpllselR {
            # [ doc = "System PLL is not the system clock source" ]
            _0,
            # [ doc = "System PLL is the system clock source" ]
            _1,
        }
        impl SpllselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpllselR::_0 => 0,
                    SpllselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpllselR {
                match bits {
                    0 => SpllselR::_0,
                    1 => SpllselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpllselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpllselR::_1
            }
        }
        # [ doc = "Possible values of the field `SPLLERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpllerrR {
            # [ doc = "System PLL Clock Monitor is disabled or has not detected an error" ]
            _0,
            # [ doc = "System PLL Clock Monitor is enabled and detected an error. System PLL Clock Error flag will not set when System OSC is selected as its source and SOSCERR has set." ]
            _1,
        }
        impl SpllerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpllerrR::_0 => 0,
                    SpllerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpllerrR {
                match bits {
                    0 => SpllerrR::_0,
                    1 => SpllerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpllerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpllerrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SPLLEN`" ]
        pub enum SpllenW {
            # [ doc = "System PLL is disabled" ]
            _0,
            # [ doc = "System PLL is enabled" ]
            _1,
        }
        impl SpllenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SpllenW::_0 => 0,
                    SpllenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SpllenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SpllenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SpllenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "System PLL is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SpllenW::_0)
            }
            # [ doc = "System PLL is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SpllenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SPLLCM`" ]
        pub enum SpllcmW {
            # [ doc = "System PLL Clock Monitor is disabled" ]
            _0,
            # [ doc = "System PLL Clock Monitor is enabled" ]
            _1,
        }
        impl SpllcmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SpllcmW::_0 => 0,
                    SpllcmW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SpllcmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SpllcmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SpllcmW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "System PLL Clock Monitor is disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SpllcmW::_0)
            }
            # [ doc = "System PLL Clock Monitor is enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SpllcmW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SPLLCMRE`" ]
        pub enum SpllcmreW {
            # [ doc = "Clock Monitor generates interrupt when error detected" ]
            _0,
            # [ doc = "Clock Monitor generates reset when error detected" ]
            _1,
        }
        impl SpllcmreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SpllcmreW::_0 => 0,
                    SpllcmreW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SpllcmreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SpllcmreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SpllcmreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock Monitor generates interrupt when error detected" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SpllcmreW::_0)
            }
            # [ doc = "Clock Monitor generates reset when error detected" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SpllcmreW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LK`" ]
        pub enum LkW {
            # [ doc = "Control Status Register can be written." ]
            _0,
            # [ doc = "Control Status Register cannot be written." ]
            _1,
        }
        impl LkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LkW::_0 => 0,
                    LkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Control Status Register can be written." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LkW::_0)
            }
            # [ doc = "Control Status Register cannot be written." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SPLLERR`" ]
        pub enum SpllerrW {
            # [ doc = "System PLL Clock Monitor is disabled or has not detected an error" ]
            _0,
            # [ doc = "System PLL Clock Monitor is enabled and detected an error. System PLL Clock Error flag will not set when System OSC is selected as its source and SOSCERR has set." ]
            _1,
        }
        impl SpllerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SpllerrW::_0 => 0,
                    SpllerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SpllerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SpllerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SpllerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "System PLL Clock Monitor is disabled or has not detected an error" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SpllerrW::_0)
            }
            # [ doc = "System PLL Clock Monitor is enabled and detected an error. System PLL Clock Error flag will not set when System OSC is selected as its source and SOSCERR has set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SpllerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - System PLL Enable" ]
            # [ inline ( always ) ]
            pub fn spllen(&self) -> SpllenR {
                SpllenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - System PLL Clock Monitor" ]
            # [ inline ( always ) ]
            pub fn spllcm(&self) -> SpllcmR {
                SpllcmR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 17 - System PLL Clock Monitor Reset Enable" ]
            # [ inline ( always ) ]
            pub fn spllcmre(&self) -> SpllcmreR {
                SpllcmreR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 17;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&self) -> LkR {
                LkR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 23;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 24 - System PLL Valid" ]
            # [ inline ( always ) ]
            pub fn spllvld(&self) -> SpllvldR {
                SpllvldR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 24;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 25 - System PLL Selected" ]
            # [ inline ( always ) ]
            pub fn spllsel(&self) -> SpllselR {
                SpllselR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 25;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 26 - System PLL Clock Error" ]
            # [ inline ( always ) ]
            pub fn spllerr(&self) -> SpllerrR {
                SpllerrR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 26;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - System PLL Enable" ]
            # [ inline ( always ) ]
            pub fn spllen(&mut self) -> _SpllenW {
                _SpllenW { w: self }
            }
            # [ doc = "Bit 16 - System PLL Clock Monitor" ]
            # [ inline ( always ) ]
            pub fn spllcm(&mut self) -> _SpllcmW {
                _SpllcmW { w: self }
            }
            # [ doc = "Bit 17 - System PLL Clock Monitor Reset Enable" ]
            # [ inline ( always ) ]
            pub fn spllcmre(&mut self) -> _SpllcmreW {
                _SpllcmreW { w: self }
            }
            # [ doc = "Bit 23 - Lock Register" ]
            # [ inline ( always ) ]
            pub fn lk(&mut self) -> _LkW {
                _LkW { w: self }
            }
            # [ doc = "Bit 26 - System PLL Clock Error" ]
            # [ inline ( always ) ]
            pub fn spllerr(&mut self) -> _SpllerrW {
                _SpllerrW { w: self }
            }
        }
    }
    # [ doc = "System PLL Divide Register" ]
    pub struct Splldiv {
        register: VolatileCell<u32>,
    }
    # [ doc = "System PLL Divide Register" ]
    pub mod splldiv {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Splldiv {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SPLLDIV1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Splldiv1R {
            # [ doc = "Clock disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Splldiv1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Splldiv1R::_000 => 0,
                    Splldiv1R::_001 => 1,
                    Splldiv1R::_010 => 2,
                    Splldiv1R::_011 => 3,
                    Splldiv1R::_100 => 4,
                    Splldiv1R::_101 => 5,
                    Splldiv1R::_110 => 6,
                    Splldiv1R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Splldiv1R {
                match bits {
                    0 => Splldiv1R::_000,
                    1 => Splldiv1R::_001,
                    2 => Splldiv1R::_010,
                    3 => Splldiv1R::_011,
                    4 => Splldiv1R::_100,
                    5 => Splldiv1R::_101,
                    6 => Splldiv1R::_110,
                    7 => Splldiv1R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Splldiv1R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Splldiv1R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Splldiv1R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Splldiv1R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Splldiv1R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Splldiv1R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Splldiv1R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Splldiv1R::_111
            }
        }
        # [ doc = "Possible values of the field `SPLLDIV2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Splldiv2R {
            # [ doc = "Clock disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Splldiv2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Splldiv2R::_000 => 0,
                    Splldiv2R::_001 => 1,
                    Splldiv2R::_010 => 2,
                    Splldiv2R::_011 => 3,
                    Splldiv2R::_100 => 4,
                    Splldiv2R::_101 => 5,
                    Splldiv2R::_110 => 6,
                    Splldiv2R::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Splldiv2R {
                match bits {
                    0 => Splldiv2R::_000,
                    1 => Splldiv2R::_001,
                    2 => Splldiv2R::_010,
                    3 => Splldiv2R::_011,
                    4 => Splldiv2R::_100,
                    5 => Splldiv2R::_101,
                    6 => Splldiv2R::_110,
                    7 => Splldiv2R::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == Splldiv2R::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == Splldiv2R::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == Splldiv2R::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == Splldiv2R::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == Splldiv2R::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == Splldiv2R::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == Splldiv2R::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == Splldiv2R::_111
            }
        }
        # [ doc = "Values that can be written to the field `SPLLDIV1`" ]
        pub enum Splldiv1W {
            # [ doc = "Clock disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Splldiv1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Splldiv1W::_000 => 0,
                    Splldiv1W::_001 => 1,
                    Splldiv1W::_010 => 2,
                    Splldiv1W::_011 => 3,
                    Splldiv1W::_100 => 4,
                    Splldiv1W::_101 => 5,
                    Splldiv1W::_110 => 6,
                    Splldiv1W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Splldiv1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Splldiv1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Splldiv1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Splldiv1W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Splldiv1W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Splldiv1W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Splldiv1W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Splldiv1W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Splldiv1W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Splldiv1W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Splldiv1W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SPLLDIV2`" ]
        pub enum Splldiv2W {
            # [ doc = "Clock disabled" ]
            _000,
            # [ doc = "Divide by 1" ]
            _001,
            # [ doc = "Divide by 2" ]
            _010,
            # [ doc = "Divide by 4" ]
            _011,
            # [ doc = "Divide by 8" ]
            _100,
            # [ doc = "Divide by 16" ]
            _101,
            # [ doc = "Divide by 32" ]
            _110,
            # [ doc = "Divide by 64" ]
            _111,
        }
        impl Splldiv2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Splldiv2W::_000 => 0,
                    Splldiv2W::_001 => 1,
                    Splldiv2W::_010 => 2,
                    Splldiv2W::_011 => 3,
                    Splldiv2W::_100 => 4,
                    Splldiv2W::_101 => 5,
                    Splldiv2W::_110 => 6,
                    Splldiv2W::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Splldiv2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Splldiv2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Splldiv2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(Splldiv2W::_000)
            }
            # [ doc = "Divide by 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(Splldiv2W::_001)
            }
            # [ doc = "Divide by 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(Splldiv2W::_010)
            }
            # [ doc = "Divide by 4" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(Splldiv2W::_011)
            }
            # [ doc = "Divide by 8" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(Splldiv2W::_100)
            }
            # [ doc = "Divide by 16" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(Splldiv2W::_101)
            }
            # [ doc = "Divide by 32" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(Splldiv2W::_110)
            }
            # [ doc = "Divide by 64" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(Splldiv2W::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - System PLL Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn splldiv1(&self) -> Splldiv1R {
                Splldiv1R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:10 - System PLL Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn splldiv2(&self) -> Splldiv2R {
                Splldiv2R::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - System PLL Clock Divide 1" ]
            # [ inline ( always ) ]
            pub fn splldiv1(&mut self) -> _Splldiv1W {
                _Splldiv1W { w: self }
            }
            # [ doc = "Bits 8:10 - System PLL Clock Divide 2" ]
            # [ inline ( always ) ]
            pub fn splldiv2(&mut self) -> _Splldiv2W {
                _Splldiv2W { w: self }
            }
        }
    }
    # [ doc = "System PLL Configuration Register" ]
    pub struct Spllcfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "System PLL Configuration Register" ]
    pub mod spllcfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Spllcfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PredivR {
            bits: u8,
        }
        impl PredivR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MultR {
            bits: u8,
        }
        impl MultR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PredivW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PredivW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MultW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MultW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:10 - PLL Reference Clock Divider" ]
            # [ inline ( always ) ]
            pub fn prediv(&self) -> PredivR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PredivR { bits }
            }
            # [ doc = "Bits 16:20 - System PLL Multiplier" ]
            # [ inline ( always ) ]
            pub fn mult(&self) -> MultR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MultR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 8:10 - PLL Reference Clock Divider" ]
            # [ inline ( always ) ]
            pub fn prediv(&mut self) -> _PredivW {
                _PredivW { w: self }
            }
            # [ doc = "Bits 16:20 - System PLL Multiplier" ]
            # [ inline ( always ) ]
            pub fn mult(&mut self) -> _MultW {
                _MultW { w: self }
            }
        }
    }
}
# [ doc = "System Clock Generator" ]
pub struct Scg {
    register_block: scg::RegisterBlock,
}
impl Deref for Scg {
    type Target = scg::RegisterBlock;
    fn deref(&self) -> &scg::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "PCC" ]
pub const PCC: Peripheral<Pcc> = unsafe { Peripheral::new(1074155520) };
# [ doc = "PCC" ]
pub mod pcc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - PCC Reserved Register 0" ]
        pub pccdummy0: Pccdummy0,
        # [ doc = "0x04 - PCC Reserved Register 1" ]
        pub pccdummy1: Pccdummy1,
        # [ doc = "0x08 - PCC Reserved Register 2" ]
        pub pccdummy2: Pccdummy2,
        # [ doc = "0x0c - PCC Reserved Register 3" ]
        pub pccdummy3: Pccdummy3,
        # [ doc = "0x10 - PCC Reserved Register 4" ]
        pub pccdummy4: Pccdummy4,
        # [ doc = "0x14 - PCC Reserved Register 5" ]
        pub pccdummy5: Pccdummy5,
        # [ doc = "0x18 - PCC Reserved Register 6" ]
        pub pccdummy6: Pccdummy6,
        # [ doc = "0x1c - PCC Reserved Register 7" ]
        pub pccdummy7: Pccdummy7,
        # [ doc = "0x20 - PCC Reserved Register 8" ]
        pub pccdummy8: Pccdummy8,
        # [ doc = "0x24 - PCC Reserved Register 9" ]
        pub pccdummy9: Pccdummy9,
        # [ doc = "0x28 - PCC Reserved Register 10" ]
        pub pccdummy10: Pccdummy10,
        # [ doc = "0x2c - PCC Reserved Register 11" ]
        pub pccdummy11: Pccdummy11,
        # [ doc = "0x30 - PCC Reserved Register 12" ]
        pub pccdummy12: Pccdummy12,
        # [ doc = "0x34 - PCC Reserved Register 13" ]
        pub pccdummy13: Pccdummy13,
        # [ doc = "0x38 - PCC Reserved Register 14" ]
        pub pccdummy14: Pccdummy14,
        # [ doc = "0x3c - PCC Reserved Register 15" ]
        pub pccdummy15: Pccdummy15,
        # [ doc = "0x40 - PCC Reserved Register 16" ]
        pub pccdummy16: Pccdummy16,
        # [ doc = "0x44 - PCC Reserved Register 17" ]
        pub pccdummy17: Pccdummy17,
        # [ doc = "0x48 - PCC Reserved Register 18" ]
        pub pccdummy18: Pccdummy18,
        # [ doc = "0x4c - PCC Reserved Register 19" ]
        pub pccdummy19: Pccdummy19,
        # [ doc = "0x50 - PCC Reserved Register 20" ]
        pub pccdummy20: Pccdummy20,
        # [ doc = "0x54 - PCC Reserved Register 21" ]
        pub pccdummy21: Pccdummy21,
        # [ doc = "0x58 - PCC Reserved Register 22" ]
        pub pccdummy22: Pccdummy22,
        # [ doc = "0x5c - PCC Reserved Register 23" ]
        pub pccdummy23: Pccdummy23,
        # [ doc = "0x60 - PCC Reserved Register 24" ]
        pub pccdummy24: Pccdummy24,
        # [ doc = "0x64 - PCC Reserved Register 25" ]
        pub pccdummy25: Pccdummy25,
        # [ doc = "0x68 - PCC Reserved Register 26" ]
        pub pccdummy26: Pccdummy26,
        # [ doc = "0x6c - PCC Reserved Register 27" ]
        pub pccdummy27: Pccdummy27,
        # [ doc = "0x70 - PCC Reserved Register 28" ]
        pub pccdummy28: Pccdummy28,
        # [ doc = "0x74 - PCC Reserved Register 29" ]
        pub pccdummy29: Pccdummy29,
        # [ doc = "0x78 - PCC Reserved Register 30" ]
        pub pccdummy30: Pccdummy30,
        # [ doc = "0x7c - PCC Reserved Register 31" ]
        pub pccdummy31: Pccdummy31,
        # [ doc = "0x80 - PCC FTFC Register" ]
        pub pcc_ftfc: PccFtfc,
        # [ doc = "0x84 - PCC DMAMUX Register" ]
        pub pcc_dmamux: PccDmamux,
        # [ doc = "0x88 - PCC Reserved Register 34" ]
        pub pccdummy34: Pccdummy34,
        # [ doc = "0x8c - PCC Reserved Register 35" ]
        pub pccdummy35: Pccdummy35,
        # [ doc = "0x90 - PCC FlexCAN0 Register" ]
        pub pcc_flex_can0: PccFlexCan0,
        # [ doc = "0x94 - PCC FlexCAN1 Register" ]
        pub pcc_flex_can1: PccFlexCan1,
        # [ doc = "0x98 - PCC FTM3 Register" ]
        pub pcc_ftm3: PccFtm3,
        # [ doc = "0x9c - PCC ADC1 Register" ]
        pub pcc_adc1: PccAdc1,
        # [ doc = "0xa0 - PCC Reserved Register 40" ]
        pub pccdummy40: Pccdummy40,
        # [ doc = "0xa4 - PCC Reserved Register 41" ]
        pub pccdummy41: Pccdummy41,
        # [ doc = "0xa8 - PCC Reserved Register 42" ]
        pub pccdummy42: Pccdummy42,
        # [ doc = "0xac - PCC FlexCAN2 Register" ]
        pub pcc_flex_can2: PccFlexCan2,
        # [ doc = "0xb0 - PCC LPSPI0 Register" ]
        pub pcc_lpspi0: PccLpspi0,
        # [ doc = "0xb4 - PCC LPSPI1 Register" ]
        pub pcc_lpspi1: PccLpspi1,
        # [ doc = "0xb8 - PCC LPSPI2 Register" ]
        pub pcc_lpspi2: PccLpspi2,
        # [ doc = "0xbc - PCC Reserved Register 47" ]
        pub pccdummy47: Pccdummy47,
        # [ doc = "0xc0 - PCC Reserved Register 48" ]
        pub pccdummy48: Pccdummy48,
        # [ doc = "0xc4 - PCC PDB1 Register" ]
        pub pcc_pdb1: PccPdb1,
        # [ doc = "0xc8 - PCC CRC Register" ]
        pub pcc_crc: PccCrc,
        # [ doc = "0xcc - PCC Reserved Register 51" ]
        pub pccdummy51: Pccdummy51,
        # [ doc = "0xd0 - PCC Reserved Register 52" ]
        pub pccdummy52: Pccdummy52,
        # [ doc = "0xd4 - PCC Reserved Register 53" ]
        pub pccdummy53: Pccdummy53,
        # [ doc = "0xd8 - PCC PDB0 Register" ]
        pub pcc_pdb0: PccPdb0,
        # [ doc = "0xdc - PCC LPIT Register" ]
        pub pcc_lpit: PccLpit,
        # [ doc = "0xe0 - PCC FTM0 Register" ]
        pub pcc_ftm0: PccFtm0,
        # [ doc = "0xe4 - PCC FTM1 Register" ]
        pub pcc_ftm1: PccFtm1,
        # [ doc = "0xe8 - PCC FTM2 Register" ]
        pub pcc_ftm2: PccFtm2,
        # [ doc = "0xec - PCC ADC0 Register" ]
        pub pcc_adc0: PccAdc0,
        # [ doc = "0xf0 - PCC Reserved Register 60" ]
        pub pccdummy60: Pccdummy60,
        # [ doc = "0xf4 - PCC RTC Register" ]
        pub pcc_rtc: PccRtc,
        # [ doc = "0xf8 - PCC Reserved Register 62" ]
        pub pccdummy62: Pccdummy62,
        # [ doc = "0xfc - PCC Reserved Register 63" ]
        pub pccdummy63: Pccdummy63,
        # [ doc = "0x100 - PCC LPTMR0 Register" ]
        pub pcc_lptmr0: PccLptmr0,
        # [ doc = "0x104 - PCC Reserved Register 65" ]
        pub pccdummy65: Pccdummy65,
        # [ doc = "0x108 - PCC Reserved Register 66" ]
        pub pccdummy66: Pccdummy66,
        # [ doc = "0x10c - PCC Reserved Register 67" ]
        pub pccdummy67: Pccdummy67,
        # [ doc = "0x110 - PCC Reserved Register 68" ]
        pub pccdummy68: Pccdummy68,
        # [ doc = "0x114 - PCC Reserved Register 69" ]
        pub pccdummy69: Pccdummy69,
        # [ doc = "0x118 - PCC Reserved Register 70" ]
        pub pccdummy70: Pccdummy70,
        # [ doc = "0x11c - PCC Reserved Register 71" ]
        pub pccdummy71: Pccdummy71,
        # [ doc = "0x120 - PCC Reserved Register 72" ]
        pub pccdummy72: Pccdummy72,
        # [ doc = "0x124 - PCC PORTA Register" ]
        pub pcc_porta: PccPorta,
        # [ doc = "0x128 - PCC PORTB Register" ]
        pub pcc_portb: PccPortb,
        # [ doc = "0x12c - PCC PORTC Register" ]
        pub pcc_portc: PccPortc,
        # [ doc = "0x130 - PCC PORTD Register" ]
        pub pcc_portd: PccPortd,
        # [ doc = "0x134 - PCC PORTE Register" ]
        pub pcc_porte: PccPorte,
        # [ doc = "0x138 - PCC Reserved Register 78" ]
        pub pccdummy78: Pccdummy78,
        # [ doc = "0x13c - PCC Reserved Register 79" ]
        pub pccdummy79: Pccdummy79,
        # [ doc = "0x140 - PCC Reserved Register 80" ]
        pub pccdummy80: Pccdummy80,
        # [ doc = "0x144 - PCC Reserved Register 81" ]
        pub pccdummy81: Pccdummy81,
        # [ doc = "0x148 - PCC Reserved Register 82" ]
        pub pccdummy82: Pccdummy82,
        # [ doc = "0x14c - PCC Reserved Register 83" ]
        pub pccdummy83: Pccdummy83,
        # [ doc = "0x150 - PCC Reserved Register 84" ]
        pub pccdummy84: Pccdummy84,
        # [ doc = "0x154 - PCC Reserved Register 85" ]
        pub pccdummy85: Pccdummy85,
        # [ doc = "0x158 - PCC Reserved Register 86" ]
        pub pccdummy86: Pccdummy86,
        # [ doc = "0x15c - PCC Reserved Register 87" ]
        pub pccdummy87: Pccdummy87,
        # [ doc = "0x160 - PCC Reserved Register 88" ]
        pub pccdummy88: Pccdummy88,
        # [ doc = "0x164 - PCC Reserved Register 89" ]
        pub pccdummy89: Pccdummy89,
        # [ doc = "0x168 - PCC FlexIO Register" ]
        pub pcc_flexio: PccFlexio,
        # [ doc = "0x16c - PCC Reserved Register 91" ]
        pub pccdummy91: Pccdummy91,
        # [ doc = "0x170 - PCC Reserved Register 92" ]
        pub pccdummy92: Pccdummy92,
        # [ doc = "0x174 - PCC Reserved Register 93" ]
        pub pccdummy93: Pccdummy93,
        # [ doc = "0x178 - PCC Reserved Register 94" ]
        pub pccdummy94: Pccdummy94,
        # [ doc = "0x17c - PCC Reserved Register 95" ]
        pub pccdummy95: Pccdummy95,
        # [ doc = "0x180 - PCC Reserved Register 96" ]
        pub pccdummy96: Pccdummy96,
        # [ doc = "0x184 - PCC EWM Register" ]
        pub pcc_ewm: PccEwm,
        # [ doc = "0x188 - PCC Reserved Register 98" ]
        pub pccdummy98: Pccdummy98,
        # [ doc = "0x18c - PCC Reserved Register 99" ]
        pub pccdummy99: Pccdummy99,
        # [ doc = "0x190 - PCC Reserved Register 100" ]
        pub pccdummy100: Pccdummy100,
        # [ doc = "0x194 - PCC Reserved Register 101" ]
        pub pccdummy101: Pccdummy101,
        # [ doc = "0x198 - PCC LPI2C0 Register" ]
        pub pcc_lpi2c0: PccLpi2c0,
        # [ doc = "0x19c - PCC Reserved Register 103" ]
        pub pccdummy103: Pccdummy103,
        # [ doc = "0x1a0 - PCC Reserved Register 104" ]
        pub pccdummy104: Pccdummy104,
        # [ doc = "0x1a4 - PCC Reserved Register 105" ]
        pub pccdummy105: Pccdummy105,
        # [ doc = "0x1a8 - PCC LPUART0 Register" ]
        pub pcc_lpuart0: PccLpuart0,
        # [ doc = "0x1ac - PCC LPUART1 Register" ]
        pub pcc_lpuart1: PccLpuart1,
        # [ doc = "0x1b0 - PCC LPUART2 Register" ]
        pub pcc_lpuart2: PccLpuart2,
        # [ doc = "0x1b4 - PCC Reserved Register 109" ]
        pub pccdummy109: Pccdummy109,
        # [ doc = "0x1b8 - PCC Reserved Register 110" ]
        pub pccdummy110: Pccdummy110,
        # [ doc = "0x1bc - PCC Reserved Register 111" ]
        pub pccdummy111: Pccdummy111,
        # [ doc = "0x1c0 - PCC Reserved Register 112" ]
        pub pccdummy112: Pccdummy112,
        # [ doc = "0x1c4 - PCC Reserved Register 113" ]
        pub pccdummy113: Pccdummy113,
        # [ doc = "0x1c8 - PCC Reserved Register 114" ]
        pub pccdummy114: Pccdummy114,
        # [ doc = "0x1cc - PCC CMP0 Register" ]
        pub pcc_cmp0: PccCmp0,
    }
    # [ doc = "PCC Reserved Register 0" ]
    pub struct Pccdummy0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 0" ]
    pub mod pccdummy0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 1" ]
    pub struct Pccdummy1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 1" ]
    pub mod pccdummy1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 2" ]
    pub struct Pccdummy2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 2" ]
    pub mod pccdummy2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 3" ]
    pub struct Pccdummy3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 3" ]
    pub mod pccdummy3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 4" ]
    pub struct Pccdummy4 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 4" ]
    pub mod pccdummy4 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy4 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 5" ]
    pub struct Pccdummy5 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 5" ]
    pub mod pccdummy5 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy5 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 6" ]
    pub struct Pccdummy6 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 6" ]
    pub mod pccdummy6 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy6 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 7" ]
    pub struct Pccdummy7 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 7" ]
    pub mod pccdummy7 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy7 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 8" ]
    pub struct Pccdummy8 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 8" ]
    pub mod pccdummy8 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy8 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 9" ]
    pub struct Pccdummy9 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 9" ]
    pub mod pccdummy9 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy9 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 10" ]
    pub struct Pccdummy10 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 10" ]
    pub mod pccdummy10 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy10 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 11" ]
    pub struct Pccdummy11 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 11" ]
    pub mod pccdummy11 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy11 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 12" ]
    pub struct Pccdummy12 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 12" ]
    pub mod pccdummy12 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy12 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 13" ]
    pub struct Pccdummy13 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 13" ]
    pub mod pccdummy13 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy13 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 14" ]
    pub struct Pccdummy14 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 14" ]
    pub mod pccdummy14 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy14 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 15" ]
    pub struct Pccdummy15 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 15" ]
    pub mod pccdummy15 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy15 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 16" ]
    pub struct Pccdummy16 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 16" ]
    pub mod pccdummy16 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy16 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 17" ]
    pub struct Pccdummy17 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 17" ]
    pub mod pccdummy17 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy17 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 18" ]
    pub struct Pccdummy18 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 18" ]
    pub mod pccdummy18 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy18 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 19" ]
    pub struct Pccdummy19 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 19" ]
    pub mod pccdummy19 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy19 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 20" ]
    pub struct Pccdummy20 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 20" ]
    pub mod pccdummy20 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy20 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 21" ]
    pub struct Pccdummy21 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 21" ]
    pub mod pccdummy21 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy21 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 22" ]
    pub struct Pccdummy22 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 22" ]
    pub mod pccdummy22 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy22 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 23" ]
    pub struct Pccdummy23 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 23" ]
    pub mod pccdummy23 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy23 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 24" ]
    pub struct Pccdummy24 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 24" ]
    pub mod pccdummy24 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy24 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 25" ]
    pub struct Pccdummy25 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 25" ]
    pub mod pccdummy25 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy25 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 26" ]
    pub struct Pccdummy26 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 26" ]
    pub mod pccdummy26 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy26 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 27" ]
    pub struct Pccdummy27 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 27" ]
    pub mod pccdummy27 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy27 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 28" ]
    pub struct Pccdummy28 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 28" ]
    pub mod pccdummy28 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy28 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 29" ]
    pub struct Pccdummy29 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 29" ]
    pub mod pccdummy29 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy29 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 30" ]
    pub struct Pccdummy30 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 30" ]
    pub mod pccdummy30 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy30 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 31" ]
    pub struct Pccdummy31 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 31" ]
    pub mod pccdummy31 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy31 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC FTFC Register" ]
    pub struct PccFtfc {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FTFC Register" ]
    pub mod pcc_ftfc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFtfc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3221225472 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC DMAMUX Register" ]
    pub struct PccDmamux {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC DMAMUX Register" ]
    pub mod pcc_dmamux {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccDmamux {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 34" ]
    pub struct Pccdummy34 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 34" ]
    pub mod pccdummy34 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy34 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 35" ]
    pub struct Pccdummy35 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 35" ]
    pub mod pccdummy35 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy35 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC FlexCAN0 Register" ]
    pub struct PccFlexCan0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FlexCAN0 Register" ]
    pub mod pcc_flex_can0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFlexCan0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC FlexCAN1 Register" ]
    pub struct PccFlexCan1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FlexCAN1 Register" ]
    pub mod pcc_flex_can1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFlexCan1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC FTM3 Register" ]
    pub struct PccFtm3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FTM3 Register" ]
    pub mod pcc_ftm3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFtm3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC ADC1 Register" ]
    pub struct PccAdc1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC ADC1 Register" ]
    pub mod pcc_adc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccAdc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 40" ]
    pub struct Pccdummy40 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 40" ]
    pub mod pccdummy40 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy40 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 41" ]
    pub struct Pccdummy41 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 41" ]
    pub mod pccdummy41 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy41 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 42" ]
    pub struct Pccdummy42 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 42" ]
    pub mod pccdummy42 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy42 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC FlexCAN2 Register" ]
    pub struct PccFlexCan2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FlexCAN2 Register" ]
    pub mod pcc_flex_can2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFlexCan2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC LPSPI0 Register" ]
    pub struct PccLpspi0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPSPI0 Register" ]
    pub mod pcc_lpspi0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpspi0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC LPSPI1 Register" ]
    pub struct PccLpspi1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPSPI1 Register" ]
    pub mod pcc_lpspi1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpspi1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC LPSPI2 Register" ]
    pub struct PccLpspi2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPSPI2 Register" ]
    pub mod pcc_lpspi2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpspi2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 47" ]
    pub struct Pccdummy47 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 47" ]
    pub mod pccdummy47 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy47 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 48" ]
    pub struct Pccdummy48 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 48" ]
    pub mod pccdummy48 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy48 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC PDB1 Register" ]
    pub struct PccPdb1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PDB1 Register" ]
    pub mod pcc_pdb1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPdb1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC CRC Register" ]
    pub struct PccCrc {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC CRC Register" ]
    pub mod pcc_crc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccCrc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 51" ]
    pub struct Pccdummy51 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 51" ]
    pub mod pccdummy51 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy51 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 52" ]
    pub struct Pccdummy52 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 52" ]
    pub mod pccdummy52 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy52 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 53" ]
    pub struct Pccdummy53 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 53" ]
    pub mod pccdummy53 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy53 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC PDB0 Register" ]
    pub struct PccPdb0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PDB0 Register" ]
    pub mod pcc_pdb0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPdb0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC LPIT Register" ]
    pub struct PccLpit {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPIT Register" ]
    pub mod pcc_lpit {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpit {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC FTM0 Register" ]
    pub struct PccFtm0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FTM0 Register" ]
    pub mod pcc_ftm0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFtm0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC FTM1 Register" ]
    pub struct PccFtm1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FTM1 Register" ]
    pub mod pcc_ftm1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFtm1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC FTM2 Register" ]
    pub struct PccFtm2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FTM2 Register" ]
    pub mod pcc_ftm2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFtm2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off. An external clock can be enabled for this peripheral." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC ADC0 Register" ]
    pub struct PccAdc0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC ADC0 Register" ]
    pub mod pcc_adc0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccAdc0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 60" ]
    pub struct Pccdummy60 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 60" ]
    pub mod pccdummy60 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy60 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC RTC Register" ]
    pub struct PccRtc {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC RTC Register" ]
    pub mod pcc_rtc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccRtc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 62" ]
    pub struct Pccdummy62 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 62" ]
    pub mod pccdummy62 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy62 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 63" ]
    pub struct Pccdummy63 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 63" ]
    pub mod pccdummy63 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy63 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC LPTMR0 Register" ]
    pub struct PccLptmr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPTMR0 Register" ]
    pub mod pcc_lptmr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLptmr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcdR {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 3." ]
            _010,
            # [ doc = "Divide by 4." ]
            _011,
            # [ doc = "Divide by 5." ]
            _100,
            # [ doc = "Divide by 6." ]
            _101,
            # [ doc = "Divide by 7." ]
            _110,
            # [ doc = "Divide by 8." ]
            _111,
        }
        impl PcdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcdR::_000 => 0,
                    PcdR::_001 => 1,
                    PcdR::_010 => 2,
                    PcdR::_011 => 3,
                    PcdR::_100 => 4,
                    PcdR::_101 => 5,
                    PcdR::_110 => 6,
                    PcdR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcdR {
                match bits {
                    0 => PcdR::_000,
                    1 => PcdR::_001,
                    2 => PcdR::_010,
                    3 => PcdR::_011,
                    4 => PcdR::_100,
                    5 => PcdR::_101,
                    6 => PcdR::_110,
                    7 => PcdR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcdR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcdR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcdR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcdR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcdR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcdR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcdR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcdR::_111
            }
        }
        # [ doc = "Possible values of the field `FRAC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FracR {
            # [ doc = "Fractional value is 0." ]
            _0,
            # [ doc = "Fractional value is 1." ]
            _1,
        }
        impl FracR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FracR::_0 => 0,
                    FracR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FracR {
                match bits {
                    0 => FracR::_0,
                    1 => FracR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FracR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FracR::_1
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCD`" ]
        pub enum PcdW {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 3." ]
            _010,
            # [ doc = "Divide by 4." ]
            _011,
            # [ doc = "Divide by 5." ]
            _100,
            # [ doc = "Divide by 6." ]
            _101,
            # [ doc = "Divide by 7." ]
            _110,
            # [ doc = "Divide by 8." ]
            _111,
        }
        impl PcdW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcdW::_000 => 0,
                    PcdW::_001 => 1,
                    PcdW::_010 => 2,
                    PcdW::_011 => 3,
                    PcdW::_100 => 4,
                    PcdW::_101 => 5,
                    PcdW::_110 => 6,
                    PcdW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcdW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcdW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcdW::_000)
            }
            # [ doc = "Divide by 2." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcdW::_001)
            }
            # [ doc = "Divide by 3." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcdW::_010)
            }
            # [ doc = "Divide by 4." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcdW::_011)
            }
            # [ doc = "Divide by 5." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcdW::_100)
            }
            # [ doc = "Divide by 6." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcdW::_101)
            }
            # [ doc = "Divide by 7." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcdW::_110)
            }
            # [ doc = "Divide by 8." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcdW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRAC`" ]
        pub enum FracW {
            # [ doc = "Fractional value is 0." ]
            _0,
            # [ doc = "Fractional value is 1." ]
            _1,
        }
        impl FracW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FracW::_0 => 0,
                    FracW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FracW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FracW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FracW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fractional value is 0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FracW::_0)
            }
            # [ doc = "Fractional value is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FracW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Peripheral Clock Divider Select" ]
            # [ inline ( always ) ]
            pub fn pcd(&self) -> PcdR {
                PcdR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Peripheral Clock Divider Fraction" ]
            # [ inline ( always ) ]
            pub fn frac(&self) -> FracR {
                FracR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Peripheral Clock Divider Select" ]
            # [ inline ( always ) ]
            pub fn pcd(&mut self) -> _PcdW {
                _PcdW { w: self }
            }
            # [ doc = "Bit 3 - Peripheral Clock Divider Fraction" ]
            # [ inline ( always ) ]
            pub fn frac(&mut self) -> _FracW {
                _FracW { w: self }
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 65" ]
    pub struct Pccdummy65 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 65" ]
    pub mod pccdummy65 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy65 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 66" ]
    pub struct Pccdummy66 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 66" ]
    pub mod pccdummy66 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy66 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 67" ]
    pub struct Pccdummy67 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 67" ]
    pub mod pccdummy67 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy67 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 68" ]
    pub struct Pccdummy68 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 68" ]
    pub mod pccdummy68 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy68 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 69" ]
    pub struct Pccdummy69 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 69" ]
    pub mod pccdummy69 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy69 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 70" ]
    pub struct Pccdummy70 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 70" ]
    pub mod pccdummy70 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy70 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 71" ]
    pub struct Pccdummy71 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 71" ]
    pub mod pccdummy71 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy71 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 72" ]
    pub struct Pccdummy72 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 72" ]
    pub mod pccdummy72 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy72 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC PORTA Register" ]
    pub struct PccPorta {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PORTA Register" ]
    pub mod pcc_porta {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPorta {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC PORTB Register" ]
    pub struct PccPortb {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PORTB Register" ]
    pub mod pcc_portb {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPortb {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC PORTC Register" ]
    pub struct PccPortc {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PORTC Register" ]
    pub mod pcc_portc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPortc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC PORTD Register" ]
    pub struct PccPortd {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PORTD Register" ]
    pub mod pcc_portd {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPortd {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC PORTE Register" ]
    pub struct PccPorte {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC PORTE Register" ]
    pub mod pcc_porte {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccPorte {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 78" ]
    pub struct Pccdummy78 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 78" ]
    pub mod pccdummy78 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy78 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 79" ]
    pub struct Pccdummy79 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 79" ]
    pub mod pccdummy79 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy79 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 80" ]
    pub struct Pccdummy80 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 80" ]
    pub mod pccdummy80 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy80 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 81" ]
    pub struct Pccdummy81 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 81" ]
    pub mod pccdummy81 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy81 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 82" ]
    pub struct Pccdummy82 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 82" ]
    pub mod pccdummy82 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy82 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 83" ]
    pub struct Pccdummy83 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 83" ]
    pub mod pccdummy83 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy83 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 84" ]
    pub struct Pccdummy84 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 84" ]
    pub mod pccdummy84 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy84 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 85" ]
    pub struct Pccdummy85 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 85" ]
    pub mod pccdummy85 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy85 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 86" ]
    pub struct Pccdummy86 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 86" ]
    pub mod pccdummy86 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy86 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 87" ]
    pub struct Pccdummy87 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 87" ]
    pub mod pccdummy87 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy87 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 88" ]
    pub struct Pccdummy88 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 88" ]
    pub mod pccdummy88 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy88 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 89" ]
    pub struct Pccdummy89 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 89" ]
    pub mod pccdummy89 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy89 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC FlexIO Register" ]
    pub struct PccFlexio {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC FlexIO Register" ]
    pub mod pcc_flexio {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccFlexio {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 91" ]
    pub struct Pccdummy91 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 91" ]
    pub mod pccdummy91 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy91 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 92" ]
    pub struct Pccdummy92 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 92" ]
    pub mod pccdummy92 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy92 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 93" ]
    pub struct Pccdummy93 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 93" ]
    pub mod pccdummy93 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy93 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 94" ]
    pub struct Pccdummy94 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 94" ]
    pub mod pccdummy94 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy94 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 95" ]
    pub struct Pccdummy95 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 95" ]
    pub mod pccdummy95 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy95 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 96" ]
    pub struct Pccdummy96 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 96" ]
    pub mod pccdummy96 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy96 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC EWM Register" ]
    pub struct PccEwm {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC EWM Register" ]
    pub mod pcc_ewm {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccEwm {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 98" ]
    pub struct Pccdummy98 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 98" ]
    pub mod pccdummy98 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy98 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 99" ]
    pub struct Pccdummy99 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 99" ]
    pub mod pccdummy99 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy99 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 100" ]
    pub struct Pccdummy100 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 100" ]
    pub mod pccdummy100 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy100 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 101" ]
    pub struct Pccdummy101 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 101" ]
    pub mod pccdummy101 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy101 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC LPI2C0 Register" ]
    pub struct PccLpi2c0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPI2C0 Register" ]
    pub mod pcc_lpi2c0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpi2c0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 103" ]
    pub struct Pccdummy103 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 103" ]
    pub mod pccdummy103 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy103 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 104" ]
    pub struct Pccdummy104 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 104" ]
    pub mod pccdummy104 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy104 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 105" ]
    pub struct Pccdummy105 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 105" ]
    pub mod pccdummy105 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy105 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC LPUART0 Register" ]
    pub struct PccLpuart0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPUART0 Register" ]
    pub mod pcc_lpuart0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpuart0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC LPUART1 Register" ]
    pub struct PccLpuart1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPUART1 Register" ]
    pub mod pcc_lpuart1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpuart1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC LPUART2 Register" ]
    pub struct PccLpuart2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC LPUART2 Register" ]
    pub mod pcc_lpuart2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccLpuart2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PCS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PcsR {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PcsR::_000 => 0,
                    PcsR::_001 => 1,
                    PcsR::_010 => 2,
                    PcsR::_011 => 3,
                    PcsR::_100 => 4,
                    PcsR::_101 => 5,
                    PcsR::_110 => 6,
                    PcsR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PcsR {
                match bits {
                    0 => PcsR::_000,
                    1 => PcsR::_001,
                    2 => PcsR::_010,
                    3 => PcsR::_011,
                    4 => PcsR::_100,
                    5 => PcsR::_101,
                    6 => PcsR::_110,
                    7 => PcsR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PcsR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PcsR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PcsR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PcsR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PcsR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PcsR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PcsR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PcsR::_111
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `PCS`" ]
        pub enum PcsW {
            # [ doc = "Clock is off." ]
            _000,
            # [ doc = "Clock option 1" ]
            _001,
            # [ doc = "Clock option 2" ]
            _010,
            # [ doc = "Clock option 3" ]
            _011,
            # [ doc = "Clock option 4" ]
            _100,
            # [ doc = "Clock option 5" ]
            _101,
            # [ doc = "Clock option 6" ]
            _110,
            # [ doc = "Clock option 7" ]
            _111,
        }
        impl PcsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PcsW::_000 => 0,
                    PcsW::_001 => 1,
                    PcsW::_010 => 2,
                    PcsW::_011 => 3,
                    PcsW::_100 => 4,
                    PcsW::_101 => 5,
                    PcsW::_110 => 6,
                    PcsW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PcsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PcsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PcsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock is off." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PcsW::_000)
            }
            # [ doc = "Clock option 1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PcsW::_001)
            }
            # [ doc = "Clock option 2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PcsW::_010)
            }
            # [ doc = "Clock option 3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PcsW::_011)
            }
            # [ doc = "Clock option 4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PcsW::_100)
            }
            # [ doc = "Clock option 5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PcsW::_101)
            }
            # [ doc = "Clock option 6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PcsW::_110)
            }
            # [ doc = "Clock option 7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PcsW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&self) -> PcsR {
                PcsR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 24:26 - Peripheral Clock Source Select" ]
            # [ inline ( always ) ]
            pub fn pcs(&mut self) -> _PcsW {
                _PcsW { w: self }
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
    # [ doc = "PCC Reserved Register 109" ]
    pub struct Pccdummy109 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 109" ]
    pub mod pccdummy109 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy109 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 110" ]
    pub struct Pccdummy110 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 110" ]
    pub mod pccdummy110 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy110 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 111" ]
    pub struct Pccdummy111 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 111" ]
    pub mod pccdummy111 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy111 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 112" ]
    pub struct Pccdummy112 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 112" ]
    pub mod pccdummy112 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy112 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 113" ]
    pub struct Pccdummy113 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 113" ]
    pub mod pccdummy113 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy113 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC Reserved Register 114" ]
    pub struct Pccdummy114 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC Reserved Register 114" ]
    pub mod pccdummy114 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccdummy114 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
        }
    }
    # [ doc = "PCC CMP0 Register" ]
    pub struct PccCmp0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "PCC CMP0 Register" ]
    pub mod pcc_cmp0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::PccCmp0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CGC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CgcR {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CgcR::_0 => 0,
                    CgcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CgcR {
                match bits {
                    0 => CgcR::_0,
                    1 => CgcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CgcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CgcR::_1
            }
        }
        # [ doc = "Possible values of the field `PR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrR {
            # [ doc = "Peripheral is not present." ]
            _0,
            # [ doc = "Peripheral is present." ]
            _1,
        }
        impl PrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrR::_0 => 0,
                    PrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrR {
                match bits {
                    0 => PrR::_0,
                    1 => PrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CGC`" ]
        pub enum CgcW {
            # [ doc = "Clock disabled" ]
            _0,
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            _1,
        }
        impl CgcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CgcW::_0 => 0,
                    CgcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CgcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CgcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CgcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CgcW::_0)
            }
            # [ doc = "Clock enabled. The current clock selection and divider options are locked." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CgcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&self) -> CgcR {
                CgcR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 30;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 31 - Present" ]
            # [ inline ( always ) ]
            pub fn pr(&self) -> PrR {
                PrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2147483648 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 30 - Clock Gate Control" ]
            # [ inline ( always ) ]
            pub fn cgc(&mut self) -> _CgcW {
                _CgcW { w: self }
            }
        }
    }
}
# [ doc = "PCC" ]
pub struct Pcc {
    register_block: pcc::RegisterBlock,
}
impl Deref for Pcc {
    type Target = pcc::RegisterBlock;
    fn deref(&self) -> &pcc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "The LPI2C Memory Map/Register Definition can be found here." ]
pub const LPI2C0: Peripheral<Lpi2c0> = unsafe { Peripheral::new(1074159616) };
# [ doc = "The LPI2C Memory Map/Register Definition can be found here." ]
pub mod lpi2c0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        _reserved0: [u8; 8usize],
        # [ doc = "0x10 - Master Control Register" ]
        pub mcr: Mcr,
        # [ doc = "0x14 - Master Status Register" ]
        pub msr: Msr,
        # [ doc = "0x18 - Master Interrupt Enable Register" ]
        pub mier: Mier,
        # [ doc = "0x1c - Master DMA Enable Register" ]
        pub mder: Mder,
        # [ doc = "0x20 - Master Configuration Register 0" ]
        pub mcfgr0: Mcfgr0,
        # [ doc = "0x24 - Master Configuration Register 1" ]
        pub mcfgr1: Mcfgr1,
        # [ doc = "0x28 - Master Configuration Register 2" ]
        pub mcfgr2: Mcfgr2,
        # [ doc = "0x2c - Master Configuration Register 3" ]
        pub mcfgr3: Mcfgr3,
        _reserved1: [u8; 16usize],
        # [ doc = "0x40 - Master Data Match Register" ]
        pub mdmr: Mdmr,
        _reserved2: [u8; 4usize],
        # [ doc = "0x48 - Master Clock Configuration Register 0" ]
        pub mccr0: Mccr0,
        _reserved3: [u8; 4usize],
        # [ doc = "0x50 - Master Clock Configuration Register 1" ]
        pub mccr1: Mccr1,
        _reserved4: [u8; 4usize],
        # [ doc = "0x58 - Master FIFO Control Register" ]
        pub mfcr: Mfcr,
        # [ doc = "0x5c - Master FIFO Status Register" ]
        pub mfsr: Mfsr,
        # [ doc = "0x60 - Master Transmit Data Register" ]
        pub mtdr: Mtdr,
        _reserved5: [u8; 12usize],
        # [ doc = "0x70 - Master Receive Data Register" ]
        pub mrdr: Mrdr,
        _reserved6: [u8; 156usize],
        # [ doc = "0x110 - Slave Control Register" ]
        pub scr: Scr,
        # [ doc = "0x114 - Slave Status Register" ]
        pub ssr: Ssr,
        # [ doc = "0x118 - Slave Interrupt Enable Register" ]
        pub sier: Sier,
        # [ doc = "0x11c - Slave DMA Enable Register" ]
        pub sder: Sder,
        _reserved7: [u8; 4usize],
        # [ doc = "0x124 - Slave Configuration Register 1" ]
        pub scfgr1: Scfgr1,
        # [ doc = "0x128 - Slave Configuration Register 2" ]
        pub scfgr2: Scfgr2,
        _reserved8: [u8; 20usize],
        # [ doc = "0x140 - Slave Address Match Register" ]
        pub samr: Samr,
        _reserved9: [u8; 12usize],
        # [ doc = "0x150 - Slave Address Status Register" ]
        pub sasr: Sasr,
        # [ doc = "0x154 - Slave Transmit ACK Register" ]
        pub star: Star,
        _reserved10: [u8; 8usize],
        # [ doc = "0x160 - Slave Transmit Data Register" ]
        pub stdr: Stdr,
        _reserved11: [u8; 12usize],
        # [ doc = "0x170 - Slave Receive Data Register" ]
        pub srdr: Srdr,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Master only with standard feature set." ]
            _0000000000000010,
            # [ doc = "Master and slave with standard feature set." ]
            _0000000000000011,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000010 => 2,
                    FeatureR::_0000000000000011 => 3,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    2 => FeatureR::_0000000000000010,
                    3 => FeatureR::_0000000000000011,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000010`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000010(&self) -> bool {
                *self == FeatureR::_0000000000000010
            }
            # [ doc = "Checks if the value of the field is `_0000000000000011`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000011(&self) -> bool {
                *self == FeatureR::_0000000000000011
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Specification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MtxfifoR {
            bits: u8,
        }
        impl MtxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MrxfifoR {
            bits: u8,
        }
        impl MrxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Master Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn mtxfifo(&self) -> MtxfifoR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MtxfifoR { bits }
            }
            # [ doc = "Bits 8:11 - Master Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn mrxfifo(&self) -> MrxfifoR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MrxfifoR { bits }
            }
        }
    }
    # [ doc = "Master Control Register" ]
    pub struct Mcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Control Register" ]
    pub mod mcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MenR {
            # [ doc = "Master logic is disabled." ]
            _0,
            # [ doc = "Master logic is enabled." ]
            _1,
        }
        impl MenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MenR::_0 => 0,
                    MenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MenR {
                match bits {
                    0 => MenR::_0,
                    1 => MenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MenR::_1
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozenR {
            # [ doc = "Master is enabled in Doze mode." ]
            _0,
            # [ doc = "Master is disabled in Doze mode." ]
            _1,
        }
        impl DozenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozenR::_0 => 0,
                    DozenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozenR {
                match bits {
                    0 => DozenR::_0,
                    1 => DozenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozenR::_1
            }
        }
        # [ doc = "Possible values of the field `DBGEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DbgenR {
            # [ doc = "Master is disabled in debug mode." ]
            _0,
            # [ doc = "Master is enabled in debug mode." ]
            _1,
        }
        impl DbgenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DbgenR::_0 => 0,
                    DbgenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DbgenR {
                match bits {
                    0 => DbgenR::_0,
                    1 => DbgenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DbgenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DbgenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MEN`" ]
        pub enum MenW {
            # [ doc = "Master logic is disabled." ]
            _0,
            # [ doc = "Master logic is enabled." ]
            _1,
        }
        impl MenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MenW::_0 => 0,
                    MenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master logic is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MenW::_0)
            }
            # [ doc = "Master logic is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Master logic is not reset." ]
            _0,
            # [ doc = "Master logic is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master logic is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Master logic is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEN`" ]
        pub enum DozenW {
            # [ doc = "Master is enabled in Doze mode." ]
            _0,
            # [ doc = "Master is disabled in Doze mode." ]
            _1,
        }
        impl DozenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozenW::_0 => 0,
                    DozenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozenW::_0)
            }
            # [ doc = "Master is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DBGEN`" ]
        pub enum DbgenW {
            # [ doc = "Master is disabled in debug mode." ]
            _0,
            # [ doc = "Master is enabled in debug mode." ]
            _1,
        }
        impl DbgenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DbgenW::_0 => 0,
                    DbgenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DbgenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DbgenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DbgenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master is disabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DbgenW::_0)
            }
            # [ doc = "Master is enabled in debug mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DbgenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RTF`" ]
        pub enum RtfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Transmit FIFO is reset." ]
            _1,
        }
        impl RtfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RtfW::_0 => 0,
                    RtfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RtfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RtfW::_0)
            }
            # [ doc = "Transmit FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RtfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRF`" ]
        pub enum RrfW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "Receive FIFO is reset." ]
            _1,
        }
        impl RrfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrfW::_0 => 0,
                    RrfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrfW::_0)
            }
            # [ doc = "Receive FIFO is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Master Enable" ]
            # [ inline ( always ) ]
            pub fn men(&self) -> MenR {
                MenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&self) -> DozenR {
                DozenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&self) -> DbgenR {
                DbgenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Master Enable" ]
            # [ inline ( always ) ]
            pub fn men(&mut self) -> _MenW {
                _MenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
            # [ doc = "Bit 2 - Doze mode enable" ]
            # [ inline ( always ) ]
            pub fn dozen(&mut self) -> _DozenW {
                _DozenW { w: self }
            }
            # [ doc = "Bit 3 - Debug Enable" ]
            # [ inline ( always ) ]
            pub fn dbgen(&mut self) -> _DbgenW {
                _DbgenW { w: self }
            }
            # [ doc = "Bit 8 - Reset Transmit FIFO" ]
            # [ inline ( always ) ]
            pub fn rtf(&mut self) -> _RtfW {
                _RtfW { w: self }
            }
            # [ doc = "Bit 9 - Reset Receive FIFO" ]
            # [ inline ( always ) ]
            pub fn rrf(&mut self) -> _RrfW {
                _RrfW { w: self }
            }
        }
    }
    # [ doc = "Master Status Register" ]
    pub struct Msr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Status Register" ]
    pub mod msr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Msr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdfR {
            # [ doc = "Transmit data not requested." ]
            _0,
            # [ doc = "Transmit data is requested." ]
            _1,
        }
        impl TdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdfR::_0 => 0,
                    TdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdfR {
                match bits {
                    0 => TdfR::_0,
                    1 => TdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdfR::_1
            }
        }
        # [ doc = "Possible values of the field `RDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdfR {
            # [ doc = "Receive Data is not ready." ]
            _0,
            # [ doc = "Receive data is ready." ]
            _1,
        }
        impl RdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdfR::_0 => 0,
                    RdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdfR {
                match bits {
                    0 => RdfR::_0,
                    1 => RdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdfR::_1
            }
        }
        # [ doc = "Possible values of the field `EPF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EpfR {
            # [ doc = "Master has not generated a STOP or Repeated START condition." ]
            _0,
            # [ doc = "Master has generated a STOP or Repeated START condition." ]
            _1,
        }
        impl EpfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EpfR::_0 => 0,
                    EpfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EpfR {
                match bits {
                    0 => EpfR::_0,
                    1 => EpfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EpfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EpfR::_1
            }
        }
        # [ doc = "Possible values of the field `SDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SdfR {
            # [ doc = "Master has not generated a STOP condition." ]
            _0,
            # [ doc = "Master has generated a STOP condition." ]
            _1,
        }
        impl SdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SdfR::_0 => 0,
                    SdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SdfR {
                match bits {
                    0 => SdfR::_0,
                    1 => SdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SdfR::_1
            }
        }
        # [ doc = "Possible values of the field `NDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NdfR {
            # [ doc = "Unexpected NACK not detected." ]
            _0,
            # [ doc = "Unexpected NACK was detected." ]
            _1,
        }
        impl NdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NdfR::_0 => 0,
                    NdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NdfR {
                match bits {
                    0 => NdfR::_0,
                    1 => NdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NdfR::_1
            }
        }
        # [ doc = "Possible values of the field `ALF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AlfR {
            # [ doc = "Master has not lost arbitration." ]
            _0,
            # [ doc = "Master has lost arbitration." ]
            _1,
        }
        impl AlfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AlfR::_0 => 0,
                    AlfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AlfR {
                match bits {
                    0 => AlfR::_0,
                    1 => AlfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AlfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AlfR::_1
            }
        }
        # [ doc = "Possible values of the field `FEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FefR {
            # [ doc = "No error." ]
            _0,
            # [ doc = "Master sending or receiving data without START condition." ]
            _1,
        }
        impl FefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FefR::_0 => 0,
                    FefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FefR {
                match bits {
                    0 => FefR::_0,
                    1 => FefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FefR::_1
            }
        }
        # [ doc = "Possible values of the field `PLTF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PltfR {
            # [ doc = "Pin low timeout has not occurred or is disabled." ]
            _0,
            # [ doc = "Pin low timeout has occurred." ]
            _1,
        }
        impl PltfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PltfR::_0 => 0,
                    PltfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PltfR {
                match bits {
                    0 => PltfR::_0,
                    1 => PltfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PltfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PltfR::_1
            }
        }
        # [ doc = "Possible values of the field `DMF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmfR {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmfR::_0 => 0,
                    DmfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmfR {
                match bits {
                    0 => DmfR::_0,
                    1 => DmfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmfR::_1
            }
        }
        # [ doc = "Possible values of the field `MBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MbfR {
            # [ doc = "I2C Master is idle." ]
            _0,
            # [ doc = "I2C Master is busy." ]
            _1,
        }
        impl MbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MbfR::_0 => 0,
                    MbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MbfR {
                match bits {
                    0 => MbfR::_0,
                    1 => MbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MbfR::_1
            }
        }
        # [ doc = "Possible values of the field `BBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BbfR {
            # [ doc = "I2C Bus is idle." ]
            _0,
            # [ doc = "I2C Bus is busy." ]
            _1,
        }
        impl BbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BbfR::_0 => 0,
                    BbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BbfR {
                match bits {
                    0 => BbfR::_0,
                    1 => BbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BbfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `EPF`" ]
        pub enum EpfW {
            # [ doc = "Master has not generated a STOP or Repeated START condition." ]
            _0,
            # [ doc = "Master has generated a STOP or Repeated START condition." ]
            _1,
        }
        impl EpfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EpfW::_0 => 0,
                    EpfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EpfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master has not generated a STOP or Repeated START condition." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EpfW::_0)
            }
            # [ doc = "Master has generated a STOP or Repeated START condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EpfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SDF`" ]
        pub enum SdfW {
            # [ doc = "Master has not generated a STOP condition." ]
            _0,
            # [ doc = "Master has generated a STOP condition." ]
            _1,
        }
        impl SdfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SdfW::_0 => 0,
                    SdfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SdfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SdfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SdfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master has not generated a STOP condition." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SdfW::_0)
            }
            # [ doc = "Master has generated a STOP condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SdfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NDF`" ]
        pub enum NdfW {
            # [ doc = "Unexpected NACK not detected." ]
            _0,
            # [ doc = "Unexpected NACK was detected." ]
            _1,
        }
        impl NdfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NdfW::_0 => 0,
                    NdfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NdfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NdfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NdfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Unexpected NACK not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NdfW::_0)
            }
            # [ doc = "Unexpected NACK was detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NdfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ALF`" ]
        pub enum AlfW {
            # [ doc = "Master has not lost arbitration." ]
            _0,
            # [ doc = "Master has lost arbitration." ]
            _1,
        }
        impl AlfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AlfW::_0 => 0,
                    AlfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AlfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AlfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AlfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Master has not lost arbitration." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AlfW::_0)
            }
            # [ doc = "Master has lost arbitration." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AlfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEF`" ]
        pub enum FefW {
            # [ doc = "No error." ]
            _0,
            # [ doc = "Master sending or receiving data without START condition." ]
            _1,
        }
        impl FefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FefW::_0 => 0,
                    FefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No error." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FefW::_0)
            }
            # [ doc = "Master sending or receiving data without START condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PLTF`" ]
        pub enum PltfW {
            # [ doc = "Pin low timeout has not occurred or is disabled." ]
            _0,
            # [ doc = "Pin low timeout has occurred." ]
            _1,
        }
        impl PltfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PltfW::_0 => 0,
                    PltfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PltfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PltfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PltfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin low timeout has not occurred or is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PltfW::_0)
            }
            # [ doc = "Pin low timeout has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PltfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMF`" ]
        pub enum DmfW {
            # [ doc = "Have not received matching data." ]
            _0,
            # [ doc = "Have received matching data." ]
            _1,
        }
        impl DmfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmfW::_0 => 0,
                    DmfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Have not received matching data." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmfW::_0)
            }
            # [ doc = "Have received matching data." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Flag" ]
            # [ inline ( always ) ]
            pub fn tdf(&self) -> TdfR {
                TdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Receive Data Flag" ]
            # [ inline ( always ) ]
            pub fn rdf(&self) -> RdfR {
                RdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - End Packet Flag" ]
            # [ inline ( always ) ]
            pub fn epf(&self) -> EpfR {
                EpfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - STOP Detect Flag" ]
            # [ inline ( always ) ]
            pub fn sdf(&self) -> SdfR {
                SdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - NACK Detect Flag" ]
            # [ inline ( always ) ]
            pub fn ndf(&self) -> NdfR {
                NdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Arbitration Lost Flag" ]
            # [ inline ( always ) ]
            pub fn alf(&self) -> AlfR {
                AlfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 11;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - FIFO Error Flag" ]
            # [ inline ( always ) ]
            pub fn fef(&self) -> FefR {
                FefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 12;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 13 - Pin Low Timeout Flag" ]
            # [ inline ( always ) ]
            pub fn pltf(&self) -> PltfR {
                PltfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&self) -> DmfR {
                DmfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Master Busy Flag" ]
            # [ inline ( always ) ]
            pub fn mbf(&self) -> MbfR {
                MbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Bus Busy Flag" ]
            # [ inline ( always ) ]
            pub fn bbf(&self) -> BbfR {
                BbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 1 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - End Packet Flag" ]
            # [ inline ( always ) ]
            pub fn epf(&mut self) -> _EpfW {
                _EpfW { w: self }
            }
            # [ doc = "Bit 9 - STOP Detect Flag" ]
            # [ inline ( always ) ]
            pub fn sdf(&mut self) -> _SdfW {
                _SdfW { w: self }
            }
            # [ doc = "Bit 10 - NACK Detect Flag" ]
            # [ inline ( always ) ]
            pub fn ndf(&mut self) -> _NdfW {
                _NdfW { w: self }
            }
            # [ doc = "Bit 11 - Arbitration Lost Flag" ]
            # [ inline ( always ) ]
            pub fn alf(&mut self) -> _AlfW {
                _AlfW { w: self }
            }
            # [ doc = "Bit 12 - FIFO Error Flag" ]
            # [ inline ( always ) ]
            pub fn fef(&mut self) -> _FefW {
                _FefW { w: self }
            }
            # [ doc = "Bit 13 - Pin Low Timeout Flag" ]
            # [ inline ( always ) ]
            pub fn pltf(&mut self) -> _PltfW {
                _PltfW { w: self }
            }
            # [ doc = "Bit 14 - Data Match Flag" ]
            # [ inline ( always ) ]
            pub fn dmf(&mut self) -> _DmfW {
                _DmfW { w: self }
            }
        }
    }
    # [ doc = "Master Interrupt Enable Register" ]
    pub struct Mier {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Interrupt Enable Register" ]
    pub mod mier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdieR::_0 => 0,
                    TdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdieR {
                match bits {
                    0 => TdieR::_0,
                    1 => TdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdieR::_0 => 0,
                    RdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdieR {
                match bits {
                    0 => RdieR::_0,
                    1 => RdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdieR::_1
            }
        }
        # [ doc = "Possible values of the field `EPIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EpieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl EpieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EpieR::_0 => 0,
                    EpieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EpieR {
                match bits {
                    0 => EpieR::_0,
                    1 => EpieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EpieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EpieR::_1
            }
        }
        # [ doc = "Possible values of the field `SDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SdieR::_0 => 0,
                    SdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SdieR {
                match bits {
                    0 => SdieR::_0,
                    1 => SdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SdieR::_1
            }
        }
        # [ doc = "Possible values of the field `NDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl NdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NdieR::_0 => 0,
                    NdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NdieR {
                match bits {
                    0 => NdieR::_0,
                    1 => NdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NdieR::_1
            }
        }
        # [ doc = "Possible values of the field `ALIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AlieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl AlieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AlieR::_0 => 0,
                    AlieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AlieR {
                match bits {
                    0 => AlieR::_0,
                    1 => AlieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AlieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AlieR::_1
            }
        }
        # [ doc = "Possible values of the field `FEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeieR {
            # [ doc = "Interrupt enabled." ]
            _0,
            # [ doc = "Interrupt disabled." ]
            _1,
        }
        impl FeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeieR::_0 => 0,
                    FeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeieR {
                match bits {
                    0 => FeieR::_0,
                    1 => FeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeieR::_1
            }
        }
        # [ doc = "Possible values of the field `PLTIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PltieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl PltieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PltieR::_0 => 0,
                    PltieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PltieR {
                match bits {
                    0 => PltieR::_0,
                    1 => PltieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PltieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PltieR::_1
            }
        }
        # [ doc = "Possible values of the field `DMIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmieR::_0 => 0,
                    DmieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmieR {
                match bits {
                    0 => DmieR::_0,
                    1 => DmieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDIE`" ]
        pub enum TdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdieW::_0 => 0,
                    TdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdieW::_0)
            }
            # [ doc = "Interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDIE`" ]
        pub enum RdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdieW::_0 => 0,
                    RdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EPIE`" ]
        pub enum EpieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl EpieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EpieW::_0 => 0,
                    EpieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EpieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EpieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EpieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EpieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EpieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SDIE`" ]
        pub enum SdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SdieW::_0 => 0,
                    SdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NDIE`" ]
        pub enum NdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl NdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NdieW::_0 => 0,
                    NdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ALIE`" ]
        pub enum AlieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl AlieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AlieW::_0 => 0,
                    AlieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AlieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AlieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AlieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AlieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AlieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEIE`" ]
        pub enum FeieW {
            # [ doc = "Interrupt enabled." ]
            _0,
            # [ doc = "Interrupt disabled." ]
            _1,
        }
        impl FeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeieW::_0 => 0,
                    FeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeieW::_0)
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PLTIE`" ]
        pub enum PltieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl PltieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PltieW::_0 => 0,
                    PltieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PltieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PltieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PltieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PltieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PltieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMIE`" ]
        pub enum DmieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl DmieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmieW::_0 => 0,
                    DmieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&self) -> TdieR {
                TdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&self) -> RdieR {
                RdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - End Packet Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn epie(&self) -> EpieR {
                EpieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - STOP Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn sdie(&self) -> SdieR {
                SdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - NACK Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ndie(&self) -> NdieR {
                NdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - Arbitration Lost Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn alie(&self) -> AlieR {
                AlieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - FIFO Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&self) -> FeieR {
                FeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 13 - Pin Low Timeout Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pltie(&self) -> PltieR {
                PltieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&self) -> DmieR {
                DmieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&mut self) -> _TdieW {
                _TdieW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&mut self) -> _RdieW {
                _RdieW { w: self }
            }
            # [ doc = "Bit 8 - End Packet Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn epie(&mut self) -> _EpieW {
                _EpieW { w: self }
            }
            # [ doc = "Bit 9 - STOP Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn sdie(&mut self) -> _SdieW {
                _SdieW { w: self }
            }
            # [ doc = "Bit 10 - NACK Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ndie(&mut self) -> _NdieW {
                _NdieW { w: self }
            }
            # [ doc = "Bit 11 - Arbitration Lost Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn alie(&mut self) -> _AlieW {
                _AlieW { w: self }
            }
            # [ doc = "Bit 12 - FIFO Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&mut self) -> _FeieW {
                _FeieW { w: self }
            }
            # [ doc = "Bit 13 - Pin Low Timeout Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn pltie(&mut self) -> _PltieW {
                _PltieW { w: self }
            }
            # [ doc = "Bit 14 - Data Match Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn dmie(&mut self) -> _DmieW {
                _DmieW { w: self }
            }
        }
    }
    # [ doc = "Master DMA Enable Register" ]
    pub struct Mder {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master DMA Enable Register" ]
    pub mod mder {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mder {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TddeR::_0 => 0,
                    TddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TddeR {
                match bits {
                    0 => TddeR::_0,
                    1 => TddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TddeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RddeR::_0 => 0,
                    RddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RddeR {
                match bits {
                    0 => RddeR::_0,
                    1 => RddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RddeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDDE`" ]
        pub enum TddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TddeW::_0 => 0,
                    TddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TddeW::_0)
            }
            # [ doc = "DMA request enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDDE`" ]
        pub enum RddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RddeW::_0 => 0,
                    RddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RddeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&self) -> TddeR {
                TddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&self) -> RddeR {
                RddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&mut self) -> _TddeW {
                _TddeW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&mut self) -> _RddeW {
                _RddeW { w: self }
            }
        }
    }
    # [ doc = "Master Configuration Register 0" ]
    pub struct Mcfgr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Configuration Register 0" ]
    pub mod mcfgr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcfgr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrenR {
            # [ doc = "Host request input is disabled." ]
            _0,
            # [ doc = "Host request input is enabled." ]
            _1,
        }
        impl HrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrenR::_0 => 0,
                    HrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrenR {
                match bits {
                    0 => HrenR::_0,
                    1 => HrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrenR::_1
            }
        }
        # [ doc = "Possible values of the field `HRPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrpolR {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrpolR::_0 => 0,
                    HrpolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrpolR {
                match bits {
                    0 => HrpolR::_0,
                    1 => HrpolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrpolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrpolR::_1
            }
        }
        # [ doc = "Possible values of the field `HRSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HrselR {
            # [ doc = "Host request input is pin HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HrselR::_0 => 0,
                    HrselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HrselR {
                match bits {
                    0 => HrselR::_0,
                    1 => HrselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HrselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HrselR::_1
            }
        }
        # [ doc = "Possible values of the field `CIRFIFO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CirfifoR {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CirfifoR::_0 => 0,
                    CirfifoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CirfifoR {
                match bits {
                    0 => CirfifoR::_0,
                    1 => CirfifoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CirfifoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CirfifoR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmoR {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the RMF is set." ]
            _1,
        }
        impl RdmoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmoR::_0 => 0,
                    RdmoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmoR {
                match bits {
                    0 => RdmoR::_0,
                    1 => RdmoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HREN`" ]
        pub enum HrenW {
            # [ doc = "Host request input is disabled." ]
            _0,
            # [ doc = "Host request input is enabled." ]
            _1,
        }
        impl HrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrenW::_0 => 0,
                    HrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request input is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrenW::_0)
            }
            # [ doc = "Host request input is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRPOL`" ]
        pub enum HrpolW {
            # [ doc = "Active low." ]
            _0,
            # [ doc = "Active high." ]
            _1,
        }
        impl HrpolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrpolW::_0 => 0,
                    HrpolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrpolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrpolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrpolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrpolW::_0)
            }
            # [ doc = "Active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrpolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HRSEL`" ]
        pub enum HrselW {
            # [ doc = "Host request input is pin HREQ." ]
            _0,
            # [ doc = "Host request input is input trigger." ]
            _1,
        }
        impl HrselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HrselW::_0 => 0,
                    HrselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HrselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HrselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HrselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Host request input is pin HREQ." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HrselW::_0)
            }
            # [ doc = "Host request input is input trigger." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HrselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CIRFIFO`" ]
        pub enum CirfifoW {
            # [ doc = "Circular FIFO is disabled." ]
            _0,
            # [ doc = "Circular FIFO is enabled." ]
            _1,
        }
        impl CirfifoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CirfifoW::_0 => 0,
                    CirfifoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CirfifoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CirfifoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CirfifoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Circular FIFO is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CirfifoW::_0)
            }
            # [ doc = "Circular FIFO is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CirfifoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMO`" ]
        pub enum RdmoW {
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            _0,
            # [ doc = "Received data is discarded unless the RMF is set." ]
            _1,
        }
        impl RdmoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmoW::_0 => 0,
                    RdmoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is stored in the receive FIFO as normal." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmoW::_0)
            }
            # [ doc = "Received data is discarded unless the RMF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&self) -> HrenR {
                HrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&self) -> HrpolR {
                HrpolR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 1;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&self) -> HrselR {
                HrselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 2;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&self) -> CirfifoR {
                CirfifoR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&self) -> RdmoR {
                RdmoR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Host Request Enable" ]
            # [ inline ( always ) ]
            pub fn hren(&mut self) -> _HrenW {
                _HrenW { w: self }
            }
            # [ doc = "Bit 1 - Host Request Polarity" ]
            # [ inline ( always ) ]
            pub fn hrpol(&mut self) -> _HrpolW {
                _HrpolW { w: self }
            }
            # [ doc = "Bit 2 - Host Request Select" ]
            # [ inline ( always ) ]
            pub fn hrsel(&mut self) -> _HrselW {
                _HrselW { w: self }
            }
            # [ doc = "Bit 8 - Circular FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn cirfifo(&mut self) -> _CirfifoW {
                _CirfifoW { w: self }
            }
            # [ doc = "Bit 9 - Receive Data Match Only" ]
            # [ inline ( always ) ]
            pub fn rdmo(&mut self) -> _RdmoW {
                _RdmoW { w: self }
            }
        }
    }
    # [ doc = "Master Configuration Register 1" ]
    pub struct Mcfgr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Configuration Register 1" ]
    pub mod mcfgr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcfgr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PRESCALE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PrescaleR {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PrescaleR::_000 => 0,
                    PrescaleR::_001 => 1,
                    PrescaleR::_010 => 2,
                    PrescaleR::_011 => 3,
                    PrescaleR::_100 => 4,
                    PrescaleR::_101 => 5,
                    PrescaleR::_110 => 6,
                    PrescaleR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PrescaleR {
                match bits {
                    0 => PrescaleR::_000,
                    1 => PrescaleR::_001,
                    2 => PrescaleR::_010,
                    3 => PrescaleR::_011,
                    4 => PrescaleR::_100,
                    5 => PrescaleR::_101,
                    6 => PrescaleR::_110,
                    7 => PrescaleR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PrescaleR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PrescaleR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PrescaleR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PrescaleR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PrescaleR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PrescaleR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PrescaleR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PrescaleR::_111
            }
        }
        # [ doc = "Possible values of the field `AUTOSTOP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AutostopR {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "STOP condition is automatically generated whenever the transmit FIFO is empty and LPI2C master is busy." ]
            _1,
        }
        impl AutostopR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AutostopR::_0 => 0,
                    AutostopR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AutostopR {
                match bits {
                    0 => AutostopR::_0,
                    1 => AutostopR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AutostopR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AutostopR::_1
            }
        }
        # [ doc = "Possible values of the field `IGNACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IgnackR {
            # [ doc = "LPI2C Master will receive ACK and NACK normally." ]
            _0,
            # [ doc = "LPI2C Master will treat a received NACK as if it was an ACK." ]
            _1,
        }
        impl IgnackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IgnackR::_0 => 0,
                    IgnackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IgnackR {
                match bits {
                    0 => IgnackR::_0,
                    1 => IgnackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IgnackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IgnackR::_1
            }
        }
        # [ doc = "Possible values of the field `TIMECFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TimecfgR {
            # [ doc = "Pin Low Timeout Flag will set if SCL is low for longer than the configured timeout." ]
            _0,
            # [ doc = "Pin Low Timeout Flag will set if either SCL or SDA is low for longer than the configured timeout." ]
            _1,
        }
        impl TimecfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TimecfgR::_0 => 0,
                    TimecfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TimecfgR {
                match bits {
                    0 => TimecfgR::_0,
                    1 => TimecfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TimecfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TimecfgR::_1
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Match disabled." ]
            _000,
            # [ doc = "Match enabled (1st data word equals MATCH0 OR MATCH1)." ]
            _010,
            # [ doc = "Match enabled (any data word equals MATCH0 OR MATCH1)." ]
            _011,
            # [ doc = "Match enabled (1st data word equals MATCH0 AND 2nd data word equals MATCH1)." ]
            _100,
            # [ doc = "Match enabled (any data word equals MATCH0 AND next data word equals MATCH1)." ]
            _101,
            # [ doc = "Match enabled (1st data word AND MATCH1 equals MATCH0 AND MATCH1)." ]
            _110,
            # [ doc = "Match enabled (any data word AND MATCH1 equals MATCH0 AND MATCH1)." ]
            _111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_000 => 0,
                    MatcfgR::_010 => 2,
                    MatcfgR::_011 => 3,
                    MatcfgR::_100 => 4,
                    MatcfgR::_101 => 5,
                    MatcfgR::_110 => 6,
                    MatcfgR::_111 => 7,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_000,
                    2 => MatcfgR::_010,
                    3 => MatcfgR::_011,
                    4 => MatcfgR::_100,
                    5 => MatcfgR::_101,
                    6 => MatcfgR::_110,
                    7 => MatcfgR::_111,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MatcfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MatcfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MatcfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MatcfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MatcfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MatcfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MatcfgR::_111
            }
        }
        # [ doc = "Possible values of the field `PINCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PincfgR {
            # [ doc = "LPI2C configured for 2-pin open drain mode." ]
            _000,
            # [ doc = "LPI2C configured for 2-pin output only mode (ultra-fast mode)." ]
            _001,
            # [ doc = "LPI2C configured for 2-pin push-pull mode." ]
            _010,
            # [ doc = "LPI2C configured for 4-pin push-pull mode." ]
            _011,
            # [ doc = "LPI2C configured for 2-pin open drain mode with separate LPI2C slave." ]
            _100,
            # [ doc = "LPI2C configured for 2-pin output only mode (ultra-fast mode) with separate LPI2C slave." ]
            _101,
            # [ doc = "LPI2C configured for 2-pin push-pull mode with separate LPI2C slave." ]
            _110,
            # [ doc = "LPI2C configured for 4-pin push-pull mode (inverted outputs)." ]
            _111,
        }
        impl PincfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PincfgR::_000 => 0,
                    PincfgR::_001 => 1,
                    PincfgR::_010 => 2,
                    PincfgR::_011 => 3,
                    PincfgR::_100 => 4,
                    PincfgR::_101 => 5,
                    PincfgR::_110 => 6,
                    PincfgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PincfgR {
                match bits {
                    0 => PincfgR::_000,
                    1 => PincfgR::_001,
                    2 => PincfgR::_010,
                    3 => PincfgR::_011,
                    4 => PincfgR::_100,
                    5 => PincfgR::_101,
                    6 => PincfgR::_110,
                    7 => PincfgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PincfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PincfgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PincfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PincfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PincfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PincfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PincfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PincfgR::_111
            }
        }
        # [ doc = "Values that can be written to the field `PRESCALE`" ]
        pub enum PrescaleW {
            # [ doc = "Divide by 1." ]
            _000,
            # [ doc = "Divide by 2." ]
            _001,
            # [ doc = "Divide by 4." ]
            _010,
            # [ doc = "Divide by 8." ]
            _011,
            # [ doc = "Divide by 16." ]
            _100,
            # [ doc = "Divide by 32." ]
            _101,
            # [ doc = "Divide by 64." ]
            _110,
            # [ doc = "Divide by 128." ]
            _111,
        }
        impl PrescaleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PrescaleW::_000 => 0,
                    PrescaleW::_001 => 1,
                    PrescaleW::_010 => 2,
                    PrescaleW::_011 => 3,
                    PrescaleW::_100 => 4,
                    PrescaleW::_101 => 5,
                    PrescaleW::_110 => 6,
                    PrescaleW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PrescaleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PrescaleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PrescaleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Divide by 1." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PrescaleW::_000)
            }
            # [ doc = "Divide by 2." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PrescaleW::_001)
            }
            # [ doc = "Divide by 4." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PrescaleW::_010)
            }
            # [ doc = "Divide by 8." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PrescaleW::_011)
            }
            # [ doc = "Divide by 16." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PrescaleW::_100)
            }
            # [ doc = "Divide by 32." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PrescaleW::_101)
            }
            # [ doc = "Divide by 64." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PrescaleW::_110)
            }
            # [ doc = "Divide by 128." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PrescaleW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AUTOSTOP`" ]
        pub enum AutostopW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "STOP condition is automatically generated whenever the transmit FIFO is empty and LPI2C master is busy." ]
            _1,
        }
        impl AutostopW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AutostopW::_0 => 0,
                    AutostopW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AutostopW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AutostopW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AutostopW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AutostopW::_0)
            }
            # [ doc = "STOP condition is automatically generated whenever the transmit FIFO is empty and LPI2C master is busy." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AutostopW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IGNACK`" ]
        pub enum IgnackW {
            # [ doc = "LPI2C Master will receive ACK and NACK normally." ]
            _0,
            # [ doc = "LPI2C Master will treat a received NACK as if it was an ACK." ]
            _1,
        }
        impl IgnackW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IgnackW::_0 => 0,
                    IgnackW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IgnackW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IgnackW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IgnackW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LPI2C Master will receive ACK and NACK normally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IgnackW::_0)
            }
            # [ doc = "LPI2C Master will treat a received NACK as if it was an ACK." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IgnackW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIMECFG`" ]
        pub enum TimecfgW {
            # [ doc = "Pin Low Timeout Flag will set if SCL is low for longer than the configured timeout." ]
            _0,
            # [ doc = "Pin Low Timeout Flag will set if either SCL or SDA is low for longer than the configured timeout." ]
            _1,
        }
        impl TimecfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TimecfgW::_0 => 0,
                    TimecfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TimecfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TimecfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TimecfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Pin Low Timeout Flag will set if SCL is low for longer than the configured timeout." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TimecfgW::_0)
            }
            # [ doc = "Pin Low Timeout Flag will set if either SCL or SDA is low for longer than the configured timeout." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TimecfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Match disabled." ]
            _000,
            # [ doc = "Match enabled (1st data word equals MATCH0 OR MATCH1)." ]
            _010,
            # [ doc = "Match enabled (any data word equals MATCH0 OR MATCH1)." ]
            _011,
            # [ doc = "Match enabled (1st data word equals MATCH0 AND 2nd data word equals MATCH1)." ]
            _100,
            # [ doc = "Match enabled (any data word equals MATCH0 AND next data word equals MATCH1)." ]
            _101,
            # [ doc = "Match enabled (1st data word AND MATCH1 equals MATCH0 AND MATCH1)." ]
            _110,
            # [ doc = "Match enabled (any data word AND MATCH1 equals MATCH0 AND MATCH1)." ]
            _111,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_000 => 0,
                    MatcfgW::_010 => 2,
                    MatcfgW::_011 => 3,
                    MatcfgW::_100 => 4,
                    MatcfgW::_101 => 5,
                    MatcfgW::_110 => 6,
                    MatcfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Match disabled." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MatcfgW::_000)
            }
            # [ doc = "Match enabled (1st data word equals MATCH0 OR MATCH1)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MatcfgW::_010)
            }
            # [ doc = "Match enabled (any data word equals MATCH0 OR MATCH1)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MatcfgW::_011)
            }
            # [ doc = "Match enabled (1st data word equals MATCH0 AND 2nd data word equals MATCH1)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MatcfgW::_100)
            }
            # [ doc = "Match enabled (any data word equals MATCH0 AND next data word equals MATCH1)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MatcfgW::_101)
            }
            # [ doc = "Match enabled (1st data word AND MATCH1 equals MATCH0 AND MATCH1)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MatcfgW::_110)
            }
            # [ doc = "Match enabled (any data word AND MATCH1 equals MATCH0 AND MATCH1)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MatcfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PINCFG`" ]
        pub enum PincfgW {
            # [ doc = "LPI2C configured for 2-pin open drain mode." ]
            _000,
            # [ doc = "LPI2C configured for 2-pin output only mode (ultra-fast mode)." ]
            _001,
            # [ doc = "LPI2C configured for 2-pin push-pull mode." ]
            _010,
            # [ doc = "LPI2C configured for 4-pin push-pull mode." ]
            _011,
            # [ doc = "LPI2C configured for 2-pin open drain mode with separate LPI2C slave." ]
            _100,
            # [ doc = "LPI2C configured for 2-pin output only mode (ultra-fast mode) with separate LPI2C slave." ]
            _101,
            # [ doc = "LPI2C configured for 2-pin push-pull mode with separate LPI2C slave." ]
            _110,
            # [ doc = "LPI2C configured for 4-pin push-pull mode (inverted outputs)." ]
            _111,
        }
        impl PincfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PincfgW::_000 => 0,
                    PincfgW::_001 => 1,
                    PincfgW::_010 => 2,
                    PincfgW::_011 => 3,
                    PincfgW::_100 => 4,
                    PincfgW::_101 => 5,
                    PincfgW::_110 => 6,
                    PincfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PincfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PincfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PincfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LPI2C configured for 2-pin open drain mode." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PincfgW::_000)
            }
            # [ doc = "LPI2C configured for 2-pin output only mode (ultra-fast mode)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PincfgW::_001)
            }
            # [ doc = "LPI2C configured for 2-pin push-pull mode." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PincfgW::_010)
            }
            # [ doc = "LPI2C configured for 4-pin push-pull mode." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PincfgW::_011)
            }
            # [ doc = "LPI2C configured for 2-pin open drain mode with separate LPI2C slave." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PincfgW::_100)
            }
            # [ doc = "LPI2C configured for 2-pin output only mode (ultra-fast mode) with separate LPI2C slave." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PincfgW::_101)
            }
            # [ doc = "LPI2C configured for 2-pin push-pull mode with separate LPI2C slave." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PincfgW::_110)
            }
            # [ doc = "LPI2C configured for 4-pin push-pull mode (inverted outputs)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PincfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Prescaler" ]
            # [ inline ( always ) ]
            pub fn prescale(&self) -> PrescaleR {
                PrescaleR::_from({
                                     const MASK: u8 = 7;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 8 - Automatic STOP Generation" ]
            # [ inline ( always ) ]
            pub fn autostop(&self) -> AutostopR {
                AutostopR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 8;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 9 - IGNACK" ]
            # [ inline ( always ) ]
            pub fn ignack(&self) -> IgnackR {
                IgnackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Timeout Configuration" ]
            # [ inline ( always ) ]
            pub fn timecfg(&self) -> TimecfgR {
                TimecfgR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 10;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 24:26 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&self) -> PincfgR {
                PincfgR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Prescaler" ]
            # [ inline ( always ) ]
            pub fn prescale(&mut self) -> _PrescaleW {
                _PrescaleW { w: self }
            }
            # [ doc = "Bit 8 - Automatic STOP Generation" ]
            # [ inline ( always ) ]
            pub fn autostop(&mut self) -> _AutostopW {
                _AutostopW { w: self }
            }
            # [ doc = "Bit 9 - IGNACK" ]
            # [ inline ( always ) ]
            pub fn ignack(&mut self) -> _IgnackW {
                _IgnackW { w: self }
            }
            # [ doc = "Bit 10 - Timeout Configuration" ]
            # [ inline ( always ) ]
            pub fn timecfg(&mut self) -> _TimecfgW {
                _TimecfgW { w: self }
            }
            # [ doc = "Bits 16:18 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bits 24:26 - Pin Configuration" ]
            # [ inline ( always ) ]
            pub fn pincfg(&mut self) -> _PincfgW {
                _PincfgW { w: self }
            }
        }
    }
    # [ doc = "Master Configuration Register 2" ]
    pub struct Mcfgr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Configuration Register 2" ]
    pub mod mcfgr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcfgr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct BusidleR {
            bits: u16,
        }
        impl BusidleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltsclR {
            bits: u8,
        }
        impl FiltsclR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltsdaR {
            bits: u8,
        }
        impl FiltsdaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BusidleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BusidleW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltsclW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltsclW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltsdaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltsdaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:11 - Bus Idle Timeout" ]
            # [ inline ( always ) ]
            pub fn busidle(&self) -> BusidleR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                BusidleR { bits }
            }
            # [ doc = "Bits 16:19 - Glitch Filter SCL" ]
            # [ inline ( always ) ]
            pub fn filtscl(&self) -> FiltsclR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltsclR { bits }
            }
            # [ doc = "Bits 24:27 - Glitch Filter SDA" ]
            # [ inline ( always ) ]
            pub fn filtsda(&self) -> FiltsdaR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltsdaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:11 - Bus Idle Timeout" ]
            # [ inline ( always ) ]
            pub fn busidle(&mut self) -> _BusidleW {
                _BusidleW { w: self }
            }
            # [ doc = "Bits 16:19 - Glitch Filter SCL" ]
            # [ inline ( always ) ]
            pub fn filtscl(&mut self) -> _FiltsclW {
                _FiltsclW { w: self }
            }
            # [ doc = "Bits 24:27 - Glitch Filter SDA" ]
            # [ inline ( always ) ]
            pub fn filtsda(&mut self) -> _FiltsdaW {
                _FiltsdaW { w: self }
            }
        }
    }
    # [ doc = "Master Configuration Register 3" ]
    pub struct Mcfgr3 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Configuration Register 3" ]
    pub mod mcfgr3 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mcfgr3 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PinlowR {
            bits: u16,
        }
        impl PinlowR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinlowW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinlowW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 8:19 - Pin Low Timeout" ]
            # [ inline ( always ) ]
            pub fn pinlow(&self) -> PinlowR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                PinlowR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 8:19 - Pin Low Timeout" ]
            # [ inline ( always ) ]
            pub fn pinlow(&mut self) -> _PinlowW {
                _PinlowW { w: self }
            }
        }
    }
    # [ doc = "Master Data Match Register" ]
    pub struct Mdmr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Data Match Register" ]
    pub mod mdmr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mdmr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match0R {
            bits: u8,
        }
        impl Match0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Match1R {
            bits: u8,
        }
        impl Match1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Match1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Match1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&self) -> Match0R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Match0R { bits }
            }
            # [ doc = "Bits 16:23 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&self) -> Match1R {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Match1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Match 0 Value" ]
            # [ inline ( always ) ]
            pub fn match0(&mut self) -> _Match0W {
                _Match0W { w: self }
            }
            # [ doc = "Bits 16:23 - Match 1 Value" ]
            # [ inline ( always ) ]
            pub fn match1(&mut self) -> _Match1W {
                _Match1W { w: self }
            }
        }
    }
    # [ doc = "Master Clock Configuration Register 0" ]
    pub struct Mccr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Clock Configuration Register 0" ]
    pub mod mccr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mccr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClkloR {
            bits: u8,
        }
        impl ClkloR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClkhiR {
            bits: u8,
        }
        impl ClkhiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SetholdR {
            bits: u8,
        }
        impl SetholdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatavdR {
            bits: u8,
        }
        impl DatavdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkloW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkloW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkhiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkhiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SetholdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SetholdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatavdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatavdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Clock Low Period" ]
            # [ inline ( always ) ]
            pub fn clklo(&self) -> ClkloR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClkloR { bits }
            }
            # [ doc = "Bits 8:13 - Clock High Period" ]
            # [ inline ( always ) ]
            pub fn clkhi(&self) -> ClkhiR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClkhiR { bits }
            }
            # [ doc = "Bits 16:21 - Setup Hold Delay" ]
            # [ inline ( always ) ]
            pub fn sethold(&self) -> SetholdR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SetholdR { bits }
            }
            # [ doc = "Bits 24:29 - Data Valid Delay" ]
            # [ inline ( always ) ]
            pub fn datavd(&self) -> DatavdR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DatavdR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Clock Low Period" ]
            # [ inline ( always ) ]
            pub fn clklo(&mut self) -> _ClkloW {
                _ClkloW { w: self }
            }
            # [ doc = "Bits 8:13 - Clock High Period" ]
            # [ inline ( always ) ]
            pub fn clkhi(&mut self) -> _ClkhiW {
                _ClkhiW { w: self }
            }
            # [ doc = "Bits 16:21 - Setup Hold Delay" ]
            # [ inline ( always ) ]
            pub fn sethold(&mut self) -> _SetholdW {
                _SetholdW { w: self }
            }
            # [ doc = "Bits 24:29 - Data Valid Delay" ]
            # [ inline ( always ) ]
            pub fn datavd(&mut self) -> _DatavdW {
                _DatavdW { w: self }
            }
        }
    }
    # [ doc = "Master Clock Configuration Register 1" ]
    pub struct Mccr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Clock Configuration Register 1" ]
    pub mod mccr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mccr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClkloR {
            bits: u8,
        }
        impl ClkloR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClkhiR {
            bits: u8,
        }
        impl ClkhiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SetholdR {
            bits: u8,
        }
        impl SetholdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatavdR {
            bits: u8,
        }
        impl DatavdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkloW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkloW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkhiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkhiW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SetholdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SetholdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatavdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatavdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:5 - Clock Low Period" ]
            # [ inline ( always ) ]
            pub fn clklo(&self) -> ClkloR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClkloR { bits }
            }
            # [ doc = "Bits 8:13 - Clock High Period" ]
            # [ inline ( always ) ]
            pub fn clkhi(&self) -> ClkhiR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClkhiR { bits }
            }
            # [ doc = "Bits 16:21 - Setup Hold Delay" ]
            # [ inline ( always ) ]
            pub fn sethold(&self) -> SetholdR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SetholdR { bits }
            }
            # [ doc = "Bits 24:29 - Data Valid Delay" ]
            # [ inline ( always ) ]
            pub fn datavd(&self) -> DatavdR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DatavdR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:5 - Clock Low Period" ]
            # [ inline ( always ) ]
            pub fn clklo(&mut self) -> _ClkloW {
                _ClkloW { w: self }
            }
            # [ doc = "Bits 8:13 - Clock High Period" ]
            # [ inline ( always ) ]
            pub fn clkhi(&mut self) -> _ClkhiW {
                _ClkhiW { w: self }
            }
            # [ doc = "Bits 16:21 - Setup Hold Delay" ]
            # [ inline ( always ) ]
            pub fn sethold(&mut self) -> _SetholdW {
                _SetholdW { w: self }
            }
            # [ doc = "Bits 24:29 - Data Valid Delay" ]
            # [ inline ( always ) ]
            pub fn datavd(&mut self) -> _DatavdW {
                _DatavdW { w: self }
            }
        }
    }
    # [ doc = "Master FIFO Control Register" ]
    pub struct Mfcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master FIFO Control Register" ]
    pub mod mfcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mfcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive FIFO Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
    # [ doc = "Master FIFO Status Register" ]
    pub struct Mfsr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master FIFO Status Register" ]
    pub mod mfsr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Mfsr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Transmit FIFO Count" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:18 - Receive FIFO Count" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
    }
    # [ doc = "Master Transmit Data Register" ]
    pub struct Mtdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Transmit Data Register" ]
    pub mod mtdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Mtdr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CMD`" ]
        pub enum CmdW {
            # [ doc = "Transmit DATA[7:0]." ]
            _000,
            # [ doc = "Receive (DATA[7:0] + 1) bytes." ]
            _001,
            # [ doc = "Generate STOP condition." ]
            _010,
            # [ doc = "Receive and discard (DATA[7:0] + 1) bytes." ]
            _011,
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0]." ]
            _100,
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0]. This transfer expects a NACK to be returned." ]
            _101,
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0] using high speed mode." ]
            _110,
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0] using high speed mode. This transfer expects a NACK to be returned." ]
            _111,
        }
        impl CmdW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CmdW::_000 => 0,
                    CmdW::_001 => 1,
                    CmdW::_010 => 2,
                    CmdW::_011 => 3,
                    CmdW::_100 => 4,
                    CmdW::_101 => 5,
                    CmdW::_110 => 6,
                    CmdW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CmdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CmdW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CmdW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit DATA[7:0]." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(CmdW::_000)
            }
            # [ doc = "Receive (DATA[7:0] + 1) bytes." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(CmdW::_001)
            }
            # [ doc = "Generate STOP condition." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(CmdW::_010)
            }
            # [ doc = "Receive and discard (DATA[7:0] + 1) bytes." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(CmdW::_011)
            }
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0]." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(CmdW::_100)
            }
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0]. This transfer expects a NACK to be returned." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(CmdW::_101)
            }
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0] using high speed mode." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(CmdW::_110)
            }
            # [ doc = "Generate (repeated) START and transmit address in DATA[7:0] using high speed mode. This transfer expects a NACK to be returned." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(CmdW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Transmit Data" ]
            # [ inline ( always ) ]
            pub fn data(&mut self) -> _DataW {
                _DataW { w: self }
            }
            # [ doc = "Bits 8:10 - Command Data" ]
            # [ inline ( always ) ]
            pub fn cmd(&mut self) -> _CmdW {
                _CmdW { w: self }
            }
        }
    }
    # [ doc = "Master Receive Data Register" ]
    pub struct Mrdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Master Receive Data Register" ]
    pub mod mrdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Mrdr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataR {
            bits: u8,
        }
        impl DataR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RXEMPTY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptyR {
            # [ doc = "Receive FIFO is not empty." ]
            _0,
            # [ doc = "Receive FIFO is empty." ]
            _1,
        }
        impl RxemptyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptyR::_0 => 0,
                    RxemptyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptyR {
                match bits {
                    0 => RxemptyR::_0,
                    1 => RxemptyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptyR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Receive Data" ]
            # [ inline ( always ) ]
            pub fn data(&self) -> DataR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataR { bits }
            }
            # [ doc = "Bit 14 - RX Empty" ]
            # [ inline ( always ) ]
            pub fn rxempty(&self) -> RxemptyR {
                RxemptyR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
    }
    # [ doc = "Slave Control Register" ]
    pub struct Scr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Control Register" ]
    pub mod scr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Scr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SenR {
            # [ doc = "Slave mode is disabled." ]
            _0,
            # [ doc = "Slave mode is enabled." ]
            _1,
        }
        impl SenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SenR::_0 => 0,
                    SenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SenR {
                match bits {
                    0 => SenR::_0,
                    1 => SenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SenR::_1
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Slave logic is not reset." ]
            _0,
            # [ doc = "Slave logic is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Possible values of the field `FILTEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FiltenR {
            # [ doc = "Disable digital filter and output delay counter for slave mode." ]
            _0,
            # [ doc = "Enable digital filter and output delay counter for slave mode." ]
            _1,
        }
        impl FiltenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FiltenR::_0 => 0,
                    FiltenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FiltenR {
                match bits {
                    0 => FiltenR::_0,
                    1 => FiltenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FiltenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FiltenR::_1
            }
        }
        # [ doc = "Possible values of the field `FILTDZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FiltdzR {
            # [ doc = "Filter remains enabled in Doze mode." ]
            _0,
            # [ doc = "Filter is disabled in Doze mode." ]
            _1,
        }
        impl FiltdzR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FiltdzR::_0 => 0,
                    FiltdzR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FiltdzR {
                match bits {
                    0 => FiltdzR::_0,
                    1 => FiltdzR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FiltdzR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FiltdzR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SEN`" ]
        pub enum SenW {
            # [ doc = "Slave mode is disabled." ]
            _0,
            # [ doc = "Slave mode is enabled." ]
            _1,
        }
        impl SenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SenW::_0 => 0,
                    SenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave mode is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SenW::_0)
            }
            # [ doc = "Slave mode is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Slave logic is not reset." ]
            _0,
            # [ doc = "Slave logic is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave logic is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Slave logic is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FILTEN`" ]
        pub enum FiltenW {
            # [ doc = "Disable digital filter and output delay counter for slave mode." ]
            _0,
            # [ doc = "Enable digital filter and output delay counter for slave mode." ]
            _1,
        }
        impl FiltenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FiltenW::_0 => 0,
                    FiltenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FiltenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable digital filter and output delay counter for slave mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FiltenW::_0)
            }
            # [ doc = "Enable digital filter and output delay counter for slave mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FiltenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FILTDZ`" ]
        pub enum FiltdzW {
            # [ doc = "Filter remains enabled in Doze mode." ]
            _0,
            # [ doc = "Filter is disabled in Doze mode." ]
            _1,
        }
        impl FiltdzW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FiltdzW::_0 => 0,
                    FiltdzW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltdzW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltdzW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FiltdzW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Filter remains enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FiltdzW::_0)
            }
            # [ doc = "Filter is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FiltdzW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Slave Enable" ]
            # [ inline ( always ) ]
            pub fn sen(&self) -> SenR {
                SenR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 4 - Filter Enable" ]
            # [ inline ( always ) ]
            pub fn filten(&self) -> FiltenR {
                FiltenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Filter Doze Enable" ]
            # [ inline ( always ) ]
            pub fn filtdz(&self) -> FiltdzR {
                FiltdzR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 5;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Slave Enable" ]
            # [ inline ( always ) ]
            pub fn sen(&mut self) -> _SenW {
                _SenW { w: self }
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
            # [ doc = "Bit 4 - Filter Enable" ]
            # [ inline ( always ) ]
            pub fn filten(&mut self) -> _FiltenW {
                _FiltenW { w: self }
            }
            # [ doc = "Bit 5 - Filter Doze Enable" ]
            # [ inline ( always ) ]
            pub fn filtdz(&mut self) -> _FiltdzW {
                _FiltdzW { w: self }
            }
        }
    }
    # [ doc = "Slave Status Register" ]
    pub struct Ssr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Status Register" ]
    pub mod ssr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ssr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdfR {
            # [ doc = "Transmit data not requested." ]
            _0,
            # [ doc = "Transmit data is requested." ]
            _1,
        }
        impl TdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdfR::_0 => 0,
                    TdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdfR {
                match bits {
                    0 => TdfR::_0,
                    1 => TdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdfR::_1
            }
        }
        # [ doc = "Possible values of the field `RDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdfR {
            # [ doc = "Receive Data is not ready." ]
            _0,
            # [ doc = "Receive data is ready." ]
            _1,
        }
        impl RdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdfR::_0 => 0,
                    RdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdfR {
                match bits {
                    0 => RdfR::_0,
                    1 => RdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdfR::_1
            }
        }
        # [ doc = "Possible values of the field `AVF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvfR {
            # [ doc = "Address Status Register is not valid." ]
            _0,
            # [ doc = "Address Status Register is valid." ]
            _1,
        }
        impl AvfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvfR::_0 => 0,
                    AvfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvfR {
                match bits {
                    0 => AvfR::_0,
                    1 => AvfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AvfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AvfR::_1
            }
        }
        # [ doc = "Possible values of the field `TAF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TafR {
            # [ doc = "Transmit ACK/NACK is not required." ]
            _0,
            # [ doc = "Transmit ACK/NACK is required." ]
            _1,
        }
        impl TafR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TafR::_0 => 0,
                    TafR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TafR {
                match bits {
                    0 => TafR::_0,
                    1 => TafR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TafR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TafR::_1
            }
        }
        # [ doc = "Possible values of the field `RSF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RsfR {
            # [ doc = "Slave has not detected a Repeated START condition." ]
            _0,
            # [ doc = "Slave has detected a Repeated START condition." ]
            _1,
        }
        impl RsfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RsfR::_0 => 0,
                    RsfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RsfR {
                match bits {
                    0 => RsfR::_0,
                    1 => RsfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RsfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RsfR::_1
            }
        }
        # [ doc = "Possible values of the field `SDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SdfR {
            # [ doc = "Slave has not detected a STOP condition." ]
            _0,
            # [ doc = "Slave has detected a STOP condition." ]
            _1,
        }
        impl SdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SdfR::_0 => 0,
                    SdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SdfR {
                match bits {
                    0 => SdfR::_0,
                    1 => SdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SdfR::_1
            }
        }
        # [ doc = "Possible values of the field `BEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BefR {
            # [ doc = "Slave has not detected a bit error." ]
            _0,
            # [ doc = "Slave has detected a bit error." ]
            _1,
        }
        impl BefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BefR::_0 => 0,
                    BefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BefR {
                match bits {
                    0 => BefR::_0,
                    1 => BefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BefR::_1
            }
        }
        # [ doc = "Possible values of the field `FEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FefR {
            # [ doc = "FIFO underflow or overflow not detected." ]
            _0,
            # [ doc = "FIFO underflow or overflow detected." ]
            _1,
        }
        impl FefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FefR::_0 => 0,
                    FefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FefR {
                match bits {
                    0 => FefR::_0,
                    1 => FefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FefR::_1
            }
        }
        # [ doc = "Possible values of the field `AM0F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Am0fR {
            # [ doc = "Have not received ADDR0 matching address." ]
            _0,
            # [ doc = "Have received ADDR0 matching address." ]
            _1,
        }
        impl Am0fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Am0fR::_0 => 0,
                    Am0fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Am0fR {
                match bits {
                    0 => Am0fR::_0,
                    1 => Am0fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Am0fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Am0fR::_1
            }
        }
        # [ doc = "Possible values of the field `AM1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Am1fR {
            # [ doc = "Have not received ADDR1 or ADDR0/ADDR1 range matching address." ]
            _0,
            # [ doc = "Have received ADDR1 or ADDR0/ADDR1 range matching address." ]
            _1,
        }
        impl Am1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Am1fR::_0 => 0,
                    Am1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Am1fR {
                match bits {
                    0 => Am1fR::_0,
                    1 => Am1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Am1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Am1fR::_1
            }
        }
        # [ doc = "Possible values of the field `GCF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GcfR {
            # [ doc = "Slave has not detected the General Call Address or General Call Address disabled." ]
            _0,
            # [ doc = "Slave has detected the General Call Address." ]
            _1,
        }
        impl GcfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GcfR::_0 => 0,
                    GcfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GcfR {
                match bits {
                    0 => GcfR::_0,
                    1 => GcfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GcfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GcfR::_1
            }
        }
        # [ doc = "Possible values of the field `SARF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SarfR {
            # [ doc = "SMBus Alert Response disabled or not detected." ]
            _0,
            # [ doc = "SMBus Alert Response enabled and detected." ]
            _1,
        }
        impl SarfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SarfR::_0 => 0,
                    SarfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SarfR {
                match bits {
                    0 => SarfR::_0,
                    1 => SarfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SarfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SarfR::_1
            }
        }
        # [ doc = "Possible values of the field `SBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbfR {
            # [ doc = "I2C Slave is idle." ]
            _0,
            # [ doc = "I2C Slave is busy." ]
            _1,
        }
        impl SbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbfR::_0 => 0,
                    SbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbfR {
                match bits {
                    0 => SbfR::_0,
                    1 => SbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbfR::_1
            }
        }
        # [ doc = "Possible values of the field `BBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BbfR {
            # [ doc = "I2C Bus is idle." ]
            _0,
            # [ doc = "I2C Bus is busy." ]
            _1,
        }
        impl BbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BbfR::_0 => 0,
                    BbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BbfR {
                match bits {
                    0 => BbfR::_0,
                    1 => BbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BbfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RSF`" ]
        pub enum RsfW {
            # [ doc = "Slave has not detected a Repeated START condition." ]
            _0,
            # [ doc = "Slave has detected a Repeated START condition." ]
            _1,
        }
        impl RsfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RsfW::_0 => 0,
                    RsfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RsfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RsfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RsfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave has not detected a Repeated START condition." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RsfW::_0)
            }
            # [ doc = "Slave has detected a Repeated START condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RsfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SDF`" ]
        pub enum SdfW {
            # [ doc = "Slave has not detected a STOP condition." ]
            _0,
            # [ doc = "Slave has detected a STOP condition." ]
            _1,
        }
        impl SdfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SdfW::_0 => 0,
                    SdfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SdfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SdfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SdfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave has not detected a STOP condition." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SdfW::_0)
            }
            # [ doc = "Slave has detected a STOP condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SdfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BEF`" ]
        pub enum BefW {
            # [ doc = "Slave has not detected a bit error." ]
            _0,
            # [ doc = "Slave has detected a bit error." ]
            _1,
        }
        impl BefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BefW::_0 => 0,
                    BefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave has not detected a bit error." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BefW::_0)
            }
            # [ doc = "Slave has detected a bit error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEF`" ]
        pub enum FefW {
            # [ doc = "FIFO underflow or overflow not detected." ]
            _0,
            # [ doc = "FIFO underflow or overflow detected." ]
            _1,
        }
        impl FefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FefW::_0 => 0,
                    FefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FIFO underflow or overflow not detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FefW::_0)
            }
            # [ doc = "FIFO underflow or overflow detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Flag" ]
            # [ inline ( always ) ]
            pub fn tdf(&self) -> TdfR {
                TdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 1 - Receive Data Flag" ]
            # [ inline ( always ) ]
            pub fn rdf(&self) -> RdfR {
                RdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Address Valid Flag" ]
            # [ inline ( always ) ]
            pub fn avf(&self) -> AvfR {
                AvfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Transmit ACK Flag" ]
            # [ inline ( always ) ]
            pub fn taf(&self) -> TafR {
                TafR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - Repeated Start Flag" ]
            # [ inline ( always ) ]
            pub fn rsf(&self) -> RsfR {
                RsfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 9 - STOP Detect Flag" ]
            # [ inline ( always ) ]
            pub fn sdf(&self) -> SdfR {
                SdfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Bit Error Flag" ]
            # [ inline ( always ) ]
            pub fn bef(&self) -> BefR {
                BefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - FIFO Error Flag" ]
            # [ inline ( always ) ]
            pub fn fef(&self) -> FefR {
                FefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 11;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 12 - Address Match 0 Flag" ]
            # [ inline ( always ) ]
            pub fn am0f(&self) -> Am0fR {
                Am0fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 13 - Address Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn am1f(&self) -> Am1fR {
                Am1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - General Call Flag" ]
            # [ inline ( always ) ]
            pub fn gcf(&self) -> GcfR {
                GcfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 15 - SMBus Alert Response Flag" ]
            # [ inline ( always ) ]
            pub fn sarf(&self) -> SarfR {
                SarfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 15;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Slave Busy Flag" ]
            # [ inline ( always ) ]
            pub fn sbf(&self) -> SbfR {
                SbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - Bus Busy Flag" ]
            # [ inline ( always ) ]
            pub fn bbf(&self) -> BbfR {
                BbfR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 8 - Repeated Start Flag" ]
            # [ inline ( always ) ]
            pub fn rsf(&mut self) -> _RsfW {
                _RsfW { w: self }
            }
            # [ doc = "Bit 9 - STOP Detect Flag" ]
            # [ inline ( always ) ]
            pub fn sdf(&mut self) -> _SdfW {
                _SdfW { w: self }
            }
            # [ doc = "Bit 10 - Bit Error Flag" ]
            # [ inline ( always ) ]
            pub fn bef(&mut self) -> _BefW {
                _BefW { w: self }
            }
            # [ doc = "Bit 11 - FIFO Error Flag" ]
            # [ inline ( always ) ]
            pub fn fef(&mut self) -> _FefW {
                _FefW { w: self }
            }
        }
    }
    # [ doc = "Slave Interrupt Enable Register" ]
    pub struct Sier {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Interrupt Enable Register" ]
    pub mod sier {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sier {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdieR::_0 => 0,
                    TdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdieR {
                match bits {
                    0 => TdieR::_0,
                    1 => TdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdieR::_0 => 0,
                    RdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdieR {
                match bits {
                    0 => RdieR::_0,
                    1 => RdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdieR::_1
            }
        }
        # [ doc = "Possible values of the field `AVIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl AvieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvieR::_0 => 0,
                    AvieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvieR {
                match bits {
                    0 => AvieR::_0,
                    1 => AvieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AvieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AvieR::_1
            }
        }
        # [ doc = "Possible values of the field `TAIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TaieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TaieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TaieR::_0 => 0,
                    TaieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TaieR {
                match bits {
                    0 => TaieR::_0,
                    1 => TaieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TaieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TaieR::_1
            }
        }
        # [ doc = "Possible values of the field `RSIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RsieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RsieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RsieR::_0 => 0,
                    RsieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RsieR {
                match bits {
                    0 => RsieR::_0,
                    1 => RsieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RsieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RsieR::_1
            }
        }
        # [ doc = "Possible values of the field `SDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SdieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SdieR::_0 => 0,
                    SdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SdieR {
                match bits {
                    0 => SdieR::_0,
                    1 => SdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SdieR::_1
            }
        }
        # [ doc = "Possible values of the field `BEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BeieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl BeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BeieR::_0 => 0,
                    BeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BeieR {
                match bits {
                    0 => BeieR::_0,
                    1 => BeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BeieR::_1
            }
        }
        # [ doc = "Possible values of the field `FEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeieR::_0 => 0,
                    FeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeieR {
                match bits {
                    0 => FeieR::_0,
                    1 => FeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeieR::_1
            }
        }
        # [ doc = "Possible values of the field `AM0IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Am0ieR {
            # [ doc = "Interrupt enabled." ]
            _0,
            # [ doc = "Interrupt disabled." ]
            _1,
        }
        impl Am0ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Am0ieR::_0 => 0,
                    Am0ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Am0ieR {
                match bits {
                    0 => Am0ieR::_0,
                    1 => Am0ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Am0ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Am0ieR::_1
            }
        }
        # [ doc = "Possible values of the field `AM1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Am1fR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl Am1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Am1fR::_0 => 0,
                    Am1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Am1fR {
                match bits {
                    0 => Am1fR::_0,
                    1 => Am1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Am1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Am1fR::_1
            }
        }
        # [ doc = "Possible values of the field `GCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GcieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl GcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GcieR::_0 => 0,
                    GcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GcieR {
                match bits {
                    0 => GcieR::_0,
                    1 => GcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GcieR::_1
            }
        }
        # [ doc = "Possible values of the field `SARIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SarieR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SarieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SarieR::_0 => 0,
                    SarieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SarieR {
                match bits {
                    0 => SarieR::_0,
                    1 => SarieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SarieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SarieR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDIE`" ]
        pub enum TdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled" ]
            _1,
        }
        impl TdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdieW::_0 => 0,
                    TdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdieW::_0)
            }
            # [ doc = "Interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDIE`" ]
        pub enum RdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdieW::_0 => 0,
                    RdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AVIE`" ]
        pub enum AvieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl AvieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvieW::_0 => 0,
                    AvieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AvieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AvieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TAIE`" ]
        pub enum TaieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl TaieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TaieW::_0 => 0,
                    TaieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TaieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TaieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TaieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TaieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TaieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RSIE`" ]
        pub enum RsieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl RsieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RsieW::_0 => 0,
                    RsieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RsieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RsieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RsieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RsieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RsieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SDIE`" ]
        pub enum SdieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SdieW::_0 => 0,
                    SdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SdieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BEIE`" ]
        pub enum BeieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl BeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BeieW::_0 => 0,
                    BeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BeieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEIE`" ]
        pub enum FeieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl FeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeieW::_0 => 0,
                    FeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AM0IE`" ]
        pub enum Am0ieW {
            # [ doc = "Interrupt enabled." ]
            _0,
            # [ doc = "Interrupt disabled." ]
            _1,
        }
        impl Am0ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Am0ieW::_0 => 0,
                    Am0ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Am0ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Am0ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Am0ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Am0ieW::_0)
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Am0ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AM1F`" ]
        pub enum Am1fW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl Am1fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Am1fW::_0 => 0,
                    Am1fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Am1fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Am1fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Am1fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Am1fW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Am1fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GCIE`" ]
        pub enum GcieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl GcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GcieW::_0 => 0,
                    GcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GcieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SARIE`" ]
        pub enum SarieW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SarieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SarieW::_0 => 0,
                    SarieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SarieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SarieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SarieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SarieW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SarieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&self) -> TdieR {
                TdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&self) -> RdieR {
                RdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Address Valid Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn avie(&self) -> AvieR {
                AvieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Transmit ACK Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn taie(&self) -> TaieR {
                TaieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Repeated Start Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rsie(&self) -> RsieR {
                RsieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - STOP Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn sdie(&self) -> SdieR {
                SdieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Bit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn beie(&self) -> BeieR {
                BeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - FIFO Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&self) -> FeieR {
                FeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Address Match 0 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn am0ie(&self) -> Am0ieR {
                Am0ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Address Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn am1f(&self) -> Am1fR {
                Am1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - General Call Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn gcie(&self) -> GcieR {
                GcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 15 - SMBus Alert Response Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn sarie(&self) -> SarieR {
                SarieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tdie(&mut self) -> _TdieW {
                _TdieW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rdie(&mut self) -> _RdieW {
                _RdieW { w: self }
            }
            # [ doc = "Bit 2 - Address Valid Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn avie(&mut self) -> _AvieW {
                _AvieW { w: self }
            }
            # [ doc = "Bit 3 - Transmit ACK Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn taie(&mut self) -> _TaieW {
                _TaieW { w: self }
            }
            # [ doc = "Bit 8 - Repeated Start Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rsie(&mut self) -> _RsieW {
                _RsieW { w: self }
            }
            # [ doc = "Bit 9 - STOP Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn sdie(&mut self) -> _SdieW {
                _SdieW { w: self }
            }
            # [ doc = "Bit 10 - Bit Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn beie(&mut self) -> _BeieW {
                _BeieW { w: self }
            }
            # [ doc = "Bit 11 - FIFO Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&mut self) -> _FeieW {
                _FeieW { w: self }
            }
            # [ doc = "Bit 12 - Address Match 0 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn am0ie(&mut self) -> _Am0ieW {
                _Am0ieW { w: self }
            }
            # [ doc = "Bit 13 - Address Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn am1f(&mut self) -> _Am1fW {
                _Am1fW { w: self }
            }
            # [ doc = "Bit 14 - General Call Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn gcie(&mut self) -> _GcieW {
                _GcieW { w: self }
            }
            # [ doc = "Bit 15 - SMBus Alert Response Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn sarie(&mut self) -> _SarieW {
                _SarieW { w: self }
            }
        }
    }
    # [ doc = "Slave DMA Enable Register" ]
    pub struct Sder {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave DMA Enable Register" ]
    pub mod sder {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Sder {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TddeR::_0 => 0,
                    TddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TddeR {
                match bits {
                    0 => TddeR::_0,
                    1 => TddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TddeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RddeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RddeR::_0 => 0,
                    RddeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RddeR {
                match bits {
                    0 => RddeR::_0,
                    1 => RddeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RddeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RddeR::_1
            }
        }
        # [ doc = "Possible values of the field `AVDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvdeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl AvdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvdeR::_0 => 0,
                    AvdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvdeR {
                match bits {
                    0 => AvdeR::_0,
                    1 => AvdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AvdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AvdeR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TDDE`" ]
        pub enum TddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled" ]
            _1,
        }
        impl TddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TddeW::_0 => 0,
                    TddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TddeW::_0)
            }
            # [ doc = "DMA request enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDDE`" ]
        pub enum RddeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RddeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RddeW::_0 => 0,
                    RddeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RddeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RddeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RddeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RddeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RddeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AVDE`" ]
        pub enum AvdeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl AvdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvdeW::_0 => 0,
                    AvdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AvdeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AvdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&self) -> TddeR {
                TddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 0;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&self) -> RddeR {
                RddeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Address Valid DMA Enable" ]
            # [ inline ( always ) ]
            pub fn avde(&self) -> AvdeR {
                AvdeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdde(&mut self) -> _TddeW {
                _TddeW { w: self }
            }
            # [ doc = "Bit 1 - Receive Data DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdde(&mut self) -> _RddeW {
                _RddeW { w: self }
            }
            # [ doc = "Bit 2 - Address Valid DMA Enable" ]
            # [ inline ( always ) ]
            pub fn avde(&mut self) -> _AvdeW {
                _AvdeW { w: self }
            }
        }
    }
    # [ doc = "Slave Configuration Register 1" ]
    pub struct Scfgr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Configuration Register 1" ]
    pub mod scfgr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Scfgr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ADRSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AdrstallR {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl AdrstallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AdrstallR::_0 => 0,
                    AdrstallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AdrstallR {
                match bits {
                    0 => AdrstallR::_0,
                    1 => AdrstallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AdrstallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AdrstallR::_1
            }
        }
        # [ doc = "Possible values of the field `RXSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxstallR {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl RxstallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxstallR::_0 => 0,
                    RxstallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxstallR {
                match bits {
                    0 => RxstallR::_0,
                    1 => RxstallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxstallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxstallR::_1
            }
        }
        # [ doc = "Possible values of the field `TXDSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxdstallR {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl TxdstallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxdstallR::_0 => 0,
                    TxdstallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxdstallR {
                match bits {
                    0 => TxdstallR::_0,
                    1 => TxdstallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxdstallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxdstallR::_1
            }
        }
        # [ doc = "Possible values of the field `ACKSTALL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AckstallR {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl AckstallR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AckstallR::_0 => 0,
                    AckstallR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AckstallR {
                match bits {
                    0 => AckstallR::_0,
                    1 => AckstallR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AckstallR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AckstallR::_1
            }
        }
        # [ doc = "Possible values of the field `GCEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GcenR {
            # [ doc = "General Call address is disabled." ]
            _0,
            # [ doc = "General call address is enabled." ]
            _1,
        }
        impl GcenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GcenR::_0 => 0,
                    GcenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GcenR {
                match bits {
                    0 => GcenR::_0,
                    1 => GcenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GcenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GcenR::_1
            }
        }
        # [ doc = "Possible values of the field `SAEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SaenR {
            # [ doc = "Disables match on SMBus Alert." ]
            _0,
            # [ doc = "Enables match on SMBus Alert." ]
            _1,
        }
        impl SaenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SaenR::_0 => 0,
                    SaenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SaenR {
                match bits {
                    0 => SaenR::_0,
                    1 => SaenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SaenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SaenR::_1
            }
        }
        # [ doc = "Possible values of the field `TXCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxcfgR {
            # [ doc = "Transmit Data Flag will only assert during a slave-transmit transfer when the transmit data register is empty." ]
            _0,
            # [ doc = "Transmit Data Flag will assert whenever the transmit data register is empty." ]
            _1,
        }
        impl TxcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxcfgR::_0 => 0,
                    TxcfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxcfgR {
                match bits {
                    0 => TxcfgR::_0,
                    1 => TxcfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxcfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxcfgR::_1
            }
        }
        # [ doc = "Possible values of the field `RXCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxcfgR {
            # [ doc = "Reading the receive data register will return receive data and clear the receive data flag." ]
            _0,
            # [ doc = "Reading the receive data register when the address valid flag is set will return the address status register and clear the address valid flag. Reading the receive data register when the address valid flag is clear will return receive data and clear the receive data flag." ]
            _1,
        }
        impl RxcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxcfgR::_0 => 0,
                    RxcfgR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxcfgR {
                match bits {
                    0 => RxcfgR::_0,
                    1 => RxcfgR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxcfgR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxcfgR::_1
            }
        }
        # [ doc = "Possible values of the field `IGNACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IgnackR {
            # [ doc = "Slave will end transfer when NACK detected." ]
            _0,
            # [ doc = "Slave will not end transfer when NACK detected." ]
            _1,
        }
        impl IgnackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IgnackR::_0 => 0,
                    IgnackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IgnackR {
                match bits {
                    0 => IgnackR::_0,
                    1 => IgnackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IgnackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IgnackR::_1
            }
        }
        # [ doc = "Possible values of the field `HSMEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HsmenR {
            # [ doc = "Disables detection of Hs-mode master code." ]
            _0,
            # [ doc = "Enables detection of Hs-mode master code." ]
            _1,
        }
        impl HsmenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HsmenR::_0 => 0,
                    HsmenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HsmenR {
                match bits {
                    0 => HsmenR::_0,
                    1 => HsmenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == HsmenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == HsmenR::_1
            }
        }
        # [ doc = "Possible values of the field `ADDRCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AddrcfgR {
            # [ doc = "Address match 0 (7-bit)." ]
            _000,
            # [ doc = "Address match 0 (10-bit)." ]
            _001,
            # [ doc = "Address match 0 (7-bit) or Address match 1 (7-bit)." ]
            _010,
            # [ doc = "Address match 0 (10-bit) or Address match 1 (10-bit)." ]
            _011,
            # [ doc = "Address match 0 (7-bit) or Address match 1 (10-bit)." ]
            _100,
            # [ doc = "Address match 0 (10-bit) or Address match 1 (7-bit)." ]
            _101,
            # [ doc = "From Address match 0 (7-bit) to Address match 1 (7-bit)." ]
            _110,
            # [ doc = "From Address match 0 (10-bit) to Address match 1 (10-bit)." ]
            _111,
        }
        impl AddrcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AddrcfgR::_000 => 0,
                    AddrcfgR::_001 => 1,
                    AddrcfgR::_010 => 2,
                    AddrcfgR::_011 => 3,
                    AddrcfgR::_100 => 4,
                    AddrcfgR::_101 => 5,
                    AddrcfgR::_110 => 6,
                    AddrcfgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AddrcfgR {
                match bits {
                    0 => AddrcfgR::_000,
                    1 => AddrcfgR::_001,
                    2 => AddrcfgR::_010,
                    3 => AddrcfgR::_011,
                    4 => AddrcfgR::_100,
                    5 => AddrcfgR::_101,
                    6 => AddrcfgR::_110,
                    7 => AddrcfgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == AddrcfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == AddrcfgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == AddrcfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == AddrcfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == AddrcfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == AddrcfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == AddrcfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == AddrcfgR::_111
            }
        }
        # [ doc = "Values that can be written to the field `ADRSTALL`" ]
        pub enum AdrstallW {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl AdrstallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AdrstallW::_0 => 0,
                    AdrstallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AdrstallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AdrstallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AdrstallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock stretching disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AdrstallW::_0)
            }
            # [ doc = "Clock stretching enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AdrstallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXSTALL`" ]
        pub enum RxstallW {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl RxstallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxstallW::_0 => 0,
                    RxstallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxstallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxstallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxstallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock stretching disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxstallW::_0)
            }
            # [ doc = "Clock stretching enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxstallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXDSTALL`" ]
        pub enum TxdstallW {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl TxdstallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxdstallW::_0 => 0,
                    TxdstallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxdstallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxdstallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxdstallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock stretching disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxdstallW::_0)
            }
            # [ doc = "Clock stretching enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxdstallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ACKSTALL`" ]
        pub enum AckstallW {
            # [ doc = "Clock stretching disabled." ]
            _0,
            # [ doc = "Clock stretching enabled." ]
            _1,
        }
        impl AckstallW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AckstallW::_0 => 0,
                    AckstallW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AckstallW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AckstallW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AckstallW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Clock stretching disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AckstallW::_0)
            }
            # [ doc = "Clock stretching enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AckstallW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GCEN`" ]
        pub enum GcenW {
            # [ doc = "General Call address is disabled." ]
            _0,
            # [ doc = "General call address is enabled." ]
            _1,
        }
        impl GcenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GcenW::_0 => 0,
                    GcenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GcenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GcenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GcenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "General Call address is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GcenW::_0)
            }
            # [ doc = "General call address is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GcenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SAEN`" ]
        pub enum SaenW {
            # [ doc = "Disables match on SMBus Alert." ]
            _0,
            # [ doc = "Enables match on SMBus Alert." ]
            _1,
        }
        impl SaenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SaenW::_0 => 0,
                    SaenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SaenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SaenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SaenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disables match on SMBus Alert." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SaenW::_0)
            }
            # [ doc = "Enables match on SMBus Alert." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SaenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCFG`" ]
        pub enum TxcfgW {
            # [ doc = "Transmit Data Flag will only assert during a slave-transmit transfer when the transmit data register is empty." ]
            _0,
            # [ doc = "Transmit Data Flag will assert whenever the transmit data register is empty." ]
            _1,
        }
        impl TxcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxcfgW::_0 => 0,
                    TxcfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxcfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit Data Flag will only assert during a slave-transmit transfer when the transmit data register is empty." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxcfgW::_0)
            }
            # [ doc = "Transmit Data Flag will assert whenever the transmit data register is empty." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxcfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXCFG`" ]
        pub enum RxcfgW {
            # [ doc = "Reading the receive data register will return receive data and clear the receive data flag." ]
            _0,
            # [ doc = "Reading the receive data register when the address valid flag is set will return the address status register and clear the address valid flag. Reading the receive data register when the address valid flag is clear will return receive data and clear the receive data flag." ]
            _1,
        }
        impl RxcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxcfgW::_0 => 0,
                    RxcfgW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxcfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reading the receive data register will return receive data and clear the receive data flag." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxcfgW::_0)
            }
            # [ doc = "Reading the receive data register when the address valid flag is set will return the address status register and clear the address valid flag. Reading the receive data register when the address valid flag is clear will return receive data and clear the receive data flag." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxcfgW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IGNACK`" ]
        pub enum IgnackW {
            # [ doc = "Slave will end transfer when NACK detected." ]
            _0,
            # [ doc = "Slave will not end transfer when NACK detected." ]
            _1,
        }
        impl IgnackW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IgnackW::_0 => 0,
                    IgnackW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IgnackW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IgnackW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IgnackW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Slave will end transfer when NACK detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IgnackW::_0)
            }
            # [ doc = "Slave will not end transfer when NACK detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IgnackW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `HSMEN`" ]
        pub enum HsmenW {
            # [ doc = "Disables detection of Hs-mode master code." ]
            _0,
            # [ doc = "Enables detection of Hs-mode master code." ]
            _1,
        }
        impl HsmenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HsmenW::_0 => 0,
                    HsmenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HsmenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HsmenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HsmenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disables detection of Hs-mode master code." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(HsmenW::_0)
            }
            # [ doc = "Enables detection of Hs-mode master code." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(HsmenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ADDRCFG`" ]
        pub enum AddrcfgW {
            # [ doc = "Address match 0 (7-bit)." ]
            _000,
            # [ doc = "Address match 0 (10-bit)." ]
            _001,
            # [ doc = "Address match 0 (7-bit) or Address match 1 (7-bit)." ]
            _010,
            # [ doc = "Address match 0 (10-bit) or Address match 1 (10-bit)." ]
            _011,
            # [ doc = "Address match 0 (7-bit) or Address match 1 (10-bit)." ]
            _100,
            # [ doc = "Address match 0 (10-bit) or Address match 1 (7-bit)." ]
            _101,
            # [ doc = "From Address match 0 (7-bit) to Address match 1 (7-bit)." ]
            _110,
            # [ doc = "From Address match 0 (10-bit) to Address match 1 (10-bit)." ]
            _111,
        }
        impl AddrcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AddrcfgW::_000 => 0,
                    AddrcfgW::_001 => 1,
                    AddrcfgW::_010 => 2,
                    AddrcfgW::_011 => 3,
                    AddrcfgW::_100 => 4,
                    AddrcfgW::_101 => 5,
                    AddrcfgW::_110 => 6,
                    AddrcfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AddrcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AddrcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AddrcfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Address match 0 (7-bit)." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(AddrcfgW::_000)
            }
            # [ doc = "Address match 0 (10-bit)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(AddrcfgW::_001)
            }
            # [ doc = "Address match 0 (7-bit) or Address match 1 (7-bit)." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(AddrcfgW::_010)
            }
            # [ doc = "Address match 0 (10-bit) or Address match 1 (10-bit)." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(AddrcfgW::_011)
            }
            # [ doc = "Address match 0 (7-bit) or Address match 1 (10-bit)." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(AddrcfgW::_100)
            }
            # [ doc = "Address match 0 (10-bit) or Address match 1 (7-bit)." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(AddrcfgW::_101)
            }
            # [ doc = "From Address match 0 (7-bit) to Address match 1 (7-bit)." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(AddrcfgW::_110)
            }
            # [ doc = "From Address match 0 (10-bit) to Address match 1 (10-bit)." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(AddrcfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Address SCL Stall" ]
            # [ inline ( always ) ]
            pub fn adrstall(&self) -> AdrstallR {
                AdrstallR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 1 - RX SCL Stall" ]
            # [ inline ( always ) ]
            pub fn rxstall(&self) -> RxstallR {
                RxstallR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 1;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - TX Data SCL Stall" ]
            # [ inline ( always ) ]
            pub fn txdstall(&self) -> TxdstallR {
                TxdstallR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - ACK SCL Stall" ]
            # [ inline ( always ) ]
            pub fn ackstall(&self) -> AckstallR {
                AckstallR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 8 - General Call Enable" ]
            # [ inline ( always ) ]
            pub fn gcen(&self) -> GcenR {
                GcenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - SMBus Alert Enable" ]
            # [ inline ( always ) ]
            pub fn saen(&self) -> SaenR {
                SaenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - Transmit Flag Configuration" ]
            # [ inline ( always ) ]
            pub fn txcfg(&self) -> TxcfgR {
                TxcfgR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 10;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 11 - Receive Data Configuration" ]
            # [ inline ( always ) ]
            pub fn rxcfg(&self) -> RxcfgR {
                RxcfgR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 12 - Ignore NACK" ]
            # [ inline ( always ) ]
            pub fn ignack(&self) -> IgnackR {
                IgnackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - High Speed Mode Enable" ]
            # [ inline ( always ) ]
            pub fn hsmen(&self) -> HsmenR {
                HsmenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 13;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 16:18 - Address Configuration" ]
            # [ inline ( always ) ]
            pub fn addrcfg(&self) -> AddrcfgR {
                AddrcfgR::_from({
                                    const MASK: u8 = 7;
                                    const OFFSET: u8 = 16;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Address SCL Stall" ]
            # [ inline ( always ) ]
            pub fn adrstall(&mut self) -> _AdrstallW {
                _AdrstallW { w: self }
            }
            # [ doc = "Bit 1 - RX SCL Stall" ]
            # [ inline ( always ) ]
            pub fn rxstall(&mut self) -> _RxstallW {
                _RxstallW { w: self }
            }
            # [ doc = "Bit 2 - TX Data SCL Stall" ]
            # [ inline ( always ) ]
            pub fn txdstall(&mut self) -> _TxdstallW {
                _TxdstallW { w: self }
            }
            # [ doc = "Bit 3 - ACK SCL Stall" ]
            # [ inline ( always ) ]
            pub fn ackstall(&mut self) -> _AckstallW {
                _AckstallW { w: self }
            }
            # [ doc = "Bit 8 - General Call Enable" ]
            # [ inline ( always ) ]
            pub fn gcen(&mut self) -> _GcenW {
                _GcenW { w: self }
            }
            # [ doc = "Bit 9 - SMBus Alert Enable" ]
            # [ inline ( always ) ]
            pub fn saen(&mut self) -> _SaenW {
                _SaenW { w: self }
            }
            # [ doc = "Bit 10 - Transmit Flag Configuration" ]
            # [ inline ( always ) ]
            pub fn txcfg(&mut self) -> _TxcfgW {
                _TxcfgW { w: self }
            }
            # [ doc = "Bit 11 - Receive Data Configuration" ]
            # [ inline ( always ) ]
            pub fn rxcfg(&mut self) -> _RxcfgW {
                _RxcfgW { w: self }
            }
            # [ doc = "Bit 12 - Ignore NACK" ]
            # [ inline ( always ) ]
            pub fn ignack(&mut self) -> _IgnackW {
                _IgnackW { w: self }
            }
            # [ doc = "Bit 13 - High Speed Mode Enable" ]
            # [ inline ( always ) ]
            pub fn hsmen(&mut self) -> _HsmenW {
                _HsmenW { w: self }
            }
            # [ doc = "Bits 16:18 - Address Configuration" ]
            # [ inline ( always ) ]
            pub fn addrcfg(&mut self) -> _AddrcfgW {
                _AddrcfgW { w: self }
            }
        }
    }
    # [ doc = "Slave Configuration Register 2" ]
    pub struct Scfgr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Configuration Register 2" ]
    pub mod scfgr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Scfgr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct ClkholdR {
            bits: u8,
        }
        impl ClkholdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DatavdR {
            bits: u8,
        }
        impl DatavdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltsclR {
            bits: u8,
        }
        impl FiltsclR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FiltsdaR {
            bits: u8,
        }
        impl FiltsdaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkholdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkholdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DatavdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DatavdW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltsclW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltsclW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FiltsdaW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FiltsdaW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Clock Hold Time" ]
            # [ inline ( always ) ]
            pub fn clkhold(&self) -> ClkholdR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                ClkholdR { bits }
            }
            # [ doc = "Bits 8:13 - Data Valid Delay" ]
            # [ inline ( always ) ]
            pub fn datavd(&self) -> DatavdR {
                let bits = {
                    const MASK: u8 = 63;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DatavdR { bits }
            }
            # [ doc = "Bits 16:19 - Glitch Filter SCL" ]
            # [ inline ( always ) ]
            pub fn filtscl(&self) -> FiltsclR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltsclR { bits }
            }
            # [ doc = "Bits 24:27 - Glitch Filter SDA" ]
            # [ inline ( always ) ]
            pub fn filtsda(&self) -> FiltsdaR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FiltsdaR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Clock Hold Time" ]
            # [ inline ( always ) ]
            pub fn clkhold(&mut self) -> _ClkholdW {
                _ClkholdW { w: self }
            }
            # [ doc = "Bits 8:13 - Data Valid Delay" ]
            # [ inline ( always ) ]
            pub fn datavd(&mut self) -> _DatavdW {
                _DatavdW { w: self }
            }
            # [ doc = "Bits 16:19 - Glitch Filter SCL" ]
            # [ inline ( always ) ]
            pub fn filtscl(&mut self) -> _FiltsclW {
                _FiltsclW { w: self }
            }
            # [ doc = "Bits 24:27 - Glitch Filter SDA" ]
            # [ inline ( always ) ]
            pub fn filtsda(&mut self) -> _FiltsdaW {
                _FiltsdaW { w: self }
            }
        }
    }
    # [ doc = "Slave Address Match Register" ]
    pub struct Samr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Address Match Register" ]
    pub mod samr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Samr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Addr0R {
            bits: u16,
        }
        impl Addr0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Addr1R {
            bits: u16,
        }
        impl Addr1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Addr0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Addr0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Addr1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Addr1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 1:10 - Address 0 Value" ]
            # [ inline ( always ) ]
            pub fn addr0(&self) -> Addr0R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Addr0R { bits }
            }
            # [ doc = "Bits 17:26 - Address 1 Value" ]
            # [ inline ( always ) ]
            pub fn addr1(&self) -> Addr1R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Addr1R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 1:10 - Address 0 Value" ]
            # [ inline ( always ) ]
            pub fn addr0(&mut self) -> _Addr0W {
                _Addr0W { w: self }
            }
            # [ doc = "Bits 17:26 - Address 1 Value" ]
            # [ inline ( always ) ]
            pub fn addr1(&mut self) -> _Addr1W {
                _Addr1W { w: self }
            }
        }
    }
    # [ doc = "Slave Address Status Register" ]
    pub struct Sasr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Address Status Register" ]
    pub mod sasr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Sasr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RaddrR {
            bits: u16,
        }
        impl RaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `ANV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AnvR {
            # [ doc = "RADDR is valid." ]
            _0,
            # [ doc = "RADDR is not valid." ]
            _1,
        }
        impl AnvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AnvR::_0 => 0,
                    AnvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AnvR {
                match bits {
                    0 => AnvR::_0,
                    1 => AnvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AnvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AnvR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:10 - Received Address" ]
            # [ inline ( always ) ]
            pub fn raddr(&self) -> RaddrR {
                let bits = {
                    const MASK: u16 = 2047;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                RaddrR { bits }
            }
            # [ doc = "Bit 14 - Address Not Valid" ]
            # [ inline ( always ) ]
            pub fn anv(&self) -> AnvR {
                AnvR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 14;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
    }
    # [ doc = "Slave Transmit ACK Register" ]
    pub struct Star {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Transmit ACK Register" ]
    pub mod star {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Star {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TXNACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxnackR {
            # [ doc = "Transmit ACK for received word." ]
            _0,
            # [ doc = "Transmit NACK for received word." ]
            _1,
        }
        impl TxnackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxnackR::_0 => 0,
                    TxnackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxnackR {
                match bits {
                    0 => TxnackR::_0,
                    1 => TxnackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxnackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxnackR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TXNACK`" ]
        pub enum TxnackW {
            # [ doc = "Transmit ACK for received word." ]
            _0,
            # [ doc = "Transmit NACK for received word." ]
            _1,
        }
        impl TxnackW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxnackW::_0 => 0,
                    TxnackW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxnackW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxnackW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxnackW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit ACK for received word." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxnackW::_0)
            }
            # [ doc = "Transmit NACK for received word." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxnackW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmit NACK" ]
            # [ inline ( always ) ]
            pub fn txnack(&self) -> TxnackR {
                TxnackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmit NACK" ]
            # [ inline ( always ) ]
            pub fn txnack(&mut self) -> _TxnackW {
                _TxnackW { w: self }
            }
        }
    }
    # [ doc = "Slave Transmit Data Register" ]
    pub struct Stdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Transmit Data Register" ]
    pub mod stdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Stdr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - Transmit Data" ]
            # [ inline ( always ) ]
            pub fn data(&mut self) -> _DataW {
                _DataW { w: self }
            }
        }
    }
    # [ doc = "Slave Receive Data Register" ]
    pub struct Srdr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Slave Receive Data Register" ]
    pub mod srdr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Srdr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataR {
            bits: u8,
        }
        impl DataR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `RXEMPTY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptyR {
            # [ doc = "The Receive Data Register is not empty." ]
            _0,
            # [ doc = "The Receive Data Register is empty." ]
            _1,
        }
        impl RxemptyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptyR::_0 => 0,
                    RxemptyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptyR {
                match bits {
                    0 => RxemptyR::_0,
                    1 => RxemptyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptyR::_1
            }
        }
        # [ doc = "Possible values of the field `SOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SofR {
            # [ doc = "Indicates this is not the first data word since a (repeated) START or STOP condition." ]
            _0,
            # [ doc = "Indicates this is the first data word since a (repeated) START or STOP condition." ]
            _1,
        }
        impl SofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SofR::_0 => 0,
                    SofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SofR {
                match bits {
                    0 => SofR::_0,
                    1 => SofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SofR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Receive Data" ]
            # [ inline ( always ) ]
            pub fn data(&self) -> DataR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                DataR { bits }
            }
            # [ doc = "Bit 14 - RX Empty" ]
            # [ inline ( always ) ]
            pub fn rxempty(&self) -> RxemptyR {
                RxemptyR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - Start Of Frame" ]
            # [ inline ( always ) ]
            pub fn sof(&self) -> SofR {
                SofR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 15;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
    }
}
# [ doc = "The LPI2C Memory Map/Register Definition can be found here." ]
pub struct Lpi2c0 {
    register_block: lpi2c0::RegisterBlock,
}
impl Deref for Lpi2c0 {
    type Target = lpi2c0::RegisterBlock;
    fn deref(&self) -> &lpi2c0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub const LPUART0: Peripheral<Lpuart0> = unsafe { Peripheral::new(1074176000) };
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub mod lpuart0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - LPUART Global Register" ]
        pub global: Global,
        # [ doc = "0x0c - LPUART Pin Configuration Register" ]
        pub pincfg: Pincfg,
        # [ doc = "0x10 - LPUART Baud Rate Register" ]
        pub baud: Baud,
        # [ doc = "0x14 - LPUART Status Register" ]
        pub stat: Stat,
        # [ doc = "0x18 - LPUART Control Register" ]
        pub ctrl: Ctrl,
        # [ doc = "0x1c - LPUART Data Register" ]
        pub data: Data,
        # [ doc = "0x20 - LPUART Match Address Register" ]
        pub match_: Match,
        # [ doc = "0x24 - LPUART Modem IrDA Register" ]
        pub modir: Modir,
        # [ doc = "0x28 - LPUART FIFO Register" ]
        pub fifo: Fifo,
        # [ doc = "0x2c - LPUART Watermark Register" ]
        pub water: Water,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set." ]
            _0000000000000001,
            # [ doc = "Standard feature set with MODEM/IrDA support." ]
            _0000000000000011,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000001 => 1,
                    FeatureR::_0000000000000011 => 3,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    1 => FeatureR::_0000000000000001,
                    3 => FeatureR::_0000000000000011,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000001`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000001(&self) -> bool {
                *self == FeatureR::_0000000000000001
            }
            # [ doc = "Checks if the value of the field is `_0000000000000011`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000011(&self) -> bool {
                *self == FeatureR::_0000000000000011
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Identification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxfifoR {
            bits: u8,
        }
        impl TxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxfifoR {
            bits: u8,
        }
        impl RxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn txfifo(&self) -> TxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxfifoR { bits }
            }
            # [ doc = "Bits 8:15 - Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn rxfifo(&self) -> RxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxfifoR { bits }
            }
        }
    }
    # [ doc = "LPUART Global Register" ]
    pub struct Global {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Global Register" ]
    pub mod global {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Global {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Module is not reset." ]
            _0,
            # [ doc = "Module is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Module is not reset." ]
            _0,
            # [ doc = "Module is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Module is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
        }
    }
    # [ doc = "LPUART Pin Configuration Register" ]
    pub struct Pincfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Pin Configuration Register" ]
    pub mod pincfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pincfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgselR {
            # [ doc = "Input trigger is disabled." ]
            _00,
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            _01,
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            _10,
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            _11,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgselR::_00 => 0,
                    TrgselR::_01 => 1,
                    TrgselR::_10 => 2,
                    TrgselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgselR {
                match bits {
                    0 => TrgselR::_00,
                    1 => TrgselR::_01,
                    2 => TrgselR::_10,
                    3 => TrgselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TrgselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TrgselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TrgselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TrgselR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TRGSEL`" ]
        pub enum TrgselW {
            # [ doc = "Input trigger is disabled." ]
            _00,
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            _01,
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            _10,
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            _11,
        }
        impl TrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgselW::_00 => 0,
                    TrgselW::_01 => 1,
                    TrgselW::_10 => 2,
                    TrgselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Input trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TrgselW::_00)
            }
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TrgselW::_01)
            }
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TrgselW::_10)
            }
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TrgselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                TrgselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "LPUART Baud Rate Register" ]
    pub struct Baud {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Baud Rate Register" ]
    pub mod baud {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Baud {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SbrR {
            bits: u16,
        }
        impl SbrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SBNS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbnsR {
            # [ doc = "One stop bit." ]
            _0,
            # [ doc = "Two stop bits." ]
            _1,
        }
        impl SbnsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbnsR::_0 => 0,
                    SbnsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbnsR {
                match bits {
                    0 => SbnsR::_0,
                    1 => SbnsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbnsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbnsR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEDGIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxedgieR {
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            _1,
        }
        impl RxedgieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxedgieR::_0 => 0,
                    RxedgieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxedgieR {
                match bits {
                    0 => RxedgieR::_0,
                    1 => RxedgieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxedgieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxedgieR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdieR {
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            _1,
        }
        impl LbkdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdieR::_0 => 0,
                    LbkdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdieR {
                match bits {
                    0 => LbkdieR::_0,
                    1 => LbkdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RESYNCDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ResyncdisR {
            # [ doc = "Resynchronization during received data word is supported" ]
            _0,
            # [ doc = "Resynchronization during received data word is disabled" ]
            _1,
        }
        impl ResyncdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ResyncdisR::_0 => 0,
                    ResyncdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ResyncdisR {
                match bits {
                    0 => ResyncdisR::_0,
                    1 => ResyncdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ResyncdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ResyncdisR::_1
            }
        }
        # [ doc = "Possible values of the field `BOTHEDGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BothedgeR {
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            _0,
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            _1,
        }
        impl BothedgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BothedgeR::_0 => 0,
                    BothedgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BothedgeR {
                match bits {
                    0 => BothedgeR::_0,
                    1 => BothedgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BothedgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BothedgeR::_1
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Address Match Wakeup" ]
            _00,
            # [ doc = "Idle Match Wakeup" ]
            _01,
            # [ doc = "Match On and Match Off" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_00 => 0,
                    MatcfgR::_01 => 1,
                    MatcfgR::_10 => 2,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_00,
                    1 => MatcfgR::_01,
                    2 => MatcfgR::_10,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == MatcfgR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == MatcfgR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == MatcfgR::_10
            }
        }
        # [ doc = "Possible values of the field `RIDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RidmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RidmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RidmaeR::_0 => 0,
                    RidmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RidmaeR {
                match bits {
                    0 => RidmaeR::_0,
                    1 => RidmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RidmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RidmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RdmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmaeR::_0 => 0,
                    RdmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmaeR {
                match bits {
                    0 => RdmaeR::_0,
                    1 => RdmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `TDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl TdmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdmaeR::_0 => 0,
                    TdmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdmaeR {
                match bits {
                    0 => TdmaeR::_0,
                    1 => TdmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `OSR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OsrR {
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            _00000,
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            _00011,
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            _00100,
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            _00101,
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            _00110,
            # [ doc = "Oversampling ratio of 8." ]
            _00111,
            # [ doc = "Oversampling ratio of 9." ]
            _01000,
            # [ doc = "Oversampling ratio of 10." ]
            _01001,
            # [ doc = "Oversampling ratio of 11." ]
            _01010,
            # [ doc = "Oversampling ratio of 12." ]
            _01011,
            # [ doc = "Oversampling ratio of 13." ]
            _01100,
            # [ doc = "Oversampling ratio of 14." ]
            _01101,
            # [ doc = "Oversampling ratio of 15." ]
            _01110,
            # [ doc = "Oversampling ratio of 16." ]
            _01111,
            # [ doc = "Oversampling ratio of 17." ]
            _10000,
            # [ doc = "Oversampling ratio of 18." ]
            _10001,
            # [ doc = "Oversampling ratio of 19." ]
            _10010,
            # [ doc = "Oversampling ratio of 20." ]
            _10011,
            # [ doc = "Oversampling ratio of 21." ]
            _10100,
            # [ doc = "Oversampling ratio of 22." ]
            _10101,
            # [ doc = "Oversampling ratio of 23." ]
            _10110,
            # [ doc = "Oversampling ratio of 24." ]
            _10111,
            # [ doc = "Oversampling ratio of 25." ]
            _11000,
            # [ doc = "Oversampling ratio of 26." ]
            _11001,
            # [ doc = "Oversampling ratio of 27." ]
            _11010,
            # [ doc = "Oversampling ratio of 28." ]
            _11011,
            # [ doc = "Oversampling ratio of 29." ]
            _11100,
            # [ doc = "Oversampling ratio of 30." ]
            _11101,
            # [ doc = "Oversampling ratio of 31." ]
            _11110,
            # [ doc = "Oversampling ratio of 32." ]
            _11111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OsrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OsrR::_00000 => 0,
                    OsrR::_00011 => 3,
                    OsrR::_00100 => 4,
                    OsrR::_00101 => 5,
                    OsrR::_00110 => 6,
                    OsrR::_00111 => 7,
                    OsrR::_01000 => 8,
                    OsrR::_01001 => 9,
                    OsrR::_01010 => 10,
                    OsrR::_01011 => 11,
                    OsrR::_01100 => 12,
                    OsrR::_01101 => 13,
                    OsrR::_01110 => 14,
                    OsrR::_01111 => 15,
                    OsrR::_10000 => 16,
                    OsrR::_10001 => 17,
                    OsrR::_10010 => 18,
                    OsrR::_10011 => 19,
                    OsrR::_10100 => 20,
                    OsrR::_10101 => 21,
                    OsrR::_10110 => 22,
                    OsrR::_10111 => 23,
                    OsrR::_11000 => 24,
                    OsrR::_11001 => 25,
                    OsrR::_11010 => 26,
                    OsrR::_11011 => 27,
                    OsrR::_11100 => 28,
                    OsrR::_11101 => 29,
                    OsrR::_11110 => 30,
                    OsrR::_11111 => 31,
                    OsrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OsrR {
                match bits {
                    0 => OsrR::_00000,
                    3 => OsrR::_00011,
                    4 => OsrR::_00100,
                    5 => OsrR::_00101,
                    6 => OsrR::_00110,
                    7 => OsrR::_00111,
                    8 => OsrR::_01000,
                    9 => OsrR::_01001,
                    10 => OsrR::_01010,
                    11 => OsrR::_01011,
                    12 => OsrR::_01100,
                    13 => OsrR::_01101,
                    14 => OsrR::_01110,
                    15 => OsrR::_01111,
                    16 => OsrR::_10000,
                    17 => OsrR::_10001,
                    18 => OsrR::_10010,
                    19 => OsrR::_10011,
                    20 => OsrR::_10100,
                    21 => OsrR::_10101,
                    22 => OsrR::_10110,
                    23 => OsrR::_10111,
                    24 => OsrR::_11000,
                    25 => OsrR::_11001,
                    26 => OsrR::_11010,
                    27 => OsrR::_11011,
                    28 => OsrR::_11100,
                    29 => OsrR::_11101,
                    30 => OsrR::_11110,
                    31 => OsrR::_11111,
                    i => OsrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000`" ]
            # [ inline ( always ) ]
            pub fn is_00000(&self) -> bool {
                *self == OsrR::_00000
            }
            # [ doc = "Checks if the value of the field is `_00011`" ]
            # [ inline ( always ) ]
            pub fn is_00011(&self) -> bool {
                *self == OsrR::_00011
            }
            # [ doc = "Checks if the value of the field is `_00100`" ]
            # [ inline ( always ) ]
            pub fn is_00100(&self) -> bool {
                *self == OsrR::_00100
            }
            # [ doc = "Checks if the value of the field is `_00101`" ]
            # [ inline ( always ) ]
            pub fn is_00101(&self) -> bool {
                *self == OsrR::_00101
            }
            # [ doc = "Checks if the value of the field is `_00110`" ]
            # [ inline ( always ) ]
            pub fn is_00110(&self) -> bool {
                *self == OsrR::_00110
            }
            # [ doc = "Checks if the value of the field is `_00111`" ]
            # [ inline ( always ) ]
            pub fn is_00111(&self) -> bool {
                *self == OsrR::_00111
            }
            # [ doc = "Checks if the value of the field is `_01000`" ]
            # [ inline ( always ) ]
            pub fn is_01000(&self) -> bool {
                *self == OsrR::_01000
            }
            # [ doc = "Checks if the value of the field is `_01001`" ]
            # [ inline ( always ) ]
            pub fn is_01001(&self) -> bool {
                *self == OsrR::_01001
            }
            # [ doc = "Checks if the value of the field is `_01010`" ]
            # [ inline ( always ) ]
            pub fn is_01010(&self) -> bool {
                *self == OsrR::_01010
            }
            # [ doc = "Checks if the value of the field is `_01011`" ]
            # [ inline ( always ) ]
            pub fn is_01011(&self) -> bool {
                *self == OsrR::_01011
            }
            # [ doc = "Checks if the value of the field is `_01100`" ]
            # [ inline ( always ) ]
            pub fn is_01100(&self) -> bool {
                *self == OsrR::_01100
            }
            # [ doc = "Checks if the value of the field is `_01101`" ]
            # [ inline ( always ) ]
            pub fn is_01101(&self) -> bool {
                *self == OsrR::_01101
            }
            # [ doc = "Checks if the value of the field is `_01110`" ]
            # [ inline ( always ) ]
            pub fn is_01110(&self) -> bool {
                *self == OsrR::_01110
            }
            # [ doc = "Checks if the value of the field is `_01111`" ]
            # [ inline ( always ) ]
            pub fn is_01111(&self) -> bool {
                *self == OsrR::_01111
            }
            # [ doc = "Checks if the value of the field is `_10000`" ]
            # [ inline ( always ) ]
            pub fn is_10000(&self) -> bool {
                *self == OsrR::_10000
            }
            # [ doc = "Checks if the value of the field is `_10001`" ]
            # [ inline ( always ) ]
            pub fn is_10001(&self) -> bool {
                *self == OsrR::_10001
            }
            # [ doc = "Checks if the value of the field is `_10010`" ]
            # [ inline ( always ) ]
            pub fn is_10010(&self) -> bool {
                *self == OsrR::_10010
            }
            # [ doc = "Checks if the value of the field is `_10011`" ]
            # [ inline ( always ) ]
            pub fn is_10011(&self) -> bool {
                *self == OsrR::_10011
            }
            # [ doc = "Checks if the value of the field is `_10100`" ]
            # [ inline ( always ) ]
            pub fn is_10100(&self) -> bool {
                *self == OsrR::_10100
            }
            # [ doc = "Checks if the value of the field is `_10101`" ]
            # [ inline ( always ) ]
            pub fn is_10101(&self) -> bool {
                *self == OsrR::_10101
            }
            # [ doc = "Checks if the value of the field is `_10110`" ]
            # [ inline ( always ) ]
            pub fn is_10110(&self) -> bool {
                *self == OsrR::_10110
            }
            # [ doc = "Checks if the value of the field is `_10111`" ]
            # [ inline ( always ) ]
            pub fn is_10111(&self) -> bool {
                *self == OsrR::_10111
            }
            # [ doc = "Checks if the value of the field is `_11000`" ]
            # [ inline ( always ) ]
            pub fn is_11000(&self) -> bool {
                *self == OsrR::_11000
            }
            # [ doc = "Checks if the value of the field is `_11001`" ]
            # [ inline ( always ) ]
            pub fn is_11001(&self) -> bool {
                *self == OsrR::_11001
            }
            # [ doc = "Checks if the value of the field is `_11010`" ]
            # [ inline ( always ) ]
            pub fn is_11010(&self) -> bool {
                *self == OsrR::_11010
            }
            # [ doc = "Checks if the value of the field is `_11011`" ]
            # [ inline ( always ) ]
            pub fn is_11011(&self) -> bool {
                *self == OsrR::_11011
            }
            # [ doc = "Checks if the value of the field is `_11100`" ]
            # [ inline ( always ) ]
            pub fn is_11100(&self) -> bool {
                *self == OsrR::_11100
            }
            # [ doc = "Checks if the value of the field is `_11101`" ]
            # [ inline ( always ) ]
            pub fn is_11101(&self) -> bool {
                *self == OsrR::_11101
            }
            # [ doc = "Checks if the value of the field is `_11110`" ]
            # [ inline ( always ) ]
            pub fn is_11110(&self) -> bool {
                *self == OsrR::_11110
            }
            # [ doc = "Checks if the value of the field is `_11111`" ]
            # [ inline ( always ) ]
            pub fn is_11111(&self) -> bool {
                *self == OsrR::_11111
            }
        }
        # [ doc = "Possible values of the field `M10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum M10R {
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            _1,
        }
        impl M10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    M10R::_0 => 0,
                    M10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> M10R {
                match bits {
                    0 => M10R::_0,
                    1 => M10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == M10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == M10R::_1
            }
        }
        # [ doc = "Possible values of the field `MAEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Maen2R {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            _1,
        }
        impl Maen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Maen2R::_0 => 0,
                    Maen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Maen2R {
                match bits {
                    0 => Maen2R::_0,
                    1 => Maen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Maen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Maen2R::_1
            }
        }
        # [ doc = "Possible values of the field `MAEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Maen1R {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            _1,
        }
        impl Maen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Maen1R::_0 => 0,
                    Maen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Maen1R {
                match bits {
                    0 => Maen1R::_0,
                    1 => Maen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Maen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Maen1R::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 8191;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBNS`" ]
        pub enum SbnsW {
            # [ doc = "One stop bit." ]
            _0,
            # [ doc = "Two stop bits." ]
            _1,
        }
        impl SbnsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SbnsW::_0 => 0,
                    SbnsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbnsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbnsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SbnsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "One stop bit." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SbnsW::_0)
            }
            # [ doc = "Two stop bits." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SbnsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXEDGIE`" ]
        pub enum RxedgieW {
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            _1,
        }
        impl RxedgieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxedgieW::_0 => 0,
                    RxedgieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxedgieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxedgieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxedgieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxedgieW::_0)
            }
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxedgieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDIE`" ]
        pub enum LbkdieW {
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            _1,
        }
        impl LbkdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdieW::_0 => 0,
                    LbkdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdieW::_0)
            }
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RESYNCDIS`" ]
        pub enum ResyncdisW {
            # [ doc = "Resynchronization during received data word is supported" ]
            _0,
            # [ doc = "Resynchronization during received data word is disabled" ]
            _1,
        }
        impl ResyncdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ResyncdisW::_0 => 0,
                    ResyncdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ResyncdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ResyncdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ResyncdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Resynchronization during received data word is supported" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ResyncdisW::_0)
            }
            # [ doc = "Resynchronization during received data word is disabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ResyncdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOTHEDGE`" ]
        pub enum BothedgeW {
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            _0,
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            _1,
        }
        impl BothedgeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BothedgeW::_0 => 0,
                    BothedgeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BothedgeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BothedgeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BothedgeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BothedgeW::_0)
            }
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BothedgeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Address Match Wakeup" ]
            _00,
            # [ doc = "Idle Match Wakeup" ]
            _01,
            # [ doc = "Match On and Match Off" ]
            _10,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_00 => 0,
                    MatcfgW::_01 => 1,
                    MatcfgW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Address Match Wakeup" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(MatcfgW::_00)
            }
            # [ doc = "Idle Match Wakeup" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(MatcfgW::_01)
            }
            # [ doc = "Match On and Match Off" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(MatcfgW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIDMAE`" ]
        pub enum RidmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RidmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RidmaeW::_0 => 0,
                    RidmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RidmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RidmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RidmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RidmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RidmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMAE`" ]
        pub enum RdmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RdmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmaeW::_0 => 0,
                    RdmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDMAE`" ]
        pub enum TdmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl TdmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdmaeW::_0 => 0,
                    TdmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OSR`" ]
        pub enum OsrW {
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            _00000,
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            _00011,
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            _00100,
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            _00101,
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            _00110,
            # [ doc = "Oversampling ratio of 8." ]
            _00111,
            # [ doc = "Oversampling ratio of 9." ]
            _01000,
            # [ doc = "Oversampling ratio of 10." ]
            _01001,
            # [ doc = "Oversampling ratio of 11." ]
            _01010,
            # [ doc = "Oversampling ratio of 12." ]
            _01011,
            # [ doc = "Oversampling ratio of 13." ]
            _01100,
            # [ doc = "Oversampling ratio of 14." ]
            _01101,
            # [ doc = "Oversampling ratio of 15." ]
            _01110,
            # [ doc = "Oversampling ratio of 16." ]
            _01111,
            # [ doc = "Oversampling ratio of 17." ]
            _10000,
            # [ doc = "Oversampling ratio of 18." ]
            _10001,
            # [ doc = "Oversampling ratio of 19." ]
            _10010,
            # [ doc = "Oversampling ratio of 20." ]
            _10011,
            # [ doc = "Oversampling ratio of 21." ]
            _10100,
            # [ doc = "Oversampling ratio of 22." ]
            _10101,
            # [ doc = "Oversampling ratio of 23." ]
            _10110,
            # [ doc = "Oversampling ratio of 24." ]
            _10111,
            # [ doc = "Oversampling ratio of 25." ]
            _11000,
            # [ doc = "Oversampling ratio of 26." ]
            _11001,
            # [ doc = "Oversampling ratio of 27." ]
            _11010,
            # [ doc = "Oversampling ratio of 28." ]
            _11011,
            # [ doc = "Oversampling ratio of 29." ]
            _11100,
            # [ doc = "Oversampling ratio of 30." ]
            _11101,
            # [ doc = "Oversampling ratio of 31." ]
            _11110,
            # [ doc = "Oversampling ratio of 32." ]
            _11111,
        }
        impl OsrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OsrW::_00000 => 0,
                    OsrW::_00011 => 3,
                    OsrW::_00100 => 4,
                    OsrW::_00101 => 5,
                    OsrW::_00110 => 6,
                    OsrW::_00111 => 7,
                    OsrW::_01000 => 8,
                    OsrW::_01001 => 9,
                    OsrW::_01010 => 10,
                    OsrW::_01011 => 11,
                    OsrW::_01100 => 12,
                    OsrW::_01101 => 13,
                    OsrW::_01110 => 14,
                    OsrW::_01111 => 15,
                    OsrW::_10000 => 16,
                    OsrW::_10001 => 17,
                    OsrW::_10010 => 18,
                    OsrW::_10011 => 19,
                    OsrW::_10100 => 20,
                    OsrW::_10101 => 21,
                    OsrW::_10110 => 22,
                    OsrW::_10111 => 23,
                    OsrW::_11000 => 24,
                    OsrW::_11001 => 25,
                    OsrW::_11010 => 26,
                    OsrW::_11011 => 27,
                    OsrW::_11100 => 28,
                    OsrW::_11101 => 29,
                    OsrW::_11110 => 30,
                    OsrW::_11111 => 31,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OsrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OsrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OsrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            # [ inline ( always ) ]
            pub fn _00000(self) -> &'a mut W {
                self.variant(OsrW::_00000)
            }
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00011(self) -> &'a mut W {
                self.variant(OsrW::_00011)
            }
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00100(self) -> &'a mut W {
                self.variant(OsrW::_00100)
            }
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00101(self) -> &'a mut W {
                self.variant(OsrW::_00101)
            }
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00110(self) -> &'a mut W {
                self.variant(OsrW::_00110)
            }
            # [ doc = "Oversampling ratio of 8." ]
            # [ inline ( always ) ]
            pub fn _00111(self) -> &'a mut W {
                self.variant(OsrW::_00111)
            }
            # [ doc = "Oversampling ratio of 9." ]
            # [ inline ( always ) ]
            pub fn _01000(self) -> &'a mut W {
                self.variant(OsrW::_01000)
            }
            # [ doc = "Oversampling ratio of 10." ]
            # [ inline ( always ) ]
            pub fn _01001(self) -> &'a mut W {
                self.variant(OsrW::_01001)
            }
            # [ doc = "Oversampling ratio of 11." ]
            # [ inline ( always ) ]
            pub fn _01010(self) -> &'a mut W {
                self.variant(OsrW::_01010)
            }
            # [ doc = "Oversampling ratio of 12." ]
            # [ inline ( always ) ]
            pub fn _01011(self) -> &'a mut W {
                self.variant(OsrW::_01011)
            }
            # [ doc = "Oversampling ratio of 13." ]
            # [ inline ( always ) ]
            pub fn _01100(self) -> &'a mut W {
                self.variant(OsrW::_01100)
            }
            # [ doc = "Oversampling ratio of 14." ]
            # [ inline ( always ) ]
            pub fn _01101(self) -> &'a mut W {
                self.variant(OsrW::_01101)
            }
            # [ doc = "Oversampling ratio of 15." ]
            # [ inline ( always ) ]
            pub fn _01110(self) -> &'a mut W {
                self.variant(OsrW::_01110)
            }
            # [ doc = "Oversampling ratio of 16." ]
            # [ inline ( always ) ]
            pub fn _01111(self) -> &'a mut W {
                self.variant(OsrW::_01111)
            }
            # [ doc = "Oversampling ratio of 17." ]
            # [ inline ( always ) ]
            pub fn _10000(self) -> &'a mut W {
                self.variant(OsrW::_10000)
            }
            # [ doc = "Oversampling ratio of 18." ]
            # [ inline ( always ) ]
            pub fn _10001(self) -> &'a mut W {
                self.variant(OsrW::_10001)
            }
            # [ doc = "Oversampling ratio of 19." ]
            # [ inline ( always ) ]
            pub fn _10010(self) -> &'a mut W {
                self.variant(OsrW::_10010)
            }
            # [ doc = "Oversampling ratio of 20." ]
            # [ inline ( always ) ]
            pub fn _10011(self) -> &'a mut W {
                self.variant(OsrW::_10011)
            }
            # [ doc = "Oversampling ratio of 21." ]
            # [ inline ( always ) ]
            pub fn _10100(self) -> &'a mut W {
                self.variant(OsrW::_10100)
            }
            # [ doc = "Oversampling ratio of 22." ]
            # [ inline ( always ) ]
            pub fn _10101(self) -> &'a mut W {
                self.variant(OsrW::_10101)
            }
            # [ doc = "Oversampling ratio of 23." ]
            # [ inline ( always ) ]
            pub fn _10110(self) -> &'a mut W {
                self.variant(OsrW::_10110)
            }
            # [ doc = "Oversampling ratio of 24." ]
            # [ inline ( always ) ]
            pub fn _10111(self) -> &'a mut W {
                self.variant(OsrW::_10111)
            }
            # [ doc = "Oversampling ratio of 25." ]
            # [ inline ( always ) ]
            pub fn _11000(self) -> &'a mut W {
                self.variant(OsrW::_11000)
            }
            # [ doc = "Oversampling ratio of 26." ]
            # [ inline ( always ) ]
            pub fn _11001(self) -> &'a mut W {
                self.variant(OsrW::_11001)
            }
            # [ doc = "Oversampling ratio of 27." ]
            # [ inline ( always ) ]
            pub fn _11010(self) -> &'a mut W {
                self.variant(OsrW::_11010)
            }
            # [ doc = "Oversampling ratio of 28." ]
            # [ inline ( always ) ]
            pub fn _11011(self) -> &'a mut W {
                self.variant(OsrW::_11011)
            }
            # [ doc = "Oversampling ratio of 29." ]
            # [ inline ( always ) ]
            pub fn _11100(self) -> &'a mut W {
                self.variant(OsrW::_11100)
            }
            # [ doc = "Oversampling ratio of 30." ]
            # [ inline ( always ) ]
            pub fn _11101(self) -> &'a mut W {
                self.variant(OsrW::_11101)
            }
            # [ doc = "Oversampling ratio of 31." ]
            # [ inline ( always ) ]
            pub fn _11110(self) -> &'a mut W {
                self.variant(OsrW::_11110)
            }
            # [ doc = "Oversampling ratio of 32." ]
            # [ inline ( always ) ]
            pub fn _11111(self) -> &'a mut W {
                self.variant(OsrW::_11111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M10`" ]
        pub enum M10W {
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            _1,
        }
        impl M10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    M10W::_0 => 0,
                    M10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _M10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _M10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: M10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(M10W::_0)
            }
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(M10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAEN2`" ]
        pub enum Maen2W {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            _1,
        }
        impl Maen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Maen2W::_0 => 0,
                    Maen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Maen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Maen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Maen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Maen2W::_0)
            }
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Maen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAEN1`" ]
        pub enum Maen1W {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            _1,
        }
        impl Maen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Maen1W::_0 => 0,
                    Maen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Maen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Maen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Maen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Maen1W::_0)
            }
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Maen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:12 - Baud Rate Modulo Divisor." ]
            # [ inline ( always ) ]
            pub fn sbr(&self) -> SbrR {
                let bits = {
                    const MASK: u16 = 8191;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SbrR { bits }
            }
            # [ doc = "Bit 13 - Stop Bit Number Select" ]
            # [ inline ( always ) ]
            pub fn sbns(&self) -> SbnsR {
                SbnsR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - RX Input Active Edge Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxedgie(&self) -> RxedgieR {
                RxedgieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - LIN Break Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lbkdie(&self) -> LbkdieR {
                LbkdieR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Resynchronization Disable" ]
            # [ inline ( always ) ]
            pub fn resyncdis(&self) -> ResyncdisR {
                ResyncdisR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 16;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 17 - Both Edge Sampling" ]
            # [ inline ( always ) ]
            pub fn bothedge(&self) -> BothedgeR {
                BothedgeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 17;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 18:19 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Receiver Idle DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ridmae(&self) -> RidmaeR {
                RidmaeR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Receiver Full DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdmae(&self) -> RdmaeR {
                RdmaeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 21;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 23 - Transmitter DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdmae(&self) -> TdmaeR {
                TdmaeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 23;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 24:28 - Oversampling Ratio" ]
            # [ inline ( always ) ]
            pub fn osr(&self) -> OsrR {
                OsrR::_from({
                                const MASK: u8 = 31;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - 10-bit Mode select" ]
            # [ inline ( always ) ]
            pub fn m10(&self) -> M10R {
                M10R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Match Address Mode Enable 2" ]
            # [ inline ( always ) ]
            pub fn maen2(&self) -> Maen2R {
                Maen2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Match Address Mode Enable 1" ]
            # [ inline ( always ) ]
            pub fn maen1(&self) -> Maen1R {
                Maen1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 251658244 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:12 - Baud Rate Modulo Divisor." ]
            # [ inline ( always ) ]
            pub fn sbr(&mut self) -> _SbrW {
                _SbrW { w: self }
            }
            # [ doc = "Bit 13 - Stop Bit Number Select" ]
            # [ inline ( always ) ]
            pub fn sbns(&mut self) -> _SbnsW {
                _SbnsW { w: self }
            }
            # [ doc = "Bit 14 - RX Input Active Edge Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxedgie(&mut self) -> _RxedgieW {
                _RxedgieW { w: self }
            }
            # [ doc = "Bit 15 - LIN Break Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lbkdie(&mut self) -> _LbkdieW {
                _LbkdieW { w: self }
            }
            # [ doc = "Bit 16 - Resynchronization Disable" ]
            # [ inline ( always ) ]
            pub fn resyncdis(&mut self) -> _ResyncdisW {
                _ResyncdisW { w: self }
            }
            # [ doc = "Bit 17 - Both Edge Sampling" ]
            # [ inline ( always ) ]
            pub fn bothedge(&mut self) -> _BothedgeW {
                _BothedgeW { w: self }
            }
            # [ doc = "Bits 18:19 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bit 20 - Receiver Idle DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ridmae(&mut self) -> _RidmaeW {
                _RidmaeW { w: self }
            }
            # [ doc = "Bit 21 - Receiver Full DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdmae(&mut self) -> _RdmaeW {
                _RdmaeW { w: self }
            }
            # [ doc = "Bit 23 - Transmitter DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdmae(&mut self) -> _TdmaeW {
                _TdmaeW { w: self }
            }
            # [ doc = "Bits 24:28 - Oversampling Ratio" ]
            # [ inline ( always ) ]
            pub fn osr(&mut self) -> _OsrW {
                _OsrW { w: self }
            }
            # [ doc = "Bit 29 - 10-bit Mode select" ]
            # [ inline ( always ) ]
            pub fn m10(&mut self) -> _M10W {
                _M10W { w: self }
            }
            # [ doc = "Bit 30 - Match Address Mode Enable 2" ]
            # [ inline ( always ) ]
            pub fn maen2(&mut self) -> _Maen2W {
                _Maen2W { w: self }
            }
            # [ doc = "Bit 31 - Match Address Mode Enable 1" ]
            # [ inline ( always ) ]
            pub fn maen1(&mut self) -> _Maen1W {
                _Maen1W { w: self }
            }
        }
    }
    # [ doc = "LPUART Status Register" ]
    pub struct Stat {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Status Register" ]
    pub mod stat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Stat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MA2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma2fR {
            # [ doc = "Received data is not equal to MA2" ]
            _0,
            # [ doc = "Received data is equal to MA2" ]
            _1,
        }
        impl Ma2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma2fR::_0 => 0,
                    Ma2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma2fR {
                match bits {
                    0 => Ma2fR::_0,
                    1 => Ma2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma2fR::_1
            }
        }
        # [ doc = "Possible values of the field `MA1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma1fR {
            # [ doc = "Received data is not equal to MA1" ]
            _0,
            # [ doc = "Received data is equal to MA1" ]
            _1,
        }
        impl Ma1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma1fR::_0 => 0,
                    Ma1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma1fR {
                match bits {
                    0 => Ma1fR::_0,
                    1 => Ma1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma1fR::_1
            }
        }
        # [ doc = "Possible values of the field `PF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PfR {
            # [ doc = "No parity error." ]
            _0,
            # [ doc = "Parity error." ]
            _1,
        }
        impl PfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PfR::_0 => 0,
                    PfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PfR {
                match bits {
                    0 => PfR::_0,
                    1 => PfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PfR::_1
            }
        }
        # [ doc = "Possible values of the field `FE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeR {
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            _0,
            # [ doc = "Framing error." ]
            _1,
        }
        impl FeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeR::_0 => 0,
                    FeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeR {
                match bits {
                    0 => FeR::_0,
                    1 => FeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeR::_1
            }
        }
        # [ doc = "Possible values of the field `NF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NfR {
            # [ doc = "No noise detected." ]
            _0,
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            _1,
        }
        impl NfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NfR::_0 => 0,
                    NfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NfR {
                match bits {
                    0 => NfR::_0,
                    1 => NfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NfR::_1
            }
        }
        # [ doc = "Possible values of the field `OR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OrR {
            # [ doc = "No overrun." ]
            _0,
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            _1,
        }
        impl OrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OrR::_0 => 0,
                    OrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OrR {
                match bits {
                    0 => OrR::_0,
                    1 => OrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdleR {
            # [ doc = "No idle line detected." ]
            _0,
            # [ doc = "Idle line was detected." ]
            _1,
        }
        impl IdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdleR::_0 => 0,
                    IdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdleR {
                match bits {
                    0 => IdleR::_0,
                    1 => IdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdleR::_1
            }
        }
        # [ doc = "Possible values of the field `RDRF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdrfR {
            # [ doc = "Receive data buffer empty." ]
            _0,
            # [ doc = "Receive data buffer full." ]
            _1,
        }
        impl RdrfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdrfR::_0 => 0,
                    RdrfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdrfR {
                match bits {
                    0 => RdrfR::_0,
                    1 => RdrfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdrfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdrfR::_1
            }
        }
        # [ doc = "Possible values of the field `TC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcR {
            # [ doc = "Transmitter active (sending data, a preamble, or a break)." ]
            _0,
            # [ doc = "Transmitter idle (transmission activity complete)." ]
            _1,
        }
        impl TcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcR::_0 => 0,
                    TcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcR {
                match bits {
                    0 => TcR::_0,
                    1 => TcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcR::_1
            }
        }
        # [ doc = "Possible values of the field `TDRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdreR {
            # [ doc = "Transmit data buffer full." ]
            _0,
            # [ doc = "Transmit data buffer empty." ]
            _1,
        }
        impl TdreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdreR::_0 => 0,
                    TdreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdreR {
                match bits {
                    0 => TdreR::_0,
                    1 => TdreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdreR::_1
            }
        }
        # [ doc = "Possible values of the field `RAF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RafR {
            # [ doc = "LPUART receiver idle waiting for a start bit." ]
            _0,
            # [ doc = "LPUART receiver active (RXD input not idle)." ]
            _1,
        }
        impl RafR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RafR::_0 => 0,
                    RafR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RafR {
                match bits {
                    0 => RafR::_0,
                    1 => RafR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RafR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RafR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdeR {
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            _0,
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            _1,
        }
        impl LbkdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdeR::_0 => 0,
                    LbkdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdeR {
                match bits {
                    0 => LbkdeR::_0,
                    1 => LbkdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdeR::_1
            }
        }
        # [ doc = "Possible values of the field `BRK13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Brk13R {
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            _0,
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            _1,
        }
        impl Brk13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Brk13R::_0 => 0,
                    Brk13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Brk13R {
                match bits {
                    0 => Brk13R::_0,
                    1 => Brk13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Brk13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Brk13R::_1
            }
        }
        # [ doc = "Possible values of the field `RWUID`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwuidR {
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            _0,
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            _1,
        }
        impl RwuidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwuidR::_0 => 0,
                    RwuidR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwuidR {
                match bits {
                    0 => RwuidR::_0,
                    1 => RwuidR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwuidR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwuidR::_1
            }
        }
        # [ doc = "Possible values of the field `RXINV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxinvR {
            # [ doc = "Receive data not inverted." ]
            _0,
            # [ doc = "Receive data inverted." ]
            _1,
        }
        impl RxinvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxinvR::_0 => 0,
                    RxinvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxinvR {
                match bits {
                    0 => RxinvR::_0,
                    1 => RxinvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxinvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxinvR::_1
            }
        }
        # [ doc = "Possible values of the field `MSBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MsbfR {
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            _0,
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            _1,
        }
        impl MsbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MsbfR::_0 => 0,
                    MsbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MsbfR {
                match bits {
                    0 => MsbfR::_0,
                    1 => MsbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MsbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MsbfR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEDGIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxedgifR {
            # [ doc = "No active edge on the receive pin has occurred." ]
            _0,
            # [ doc = "An active edge on the receive pin has occurred." ]
            _1,
        }
        impl RxedgifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxedgifR::_0 => 0,
                    RxedgifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxedgifR {
                match bits {
                    0 => RxedgifR::_0,
                    1 => RxedgifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxedgifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxedgifR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdifR {
            # [ doc = "No LIN break character has been detected." ]
            _0,
            # [ doc = "LIN break character has been detected." ]
            _1,
        }
        impl LbkdifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdifR::_0 => 0,
                    LbkdifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdifR {
                match bits {
                    0 => LbkdifR::_0,
                    1 => LbkdifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdifR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MA2F`" ]
        pub enum Ma2fW {
            # [ doc = "Received data is not equal to MA2" ]
            _0,
            # [ doc = "Received data is equal to MA2" ]
            _1,
        }
        impl Ma2fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma2fW::_0 => 0,
                    Ma2fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma2fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is not equal to MA2" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma2fW::_0)
            }
            # [ doc = "Received data is equal to MA2" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma2fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA1F`" ]
        pub enum Ma1fW {
            # [ doc = "Received data is not equal to MA1" ]
            _0,
            # [ doc = "Received data is equal to MA1" ]
            _1,
        }
        impl Ma1fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma1fW::_0 => 0,
                    Ma1fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma1fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is not equal to MA1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma1fW::_0)
            }
            # [ doc = "Received data is equal to MA1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma1fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PF`" ]
        pub enum PfW {
            # [ doc = "No parity error." ]
            _0,
            # [ doc = "Parity error." ]
            _1,
        }
        impl PfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PfW::_0 => 0,
                    PfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No parity error." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PfW::_0)
            }
            # [ doc = "Parity error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FE`" ]
        pub enum FeW {
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            _0,
            # [ doc = "Framing error." ]
            _1,
        }
        impl FeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeW::_0 => 0,
                    FeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeW::_0)
            }
            # [ doc = "Framing error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NF`" ]
        pub enum NfW {
            # [ doc = "No noise detected." ]
            _0,
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            _1,
        }
        impl NfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NfW::_0 => 0,
                    NfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No noise detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NfW::_0)
            }
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OR`" ]
        pub enum OrW {
            # [ doc = "No overrun." ]
            _0,
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            _1,
        }
        impl OrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OrW::_0 => 0,
                    OrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No overrun." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OrW::_0)
            }
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDLE`" ]
        pub enum IdleW {
            # [ doc = "No idle line detected." ]
            _0,
            # [ doc = "Idle line was detected." ]
            _1,
        }
        impl IdleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdleW::_0 => 0,
                    IdleW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No idle line detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IdleW::_0)
            }
            # [ doc = "Idle line was detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IdleW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDE`" ]
        pub enum LbkdeW {
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            _0,
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            _1,
        }
        impl LbkdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdeW::_0 => 0,
                    LbkdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdeW::_0)
            }
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BRK13`" ]
        pub enum Brk13W {
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            _0,
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            _1,
        }
        impl Brk13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Brk13W::_0 => 0,
                    Brk13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Brk13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Brk13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Brk13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Brk13W::_0)
            }
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Brk13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWUID`" ]
        pub enum RwuidW {
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            _0,
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            _1,
        }
        impl RwuidW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwuidW::_0 => 0,
                    RwuidW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwuidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwuidW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwuidW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwuidW::_0)
            }
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwuidW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXINV`" ]
        pub enum RxinvW {
            # [ doc = "Receive data not inverted." ]
            _0,
            # [ doc = "Receive data inverted." ]
            _1,
        }
        impl RxinvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxinvW::_0 => 0,
                    RxinvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxinvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxinvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxinvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive data not inverted." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxinvW::_0)
            }
            # [ doc = "Receive data inverted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxinvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MSBF`" ]
        pub enum MsbfW {
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            _0,
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            _1,
        }
        impl MsbfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MsbfW::_0 => 0,
                    MsbfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MsbfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MsbfW::_0)
            }
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MsbfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXEDGIF`" ]
        pub enum RxedgifW {
            # [ doc = "No active edge on the receive pin has occurred." ]
            _0,
            # [ doc = "An active edge on the receive pin has occurred." ]
            _1,
        }
        impl RxedgifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxedgifW::_0 => 0,
                    RxedgifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxedgifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxedgifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxedgifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No active edge on the receive pin has occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxedgifW::_0)
            }
            # [ doc = "An active edge on the receive pin has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxedgifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDIF`" ]
        pub enum LbkdifW {
            # [ doc = "No LIN break character has been detected." ]
            _0,
            # [ doc = "LIN break character has been detected." ]
            _1,
        }
        impl LbkdifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdifW::_0 => 0,
                    LbkdifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No LIN break character has been detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdifW::_0)
            }
            # [ doc = "LIN break character has been detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 14 - Match 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ma2f(&self) -> Ma2fR {
                Ma2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 15 - Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ma1f(&self) -> Ma1fR {
                Ma1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 15;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Parity Error Flag" ]
            # [ inline ( always ) ]
            pub fn pf(&self) -> PfR {
                PfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 17 - Framing Error Flag" ]
            # [ inline ( always ) ]
            pub fn fe(&self) -> FeR {
                FeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 17;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 18 - Noise Flag" ]
            # [ inline ( always ) ]
            pub fn nf(&self) -> NfR {
                NfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 19 - Receiver Overrun Flag" ]
            # [ inline ( always ) ]
            pub fn or(&self) -> OrR {
                OrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 19;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 20 - Idle Line Flag" ]
            # [ inline ( always ) ]
            pub fn idle(&self) -> IdleR {
                IdleR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Receive Data Register Full Flag" ]
            # [ inline ( always ) ]
            pub fn rdrf(&self) -> RdrfR {
                RdrfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Transmission Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tc(&self) -> TcR {
                TcR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 22;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 23 - Transmit Data Register Empty Flag" ]
            # [ inline ( always ) ]
            pub fn tdre(&self) -> TdreR {
                TdreR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 23;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Receiver Active Flag" ]
            # [ inline ( always ) ]
            pub fn raf(&self) -> RafR {
                RafR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - LIN Break Detection Enable" ]
            # [ inline ( always ) ]
            pub fn lbkde(&self) -> LbkdeR {
                LbkdeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Break Character Generation Length" ]
            # [ inline ( always ) ]
            pub fn brk13(&self) -> Brk13R {
                Brk13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 26;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 27 - Receive Wake Up Idle Detect" ]
            # [ inline ( always ) ]
            pub fn rwuid(&self) -> RwuidR {
                RwuidR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 27;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - Receive Data Inversion" ]
            # [ inline ( always ) ]
            pub fn rxinv(&self) -> RxinvR {
                RxinvR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - MSB First" ]
            # [ inline ( always ) ]
            pub fn msbf(&self) -> MsbfR {
                MsbfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - RXD Pin Active Edge Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rxedgif(&self) -> RxedgifR {
                RxedgifR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 30;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 31 - LIN Break Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn lbkdif(&self) -> LbkdifR {
                LbkdifR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12582912 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 14 - Match 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ma2f(&mut self) -> _Ma2fW {
                _Ma2fW { w: self }
            }
            # [ doc = "Bit 15 - Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ma1f(&mut self) -> _Ma1fW {
                _Ma1fW { w: self }
            }
            # [ doc = "Bit 16 - Parity Error Flag" ]
            # [ inline ( always ) ]
            pub fn pf(&mut self) -> _PfW {
                _PfW { w: self }
            }
            # [ doc = "Bit 17 - Framing Error Flag" ]
            # [ inline ( always ) ]
            pub fn fe(&mut self) -> _FeW {
                _FeW { w: self }
            }
            # [ doc = "Bit 18 - Noise Flag" ]
            # [ inline ( always ) ]
            pub fn nf(&mut self) -> _NfW {
                _NfW { w: self }
            }
            # [ doc = "Bit 19 - Receiver Overrun Flag" ]
            # [ inline ( always ) ]
            pub fn or(&mut self) -> _OrW {
                _OrW { w: self }
            }
            # [ doc = "Bit 20 - Idle Line Flag" ]
            # [ inline ( always ) ]
            pub fn idle(&mut self) -> _IdleW {
                _IdleW { w: self }
            }
            # [ doc = "Bit 25 - LIN Break Detection Enable" ]
            # [ inline ( always ) ]
            pub fn lbkde(&mut self) -> _LbkdeW {
                _LbkdeW { w: self }
            }
            # [ doc = "Bit 26 - Break Character Generation Length" ]
            # [ inline ( always ) ]
            pub fn brk13(&mut self) -> _Brk13W {
                _Brk13W { w: self }
            }
            # [ doc = "Bit 27 - Receive Wake Up Idle Detect" ]
            # [ inline ( always ) ]
            pub fn rwuid(&mut self) -> _RwuidW {
                _RwuidW { w: self }
            }
            # [ doc = "Bit 28 - Receive Data Inversion" ]
            # [ inline ( always ) ]
            pub fn rxinv(&mut self) -> _RxinvW {
                _RxinvW { w: self }
            }
            # [ doc = "Bit 29 - MSB First" ]
            # [ inline ( always ) ]
            pub fn msbf(&mut self) -> _MsbfW {
                _MsbfW { w: self }
            }
            # [ doc = "Bit 30 - RXD Pin Active Edge Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rxedgif(&mut self) -> _RxedgifW {
                _RxedgifW { w: self }
            }
            # [ doc = "Bit 31 - LIN Break Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn lbkdif(&mut self) -> _LbkdifW {
                _LbkdifW { w: self }
            }
        }
    }
    # [ doc = "LPUART Control Register" ]
    pub struct Ctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Control Register" ]
    pub mod ctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PtR {
            # [ doc = "Even parity." ]
            _0,
            # [ doc = "Odd parity." ]
            _1,
        }
        impl PtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PtR::_0 => 0,
                    PtR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PtR {
                match bits {
                    0 => PtR::_0,
                    1 => PtR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PtR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PtR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "No hardware parity generation or checking." ]
            _0,
            # [ doc = "Parity enabled." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `ILT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IltR {
            # [ doc = "Idle character bit count starts after start bit." ]
            _0,
            # [ doc = "Idle character bit count starts after stop bit." ]
            _1,
        }
        impl IltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IltR::_0 => 0,
                    IltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IltR {
                match bits {
                    0 => IltR::_0,
                    1 => IltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IltR::_1
            }
        }
        # [ doc = "Possible values of the field `WAKE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WakeR {
            # [ doc = "Configures RWU for idle-line wakeup." ]
            _0,
            # [ doc = "Configures RWU with address-mark wakeup." ]
            _1,
        }
        impl WakeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WakeR::_0 => 0,
                    WakeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WakeR {
                match bits {
                    0 => WakeR::_0,
                    1 => WakeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WakeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WakeR::_1
            }
        }
        # [ doc = "Possible values of the field `M`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MR {
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            _1,
        }
        impl MR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MR::_0 => 0,
                    MR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MR {
                match bits {
                    0 => MR::_0,
                    1 => MR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MR::_1
            }
        }
        # [ doc = "Possible values of the field `RSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RsrcR {
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            _0,
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            _1,
        }
        impl RsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RsrcR::_0 => 0,
                    RsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RsrcR {
                match bits {
                    0 => RsrcR::_0,
                    1 => RsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozeenR {
            # [ doc = "LPUART is enabled in Doze mode." ]
            _0,
            # [ doc = "LPUART is disabled in Doze mode." ]
            _1,
        }
        impl DozeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozeenR::_0 => 0,
                    DozeenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozeenR {
                match bits {
                    0 => DozeenR::_0,
                    1 => DozeenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozeenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozeenR::_1
            }
        }
        # [ doc = "Possible values of the field `LOOPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LoopsR {
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            _0,
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            _1,
        }
        impl LoopsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LoopsR::_0 => 0,
                    LoopsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LoopsR {
                match bits {
                    0 => LoopsR::_0,
                    1 => LoopsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LoopsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LoopsR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLECFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdlecfgR {
            # [ doc = "1 idle character" ]
            _000,
            # [ doc = "2 idle characters" ]
            _001,
            # [ doc = "4 idle characters" ]
            _010,
            # [ doc = "8 idle characters" ]
            _011,
            # [ doc = "16 idle characters" ]
            _100,
            # [ doc = "32 idle characters" ]
            _101,
            # [ doc = "64 idle characters" ]
            _110,
            # [ doc = "128 idle characters" ]
            _111,
        }
        impl IdlecfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdlecfgR::_000 => 0,
                    IdlecfgR::_001 => 1,
                    IdlecfgR::_010 => 2,
                    IdlecfgR::_011 => 3,
                    IdlecfgR::_100 => 4,
                    IdlecfgR::_101 => 5,
                    IdlecfgR::_110 => 6,
                    IdlecfgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdlecfgR {
                match bits {
                    0 => IdlecfgR::_000,
                    1 => IdlecfgR::_001,
                    2 => IdlecfgR::_010,
                    3 => IdlecfgR::_011,
                    4 => IdlecfgR::_100,
                    5 => IdlecfgR::_101,
                    6 => IdlecfgR::_110,
                    7 => IdlecfgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == IdlecfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == IdlecfgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == IdlecfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == IdlecfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == IdlecfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == IdlecfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == IdlecfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == IdlecfgR::_111
            }
        }
        # [ doc = "Possible values of the field `M7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum M7R {
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            _1,
        }
        impl M7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    M7R::_0 => 0,
                    M7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> M7R {
                match bits {
                    0 => M7R::_0,
                    1 => M7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == M7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == M7R::_1
            }
        }
        # [ doc = "Possible values of the field `MA2IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma2ieR {
            # [ doc = "MA2F interrupt disabled" ]
            _0,
            # [ doc = "MA2F interrupt enabled" ]
            _1,
        }
        impl Ma2ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma2ieR::_0 => 0,
                    Ma2ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma2ieR {
                match bits {
                    0 => Ma2ieR::_0,
                    1 => Ma2ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma2ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma2ieR::_1
            }
        }
        # [ doc = "Possible values of the field `MA1IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma1ieR {
            # [ doc = "MA1F interrupt disabled" ]
            _0,
            # [ doc = "MA1F interrupt enabled" ]
            _1,
        }
        impl Ma1ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma1ieR::_0 => 0,
                    Ma1ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma1ieR {
                match bits {
                    0 => Ma1ieR::_0,
                    1 => Ma1ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma1ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma1ieR::_1
            }
        }
        # [ doc = "Possible values of the field `SBK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbkR {
            # [ doc = "Normal transmitter operation." ]
            _0,
            # [ doc = "Queue break character(s) to be sent." ]
            _1,
        }
        impl SbkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbkR::_0 => 0,
                    SbkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbkR {
                match bits {
                    0 => SbkR::_0,
                    1 => SbkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbkR::_1
            }
        }
        # [ doc = "Possible values of the field `RWU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwuR {
            # [ doc = "Normal receiver operation." ]
            _0,
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            _1,
        }
        impl RwuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwuR::_0 => 0,
                    RwuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwuR {
                match bits {
                    0 => RwuR::_0,
                    1 => RwuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwuR::_1
            }
        }
        # [ doc = "Possible values of the field `RE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReR {
            # [ doc = "Receiver disabled." ]
            _0,
            # [ doc = "Receiver enabled." ]
            _1,
        }
        impl ReR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReR::_0 => 0,
                    ReR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReR {
                match bits {
                    0 => ReR::_0,
                    1 => ReR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReR::_1
            }
        }
        # [ doc = "Possible values of the field `TE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TeR {
            # [ doc = "Transmitter disabled." ]
            _0,
            # [ doc = "Transmitter enabled." ]
            _1,
        }
        impl TeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TeR::_0 => 0,
                    TeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TeR {
                match bits {
                    0 => TeR::_0,
                    1 => TeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TeR::_1
            }
        }
        # [ doc = "Possible values of the field `ILIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IlieR {
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            _1,
        }
        impl IlieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IlieR::_0 => 0,
                    IlieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IlieR {
                match bits {
                    0 => IlieR::_0,
                    1 => IlieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IlieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IlieR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcieR {
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            _1,
        }
        impl TcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcieR::_0 => 0,
                    TcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcieR {
                match bits {
                    0 => TcieR::_0,
                    1 => TcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TieR {
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            _1,
        }
        impl TieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TieR::_0 => 0,
                    TieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TieR {
                match bits {
                    0 => TieR::_0,
                    1 => TieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TieR::_1
            }
        }
        # [ doc = "Possible values of the field `PEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeieR {
            # [ doc = "PF interrupts disabled; use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when PF is set." ]
            _1,
        }
        impl PeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeieR::_0 => 0,
                    PeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeieR {
                match bits {
                    0 => PeieR::_0,
                    1 => PeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeieR::_1
            }
        }
        # [ doc = "Possible values of the field `FEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeieR {
            # [ doc = "FE interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when FE is set." ]
            _1,
        }
        impl FeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeieR::_0 => 0,
                    FeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeieR {
                match bits {
                    0 => FeieR::_0,
                    1 => FeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeieR::_1
            }
        }
        # [ doc = "Possible values of the field `NEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NeieR {
            # [ doc = "NF interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when NF is set." ]
            _1,
        }
        impl NeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NeieR::_0 => 0,
                    NeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NeieR {
                match bits {
                    0 => NeieR::_0,
                    1 => NeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NeieR::_1
            }
        }
        # [ doc = "Possible values of the field `ORIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OrieR {
            # [ doc = "OR interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when OR is set." ]
            _1,
        }
        impl OrieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OrieR::_0 => 0,
                    OrieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OrieR {
                match bits {
                    0 => OrieR::_0,
                    1 => OrieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OrieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OrieR::_1
            }
        }
        # [ doc = "Possible values of the field `TXINV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxinvR {
            # [ doc = "Transmit data not inverted." ]
            _0,
            # [ doc = "Transmit data inverted." ]
            _1,
        }
        impl TxinvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxinvR::_0 => 0,
                    TxinvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxinvR {
                match bits {
                    0 => TxinvR::_0,
                    1 => TxinvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxinvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxinvR::_1
            }
        }
        # [ doc = "Possible values of the field `TXDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxdirR {
            # [ doc = "TXD pin is an input in single-wire mode." ]
            _0,
            # [ doc = "TXD pin is an output in single-wire mode." ]
            _1,
        }
        impl TxdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxdirR::_0 => 0,
                    TxdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxdirR {
                match bits {
                    0 => TxdirR::_0,
                    1 => TxdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxdirR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R9t8R {
            bits: u8,
        }
        impl R9t8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R8t9R {
            bits: u8,
        }
        impl R8t9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `PT`" ]
        pub enum PtW {
            # [ doc = "Even parity." ]
            _0,
            # [ doc = "Odd parity." ]
            _1,
        }
        impl PtW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PtW::_0 => 0,
                    PtW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PtW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Even parity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PtW::_0)
            }
            # [ doc = "Odd parity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PtW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "No hardware parity generation or checking." ]
            _0,
            # [ doc = "Parity enabled." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No hardware parity generation or checking." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Parity enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ILT`" ]
        pub enum IltW {
            # [ doc = "Idle character bit count starts after start bit." ]
            _0,
            # [ doc = "Idle character bit count starts after stop bit." ]
            _1,
        }
        impl IltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IltW::_0 => 0,
                    IltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Idle character bit count starts after start bit." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IltW::_0)
            }
            # [ doc = "Idle character bit count starts after stop bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WAKE`" ]
        pub enum WakeW {
            # [ doc = "Configures RWU for idle-line wakeup." ]
            _0,
            # [ doc = "Configures RWU with address-mark wakeup." ]
            _1,
        }
        impl WakeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WakeW::_0 => 0,
                    WakeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WakeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WakeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WakeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configures RWU for idle-line wakeup." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WakeW::_0)
            }
            # [ doc = "Configures RWU with address-mark wakeup." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WakeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M`" ]
        pub enum MW {
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            _1,
        }
        impl MW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MW::_0 => 0,
                    MW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MW::_0)
            }
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RSRC`" ]
        pub enum RsrcW {
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            _0,
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            _1,
        }
        impl RsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RsrcW::_0 => 0,
                    RsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RsrcW::_0)
            }
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEEN`" ]
        pub enum DozeenW {
            # [ doc = "LPUART is enabled in Doze mode." ]
            _0,
            # [ doc = "LPUART is disabled in Doze mode." ]
            _1,
        }
        impl DozeenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozeenW::_0 => 0,
                    DozeenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozeenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozeenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LPUART is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozeenW::_0)
            }
            # [ doc = "LPUART is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozeenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOOPS`" ]
        pub enum LoopsW {
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            _0,
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            _1,
        }
        impl LoopsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LoopsW::_0 => 0,
                    LoopsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LoopsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LoopsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LoopsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LoopsW::_0)
            }
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LoopsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDLECFG`" ]
        pub enum IdlecfgW {
            # [ doc = "1 idle character" ]
            _000,
            # [ doc = "2 idle characters" ]
            _001,
            # [ doc = "4 idle characters" ]
            _010,
            # [ doc = "8 idle characters" ]
            _011,
            # [ doc = "16 idle characters" ]
            _100,
            # [ doc = "32 idle characters" ]
            _101,
            # [ doc = "64 idle characters" ]
            _110,
            # [ doc = "128 idle characters" ]
            _111,
        }
        impl IdlecfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdlecfgW::_000 => 0,
                    IdlecfgW::_001 => 1,
                    IdlecfgW::_010 => 2,
                    IdlecfgW::_011 => 3,
                    IdlecfgW::_100 => 4,
                    IdlecfgW::_101 => 5,
                    IdlecfgW::_110 => 6,
                    IdlecfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdlecfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdlecfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdlecfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1 idle character" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(IdlecfgW::_000)
            }
            # [ doc = "2 idle characters" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(IdlecfgW::_001)
            }
            # [ doc = "4 idle characters" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(IdlecfgW::_010)
            }
            # [ doc = "8 idle characters" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(IdlecfgW::_011)
            }
            # [ doc = "16 idle characters" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(IdlecfgW::_100)
            }
            # [ doc = "32 idle characters" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(IdlecfgW::_101)
            }
            # [ doc = "64 idle characters" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(IdlecfgW::_110)
            }
            # [ doc = "128 idle characters" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(IdlecfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M7`" ]
        pub enum M7W {
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            _1,
        }
        impl M7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    M7W::_0 => 0,
                    M7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _M7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _M7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: M7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(M7W::_0)
            }
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(M7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA2IE`" ]
        pub enum Ma2ieW {
            # [ doc = "MA2F interrupt disabled" ]
            _0,
            # [ doc = "MA2F interrupt enabled" ]
            _1,
        }
        impl Ma2ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma2ieW::_0 => 0,
                    Ma2ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma2ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "MA2F interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma2ieW::_0)
            }
            # [ doc = "MA2F interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma2ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA1IE`" ]
        pub enum Ma1ieW {
            # [ doc = "MA1F interrupt disabled" ]
            _0,
            # [ doc = "MA1F interrupt enabled" ]
            _1,
        }
        impl Ma1ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma1ieW::_0 => 0,
                    Ma1ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma1ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "MA1F interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma1ieW::_0)
            }
            # [ doc = "MA1F interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma1ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBK`" ]
        pub enum SbkW {
            # [ doc = "Normal transmitter operation." ]
            _0,
            # [ doc = "Queue break character(s) to be sent." ]
            _1,
        }
        impl SbkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SbkW::_0 => 0,
                    SbkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SbkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transmitter operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SbkW::_0)
            }
            # [ doc = "Queue break character(s) to be sent." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SbkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWU`" ]
        pub enum RwuW {
            # [ doc = "Normal receiver operation." ]
            _0,
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            _1,
        }
        impl RwuW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwuW::_0 => 0,
                    RwuW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwuW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwuW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal receiver operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwuW::_0)
            }
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwuW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RE`" ]
        pub enum ReW {
            # [ doc = "Receiver disabled." ]
            _0,
            # [ doc = "Receiver enabled." ]
            _1,
        }
        impl ReW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReW::_0 => 0,
                    ReW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReW::_0)
            }
            # [ doc = "Receiver enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TE`" ]
        pub enum TeW {
            # [ doc = "Transmitter disabled." ]
            _0,
            # [ doc = "Transmitter enabled." ]
            _1,
        }
        impl TeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TeW::_0 => 0,
                    TeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmitter disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TeW::_0)
            }
            # [ doc = "Transmitter enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ILIE`" ]
        pub enum IlieW {
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            _1,
        }
        impl IlieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IlieW::_0 => 0,
                    IlieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IlieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IlieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IlieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IlieW::_0)
            }
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IlieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCIE`" ]
        pub enum TcieW {
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            _1,
        }
        impl TcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcieW::_0 => 0,
                    TcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcieW::_0)
            }
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE`" ]
        pub enum TieW {
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            _1,
        }
        impl TieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TieW::_0 => 0,
                    TieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TieW::_0)
            }
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PEIE`" ]
        pub enum PeieW {
            # [ doc = "PF interrupts disabled; use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when PF is set." ]
            _1,
        }
        impl PeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeieW::_0 => 0,
                    PeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PF interrupts disabled; use polling)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when PF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEIE`" ]
        pub enum FeieW {
            # [ doc = "FE interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when FE is set." ]
            _1,
        }
        impl FeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeieW::_0 => 0,
                    FeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FE interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when FE is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NEIE`" ]
        pub enum NeieW {
            # [ doc = "NF interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when NF is set." ]
            _1,
        }
        impl NeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NeieW::_0 => 0,
                    NeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "NF interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when NF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ORIE`" ]
        pub enum OrieW {
            # [ doc = "OR interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when OR is set." ]
            _1,
        }
        impl OrieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OrieW::_0 => 0,
                    OrieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OrieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OrieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OrieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OR interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OrieW::_0)
            }
            # [ doc = "Hardware interrupt requested when OR is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OrieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXINV`" ]
        pub enum TxinvW {
            # [ doc = "Transmit data not inverted." ]
            _0,
            # [ doc = "Transmit data inverted." ]
            _1,
        }
        impl TxinvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxinvW::_0 => 0,
                    TxinvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxinvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxinvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxinvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit data not inverted." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxinvW::_0)
            }
            # [ doc = "Transmit data inverted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxinvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXDIR`" ]
        pub enum TxdirW {
            # [ doc = "TXD pin is an input in single-wire mode." ]
            _0,
            # [ doc = "TXD pin is an output in single-wire mode." ]
            _1,
        }
        impl TxdirW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxdirW::_0 => 0,
                    TxdirW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxdirW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxdirW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxdirW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TXD pin is an input in single-wire mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxdirW::_0)
            }
            # [ doc = "TXD pin is an output in single-wire mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxdirW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9t8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9t8W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8t9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8t9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Parity Type" ]
            # [ inline ( always ) ]
            pub fn pt(&self) -> PtR {
                PtR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Parity Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 2 - Idle Line Type Select" ]
            # [ inline ( always ) ]
            pub fn ilt(&self) -> IltR {
                IltR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Receiver Wakeup Method Select" ]
            # [ inline ( always ) ]
            pub fn wake(&self) -> WakeR {
                WakeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - 9-Bit or 8-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m(&self) -> MR {
                MR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 4;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
            # [ doc = "Bit 5 - Receiver Source Select" ]
            # [ inline ( always ) ]
            pub fn rsrc(&self) -> RsrcR {
                RsrcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozeen(&self) -> DozeenR {
                DozeenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Loop Mode Select" ]
            # [ inline ( always ) ]
            pub fn loops(&self) -> LoopsR {
                LoopsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Idle Configuration" ]
            # [ inline ( always ) ]
            pub fn idlecfg(&self) -> IdlecfgR {
                IdlecfgR::_from({
                                    const MASK: u8 = 7;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - 7-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m7(&self) -> M7R {
                M7R::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 11;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 14 - Match 2 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma2ie(&self) -> Ma2ieR {
                Ma2ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma1ie(&self) -> Ma1ieR {
                Ma1ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - Send Break" ]
            # [ inline ( always ) ]
            pub fn sbk(&self) -> SbkR {
                SbkR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Receiver Wakeup Control" ]
            # [ inline ( always ) ]
            pub fn rwu(&self) -> RwuR {
                RwuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Receiver Enable" ]
            # [ inline ( always ) ]
            pub fn re(&self) -> ReR {
                ReR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 19 - Transmitter Enable" ]
            # [ inline ( always ) ]
            pub fn te(&self) -> TeR {
                TeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 19;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 20 - Idle Line Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ilie(&self) -> IlieR {
                IlieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Receiver Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Transmission Complete Interrupt Enable for" ]
            # [ inline ( always ) ]
            pub fn tcie(&self) -> TcieR {
                TcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Transmit Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&self) -> TieR {
                TieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 23;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Parity Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn peie(&self) -> PeieR {
                PeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 25 - Framing Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&self) -> FeieR {
                FeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 25;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 26 - Noise Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn neie(&self) -> NeieR {
                NeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 26;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 27 - Overrun Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn orie(&self) -> OrieR {
                OrieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 27;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - Transmit Data Inversion" ]
            # [ inline ( always ) ]
            pub fn txinv(&self) -> TxinvR {
                TxinvR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - TXD Pin Direction in Single-Wire Mode" ]
            # [ inline ( always ) ]
            pub fn txdir(&self) -> TxdirR {
                TxdirR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 29;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 30 - Receive Bit 9 / Transmit Bit 8" ]
            # [ inline ( always ) ]
            pub fn r9t8(&self) -> R9t8R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R9t8R { bits }
            }
            # [ doc = "Bit 31 - Receive Bit 8 / Transmit Bit 9" ]
            # [ inline ( always ) ]
            pub fn r8t9(&self) -> R8t9R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R8t9R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Parity Type" ]
            # [ inline ( always ) ]
            pub fn pt(&mut self) -> _PtW {
                _PtW { w: self }
            }
            # [ doc = "Bit 1 - Parity Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 2 - Idle Line Type Select" ]
            # [ inline ( always ) ]
            pub fn ilt(&mut self) -> _IltW {
                _IltW { w: self }
            }
            # [ doc = "Bit 3 - Receiver Wakeup Method Select" ]
            # [ inline ( always ) ]
            pub fn wake(&mut self) -> _WakeW {
                _WakeW { w: self }
            }
            # [ doc = "Bit 4 - 9-Bit or 8-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m(&mut self) -> _MW {
                _MW { w: self }
            }
            # [ doc = "Bit 5 - Receiver Source Select" ]
            # [ inline ( always ) ]
            pub fn rsrc(&mut self) -> _RsrcW {
                _RsrcW { w: self }
            }
            # [ doc = "Bit 6 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozeen(&mut self) -> _DozeenW {
                _DozeenW { w: self }
            }
            # [ doc = "Bit 7 - Loop Mode Select" ]
            # [ inline ( always ) ]
            pub fn loops(&mut self) -> _LoopsW {
                _LoopsW { w: self }
            }
            # [ doc = "Bits 8:10 - Idle Configuration" ]
            # [ inline ( always ) ]
            pub fn idlecfg(&mut self) -> _IdlecfgW {
                _IdlecfgW { w: self }
            }
            # [ doc = "Bit 11 - 7-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m7(&mut self) -> _M7W {
                _M7W { w: self }
            }
            # [ doc = "Bit 14 - Match 2 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma2ie(&mut self) -> _Ma2ieW {
                _Ma2ieW { w: self }
            }
            # [ doc = "Bit 15 - Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma1ie(&mut self) -> _Ma1ieW {
                _Ma1ieW { w: self }
            }
            # [ doc = "Bit 16 - Send Break" ]
            # [ inline ( always ) ]
            pub fn sbk(&mut self) -> _SbkW {
                _SbkW { w: self }
            }
            # [ doc = "Bit 17 - Receiver Wakeup Control" ]
            # [ inline ( always ) ]
            pub fn rwu(&mut self) -> _RwuW {
                _RwuW { w: self }
            }
            # [ doc = "Bit 18 - Receiver Enable" ]
            # [ inline ( always ) ]
            pub fn re(&mut self) -> _ReW {
                _ReW { w: self }
            }
            # [ doc = "Bit 19 - Transmitter Enable" ]
            # [ inline ( always ) ]
            pub fn te(&mut self) -> _TeW {
                _TeW { w: self }
            }
            # [ doc = "Bit 20 - Idle Line Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ilie(&mut self) -> _IlieW {
                _IlieW { w: self }
            }
            # [ doc = "Bit 21 - Receiver Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 22 - Transmission Complete Interrupt Enable for" ]
            # [ inline ( always ) ]
            pub fn tcie(&mut self) -> _TcieW {
                _TcieW { w: self }
            }
            # [ doc = "Bit 23 - Transmit Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&mut self) -> _TieW {
                _TieW { w: self }
            }
            # [ doc = "Bit 24 - Parity Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn peie(&mut self) -> _PeieW {
                _PeieW { w: self }
            }
            # [ doc = "Bit 25 - Framing Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&mut self) -> _FeieW {
                _FeieW { w: self }
            }
            # [ doc = "Bit 26 - Noise Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn neie(&mut self) -> _NeieW {
                _NeieW { w: self }
            }
            # [ doc = "Bit 27 - Overrun Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn orie(&mut self) -> _OrieW {
                _OrieW { w: self }
            }
            # [ doc = "Bit 28 - Transmit Data Inversion" ]
            # [ inline ( always ) ]
            pub fn txinv(&mut self) -> _TxinvW {
                _TxinvW { w: self }
            }
            # [ doc = "Bit 29 - TXD Pin Direction in Single-Wire Mode" ]
            # [ inline ( always ) ]
            pub fn txdir(&mut self) -> _TxdirW {
                _TxdirW { w: self }
            }
            # [ doc = "Bit 30 - Receive Bit 9 / Transmit Bit 8" ]
            # [ inline ( always ) ]
            pub fn r9t8(&mut self) -> _R9t8W {
                _R9t8W { w: self }
            }
            # [ doc = "Bit 31 - Receive Bit 8 / Transmit Bit 9" ]
            # [ inline ( always ) ]
            pub fn r8t9(&mut self) -> _R8t9W {
                _R8t9W { w: self }
            }
        }
    }
    # [ doc = "LPUART Data Register" ]
    pub struct Data {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Data Register" ]
    pub mod data {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Data {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R0t0R {
            bits: u8,
        }
        impl R0t0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R1t1R {
            bits: u8,
        }
        impl R1t1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R2t2R {
            bits: u8,
        }
        impl R2t2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R3t3R {
            bits: u8,
        }
        impl R3t3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R4t4R {
            bits: u8,
        }
        impl R4t4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R5t5R {
            bits: u8,
        }
        impl R5t5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R6t6R {
            bits: u8,
        }
        impl R6t6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R7t7R {
            bits: u8,
        }
        impl R7t7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R8t8R {
            bits: u8,
        }
        impl R8t8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R9t9R {
            bits: u8,
        }
        impl R9t9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `IDLINE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdlineR {
            # [ doc = "Receiver was not idle before receiving this character." ]
            _0,
            # [ doc = "Receiver was idle before receiving this character." ]
            _1,
        }
        impl IdlineR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdlineR::_0 => 0,
                    IdlineR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdlineR {
                match bits {
                    0 => IdlineR::_0,
                    1 => IdlineR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdlineR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdlineR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptR {
            # [ doc = "Receive buffer contains valid data." ]
            _0,
            # [ doc = "Receive buffer is empty, data returned on read is not valid." ]
            _1,
        }
        impl RxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptR::_0 => 0,
                    RxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptR {
                match bits {
                    0 => RxemptR::_0,
                    1 => RxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptR::_1
            }
        }
        # [ doc = "Possible values of the field `FRETSC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FretscR {
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            _0,
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            _1,
        }
        impl FretscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FretscR::_0 => 0,
                    FretscR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FretscR {
                match bits {
                    0 => FretscR::_0,
                    1 => FretscR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FretscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FretscR::_1
            }
        }
        # [ doc = "Possible values of the field `PARITYE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ParityeR {
            # [ doc = "The dataword was received without a parity error." ]
            _0,
            # [ doc = "The dataword was received with a parity error." ]
            _1,
        }
        impl ParityeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ParityeR::_0 => 0,
                    ParityeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ParityeR {
                match bits {
                    0 => ParityeR::_0,
                    1 => ParityeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ParityeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ParityeR::_1
            }
        }
        # [ doc = "Possible values of the field `NOISY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NoisyR {
            # [ doc = "The dataword was received without noise." ]
            _0,
            # [ doc = "The data was received with noise." ]
            _1,
        }
        impl NoisyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NoisyR::_0 => 0,
                    NoisyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NoisyR {
                match bits {
                    0 => NoisyR::_0,
                    1 => NoisyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NoisyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NoisyR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R0t0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R0t0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R1t1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R1t1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R2t2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R2t2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R3t3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R3t3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R4t4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R4t4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R5t5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R5t5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R6t6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R6t6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R7t7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R7t7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8t8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8t8W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9t9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9t9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRETSC`" ]
        pub enum FretscW {
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            _0,
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            _1,
        }
        impl FretscW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FretscW::_0 => 0,
                    FretscW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FretscW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FretscW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FretscW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FretscW::_0)
            }
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FretscW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - R0T0" ]
            # [ inline ( always ) ]
            pub fn r0t0(&self) -> R0t0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R0t0R { bits }
            }
            # [ doc = "Bit 1 - R1T1" ]
            # [ inline ( always ) ]
            pub fn r1t1(&self) -> R1t1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R1t1R { bits }
            }
            # [ doc = "Bit 2 - R2T2" ]
            # [ inline ( always ) ]
            pub fn r2t2(&self) -> R2t2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R2t2R { bits }
            }
            # [ doc = "Bit 3 - R3T3" ]
            # [ inline ( always ) ]
            pub fn r3t3(&self) -> R3t3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R3t3R { bits }
            }
            # [ doc = "Bit 4 - R4T4" ]
            # [ inline ( always ) ]
            pub fn r4t4(&self) -> R4t4R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R4t4R { bits }
            }
            # [ doc = "Bit 5 - R5T5" ]
            # [ inline ( always ) ]
            pub fn r5t5(&self) -> R5t5R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R5t5R { bits }
            }
            # [ doc = "Bit 6 - R6T6" ]
            # [ inline ( always ) ]
            pub fn r6t6(&self) -> R6t6R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R6t6R { bits }
            }
            # [ doc = "Bit 7 - R7T7" ]
            # [ inline ( always ) ]
            pub fn r7t7(&self) -> R7t7R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R7t7R { bits }
            }
            # [ doc = "Bit 8 - R8T8" ]
            # [ inline ( always ) ]
            pub fn r8t8(&self) -> R8t8R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R8t8R { bits }
            }
            # [ doc = "Bit 9 - R9T9" ]
            # [ inline ( always ) ]
            pub fn r9t9(&self) -> R9t9R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R9t9R { bits }
            }
            # [ doc = "Bit 11 - Idle Line" ]
            # [ inline ( always ) ]
            pub fn idline(&self) -> IdlineR {
                IdlineR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Receive Buffer Empty" ]
            # [ inline ( always ) ]
            pub fn rxempt(&self) -> RxemptR {
                RxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Frame Error / Transmit Special Character" ]
            # [ inline ( always ) ]
            pub fn fretsc(&self) -> FretscR {
                FretscR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - PARITYE" ]
            # [ inline ( always ) ]
            pub fn paritye(&self) -> ParityeR {
                ParityeR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - NOISY" ]
            # [ inline ( always ) ]
            pub fn noisy(&self) -> NoisyR {
                NoisyR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4096 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - R0T0" ]
            # [ inline ( always ) ]
            pub fn r0t0(&mut self) -> _R0t0W {
                _R0t0W { w: self }
            }
            # [ doc = "Bit 1 - R1T1" ]
            # [ inline ( always ) ]
            pub fn r1t1(&mut self) -> _R1t1W {
                _R1t1W { w: self }
            }
            # [ doc = "Bit 2 - R2T2" ]
            # [ inline ( always ) ]
            pub fn r2t2(&mut self) -> _R2t2W {
                _R2t2W { w: self }
            }
            # [ doc = "Bit 3 - R3T3" ]
            # [ inline ( always ) ]
            pub fn r3t3(&mut self) -> _R3t3W {
                _R3t3W { w: self }
            }
            # [ doc = "Bit 4 - R4T4" ]
            # [ inline ( always ) ]
            pub fn r4t4(&mut self) -> _R4t4W {
                _R4t4W { w: self }
            }
            # [ doc = "Bit 5 - R5T5" ]
            # [ inline ( always ) ]
            pub fn r5t5(&mut self) -> _R5t5W {
                _R5t5W { w: self }
            }
            # [ doc = "Bit 6 - R6T6" ]
            # [ inline ( always ) ]
            pub fn r6t6(&mut self) -> _R6t6W {
                _R6t6W { w: self }
            }
            # [ doc = "Bit 7 - R7T7" ]
            # [ inline ( always ) ]
            pub fn r7t7(&mut self) -> _R7t7W {
                _R7t7W { w: self }
            }
            # [ doc = "Bit 8 - R8T8" ]
            # [ inline ( always ) ]
            pub fn r8t8(&mut self) -> _R8t8W {
                _R8t8W { w: self }
            }
            # [ doc = "Bit 9 - R9T9" ]
            # [ inline ( always ) ]
            pub fn r9t9(&mut self) -> _R9t9W {
                _R9t9W { w: self }
            }
            # [ doc = "Bit 13 - Frame Error / Transmit Special Character" ]
            # [ inline ( always ) ]
            pub fn fretsc(&mut self) -> _FretscW {
                _FretscW { w: self }
            }
        }
    }
    # [ doc = "LPUART Match Address Register" ]
    pub struct Match {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Match Address Register" ]
    pub mod match_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Match {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ma1R {
            bits: u16,
        }
        impl Ma1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ma2R {
            bits: u16,
        }
        impl Ma2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Match Address 1" ]
            # [ inline ( always ) ]
            pub fn ma1(&self) -> Ma1R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Ma1R { bits }
            }
            # [ doc = "Bits 16:25 - Match Address 2" ]
            # [ inline ( always ) ]
            pub fn ma2(&self) -> Ma2R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Ma2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Match Address 1" ]
            # [ inline ( always ) ]
            pub fn ma1(&mut self) -> _Ma1W {
                _Ma1W { w: self }
            }
            # [ doc = "Bits 16:25 - Match Address 2" ]
            # [ inline ( always ) ]
            pub fn ma2(&mut self) -> _Ma2W {
                _Ma2W { w: self }
            }
        }
    }
    # [ doc = "LPUART Modem IrDA Register" ]
    pub struct Modir {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Modem IrDA Register" ]
    pub mod modir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Modir {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TXCTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctseR {
            # [ doc = "CTS has no effect on the transmitter." ]
            _0,
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            _1,
        }
        impl TxctseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctseR::_0 => 0,
                    TxctseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctseR {
                match bits {
                    0 => TxctseR::_0,
                    1 => TxctseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctseR::_1
            }
        }
        # [ doc = "Possible values of the field `TXRTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxrtseR {
            # [ doc = "The transmitter has no effect on RTS." ]
            _0,
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            _1,
        }
        impl TxrtseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxrtseR::_0 => 0,
                    TxrtseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxrtseR {
                match bits {
                    0 => TxrtseR::_0,
                    1 => TxrtseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxrtseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxrtseR::_1
            }
        }
        # [ doc = "Possible values of the field `TXRTSPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxrtspolR {
            # [ doc = "Transmitter RTS is active low." ]
            _0,
            # [ doc = "Transmitter RTS is active high." ]
            _1,
        }
        impl TxrtspolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxrtspolR::_0 => 0,
                    TxrtspolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxrtspolR {
                match bits {
                    0 => TxrtspolR::_0,
                    1 => TxrtspolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxrtspolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxrtspolR::_1
            }
        }
        # [ doc = "Possible values of the field `RXRTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxrtseR {
            # [ doc = "The receiver has no effect on RTS." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RxrtseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxrtseR::_0 => 0,
                    RxrtseR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxrtseR {
                match bits {
                    0 => RxrtseR::_0,
                    i => RxrtseR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxrtseR::_0
            }
        }
        # [ doc = "Possible values of the field `TXCTSC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctscR {
            # [ doc = "CTS input is sampled at the start of each character." ]
            _0,
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            _1,
        }
        impl TxctscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctscR::_0 => 0,
                    TxctscR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctscR {
                match bits {
                    0 => TxctscR::_0,
                    1 => TxctscR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctscR::_1
            }
        }
        # [ doc = "Possible values of the field `TXCTSSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctssrcR {
            # [ doc = "CTS input is the CTS_B pin." ]
            _0,
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            _1,
        }
        impl TxctssrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctssrcR::_0 => 0,
                    TxctssrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctssrcR {
                match bits {
                    0 => TxctssrcR::_0,
                    1 => TxctssrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctssrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctssrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RtswaterR {
            bits: u8,
        }
        impl RtswaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TNP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TnpR {
            # [ doc = "1/OSR." ]
            _00,
            # [ doc = "2/OSR." ]
            _01,
            # [ doc = "3/OSR." ]
            _10,
            # [ doc = "4/OSR." ]
            _11,
        }
        impl TnpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TnpR::_00 => 0,
                    TnpR::_01 => 1,
                    TnpR::_10 => 2,
                    TnpR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TnpR {
                match bits {
                    0 => TnpR::_00,
                    1 => TnpR::_01,
                    2 => TnpR::_10,
                    3 => TnpR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TnpR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TnpR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TnpR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TnpR::_11
            }
        }
        # [ doc = "Possible values of the field `IREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrenR {
            # [ doc = "IR disabled." ]
            _0,
            # [ doc = "IR enabled." ]
            _1,
        }
        impl IrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrenR::_0 => 0,
                    IrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrenR {
                match bits {
                    0 => IrenR::_0,
                    1 => IrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSE`" ]
        pub enum TxctseW {
            # [ doc = "CTS has no effect on the transmitter." ]
            _0,
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            _1,
        }
        impl TxctseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctseW::_0 => 0,
                    TxctseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS has no effect on the transmitter." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctseW::_0)
            }
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXRTSE`" ]
        pub enum TxrtseW {
            # [ doc = "The transmitter has no effect on RTS." ]
            _0,
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            _1,
        }
        impl TxrtseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxrtseW::_0 => 0,
                    TxrtseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxrtseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxrtseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxrtseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The transmitter has no effect on RTS." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxrtseW::_0)
            }
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxrtseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXRTSPOL`" ]
        pub enum TxrtspolW {
            # [ doc = "Transmitter RTS is active low." ]
            _0,
            # [ doc = "Transmitter RTS is active high." ]
            _1,
        }
        impl TxrtspolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxrtspolW::_0 => 0,
                    TxrtspolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxrtspolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxrtspolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxrtspolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmitter RTS is active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxrtspolW::_0)
            }
            # [ doc = "Transmitter RTS is active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxrtspolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXRTSE`" ]
        pub enum RxrtseW {
            # [ doc = "The receiver has no effect on RTS." ]
            _0,
        }
        impl RxrtseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxrtseW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxrtseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxrtseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxrtseW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The receiver has no effect on RTS." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxrtseW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSC`" ]
        pub enum TxctscW {
            # [ doc = "CTS input is sampled at the start of each character." ]
            _0,
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            _1,
        }
        impl TxctscW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctscW::_0 => 0,
                    TxctscW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctscW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctscW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctscW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS input is sampled at the start of each character." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctscW::_0)
            }
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctscW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSSRC`" ]
        pub enum TxctssrcW {
            # [ doc = "CTS input is the CTS_B pin." ]
            _0,
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            _1,
        }
        impl TxctssrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctssrcW::_0 => 0,
                    TxctssrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctssrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctssrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctssrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS input is the CTS_B pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctssrcW::_0)
            }
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctssrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtswaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtswaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TNP`" ]
        pub enum TnpW {
            # [ doc = "1/OSR." ]
            _00,
            # [ doc = "2/OSR." ]
            _01,
            # [ doc = "3/OSR." ]
            _10,
            # [ doc = "4/OSR." ]
            _11,
        }
        impl TnpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TnpW::_00 => 0,
                    TnpW::_01 => 1,
                    TnpW::_10 => 2,
                    TnpW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TnpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TnpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TnpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1/OSR." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TnpW::_00)
            }
            # [ doc = "2/OSR." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TnpW::_01)
            }
            # [ doc = "3/OSR." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TnpW::_10)
            }
            # [ doc = "4/OSR." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TnpW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IREN`" ]
        pub enum IrenW {
            # [ doc = "IR disabled." ]
            _0,
            # [ doc = "IR enabled." ]
            _1,
        }
        impl IrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrenW::_0 => 0,
                    IrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "IR disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IrenW::_0)
            }
            # [ doc = "IR enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmitter clear-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txctse(&self) -> TxctseR {
                TxctseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Transmitter request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txrtse(&self) -> TxrtseR {
                TxrtseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Transmitter request-to-send polarity" ]
            # [ inline ( always ) ]
            pub fn txrtspol(&self) -> TxrtspolR {
                TxrtspolR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Receiver request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn rxrtse(&self) -> RxrtseR {
                RxrtseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Transmit CTS Configuration" ]
            # [ inline ( always ) ]
            pub fn txctsc(&self) -> TxctscR {
                TxctscR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Transmit CTS Source" ]
            # [ inline ( always ) ]
            pub fn txctssrc(&self) -> TxctssrcR {
                TxctssrcR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:9 - Receive RTS Configuration" ]
            # [ inline ( always ) ]
            pub fn rtswater(&self) -> RtswaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RtswaterR { bits }
            }
            # [ doc = "Bits 16:17 - Transmitter narrow pulse" ]
            # [ inline ( always ) ]
            pub fn tnp(&self) -> TnpR {
                TnpR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Infrared enable" ]
            # [ inline ( always ) ]
            pub fn iren(&self) -> IrenR {
                IrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmitter clear-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txctse(&mut self) -> _TxctseW {
                _TxctseW { w: self }
            }
            # [ doc = "Bit 1 - Transmitter request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txrtse(&mut self) -> _TxrtseW {
                _TxrtseW { w: self }
            }
            # [ doc = "Bit 2 - Transmitter request-to-send polarity" ]
            # [ inline ( always ) ]
            pub fn txrtspol(&mut self) -> _TxrtspolW {
                _TxrtspolW { w: self }
            }
            # [ doc = "Bit 3 - Receiver request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn rxrtse(&mut self) -> _RxrtseW {
                _RxrtseW { w: self }
            }
            # [ doc = "Bit 4 - Transmit CTS Configuration" ]
            # [ inline ( always ) ]
            pub fn txctsc(&mut self) -> _TxctscW {
                _TxctscW { w: self }
            }
            # [ doc = "Bit 5 - Transmit CTS Source" ]
            # [ inline ( always ) ]
            pub fn txctssrc(&mut self) -> _TxctssrcW {
                _TxctssrcW { w: self }
            }
            # [ doc = "Bits 8:9 - Receive RTS Configuration" ]
            # [ inline ( always ) ]
            pub fn rtswater(&mut self) -> _RtswaterW {
                _RtswaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Transmitter narrow pulse" ]
            # [ inline ( always ) ]
            pub fn tnp(&mut self) -> _TnpW {
                _TnpW { w: self }
            }
            # [ doc = "Bit 18 - Infrared enable" ]
            # [ inline ( always ) ]
            pub fn iren(&mut self) -> _IrenW {
                _IrenW { w: self }
            }
        }
    }
    # [ doc = "LPUART FIFO Register" ]
    pub struct Fifo {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART FIFO Register" ]
    pub mod fifo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fifo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RXFIFOSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxfifosizeR {
            # [ doc = "Receive FIFO/Buffer depth = 1 dataword." ]
            _000,
            # [ doc = "Receive FIFO/Buffer depth = 4 datawords." ]
            _001,
            # [ doc = "Receive FIFO/Buffer depth = 8 datawords." ]
            _010,
            # [ doc = "Receive FIFO/Buffer depth = 16 datawords." ]
            _011,
            # [ doc = "Receive FIFO/Buffer depth = 32 datawords." ]
            _100,
            # [ doc = "Receive FIFO/Buffer depth = 64 datawords." ]
            _101,
            # [ doc = "Receive FIFO/Buffer depth = 128 datawords." ]
            _110,
            # [ doc = "Receive FIFO/Buffer depth = 256 datawords." ]
            _111,
        }
        impl RxfifosizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxfifosizeR::_000 => 0,
                    RxfifosizeR::_001 => 1,
                    RxfifosizeR::_010 => 2,
                    RxfifosizeR::_011 => 3,
                    RxfifosizeR::_100 => 4,
                    RxfifosizeR::_101 => 5,
                    RxfifosizeR::_110 => 6,
                    RxfifosizeR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxfifosizeR {
                match bits {
                    0 => RxfifosizeR::_000,
                    1 => RxfifosizeR::_001,
                    2 => RxfifosizeR::_010,
                    3 => RxfifosizeR::_011,
                    4 => RxfifosizeR::_100,
                    5 => RxfifosizeR::_101,
                    6 => RxfifosizeR::_110,
                    7 => RxfifosizeR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == RxfifosizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == RxfifosizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == RxfifosizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == RxfifosizeR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == RxfifosizeR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == RxfifosizeR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == RxfifosizeR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == RxfifosizeR::_111
            }
        }
        # [ doc = "Possible values of the field `RXFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxfeR {
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            _0,
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            _1,
        }
        impl RxfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxfeR::_0 => 0,
                    RxfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxfeR {
                match bits {
                    0 => RxfeR::_0,
                    1 => RxfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxfeR::_1
            }
        }
        # [ doc = "Possible values of the field `TXFIFOSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxfifosizeR {
            # [ doc = "Transmit FIFO/Buffer depth = 1 dataword." ]
            _000,
            # [ doc = "Transmit FIFO/Buffer depth = 4 datawords." ]
            _001,
            # [ doc = "Transmit FIFO/Buffer depth = 8 datawords." ]
            _010,
            # [ doc = "Transmit FIFO/Buffer depth = 16 datawords." ]
            _011,
            # [ doc = "Transmit FIFO/Buffer depth = 32 datawords." ]
            _100,
            # [ doc = "Transmit FIFO/Buffer depth = 64 datawords." ]
            _101,
            # [ doc = "Transmit FIFO/Buffer depth = 128 datawords." ]
            _110,
            # [ doc = "Transmit FIFO/Buffer depth = 256 datawords" ]
            _111,
        }
        impl TxfifosizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxfifosizeR::_000 => 0,
                    TxfifosizeR::_001 => 1,
                    TxfifosizeR::_010 => 2,
                    TxfifosizeR::_011 => 3,
                    TxfifosizeR::_100 => 4,
                    TxfifosizeR::_101 => 5,
                    TxfifosizeR::_110 => 6,
                    TxfifosizeR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxfifosizeR {
                match bits {
                    0 => TxfifosizeR::_000,
                    1 => TxfifosizeR::_001,
                    2 => TxfifosizeR::_010,
                    3 => TxfifosizeR::_011,
                    4 => TxfifosizeR::_100,
                    5 => TxfifosizeR::_101,
                    6 => TxfifosizeR::_110,
                    7 => TxfifosizeR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == TxfifosizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == TxfifosizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == TxfifosizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == TxfifosizeR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TxfifosizeR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TxfifosizeR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TxfifosizeR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TxfifosizeR::_111
            }
        }
        # [ doc = "Possible values of the field `TXFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxfeR {
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            _0,
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            _1,
        }
        impl TxfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxfeR::_0 => 0,
                    TxfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxfeR {
                match bits {
                    0 => TxfeR::_0,
                    1 => TxfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxfeR::_1
            }
        }
        # [ doc = "Possible values of the field `RXUFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxufeR {
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            _1,
        }
        impl RxufeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxufeR::_0 => 0,
                    RxufeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxufeR {
                match bits {
                    0 => RxufeR::_0,
                    1 => RxufeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxufeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxufeR::_1
            }
        }
        # [ doc = "Possible values of the field `TXOFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxofeR {
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            _1,
        }
        impl TxofeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxofeR::_0 => 0,
                    TxofeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxofeR {
                match bits {
                    0 => TxofeR::_0,
                    1 => TxofeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxofeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxofeR::_1
            }
        }
        # [ doc = "Possible values of the field `RXIDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxidenR {
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            _000,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            _001,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            _010,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            _011,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            _100,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            _101,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            _110,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            _111,
        }
        impl RxidenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxidenR::_000 => 0,
                    RxidenR::_001 => 1,
                    RxidenR::_010 => 2,
                    RxidenR::_011 => 3,
                    RxidenR::_100 => 4,
                    RxidenR::_101 => 5,
                    RxidenR::_110 => 6,
                    RxidenR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxidenR {
                match bits {
                    0 => RxidenR::_000,
                    1 => RxidenR::_001,
                    2 => RxidenR::_010,
                    3 => RxidenR::_011,
                    4 => RxidenR::_100,
                    5 => RxidenR::_101,
                    6 => RxidenR::_110,
                    7 => RxidenR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == RxidenR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == RxidenR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == RxidenR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == RxidenR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == RxidenR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == RxidenR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == RxidenR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == RxidenR::_111
            }
        }
        # [ doc = "Possible values of the field `RXUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxufR {
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl RxufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxufR::_0 => 0,
                    RxufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxufR {
                match bits {
                    0 => RxufR::_0,
                    1 => RxufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxufR::_1
            }
        }
        # [ doc = "Possible values of the field `TXOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxofR {
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl TxofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxofR::_0 => 0,
                    TxofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxofR {
                match bits {
                    0 => TxofR::_0,
                    1 => TxofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxofR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptR {
            # [ doc = "Receive buffer is not empty." ]
            _0,
            # [ doc = "Receive buffer is empty." ]
            _1,
        }
        impl RxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptR::_0 => 0,
                    RxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptR {
                match bits {
                    0 => RxemptR::_0,
                    1 => RxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptR::_1
            }
        }
        # [ doc = "Possible values of the field `TXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxemptR {
            # [ doc = "Transmit buffer is not empty." ]
            _0,
            # [ doc = "Transmit buffer is empty." ]
            _1,
        }
        impl TxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxemptR::_0 => 0,
                    TxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxemptR {
                match bits {
                    0 => TxemptR::_0,
                    1 => TxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxemptR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RXFE`" ]
        pub enum RxfeW {
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            _0,
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            _1,
        }
        impl RxfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxfeW::_0 => 0,
                    RxfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxfeW::_0)
            }
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXFE`" ]
        pub enum TxfeW {
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            _0,
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            _1,
        }
        impl TxfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxfeW::_0 => 0,
                    TxfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxfeW::_0)
            }
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXUFE`" ]
        pub enum RxufeW {
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            _1,
        }
        impl RxufeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxufeW::_0 => 0,
                    RxufeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxufeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxufeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxufeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxufeW::_0)
            }
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxufeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXOFE`" ]
        pub enum TxofeW {
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            _1,
        }
        impl TxofeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxofeW::_0 => 0,
                    TxofeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxofeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxofeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxofeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxofeW::_0)
            }
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxofeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXIDEN`" ]
        pub enum RxidenW {
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            _000,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            _001,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            _010,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            _011,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            _100,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            _101,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            _110,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            _111,
        }
        impl RxidenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxidenW::_000 => 0,
                    RxidenW::_001 => 1,
                    RxidenW::_010 => 2,
                    RxidenW::_011 => 3,
                    RxidenW::_100 => 4,
                    RxidenW::_101 => 5,
                    RxidenW::_110 => 6,
                    RxidenW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxidenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxidenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxidenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(RxidenW::_000)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(RxidenW::_001)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(RxidenW::_010)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(RxidenW::_011)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(RxidenW::_100)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(RxidenW::_101)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(RxidenW::_110)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(RxidenW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXFLUSH`" ]
        pub enum RxflushW {
            # [ doc = "No flush operation occurs." ]
            _0,
            # [ doc = "All data in the receive FIFO/buffer is cleared out." ]
            _1,
        }
        impl RxflushW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxflushW::_0 => 0,
                    RxflushW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxflushW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxflushW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxflushW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No flush operation occurs." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxflushW::_0)
            }
            # [ doc = "All data in the receive FIFO/buffer is cleared out." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxflushW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXFLUSH`" ]
        pub enum TxflushW {
            # [ doc = "No flush operation occurs." ]
            _0,
            # [ doc = "All data in the transmit FIFO/Buffer is cleared out." ]
            _1,
        }
        impl TxflushW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxflushW::_0 => 0,
                    TxflushW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxflushW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxflushW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxflushW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No flush operation occurs." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxflushW::_0)
            }
            # [ doc = "All data in the transmit FIFO/Buffer is cleared out." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxflushW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXUF`" ]
        pub enum RxufW {
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl RxufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxufW::_0 => 0,
                    RxufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxufW::_0)
            }
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXOF`" ]
        pub enum TxofW {
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl TxofW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxofW::_0 => 0,
                    TxofW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxofW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxofW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxofW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxofW::_0)
            }
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxofW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Receive FIFO. Buffer Depth" ]
            # [ inline ( always ) ]
            pub fn rxfifosize(&self) -> RxfifosizeR {
                RxfifosizeR::_from({
                                       const MASK: u8 = 7;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 3 - Receive FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rxfe(&self) -> RxfeR {
                RxfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 4:6 - Transmit FIFO. Buffer Depth" ]
            # [ inline ( always ) ]
            pub fn txfifosize(&self) -> TxfifosizeR {
                TxfifosizeR::_from({
                                       const MASK: u8 = 7;
                                       const OFFSET: u8 = 4;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Transmit FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn txfe(&self) -> TxfeR {
                TxfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Receive FIFO Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxufe(&self) -> RxufeR {
                RxufeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Transmit FIFO Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn txofe(&self) -> TxofeR {
                TxofeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 10:12 - Receiver Idle Empty Enable" ]
            # [ inline ( always ) ]
            pub fn rxiden(&self) -> RxidenR {
                RxidenR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Receiver Buffer Underflow Flag" ]
            # [ inline ( always ) ]
            pub fn rxuf(&self) -> RxufR {
                RxufR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Transmitter Buffer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn txof(&self) -> TxofR {
                TxofR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Receive Buffer/FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn rxempt(&self) -> RxemptR {
                RxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Transmit Buffer/FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn txempt(&self) -> TxemptR {
                TxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12582929 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 3 - Receive FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rxfe(&mut self) -> _RxfeW {
                _RxfeW { w: self }
            }
            # [ doc = "Bit 7 - Transmit FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn txfe(&mut self) -> _TxfeW {
                _TxfeW { w: self }
            }
            # [ doc = "Bit 8 - Receive FIFO Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxufe(&mut self) -> _RxufeW {
                _RxufeW { w: self }
            }
            # [ doc = "Bit 9 - Transmit FIFO Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn txofe(&mut self) -> _TxofeW {
                _TxofeW { w: self }
            }
            # [ doc = "Bits 10:12 - Receiver Idle Empty Enable" ]
            # [ inline ( always ) ]
            pub fn rxiden(&mut self) -> _RxidenW {
                _RxidenW { w: self }
            }
            # [ doc = "Bit 14 - Receive FIFO/Buffer Flush" ]
            # [ inline ( always ) ]
            pub fn rxflush(&mut self) -> _RxflushW {
                _RxflushW { w: self }
            }
            # [ doc = "Bit 15 - Transmit FIFO/Buffer Flush" ]
            # [ inline ( always ) ]
            pub fn txflush(&mut self) -> _TxflushW {
                _TxflushW { w: self }
            }
            # [ doc = "Bit 16 - Receiver Buffer Underflow Flag" ]
            # [ inline ( always ) ]
            pub fn rxuf(&mut self) -> _RxufW {
                _RxufW { w: self }
            }
            # [ doc = "Bit 17 - Transmitter Buffer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn txof(&mut self) -> _TxofW {
                _TxofW { w: self }
            }
        }
    }
    # [ doc = "LPUART Watermark Register" ]
    pub struct Water {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Watermark Register" ]
    pub mod water {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Water {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 8:10 - Transmit Counter" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:17 - Receive Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
            # [ doc = "Bits 24:26 - Receive Counter" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
}
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub struct Lpuart0 {
    register_block: lpuart0::RegisterBlock,
}
impl Deref for Lpuart0 {
    type Target = lpuart0::RegisterBlock;
    fn deref(&self) -> &lpuart0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub const LPUART1: Peripheral<Lpuart1> = unsafe { Peripheral::new(1074180096) };
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub mod lpuart1 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - LPUART Global Register" ]
        pub global: Global,
        # [ doc = "0x0c - LPUART Pin Configuration Register" ]
        pub pincfg: Pincfg,
        # [ doc = "0x10 - LPUART Baud Rate Register" ]
        pub baud: Baud,
        # [ doc = "0x14 - LPUART Status Register" ]
        pub stat: Stat,
        # [ doc = "0x18 - LPUART Control Register" ]
        pub ctrl: Ctrl,
        # [ doc = "0x1c - LPUART Data Register" ]
        pub data: Data,
        # [ doc = "0x20 - LPUART Match Address Register" ]
        pub match_: Match,
        # [ doc = "0x24 - LPUART Modem IrDA Register" ]
        pub modir: Modir,
        # [ doc = "0x28 - LPUART FIFO Register" ]
        pub fifo: Fifo,
        # [ doc = "0x2c - LPUART Watermark Register" ]
        pub water: Water,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set." ]
            _0000000000000001,
            # [ doc = "Standard feature set with MODEM/IrDA support." ]
            _0000000000000011,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000001 => 1,
                    FeatureR::_0000000000000011 => 3,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    1 => FeatureR::_0000000000000001,
                    3 => FeatureR::_0000000000000011,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000001`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000001(&self) -> bool {
                *self == FeatureR::_0000000000000001
            }
            # [ doc = "Checks if the value of the field is `_0000000000000011`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000011(&self) -> bool {
                *self == FeatureR::_0000000000000011
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Identification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxfifoR {
            bits: u8,
        }
        impl TxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxfifoR {
            bits: u8,
        }
        impl RxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn txfifo(&self) -> TxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxfifoR { bits }
            }
            # [ doc = "Bits 8:15 - Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn rxfifo(&self) -> RxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxfifoR { bits }
            }
        }
    }
    # [ doc = "LPUART Global Register" ]
    pub struct Global {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Global Register" ]
    pub mod global {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Global {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Module is not reset." ]
            _0,
            # [ doc = "Module is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Module is not reset." ]
            _0,
            # [ doc = "Module is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Module is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
        }
    }
    # [ doc = "LPUART Pin Configuration Register" ]
    pub struct Pincfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Pin Configuration Register" ]
    pub mod pincfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pincfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgselR {
            # [ doc = "Input trigger is disabled." ]
            _00,
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            _01,
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            _10,
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            _11,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgselR::_00 => 0,
                    TrgselR::_01 => 1,
                    TrgselR::_10 => 2,
                    TrgselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgselR {
                match bits {
                    0 => TrgselR::_00,
                    1 => TrgselR::_01,
                    2 => TrgselR::_10,
                    3 => TrgselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TrgselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TrgselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TrgselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TrgselR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TRGSEL`" ]
        pub enum TrgselW {
            # [ doc = "Input trigger is disabled." ]
            _00,
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            _01,
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            _10,
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            _11,
        }
        impl TrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgselW::_00 => 0,
                    TrgselW::_01 => 1,
                    TrgselW::_10 => 2,
                    TrgselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Input trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TrgselW::_00)
            }
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TrgselW::_01)
            }
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TrgselW::_10)
            }
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TrgselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                TrgselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "LPUART Baud Rate Register" ]
    pub struct Baud {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Baud Rate Register" ]
    pub mod baud {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Baud {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SbrR {
            bits: u16,
        }
        impl SbrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SBNS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbnsR {
            # [ doc = "One stop bit." ]
            _0,
            # [ doc = "Two stop bits." ]
            _1,
        }
        impl SbnsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbnsR::_0 => 0,
                    SbnsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbnsR {
                match bits {
                    0 => SbnsR::_0,
                    1 => SbnsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbnsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbnsR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEDGIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxedgieR {
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            _1,
        }
        impl RxedgieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxedgieR::_0 => 0,
                    RxedgieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxedgieR {
                match bits {
                    0 => RxedgieR::_0,
                    1 => RxedgieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxedgieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxedgieR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdieR {
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            _1,
        }
        impl LbkdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdieR::_0 => 0,
                    LbkdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdieR {
                match bits {
                    0 => LbkdieR::_0,
                    1 => LbkdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RESYNCDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ResyncdisR {
            # [ doc = "Resynchronization during received data word is supported" ]
            _0,
            # [ doc = "Resynchronization during received data word is disabled" ]
            _1,
        }
        impl ResyncdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ResyncdisR::_0 => 0,
                    ResyncdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ResyncdisR {
                match bits {
                    0 => ResyncdisR::_0,
                    1 => ResyncdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ResyncdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ResyncdisR::_1
            }
        }
        # [ doc = "Possible values of the field `BOTHEDGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BothedgeR {
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            _0,
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            _1,
        }
        impl BothedgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BothedgeR::_0 => 0,
                    BothedgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BothedgeR {
                match bits {
                    0 => BothedgeR::_0,
                    1 => BothedgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BothedgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BothedgeR::_1
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Address Match Wakeup" ]
            _00,
            # [ doc = "Idle Match Wakeup" ]
            _01,
            # [ doc = "Match On and Match Off" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_00 => 0,
                    MatcfgR::_01 => 1,
                    MatcfgR::_10 => 2,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_00,
                    1 => MatcfgR::_01,
                    2 => MatcfgR::_10,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == MatcfgR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == MatcfgR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == MatcfgR::_10
            }
        }
        # [ doc = "Possible values of the field `RIDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RidmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RidmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RidmaeR::_0 => 0,
                    RidmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RidmaeR {
                match bits {
                    0 => RidmaeR::_0,
                    1 => RidmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RidmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RidmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RdmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmaeR::_0 => 0,
                    RdmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmaeR {
                match bits {
                    0 => RdmaeR::_0,
                    1 => RdmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `TDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl TdmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdmaeR::_0 => 0,
                    TdmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdmaeR {
                match bits {
                    0 => TdmaeR::_0,
                    1 => TdmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `OSR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OsrR {
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            _00000,
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            _00011,
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            _00100,
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            _00101,
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            _00110,
            # [ doc = "Oversampling ratio of 8." ]
            _00111,
            # [ doc = "Oversampling ratio of 9." ]
            _01000,
            # [ doc = "Oversampling ratio of 10." ]
            _01001,
            # [ doc = "Oversampling ratio of 11." ]
            _01010,
            # [ doc = "Oversampling ratio of 12." ]
            _01011,
            # [ doc = "Oversampling ratio of 13." ]
            _01100,
            # [ doc = "Oversampling ratio of 14." ]
            _01101,
            # [ doc = "Oversampling ratio of 15." ]
            _01110,
            # [ doc = "Oversampling ratio of 16." ]
            _01111,
            # [ doc = "Oversampling ratio of 17." ]
            _10000,
            # [ doc = "Oversampling ratio of 18." ]
            _10001,
            # [ doc = "Oversampling ratio of 19." ]
            _10010,
            # [ doc = "Oversampling ratio of 20." ]
            _10011,
            # [ doc = "Oversampling ratio of 21." ]
            _10100,
            # [ doc = "Oversampling ratio of 22." ]
            _10101,
            # [ doc = "Oversampling ratio of 23." ]
            _10110,
            # [ doc = "Oversampling ratio of 24." ]
            _10111,
            # [ doc = "Oversampling ratio of 25." ]
            _11000,
            # [ doc = "Oversampling ratio of 26." ]
            _11001,
            # [ doc = "Oversampling ratio of 27." ]
            _11010,
            # [ doc = "Oversampling ratio of 28." ]
            _11011,
            # [ doc = "Oversampling ratio of 29." ]
            _11100,
            # [ doc = "Oversampling ratio of 30." ]
            _11101,
            # [ doc = "Oversampling ratio of 31." ]
            _11110,
            # [ doc = "Oversampling ratio of 32." ]
            _11111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OsrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OsrR::_00000 => 0,
                    OsrR::_00011 => 3,
                    OsrR::_00100 => 4,
                    OsrR::_00101 => 5,
                    OsrR::_00110 => 6,
                    OsrR::_00111 => 7,
                    OsrR::_01000 => 8,
                    OsrR::_01001 => 9,
                    OsrR::_01010 => 10,
                    OsrR::_01011 => 11,
                    OsrR::_01100 => 12,
                    OsrR::_01101 => 13,
                    OsrR::_01110 => 14,
                    OsrR::_01111 => 15,
                    OsrR::_10000 => 16,
                    OsrR::_10001 => 17,
                    OsrR::_10010 => 18,
                    OsrR::_10011 => 19,
                    OsrR::_10100 => 20,
                    OsrR::_10101 => 21,
                    OsrR::_10110 => 22,
                    OsrR::_10111 => 23,
                    OsrR::_11000 => 24,
                    OsrR::_11001 => 25,
                    OsrR::_11010 => 26,
                    OsrR::_11011 => 27,
                    OsrR::_11100 => 28,
                    OsrR::_11101 => 29,
                    OsrR::_11110 => 30,
                    OsrR::_11111 => 31,
                    OsrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OsrR {
                match bits {
                    0 => OsrR::_00000,
                    3 => OsrR::_00011,
                    4 => OsrR::_00100,
                    5 => OsrR::_00101,
                    6 => OsrR::_00110,
                    7 => OsrR::_00111,
                    8 => OsrR::_01000,
                    9 => OsrR::_01001,
                    10 => OsrR::_01010,
                    11 => OsrR::_01011,
                    12 => OsrR::_01100,
                    13 => OsrR::_01101,
                    14 => OsrR::_01110,
                    15 => OsrR::_01111,
                    16 => OsrR::_10000,
                    17 => OsrR::_10001,
                    18 => OsrR::_10010,
                    19 => OsrR::_10011,
                    20 => OsrR::_10100,
                    21 => OsrR::_10101,
                    22 => OsrR::_10110,
                    23 => OsrR::_10111,
                    24 => OsrR::_11000,
                    25 => OsrR::_11001,
                    26 => OsrR::_11010,
                    27 => OsrR::_11011,
                    28 => OsrR::_11100,
                    29 => OsrR::_11101,
                    30 => OsrR::_11110,
                    31 => OsrR::_11111,
                    i => OsrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000`" ]
            # [ inline ( always ) ]
            pub fn is_00000(&self) -> bool {
                *self == OsrR::_00000
            }
            # [ doc = "Checks if the value of the field is `_00011`" ]
            # [ inline ( always ) ]
            pub fn is_00011(&self) -> bool {
                *self == OsrR::_00011
            }
            # [ doc = "Checks if the value of the field is `_00100`" ]
            # [ inline ( always ) ]
            pub fn is_00100(&self) -> bool {
                *self == OsrR::_00100
            }
            # [ doc = "Checks if the value of the field is `_00101`" ]
            # [ inline ( always ) ]
            pub fn is_00101(&self) -> bool {
                *self == OsrR::_00101
            }
            # [ doc = "Checks if the value of the field is `_00110`" ]
            # [ inline ( always ) ]
            pub fn is_00110(&self) -> bool {
                *self == OsrR::_00110
            }
            # [ doc = "Checks if the value of the field is `_00111`" ]
            # [ inline ( always ) ]
            pub fn is_00111(&self) -> bool {
                *self == OsrR::_00111
            }
            # [ doc = "Checks if the value of the field is `_01000`" ]
            # [ inline ( always ) ]
            pub fn is_01000(&self) -> bool {
                *self == OsrR::_01000
            }
            # [ doc = "Checks if the value of the field is `_01001`" ]
            # [ inline ( always ) ]
            pub fn is_01001(&self) -> bool {
                *self == OsrR::_01001
            }
            # [ doc = "Checks if the value of the field is `_01010`" ]
            # [ inline ( always ) ]
            pub fn is_01010(&self) -> bool {
                *self == OsrR::_01010
            }
            # [ doc = "Checks if the value of the field is `_01011`" ]
            # [ inline ( always ) ]
            pub fn is_01011(&self) -> bool {
                *self == OsrR::_01011
            }
            # [ doc = "Checks if the value of the field is `_01100`" ]
            # [ inline ( always ) ]
            pub fn is_01100(&self) -> bool {
                *self == OsrR::_01100
            }
            # [ doc = "Checks if the value of the field is `_01101`" ]
            # [ inline ( always ) ]
            pub fn is_01101(&self) -> bool {
                *self == OsrR::_01101
            }
            # [ doc = "Checks if the value of the field is `_01110`" ]
            # [ inline ( always ) ]
            pub fn is_01110(&self) -> bool {
                *self == OsrR::_01110
            }
            # [ doc = "Checks if the value of the field is `_01111`" ]
            # [ inline ( always ) ]
            pub fn is_01111(&self) -> bool {
                *self == OsrR::_01111
            }
            # [ doc = "Checks if the value of the field is `_10000`" ]
            # [ inline ( always ) ]
            pub fn is_10000(&self) -> bool {
                *self == OsrR::_10000
            }
            # [ doc = "Checks if the value of the field is `_10001`" ]
            # [ inline ( always ) ]
            pub fn is_10001(&self) -> bool {
                *self == OsrR::_10001
            }
            # [ doc = "Checks if the value of the field is `_10010`" ]
            # [ inline ( always ) ]
            pub fn is_10010(&self) -> bool {
                *self == OsrR::_10010
            }
            # [ doc = "Checks if the value of the field is `_10011`" ]
            # [ inline ( always ) ]
            pub fn is_10011(&self) -> bool {
                *self == OsrR::_10011
            }
            # [ doc = "Checks if the value of the field is `_10100`" ]
            # [ inline ( always ) ]
            pub fn is_10100(&self) -> bool {
                *self == OsrR::_10100
            }
            # [ doc = "Checks if the value of the field is `_10101`" ]
            # [ inline ( always ) ]
            pub fn is_10101(&self) -> bool {
                *self == OsrR::_10101
            }
            # [ doc = "Checks if the value of the field is `_10110`" ]
            # [ inline ( always ) ]
            pub fn is_10110(&self) -> bool {
                *self == OsrR::_10110
            }
            # [ doc = "Checks if the value of the field is `_10111`" ]
            # [ inline ( always ) ]
            pub fn is_10111(&self) -> bool {
                *self == OsrR::_10111
            }
            # [ doc = "Checks if the value of the field is `_11000`" ]
            # [ inline ( always ) ]
            pub fn is_11000(&self) -> bool {
                *self == OsrR::_11000
            }
            # [ doc = "Checks if the value of the field is `_11001`" ]
            # [ inline ( always ) ]
            pub fn is_11001(&self) -> bool {
                *self == OsrR::_11001
            }
            # [ doc = "Checks if the value of the field is `_11010`" ]
            # [ inline ( always ) ]
            pub fn is_11010(&self) -> bool {
                *self == OsrR::_11010
            }
            # [ doc = "Checks if the value of the field is `_11011`" ]
            # [ inline ( always ) ]
            pub fn is_11011(&self) -> bool {
                *self == OsrR::_11011
            }
            # [ doc = "Checks if the value of the field is `_11100`" ]
            # [ inline ( always ) ]
            pub fn is_11100(&self) -> bool {
                *self == OsrR::_11100
            }
            # [ doc = "Checks if the value of the field is `_11101`" ]
            # [ inline ( always ) ]
            pub fn is_11101(&self) -> bool {
                *self == OsrR::_11101
            }
            # [ doc = "Checks if the value of the field is `_11110`" ]
            # [ inline ( always ) ]
            pub fn is_11110(&self) -> bool {
                *self == OsrR::_11110
            }
            # [ doc = "Checks if the value of the field is `_11111`" ]
            # [ inline ( always ) ]
            pub fn is_11111(&self) -> bool {
                *self == OsrR::_11111
            }
        }
        # [ doc = "Possible values of the field `M10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum M10R {
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            _1,
        }
        impl M10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    M10R::_0 => 0,
                    M10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> M10R {
                match bits {
                    0 => M10R::_0,
                    1 => M10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == M10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == M10R::_1
            }
        }
        # [ doc = "Possible values of the field `MAEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Maen2R {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            _1,
        }
        impl Maen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Maen2R::_0 => 0,
                    Maen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Maen2R {
                match bits {
                    0 => Maen2R::_0,
                    1 => Maen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Maen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Maen2R::_1
            }
        }
        # [ doc = "Possible values of the field `MAEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Maen1R {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            _1,
        }
        impl Maen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Maen1R::_0 => 0,
                    Maen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Maen1R {
                match bits {
                    0 => Maen1R::_0,
                    1 => Maen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Maen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Maen1R::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 8191;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBNS`" ]
        pub enum SbnsW {
            # [ doc = "One stop bit." ]
            _0,
            # [ doc = "Two stop bits." ]
            _1,
        }
        impl SbnsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SbnsW::_0 => 0,
                    SbnsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbnsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbnsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SbnsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "One stop bit." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SbnsW::_0)
            }
            # [ doc = "Two stop bits." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SbnsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXEDGIE`" ]
        pub enum RxedgieW {
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            _1,
        }
        impl RxedgieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxedgieW::_0 => 0,
                    RxedgieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxedgieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxedgieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxedgieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxedgieW::_0)
            }
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxedgieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDIE`" ]
        pub enum LbkdieW {
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            _1,
        }
        impl LbkdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdieW::_0 => 0,
                    LbkdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdieW::_0)
            }
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RESYNCDIS`" ]
        pub enum ResyncdisW {
            # [ doc = "Resynchronization during received data word is supported" ]
            _0,
            # [ doc = "Resynchronization during received data word is disabled" ]
            _1,
        }
        impl ResyncdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ResyncdisW::_0 => 0,
                    ResyncdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ResyncdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ResyncdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ResyncdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Resynchronization during received data word is supported" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ResyncdisW::_0)
            }
            # [ doc = "Resynchronization during received data word is disabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ResyncdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOTHEDGE`" ]
        pub enum BothedgeW {
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            _0,
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            _1,
        }
        impl BothedgeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BothedgeW::_0 => 0,
                    BothedgeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BothedgeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BothedgeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BothedgeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BothedgeW::_0)
            }
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BothedgeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Address Match Wakeup" ]
            _00,
            # [ doc = "Idle Match Wakeup" ]
            _01,
            # [ doc = "Match On and Match Off" ]
            _10,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_00 => 0,
                    MatcfgW::_01 => 1,
                    MatcfgW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Address Match Wakeup" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(MatcfgW::_00)
            }
            # [ doc = "Idle Match Wakeup" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(MatcfgW::_01)
            }
            # [ doc = "Match On and Match Off" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(MatcfgW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIDMAE`" ]
        pub enum RidmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RidmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RidmaeW::_0 => 0,
                    RidmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RidmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RidmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RidmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RidmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RidmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMAE`" ]
        pub enum RdmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RdmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmaeW::_0 => 0,
                    RdmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDMAE`" ]
        pub enum TdmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl TdmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdmaeW::_0 => 0,
                    TdmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OSR`" ]
        pub enum OsrW {
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            _00000,
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            _00011,
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            _00100,
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            _00101,
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            _00110,
            # [ doc = "Oversampling ratio of 8." ]
            _00111,
            # [ doc = "Oversampling ratio of 9." ]
            _01000,
            # [ doc = "Oversampling ratio of 10." ]
            _01001,
            # [ doc = "Oversampling ratio of 11." ]
            _01010,
            # [ doc = "Oversampling ratio of 12." ]
            _01011,
            # [ doc = "Oversampling ratio of 13." ]
            _01100,
            # [ doc = "Oversampling ratio of 14." ]
            _01101,
            # [ doc = "Oversampling ratio of 15." ]
            _01110,
            # [ doc = "Oversampling ratio of 16." ]
            _01111,
            # [ doc = "Oversampling ratio of 17." ]
            _10000,
            # [ doc = "Oversampling ratio of 18." ]
            _10001,
            # [ doc = "Oversampling ratio of 19." ]
            _10010,
            # [ doc = "Oversampling ratio of 20." ]
            _10011,
            # [ doc = "Oversampling ratio of 21." ]
            _10100,
            # [ doc = "Oversampling ratio of 22." ]
            _10101,
            # [ doc = "Oversampling ratio of 23." ]
            _10110,
            # [ doc = "Oversampling ratio of 24." ]
            _10111,
            # [ doc = "Oversampling ratio of 25." ]
            _11000,
            # [ doc = "Oversampling ratio of 26." ]
            _11001,
            # [ doc = "Oversampling ratio of 27." ]
            _11010,
            # [ doc = "Oversampling ratio of 28." ]
            _11011,
            # [ doc = "Oversampling ratio of 29." ]
            _11100,
            # [ doc = "Oversampling ratio of 30." ]
            _11101,
            # [ doc = "Oversampling ratio of 31." ]
            _11110,
            # [ doc = "Oversampling ratio of 32." ]
            _11111,
        }
        impl OsrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OsrW::_00000 => 0,
                    OsrW::_00011 => 3,
                    OsrW::_00100 => 4,
                    OsrW::_00101 => 5,
                    OsrW::_00110 => 6,
                    OsrW::_00111 => 7,
                    OsrW::_01000 => 8,
                    OsrW::_01001 => 9,
                    OsrW::_01010 => 10,
                    OsrW::_01011 => 11,
                    OsrW::_01100 => 12,
                    OsrW::_01101 => 13,
                    OsrW::_01110 => 14,
                    OsrW::_01111 => 15,
                    OsrW::_10000 => 16,
                    OsrW::_10001 => 17,
                    OsrW::_10010 => 18,
                    OsrW::_10011 => 19,
                    OsrW::_10100 => 20,
                    OsrW::_10101 => 21,
                    OsrW::_10110 => 22,
                    OsrW::_10111 => 23,
                    OsrW::_11000 => 24,
                    OsrW::_11001 => 25,
                    OsrW::_11010 => 26,
                    OsrW::_11011 => 27,
                    OsrW::_11100 => 28,
                    OsrW::_11101 => 29,
                    OsrW::_11110 => 30,
                    OsrW::_11111 => 31,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OsrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OsrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OsrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            # [ inline ( always ) ]
            pub fn _00000(self) -> &'a mut W {
                self.variant(OsrW::_00000)
            }
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00011(self) -> &'a mut W {
                self.variant(OsrW::_00011)
            }
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00100(self) -> &'a mut W {
                self.variant(OsrW::_00100)
            }
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00101(self) -> &'a mut W {
                self.variant(OsrW::_00101)
            }
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00110(self) -> &'a mut W {
                self.variant(OsrW::_00110)
            }
            # [ doc = "Oversampling ratio of 8." ]
            # [ inline ( always ) ]
            pub fn _00111(self) -> &'a mut W {
                self.variant(OsrW::_00111)
            }
            # [ doc = "Oversampling ratio of 9." ]
            # [ inline ( always ) ]
            pub fn _01000(self) -> &'a mut W {
                self.variant(OsrW::_01000)
            }
            # [ doc = "Oversampling ratio of 10." ]
            # [ inline ( always ) ]
            pub fn _01001(self) -> &'a mut W {
                self.variant(OsrW::_01001)
            }
            # [ doc = "Oversampling ratio of 11." ]
            # [ inline ( always ) ]
            pub fn _01010(self) -> &'a mut W {
                self.variant(OsrW::_01010)
            }
            # [ doc = "Oversampling ratio of 12." ]
            # [ inline ( always ) ]
            pub fn _01011(self) -> &'a mut W {
                self.variant(OsrW::_01011)
            }
            # [ doc = "Oversampling ratio of 13." ]
            # [ inline ( always ) ]
            pub fn _01100(self) -> &'a mut W {
                self.variant(OsrW::_01100)
            }
            # [ doc = "Oversampling ratio of 14." ]
            # [ inline ( always ) ]
            pub fn _01101(self) -> &'a mut W {
                self.variant(OsrW::_01101)
            }
            # [ doc = "Oversampling ratio of 15." ]
            # [ inline ( always ) ]
            pub fn _01110(self) -> &'a mut W {
                self.variant(OsrW::_01110)
            }
            # [ doc = "Oversampling ratio of 16." ]
            # [ inline ( always ) ]
            pub fn _01111(self) -> &'a mut W {
                self.variant(OsrW::_01111)
            }
            # [ doc = "Oversampling ratio of 17." ]
            # [ inline ( always ) ]
            pub fn _10000(self) -> &'a mut W {
                self.variant(OsrW::_10000)
            }
            # [ doc = "Oversampling ratio of 18." ]
            # [ inline ( always ) ]
            pub fn _10001(self) -> &'a mut W {
                self.variant(OsrW::_10001)
            }
            # [ doc = "Oversampling ratio of 19." ]
            # [ inline ( always ) ]
            pub fn _10010(self) -> &'a mut W {
                self.variant(OsrW::_10010)
            }
            # [ doc = "Oversampling ratio of 20." ]
            # [ inline ( always ) ]
            pub fn _10011(self) -> &'a mut W {
                self.variant(OsrW::_10011)
            }
            # [ doc = "Oversampling ratio of 21." ]
            # [ inline ( always ) ]
            pub fn _10100(self) -> &'a mut W {
                self.variant(OsrW::_10100)
            }
            # [ doc = "Oversampling ratio of 22." ]
            # [ inline ( always ) ]
            pub fn _10101(self) -> &'a mut W {
                self.variant(OsrW::_10101)
            }
            # [ doc = "Oversampling ratio of 23." ]
            # [ inline ( always ) ]
            pub fn _10110(self) -> &'a mut W {
                self.variant(OsrW::_10110)
            }
            # [ doc = "Oversampling ratio of 24." ]
            # [ inline ( always ) ]
            pub fn _10111(self) -> &'a mut W {
                self.variant(OsrW::_10111)
            }
            # [ doc = "Oversampling ratio of 25." ]
            # [ inline ( always ) ]
            pub fn _11000(self) -> &'a mut W {
                self.variant(OsrW::_11000)
            }
            # [ doc = "Oversampling ratio of 26." ]
            # [ inline ( always ) ]
            pub fn _11001(self) -> &'a mut W {
                self.variant(OsrW::_11001)
            }
            # [ doc = "Oversampling ratio of 27." ]
            # [ inline ( always ) ]
            pub fn _11010(self) -> &'a mut W {
                self.variant(OsrW::_11010)
            }
            # [ doc = "Oversampling ratio of 28." ]
            # [ inline ( always ) ]
            pub fn _11011(self) -> &'a mut W {
                self.variant(OsrW::_11011)
            }
            # [ doc = "Oversampling ratio of 29." ]
            # [ inline ( always ) ]
            pub fn _11100(self) -> &'a mut W {
                self.variant(OsrW::_11100)
            }
            # [ doc = "Oversampling ratio of 30." ]
            # [ inline ( always ) ]
            pub fn _11101(self) -> &'a mut W {
                self.variant(OsrW::_11101)
            }
            # [ doc = "Oversampling ratio of 31." ]
            # [ inline ( always ) ]
            pub fn _11110(self) -> &'a mut W {
                self.variant(OsrW::_11110)
            }
            # [ doc = "Oversampling ratio of 32." ]
            # [ inline ( always ) ]
            pub fn _11111(self) -> &'a mut W {
                self.variant(OsrW::_11111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M10`" ]
        pub enum M10W {
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            _1,
        }
        impl M10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    M10W::_0 => 0,
                    M10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _M10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _M10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: M10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(M10W::_0)
            }
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(M10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAEN2`" ]
        pub enum Maen2W {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            _1,
        }
        impl Maen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Maen2W::_0 => 0,
                    Maen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Maen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Maen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Maen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Maen2W::_0)
            }
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Maen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAEN1`" ]
        pub enum Maen1W {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            _1,
        }
        impl Maen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Maen1W::_0 => 0,
                    Maen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Maen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Maen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Maen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Maen1W::_0)
            }
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Maen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:12 - Baud Rate Modulo Divisor." ]
            # [ inline ( always ) ]
            pub fn sbr(&self) -> SbrR {
                let bits = {
                    const MASK: u16 = 8191;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SbrR { bits }
            }
            # [ doc = "Bit 13 - Stop Bit Number Select" ]
            # [ inline ( always ) ]
            pub fn sbns(&self) -> SbnsR {
                SbnsR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - RX Input Active Edge Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxedgie(&self) -> RxedgieR {
                RxedgieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - LIN Break Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lbkdie(&self) -> LbkdieR {
                LbkdieR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Resynchronization Disable" ]
            # [ inline ( always ) ]
            pub fn resyncdis(&self) -> ResyncdisR {
                ResyncdisR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 16;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 17 - Both Edge Sampling" ]
            # [ inline ( always ) ]
            pub fn bothedge(&self) -> BothedgeR {
                BothedgeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 17;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 18:19 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Receiver Idle DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ridmae(&self) -> RidmaeR {
                RidmaeR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Receiver Full DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdmae(&self) -> RdmaeR {
                RdmaeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 21;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 23 - Transmitter DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdmae(&self) -> TdmaeR {
                TdmaeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 23;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 24:28 - Oversampling Ratio" ]
            # [ inline ( always ) ]
            pub fn osr(&self) -> OsrR {
                OsrR::_from({
                                const MASK: u8 = 31;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - 10-bit Mode select" ]
            # [ inline ( always ) ]
            pub fn m10(&self) -> M10R {
                M10R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Match Address Mode Enable 2" ]
            # [ inline ( always ) ]
            pub fn maen2(&self) -> Maen2R {
                Maen2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Match Address Mode Enable 1" ]
            # [ inline ( always ) ]
            pub fn maen1(&self) -> Maen1R {
                Maen1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 251658244 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:12 - Baud Rate Modulo Divisor." ]
            # [ inline ( always ) ]
            pub fn sbr(&mut self) -> _SbrW {
                _SbrW { w: self }
            }
            # [ doc = "Bit 13 - Stop Bit Number Select" ]
            # [ inline ( always ) ]
            pub fn sbns(&mut self) -> _SbnsW {
                _SbnsW { w: self }
            }
            # [ doc = "Bit 14 - RX Input Active Edge Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxedgie(&mut self) -> _RxedgieW {
                _RxedgieW { w: self }
            }
            # [ doc = "Bit 15 - LIN Break Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lbkdie(&mut self) -> _LbkdieW {
                _LbkdieW { w: self }
            }
            # [ doc = "Bit 16 - Resynchronization Disable" ]
            # [ inline ( always ) ]
            pub fn resyncdis(&mut self) -> _ResyncdisW {
                _ResyncdisW { w: self }
            }
            # [ doc = "Bit 17 - Both Edge Sampling" ]
            # [ inline ( always ) ]
            pub fn bothedge(&mut self) -> _BothedgeW {
                _BothedgeW { w: self }
            }
            # [ doc = "Bits 18:19 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bit 20 - Receiver Idle DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ridmae(&mut self) -> _RidmaeW {
                _RidmaeW { w: self }
            }
            # [ doc = "Bit 21 - Receiver Full DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdmae(&mut self) -> _RdmaeW {
                _RdmaeW { w: self }
            }
            # [ doc = "Bit 23 - Transmitter DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdmae(&mut self) -> _TdmaeW {
                _TdmaeW { w: self }
            }
            # [ doc = "Bits 24:28 - Oversampling Ratio" ]
            # [ inline ( always ) ]
            pub fn osr(&mut self) -> _OsrW {
                _OsrW { w: self }
            }
            # [ doc = "Bit 29 - 10-bit Mode select" ]
            # [ inline ( always ) ]
            pub fn m10(&mut self) -> _M10W {
                _M10W { w: self }
            }
            # [ doc = "Bit 30 - Match Address Mode Enable 2" ]
            # [ inline ( always ) ]
            pub fn maen2(&mut self) -> _Maen2W {
                _Maen2W { w: self }
            }
            # [ doc = "Bit 31 - Match Address Mode Enable 1" ]
            # [ inline ( always ) ]
            pub fn maen1(&mut self) -> _Maen1W {
                _Maen1W { w: self }
            }
        }
    }
    # [ doc = "LPUART Status Register" ]
    pub struct Stat {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Status Register" ]
    pub mod stat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Stat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MA2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma2fR {
            # [ doc = "Received data is not equal to MA2" ]
            _0,
            # [ doc = "Received data is equal to MA2" ]
            _1,
        }
        impl Ma2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma2fR::_0 => 0,
                    Ma2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma2fR {
                match bits {
                    0 => Ma2fR::_0,
                    1 => Ma2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma2fR::_1
            }
        }
        # [ doc = "Possible values of the field `MA1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma1fR {
            # [ doc = "Received data is not equal to MA1" ]
            _0,
            # [ doc = "Received data is equal to MA1" ]
            _1,
        }
        impl Ma1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma1fR::_0 => 0,
                    Ma1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma1fR {
                match bits {
                    0 => Ma1fR::_0,
                    1 => Ma1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma1fR::_1
            }
        }
        # [ doc = "Possible values of the field `PF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PfR {
            # [ doc = "No parity error." ]
            _0,
            # [ doc = "Parity error." ]
            _1,
        }
        impl PfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PfR::_0 => 0,
                    PfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PfR {
                match bits {
                    0 => PfR::_0,
                    1 => PfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PfR::_1
            }
        }
        # [ doc = "Possible values of the field `FE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeR {
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            _0,
            # [ doc = "Framing error." ]
            _1,
        }
        impl FeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeR::_0 => 0,
                    FeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeR {
                match bits {
                    0 => FeR::_0,
                    1 => FeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeR::_1
            }
        }
        # [ doc = "Possible values of the field `NF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NfR {
            # [ doc = "No noise detected." ]
            _0,
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            _1,
        }
        impl NfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NfR::_0 => 0,
                    NfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NfR {
                match bits {
                    0 => NfR::_0,
                    1 => NfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NfR::_1
            }
        }
        # [ doc = "Possible values of the field `OR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OrR {
            # [ doc = "No overrun." ]
            _0,
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            _1,
        }
        impl OrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OrR::_0 => 0,
                    OrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OrR {
                match bits {
                    0 => OrR::_0,
                    1 => OrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdleR {
            # [ doc = "No idle line detected." ]
            _0,
            # [ doc = "Idle line was detected." ]
            _1,
        }
        impl IdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdleR::_0 => 0,
                    IdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdleR {
                match bits {
                    0 => IdleR::_0,
                    1 => IdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdleR::_1
            }
        }
        # [ doc = "Possible values of the field `RDRF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdrfR {
            # [ doc = "Receive data buffer empty." ]
            _0,
            # [ doc = "Receive data buffer full." ]
            _1,
        }
        impl RdrfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdrfR::_0 => 0,
                    RdrfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdrfR {
                match bits {
                    0 => RdrfR::_0,
                    1 => RdrfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdrfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdrfR::_1
            }
        }
        # [ doc = "Possible values of the field `TC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcR {
            # [ doc = "Transmitter active (sending data, a preamble, or a break)." ]
            _0,
            # [ doc = "Transmitter idle (transmission activity complete)." ]
            _1,
        }
        impl TcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcR::_0 => 0,
                    TcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcR {
                match bits {
                    0 => TcR::_0,
                    1 => TcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcR::_1
            }
        }
        # [ doc = "Possible values of the field `TDRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdreR {
            # [ doc = "Transmit data buffer full." ]
            _0,
            # [ doc = "Transmit data buffer empty." ]
            _1,
        }
        impl TdreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdreR::_0 => 0,
                    TdreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdreR {
                match bits {
                    0 => TdreR::_0,
                    1 => TdreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdreR::_1
            }
        }
        # [ doc = "Possible values of the field `RAF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RafR {
            # [ doc = "LPUART receiver idle waiting for a start bit." ]
            _0,
            # [ doc = "LPUART receiver active (RXD input not idle)." ]
            _1,
        }
        impl RafR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RafR::_0 => 0,
                    RafR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RafR {
                match bits {
                    0 => RafR::_0,
                    1 => RafR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RafR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RafR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdeR {
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            _0,
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            _1,
        }
        impl LbkdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdeR::_0 => 0,
                    LbkdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdeR {
                match bits {
                    0 => LbkdeR::_0,
                    1 => LbkdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdeR::_1
            }
        }
        # [ doc = "Possible values of the field `BRK13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Brk13R {
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            _0,
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            _1,
        }
        impl Brk13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Brk13R::_0 => 0,
                    Brk13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Brk13R {
                match bits {
                    0 => Brk13R::_0,
                    1 => Brk13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Brk13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Brk13R::_1
            }
        }
        # [ doc = "Possible values of the field `RWUID`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwuidR {
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            _0,
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            _1,
        }
        impl RwuidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwuidR::_0 => 0,
                    RwuidR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwuidR {
                match bits {
                    0 => RwuidR::_0,
                    1 => RwuidR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwuidR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwuidR::_1
            }
        }
        # [ doc = "Possible values of the field `RXINV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxinvR {
            # [ doc = "Receive data not inverted." ]
            _0,
            # [ doc = "Receive data inverted." ]
            _1,
        }
        impl RxinvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxinvR::_0 => 0,
                    RxinvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxinvR {
                match bits {
                    0 => RxinvR::_0,
                    1 => RxinvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxinvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxinvR::_1
            }
        }
        # [ doc = "Possible values of the field `MSBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MsbfR {
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            _0,
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            _1,
        }
        impl MsbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MsbfR::_0 => 0,
                    MsbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MsbfR {
                match bits {
                    0 => MsbfR::_0,
                    1 => MsbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MsbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MsbfR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEDGIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxedgifR {
            # [ doc = "No active edge on the receive pin has occurred." ]
            _0,
            # [ doc = "An active edge on the receive pin has occurred." ]
            _1,
        }
        impl RxedgifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxedgifR::_0 => 0,
                    RxedgifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxedgifR {
                match bits {
                    0 => RxedgifR::_0,
                    1 => RxedgifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxedgifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxedgifR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdifR {
            # [ doc = "No LIN break character has been detected." ]
            _0,
            # [ doc = "LIN break character has been detected." ]
            _1,
        }
        impl LbkdifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdifR::_0 => 0,
                    LbkdifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdifR {
                match bits {
                    0 => LbkdifR::_0,
                    1 => LbkdifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdifR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MA2F`" ]
        pub enum Ma2fW {
            # [ doc = "Received data is not equal to MA2" ]
            _0,
            # [ doc = "Received data is equal to MA2" ]
            _1,
        }
        impl Ma2fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma2fW::_0 => 0,
                    Ma2fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma2fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is not equal to MA2" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma2fW::_0)
            }
            # [ doc = "Received data is equal to MA2" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma2fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA1F`" ]
        pub enum Ma1fW {
            # [ doc = "Received data is not equal to MA1" ]
            _0,
            # [ doc = "Received data is equal to MA1" ]
            _1,
        }
        impl Ma1fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma1fW::_0 => 0,
                    Ma1fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma1fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is not equal to MA1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma1fW::_0)
            }
            # [ doc = "Received data is equal to MA1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma1fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PF`" ]
        pub enum PfW {
            # [ doc = "No parity error." ]
            _0,
            # [ doc = "Parity error." ]
            _1,
        }
        impl PfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PfW::_0 => 0,
                    PfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No parity error." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PfW::_0)
            }
            # [ doc = "Parity error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FE`" ]
        pub enum FeW {
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            _0,
            # [ doc = "Framing error." ]
            _1,
        }
        impl FeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeW::_0 => 0,
                    FeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeW::_0)
            }
            # [ doc = "Framing error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NF`" ]
        pub enum NfW {
            # [ doc = "No noise detected." ]
            _0,
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            _1,
        }
        impl NfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NfW::_0 => 0,
                    NfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No noise detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NfW::_0)
            }
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OR`" ]
        pub enum OrW {
            # [ doc = "No overrun." ]
            _0,
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            _1,
        }
        impl OrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OrW::_0 => 0,
                    OrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No overrun." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OrW::_0)
            }
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDLE`" ]
        pub enum IdleW {
            # [ doc = "No idle line detected." ]
            _0,
            # [ doc = "Idle line was detected." ]
            _1,
        }
        impl IdleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdleW::_0 => 0,
                    IdleW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No idle line detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IdleW::_0)
            }
            # [ doc = "Idle line was detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IdleW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDE`" ]
        pub enum LbkdeW {
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            _0,
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            _1,
        }
        impl LbkdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdeW::_0 => 0,
                    LbkdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdeW::_0)
            }
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BRK13`" ]
        pub enum Brk13W {
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            _0,
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            _1,
        }
        impl Brk13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Brk13W::_0 => 0,
                    Brk13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Brk13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Brk13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Brk13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Brk13W::_0)
            }
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Brk13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWUID`" ]
        pub enum RwuidW {
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            _0,
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            _1,
        }
        impl RwuidW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwuidW::_0 => 0,
                    RwuidW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwuidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwuidW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwuidW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwuidW::_0)
            }
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwuidW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXINV`" ]
        pub enum RxinvW {
            # [ doc = "Receive data not inverted." ]
            _0,
            # [ doc = "Receive data inverted." ]
            _1,
        }
        impl RxinvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxinvW::_0 => 0,
                    RxinvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxinvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxinvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxinvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive data not inverted." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxinvW::_0)
            }
            # [ doc = "Receive data inverted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxinvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MSBF`" ]
        pub enum MsbfW {
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            _0,
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            _1,
        }
        impl MsbfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MsbfW::_0 => 0,
                    MsbfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MsbfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MsbfW::_0)
            }
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MsbfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXEDGIF`" ]
        pub enum RxedgifW {
            # [ doc = "No active edge on the receive pin has occurred." ]
            _0,
            # [ doc = "An active edge on the receive pin has occurred." ]
            _1,
        }
        impl RxedgifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxedgifW::_0 => 0,
                    RxedgifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxedgifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxedgifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxedgifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No active edge on the receive pin has occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxedgifW::_0)
            }
            # [ doc = "An active edge on the receive pin has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxedgifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDIF`" ]
        pub enum LbkdifW {
            # [ doc = "No LIN break character has been detected." ]
            _0,
            # [ doc = "LIN break character has been detected." ]
            _1,
        }
        impl LbkdifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdifW::_0 => 0,
                    LbkdifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No LIN break character has been detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdifW::_0)
            }
            # [ doc = "LIN break character has been detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 14 - Match 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ma2f(&self) -> Ma2fR {
                Ma2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 15 - Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ma1f(&self) -> Ma1fR {
                Ma1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 15;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Parity Error Flag" ]
            # [ inline ( always ) ]
            pub fn pf(&self) -> PfR {
                PfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 17 - Framing Error Flag" ]
            # [ inline ( always ) ]
            pub fn fe(&self) -> FeR {
                FeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 17;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 18 - Noise Flag" ]
            # [ inline ( always ) ]
            pub fn nf(&self) -> NfR {
                NfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 19 - Receiver Overrun Flag" ]
            # [ inline ( always ) ]
            pub fn or(&self) -> OrR {
                OrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 19;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 20 - Idle Line Flag" ]
            # [ inline ( always ) ]
            pub fn idle(&self) -> IdleR {
                IdleR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Receive Data Register Full Flag" ]
            # [ inline ( always ) ]
            pub fn rdrf(&self) -> RdrfR {
                RdrfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Transmission Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tc(&self) -> TcR {
                TcR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 22;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 23 - Transmit Data Register Empty Flag" ]
            # [ inline ( always ) ]
            pub fn tdre(&self) -> TdreR {
                TdreR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 23;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Receiver Active Flag" ]
            # [ inline ( always ) ]
            pub fn raf(&self) -> RafR {
                RafR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - LIN Break Detection Enable" ]
            # [ inline ( always ) ]
            pub fn lbkde(&self) -> LbkdeR {
                LbkdeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Break Character Generation Length" ]
            # [ inline ( always ) ]
            pub fn brk13(&self) -> Brk13R {
                Brk13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 26;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 27 - Receive Wake Up Idle Detect" ]
            # [ inline ( always ) ]
            pub fn rwuid(&self) -> RwuidR {
                RwuidR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 27;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - Receive Data Inversion" ]
            # [ inline ( always ) ]
            pub fn rxinv(&self) -> RxinvR {
                RxinvR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - MSB First" ]
            # [ inline ( always ) ]
            pub fn msbf(&self) -> MsbfR {
                MsbfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - RXD Pin Active Edge Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rxedgif(&self) -> RxedgifR {
                RxedgifR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 30;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 31 - LIN Break Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn lbkdif(&self) -> LbkdifR {
                LbkdifR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12582912 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 14 - Match 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ma2f(&mut self) -> _Ma2fW {
                _Ma2fW { w: self }
            }
            # [ doc = "Bit 15 - Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ma1f(&mut self) -> _Ma1fW {
                _Ma1fW { w: self }
            }
            # [ doc = "Bit 16 - Parity Error Flag" ]
            # [ inline ( always ) ]
            pub fn pf(&mut self) -> _PfW {
                _PfW { w: self }
            }
            # [ doc = "Bit 17 - Framing Error Flag" ]
            # [ inline ( always ) ]
            pub fn fe(&mut self) -> _FeW {
                _FeW { w: self }
            }
            # [ doc = "Bit 18 - Noise Flag" ]
            # [ inline ( always ) ]
            pub fn nf(&mut self) -> _NfW {
                _NfW { w: self }
            }
            # [ doc = "Bit 19 - Receiver Overrun Flag" ]
            # [ inline ( always ) ]
            pub fn or(&mut self) -> _OrW {
                _OrW { w: self }
            }
            # [ doc = "Bit 20 - Idle Line Flag" ]
            # [ inline ( always ) ]
            pub fn idle(&mut self) -> _IdleW {
                _IdleW { w: self }
            }
            # [ doc = "Bit 25 - LIN Break Detection Enable" ]
            # [ inline ( always ) ]
            pub fn lbkde(&mut self) -> _LbkdeW {
                _LbkdeW { w: self }
            }
            # [ doc = "Bit 26 - Break Character Generation Length" ]
            # [ inline ( always ) ]
            pub fn brk13(&mut self) -> _Brk13W {
                _Brk13W { w: self }
            }
            # [ doc = "Bit 27 - Receive Wake Up Idle Detect" ]
            # [ inline ( always ) ]
            pub fn rwuid(&mut self) -> _RwuidW {
                _RwuidW { w: self }
            }
            # [ doc = "Bit 28 - Receive Data Inversion" ]
            # [ inline ( always ) ]
            pub fn rxinv(&mut self) -> _RxinvW {
                _RxinvW { w: self }
            }
            # [ doc = "Bit 29 - MSB First" ]
            # [ inline ( always ) ]
            pub fn msbf(&mut self) -> _MsbfW {
                _MsbfW { w: self }
            }
            # [ doc = "Bit 30 - RXD Pin Active Edge Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rxedgif(&mut self) -> _RxedgifW {
                _RxedgifW { w: self }
            }
            # [ doc = "Bit 31 - LIN Break Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn lbkdif(&mut self) -> _LbkdifW {
                _LbkdifW { w: self }
            }
        }
    }
    # [ doc = "LPUART Control Register" ]
    pub struct Ctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Control Register" ]
    pub mod ctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PtR {
            # [ doc = "Even parity." ]
            _0,
            # [ doc = "Odd parity." ]
            _1,
        }
        impl PtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PtR::_0 => 0,
                    PtR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PtR {
                match bits {
                    0 => PtR::_0,
                    1 => PtR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PtR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PtR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "No hardware parity generation or checking." ]
            _0,
            # [ doc = "Parity enabled." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `ILT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IltR {
            # [ doc = "Idle character bit count starts after start bit." ]
            _0,
            # [ doc = "Idle character bit count starts after stop bit." ]
            _1,
        }
        impl IltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IltR::_0 => 0,
                    IltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IltR {
                match bits {
                    0 => IltR::_0,
                    1 => IltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IltR::_1
            }
        }
        # [ doc = "Possible values of the field `WAKE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WakeR {
            # [ doc = "Configures RWU for idle-line wakeup." ]
            _0,
            # [ doc = "Configures RWU with address-mark wakeup." ]
            _1,
        }
        impl WakeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WakeR::_0 => 0,
                    WakeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WakeR {
                match bits {
                    0 => WakeR::_0,
                    1 => WakeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WakeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WakeR::_1
            }
        }
        # [ doc = "Possible values of the field `M`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MR {
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            _1,
        }
        impl MR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MR::_0 => 0,
                    MR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MR {
                match bits {
                    0 => MR::_0,
                    1 => MR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MR::_1
            }
        }
        # [ doc = "Possible values of the field `RSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RsrcR {
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            _0,
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            _1,
        }
        impl RsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RsrcR::_0 => 0,
                    RsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RsrcR {
                match bits {
                    0 => RsrcR::_0,
                    1 => RsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozeenR {
            # [ doc = "LPUART is enabled in Doze mode." ]
            _0,
            # [ doc = "LPUART is disabled in Doze mode." ]
            _1,
        }
        impl DozeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozeenR::_0 => 0,
                    DozeenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozeenR {
                match bits {
                    0 => DozeenR::_0,
                    1 => DozeenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozeenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozeenR::_1
            }
        }
        # [ doc = "Possible values of the field `LOOPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LoopsR {
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            _0,
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            _1,
        }
        impl LoopsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LoopsR::_0 => 0,
                    LoopsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LoopsR {
                match bits {
                    0 => LoopsR::_0,
                    1 => LoopsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LoopsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LoopsR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLECFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdlecfgR {
            # [ doc = "1 idle character" ]
            _000,
            # [ doc = "2 idle characters" ]
            _001,
            # [ doc = "4 idle characters" ]
            _010,
            # [ doc = "8 idle characters" ]
            _011,
            # [ doc = "16 idle characters" ]
            _100,
            # [ doc = "32 idle characters" ]
            _101,
            # [ doc = "64 idle characters" ]
            _110,
            # [ doc = "128 idle characters" ]
            _111,
        }
        impl IdlecfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdlecfgR::_000 => 0,
                    IdlecfgR::_001 => 1,
                    IdlecfgR::_010 => 2,
                    IdlecfgR::_011 => 3,
                    IdlecfgR::_100 => 4,
                    IdlecfgR::_101 => 5,
                    IdlecfgR::_110 => 6,
                    IdlecfgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdlecfgR {
                match bits {
                    0 => IdlecfgR::_000,
                    1 => IdlecfgR::_001,
                    2 => IdlecfgR::_010,
                    3 => IdlecfgR::_011,
                    4 => IdlecfgR::_100,
                    5 => IdlecfgR::_101,
                    6 => IdlecfgR::_110,
                    7 => IdlecfgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == IdlecfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == IdlecfgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == IdlecfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == IdlecfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == IdlecfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == IdlecfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == IdlecfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == IdlecfgR::_111
            }
        }
        # [ doc = "Possible values of the field `M7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum M7R {
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            _1,
        }
        impl M7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    M7R::_0 => 0,
                    M7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> M7R {
                match bits {
                    0 => M7R::_0,
                    1 => M7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == M7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == M7R::_1
            }
        }
        # [ doc = "Possible values of the field `MA2IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma2ieR {
            # [ doc = "MA2F interrupt disabled" ]
            _0,
            # [ doc = "MA2F interrupt enabled" ]
            _1,
        }
        impl Ma2ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma2ieR::_0 => 0,
                    Ma2ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma2ieR {
                match bits {
                    0 => Ma2ieR::_0,
                    1 => Ma2ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma2ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma2ieR::_1
            }
        }
        # [ doc = "Possible values of the field `MA1IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma1ieR {
            # [ doc = "MA1F interrupt disabled" ]
            _0,
            # [ doc = "MA1F interrupt enabled" ]
            _1,
        }
        impl Ma1ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma1ieR::_0 => 0,
                    Ma1ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma1ieR {
                match bits {
                    0 => Ma1ieR::_0,
                    1 => Ma1ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma1ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma1ieR::_1
            }
        }
        # [ doc = "Possible values of the field `SBK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbkR {
            # [ doc = "Normal transmitter operation." ]
            _0,
            # [ doc = "Queue break character(s) to be sent." ]
            _1,
        }
        impl SbkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbkR::_0 => 0,
                    SbkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbkR {
                match bits {
                    0 => SbkR::_0,
                    1 => SbkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbkR::_1
            }
        }
        # [ doc = "Possible values of the field `RWU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwuR {
            # [ doc = "Normal receiver operation." ]
            _0,
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            _1,
        }
        impl RwuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwuR::_0 => 0,
                    RwuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwuR {
                match bits {
                    0 => RwuR::_0,
                    1 => RwuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwuR::_1
            }
        }
        # [ doc = "Possible values of the field `RE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReR {
            # [ doc = "Receiver disabled." ]
            _0,
            # [ doc = "Receiver enabled." ]
            _1,
        }
        impl ReR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReR::_0 => 0,
                    ReR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReR {
                match bits {
                    0 => ReR::_0,
                    1 => ReR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReR::_1
            }
        }
        # [ doc = "Possible values of the field `TE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TeR {
            # [ doc = "Transmitter disabled." ]
            _0,
            # [ doc = "Transmitter enabled." ]
            _1,
        }
        impl TeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TeR::_0 => 0,
                    TeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TeR {
                match bits {
                    0 => TeR::_0,
                    1 => TeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TeR::_1
            }
        }
        # [ doc = "Possible values of the field `ILIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IlieR {
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            _1,
        }
        impl IlieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IlieR::_0 => 0,
                    IlieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IlieR {
                match bits {
                    0 => IlieR::_0,
                    1 => IlieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IlieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IlieR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcieR {
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            _1,
        }
        impl TcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcieR::_0 => 0,
                    TcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcieR {
                match bits {
                    0 => TcieR::_0,
                    1 => TcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TieR {
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            _1,
        }
        impl TieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TieR::_0 => 0,
                    TieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TieR {
                match bits {
                    0 => TieR::_0,
                    1 => TieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TieR::_1
            }
        }
        # [ doc = "Possible values of the field `PEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeieR {
            # [ doc = "PF interrupts disabled; use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when PF is set." ]
            _1,
        }
        impl PeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeieR::_0 => 0,
                    PeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeieR {
                match bits {
                    0 => PeieR::_0,
                    1 => PeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeieR::_1
            }
        }
        # [ doc = "Possible values of the field `FEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeieR {
            # [ doc = "FE interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when FE is set." ]
            _1,
        }
        impl FeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeieR::_0 => 0,
                    FeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeieR {
                match bits {
                    0 => FeieR::_0,
                    1 => FeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeieR::_1
            }
        }
        # [ doc = "Possible values of the field `NEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NeieR {
            # [ doc = "NF interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when NF is set." ]
            _1,
        }
        impl NeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NeieR::_0 => 0,
                    NeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NeieR {
                match bits {
                    0 => NeieR::_0,
                    1 => NeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NeieR::_1
            }
        }
        # [ doc = "Possible values of the field `ORIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OrieR {
            # [ doc = "OR interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when OR is set." ]
            _1,
        }
        impl OrieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OrieR::_0 => 0,
                    OrieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OrieR {
                match bits {
                    0 => OrieR::_0,
                    1 => OrieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OrieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OrieR::_1
            }
        }
        # [ doc = "Possible values of the field `TXINV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxinvR {
            # [ doc = "Transmit data not inverted." ]
            _0,
            # [ doc = "Transmit data inverted." ]
            _1,
        }
        impl TxinvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxinvR::_0 => 0,
                    TxinvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxinvR {
                match bits {
                    0 => TxinvR::_0,
                    1 => TxinvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxinvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxinvR::_1
            }
        }
        # [ doc = "Possible values of the field `TXDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxdirR {
            # [ doc = "TXD pin is an input in single-wire mode." ]
            _0,
            # [ doc = "TXD pin is an output in single-wire mode." ]
            _1,
        }
        impl TxdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxdirR::_0 => 0,
                    TxdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxdirR {
                match bits {
                    0 => TxdirR::_0,
                    1 => TxdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxdirR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R9t8R {
            bits: u8,
        }
        impl R9t8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R8t9R {
            bits: u8,
        }
        impl R8t9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `PT`" ]
        pub enum PtW {
            # [ doc = "Even parity." ]
            _0,
            # [ doc = "Odd parity." ]
            _1,
        }
        impl PtW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PtW::_0 => 0,
                    PtW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PtW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Even parity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PtW::_0)
            }
            # [ doc = "Odd parity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PtW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "No hardware parity generation or checking." ]
            _0,
            # [ doc = "Parity enabled." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No hardware parity generation or checking." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Parity enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ILT`" ]
        pub enum IltW {
            # [ doc = "Idle character bit count starts after start bit." ]
            _0,
            # [ doc = "Idle character bit count starts after stop bit." ]
            _1,
        }
        impl IltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IltW::_0 => 0,
                    IltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Idle character bit count starts after start bit." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IltW::_0)
            }
            # [ doc = "Idle character bit count starts after stop bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WAKE`" ]
        pub enum WakeW {
            # [ doc = "Configures RWU for idle-line wakeup." ]
            _0,
            # [ doc = "Configures RWU with address-mark wakeup." ]
            _1,
        }
        impl WakeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WakeW::_0 => 0,
                    WakeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WakeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WakeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WakeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configures RWU for idle-line wakeup." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WakeW::_0)
            }
            # [ doc = "Configures RWU with address-mark wakeup." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WakeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M`" ]
        pub enum MW {
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            _1,
        }
        impl MW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MW::_0 => 0,
                    MW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MW::_0)
            }
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RSRC`" ]
        pub enum RsrcW {
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            _0,
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            _1,
        }
        impl RsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RsrcW::_0 => 0,
                    RsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RsrcW::_0)
            }
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEEN`" ]
        pub enum DozeenW {
            # [ doc = "LPUART is enabled in Doze mode." ]
            _0,
            # [ doc = "LPUART is disabled in Doze mode." ]
            _1,
        }
        impl DozeenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozeenW::_0 => 0,
                    DozeenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozeenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozeenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LPUART is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozeenW::_0)
            }
            # [ doc = "LPUART is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozeenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOOPS`" ]
        pub enum LoopsW {
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            _0,
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            _1,
        }
        impl LoopsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LoopsW::_0 => 0,
                    LoopsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LoopsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LoopsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LoopsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LoopsW::_0)
            }
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LoopsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDLECFG`" ]
        pub enum IdlecfgW {
            # [ doc = "1 idle character" ]
            _000,
            # [ doc = "2 idle characters" ]
            _001,
            # [ doc = "4 idle characters" ]
            _010,
            # [ doc = "8 idle characters" ]
            _011,
            # [ doc = "16 idle characters" ]
            _100,
            # [ doc = "32 idle characters" ]
            _101,
            # [ doc = "64 idle characters" ]
            _110,
            # [ doc = "128 idle characters" ]
            _111,
        }
        impl IdlecfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdlecfgW::_000 => 0,
                    IdlecfgW::_001 => 1,
                    IdlecfgW::_010 => 2,
                    IdlecfgW::_011 => 3,
                    IdlecfgW::_100 => 4,
                    IdlecfgW::_101 => 5,
                    IdlecfgW::_110 => 6,
                    IdlecfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdlecfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdlecfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdlecfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1 idle character" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(IdlecfgW::_000)
            }
            # [ doc = "2 idle characters" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(IdlecfgW::_001)
            }
            # [ doc = "4 idle characters" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(IdlecfgW::_010)
            }
            # [ doc = "8 idle characters" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(IdlecfgW::_011)
            }
            # [ doc = "16 idle characters" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(IdlecfgW::_100)
            }
            # [ doc = "32 idle characters" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(IdlecfgW::_101)
            }
            # [ doc = "64 idle characters" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(IdlecfgW::_110)
            }
            # [ doc = "128 idle characters" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(IdlecfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M7`" ]
        pub enum M7W {
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            _1,
        }
        impl M7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    M7W::_0 => 0,
                    M7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _M7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _M7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: M7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(M7W::_0)
            }
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(M7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA2IE`" ]
        pub enum Ma2ieW {
            # [ doc = "MA2F interrupt disabled" ]
            _0,
            # [ doc = "MA2F interrupt enabled" ]
            _1,
        }
        impl Ma2ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma2ieW::_0 => 0,
                    Ma2ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma2ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "MA2F interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma2ieW::_0)
            }
            # [ doc = "MA2F interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma2ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA1IE`" ]
        pub enum Ma1ieW {
            # [ doc = "MA1F interrupt disabled" ]
            _0,
            # [ doc = "MA1F interrupt enabled" ]
            _1,
        }
        impl Ma1ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma1ieW::_0 => 0,
                    Ma1ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma1ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "MA1F interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma1ieW::_0)
            }
            # [ doc = "MA1F interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma1ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBK`" ]
        pub enum SbkW {
            # [ doc = "Normal transmitter operation." ]
            _0,
            # [ doc = "Queue break character(s) to be sent." ]
            _1,
        }
        impl SbkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SbkW::_0 => 0,
                    SbkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SbkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transmitter operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SbkW::_0)
            }
            # [ doc = "Queue break character(s) to be sent." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SbkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWU`" ]
        pub enum RwuW {
            # [ doc = "Normal receiver operation." ]
            _0,
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            _1,
        }
        impl RwuW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwuW::_0 => 0,
                    RwuW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwuW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwuW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal receiver operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwuW::_0)
            }
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwuW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RE`" ]
        pub enum ReW {
            # [ doc = "Receiver disabled." ]
            _0,
            # [ doc = "Receiver enabled." ]
            _1,
        }
        impl ReW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReW::_0 => 0,
                    ReW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReW::_0)
            }
            # [ doc = "Receiver enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TE`" ]
        pub enum TeW {
            # [ doc = "Transmitter disabled." ]
            _0,
            # [ doc = "Transmitter enabled." ]
            _1,
        }
        impl TeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TeW::_0 => 0,
                    TeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmitter disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TeW::_0)
            }
            # [ doc = "Transmitter enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ILIE`" ]
        pub enum IlieW {
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            _1,
        }
        impl IlieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IlieW::_0 => 0,
                    IlieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IlieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IlieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IlieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IlieW::_0)
            }
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IlieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCIE`" ]
        pub enum TcieW {
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            _1,
        }
        impl TcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcieW::_0 => 0,
                    TcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcieW::_0)
            }
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE`" ]
        pub enum TieW {
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            _1,
        }
        impl TieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TieW::_0 => 0,
                    TieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TieW::_0)
            }
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PEIE`" ]
        pub enum PeieW {
            # [ doc = "PF interrupts disabled; use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when PF is set." ]
            _1,
        }
        impl PeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeieW::_0 => 0,
                    PeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PF interrupts disabled; use polling)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when PF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEIE`" ]
        pub enum FeieW {
            # [ doc = "FE interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when FE is set." ]
            _1,
        }
        impl FeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeieW::_0 => 0,
                    FeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FE interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when FE is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NEIE`" ]
        pub enum NeieW {
            # [ doc = "NF interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when NF is set." ]
            _1,
        }
        impl NeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NeieW::_0 => 0,
                    NeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "NF interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when NF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ORIE`" ]
        pub enum OrieW {
            # [ doc = "OR interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when OR is set." ]
            _1,
        }
        impl OrieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OrieW::_0 => 0,
                    OrieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OrieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OrieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OrieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OR interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OrieW::_0)
            }
            # [ doc = "Hardware interrupt requested when OR is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OrieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXINV`" ]
        pub enum TxinvW {
            # [ doc = "Transmit data not inverted." ]
            _0,
            # [ doc = "Transmit data inverted." ]
            _1,
        }
        impl TxinvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxinvW::_0 => 0,
                    TxinvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxinvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxinvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxinvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit data not inverted." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxinvW::_0)
            }
            # [ doc = "Transmit data inverted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxinvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXDIR`" ]
        pub enum TxdirW {
            # [ doc = "TXD pin is an input in single-wire mode." ]
            _0,
            # [ doc = "TXD pin is an output in single-wire mode." ]
            _1,
        }
        impl TxdirW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxdirW::_0 => 0,
                    TxdirW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxdirW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxdirW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxdirW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TXD pin is an input in single-wire mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxdirW::_0)
            }
            # [ doc = "TXD pin is an output in single-wire mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxdirW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9t8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9t8W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8t9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8t9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Parity Type" ]
            # [ inline ( always ) ]
            pub fn pt(&self) -> PtR {
                PtR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Parity Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 2 - Idle Line Type Select" ]
            # [ inline ( always ) ]
            pub fn ilt(&self) -> IltR {
                IltR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Receiver Wakeup Method Select" ]
            # [ inline ( always ) ]
            pub fn wake(&self) -> WakeR {
                WakeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - 9-Bit or 8-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m(&self) -> MR {
                MR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 4;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
            # [ doc = "Bit 5 - Receiver Source Select" ]
            # [ inline ( always ) ]
            pub fn rsrc(&self) -> RsrcR {
                RsrcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozeen(&self) -> DozeenR {
                DozeenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Loop Mode Select" ]
            # [ inline ( always ) ]
            pub fn loops(&self) -> LoopsR {
                LoopsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Idle Configuration" ]
            # [ inline ( always ) ]
            pub fn idlecfg(&self) -> IdlecfgR {
                IdlecfgR::_from({
                                    const MASK: u8 = 7;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - 7-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m7(&self) -> M7R {
                M7R::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 11;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 14 - Match 2 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma2ie(&self) -> Ma2ieR {
                Ma2ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma1ie(&self) -> Ma1ieR {
                Ma1ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - Send Break" ]
            # [ inline ( always ) ]
            pub fn sbk(&self) -> SbkR {
                SbkR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Receiver Wakeup Control" ]
            # [ inline ( always ) ]
            pub fn rwu(&self) -> RwuR {
                RwuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Receiver Enable" ]
            # [ inline ( always ) ]
            pub fn re(&self) -> ReR {
                ReR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 19 - Transmitter Enable" ]
            # [ inline ( always ) ]
            pub fn te(&self) -> TeR {
                TeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 19;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 20 - Idle Line Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ilie(&self) -> IlieR {
                IlieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Receiver Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Transmission Complete Interrupt Enable for" ]
            # [ inline ( always ) ]
            pub fn tcie(&self) -> TcieR {
                TcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Transmit Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&self) -> TieR {
                TieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 23;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Parity Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn peie(&self) -> PeieR {
                PeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 25 - Framing Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&self) -> FeieR {
                FeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 25;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 26 - Noise Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn neie(&self) -> NeieR {
                NeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 26;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 27 - Overrun Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn orie(&self) -> OrieR {
                OrieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 27;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - Transmit Data Inversion" ]
            # [ inline ( always ) ]
            pub fn txinv(&self) -> TxinvR {
                TxinvR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - TXD Pin Direction in Single-Wire Mode" ]
            # [ inline ( always ) ]
            pub fn txdir(&self) -> TxdirR {
                TxdirR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 29;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 30 - Receive Bit 9 / Transmit Bit 8" ]
            # [ inline ( always ) ]
            pub fn r9t8(&self) -> R9t8R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R9t8R { bits }
            }
            # [ doc = "Bit 31 - Receive Bit 8 / Transmit Bit 9" ]
            # [ inline ( always ) ]
            pub fn r8t9(&self) -> R8t9R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R8t9R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Parity Type" ]
            # [ inline ( always ) ]
            pub fn pt(&mut self) -> _PtW {
                _PtW { w: self }
            }
            # [ doc = "Bit 1 - Parity Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 2 - Idle Line Type Select" ]
            # [ inline ( always ) ]
            pub fn ilt(&mut self) -> _IltW {
                _IltW { w: self }
            }
            # [ doc = "Bit 3 - Receiver Wakeup Method Select" ]
            # [ inline ( always ) ]
            pub fn wake(&mut self) -> _WakeW {
                _WakeW { w: self }
            }
            # [ doc = "Bit 4 - 9-Bit or 8-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m(&mut self) -> _MW {
                _MW { w: self }
            }
            # [ doc = "Bit 5 - Receiver Source Select" ]
            # [ inline ( always ) ]
            pub fn rsrc(&mut self) -> _RsrcW {
                _RsrcW { w: self }
            }
            # [ doc = "Bit 6 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozeen(&mut self) -> _DozeenW {
                _DozeenW { w: self }
            }
            # [ doc = "Bit 7 - Loop Mode Select" ]
            # [ inline ( always ) ]
            pub fn loops(&mut self) -> _LoopsW {
                _LoopsW { w: self }
            }
            # [ doc = "Bits 8:10 - Idle Configuration" ]
            # [ inline ( always ) ]
            pub fn idlecfg(&mut self) -> _IdlecfgW {
                _IdlecfgW { w: self }
            }
            # [ doc = "Bit 11 - 7-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m7(&mut self) -> _M7W {
                _M7W { w: self }
            }
            # [ doc = "Bit 14 - Match 2 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma2ie(&mut self) -> _Ma2ieW {
                _Ma2ieW { w: self }
            }
            # [ doc = "Bit 15 - Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma1ie(&mut self) -> _Ma1ieW {
                _Ma1ieW { w: self }
            }
            # [ doc = "Bit 16 - Send Break" ]
            # [ inline ( always ) ]
            pub fn sbk(&mut self) -> _SbkW {
                _SbkW { w: self }
            }
            # [ doc = "Bit 17 - Receiver Wakeup Control" ]
            # [ inline ( always ) ]
            pub fn rwu(&mut self) -> _RwuW {
                _RwuW { w: self }
            }
            # [ doc = "Bit 18 - Receiver Enable" ]
            # [ inline ( always ) ]
            pub fn re(&mut self) -> _ReW {
                _ReW { w: self }
            }
            # [ doc = "Bit 19 - Transmitter Enable" ]
            # [ inline ( always ) ]
            pub fn te(&mut self) -> _TeW {
                _TeW { w: self }
            }
            # [ doc = "Bit 20 - Idle Line Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ilie(&mut self) -> _IlieW {
                _IlieW { w: self }
            }
            # [ doc = "Bit 21 - Receiver Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 22 - Transmission Complete Interrupt Enable for" ]
            # [ inline ( always ) ]
            pub fn tcie(&mut self) -> _TcieW {
                _TcieW { w: self }
            }
            # [ doc = "Bit 23 - Transmit Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&mut self) -> _TieW {
                _TieW { w: self }
            }
            # [ doc = "Bit 24 - Parity Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn peie(&mut self) -> _PeieW {
                _PeieW { w: self }
            }
            # [ doc = "Bit 25 - Framing Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&mut self) -> _FeieW {
                _FeieW { w: self }
            }
            # [ doc = "Bit 26 - Noise Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn neie(&mut self) -> _NeieW {
                _NeieW { w: self }
            }
            # [ doc = "Bit 27 - Overrun Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn orie(&mut self) -> _OrieW {
                _OrieW { w: self }
            }
            # [ doc = "Bit 28 - Transmit Data Inversion" ]
            # [ inline ( always ) ]
            pub fn txinv(&mut self) -> _TxinvW {
                _TxinvW { w: self }
            }
            # [ doc = "Bit 29 - TXD Pin Direction in Single-Wire Mode" ]
            # [ inline ( always ) ]
            pub fn txdir(&mut self) -> _TxdirW {
                _TxdirW { w: self }
            }
            # [ doc = "Bit 30 - Receive Bit 9 / Transmit Bit 8" ]
            # [ inline ( always ) ]
            pub fn r9t8(&mut self) -> _R9t8W {
                _R9t8W { w: self }
            }
            # [ doc = "Bit 31 - Receive Bit 8 / Transmit Bit 9" ]
            # [ inline ( always ) ]
            pub fn r8t9(&mut self) -> _R8t9W {
                _R8t9W { w: self }
            }
        }
    }
    # [ doc = "LPUART Data Register" ]
    pub struct Data {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Data Register" ]
    pub mod data {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Data {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R0t0R {
            bits: u8,
        }
        impl R0t0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R1t1R {
            bits: u8,
        }
        impl R1t1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R2t2R {
            bits: u8,
        }
        impl R2t2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R3t3R {
            bits: u8,
        }
        impl R3t3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R4t4R {
            bits: u8,
        }
        impl R4t4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R5t5R {
            bits: u8,
        }
        impl R5t5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R6t6R {
            bits: u8,
        }
        impl R6t6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R7t7R {
            bits: u8,
        }
        impl R7t7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R8t8R {
            bits: u8,
        }
        impl R8t8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R9t9R {
            bits: u8,
        }
        impl R9t9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `IDLINE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdlineR {
            # [ doc = "Receiver was not idle before receiving this character." ]
            _0,
            # [ doc = "Receiver was idle before receiving this character." ]
            _1,
        }
        impl IdlineR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdlineR::_0 => 0,
                    IdlineR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdlineR {
                match bits {
                    0 => IdlineR::_0,
                    1 => IdlineR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdlineR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdlineR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptR {
            # [ doc = "Receive buffer contains valid data." ]
            _0,
            # [ doc = "Receive buffer is empty, data returned on read is not valid." ]
            _1,
        }
        impl RxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptR::_0 => 0,
                    RxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptR {
                match bits {
                    0 => RxemptR::_0,
                    1 => RxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptR::_1
            }
        }
        # [ doc = "Possible values of the field `FRETSC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FretscR {
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            _0,
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            _1,
        }
        impl FretscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FretscR::_0 => 0,
                    FretscR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FretscR {
                match bits {
                    0 => FretscR::_0,
                    1 => FretscR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FretscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FretscR::_1
            }
        }
        # [ doc = "Possible values of the field `PARITYE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ParityeR {
            # [ doc = "The dataword was received without a parity error." ]
            _0,
            # [ doc = "The dataword was received with a parity error." ]
            _1,
        }
        impl ParityeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ParityeR::_0 => 0,
                    ParityeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ParityeR {
                match bits {
                    0 => ParityeR::_0,
                    1 => ParityeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ParityeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ParityeR::_1
            }
        }
        # [ doc = "Possible values of the field `NOISY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NoisyR {
            # [ doc = "The dataword was received without noise." ]
            _0,
            # [ doc = "The data was received with noise." ]
            _1,
        }
        impl NoisyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NoisyR::_0 => 0,
                    NoisyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NoisyR {
                match bits {
                    0 => NoisyR::_0,
                    1 => NoisyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NoisyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NoisyR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R0t0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R0t0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R1t1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R1t1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R2t2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R2t2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R3t3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R3t3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R4t4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R4t4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R5t5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R5t5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R6t6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R6t6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R7t7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R7t7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8t8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8t8W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9t9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9t9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRETSC`" ]
        pub enum FretscW {
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            _0,
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            _1,
        }
        impl FretscW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FretscW::_0 => 0,
                    FretscW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FretscW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FretscW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FretscW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FretscW::_0)
            }
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FretscW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - R0T0" ]
            # [ inline ( always ) ]
            pub fn r0t0(&self) -> R0t0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R0t0R { bits }
            }
            # [ doc = "Bit 1 - R1T1" ]
            # [ inline ( always ) ]
            pub fn r1t1(&self) -> R1t1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R1t1R { bits }
            }
            # [ doc = "Bit 2 - R2T2" ]
            # [ inline ( always ) ]
            pub fn r2t2(&self) -> R2t2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R2t2R { bits }
            }
            # [ doc = "Bit 3 - R3T3" ]
            # [ inline ( always ) ]
            pub fn r3t3(&self) -> R3t3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R3t3R { bits }
            }
            # [ doc = "Bit 4 - R4T4" ]
            # [ inline ( always ) ]
            pub fn r4t4(&self) -> R4t4R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R4t4R { bits }
            }
            # [ doc = "Bit 5 - R5T5" ]
            # [ inline ( always ) ]
            pub fn r5t5(&self) -> R5t5R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R5t5R { bits }
            }
            # [ doc = "Bit 6 - R6T6" ]
            # [ inline ( always ) ]
            pub fn r6t6(&self) -> R6t6R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R6t6R { bits }
            }
            # [ doc = "Bit 7 - R7T7" ]
            # [ inline ( always ) ]
            pub fn r7t7(&self) -> R7t7R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R7t7R { bits }
            }
            # [ doc = "Bit 8 - R8T8" ]
            # [ inline ( always ) ]
            pub fn r8t8(&self) -> R8t8R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R8t8R { bits }
            }
            # [ doc = "Bit 9 - R9T9" ]
            # [ inline ( always ) ]
            pub fn r9t9(&self) -> R9t9R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R9t9R { bits }
            }
            # [ doc = "Bit 11 - Idle Line" ]
            # [ inline ( always ) ]
            pub fn idline(&self) -> IdlineR {
                IdlineR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Receive Buffer Empty" ]
            # [ inline ( always ) ]
            pub fn rxempt(&self) -> RxemptR {
                RxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Frame Error / Transmit Special Character" ]
            # [ inline ( always ) ]
            pub fn fretsc(&self) -> FretscR {
                FretscR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - PARITYE" ]
            # [ inline ( always ) ]
            pub fn paritye(&self) -> ParityeR {
                ParityeR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - NOISY" ]
            # [ inline ( always ) ]
            pub fn noisy(&self) -> NoisyR {
                NoisyR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4096 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - R0T0" ]
            # [ inline ( always ) ]
            pub fn r0t0(&mut self) -> _R0t0W {
                _R0t0W { w: self }
            }
            # [ doc = "Bit 1 - R1T1" ]
            # [ inline ( always ) ]
            pub fn r1t1(&mut self) -> _R1t1W {
                _R1t1W { w: self }
            }
            # [ doc = "Bit 2 - R2T2" ]
            # [ inline ( always ) ]
            pub fn r2t2(&mut self) -> _R2t2W {
                _R2t2W { w: self }
            }
            # [ doc = "Bit 3 - R3T3" ]
            # [ inline ( always ) ]
            pub fn r3t3(&mut self) -> _R3t3W {
                _R3t3W { w: self }
            }
            # [ doc = "Bit 4 - R4T4" ]
            # [ inline ( always ) ]
            pub fn r4t4(&mut self) -> _R4t4W {
                _R4t4W { w: self }
            }
            # [ doc = "Bit 5 - R5T5" ]
            # [ inline ( always ) ]
            pub fn r5t5(&mut self) -> _R5t5W {
                _R5t5W { w: self }
            }
            # [ doc = "Bit 6 - R6T6" ]
            # [ inline ( always ) ]
            pub fn r6t6(&mut self) -> _R6t6W {
                _R6t6W { w: self }
            }
            # [ doc = "Bit 7 - R7T7" ]
            # [ inline ( always ) ]
            pub fn r7t7(&mut self) -> _R7t7W {
                _R7t7W { w: self }
            }
            # [ doc = "Bit 8 - R8T8" ]
            # [ inline ( always ) ]
            pub fn r8t8(&mut self) -> _R8t8W {
                _R8t8W { w: self }
            }
            # [ doc = "Bit 9 - R9T9" ]
            # [ inline ( always ) ]
            pub fn r9t9(&mut self) -> _R9t9W {
                _R9t9W { w: self }
            }
            # [ doc = "Bit 13 - Frame Error / Transmit Special Character" ]
            # [ inline ( always ) ]
            pub fn fretsc(&mut self) -> _FretscW {
                _FretscW { w: self }
            }
        }
    }
    # [ doc = "LPUART Match Address Register" ]
    pub struct Match {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Match Address Register" ]
    pub mod match_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Match {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ma1R {
            bits: u16,
        }
        impl Ma1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ma2R {
            bits: u16,
        }
        impl Ma2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Match Address 1" ]
            # [ inline ( always ) ]
            pub fn ma1(&self) -> Ma1R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Ma1R { bits }
            }
            # [ doc = "Bits 16:25 - Match Address 2" ]
            # [ inline ( always ) ]
            pub fn ma2(&self) -> Ma2R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Ma2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Match Address 1" ]
            # [ inline ( always ) ]
            pub fn ma1(&mut self) -> _Ma1W {
                _Ma1W { w: self }
            }
            # [ doc = "Bits 16:25 - Match Address 2" ]
            # [ inline ( always ) ]
            pub fn ma2(&mut self) -> _Ma2W {
                _Ma2W { w: self }
            }
        }
    }
    # [ doc = "LPUART Modem IrDA Register" ]
    pub struct Modir {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Modem IrDA Register" ]
    pub mod modir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Modir {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TXCTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctseR {
            # [ doc = "CTS has no effect on the transmitter." ]
            _0,
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            _1,
        }
        impl TxctseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctseR::_0 => 0,
                    TxctseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctseR {
                match bits {
                    0 => TxctseR::_0,
                    1 => TxctseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctseR::_1
            }
        }
        # [ doc = "Possible values of the field `TXRTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxrtseR {
            # [ doc = "The transmitter has no effect on RTS." ]
            _0,
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            _1,
        }
        impl TxrtseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxrtseR::_0 => 0,
                    TxrtseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxrtseR {
                match bits {
                    0 => TxrtseR::_0,
                    1 => TxrtseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxrtseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxrtseR::_1
            }
        }
        # [ doc = "Possible values of the field `TXRTSPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxrtspolR {
            # [ doc = "Transmitter RTS is active low." ]
            _0,
            # [ doc = "Transmitter RTS is active high." ]
            _1,
        }
        impl TxrtspolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxrtspolR::_0 => 0,
                    TxrtspolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxrtspolR {
                match bits {
                    0 => TxrtspolR::_0,
                    1 => TxrtspolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxrtspolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxrtspolR::_1
            }
        }
        # [ doc = "Possible values of the field `RXRTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxrtseR {
            # [ doc = "The receiver has no effect on RTS." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RxrtseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxrtseR::_0 => 0,
                    RxrtseR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxrtseR {
                match bits {
                    0 => RxrtseR::_0,
                    i => RxrtseR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxrtseR::_0
            }
        }
        # [ doc = "Possible values of the field `TXCTSC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctscR {
            # [ doc = "CTS input is sampled at the start of each character." ]
            _0,
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            _1,
        }
        impl TxctscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctscR::_0 => 0,
                    TxctscR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctscR {
                match bits {
                    0 => TxctscR::_0,
                    1 => TxctscR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctscR::_1
            }
        }
        # [ doc = "Possible values of the field `TXCTSSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctssrcR {
            # [ doc = "CTS input is the CTS_B pin." ]
            _0,
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            _1,
        }
        impl TxctssrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctssrcR::_0 => 0,
                    TxctssrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctssrcR {
                match bits {
                    0 => TxctssrcR::_0,
                    1 => TxctssrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctssrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctssrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RtswaterR {
            bits: u8,
        }
        impl RtswaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TNP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TnpR {
            # [ doc = "1/OSR." ]
            _00,
            # [ doc = "2/OSR." ]
            _01,
            # [ doc = "3/OSR." ]
            _10,
            # [ doc = "4/OSR." ]
            _11,
        }
        impl TnpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TnpR::_00 => 0,
                    TnpR::_01 => 1,
                    TnpR::_10 => 2,
                    TnpR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TnpR {
                match bits {
                    0 => TnpR::_00,
                    1 => TnpR::_01,
                    2 => TnpR::_10,
                    3 => TnpR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TnpR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TnpR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TnpR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TnpR::_11
            }
        }
        # [ doc = "Possible values of the field `IREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrenR {
            # [ doc = "IR disabled." ]
            _0,
            # [ doc = "IR enabled." ]
            _1,
        }
        impl IrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrenR::_0 => 0,
                    IrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrenR {
                match bits {
                    0 => IrenR::_0,
                    1 => IrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSE`" ]
        pub enum TxctseW {
            # [ doc = "CTS has no effect on the transmitter." ]
            _0,
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            _1,
        }
        impl TxctseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctseW::_0 => 0,
                    TxctseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS has no effect on the transmitter." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctseW::_0)
            }
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXRTSE`" ]
        pub enum TxrtseW {
            # [ doc = "The transmitter has no effect on RTS." ]
            _0,
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            _1,
        }
        impl TxrtseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxrtseW::_0 => 0,
                    TxrtseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxrtseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxrtseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxrtseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The transmitter has no effect on RTS." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxrtseW::_0)
            }
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxrtseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXRTSPOL`" ]
        pub enum TxrtspolW {
            # [ doc = "Transmitter RTS is active low." ]
            _0,
            # [ doc = "Transmitter RTS is active high." ]
            _1,
        }
        impl TxrtspolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxrtspolW::_0 => 0,
                    TxrtspolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxrtspolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxrtspolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxrtspolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmitter RTS is active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxrtspolW::_0)
            }
            # [ doc = "Transmitter RTS is active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxrtspolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXRTSE`" ]
        pub enum RxrtseW {
            # [ doc = "The receiver has no effect on RTS." ]
            _0,
        }
        impl RxrtseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxrtseW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxrtseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxrtseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxrtseW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The receiver has no effect on RTS." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxrtseW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSC`" ]
        pub enum TxctscW {
            # [ doc = "CTS input is sampled at the start of each character." ]
            _0,
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            _1,
        }
        impl TxctscW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctscW::_0 => 0,
                    TxctscW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctscW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctscW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctscW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS input is sampled at the start of each character." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctscW::_0)
            }
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctscW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSSRC`" ]
        pub enum TxctssrcW {
            # [ doc = "CTS input is the CTS_B pin." ]
            _0,
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            _1,
        }
        impl TxctssrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctssrcW::_0 => 0,
                    TxctssrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctssrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctssrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctssrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS input is the CTS_B pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctssrcW::_0)
            }
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctssrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtswaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtswaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TNP`" ]
        pub enum TnpW {
            # [ doc = "1/OSR." ]
            _00,
            # [ doc = "2/OSR." ]
            _01,
            # [ doc = "3/OSR." ]
            _10,
            # [ doc = "4/OSR." ]
            _11,
        }
        impl TnpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TnpW::_00 => 0,
                    TnpW::_01 => 1,
                    TnpW::_10 => 2,
                    TnpW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TnpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TnpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TnpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1/OSR." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TnpW::_00)
            }
            # [ doc = "2/OSR." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TnpW::_01)
            }
            # [ doc = "3/OSR." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TnpW::_10)
            }
            # [ doc = "4/OSR." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TnpW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IREN`" ]
        pub enum IrenW {
            # [ doc = "IR disabled." ]
            _0,
            # [ doc = "IR enabled." ]
            _1,
        }
        impl IrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrenW::_0 => 0,
                    IrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "IR disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IrenW::_0)
            }
            # [ doc = "IR enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmitter clear-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txctse(&self) -> TxctseR {
                TxctseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Transmitter request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txrtse(&self) -> TxrtseR {
                TxrtseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Transmitter request-to-send polarity" ]
            # [ inline ( always ) ]
            pub fn txrtspol(&self) -> TxrtspolR {
                TxrtspolR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Receiver request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn rxrtse(&self) -> RxrtseR {
                RxrtseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Transmit CTS Configuration" ]
            # [ inline ( always ) ]
            pub fn txctsc(&self) -> TxctscR {
                TxctscR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Transmit CTS Source" ]
            # [ inline ( always ) ]
            pub fn txctssrc(&self) -> TxctssrcR {
                TxctssrcR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:9 - Receive RTS Configuration" ]
            # [ inline ( always ) ]
            pub fn rtswater(&self) -> RtswaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RtswaterR { bits }
            }
            # [ doc = "Bits 16:17 - Transmitter narrow pulse" ]
            # [ inline ( always ) ]
            pub fn tnp(&self) -> TnpR {
                TnpR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Infrared enable" ]
            # [ inline ( always ) ]
            pub fn iren(&self) -> IrenR {
                IrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmitter clear-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txctse(&mut self) -> _TxctseW {
                _TxctseW { w: self }
            }
            # [ doc = "Bit 1 - Transmitter request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txrtse(&mut self) -> _TxrtseW {
                _TxrtseW { w: self }
            }
            # [ doc = "Bit 2 - Transmitter request-to-send polarity" ]
            # [ inline ( always ) ]
            pub fn txrtspol(&mut self) -> _TxrtspolW {
                _TxrtspolW { w: self }
            }
            # [ doc = "Bit 3 - Receiver request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn rxrtse(&mut self) -> _RxrtseW {
                _RxrtseW { w: self }
            }
            # [ doc = "Bit 4 - Transmit CTS Configuration" ]
            # [ inline ( always ) ]
            pub fn txctsc(&mut self) -> _TxctscW {
                _TxctscW { w: self }
            }
            # [ doc = "Bit 5 - Transmit CTS Source" ]
            # [ inline ( always ) ]
            pub fn txctssrc(&mut self) -> _TxctssrcW {
                _TxctssrcW { w: self }
            }
            # [ doc = "Bits 8:9 - Receive RTS Configuration" ]
            # [ inline ( always ) ]
            pub fn rtswater(&mut self) -> _RtswaterW {
                _RtswaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Transmitter narrow pulse" ]
            # [ inline ( always ) ]
            pub fn tnp(&mut self) -> _TnpW {
                _TnpW { w: self }
            }
            # [ doc = "Bit 18 - Infrared enable" ]
            # [ inline ( always ) ]
            pub fn iren(&mut self) -> _IrenW {
                _IrenW { w: self }
            }
        }
    }
    # [ doc = "LPUART FIFO Register" ]
    pub struct Fifo {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART FIFO Register" ]
    pub mod fifo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fifo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RXFIFOSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxfifosizeR {
            # [ doc = "Receive FIFO/Buffer depth = 1 dataword." ]
            _000,
            # [ doc = "Receive FIFO/Buffer depth = 4 datawords." ]
            _001,
            # [ doc = "Receive FIFO/Buffer depth = 8 datawords." ]
            _010,
            # [ doc = "Receive FIFO/Buffer depth = 16 datawords." ]
            _011,
            # [ doc = "Receive FIFO/Buffer depth = 32 datawords." ]
            _100,
            # [ doc = "Receive FIFO/Buffer depth = 64 datawords." ]
            _101,
            # [ doc = "Receive FIFO/Buffer depth = 128 datawords." ]
            _110,
            # [ doc = "Receive FIFO/Buffer depth = 256 datawords." ]
            _111,
        }
        impl RxfifosizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxfifosizeR::_000 => 0,
                    RxfifosizeR::_001 => 1,
                    RxfifosizeR::_010 => 2,
                    RxfifosizeR::_011 => 3,
                    RxfifosizeR::_100 => 4,
                    RxfifosizeR::_101 => 5,
                    RxfifosizeR::_110 => 6,
                    RxfifosizeR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxfifosizeR {
                match bits {
                    0 => RxfifosizeR::_000,
                    1 => RxfifosizeR::_001,
                    2 => RxfifosizeR::_010,
                    3 => RxfifosizeR::_011,
                    4 => RxfifosizeR::_100,
                    5 => RxfifosizeR::_101,
                    6 => RxfifosizeR::_110,
                    7 => RxfifosizeR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == RxfifosizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == RxfifosizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == RxfifosizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == RxfifosizeR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == RxfifosizeR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == RxfifosizeR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == RxfifosizeR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == RxfifosizeR::_111
            }
        }
        # [ doc = "Possible values of the field `RXFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxfeR {
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            _0,
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            _1,
        }
        impl RxfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxfeR::_0 => 0,
                    RxfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxfeR {
                match bits {
                    0 => RxfeR::_0,
                    1 => RxfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxfeR::_1
            }
        }
        # [ doc = "Possible values of the field `TXFIFOSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxfifosizeR {
            # [ doc = "Transmit FIFO/Buffer depth = 1 dataword." ]
            _000,
            # [ doc = "Transmit FIFO/Buffer depth = 4 datawords." ]
            _001,
            # [ doc = "Transmit FIFO/Buffer depth = 8 datawords." ]
            _010,
            # [ doc = "Transmit FIFO/Buffer depth = 16 datawords." ]
            _011,
            # [ doc = "Transmit FIFO/Buffer depth = 32 datawords." ]
            _100,
            # [ doc = "Transmit FIFO/Buffer depth = 64 datawords." ]
            _101,
            # [ doc = "Transmit FIFO/Buffer depth = 128 datawords." ]
            _110,
            # [ doc = "Transmit FIFO/Buffer depth = 256 datawords" ]
            _111,
        }
        impl TxfifosizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxfifosizeR::_000 => 0,
                    TxfifosizeR::_001 => 1,
                    TxfifosizeR::_010 => 2,
                    TxfifosizeR::_011 => 3,
                    TxfifosizeR::_100 => 4,
                    TxfifosizeR::_101 => 5,
                    TxfifosizeR::_110 => 6,
                    TxfifosizeR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxfifosizeR {
                match bits {
                    0 => TxfifosizeR::_000,
                    1 => TxfifosizeR::_001,
                    2 => TxfifosizeR::_010,
                    3 => TxfifosizeR::_011,
                    4 => TxfifosizeR::_100,
                    5 => TxfifosizeR::_101,
                    6 => TxfifosizeR::_110,
                    7 => TxfifosizeR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == TxfifosizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == TxfifosizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == TxfifosizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == TxfifosizeR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TxfifosizeR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TxfifosizeR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TxfifosizeR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TxfifosizeR::_111
            }
        }
        # [ doc = "Possible values of the field `TXFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxfeR {
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            _0,
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            _1,
        }
        impl TxfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxfeR::_0 => 0,
                    TxfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxfeR {
                match bits {
                    0 => TxfeR::_0,
                    1 => TxfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxfeR::_1
            }
        }
        # [ doc = "Possible values of the field `RXUFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxufeR {
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            _1,
        }
        impl RxufeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxufeR::_0 => 0,
                    RxufeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxufeR {
                match bits {
                    0 => RxufeR::_0,
                    1 => RxufeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxufeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxufeR::_1
            }
        }
        # [ doc = "Possible values of the field `TXOFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxofeR {
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            _1,
        }
        impl TxofeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxofeR::_0 => 0,
                    TxofeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxofeR {
                match bits {
                    0 => TxofeR::_0,
                    1 => TxofeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxofeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxofeR::_1
            }
        }
        # [ doc = "Possible values of the field `RXIDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxidenR {
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            _000,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            _001,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            _010,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            _011,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            _100,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            _101,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            _110,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            _111,
        }
        impl RxidenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxidenR::_000 => 0,
                    RxidenR::_001 => 1,
                    RxidenR::_010 => 2,
                    RxidenR::_011 => 3,
                    RxidenR::_100 => 4,
                    RxidenR::_101 => 5,
                    RxidenR::_110 => 6,
                    RxidenR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxidenR {
                match bits {
                    0 => RxidenR::_000,
                    1 => RxidenR::_001,
                    2 => RxidenR::_010,
                    3 => RxidenR::_011,
                    4 => RxidenR::_100,
                    5 => RxidenR::_101,
                    6 => RxidenR::_110,
                    7 => RxidenR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == RxidenR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == RxidenR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == RxidenR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == RxidenR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == RxidenR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == RxidenR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == RxidenR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == RxidenR::_111
            }
        }
        # [ doc = "Possible values of the field `RXUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxufR {
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl RxufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxufR::_0 => 0,
                    RxufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxufR {
                match bits {
                    0 => RxufR::_0,
                    1 => RxufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxufR::_1
            }
        }
        # [ doc = "Possible values of the field `TXOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxofR {
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl TxofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxofR::_0 => 0,
                    TxofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxofR {
                match bits {
                    0 => TxofR::_0,
                    1 => TxofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxofR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptR {
            # [ doc = "Receive buffer is not empty." ]
            _0,
            # [ doc = "Receive buffer is empty." ]
            _1,
        }
        impl RxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptR::_0 => 0,
                    RxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptR {
                match bits {
                    0 => RxemptR::_0,
                    1 => RxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptR::_1
            }
        }
        # [ doc = "Possible values of the field `TXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxemptR {
            # [ doc = "Transmit buffer is not empty." ]
            _0,
            # [ doc = "Transmit buffer is empty." ]
            _1,
        }
        impl TxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxemptR::_0 => 0,
                    TxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxemptR {
                match bits {
                    0 => TxemptR::_0,
                    1 => TxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxemptR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RXFE`" ]
        pub enum RxfeW {
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            _0,
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            _1,
        }
        impl RxfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxfeW::_0 => 0,
                    RxfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxfeW::_0)
            }
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXFE`" ]
        pub enum TxfeW {
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            _0,
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            _1,
        }
        impl TxfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxfeW::_0 => 0,
                    TxfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxfeW::_0)
            }
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXUFE`" ]
        pub enum RxufeW {
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            _1,
        }
        impl RxufeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxufeW::_0 => 0,
                    RxufeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxufeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxufeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxufeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxufeW::_0)
            }
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxufeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXOFE`" ]
        pub enum TxofeW {
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            _1,
        }
        impl TxofeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxofeW::_0 => 0,
                    TxofeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxofeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxofeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxofeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxofeW::_0)
            }
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxofeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXIDEN`" ]
        pub enum RxidenW {
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            _000,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            _001,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            _010,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            _011,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            _100,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            _101,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            _110,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            _111,
        }
        impl RxidenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxidenW::_000 => 0,
                    RxidenW::_001 => 1,
                    RxidenW::_010 => 2,
                    RxidenW::_011 => 3,
                    RxidenW::_100 => 4,
                    RxidenW::_101 => 5,
                    RxidenW::_110 => 6,
                    RxidenW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxidenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxidenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxidenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(RxidenW::_000)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(RxidenW::_001)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(RxidenW::_010)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(RxidenW::_011)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(RxidenW::_100)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(RxidenW::_101)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(RxidenW::_110)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(RxidenW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXFLUSH`" ]
        pub enum RxflushW {
            # [ doc = "No flush operation occurs." ]
            _0,
            # [ doc = "All data in the receive FIFO/buffer is cleared out." ]
            _1,
        }
        impl RxflushW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxflushW::_0 => 0,
                    RxflushW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxflushW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxflushW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxflushW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No flush operation occurs." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxflushW::_0)
            }
            # [ doc = "All data in the receive FIFO/buffer is cleared out." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxflushW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXFLUSH`" ]
        pub enum TxflushW {
            # [ doc = "No flush operation occurs." ]
            _0,
            # [ doc = "All data in the transmit FIFO/Buffer is cleared out." ]
            _1,
        }
        impl TxflushW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxflushW::_0 => 0,
                    TxflushW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxflushW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxflushW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxflushW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No flush operation occurs." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxflushW::_0)
            }
            # [ doc = "All data in the transmit FIFO/Buffer is cleared out." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxflushW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXUF`" ]
        pub enum RxufW {
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl RxufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxufW::_0 => 0,
                    RxufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxufW::_0)
            }
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXOF`" ]
        pub enum TxofW {
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl TxofW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxofW::_0 => 0,
                    TxofW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxofW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxofW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxofW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxofW::_0)
            }
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxofW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Receive FIFO. Buffer Depth" ]
            # [ inline ( always ) ]
            pub fn rxfifosize(&self) -> RxfifosizeR {
                RxfifosizeR::_from({
                                       const MASK: u8 = 7;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 3 - Receive FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rxfe(&self) -> RxfeR {
                RxfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 4:6 - Transmit FIFO. Buffer Depth" ]
            # [ inline ( always ) ]
            pub fn txfifosize(&self) -> TxfifosizeR {
                TxfifosizeR::_from({
                                       const MASK: u8 = 7;
                                       const OFFSET: u8 = 4;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Transmit FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn txfe(&self) -> TxfeR {
                TxfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Receive FIFO Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxufe(&self) -> RxufeR {
                RxufeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Transmit FIFO Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn txofe(&self) -> TxofeR {
                TxofeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 10:12 - Receiver Idle Empty Enable" ]
            # [ inline ( always ) ]
            pub fn rxiden(&self) -> RxidenR {
                RxidenR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Receiver Buffer Underflow Flag" ]
            # [ inline ( always ) ]
            pub fn rxuf(&self) -> RxufR {
                RxufR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Transmitter Buffer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn txof(&self) -> TxofR {
                TxofR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Receive Buffer/FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn rxempt(&self) -> RxemptR {
                RxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Transmit Buffer/FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn txempt(&self) -> TxemptR {
                TxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12582929 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 3 - Receive FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rxfe(&mut self) -> _RxfeW {
                _RxfeW { w: self }
            }
            # [ doc = "Bit 7 - Transmit FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn txfe(&mut self) -> _TxfeW {
                _TxfeW { w: self }
            }
            # [ doc = "Bit 8 - Receive FIFO Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxufe(&mut self) -> _RxufeW {
                _RxufeW { w: self }
            }
            # [ doc = "Bit 9 - Transmit FIFO Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn txofe(&mut self) -> _TxofeW {
                _TxofeW { w: self }
            }
            # [ doc = "Bits 10:12 - Receiver Idle Empty Enable" ]
            # [ inline ( always ) ]
            pub fn rxiden(&mut self) -> _RxidenW {
                _RxidenW { w: self }
            }
            # [ doc = "Bit 14 - Receive FIFO/Buffer Flush" ]
            # [ inline ( always ) ]
            pub fn rxflush(&mut self) -> _RxflushW {
                _RxflushW { w: self }
            }
            # [ doc = "Bit 15 - Transmit FIFO/Buffer Flush" ]
            # [ inline ( always ) ]
            pub fn txflush(&mut self) -> _TxflushW {
                _TxflushW { w: self }
            }
            # [ doc = "Bit 16 - Receiver Buffer Underflow Flag" ]
            # [ inline ( always ) ]
            pub fn rxuf(&mut self) -> _RxufW {
                _RxufW { w: self }
            }
            # [ doc = "Bit 17 - Transmitter Buffer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn txof(&mut self) -> _TxofW {
                _TxofW { w: self }
            }
        }
    }
    # [ doc = "LPUART Watermark Register" ]
    pub struct Water {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Watermark Register" ]
    pub mod water {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Water {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 8:10 - Transmit Counter" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:17 - Receive Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
            # [ doc = "Bits 24:26 - Receive Counter" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
}
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub struct Lpuart1 {
    register_block: lpuart1::RegisterBlock,
}
impl Deref for Lpuart1 {
    type Target = lpuart1::RegisterBlock;
    fn deref(&self) -> &lpuart1::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub const LPUART2: Peripheral<Lpuart2> = unsafe { Peripheral::new(1074184192) };
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub mod lpuart2 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - LPUART Global Register" ]
        pub global: Global,
        # [ doc = "0x0c - LPUART Pin Configuration Register" ]
        pub pincfg: Pincfg,
        # [ doc = "0x10 - LPUART Baud Rate Register" ]
        pub baud: Baud,
        # [ doc = "0x14 - LPUART Status Register" ]
        pub stat: Stat,
        # [ doc = "0x18 - LPUART Control Register" ]
        pub ctrl: Ctrl,
        # [ doc = "0x1c - LPUART Data Register" ]
        pub data: Data,
        # [ doc = "0x20 - LPUART Match Address Register" ]
        pub match_: Match,
        # [ doc = "0x24 - LPUART Modem IrDA Register" ]
        pub modir: Modir,
        # [ doc = "0x28 - LPUART FIFO Register" ]
        pub fifo: Fifo,
        # [ doc = "0x2c - LPUART Watermark Register" ]
        pub water: Water,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set." ]
            _0000000000000001,
            # [ doc = "Standard feature set with MODEM/IrDA support." ]
            _0000000000000011,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0000000000000001 => 1,
                    FeatureR::_0000000000000011 => 3,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    1 => FeatureR::_0000000000000001,
                    3 => FeatureR::_0000000000000011,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000000000000001`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000001(&self) -> bool {
                *self == FeatureR::_0000000000000001
            }
            # [ doc = "Checks if the value of the field is `_0000000000000011`" ]
            # [ inline ( always ) ]
            pub fn is_0000000000000011(&self) -> bool {
                *self == FeatureR::_0000000000000011
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Identification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxfifoR {
            bits: u8,
        }
        impl TxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxfifoR {
            bits: u8,
        }
        impl RxfifoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Transmit FIFO Size" ]
            # [ inline ( always ) ]
            pub fn txfifo(&self) -> TxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxfifoR { bits }
            }
            # [ doc = "Bits 8:15 - Receive FIFO Size" ]
            # [ inline ( always ) ]
            pub fn rxfifo(&self) -> RxfifoR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxfifoR { bits }
            }
        }
    }
    # [ doc = "LPUART Global Register" ]
    pub struct Global {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Global Register" ]
    pub mod global {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Global {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstR {
            # [ doc = "Module is not reset." ]
            _0,
            # [ doc = "Module is reset." ]
            _1,
        }
        impl RstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstR::_0 => 0,
                    RstR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstR {
                match bits {
                    0 => RstR::_0,
                    1 => RstR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RST`" ]
        pub enum RstW {
            # [ doc = "Module is not reset." ]
            _0,
            # [ doc = "Module is reset." ]
            _1,
        }
        impl RstW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstW::_0 => 0,
                    RstW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Module is not reset." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstW::_0)
            }
            # [ doc = "Module is reset." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&self) -> RstR {
                RstR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Software Reset" ]
            # [ inline ( always ) ]
            pub fn rst(&mut self) -> _RstW {
                _RstW { w: self }
            }
        }
    }
    # [ doc = "LPUART Pin Configuration Register" ]
    pub struct Pincfg {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Pin Configuration Register" ]
    pub mod pincfg {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pincfg {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TRGSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TrgselR {
            # [ doc = "Input trigger is disabled." ]
            _00,
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            _01,
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            _10,
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            _11,
        }
        impl TrgselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TrgselR::_00 => 0,
                    TrgselR::_01 => 1,
                    TrgselR::_10 => 2,
                    TrgselR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TrgselR {
                match bits {
                    0 => TrgselR::_00,
                    1 => TrgselR::_01,
                    2 => TrgselR::_10,
                    3 => TrgselR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TrgselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TrgselR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TrgselR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TrgselR::_11
            }
        }
        # [ doc = "Values that can be written to the field `TRGSEL`" ]
        pub enum TrgselW {
            # [ doc = "Input trigger is disabled." ]
            _00,
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            _01,
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            _10,
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            _11,
        }
        impl TrgselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TrgselW::_00 => 0,
                    TrgselW::_01 => 1,
                    TrgselW::_10 => 2,
                    TrgselW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TrgselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TrgselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TrgselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Input trigger is disabled." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TrgselW::_00)
            }
            # [ doc = "Input trigger is used instead of RXD pin input." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TrgselW::_01)
            }
            # [ doc = "Input trigger is used instead of CTS_B pin input." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TrgselW::_10)
            }
            # [ doc = "Input trigger is used to modulate the TXD pin output. The TXD pin output (after TXINV configuration) is ANDed with the input trigger." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TrgselW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&self) -> TrgselR {
                TrgselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Trigger Select" ]
            # [ inline ( always ) ]
            pub fn trgsel(&mut self) -> _TrgselW {
                _TrgselW { w: self }
            }
        }
    }
    # [ doc = "LPUART Baud Rate Register" ]
    pub struct Baud {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Baud Rate Register" ]
    pub mod baud {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Baud {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SbrR {
            bits: u16,
        }
        impl SbrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SBNS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbnsR {
            # [ doc = "One stop bit." ]
            _0,
            # [ doc = "Two stop bits." ]
            _1,
        }
        impl SbnsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbnsR::_0 => 0,
                    SbnsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbnsR {
                match bits {
                    0 => SbnsR::_0,
                    1 => SbnsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbnsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbnsR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEDGIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxedgieR {
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            _1,
        }
        impl RxedgieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxedgieR::_0 => 0,
                    RxedgieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxedgieR {
                match bits {
                    0 => RxedgieR::_0,
                    1 => RxedgieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxedgieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxedgieR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdieR {
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            _1,
        }
        impl LbkdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdieR::_0 => 0,
                    LbkdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdieR {
                match bits {
                    0 => LbkdieR::_0,
                    1 => LbkdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdieR::_1
            }
        }
        # [ doc = "Possible values of the field `RESYNCDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ResyncdisR {
            # [ doc = "Resynchronization during received data word is supported" ]
            _0,
            # [ doc = "Resynchronization during received data word is disabled" ]
            _1,
        }
        impl ResyncdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ResyncdisR::_0 => 0,
                    ResyncdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ResyncdisR {
                match bits {
                    0 => ResyncdisR::_0,
                    1 => ResyncdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ResyncdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ResyncdisR::_1
            }
        }
        # [ doc = "Possible values of the field `BOTHEDGE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BothedgeR {
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            _0,
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            _1,
        }
        impl BothedgeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BothedgeR::_0 => 0,
                    BothedgeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BothedgeR {
                match bits {
                    0 => BothedgeR::_0,
                    1 => BothedgeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BothedgeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BothedgeR::_1
            }
        }
        # [ doc = "Possible values of the field `MATCFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MatcfgR {
            # [ doc = "Address Match Wakeup" ]
            _00,
            # [ doc = "Idle Match Wakeup" ]
            _01,
            # [ doc = "Match On and Match Off" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MatcfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MatcfgR::_00 => 0,
                    MatcfgR::_01 => 1,
                    MatcfgR::_10 => 2,
                    MatcfgR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MatcfgR {
                match bits {
                    0 => MatcfgR::_00,
                    1 => MatcfgR::_01,
                    2 => MatcfgR::_10,
                    i => MatcfgR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == MatcfgR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == MatcfgR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == MatcfgR::_10
            }
        }
        # [ doc = "Possible values of the field `RIDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RidmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RidmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RidmaeR::_0 => 0,
                    RidmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RidmaeR {
                match bits {
                    0 => RidmaeR::_0,
                    1 => RidmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RidmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RidmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `RDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RdmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdmaeR::_0 => 0,
                    RdmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdmaeR {
                match bits {
                    0 => RdmaeR::_0,
                    1 => RdmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `TDMAE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdmaeR {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl TdmaeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdmaeR::_0 => 0,
                    TdmaeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdmaeR {
                match bits {
                    0 => TdmaeR::_0,
                    1 => TdmaeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdmaeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdmaeR::_1
            }
        }
        # [ doc = "Possible values of the field `OSR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OsrR {
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            _00000,
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            _00011,
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            _00100,
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            _00101,
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            _00110,
            # [ doc = "Oversampling ratio of 8." ]
            _00111,
            # [ doc = "Oversampling ratio of 9." ]
            _01000,
            # [ doc = "Oversampling ratio of 10." ]
            _01001,
            # [ doc = "Oversampling ratio of 11." ]
            _01010,
            # [ doc = "Oversampling ratio of 12." ]
            _01011,
            # [ doc = "Oversampling ratio of 13." ]
            _01100,
            # [ doc = "Oversampling ratio of 14." ]
            _01101,
            # [ doc = "Oversampling ratio of 15." ]
            _01110,
            # [ doc = "Oversampling ratio of 16." ]
            _01111,
            # [ doc = "Oversampling ratio of 17." ]
            _10000,
            # [ doc = "Oversampling ratio of 18." ]
            _10001,
            # [ doc = "Oversampling ratio of 19." ]
            _10010,
            # [ doc = "Oversampling ratio of 20." ]
            _10011,
            # [ doc = "Oversampling ratio of 21." ]
            _10100,
            # [ doc = "Oversampling ratio of 22." ]
            _10101,
            # [ doc = "Oversampling ratio of 23." ]
            _10110,
            # [ doc = "Oversampling ratio of 24." ]
            _10111,
            # [ doc = "Oversampling ratio of 25." ]
            _11000,
            # [ doc = "Oversampling ratio of 26." ]
            _11001,
            # [ doc = "Oversampling ratio of 27." ]
            _11010,
            # [ doc = "Oversampling ratio of 28." ]
            _11011,
            # [ doc = "Oversampling ratio of 29." ]
            _11100,
            # [ doc = "Oversampling ratio of 30." ]
            _11101,
            # [ doc = "Oversampling ratio of 31." ]
            _11110,
            # [ doc = "Oversampling ratio of 32." ]
            _11111,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl OsrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OsrR::_00000 => 0,
                    OsrR::_00011 => 3,
                    OsrR::_00100 => 4,
                    OsrR::_00101 => 5,
                    OsrR::_00110 => 6,
                    OsrR::_00111 => 7,
                    OsrR::_01000 => 8,
                    OsrR::_01001 => 9,
                    OsrR::_01010 => 10,
                    OsrR::_01011 => 11,
                    OsrR::_01100 => 12,
                    OsrR::_01101 => 13,
                    OsrR::_01110 => 14,
                    OsrR::_01111 => 15,
                    OsrR::_10000 => 16,
                    OsrR::_10001 => 17,
                    OsrR::_10010 => 18,
                    OsrR::_10011 => 19,
                    OsrR::_10100 => 20,
                    OsrR::_10101 => 21,
                    OsrR::_10110 => 22,
                    OsrR::_10111 => 23,
                    OsrR::_11000 => 24,
                    OsrR::_11001 => 25,
                    OsrR::_11010 => 26,
                    OsrR::_11011 => 27,
                    OsrR::_11100 => 28,
                    OsrR::_11101 => 29,
                    OsrR::_11110 => 30,
                    OsrR::_11111 => 31,
                    OsrR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OsrR {
                match bits {
                    0 => OsrR::_00000,
                    3 => OsrR::_00011,
                    4 => OsrR::_00100,
                    5 => OsrR::_00101,
                    6 => OsrR::_00110,
                    7 => OsrR::_00111,
                    8 => OsrR::_01000,
                    9 => OsrR::_01001,
                    10 => OsrR::_01010,
                    11 => OsrR::_01011,
                    12 => OsrR::_01100,
                    13 => OsrR::_01101,
                    14 => OsrR::_01110,
                    15 => OsrR::_01111,
                    16 => OsrR::_10000,
                    17 => OsrR::_10001,
                    18 => OsrR::_10010,
                    19 => OsrR::_10011,
                    20 => OsrR::_10100,
                    21 => OsrR::_10101,
                    22 => OsrR::_10110,
                    23 => OsrR::_10111,
                    24 => OsrR::_11000,
                    25 => OsrR::_11001,
                    26 => OsrR::_11010,
                    27 => OsrR::_11011,
                    28 => OsrR::_11100,
                    29 => OsrR::_11101,
                    30 => OsrR::_11110,
                    31 => OsrR::_11111,
                    i => OsrR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00000`" ]
            # [ inline ( always ) ]
            pub fn is_00000(&self) -> bool {
                *self == OsrR::_00000
            }
            # [ doc = "Checks if the value of the field is `_00011`" ]
            # [ inline ( always ) ]
            pub fn is_00011(&self) -> bool {
                *self == OsrR::_00011
            }
            # [ doc = "Checks if the value of the field is `_00100`" ]
            # [ inline ( always ) ]
            pub fn is_00100(&self) -> bool {
                *self == OsrR::_00100
            }
            # [ doc = "Checks if the value of the field is `_00101`" ]
            # [ inline ( always ) ]
            pub fn is_00101(&self) -> bool {
                *self == OsrR::_00101
            }
            # [ doc = "Checks if the value of the field is `_00110`" ]
            # [ inline ( always ) ]
            pub fn is_00110(&self) -> bool {
                *self == OsrR::_00110
            }
            # [ doc = "Checks if the value of the field is `_00111`" ]
            # [ inline ( always ) ]
            pub fn is_00111(&self) -> bool {
                *self == OsrR::_00111
            }
            # [ doc = "Checks if the value of the field is `_01000`" ]
            # [ inline ( always ) ]
            pub fn is_01000(&self) -> bool {
                *self == OsrR::_01000
            }
            # [ doc = "Checks if the value of the field is `_01001`" ]
            # [ inline ( always ) ]
            pub fn is_01001(&self) -> bool {
                *self == OsrR::_01001
            }
            # [ doc = "Checks if the value of the field is `_01010`" ]
            # [ inline ( always ) ]
            pub fn is_01010(&self) -> bool {
                *self == OsrR::_01010
            }
            # [ doc = "Checks if the value of the field is `_01011`" ]
            # [ inline ( always ) ]
            pub fn is_01011(&self) -> bool {
                *self == OsrR::_01011
            }
            # [ doc = "Checks if the value of the field is `_01100`" ]
            # [ inline ( always ) ]
            pub fn is_01100(&self) -> bool {
                *self == OsrR::_01100
            }
            # [ doc = "Checks if the value of the field is `_01101`" ]
            # [ inline ( always ) ]
            pub fn is_01101(&self) -> bool {
                *self == OsrR::_01101
            }
            # [ doc = "Checks if the value of the field is `_01110`" ]
            # [ inline ( always ) ]
            pub fn is_01110(&self) -> bool {
                *self == OsrR::_01110
            }
            # [ doc = "Checks if the value of the field is `_01111`" ]
            # [ inline ( always ) ]
            pub fn is_01111(&self) -> bool {
                *self == OsrR::_01111
            }
            # [ doc = "Checks if the value of the field is `_10000`" ]
            # [ inline ( always ) ]
            pub fn is_10000(&self) -> bool {
                *self == OsrR::_10000
            }
            # [ doc = "Checks if the value of the field is `_10001`" ]
            # [ inline ( always ) ]
            pub fn is_10001(&self) -> bool {
                *self == OsrR::_10001
            }
            # [ doc = "Checks if the value of the field is `_10010`" ]
            # [ inline ( always ) ]
            pub fn is_10010(&self) -> bool {
                *self == OsrR::_10010
            }
            # [ doc = "Checks if the value of the field is `_10011`" ]
            # [ inline ( always ) ]
            pub fn is_10011(&self) -> bool {
                *self == OsrR::_10011
            }
            # [ doc = "Checks if the value of the field is `_10100`" ]
            # [ inline ( always ) ]
            pub fn is_10100(&self) -> bool {
                *self == OsrR::_10100
            }
            # [ doc = "Checks if the value of the field is `_10101`" ]
            # [ inline ( always ) ]
            pub fn is_10101(&self) -> bool {
                *self == OsrR::_10101
            }
            # [ doc = "Checks if the value of the field is `_10110`" ]
            # [ inline ( always ) ]
            pub fn is_10110(&self) -> bool {
                *self == OsrR::_10110
            }
            # [ doc = "Checks if the value of the field is `_10111`" ]
            # [ inline ( always ) ]
            pub fn is_10111(&self) -> bool {
                *self == OsrR::_10111
            }
            # [ doc = "Checks if the value of the field is `_11000`" ]
            # [ inline ( always ) ]
            pub fn is_11000(&self) -> bool {
                *self == OsrR::_11000
            }
            # [ doc = "Checks if the value of the field is `_11001`" ]
            # [ inline ( always ) ]
            pub fn is_11001(&self) -> bool {
                *self == OsrR::_11001
            }
            # [ doc = "Checks if the value of the field is `_11010`" ]
            # [ inline ( always ) ]
            pub fn is_11010(&self) -> bool {
                *self == OsrR::_11010
            }
            # [ doc = "Checks if the value of the field is `_11011`" ]
            # [ inline ( always ) ]
            pub fn is_11011(&self) -> bool {
                *self == OsrR::_11011
            }
            # [ doc = "Checks if the value of the field is `_11100`" ]
            # [ inline ( always ) ]
            pub fn is_11100(&self) -> bool {
                *self == OsrR::_11100
            }
            # [ doc = "Checks if the value of the field is `_11101`" ]
            # [ inline ( always ) ]
            pub fn is_11101(&self) -> bool {
                *self == OsrR::_11101
            }
            # [ doc = "Checks if the value of the field is `_11110`" ]
            # [ inline ( always ) ]
            pub fn is_11110(&self) -> bool {
                *self == OsrR::_11110
            }
            # [ doc = "Checks if the value of the field is `_11111`" ]
            # [ inline ( always ) ]
            pub fn is_11111(&self) -> bool {
                *self == OsrR::_11111
            }
        }
        # [ doc = "Possible values of the field `M10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum M10R {
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            _1,
        }
        impl M10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    M10R::_0 => 0,
                    M10R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> M10R {
                match bits {
                    0 => M10R::_0,
                    1 => M10R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == M10R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == M10R::_1
            }
        }
        # [ doc = "Possible values of the field `MAEN2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Maen2R {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            _1,
        }
        impl Maen2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Maen2R::_0 => 0,
                    Maen2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Maen2R {
                match bits {
                    0 => Maen2R::_0,
                    1 => Maen2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Maen2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Maen2R::_1
            }
        }
        # [ doc = "Possible values of the field `MAEN1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Maen1R {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            _1,
        }
        impl Maen1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Maen1R::_0 => 0,
                    Maen1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Maen1R {
                match bits {
                    0 => Maen1R::_0,
                    1 => Maen1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Maen1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Maen1R::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 8191;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBNS`" ]
        pub enum SbnsW {
            # [ doc = "One stop bit." ]
            _0,
            # [ doc = "Two stop bits." ]
            _1,
        }
        impl SbnsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SbnsW::_0 => 0,
                    SbnsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbnsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbnsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SbnsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "One stop bit." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SbnsW::_0)
            }
            # [ doc = "Two stop bits." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SbnsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXEDGIE`" ]
        pub enum RxedgieW {
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            _1,
        }
        impl RxedgieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxedgieW::_0 => 0,
                    RxedgieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxedgieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxedgieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxedgieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from LPUART_STAT[RXEDGIF] disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxedgieW::_0)
            }
            # [ doc = "Hardware interrupt requested when LPUART_STAT[RXEDGIF] flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxedgieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDIE`" ]
        pub enum LbkdieW {
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            _1,
        }
        impl LbkdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdieW::_0 => 0,
                    LbkdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from LPUART_STAT[LBKDIF] disabled (use polling)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdieW::_0)
            }
            # [ doc = "Hardware interrupt requested when LPUART_STAT[LBKDIF] flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RESYNCDIS`" ]
        pub enum ResyncdisW {
            # [ doc = "Resynchronization during received data word is supported" ]
            _0,
            # [ doc = "Resynchronization during received data word is disabled" ]
            _1,
        }
        impl ResyncdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ResyncdisW::_0 => 0,
                    ResyncdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ResyncdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ResyncdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ResyncdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Resynchronization during received data word is supported" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ResyncdisW::_0)
            }
            # [ doc = "Resynchronization during received data word is disabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ResyncdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BOTHEDGE`" ]
        pub enum BothedgeW {
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            _0,
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            _1,
        }
        impl BothedgeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BothedgeW::_0 => 0,
                    BothedgeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BothedgeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BothedgeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BothedgeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver samples input data using the rising edge of the baud rate clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BothedgeW::_0)
            }
            # [ doc = "Receiver samples input data using the rising and falling edge of the baud rate clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BothedgeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MATCFG`" ]
        pub enum MatcfgW {
            # [ doc = "Address Match Wakeup" ]
            _00,
            # [ doc = "Idle Match Wakeup" ]
            _01,
            # [ doc = "Match On and Match Off" ]
            _10,
        }
        impl MatcfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MatcfgW::_00 => 0,
                    MatcfgW::_01 => 1,
                    MatcfgW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MatcfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MatcfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MatcfgW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Address Match Wakeup" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(MatcfgW::_00)
            }
            # [ doc = "Idle Match Wakeup" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(MatcfgW::_01)
            }
            # [ doc = "Match On and Match Off" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(MatcfgW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIDMAE`" ]
        pub enum RidmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RidmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RidmaeW::_0 => 0,
                    RidmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RidmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RidmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RidmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RidmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RidmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RDMAE`" ]
        pub enum RdmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl RdmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RdmaeW::_0 => 0,
                    RdmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RdmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RdmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RdmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RdmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RdmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDMAE`" ]
        pub enum TdmaeW {
            # [ doc = "DMA request disabled." ]
            _0,
            # [ doc = "DMA request enabled." ]
            _1,
        }
        impl TdmaeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdmaeW::_0 => 0,
                    TdmaeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdmaeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdmaeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdmaeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA request disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdmaeW::_0)
            }
            # [ doc = "DMA request enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdmaeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OSR`" ]
        pub enum OsrW {
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            _00000,
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            _00011,
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            _00100,
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            _00101,
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            _00110,
            # [ doc = "Oversampling ratio of 8." ]
            _00111,
            # [ doc = "Oversampling ratio of 9." ]
            _01000,
            # [ doc = "Oversampling ratio of 10." ]
            _01001,
            # [ doc = "Oversampling ratio of 11." ]
            _01010,
            # [ doc = "Oversampling ratio of 12." ]
            _01011,
            # [ doc = "Oversampling ratio of 13." ]
            _01100,
            # [ doc = "Oversampling ratio of 14." ]
            _01101,
            # [ doc = "Oversampling ratio of 15." ]
            _01110,
            # [ doc = "Oversampling ratio of 16." ]
            _01111,
            # [ doc = "Oversampling ratio of 17." ]
            _10000,
            # [ doc = "Oversampling ratio of 18." ]
            _10001,
            # [ doc = "Oversampling ratio of 19." ]
            _10010,
            # [ doc = "Oversampling ratio of 20." ]
            _10011,
            # [ doc = "Oversampling ratio of 21." ]
            _10100,
            # [ doc = "Oversampling ratio of 22." ]
            _10101,
            # [ doc = "Oversampling ratio of 23." ]
            _10110,
            # [ doc = "Oversampling ratio of 24." ]
            _10111,
            # [ doc = "Oversampling ratio of 25." ]
            _11000,
            # [ doc = "Oversampling ratio of 26." ]
            _11001,
            # [ doc = "Oversampling ratio of 27." ]
            _11010,
            # [ doc = "Oversampling ratio of 28." ]
            _11011,
            # [ doc = "Oversampling ratio of 29." ]
            _11100,
            # [ doc = "Oversampling ratio of 30." ]
            _11101,
            # [ doc = "Oversampling ratio of 31." ]
            _11110,
            # [ doc = "Oversampling ratio of 32." ]
            _11111,
        }
        impl OsrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OsrW::_00000 => 0,
                    OsrW::_00011 => 3,
                    OsrW::_00100 => 4,
                    OsrW::_00101 => 5,
                    OsrW::_00110 => 6,
                    OsrW::_00111 => 7,
                    OsrW::_01000 => 8,
                    OsrW::_01001 => 9,
                    OsrW::_01010 => 10,
                    OsrW::_01011 => 11,
                    OsrW::_01100 => 12,
                    OsrW::_01101 => 13,
                    OsrW::_01110 => 14,
                    OsrW::_01111 => 15,
                    OsrW::_10000 => 16,
                    OsrW::_10001 => 17,
                    OsrW::_10010 => 18,
                    OsrW::_10011 => 19,
                    OsrW::_10100 => 20,
                    OsrW::_10101 => 21,
                    OsrW::_10110 => 22,
                    OsrW::_10111 => 23,
                    OsrW::_11000 => 24,
                    OsrW::_11001 => 25,
                    OsrW::_11010 => 26,
                    OsrW::_11011 => 27,
                    OsrW::_11100 => 28,
                    OsrW::_11101 => 29,
                    OsrW::_11110 => 30,
                    OsrW::_11111 => 31,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OsrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OsrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OsrW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Writing 0 to this field will result in an oversampling ratio of 16" ]
            # [ inline ( always ) ]
            pub fn _00000(self) -> &'a mut W {
                self.variant(OsrW::_00000)
            }
            # [ doc = "Oversampling ratio of 4, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00011(self) -> &'a mut W {
                self.variant(OsrW::_00011)
            }
            # [ doc = "Oversampling ratio of 5, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00100(self) -> &'a mut W {
                self.variant(OsrW::_00100)
            }
            # [ doc = "Oversampling ratio of 6, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00101(self) -> &'a mut W {
                self.variant(OsrW::_00101)
            }
            # [ doc = "Oversampling ratio of 7, requires BOTHEDGE to be set." ]
            # [ inline ( always ) ]
            pub fn _00110(self) -> &'a mut W {
                self.variant(OsrW::_00110)
            }
            # [ doc = "Oversampling ratio of 8." ]
            # [ inline ( always ) ]
            pub fn _00111(self) -> &'a mut W {
                self.variant(OsrW::_00111)
            }
            # [ doc = "Oversampling ratio of 9." ]
            # [ inline ( always ) ]
            pub fn _01000(self) -> &'a mut W {
                self.variant(OsrW::_01000)
            }
            # [ doc = "Oversampling ratio of 10." ]
            # [ inline ( always ) ]
            pub fn _01001(self) -> &'a mut W {
                self.variant(OsrW::_01001)
            }
            # [ doc = "Oversampling ratio of 11." ]
            # [ inline ( always ) ]
            pub fn _01010(self) -> &'a mut W {
                self.variant(OsrW::_01010)
            }
            # [ doc = "Oversampling ratio of 12." ]
            # [ inline ( always ) ]
            pub fn _01011(self) -> &'a mut W {
                self.variant(OsrW::_01011)
            }
            # [ doc = "Oversampling ratio of 13." ]
            # [ inline ( always ) ]
            pub fn _01100(self) -> &'a mut W {
                self.variant(OsrW::_01100)
            }
            # [ doc = "Oversampling ratio of 14." ]
            # [ inline ( always ) ]
            pub fn _01101(self) -> &'a mut W {
                self.variant(OsrW::_01101)
            }
            # [ doc = "Oversampling ratio of 15." ]
            # [ inline ( always ) ]
            pub fn _01110(self) -> &'a mut W {
                self.variant(OsrW::_01110)
            }
            # [ doc = "Oversampling ratio of 16." ]
            # [ inline ( always ) ]
            pub fn _01111(self) -> &'a mut W {
                self.variant(OsrW::_01111)
            }
            # [ doc = "Oversampling ratio of 17." ]
            # [ inline ( always ) ]
            pub fn _10000(self) -> &'a mut W {
                self.variant(OsrW::_10000)
            }
            # [ doc = "Oversampling ratio of 18." ]
            # [ inline ( always ) ]
            pub fn _10001(self) -> &'a mut W {
                self.variant(OsrW::_10001)
            }
            # [ doc = "Oversampling ratio of 19." ]
            # [ inline ( always ) ]
            pub fn _10010(self) -> &'a mut W {
                self.variant(OsrW::_10010)
            }
            # [ doc = "Oversampling ratio of 20." ]
            # [ inline ( always ) ]
            pub fn _10011(self) -> &'a mut W {
                self.variant(OsrW::_10011)
            }
            # [ doc = "Oversampling ratio of 21." ]
            # [ inline ( always ) ]
            pub fn _10100(self) -> &'a mut W {
                self.variant(OsrW::_10100)
            }
            # [ doc = "Oversampling ratio of 22." ]
            # [ inline ( always ) ]
            pub fn _10101(self) -> &'a mut W {
                self.variant(OsrW::_10101)
            }
            # [ doc = "Oversampling ratio of 23." ]
            # [ inline ( always ) ]
            pub fn _10110(self) -> &'a mut W {
                self.variant(OsrW::_10110)
            }
            # [ doc = "Oversampling ratio of 24." ]
            # [ inline ( always ) ]
            pub fn _10111(self) -> &'a mut W {
                self.variant(OsrW::_10111)
            }
            # [ doc = "Oversampling ratio of 25." ]
            # [ inline ( always ) ]
            pub fn _11000(self) -> &'a mut W {
                self.variant(OsrW::_11000)
            }
            # [ doc = "Oversampling ratio of 26." ]
            # [ inline ( always ) ]
            pub fn _11001(self) -> &'a mut W {
                self.variant(OsrW::_11001)
            }
            # [ doc = "Oversampling ratio of 27." ]
            # [ inline ( always ) ]
            pub fn _11010(self) -> &'a mut W {
                self.variant(OsrW::_11010)
            }
            # [ doc = "Oversampling ratio of 28." ]
            # [ inline ( always ) ]
            pub fn _11011(self) -> &'a mut W {
                self.variant(OsrW::_11011)
            }
            # [ doc = "Oversampling ratio of 29." ]
            # [ inline ( always ) ]
            pub fn _11100(self) -> &'a mut W {
                self.variant(OsrW::_11100)
            }
            # [ doc = "Oversampling ratio of 30." ]
            # [ inline ( always ) ]
            pub fn _11101(self) -> &'a mut W {
                self.variant(OsrW::_11101)
            }
            # [ doc = "Oversampling ratio of 31." ]
            # [ inline ( always ) ]
            pub fn _11110(self) -> &'a mut W {
                self.variant(OsrW::_11110)
            }
            # [ doc = "Oversampling ratio of 32." ]
            # [ inline ( always ) ]
            pub fn _11111(self) -> &'a mut W {
                self.variant(OsrW::_11111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M10`" ]
        pub enum M10W {
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            _1,
        }
        impl M10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    M10W::_0 => 0,
                    M10W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _M10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _M10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: M10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 7-bit to 9-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(M10W::_0)
            }
            # [ doc = "Receiver and transmitter use 10-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(M10W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAEN2`" ]
        pub enum Maen2W {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            _1,
        }
        impl Maen2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Maen2W::_0 => 0,
                    Maen2W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Maen2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Maen2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Maen2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Maen2W::_0)
            }
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA2]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Maen2W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MAEN1`" ]
        pub enum Maen1W {
            # [ doc = "Normal operation." ]
            _0,
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            _1,
        }
        impl Maen1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Maen1W::_0 => 0,
                    Maen1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Maen1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Maen1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Maen1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Maen1W::_0)
            }
            # [ doc = "Enables automatic address matching or data matching mode for MATCH[MA1]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Maen1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:12 - Baud Rate Modulo Divisor." ]
            # [ inline ( always ) ]
            pub fn sbr(&self) -> SbrR {
                let bits = {
                    const MASK: u16 = 8191;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                SbrR { bits }
            }
            # [ doc = "Bit 13 - Stop Bit Number Select" ]
            # [ inline ( always ) ]
            pub fn sbns(&self) -> SbnsR {
                SbnsR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 13;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - RX Input Active Edge Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxedgie(&self) -> RxedgieR {
                RxedgieR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - LIN Break Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lbkdie(&self) -> LbkdieR {
                LbkdieR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 15;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Resynchronization Disable" ]
            # [ inline ( always ) ]
            pub fn resyncdis(&self) -> ResyncdisR {
                ResyncdisR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 16;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 17 - Both Edge Sampling" ]
            # [ inline ( always ) ]
            pub fn bothedge(&self) -> BothedgeR {
                BothedgeR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 17;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 18:19 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&self) -> MatcfgR {
                MatcfgR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 18;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 20 - Receiver Idle DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ridmae(&self) -> RidmaeR {
                RidmaeR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 20;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 21 - Receiver Full DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdmae(&self) -> RdmaeR {
                RdmaeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 21;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 23 - Transmitter DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdmae(&self) -> TdmaeR {
                TdmaeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 23;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 24:28 - Oversampling Ratio" ]
            # [ inline ( always ) ]
            pub fn osr(&self) -> OsrR {
                OsrR::_from({
                                const MASK: u8 = 31;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 29 - 10-bit Mode select" ]
            # [ inline ( always ) ]
            pub fn m10(&self) -> M10R {
                M10R::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 29;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - Match Address Mode Enable 2" ]
            # [ inline ( always ) ]
            pub fn maen2(&self) -> Maen2R {
                Maen2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Match Address Mode Enable 1" ]
            # [ inline ( always ) ]
            pub fn maen1(&self) -> Maen1R {
                Maen1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 251658244 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:12 - Baud Rate Modulo Divisor." ]
            # [ inline ( always ) ]
            pub fn sbr(&mut self) -> _SbrW {
                _SbrW { w: self }
            }
            # [ doc = "Bit 13 - Stop Bit Number Select" ]
            # [ inline ( always ) ]
            pub fn sbns(&mut self) -> _SbnsW {
                _SbnsW { w: self }
            }
            # [ doc = "Bit 14 - RX Input Active Edge Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxedgie(&mut self) -> _RxedgieW {
                _RxedgieW { w: self }
            }
            # [ doc = "Bit 15 - LIN Break Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lbkdie(&mut self) -> _LbkdieW {
                _LbkdieW { w: self }
            }
            # [ doc = "Bit 16 - Resynchronization Disable" ]
            # [ inline ( always ) ]
            pub fn resyncdis(&mut self) -> _ResyncdisW {
                _ResyncdisW { w: self }
            }
            # [ doc = "Bit 17 - Both Edge Sampling" ]
            # [ inline ( always ) ]
            pub fn bothedge(&mut self) -> _BothedgeW {
                _BothedgeW { w: self }
            }
            # [ doc = "Bits 18:19 - Match Configuration" ]
            # [ inline ( always ) ]
            pub fn matcfg(&mut self) -> _MatcfgW {
                _MatcfgW { w: self }
            }
            # [ doc = "Bit 20 - Receiver Idle DMA Enable" ]
            # [ inline ( always ) ]
            pub fn ridmae(&mut self) -> _RidmaeW {
                _RidmaeW { w: self }
            }
            # [ doc = "Bit 21 - Receiver Full DMA Enable" ]
            # [ inline ( always ) ]
            pub fn rdmae(&mut self) -> _RdmaeW {
                _RdmaeW { w: self }
            }
            # [ doc = "Bit 23 - Transmitter DMA Enable" ]
            # [ inline ( always ) ]
            pub fn tdmae(&mut self) -> _TdmaeW {
                _TdmaeW { w: self }
            }
            # [ doc = "Bits 24:28 - Oversampling Ratio" ]
            # [ inline ( always ) ]
            pub fn osr(&mut self) -> _OsrW {
                _OsrW { w: self }
            }
            # [ doc = "Bit 29 - 10-bit Mode select" ]
            # [ inline ( always ) ]
            pub fn m10(&mut self) -> _M10W {
                _M10W { w: self }
            }
            # [ doc = "Bit 30 - Match Address Mode Enable 2" ]
            # [ inline ( always ) ]
            pub fn maen2(&mut self) -> _Maen2W {
                _Maen2W { w: self }
            }
            # [ doc = "Bit 31 - Match Address Mode Enable 1" ]
            # [ inline ( always ) ]
            pub fn maen1(&mut self) -> _Maen1W {
                _Maen1W { w: self }
            }
        }
    }
    # [ doc = "LPUART Status Register" ]
    pub struct Stat {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Status Register" ]
    pub mod stat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Stat {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `MA2F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma2fR {
            # [ doc = "Received data is not equal to MA2" ]
            _0,
            # [ doc = "Received data is equal to MA2" ]
            _1,
        }
        impl Ma2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma2fR::_0 => 0,
                    Ma2fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma2fR {
                match bits {
                    0 => Ma2fR::_0,
                    1 => Ma2fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma2fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma2fR::_1
            }
        }
        # [ doc = "Possible values of the field `MA1F`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma1fR {
            # [ doc = "Received data is not equal to MA1" ]
            _0,
            # [ doc = "Received data is equal to MA1" ]
            _1,
        }
        impl Ma1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma1fR::_0 => 0,
                    Ma1fR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma1fR {
                match bits {
                    0 => Ma1fR::_0,
                    1 => Ma1fR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma1fR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma1fR::_1
            }
        }
        # [ doc = "Possible values of the field `PF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PfR {
            # [ doc = "No parity error." ]
            _0,
            # [ doc = "Parity error." ]
            _1,
        }
        impl PfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PfR::_0 => 0,
                    PfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PfR {
                match bits {
                    0 => PfR::_0,
                    1 => PfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PfR::_1
            }
        }
        # [ doc = "Possible values of the field `FE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeR {
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            _0,
            # [ doc = "Framing error." ]
            _1,
        }
        impl FeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeR::_0 => 0,
                    FeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeR {
                match bits {
                    0 => FeR::_0,
                    1 => FeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeR::_1
            }
        }
        # [ doc = "Possible values of the field `NF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NfR {
            # [ doc = "No noise detected." ]
            _0,
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            _1,
        }
        impl NfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NfR::_0 => 0,
                    NfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NfR {
                match bits {
                    0 => NfR::_0,
                    1 => NfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NfR::_1
            }
        }
        # [ doc = "Possible values of the field `OR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OrR {
            # [ doc = "No overrun." ]
            _0,
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            _1,
        }
        impl OrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OrR::_0 => 0,
                    OrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OrR {
                match bits {
                    0 => OrR::_0,
                    1 => OrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OrR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdleR {
            # [ doc = "No idle line detected." ]
            _0,
            # [ doc = "Idle line was detected." ]
            _1,
        }
        impl IdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdleR::_0 => 0,
                    IdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdleR {
                match bits {
                    0 => IdleR::_0,
                    1 => IdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdleR::_1
            }
        }
        # [ doc = "Possible values of the field `RDRF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RdrfR {
            # [ doc = "Receive data buffer empty." ]
            _0,
            # [ doc = "Receive data buffer full." ]
            _1,
        }
        impl RdrfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RdrfR::_0 => 0,
                    RdrfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RdrfR {
                match bits {
                    0 => RdrfR::_0,
                    1 => RdrfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RdrfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RdrfR::_1
            }
        }
        # [ doc = "Possible values of the field `TC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcR {
            # [ doc = "Transmitter active (sending data, a preamble, or a break)." ]
            _0,
            # [ doc = "Transmitter idle (transmission activity complete)." ]
            _1,
        }
        impl TcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcR::_0 => 0,
                    TcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcR {
                match bits {
                    0 => TcR::_0,
                    1 => TcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcR::_1
            }
        }
        # [ doc = "Possible values of the field `TDRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdreR {
            # [ doc = "Transmit data buffer full." ]
            _0,
            # [ doc = "Transmit data buffer empty." ]
            _1,
        }
        impl TdreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdreR::_0 => 0,
                    TdreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdreR {
                match bits {
                    0 => TdreR::_0,
                    1 => TdreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdreR::_1
            }
        }
        # [ doc = "Possible values of the field `RAF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RafR {
            # [ doc = "LPUART receiver idle waiting for a start bit." ]
            _0,
            # [ doc = "LPUART receiver active (RXD input not idle)." ]
            _1,
        }
        impl RafR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RafR::_0 => 0,
                    RafR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RafR {
                match bits {
                    0 => RafR::_0,
                    1 => RafR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RafR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RafR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdeR {
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            _0,
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            _1,
        }
        impl LbkdeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdeR::_0 => 0,
                    LbkdeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdeR {
                match bits {
                    0 => LbkdeR::_0,
                    1 => LbkdeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdeR::_1
            }
        }
        # [ doc = "Possible values of the field `BRK13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Brk13R {
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            _0,
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            _1,
        }
        impl Brk13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Brk13R::_0 => 0,
                    Brk13R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Brk13R {
                match bits {
                    0 => Brk13R::_0,
                    1 => Brk13R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Brk13R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Brk13R::_1
            }
        }
        # [ doc = "Possible values of the field `RWUID`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwuidR {
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            _0,
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            _1,
        }
        impl RwuidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwuidR::_0 => 0,
                    RwuidR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwuidR {
                match bits {
                    0 => RwuidR::_0,
                    1 => RwuidR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwuidR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwuidR::_1
            }
        }
        # [ doc = "Possible values of the field `RXINV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxinvR {
            # [ doc = "Receive data not inverted." ]
            _0,
            # [ doc = "Receive data inverted." ]
            _1,
        }
        impl RxinvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxinvR::_0 => 0,
                    RxinvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxinvR {
                match bits {
                    0 => RxinvR::_0,
                    1 => RxinvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxinvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxinvR::_1
            }
        }
        # [ doc = "Possible values of the field `MSBF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MsbfR {
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            _0,
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            _1,
        }
        impl MsbfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MsbfR::_0 => 0,
                    MsbfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MsbfR {
                match bits {
                    0 => MsbfR::_0,
                    1 => MsbfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MsbfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MsbfR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEDGIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxedgifR {
            # [ doc = "No active edge on the receive pin has occurred." ]
            _0,
            # [ doc = "An active edge on the receive pin has occurred." ]
            _1,
        }
        impl RxedgifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxedgifR::_0 => 0,
                    RxedgifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxedgifR {
                match bits {
                    0 => RxedgifR::_0,
                    1 => RxedgifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxedgifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxedgifR::_1
            }
        }
        # [ doc = "Possible values of the field `LBKDIF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LbkdifR {
            # [ doc = "No LIN break character has been detected." ]
            _0,
            # [ doc = "LIN break character has been detected." ]
            _1,
        }
        impl LbkdifR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LbkdifR::_0 => 0,
                    LbkdifR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LbkdifR {
                match bits {
                    0 => LbkdifR::_0,
                    1 => LbkdifR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LbkdifR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LbkdifR::_1
            }
        }
        # [ doc = "Values that can be written to the field `MA2F`" ]
        pub enum Ma2fW {
            # [ doc = "Received data is not equal to MA2" ]
            _0,
            # [ doc = "Received data is equal to MA2" ]
            _1,
        }
        impl Ma2fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma2fW::_0 => 0,
                    Ma2fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma2fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is not equal to MA2" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma2fW::_0)
            }
            # [ doc = "Received data is equal to MA2" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma2fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA1F`" ]
        pub enum Ma1fW {
            # [ doc = "Received data is not equal to MA1" ]
            _0,
            # [ doc = "Received data is equal to MA1" ]
            _1,
        }
        impl Ma1fW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma1fW::_0 => 0,
                    Ma1fW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1fW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma1fW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Received data is not equal to MA1" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma1fW::_0)
            }
            # [ doc = "Received data is equal to MA1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma1fW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PF`" ]
        pub enum PfW {
            # [ doc = "No parity error." ]
            _0,
            # [ doc = "Parity error." ]
            _1,
        }
        impl PfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PfW::_0 => 0,
                    PfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No parity error." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PfW::_0)
            }
            # [ doc = "Parity error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FE`" ]
        pub enum FeW {
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            _0,
            # [ doc = "Framing error." ]
            _1,
        }
        impl FeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeW::_0 => 0,
                    FeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No framing error detected. This does not guarantee the framing is correct." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeW::_0)
            }
            # [ doc = "Framing error." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NF`" ]
        pub enum NfW {
            # [ doc = "No noise detected." ]
            _0,
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            _1,
        }
        impl NfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NfW::_0 => 0,
                    NfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No noise detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NfW::_0)
            }
            # [ doc = "Noise detected in the received character in LPUART_DATA." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OR`" ]
        pub enum OrW {
            # [ doc = "No overrun." ]
            _0,
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            _1,
        }
        impl OrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OrW::_0 => 0,
                    OrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No overrun." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OrW::_0)
            }
            # [ doc = "Receive overrun (new LPUART data lost)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDLE`" ]
        pub enum IdleW {
            # [ doc = "No idle line detected." ]
            _0,
            # [ doc = "Idle line was detected." ]
            _1,
        }
        impl IdleW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdleW::_0 => 0,
                    IdleW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdleW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdleW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdleW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No idle line detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IdleW::_0)
            }
            # [ doc = "Idle line was detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IdleW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDE`" ]
        pub enum LbkdeW {
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            _0,
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            _1,
        }
        impl LbkdeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdeW::_0 => 0,
                    LbkdeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LIN break detect is disabled, normal break character can be detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdeW::_0)
            }
            # [ doc = "LIN break detect is enabled. LIN break character is detected at length of 11 bit times (if M = 0) or 12 (if M = 1) or 13 (M10 = 1)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `BRK13`" ]
        pub enum Brk13W {
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            _0,
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            _1,
        }
        impl Brk13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Brk13W::_0 => 0,
                    Brk13W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Brk13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Brk13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Brk13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Break character is transmitted with length of 9 to 13 bit times." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Brk13W::_0)
            }
            # [ doc = "Break character is transmitted with length of 12 to 15 bit times." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Brk13W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWUID`" ]
        pub enum RwuidW {
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            _0,
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            _1,
        }
        impl RwuidW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwuidW::_0 => 0,
                    RwuidW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwuidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwuidW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwuidW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit does not get set upon detection of an idle character. During address match wakeup, the IDLE bit does not set when an address does not match." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwuidW::_0)
            }
            # [ doc = "During receive standby state (RWU = 1), the IDLE bit gets set upon detection of an idle character. During address match wakeup, the IDLE bit does set when an address does not match." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwuidW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXINV`" ]
        pub enum RxinvW {
            # [ doc = "Receive data not inverted." ]
            _0,
            # [ doc = "Receive data inverted." ]
            _1,
        }
        impl RxinvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxinvW::_0 => 0,
                    RxinvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxinvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxinvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxinvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive data not inverted." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxinvW::_0)
            }
            # [ doc = "Receive data inverted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxinvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MSBF`" ]
        pub enum MsbfW {
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            _0,
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            _1,
        }
        impl MsbfW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MsbfW::_0 => 0,
                    MsbfW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MsbfW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MsbfW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MsbfW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LSB (bit0) is the first bit that is transmitted following the start bit. Further, the first bit received after the start bit is identified as bit0." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MsbfW::_0)
            }
            # [ doc = "MSB (bit9, bit8, bit7 or bit6) is the first bit that is transmitted following the start bit depending on the setting of CTRL[M], CTRL[PE] and BAUD[M10]. Further, the first bit received after the start bit is identified as bit9, bit8, bit7 or bit6 depending on the setting of CTRL[M] and CTRL[PE]." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MsbfW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXEDGIF`" ]
        pub enum RxedgifW {
            # [ doc = "No active edge on the receive pin has occurred." ]
            _0,
            # [ doc = "An active edge on the receive pin has occurred." ]
            _1,
        }
        impl RxedgifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxedgifW::_0 => 0,
                    RxedgifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxedgifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxedgifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxedgifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No active edge on the receive pin has occurred." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxedgifW::_0)
            }
            # [ doc = "An active edge on the receive pin has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxedgifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LBKDIF`" ]
        pub enum LbkdifW {
            # [ doc = "No LIN break character has been detected." ]
            _0,
            # [ doc = "LIN break character has been detected." ]
            _1,
        }
        impl LbkdifW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LbkdifW::_0 => 0,
                    LbkdifW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LbkdifW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LbkdifW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LbkdifW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No LIN break character has been detected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LbkdifW::_0)
            }
            # [ doc = "LIN break character has been detected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LbkdifW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 14 - Match 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ma2f(&self) -> Ma2fR {
                Ma2fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 15 - Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ma1f(&self) -> Ma1fR {
                Ma1fR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 15;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Parity Error Flag" ]
            # [ inline ( always ) ]
            pub fn pf(&self) -> PfR {
                PfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 17 - Framing Error Flag" ]
            # [ inline ( always ) ]
            pub fn fe(&self) -> FeR {
                FeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 17;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 18 - Noise Flag" ]
            # [ inline ( always ) ]
            pub fn nf(&self) -> NfR {
                NfR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 19 - Receiver Overrun Flag" ]
            # [ inline ( always ) ]
            pub fn or(&self) -> OrR {
                OrR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 19;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 20 - Idle Line Flag" ]
            # [ inline ( always ) ]
            pub fn idle(&self) -> IdleR {
                IdleR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Receive Data Register Full Flag" ]
            # [ inline ( always ) ]
            pub fn rdrf(&self) -> RdrfR {
                RdrfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 21;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Transmission Complete Flag" ]
            # [ inline ( always ) ]
            pub fn tc(&self) -> TcR {
                TcR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 22;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 23 - Transmit Data Register Empty Flag" ]
            # [ inline ( always ) ]
            pub fn tdre(&self) -> TdreR {
                TdreR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 23;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - Receiver Active Flag" ]
            # [ inline ( always ) ]
            pub fn raf(&self) -> RafR {
                RafR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 24;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 25 - LIN Break Detection Enable" ]
            # [ inline ( always ) ]
            pub fn lbkde(&self) -> LbkdeR {
                LbkdeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - Break Character Generation Length" ]
            # [ inline ( always ) ]
            pub fn brk13(&self) -> Brk13R {
                Brk13R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 26;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 27 - Receive Wake Up Idle Detect" ]
            # [ inline ( always ) ]
            pub fn rwuid(&self) -> RwuidR {
                RwuidR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 27;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - Receive Data Inversion" ]
            # [ inline ( always ) ]
            pub fn rxinv(&self) -> RxinvR {
                RxinvR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - MSB First" ]
            # [ inline ( always ) ]
            pub fn msbf(&self) -> MsbfR {
                MsbfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - RXD Pin Active Edge Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rxedgif(&self) -> RxedgifR {
                RxedgifR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 30;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 31 - LIN Break Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn lbkdif(&self) -> LbkdifR {
                LbkdifR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 31;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12582912 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 14 - Match 2 Flag" ]
            # [ inline ( always ) ]
            pub fn ma2f(&mut self) -> _Ma2fW {
                _Ma2fW { w: self }
            }
            # [ doc = "Bit 15 - Match 1 Flag" ]
            # [ inline ( always ) ]
            pub fn ma1f(&mut self) -> _Ma1fW {
                _Ma1fW { w: self }
            }
            # [ doc = "Bit 16 - Parity Error Flag" ]
            # [ inline ( always ) ]
            pub fn pf(&mut self) -> _PfW {
                _PfW { w: self }
            }
            # [ doc = "Bit 17 - Framing Error Flag" ]
            # [ inline ( always ) ]
            pub fn fe(&mut self) -> _FeW {
                _FeW { w: self }
            }
            # [ doc = "Bit 18 - Noise Flag" ]
            # [ inline ( always ) ]
            pub fn nf(&mut self) -> _NfW {
                _NfW { w: self }
            }
            # [ doc = "Bit 19 - Receiver Overrun Flag" ]
            # [ inline ( always ) ]
            pub fn or(&mut self) -> _OrW {
                _OrW { w: self }
            }
            # [ doc = "Bit 20 - Idle Line Flag" ]
            # [ inline ( always ) ]
            pub fn idle(&mut self) -> _IdleW {
                _IdleW { w: self }
            }
            # [ doc = "Bit 25 - LIN Break Detection Enable" ]
            # [ inline ( always ) ]
            pub fn lbkde(&mut self) -> _LbkdeW {
                _LbkdeW { w: self }
            }
            # [ doc = "Bit 26 - Break Character Generation Length" ]
            # [ inline ( always ) ]
            pub fn brk13(&mut self) -> _Brk13W {
                _Brk13W { w: self }
            }
            # [ doc = "Bit 27 - Receive Wake Up Idle Detect" ]
            # [ inline ( always ) ]
            pub fn rwuid(&mut self) -> _RwuidW {
                _RwuidW { w: self }
            }
            # [ doc = "Bit 28 - Receive Data Inversion" ]
            # [ inline ( always ) ]
            pub fn rxinv(&mut self) -> _RxinvW {
                _RxinvW { w: self }
            }
            # [ doc = "Bit 29 - MSB First" ]
            # [ inline ( always ) ]
            pub fn msbf(&mut self) -> _MsbfW {
                _MsbfW { w: self }
            }
            # [ doc = "Bit 30 - RXD Pin Active Edge Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn rxedgif(&mut self) -> _RxedgifW {
                _RxedgifW { w: self }
            }
            # [ doc = "Bit 31 - LIN Break Detect Interrupt Flag" ]
            # [ inline ( always ) ]
            pub fn lbkdif(&mut self) -> _LbkdifW {
                _LbkdifW { w: self }
            }
        }
    }
    # [ doc = "LPUART Control Register" ]
    pub struct Ctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Control Register" ]
    pub mod ctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `PT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PtR {
            # [ doc = "Even parity." ]
            _0,
            # [ doc = "Odd parity." ]
            _1,
        }
        impl PtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PtR::_0 => 0,
                    PtR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PtR {
                match bits {
                    0 => PtR::_0,
                    1 => PtR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PtR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PtR::_1
            }
        }
        # [ doc = "Possible values of the field `PE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeR {
            # [ doc = "No hardware parity generation or checking." ]
            _0,
            # [ doc = "Parity enabled." ]
            _1,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeR::_0 => 0,
                    PeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeR {
                match bits {
                    0 => PeR::_0,
                    1 => PeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeR::_1
            }
        }
        # [ doc = "Possible values of the field `ILT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IltR {
            # [ doc = "Idle character bit count starts after start bit." ]
            _0,
            # [ doc = "Idle character bit count starts after stop bit." ]
            _1,
        }
        impl IltR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IltR::_0 => 0,
                    IltR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IltR {
                match bits {
                    0 => IltR::_0,
                    1 => IltR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IltR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IltR::_1
            }
        }
        # [ doc = "Possible values of the field `WAKE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WakeR {
            # [ doc = "Configures RWU for idle-line wakeup." ]
            _0,
            # [ doc = "Configures RWU with address-mark wakeup." ]
            _1,
        }
        impl WakeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WakeR::_0 => 0,
                    WakeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WakeR {
                match bits {
                    0 => WakeR::_0,
                    1 => WakeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WakeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WakeR::_1
            }
        }
        # [ doc = "Possible values of the field `M`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MR {
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            _1,
        }
        impl MR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MR::_0 => 0,
                    MR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MR {
                match bits {
                    0 => MR::_0,
                    1 => MR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MR::_1
            }
        }
        # [ doc = "Possible values of the field `RSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RsrcR {
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            _0,
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            _1,
        }
        impl RsrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RsrcR::_0 => 0,
                    RsrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RsrcR {
                match bits {
                    0 => RsrcR::_0,
                    1 => RsrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RsrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RsrcR::_1
            }
        }
        # [ doc = "Possible values of the field `DOZEEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DozeenR {
            # [ doc = "LPUART is enabled in Doze mode." ]
            _0,
            # [ doc = "LPUART is disabled in Doze mode." ]
            _1,
        }
        impl DozeenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DozeenR::_0 => 0,
                    DozeenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DozeenR {
                match bits {
                    0 => DozeenR::_0,
                    1 => DozeenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DozeenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DozeenR::_1
            }
        }
        # [ doc = "Possible values of the field `LOOPS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LoopsR {
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            _0,
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            _1,
        }
        impl LoopsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LoopsR::_0 => 0,
                    LoopsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LoopsR {
                match bits {
                    0 => LoopsR::_0,
                    1 => LoopsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LoopsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LoopsR::_1
            }
        }
        # [ doc = "Possible values of the field `IDLECFG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdlecfgR {
            # [ doc = "1 idle character" ]
            _000,
            # [ doc = "2 idle characters" ]
            _001,
            # [ doc = "4 idle characters" ]
            _010,
            # [ doc = "8 idle characters" ]
            _011,
            # [ doc = "16 idle characters" ]
            _100,
            # [ doc = "32 idle characters" ]
            _101,
            # [ doc = "64 idle characters" ]
            _110,
            # [ doc = "128 idle characters" ]
            _111,
        }
        impl IdlecfgR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdlecfgR::_000 => 0,
                    IdlecfgR::_001 => 1,
                    IdlecfgR::_010 => 2,
                    IdlecfgR::_011 => 3,
                    IdlecfgR::_100 => 4,
                    IdlecfgR::_101 => 5,
                    IdlecfgR::_110 => 6,
                    IdlecfgR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdlecfgR {
                match bits {
                    0 => IdlecfgR::_000,
                    1 => IdlecfgR::_001,
                    2 => IdlecfgR::_010,
                    3 => IdlecfgR::_011,
                    4 => IdlecfgR::_100,
                    5 => IdlecfgR::_101,
                    6 => IdlecfgR::_110,
                    7 => IdlecfgR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == IdlecfgR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == IdlecfgR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == IdlecfgR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == IdlecfgR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == IdlecfgR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == IdlecfgR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == IdlecfgR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == IdlecfgR::_111
            }
        }
        # [ doc = "Possible values of the field `M7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum M7R {
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            _1,
        }
        impl M7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    M7R::_0 => 0,
                    M7R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> M7R {
                match bits {
                    0 => M7R::_0,
                    1 => M7R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == M7R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == M7R::_1
            }
        }
        # [ doc = "Possible values of the field `MA2IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma2ieR {
            # [ doc = "MA2F interrupt disabled" ]
            _0,
            # [ doc = "MA2F interrupt enabled" ]
            _1,
        }
        impl Ma2ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma2ieR::_0 => 0,
                    Ma2ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma2ieR {
                match bits {
                    0 => Ma2ieR::_0,
                    1 => Ma2ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma2ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma2ieR::_1
            }
        }
        # [ doc = "Possible values of the field `MA1IE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ma1ieR {
            # [ doc = "MA1F interrupt disabled" ]
            _0,
            # [ doc = "MA1F interrupt enabled" ]
            _1,
        }
        impl Ma1ieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ma1ieR::_0 => 0,
                    Ma1ieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ma1ieR {
                match bits {
                    0 => Ma1ieR::_0,
                    1 => Ma1ieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ma1ieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ma1ieR::_1
            }
        }
        # [ doc = "Possible values of the field `SBK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SbkR {
            # [ doc = "Normal transmitter operation." ]
            _0,
            # [ doc = "Queue break character(s) to be sent." ]
            _1,
        }
        impl SbkR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SbkR::_0 => 0,
                    SbkR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SbkR {
                match bits {
                    0 => SbkR::_0,
                    1 => SbkR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SbkR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SbkR::_1
            }
        }
        # [ doc = "Possible values of the field `RWU`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RwuR {
            # [ doc = "Normal receiver operation." ]
            _0,
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            _1,
        }
        impl RwuR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RwuR::_0 => 0,
                    RwuR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RwuR {
                match bits {
                    0 => RwuR::_0,
                    1 => RwuR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RwuR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RwuR::_1
            }
        }
        # [ doc = "Possible values of the field `RE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ReR {
            # [ doc = "Receiver disabled." ]
            _0,
            # [ doc = "Receiver enabled." ]
            _1,
        }
        impl ReR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ReR::_0 => 0,
                    ReR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ReR {
                match bits {
                    0 => ReR::_0,
                    1 => ReR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ReR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ReR::_1
            }
        }
        # [ doc = "Possible values of the field `TE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TeR {
            # [ doc = "Transmitter disabled." ]
            _0,
            # [ doc = "Transmitter enabled." ]
            _1,
        }
        impl TeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TeR::_0 => 0,
                    TeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TeR {
                match bits {
                    0 => TeR::_0,
                    1 => TeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TeR::_1
            }
        }
        # [ doc = "Possible values of the field `ILIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IlieR {
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            _1,
        }
        impl IlieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IlieR::_0 => 0,
                    IlieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IlieR {
                match bits {
                    0 => IlieR::_0,
                    1 => IlieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IlieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IlieR::_1
            }
        }
        # [ doc = "Possible values of the field `RIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RieR {
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            _1,
        }
        impl RieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RieR::_0 => 0,
                    RieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RieR {
                match bits {
                    0 => RieR::_0,
                    1 => RieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RieR::_1
            }
        }
        # [ doc = "Possible values of the field `TCIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TcieR {
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            _1,
        }
        impl TcieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TcieR::_0 => 0,
                    TcieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TcieR {
                match bits {
                    0 => TcieR::_0,
                    1 => TcieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TcieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TcieR::_1
            }
        }
        # [ doc = "Possible values of the field `TIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TieR {
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            _1,
        }
        impl TieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TieR::_0 => 0,
                    TieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TieR {
                match bits {
                    0 => TieR::_0,
                    1 => TieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TieR::_1
            }
        }
        # [ doc = "Possible values of the field `PEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeieR {
            # [ doc = "PF interrupts disabled; use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when PF is set." ]
            _1,
        }
        impl PeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeieR::_0 => 0,
                    PeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeieR {
                match bits {
                    0 => PeieR::_0,
                    1 => PeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PeieR::_1
            }
        }
        # [ doc = "Possible values of the field `FEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeieR {
            # [ doc = "FE interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when FE is set." ]
            _1,
        }
        impl FeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FeieR::_0 => 0,
                    FeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FeieR {
                match bits {
                    0 => FeieR::_0,
                    1 => FeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FeieR::_1
            }
        }
        # [ doc = "Possible values of the field `NEIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NeieR {
            # [ doc = "NF interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when NF is set." ]
            _1,
        }
        impl NeieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NeieR::_0 => 0,
                    NeieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NeieR {
                match bits {
                    0 => NeieR::_0,
                    1 => NeieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NeieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NeieR::_1
            }
        }
        # [ doc = "Possible values of the field `ORIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OrieR {
            # [ doc = "OR interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when OR is set." ]
            _1,
        }
        impl OrieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OrieR::_0 => 0,
                    OrieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OrieR {
                match bits {
                    0 => OrieR::_0,
                    1 => OrieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OrieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OrieR::_1
            }
        }
        # [ doc = "Possible values of the field `TXINV`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxinvR {
            # [ doc = "Transmit data not inverted." ]
            _0,
            # [ doc = "Transmit data inverted." ]
            _1,
        }
        impl TxinvR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxinvR::_0 => 0,
                    TxinvR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxinvR {
                match bits {
                    0 => TxinvR::_0,
                    1 => TxinvR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxinvR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxinvR::_1
            }
        }
        # [ doc = "Possible values of the field `TXDIR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxdirR {
            # [ doc = "TXD pin is an input in single-wire mode." ]
            _0,
            # [ doc = "TXD pin is an output in single-wire mode." ]
            _1,
        }
        impl TxdirR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxdirR::_0 => 0,
                    TxdirR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxdirR {
                match bits {
                    0 => TxdirR::_0,
                    1 => TxdirR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxdirR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxdirR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R9t8R {
            bits: u8,
        }
        impl R9t8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R8t9R {
            bits: u8,
        }
        impl R8t9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `PT`" ]
        pub enum PtW {
            # [ doc = "Even parity." ]
            _0,
            # [ doc = "Odd parity." ]
            _1,
        }
        impl PtW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PtW::_0 => 0,
                    PtW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PtW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Even parity." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PtW::_0)
            }
            # [ doc = "Odd parity." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PtW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PE`" ]
        pub enum PeW {
            # [ doc = "No hardware parity generation or checking." ]
            _0,
            # [ doc = "Parity enabled." ]
            _1,
        }
        impl PeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeW::_0 => 0,
                    PeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No hardware parity generation or checking." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeW::_0)
            }
            # [ doc = "Parity enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ILT`" ]
        pub enum IltW {
            # [ doc = "Idle character bit count starts after start bit." ]
            _0,
            # [ doc = "Idle character bit count starts after stop bit." ]
            _1,
        }
        impl IltW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IltW::_0 => 0,
                    IltW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IltW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IltW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IltW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Idle character bit count starts after start bit." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IltW::_0)
            }
            # [ doc = "Idle character bit count starts after stop bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IltW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WAKE`" ]
        pub enum WakeW {
            # [ doc = "Configures RWU for idle-line wakeup." ]
            _0,
            # [ doc = "Configures RWU with address-mark wakeup." ]
            _1,
        }
        impl WakeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WakeW::_0 => 0,
                    WakeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WakeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WakeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WakeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Configures RWU for idle-line wakeup." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WakeW::_0)
            }
            # [ doc = "Configures RWU with address-mark wakeup." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WakeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M`" ]
        pub enum MW {
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            _1,
        }
        impl MW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MW::_0 => 0,
                    MW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 8-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MW::_0)
            }
            # [ doc = "Receiver and transmitter use 9-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RSRC`" ]
        pub enum RsrcW {
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            _0,
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            _1,
        }
        impl RsrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RsrcW::_0 => 0,
                    RsrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RsrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RsrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RsrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Provided LOOPS is set, RSRC is cleared, selects internal loop back mode and the LPUART does not use the RXD pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RsrcW::_0)
            }
            # [ doc = "Single-wire LPUART mode where the TXD pin is connected to the transmitter output and receiver input." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RsrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DOZEEN`" ]
        pub enum DozeenW {
            # [ doc = "LPUART is enabled in Doze mode." ]
            _0,
            # [ doc = "LPUART is disabled in Doze mode." ]
            _1,
        }
        impl DozeenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DozeenW::_0 => 0,
                    DozeenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DozeenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DozeenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DozeenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "LPUART is enabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DozeenW::_0)
            }
            # [ doc = "LPUART is disabled in Doze mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DozeenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOOPS`" ]
        pub enum LoopsW {
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            _0,
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            _1,
        }
        impl LoopsW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LoopsW::_0 => 0,
                    LoopsW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LoopsW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LoopsW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LoopsW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal operation - RXD and TXD use separate pins." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LoopsW::_0)
            }
            # [ doc = "Loop mode or single-wire mode where transmitter outputs are internally connected to receiver input (see RSRC bit)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LoopsW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IDLECFG`" ]
        pub enum IdlecfgW {
            # [ doc = "1 idle character" ]
            _000,
            # [ doc = "2 idle characters" ]
            _001,
            # [ doc = "4 idle characters" ]
            _010,
            # [ doc = "8 idle characters" ]
            _011,
            # [ doc = "16 idle characters" ]
            _100,
            # [ doc = "32 idle characters" ]
            _101,
            # [ doc = "64 idle characters" ]
            _110,
            # [ doc = "128 idle characters" ]
            _111,
        }
        impl IdlecfgW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IdlecfgW::_000 => 0,
                    IdlecfgW::_001 => 1,
                    IdlecfgW::_010 => 2,
                    IdlecfgW::_011 => 3,
                    IdlecfgW::_100 => 4,
                    IdlecfgW::_101 => 5,
                    IdlecfgW::_110 => 6,
                    IdlecfgW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IdlecfgW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IdlecfgW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IdlecfgW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1 idle character" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(IdlecfgW::_000)
            }
            # [ doc = "2 idle characters" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(IdlecfgW::_001)
            }
            # [ doc = "4 idle characters" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(IdlecfgW::_010)
            }
            # [ doc = "8 idle characters" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(IdlecfgW::_011)
            }
            # [ doc = "16 idle characters" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(IdlecfgW::_100)
            }
            # [ doc = "32 idle characters" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(IdlecfgW::_101)
            }
            # [ doc = "64 idle characters" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(IdlecfgW::_110)
            }
            # [ doc = "128 idle characters" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(IdlecfgW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `M7`" ]
        pub enum M7W {
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            _0,
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            _1,
        }
        impl M7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    M7W::_0 => 0,
                    M7W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _M7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _M7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: M7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver and transmitter use 8-bit to 10-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(M7W::_0)
            }
            # [ doc = "Receiver and transmitter use 7-bit data characters." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(M7W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA2IE`" ]
        pub enum Ma2ieW {
            # [ doc = "MA2F interrupt disabled" ]
            _0,
            # [ doc = "MA2F interrupt enabled" ]
            _1,
        }
        impl Ma2ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma2ieW::_0 => 0,
                    Ma2ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma2ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "MA2F interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma2ieW::_0)
            }
            # [ doc = "MA2F interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma2ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MA1IE`" ]
        pub enum Ma1ieW {
            # [ doc = "MA1F interrupt disabled" ]
            _0,
            # [ doc = "MA1F interrupt enabled" ]
            _1,
        }
        impl Ma1ieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Ma1ieW::_0 => 0,
                    Ma1ieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1ieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1ieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Ma1ieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "MA1F interrupt disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Ma1ieW::_0)
            }
            # [ doc = "MA1F interrupt enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Ma1ieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SBK`" ]
        pub enum SbkW {
            # [ doc = "Normal transmitter operation." ]
            _0,
            # [ doc = "Queue break character(s) to be sent." ]
            _1,
        }
        impl SbkW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SbkW::_0 => 0,
                    SbkW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SbkW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SbkW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SbkW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal transmitter operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SbkW::_0)
            }
            # [ doc = "Queue break character(s) to be sent." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SbkW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RWU`" ]
        pub enum RwuW {
            # [ doc = "Normal receiver operation." ]
            _0,
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            _1,
        }
        impl RwuW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RwuW::_0 => 0,
                    RwuW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RwuW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RwuW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RwuW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Normal receiver operation." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RwuW::_0)
            }
            # [ doc = "LPUART receiver in standby waiting for wakeup condition." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RwuW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RE`" ]
        pub enum ReW {
            # [ doc = "Receiver disabled." ]
            _0,
            # [ doc = "Receiver enabled." ]
            _1,
        }
        impl ReW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ReW::_0 => 0,
                    ReW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ReW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ReW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ReW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receiver disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ReW::_0)
            }
            # [ doc = "Receiver enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ReW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TE`" ]
        pub enum TeW {
            # [ doc = "Transmitter disabled." ]
            _0,
            # [ doc = "Transmitter enabled." ]
            _1,
        }
        impl TeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TeW::_0 => 0,
                    TeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmitter disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TeW::_0)
            }
            # [ doc = "Transmitter enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ILIE`" ]
        pub enum IlieW {
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            _1,
        }
        impl IlieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IlieW::_0 => 0,
                    IlieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IlieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IlieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IlieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from IDLE disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IlieW::_0)
            }
            # [ doc = "Hardware interrupt requested when IDLE flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IlieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RIE`" ]
        pub enum RieW {
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            _1,
        }
        impl RieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RieW::_0 => 0,
                    RieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from RDRF disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RieW::_0)
            }
            # [ doc = "Hardware interrupt requested when RDRF flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TCIE`" ]
        pub enum TcieW {
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            _1,
        }
        impl TcieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TcieW::_0 => 0,
                    TcieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TcieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TcieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TcieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from TC disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TcieW::_0)
            }
            # [ doc = "Hardware interrupt requested when TC flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TcieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TIE`" ]
        pub enum TieW {
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            _1,
        }
        impl TieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TieW::_0 => 0,
                    TieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupts from TDRE disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TieW::_0)
            }
            # [ doc = "Hardware interrupt requested when TDRE flag is 1." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PEIE`" ]
        pub enum PeieW {
            # [ doc = "PF interrupts disabled; use polling)." ]
            _0,
            # [ doc = "Hardware interrupt requested when PF is set." ]
            _1,
        }
        impl PeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PeieW::_0 => 0,
                    PeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "PF interrupts disabled; use polling)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when PF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FEIE`" ]
        pub enum FeieW {
            # [ doc = "FE interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when FE is set." ]
            _1,
        }
        impl FeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FeieW::_0 => 0,
                    FeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "FE interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when FE is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NEIE`" ]
        pub enum NeieW {
            # [ doc = "NF interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when NF is set." ]
            _1,
        }
        impl NeieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NeieW::_0 => 0,
                    NeieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NeieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NeieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NeieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "NF interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(NeieW::_0)
            }
            # [ doc = "Hardware interrupt requested when NF is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(NeieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ORIE`" ]
        pub enum OrieW {
            # [ doc = "OR interrupts disabled; use polling." ]
            _0,
            # [ doc = "Hardware interrupt requested when OR is set." ]
            _1,
        }
        impl OrieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OrieW::_0 => 0,
                    OrieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OrieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OrieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OrieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "OR interrupts disabled; use polling." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OrieW::_0)
            }
            # [ doc = "Hardware interrupt requested when OR is set." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OrieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXINV`" ]
        pub enum TxinvW {
            # [ doc = "Transmit data not inverted." ]
            _0,
            # [ doc = "Transmit data inverted." ]
            _1,
        }
        impl TxinvW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxinvW::_0 => 0,
                    TxinvW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxinvW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxinvW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxinvW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit data not inverted." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxinvW::_0)
            }
            # [ doc = "Transmit data inverted." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxinvW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXDIR`" ]
        pub enum TxdirW {
            # [ doc = "TXD pin is an input in single-wire mode." ]
            _0,
            # [ doc = "TXD pin is an output in single-wire mode." ]
            _1,
        }
        impl TxdirW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxdirW::_0 => 0,
                    TxdirW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxdirW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxdirW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxdirW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TXD pin is an input in single-wire mode." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxdirW::_0)
            }
            # [ doc = "TXD pin is an output in single-wire mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxdirW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9t8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9t8W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8t9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8t9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Parity Type" ]
            # [ inline ( always ) ]
            pub fn pt(&self) -> PtR {
                PtR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 0;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 1 - Parity Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                PeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 1;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 2 - Idle Line Type Select" ]
            # [ inline ( always ) ]
            pub fn ilt(&self) -> IltR {
                IltR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Receiver Wakeup Method Select" ]
            # [ inline ( always ) ]
            pub fn wake(&self) -> WakeR {
                WakeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 4 - 9-Bit or 8-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m(&self) -> MR {
                MR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 4;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
            # [ doc = "Bit 5 - Receiver Source Select" ]
            # [ inline ( always ) ]
            pub fn rsrc(&self) -> RsrcR {
                RsrcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozeen(&self) -> DozeenR {
                DozeenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 7 - Loop Mode Select" ]
            # [ inline ( always ) ]
            pub fn loops(&self) -> LoopsR {
                LoopsR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 7;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 8:10 - Idle Configuration" ]
            # [ inline ( always ) ]
            pub fn idlecfg(&self) -> IdlecfgR {
                IdlecfgR::_from({
                                    const MASK: u8 = 7;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 11 - 7-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m7(&self) -> M7R {
                M7R::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 11;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 14 - Match 2 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma2ie(&self) -> Ma2ieR {
                Ma2ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma1ie(&self) -> Ma1ieR {
                Ma1ieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - Send Break" ]
            # [ inline ( always ) ]
            pub fn sbk(&self) -> SbkR {
                SbkR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 17 - Receiver Wakeup Control" ]
            # [ inline ( always ) ]
            pub fn rwu(&self) -> RwuR {
                RwuR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Receiver Enable" ]
            # [ inline ( always ) ]
            pub fn re(&self) -> ReR {
                ReR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 19 - Transmitter Enable" ]
            # [ inline ( always ) ]
            pub fn te(&self) -> TeR {
                TeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 19;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 20 - Idle Line Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ilie(&self) -> IlieR {
                IlieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 21 - Receiver Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&self) -> RieR {
                RieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 21;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 22 - Transmission Complete Interrupt Enable for" ]
            # [ inline ( always ) ]
            pub fn tcie(&self) -> TcieR {
                TcieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 22;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 23 - Transmit Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&self) -> TieR {
                TieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 23;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 24 - Parity Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn peie(&self) -> PeieR {
                PeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 25 - Framing Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&self) -> FeieR {
                FeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 25;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 26 - Noise Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn neie(&self) -> NeieR {
                NeieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 26;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 27 - Overrun Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn orie(&self) -> OrieR {
                OrieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 27;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - Transmit Data Inversion" ]
            # [ inline ( always ) ]
            pub fn txinv(&self) -> TxinvR {
                TxinvR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 29 - TXD Pin Direction in Single-Wire Mode" ]
            # [ inline ( always ) ]
            pub fn txdir(&self) -> TxdirR {
                TxdirR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 29;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 30 - Receive Bit 9 / Transmit Bit 8" ]
            # [ inline ( always ) ]
            pub fn r9t8(&self) -> R9t8R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R9t8R { bits }
            }
            # [ doc = "Bit 31 - Receive Bit 8 / Transmit Bit 9" ]
            # [ inline ( always ) ]
            pub fn r8t9(&self) -> R8t9R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R8t9R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Parity Type" ]
            # [ inline ( always ) ]
            pub fn pt(&mut self) -> _PtW {
                _PtW { w: self }
            }
            # [ doc = "Bit 1 - Parity Enable" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
            # [ doc = "Bit 2 - Idle Line Type Select" ]
            # [ inline ( always ) ]
            pub fn ilt(&mut self) -> _IltW {
                _IltW { w: self }
            }
            # [ doc = "Bit 3 - Receiver Wakeup Method Select" ]
            # [ inline ( always ) ]
            pub fn wake(&mut self) -> _WakeW {
                _WakeW { w: self }
            }
            # [ doc = "Bit 4 - 9-Bit or 8-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m(&mut self) -> _MW {
                _MW { w: self }
            }
            # [ doc = "Bit 5 - Receiver Source Select" ]
            # [ inline ( always ) ]
            pub fn rsrc(&mut self) -> _RsrcW {
                _RsrcW { w: self }
            }
            # [ doc = "Bit 6 - Doze Enable" ]
            # [ inline ( always ) ]
            pub fn dozeen(&mut self) -> _DozeenW {
                _DozeenW { w: self }
            }
            # [ doc = "Bit 7 - Loop Mode Select" ]
            # [ inline ( always ) ]
            pub fn loops(&mut self) -> _LoopsW {
                _LoopsW { w: self }
            }
            # [ doc = "Bits 8:10 - Idle Configuration" ]
            # [ inline ( always ) ]
            pub fn idlecfg(&mut self) -> _IdlecfgW {
                _IdlecfgW { w: self }
            }
            # [ doc = "Bit 11 - 7-Bit Mode Select" ]
            # [ inline ( always ) ]
            pub fn m7(&mut self) -> _M7W {
                _M7W { w: self }
            }
            # [ doc = "Bit 14 - Match 2 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma2ie(&mut self) -> _Ma2ieW {
                _Ma2ieW { w: self }
            }
            # [ doc = "Bit 15 - Match 1 Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ma1ie(&mut self) -> _Ma1ieW {
                _Ma1ieW { w: self }
            }
            # [ doc = "Bit 16 - Send Break" ]
            # [ inline ( always ) ]
            pub fn sbk(&mut self) -> _SbkW {
                _SbkW { w: self }
            }
            # [ doc = "Bit 17 - Receiver Wakeup Control" ]
            # [ inline ( always ) ]
            pub fn rwu(&mut self) -> _RwuW {
                _RwuW { w: self }
            }
            # [ doc = "Bit 18 - Receiver Enable" ]
            # [ inline ( always ) ]
            pub fn re(&mut self) -> _ReW {
                _ReW { w: self }
            }
            # [ doc = "Bit 19 - Transmitter Enable" ]
            # [ inline ( always ) ]
            pub fn te(&mut self) -> _TeW {
                _TeW { w: self }
            }
            # [ doc = "Bit 20 - Idle Line Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn ilie(&mut self) -> _IlieW {
                _IlieW { w: self }
            }
            # [ doc = "Bit 21 - Receiver Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rie(&mut self) -> _RieW {
                _RieW { w: self }
            }
            # [ doc = "Bit 22 - Transmission Complete Interrupt Enable for" ]
            # [ inline ( always ) ]
            pub fn tcie(&mut self) -> _TcieW {
                _TcieW { w: self }
            }
            # [ doc = "Bit 23 - Transmit Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn tie(&mut self) -> _TieW {
                _TieW { w: self }
            }
            # [ doc = "Bit 24 - Parity Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn peie(&mut self) -> _PeieW {
                _PeieW { w: self }
            }
            # [ doc = "Bit 25 - Framing Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn feie(&mut self) -> _FeieW {
                _FeieW { w: self }
            }
            # [ doc = "Bit 26 - Noise Error Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn neie(&mut self) -> _NeieW {
                _NeieW { w: self }
            }
            # [ doc = "Bit 27 - Overrun Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn orie(&mut self) -> _OrieW {
                _OrieW { w: self }
            }
            # [ doc = "Bit 28 - Transmit Data Inversion" ]
            # [ inline ( always ) ]
            pub fn txinv(&mut self) -> _TxinvW {
                _TxinvW { w: self }
            }
            # [ doc = "Bit 29 - TXD Pin Direction in Single-Wire Mode" ]
            # [ inline ( always ) ]
            pub fn txdir(&mut self) -> _TxdirW {
                _TxdirW { w: self }
            }
            # [ doc = "Bit 30 - Receive Bit 9 / Transmit Bit 8" ]
            # [ inline ( always ) ]
            pub fn r9t8(&mut self) -> _R9t8W {
                _R9t8W { w: self }
            }
            # [ doc = "Bit 31 - Receive Bit 8 / Transmit Bit 9" ]
            # [ inline ( always ) ]
            pub fn r8t9(&mut self) -> _R8t9W {
                _R8t9W { w: self }
            }
        }
    }
    # [ doc = "LPUART Data Register" ]
    pub struct Data {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Data Register" ]
    pub mod data {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Data {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R0t0R {
            bits: u8,
        }
        impl R0t0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R1t1R {
            bits: u8,
        }
        impl R1t1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R2t2R {
            bits: u8,
        }
        impl R2t2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R3t3R {
            bits: u8,
        }
        impl R3t3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R4t4R {
            bits: u8,
        }
        impl R4t4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R5t5R {
            bits: u8,
        }
        impl R5t5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R6t6R {
            bits: u8,
        }
        impl R6t6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R7t7R {
            bits: u8,
        }
        impl R7t7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R8t8R {
            bits: u8,
        }
        impl R8t8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct R9t9R {
            bits: u8,
        }
        impl R9t9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `IDLINE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IdlineR {
            # [ doc = "Receiver was not idle before receiving this character." ]
            _0,
            # [ doc = "Receiver was idle before receiving this character." ]
            _1,
        }
        impl IdlineR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IdlineR::_0 => 0,
                    IdlineR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IdlineR {
                match bits {
                    0 => IdlineR::_0,
                    1 => IdlineR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IdlineR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IdlineR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptR {
            # [ doc = "Receive buffer contains valid data." ]
            _0,
            # [ doc = "Receive buffer is empty, data returned on read is not valid." ]
            _1,
        }
        impl RxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptR::_0 => 0,
                    RxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptR {
                match bits {
                    0 => RxemptR::_0,
                    1 => RxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptR::_1
            }
        }
        # [ doc = "Possible values of the field `FRETSC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FretscR {
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            _0,
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            _1,
        }
        impl FretscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FretscR::_0 => 0,
                    FretscR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FretscR {
                match bits {
                    0 => FretscR::_0,
                    1 => FretscR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FretscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FretscR::_1
            }
        }
        # [ doc = "Possible values of the field `PARITYE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ParityeR {
            # [ doc = "The dataword was received without a parity error." ]
            _0,
            # [ doc = "The dataword was received with a parity error." ]
            _1,
        }
        impl ParityeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ParityeR::_0 => 0,
                    ParityeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ParityeR {
                match bits {
                    0 => ParityeR::_0,
                    1 => ParityeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ParityeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ParityeR::_1
            }
        }
        # [ doc = "Possible values of the field `NOISY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NoisyR {
            # [ doc = "The dataword was received without noise." ]
            _0,
            # [ doc = "The data was received with noise." ]
            _1,
        }
        impl NoisyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NoisyR::_0 => 0,
                    NoisyR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NoisyR {
                match bits {
                    0 => NoisyR::_0,
                    1 => NoisyR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == NoisyR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == NoisyR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R0t0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R0t0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R1t1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R1t1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R2t2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R2t2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R3t3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R3t3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R4t4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R4t4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R5t5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R5t5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R6t6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R6t6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R7t7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R7t7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8t8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8t8W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9t9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9t9W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FRETSC`" ]
        pub enum FretscW {
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            _0,
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            _1,
        }
        impl FretscW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FretscW::_0 => 0,
                    FretscW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FretscW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FretscW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FretscW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The dataword was received without a frame error on read, or transmit a normal character on write." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FretscW::_0)
            }
            # [ doc = "The dataword was received with a frame error, or transmit an idle or break character on transmit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FretscW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - R0T0" ]
            # [ inline ( always ) ]
            pub fn r0t0(&self) -> R0t0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R0t0R { bits }
            }
            # [ doc = "Bit 1 - R1T1" ]
            # [ inline ( always ) ]
            pub fn r1t1(&self) -> R1t1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 1;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R1t1R { bits }
            }
            # [ doc = "Bit 2 - R2T2" ]
            # [ inline ( always ) ]
            pub fn r2t2(&self) -> R2t2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R2t2R { bits }
            }
            # [ doc = "Bit 3 - R3T3" ]
            # [ inline ( always ) ]
            pub fn r3t3(&self) -> R3t3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R3t3R { bits }
            }
            # [ doc = "Bit 4 - R4T4" ]
            # [ inline ( always ) ]
            pub fn r4t4(&self) -> R4t4R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R4t4R { bits }
            }
            # [ doc = "Bit 5 - R5T5" ]
            # [ inline ( always ) ]
            pub fn r5t5(&self) -> R5t5R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 5;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R5t5R { bits }
            }
            # [ doc = "Bit 6 - R6T6" ]
            # [ inline ( always ) ]
            pub fn r6t6(&self) -> R6t6R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 6;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R6t6R { bits }
            }
            # [ doc = "Bit 7 - R7T7" ]
            # [ inline ( always ) ]
            pub fn r7t7(&self) -> R7t7R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R7t7R { bits }
            }
            # [ doc = "Bit 8 - R8T8" ]
            # [ inline ( always ) ]
            pub fn r8t8(&self) -> R8t8R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R8t8R { bits }
            }
            # [ doc = "Bit 9 - R9T9" ]
            # [ inline ( always ) ]
            pub fn r9t9(&self) -> R9t9R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 9;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                R9t9R { bits }
            }
            # [ doc = "Bit 11 - Idle Line" ]
            # [ inline ( always ) ]
            pub fn idline(&self) -> IdlineR {
                IdlineR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 12 - Receive Buffer Empty" ]
            # [ inline ( always ) ]
            pub fn rxempt(&self) -> RxemptR {
                RxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 12;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Frame Error / Transmit Special Character" ]
            # [ inline ( always ) ]
            pub fn fretsc(&self) -> FretscR {
                FretscR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 13;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 14 - PARITYE" ]
            # [ inline ( always ) ]
            pub fn paritye(&self) -> ParityeR {
                ParityeR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 14;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 15 - NOISY" ]
            # [ inline ( always ) ]
            pub fn noisy(&self) -> NoisyR {
                NoisyR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4096 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - R0T0" ]
            # [ inline ( always ) ]
            pub fn r0t0(&mut self) -> _R0t0W {
                _R0t0W { w: self }
            }
            # [ doc = "Bit 1 - R1T1" ]
            # [ inline ( always ) ]
            pub fn r1t1(&mut self) -> _R1t1W {
                _R1t1W { w: self }
            }
            # [ doc = "Bit 2 - R2T2" ]
            # [ inline ( always ) ]
            pub fn r2t2(&mut self) -> _R2t2W {
                _R2t2W { w: self }
            }
            # [ doc = "Bit 3 - R3T3" ]
            # [ inline ( always ) ]
            pub fn r3t3(&mut self) -> _R3t3W {
                _R3t3W { w: self }
            }
            # [ doc = "Bit 4 - R4T4" ]
            # [ inline ( always ) ]
            pub fn r4t4(&mut self) -> _R4t4W {
                _R4t4W { w: self }
            }
            # [ doc = "Bit 5 - R5T5" ]
            # [ inline ( always ) ]
            pub fn r5t5(&mut self) -> _R5t5W {
                _R5t5W { w: self }
            }
            # [ doc = "Bit 6 - R6T6" ]
            # [ inline ( always ) ]
            pub fn r6t6(&mut self) -> _R6t6W {
                _R6t6W { w: self }
            }
            # [ doc = "Bit 7 - R7T7" ]
            # [ inline ( always ) ]
            pub fn r7t7(&mut self) -> _R7t7W {
                _R7t7W { w: self }
            }
            # [ doc = "Bit 8 - R8T8" ]
            # [ inline ( always ) ]
            pub fn r8t8(&mut self) -> _R8t8W {
                _R8t8W { w: self }
            }
            # [ doc = "Bit 9 - R9T9" ]
            # [ inline ( always ) ]
            pub fn r9t9(&mut self) -> _R9t9W {
                _R9t9W { w: self }
            }
            # [ doc = "Bit 13 - Frame Error / Transmit Special Character" ]
            # [ inline ( always ) ]
            pub fn fretsc(&mut self) -> _FretscW {
                _FretscW { w: self }
            }
        }
    }
    # [ doc = "LPUART Match Address Register" ]
    pub struct Match {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Match Address Register" ]
    pub mod match_ {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Match {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ma1R {
            bits: u16,
        }
        impl Ma1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ma2R {
            bits: u16,
        }
        impl Ma2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ma2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ma2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 1023;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:9 - Match Address 1" ]
            # [ inline ( always ) ]
            pub fn ma1(&self) -> Ma1R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Ma1R { bits }
            }
            # [ doc = "Bits 16:25 - Match Address 2" ]
            # [ inline ( always ) ]
            pub fn ma2(&self) -> Ma2R {
                let bits = {
                    const MASK: u16 = 1023;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                Ma2R { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:9 - Match Address 1" ]
            # [ inline ( always ) ]
            pub fn ma1(&mut self) -> _Ma1W {
                _Ma1W { w: self }
            }
            # [ doc = "Bits 16:25 - Match Address 2" ]
            # [ inline ( always ) ]
            pub fn ma2(&mut self) -> _Ma2W {
                _Ma2W { w: self }
            }
        }
    }
    # [ doc = "LPUART Modem IrDA Register" ]
    pub struct Modir {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Modem IrDA Register" ]
    pub mod modir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Modir {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `TXCTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctseR {
            # [ doc = "CTS has no effect on the transmitter." ]
            _0,
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            _1,
        }
        impl TxctseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctseR::_0 => 0,
                    TxctseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctseR {
                match bits {
                    0 => TxctseR::_0,
                    1 => TxctseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctseR::_1
            }
        }
        # [ doc = "Possible values of the field `TXRTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxrtseR {
            # [ doc = "The transmitter has no effect on RTS." ]
            _0,
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            _1,
        }
        impl TxrtseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxrtseR::_0 => 0,
                    TxrtseR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxrtseR {
                match bits {
                    0 => TxrtseR::_0,
                    1 => TxrtseR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxrtseR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxrtseR::_1
            }
        }
        # [ doc = "Possible values of the field `TXRTSPOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxrtspolR {
            # [ doc = "Transmitter RTS is active low." ]
            _0,
            # [ doc = "Transmitter RTS is active high." ]
            _1,
        }
        impl TxrtspolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxrtspolR::_0 => 0,
                    TxrtspolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxrtspolR {
                match bits {
                    0 => TxrtspolR::_0,
                    1 => TxrtspolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxrtspolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxrtspolR::_1
            }
        }
        # [ doc = "Possible values of the field `RXRTSE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxrtseR {
            # [ doc = "The receiver has no effect on RTS." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RxrtseR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxrtseR::_0 => 0,
                    RxrtseR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxrtseR {
                match bits {
                    0 => RxrtseR::_0,
                    i => RxrtseR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxrtseR::_0
            }
        }
        # [ doc = "Possible values of the field `TXCTSC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctscR {
            # [ doc = "CTS input is sampled at the start of each character." ]
            _0,
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            _1,
        }
        impl TxctscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctscR::_0 => 0,
                    TxctscR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctscR {
                match bits {
                    0 => TxctscR::_0,
                    1 => TxctscR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctscR::_1
            }
        }
        # [ doc = "Possible values of the field `TXCTSSRC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxctssrcR {
            # [ doc = "CTS input is the CTS_B pin." ]
            _0,
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            _1,
        }
        impl TxctssrcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxctssrcR::_0 => 0,
                    TxctssrcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxctssrcR {
                match bits {
                    0 => TxctssrcR::_0,
                    1 => TxctssrcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxctssrcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxctssrcR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RtswaterR {
            bits: u8,
        }
        impl RtswaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `TNP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TnpR {
            # [ doc = "1/OSR." ]
            _00,
            # [ doc = "2/OSR." ]
            _01,
            # [ doc = "3/OSR." ]
            _10,
            # [ doc = "4/OSR." ]
            _11,
        }
        impl TnpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TnpR::_00 => 0,
                    TnpR::_01 => 1,
                    TnpR::_10 => 2,
                    TnpR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TnpR {
                match bits {
                    0 => TnpR::_00,
                    1 => TnpR::_01,
                    2 => TnpR::_10,
                    3 => TnpR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == TnpR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == TnpR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == TnpR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == TnpR::_11
            }
        }
        # [ doc = "Possible values of the field `IREN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IrenR {
            # [ doc = "IR disabled." ]
            _0,
            # [ doc = "IR enabled." ]
            _1,
        }
        impl IrenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IrenR::_0 => 0,
                    IrenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IrenR {
                match bits {
                    0 => IrenR::_0,
                    1 => IrenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IrenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IrenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSE`" ]
        pub enum TxctseW {
            # [ doc = "CTS has no effect on the transmitter." ]
            _0,
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            _1,
        }
        impl TxctseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctseW::_0 => 0,
                    TxctseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS has no effect on the transmitter." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctseW::_0)
            }
            # [ doc = "Enables clear-to-send operation. The transmitter checks the state of CTS each time it is ready to send a character. If CTS is asserted, the character is sent. If CTS is deasserted, the signal TXD remains in the mark state and transmission is delayed until CTS is asserted. Changes in CTS as a character is being sent do not affect its transmission." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXRTSE`" ]
        pub enum TxrtseW {
            # [ doc = "The transmitter has no effect on RTS." ]
            _0,
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            _1,
        }
        impl TxrtseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxrtseW::_0 => 0,
                    TxrtseW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxrtseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxrtseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxrtseW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The transmitter has no effect on RTS." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxrtseW::_0)
            }
            # [ doc = "When a character is placed into an empty transmitter data buffer , RTS asserts one bit time before the start bit is transmitted. RTS deasserts one bit time after all characters in the transmitter data buffer and shift register are completely sent, including the last stop bit." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxrtseW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXRTSPOL`" ]
        pub enum TxrtspolW {
            # [ doc = "Transmitter RTS is active low." ]
            _0,
            # [ doc = "Transmitter RTS is active high." ]
            _1,
        }
        impl TxrtspolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxrtspolW::_0 => 0,
                    TxrtspolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxrtspolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxrtspolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxrtspolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmitter RTS is active low." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxrtspolW::_0)
            }
            # [ doc = "Transmitter RTS is active high." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxrtspolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXRTSE`" ]
        pub enum RxrtseW {
            # [ doc = "The receiver has no effect on RTS." ]
            _0,
        }
        impl RxrtseW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxrtseW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxrtseW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxrtseW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxrtseW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The receiver has no effect on RTS." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxrtseW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSC`" ]
        pub enum TxctscW {
            # [ doc = "CTS input is sampled at the start of each character." ]
            _0,
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            _1,
        }
        impl TxctscW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctscW::_0 => 0,
                    TxctscW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctscW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctscW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctscW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS input is sampled at the start of each character." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctscW::_0)
            }
            # [ doc = "CTS input is sampled when the transmitter is idle." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctscW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXCTSSRC`" ]
        pub enum TxctssrcW {
            # [ doc = "CTS input is the CTS_B pin." ]
            _0,
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            _1,
        }
        impl TxctssrcW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxctssrcW::_0 => 0,
                    TxctssrcW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxctssrcW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxctssrcW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxctssrcW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "CTS input is the CTS_B pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxctssrcW::_0)
            }
            # [ doc = "CTS input is the inverted Receiver Match result." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxctssrcW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RtswaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RtswaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TNP`" ]
        pub enum TnpW {
            # [ doc = "1/OSR." ]
            _00,
            # [ doc = "2/OSR." ]
            _01,
            # [ doc = "3/OSR." ]
            _10,
            # [ doc = "4/OSR." ]
            _11,
        }
        impl TnpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TnpW::_00 => 0,
                    TnpW::_01 => 1,
                    TnpW::_10 => 2,
                    TnpW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TnpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TnpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TnpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "1/OSR." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(TnpW::_00)
            }
            # [ doc = "2/OSR." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(TnpW::_01)
            }
            # [ doc = "3/OSR." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(TnpW::_10)
            }
            # [ doc = "4/OSR." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(TnpW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IREN`" ]
        pub enum IrenW {
            # [ doc = "IR disabled." ]
            _0,
            # [ doc = "IR enabled." ]
            _1,
        }
        impl IrenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IrenW::_0 => 0,
                    IrenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IrenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IrenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IrenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "IR disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IrenW::_0)
            }
            # [ doc = "IR enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IrenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Transmitter clear-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txctse(&self) -> TxctseR {
                TxctseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Transmitter request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txrtse(&self) -> TxrtseR {
                TxrtseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Transmitter request-to-send polarity" ]
            # [ inline ( always ) ]
            pub fn txrtspol(&self) -> TxrtspolR {
                TxrtspolR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 3 - Receiver request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn rxrtse(&self) -> RxrtseR {
                RxrtseR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 3;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 4 - Transmit CTS Configuration" ]
            # [ inline ( always ) ]
            pub fn txctsc(&self) -> TxctscR {
                TxctscR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 4;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 5 - Transmit CTS Source" ]
            # [ inline ( always ) ]
            pub fn txctssrc(&self) -> TxctssrcR {
                TxctssrcR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 5;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:9 - Receive RTS Configuration" ]
            # [ inline ( always ) ]
            pub fn rtswater(&self) -> RtswaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RtswaterR { bits }
            }
            # [ doc = "Bits 16:17 - Transmitter narrow pulse" ]
            # [ inline ( always ) ]
            pub fn tnp(&self) -> TnpR {
                TnpR::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 16;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 18 - Infrared enable" ]
            # [ inline ( always ) ]
            pub fn iren(&self) -> IrenR {
                IrenR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 18;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Transmitter clear-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txctse(&mut self) -> _TxctseW {
                _TxctseW { w: self }
            }
            # [ doc = "Bit 1 - Transmitter request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn txrtse(&mut self) -> _TxrtseW {
                _TxrtseW { w: self }
            }
            # [ doc = "Bit 2 - Transmitter request-to-send polarity" ]
            # [ inline ( always ) ]
            pub fn txrtspol(&mut self) -> _TxrtspolW {
                _TxrtspolW { w: self }
            }
            # [ doc = "Bit 3 - Receiver request-to-send enable" ]
            # [ inline ( always ) ]
            pub fn rxrtse(&mut self) -> _RxrtseW {
                _RxrtseW { w: self }
            }
            # [ doc = "Bit 4 - Transmit CTS Configuration" ]
            # [ inline ( always ) ]
            pub fn txctsc(&mut self) -> _TxctscW {
                _TxctscW { w: self }
            }
            # [ doc = "Bit 5 - Transmit CTS Source" ]
            # [ inline ( always ) ]
            pub fn txctssrc(&mut self) -> _TxctssrcW {
                _TxctssrcW { w: self }
            }
            # [ doc = "Bits 8:9 - Receive RTS Configuration" ]
            # [ inline ( always ) ]
            pub fn rtswater(&mut self) -> _RtswaterW {
                _RtswaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Transmitter narrow pulse" ]
            # [ inline ( always ) ]
            pub fn tnp(&mut self) -> _TnpW {
                _TnpW { w: self }
            }
            # [ doc = "Bit 18 - Infrared enable" ]
            # [ inline ( always ) ]
            pub fn iren(&mut self) -> _IrenW {
                _IrenW { w: self }
            }
        }
    }
    # [ doc = "LPUART FIFO Register" ]
    pub struct Fifo {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART FIFO Register" ]
    pub mod fifo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Fifo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RXFIFOSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxfifosizeR {
            # [ doc = "Receive FIFO/Buffer depth = 1 dataword." ]
            _000,
            # [ doc = "Receive FIFO/Buffer depth = 4 datawords." ]
            _001,
            # [ doc = "Receive FIFO/Buffer depth = 8 datawords." ]
            _010,
            # [ doc = "Receive FIFO/Buffer depth = 16 datawords." ]
            _011,
            # [ doc = "Receive FIFO/Buffer depth = 32 datawords." ]
            _100,
            # [ doc = "Receive FIFO/Buffer depth = 64 datawords." ]
            _101,
            # [ doc = "Receive FIFO/Buffer depth = 128 datawords." ]
            _110,
            # [ doc = "Receive FIFO/Buffer depth = 256 datawords." ]
            _111,
        }
        impl RxfifosizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxfifosizeR::_000 => 0,
                    RxfifosizeR::_001 => 1,
                    RxfifosizeR::_010 => 2,
                    RxfifosizeR::_011 => 3,
                    RxfifosizeR::_100 => 4,
                    RxfifosizeR::_101 => 5,
                    RxfifosizeR::_110 => 6,
                    RxfifosizeR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxfifosizeR {
                match bits {
                    0 => RxfifosizeR::_000,
                    1 => RxfifosizeR::_001,
                    2 => RxfifosizeR::_010,
                    3 => RxfifosizeR::_011,
                    4 => RxfifosizeR::_100,
                    5 => RxfifosizeR::_101,
                    6 => RxfifosizeR::_110,
                    7 => RxfifosizeR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == RxfifosizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == RxfifosizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == RxfifosizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == RxfifosizeR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == RxfifosizeR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == RxfifosizeR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == RxfifosizeR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == RxfifosizeR::_111
            }
        }
        # [ doc = "Possible values of the field `RXFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxfeR {
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            _0,
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            _1,
        }
        impl RxfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxfeR::_0 => 0,
                    RxfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxfeR {
                match bits {
                    0 => RxfeR::_0,
                    1 => RxfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxfeR::_1
            }
        }
        # [ doc = "Possible values of the field `TXFIFOSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxfifosizeR {
            # [ doc = "Transmit FIFO/Buffer depth = 1 dataword." ]
            _000,
            # [ doc = "Transmit FIFO/Buffer depth = 4 datawords." ]
            _001,
            # [ doc = "Transmit FIFO/Buffer depth = 8 datawords." ]
            _010,
            # [ doc = "Transmit FIFO/Buffer depth = 16 datawords." ]
            _011,
            # [ doc = "Transmit FIFO/Buffer depth = 32 datawords." ]
            _100,
            # [ doc = "Transmit FIFO/Buffer depth = 64 datawords." ]
            _101,
            # [ doc = "Transmit FIFO/Buffer depth = 128 datawords." ]
            _110,
            # [ doc = "Transmit FIFO/Buffer depth = 256 datawords" ]
            _111,
        }
        impl TxfifosizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxfifosizeR::_000 => 0,
                    TxfifosizeR::_001 => 1,
                    TxfifosizeR::_010 => 2,
                    TxfifosizeR::_011 => 3,
                    TxfifosizeR::_100 => 4,
                    TxfifosizeR::_101 => 5,
                    TxfifosizeR::_110 => 6,
                    TxfifosizeR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxfifosizeR {
                match bits {
                    0 => TxfifosizeR::_000,
                    1 => TxfifosizeR::_001,
                    2 => TxfifosizeR::_010,
                    3 => TxfifosizeR::_011,
                    4 => TxfifosizeR::_100,
                    5 => TxfifosizeR::_101,
                    6 => TxfifosizeR::_110,
                    7 => TxfifosizeR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == TxfifosizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == TxfifosizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == TxfifosizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == TxfifosizeR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == TxfifosizeR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == TxfifosizeR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == TxfifosizeR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == TxfifosizeR::_111
            }
        }
        # [ doc = "Possible values of the field `TXFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxfeR {
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            _0,
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            _1,
        }
        impl TxfeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxfeR::_0 => 0,
                    TxfeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxfeR {
                match bits {
                    0 => TxfeR::_0,
                    1 => TxfeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxfeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxfeR::_1
            }
        }
        # [ doc = "Possible values of the field `RXUFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxufeR {
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            _1,
        }
        impl RxufeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxufeR::_0 => 0,
                    RxufeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxufeR {
                match bits {
                    0 => RxufeR::_0,
                    1 => RxufeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxufeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxufeR::_1
            }
        }
        # [ doc = "Possible values of the field `TXOFE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxofeR {
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            _1,
        }
        impl TxofeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxofeR::_0 => 0,
                    TxofeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxofeR {
                match bits {
                    0 => TxofeR::_0,
                    1 => TxofeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxofeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxofeR::_1
            }
        }
        # [ doc = "Possible values of the field `RXIDEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxidenR {
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            _000,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            _001,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            _010,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            _011,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            _100,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            _101,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            _110,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            _111,
        }
        impl RxidenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxidenR::_000 => 0,
                    RxidenR::_001 => 1,
                    RxidenR::_010 => 2,
                    RxidenR::_011 => 3,
                    RxidenR::_100 => 4,
                    RxidenR::_101 => 5,
                    RxidenR::_110 => 6,
                    RxidenR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxidenR {
                match bits {
                    0 => RxidenR::_000,
                    1 => RxidenR::_001,
                    2 => RxidenR::_010,
                    3 => RxidenR::_011,
                    4 => RxidenR::_100,
                    5 => RxidenR::_101,
                    6 => RxidenR::_110,
                    7 => RxidenR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == RxidenR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == RxidenR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == RxidenR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == RxidenR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == RxidenR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == RxidenR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == RxidenR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == RxidenR::_111
            }
        }
        # [ doc = "Possible values of the field `RXUF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxufR {
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl RxufR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxufR::_0 => 0,
                    RxufR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxufR {
                match bits {
                    0 => RxufR::_0,
                    1 => RxufR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxufR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxufR::_1
            }
        }
        # [ doc = "Possible values of the field `TXOF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxofR {
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl TxofR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxofR::_0 => 0,
                    TxofR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxofR {
                match bits {
                    0 => TxofR::_0,
                    1 => TxofR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxofR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxofR::_1
            }
        }
        # [ doc = "Possible values of the field `RXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RxemptR {
            # [ doc = "Receive buffer is not empty." ]
            _0,
            # [ doc = "Receive buffer is empty." ]
            _1,
        }
        impl RxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RxemptR::_0 => 0,
                    RxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RxemptR {
                match bits {
                    0 => RxemptR::_0,
                    1 => RxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RxemptR::_1
            }
        }
        # [ doc = "Possible values of the field `TXEMPT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TxemptR {
            # [ doc = "Transmit buffer is not empty." ]
            _0,
            # [ doc = "Transmit buffer is empty." ]
            _1,
        }
        impl TxemptR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TxemptR::_0 => 0,
                    TxemptR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TxemptR {
                match bits {
                    0 => TxemptR::_0,
                    1 => TxemptR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TxemptR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TxemptR::_1
            }
        }
        # [ doc = "Values that can be written to the field `RXFE`" ]
        pub enum RxfeW {
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            _0,
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            _1,
        }
        impl RxfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxfeW::_0 => 0,
                    RxfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Receive FIFO is not enabled. Buffer is depth 1. (Legacy support)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxfeW::_0)
            }
            # [ doc = "Receive FIFO is enabled. Buffer is depth indicted by RXFIFOSIZE." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXFE`" ]
        pub enum TxfeW {
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            _0,
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            _1,
        }
        impl TxfeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxfeW::_0 => 0,
                    TxfeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxfeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxfeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxfeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Transmit FIFO is not enabled. Buffer is depth 1. (Legacy support)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxfeW::_0)
            }
            # [ doc = "Transmit FIFO is enabled. Buffer is depth indicated by TXFIFOSIZE." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxfeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXUFE`" ]
        pub enum RxufeW {
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            _1,
        }
        impl RxufeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxufeW::_0 => 0,
                    RxufeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxufeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxufeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxufeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "RXUF flag does not generate an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxufeW::_0)
            }
            # [ doc = "RXUF flag generates an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxufeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXOFE`" ]
        pub enum TxofeW {
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            _0,
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            _1,
        }
        impl TxofeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxofeW::_0 => 0,
                    TxofeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxofeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxofeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxofeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "TXOF flag does not generate an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxofeW::_0)
            }
            # [ doc = "TXOF flag generates an interrupt to the host." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxofeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXIDEN`" ]
        pub enum RxidenW {
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            _000,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            _001,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            _010,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            _011,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            _100,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            _101,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            _110,
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            _111,
        }
        impl RxidenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxidenW::_000 => 0,
                    RxidenW::_001 => 1,
                    RxidenW::_010 => 2,
                    RxidenW::_011 => 3,
                    RxidenW::_100 => 4,
                    RxidenW::_101 => 5,
                    RxidenW::_110 => 6,
                    RxidenW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxidenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxidenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxidenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable RDRF assertion due to partially filled FIFO when receiver is idle." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(RxidenW::_000)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 1 character." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(RxidenW::_001)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 2 characters." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(RxidenW::_010)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 4 characters." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(RxidenW::_011)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 8 characters." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(RxidenW::_100)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 16 characters." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(RxidenW::_101)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 32 characters." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(RxidenW::_110)
            }
            # [ doc = "Enable RDRF assertion due to partially filled FIFO when receiver is idle for 64 characters." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(RxidenW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXFLUSH`" ]
        pub enum RxflushW {
            # [ doc = "No flush operation occurs." ]
            _0,
            # [ doc = "All data in the receive FIFO/buffer is cleared out." ]
            _1,
        }
        impl RxflushW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxflushW::_0 => 0,
                    RxflushW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxflushW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxflushW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxflushW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No flush operation occurs." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxflushW::_0)
            }
            # [ doc = "All data in the receive FIFO/buffer is cleared out." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxflushW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXFLUSH`" ]
        pub enum TxflushW {
            # [ doc = "No flush operation occurs." ]
            _0,
            # [ doc = "All data in the transmit FIFO/Buffer is cleared out." ]
            _1,
        }
        impl TxflushW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxflushW::_0 => 0,
                    TxflushW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxflushW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxflushW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxflushW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No flush operation occurs." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxflushW::_0)
            }
            # [ doc = "All data in the transmit FIFO/Buffer is cleared out." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxflushW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RXUF`" ]
        pub enum RxufW {
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl RxufW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RxufW::_0 => 0,
                    RxufW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxufW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxufW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RxufW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No receive buffer underflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RxufW::_0)
            }
            # [ doc = "At least one receive buffer underflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RxufW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TXOF`" ]
        pub enum TxofW {
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _0,
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            _1,
        }
        impl TxofW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TxofW::_0 => 0,
                    TxofW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxofW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxofW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TxofW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No transmit buffer overflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TxofW::_0)
            }
            # [ doc = "At least one transmit buffer overflow has occurred since the last time the flag was cleared." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TxofW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Receive FIFO. Buffer Depth" ]
            # [ inline ( always ) ]
            pub fn rxfifosize(&self) -> RxfifosizeR {
                RxfifosizeR::_from({
                                       const MASK: u8 = 7;
                                       const OFFSET: u8 = 0;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 3 - Receive FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rxfe(&self) -> RxfeR {
                RxfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 4:6 - Transmit FIFO. Buffer Depth" ]
            # [ inline ( always ) ]
            pub fn txfifosize(&self) -> TxfifosizeR {
                TxfifosizeR::_from({
                                       const MASK: u8 = 7;
                                       const OFFSET: u8 = 4;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 7 - Transmit FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn txfe(&self) -> TxfeR {
                TxfeR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Receive FIFO Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxufe(&self) -> RxufeR {
                RxufeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Transmit FIFO Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn txofe(&self) -> TxofeR {
                TxofeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 9;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 10:12 - Receiver Idle Empty Enable" ]
            # [ inline ( always ) ]
            pub fn rxiden(&self) -> RxidenR {
                RxidenR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 10;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 16 - Receiver Buffer Underflow Flag" ]
            # [ inline ( always ) ]
            pub fn rxuf(&self) -> RxufR {
                RxufR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 17 - Transmitter Buffer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn txof(&self) -> TxofR {
                TxofR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 17;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 22 - Receive Buffer/FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn rxempt(&self) -> RxemptR {
                RxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 22;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 23 - Transmit Buffer/FIFO Empty" ]
            # [ inline ( always ) ]
            pub fn txempt(&self) -> TxemptR {
                TxemptR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 23;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 12582929 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 3 - Receive FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn rxfe(&mut self) -> _RxfeW {
                _RxfeW { w: self }
            }
            # [ doc = "Bit 7 - Transmit FIFO Enable" ]
            # [ inline ( always ) ]
            pub fn txfe(&mut self) -> _TxfeW {
                _TxfeW { w: self }
            }
            # [ doc = "Bit 8 - Receive FIFO Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn rxufe(&mut self) -> _RxufeW {
                _RxufeW { w: self }
            }
            # [ doc = "Bit 9 - Transmit FIFO Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn txofe(&mut self) -> _TxofeW {
                _TxofeW { w: self }
            }
            # [ doc = "Bits 10:12 - Receiver Idle Empty Enable" ]
            # [ inline ( always ) ]
            pub fn rxiden(&mut self) -> _RxidenW {
                _RxidenW { w: self }
            }
            # [ doc = "Bit 14 - Receive FIFO/Buffer Flush" ]
            # [ inline ( always ) ]
            pub fn rxflush(&mut self) -> _RxflushW {
                _RxflushW { w: self }
            }
            # [ doc = "Bit 15 - Transmit FIFO/Buffer Flush" ]
            # [ inline ( always ) ]
            pub fn txflush(&mut self) -> _TxflushW {
                _TxflushW { w: self }
            }
            # [ doc = "Bit 16 - Receiver Buffer Underflow Flag" ]
            # [ inline ( always ) ]
            pub fn rxuf(&mut self) -> _RxufW {
                _RxufW { w: self }
            }
            # [ doc = "Bit 17 - Transmitter Buffer Overflow Flag" ]
            # [ inline ( always ) ]
            pub fn txof(&mut self) -> _TxofW {
                _TxofW { w: self }
            }
        }
    }
    # [ doc = "LPUART Watermark Register" ]
    pub struct Water {
        register: VolatileCell<u32>,
    }
    # [ doc = "LPUART Watermark Register" ]
    pub mod water {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Water {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxwaterR {
            bits: u8,
        }
        impl TxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct TxcountR {
            bits: u8,
        }
        impl TxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxwaterR {
            bits: u8,
        }
        impl RxwaterR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RxcountR {
            bits: u8,
        }
        impl RxcountR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RxwaterW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RxwaterW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Transmit Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&self) -> TxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxwaterR { bits }
            }
            # [ doc = "Bits 8:10 - Transmit Counter" ]
            # [ inline ( always ) ]
            pub fn txcount(&self) -> TxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                TxcountR { bits }
            }
            # [ doc = "Bits 16:17 - Receive Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&self) -> RxwaterR {
                let bits = {
                    const MASK: u8 = 3;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxwaterR { bits }
            }
            # [ doc = "Bits 24:26 - Receive Counter" ]
            # [ inline ( always ) ]
            pub fn rxcount(&self) -> RxcountR {
                let bits = {
                    const MASK: u8 = 7;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RxcountR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Transmit Watermark" ]
            # [ inline ( always ) ]
            pub fn txwater(&mut self) -> _TxwaterW {
                _TxwaterW { w: self }
            }
            # [ doc = "Bits 16:17 - Receive Watermark" ]
            # [ inline ( always ) ]
            pub fn rxwater(&mut self) -> _RxwaterW {
                _RxwaterW { w: self }
            }
        }
    }
}
# [ doc = "Universal Asynchronous Receiver/Transmitter" ]
pub struct Lpuart2 {
    register_block: lpuart2::RegisterBlock,
}
impl Deref for Lpuart2 {
    type Target = lpuart2::RegisterBlock;
    fn deref(&self) -> &lpuart2::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "High-Speed Comparator (CMP), Voltage Reference (VREF) Digital-to-Analog Converter (DAC), and Analog Mux (ANMUX)" ]
pub const CMP0: Peripheral<Cmp0> = unsafe { Peripheral::new(1074212864) };
# [ doc = "High-Speed Comparator (CMP), Voltage Reference (VREF) Digital-to-Analog Converter (DAC), and Analog Mux (ANMUX)" ]
pub mod cmp0 {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - CMP Control Register 0" ]
        pub c0: C0,
        # [ doc = "0x04 - CMP Control Register 1" ]
        pub c1: C1,
        # [ doc = "0x08 - CMP Control Register 2" ]
        pub c2: C2,
    }
    # [ doc = "CMP Control Register 0" ]
    pub struct C0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CMP Control Register 0" ]
    pub mod c0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HYSTCTR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HystctrR {
            # [ doc = "The hard block output has level 0 hysteresis internally." ]
            _00,
            # [ doc = "The hard block output has level 1 hysteresis internally." ]
            _01,
            # [ doc = "The hard block output has level 2 hysteresis internally." ]
            _10,
            # [ doc = "The hard block output has level 3 hysteresis internally." ]
            _11,
        }
        impl HystctrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HystctrR::_00 => 0,
                    HystctrR::_01 => 1,
                    HystctrR::_10 => 2,
                    HystctrR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HystctrR {
                match bits {
                    0 => HystctrR::_00,
                    1 => HystctrR::_01,
                    2 => HystctrR::_10,
                    3 => HystctrR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == HystctrR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == HystctrR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == HystctrR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == HystctrR::_11
            }
        }
        # [ doc = "Possible values of the field `OFFSET`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OffsetR {
            # [ doc = "The comparator hard block output has level 0 offset internally." ]
            _0,
            # [ doc = "The comparator hard block output has level 1 offset internally." ]
            _1,
        }
        impl OffsetR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OffsetR::_0 => 0,
                    OffsetR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OffsetR {
                match bits {
                    0 => OffsetR::_0,
                    1 => OffsetR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OffsetR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OffsetR::_1
            }
        }
        # [ doc = "Possible values of the field `FILTER_CNT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FilterCntR {
            # [ doc = "Filter is disabled. If SE = 1, then COUT is a logic zero (this is not a legal state, and is not recommended). If SE = 0, COUT = COUTA." ]
            _000,
            # [ doc = "1 consecutive sample must agree (comparator output is simply sampled)." ]
            _001,
            # [ doc = "2 consecutive samples must agree." ]
            _010,
            # [ doc = "3 consecutive samples must agree." ]
            _011,
            # [ doc = "4 consecutive samples must agree." ]
            _100,
            # [ doc = "5 consecutive samples must agree." ]
            _101,
            # [ doc = "6 consecutive samples must agree." ]
            _110,
            # [ doc = "7 consecutive samples must agree." ]
            _111,
        }
        impl FilterCntR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FilterCntR::_000 => 0,
                    FilterCntR::_001 => 1,
                    FilterCntR::_010 => 2,
                    FilterCntR::_011 => 3,
                    FilterCntR::_100 => 4,
                    FilterCntR::_101 => 5,
                    FilterCntR::_110 => 6,
                    FilterCntR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FilterCntR {
                match bits {
                    0 => FilterCntR::_000,
                    1 => FilterCntR::_001,
                    2 => FilterCntR::_010,
                    3 => FilterCntR::_011,
                    4 => FilterCntR::_100,
                    5 => FilterCntR::_101,
                    6 => FilterCntR::_110,
                    7 => FilterCntR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == FilterCntR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == FilterCntR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == FilterCntR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == FilterCntR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == FilterCntR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == FilterCntR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == FilterCntR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == FilterCntR::_111
            }
        }
        # [ doc = "Possible values of the field `EN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EnR {
            # [ doc = "Analog Comparator is disabled." ]
            _0,
            # [ doc = "Analog Comparator is enabled." ]
            _1,
        }
        impl EnR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EnR::_0 => 0,
                    EnR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EnR {
                match bits {
                    0 => EnR::_0,
                    1 => EnR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EnR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EnR::_1
            }
        }
        # [ doc = "Possible values of the field `OPE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum OpeR {
            # [ doc = "When OPE is 0, the comparator output (after window/filter settings dependent on software configuration) is not available to a packaged pin." ]
            _0,
            # [ doc = "When OPE is 1, and if the software has configured the comparator to own a packaged pin, the comparator is available in a packaged pin." ]
            _1,
        }
        impl OpeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    OpeR::_0 => 0,
                    OpeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> OpeR {
                match bits {
                    0 => OpeR::_0,
                    1 => OpeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == OpeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == OpeR::_1
            }
        }
        # [ doc = "Possible values of the field `COS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CosR {
            # [ doc = "Set CMPO to equal COUT (filtered comparator output)." ]
            _0,
            # [ doc = "Set CMPO to equal COUTA (unfiltered comparator output)." ]
            _1,
        }
        impl CosR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CosR::_0 => 0,
                    CosR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CosR {
                match bits {
                    0 => CosR::_0,
                    1 => CosR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CosR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CosR::_1
            }
        }
        # [ doc = "Possible values of the field `INVT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InvtR {
            # [ doc = "Does not invert the comparator output." ]
            _0,
            # [ doc = "Inverts the comparator output." ]
            _1,
        }
        impl InvtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InvtR::_0 => 0,
                    InvtR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InvtR {
                match bits {
                    0 => InvtR::_0,
                    1 => InvtR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == InvtR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == InvtR::_1
            }
        }
        # [ doc = "Possible values of the field `PMODE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PmodeR {
            # [ doc = "Low Speed (LS) comparison mode is selected." ]
            _0,
            # [ doc = "High Speed (HS) comparison mode is selected, in VLPx mode, or Stop mode switched to Low Speed (LS) mode." ]
            _1,
        }
        impl PmodeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PmodeR::_0 => 0,
                    PmodeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PmodeR {
                match bits {
                    0 => PmodeR::_0,
                    1 => PmodeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PmodeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PmodeR::_1
            }
        }
        # [ doc = "Possible values of the field `WE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WeR {
            # [ doc = "Windowing mode is not selected." ]
            _0,
            # [ doc = "Windowing mode is selected." ]
            _1,
        }
        impl WeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WeR::_0 => 0,
                    WeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WeR {
                match bits {
                    0 => WeR::_0,
                    1 => WeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WeR::_1
            }
        }
        # [ doc = "Possible values of the field `SE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SeR {
            # [ doc = "Sampling mode is not selected." ]
            _0,
            # [ doc = "Sampling mode is selected." ]
            _1,
        }
        impl SeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SeR::_0 => 0,
                    SeR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SeR {
                match bits {
                    0 => SeR::_0,
                    1 => SeR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SeR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SeR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct FprR {
            bits: u8,
        }
        impl FprR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CoutR {
            bits: u8,
        }
        impl CoutR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `CFF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CffR {
            # [ doc = "A falling edge has not been detected on COUT." ]
            _0,
            # [ doc = "A falling edge on COUT has occurred." ]
            _1,
        }
        impl CffR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CffR::_0 => 0,
                    CffR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CffR {
                match bits {
                    0 => CffR::_0,
                    1 => CffR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CffR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CffR::_1
            }
        }
        # [ doc = "Possible values of the field `CFR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CfrR {
            # [ doc = "A rising edge has not been detected on COUT." ]
            _0,
            # [ doc = "A rising edge on COUT has occurred." ]
            _1,
        }
        impl CfrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CfrR::_0 => 0,
                    CfrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CfrR {
                match bits {
                    0 => CfrR::_0,
                    1 => CfrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CfrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CfrR::_1
            }
        }
        # [ doc = "Possible values of the field `IEF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IefR {
            # [ doc = "Interrupt is disabled." ]
            _0,
            # [ doc = "Interrupt is enabled." ]
            _1,
        }
        impl IefR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IefR::_0 => 0,
                    IefR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IefR {
                match bits {
                    0 => IefR::_0,
                    1 => IefR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IefR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IefR::_1
            }
        }
        # [ doc = "Possible values of the field `IER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum IerR {
            # [ doc = "Interrupt is disabled." ]
            _0,
            # [ doc = "Interrupt is enabled." ]
            _1,
        }
        impl IerR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    IerR::_0 => 0,
                    IerR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> IerR {
                match bits {
                    0 => IerR::_0,
                    1 => IerR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == IerR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == IerR::_1
            }
        }
        # [ doc = "Possible values of the field `DMAEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DmaenR {
            # [ doc = "DMA is disabled." ]
            _0,
            # [ doc = "DMA is enabled." ]
            _1,
        }
        impl DmaenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DmaenR::_0 => 0,
                    DmaenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DmaenR {
                match bits {
                    0 => DmaenR::_0,
                    1 => DmaenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DmaenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DmaenR::_1
            }
        }
        # [ doc = "Values that can be written to the field `HYSTCTR`" ]
        pub enum HystctrW {
            # [ doc = "The hard block output has level 0 hysteresis internally." ]
            _00,
            # [ doc = "The hard block output has level 1 hysteresis internally." ]
            _01,
            # [ doc = "The hard block output has level 2 hysteresis internally." ]
            _10,
            # [ doc = "The hard block output has level 3 hysteresis internally." ]
            _11,
        }
        impl HystctrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    HystctrW::_00 => 0,
                    HystctrW::_01 => 1,
                    HystctrW::_10 => 2,
                    HystctrW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _HystctrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _HystctrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: HystctrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The hard block output has level 0 hysteresis internally." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(HystctrW::_00)
            }
            # [ doc = "The hard block output has level 1 hysteresis internally." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(HystctrW::_01)
            }
            # [ doc = "The hard block output has level 2 hysteresis internally." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(HystctrW::_10)
            }
            # [ doc = "The hard block output has level 3 hysteresis internally." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(HystctrW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OFFSET`" ]
        pub enum OffsetW {
            # [ doc = "The comparator hard block output has level 0 offset internally." ]
            _0,
            # [ doc = "The comparator hard block output has level 1 offset internally." ]
            _1,
        }
        impl OffsetW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OffsetW::_0 => 0,
                    OffsetW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OffsetW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OffsetW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OffsetW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The comparator hard block output has level 0 offset internally." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OffsetW::_0)
            }
            # [ doc = "The comparator hard block output has level 1 offset internally." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OffsetW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FILTER_CNT`" ]
        pub enum FilterCntW {
            # [ doc = "Filter is disabled. If SE = 1, then COUT is a logic zero (this is not a legal state, and is not recommended). If SE = 0, COUT = COUTA." ]
            _000,
            # [ doc = "1 consecutive sample must agree (comparator output is simply sampled)." ]
            _001,
            # [ doc = "2 consecutive samples must agree." ]
            _010,
            # [ doc = "3 consecutive samples must agree." ]
            _011,
            # [ doc = "4 consecutive samples must agree." ]
            _100,
            # [ doc = "5 consecutive samples must agree." ]
            _101,
            # [ doc = "6 consecutive samples must agree." ]
            _110,
            # [ doc = "7 consecutive samples must agree." ]
            _111,
        }
        impl FilterCntW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FilterCntW::_000 => 0,
                    FilterCntW::_001 => 1,
                    FilterCntW::_010 => 2,
                    FilterCntW::_011 => 3,
                    FilterCntW::_100 => 4,
                    FilterCntW::_101 => 5,
                    FilterCntW::_110 => 6,
                    FilterCntW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FilterCntW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FilterCntW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FilterCntW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Filter is disabled. If SE = 1, then COUT is a logic zero (this is not a legal state, and is not recommended). If SE = 0, COUT = COUTA." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(FilterCntW::_000)
            }
            # [ doc = "1 consecutive sample must agree (comparator output is simply sampled)." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(FilterCntW::_001)
            }
            # [ doc = "2 consecutive samples must agree." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(FilterCntW::_010)
            }
            # [ doc = "3 consecutive samples must agree." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(FilterCntW::_011)
            }
            # [ doc = "4 consecutive samples must agree." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(FilterCntW::_100)
            }
            # [ doc = "5 consecutive samples must agree." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(FilterCntW::_101)
            }
            # [ doc = "6 consecutive samples must agree." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(FilterCntW::_110)
            }
            # [ doc = "7 consecutive samples must agree." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(FilterCntW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `EN`" ]
        pub enum EnW {
            # [ doc = "Analog Comparator is disabled." ]
            _0,
            # [ doc = "Analog Comparator is enabled." ]
            _1,
        }
        impl EnW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EnW::_0 => 0,
                    EnW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EnW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EnW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EnW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Analog Comparator is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EnW::_0)
            }
            # [ doc = "Analog Comparator is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EnW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `OPE`" ]
        pub enum OpeW {
            # [ doc = "When OPE is 0, the comparator output (after window/filter settings dependent on software configuration) is not available to a packaged pin." ]
            _0,
            # [ doc = "When OPE is 1, and if the software has configured the comparator to own a packaged pin, the comparator is available in a packaged pin." ]
            _1,
        }
        impl OpeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    OpeW::_0 => 0,
                    OpeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _OpeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _OpeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: OpeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "When OPE is 0, the comparator output (after window/filter settings dependent on software configuration) is not available to a packaged pin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(OpeW::_0)
            }
            # [ doc = "When OPE is 1, and if the software has configured the comparator to own a packaged pin, the comparator is available in a packaged pin." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(OpeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `COS`" ]
        pub enum CosW {
            # [ doc = "Set CMPO to equal COUT (filtered comparator output)." ]
            _0,
            # [ doc = "Set CMPO to equal COUTA (unfiltered comparator output)." ]
            _1,
        }
        impl CosW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CosW::_0 => 0,
                    CosW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CosW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CosW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CosW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Set CMPO to equal COUT (filtered comparator output)." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CosW::_0)
            }
            # [ doc = "Set CMPO to equal COUTA (unfiltered comparator output)." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CosW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVT`" ]
        pub enum InvtW {
            # [ doc = "Does not invert the comparator output." ]
            _0,
            # [ doc = "Inverts the comparator output." ]
            _1,
        }
        impl InvtW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InvtW::_0 => 0,
                    InvtW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InvtW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InvtW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InvtW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Does not invert the comparator output." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(InvtW::_0)
            }
            # [ doc = "Inverts the comparator output." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(InvtW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PMODE`" ]
        pub enum PmodeW {
            # [ doc = "Low Speed (LS) comparison mode is selected." ]
            _0,
            # [ doc = "High Speed (HS) comparison mode is selected, in VLPx mode, or Stop mode switched to Low Speed (LS) mode." ]
            _1,
        }
        impl PmodeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PmodeW::_0 => 0,
                    PmodeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PmodeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PmodeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PmodeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low Speed (LS) comparison mode is selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PmodeW::_0)
            }
            # [ doc = "High Speed (HS) comparison mode is selected, in VLPx mode, or Stop mode switched to Low Speed (LS) mode." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PmodeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WE`" ]
        pub enum WeW {
            # [ doc = "Windowing mode is not selected." ]
            _0,
            # [ doc = "Windowing mode is selected." ]
            _1,
        }
        impl WeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WeW::_0 => 0,
                    WeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Windowing mode is not selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WeW::_0)
            }
            # [ doc = "Windowing mode is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SE`" ]
        pub enum SeW {
            # [ doc = "Sampling mode is not selected." ]
            _0,
            # [ doc = "Sampling mode is selected." ]
            _1,
        }
        impl SeW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SeW::_0 => 0,
                    SeW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SeW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SeW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Sampling mode is not selected." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SeW::_0)
            }
            # [ doc = "Sampling mode is selected." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SeW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FprW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FprW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CFF`" ]
        pub enum CffW {
            # [ doc = "A falling edge has not been detected on COUT." ]
            _0,
            # [ doc = "A falling edge on COUT has occurred." ]
            _1,
        }
        impl CffW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CffW::_0 => 0,
                    CffW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CffW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CffW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CffW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A falling edge has not been detected on COUT." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CffW::_0)
            }
            # [ doc = "A falling edge on COUT has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CffW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CFR`" ]
        pub enum CfrW {
            # [ doc = "A rising edge has not been detected on COUT." ]
            _0,
            # [ doc = "A rising edge on COUT has occurred." ]
            _1,
        }
        impl CfrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CfrW::_0 => 0,
                    CfrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CfrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CfrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CfrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "A rising edge has not been detected on COUT." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CfrW::_0)
            }
            # [ doc = "A rising edge on COUT has occurred." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CfrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IEF`" ]
        pub enum IefW {
            # [ doc = "Interrupt is disabled." ]
            _0,
            # [ doc = "Interrupt is enabled." ]
            _1,
        }
        impl IefW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IefW::_0 => 0,
                    IefW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IefW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IefW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IefW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IefW::_0)
            }
            # [ doc = "Interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IefW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `IER`" ]
        pub enum IerW {
            # [ doc = "Interrupt is disabled." ]
            _0,
            # [ doc = "Interrupt is enabled." ]
            _1,
        }
        impl IerW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    IerW::_0 => 0,
                    IerW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _IerW<'a> {
            w: &'a mut W,
        }
        impl<'a> _IerW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: IerW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(IerW::_0)
            }
            # [ doc = "Interrupt is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(IerW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DMAEN`" ]
        pub enum DmaenW {
            # [ doc = "DMA is disabled." ]
            _0,
            # [ doc = "DMA is enabled." ]
            _1,
        }
        impl DmaenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DmaenW::_0 => 0,
                    DmaenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DmaenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DmaenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DmaenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DMA is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DmaenW::_0)
            }
            # [ doc = "DMA is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DmaenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Comparator hard block hysteresis control. See chip data sheet to get the actual hystersis value with each level" ]
            # [ inline ( always ) ]
            pub fn hystctr(&self) -> HystctrR {
                HystctrR::_from({
                                    const MASK: u8 = 3;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Comparator hard block offset control. See chip data sheet to get the actual offset value with each level" ]
            # [ inline ( always ) ]
            pub fn offset(&self) -> OffsetR {
                OffsetR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 4:6 - Filter Sample Count" ]
            # [ inline ( always ) ]
            pub fn filter_cnt(&self) -> FilterCntR {
                FilterCntR::_from({
                                      const MASK: u8 = 7;
                                      const OFFSET: u8 = 4;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 8 - Comparator Module Enable" ]
            # [ inline ( always ) ]
            pub fn en(&self) -> EnR {
                EnR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 8;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 9 - Comparator Output Pin Enable" ]
            # [ inline ( always ) ]
            pub fn ope(&self) -> OpeR {
                OpeR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 9;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 10 - Comparator Output Select" ]
            # [ inline ( always ) ]
            pub fn cos(&self) -> CosR {
                CosR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Comparator invert" ]
            # [ inline ( always ) ]
            pub fn invt(&self) -> InvtR {
                InvtR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - Power Mode Select" ]
            # [ inline ( always ) ]
            pub fn pmode(&self) -> PmodeR {
                PmodeR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 12;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 14 - Windowing Enable" ]
            # [ inline ( always ) ]
            pub fn we(&self) -> WeR {
                WeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 14;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 15 - Sample Enable" ]
            # [ inline ( always ) ]
            pub fn se(&self) -> SeR {
                SeR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 15;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:23 - Filter Sample Period" ]
            # [ inline ( always ) ]
            pub fn fpr(&self) -> FprR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                FprR { bits }
            }
            # [ doc = "Bit 24 - Analog Comparator Output" ]
            # [ inline ( always ) ]
            pub fn cout(&self) -> CoutR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                CoutR { bits }
            }
            # [ doc = "Bit 25 - Analog Comparator Flag Falling" ]
            # [ inline ( always ) ]
            pub fn cff(&self) -> CffR {
                CffR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 25;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 26 - Analog Comparator Flag Rising" ]
            # [ inline ( always ) ]
            pub fn cfr(&self) -> CfrR {
                CfrR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 26;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 27 - Comparator Interrupt Enable Falling" ]
            # [ inline ( always ) ]
            pub fn ief(&self) -> IefR {
                IefR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 27;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 28 - Comparator Interrupt Enable Rising" ]
            # [ inline ( always ) ]
            pub fn ier(&self) -> IerR {
                IerR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 28;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 30 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&self) -> DmaenR {
                DmaenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 30;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Comparator hard block hysteresis control. See chip data sheet to get the actual hystersis value with each level" ]
            # [ inline ( always ) ]
            pub fn hystctr(&mut self) -> _HystctrW {
                _HystctrW { w: self }
            }
            # [ doc = "Bit 2 - Comparator hard block offset control. See chip data sheet to get the actual offset value with each level" ]
            # [ inline ( always ) ]
            pub fn offset(&mut self) -> _OffsetW {
                _OffsetW { w: self }
            }
            # [ doc = "Bits 4:6 - Filter Sample Count" ]
            # [ inline ( always ) ]
            pub fn filter_cnt(&mut self) -> _FilterCntW {
                _FilterCntW { w: self }
            }
            # [ doc = "Bit 8 - Comparator Module Enable" ]
            # [ inline ( always ) ]
            pub fn en(&mut self) -> _EnW {
                _EnW { w: self }
            }
            # [ doc = "Bit 9 - Comparator Output Pin Enable" ]
            # [ inline ( always ) ]
            pub fn ope(&mut self) -> _OpeW {
                _OpeW { w: self }
            }
            # [ doc = "Bit 10 - Comparator Output Select" ]
            # [ inline ( always ) ]
            pub fn cos(&mut self) -> _CosW {
                _CosW { w: self }
            }
            # [ doc = "Bit 11 - Comparator invert" ]
            # [ inline ( always ) ]
            pub fn invt(&mut self) -> _InvtW {
                _InvtW { w: self }
            }
            # [ doc = "Bit 12 - Power Mode Select" ]
            # [ inline ( always ) ]
            pub fn pmode(&mut self) -> _PmodeW {
                _PmodeW { w: self }
            }
            # [ doc = "Bit 14 - Windowing Enable" ]
            # [ inline ( always ) ]
            pub fn we(&mut self) -> _WeW {
                _WeW { w: self }
            }
            # [ doc = "Bit 15 - Sample Enable" ]
            # [ inline ( always ) ]
            pub fn se(&mut self) -> _SeW {
                _SeW { w: self }
            }
            # [ doc = "Bits 16:23 - Filter Sample Period" ]
            # [ inline ( always ) ]
            pub fn fpr(&mut self) -> _FprW {
                _FprW { w: self }
            }
            # [ doc = "Bit 25 - Analog Comparator Flag Falling" ]
            # [ inline ( always ) ]
            pub fn cff(&mut self) -> _CffW {
                _CffW { w: self }
            }
            # [ doc = "Bit 26 - Analog Comparator Flag Rising" ]
            # [ inline ( always ) ]
            pub fn cfr(&mut self) -> _CfrW {
                _CfrW { w: self }
            }
            # [ doc = "Bit 27 - Comparator Interrupt Enable Falling" ]
            # [ inline ( always ) ]
            pub fn ief(&mut self) -> _IefW {
                _IefW { w: self }
            }
            # [ doc = "Bit 28 - Comparator Interrupt Enable Rising" ]
            # [ inline ( always ) ]
            pub fn ier(&mut self) -> _IerW {
                _IerW { w: self }
            }
            # [ doc = "Bit 30 - DMA Enable" ]
            # [ inline ( always ) ]
            pub fn dmaen(&mut self) -> _DmaenW {
                _DmaenW { w: self }
            }
        }
    }
    # [ doc = "CMP Control Register 1" ]
    pub struct C1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CMP Control Register 1" ]
    pub mod c1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct VoselR {
            bits: u8,
        }
        impl VoselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `MSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MselR {
            # [ doc = "IN0" ]
            _000,
            # [ doc = "IN1" ]
            _001,
            # [ doc = "IN2" ]
            _010,
            # [ doc = "IN3" ]
            _011,
            # [ doc = "IN4" ]
            _100,
            # [ doc = "IN5" ]
            _101,
            # [ doc = "IN6" ]
            _110,
            # [ doc = "IN7" ]
            _111,
        }
        impl MselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MselR::_000 => 0,
                    MselR::_001 => 1,
                    MselR::_010 => 2,
                    MselR::_011 => 3,
                    MselR::_100 => 4,
                    MselR::_101 => 5,
                    MselR::_110 => 6,
                    MselR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MselR {
                match bits {
                    0 => MselR::_000,
                    1 => MselR::_001,
                    2 => MselR::_010,
                    3 => MselR::_011,
                    4 => MselR::_100,
                    5 => MselR::_101,
                    6 => MselR::_110,
                    7 => MselR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MselR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MselR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MselR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == MselR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == MselR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == MselR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == MselR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == MselR::_111
            }
        }
        # [ doc = "Possible values of the field `PSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PselR {
            # [ doc = "IN0" ]
            _000,
            # [ doc = "IN1" ]
            _001,
            # [ doc = "IN2" ]
            _010,
            # [ doc = "IN3" ]
            _011,
            # [ doc = "IN4" ]
            _100,
            # [ doc = "IN5" ]
            _101,
            # [ doc = "IN6" ]
            _110,
            # [ doc = "IN7" ]
            _111,
        }
        impl PselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PselR::_000 => 0,
                    PselR::_001 => 1,
                    PselR::_010 => 2,
                    PselR::_011 => 3,
                    PselR::_100 => 4,
                    PselR::_101 => 5,
                    PselR::_110 => 6,
                    PselR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PselR {
                match bits {
                    0 => PselR::_000,
                    1 => PselR::_001,
                    2 => PselR::_010,
                    3 => PselR::_011,
                    4 => PselR::_100,
                    5 => PselR::_101,
                    6 => PselR::_110,
                    7 => PselR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PselR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PselR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PselR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PselR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == PselR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == PselR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == PselR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == PselR::_111
            }
        }
        # [ doc = "Possible values of the field `VRSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VrselR {
            # [ doc = "Vin1 is selected as resistor ladder network supply reference Vin." ]
            _0,
            # [ doc = "Vin2 is selected as resistor ladder network supply reference Vin." ]
            _1,
        }
        impl VrselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VrselR::_0 => 0,
                    VrselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VrselR {
                match bits {
                    0 => VrselR::_0,
                    1 => VrselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VrselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VrselR::_1
            }
        }
        # [ doc = "Possible values of the field `DACEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DacenR {
            # [ doc = "DAC is disabled." ]
            _0,
            # [ doc = "DAC is enabled." ]
            _1,
        }
        impl DacenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DacenR::_0 => 0,
                    DacenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DacenR {
                match bits {
                    0 => DacenR::_0,
                    1 => DacenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == DacenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == DacenR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn0R {
            bits: u8,
        }
        impl Chn0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn1R {
            bits: u8,
        }
        impl Chn1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn2R {
            bits: u8,
        }
        impl Chn2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn3R {
            bits: u8,
        }
        impl Chn3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn4R {
            bits: u8,
        }
        impl Chn4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn5R {
            bits: u8,
        }
        impl Chn5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn6R {
            bits: u8,
        }
        impl Chn6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Chn7R {
            bits: u8,
        }
        impl Chn7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `INNSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InnselR {
            # [ doc = "IN0, from the 8-bit DAC output" ]
            _00,
            # [ doc = "IN1, from the analog 8-1 mux" ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl InnselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InnselR::_00 => 0,
                    InnselR::_01 => 1,
                    InnselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InnselR {
                match bits {
                    0 => InnselR::_00,
                    1 => InnselR::_01,
                    i => InnselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == InnselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == InnselR::_01
            }
        }
        # [ doc = "Possible values of the field `INPSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InpselR {
            # [ doc = "IN0, from the 8-bit DAC output" ]
            _00,
            # [ doc = "IN1, from the analog 8-1 mux" ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl InpselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InpselR::_00 => 0,
                    InpselR::_01 => 1,
                    InpselR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InpselR {
                match bits {
                    0 => InpselR::_00,
                    1 => InpselR::_01,
                    i => InpselR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == InpselR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == InpselR::_01
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _VoselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VoselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MSEL`" ]
        pub enum MselW {
            # [ doc = "IN0" ]
            _000,
            # [ doc = "IN1" ]
            _001,
            # [ doc = "IN2" ]
            _010,
            # [ doc = "IN3" ]
            _011,
            # [ doc = "IN4" ]
            _100,
            # [ doc = "IN5" ]
            _101,
            # [ doc = "IN6" ]
            _110,
            # [ doc = "IN7" ]
            _111,
        }
        impl MselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MselW::_000 => 0,
                    MselW::_001 => 1,
                    MselW::_010 => 2,
                    MselW::_011 => 3,
                    MselW::_100 => 4,
                    MselW::_101 => 5,
                    MselW::_110 => 6,
                    MselW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "IN0" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(MselW::_000)
            }
            # [ doc = "IN1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(MselW::_001)
            }
            # [ doc = "IN2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(MselW::_010)
            }
            # [ doc = "IN3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(MselW::_011)
            }
            # [ doc = "IN4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(MselW::_100)
            }
            # [ doc = "IN5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(MselW::_101)
            }
            # [ doc = "IN6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(MselW::_110)
            }
            # [ doc = "IN7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(MselW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PSEL`" ]
        pub enum PselW {
            # [ doc = "IN0" ]
            _000,
            # [ doc = "IN1" ]
            _001,
            # [ doc = "IN2" ]
            _010,
            # [ doc = "IN3" ]
            _011,
            # [ doc = "IN4" ]
            _100,
            # [ doc = "IN5" ]
            _101,
            # [ doc = "IN6" ]
            _110,
            # [ doc = "IN7" ]
            _111,
        }
        impl PselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PselW::_000 => 0,
                    PselW::_001 => 1,
                    PselW::_010 => 2,
                    PselW::_011 => 3,
                    PselW::_100 => 4,
                    PselW::_101 => 5,
                    PselW::_110 => 6,
                    PselW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "IN0" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(PselW::_000)
            }
            # [ doc = "IN1" ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(PselW::_001)
            }
            # [ doc = "IN2" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(PselW::_010)
            }
            # [ doc = "IN3" ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(PselW::_011)
            }
            # [ doc = "IN4" ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(PselW::_100)
            }
            # [ doc = "IN5" ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(PselW::_101)
            }
            # [ doc = "IN6" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(PselW::_110)
            }
            # [ doc = "IN7" ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(PselW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `VRSEL`" ]
        pub enum VrselW {
            # [ doc = "Vin1 is selected as resistor ladder network supply reference Vin." ]
            _0,
            # [ doc = "Vin2 is selected as resistor ladder network supply reference Vin." ]
            _1,
        }
        impl VrselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    VrselW::_0 => 0,
                    VrselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _VrselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _VrselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: VrselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Vin1 is selected as resistor ladder network supply reference Vin." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(VrselW::_0)
            }
            # [ doc = "Vin2 is selected as resistor ladder network supply reference Vin." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(VrselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `DACEN`" ]
        pub enum DacenW {
            # [ doc = "DAC is disabled." ]
            _0,
            # [ doc = "DAC is enabled." ]
            _1,
        }
        impl DacenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DacenW::_0 => 0,
                    DacenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DacenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DacenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DacenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "DAC is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(DacenW::_0)
            }
            # [ doc = "DAC is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(DacenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 15;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn4W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn5W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn6W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Chn7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Chn7W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INNSEL`" ]
        pub enum InnselW {
            # [ doc = "IN0, from the 8-bit DAC output" ]
            _00,
            # [ doc = "IN1, from the analog 8-1 mux" ]
            _01,
        }
        impl InnselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InnselW::_00 => 0,
                    InnselW::_01 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InnselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InnselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InnselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "IN0, from the 8-bit DAC output" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(InnselW::_00)
            }
            # [ doc = "IN1, from the analog 8-1 mux" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(InnselW::_01)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INPSEL`" ]
        pub enum InpselW {
            # [ doc = "IN0, from the 8-bit DAC output" ]
            _00,
            # [ doc = "IN1, from the analog 8-1 mux" ]
            _01,
        }
        impl InpselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InpselW::_00 => 0,
                    InpselW::_01 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InpselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InpselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InpselW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "IN0, from the 8-bit DAC output" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(InpselW::_00)
            }
            # [ doc = "IN1, from the analog 8-1 mux" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(InpselW::_01)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - DAC Output Voltage Select" ]
            # [ inline ( always ) ]
            pub fn vosel(&self) -> VoselR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                VoselR { bits }
            }
            # [ doc = "Bits 8:10 - Minus Input MUX Control" ]
            # [ inline ( always ) ]
            pub fn msel(&self) -> MselR {
                MselR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 11:13 - Plus Input MUX Control" ]
            # [ inline ( always ) ]
            pub fn psel(&self) -> PselR {
                PselR::_from({
                                 const MASK: u8 = 7;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 14 - Supply Voltage Reference Source Select" ]
            # [ inline ( always ) ]
            pub fn vrsel(&self) -> VrselR {
                VrselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 14;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 15 - DAC Enable" ]
            # [ inline ( always ) ]
            pub fn dacen(&self) -> DacenR {
                DacenR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 15;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 16 - Channel 0 input enable" ]
            # [ inline ( always ) ]
            pub fn chn0(&self) -> Chn0R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn0R { bits }
            }
            # [ doc = "Bit 17 - Channel 1 input enable" ]
            # [ inline ( always ) ]
            pub fn chn1(&self) -> Chn1R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn1R { bits }
            }
            # [ doc = "Bit 18 - Channel 2 input enable" ]
            # [ inline ( always ) ]
            pub fn chn2(&self) -> Chn2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn2R { bits }
            }
            # [ doc = "Bit 19 - Channel 3 input enable" ]
            # [ inline ( always ) ]
            pub fn chn3(&self) -> Chn3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn3R { bits }
            }
            # [ doc = "Bit 20 - Channel 4 input enable" ]
            # [ inline ( always ) ]
            pub fn chn4(&self) -> Chn4R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn4R { bits }
            }
            # [ doc = "Bit 21 - Channel 5 input enable" ]
            # [ inline ( always ) ]
            pub fn chn5(&self) -> Chn5R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn5R { bits }
            }
            # [ doc = "Bit 22 - Channel 6 input enable" ]
            # [ inline ( always ) ]
            pub fn chn6(&self) -> Chn6R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn6R { bits }
            }
            # [ doc = "Bit 23 - Channel 7 input enable" ]
            # [ inline ( always ) ]
            pub fn chn7(&self) -> Chn7R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Chn7R { bits }
            }
            # [ doc = "Bits 24:25 - Selection of the input to the negative port of the comparator" ]
            # [ inline ( always ) ]
            pub fn innsel(&self) -> InnselR {
                InnselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bits 27:28 - Selection of the input to the positive port of the comparator" ]
            # [ inline ( always ) ]
            pub fn inpsel(&self) -> InpselR {
                InpselR::_from({
                                   const MASK: u8 = 3;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - DAC Output Voltage Select" ]
            # [ inline ( always ) ]
            pub fn vosel(&mut self) -> _VoselW {
                _VoselW { w: self }
            }
            # [ doc = "Bits 8:10 - Minus Input MUX Control" ]
            # [ inline ( always ) ]
            pub fn msel(&mut self) -> _MselW {
                _MselW { w: self }
            }
            # [ doc = "Bits 11:13 - Plus Input MUX Control" ]
            # [ inline ( always ) ]
            pub fn psel(&mut self) -> _PselW {
                _PselW { w: self }
            }
            # [ doc = "Bit 14 - Supply Voltage Reference Source Select" ]
            # [ inline ( always ) ]
            pub fn vrsel(&mut self) -> _VrselW {
                _VrselW { w: self }
            }
            # [ doc = "Bit 15 - DAC Enable" ]
            # [ inline ( always ) ]
            pub fn dacen(&mut self) -> _DacenW {
                _DacenW { w: self }
            }
            # [ doc = "Bit 16 - Channel 0 input enable" ]
            # [ inline ( always ) ]
            pub fn chn0(&mut self) -> _Chn0W {
                _Chn0W { w: self }
            }
            # [ doc = "Bit 17 - Channel 1 input enable" ]
            # [ inline ( always ) ]
            pub fn chn1(&mut self) -> _Chn1W {
                _Chn1W { w: self }
            }
            # [ doc = "Bit 18 - Channel 2 input enable" ]
            # [ inline ( always ) ]
            pub fn chn2(&mut self) -> _Chn2W {
                _Chn2W { w: self }
            }
            # [ doc = "Bit 19 - Channel 3 input enable" ]
            # [ inline ( always ) ]
            pub fn chn3(&mut self) -> _Chn3W {
                _Chn3W { w: self }
            }
            # [ doc = "Bit 20 - Channel 4 input enable" ]
            # [ inline ( always ) ]
            pub fn chn4(&mut self) -> _Chn4W {
                _Chn4W { w: self }
            }
            # [ doc = "Bit 21 - Channel 5 input enable" ]
            # [ inline ( always ) ]
            pub fn chn5(&mut self) -> _Chn5W {
                _Chn5W { w: self }
            }
            # [ doc = "Bit 22 - Channel 6 input enable" ]
            # [ inline ( always ) ]
            pub fn chn6(&mut self) -> _Chn6W {
                _Chn6W { w: self }
            }
            # [ doc = "Bit 23 - Channel 7 input enable" ]
            # [ inline ( always ) ]
            pub fn chn7(&mut self) -> _Chn7W {
                _Chn7W { w: self }
            }
            # [ doc = "Bits 24:25 - Selection of the input to the negative port of the comparator" ]
            # [ inline ( always ) ]
            pub fn innsel(&mut self) -> _InnselW {
                _InnselW { w: self }
            }
            # [ doc = "Bits 27:28 - Selection of the input to the positive port of the comparator" ]
            # [ inline ( always ) ]
            pub fn inpsel(&mut self) -> _InpselW {
                _InpselW { w: self }
            }
        }
    }
    # [ doc = "CMP Control Register 2" ]
    pub struct C2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "CMP Control Register 2" ]
    pub mod c2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::C2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct AconR {
            bits: u8,
        }
        impl AconR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `INITMOD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum InitmodR {
            # [ doc = "The modulus is set to 64(same with 111111)." ]
            _000000,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl InitmodR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    InitmodR::_000000 => 0,
                    InitmodR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> InitmodR {
                match bits {
                    0 => InitmodR::_000000,
                    i => InitmodR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000000`" ]
            # [ inline ( always ) ]
            pub fn is_000000(&self) -> bool {
                *self == InitmodR::_000000
            }
        }
        # [ doc = "Possible values of the field `NSAM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum NsamR {
            # [ doc = "The comparison result is sampled as soon as the active channel is scanned in one round-robin clock." ]
            _00,
            # [ doc = "The sampling takes place 1 round-robin clock cycle after the next cycle of the round-robin clock." ]
            _01,
            # [ doc = "The sampling takes place 2 round-robin clock cycles after the next cycle of the round-robin clock." ]
            _10,
            # [ doc = "The sampling takes place 3 round-robin clock cycles after the next cycle of the round-robin clock." ]
            _11,
        }
        impl NsamR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    NsamR::_00 => 0,
                    NsamR::_01 => 1,
                    NsamR::_10 => 2,
                    NsamR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> NsamR {
                match bits {
                    0 => NsamR::_00,
                    1 => NsamR::_01,
                    2 => NsamR::_10,
                    3 => NsamR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == NsamR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == NsamR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == NsamR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == NsamR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch0fR {
            bits: u8,
        }
        impl Ch0fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch1fR {
            bits: u8,
        }
        impl Ch1fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch2fR {
            bits: u8,
        }
        impl Ch2fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch3fR {
            bits: u8,
        }
        impl Ch3fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch4fR {
            bits: u8,
        }
        impl Ch4fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch5fR {
            bits: u8,
        }
        impl Ch5fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch6fR {
            bits: u8,
        }
        impl Ch6fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Ch7fR {
            bits: u8,
        }
        impl Ch7fR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `FXMXCH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FxmxchR {
            # [ doc = "Channel 0 is selected as the fixed reference input for the fixed mux port." ]
            _000,
            # [ doc = "Channel 1 is selected as the fixed reference input for the fixed mux port." ]
            _001,
            # [ doc = "Channel 2 is selected as the fixed reference input for the fixed mux port." ]
            _010,
            # [ doc = "Channel 3 is selected as the fixed reference input for the fixed mux port." ]
            _011,
            # [ doc = "Channel 4 is selected as the fixed reference input for the fixed mux port." ]
            _100,
            # [ doc = "Channel 5 is selected as the fixed reference input for the fixed mux port." ]
            _101,
            # [ doc = "Channel 6 is selected as the fixed reference input for the fixed mux port." ]
            _110,
            # [ doc = "Channel 7 is selected as the fixed reference input for the fixed mux port." ]
            _111,
        }
        impl FxmxchR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FxmxchR::_000 => 0,
                    FxmxchR::_001 => 1,
                    FxmxchR::_010 => 2,
                    FxmxchR::_011 => 3,
                    FxmxchR::_100 => 4,
                    FxmxchR::_101 => 5,
                    FxmxchR::_110 => 6,
                    FxmxchR::_111 => 7,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FxmxchR {
                match bits {
                    0 => FxmxchR::_000,
                    1 => FxmxchR::_001,
                    2 => FxmxchR::_010,
                    3 => FxmxchR::_011,
                    4 => FxmxchR::_100,
                    5 => FxmxchR::_101,
                    6 => FxmxchR::_110,
                    7 => FxmxchR::_111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == FxmxchR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == FxmxchR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == FxmxchR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == FxmxchR::_011
            }
            # [ doc = "Checks if the value of the field is `_100`" ]
            # [ inline ( always ) ]
            pub fn is_100(&self) -> bool {
                *self == FxmxchR::_100
            }
            # [ doc = "Checks if the value of the field is `_101`" ]
            # [ inline ( always ) ]
            pub fn is_101(&self) -> bool {
                *self == FxmxchR::_101
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == FxmxchR::_110
            }
            # [ doc = "Checks if the value of the field is `_111`" ]
            # [ inline ( always ) ]
            pub fn is_111(&self) -> bool {
                *self == FxmxchR::_111
            }
        }
        # [ doc = "Possible values of the field `FXMP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FxmpR {
            # [ doc = "The Plus port is fixed. Only the inputs to the Minus port are swept in each round." ]
            _0,
            # [ doc = "The Minus port is fixed. Only the inputs to the Plus port are swept in each round." ]
            _1,
        }
        impl FxmpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FxmpR::_0 => 0,
                    FxmpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FxmpR {
                match bits {
                    0 => FxmpR::_0,
                    1 => FxmpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FxmpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FxmpR::_1
            }
        }
        # [ doc = "Possible values of the field `RRIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RrieR {
            # [ doc = "The round-robin interrupt is disabled." ]
            _0,
            # [ doc = "The round-robin interrupt is enabled when a comparison result changes from the last sample." ]
            _1,
        }
        impl RrieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RrieR::_0 => 0,
                    RrieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RrieR {
                match bits {
                    0 => RrieR::_0,
                    1 => RrieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RrieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RrieR::_1
            }
        }
        # [ doc = "Possible values of the field `RRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RreR {
            # [ doc = "Round-robin operation is disabled." ]
            _0,
            # [ doc = "Round-robin operation is enabled." ]
            _1,
        }
        impl RreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RreR::_0 => 0,
                    RreR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RreR {
                match bits {
                    0 => RreR::_0,
                    1 => RreR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RreR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RreR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AconW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AconW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INITMOD`" ]
        pub enum InitmodW {
            # [ doc = "The modulus is set to 64(same with 111111)." ]
            _000000,
        }
        impl InitmodW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    InitmodW::_000000 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _InitmodW<'a> {
            w: &'a mut W,
        }
        impl<'a> _InitmodW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: InitmodW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "The modulus is set to 64(same with 111111)." ]
            # [ inline ( always ) ]
            pub fn _000000(self) -> &'a mut W {
                self.variant(InitmodW::_000000)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 63;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `NSAM`" ]
        pub enum NsamW {
            # [ doc = "The comparison result is sampled as soon as the active channel is scanned in one round-robin clock." ]
            _00,
            # [ doc = "The sampling takes place 1 round-robin clock cycle after the next cycle of the round-robin clock." ]
            _01,
            # [ doc = "The sampling takes place 2 round-robin clock cycles after the next cycle of the round-robin clock." ]
            _10,
            # [ doc = "The sampling takes place 3 round-robin clock cycles after the next cycle of the round-robin clock." ]
            _11,
        }
        impl NsamW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    NsamW::_00 => 0,
                    NsamW::_01 => 1,
                    NsamW::_10 => 2,
                    NsamW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _NsamW<'a> {
            w: &'a mut W,
        }
        impl<'a> _NsamW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: NsamW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The comparison result is sampled as soon as the active channel is scanned in one round-robin clock." ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(NsamW::_00)
            }
            # [ doc = "The sampling takes place 1 round-robin clock cycle after the next cycle of the round-robin clock." ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(NsamW::_01)
            }
            # [ doc = "The sampling takes place 2 round-robin clock cycles after the next cycle of the round-robin clock." ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(NsamW::_10)
            }
            # [ doc = "The sampling takes place 3 round-robin clock cycles after the next cycle of the round-robin clock." ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(NsamW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch0fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch0fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch1fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch1fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 17;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch2fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch2fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch3fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch3fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 19;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch4fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch4fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch5fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch5fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch6fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch6fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Ch7fW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Ch7fW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 23;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FXMXCH`" ]
        pub enum FxmxchW {
            # [ doc = "Channel 0 is selected as the fixed reference input for the fixed mux port." ]
            _000,
            # [ doc = "Channel 1 is selected as the fixed reference input for the fixed mux port." ]
            _001,
            # [ doc = "Channel 2 is selected as the fixed reference input for the fixed mux port." ]
            _010,
            # [ doc = "Channel 3 is selected as the fixed reference input for the fixed mux port." ]
            _011,
            # [ doc = "Channel 4 is selected as the fixed reference input for the fixed mux port." ]
            _100,
            # [ doc = "Channel 5 is selected as the fixed reference input for the fixed mux port." ]
            _101,
            # [ doc = "Channel 6 is selected as the fixed reference input for the fixed mux port." ]
            _110,
            # [ doc = "Channel 7 is selected as the fixed reference input for the fixed mux port." ]
            _111,
        }
        impl FxmxchW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FxmxchW::_000 => 0,
                    FxmxchW::_001 => 1,
                    FxmxchW::_010 => 2,
                    FxmxchW::_011 => 3,
                    FxmxchW::_100 => 4,
                    FxmxchW::_101 => 5,
                    FxmxchW::_110 => 6,
                    FxmxchW::_111 => 7,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FxmxchW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FxmxchW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FxmxchW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Channel 0 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(FxmxchW::_000)
            }
            # [ doc = "Channel 1 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _001(self) -> &'a mut W {
                self.variant(FxmxchW::_001)
            }
            # [ doc = "Channel 2 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(FxmxchW::_010)
            }
            # [ doc = "Channel 3 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _011(self) -> &'a mut W {
                self.variant(FxmxchW::_011)
            }
            # [ doc = "Channel 4 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _100(self) -> &'a mut W {
                self.variant(FxmxchW::_100)
            }
            # [ doc = "Channel 5 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _101(self) -> &'a mut W {
                self.variant(FxmxchW::_101)
            }
            # [ doc = "Channel 6 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(FxmxchW::_110)
            }
            # [ doc = "Channel 7 is selected as the fixed reference input for the fixed mux port." ]
            # [ inline ( always ) ]
            pub fn _111(self) -> &'a mut W {
                self.variant(FxmxchW::_111)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FXMP`" ]
        pub enum FxmpW {
            # [ doc = "The Plus port is fixed. Only the inputs to the Minus port are swept in each round." ]
            _0,
            # [ doc = "The Minus port is fixed. Only the inputs to the Plus port are swept in each round." ]
            _1,
        }
        impl FxmpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FxmpW::_0 => 0,
                    FxmpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FxmpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FxmpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FxmpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The Plus port is fixed. Only the inputs to the Minus port are swept in each round." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FxmpW::_0)
            }
            # [ doc = "The Minus port is fixed. Only the inputs to the Plus port are swept in each round." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FxmpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 29;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRIE`" ]
        pub enum RrieW {
            # [ doc = "The round-robin interrupt is disabled." ]
            _0,
            # [ doc = "The round-robin interrupt is enabled when a comparison result changes from the last sample." ]
            _1,
        }
        impl RrieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RrieW::_0 => 0,
                    RrieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RrieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RrieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RrieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "The round-robin interrupt is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RrieW::_0)
            }
            # [ doc = "The round-robin interrupt is enabled when a comparison result changes from the last sample." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RrieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RRE`" ]
        pub enum RreW {
            # [ doc = "Round-robin operation is disabled." ]
            _0,
            # [ doc = "Round-robin operation is enabled." ]
            _1,
        }
        impl RreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RreW::_0 => 0,
                    RreW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RreW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Round-robin operation is disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RreW::_0)
            }
            # [ doc = "Round-robin operation is enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RreW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - The result of the input comparison for channel n" ]
            # [ inline ( always ) ]
            pub fn acon(&self) -> AconR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                AconR { bits }
            }
            # [ doc = "Bits 8:13 - Comparator and DAC initialization delay modulus." ]
            # [ inline ( always ) ]
            pub fn initmod(&self) -> InitmodR {
                InitmodR::_from({
                                    const MASK: u8 = 63;
                                    const OFFSET: u8 = 8;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bits 14:15 - Number of sample clocks" ]
            # [ inline ( always ) ]
            pub fn nsam(&self) -> NsamR {
                NsamR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Channel 0 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch0f(&self) -> Ch0fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch0fR { bits }
            }
            # [ doc = "Bit 17 - Channel 1 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch1f(&self) -> Ch1fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 17;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch1fR { bits }
            }
            # [ doc = "Bit 18 - Channel 2 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch2f(&self) -> Ch2fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 18;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch2fR { bits }
            }
            # [ doc = "Bit 19 - Channel 3 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch3f(&self) -> Ch3fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 19;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch3fR { bits }
            }
            # [ doc = "Bit 20 - Channel 4 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch4f(&self) -> Ch4fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch4fR { bits }
            }
            # [ doc = "Bit 21 - Channel 5 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch5f(&self) -> Ch5fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch5fR { bits }
            }
            # [ doc = "Bit 22 - Channel 6 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch6f(&self) -> Ch6fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch6fR { bits }
            }
            # [ doc = "Bit 23 - Channel 7 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch7f(&self) -> Ch7fR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 23;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Ch7fR { bits }
            }
            # [ doc = "Bits 25:27 - Fixed channel selection" ]
            # [ inline ( always ) ]
            pub fn fxmxch(&self) -> FxmxchR {
                FxmxchR::_from({
                                   const MASK: u8 = 7;
                                   const OFFSET: u8 = 25;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 29 - Fixed MUX Port" ]
            # [ inline ( always ) ]
            pub fn fxmp(&self) -> FxmpR {
                FxmpR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 29;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 30 - Round-Robin interrupt enable" ]
            # [ inline ( always ) ]
            pub fn rrie(&self) -> RrieR {
                RrieR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 30;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 31 - Round-Robin Enable" ]
            # [ inline ( always ) ]
            pub fn rre(&self) -> RreR {
                RreR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 31;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - The result of the input comparison for channel n" ]
            # [ inline ( always ) ]
            pub fn acon(&mut self) -> _AconW {
                _AconW { w: self }
            }
            # [ doc = "Bits 8:13 - Comparator and DAC initialization delay modulus." ]
            # [ inline ( always ) ]
            pub fn initmod(&mut self) -> _InitmodW {
                _InitmodW { w: self }
            }
            # [ doc = "Bits 14:15 - Number of sample clocks" ]
            # [ inline ( always ) ]
            pub fn nsam(&mut self) -> _NsamW {
                _NsamW { w: self }
            }
            # [ doc = "Bit 16 - Channel 0 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch0f(&mut self) -> _Ch0fW {
                _Ch0fW { w: self }
            }
            # [ doc = "Bit 17 - Channel 1 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch1f(&mut self) -> _Ch1fW {
                _Ch1fW { w: self }
            }
            # [ doc = "Bit 18 - Channel 2 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch2f(&mut self) -> _Ch2fW {
                _Ch2fW { w: self }
            }
            # [ doc = "Bit 19 - Channel 3 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch3f(&mut self) -> _Ch3fW {
                _Ch3fW { w: self }
            }
            # [ doc = "Bit 20 - Channel 4 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch4f(&mut self) -> _Ch4fW {
                _Ch4fW { w: self }
            }
            # [ doc = "Bit 21 - Channel 5 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch5f(&mut self) -> _Ch5fW {
                _Ch5fW { w: self }
            }
            # [ doc = "Bit 22 - Channel 6 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch6f(&mut self) -> _Ch6fW {
                _Ch6fW { w: self }
            }
            # [ doc = "Bit 23 - Channel 7 input changed flag" ]
            # [ inline ( always ) ]
            pub fn ch7f(&mut self) -> _Ch7fW {
                _Ch7fW { w: self }
            }
            # [ doc = "Bits 25:27 - Fixed channel selection" ]
            # [ inline ( always ) ]
            pub fn fxmxch(&mut self) -> _FxmxchW {
                _FxmxchW { w: self }
            }
            # [ doc = "Bit 29 - Fixed MUX Port" ]
            # [ inline ( always ) ]
            pub fn fxmp(&mut self) -> _FxmpW {
                _FxmpW { w: self }
            }
            # [ doc = "Bit 30 - Round-Robin interrupt enable" ]
            # [ inline ( always ) ]
            pub fn rrie(&mut self) -> _RrieW {
                _RrieW { w: self }
            }
            # [ doc = "Bit 31 - Round-Robin Enable" ]
            # [ inline ( always ) ]
            pub fn rre(&mut self) -> _RreW {
                _RreW { w: self }
            }
        }
    }
}
# [ doc = "High-Speed Comparator (CMP), Voltage Reference (VREF) Digital-to-Analog Converter (DAC), and Analog Mux (ANMUX)" ]
pub struct Cmp0 {
    register_block: cmp0::RegisterBlock,
}
impl Deref for Cmp0 {
    type Target = cmp0::RegisterBlock;
    fn deref(&self) -> &cmp0::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "PMC" ]
pub const PMC: Peripheral<Pmc> = unsafe { Peripheral::new(1074253824) };
# [ doc = "PMC" ]
pub mod pmc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Low Voltage Detect Status and Control 1 Register" ]
        pub lvdsc1: Lvdsc1,
        # [ doc = "0x01 - Low Voltage Detect Status and Control 2 Register" ]
        pub lvdsc2: Lvdsc2,
        # [ doc = "0x02 - Regulator Status and Control Register" ]
        pub regsc: Regsc,
        _reserved0: [u8; 1usize],
        # [ doc = "0x04 - Low Power Oscillator Trim Register" ]
        pub lpotrim: Lpotrim,
    }
    # [ doc = "Low Voltage Detect Status and Control 1 Register" ]
    pub struct Lvdsc1 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Low Voltage Detect Status and Control 1 Register" ]
    pub mod lvdsc1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Lvdsc1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `LVDRE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LvdreR {
            # [ doc = "No system resets on low voltage detect events." ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl LvdreR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LvdreR::_0 => 0,
                    LvdreR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LvdreR {
                match bits {
                    0 => LvdreR::_0,
                    i => LvdreR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LvdreR::_0
            }
        }
        # [ doc = "Possible values of the field `LVDIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LvdieR {
            # [ doc = "Hardware interrupt disabled (use polling)" ]
            _0,
            # [ doc = "Request a hardware interrupt when LVDF = 1" ]
            _1,
        }
        impl LvdieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LvdieR::_0 => 0,
                    LvdieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LvdieR {
                match bits {
                    0 => LvdieR::_0,
                    1 => LvdieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LvdieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LvdieR::_1
            }
        }
        # [ doc = "Possible values of the field `LVDF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LvdfR {
            # [ doc = "Low-voltage event not detected" ]
            _0,
            # [ doc = "Low-voltage event detected" ]
            _1,
        }
        impl LvdfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LvdfR::_0 => 0,
                    LvdfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LvdfR {
                match bits {
                    0 => LvdfR::_0,
                    1 => LvdfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LvdfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LvdfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `LVDRE`" ]
        pub enum LvdreW {
            # [ doc = "No system resets on low voltage detect events." ]
            _0,
        }
        impl LvdreW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LvdreW::_0 => 0,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LvdreW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LvdreW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LvdreW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "No system resets on low voltage detect events." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LvdreW::_0)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LVDIE`" ]
        pub enum LvdieW {
            # [ doc = "Hardware interrupt disabled (use polling)" ]
            _0,
            # [ doc = "Request a hardware interrupt when LVDF = 1" ]
            _1,
        }
        impl LvdieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LvdieW::_0 => 0,
                    LvdieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LvdieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LvdieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LvdieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupt disabled (use polling)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LvdieW::_0)
            }
            # [ doc = "Request a hardware interrupt when LVDF = 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LvdieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LvdackW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LvdackW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 4 - Low Voltage Detect Reset Enable" ]
            # [ inline ( always ) ]
            pub fn lvdre(&self) -> LvdreR {
                LvdreR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 4;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
            # [ doc = "Bit 5 - Low Voltage Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lvdie(&self) -> LvdieR {
                LvdieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
            # [ doc = "Bit 7 - Low Voltage Detect Flag" ]
            # [ inline ( always ) ]
            pub fn lvdf(&self) -> LvdfR {
                LvdfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 4 - Low Voltage Detect Reset Enable" ]
            # [ inline ( always ) ]
            pub fn lvdre(&mut self) -> _LvdreW {
                _LvdreW { w: self }
            }
            # [ doc = "Bit 5 - Low Voltage Detect Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lvdie(&mut self) -> _LvdieW {
                _LvdieW { w: self }
            }
            # [ doc = "Bit 6 - Low Voltage Detect Acknowledge" ]
            # [ inline ( always ) ]
            pub fn lvdack(&mut self) -> _LvdackW {
                _LvdackW { w: self }
            }
        }
    }
    # [ doc = "Low Voltage Detect Status and Control 2 Register" ]
    pub struct Lvdsc2 {
        register: VolatileCell<u8>,
    }
    # [ doc = "Low Voltage Detect Status and Control 2 Register" ]
    pub mod lvdsc2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Lvdsc2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `LVWIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LvwieR {
            # [ doc = "Hardware interrupt disabled (use polling)" ]
            _0,
            # [ doc = "Request a hardware interrupt when LVWF=1" ]
            _1,
        }
        impl LvwieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LvwieR::_0 => 0,
                    LvwieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LvwieR {
                match bits {
                    0 => LvwieR::_0,
                    1 => LvwieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LvwieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LvwieR::_1
            }
        }
        # [ doc = "Possible values of the field `LVWF`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LvwfR {
            # [ doc = "Low-voltage warning event not detected" ]
            _0,
            # [ doc = "Low-voltage warning event detected" ]
            _1,
        }
        impl LvwfR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LvwfR::_0 => 0,
                    LvwfR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LvwfR {
                match bits {
                    0 => LvwfR::_0,
                    1 => LvwfR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LvwfR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LvwfR::_1
            }
        }
        # [ doc = "Values that can be written to the field `LVWIE`" ]
        pub enum LvwieW {
            # [ doc = "Hardware interrupt disabled (use polling)" ]
            _0,
            # [ doc = "Request a hardware interrupt when LVWF=1" ]
            _1,
        }
        impl LvwieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LvwieW::_0 => 0,
                    LvwieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LvwieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LvwieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LvwieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Hardware interrupt disabled (use polling)" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LvwieW::_0)
            }
            # [ doc = "Request a hardware interrupt when LVWF=1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LvwieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LvwackW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LvwackW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 5 - Low-Voltage Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lvwie(&self) -> LvwieR {
                LvwieR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u8) as u8
                              })
            }
            # [ doc = "Bit 7 - Low-Voltage Warning Flag" ]
            # [ inline ( always ) ]
            pub fn lvwf(&self) -> LvwfR {
                LvwfR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u8) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 5 - Low-Voltage Warning Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn lvwie(&mut self) -> _LvwieW {
                _LvwieW { w: self }
            }
            # [ doc = "Bit 6 - Low-Voltage Warning Acknowledge" ]
            # [ inline ( always ) ]
            pub fn lvwack(&mut self) -> _LvwackW {
                _LvwackW { w: self }
            }
        }
    }
    # [ doc = "Regulator Status and Control Register" ]
    pub struct Regsc {
        register: VolatileCell<u8>,
    }
    # [ doc = "Regulator Status and Control Register" ]
    pub mod regsc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Regsc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `BIASEN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum BiasenR {
            # [ doc = "Biasing disabled, core logic can run in full performance" ]
            _0,
            # [ doc = "Biasing enabled, core logic is slower and there are restrictions in allowed system clock speed (see Data Sheet for details)" ]
            _1,
        }
        impl BiasenR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    BiasenR::_0 => 0,
                    BiasenR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> BiasenR {
                match bits {
                    0 => BiasenR::_0,
                    1 => BiasenR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == BiasenR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == BiasenR::_1
            }
        }
        # [ doc = "Possible values of the field `CLKBIASDIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ClkbiasdisR {
            # [ doc = "No effect" ]
            _0,
            # [ doc = "In VLPS mode, the bias currents and reference voltages for the following clock modules are disabled: SIRC, FIRC, PLL. (if available on device)" ]
            _1,
        }
        impl ClkbiasdisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ClkbiasdisR::_0 => 0,
                    ClkbiasdisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ClkbiasdisR {
                match bits {
                    0 => ClkbiasdisR::_0,
                    1 => ClkbiasdisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ClkbiasdisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ClkbiasdisR::_1
            }
        }
        # [ doc = "Possible values of the field `REGFPM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RegfpmR {
            # [ doc = "Regulator is in low power mode or transition to/from" ]
            _0,
            # [ doc = "Regulator is in full performance mode" ]
            _1,
        }
        impl RegfpmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RegfpmR::_0 => 0,
                    RegfpmR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RegfpmR {
                match bits {
                    0 => RegfpmR::_0,
                    1 => RegfpmR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RegfpmR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RegfpmR::_1
            }
        }
        # [ doc = "Possible values of the field `LPOSTAT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpostatR {
            # [ doc = "Low power oscillator in low phase" ]
            _0,
            # [ doc = "Low power oscillator in high phase" ]
            _1,
        }
        impl LpostatR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpostatR::_0 => 0,
                    LpostatR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpostatR {
                match bits {
                    0 => LpostatR::_0,
                    1 => LpostatR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpostatR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpostatR::_1
            }
        }
        # [ doc = "Possible values of the field `LPODIS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LpodisR {
            # [ doc = "Low power oscillator enabled" ]
            _0,
            # [ doc = "Low power oscillator disabled" ]
            _1,
        }
        impl LpodisR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LpodisR::_0 => 0,
                    LpodisR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LpodisR {
                match bits {
                    0 => LpodisR::_0,
                    1 => LpodisR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LpodisR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LpodisR::_1
            }
        }
        # [ doc = "Values that can be written to the field `BIASEN`" ]
        pub enum BiasenW {
            # [ doc = "Biasing disabled, core logic can run in full performance" ]
            _0,
            # [ doc = "Biasing enabled, core logic is slower and there are restrictions in allowed system clock speed (see Data Sheet for details)" ]
            _1,
        }
        impl BiasenW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    BiasenW::_0 => 0,
                    BiasenW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _BiasenW<'a> {
            w: &'a mut W,
        }
        impl<'a> _BiasenW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: BiasenW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Biasing disabled, core logic can run in full performance" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(BiasenW::_0)
            }
            # [ doc = "Biasing enabled, core logic is slower and there are restrictions in allowed system clock speed (see Data Sheet for details)" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(BiasenW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CLKBIASDIS`" ]
        pub enum ClkbiasdisW {
            # [ doc = "No effect" ]
            _0,
            # [ doc = "In VLPS mode, the bias currents and reference voltages for the following clock modules are disabled: SIRC, FIRC, PLL. (if available on device)" ]
            _1,
        }
        impl ClkbiasdisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ClkbiasdisW::_0 => 0,
                    ClkbiasdisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ClkbiasdisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ClkbiasdisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ClkbiasdisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ClkbiasdisW::_0)
            }
            # [ doc = "In VLPS mode, the bias currents and reference voltages for the following clock modules are disabled: SIRC, FIRC, PLL. (if available on device)" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ClkbiasdisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LPODIS`" ]
        pub enum LpodisW {
            # [ doc = "Low power oscillator enabled" ]
            _0,
            # [ doc = "Low power oscillator disabled" ]
            _1,
        }
        impl LpodisW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LpodisW::_0 => 0,
                    LpodisW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LpodisW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LpodisW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LpodisW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Low power oscillator enabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LpodisW::_0)
            }
            # [ doc = "Low power oscillator disabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LpodisW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bit 0 - Bias Enable Bit" ]
            # [ inline ( always ) ]
            pub fn biasen(&self) -> BiasenR {
                BiasenR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u8) as u8
                               })
            }
            # [ doc = "Bit 1 - Clock Bias Disable Bit" ]
            # [ inline ( always ) ]
            pub fn clkbiasdis(&self) -> ClkbiasdisR {
                ClkbiasdisR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 1;
                                       ((self.bits >> OFFSET) & MASK as u8) as u8
                                   })
            }
            # [ doc = "Bit 2 - Regulator in Full Performance Mode Status Bit" ]
            # [ inline ( always ) ]
            pub fn regfpm(&self) -> RegfpmR {
                RegfpmR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u8) as u8
                               })
            }
            # [ doc = "Bit 6 - LPO Status Bit" ]
            # [ inline ( always ) ]
            pub fn lpostat(&self) -> LpostatR {
                LpostatR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 6;
                                    ((self.bits >> OFFSET) & MASK as u8) as u8
                                })
            }
            # [ doc = "Bit 7 - LPO Disable Bit" ]
            # [ inline ( always ) ]
            pub fn lpodis(&self) -> LpodisR {
                LpodisR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u8) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 4 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Bias Enable Bit" ]
            # [ inline ( always ) ]
            pub fn biasen(&mut self) -> _BiasenW {
                _BiasenW { w: self }
            }
            # [ doc = "Bit 1 - Clock Bias Disable Bit" ]
            # [ inline ( always ) ]
            pub fn clkbiasdis(&mut self) -> _ClkbiasdisW {
                _ClkbiasdisW { w: self }
            }
            # [ doc = "Bit 7 - LPO Disable Bit" ]
            # [ inline ( always ) ]
            pub fn lpodis(&mut self) -> _LpodisW {
                _LpodisW { w: self }
            }
        }
    }
    # [ doc = "Low Power Oscillator Trim Register" ]
    pub struct Lpotrim {
        register: VolatileCell<u8>,
    }
    # [ doc = "Low Power Oscillator Trim Register" ]
    pub mod lpotrim {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u8,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u8,
        }
        impl super::Lpotrim {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LpotrimR {
            bits: u8,
        }
        impl LpotrimR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LpotrimW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LpotrimW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u8) << OFFSET);
                self.w.bits |= ((bits & MASK) as u8) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
            # [ doc = "Bits 0:4 - LPO trimming bits" ]
            # [ inline ( always ) ]
            pub fn lpotrim(&self) -> LpotrimR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u8) as u8
                };
                LpotrimR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:4 - LPO trimming bits" ]
            # [ inline ( always ) ]
            pub fn lpotrim(&mut self) -> _LpotrimW {
                _LpotrimW { w: self }
            }
        }
    }
}
# [ doc = "PMC" ]
pub struct Pmc {
    register_block: pmc::RegisterBlock,
}
impl Deref for Pmc {
    type Target = pmc::RegisterBlock;
    fn deref(&self) -> &pmc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "System Mode Controller" ]
pub const SMC: Peripheral<Smc> = unsafe { Peripheral::new(1074257920) };
# [ doc = "System Mode Controller" ]
pub mod smc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - SMC Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - SMC Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - Power Mode Protection register" ]
        pub pmprot: Pmprot,
        # [ doc = "0x0c - Power Mode Control register" ]
        pub pmctrl: Pmctrl,
        # [ doc = "0x10 - Stop Control Register" ]
        pub stopctrl: Stopctrl,
        # [ doc = "0x14 - Power Mode Status register" ]
        pub pmstat: Pmstat,
    }
    # [ doc = "SMC Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "SMC Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard features implemented" ]
            _0,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_0 => 0,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    0 => FeatureR::_0,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FeatureR::_0
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Specification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "SMC Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "SMC Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `EHSRUN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EhsrunR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EhsrunR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EhsrunR::_0 => 0,
                    EhsrunR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EhsrunR {
                match bits {
                    0 => EhsrunR::_0,
                    1 => EhsrunR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EhsrunR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EhsrunR::_1
            }
        }
        # [ doc = "Possible values of the field `ELLS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EllsR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EllsR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EllsR::_0 => 0,
                    EllsR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EllsR {
                match bits {
                    0 => EllsR::_0,
                    1 => EllsR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EllsR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EllsR::_1
            }
        }
        # [ doc = "Possible values of the field `ELLS2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ells2R {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl Ells2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ells2R::_0 => 0,
                    Ells2R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ells2R {
                match bits {
                    0 => Ells2R::_0,
                    1 => Ells2R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ells2R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ells2R::_1
            }
        }
        # [ doc = "Possible values of the field `EVLLS0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Evlls0R {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl Evlls0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Evlls0R::_0 => 0,
                    Evlls0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Evlls0R {
                match bits {
                    0 => Evlls0R::_0,
                    1 => Evlls0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Evlls0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Evlls0R::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Existence of HSRUN feature" ]
            # [ inline ( always ) ]
            pub fn ehsrun(&self) -> EhsrunR {
                EhsrunR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 3 - Existence of LLS feature" ]
            # [ inline ( always ) ]
            pub fn ells(&self) -> EllsR {
                EllsR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Existence of LLS2 feature" ]
            # [ inline ( always ) ]
            pub fn ells2(&self) -> Ells2R {
                Ells2R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Existence of VLLS0 feature" ]
            # [ inline ( always ) ]
            pub fn evlls0(&self) -> Evlls0R {
                Evlls0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 6;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
    }
    # [ doc = "Power Mode Protection register" ]
    pub struct Pmprot {
        register: VolatileCell<u32>,
    }
    # [ doc = "Power Mode Protection register" ]
    pub mod pmprot {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pmprot {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `AVLP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AvlpR {
            # [ doc = "VLPR and VLPS are not allowed." ]
            _0,
            # [ doc = "VLPR and VLPS are allowed." ]
            _1,
        }
        impl AvlpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AvlpR::_0 => 0,
                    AvlpR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AvlpR {
                match bits {
                    0 => AvlpR::_0,
                    1 => AvlpR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AvlpR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AvlpR::_1
            }
        }
        # [ doc = "Possible values of the field `AHSRUN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AhsrunR {
            # [ doc = "HSRUN is not allowed" ]
            _0,
            # [ doc = "HSRUN is allowed" ]
            _1,
        }
        impl AhsrunR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AhsrunR::_0 => 0,
                    AhsrunR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AhsrunR {
                match bits {
                    0 => AhsrunR::_0,
                    1 => AhsrunR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AhsrunR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AhsrunR::_1
            }
        }
        # [ doc = "Values that can be written to the field `AVLP`" ]
        pub enum AvlpW {
            # [ doc = "VLPR and VLPS are not allowed." ]
            _0,
            # [ doc = "VLPR and VLPS are allowed." ]
            _1,
        }
        impl AvlpW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AvlpW::_0 => 0,
                    AvlpW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AvlpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AvlpW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AvlpW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "VLPR and VLPS are not allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AvlpW::_0)
            }
            # [ doc = "VLPR and VLPS are allowed." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AvlpW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `AHSRUN`" ]
        pub enum AhsrunW {
            # [ doc = "HSRUN is not allowed" ]
            _0,
            # [ doc = "HSRUN is allowed" ]
            _1,
        }
        impl AhsrunW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    AhsrunW::_0 => 0,
                    AhsrunW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _AhsrunW<'a> {
            w: &'a mut W,
        }
        impl<'a> _AhsrunW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: AhsrunW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "HSRUN is not allowed" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(AhsrunW::_0)
            }
            # [ doc = "HSRUN is allowed" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(AhsrunW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 5 - Allow Very-Low-Power Modes" ]
            # [ inline ( always ) ]
            pub fn avlp(&self) -> AvlpR {
                AvlpR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Allow High Speed Run mode" ]
            # [ inline ( always ) ]
            pub fn ahsrun(&self) -> AhsrunR {
                AhsrunR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 7;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 5 - Allow Very-Low-Power Modes" ]
            # [ inline ( always ) ]
            pub fn avlp(&mut self) -> _AvlpW {
                _AvlpW { w: self }
            }
            # [ doc = "Bit 7 - Allow High Speed Run mode" ]
            # [ inline ( always ) ]
            pub fn ahsrun(&mut self) -> _AhsrunW {
                _AhsrunW { w: self }
            }
        }
    }
    # [ doc = "Power Mode Control register" ]
    pub struct Pmctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Power Mode Control register" ]
    pub mod pmctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pmctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `STOPM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StopmR {
            # [ doc = "Normal Stop (STOP)" ]
            _000,
            # [ doc = "Very-Low-Power Stop (VLPS)" ]
            _010,
            # [ doc = "Reseved" ]
            _110,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl StopmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StopmR::_000 => 0,
                    StopmR::_010 => 2,
                    StopmR::_110 => 6,
                    StopmR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StopmR {
                match bits {
                    0 => StopmR::_000,
                    2 => StopmR::_010,
                    6 => StopmR::_110,
                    i => StopmR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == StopmR::_000
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == StopmR::_010
            }
            # [ doc = "Checks if the value of the field is `_110`" ]
            # [ inline ( always ) ]
            pub fn is_110(&self) -> bool {
                *self == StopmR::_110
            }
        }
        # [ doc = "Possible values of the field `VLPSA`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VlpsaR {
            # [ doc = "The previous stop mode entry was successful." ]
            _0,
            # [ doc = "The previous stop mode entry was aborted." ]
            _1,
        }
        impl VlpsaR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VlpsaR::_0 => 0,
                    VlpsaR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VlpsaR {
                match bits {
                    0 => VlpsaR::_0,
                    1 => VlpsaR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VlpsaR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VlpsaR::_1
            }
        }
        # [ doc = "Possible values of the field `RUNM`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RunmR {
            # [ doc = "Normal Run mode (RUN)" ]
            _00,
            # [ doc = "Very-Low-Power Run mode (VLPR)" ]
            _10,
            # [ doc = "High Speed Run mode (HSRUN)" ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RunmR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RunmR::_00 => 0,
                    RunmR::_10 => 2,
                    RunmR::_11 => 3,
                    RunmR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RunmR {
                match bits {
                    0 => RunmR::_00,
                    2 => RunmR::_10,
                    3 => RunmR::_11,
                    i => RunmR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == RunmR::_00
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == RunmR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == RunmR::_11
            }
        }
        # [ doc = "Values that can be written to the field `STOPM`" ]
        pub enum StopmW {
            # [ doc = "Normal Stop (STOP)" ]
            _000,
            # [ doc = "Very-Low-Power Stop (VLPS)" ]
            _010,
            # [ doc = "Reseved" ]
            _110,
        }
        impl StopmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StopmW::_000 => 0,
                    StopmW::_010 => 2,
                    StopmW::_110 => 6,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StopmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StopmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StopmW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Normal Stop (STOP)" ]
            # [ inline ( always ) ]
            pub fn _000(self) -> &'a mut W {
                self.variant(StopmW::_000)
            }
            # [ doc = "Very-Low-Power Stop (VLPS)" ]
            # [ inline ( always ) ]
            pub fn _010(self) -> &'a mut W {
                self.variant(StopmW::_010)
            }
            # [ doc = "Reseved" ]
            # [ inline ( always ) ]
            pub fn _110(self) -> &'a mut W {
                self.variant(StopmW::_110)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 7;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RUNM`" ]
        pub enum RunmW {
            # [ doc = "Normal Run mode (RUN)" ]
            _00,
            # [ doc = "Very-Low-Power Run mode (VLPR)" ]
            _10,
            # [ doc = "High Speed Run mode (HSRUN)" ]
            _11,
        }
        impl RunmW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RunmW::_00 => 0,
                    RunmW::_10 => 2,
                    RunmW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RunmW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RunmW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RunmW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "Normal Run mode (RUN)" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(RunmW::_00)
            }
            # [ doc = "Very-Low-Power Run mode (VLPR)" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(RunmW::_10)
            }
            # [ doc = "High Speed Run mode (HSRUN)" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(RunmW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:2 - Stop Mode Control" ]
            # [ inline ( always ) ]
            pub fn stopm(&self) -> StopmR {
                StopmR::_from({
                                  const MASK: u8 = 7;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 3 - Very Low Power Stop Aborted" ]
            # [ inline ( always ) ]
            pub fn vlpsa(&self) -> VlpsaR {
                VlpsaR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 3;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bits 5:6 - Run Mode Control" ]
            # [ inline ( always ) ]
            pub fn runm(&self) -> RunmR {
                RunmR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:2 - Stop Mode Control" ]
            # [ inline ( always ) ]
            pub fn stopm(&mut self) -> _StopmW {
                _StopmW { w: self }
            }
            # [ doc = "Bits 5:6 - Run Mode Control" ]
            # [ inline ( always ) ]
            pub fn runm(&mut self) -> _RunmW {
                _RunmW { w: self }
            }
        }
    }
    # [ doc = "Stop Control Register" ]
    pub struct Stopctrl {
        register: VolatileCell<u32>,
    }
    # [ doc = "Stop Control Register" ]
    pub mod stopctrl {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Stopctrl {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `STOPO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum StopoR {
            # [ doc = "STOP1 - Stop with both system and bus clocks disabled" ]
            _01,
            # [ doc = "STOP2 - Stop with system clock disabled and bus clock enabled" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl StopoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    StopoR::_01 => 1,
                    StopoR::_10 => 2,
                    StopoR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> StopoR {
                match bits {
                    1 => StopoR::_01,
                    2 => StopoR::_10,
                    i => StopoR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == StopoR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == StopoR::_10
            }
        }
        # [ doc = "Values that can be written to the field `STOPO`" ]
        pub enum StopoW {
            # [ doc = "STOP1 - Stop with both system and bus clocks disabled" ]
            _01,
            # [ doc = "STOP2 - Stop with system clock disabled and bus clock enabled" ]
            _10,
        }
        impl StopoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    StopoW::_01 => 1,
                    StopoW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _StopoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _StopoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: StopoW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "STOP1 - Stop with both system and bus clocks disabled" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(StopoW::_01)
            }
            # [ doc = "STOP2 - Stop with system clock disabled and bus clock enabled" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(StopoW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 6:7 - Stop Option" ]
            # [ inline ( always ) ]
            pub fn stopo(&self) -> StopoR {
                StopoR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 6;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 3 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 6:7 - Stop Option" ]
            # [ inline ( always ) ]
            pub fn stopo(&mut self) -> _StopoW {
                _StopoW { w: self }
            }
        }
    }
    # [ doc = "Power Mode Status register" ]
    pub struct Pmstat {
        register: VolatileCell<u32>,
    }
    # [ doc = "Power Mode Status register" ]
    pub mod pmstat {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pmstat {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PmstatR {
            bits: u8,
        }
        impl PmstatR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Power Mode Status" ]
            # [ inline ( always ) ]
            pub fn pmstat(&self) -> PmstatR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PmstatR { bits }
            }
        }
    }
}
# [ doc = "System Mode Controller" ]
pub struct Smc {
    register_block: smc::RegisterBlock,
}
impl Deref for Smc {
    type Target = smc::RegisterBlock;
    fn deref(&self) -> &smc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Reset Control Module" ]
pub const RCM: Peripheral<Rcm> = unsafe { Peripheral::new(1074262016) };
# [ doc = "Reset Control Module" ]
pub mod rcm {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Version ID Register" ]
        pub verid: Verid,
        # [ doc = "0x04 - Parameter Register" ]
        pub param: Param,
        # [ doc = "0x08 - System Reset Status Register" ]
        pub srs: Srs,
        # [ doc = "0x0c - Reset Pin Control register" ]
        pub rpc: Rpc,
        _reserved0: [u8; 8usize],
        # [ doc = "0x18 - Sticky System Reset Status Register" ]
        pub ssrs: Ssrs,
        # [ doc = "0x1c - System Reset Interrupt Enable Register" ]
        pub srie: Srie,
    }
    # [ doc = "Version ID Register" ]
    pub struct Verid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Version ID Register" ]
    pub mod verid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Verid {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `FEATURE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FeatureR {
            # [ doc = "Standard feature set." ]
            _11,
            # [ doc = r" Reserved" ]
            _Reserved(u16),
        }
        impl FeatureR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                match *self {
                    FeatureR::_11 => 3,
                    FeatureR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u16) -> FeatureR {
                match bits {
                    3 => FeatureR::_11,
                    i => FeatureR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == FeatureR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MinorR {
            bits: u8,
        }
        impl MinorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct MajorR {
            bits: u8,
        }
        impl MajorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:15 - Feature Specification Number" ]
            # [ inline ( always ) ]
            pub fn feature(&self) -> FeatureR {
                FeatureR::_from({
                                    const MASK: u16 = 65535;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u16
                                })
            }
            # [ doc = "Bits 16:23 - Minor Version Number" ]
            # [ inline ( always ) ]
            pub fn minor(&self) -> MinorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MinorR { bits }
            }
            # [ doc = "Bits 24:31 - Major Version Number" ]
            # [ inline ( always ) ]
            pub fn major(&self) -> MajorR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 24;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                MajorR { bits }
            }
        }
    }
    # [ doc = "Parameter Register" ]
    pub struct Param {
        register: VolatileCell<u32>,
    }
    # [ doc = "Parameter Register" ]
    pub mod param {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Param {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `EWAKEUP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EwakeupR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EwakeupR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EwakeupR::_0 => 0,
                    EwakeupR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EwakeupR {
                match bits {
                    0 => EwakeupR::_0,
                    1 => EwakeupR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EwakeupR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EwakeupR::_1
            }
        }
        # [ doc = "Possible values of the field `ELVD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElvdR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl ElvdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElvdR::_0 => 0,
                    ElvdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElvdR {
                match bits {
                    0 => ElvdR::_0,
                    1 => ElvdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElvdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElvdR::_1
            }
        }
        # [ doc = "Possible values of the field `ELOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElocR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl ElocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElocR::_0 => 0,
                    ElocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElocR {
                match bits {
                    0 => ElocR::_0,
                    1 => ElocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElocR::_1
            }
        }
        # [ doc = "Possible values of the field `ELOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElolR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl ElolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElolR::_0 => 0,
                    ElolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElolR {
                match bits {
                    0 => ElolR::_0,
                    1 => ElolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElolR::_1
            }
        }
        # [ doc = "Possible values of the field `EWDOG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EwdogR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EwdogR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EwdogR::_0 => 0,
                    EwdogR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EwdogR {
                match bits {
                    0 => EwdogR::_0,
                    1 => EwdogR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EwdogR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EwdogR::_1
            }
        }
        # [ doc = "Possible values of the field `EPIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EpinR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EpinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EpinR::_0 => 0,
                    EpinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EpinR {
                match bits {
                    0 => EpinR::_0,
                    1 => EpinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EpinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EpinR::_1
            }
        }
        # [ doc = "Possible values of the field `EPOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EporR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EporR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EporR::_0 => 0,
                    EporR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EporR {
                match bits {
                    0 => EporR::_0,
                    1 => EporR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EporR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EporR::_1
            }
        }
        # [ doc = "Possible values of the field `EJTAG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EjtagR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EjtagR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EjtagR::_0 => 0,
                    EjtagR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EjtagR {
                match bits {
                    0 => EjtagR::_0,
                    1 => EjtagR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EjtagR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EjtagR::_1
            }
        }
        # [ doc = "Possible values of the field `ELOCKUP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ElockupR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl ElockupR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ElockupR::_0 => 0,
                    ElockupR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ElockupR {
                match bits {
                    0 => ElockupR::_0,
                    1 => ElockupR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ElockupR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ElockupR::_1
            }
        }
        # [ doc = "Possible values of the field `ESW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EswR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EswR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EswR::_0 => 0,
                    EswR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EswR {
                match bits {
                    0 => EswR::_0,
                    1 => EswR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EswR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EswR::_1
            }
        }
        # [ doc = "Possible values of the field `EMDM_AP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EmdmApR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EmdmApR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EmdmApR::_0 => 0,
                    EmdmApR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EmdmApR {
                match bits {
                    0 => EmdmApR::_0,
                    1 => EmdmApR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EmdmApR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EmdmApR::_1
            }
        }
        # [ doc = "Possible values of the field `ESACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EsackerrR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EsackerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EsackerrR::_0 => 0,
                    EsackerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EsackerrR {
                match bits {
                    0 => EsackerrR::_0,
                    1 => EsackerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EsackerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EsackerrR::_1
            }
        }
        # [ doc = "Possible values of the field `ETAMPER`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EtamperR {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl EtamperR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EtamperR::_0 => 0,
                    EtamperR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EtamperR {
                match bits {
                    0 => EtamperR::_0,
                    1 => EtamperR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EtamperR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EtamperR::_1
            }
        }
        # [ doc = "Possible values of the field `ECORE1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Ecore1R {
            # [ doc = "The feature is not available." ]
            _0,
            # [ doc = "The feature is available." ]
            _1,
        }
        impl Ecore1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Ecore1R::_0 => 0,
                    Ecore1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Ecore1R {
                match bits {
                    0 => Ecore1R::_0,
                    1 => Ecore1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Ecore1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Ecore1R::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Existence of SRS[WAKEUP] status indication feature" ]
            # [ inline ( always ) ]
            pub fn ewakeup(&self) -> EwakeupR {
                EwakeupR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 1 - Existence of SRS[LVD] status indication feature" ]
            # [ inline ( always ) ]
            pub fn elvd(&self) -> ElvdR {
                ElvdR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Existence of SRS[LOC] status indication feature" ]
            # [ inline ( always ) ]
            pub fn eloc(&self) -> ElocR {
                ElocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Existence of SRS[LOL] status indication feature" ]
            # [ inline ( always ) ]
            pub fn elol(&self) -> ElolR {
                ElolR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Existence of SRS[WDOG] status indication feature" ]
            # [ inline ( always ) ]
            pub fn ewdog(&self) -> EwdogR {
                EwdogR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Existence of SRS[PIN] status indication feature" ]
            # [ inline ( always ) ]
            pub fn epin(&self) -> EpinR {
                EpinR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Existence of SRS[POR] status indication feature" ]
            # [ inline ( always ) ]
            pub fn epor(&self) -> EporR {
                EporR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Existence of SRS[JTAG] status indication feature" ]
            # [ inline ( always ) ]
            pub fn ejtag(&self) -> EjtagR {
                EjtagR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Existence of SRS[LOCKUP] status indication feature" ]
            # [ inline ( always ) ]
            pub fn elockup(&self) -> ElockupR {
                ElockupR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 10 - Existence of SRS[SW] status indication feature" ]
            # [ inline ( always ) ]
            pub fn esw(&self) -> EswR {
                EswR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Existence of SRS[MDM_AP] status indication feature" ]
            # [ inline ( always ) ]
            pub fn emdm_ap(&self) -> EmdmApR {
                EmdmApR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Existence of SRS[SACKERR] status indication feature" ]
            # [ inline ( always ) ]
            pub fn esackerr(&self) -> EsackerrR {
                EsackerrR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 13;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 15 - Existence of SRS[TAMPER] status indication feature" ]
            # [ inline ( always ) ]
            pub fn etamper(&self) -> EtamperR {
                EtamperR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 15;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 16 - Existence of SRS[CORE1] status indication feature" ]
            # [ inline ( always ) ]
            pub fn ecore1(&self) -> Ecore1R {
                Ecore1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 16;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
    }
    # [ doc = "System Reset Status Register" ]
    pub struct Srs {
        register: VolatileCell<u32>,
    }
    # [ doc = "System Reset Status Register" ]
    pub mod srs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Srs {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `LVD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LvdR {
            # [ doc = "Reset not caused by LVD trip, HVD trip or POR" ]
            _0,
            # [ doc = "Reset caused by LVD trip, HVD trip or POR" ]
            _1,
        }
        impl LvdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LvdR::_0 => 0,
                    LvdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LvdR {
                match bits {
                    0 => LvdR::_0,
                    1 => LvdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LvdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LvdR::_1
            }
        }
        # [ doc = "Possible values of the field `LOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LocR {
            # [ doc = "Reset not caused by a loss of external clock." ]
            _0,
            # [ doc = "Reset caused by a loss of external clock." ]
            _1,
        }
        impl LocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LocR::_0 => 0,
                    LocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LocR {
                match bits {
                    0 => LocR::_0,
                    1 => LocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LocR::_1
            }
        }
        # [ doc = "Possible values of the field `LOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LolR {
            # [ doc = "Reset not caused by a loss of lock in the PLL/FLL" ]
            _0,
            # [ doc = "Reset caused by a loss of lock in the PLL/FLL" ]
            _1,
        }
        impl LolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LolR::_0 => 0,
                    LolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LolR {
                match bits {
                    0 => LolR::_0,
                    1 => LolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LolR::_1
            }
        }
        # [ doc = "Possible values of the field `WDOG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WdogR {
            # [ doc = "Reset not caused by watchdog timeout" ]
            _0,
            # [ doc = "Reset caused by watchdog timeout" ]
            _1,
        }
        impl WdogR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WdogR::_0 => 0,
                    WdogR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WdogR {
                match bits {
                    0 => WdogR::_0,
                    1 => WdogR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WdogR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WdogR::_1
            }
        }
        # [ doc = "Possible values of the field `PIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinR {
            # [ doc = "Reset not caused by external reset pin" ]
            _0,
            # [ doc = "Reset caused by external reset pin" ]
            _1,
        }
        impl PinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinR::_0 => 0,
                    PinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinR {
                match bits {
                    0 => PinR::_0,
                    1 => PinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinR::_1
            }
        }
        # [ doc = "Possible values of the field `POR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PorR {
            # [ doc = "Reset not caused by POR" ]
            _0,
            # [ doc = "Reset caused by POR" ]
            _1,
        }
        impl PorR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PorR::_0 => 0,
                    PorR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PorR {
                match bits {
                    0 => PorR::_0,
                    1 => PorR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PorR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PorR::_1
            }
        }
        # [ doc = "Possible values of the field `JTAG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum JtagR {
            # [ doc = "Reset not caused by JTAG" ]
            _0,
            # [ doc = "Reset caused by JTAG" ]
            _1,
        }
        impl JtagR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    JtagR::_0 => 0,
                    JtagR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> JtagR {
                match bits {
                    0 => JtagR::_0,
                    1 => JtagR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == JtagR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == JtagR::_1
            }
        }
        # [ doc = "Possible values of the field `LOCKUP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LockupR {
            # [ doc = "Reset not caused by core LOCKUP event" ]
            _0,
            # [ doc = "Reset caused by core LOCKUP event" ]
            _1,
        }
        impl LockupR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LockupR::_0 => 0,
                    LockupR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LockupR {
                match bits {
                    0 => LockupR::_0,
                    1 => LockupR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LockupR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LockupR::_1
            }
        }
        # [ doc = "Possible values of the field `SW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwR {
            # [ doc = "Reset not caused by software setting of SYSRESETREQ bit" ]
            _0,
            # [ doc = "Reset caused by software setting of SYSRESETREQ bit" ]
            _1,
        }
        impl SwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwR::_0 => 0,
                    SwR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwR {
                match bits {
                    0 => SwR::_0,
                    1 => SwR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwR::_1
            }
        }
        # [ doc = "Possible values of the field `MDM_AP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MdmApR {
            # [ doc = "Reset was not caused by host debugger system setting of the System Reset Request bit" ]
            _0,
            # [ doc = "Reset was caused by host debugger system setting of the System Reset Request bit" ]
            _1,
        }
        impl MdmApR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MdmApR::_0 => 0,
                    MdmApR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MdmApR {
                match bits {
                    0 => MdmApR::_0,
                    1 => MdmApR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MdmApR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MdmApR::_1
            }
        }
        # [ doc = "Possible values of the field `SACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SackerrR {
            # [ doc = "Reset not caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            _0,
            # [ doc = "Reset caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            _1,
        }
        impl SackerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SackerrR::_0 => 0,
                    SackerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SackerrR {
                match bits {
                    0 => SackerrR::_0,
                    1 => SackerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SackerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SackerrR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Low-Voltage Detect Reset or High-Voltage Detect Reset" ]
            # [ inline ( always ) ]
            pub fn lvd(&self) -> LvdR {
                LvdR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 1;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 2 - Loss-of-Clock Reset" ]
            # [ inline ( always ) ]
            pub fn loc(&self) -> LocR {
                LocR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Loss-of-Lock Reset" ]
            # [ inline ( always ) ]
            pub fn lol(&self) -> LolR {
                LolR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Watchdog" ]
            # [ inline ( always ) ]
            pub fn wdog(&self) -> WdogR {
                WdogR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - External Reset Pin" ]
            # [ inline ( always ) ]
            pub fn pin(&self) -> PinR {
                PinR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Power-On Reset" ]
            # [ inline ( always ) ]
            pub fn por(&self) -> PorR {
                PorR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - JTAG generated reset" ]
            # [ inline ( always ) ]
            pub fn jtag(&self) -> JtagR {
                JtagR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Core Lockup" ]
            # [ inline ( always ) ]
            pub fn lockup(&self) -> LockupR {
                LockupR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Software" ]
            # [ inline ( always ) ]
            pub fn sw(&self) -> SwR {
                SwR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 10;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 11 - MDM-AP System Reset Request" ]
            # [ inline ( always ) ]
            pub fn mdm_ap(&self) -> MdmApR {
                MdmApR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Stop Acknowledge Error" ]
            # [ inline ( always ) ]
            pub fn sackerr(&self) -> SackerrR {
                SackerrR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
    }
    # [ doc = "Reset Pin Control register" ]
    pub struct Rpc {
        register: VolatileCell<u32>,
    }
    # [ doc = "Reset Pin Control register" ]
    pub mod rpc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Rpc {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `RSTFLTSRW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstfltsrwR {
            # [ doc = "All filtering disabled" ]
            _00,
            # [ doc = "Bus clock filter enabled for normal operation" ]
            _01,
            # [ doc = "LPO clock filter enabled for normal operation" ]
            _10,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl RstfltsrwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstfltsrwR::_00 => 0,
                    RstfltsrwR::_01 => 1,
                    RstfltsrwR::_10 => 2,
                    RstfltsrwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstfltsrwR {
                match bits {
                    0 => RstfltsrwR::_00,
                    1 => RstfltsrwR::_01,
                    2 => RstfltsrwR::_10,
                    i => RstfltsrwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == RstfltsrwR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == RstfltsrwR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == RstfltsrwR::_10
            }
        }
        # [ doc = "Possible values of the field `RSTFLTSS`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum RstfltssR {
            # [ doc = "All filtering disabled" ]
            _0,
            # [ doc = "LPO clock filter enabled" ]
            _1,
        }
        impl RstfltssR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    RstfltssR::_0 => 0,
                    RstfltssR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> RstfltssR {
                match bits {
                    0 => RstfltssR::_0,
                    1 => RstfltssR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == RstfltssR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == RstfltssR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct RstfltselR {
            bits: u8,
        }
        impl RstfltselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `RSTFLTSRW`" ]
        pub enum RstfltsrwW {
            # [ doc = "All filtering disabled" ]
            _00,
            # [ doc = "Bus clock filter enabled for normal operation" ]
            _01,
            # [ doc = "LPO clock filter enabled for normal operation" ]
            _10,
        }
        impl RstfltsrwW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstfltsrwW::_00 => 0,
                    RstfltsrwW::_01 => 1,
                    RstfltsrwW::_10 => 2,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstfltsrwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstfltsrwW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstfltsrwW) -> &'a mut W {
                unsafe { self.bits(variant._bits()) }
            }
            # [ doc = "All filtering disabled" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(RstfltsrwW::_00)
            }
            # [ doc = "Bus clock filter enabled for normal operation" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(RstfltsrwW::_01)
            }
            # [ doc = "LPO clock filter enabled for normal operation" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(RstfltsrwW::_10)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `RSTFLTSS`" ]
        pub enum RstfltssW {
            # [ doc = "All filtering disabled" ]
            _0,
            # [ doc = "LPO clock filter enabled" ]
            _1,
        }
        impl RstfltssW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    RstfltssW::_0 => 0,
                    RstfltssW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstfltssW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstfltssW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: RstfltssW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "All filtering disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(RstfltssW::_0)
            }
            # [ doc = "LPO clock filter enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(RstfltssW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _RstfltselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _RstfltselW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 31;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Reset Pin Filter Select in Run and Wait Modes" ]
            # [ inline ( always ) ]
            pub fn rstfltsrw(&self) -> RstfltsrwR {
                RstfltsrwR::_from({
                                      const MASK: u8 = 3;
                                      const OFFSET: u8 = 0;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 2 - Reset Pin Filter Select in Stop Mode" ]
            # [ inline ( always ) ]
            pub fn rstfltss(&self) -> RstfltssR {
                RstfltssR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 2;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bits 8:12 - Reset Pin Filter Bus Clock Select" ]
            # [ inline ( always ) ]
            pub fn rstfltsel(&self) -> RstfltselR {
                let bits = {
                    const MASK: u8 = 31;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                RstfltselR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Reset Pin Filter Select in Run and Wait Modes" ]
            # [ inline ( always ) ]
            pub fn rstfltsrw(&mut self) -> _RstfltsrwW {
                _RstfltsrwW { w: self }
            }
            # [ doc = "Bit 2 - Reset Pin Filter Select in Stop Mode" ]
            # [ inline ( always ) ]
            pub fn rstfltss(&mut self) -> _RstfltssW {
                _RstfltssW { w: self }
            }
            # [ doc = "Bits 8:12 - Reset Pin Filter Bus Clock Select" ]
            # [ inline ( always ) ]
            pub fn rstfltsel(&mut self) -> _RstfltselW {
                _RstfltselW { w: self }
            }
        }
    }
    # [ doc = "Sticky System Reset Status Register" ]
    pub struct Ssrs {
        register: VolatileCell<u32>,
    }
    # [ doc = "Sticky System Reset Status Register" ]
    pub mod ssrs {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ssrs {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `SLVD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SlvdR {
            # [ doc = "Reset not caused by LVD trip or POR" ]
            _0,
            # [ doc = "Reset caused by LVD trip or POR" ]
            _1,
        }
        impl SlvdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SlvdR::_0 => 0,
                    SlvdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SlvdR {
                match bits {
                    0 => SlvdR::_0,
                    1 => SlvdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SlvdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SlvdR::_1
            }
        }
        # [ doc = "Possible values of the field `SLOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SlocR {
            # [ doc = "Reset not caused by a loss of external clock." ]
            _0,
            # [ doc = "Reset caused by a loss of external clock." ]
            _1,
        }
        impl SlocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SlocR::_0 => 0,
                    SlocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SlocR {
                match bits {
                    0 => SlocR::_0,
                    1 => SlocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SlocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SlocR::_1
            }
        }
        # [ doc = "Possible values of the field `SLOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SlolR {
            # [ doc = "Reset not caused by a loss of lock in the PLL/FLL" ]
            _0,
            # [ doc = "Reset caused by a loss of lock in the PLL/FLL" ]
            _1,
        }
        impl SlolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SlolR::_0 => 0,
                    SlolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SlolR {
                match bits {
                    0 => SlolR::_0,
                    1 => SlolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SlolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SlolR::_1
            }
        }
        # [ doc = "Possible values of the field `SWDOG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwdogR {
            # [ doc = "Reset not caused by watchdog timeout" ]
            _0,
            # [ doc = "Reset caused by watchdog timeout" ]
            _1,
        }
        impl SwdogR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwdogR::_0 => 0,
                    SwdogR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwdogR {
                match bits {
                    0 => SwdogR::_0,
                    1 => SwdogR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwdogR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwdogR::_1
            }
        }
        # [ doc = "Possible values of the field `SPIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SpinR {
            # [ doc = "Reset not caused by external reset pin" ]
            _0,
            # [ doc = "Reset caused by external reset pin" ]
            _1,
        }
        impl SpinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SpinR::_0 => 0,
                    SpinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SpinR {
                match bits {
                    0 => SpinR::_0,
                    1 => SpinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SpinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SpinR::_1
            }
        }
        # [ doc = "Possible values of the field `SPOR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SporR {
            # [ doc = "Reset not caused by POR" ]
            _0,
            # [ doc = "Reset caused by POR" ]
            _1,
        }
        impl SporR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SporR::_0 => 0,
                    SporR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SporR {
                match bits {
                    0 => SporR::_0,
                    1 => SporR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SporR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SporR::_1
            }
        }
        # [ doc = "Possible values of the field `SJTAG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SjtagR {
            # [ doc = "Reset not caused by JTAG" ]
            _0,
            # [ doc = "Reset caused by JTAG" ]
            _1,
        }
        impl SjtagR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SjtagR::_0 => 0,
                    SjtagR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SjtagR {
                match bits {
                    0 => SjtagR::_0,
                    1 => SjtagR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SjtagR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SjtagR::_1
            }
        }
        # [ doc = "Possible values of the field `SLOCKUP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SlockupR {
            # [ doc = "Reset not caused by core LOCKUP event" ]
            _0,
            # [ doc = "Reset caused by core LOCKUP event" ]
            _1,
        }
        impl SlockupR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SlockupR::_0 => 0,
                    SlockupR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SlockupR {
                match bits {
                    0 => SlockupR::_0,
                    1 => SlockupR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SlockupR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SlockupR::_1
            }
        }
        # [ doc = "Possible values of the field `SSW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SswR {
            # [ doc = "Reset not caused by software setting of SYSRESETREQ bit" ]
            _0,
            # [ doc = "Reset caused by software setting of SYSRESETREQ bit" ]
            _1,
        }
        impl SswR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SswR::_0 => 0,
                    SswR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SswR {
                match bits {
                    0 => SswR::_0,
                    1 => SswR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SswR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SswR::_1
            }
        }
        # [ doc = "Possible values of the field `SMDM_AP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SmdmApR {
            # [ doc = "Reset was not caused by host debugger system setting of the System Reset Request bit" ]
            _0,
            # [ doc = "Reset was caused by host debugger system setting of the System Reset Request bit" ]
            _1,
        }
        impl SmdmApR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SmdmApR::_0 => 0,
                    SmdmApR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SmdmApR {
                match bits {
                    0 => SmdmApR::_0,
                    1 => SmdmApR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SmdmApR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SmdmApR::_1
            }
        }
        # [ doc = "Possible values of the field `SSACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SsackerrR {
            # [ doc = "Reset not caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            _0,
            # [ doc = "Reset caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            _1,
        }
        impl SsackerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SsackerrR::_0 => 0,
                    SsackerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SsackerrR {
                match bits {
                    0 => SsackerrR::_0,
                    1 => SsackerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SsackerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SsackerrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `SLVD`" ]
        pub enum SlvdW {
            # [ doc = "Reset not caused by LVD trip or POR" ]
            _0,
            # [ doc = "Reset caused by LVD trip or POR" ]
            _1,
        }
        impl SlvdW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SlvdW::_0 => 0,
                    SlvdW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlvdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlvdW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SlvdW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by LVD trip or POR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SlvdW::_0)
            }
            # [ doc = "Reset caused by LVD trip or POR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SlvdW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 1;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SLOC`" ]
        pub enum SlocW {
            # [ doc = "Reset not caused by a loss of external clock." ]
            _0,
            # [ doc = "Reset caused by a loss of external clock." ]
            _1,
        }
        impl SlocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SlocW::_0 => 0,
                    SlocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SlocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by a loss of external clock." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SlocW::_0)
            }
            # [ doc = "Reset caused by a loss of external clock." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SlocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SLOL`" ]
        pub enum SlolW {
            # [ doc = "Reset not caused by a loss of lock in the PLL/FLL" ]
            _0,
            # [ doc = "Reset caused by a loss of lock in the PLL/FLL" ]
            _1,
        }
        impl SlolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SlolW::_0 => 0,
                    SlolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SlolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by a loss of lock in the PLL/FLL" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SlolW::_0)
            }
            # [ doc = "Reset caused by a loss of lock in the PLL/FLL" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SlolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SWDOG`" ]
        pub enum SwdogW {
            # [ doc = "Reset not caused by watchdog timeout" ]
            _0,
            # [ doc = "Reset caused by watchdog timeout" ]
            _1,
        }
        impl SwdogW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwdogW::_0 => 0,
                    SwdogW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwdogW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwdogW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwdogW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by watchdog timeout" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwdogW::_0)
            }
            # [ doc = "Reset caused by watchdog timeout" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwdogW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SPIN`" ]
        pub enum SpinW {
            # [ doc = "Reset not caused by external reset pin" ]
            _0,
            # [ doc = "Reset caused by external reset pin" ]
            _1,
        }
        impl SpinW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SpinW::_0 => 0,
                    SpinW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SpinW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SpinW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SpinW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by external reset pin" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SpinW::_0)
            }
            # [ doc = "Reset caused by external reset pin" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SpinW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SPOR`" ]
        pub enum SporW {
            # [ doc = "Reset not caused by POR" ]
            _0,
            # [ doc = "Reset caused by POR" ]
            _1,
        }
        impl SporW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SporW::_0 => 0,
                    SporW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SporW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SporW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SporW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by POR" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SporW::_0)
            }
            # [ doc = "Reset caused by POR" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SporW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SJTAG`" ]
        pub enum SjtagW {
            # [ doc = "Reset not caused by JTAG" ]
            _0,
            # [ doc = "Reset caused by JTAG" ]
            _1,
        }
        impl SjtagW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SjtagW::_0 => 0,
                    SjtagW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SjtagW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SjtagW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SjtagW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by JTAG" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SjtagW::_0)
            }
            # [ doc = "Reset caused by JTAG" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SjtagW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SLOCKUP`" ]
        pub enum SlockupW {
            # [ doc = "Reset not caused by core LOCKUP event" ]
            _0,
            # [ doc = "Reset caused by core LOCKUP event" ]
            _1,
        }
        impl SlockupW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SlockupW::_0 => 0,
                    SlockupW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SlockupW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SlockupW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SlockupW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by core LOCKUP event" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SlockupW::_0)
            }
            # [ doc = "Reset caused by core LOCKUP event" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SlockupW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSW`" ]
        pub enum SswW {
            # [ doc = "Reset not caused by software setting of SYSRESETREQ bit" ]
            _0,
            # [ doc = "Reset caused by software setting of SYSRESETREQ bit" ]
            _1,
        }
        impl SswW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SswW::_0 => 0,
                    SswW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SswW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SswW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SswW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by software setting of SYSRESETREQ bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SswW::_0)
            }
            # [ doc = "Reset caused by software setting of SYSRESETREQ bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SswW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SMDM_AP`" ]
        pub enum SmdmApW {
            # [ doc = "Reset was not caused by host debugger system setting of the System Reset Request bit" ]
            _0,
            # [ doc = "Reset was caused by host debugger system setting of the System Reset Request bit" ]
            _1,
        }
        impl SmdmApW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SmdmApW::_0 => 0,
                    SmdmApW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SmdmApW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SmdmApW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SmdmApW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset was not caused by host debugger system setting of the System Reset Request bit" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SmdmApW::_0)
            }
            # [ doc = "Reset was caused by host debugger system setting of the System Reset Request bit" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SmdmApW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SSACKERR`" ]
        pub enum SsackerrW {
            # [ doc = "Reset not caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            _0,
            # [ doc = "Reset caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            _1,
        }
        impl SsackerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SsackerrW::_0 => 0,
                    SsackerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SsackerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SsackerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SsackerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SsackerrW::_0)
            }
            # [ doc = "Reset caused by peripheral failure to acknowledge attempt to enter stop mode" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SsackerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 1 - Sticky Low-Voltage Detect Reset" ]
            # [ inline ( always ) ]
            pub fn slvd(&self) -> SlvdR {
                SlvdR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 1;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 2 - Sticky Loss-of-Clock Reset" ]
            # [ inline ( always ) ]
            pub fn sloc(&self) -> SlocR {
                SlocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 2;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 3 - Sticky Loss-of-Lock Reset" ]
            # [ inline ( always ) ]
            pub fn slol(&self) -> SlolR {
                SlolR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 3;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 5 - Sticky Watchdog" ]
            # [ inline ( always ) ]
            pub fn swdog(&self) -> SwdogR {
                SwdogR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 5;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 6 - Sticky External Reset Pin" ]
            # [ inline ( always ) ]
            pub fn spin(&self) -> SpinR {
                SpinR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 6;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 7 - Sticky Power-On Reset" ]
            # [ inline ( always ) ]
            pub fn spor(&self) -> SporR {
                SporR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 7;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 8 - Sticky JTAG generated reset" ]
            # [ inline ( always ) ]
            pub fn sjtag(&self) -> SjtagR {
                SjtagR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 9 - Sticky Core Lockup" ]
            # [ inline ( always ) ]
            pub fn slockup(&self) -> SlockupR {
                SlockupR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 9;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 10 - Sticky Software" ]
            # [ inline ( always ) ]
            pub fn ssw(&self) -> SswR {
                SswR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 11 - Sticky MDM-AP System Reset Request" ]
            # [ inline ( always ) ]
            pub fn smdm_ap(&self) -> SmdmApR {
                SmdmApR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 11;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 13 - Sticky Stop Acknowledge Error" ]
            # [ inline ( always ) ]
            pub fn ssackerr(&self) -> SsackerrR {
                SsackerrR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 13;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 130 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 1 - Sticky Low-Voltage Detect Reset" ]
            # [ inline ( always ) ]
            pub fn slvd(&mut self) -> _SlvdW {
                _SlvdW { w: self }
            }
            # [ doc = "Bit 2 - Sticky Loss-of-Clock Reset" ]
            # [ inline ( always ) ]
            pub fn sloc(&mut self) -> _SlocW {
                _SlocW { w: self }
            }
            # [ doc = "Bit 3 - Sticky Loss-of-Lock Reset" ]
            # [ inline ( always ) ]
            pub fn slol(&mut self) -> _SlolW {
                _SlolW { w: self }
            }
            # [ doc = "Bit 5 - Sticky Watchdog" ]
            # [ inline ( always ) ]
            pub fn swdog(&mut self) -> _SwdogW {
                _SwdogW { w: self }
            }
            # [ doc = "Bit 6 - Sticky External Reset Pin" ]
            # [ inline ( always ) ]
            pub fn spin(&mut self) -> _SpinW {
                _SpinW { w: self }
            }
            # [ doc = "Bit 7 - Sticky Power-On Reset" ]
            # [ inline ( always ) ]
            pub fn spor(&mut self) -> _SporW {
                _SporW { w: self }
            }
            # [ doc = "Bit 8 - Sticky JTAG generated reset" ]
            # [ inline ( always ) ]
            pub fn sjtag(&mut self) -> _SjtagW {
                _SjtagW { w: self }
            }
            # [ doc = "Bit 9 - Sticky Core Lockup" ]
            # [ inline ( always ) ]
            pub fn slockup(&mut self) -> _SlockupW {
                _SlockupW { w: self }
            }
            # [ doc = "Bit 10 - Sticky Software" ]
            # [ inline ( always ) ]
            pub fn ssw(&mut self) -> _SswW {
                _SswW { w: self }
            }
            # [ doc = "Bit 11 - Sticky MDM-AP System Reset Request" ]
            # [ inline ( always ) ]
            pub fn smdm_ap(&mut self) -> _SmdmApW {
                _SmdmApW { w: self }
            }
            # [ doc = "Bit 13 - Sticky Stop Acknowledge Error" ]
            # [ inline ( always ) ]
            pub fn ssackerr(&mut self) -> _SsackerrW {
                _SsackerrW { w: self }
            }
        }
    }
    # [ doc = "System Reset Interrupt Enable Register" ]
    pub struct Srie {
        register: VolatileCell<u32>,
    }
    # [ doc = "System Reset Interrupt Enable Register" ]
    pub mod srie {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Srie {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `DELAY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DelayR {
            # [ doc = "10 LPO cycles" ]
            _00,
            # [ doc = "34 LPO cycles" ]
            _01,
            # [ doc = "130 LPO cycles" ]
            _10,
            # [ doc = "514 LPO cycles" ]
            _11,
        }
        impl DelayR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DelayR::_00 => 0,
                    DelayR::_01 => 1,
                    DelayR::_10 => 2,
                    DelayR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DelayR {
                match bits {
                    0 => DelayR::_00,
                    1 => DelayR::_01,
                    2 => DelayR::_10,
                    3 => DelayR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == DelayR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == DelayR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == DelayR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == DelayR::_11
            }
        }
        # [ doc = "Possible values of the field `LOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LocR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl LocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LocR::_0 => 0,
                    LocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LocR {
                match bits {
                    0 => LocR::_0,
                    1 => LocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LocR::_1
            }
        }
        # [ doc = "Possible values of the field `LOL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LolR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl LolR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LolR::_0 => 0,
                    LolR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LolR {
                match bits {
                    0 => LolR::_0,
                    1 => LolR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LolR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LolR::_1
            }
        }
        # [ doc = "Possible values of the field `WDOG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WdogR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WdogR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WdogR::_0 => 0,
                    WdogR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WdogR {
                match bits {
                    0 => WdogR::_0,
                    1 => WdogR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WdogR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WdogR::_1
            }
        }
        # [ doc = "Possible values of the field `PIN`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PinR {
            # [ doc = "Reset not caused by external reset pin" ]
            _0,
            # [ doc = "Reset caused by external reset pin" ]
            _1,
        }
        impl PinR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PinR::_0 => 0,
                    PinR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PinR {
                match bits {
                    0 => PinR::_0,
                    1 => PinR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PinR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PinR::_1
            }
        }
        # [ doc = "Possible values of the field `GIE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GieR {
            # [ doc = "All interrupt sources disabled." ]
            _0,
            # [ doc = "All interrupt sources enabled. Note that the individual interrupt-enable bits still need to be set to generate interrupts." ]
            _1,
        }
        impl GieR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GieR::_0 => 0,
                    GieR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GieR {
                match bits {
                    0 => GieR::_0,
                    1 => GieR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GieR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GieR::_1
            }
        }
        # [ doc = "Possible values of the field `JTAG`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum JtagR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl JtagR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    JtagR::_0 => 0,
                    JtagR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> JtagR {
                match bits {
                    0 => JtagR::_0,
                    1 => JtagR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == JtagR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == JtagR::_1
            }
        }
        # [ doc = "Possible values of the field `LOCKUP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LockupR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl LockupR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LockupR::_0 => 0,
                    LockupR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LockupR {
                match bits {
                    0 => LockupR::_0,
                    1 => LockupR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LockupR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LockupR::_1
            }
        }
        # [ doc = "Possible values of the field `SW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SwR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SwR::_0 => 0,
                    SwR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SwR {
                match bits {
                    0 => SwR::_0,
                    1 => SwR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SwR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SwR::_1
            }
        }
        # [ doc = "Possible values of the field `MDM_AP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MdmApR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl MdmApR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MdmApR::_0 => 0,
                    MdmApR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MdmApR {
                match bits {
                    0 => MdmApR::_0,
                    1 => MdmApR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == MdmApR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == MdmApR::_1
            }
        }
        # [ doc = "Possible values of the field `SACKERR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SackerrR {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SackerrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SackerrR::_0 => 0,
                    SackerrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SackerrR {
                match bits {
                    0 => SackerrR::_0,
                    1 => SackerrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == SackerrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == SackerrR::_1
            }
        }
        # [ doc = "Values that can be written to the field `DELAY`" ]
        pub enum DelayW {
            # [ doc = "10 LPO cycles" ]
            _00,
            # [ doc = "34 LPO cycles" ]
            _01,
            # [ doc = "130 LPO cycles" ]
            _10,
            # [ doc = "514 LPO cycles" ]
            _11,
        }
        impl DelayW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    DelayW::_00 => 0,
                    DelayW::_01 => 1,
                    DelayW::_10 => 2,
                    DelayW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DelayW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DelayW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: DelayW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "10 LPO cycles" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(DelayW::_00)
            }
            # [ doc = "34 LPO cycles" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(DelayW::_01)
            }
            # [ doc = "130 LPO cycles" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(DelayW::_10)
            }
            # [ doc = "514 LPO cycles" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(DelayW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOC`" ]
        pub enum LocW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl LocW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LocW::_0 => 0,
                    LocW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LocW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LocW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LocW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LocW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LocW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOL`" ]
        pub enum LolW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl LolW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LolW::_0 => 0,
                    LolW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LolW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LolW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LolW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LolW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LolW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WDOG`" ]
        pub enum WdogW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl WdogW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WdogW::_0 => 0,
                    WdogW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WdogW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WdogW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WdogW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WdogW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WdogW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 5;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PIN`" ]
        pub enum PinW {
            # [ doc = "Reset not caused by external reset pin" ]
            _0,
            # [ doc = "Reset caused by external reset pin" ]
            _1,
        }
        impl PinW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    PinW::_0 => 0,
                    PinW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PinW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PinW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: PinW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reset not caused by external reset pin" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(PinW::_0)
            }
            # [ doc = "Reset caused by external reset pin" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(PinW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GIE`" ]
        pub enum GieW {
            # [ doc = "All interrupt sources disabled." ]
            _0,
            # [ doc = "All interrupt sources enabled. Note that the individual interrupt-enable bits still need to be set to generate interrupts." ]
            _1,
        }
        impl GieW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GieW::_0 => 0,
                    GieW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GieW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GieW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GieW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "All interrupt sources disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GieW::_0)
            }
            # [ doc = "All interrupt sources enabled. Note that the individual interrupt-enable bits still need to be set to generate interrupts." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GieW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 7;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `JTAG`" ]
        pub enum JtagW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl JtagW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    JtagW::_0 => 0,
                    JtagW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _JtagW<'a> {
            w: &'a mut W,
        }
        impl<'a> _JtagW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: JtagW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(JtagW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(JtagW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOCKUP`" ]
        pub enum LockupW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl LockupW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LockupW::_0 => 0,
                    LockupW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LockupW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LockupW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LockupW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LockupW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LockupW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SW`" ]
        pub enum SwW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SwW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SwW::_0 => 0,
                    SwW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SwW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SwW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SwW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SwW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SwW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `MDM_AP`" ]
        pub enum MdmApW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl MdmApW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    MdmApW::_0 => 0,
                    MdmApW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _MdmApW<'a> {
            w: &'a mut W,
        }
        impl<'a> _MdmApW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: MdmApW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(MdmApW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(MdmApW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 11;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SACKERR`" ]
        pub enum SackerrW {
            # [ doc = "Interrupt disabled." ]
            _0,
            # [ doc = "Interrupt enabled." ]
            _1,
        }
        impl SackerrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SackerrW::_0 => 0,
                    SackerrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SackerrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SackerrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SackerrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Interrupt disabled." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(SackerrW::_0)
            }
            # [ doc = "Interrupt enabled." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(SackerrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 13;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Reset Delay Time" ]
            # [ inline ( always ) ]
            pub fn delay(&self) -> DelayR {
                DelayR::_from({
                                  const MASK: u8 = 3;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 2 - Loss-of-Clock Interrupt" ]
            # [ inline ( always ) ]
            pub fn loc(&self) -> LocR {
                LocR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 3 - Loss-of-Lock Interrupt" ]
            # [ inline ( always ) ]
            pub fn lol(&self) -> LolR {
                LolR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 3;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 5 - Watchdog Interrupt" ]
            # [ inline ( always ) ]
            pub fn wdog(&self) -> WdogR {
                WdogR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 5;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 6 - External Reset Pin Interrupt" ]
            # [ inline ( always ) ]
            pub fn pin(&self) -> PinR {
                PinR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 7 - Global Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn gie(&self) -> GieR {
                GieR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 7;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bit 8 - JTAG generated reset" ]
            # [ inline ( always ) ]
            pub fn jtag(&self) -> JtagR {
                JtagR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - Core Lockup Interrupt" ]
            # [ inline ( always ) ]
            pub fn lockup(&self) -> LockupR {
                LockupR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 9;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 10 - Software Interrupt" ]
            # [ inline ( always ) ]
            pub fn sw(&self) -> SwR {
                SwR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 10;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 11 - MDM-AP System Reset Request" ]
            # [ inline ( always ) ]
            pub fn mdm_ap(&self) -> MdmApR {
                MdmApR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 11;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 13 - Stop Acknowledge Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn sackerr(&self) -> SackerrR {
                SackerrR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 13;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Reset Delay Time" ]
            # [ inline ( always ) ]
            pub fn delay(&mut self) -> _DelayW {
                _DelayW { w: self }
            }
            # [ doc = "Bit 2 - Loss-of-Clock Interrupt" ]
            # [ inline ( always ) ]
            pub fn loc(&mut self) -> _LocW {
                _LocW { w: self }
            }
            # [ doc = "Bit 3 - Loss-of-Lock Interrupt" ]
            # [ inline ( always ) ]
            pub fn lol(&mut self) -> _LolW {
                _LolW { w: self }
            }
            # [ doc = "Bit 5 - Watchdog Interrupt" ]
            # [ inline ( always ) ]
            pub fn wdog(&mut self) -> _WdogW {
                _WdogW { w: self }
            }
            # [ doc = "Bit 6 - External Reset Pin Interrupt" ]
            # [ inline ( always ) ]
            pub fn pin(&mut self) -> _PinW {
                _PinW { w: self }
            }
            # [ doc = "Bit 7 - Global Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn gie(&mut self) -> _GieW {
                _GieW { w: self }
            }
            # [ doc = "Bit 8 - JTAG generated reset" ]
            # [ inline ( always ) ]
            pub fn jtag(&mut self) -> _JtagW {
                _JtagW { w: self }
            }
            # [ doc = "Bit 9 - Core Lockup Interrupt" ]
            # [ inline ( always ) ]
            pub fn lockup(&mut self) -> _LockupW {
                _LockupW { w: self }
            }
            # [ doc = "Bit 10 - Software Interrupt" ]
            # [ inline ( always ) ]
            pub fn sw(&mut self) -> _SwW {
                _SwW { w: self }
            }
            # [ doc = "Bit 11 - MDM-AP System Reset Request" ]
            # [ inline ( always ) ]
            pub fn mdm_ap(&mut self) -> _MdmApW {
                _MdmApW { w: self }
            }
            # [ doc = "Bit 13 - Stop Acknowledge Error Interrupt" ]
            # [ inline ( always ) ]
            pub fn sackerr(&mut self) -> _SackerrW {
                _SackerrW { w: self }
            }
        }
    }
}
# [ doc = "Reset Control Module" ]
pub struct Rcm {
    register_block: rcm::RegisterBlock,
}
impl Deref for Rcm {
    type Target = rcm::RegisterBlock;
    fn deref(&self) -> &rcm::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "General Purpose Input/Output" ]
pub const PTA: Peripheral<Pta> = unsafe { Peripheral::new(1074786304) };
# [ doc = "General Purpose Input/Output" ]
pub mod pta {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Port Data Output Register" ]
        pub pdor: Pdor,
        # [ doc = "0x04 - Port Set Output Register" ]
        pub psor: Psor,
        # [ doc = "0x08 - Port Clear Output Register" ]
        pub pcor: Pcor,
        # [ doc = "0x0c - Port Toggle Output Register" ]
        pub ptor: Ptor,
        # [ doc = "0x10 - Port Data Input Register" ]
        pub pdir: Pdir,
        # [ doc = "0x14 - Port Data Direction Register" ]
        pub pddr: Pddr,
        # [ doc = "0x18 - Port Input Disable Register" ]
        pub pidr: Pidr,
    }
    # [ doc = "Port Data Output Register" ]
    pub struct Pdor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Output Register" ]
    pub mod pdor {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pdor {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdoR {
            bits: u32,
        }
        impl PdoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&self) -> PdoR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&mut self) -> _PdoW {
                _PdoW { w: self }
            }
        }
    }
    # [ doc = "Port Set Output Register" ]
    pub struct Psor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Set Output Register" ]
    pub mod psor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Psor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtsoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtsoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Set Output" ]
            # [ inline ( always ) ]
            pub fn ptso(&mut self) -> _PtsoW {
                _PtsoW { w: self }
            }
        }
    }
    # [ doc = "Port Clear Output Register" ]
    pub struct Pcor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Clear Output Register" ]
    pub mod pcor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtcoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Clear Output" ]
            # [ inline ( always ) ]
            pub fn ptco(&mut self) -> _PtcoW {
                _PtcoW { w: self }
            }
        }
    }
    # [ doc = "Port Toggle Output Register" ]
    pub struct Ptor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Toggle Output Register" ]
    pub mod ptor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ptor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PttoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PttoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Toggle Output" ]
            # [ inline ( always ) ]
            pub fn ptto(&mut self) -> _PttoW {
                _PttoW { w: self }
            }
        }
    }
    # [ doc = "Port Data Input Register" ]
    pub struct Pdir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Input Register" ]
    pub mod pdir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pdir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdiR {
            bits: u32,
        }
        impl PdiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Input" ]
            # [ inline ( always ) ]
            pub fn pdi(&self) -> PdiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdiR { bits }
            }
        }
    }
    # [ doc = "Port Data Direction Register" ]
    pub struct Pddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Direction Register" ]
    pub mod pddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PddR {
            bits: u32,
        }
        impl PddR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PddW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PddW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&self) -> PddR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PddR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&mut self) -> _PddW {
                _PddW { w: self }
            }
        }
    }
    # [ doc = "Port Input Disable Register" ]
    pub struct Pidr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Input Disable Register" ]
    pub mod pidr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pidr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PidR {
            bits: u32,
        }
        impl PidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PidW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&self) -> PidR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PidR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&mut self) -> _PidW {
                _PidW { w: self }
            }
        }
    }
}
# [ doc = "General Purpose Input/Output" ]
pub struct Pta {
    register_block: pta::RegisterBlock,
}
impl Deref for Pta {
    type Target = pta::RegisterBlock;
    fn deref(&self) -> &pta::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "General Purpose Input/Output" ]
pub const PTB: Peripheral<Ptb> = unsafe { Peripheral::new(1074786368) };
# [ doc = "General Purpose Input/Output" ]
pub mod ptb {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Port Data Output Register" ]
        pub pdor: Pdor,
        # [ doc = "0x04 - Port Set Output Register" ]
        pub psor: Psor,
        # [ doc = "0x08 - Port Clear Output Register" ]
        pub pcor: Pcor,
        # [ doc = "0x0c - Port Toggle Output Register" ]
        pub ptor: Ptor,
        # [ doc = "0x10 - Port Data Input Register" ]
        pub pdir: Pdir,
        # [ doc = "0x14 - Port Data Direction Register" ]
        pub pddr: Pddr,
        # [ doc = "0x18 - Port Input Disable Register" ]
        pub pidr: Pidr,
    }
    # [ doc = "Port Data Output Register" ]
    pub struct Pdor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Output Register" ]
    pub mod pdor {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pdor {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdoR {
            bits: u32,
        }
        impl PdoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&self) -> PdoR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&mut self) -> _PdoW {
                _PdoW { w: self }
            }
        }
    }
    # [ doc = "Port Set Output Register" ]
    pub struct Psor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Set Output Register" ]
    pub mod psor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Psor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtsoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtsoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Set Output" ]
            # [ inline ( always ) ]
            pub fn ptso(&mut self) -> _PtsoW {
                _PtsoW { w: self }
            }
        }
    }
    # [ doc = "Port Clear Output Register" ]
    pub struct Pcor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Clear Output Register" ]
    pub mod pcor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtcoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Clear Output" ]
            # [ inline ( always ) ]
            pub fn ptco(&mut self) -> _PtcoW {
                _PtcoW { w: self }
            }
        }
    }
    # [ doc = "Port Toggle Output Register" ]
    pub struct Ptor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Toggle Output Register" ]
    pub mod ptor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ptor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PttoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PttoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Toggle Output" ]
            # [ inline ( always ) ]
            pub fn ptto(&mut self) -> _PttoW {
                _PttoW { w: self }
            }
        }
    }
    # [ doc = "Port Data Input Register" ]
    pub struct Pdir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Input Register" ]
    pub mod pdir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pdir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdiR {
            bits: u32,
        }
        impl PdiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Input" ]
            # [ inline ( always ) ]
            pub fn pdi(&self) -> PdiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdiR { bits }
            }
        }
    }
    # [ doc = "Port Data Direction Register" ]
    pub struct Pddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Direction Register" ]
    pub mod pddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PddR {
            bits: u32,
        }
        impl PddR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PddW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PddW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&self) -> PddR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PddR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&mut self) -> _PddW {
                _PddW { w: self }
            }
        }
    }
    # [ doc = "Port Input Disable Register" ]
    pub struct Pidr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Input Disable Register" ]
    pub mod pidr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pidr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PidR {
            bits: u32,
        }
        impl PidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PidW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&self) -> PidR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PidR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&mut self) -> _PidW {
                _PidW { w: self }
            }
        }
    }
}
# [ doc = "General Purpose Input/Output" ]
pub struct Ptb {
    register_block: ptb::RegisterBlock,
}
impl Deref for Ptb {
    type Target = ptb::RegisterBlock;
    fn deref(&self) -> &ptb::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "General Purpose Input/Output" ]
pub const PTC: Peripheral<Ptc> = unsafe { Peripheral::new(1074786432) };
# [ doc = "General Purpose Input/Output" ]
pub mod ptc {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Port Data Output Register" ]
        pub pdor: Pdor,
        # [ doc = "0x04 - Port Set Output Register" ]
        pub psor: Psor,
        # [ doc = "0x08 - Port Clear Output Register" ]
        pub pcor: Pcor,
        # [ doc = "0x0c - Port Toggle Output Register" ]
        pub ptor: Ptor,
        # [ doc = "0x10 - Port Data Input Register" ]
        pub pdir: Pdir,
        # [ doc = "0x14 - Port Data Direction Register" ]
        pub pddr: Pddr,
        # [ doc = "0x18 - Port Input Disable Register" ]
        pub pidr: Pidr,
    }
    # [ doc = "Port Data Output Register" ]
    pub struct Pdor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Output Register" ]
    pub mod pdor {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pdor {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdoR {
            bits: u32,
        }
        impl PdoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&self) -> PdoR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&mut self) -> _PdoW {
                _PdoW { w: self }
            }
        }
    }
    # [ doc = "Port Set Output Register" ]
    pub struct Psor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Set Output Register" ]
    pub mod psor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Psor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtsoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtsoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Set Output" ]
            # [ inline ( always ) ]
            pub fn ptso(&mut self) -> _PtsoW {
                _PtsoW { w: self }
            }
        }
    }
    # [ doc = "Port Clear Output Register" ]
    pub struct Pcor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Clear Output Register" ]
    pub mod pcor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtcoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Clear Output" ]
            # [ inline ( always ) ]
            pub fn ptco(&mut self) -> _PtcoW {
                _PtcoW { w: self }
            }
        }
    }
    # [ doc = "Port Toggle Output Register" ]
    pub struct Ptor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Toggle Output Register" ]
    pub mod ptor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ptor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PttoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PttoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Toggle Output" ]
            # [ inline ( always ) ]
            pub fn ptto(&mut self) -> _PttoW {
                _PttoW { w: self }
            }
        }
    }
    # [ doc = "Port Data Input Register" ]
    pub struct Pdir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Input Register" ]
    pub mod pdir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pdir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdiR {
            bits: u32,
        }
        impl PdiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Input" ]
            # [ inline ( always ) ]
            pub fn pdi(&self) -> PdiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdiR { bits }
            }
        }
    }
    # [ doc = "Port Data Direction Register" ]
    pub struct Pddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Direction Register" ]
    pub mod pddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PddR {
            bits: u32,
        }
        impl PddR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PddW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PddW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&self) -> PddR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PddR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&mut self) -> _PddW {
                _PddW { w: self }
            }
        }
    }
    # [ doc = "Port Input Disable Register" ]
    pub struct Pidr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Input Disable Register" ]
    pub mod pidr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pidr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PidR {
            bits: u32,
        }
        impl PidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PidW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&self) -> PidR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PidR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&mut self) -> _PidW {
                _PidW { w: self }
            }
        }
    }
}
# [ doc = "General Purpose Input/Output" ]
pub struct Ptc {
    register_block: ptc::RegisterBlock,
}
impl Deref for Ptc {
    type Target = ptc::RegisterBlock;
    fn deref(&self) -> &ptc::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "General Purpose Input/Output" ]
pub const PTD: Peripheral<Ptd> = unsafe { Peripheral::new(1074786496) };
# [ doc = "General Purpose Input/Output" ]
pub mod ptd {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Port Data Output Register" ]
        pub pdor: Pdor,
        # [ doc = "0x04 - Port Set Output Register" ]
        pub psor: Psor,
        # [ doc = "0x08 - Port Clear Output Register" ]
        pub pcor: Pcor,
        # [ doc = "0x0c - Port Toggle Output Register" ]
        pub ptor: Ptor,
        # [ doc = "0x10 - Port Data Input Register" ]
        pub pdir: Pdir,
        # [ doc = "0x14 - Port Data Direction Register" ]
        pub pddr: Pddr,
        # [ doc = "0x18 - Port Input Disable Register" ]
        pub pidr: Pidr,
    }
    # [ doc = "Port Data Output Register" ]
    pub struct Pdor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Output Register" ]
    pub mod pdor {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pdor {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdoR {
            bits: u32,
        }
        impl PdoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&self) -> PdoR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&mut self) -> _PdoW {
                _PdoW { w: self }
            }
        }
    }
    # [ doc = "Port Set Output Register" ]
    pub struct Psor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Set Output Register" ]
    pub mod psor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Psor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtsoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtsoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Set Output" ]
            # [ inline ( always ) ]
            pub fn ptso(&mut self) -> _PtsoW {
                _PtsoW { w: self }
            }
        }
    }
    # [ doc = "Port Clear Output Register" ]
    pub struct Pcor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Clear Output Register" ]
    pub mod pcor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtcoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Clear Output" ]
            # [ inline ( always ) ]
            pub fn ptco(&mut self) -> _PtcoW {
                _PtcoW { w: self }
            }
        }
    }
    # [ doc = "Port Toggle Output Register" ]
    pub struct Ptor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Toggle Output Register" ]
    pub mod ptor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ptor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PttoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PttoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Toggle Output" ]
            # [ inline ( always ) ]
            pub fn ptto(&mut self) -> _PttoW {
                _PttoW { w: self }
            }
        }
    }
    # [ doc = "Port Data Input Register" ]
    pub struct Pdir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Input Register" ]
    pub mod pdir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pdir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdiR {
            bits: u32,
        }
        impl PdiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Input" ]
            # [ inline ( always ) ]
            pub fn pdi(&self) -> PdiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdiR { bits }
            }
        }
    }
    # [ doc = "Port Data Direction Register" ]
    pub struct Pddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Direction Register" ]
    pub mod pddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PddR {
            bits: u32,
        }
        impl PddR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PddW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PddW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&self) -> PddR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PddR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&mut self) -> _PddW {
                _PddW { w: self }
            }
        }
    }
    # [ doc = "Port Input Disable Register" ]
    pub struct Pidr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Input Disable Register" ]
    pub mod pidr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pidr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PidR {
            bits: u32,
        }
        impl PidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PidW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&self) -> PidR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PidR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&mut self) -> _PidW {
                _PidW { w: self }
            }
        }
    }
}
# [ doc = "General Purpose Input/Output" ]
pub struct Ptd {
    register_block: ptd::RegisterBlock,
}
impl Deref for Ptd {
    type Target = ptd::RegisterBlock;
    fn deref(&self) -> &ptd::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "General Purpose Input/Output" ]
pub const PTE: Peripheral<Pte> = unsafe { Peripheral::new(1074786560) };
# [ doc = "General Purpose Input/Output" ]
pub mod pte {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Port Data Output Register" ]
        pub pdor: Pdor,
        # [ doc = "0x04 - Port Set Output Register" ]
        pub psor: Psor,
        # [ doc = "0x08 - Port Clear Output Register" ]
        pub pcor: Pcor,
        # [ doc = "0x0c - Port Toggle Output Register" ]
        pub ptor: Ptor,
        # [ doc = "0x10 - Port Data Input Register" ]
        pub pdir: Pdir,
        # [ doc = "0x14 - Port Data Direction Register" ]
        pub pddr: Pddr,
        # [ doc = "0x18 - Port Input Disable Register" ]
        pub pidr: Pidr,
    }
    # [ doc = "Port Data Output Register" ]
    pub struct Pdor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Output Register" ]
    pub mod pdor {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pdor {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdoR {
            bits: u32,
        }
        impl PdoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PdoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PdoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&self) -> PdoR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdoR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Output" ]
            # [ inline ( always ) ]
            pub fn pdo(&mut self) -> _PdoW {
                _PdoW { w: self }
            }
        }
    }
    # [ doc = "Port Set Output Register" ]
    pub struct Psor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Set Output Register" ]
    pub mod psor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Psor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtsoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtsoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Set Output" ]
            # [ inline ( always ) ]
            pub fn ptso(&mut self) -> _PtsoW {
                _PtsoW { w: self }
            }
        }
    }
    # [ doc = "Port Clear Output Register" ]
    pub struct Pcor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Clear Output Register" ]
    pub mod pcor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pcor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PtcoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PtcoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Clear Output" ]
            # [ inline ( always ) ]
            pub fn ptco(&mut self) -> _PtcoW {
                _PtcoW { w: self }
            }
        }
    }
    # [ doc = "Port Toggle Output Register" ]
    pub struct Ptor {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Toggle Output Register" ]
    pub mod ptor {
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Ptor {
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PttoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PttoW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Toggle Output" ]
            # [ inline ( always ) ]
            pub fn ptto(&mut self) -> _PttoW {
                _PttoW { w: self }
            }
        }
    }
    # [ doc = "Port Data Input Register" ]
    pub struct Pdir {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Input Register" ]
    pub mod pdir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Pdir {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PdiR {
            bits: u32,
        }
        impl PdiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Input" ]
            # [ inline ( always ) ]
            pub fn pdi(&self) -> PdiR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PdiR { bits }
            }
        }
    }
    # [ doc = "Port Data Direction Register" ]
    pub struct Pddr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Data Direction Register" ]
    pub mod pddr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pddr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PddR {
            bits: u32,
        }
        impl PddR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PddW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PddW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&self) -> PddR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PddR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Data Direction" ]
            # [ inline ( always ) ]
            pub fn pdd(&mut self) -> _PddW {
                _PddW { w: self }
            }
        }
    }
    # [ doc = "Port Input Disable Register" ]
    pub struct Pidr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Port Input Disable Register" ]
    pub mod pidr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pidr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PidR {
            bits: u32,
        }
        impl PidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PidW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&self) -> PidR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PidR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Port Input Disable" ]
            # [ inline ( always ) ]
            pub fn pid(&mut self) -> _PidW {
                _PidW { w: self }
            }
        }
    }
}
# [ doc = "General Purpose Input/Output" ]
pub struct Pte {
    register_block: pte::RegisterBlock,
}
impl Deref for Pte {
    type Target = pte::RegisterBlock;
    fn deref(&self) -> &pte::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Core Platform Miscellaneous Control Module" ]
pub const MCM: Peripheral<Mcm> = unsafe { Peripheral::new(3758620672) };
# [ doc = "Core Platform Miscellaneous Control Module" ]
pub mod mcm {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        _reserved0: [u8; 8usize],
        # [ doc = "0x08 - Crossbar Switch (AXBS) Slave Configuration" ]
        pub plasc: Plasc,
        # [ doc = "0x0a - Crossbar Switch (AXBS) Master Configuration" ]
        pub plamc: Plamc,
        # [ doc = "0x0c - Core Platform Control Register" ]
        pub cpcr: Cpcr,
        # [ doc = "0x10 - Interrupt Status and Control Register" ]
        pub iscr: Iscr,
        _reserved1: [u8; 28usize],
        # [ doc = "0x30 - Process ID Register" ]
        pub pid: Pid,
        _reserved2: [u8; 12usize],
        # [ doc = "0x40 - Compute Operation Control Register" ]
        pub cpo: Cpo,
        _reserved3: [u8; 956usize],
        # [ doc = "0x400 - Local Memory Descriptor Register" ]
        pub lmdr0: Lmdr0,
        # [ doc = "0x404 - Local Memory Descriptor Register" ]
        pub lmdr1: Lmdr1,
        # [ doc = "0x408 - Local Memory Descriptor Register2" ]
        pub lmdr2: Lmdr2,
        _reserved4: [u8; 116usize],
        # [ doc = "0x480 - LMEM Parity and ECC Control Register" ]
        pub lmpecr: Lmpecr,
        _reserved5: [u8; 4usize],
        # [ doc = "0x488 - LMEM Parity and ECC Interrupt Register" ]
        pub lmpeir: Lmpeir,
        _reserved6: [u8; 4usize],
        # [ doc = "0x490 - LMEM Fault Address Register" ]
        pub lmfar: Lmfar,
        # [ doc = "0x494 - LMEM Fault Attribute Register" ]
        pub lmfatr: Lmfatr,
        _reserved7: [u8; 8usize],
        # [ doc = "0x4a0 - LMEM Fault Data High Register" ]
        pub lmfdhr: Lmfdhr,
        # [ doc = "0x4a4 - LMEM Fault Data Low Register" ]
        pub lmfdlr: Lmfdlr,
    }
    # [ doc = "Crossbar Switch (AXBS) Slave Configuration" ]
    pub struct Plasc {
        register: VolatileCell<u16>,
    }
    # [ doc = "Crossbar Switch (AXBS) Slave Configuration" ]
    pub mod plasc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        impl super::Plasc {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `ASC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AscR {
            # [ doc = "A bus slave connection to AXBS input port n is absent" ]
            _0,
            # [ doc = "A bus slave connection to AXBS input port n is present" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl AscR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AscR::_0 => 0,
                    AscR::_1 => 1,
                    AscR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AscR {
                match bits {
                    0 => AscR::_0,
                    1 => AscR::_1,
                    i => AscR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AscR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AscR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Each bit in the ASC field indicates whether there is a corresponding connection to the crossbar switch's slave input port." ]
            # [ inline ( always ) ]
            pub fn asc(&self) -> AscR {
                AscR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
    }
    # [ doc = "Crossbar Switch (AXBS) Master Configuration" ]
    pub struct Plamc {
        register: VolatileCell<u16>,
    }
    # [ doc = "Crossbar Switch (AXBS) Master Configuration" ]
    pub mod plamc {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u16,
        }
        impl super::Plamc {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = "Possible values of the field `AMC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AmcR {
            # [ doc = "A bus master connection to AXBS input port n is absent" ]
            _0,
            # [ doc = "A bus master connection to AXBS input port n is present" ]
            _1,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl AmcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AmcR::_0 => 0,
                    AmcR::_1 => 1,
                    AmcR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AmcR {
                match bits {
                    0 => AmcR::_0,
                    1 => AmcR::_1,
                    i => AmcR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AmcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AmcR::_1
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
            # [ doc = "Bits 0:7 - Each bit in the AMC field indicates whether there is a corresponding connection to the AXBS master input port." ]
            # [ inline ( always ) ]
            pub fn amc(&self) -> AmcR {
                AmcR::_from({
                                const MASK: u8 = 255;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u16) as u8
                            })
            }
        }
    }
    # [ doc = "Core Platform Control Register" ]
    pub struct Cpcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Core Platform Control Register" ]
    pub mod cpcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cpcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `HLT_FSM_ST`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum HltFsmStR {
            # [ doc = "Waiting for request" ]
            _00,
            # [ doc = "Waiting for platform idle" ]
            _01,
            # [ doc = "Platform stalled" ]
            _11,
            # [ doc = "Unused state" ]
            _10,
        }
        impl HltFsmStR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    HltFsmStR::_00 => 0,
                    HltFsmStR::_01 => 1,
                    HltFsmStR::_11 => 3,
                    HltFsmStR::_10 => 2,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> HltFsmStR {
                match bits {
                    0 => HltFsmStR::_00,
                    1 => HltFsmStR::_01,
                    3 => HltFsmStR::_11,
                    2 => HltFsmStR::_10,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == HltFsmStR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == HltFsmStR::_01
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == HltFsmStR::_11
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == HltFsmStR::_10
            }
        }
        # [ doc = "Possible values of the field `AXBS_HLT_REQ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AxbsHltReqR {
            # [ doc = "AXBS is not receiving halt request" ]
            _0,
            # [ doc = "AXBS is receiving halt request" ]
            _1,
        }
        impl AxbsHltReqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AxbsHltReqR::_0 => 0,
                    AxbsHltReqR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AxbsHltReqR {
                match bits {
                    0 => AxbsHltReqR::_0,
                    1 => AxbsHltReqR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AxbsHltReqR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AxbsHltReqR::_1
            }
        }
        # [ doc = "Possible values of the field `AXBS_HLTD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum AxbsHltdR {
            # [ doc = "AXBS is not currently halted" ]
            _0,
            # [ doc = "AXBS is currently halted" ]
            _1,
        }
        impl AxbsHltdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    AxbsHltdR::_0 => 0,
                    AxbsHltdR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> AxbsHltdR {
                match bits {
                    0 => AxbsHltdR::_0,
                    1 => AxbsHltdR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == AxbsHltdR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == AxbsHltdR::_1
            }
        }
        # [ doc = "Possible values of the field `FMC_PF_IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FmcPfIdleR {
            # [ doc = "FMC program flash is not idle" ]
            _0,
            # [ doc = "FMC program flash is currently idle" ]
            _1,
        }
        impl FmcPfIdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FmcPfIdleR::_0 => 0,
                    FmcPfIdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FmcPfIdleR {
                match bits {
                    0 => FmcPfIdleR::_0,
                    1 => FmcPfIdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FmcPfIdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FmcPfIdleR::_1
            }
        }
        # [ doc = "Possible values of the field `PBRIDGE_IDLE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PbridgeIdleR {
            # [ doc = "PBRIDGE is not idle" ]
            _0,
            # [ doc = "PBRIDGE is currently idle" ]
            _1,
        }
        impl PbridgeIdleR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PbridgeIdleR::_0 => 0,
                    PbridgeIdleR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PbridgeIdleR {
                match bits {
                    0 => PbridgeIdleR::_0,
                    1 => PbridgeIdleR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == PbridgeIdleR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == PbridgeIdleR::_1
            }
        }
        # [ doc = "Possible values of the field `CBRR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CbrrR {
            # [ doc = "Fixed-priority arbitration" ]
            _0,
            # [ doc = "Round-robin arbitration" ]
            _1,
        }
        impl CbrrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CbrrR::_0 => 0,
                    CbrrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CbrrR {
                match bits {
                    0 => CbrrR::_0,
                    1 => CbrrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CbrrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CbrrR::_1
            }
        }
        # [ doc = "Possible values of the field `SRAMUAP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SramuapR {
            # [ doc = "Round robin" ]
            _00,
            # [ doc = "Special round robin (favors SRAM backdoor accesses over the processor)" ]
            _01,
            # [ doc = "Fixed priority. Processor has highest, backdoor has lowest" ]
            _10,
            # [ doc = "Fixed priority. Backdoor has highest, processor has lowest" ]
            _11,
        }
        impl SramuapR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SramuapR::_00 => 0,
                    SramuapR::_01 => 1,
                    SramuapR::_10 => 2,
                    SramuapR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SramuapR {
                match bits {
                    0 => SramuapR::_00,
                    1 => SramuapR::_01,
                    2 => SramuapR::_10,
                    3 => SramuapR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == SramuapR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == SramuapR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SramuapR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SramuapR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SramuwpR {
            bits: u8,
        }
        impl SramuwpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `SRAMLAP`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum SramlapR {
            # [ doc = "Round robin" ]
            _00,
            # [ doc = "Special round robin (favors SRAM backdoor accesses over the processor)" ]
            _01,
            # [ doc = "Fixed priority. Processor has highest, backdoor has lowest" ]
            _10,
            # [ doc = "Fixed priority. Backdoor has highest, processor has lowest" ]
            _11,
        }
        impl SramlapR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    SramlapR::_00 => 0,
                    SramlapR::_01 => 1,
                    SramlapR::_10 => 2,
                    SramlapR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> SramlapR {
                match bits {
                    0 => SramlapR::_00,
                    1 => SramlapR::_01,
                    2 => SramlapR::_10,
                    3 => SramlapR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == SramlapR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == SramlapR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == SramlapR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == SramlapR::_11
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct SramlwpR {
            bits: u8,
        }
        impl SramlwpR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `CBRR`" ]
        pub enum CbrrW {
            # [ doc = "Fixed-priority arbitration" ]
            _0,
            # [ doc = "Round-robin arbitration" ]
            _1,
        }
        impl CbrrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CbrrW::_0 => 0,
                    CbrrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CbrrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CbrrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CbrrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Fixed-priority arbitration" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CbrrW::_0)
            }
            # [ doc = "Round-robin arbitration" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CbrrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 9;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRAMUAP`" ]
        pub enum SramuapW {
            # [ doc = "Round robin" ]
            _00,
            # [ doc = "Special round robin (favors SRAM backdoor accesses over the processor)" ]
            _01,
            # [ doc = "Fixed priority. Processor has highest, backdoor has lowest" ]
            _10,
            # [ doc = "Fixed priority. Backdoor has highest, processor has lowest" ]
            _11,
        }
        impl SramuapW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SramuapW::_00 => 0,
                    SramuapW::_01 => 1,
                    SramuapW::_10 => 2,
                    SramuapW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SramuapW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SramuapW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SramuapW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Round robin" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(SramuapW::_00)
            }
            # [ doc = "Special round robin (favors SRAM backdoor accesses over the processor)" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(SramuapW::_01)
            }
            # [ doc = "Fixed priority. Processor has highest, backdoor has lowest" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SramuapW::_10)
            }
            # [ doc = "Fixed priority. Backdoor has highest, processor has lowest" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SramuapW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SramuwpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SramuwpW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `SRAMLAP`" ]
        pub enum SramlapW {
            # [ doc = "Round robin" ]
            _00,
            # [ doc = "Special round robin (favors SRAM backdoor accesses over the processor)" ]
            _01,
            # [ doc = "Fixed priority. Processor has highest, backdoor has lowest" ]
            _10,
            # [ doc = "Fixed priority. Backdoor has highest, processor has lowest" ]
            _11,
        }
        impl SramlapW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    SramlapW::_00 => 0,
                    SramlapW::_01 => 1,
                    SramlapW::_10 => 2,
                    SramlapW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SramlapW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SramlapW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: SramlapW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Round robin" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(SramlapW::_00)
            }
            # [ doc = "Special round robin (favors SRAM backdoor accesses over the processor)" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(SramlapW::_01)
            }
            # [ doc = "Fixed priority. Processor has highest, backdoor has lowest" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(SramlapW::_10)
            }
            # [ doc = "Fixed priority. Backdoor has highest, processor has lowest" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(SramlapW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _SramlwpW<'a> {
            w: &'a mut W,
        }
        impl<'a> _SramlwpW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - AXBS Halt State Machine Status" ]
            # [ inline ( always ) ]
            pub fn hlt_fsm_st(&self) -> HltFsmStR {
                HltFsmStR::_from({
                                     const MASK: u8 = 3;
                                     const OFFSET: u8 = 0;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 2 - AXBS Halt Request" ]
            # [ inline ( always ) ]
            pub fn axbs_hlt_req(&self) -> AxbsHltReqR {
                AxbsHltReqR::_from({
                                       const MASK: u8 = 1;
                                       const OFFSET: u8 = 2;
                                       ((self.bits >> OFFSET) & MASK as u32) as u8
                                   })
            }
            # [ doc = "Bit 3 - AXBS Halted" ]
            # [ inline ( always ) ]
            pub fn axbs_hltd(&self) -> AxbsHltdR {
                AxbsHltdR::_from({
                                     const MASK: u8 = 1;
                                     const OFFSET: u8 = 3;
                                     ((self.bits >> OFFSET) & MASK as u32) as u8
                                 })
            }
            # [ doc = "Bit 4 - Flash Memory Controller Program Flash Idle" ]
            # [ inline ( always ) ]
            pub fn fmc_pf_idle(&self) -> FmcPfIdleR {
                FmcPfIdleR::_from({
                                      const MASK: u8 = 1;
                                      const OFFSET: u8 = 4;
                                      ((self.bits >> OFFSET) & MASK as u32) as u8
                                  })
            }
            # [ doc = "Bit 6 - Peripheral Bridge Idle" ]
            # [ inline ( always ) ]
            pub fn pbridge_idle(&self) -> PbridgeIdleR {
                PbridgeIdleR::_from({
                                        const MASK: u8 = 1;
                                        const OFFSET: u8 = 6;
                                        ((self.bits >> OFFSET) & MASK as u32) as u8
                                    })
            }
            # [ doc = "Bit 9 - Crossbar Round-robin Arbitration Enable" ]
            # [ inline ( always ) ]
            pub fn cbrr(&self) -> CbrrR {
                CbrrR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 24:25 - SRAM_U Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn sramuap(&self) -> SramuapR {
                SramuapR::_from({
                                    const MASK: u8 = 3;
                                    const OFFSET: u8 = 24;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 26 - SRAM_U Write Protect" ]
            # [ inline ( always ) ]
            pub fn sramuwp(&self) -> SramuwpR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 26;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SramuwpR { bits }
            }
            # [ doc = "Bits 28:29 - SRAM_L Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn sramlap(&self) -> SramlapR {
                SramlapR::_from({
                                    const MASK: u8 = 3;
                                    const OFFSET: u8 = 28;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 30 - SRAM_L Write Protect" ]
            # [ inline ( always ) ]
            pub fn sramlwp(&self) -> SramlwpR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 30;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                SramlwpR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 9 - Crossbar Round-robin Arbitration Enable" ]
            # [ inline ( always ) ]
            pub fn cbrr(&mut self) -> _CbrrW {
                _CbrrW { w: self }
            }
            # [ doc = "Bits 24:25 - SRAM_U Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn sramuap(&mut self) -> _SramuapW {
                _SramuapW { w: self }
            }
            # [ doc = "Bit 26 - SRAM_U Write Protect" ]
            # [ inline ( always ) ]
            pub fn sramuwp(&mut self) -> _SramuwpW {
                _SramuwpW { w: self }
            }
            # [ doc = "Bits 28:29 - SRAM_L Arbitration Priority" ]
            # [ inline ( always ) ]
            pub fn sramlap(&mut self) -> _SramlapW {
                _SramlapW { w: self }
            }
            # [ doc = "Bit 30 - SRAM_L Write Protect" ]
            # [ inline ( always ) ]
            pub fn sramlwp(&mut self) -> _SramlwpW {
                _SramlwpW { w: self }
            }
        }
    }
    # [ doc = "Interrupt Status and Control Register" ]
    pub struct Iscr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Interrupt Status and Control Register" ]
    pub mod iscr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Iscr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `FIOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FiocR {
            # [ doc = "No interrupt" ]
            _0,
            # [ doc = "Interrupt occurred" ]
            _1,
        }
        impl FiocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FiocR::_0 => 0,
                    FiocR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FiocR {
                match bits {
                    0 => FiocR::_0,
                    1 => FiocR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FiocR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FiocR::_1
            }
        }
        # [ doc = "Possible values of the field `FDZC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdzcR {
            # [ doc = "No interrupt" ]
            _0,
            # [ doc = "Interrupt occurred" ]
            _1,
        }
        impl FdzcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdzcR::_0 => 0,
                    FdzcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdzcR {
                match bits {
                    0 => FdzcR::_0,
                    1 => FdzcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdzcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdzcR::_1
            }
        }
        # [ doc = "Possible values of the field `FOFC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FofcR {
            # [ doc = "No interrupt" ]
            _0,
            # [ doc = "Interrupt occurred" ]
            _1,
        }
        impl FofcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FofcR::_0 => 0,
                    FofcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FofcR {
                match bits {
                    0 => FofcR::_0,
                    1 => FofcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FofcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FofcR::_1
            }
        }
        # [ doc = "Possible values of the field `FUFC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FufcR {
            # [ doc = "No interrupt" ]
            _0,
            # [ doc = "Interrupt occurred" ]
            _1,
        }
        impl FufcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FufcR::_0 => 0,
                    FufcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FufcR {
                match bits {
                    0 => FufcR::_0,
                    1 => FufcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FufcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FufcR::_1
            }
        }
        # [ doc = "Possible values of the field `FIXC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FixcR {
            # [ doc = "No interrupt" ]
            _0,
            # [ doc = "Interrupt occurred" ]
            _1,
        }
        impl FixcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FixcR::_0 => 0,
                    FixcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FixcR {
                match bits {
                    0 => FixcR::_0,
                    1 => FixcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FixcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FixcR::_1
            }
        }
        # [ doc = "Possible values of the field `FIDC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FidcR {
            # [ doc = "No interrupt" ]
            _0,
            # [ doc = "Interrupt occurred" ]
            _1,
        }
        impl FidcR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FidcR::_0 => 0,
                    FidcR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FidcR {
                match bits {
                    0 => FidcR::_0,
                    1 => FidcR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FidcR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FidcR::_1
            }
        }
        # [ doc = "Possible values of the field `FIOCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FioceR {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FioceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FioceR::_0 => 0,
                    FioceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FioceR {
                match bits {
                    0 => FioceR::_0,
                    1 => FioceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FioceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FioceR::_1
            }
        }
        # [ doc = "Possible values of the field `FDZCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FdzceR {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FdzceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FdzceR::_0 => 0,
                    FdzceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FdzceR {
                match bits {
                    0 => FdzceR::_0,
                    1 => FdzceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FdzceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FdzceR::_1
            }
        }
        # [ doc = "Possible values of the field `FOFCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FofceR {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FofceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FofceR::_0 => 0,
                    FofceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FofceR {
                match bits {
                    0 => FofceR::_0,
                    1 => FofceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FofceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FofceR::_1
            }
        }
        # [ doc = "Possible values of the field `FUFCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FufceR {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FufceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FufceR::_0 => 0,
                    FufceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FufceR {
                match bits {
                    0 => FufceR::_0,
                    1 => FufceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FufceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FufceR::_1
            }
        }
        # [ doc = "Possible values of the field `FIXCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FixceR {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FixceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FixceR::_0 => 0,
                    FixceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FixceR {
                match bits {
                    0 => FixceR::_0,
                    1 => FixceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FixceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FixceR::_1
            }
        }
        # [ doc = "Possible values of the field `FIDCE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum FidceR {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FidceR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    FidceR::_0 => 0,
                    FidceR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> FidceR {
                match bits {
                    0 => FidceR::_0,
                    1 => FidceR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == FidceR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == FidceR::_1
            }
        }
        # [ doc = "Values that can be written to the field `FIOCE`" ]
        pub enum FioceW {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FioceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FioceW::_0 => 0,
                    FioceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FioceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FioceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FioceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FioceW::_0)
            }
            # [ doc = "Enable interrupt" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FioceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FDZCE`" ]
        pub enum FdzceW {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FdzceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FdzceW::_0 => 0,
                    FdzceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FdzceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FdzceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FdzceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FdzceW::_0)
            }
            # [ doc = "Enable interrupt" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FdzceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FOFCE`" ]
        pub enum FofceW {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FofceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FofceW::_0 => 0,
                    FofceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FofceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FofceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FofceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FofceW::_0)
            }
            # [ doc = "Enable interrupt" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FofceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FUFCE`" ]
        pub enum FufceW {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FufceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FufceW::_0 => 0,
                    FufceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FufceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FufceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FufceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FufceW::_0)
            }
            # [ doc = "Enable interrupt" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FufceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FIXCE`" ]
        pub enum FixceW {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FixceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FixceW::_0 => 0,
                    FixceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FixceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FixceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FixceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FixceW::_0)
            }
            # [ doc = "Enable interrupt" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FixceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `FIDCE`" ]
        pub enum FidceW {
            # [ doc = "Disable interrupt" ]
            _0,
            # [ doc = "Enable interrupt" ]
            _1,
        }
        impl FidceW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    FidceW::_0 => 0,
                    FidceW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _FidceW<'a> {
            w: &'a mut W,
        }
        impl<'a> _FidceW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: FidceW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Disable interrupt" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(FidceW::_0)
            }
            # [ doc = "Enable interrupt" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(FidceW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 8 - FPU Invalid Operation Interrupt Status" ]
            # [ inline ( always ) ]
            pub fn fioc(&self) -> FiocR {
                FiocR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 8;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 9 - FPU Divide-by-Zero Interrupt Status" ]
            # [ inline ( always ) ]
            pub fn fdzc(&self) -> FdzcR {
                FdzcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 9;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 10 - FPU Overflow Interrupt Status" ]
            # [ inline ( always ) ]
            pub fn fofc(&self) -> FofcR {
                FofcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 10;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 11 - FPU Underflow Interrupt Status" ]
            # [ inline ( always ) ]
            pub fn fufc(&self) -> FufcR {
                FufcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 11;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 12 - FPU Inexact Interrupt Status" ]
            # [ inline ( always ) ]
            pub fn fixc(&self) -> FixcR {
                FixcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 12;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 15 - FPU Input Denormal Interrupt Status" ]
            # [ inline ( always ) ]
            pub fn fidc(&self) -> FidcR {
                FidcR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 15;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 24 - FPU Invalid Operation Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fioce(&self) -> FioceR {
                FioceR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 25 - FPU Divide-by-Zero Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fdzce(&self) -> FdzceR {
                FdzceR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 25;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 26 - FPU Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fofce(&self) -> FofceR {
                FofceR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 26;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 27 - FPU Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fufce(&self) -> FufceR {
                FufceR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 27;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 28 - FPU Inexact Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fixce(&self) -> FixceR {
                FixceR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - FPU Input Denormal Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fidce(&self) -> FidceR {
                FidceR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 31;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 131072 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 24 - FPU Invalid Operation Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fioce(&mut self) -> _FioceW {
                _FioceW { w: self }
            }
            # [ doc = "Bit 25 - FPU Divide-by-Zero Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fdzce(&mut self) -> _FdzceW {
                _FdzceW { w: self }
            }
            # [ doc = "Bit 26 - FPU Overflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fofce(&mut self) -> _FofceW {
                _FofceW { w: self }
            }
            # [ doc = "Bit 27 - FPU Underflow Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fufce(&mut self) -> _FufceW {
                _FufceW { w: self }
            }
            # [ doc = "Bit 28 - FPU Inexact Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fixce(&mut self) -> _FixceW {
                _FixceW { w: self }
            }
            # [ doc = "Bit 31 - FPU Input Denormal Interrupt Enable" ]
            # [ inline ( always ) ]
            pub fn fidce(&mut self) -> _FidceW {
                _FidceW { w: self }
            }
        }
    }
    # [ doc = "Process ID Register" ]
    pub struct Pid {
        register: VolatileCell<u32>,
    }
    # [ doc = "Process ID Register" ]
    pub mod pid {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pid {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PidR {
            bits: u8,
        }
        impl PidR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PidW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PidW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - M0_PID and M1_PID for MPU" ]
            # [ inline ( always ) ]
            pub fn pid(&self) -> PidR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PidR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - M0_PID and M1_PID for MPU" ]
            # [ inline ( always ) ]
            pub fn pid(&mut self) -> _PidW {
                _PidW { w: self }
            }
        }
    }
    # [ doc = "Compute Operation Control Register" ]
    pub struct Cpo {
        register: VolatileCell<u32>,
    }
    # [ doc = "Compute Operation Control Register" ]
    pub mod cpo {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Cpo {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `CPOREQ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CporeqR {
            # [ doc = "Request is cleared." ]
            _0,
            # [ doc = "Request Compute Operation." ]
            _1,
        }
        impl CporeqR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CporeqR::_0 => 0,
                    CporeqR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CporeqR {
                match bits {
                    0 => CporeqR::_0,
                    1 => CporeqR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CporeqR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CporeqR::_1
            }
        }
        # [ doc = "Possible values of the field `CPOACK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpoackR {
            # [ doc = "Compute operation entry has not completed or compute operation exit has completed." ]
            _0,
            # [ doc = "Compute operation entry has completed or compute operation exit has not completed." ]
            _1,
        }
        impl CpoackR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpoackR::_0 => 0,
                    CpoackR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpoackR {
                match bits {
                    0 => CpoackR::_0,
                    1 => CpoackR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpoackR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpoackR::_1
            }
        }
        # [ doc = "Possible values of the field `CPOWOI`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum CpowoiR {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "When set, the CPOREQ is cleared on any interrupt or exception vector fetch." ]
            _1,
        }
        impl CpowoiR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    CpowoiR::_0 => 0,
                    CpowoiR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> CpowoiR {
                match bits {
                    0 => CpowoiR::_0,
                    1 => CpowoiR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == CpowoiR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == CpowoiR::_1
            }
        }
        # [ doc = "Values that can be written to the field `CPOREQ`" ]
        pub enum CporeqW {
            # [ doc = "Request is cleared." ]
            _0,
            # [ doc = "Request Compute Operation." ]
            _1,
        }
        impl CporeqW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CporeqW::_0 => 0,
                    CporeqW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CporeqW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CporeqW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CporeqW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Request is cleared." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CporeqW::_0)
            }
            # [ doc = "Request Compute Operation." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CporeqW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `CPOWOI`" ]
        pub enum CpowoiW {
            # [ doc = "No effect." ]
            _0,
            # [ doc = "When set, the CPOREQ is cleared on any interrupt or exception vector fetch." ]
            _1,
        }
        impl CpowoiW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    CpowoiW::_0 => 0,
                    CpowoiW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CpowoiW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CpowoiW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: CpowoiW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No effect." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(CpowoiW::_0)
            }
            # [ doc = "When set, the CPOREQ is cleared on any interrupt or exception vector fetch." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(CpowoiW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Compute Operation Request" ]
            # [ inline ( always ) ]
            pub fn cporeq(&self) -> CporeqR {
                CporeqR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 0;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 1 - Compute Operation Acknowledge" ]
            # [ inline ( always ) ]
            pub fn cpoack(&self) -> CpoackR {
                CpoackR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 1;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 2 - Compute Operation Wakeup On Interrupt" ]
            # [ inline ( always ) ]
            pub fn cpowoi(&self) -> CpowoiR {
                CpowoiR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 2;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Compute Operation Request" ]
            # [ inline ( always ) ]
            pub fn cporeq(&mut self) -> _CporeqW {
                _CporeqW { w: self }
            }
            # [ doc = "Bit 2 - Compute Operation Wakeup On Interrupt" ]
            # [ inline ( always ) ]
            pub fn cpowoi(&mut self) -> _CpowoiW {
                _CpowoiW { w: self }
            }
        }
    }
    # [ doc = "Local Memory Descriptor Register" ]
    pub struct Lmdr0 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Local Memory Descriptor Register" ]
    pub mod lmdr0 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lmdr0 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Cf0R {
            bits: u8,
        }
        impl Cf0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Cf1R {
            bits: u8,
        }
        impl Cf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `MT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MtR {
            # [ doc = "SRAM_L" ]
            _000,
            # [ doc = "SRAM_U" ]
            _001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MtR::_000 => 0,
                    MtR::_001 => 1,
                    MtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MtR {
                match bits {
                    0 => MtR::_000,
                    1 => MtR::_001,
                    i => MtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MtR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MtR::_001
            }
        }
        # [ doc = "Possible values of the field `LOCK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LockR {
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            _0,
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            _1,
        }
        impl LockR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LockR::_0 => 0,
                    LockR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LockR {
                match bits {
                    0 => LockR::_0,
                    1 => LockR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LockR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LockR::_1
            }
        }
        # [ doc = "Possible values of the field `DPW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpwR {
            # [ doc = "LMEMn 32-bits wide" ]
            _010,
            # [ doc = "LMEMn 64-bits wide" ]
            _011,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DpwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpwR::_010 => 2,
                    DpwR::_011 => 3,
                    DpwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpwR {
                match bits {
                    2 => DpwR::_010,
                    3 => DpwR::_011,
                    i => DpwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == DpwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == DpwR::_011
            }
        }
        # [ doc = "Possible values of the field `WY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WyR {
            # [ doc = "No Cache" ]
            _0000,
            # [ doc = "2-Way Set Associative" ]
            _0010,
            # [ doc = "4-Way Set Associative" ]
            _0100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl WyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WyR::_0000 => 0,
                    WyR::_0010 => 2,
                    WyR::_0100 => 4,
                    WyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WyR {
                match bits {
                    0 => WyR::_0000,
                    2 => WyR::_0010,
                    4 => WyR::_0100,
                    i => WyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == WyR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == WyR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == WyR::_0100
            }
        }
        # [ doc = "Possible values of the field `LMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LmszR {
            # [ doc = "no LMEMn (0 KB)" ]
            _0000,
            # [ doc = "1 KB LMEMn" ]
            _0001,
            # [ doc = "2 KB LMEMn" ]
            _0010,
            # [ doc = "4 KB LMEMn" ]
            _0011,
            # [ doc = "8 KB LMEMn" ]
            _0100,
            # [ doc = "16 KB LMEMn" ]
            _0101,
            # [ doc = "32 KB LMEMn" ]
            _0110,
            # [ doc = "64 KB LMEMn" ]
            _0111,
            # [ doc = "128 KB LMEMn" ]
            _1000,
            # [ doc = "256 KB LMEMn" ]
            _1001,
            # [ doc = "512 KB LMEMn" ]
            _1010,
            # [ doc = "1024 KB LMEMn" ]
            _1011,
            # [ doc = "2048 KB LMEMn" ]
            _1100,
            # [ doc = "4096 KB LMEMn" ]
            _1101,
            # [ doc = "8192 KB LMEMn" ]
            _1110,
            # [ doc = "16384 KB LMEMn" ]
            _1111,
        }
        impl LmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LmszR::_0000 => 0,
                    LmszR::_0001 => 1,
                    LmszR::_0010 => 2,
                    LmszR::_0011 => 3,
                    LmszR::_0100 => 4,
                    LmszR::_0101 => 5,
                    LmszR::_0110 => 6,
                    LmszR::_0111 => 7,
                    LmszR::_1000 => 8,
                    LmszR::_1001 => 9,
                    LmszR::_1010 => 10,
                    LmszR::_1011 => 11,
                    LmszR::_1100 => 12,
                    LmszR::_1101 => 13,
                    LmszR::_1110 => 14,
                    LmszR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LmszR {
                match bits {
                    0 => LmszR::_0000,
                    1 => LmszR::_0001,
                    2 => LmszR::_0010,
                    3 => LmszR::_0011,
                    4 => LmszR::_0100,
                    5 => LmszR::_0101,
                    6 => LmszR::_0110,
                    7 => LmszR::_0111,
                    8 => LmszR::_1000,
                    9 => LmszR::_1001,
                    10 => LmszR::_1010,
                    11 => LmszR::_1011,
                    12 => LmszR::_1100,
                    13 => LmszR::_1101,
                    14 => LmszR::_1110,
                    15 => LmszR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == LmszR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == LmszR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == LmszR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == LmszR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == LmszR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == LmszR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == LmszR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == LmszR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == LmszR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == LmszR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == LmszR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == LmszR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == LmszR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == LmszR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == LmszR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == LmszR::_1111
            }
        }
        # [ doc = "Possible values of the field `LMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LmszhR {
            # [ doc = "LMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "LMEMn is not a power-of-2, with a capacity is 0.75 * LMSZ." ]
            _1,
        }
        impl LmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LmszhR::_0 => 0,
                    LmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LmszhR {
                match bits {
                    0 => LmszhR::_0,
                    1 => LmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "LMEMn is not present." ]
            _0,
            # [ doc = "LMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Cf0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Cf0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Cf1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Cf1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOCK`" ]
        pub enum LockW {
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            _0,
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            _1,
        }
        impl LockW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LockW::_0 => 0,
                    LockW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LockW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LockW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LockW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LockW::_0)
            }
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LockW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Control Field 0" ]
            # [ inline ( always ) ]
            pub fn cf0(&self) -> Cf0R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Cf0R { bits }
            }
            # [ doc = "Bits 4:7 - Control Field 1" ]
            # [ inline ( always ) ]
            pub fn cf1(&self) -> Cf1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Cf1R { bits }
            }
            # [ doc = "Bits 13:15 - Memory Type" ]
            # [ inline ( always ) ]
            pub fn mt(&self) -> MtR {
                MtR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 13;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 16 - LOCK" ]
            # [ inline ( always ) ]
            pub fn lock(&self) -> LockR {
                LockR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 17:19 - LMEM Data Path Width. This field defines the width of the local memory." ]
            # [ inline ( always ) ]
            pub fn dpw(&self) -> DpwR {
                DpwR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 20:23 - Level 1 Cache Ways" ]
            # [ inline ( always ) ]
            pub fn wy(&self) -> WyR {
                WyR::_from({
                               const MASK: u8 = 15;
                               const OFFSET: u8 = 20;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 24:27 - LMEM Size" ]
            # [ inline ( always ) ]
            pub fn lmsz(&self) -> LmszR {
                LmszR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - LMEM Size Hole" ]
            # [ inline ( always ) ]
            pub fn lmszh(&self) -> LmszhR {
                LmszhR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Local Memory Valid" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Control Field 0" ]
            # [ inline ( always ) ]
            pub fn cf0(&mut self) -> _Cf0W {
                _Cf0W { w: self }
            }
            # [ doc = "Bits 4:7 - Control Field 1" ]
            # [ inline ( always ) ]
            pub fn cf1(&mut self) -> _Cf1W {
                _Cf1W { w: self }
            }
            # [ doc = "Bit 16 - LOCK" ]
            # [ inline ( always ) ]
            pub fn lock(&mut self) -> _LockW {
                _LockW { w: self }
            }
        }
    }
    # [ doc = "Local Memory Descriptor Register" ]
    pub struct Lmdr1 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Local Memory Descriptor Register" ]
    pub mod lmdr1 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lmdr1 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Cf0R {
            bits: u8,
        }
        impl Cf0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Cf1R {
            bits: u8,
        }
        impl Cf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `MT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MtR {
            # [ doc = "SRAM_L" ]
            _000,
            # [ doc = "SRAM_U" ]
            _001,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MtR::_000 => 0,
                    MtR::_001 => 1,
                    MtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MtR {
                match bits {
                    0 => MtR::_000,
                    1 => MtR::_001,
                    i => MtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == MtR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == MtR::_001
            }
        }
        # [ doc = "Possible values of the field `LOCK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LockR {
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            _0,
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            _1,
        }
        impl LockR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LockR::_0 => 0,
                    LockR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LockR {
                match bits {
                    0 => LockR::_0,
                    1 => LockR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LockR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LockR::_1
            }
        }
        # [ doc = "Possible values of the field `DPW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpwR {
            # [ doc = "LMEMn 32-bits wide" ]
            _010,
            # [ doc = "LMEMn 64-bits wide" ]
            _011,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DpwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpwR::_010 => 2,
                    DpwR::_011 => 3,
                    DpwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpwR {
                match bits {
                    2 => DpwR::_010,
                    3 => DpwR::_011,
                    i => DpwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == DpwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == DpwR::_011
            }
        }
        # [ doc = "Possible values of the field `WY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WyR {
            # [ doc = "No Cache" ]
            _0000,
            # [ doc = "2-Way Set Associative" ]
            _0010,
            # [ doc = "4-Way Set Associative" ]
            _0100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl WyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WyR::_0000 => 0,
                    WyR::_0010 => 2,
                    WyR::_0100 => 4,
                    WyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WyR {
                match bits {
                    0 => WyR::_0000,
                    2 => WyR::_0010,
                    4 => WyR::_0100,
                    i => WyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == WyR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == WyR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == WyR::_0100
            }
        }
        # [ doc = "Possible values of the field `LMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LmszR {
            # [ doc = "no LMEMn (0 KB)" ]
            _0000,
            # [ doc = "1 KB LMEMn" ]
            _0001,
            # [ doc = "2 KB LMEMn" ]
            _0010,
            # [ doc = "4 KB LMEMn" ]
            _0011,
            # [ doc = "8 KB LMEMn" ]
            _0100,
            # [ doc = "16 KB LMEMn" ]
            _0101,
            # [ doc = "32 KB LMEMn" ]
            _0110,
            # [ doc = "64 KB LMEMn" ]
            _0111,
            # [ doc = "128 KB LMEMn" ]
            _1000,
            # [ doc = "256 KB LMEMn" ]
            _1001,
            # [ doc = "512 KB LMEMn" ]
            _1010,
            # [ doc = "1024 KB LMEMn" ]
            _1011,
            # [ doc = "2048 KB LMEMn" ]
            _1100,
            # [ doc = "4096 KB LMEMn" ]
            _1101,
            # [ doc = "8192 KB LMEMn" ]
            _1110,
            # [ doc = "16384 KB LMEMn" ]
            _1111,
        }
        impl LmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LmszR::_0000 => 0,
                    LmszR::_0001 => 1,
                    LmszR::_0010 => 2,
                    LmszR::_0011 => 3,
                    LmszR::_0100 => 4,
                    LmszR::_0101 => 5,
                    LmszR::_0110 => 6,
                    LmszR::_0111 => 7,
                    LmszR::_1000 => 8,
                    LmszR::_1001 => 9,
                    LmszR::_1010 => 10,
                    LmszR::_1011 => 11,
                    LmszR::_1100 => 12,
                    LmszR::_1101 => 13,
                    LmszR::_1110 => 14,
                    LmszR::_1111 => 15,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LmszR {
                match bits {
                    0 => LmszR::_0000,
                    1 => LmszR::_0001,
                    2 => LmszR::_0010,
                    3 => LmszR::_0011,
                    4 => LmszR::_0100,
                    5 => LmszR::_0101,
                    6 => LmszR::_0110,
                    7 => LmszR::_0111,
                    8 => LmszR::_1000,
                    9 => LmszR::_1001,
                    10 => LmszR::_1010,
                    11 => LmszR::_1011,
                    12 => LmszR::_1100,
                    13 => LmszR::_1101,
                    14 => LmszR::_1110,
                    15 => LmszR::_1111,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == LmszR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0001`" ]
            # [ inline ( always ) ]
            pub fn is_0001(&self) -> bool {
                *self == LmszR::_0001
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == LmszR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0011`" ]
            # [ inline ( always ) ]
            pub fn is_0011(&self) -> bool {
                *self == LmszR::_0011
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == LmszR::_0100
            }
            # [ doc = "Checks if the value of the field is `_0101`" ]
            # [ inline ( always ) ]
            pub fn is_0101(&self) -> bool {
                *self == LmszR::_0101
            }
            # [ doc = "Checks if the value of the field is `_0110`" ]
            # [ inline ( always ) ]
            pub fn is_0110(&self) -> bool {
                *self == LmszR::_0110
            }
            # [ doc = "Checks if the value of the field is `_0111`" ]
            # [ inline ( always ) ]
            pub fn is_0111(&self) -> bool {
                *self == LmszR::_0111
            }
            # [ doc = "Checks if the value of the field is `_1000`" ]
            # [ inline ( always ) ]
            pub fn is_1000(&self) -> bool {
                *self == LmszR::_1000
            }
            # [ doc = "Checks if the value of the field is `_1001`" ]
            # [ inline ( always ) ]
            pub fn is_1001(&self) -> bool {
                *self == LmszR::_1001
            }
            # [ doc = "Checks if the value of the field is `_1010`" ]
            # [ inline ( always ) ]
            pub fn is_1010(&self) -> bool {
                *self == LmszR::_1010
            }
            # [ doc = "Checks if the value of the field is `_1011`" ]
            # [ inline ( always ) ]
            pub fn is_1011(&self) -> bool {
                *self == LmszR::_1011
            }
            # [ doc = "Checks if the value of the field is `_1100`" ]
            # [ inline ( always ) ]
            pub fn is_1100(&self) -> bool {
                *self == LmszR::_1100
            }
            # [ doc = "Checks if the value of the field is `_1101`" ]
            # [ inline ( always ) ]
            pub fn is_1101(&self) -> bool {
                *self == LmszR::_1101
            }
            # [ doc = "Checks if the value of the field is `_1110`" ]
            # [ inline ( always ) ]
            pub fn is_1110(&self) -> bool {
                *self == LmszR::_1110
            }
            # [ doc = "Checks if the value of the field is `_1111`" ]
            # [ inline ( always ) ]
            pub fn is_1111(&self) -> bool {
                *self == LmszR::_1111
            }
        }
        # [ doc = "Possible values of the field `LMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LmszhR {
            # [ doc = "LMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "LMEMn is not a power-of-2, with a capacity is 0.75 * LMSZ." ]
            _1,
        }
        impl LmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LmszhR::_0 => 0,
                    LmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LmszhR {
                match bits {
                    0 => LmszhR::_0,
                    1 => LmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "LMEMn is not present." ]
            _0,
            # [ doc = "LMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Cf0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Cf0W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Cf1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Cf1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOCK`" ]
        pub enum LockW {
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            _0,
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            _1,
        }
        impl LockW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LockW::_0 => 0,
                    LockW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LockW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LockW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LockW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LockW::_0)
            }
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LockW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Control Field 0" ]
            # [ inline ( always ) ]
            pub fn cf0(&self) -> Cf0R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Cf0R { bits }
            }
            # [ doc = "Bits 4:7 - Control Field 1" ]
            # [ inline ( always ) ]
            pub fn cf1(&self) -> Cf1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Cf1R { bits }
            }
            # [ doc = "Bits 13:15 - Memory Type" ]
            # [ inline ( always ) ]
            pub fn mt(&self) -> MtR {
                MtR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 13;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 16 - LOCK" ]
            # [ inline ( always ) ]
            pub fn lock(&self) -> LockR {
                LockR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 17:19 - LMEM Data Path Width. This field defines the width of the local memory." ]
            # [ inline ( always ) ]
            pub fn dpw(&self) -> DpwR {
                DpwR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 20:23 - Level 1 Cache Ways" ]
            # [ inline ( always ) ]
            pub fn wy(&self) -> WyR {
                WyR::_from({
                               const MASK: u8 = 15;
                               const OFFSET: u8 = 20;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 24:27 - LMEM Size" ]
            # [ inline ( always ) ]
            pub fn lmsz(&self) -> LmszR {
                LmszR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - LMEM Size Hole" ]
            # [ inline ( always ) ]
            pub fn lmszh(&self) -> LmszhR {
                LmszhR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Local Memory Valid" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:3 - Control Field 0" ]
            # [ inline ( always ) ]
            pub fn cf0(&mut self) -> _Cf0W {
                _Cf0W { w: self }
            }
            # [ doc = "Bits 4:7 - Control Field 1" ]
            # [ inline ( always ) ]
            pub fn cf1(&mut self) -> _Cf1W {
                _Cf1W { w: self }
            }
            # [ doc = "Bit 16 - LOCK" ]
            # [ inline ( always ) ]
            pub fn lock(&mut self) -> _LockW {
                _LockW { w: self }
            }
        }
    }
    # [ doc = "Local Memory Descriptor Register2" ]
    pub struct Lmdr2 {
        register: VolatileCell<u32>,
    }
    # [ doc = "Local Memory Descriptor Register2" ]
    pub mod lmdr2 {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lmdr2 {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Cf1R {
            bits: u8,
        }
        impl Cf1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `MT`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum MtR {
            # [ doc = "PC Cache" ]
            _010,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl MtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    MtR::_010 => 2,
                    MtR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> MtR {
                match bits {
                    2 => MtR::_010,
                    i => MtR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == MtR::_010
            }
        }
        # [ doc = "Possible values of the field `LOCK`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LockR {
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            _0,
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            _1,
        }
        impl LockR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LockR::_0 => 0,
                    LockR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LockR {
                match bits {
                    0 => LockR::_0,
                    1 => LockR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LockR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LockR::_1
            }
        }
        # [ doc = "Possible values of the field `DPW`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum DpwR {
            # [ doc = "LMEMn 32-bits wide" ]
            _010,
            # [ doc = "LMEMn 64-bits wide" ]
            _011,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl DpwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    DpwR::_010 => 2,
                    DpwR::_011 => 3,
                    DpwR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> DpwR {
                match bits {
                    2 => DpwR::_010,
                    3 => DpwR::_011,
                    i => DpwR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == DpwR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == DpwR::_011
            }
        }
        # [ doc = "Possible values of the field `WY`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WyR {
            # [ doc = "No Cache" ]
            _0000,
            # [ doc = "2-Way Set Associative" ]
            _0010,
            # [ doc = "4-Way Set Associative" ]
            _0100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl WyR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WyR::_0000 => 0,
                    WyR::_0010 => 2,
                    WyR::_0100 => 4,
                    WyR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WyR {
                match bits {
                    0 => WyR::_0000,
                    2 => WyR::_0010,
                    4 => WyR::_0100,
                    i => WyR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0000`" ]
            # [ inline ( always ) ]
            pub fn is_0000(&self) -> bool {
                *self == WyR::_0000
            }
            # [ doc = "Checks if the value of the field is `_0010`" ]
            # [ inline ( always ) ]
            pub fn is_0010(&self) -> bool {
                *self == WyR::_0010
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == WyR::_0100
            }
        }
        # [ doc = "Possible values of the field `LMSZ`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LmszR {
            # [ doc = "4 KB LMEMn" ]
            _0100,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl LmszR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LmszR::_0100 => 4,
                    LmszR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LmszR {
                match bits {
                    4 => LmszR::_0100,
                    i => LmszR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_0100`" ]
            # [ inline ( always ) ]
            pub fn is_0100(&self) -> bool {
                *self == LmszR::_0100
            }
        }
        # [ doc = "Possible values of the field `LMSZH`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LmszhR {
            # [ doc = "LMEMn is a power-of-2 capacity." ]
            _0,
            # [ doc = "LMEMn is not a power-of-2, with a capacity is 0.75 * LMSZ." ]
            _1,
        }
        impl LmszhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LmszhR::_0 => 0,
                    LmszhR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LmszhR {
                match bits {
                    0 => LmszhR::_0,
                    1 => LmszhR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LmszhR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LmszhR::_1
            }
        }
        # [ doc = "Possible values of the field `V`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum VR {
            # [ doc = "LMEMn is not present." ]
            _0,
            # [ doc = "LMEMn is present." ]
            _1,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    VR::_0 => 0,
                    VR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> VR {
                match bits {
                    0 => VR::_0,
                    1 => VR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == VR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == VR::_1
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Cf1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Cf1W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 15;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LOCK`" ]
        pub enum LockW {
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            _0,
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            _1,
        }
        impl LockW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LockW::_0 => 0,
                    LockW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LockW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LockW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LockW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Writes to the LMDRn[7:0] are allowed." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LockW::_0)
            }
            # [ doc = "Writes to the LMDRn[7:0] are ignored." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LockW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 4:7 - Control Field 1" ]
            # [ inline ( always ) ]
            pub fn cf1(&self) -> Cf1R {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 4;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Cf1R { bits }
            }
            # [ doc = "Bits 13:15 - Memory Type" ]
            # [ inline ( always ) ]
            pub fn mt(&self) -> MtR {
                MtR::_from({
                               const MASK: u8 = 7;
                               const OFFSET: u8 = 13;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bit 16 - LOCK" ]
            # [ inline ( always ) ]
            pub fn lock(&self) -> LockR {
                LockR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 16;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bits 17:19 - LMEM Data Path Width. This field defines the width of the local memory." ]
            # [ inline ( always ) ]
            pub fn dpw(&self) -> DpwR {
                DpwR::_from({
                                const MASK: u8 = 7;
                                const OFFSET: u8 = 17;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 20:23 - Level 1 Cache Ways" ]
            # [ inline ( always ) ]
            pub fn wy(&self) -> WyR {
                WyR::_from({
                               const MASK: u8 = 15;
                               const OFFSET: u8 = 20;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 24:27 - LMEM Size" ]
            # [ inline ( always ) ]
            pub fn lmsz(&self) -> LmszR {
                LmszR::_from({
                                 const MASK: u8 = 15;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 28 - LMEM Size Hole" ]
            # [ inline ( always ) ]
            pub fn lmszh(&self) -> LmszhR {
                LmszhR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 28;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 31 - Local Memory Valid" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                VR::_from({
                              const MASK: u8 = 1;
                              const OFFSET: u8 = 31;
                              ((self.bits >> OFFSET) & MASK as u32) as u8
                          })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2216968352 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 4:7 - Control Field 1" ]
            # [ inline ( always ) ]
            pub fn cf1(&mut self) -> _Cf1W {
                _Cf1W { w: self }
            }
            # [ doc = "Bit 16 - LOCK" ]
            # [ inline ( always ) ]
            pub fn lock(&mut self) -> _LockW {
                _LockW { w: self }
            }
        }
    }
    # [ doc = "LMEM Parity and ECC Control Register" ]
    pub struct Lmpecr {
        register: VolatileCell<u32>,
    }
    # [ doc = "LMEM Parity and ECC Control Register" ]
    pub mod lmpecr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lmpecr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ERNCR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum ErncrR {
            # [ doc = "Reporting disabled" ]
            _0,
            # [ doc = "Reporting enabled" ]
            _1,
        }
        impl ErncrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    ErncrR::_0 => 0,
                    ErncrR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> ErncrR {
                match bits {
                    0 => ErncrR::_0,
                    1 => ErncrR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == ErncrR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == ErncrR::_1
            }
        }
        # [ doc = "Possible values of the field `ER1BR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Er1brR {
            # [ doc = "Reporting disabled" ]
            _0,
            # [ doc = "Reporting enabled" ]
            _1,
        }
        impl Er1brR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Er1brR::_0 => 0,
                    Er1brR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Er1brR {
                match bits {
                    0 => Er1brR::_0,
                    1 => Er1brR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Er1brR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Er1brR::_1
            }
        }
        # [ doc = "Possible values of the field `ECPR`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EcprR {
            # [ doc = "Reporting disabled" ]
            _0,
            # [ doc = "Reporting enabled" ]
            _1,
        }
        impl EcprR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EcprR::_0 => 0,
                    EcprR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EcprR {
                match bits {
                    0 => EcprR::_0,
                    1 => EcprR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EcprR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EcprR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ERNCR`" ]
        pub enum ErncrW {
            # [ doc = "Reporting disabled" ]
            _0,
            # [ doc = "Reporting enabled" ]
            _1,
        }
        impl ErncrW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    ErncrW::_0 => 0,
                    ErncrW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _ErncrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _ErncrW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: ErncrW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reporting disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(ErncrW::_0)
            }
            # [ doc = "Reporting enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(ErncrW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ER1BR`" ]
        pub enum Er1brW {
            # [ doc = "Reporting disabled" ]
            _0,
            # [ doc = "Reporting enabled" ]
            _1,
        }
        impl Er1brW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Er1brW::_0 => 0,
                    Er1brW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Er1brW<'a> {
            w: &'a mut W,
        }
        impl<'a> _Er1brW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Er1brW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reporting disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Er1brW::_0)
            }
            # [ doc = "Reporting enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Er1brW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `ECPR`" ]
        pub enum EcprW {
            # [ doc = "Reporting disabled" ]
            _0,
            # [ doc = "Reporting enabled" ]
            _1,
        }
        impl EcprW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EcprW::_0 => 0,
                    EcprW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EcprW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EcprW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EcprW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Reporting disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EcprW::_0)
            }
            # [ doc = "Reporting enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EcprW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Enable RAM ECC Noncorrectable Reporting" ]
            # [ inline ( always ) ]
            pub fn erncr(&self) -> ErncrR {
                ErncrR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 0;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 8 - Enable RAM ECC 1 Bit Reporting" ]
            # [ inline ( always ) ]
            pub fn er1br(&self) -> Er1brR {
                Er1brR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 8;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 20 - Enable Cache Parity Reporting" ]
            # [ inline ( always ) ]
            pub fn ecpr(&self) -> EcprR {
                EcprR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 20;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Enable RAM ECC Noncorrectable Reporting" ]
            # [ inline ( always ) ]
            pub fn erncr(&mut self) -> _ErncrW {
                _ErncrW { w: self }
            }
            # [ doc = "Bit 8 - Enable RAM ECC 1 Bit Reporting" ]
            # [ inline ( always ) ]
            pub fn er1br(&mut self) -> _Er1brW {
                _Er1brW { w: self }
            }
            # [ doc = "Bit 20 - Enable Cache Parity Reporting" ]
            # [ inline ( always ) ]
            pub fn ecpr(&mut self) -> _EcprW {
                _EcprW { w: self }
            }
        }
    }
    # [ doc = "LMEM Parity and ECC Interrupt Register" ]
    pub struct Lmpeir {
        register: VolatileCell<u32>,
    }
    # [ doc = "LMEM Parity and ECC Interrupt Register" ]
    pub mod lmpeir {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Lmpeir {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EncR {
            bits: u8,
        }
        impl EncR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct E1bR {
            bits: u8,
        }
        impl E1bR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PeR {
            bits: u8,
        }
        impl PeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PEELOC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PeelocR {
            # [ doc = "Non-correctable ECC event from SRAM_L" ]
            _00,
            # [ doc = "Non-correctable ECC event from SRAM_U" ]
            _01,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PeelocR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PeelocR::_00 => 0,
                    PeelocR::_01 => 1,
                    PeelocR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PeelocR {
                match bits {
                    0 => PeelocR::_00,
                    1 => PeelocR::_01,
                    i => PeelocR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == PeelocR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == PeelocR::_01
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct VR {
            bits: u8,
        }
        impl VR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EncW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EncW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _E1bW<'a> {
            w: &'a mut W,
        }
        impl<'a> _E1bW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PeW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PeW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 255;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:7 - ENCn = ECC Noncorrectable Error n" ]
            # [ inline ( always ) ]
            pub fn enc(&self) -> EncR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                EncR { bits }
            }
            # [ doc = "Bits 8:15 - E1Bn = ECC 1-bit Error n" ]
            # [ inline ( always ) ]
            pub fn e1b(&self) -> E1bR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                E1bR { bits }
            }
            # [ doc = "Bits 16:23 - Cache Parity Error" ]
            # [ inline ( always ) ]
            pub fn pe(&self) -> PeR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 16;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PeR { bits }
            }
            # [ doc = "Bits 24:28 - Parity or ECC Error Location" ]
            # [ inline ( always ) ]
            pub fn peeloc(&self) -> PeelocR {
                PeelocR::_from({
                                   const MASK: u8 = 31;
                                   const OFFSET: u8 = 24;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - Valid Bit" ]
            # [ inline ( always ) ]
            pub fn v(&self) -> VR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                VR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:7 - ENCn = ECC Noncorrectable Error n" ]
            # [ inline ( always ) ]
            pub fn enc(&mut self) -> _EncW {
                _EncW { w: self }
            }
            # [ doc = "Bits 8:15 - E1Bn = ECC 1-bit Error n" ]
            # [ inline ( always ) ]
            pub fn e1b(&mut self) -> _E1bW {
                _E1bW { w: self }
            }
            # [ doc = "Bits 16:23 - Cache Parity Error" ]
            # [ inline ( always ) ]
            pub fn pe(&mut self) -> _PeW {
                _PeW { w: self }
            }
        }
    }
    # [ doc = "LMEM Fault Address Register" ]
    pub struct Lmfar {
        register: VolatileCell<u32>,
    }
    # [ doc = "LMEM Fault Address Register" ]
    pub mod lmfar {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Lmfar {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct EfaddR {
            bits: u32,
        }
        impl EfaddR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - ECC Fault Address" ]
            # [ inline ( always ) ]
            pub fn efadd(&self) -> EfaddR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                EfaddR { bits }
            }
        }
    }
    # [ doc = "LMEM Fault Attribute Register" ]
    pub struct Lmfatr {
        register: VolatileCell<u32>,
    }
    # [ doc = "LMEM Fault Attribute Register" ]
    pub mod lmfatr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Lmfatr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PefprtR {
            bits: u8,
        }
        impl PefprtR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `PEFSIZE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum PefsizeR {
            # [ doc = "8-bit access" ]
            _000,
            # [ doc = "16-bit access" ]
            _001,
            # [ doc = "32-bit access" ]
            _010,
            # [ doc = "64-bit access" ]
            _011,
            # [ doc = r" Reserved" ]
            _Reserved(u8),
        }
        impl PefsizeR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    PefsizeR::_000 => 0,
                    PefsizeR::_001 => 1,
                    PefsizeR::_010 => 2,
                    PefsizeR::_011 => 3,
                    PefsizeR::_Reserved(bits) => bits,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> PefsizeR {
                match bits {
                    0 => PefsizeR::_000,
                    1 => PefsizeR::_001,
                    2 => PefsizeR::_010,
                    3 => PefsizeR::_011,
                    i => PefsizeR::_Reserved(i),
                }
            }
            # [ doc = "Checks if the value of the field is `_000`" ]
            # [ inline ( always ) ]
            pub fn is_000(&self) -> bool {
                *self == PefsizeR::_000
            }
            # [ doc = "Checks if the value of the field is `_001`" ]
            # [ inline ( always ) ]
            pub fn is_001(&self) -> bool {
                *self == PefsizeR::_001
            }
            # [ doc = "Checks if the value of the field is `_010`" ]
            # [ inline ( always ) ]
            pub fn is_010(&self) -> bool {
                *self == PefsizeR::_010
            }
            # [ doc = "Checks if the value of the field is `_011`" ]
            # [ inline ( always ) ]
            pub fn is_011(&self) -> bool {
                *self == PefsizeR::_011
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PefwR {
            bits: u8,
        }
        impl PefwR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PefmstR {
            bits: u8,
        }
        impl PefmstR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct OvrR {
            bits: u8,
        }
        impl OvrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:3 - Parity/ECC Fault Protection" ]
            # [ inline ( always ) ]
            pub fn pefprt(&self) -> PefprtR {
                let bits = {
                    const MASK: u8 = 15;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PefprtR { bits }
            }
            # [ doc = "Bits 4:6 - Parity/ECC Fault Master Size" ]
            # [ inline ( always ) ]
            pub fn pefsize(&self) -> PefsizeR {
                PefsizeR::_from({
                                    const MASK: u8 = 7;
                                    const OFFSET: u8 = 4;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 7 - Parity/ECC Fault Write" ]
            # [ inline ( always ) ]
            pub fn pefw(&self) -> PefwR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 7;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PefwR { bits }
            }
            # [ doc = "Bits 8:15 - Parity/ECC Fault Master Number" ]
            # [ inline ( always ) ]
            pub fn pefmst(&self) -> PefmstR {
                let bits = {
                    const MASK: u8 = 255;
                    const OFFSET: u8 = 8;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                PefmstR { bits }
            }
            # [ doc = "Bit 31 - Overrun" ]
            # [ inline ( always ) ]
            pub fn ovr(&self) -> OvrR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 31;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                OvrR { bits }
            }
        }
    }
    # [ doc = "LMEM Fault Data High Register" ]
    pub struct Lmfdhr {
        register: VolatileCell<u32>,
    }
    # [ doc = "LMEM Fault Data High Register" ]
    pub mod lmfdhr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Lmfdhr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PefdhR {
            bits: u32,
        }
        impl PefdhR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Parity or ECC Fault Data High" ]
            # [ inline ( always ) ]
            pub fn pefdh(&self) -> PefdhR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PefdhR { bits }
            }
        }
    }
    # [ doc = "LMEM Fault Data Low Register" ]
    pub struct Lmfdlr {
        register: VolatileCell<u32>,
    }
    # [ doc = "LMEM Fault Data Low Register" ]
    pub mod lmfdlr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        impl super::Lmfdlr {
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PefdlR {
            bits: u32,
        }
        impl PefdlR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Parity or ECC Fault Data Low" ]
            # [ inline ( always ) ]
            pub fn pefdl(&self) -> PefdlR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PefdlR { bits }
            }
        }
    }
}
# [ doc = "Core Platform Miscellaneous Control Module" ]
pub struct Mcm {
    register_block: mcm::RegisterBlock,
}
impl Deref for Mcm {
    type Target = mcm::RegisterBlock;
    fn deref(&self) -> &mcm::RegisterBlock {
        &self.register_block
    }
}
# [ doc = "Local Memory Controller" ]
pub const LMEM: Peripheral<Lmem> = unsafe { Peripheral::new(3758628864) };
# [ doc = "Local Memory Controller" ]
pub mod lmem {
    use vcell::VolatileCell;
    # [ doc = r" Register block" ]
    # [ repr ( C ) ]
    pub struct RegisterBlock {
        # [ doc = "0x00 - Cache control register" ]
        pub lmem_pcccr: LmemPcccr,
        # [ doc = "0x04 - Cache line control register" ]
        pub lmem_pcclcr: LmemPcclcr,
        # [ doc = "0x08 - Cache search address register" ]
        pub lmem_pccsar: LmemPccsar,
        # [ doc = "0x0c - Cache read/write value register" ]
        pub lmem_pcccvr: LmemPcccvr,
        _reserved0: [u8; 16usize],
        # [ doc = "0x20 - Cache regions mode register" ]
        pub pccrmr: Pccrmr,
    }
    # [ doc = "Cache control register" ]
    pub struct LmemPcccr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Cache control register" ]
    pub mod lmem_pcccr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::LmemPcccr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `ENCACHE`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum EncacheR {
            # [ doc = "Cache disabled" ]
            _0,
            # [ doc = "Cache enabled" ]
            _1,
        }
        impl EncacheR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    EncacheR::_0 => 0,
                    EncacheR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> EncacheR {
                match bits {
                    0 => EncacheR::_0,
                    1 => EncacheR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == EncacheR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == EncacheR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pccr2R {
            bits: u8,
        }
        impl Pccr2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct Pccr3R {
            bits: u8,
        }
        impl Pccr3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `INVW0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Invw0R {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, invalidate all lines in way 0." ]
            _1,
        }
        impl Invw0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Invw0R::_0 => 0,
                    Invw0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Invw0R {
                match bits {
                    0 => Invw0R::_0,
                    1 => Invw0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Invw0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Invw0R::_1
            }
        }
        # [ doc = "Possible values of the field `PUSHW0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pushw0R {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, push all modified lines in way 0" ]
            _1,
        }
        impl Pushw0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pushw0R::_0 => 0,
                    Pushw0R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pushw0R {
                match bits {
                    0 => Pushw0R::_0,
                    1 => Pushw0R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pushw0R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pushw0R::_1
            }
        }
        # [ doc = "Possible values of the field `INVW1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Invw1R {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, invalidate all lines in way 1" ]
            _1,
        }
        impl Invw1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Invw1R::_0 => 0,
                    Invw1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Invw1R {
                match bits {
                    0 => Invw1R::_0,
                    1 => Invw1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Invw1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Invw1R::_1
            }
        }
        # [ doc = "Possible values of the field `PUSHW1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum Pushw1R {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, push all modified lines in way 1" ]
            _1,
        }
        impl Pushw1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    Pushw1R::_0 => 0,
                    Pushw1R::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> Pushw1R {
                match bits {
                    0 => Pushw1R::_0,
                    1 => Pushw1R::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == Pushw1R::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == Pushw1R::_1
            }
        }
        # [ doc = "Possible values of the field `GO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum GoR {
            # [ doc = "Write: no effect. Read: no cache command active." ]
            _0,
            # [ doc = "Write: initiate command indicated by bits 27-24. Read: cache command active." ]
            _1,
        }
        impl GoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    GoR::_0 => 0,
                    GoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> GoR {
                match bits {
                    0 => GoR::_0,
                    1 => GoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == GoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == GoR::_1
            }
        }
        # [ doc = "Values that can be written to the field `ENCACHE`" ]
        pub enum EncacheW {
            # [ doc = "Cache disabled" ]
            _0,
            # [ doc = "Cache enabled" ]
            _1,
        }
        impl EncacheW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    EncacheW::_0 => 0,
                    EncacheW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _EncacheW<'a> {
            w: &'a mut W,
        }
        impl<'a> _EncacheW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: EncacheW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Cache disabled" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(EncacheW::_0)
            }
            # [ doc = "Cache enabled" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(EncacheW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pccr2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pccr2W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pccr3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pccr3W<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 3;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVW0`" ]
        pub enum Invw0W {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, invalidate all lines in way 0." ]
            _1,
        }
        impl Invw0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Invw0W::_0 => 0,
                    Invw0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Invw0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Invw0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Invw0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Invw0W::_0)
            }
            # [ doc = "When setting the GO bit, invalidate all lines in way 0." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Invw0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PUSHW0`" ]
        pub enum Pushw0W {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, push all modified lines in way 0" ]
            _1,
        }
        impl Pushw0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pushw0W::_0 => 0,
                    Pushw0W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pushw0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pushw0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pushw0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pushw0W::_0)
            }
            # [ doc = "When setting the GO bit, push all modified lines in way 0" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pushw0W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 25;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `INVW1`" ]
        pub enum Invw1W {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, invalidate all lines in way 1" ]
            _1,
        }
        impl Invw1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Invw1W::_0 => 0,
                    Invw1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Invw1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Invw1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Invw1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Invw1W::_0)
            }
            # [ doc = "When setting the GO bit, invalidate all lines in way 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Invw1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `PUSHW1`" ]
        pub enum Pushw1W {
            # [ doc = "No operation" ]
            _0,
            # [ doc = "When setting the GO bit, push all modified lines in way 1" ]
            _1,
        }
        impl Pushw1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    Pushw1W::_0 => 0,
                    Pushw1W::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _Pushw1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _Pushw1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: Pushw1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "No operation" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(Pushw1W::_0)
            }
            # [ doc = "When setting the GO bit, push all modified lines in way 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(Pushw1W::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `GO`" ]
        pub enum GoW {
            # [ doc = "Write: no effect. Read: no cache command active." ]
            _0,
            # [ doc = "Write: initiate command indicated by bits 27-24. Read: cache command active." ]
            _1,
        }
        impl GoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    GoW::_0 => 0,
                    GoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _GoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _GoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: GoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write: no effect. Read: no cache command active." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(GoW::_0)
            }
            # [ doc = "Write: initiate command indicated by bits 27-24. Read: cache command active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(GoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 31;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Cache enable" ]
            # [ inline ( always ) ]
            pub fn encache(&self) -> EncacheR {
                EncacheR::_from({
                                    const MASK: u8 = 1;
                                    const OFFSET: u8 = 0;
                                    ((self.bits >> OFFSET) & MASK as u32) as u8
                                })
            }
            # [ doc = "Bit 2 - Forces all cacheable spaces to write through" ]
            # [ inline ( always ) ]
            pub fn pccr2(&self) -> Pccr2R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pccr2R { bits }
            }
            # [ doc = "Bit 3 - Forces no allocation on cache misses (must also have PCCR2 asserted)" ]
            # [ inline ( always ) ]
            pub fn pccr3(&self) -> Pccr3R {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 3;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                Pccr3R { bits }
            }
            # [ doc = "Bit 24 - Invalidate Way 0" ]
            # [ inline ( always ) ]
            pub fn invw0(&self) -> Invw0R {
                Invw0R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 24;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 25 - Push Way 0" ]
            # [ inline ( always ) ]
            pub fn pushw0(&self) -> Pushw0R {
                Pushw0R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 25;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 26 - Invalidate Way 1" ]
            # [ inline ( always ) ]
            pub fn invw1(&self) -> Invw1R {
                Invw1R::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 26;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 27 - Push Way 1" ]
            # [ inline ( always ) ]
            pub fn pushw1(&self) -> Pushw1R {
                Pushw1R::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 27;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 31 - Initiate Cache Command" ]
            # [ inline ( always ) ]
            pub fn go(&self) -> GoR {
                GoR::_from({
                               const MASK: u8 = 1;
                               const OFFSET: u8 = 31;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Cache enable" ]
            # [ inline ( always ) ]
            pub fn encache(&mut self) -> _EncacheW {
                _EncacheW { w: self }
            }
            # [ doc = "Bit 2 - Forces all cacheable spaces to write through" ]
            # [ inline ( always ) ]
            pub fn pccr2(&mut self) -> _Pccr2W {
                _Pccr2W { w: self }
            }
            # [ doc = "Bit 3 - Forces no allocation on cache misses (must also have PCCR2 asserted)" ]
            # [ inline ( always ) ]
            pub fn pccr3(&mut self) -> _Pccr3W {
                _Pccr3W { w: self }
            }
            # [ doc = "Bit 24 - Invalidate Way 0" ]
            # [ inline ( always ) ]
            pub fn invw0(&mut self) -> _Invw0W {
                _Invw0W { w: self }
            }
            # [ doc = "Bit 25 - Push Way 0" ]
            # [ inline ( always ) ]
            pub fn pushw0(&mut self) -> _Pushw0W {
                _Pushw0W { w: self }
            }
            # [ doc = "Bit 26 - Invalidate Way 1" ]
            # [ inline ( always ) ]
            pub fn invw1(&mut self) -> _Invw1W {
                _Invw1W { w: self }
            }
            # [ doc = "Bit 27 - Push Way 1" ]
            # [ inline ( always ) ]
            pub fn pushw1(&mut self) -> _Pushw1W {
                _Pushw1W { w: self }
            }
            # [ doc = "Bit 31 - Initiate Cache Command" ]
            # [ inline ( always ) ]
            pub fn go(&mut self) -> _GoW {
                _GoW { w: self }
            }
        }
    }
    # [ doc = "Cache line control register" ]
    pub struct LmemPcclcr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Cache line control register" ]
    pub mod lmem_pcclcr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::LmemPcclcr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `LGO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LgoR {
            # [ doc = "Write: no effect. Read: no line command active." ]
            _0,
            # [ doc = "Write: initiate line command indicated by bits 27-24. Read: line command active." ]
            _1,
        }
        impl LgoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LgoR::_0 => 0,
                    LgoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LgoR {
                match bits {
                    0 => LgoR::_0,
                    1 => LgoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LgoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LgoR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct CacheaddrR {
            bits: u16,
        }
        impl CacheaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u16 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `WSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum WselR {
            # [ doc = "Way 0" ]
            _0,
            # [ doc = "Way 1" ]
            _1,
        }
        impl WselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    WselR::_0 => 0,
                    WselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> WselR {
                match bits {
                    0 => WselR::_0,
                    1 => WselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == WselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == WselR::_1
            }
        }
        # [ doc = "Possible values of the field `TDSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum TdselR {
            # [ doc = "Data" ]
            _0,
            # [ doc = "Tag" ]
            _1,
        }
        impl TdselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    TdselR::_0 => 0,
                    TdselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> TdselR {
                match bits {
                    0 => TdselR::_0,
                    1 => TdselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == TdselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == TdselR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LcivbR {
            bits: u8,
        }
        impl LcivbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LcimbR {
            bits: u8,
        }
        impl LcimbR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct LcwayR {
            bits: u8,
        }
        impl LcwayR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                self.bits
            }
        }
        # [ doc = "Possible values of the field `LCMD`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LcmdR {
            # [ doc = "Search and read or write" ]
            _00,
            # [ doc = "Invalidate" ]
            _01,
            # [ doc = "Push" ]
            _10,
            # [ doc = "Clear" ]
            _11,
        }
        impl LcmdR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LcmdR::_00 => 0,
                    LcmdR::_01 => 1,
                    LcmdR::_10 => 2,
                    LcmdR::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LcmdR {
                match bits {
                    0 => LcmdR::_00,
                    1 => LcmdR::_01,
                    2 => LcmdR::_10,
                    3 => LcmdR::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == LcmdR::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == LcmdR::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == LcmdR::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == LcmdR::_11
            }
        }
        # [ doc = "Possible values of the field `LADSEL`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LadselR {
            # [ doc = "Cache address" ]
            _0,
            # [ doc = "Physical address" ]
            _1,
        }
        impl LadselR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LadselR::_0 => 0,
                    LadselR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LadselR {
                match bits {
                    0 => LadselR::_0,
                    1 => LadselR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LadselR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LadselR::_1
            }
        }
        # [ doc = "Possible values of the field `LACC`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LaccR {
            # [ doc = "Read" ]
            _0,
            # [ doc = "Write" ]
            _1,
        }
        impl LaccR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LaccR::_0 => 0,
                    LaccR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LaccR {
                match bits {
                    0 => LaccR::_0,
                    1 => LaccR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LaccR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LaccR::_1
            }
        }
        # [ doc = "Values that can be written to the field `LGO`" ]
        pub enum LgoW {
            # [ doc = "Write: no effect. Read: no line command active." ]
            _0,
            # [ doc = "Write: initiate line command indicated by bits 27-24. Read: line command active." ]
            _1,
        }
        impl LgoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LgoW::_0 => 0,
                    LgoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LgoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LgoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LgoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write: no effect. Read: no line command active." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LgoW::_0)
            }
            # [ doc = "Write: initiate line command indicated by bits 27-24. Read: line command active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LgoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _CacheaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _CacheaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u16) -> &'a mut W {
                const MASK: u16 = 4095;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `WSEL`" ]
        pub enum WselW {
            # [ doc = "Way 0" ]
            _0,
            # [ doc = "Way 1" ]
            _1,
        }
        impl WselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    WselW::_0 => 0,
                    WselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _WselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _WselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: WselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Way 0" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(WselW::_0)
            }
            # [ doc = "Way 1" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(WselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `TDSEL`" ]
        pub enum TdselW {
            # [ doc = "Data" ]
            _0,
            # [ doc = "Tag" ]
            _1,
        }
        impl TdselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    TdselW::_0 => 0,
                    TdselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _TdselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _TdselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: TdselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Data" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(TdselW::_0)
            }
            # [ doc = "Tag" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(TdselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LcivbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LcivbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LcimbW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LcimbW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 21;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LcwayW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LcwayW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LCMD`" ]
        pub enum LcmdW {
            # [ doc = "Search and read or write" ]
            _00,
            # [ doc = "Invalidate" ]
            _01,
            # [ doc = "Push" ]
            _10,
            # [ doc = "Clear" ]
            _11,
        }
        impl LcmdW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LcmdW::_00 => 0,
                    LcmdW::_01 => 1,
                    LcmdW::_10 => 2,
                    LcmdW::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LcmdW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LcmdW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LcmdW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Search and read or write" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(LcmdW::_00)
            }
            # [ doc = "Invalidate" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(LcmdW::_01)
            }
            # [ doc = "Push" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(LcmdW::_10)
            }
            # [ doc = "Clear" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(LcmdW::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LADSEL`" ]
        pub enum LadselW {
            # [ doc = "Cache address" ]
            _0,
            # [ doc = "Physical address" ]
            _1,
        }
        impl LadselW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LadselW::_0 => 0,
                    LadselW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LadselW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LadselW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LadselW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Cache address" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LadselW::_0)
            }
            # [ doc = "Physical address" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LadselW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `LACC`" ]
        pub enum LaccW {
            # [ doc = "Read" ]
            _0,
            # [ doc = "Write" ]
            _1,
        }
        impl LaccW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LaccW::_0 => 0,
                    LaccW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LaccW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LaccW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LaccW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Read" ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LaccW::_0)
            }
            # [ doc = "Write" ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LaccW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 27;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Initiate Cache Line Command" ]
            # [ inline ( always ) ]
            pub fn lgo(&self) -> LgoR {
                LgoR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 2:13 - Cache address" ]
            # [ inline ( always ) ]
            pub fn cacheaddr(&self) -> CacheaddrR {
                let bits = {
                    const MASK: u16 = 4095;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u16
                };
                CacheaddrR { bits }
            }
            # [ doc = "Bit 14 - Way select" ]
            # [ inline ( always ) ]
            pub fn wsel(&self) -> WselR {
                WselR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 14;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 16 - Tag/Data Select" ]
            # [ inline ( always ) ]
            pub fn tdsel(&self) -> TdselR {
                TdselR::_from({
                                  const MASK: u8 = 1;
                                  const OFFSET: u8 = 16;
                                  ((self.bits >> OFFSET) & MASK as u32) as u8
                              })
            }
            # [ doc = "Bit 20 - Line Command Initial Valid Bit" ]
            # [ inline ( always ) ]
            pub fn lcivb(&self) -> LcivbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 20;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LcivbR { bits }
            }
            # [ doc = "Bit 21 - Line Command Initial Modified Bit" ]
            # [ inline ( always ) ]
            pub fn lcimb(&self) -> LcimbR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 21;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LcimbR { bits }
            }
            # [ doc = "Bit 22 - Line Command Way" ]
            # [ inline ( always ) ]
            pub fn lcway(&self) -> LcwayR {
                let bits = {
                    const MASK: u8 = 1;
                    const OFFSET: u8 = 22;
                    ((self.bits >> OFFSET) & MASK as u32) as u8
                };
                LcwayR { bits }
            }
            # [ doc = "Bits 24:25 - Line Command" ]
            # [ inline ( always ) ]
            pub fn lcmd(&self) -> LcmdR {
                LcmdR::_from({
                                 const MASK: u8 = 3;
                                 const OFFSET: u8 = 24;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
            # [ doc = "Bit 26 - Line Address Select" ]
            # [ inline ( always ) ]
            pub fn ladsel(&self) -> LadselR {
                LadselR::_from({
                                   const MASK: u8 = 1;
                                   const OFFSET: u8 = 26;
                                   ((self.bits >> OFFSET) & MASK as u32) as u8
                               })
            }
            # [ doc = "Bit 27 - Line access type" ]
            # [ inline ( always ) ]
            pub fn lacc(&self) -> LaccR {
                LaccR::_from({
                                 const MASK: u8 = 1;
                                 const OFFSET: u8 = 27;
                                 ((self.bits >> OFFSET) & MASK as u32) as u8
                             })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Initiate Cache Line Command" ]
            # [ inline ( always ) ]
            pub fn lgo(&mut self) -> _LgoW {
                _LgoW { w: self }
            }
            # [ doc = "Bits 2:13 - Cache address" ]
            # [ inline ( always ) ]
            pub fn cacheaddr(&mut self) -> _CacheaddrW {
                _CacheaddrW { w: self }
            }
            # [ doc = "Bit 14 - Way select" ]
            # [ inline ( always ) ]
            pub fn wsel(&mut self) -> _WselW {
                _WselW { w: self }
            }
            # [ doc = "Bit 16 - Tag/Data Select" ]
            # [ inline ( always ) ]
            pub fn tdsel(&mut self) -> _TdselW {
                _TdselW { w: self }
            }
            # [ doc = "Bit 20 - Line Command Initial Valid Bit" ]
            # [ inline ( always ) ]
            pub fn lcivb(&mut self) -> _LcivbW {
                _LcivbW { w: self }
            }
            # [ doc = "Bit 21 - Line Command Initial Modified Bit" ]
            # [ inline ( always ) ]
            pub fn lcimb(&mut self) -> _LcimbW {
                _LcimbW { w: self }
            }
            # [ doc = "Bit 22 - Line Command Way" ]
            # [ inline ( always ) ]
            pub fn lcway(&mut self) -> _LcwayW {
                _LcwayW { w: self }
            }
            # [ doc = "Bits 24:25 - Line Command" ]
            # [ inline ( always ) ]
            pub fn lcmd(&mut self) -> _LcmdW {
                _LcmdW { w: self }
            }
            # [ doc = "Bit 26 - Line Address Select" ]
            # [ inline ( always ) ]
            pub fn ladsel(&mut self) -> _LadselW {
                _LadselW { w: self }
            }
            # [ doc = "Bit 27 - Line access type" ]
            # [ inline ( always ) ]
            pub fn lacc(&mut self) -> _LaccW {
                _LaccW { w: self }
            }
        }
    }
    # [ doc = "Cache search address register" ]
    pub struct LmemPccsar {
        register: VolatileCell<u32>,
    }
    # [ doc = "Cache search address register" ]
    pub mod lmem_pccsar {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::LmemPccsar {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `LGO`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum LgoR {
            # [ doc = "Write: no effect. Read: no line command active." ]
            _0,
            # [ doc = "Write: initiate line command indicated by bits CLCR[27:24]. Read: line command active." ]
            _1,
        }
        impl LgoR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    LgoR::_0 => 0,
                    LgoR::_1 => 1,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> LgoR {
                match bits {
                    0 => LgoR::_0,
                    1 => LgoR::_1,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_0`" ]
            # [ inline ( always ) ]
            pub fn is_0(&self) -> bool {
                *self == LgoR::_0
            }
            # [ doc = "Checks if the value of the field is `_1`" ]
            # [ inline ( always ) ]
            pub fn is_1(&self) -> bool {
                *self == LgoR::_1
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct PhyaddrR {
            bits: u32,
        }
        impl PhyaddrR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = "Values that can be written to the field `LGO`" ]
        pub enum LgoW {
            # [ doc = "Write: no effect. Read: no line command active." ]
            _0,
            # [ doc = "Write: initiate line command indicated by bits CLCR[27:24]. Read: line command active." ]
            _1,
        }
        impl LgoW {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    LgoW::_0 => 0,
                    LgoW::_1 => 1,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _LgoW<'a> {
            w: &'a mut W,
        }
        impl<'a> _LgoW<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: LgoW) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Write: no effect. Read: no line command active." ]
            # [ inline ( always ) ]
            pub fn _0(self) -> &'a mut W {
                self.variant(LgoW::_0)
            }
            # [ doc = "Write: initiate line command indicated by bits CLCR[27:24]. Read: line command active." ]
            # [ inline ( always ) ]
            pub fn _1(self) -> &'a mut W {
                self.variant(LgoW::_1)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 1;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _PhyaddrW<'a> {
            w: &'a mut W,
        }
        impl<'a> _PhyaddrW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 1073741823;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bit 0 - Initiate Cache Line Command" ]
            # [ inline ( always ) ]
            pub fn lgo(&self) -> LgoR {
                LgoR::_from({
                                const MASK: u8 = 1;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 2:31 - Physical Address" ]
            # [ inline ( always ) ]
            pub fn phyaddr(&self) -> PhyaddrR {
                let bits = {
                    const MASK: u32 = 1073741823;
                    const OFFSET: u8 = 2;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                PhyaddrR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bit 0 - Initiate Cache Line Command" ]
            # [ inline ( always ) ]
            pub fn lgo(&mut self) -> _LgoW {
                _LgoW { w: self }
            }
            # [ doc = "Bits 2:31 - Physical Address" ]
            # [ inline ( always ) ]
            pub fn phyaddr(&mut self) -> _PhyaddrW {
                _PhyaddrW { w: self }
            }
        }
    }
    # [ doc = "Cache read/write value register" ]
    pub struct LmemPcccvr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Cache read/write value register" ]
    pub mod lmem_pcccvr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::LmemPcccvr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = r" Value of the field" ]
        pub struct DataR {
            bits: u32,
        }
        impl DataR {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _DataW<'a> {
            w: &'a mut W,
        }
        impl<'a> _DataW<'a> {
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(self, bits: u32) -> &'a mut W {
                const MASK: u32 = 4294967295;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:31 - Cache read/write Data" ]
            # [ inline ( always ) ]
            pub fn data(&self) -> DataR {
                let bits = {
                    const MASK: u32 = 4294967295;
                    const OFFSET: u8 = 0;
                    ((self.bits >> OFFSET) & MASK as u32) as u32
                };
                DataR { bits }
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 0 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:31 - Cache read/write Data" ]
            # [ inline ( always ) ]
            pub fn data(&mut self) -> _DataW {
                _DataW { w: self }
            }
        }
    }
    # [ doc = "Cache regions mode register" ]
    pub struct Pccrmr {
        register: VolatileCell<u32>,
    }
    # [ doc = "Cache regions mode register" ]
    pub mod pccrmr {
        # [ doc = r" Value read from the register" ]
        pub struct R {
            bits: u32,
        }
        # [ doc = r" Value to write to the register" ]
        pub struct W {
            bits: u32,
        }
        impl super::Pccrmr {
            # [ doc = r" Modifies the contents of the register" ]
            # [ inline ( always ) ]
            pub fn modify<F>(&self, f: F)
                where for<'w> F: FnOnce(&R, &'w mut W) -> &'w mut W
            {
                let bits = self.register.get();
                let r = R { bits: bits };
                let mut w = W { bits: bits };
                f(&r, &mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Reads the contents of the register" ]
            # [ inline ( always ) ]
            pub fn read(&self) -> R {
                R { bits: self.register.get() }
            }
            # [ doc = r" Writes to the register" ]
            # [ inline ( always ) ]
            pub fn write<F>(&self, f: F)
                where F: FnOnce(&mut W) -> &mut W
            {
                let mut w = W::reset_value();
                f(&mut w);
                self.register.set(w.bits);
            }
            # [ doc = r" Writes the reset value to the register" ]
            # [ inline ( always ) ]
            pub fn reset(&self) {
                self.write(|w| w)
            }
        }
        # [ doc = "Possible values of the field `R15`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R15R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R15R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R15R::_00 => 0,
                    R15R::_01 => 1,
                    R15R::_10 => 2,
                    R15R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R15R {
                match bits {
                    0 => R15R::_00,
                    1 => R15R::_01,
                    2 => R15R::_10,
                    3 => R15R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R15R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R15R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R15R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R15R::_11
            }
        }
        # [ doc = "Possible values of the field `R14`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R14R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R14R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R14R::_00 => 0,
                    R14R::_01 => 1,
                    R14R::_10 => 2,
                    R14R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R14R {
                match bits {
                    0 => R14R::_00,
                    1 => R14R::_01,
                    2 => R14R::_10,
                    3 => R14R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R14R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R14R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R14R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R14R::_11
            }
        }
        # [ doc = "Possible values of the field `R13`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R13R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R13R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R13R::_00 => 0,
                    R13R::_01 => 1,
                    R13R::_10 => 2,
                    R13R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R13R {
                match bits {
                    0 => R13R::_00,
                    1 => R13R::_01,
                    2 => R13R::_10,
                    3 => R13R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R13R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R13R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R13R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R13R::_11
            }
        }
        # [ doc = "Possible values of the field `R12`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R12R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R12R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R12R::_00 => 0,
                    R12R::_01 => 1,
                    R12R::_10 => 2,
                    R12R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R12R {
                match bits {
                    0 => R12R::_00,
                    1 => R12R::_01,
                    2 => R12R::_10,
                    3 => R12R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R12R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R12R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R12R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R12R::_11
            }
        }
        # [ doc = "Possible values of the field `R11`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R11R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R11R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R11R::_00 => 0,
                    R11R::_01 => 1,
                    R11R::_10 => 2,
                    R11R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R11R {
                match bits {
                    0 => R11R::_00,
                    1 => R11R::_01,
                    2 => R11R::_10,
                    3 => R11R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R11R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R11R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R11R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R11R::_11
            }
        }
        # [ doc = "Possible values of the field `R10`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R10R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R10R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R10R::_00 => 0,
                    R10R::_01 => 1,
                    R10R::_10 => 2,
                    R10R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R10R {
                match bits {
                    0 => R10R::_00,
                    1 => R10R::_01,
                    2 => R10R::_10,
                    3 => R10R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R10R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R10R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R10R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R10R::_11
            }
        }
        # [ doc = "Possible values of the field `R9`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R9R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R9R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R9R::_00 => 0,
                    R9R::_01 => 1,
                    R9R::_10 => 2,
                    R9R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R9R {
                match bits {
                    0 => R9R::_00,
                    1 => R9R::_01,
                    2 => R9R::_10,
                    3 => R9R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R9R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R9R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R9R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R9R::_11
            }
        }
        # [ doc = "Possible values of the field `R8`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R8R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R8R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R8R::_00 => 0,
                    R8R::_01 => 1,
                    R8R::_10 => 2,
                    R8R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R8R {
                match bits {
                    0 => R8R::_00,
                    1 => R8R::_01,
                    2 => R8R::_10,
                    3 => R8R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R8R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R8R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R8R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R8R::_11
            }
        }
        # [ doc = "Possible values of the field `R7`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R7R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R7R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R7R::_00 => 0,
                    R7R::_01 => 1,
                    R7R::_10 => 2,
                    R7R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R7R {
                match bits {
                    0 => R7R::_00,
                    1 => R7R::_01,
                    2 => R7R::_10,
                    3 => R7R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R7R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R7R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R7R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R7R::_11
            }
        }
        # [ doc = "Possible values of the field `R6`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R6R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R6R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R6R::_00 => 0,
                    R6R::_01 => 1,
                    R6R::_10 => 2,
                    R6R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R6R {
                match bits {
                    0 => R6R::_00,
                    1 => R6R::_01,
                    2 => R6R::_10,
                    3 => R6R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R6R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R6R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R6R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R6R::_11
            }
        }
        # [ doc = "Possible values of the field `R5`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R5R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R5R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R5R::_00 => 0,
                    R5R::_01 => 1,
                    R5R::_10 => 2,
                    R5R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R5R {
                match bits {
                    0 => R5R::_00,
                    1 => R5R::_01,
                    2 => R5R::_10,
                    3 => R5R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R5R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R5R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R5R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R5R::_11
            }
        }
        # [ doc = "Possible values of the field `R4`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R4R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R4R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R4R::_00 => 0,
                    R4R::_01 => 1,
                    R4R::_10 => 2,
                    R4R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R4R {
                match bits {
                    0 => R4R::_00,
                    1 => R4R::_01,
                    2 => R4R::_10,
                    3 => R4R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R4R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R4R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R4R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R4R::_11
            }
        }
        # [ doc = "Possible values of the field `R3`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R3R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R3R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R3R::_00 => 0,
                    R3R::_01 => 1,
                    R3R::_10 => 2,
                    R3R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R3R {
                match bits {
                    0 => R3R::_00,
                    1 => R3R::_01,
                    2 => R3R::_10,
                    3 => R3R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R3R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R3R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R3R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R3R::_11
            }
        }
        # [ doc = "Possible values of the field `R2`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R2R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R2R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R2R::_00 => 0,
                    R2R::_01 => 1,
                    R2R::_10 => 2,
                    R2R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R2R {
                match bits {
                    0 => R2R::_00,
                    1 => R2R::_01,
                    2 => R2R::_10,
                    3 => R2R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R2R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R2R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R2R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R2R::_11
            }
        }
        # [ doc = "Possible values of the field `R1`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R1R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R1R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R1R::_00 => 0,
                    R1R::_01 => 1,
                    R1R::_10 => 2,
                    R1R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R1R {
                match bits {
                    0 => R1R::_00,
                    1 => R1R::_01,
                    2 => R1R::_10,
                    3 => R1R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R1R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R1R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R1R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R1R::_11
            }
        }
        # [ doc = "Possible values of the field `R0`" ]
        # [ derive ( Clone , Copy , Debug , PartialEq ) ]
        pub enum R0R {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R0R {
            # [ doc = r" Value of the field as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u8 {
                match *self {
                    R0R::_00 => 0,
                    R0R::_01 => 1,
                    R0R::_10 => 2,
                    R0R::_11 => 3,
                }
            }
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _from(bits: u8) -> R0R {
                match bits {
                    0 => R0R::_00,
                    1 => R0R::_01,
                    2 => R0R::_10,
                    3 => R0R::_11,
                    _ => unreachable!(),
                }
            }
            # [ doc = "Checks if the value of the field is `_00`" ]
            # [ inline ( always ) ]
            pub fn is_00(&self) -> bool {
                *self == R0R::_00
            }
            # [ doc = "Checks if the value of the field is `_01`" ]
            # [ inline ( always ) ]
            pub fn is_01(&self) -> bool {
                *self == R0R::_01
            }
            # [ doc = "Checks if the value of the field is `_10`" ]
            # [ inline ( always ) ]
            pub fn is_10(&self) -> bool {
                *self == R0R::_10
            }
            # [ doc = "Checks if the value of the field is `_11`" ]
            # [ inline ( always ) ]
            pub fn is_11(&self) -> bool {
                *self == R0R::_11
            }
        }
        # [ doc = "Values that can be written to the field `R15`" ]
        pub enum R15W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R15W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R15W::_00 => 0,
                    R15W::_01 => 1,
                    R15W::_10 => 2,
                    R15W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R15W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R15W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R15W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R15W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R15W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R15W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R15W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 0;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R14`" ]
        pub enum R14W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R14W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R14W::_00 => 0,
                    R14W::_01 => 1,
                    R14W::_10 => 2,
                    R14W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R14W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R14W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R14W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R14W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R14W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R14W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R14W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 2;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R13`" ]
        pub enum R13W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R13W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R13W::_00 => 0,
                    R13W::_01 => 1,
                    R13W::_10 => 2,
                    R13W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R13W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R13W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R13W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R13W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R13W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R13W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R13W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 4;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R12`" ]
        pub enum R12W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R12W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R12W::_00 => 0,
                    R12W::_01 => 1,
                    R12W::_10 => 2,
                    R12W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R12W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R12W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R12W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R12W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R12W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R12W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R12W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 6;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R11`" ]
        pub enum R11W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R11W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R11W::_00 => 0,
                    R11W::_01 => 1,
                    R11W::_10 => 2,
                    R11W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R11W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R11W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R11W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R11W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R11W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R11W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R11W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 8;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R10`" ]
        pub enum R10W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R10W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R10W::_00 => 0,
                    R10W::_01 => 1,
                    R10W::_10 => 2,
                    R10W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R10W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R10W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R10W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R10W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R10W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R10W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R10W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 10;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R9`" ]
        pub enum R9W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R9W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R9W::_00 => 0,
                    R9W::_01 => 1,
                    R9W::_10 => 2,
                    R9W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R9W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R9W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R9W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R9W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R9W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R9W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R9W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 12;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R8`" ]
        pub enum R8W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R8W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R8W::_00 => 0,
                    R8W::_01 => 1,
                    R8W::_10 => 2,
                    R8W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R8W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R8W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R8W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R8W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R8W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R8W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R8W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 14;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R7`" ]
        pub enum R7W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R7W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R7W::_00 => 0,
                    R7W::_01 => 1,
                    R7W::_10 => 2,
                    R7W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R7W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R7W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R7W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R7W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R7W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R7W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R7W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 16;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R6`" ]
        pub enum R6W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R6W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R6W::_00 => 0,
                    R6W::_01 => 1,
                    R6W::_10 => 2,
                    R6W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R6W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R6W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R6W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R6W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R6W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R6W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R6W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 18;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R5`" ]
        pub enum R5W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R5W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R5W::_00 => 0,
                    R5W::_01 => 1,
                    R5W::_10 => 2,
                    R5W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R5W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R5W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R5W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R5W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R5W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R5W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R5W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 20;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R4`" ]
        pub enum R4W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R4W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R4W::_00 => 0,
                    R4W::_01 => 1,
                    R4W::_10 => 2,
                    R4W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R4W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R4W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R4W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R4W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R4W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R4W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R4W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 22;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R3`" ]
        pub enum R3W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R3W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R3W::_00 => 0,
                    R3W::_01 => 1,
                    R3W::_10 => 2,
                    R3W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R3W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R3W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R3W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R3W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R3W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R3W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R3W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 24;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R2`" ]
        pub enum R2W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R2W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R2W::_00 => 0,
                    R2W::_01 => 1,
                    R2W::_10 => 2,
                    R2W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R2W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R2W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R2W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R2W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R2W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R2W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R2W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 26;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R1`" ]
        pub enum R1W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R1W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R1W::_00 => 0,
                    R1W::_01 => 1,
                    R1W::_10 => 2,
                    R1W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R1W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R1W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R1W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R1W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R1W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R1W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R1W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 28;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        # [ doc = "Values that can be written to the field `R0`" ]
        pub enum R0W {
            # [ doc = "Non-cacheable" ]
            _00,
            # [ doc = "Non-cacheable" ]
            _01,
            # [ doc = "Write-through" ]
            _10,
            # [ doc = "Write-back" ]
            _11,
        }
        impl R0W {
            # [ allow ( missing_docs ) ]
            # [ doc ( hidden ) ]
            # [ inline ( always ) ]
            pub fn _bits(&self) -> u8 {
                match *self {
                    R0W::_00 => 0,
                    R0W::_01 => 1,
                    R0W::_10 => 2,
                    R0W::_11 => 3,
                }
            }
        }
        # [ doc = r" Proxy" ]
        pub struct _R0W<'a> {
            w: &'a mut W,
        }
        impl<'a> _R0W<'a> {
            # [ doc = r" Writes `variant` to the field" ]
            # [ inline ( always ) ]
            pub fn variant(self, variant: R0W) -> &'a mut W {
                {
                    self.bits(variant._bits())
                }
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _00(self) -> &'a mut W {
                self.variant(R0W::_00)
            }
            # [ doc = "Non-cacheable" ]
            # [ inline ( always ) ]
            pub fn _01(self) -> &'a mut W {
                self.variant(R0W::_01)
            }
            # [ doc = "Write-through" ]
            # [ inline ( always ) ]
            pub fn _10(self) -> &'a mut W {
                self.variant(R0W::_10)
            }
            # [ doc = "Write-back" ]
            # [ inline ( always ) ]
            pub fn _11(self) -> &'a mut W {
                self.variant(R0W::_11)
            }
            # [ doc = r" Writes raw bits to the field" ]
            # [ inline ( always ) ]
            pub fn bits(self, bits: u8) -> &'a mut W {
                const MASK: u8 = 3;
                const OFFSET: u8 = 30;
                self.w.bits &= !((MASK as u32) << OFFSET);
                self.w.bits |= ((bits & MASK) as u32) << OFFSET;
                self.w
            }
        }
        impl R {
            # [ doc = r" Value of the register as raw bits" ]
            # [ inline ( always ) ]
            pub fn bits(&self) -> u32 {
                self.bits
            }
            # [ doc = "Bits 0:1 - Region 15 mode" ]
            # [ inline ( always ) ]
            pub fn r15(&self) -> R15R {
                R15R::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 0;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 2:3 - Region 14 mode" ]
            # [ inline ( always ) ]
            pub fn r14(&self) -> R14R {
                R14R::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 2;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 4:5 - Region 13 mode" ]
            # [ inline ( always ) ]
            pub fn r13(&self) -> R13R {
                R13R::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 4;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 6:7 - Region 12 mode" ]
            # [ inline ( always ) ]
            pub fn r12(&self) -> R12R {
                R12R::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 6;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 8:9 - Region 11 mode" ]
            # [ inline ( always ) ]
            pub fn r11(&self) -> R11R {
                R11R::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 8;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 10:11 - Region 10 mode" ]
            # [ inline ( always ) ]
            pub fn r10(&self) -> R10R {
                R10R::_from({
                                const MASK: u8 = 3;
                                const OFFSET: u8 = 10;
                                ((self.bits >> OFFSET) & MASK as u32) as u8
                            })
            }
            # [ doc = "Bits 12:13 - Region 9 mode" ]
            # [ inline ( always ) ]
            pub fn r9(&self) -> R9R {
                R9R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 12;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 14:15 - Region 8 mode" ]
            # [ inline ( always ) ]
            pub fn r8(&self) -> R8R {
                R8R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 14;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 16:17 - Region 7 mode" ]
            # [ inline ( always ) ]
            pub fn r7(&self) -> R7R {
                R7R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 16;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 18:19 - Region 6 mode" ]
            # [ inline ( always ) ]
            pub fn r6(&self) -> R6R {
                R6R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 18;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 20:21 - Region 5 mode" ]
            # [ inline ( always ) ]
            pub fn r5(&self) -> R5R {
                R5R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 20;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 22:23 - Region 4 mode" ]
            # [ inline ( always ) ]
            pub fn r4(&self) -> R4R {
                R4R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 22;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 24:25 - Region 3 mode" ]
            # [ inline ( always ) ]
            pub fn r3(&self) -> R3R {
                R3R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 24;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 26:27 - Region 2 mode" ]
            # [ inline ( always ) ]
            pub fn r2(&self) -> R2R {
                R2R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 26;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 28:29 - Region 1 mode" ]
            # [ inline ( always ) ]
            pub fn r1(&self) -> R1R {
                R1R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 28;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
            # [ doc = "Bits 30:31 - Region 0 mode" ]
            # [ inline ( always ) ]
            pub fn r0(&self) -> R0R {
                R0R::_from({
                               const MASK: u8 = 3;
                               const OFFSET: u8 = 30;
                               ((self.bits >> OFFSET) & MASK as u32) as u8
                           })
            }
        }
        impl W {
            # [ doc = r" Reset value of the register" ]
            # [ inline ( always ) ]
            pub fn reset_value() -> W {
                W { bits: 2853150720 }
            }
            # [ doc = r" Writes raw bits to the register" ]
            # [ inline ( always ) ]
            pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
                self.bits = bits;
                self
            }
            # [ doc = "Bits 0:1 - Region 15 mode" ]
            # [ inline ( always ) ]
            pub fn r15(&mut self) -> _R15W {
                _R15W { w: self }
            }
            # [ doc = "Bits 2:3 - Region 14 mode" ]
            # [ inline ( always ) ]
            pub fn r14(&mut self) -> _R14W {
                _R14W { w: self }
            }
            # [ doc = "Bits 4:5 - Region 13 mode" ]
            # [ inline ( always ) ]
            pub fn r13(&mut self) -> _R13W {
                _R13W { w: self }
            }
            # [ doc = "Bits 6:7 - Region 12 mode" ]
            # [ inline ( always ) ]
            pub fn r12(&mut self) -> _R12W {
                _R12W { w: self }
            }
            # [ doc = "Bits 8:9 - Region 11 mode" ]
            # [ inline ( always ) ]
            pub fn r11(&mut self) -> _R11W {
                _R11W { w: self }
            }
            # [ doc = "Bits 10:11 - Region 10 mode" ]
            # [ inline ( always ) ]
            pub fn r10(&mut self) -> _R10W {
                _R10W { w: self }
            }
            # [ doc = "Bits 12:13 - Region 9 mode" ]
            # [ inline ( always ) ]
            pub fn r9(&mut self) -> _R9W {
                _R9W { w: self }
            }
            # [ doc = "Bits 14:15 - Region 8 mode" ]
            # [ inline ( always ) ]
            pub fn r8(&mut self) -> _R8W {
                _R8W { w: self }
            }
            # [ doc = "Bits 16:17 - Region 7 mode" ]
            # [ inline ( always ) ]
            pub fn r7(&mut self) -> _R7W {
                _R7W { w: self }
            }
            # [ doc = "Bits 18:19 - Region 6 mode" ]
            # [ inline ( always ) ]
            pub fn r6(&mut self) -> _R6W {
                _R6W { w: self }
            }
            # [ doc = "Bits 20:21 - Region 5 mode" ]
            # [ inline ( always ) ]
            pub fn r5(&mut self) -> _R5W {
                _R5W { w: self }
            }
            # [ doc = "Bits 22:23 - Region 4 mode" ]
            # [ inline ( always ) ]
            pub fn r4(&mut self) -> _R4W {
                _R4W { w: self }
            }
            # [ doc = "Bits 24:25 - Region 3 mode" ]
            # [ inline ( always ) ]
            pub fn r3(&mut self) -> _R3W {
                _R3W { w: self }
            }
            # [ doc = "Bits 26:27 - Region 2 mode" ]
            # [ inline ( always ) ]
            pub fn r2(&mut self) -> _R2W {
                _R2W { w: self }
            }
            # [ doc = "Bits 28:29 - Region 1 mode" ]
            # [ inline ( always ) ]
            pub fn r1(&mut self) -> _R1W {
                _R1W { w: self }
            }
            # [ doc = "Bits 30:31 - Region 0 mode" ]
            # [ inline ( always ) ]
            pub fn r0(&mut self) -> _R0W {
                _R0W { w: self }
            }
        }
    }
}
# [ doc = "Local Memory Controller" ]
pub struct Lmem {
    register_block: lmem::RegisterBlock,
}
impl Deref for Lmem {
    type Target = lmem::RegisterBlock;
    fn deref(&self) -> &lmem::RegisterBlock {
        &self.register_block
    }
}
